#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2423
#define LARGE_STATE_COUNT 613
#define SYMBOL_COUNT 348
#define ALIAS_COUNT 3
#define TOKEN_COUNT 155
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 39
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 132

enum ts_symbol_identifiers {
  sym_identifier = 1,
  aux_sym_preproc_include_token1 = 2,
  aux_sym_preproc_include_token2 = 3,
  aux_sym_preproc_def_token1 = 4,
  anon_sym_LPAREN = 5,
  anon_sym_DOT_DOT_DOT = 6,
  anon_sym_COMMA = 7,
  anon_sym_RPAREN = 8,
  aux_sym_preproc_if_token1 = 9,
  anon_sym_LF = 10,
  aux_sym_preproc_if_token2 = 11,
  aux_sym_preproc_ifdef_token1 = 12,
  aux_sym_preproc_ifdef_token2 = 13,
  aux_sym_preproc_else_token1 = 14,
  aux_sym_preproc_elif_token1 = 15,
  aux_sym_preproc_elifdef_token1 = 16,
  aux_sym_preproc_elifdef_token2 = 17,
  sym_preproc_arg = 18,
  sym_preproc_directive = 19,
  anon_sym_LPAREN2 = 20,
  anon_sym_defined = 21,
  anon_sym_BANG = 22,
  anon_sym_TILDE = 23,
  anon_sym_DASH = 24,
  anon_sym_PLUS = 25,
  anon_sym_STAR = 26,
  anon_sym_SLASH = 27,
  anon_sym_PERCENT = 28,
  anon_sym_PIPE_PIPE = 29,
  anon_sym_AMP_AMP = 30,
  anon_sym_PIPE = 31,
  anon_sym_CARET = 32,
  anon_sym_AMP = 33,
  anon_sym_EQ_EQ = 34,
  anon_sym_BANG_EQ = 35,
  anon_sym_GT = 36,
  anon_sym_GT_EQ = 37,
  anon_sym_LT_EQ = 38,
  anon_sym_LT = 39,
  anon_sym_LT_LT = 40,
  anon_sym_GT_GT = 41,
  anon_sym_SEMI = 42,
  anon_sym___extension__ = 43,
  anon_sym_typedef = 44,
  anon_sym_extern = 45,
  anon_sym___attribute__ = 46,
  anon_sym_COLON_COLON = 47,
  anon_sym_LBRACK_LBRACK = 48,
  anon_sym_RBRACK_RBRACK = 49,
  anon_sym___declspec = 50,
  anon_sym___based = 51,
  anon_sym___cdecl = 52,
  anon_sym___clrcall = 53,
  anon_sym___stdcall = 54,
  anon_sym___fastcall = 55,
  anon_sym___thiscall = 56,
  anon_sym___vectorcall = 57,
  sym_ms_restrict_modifier = 58,
  sym_ms_unsigned_ptr_modifier = 59,
  sym_ms_signed_ptr_modifier = 60,
  anon_sym__unaligned = 61,
  anon_sym___unaligned = 62,
  anon_sym_LBRACE = 63,
  anon_sym_RBRACE = 64,
  anon_sym_signed = 65,
  anon_sym_unsigned = 66,
  anon_sym_long = 67,
  anon_sym_short = 68,
  anon_sym_LBRACK = 69,
  anon_sym_RBRACK = 70,
  anon_sym_EQ = 71,
  anon_sym_static = 72,
  anon_sym_auto = 73,
  anon_sym_register = 74,
  anon_sym_inline = 75,
  anon_sym___inline = 76,
  anon_sym___inline__ = 77,
  anon_sym___forceinline = 78,
  anon_sym_thread_local = 79,
  anon_sym___thread = 80,
  anon_sym_const = 81,
  anon_sym_constexpr = 82,
  anon_sym_volatile = 83,
  anon_sym_restrict = 84,
  anon_sym___restrict__ = 85,
  anon_sym__Atomic = 86,
  anon_sym__Noreturn = 87,
  anon_sym_noreturn = 88,
  sym_primitive_type = 89,
  anon_sym_enum = 90,
  anon_sym_COLON = 91,
  anon_sym_struct = 92,
  anon_sym_union = 93,
  anon_sym_if = 94,
  anon_sym_else = 95,
  anon_sym_switch = 96,
  anon_sym_case = 97,
  anon_sym_default = 98,
  anon_sym_while = 99,
  anon_sym_do = 100,
  anon_sym_for = 101,
  anon_sym_return = 102,
  anon_sym_break = 103,
  anon_sym_continue = 104,
  anon_sym_goto = 105,
  anon_sym___try = 106,
  anon_sym___except = 107,
  anon_sym___finally = 108,
  anon_sym___leave = 109,
  anon_sym_QMARK = 110,
  anon_sym_STAR_EQ = 111,
  anon_sym_SLASH_EQ = 112,
  anon_sym_PERCENT_EQ = 113,
  anon_sym_PLUS_EQ = 114,
  anon_sym_DASH_EQ = 115,
  anon_sym_LT_LT_EQ = 116,
  anon_sym_GT_GT_EQ = 117,
  anon_sym_AMP_EQ = 118,
  anon_sym_CARET_EQ = 119,
  anon_sym_PIPE_EQ = 120,
  anon_sym_DASH_DASH = 121,
  anon_sym_PLUS_PLUS = 122,
  anon_sym_sizeof = 123,
  anon_sym___alignof__ = 124,
  anon_sym___alignof = 125,
  anon_sym__alignof = 126,
  anon_sym_alignof = 127,
  anon_sym__Alignof = 128,
  anon_sym_offsetof = 129,
  anon_sym__Generic = 130,
  anon_sym_asm = 131,
  anon_sym___asm__ = 132,
  anon_sym_DOT = 133,
  anon_sym_DASH_GT = 134,
  sym_number_literal = 135,
  anon_sym_L_SQUOTE = 136,
  anon_sym_u_SQUOTE = 137,
  anon_sym_U_SQUOTE = 138,
  anon_sym_u8_SQUOTE = 139,
  anon_sym_SQUOTE = 140,
  aux_sym_char_literal_token1 = 141,
  anon_sym_L_DQUOTE = 142,
  anon_sym_u_DQUOTE = 143,
  anon_sym_U_DQUOTE = 144,
  anon_sym_u8_DQUOTE = 145,
  anon_sym_DQUOTE = 146,
  aux_sym_string_literal_token1 = 147,
  sym_escape_sequence = 148,
  sym_system_lib_string = 149,
  sym_true = 150,
  sym_false = 151,
  anon_sym_NULL = 152,
  anon_sym_nullptr = 153,
  sym_comment = 154,
  sym_translation_unit = 155,
  sym_preproc_include = 156,
  sym_preproc_def = 157,
  sym_preproc_function_def = 158,
  sym_preproc_params = 159,
  sym_preproc_call = 160,
  sym_preproc_if = 161,
  sym_preproc_ifdef = 162,
  sym_preproc_else = 163,
  sym_preproc_elif = 164,
  sym_preproc_elifdef = 165,
  sym_preproc_if_in_field_declaration_list = 166,
  sym_preproc_ifdef_in_field_declaration_list = 167,
  sym_preproc_else_in_field_declaration_list = 168,
  sym_preproc_elif_in_field_declaration_list = 169,
  sym_preproc_elifdef_in_field_declaration_list = 170,
  sym_preproc_if_in_enumerator_list = 171,
  sym_preproc_ifdef_in_enumerator_list = 172,
  sym_preproc_else_in_enumerator_list = 173,
  sym_preproc_elif_in_enumerator_list = 174,
  sym_preproc_elifdef_in_enumerator_list = 175,
  sym_preproc_if_in_enumerator_list_no_comma = 176,
  sym_preproc_ifdef_in_enumerator_list_no_comma = 177,
  sym_preproc_else_in_enumerator_list_no_comma = 178,
  sym_preproc_elif_in_enumerator_list_no_comma = 179,
  sym_preproc_elifdef_in_enumerator_list_no_comma = 180,
  sym__preproc_expression = 181,
  sym_preproc_parenthesized_expression = 182,
  sym_preproc_defined = 183,
  sym_preproc_unary_expression = 184,
  sym_preproc_call_expression = 185,
  sym_preproc_argument_list = 186,
  sym_preproc_binary_expression = 187,
  sym_function_definition = 188,
  sym__old_style_function_definition = 189,
  sym_declaration = 190,
  sym_type_definition = 191,
  sym__type_definition_type = 192,
  sym__type_definition_declarators = 193,
  sym__declaration_modifiers = 194,
  sym__declaration_specifiers = 195,
  sym_linkage_specification = 196,
  sym_attribute_specifier = 197,
  sym_attribute = 198,
  sym_attribute_declaration = 199,
  sym_ms_declspec_modifier = 200,
  sym_ms_based_modifier = 201,
  sym_ms_call_modifier = 202,
  sym_ms_unaligned_ptr_modifier = 203,
  sym_ms_pointer_modifier = 204,
  sym_declaration_list = 205,
  sym__declarator = 206,
  sym__declaration_declarator = 207,
  sym__field_declarator = 208,
  sym__type_declarator = 209,
  sym__abstract_declarator = 210,
  sym_parenthesized_declarator = 211,
  sym_parenthesized_field_declarator = 212,
  sym_parenthesized_type_declarator = 213,
  sym_abstract_parenthesized_declarator = 214,
  sym_attributed_declarator = 215,
  sym_attributed_field_declarator = 216,
  sym_attributed_type_declarator = 217,
  sym_pointer_declarator = 218,
  sym_pointer_field_declarator = 219,
  sym_pointer_type_declarator = 220,
  sym_abstract_pointer_declarator = 221,
  sym_function_declarator = 222,
  sym__function_declaration_declarator = 223,
  sym_function_field_declarator = 224,
  sym_function_type_declarator = 225,
  sym_abstract_function_declarator = 226,
  sym__old_style_function_declarator = 227,
  sym_array_declarator = 228,
  sym_array_field_declarator = 229,
  sym_array_type_declarator = 230,
  sym_abstract_array_declarator = 231,
  sym_init_declarator = 232,
  sym_compound_statement = 233,
  sym_storage_class_specifier = 234,
  sym_type_qualifier = 235,
  sym__type_specifier = 236,
  sym_sized_type_specifier = 237,
  sym_enum_specifier = 238,
  sym_enumerator_list = 239,
  sym_struct_specifier = 240,
  sym_union_specifier = 241,
  sym_field_declaration_list = 242,
  sym__field_declaration_list_item = 243,
  sym_field_declaration = 244,
  sym__field_declaration_declarator = 245,
  sym_bitfield_clause = 246,
  sym_enumerator = 247,
  sym_variadic_parameter = 248,
  sym_parameter_list = 249,
  sym__old_style_parameter_list = 250,
  sym_parameter_declaration = 251,
  sym_attributed_statement = 252,
  sym_labeled_statement = 253,
  sym__top_level_expression_statement = 254,
  sym_expression_statement = 255,
  sym_if_statement = 256,
  sym_else_clause = 257,
  sym_switch_statement = 258,
  sym_case_statement = 259,
  sym_while_statement = 260,
  sym_do_statement = 261,
  sym_for_statement = 262,
  sym__for_statement_body = 263,
  sym_return_statement = 264,
  sym_break_statement = 265,
  sym_continue_statement = 266,
  sym_goto_statement = 267,
  sym_seh_try_statement = 268,
  sym_seh_except_clause = 269,
  sym_seh_finally_clause = 270,
  sym_seh_leave_statement = 271,
  sym__expression = 272,
  sym__expression_not_binary = 273,
  sym__string = 274,
  sym_comma_expression = 275,
  sym_conditional_expression = 276,
  sym_assignment_expression = 277,
  sym_pointer_expression = 278,
  sym_unary_expression = 279,
  sym_binary_expression = 280,
  sym_update_expression = 281,
  sym_cast_expression = 282,
  sym_type_descriptor = 283,
  sym_sizeof_expression = 284,
  sym_alignof_expression = 285,
  sym_offsetof_expression = 286,
  sym_generic_expression = 287,
  sym_subscript_expression = 288,
  sym_call_expression = 289,
  sym_gnu_asm_expression = 290,
  sym_gnu_asm_qualifier = 291,
  sym_gnu_asm_output_operand_list = 292,
  sym_gnu_asm_output_operand = 293,
  sym_gnu_asm_input_operand_list = 294,
  sym_gnu_asm_input_operand = 295,
  sym_gnu_asm_clobber_list = 296,
  sym_gnu_asm_goto_list = 297,
  sym_argument_list = 298,
  sym_field_expression = 299,
  sym_compound_literal_expression = 300,
  sym_parenthesized_expression = 301,
  sym_initializer_list = 302,
  sym_initializer_pair = 303,
  sym_subscript_designator = 304,
  sym_subscript_range_designator = 305,
  sym_field_designator = 306,
  sym_char_literal = 307,
  sym_concatenated_string = 308,
  sym_string_literal = 309,
  sym_null = 310,
  sym__empty_declaration = 311,
  sym_macro_type_specifier = 312,
  aux_sym_translation_unit_repeat1 = 313,
  aux_sym_preproc_params_repeat1 = 314,
  aux_sym_preproc_if_repeat1 = 315,
  aux_sym_preproc_if_in_field_declaration_list_repeat1 = 316,
  aux_sym_preproc_if_in_enumerator_list_repeat1 = 317,
  aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1 = 318,
  aux_sym_preproc_argument_list_repeat1 = 319,
  aux_sym__old_style_function_definition_repeat1 = 320,
  aux_sym_declaration_repeat1 = 321,
  aux_sym_type_definition_repeat1 = 322,
  aux_sym__type_definition_type_repeat1 = 323,
  aux_sym__type_definition_declarators_repeat1 = 324,
  aux_sym__declaration_specifiers_repeat1 = 325,
  aux_sym_attribute_declaration_repeat1 = 326,
  aux_sym_attributed_declarator_repeat1 = 327,
  aux_sym_pointer_declarator_repeat1 = 328,
  aux_sym_function_declarator_repeat1 = 329,
  aux_sym_sized_type_specifier_repeat1 = 330,
  aux_sym_enumerator_list_repeat1 = 331,
  aux_sym__field_declaration_declarator_repeat1 = 332,
  aux_sym_parameter_list_repeat1 = 333,
  aux_sym__old_style_parameter_list_repeat1 = 334,
  aux_sym_case_statement_repeat1 = 335,
  aux_sym_generic_expression_repeat1 = 336,
  aux_sym_gnu_asm_expression_repeat1 = 337,
  aux_sym_gnu_asm_output_operand_list_repeat1 = 338,
  aux_sym_gnu_asm_input_operand_list_repeat1 = 339,
  aux_sym_gnu_asm_clobber_list_repeat1 = 340,
  aux_sym_gnu_asm_goto_list_repeat1 = 341,
  aux_sym_argument_list_repeat1 = 342,
  aux_sym_initializer_list_repeat1 = 343,
  aux_sym_initializer_pair_repeat1 = 344,
  aux_sym_char_literal_repeat1 = 345,
  aux_sym_concatenated_string_repeat1 = 346,
  aux_sym_string_literal_repeat1 = 347,
  alias_sym_field_identifier = 348,
  alias_sym_statement_identifier = 349,
  alias_sym_type_identifier = 350,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [aux_sym_preproc_include_token1] = "#include",
  [aux_sym_preproc_include_token2] = "preproc_include_token2",
  [aux_sym_preproc_def_token1] = "#define",
  [anon_sym_LPAREN] = "(",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [aux_sym_preproc_if_token1] = "#if",
  [anon_sym_LF] = "\n",
  [aux_sym_preproc_if_token2] = "#endif",
  [aux_sym_preproc_ifdef_token1] = "#ifdef",
  [aux_sym_preproc_ifdef_token2] = "#ifndef",
  [aux_sym_preproc_else_token1] = "#else",
  [aux_sym_preproc_elif_token1] = "#elif",
  [aux_sym_preproc_elifdef_token1] = "#elifdef",
  [aux_sym_preproc_elifdef_token2] = "#elifndef",
  [sym_preproc_arg] = "preproc_arg",
  [sym_preproc_directive] = "preproc_directive",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_defined] = "defined",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_SEMI] = ";",
  [anon_sym___extension__] = "__extension__",
  [anon_sym_typedef] = "typedef",
  [anon_sym_extern] = "extern",
  [anon_sym___attribute__] = "__attribute__",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym___declspec] = "__declspec",
  [anon_sym___based] = "__based",
  [anon_sym___cdecl] = "__cdecl",
  [anon_sym___clrcall] = "__clrcall",
  [anon_sym___stdcall] = "__stdcall",
  [anon_sym___fastcall] = "__fastcall",
  [anon_sym___thiscall] = "__thiscall",
  [anon_sym___vectorcall] = "__vectorcall",
  [sym_ms_restrict_modifier] = "ms_restrict_modifier",
  [sym_ms_unsigned_ptr_modifier] = "ms_unsigned_ptr_modifier",
  [sym_ms_signed_ptr_modifier] = "ms_signed_ptr_modifier",
  [anon_sym__unaligned] = "_unaligned",
  [anon_sym___unaligned] = "__unaligned",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_signed] = "signed",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_long] = "long",
  [anon_sym_short] = "short",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_EQ] = "=",
  [anon_sym_static] = "static",
  [anon_sym_auto] = "auto",
  [anon_sym_register] = "register",
  [anon_sym_inline] = "inline",
  [anon_sym___inline] = "__inline",
  [anon_sym___inline__] = "__inline__",
  [anon_sym___forceinline] = "__forceinline",
  [anon_sym_thread_local] = "thread_local",
  [anon_sym___thread] = "__thread",
  [anon_sym_const] = "const",
  [anon_sym_constexpr] = "constexpr",
  [anon_sym_volatile] = "volatile",
  [anon_sym_restrict] = "restrict",
  [anon_sym___restrict__] = "__restrict__",
  [anon_sym__Atomic] = "_Atomic",
  [anon_sym__Noreturn] = "_Noreturn",
  [anon_sym_noreturn] = "noreturn",
  [sym_primitive_type] = "primitive_type",
  [anon_sym_enum] = "enum",
  [anon_sym_COLON] = ":",
  [anon_sym_struct] = "struct",
  [anon_sym_union] = "union",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym___try] = "__try",
  [anon_sym___except] = "__except",
  [anon_sym___finally] = "__finally",
  [anon_sym___leave] = "__leave",
  [anon_sym_QMARK] = "\?",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym___alignof__] = "__alignof__",
  [anon_sym___alignof] = "__alignof",
  [anon_sym__alignof] = "_alignof",
  [anon_sym_alignof] = "alignof",
  [anon_sym__Alignof] = "_Alignof",
  [anon_sym_offsetof] = "offsetof",
  [anon_sym__Generic] = "_Generic",
  [anon_sym_asm] = "asm",
  [anon_sym___asm__] = "__asm__",
  [anon_sym_DOT] = ".",
  [anon_sym_DASH_GT] = "->",
  [sym_number_literal] = "number_literal",
  [anon_sym_L_SQUOTE] = "L'",
  [anon_sym_u_SQUOTE] = "u'",
  [anon_sym_U_SQUOTE] = "U'",
  [anon_sym_u8_SQUOTE] = "u8'",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_char_literal_token1] = "character",
  [anon_sym_L_DQUOTE] = "L\"",
  [anon_sym_u_DQUOTE] = "u\"",
  [anon_sym_U_DQUOTE] = "U\"",
  [anon_sym_u8_DQUOTE] = "u8\"",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_literal_token1] = "string_content",
  [sym_escape_sequence] = "escape_sequence",
  [sym_system_lib_string] = "system_lib_string",
  [sym_true] = "true",
  [sym_false] = "false",
  [anon_sym_NULL] = "NULL",
  [anon_sym_nullptr] = "nullptr",
  [sym_comment] = "comment",
  [sym_translation_unit] = "translation_unit",
  [sym_preproc_include] = "preproc_include",
  [sym_preproc_def] = "preproc_def",
  [sym_preproc_function_def] = "preproc_function_def",
  [sym_preproc_params] = "preproc_params",
  [sym_preproc_call] = "preproc_call",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_ifdef] = "preproc_ifdef",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_elifdef] = "preproc_elifdef",
  [sym_preproc_if_in_field_declaration_list] = "preproc_if",
  [sym_preproc_ifdef_in_field_declaration_list] = "preproc_ifdef",
  [sym_preproc_else_in_field_declaration_list] = "preproc_else",
  [sym_preproc_elif_in_field_declaration_list] = "preproc_elif",
  [sym_preproc_elifdef_in_field_declaration_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list_no_comma] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list_no_comma] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list_no_comma] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = "preproc_elifdef",
  [sym__preproc_expression] = "_preproc_expression",
  [sym_preproc_parenthesized_expression] = "parenthesized_expression",
  [sym_preproc_defined] = "preproc_defined",
  [sym_preproc_unary_expression] = "unary_expression",
  [sym_preproc_call_expression] = "call_expression",
  [sym_preproc_argument_list] = "argument_list",
  [sym_preproc_binary_expression] = "binary_expression",
  [sym_function_definition] = "function_definition",
  [sym__old_style_function_definition] = "function_definition",
  [sym_declaration] = "declaration",
  [sym_type_definition] = "type_definition",
  [sym__type_definition_type] = "_type_definition_type",
  [sym__type_definition_declarators] = "_type_definition_declarators",
  [sym__declaration_modifiers] = "_declaration_modifiers",
  [sym__declaration_specifiers] = "_declaration_specifiers",
  [sym_linkage_specification] = "linkage_specification",
  [sym_attribute_specifier] = "attribute_specifier",
  [sym_attribute] = "attribute",
  [sym_attribute_declaration] = "attribute_declaration",
  [sym_ms_declspec_modifier] = "ms_declspec_modifier",
  [sym_ms_based_modifier] = "ms_based_modifier",
  [sym_ms_call_modifier] = "ms_call_modifier",
  [sym_ms_unaligned_ptr_modifier] = "ms_unaligned_ptr_modifier",
  [sym_ms_pointer_modifier] = "ms_pointer_modifier",
  [sym_declaration_list] = "declaration_list",
  [sym__declarator] = "_declarator",
  [sym__declaration_declarator] = "_declaration_declarator",
  [sym__field_declarator] = "_field_declarator",
  [sym__type_declarator] = "_type_declarator",
  [sym__abstract_declarator] = "_abstract_declarator",
  [sym_parenthesized_declarator] = "parenthesized_declarator",
  [sym_parenthesized_field_declarator] = "parenthesized_declarator",
  [sym_parenthesized_type_declarator] = "parenthesized_declarator",
  [sym_abstract_parenthesized_declarator] = "abstract_parenthesized_declarator",
  [sym_attributed_declarator] = "attributed_declarator",
  [sym_attributed_field_declarator] = "attributed_declarator",
  [sym_attributed_type_declarator] = "attributed_declarator",
  [sym_pointer_declarator] = "pointer_declarator",
  [sym_pointer_field_declarator] = "pointer_declarator",
  [sym_pointer_type_declarator] = "pointer_declarator",
  [sym_abstract_pointer_declarator] = "abstract_pointer_declarator",
  [sym_function_declarator] = "function_declarator",
  [sym__function_declaration_declarator] = "function_declarator",
  [sym_function_field_declarator] = "function_declarator",
  [sym_function_type_declarator] = "function_declarator",
  [sym_abstract_function_declarator] = "abstract_function_declarator",
  [sym__old_style_function_declarator] = "function_declarator",
  [sym_array_declarator] = "array_declarator",
  [sym_array_field_declarator] = "array_declarator",
  [sym_array_type_declarator] = "array_declarator",
  [sym_abstract_array_declarator] = "abstract_array_declarator",
  [sym_init_declarator] = "init_declarator",
  [sym_compound_statement] = "compound_statement",
  [sym_storage_class_specifier] = "storage_class_specifier",
  [sym_type_qualifier] = "type_qualifier",
  [sym__type_specifier] = "_type_specifier",
  [sym_sized_type_specifier] = "sized_type_specifier",
  [sym_enum_specifier] = "enum_specifier",
  [sym_enumerator_list] = "enumerator_list",
  [sym_struct_specifier] = "struct_specifier",
  [sym_union_specifier] = "union_specifier",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym__field_declaration_list_item] = "_field_declaration_list_item",
  [sym_field_declaration] = "field_declaration",
  [sym__field_declaration_declarator] = "_field_declaration_declarator",
  [sym_bitfield_clause] = "bitfield_clause",
  [sym_enumerator] = "enumerator",
  [sym_variadic_parameter] = "variadic_parameter",
  [sym_parameter_list] = "parameter_list",
  [sym__old_style_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_attributed_statement] = "attributed_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym__top_level_expression_statement] = "expression_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_else_clause] = "else_clause",
  [sym_switch_statement] = "switch_statement",
  [sym_case_statement] = "case_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym__for_statement_body] = "_for_statement_body",
  [sym_return_statement] = "return_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_seh_try_statement] = "seh_try_statement",
  [sym_seh_except_clause] = "seh_except_clause",
  [sym_seh_finally_clause] = "seh_finally_clause",
  [sym_seh_leave_statement] = "seh_leave_statement",
  [sym__expression] = "_expression",
  [sym__expression_not_binary] = "_expression_not_binary",
  [sym__string] = "_string",
  [sym_comma_expression] = "comma_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_pointer_expression] = "pointer_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_update_expression] = "update_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_type_descriptor] = "type_descriptor",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_alignof_expression] = "alignof_expression",
  [sym_offsetof_expression] = "offsetof_expression",
  [sym_generic_expression] = "generic_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_call_expression] = "call_expression",
  [sym_gnu_asm_expression] = "gnu_asm_expression",
  [sym_gnu_asm_qualifier] = "gnu_asm_qualifier",
  [sym_gnu_asm_output_operand_list] = "gnu_asm_output_operand_list",
  [sym_gnu_asm_output_operand] = "gnu_asm_output_operand",
  [sym_gnu_asm_input_operand_list] = "gnu_asm_input_operand_list",
  [sym_gnu_asm_input_operand] = "gnu_asm_input_operand",
  [sym_gnu_asm_clobber_list] = "gnu_asm_clobber_list",
  [sym_gnu_asm_goto_list] = "gnu_asm_goto_list",
  [sym_argument_list] = "argument_list",
  [sym_field_expression] = "field_expression",
  [sym_compound_literal_expression] = "compound_literal_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_initializer_list] = "initializer_list",
  [sym_initializer_pair] = "initializer_pair",
  [sym_subscript_designator] = "subscript_designator",
  [sym_subscript_range_designator] = "subscript_range_designator",
  [sym_field_designator] = "field_designator",
  [sym_char_literal] = "char_literal",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string_literal] = "string_literal",
  [sym_null] = "null",
  [sym__empty_declaration] = "_empty_declaration",
  [sym_macro_type_specifier] = "macro_type_specifier",
  [aux_sym_translation_unit_repeat1] = "translation_unit_repeat1",
  [aux_sym_preproc_params_repeat1] = "preproc_params_repeat1",
  [aux_sym_preproc_if_repeat1] = "preproc_if_repeat1",
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = "preproc_if_in_field_declaration_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = "preproc_if_in_enumerator_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = "preproc_if_in_enumerator_list_no_comma_repeat1",
  [aux_sym_preproc_argument_list_repeat1] = "preproc_argument_list_repeat1",
  [aux_sym__old_style_function_definition_repeat1] = "_old_style_function_definition_repeat1",
  [aux_sym_declaration_repeat1] = "declaration_repeat1",
  [aux_sym_type_definition_repeat1] = "type_definition_repeat1",
  [aux_sym__type_definition_type_repeat1] = "_type_definition_type_repeat1",
  [aux_sym__type_definition_declarators_repeat1] = "_type_definition_declarators_repeat1",
  [aux_sym__declaration_specifiers_repeat1] = "_declaration_specifiers_repeat1",
  [aux_sym_attribute_declaration_repeat1] = "attribute_declaration_repeat1",
  [aux_sym_attributed_declarator_repeat1] = "attributed_declarator_repeat1",
  [aux_sym_pointer_declarator_repeat1] = "pointer_declarator_repeat1",
  [aux_sym_function_declarator_repeat1] = "function_declarator_repeat1",
  [aux_sym_sized_type_specifier_repeat1] = "sized_type_specifier_repeat1",
  [aux_sym_enumerator_list_repeat1] = "enumerator_list_repeat1",
  [aux_sym__field_declaration_declarator_repeat1] = "_field_declaration_declarator_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym__old_style_parameter_list_repeat1] = "_old_style_parameter_list_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_generic_expression_repeat1] = "generic_expression_repeat1",
  [aux_sym_gnu_asm_expression_repeat1] = "gnu_asm_expression_repeat1",
  [aux_sym_gnu_asm_output_operand_list_repeat1] = "gnu_asm_output_operand_list_repeat1",
  [aux_sym_gnu_asm_input_operand_list_repeat1] = "gnu_asm_input_operand_list_repeat1",
  [aux_sym_gnu_asm_clobber_list_repeat1] = "gnu_asm_clobber_list_repeat1",
  [aux_sym_gnu_asm_goto_list_repeat1] = "gnu_asm_goto_list_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_initializer_list_repeat1] = "initializer_list_repeat1",
  [aux_sym_initializer_pair_repeat1] = "initializer_pair_repeat1",
  [aux_sym_char_literal_repeat1] = "char_literal_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [aux_sym_preproc_include_token1] = aux_sym_preproc_include_token1,
  [aux_sym_preproc_include_token2] = aux_sym_preproc_include_token2,
  [aux_sym_preproc_def_token1] = aux_sym_preproc_def_token1,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [aux_sym_preproc_if_token1] = aux_sym_preproc_if_token1,
  [anon_sym_LF] = anon_sym_LF,
  [aux_sym_preproc_if_token2] = aux_sym_preproc_if_token2,
  [aux_sym_preproc_ifdef_token1] = aux_sym_preproc_ifdef_token1,
  [aux_sym_preproc_ifdef_token2] = aux_sym_preproc_ifdef_token2,
  [aux_sym_preproc_else_token1] = aux_sym_preproc_else_token1,
  [aux_sym_preproc_elif_token1] = aux_sym_preproc_elif_token1,
  [aux_sym_preproc_elifdef_token1] = aux_sym_preproc_elifdef_token1,
  [aux_sym_preproc_elifdef_token2] = aux_sym_preproc_elifdef_token2,
  [sym_preproc_arg] = sym_preproc_arg,
  [sym_preproc_directive] = sym_preproc_directive,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_defined] = anon_sym_defined,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym___extension__] = anon_sym___extension__,
  [anon_sym_typedef] = anon_sym_typedef,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym___attribute__] = anon_sym___attribute__,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_LBRACK_LBRACK] = anon_sym_LBRACK_LBRACK,
  [anon_sym_RBRACK_RBRACK] = anon_sym_RBRACK_RBRACK,
  [anon_sym___declspec] = anon_sym___declspec,
  [anon_sym___based] = anon_sym___based,
  [anon_sym___cdecl] = anon_sym___cdecl,
  [anon_sym___clrcall] = anon_sym___clrcall,
  [anon_sym___stdcall] = anon_sym___stdcall,
  [anon_sym___fastcall] = anon_sym___fastcall,
  [anon_sym___thiscall] = anon_sym___thiscall,
  [anon_sym___vectorcall] = anon_sym___vectorcall,
  [sym_ms_restrict_modifier] = sym_ms_restrict_modifier,
  [sym_ms_unsigned_ptr_modifier] = sym_ms_unsigned_ptr_modifier,
  [sym_ms_signed_ptr_modifier] = sym_ms_signed_ptr_modifier,
  [anon_sym__unaligned] = anon_sym__unaligned,
  [anon_sym___unaligned] = anon_sym___unaligned,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_signed] = anon_sym_signed,
  [anon_sym_unsigned] = anon_sym_unsigned,
  [anon_sym_long] = anon_sym_long,
  [anon_sym_short] = anon_sym_short,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_auto] = anon_sym_auto,
  [anon_sym_register] = anon_sym_register,
  [anon_sym_inline] = anon_sym_inline,
  [anon_sym___inline] = anon_sym___inline,
  [anon_sym___inline__] = anon_sym___inline__,
  [anon_sym___forceinline] = anon_sym___forceinline,
  [anon_sym_thread_local] = anon_sym_thread_local,
  [anon_sym___thread] = anon_sym___thread,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_constexpr] = anon_sym_constexpr,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_restrict] = anon_sym_restrict,
  [anon_sym___restrict__] = anon_sym___restrict__,
  [anon_sym__Atomic] = anon_sym__Atomic,
  [anon_sym__Noreturn] = anon_sym__Noreturn,
  [anon_sym_noreturn] = anon_sym_noreturn,
  [sym_primitive_type] = sym_primitive_type,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym___try] = anon_sym___try,
  [anon_sym___except] = anon_sym___except,
  [anon_sym___finally] = anon_sym___finally,
  [anon_sym___leave] = anon_sym___leave,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_sizeof] = anon_sym_sizeof,
  [anon_sym___alignof__] = anon_sym___alignof__,
  [anon_sym___alignof] = anon_sym___alignof,
  [anon_sym__alignof] = anon_sym__alignof,
  [anon_sym_alignof] = anon_sym_alignof,
  [anon_sym__Alignof] = anon_sym__Alignof,
  [anon_sym_offsetof] = anon_sym_offsetof,
  [anon_sym__Generic] = anon_sym__Generic,
  [anon_sym_asm] = anon_sym_asm,
  [anon_sym___asm__] = anon_sym___asm__,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [sym_number_literal] = sym_number_literal,
  [anon_sym_L_SQUOTE] = anon_sym_L_SQUOTE,
  [anon_sym_u_SQUOTE] = anon_sym_u_SQUOTE,
  [anon_sym_U_SQUOTE] = anon_sym_U_SQUOTE,
  [anon_sym_u8_SQUOTE] = anon_sym_u8_SQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_char_literal_token1] = aux_sym_char_literal_token1,
  [anon_sym_L_DQUOTE] = anon_sym_L_DQUOTE,
  [anon_sym_u_DQUOTE] = anon_sym_u_DQUOTE,
  [anon_sym_U_DQUOTE] = anon_sym_U_DQUOTE,
  [anon_sym_u8_DQUOTE] = anon_sym_u8_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_literal_token1] = aux_sym_string_literal_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_system_lib_string] = sym_system_lib_string,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [anon_sym_NULL] = anon_sym_NULL,
  [anon_sym_nullptr] = anon_sym_nullptr,
  [sym_comment] = sym_comment,
  [sym_translation_unit] = sym_translation_unit,
  [sym_preproc_include] = sym_preproc_include,
  [sym_preproc_def] = sym_preproc_def,
  [sym_preproc_function_def] = sym_preproc_function_def,
  [sym_preproc_params] = sym_preproc_params,
  [sym_preproc_call] = sym_preproc_call,
  [sym_preproc_if] = sym_preproc_if,
  [sym_preproc_ifdef] = sym_preproc_ifdef,
  [sym_preproc_else] = sym_preproc_else,
  [sym_preproc_elif] = sym_preproc_elif,
  [sym_preproc_elifdef] = sym_preproc_elifdef,
  [sym_preproc_if_in_field_declaration_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_field_declaration_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_field_declaration_list] = sym_preproc_else,
  [sym_preproc_elif_in_field_declaration_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_field_declaration_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list_no_comma] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list_no_comma] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list_no_comma] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = sym_preproc_elifdef,
  [sym__preproc_expression] = sym__preproc_expression,
  [sym_preproc_parenthesized_expression] = sym_parenthesized_expression,
  [sym_preproc_defined] = sym_preproc_defined,
  [sym_preproc_unary_expression] = sym_unary_expression,
  [sym_preproc_call_expression] = sym_call_expression,
  [sym_preproc_argument_list] = sym_argument_list,
  [sym_preproc_binary_expression] = sym_binary_expression,
  [sym_function_definition] = sym_function_definition,
  [sym__old_style_function_definition] = sym_function_definition,
  [sym_declaration] = sym_declaration,
  [sym_type_definition] = sym_type_definition,
  [sym__type_definition_type] = sym__type_definition_type,
  [sym__type_definition_declarators] = sym__type_definition_declarators,
  [sym__declaration_modifiers] = sym__declaration_modifiers,
  [sym__declaration_specifiers] = sym__declaration_specifiers,
  [sym_linkage_specification] = sym_linkage_specification,
  [sym_attribute_specifier] = sym_attribute_specifier,
  [sym_attribute] = sym_attribute,
  [sym_attribute_declaration] = sym_attribute_declaration,
  [sym_ms_declspec_modifier] = sym_ms_declspec_modifier,
  [sym_ms_based_modifier] = sym_ms_based_modifier,
  [sym_ms_call_modifier] = sym_ms_call_modifier,
  [sym_ms_unaligned_ptr_modifier] = sym_ms_unaligned_ptr_modifier,
  [sym_ms_pointer_modifier] = sym_ms_pointer_modifier,
  [sym_declaration_list] = sym_declaration_list,
  [sym__declarator] = sym__declarator,
  [sym__declaration_declarator] = sym__declaration_declarator,
  [sym__field_declarator] = sym__field_declarator,
  [sym__type_declarator] = sym__type_declarator,
  [sym__abstract_declarator] = sym__abstract_declarator,
  [sym_parenthesized_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_field_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_type_declarator] = sym_parenthesized_declarator,
  [sym_abstract_parenthesized_declarator] = sym_abstract_parenthesized_declarator,
  [sym_attributed_declarator] = sym_attributed_declarator,
  [sym_attributed_field_declarator] = sym_attributed_declarator,
  [sym_attributed_type_declarator] = sym_attributed_declarator,
  [sym_pointer_declarator] = sym_pointer_declarator,
  [sym_pointer_field_declarator] = sym_pointer_declarator,
  [sym_pointer_type_declarator] = sym_pointer_declarator,
  [sym_abstract_pointer_declarator] = sym_abstract_pointer_declarator,
  [sym_function_declarator] = sym_function_declarator,
  [sym__function_declaration_declarator] = sym_function_declarator,
  [sym_function_field_declarator] = sym_function_declarator,
  [sym_function_type_declarator] = sym_function_declarator,
  [sym_abstract_function_declarator] = sym_abstract_function_declarator,
  [sym__old_style_function_declarator] = sym_function_declarator,
  [sym_array_declarator] = sym_array_declarator,
  [sym_array_field_declarator] = sym_array_declarator,
  [sym_array_type_declarator] = sym_array_declarator,
  [sym_abstract_array_declarator] = sym_abstract_array_declarator,
  [sym_init_declarator] = sym_init_declarator,
  [sym_compound_statement] = sym_compound_statement,
  [sym_storage_class_specifier] = sym_storage_class_specifier,
  [sym_type_qualifier] = sym_type_qualifier,
  [sym__type_specifier] = sym__type_specifier,
  [sym_sized_type_specifier] = sym_sized_type_specifier,
  [sym_enum_specifier] = sym_enum_specifier,
  [sym_enumerator_list] = sym_enumerator_list,
  [sym_struct_specifier] = sym_struct_specifier,
  [sym_union_specifier] = sym_union_specifier,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym__field_declaration_list_item] = sym__field_declaration_list_item,
  [sym_field_declaration] = sym_field_declaration,
  [sym__field_declaration_declarator] = sym__field_declaration_declarator,
  [sym_bitfield_clause] = sym_bitfield_clause,
  [sym_enumerator] = sym_enumerator,
  [sym_variadic_parameter] = sym_variadic_parameter,
  [sym_parameter_list] = sym_parameter_list,
  [sym__old_style_parameter_list] = sym_parameter_list,
  [sym_parameter_declaration] = sym_parameter_declaration,
  [sym_attributed_statement] = sym_attributed_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym__top_level_expression_statement] = sym_expression_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_else_clause] = sym_else_clause,
  [sym_switch_statement] = sym_switch_statement,
  [sym_case_statement] = sym_case_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_for_statement] = sym_for_statement,
  [sym__for_statement_body] = sym__for_statement_body,
  [sym_return_statement] = sym_return_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_seh_try_statement] = sym_seh_try_statement,
  [sym_seh_except_clause] = sym_seh_except_clause,
  [sym_seh_finally_clause] = sym_seh_finally_clause,
  [sym_seh_leave_statement] = sym_seh_leave_statement,
  [sym__expression] = sym__expression,
  [sym__expression_not_binary] = sym__expression_not_binary,
  [sym__string] = sym__string,
  [sym_comma_expression] = sym_comma_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_pointer_expression] = sym_pointer_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_type_descriptor] = sym_type_descriptor,
  [sym_sizeof_expression] = sym_sizeof_expression,
  [sym_alignof_expression] = sym_alignof_expression,
  [sym_offsetof_expression] = sym_offsetof_expression,
  [sym_generic_expression] = sym_generic_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_gnu_asm_expression] = sym_gnu_asm_expression,
  [sym_gnu_asm_qualifier] = sym_gnu_asm_qualifier,
  [sym_gnu_asm_output_operand_list] = sym_gnu_asm_output_operand_list,
  [sym_gnu_asm_output_operand] = sym_gnu_asm_output_operand,
  [sym_gnu_asm_input_operand_list] = sym_gnu_asm_input_operand_list,
  [sym_gnu_asm_input_operand] = sym_gnu_asm_input_operand,
  [sym_gnu_asm_clobber_list] = sym_gnu_asm_clobber_list,
  [sym_gnu_asm_goto_list] = sym_gnu_asm_goto_list,
  [sym_argument_list] = sym_argument_list,
  [sym_field_expression] = sym_field_expression,
  [sym_compound_literal_expression] = sym_compound_literal_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_initializer_list] = sym_initializer_list,
  [sym_initializer_pair] = sym_initializer_pair,
  [sym_subscript_designator] = sym_subscript_designator,
  [sym_subscript_range_designator] = sym_subscript_range_designator,
  [sym_field_designator] = sym_field_designator,
  [sym_char_literal] = sym_char_literal,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_string_literal] = sym_string_literal,
  [sym_null] = sym_null,
  [sym__empty_declaration] = sym__empty_declaration,
  [sym_macro_type_specifier] = sym_macro_type_specifier,
  [aux_sym_translation_unit_repeat1] = aux_sym_translation_unit_repeat1,
  [aux_sym_preproc_params_repeat1] = aux_sym_preproc_params_repeat1,
  [aux_sym_preproc_if_repeat1] = aux_sym_preproc_if_repeat1,
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = aux_sym_preproc_if_in_enumerator_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [aux_sym_preproc_argument_list_repeat1] = aux_sym_preproc_argument_list_repeat1,
  [aux_sym__old_style_function_definition_repeat1] = aux_sym__old_style_function_definition_repeat1,
  [aux_sym_declaration_repeat1] = aux_sym_declaration_repeat1,
  [aux_sym_type_definition_repeat1] = aux_sym_type_definition_repeat1,
  [aux_sym__type_definition_type_repeat1] = aux_sym__type_definition_type_repeat1,
  [aux_sym__type_definition_declarators_repeat1] = aux_sym__type_definition_declarators_repeat1,
  [aux_sym__declaration_specifiers_repeat1] = aux_sym__declaration_specifiers_repeat1,
  [aux_sym_attribute_declaration_repeat1] = aux_sym_attribute_declaration_repeat1,
  [aux_sym_attributed_declarator_repeat1] = aux_sym_attributed_declarator_repeat1,
  [aux_sym_pointer_declarator_repeat1] = aux_sym_pointer_declarator_repeat1,
  [aux_sym_function_declarator_repeat1] = aux_sym_function_declarator_repeat1,
  [aux_sym_sized_type_specifier_repeat1] = aux_sym_sized_type_specifier_repeat1,
  [aux_sym_enumerator_list_repeat1] = aux_sym_enumerator_list_repeat1,
  [aux_sym__field_declaration_declarator_repeat1] = aux_sym__field_declaration_declarator_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym__old_style_parameter_list_repeat1] = aux_sym__old_style_parameter_list_repeat1,
  [aux_sym_case_statement_repeat1] = aux_sym_case_statement_repeat1,
  [aux_sym_generic_expression_repeat1] = aux_sym_generic_expression_repeat1,
  [aux_sym_gnu_asm_expression_repeat1] = aux_sym_gnu_asm_expression_repeat1,
  [aux_sym_gnu_asm_output_operand_list_repeat1] = aux_sym_gnu_asm_output_operand_list_repeat1,
  [aux_sym_gnu_asm_input_operand_list_repeat1] = aux_sym_gnu_asm_input_operand_list_repeat1,
  [aux_sym_gnu_asm_clobber_list_repeat1] = aux_sym_gnu_asm_clobber_list_repeat1,
  [aux_sym_gnu_asm_goto_list_repeat1] = aux_sym_gnu_asm_goto_list_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_initializer_list_repeat1] = aux_sym_initializer_list_repeat1,
  [aux_sym_initializer_pair_repeat1] = aux_sym_initializer_pair_repeat1,
  [aux_sym_char_literal_repeat1] = aux_sym_char_literal_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_preproc_include_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_include_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_def_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_else_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elif_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_directive] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___extension__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___attribute__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___declspec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___based] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___cdecl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___clrcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___stdcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___fastcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thiscall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___vectorcall] = {
    .visible = true,
    .named = false,
  },
  [sym_ms_restrict_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unsigned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_signed_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_auto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_register] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___forceinline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thread_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thread] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constexpr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restrict] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___restrict__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noreturn] = {
    .visible = true,
    .named = false,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___leave] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_offsetof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Generic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___asm__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_char_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_system_lib_string] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_NULL] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nullptr] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_translation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_include] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_params] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym__preproc_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_defined] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__old_style_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__type_definition_type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_definition_declarators] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_modifiers] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_linkage_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_declspec_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_based_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_call_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unaligned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_pointer_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__declaration_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym__field_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__type_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__abstract_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym__function_declaration_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym__old_style_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_init_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_storage_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym__type_specifier] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_sized_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_union_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_list_item] = {
    .visible = false,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_bitfield_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym__old_style_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_statement_body] = {
    .visible = false,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_leave_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__expression_not_binary] = {
    .visible = false,
    .named = true,
  },
  [sym__string] = {
    .visible = false,
    .named = true,
  },
  [sym_comma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_alignof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_offsetof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_clobber_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_goto_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_range_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_field_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_macro_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_translation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__old_style_function_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_declarators_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attributed_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pointer_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sized_type_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__field_declaration_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__old_style_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_output_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_input_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_clobber_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_goto_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_pair_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_char_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_argument = 2,
  field_arguments = 3,
  field_assembly_code = 4,
  field_body = 5,
  field_clobbers = 6,
  field_condition = 7,
  field_consequence = 8,
  field_constraint = 9,
  field_declarator = 10,
  field_designator = 11,
  field_directive = 12,
  field_end = 13,
  field_field = 14,
  field_filter = 15,
  field_function = 16,
  field_goto_labels = 17,
  field_index = 18,
  field_initializer = 19,
  field_input_operands = 20,
  field_label = 21,
  field_left = 22,
  field_member = 23,
  field_name = 24,
  field_operand = 25,
  field_operator = 26,
  field_output_operands = 27,
  field_parameters = 28,
  field_path = 29,
  field_prefix = 30,
  field_register = 31,
  field_right = 32,
  field_size = 33,
  field_start = 34,
  field_symbol = 35,
  field_type = 36,
  field_underlying_type = 37,
  field_update = 38,
  field_value = 39,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_assembly_code] = "assembly_code",
  [field_body] = "body",
  [field_clobbers] = "clobbers",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_declarator] = "declarator",
  [field_designator] = "designator",
  [field_directive] = "directive",
  [field_end] = "end",
  [field_field] = "field",
  [field_filter] = "filter",
  [field_function] = "function",
  [field_goto_labels] = "goto_labels",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_input_operands] = "input_operands",
  [field_label] = "label",
  [field_left] = "left",
  [field_member] = "member",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_output_operands] = "output_operands",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_prefix] = "prefix",
  [field_register] = "register",
  [field_right] = "right",
  [field_size] = "size",
  [field_start] = "start",
  [field_symbol] = "symbol",
  [field_type] = "type",
  [field_underlying_type] = "underlying_type",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 3},
  [3] = {.index = 3, .length = 1},
  [4] = {.index = 4, .length = 1},
  [5] = {.index = 5, .length = 2},
  [6] = {.index = 7, .length = 1},
  [7] = {.index = 8, .length = 1},
  [8] = {.index = 9, .length = 1},
  [9] = {.index = 10, .length = 1},
  [10] = {.index = 3, .length = 1},
  [11] = {.index = 11, .length = 2},
  [12] = {.index = 13, .length = 2},
  [13] = {.index = 15, .length = 2},
  [14] = {.index = 17, .length = 1},
  [15] = {.index = 17, .length = 1},
  [16] = {.index = 18, .length = 1},
  [17] = {.index = 8, .length = 1},
  [18] = {.index = 19, .length = 2},
  [19] = {.index = 21, .length = 2},
  [20] = {.index = 23, .length = 1},
  [22] = {.index = 24, .length = 1},
  [23] = {.index = 25, .length = 2},
  [24] = {.index = 27, .length = 2},
  [25] = {.index = 29, .length = 1},
  [26] = {.index = 30, .length = 1},
  [27] = {.index = 31, .length = 2},
  [28] = {.index = 33, .length = 2},
  [29] = {.index = 35, .length = 1},
  [30] = {.index = 36, .length = 3},
  [31] = {.index = 39, .length = 1},
  [32] = {.index = 40, .length = 1},
  [33] = {.index = 41, .length = 3},
  [34] = {.index = 44, .length = 2},
  [35] = {.index = 46, .length = 2},
  [36] = {.index = 48, .length = 5},
  [37] = {.index = 53, .length = 3},
  [38] = {.index = 56, .length = 2},
  [39] = {.index = 58, .length = 2},
  [40] = {.index = 60, .length = 1},
  [41] = {.index = 61, .length = 2},
  [42] = {.index = 63, .length = 1},
  [43] = {.index = 64, .length = 2},
  [44] = {.index = 66, .length = 2},
  [45] = {.index = 68, .length = 2},
  [46] = {.index = 70, .length = 2},
  [47] = {.index = 72, .length = 2},
  [48] = {.index = 74, .length = 2},
  [49] = {.index = 76, .length = 2},
  [50] = {.index = 78, .length = 2},
  [52] = {.index = 80, .length = 2},
  [53] = {.index = 82, .length = 1},
  [54] = {.index = 83, .length = 1},
  [55] = {.index = 84, .length = 3},
  [56] = {.index = 87, .length = 1},
  [57] = {.index = 88, .length = 1},
  [58] = {.index = 89, .length = 1},
  [59] = {.index = 90, .length = 2},
  [60] = {.index = 92, .length = 1},
  [61] = {.index = 93, .length = 3},
  [62] = {.index = 96, .length = 3},
  [63] = {.index = 99, .length = 2},
  [64] = {.index = 101, .length = 3},
  [65] = {.index = 104, .length = 2},
  [66] = {.index = 106, .length = 5},
  [67] = {.index = 111, .length = 3},
  [68] = {.index = 114, .length = 5},
  [69] = {.index = 119, .length = 2},
  [70] = {.index = 121, .length = 2},
  [71] = {.index = 123, .length = 3},
  [72] = {.index = 126, .length = 2},
  [73] = {.index = 128, .length = 2},
  [74] = {.index = 130, .length = 1},
  [75] = {.index = 131, .length = 2},
  [76] = {.index = 133, .length = 2},
  [77] = {.index = 135, .length = 2},
  [78] = {.index = 137, .length = 3},
  [79] = {.index = 140, .length = 2},
  [80] = {.index = 142, .length = 2},
  [81] = {.index = 144, .length = 2},
  [82] = {.index = 146, .length = 1},
  [83] = {.index = 147, .length = 2},
  [84] = {.index = 149, .length = 2},
  [85] = {.index = 151, .length = 4},
  [86] = {.index = 155, .length = 1},
  [87] = {.index = 156, .length = 2},
  [88] = {.index = 158, .length = 1},
  [89] = {.index = 159, .length = 1},
  [90] = {.index = 160, .length = 4},
  [91] = {.index = 164, .length = 4},
  [92] = {.index = 168, .length = 2},
  [93] = {.index = 170, .length = 2},
  [94] = {.index = 172, .length = 3},
  [95] = {.index = 175, .length = 5},
  [96] = {.index = 180, .length = 3},
  [97] = {.index = 183, .length = 2},
  [98] = {.index = 185, .length = 1},
  [100] = {.index = 186, .length = 2},
  [101] = {.index = 188, .length = 2},
  [102] = {.index = 190, .length = 2},
  [103] = {.index = 192, .length = 3},
  [104] = {.index = 195, .length = 2},
  [105] = {.index = 197, .length = 2},
  [106] = {.index = 199, .length = 2},
  [107] = {.index = 201, .length = 2},
  [108] = {.index = 203, .length = 3},
  [109] = {.index = 206, .length = 2},
  [110] = {.index = 208, .length = 1},
  [111] = {.index = 209, .length = 5},
  [112] = {.index = 214, .length = 2},
  [113] = {.index = 216, .length = 3},
  [114] = {.index = 219, .length = 2},
  [115] = {.index = 219, .length = 2},
  [116] = {.index = 221, .length = 3},
  [117] = {.index = 224, .length = 2},
  [118] = {.index = 226, .length = 1},
  [119] = {.index = 227, .length = 4},
  [120] = {.index = 231, .length = 3},
  [121] = {.index = 234, .length = 2},
  [122] = {.index = 236, .length = 2},
  [123] = {.index = 35, .length = 1},
  [124] = {.index = 238, .length = 5},
  [125] = {.index = 243, .length = 4},
  [126] = {.index = 247, .length = 2},
  [127] = {.index = 249, .length = 2},
  [128] = {.index = 251, .length = 2},
  [129] = {.index = 253, .length = 5},
  [130] = {.index = 258, .length = 2},
  [131] = {.index = 260, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_body, 0, .inherited = true},
    {field_declarator, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [3] =
    {field_type, 0},
  [4] =
    {field_directive, 0},
  [5] =
    {field_argument, 1},
    {field_operator, 0},
  [7] =
    {field_name, 0},
  [8] =
    {field_name, 1},
  [9] =
    {field_body, 1},
  [10] =
    {field_value, 1},
  [11] =
    {field_declarator, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
  [13] =
    {field_argument, 0},
    {field_operator, 1},
  [15] =
    {field_arguments, 1},
    {field_function, 0},
  [17] =
    {field_type, 1},
  [18] =
    {field_path, 1},
  [19] =
    {field_argument, 1},
    {field_directive, 0},
  [21] =
    {field_declarator, 1},
    {field_type, 0},
  [23] =
    {field_parameters, 0},
  [24] =
    {field_declarator, 0},
  [25] =
    {field_body, 2},
    {field_value, 1},
  [27] =
    {field_body, 2},
    {field_name, 1},
  [29] =
    {field_name, 2},
  [30] =
    {field_body, 2},
  [31] =
    {field_condition, 1},
    {field_consequence, 2},
  [33] =
    {field_body, 2},
    {field_condition, 1},
  [35] =
    {field_label, 1},
  [36] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [39] =
    {field_label, 0},
  [40] =
    {field_declarator, 1},
  [41] =
    {field_body, 2},
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [44] =
    {field_declarator, 0},
    {field_parameters, 1},
  [46] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [48] =
    {field_body, 2},
    {field_declarator, 1},
    {field_declarator, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type, 0, .inherited = true},
  [53] =
    {field_argument, 0},
    {field_field, 2},
    {field_operator, 1},
  [56] =
    {field_name, 1},
    {field_value, 2},
  [58] =
    {field_name, 1},
    {field_parameters, 2},
  [60] =
    {field_condition, 1},
  [61] =
    {field_alternative, 2},
    {field_name, 1},
  [63] =
    {field_type, 0, .inherited = true},
  [64] =
    {field_declarator, 2},
    {field_type, 0},
  [66] =
    {field_left, 0},
    {field_right, 2},
  [68] =
    {field_type, 1},
    {field_value, 3},
  [70] =
    {field_declarator, 2},
    {field_type, 1},
  [72] =
    {field_declarator, 2, .inherited = true},
    {field_type, 1, .inherited = true},
  [74] =
    {field_declarator, 0},
    {field_declarator, 1, .inherited = true},
  [76] =
    {field_name, 2},
    {field_prefix, 0},
  [78] =
    {field_name, 1},
    {field_underlying_type, 3},
  [80] =
    {field_body, 3},
    {field_name, 2},
  [82] =
    {field_name, 3},
  [83] =
    {field_body, 3},
  [84] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [87] =
    {field_initializer, 0},
  [88] =
    {field_type, 2},
  [89] =
    {field_assembly_code, 2},
  [90] =
    {field_name, 0},
    {field_type, 2},
  [92] =
    {field_declarator, 2},
  [93] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 0, .inherited = true},
  [96] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_type, 0, .inherited = true},
  [99] =
    {field_declarator, 0},
    {field_value, 2},
  [101] =
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
    {field_type, 0, .inherited = true},
  [104] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
  [106] =
    {field_body, 3},
    {field_declarator, 1},
    {field_declarator, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type, 0, .inherited = true},
  [111] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [114] =
    {field_body, 3},
    {field_declarator, 2},
    {field_declarator, 2, .inherited = true},
    {field_parameters, 2, .inherited = true},
    {field_type, 1, .inherited = true},
  [119] =
    {field_argument, 0},
    {field_index, 2},
  [121] =
    {field_alternative, 3},
    {field_condition, 0},
  [123] =
    {field_name, 1},
    {field_parameters, 2},
    {field_value, 3},
  [126] =
    {field_alternative, 3},
    {field_condition, 1},
  [128] =
    {field_alternative, 3},
    {field_name, 1},
  [130] =
    {field_size, 1},
  [131] =
    {field_declarator, 3},
    {field_type, 1},
  [133] =
    {field_declarator, 3, .inherited = true},
    {field_type, 2, .inherited = true},
  [135] =
    {field_name, 0},
    {field_value, 2},
  [137] =
    {field_body, 4},
    {field_name, 1},
    {field_underlying_type, 3},
  [140] =
    {field_declarator, 1, .inherited = true},
    {field_type, 0, .inherited = true},
  [142] =
    {field_body, 4},
    {field_name, 3},
  [144] =
    {field_body, 1},
    {field_condition, 3},
  [146] =
    {field_update, 2},
  [147] =
    {field_initializer, 0},
    {field_update, 2},
  [149] =
    {field_condition, 1},
    {field_initializer, 0},
  [151] =
    {field_body, 4},
    {field_condition, 2, .inherited = true},
    {field_initializer, 2, .inherited = true},
    {field_update, 2, .inherited = true},
  [155] =
    {field_operand, 1},
  [156] =
    {field_assembly_code, 2},
    {field_output_operands, 3},
  [158] =
    {field_assembly_code, 3},
  [159] =
    {field_declarator, 3},
  [160] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3},
    {field_type, 0, .inherited = true},
  [164] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [168] =
    {field_declarator, 0},
    {field_size, 2},
  [170] =
    {field_declarator, 1},
    {field_declarator, 2},
  [172] =
    {field_body, 4},
    {field_declarator, 3},
    {field_type, 1, .inherited = true},
  [175] =
    {field_body, 4},
    {field_declarator, 2},
    {field_declarator, 2, .inherited = true},
    {field_parameters, 2, .inherited = true},
    {field_type, 1, .inherited = true},
  [180] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [183] =
    {field_alternative, 4},
    {field_condition, 1},
  [185] =
    {field_size, 2},
  [186] =
    {field_body, 2},
    {field_filter, 1},
  [188] =
    {field_declarator, 0},
    {field_declarator, 2, .inherited = true},
  [190] =
    {field_condition, 1},
    {field_update, 3},
  [192] =
    {field_condition, 1},
    {field_initializer, 0},
    {field_update, 3},
  [195] =
    {field_initializer, 0},
    {field_update, 3},
  [197] =
    {field_condition, 2},
    {field_initializer, 0},
  [199] =
    {field_member, 4},
    {field_type, 2},
  [201] =
    {field_operand, 1},
    {field_operand, 2, .inherited = true},
  [203] =
    {field_assembly_code, 2},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [206] =
    {field_assembly_code, 3},
    {field_output_operands, 4},
  [208] =
    {field_declarator, 4},
  [209] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3},
    {field_declarator, 4, .inherited = true},
    {field_type, 0, .inherited = true},
  [214] =
    {field_declarator, 0},
    {field_size, 3},
  [216] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3},
  [219] =
    {field_designator, 0},
    {field_value, 2},
  [221] =
    {field_condition, 2},
    {field_initializer, 0},
    {field_update, 4},
  [224] =
    {field_operand, 0, .inherited = true},
    {field_operand, 1, .inherited = true},
  [226] =
    {field_register, 1},
  [227] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [231] =
    {field_assembly_code, 3},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [234] =
    {field_constraint, 0},
    {field_value, 2},
  [236] =
    {field_register, 1},
    {field_register, 2, .inherited = true},
  [238] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_goto_labels, 6},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [243] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [247] =
    {field_end, 3},
    {field_start, 1},
  [249] =
    {field_register, 0, .inherited = true},
    {field_register, 1, .inherited = true},
  [251] =
    {field_label, 1},
    {field_label, 2, .inherited = true},
  [253] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_goto_labels, 7},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [258] =
    {field_label, 0, .inherited = true},
    {field_label, 1, .inherited = true},
  [260] =
    {field_constraint, 3},
    {field_symbol, 1},
    {field_value, 5},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [7] = {
    [1] = alias_sym_type_identifier,
  },
  [10] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [1] = alias_sym_type_identifier,
  },
  [21] = {
    [0] = sym_primitive_type,
  },
  [24] = {
    [1] = alias_sym_type_identifier,
  },
  [25] = {
    [2] = alias_sym_type_identifier,
  },
  [29] = {
    [1] = alias_sym_statement_identifier,
  },
  [31] = {
    [0] = alias_sym_statement_identifier,
  },
  [37] = {
    [2] = alias_sym_field_identifier,
  },
  [50] = {
    [1] = alias_sym_type_identifier,
  },
  [51] = {
    [0] = alias_sym_field_identifier,
  },
  [52] = {
    [2] = alias_sym_type_identifier,
  },
  [53] = {
    [3] = alias_sym_type_identifier,
  },
  [78] = {
    [1] = alias_sym_type_identifier,
  },
  [80] = {
    [3] = alias_sym_type_identifier,
  },
  [99] = {
    [1] = alias_sym_field_identifier,
  },
  [106] = {
    [4] = alias_sym_field_identifier,
  },
  [114] = {
    [0] = alias_sym_field_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 4,
  [5] = 4,
  [6] = 4,
  [7] = 4,
  [8] = 2,
  [9] = 4,
  [10] = 2,
  [11] = 2,
  [12] = 12,
  [13] = 12,
  [14] = 12,
  [15] = 15,
  [16] = 16,
  [17] = 12,
  [18] = 18,
  [19] = 19,
  [20] = 19,
  [21] = 21,
  [22] = 12,
  [23] = 19,
  [24] = 19,
  [25] = 19,
  [26] = 26,
  [27] = 16,
  [28] = 28,
  [29] = 28,
  [30] = 30,
  [31] = 31,
  [32] = 28,
  [33] = 31,
  [34] = 34,
  [35] = 34,
  [36] = 36,
  [37] = 31,
  [38] = 38,
  [39] = 30,
  [40] = 16,
  [41] = 28,
  [42] = 31,
  [43] = 31,
  [44] = 30,
  [45] = 34,
  [46] = 30,
  [47] = 16,
  [48] = 34,
  [49] = 28,
  [50] = 34,
  [51] = 30,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 55,
  [60] = 58,
  [61] = 57,
  [62] = 56,
  [63] = 54,
  [64] = 57,
  [65] = 58,
  [66] = 54,
  [67] = 58,
  [68] = 55,
  [69] = 54,
  [70] = 58,
  [71] = 57,
  [72] = 56,
  [73] = 56,
  [74] = 55,
  [75] = 54,
  [76] = 55,
  [77] = 56,
  [78] = 57,
  [79] = 54,
  [80] = 58,
  [81] = 57,
  [82] = 56,
  [83] = 55,
  [84] = 84,
  [85] = 84,
  [86] = 84,
  [87] = 84,
  [88] = 84,
  [89] = 84,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 96,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 107,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 90,
  [172] = 128,
  [173] = 115,
  [174] = 98,
  [175] = 91,
  [176] = 121,
  [177] = 101,
  [178] = 99,
  [179] = 122,
  [180] = 110,
  [181] = 120,
  [182] = 109,
  [183] = 119,
  [184] = 139,
  [185] = 111,
  [186] = 124,
  [187] = 140,
  [188] = 112,
  [189] = 113,
  [190] = 141,
  [191] = 142,
  [192] = 125,
  [193] = 117,
  [194] = 116,
  [195] = 126,
  [196] = 118,
  [197] = 102,
  [198] = 114,
  [199] = 108,
  [200] = 127,
  [201] = 96,
  [202] = 106,
  [203] = 131,
  [204] = 130,
  [205] = 129,
  [206] = 123,
  [207] = 132,
  [208] = 135,
  [209] = 100,
  [210] = 134,
  [211] = 136,
  [212] = 92,
  [213] = 107,
  [214] = 137,
  [215] = 138,
  [216] = 93,
  [217] = 94,
  [218] = 95,
  [219] = 97,
  [220] = 103,
  [221] = 104,
  [222] = 157,
  [223] = 168,
  [224] = 144,
  [225] = 145,
  [226] = 146,
  [227] = 167,
  [228] = 152,
  [229] = 165,
  [230] = 90,
  [231] = 147,
  [232] = 169,
  [233] = 164,
  [234] = 161,
  [235] = 149,
  [236] = 156,
  [237] = 160,
  [238] = 238,
  [239] = 166,
  [240] = 238,
  [241] = 159,
  [242] = 155,
  [243] = 90,
  [244] = 90,
  [245] = 153,
  [246] = 170,
  [247] = 151,
  [248] = 143,
  [249] = 163,
  [250] = 150,
  [251] = 148,
  [252] = 162,
  [253] = 154,
  [254] = 158,
  [255] = 136,
  [256] = 141,
  [257] = 139,
  [258] = 140,
  [259] = 127,
  [260] = 138,
  [261] = 137,
  [262] = 104,
  [263] = 103,
  [264] = 92,
  [265] = 135,
  [266] = 139,
  [267] = 132,
  [268] = 140,
  [269] = 129,
  [270] = 141,
  [271] = 131,
  [272] = 134,
  [273] = 126,
  [274] = 125,
  [275] = 124,
  [276] = 138,
  [277] = 137,
  [278] = 123,
  [279] = 122,
  [280] = 121,
  [281] = 109,
  [282] = 130,
  [283] = 120,
  [284] = 128,
  [285] = 110,
  [286] = 92,
  [287] = 119,
  [288] = 117,
  [289] = 116,
  [290] = 114,
  [291] = 108,
  [292] = 111,
  [293] = 112,
  [294] = 106,
  [295] = 118,
  [296] = 102,
  [297] = 115,
  [298] = 142,
  [299] = 101,
  [300] = 91,
  [301] = 97,
  [302] = 99,
  [303] = 98,
  [304] = 136,
  [305] = 135,
  [306] = 113,
  [307] = 112,
  [308] = 113,
  [309] = 100,
  [310] = 99,
  [311] = 132,
  [312] = 98,
  [313] = 129,
  [314] = 127,
  [315] = 100,
  [316] = 126,
  [317] = 125,
  [318] = 124,
  [319] = 134,
  [320] = 107,
  [321] = 111,
  [322] = 110,
  [323] = 93,
  [324] = 109,
  [325] = 131,
  [326] = 94,
  [327] = 95,
  [328] = 97,
  [329] = 115,
  [330] = 123,
  [331] = 122,
  [332] = 103,
  [333] = 104,
  [334] = 118,
  [335] = 96,
  [336] = 121,
  [337] = 109,
  [338] = 120,
  [339] = 96,
  [340] = 110,
  [341] = 104,
  [342] = 111,
  [343] = 103,
  [344] = 112,
  [345] = 113,
  [346] = 119,
  [347] = 117,
  [348] = 128,
  [349] = 130,
  [350] = 97,
  [351] = 130,
  [352] = 131,
  [353] = 98,
  [354] = 95,
  [355] = 91,
  [356] = 101,
  [357] = 94,
  [358] = 102,
  [359] = 139,
  [360] = 140,
  [361] = 141,
  [362] = 142,
  [363] = 118,
  [364] = 115,
  [365] = 116,
  [366] = 93,
  [367] = 114,
  [368] = 108,
  [369] = 106,
  [370] = 138,
  [371] = 142,
  [372] = 107,
  [373] = 137,
  [374] = 95,
  [375] = 94,
  [376] = 93,
  [377] = 102,
  [378] = 92,
  [379] = 128,
  [380] = 101,
  [381] = 91,
  [382] = 136,
  [383] = 134,
  [384] = 135,
  [385] = 132,
  [386] = 99,
  [387] = 100,
  [388] = 106,
  [389] = 108,
  [390] = 114,
  [391] = 116,
  [392] = 117,
  [393] = 119,
  [394] = 120,
  [395] = 121,
  [396] = 122,
  [397] = 123,
  [398] = 124,
  [399] = 125,
  [400] = 126,
  [401] = 127,
  [402] = 129,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 148,
  [408] = 408,
  [409] = 409,
  [410] = 149,
  [411] = 411,
  [412] = 150,
  [413] = 143,
  [414] = 403,
  [415] = 415,
  [416] = 411,
  [417] = 408,
  [418] = 159,
  [419] = 151,
  [420] = 155,
  [421] = 144,
  [422] = 157,
  [423] = 409,
  [424] = 166,
  [425] = 169,
  [426] = 168,
  [427] = 167,
  [428] = 403,
  [429] = 415,
  [430] = 170,
  [431] = 165,
  [432] = 411,
  [433] = 164,
  [434] = 161,
  [435] = 405,
  [436] = 156,
  [437] = 406,
  [438] = 149,
  [439] = 415,
  [440] = 170,
  [441] = 404,
  [442] = 163,
  [443] = 409,
  [444] = 160,
  [445] = 162,
  [446] = 160,
  [447] = 158,
  [448] = 404,
  [449] = 404,
  [450] = 154,
  [451] = 153,
  [452] = 148,
  [453] = 150,
  [454] = 411,
  [455] = 415,
  [456] = 162,
  [457] = 403,
  [458] = 408,
  [459] = 408,
  [460] = 143,
  [461] = 415,
  [462] = 403,
  [463] = 411,
  [464] = 147,
  [465] = 152,
  [466] = 415,
  [467] = 146,
  [468] = 144,
  [469] = 145,
  [470] = 411,
  [471] = 147,
  [472] = 408,
  [473] = 409,
  [474] = 406,
  [475] = 169,
  [476] = 145,
  [477] = 168,
  [478] = 167,
  [479] = 238,
  [480] = 159,
  [481] = 158,
  [482] = 146,
  [483] = 151,
  [484] = 405,
  [485] = 406,
  [486] = 166,
  [487] = 405,
  [488] = 409,
  [489] = 165,
  [490] = 152,
  [491] = 164,
  [492] = 161,
  [493] = 156,
  [494] = 405,
  [495] = 406,
  [496] = 163,
  [497] = 406,
  [498] = 153,
  [499] = 409,
  [500] = 403,
  [501] = 405,
  [502] = 154,
  [503] = 404,
  [504] = 155,
  [505] = 157,
  [506] = 408,
  [507] = 149,
  [508] = 151,
  [509] = 238,
  [510] = 165,
  [511] = 511,
  [512] = 162,
  [513] = 166,
  [514] = 147,
  [515] = 156,
  [516] = 153,
  [517] = 517,
  [518] = 169,
  [519] = 163,
  [520] = 158,
  [521] = 157,
  [522] = 159,
  [523] = 154,
  [524] = 143,
  [525] = 150,
  [526] = 160,
  [527] = 148,
  [528] = 155,
  [529] = 146,
  [530] = 144,
  [531] = 145,
  [532] = 161,
  [533] = 167,
  [534] = 168,
  [535] = 152,
  [536] = 164,
  [537] = 537,
  [538] = 538,
  [539] = 537,
  [540] = 538,
  [541] = 538,
  [542] = 538,
  [543] = 538,
  [544] = 537,
  [545] = 537,
  [546] = 537,
  [547] = 538,
  [548] = 537,
  [549] = 537,
  [550] = 538,
  [551] = 537,
  [552] = 538,
  [553] = 553,
  [554] = 238,
  [555] = 238,
  [556] = 556,
  [557] = 238,
  [558] = 238,
  [559] = 90,
  [560] = 560,
  [561] = 560,
  [562] = 562,
  [563] = 560,
  [564] = 560,
  [565] = 560,
  [566] = 560,
  [567] = 560,
  [568] = 560,
  [569] = 560,
  [570] = 560,
  [571] = 571,
  [572] = 560,
  [573] = 573,
  [574] = 574,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 583,
  [584] = 584,
  [585] = 584,
  [586] = 586,
  [587] = 587,
  [588] = 587,
  [589] = 586,
  [590] = 590,
  [591] = 591,
  [592] = 592,
  [593] = 591,
  [594] = 592,
  [595] = 591,
  [596] = 592,
  [597] = 592,
  [598] = 591,
  [599] = 599,
  [600] = 600,
  [601] = 601,
  [602] = 600,
  [603] = 603,
  [604] = 604,
  [605] = 605,
  [606] = 600,
  [607] = 600,
  [608] = 608,
  [609] = 609,
  [610] = 609,
  [611] = 609,
  [612] = 609,
  [613] = 613,
  [614] = 613,
  [615] = 615,
  [616] = 601,
  [617] = 617,
  [618] = 618,
  [619] = 618,
  [620] = 620,
  [621] = 618,
  [622] = 618,
  [623] = 620,
  [624] = 620,
  [625] = 625,
  [626] = 625,
  [627] = 618,
  [628] = 628,
  [629] = 618,
  [630] = 630,
  [631] = 618,
  [632] = 632,
  [633] = 625,
  [634] = 634,
  [635] = 635,
  [636] = 636,
  [637] = 637,
  [638] = 625,
  [639] = 639,
  [640] = 625,
  [641] = 641,
  [642] = 642,
  [643] = 625,
  [644] = 618,
  [645] = 625,
  [646] = 625,
  [647] = 620,
  [648] = 620,
  [649] = 649,
  [650] = 650,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 655,
  [656] = 656,
  [657] = 657,
  [658] = 658,
  [659] = 659,
  [660] = 601,
  [661] = 655,
  [662] = 662,
  [663] = 663,
  [664] = 664,
  [665] = 665,
  [666] = 666,
  [667] = 667,
  [668] = 601,
  [669] = 669,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 673,
  [674] = 674,
  [675] = 675,
  [676] = 676,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 678,
  [682] = 682,
  [683] = 670,
  [684] = 684,
  [685] = 685,
  [686] = 676,
  [687] = 687,
  [688] = 688,
  [689] = 689,
  [690] = 670,
  [691] = 691,
  [692] = 692,
  [693] = 693,
  [694] = 678,
  [695] = 676,
  [696] = 696,
  [697] = 674,
  [698] = 698,
  [699] = 699,
  [700] = 687,
  [701] = 675,
  [702] = 677,
  [703] = 679,
  [704] = 678,
  [705] = 680,
  [706] = 669,
  [707] = 670,
  [708] = 692,
  [709] = 709,
  [710] = 682,
  [711] = 711,
  [712] = 684,
  [713] = 692,
  [714] = 688,
  [715] = 692,
  [716] = 696,
  [717] = 674,
  [718] = 718,
  [719] = 670,
  [720] = 675,
  [721] = 677,
  [722] = 678,
  [723] = 679,
  [724] = 698,
  [725] = 680,
  [726] = 669,
  [727] = 682,
  [728] = 698,
  [729] = 679,
  [730] = 674,
  [731] = 684,
  [732] = 696,
  [733] = 688,
  [734] = 684,
  [735] = 682,
  [736] = 669,
  [737] = 680,
  [738] = 679,
  [739] = 677,
  [740] = 688,
  [741] = 675,
  [742] = 677,
  [743] = 679,
  [744] = 680,
  [745] = 669,
  [746] = 696,
  [747] = 682,
  [748] = 674,
  [749] = 698,
  [750] = 684,
  [751] = 688,
  [752] = 699,
  [753] = 753,
  [754] = 677,
  [755] = 692,
  [756] = 679,
  [757] = 687,
  [758] = 680,
  [759] = 693,
  [760] = 669,
  [761] = 685,
  [762] = 682,
  [763] = 691,
  [764] = 684,
  [765] = 688,
  [766] = 766,
  [767] = 677,
  [768] = 680,
  [769] = 669,
  [770] = 682,
  [771] = 684,
  [772] = 696,
  [773] = 688,
  [774] = 678,
  [775] = 696,
  [776] = 696,
  [777] = 674,
  [778] = 698,
  [779] = 676,
  [780] = 691,
  [781] = 678,
  [782] = 711,
  [783] = 670,
  [784] = 698,
  [785] = 692,
  [786] = 674,
  [787] = 698,
  [788] = 711,
  [789] = 789,
  [790] = 711,
  [791] = 692,
  [792] = 670,
  [793] = 687,
  [794] = 678,
  [795] = 698,
  [796] = 691,
  [797] = 676,
  [798] = 691,
  [799] = 676,
  [800] = 674,
  [801] = 696,
  [802] = 688,
  [803] = 711,
  [804] = 684,
  [805] = 692,
  [806] = 682,
  [807] = 691,
  [808] = 676,
  [809] = 670,
  [810] = 669,
  [811] = 676,
  [812] = 680,
  [813] = 689,
  [814] = 711,
  [815] = 679,
  [816] = 766,
  [817] = 689,
  [818] = 677,
  [819] = 691,
  [820] = 691,
  [821] = 571,
  [822] = 822,
  [823] = 822,
  [824] = 824,
  [825] = 825,
  [826] = 822,
  [827] = 827,
  [828] = 822,
  [829] = 822,
  [830] = 830,
  [831] = 831,
  [832] = 832,
  [833] = 833,
  [834] = 834,
  [835] = 835,
  [836] = 836,
  [837] = 837,
  [838] = 838,
  [839] = 839,
  [840] = 840,
  [841] = 841,
  [842] = 842,
  [843] = 843,
  [844] = 844,
  [845] = 845,
  [846] = 553,
  [847] = 843,
  [848] = 556,
  [849] = 849,
  [850] = 850,
  [851] = 851,
  [852] = 849,
  [853] = 851,
  [854] = 854,
  [855] = 855,
  [856] = 856,
  [857] = 857,
  [858] = 858,
  [859] = 859,
  [860] = 851,
  [861] = 861,
  [862] = 862,
  [863] = 863,
  [864] = 864,
  [865] = 865,
  [866] = 866,
  [867] = 855,
  [868] = 851,
  [869] = 869,
  [870] = 870,
  [871] = 849,
  [872] = 872,
  [873] = 851,
  [874] = 855,
  [875] = 855,
  [876] = 854,
  [877] = 854,
  [878] = 854,
  [879] = 849,
  [880] = 855,
  [881] = 854,
  [882] = 882,
  [883] = 883,
  [884] = 884,
  [885] = 849,
  [886] = 886,
  [887] = 887,
  [888] = 888,
  [889] = 889,
  [890] = 845,
  [891] = 891,
  [892] = 892,
  [893] = 893,
  [894] = 894,
  [895] = 895,
  [896] = 830,
  [897] = 897,
  [898] = 898,
  [899] = 899,
  [900] = 900,
  [901] = 901,
  [902] = 902,
  [903] = 825,
  [904] = 827,
  [905] = 824,
  [906] = 830,
  [907] = 830,
  [908] = 908,
  [909] = 830,
  [910] = 845,
  [911] = 911,
  [912] = 911,
  [913] = 911,
  [914] = 914,
  [915] = 914,
  [916] = 832,
  [917] = 911,
  [918] = 831,
  [919] = 914,
  [920] = 914,
  [921] = 914,
  [922] = 911,
  [923] = 923,
  [924] = 924,
  [925] = 923,
  [926] = 926,
  [927] = 923,
  [928] = 928,
  [929] = 929,
  [930] = 930,
  [931] = 931,
  [932] = 932,
  [933] = 933,
  [934] = 923,
  [935] = 923,
  [936] = 926,
  [937] = 937,
  [938] = 923,
  [939] = 556,
  [940] = 940,
  [941] = 553,
  [942] = 942,
  [943] = 943,
  [944] = 944,
  [945] = 945,
  [946] = 946,
  [947] = 947,
  [948] = 948,
  [949] = 830,
  [950] = 950,
  [951] = 951,
  [952] = 952,
  [953] = 953,
  [954] = 954,
  [955] = 955,
  [956] = 956,
  [957] = 942,
  [958] = 901,
  [959] = 959,
  [960] = 960,
  [961] = 961,
  [962] = 962,
  [963] = 940,
  [964] = 897,
  [965] = 965,
  [966] = 966,
  [967] = 967,
  [968] = 968,
  [969] = 969,
  [970] = 895,
  [971] = 954,
  [972] = 953,
  [973] = 952,
  [974] = 974,
  [975] = 951,
  [976] = 948,
  [977] = 947,
  [978] = 946,
  [979] = 945,
  [980] = 944,
  [981] = 892,
  [982] = 943,
  [983] = 983,
  [984] = 984,
  [985] = 985,
  [986] = 986,
  [987] = 943,
  [988] = 944,
  [989] = 989,
  [990] = 946,
  [991] = 991,
  [992] = 992,
  [993] = 951,
  [994] = 952,
  [995] = 953,
  [996] = 902,
  [997] = 954,
  [998] = 998,
  [999] = 945,
  [1000] = 1000,
  [1001] = 889,
  [1002] = 887,
  [1003] = 983,
  [1004] = 942,
  [1005] = 947,
  [1006] = 1006,
  [1007] = 1007,
  [1008] = 1008,
  [1009] = 1009,
  [1010] = 1010,
  [1011] = 1011,
  [1012] = 1012,
  [1013] = 1013,
  [1014] = 1014,
  [1015] = 1015,
  [1016] = 1016,
  [1017] = 1017,
  [1018] = 891,
  [1019] = 1019,
  [1020] = 1020,
  [1021] = 899,
  [1022] = 1022,
  [1023] = 1023,
  [1024] = 1024,
  [1025] = 1025,
  [1026] = 1026,
  [1027] = 1027,
  [1028] = 1028,
  [1029] = 1029,
  [1030] = 1030,
  [1031] = 1031,
  [1032] = 940,
  [1033] = 948,
  [1034] = 1034,
  [1035] = 1035,
  [1036] = 1036,
  [1037] = 1037,
  [1038] = 1038,
  [1039] = 900,
  [1040] = 1040,
  [1041] = 1041,
  [1042] = 1042,
  [1043] = 835,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 1046,
  [1047] = 858,
  [1048] = 1048,
  [1049] = 1049,
  [1050] = 856,
  [1051] = 1051,
  [1052] = 841,
  [1053] = 861,
  [1054] = 834,
  [1055] = 883,
  [1056] = 838,
  [1057] = 865,
  [1058] = 864,
  [1059] = 1059,
  [1060] = 859,
  [1061] = 1061,
  [1062] = 1062,
  [1063] = 833,
  [1064] = 866,
  [1065] = 837,
  [1066] = 166,
  [1067] = 1067,
  [1068] = 157,
  [1069] = 1069,
  [1070] = 155,
  [1071] = 870,
  [1072] = 872,
  [1073] = 884,
  [1074] = 843,
  [1075] = 882,
  [1076] = 842,
  [1077] = 857,
  [1078] = 840,
  [1079] = 886,
  [1080] = 850,
  [1081] = 839,
  [1082] = 1082,
  [1083] = 151,
  [1084] = 869,
  [1085] = 159,
  [1086] = 149,
  [1087] = 836,
  [1088] = 983,
  [1089] = 1089,
  [1090] = 1090,
  [1091] = 1089,
  [1092] = 1089,
  [1093] = 1089,
  [1094] = 1089,
  [1095] = 159,
  [1096] = 891,
  [1097] = 1059,
  [1098] = 953,
  [1099] = 954,
  [1100] = 902,
  [1101] = 940,
  [1102] = 942,
  [1103] = 155,
  [1104] = 1104,
  [1105] = 1044,
  [1106] = 1082,
  [1107] = 1061,
  [1108] = 1062,
  [1109] = 1045,
  [1110] = 1067,
  [1111] = 1069,
  [1112] = 1112,
  [1113] = 1113,
  [1114] = 149,
  [1115] = 1048,
  [1116] = 1051,
  [1117] = 952,
  [1118] = 151,
  [1119] = 945,
  [1120] = 951,
  [1121] = 1121,
  [1122] = 1122,
  [1123] = 1049,
  [1124] = 1046,
  [1125] = 157,
  [1126] = 166,
  [1127] = 887,
  [1128] = 943,
  [1129] = 889,
  [1130] = 899,
  [1131] = 944,
  [1132] = 900,
  [1133] = 948,
  [1134] = 947,
  [1135] = 946,
  [1136] = 831,
  [1137] = 832,
  [1138] = 983,
  [1139] = 1051,
  [1140] = 1061,
  [1141] = 157,
  [1142] = 155,
  [1143] = 155,
  [1144] = 1046,
  [1145] = 1069,
  [1146] = 1067,
  [1147] = 1046,
  [1148] = 1048,
  [1149] = 1049,
  [1150] = 1048,
  [1151] = 1062,
  [1152] = 1152,
  [1153] = 1153,
  [1154] = 149,
  [1155] = 159,
  [1156] = 151,
  [1157] = 1152,
  [1158] = 1069,
  [1159] = 1059,
  [1160] = 157,
  [1161] = 166,
  [1162] = 1082,
  [1163] = 1163,
  [1164] = 1049,
  [1165] = 1152,
  [1166] = 1166,
  [1167] = 1061,
  [1168] = 1059,
  [1169] = 1152,
  [1170] = 1044,
  [1171] = 1152,
  [1172] = 1045,
  [1173] = 151,
  [1174] = 159,
  [1175] = 1051,
  [1176] = 1067,
  [1177] = 166,
  [1178] = 1045,
  [1179] = 1044,
  [1180] = 1062,
  [1181] = 1082,
  [1182] = 149,
  [1183] = 141,
  [1184] = 139,
  [1185] = 98,
  [1186] = 91,
  [1187] = 101,
  [1188] = 102,
  [1189] = 118,
  [1190] = 142,
  [1191] = 115,
  [1192] = 140,
  [1193] = 1193,
  [1194] = 1194,
  [1195] = 1195,
  [1196] = 1196,
  [1197] = 1197,
  [1198] = 1198,
  [1199] = 1199,
  [1200] = 1200,
  [1201] = 1201,
  [1202] = 944,
  [1203] = 945,
  [1204] = 946,
  [1205] = 947,
  [1206] = 948,
  [1207] = 953,
  [1208] = 942,
  [1209] = 943,
  [1210] = 940,
  [1211] = 952,
  [1212] = 951,
  [1213] = 954,
  [1214] = 951,
  [1215] = 944,
  [1216] = 1216,
  [1217] = 954,
  [1218] = 946,
  [1219] = 91,
  [1220] = 953,
  [1221] = 1221,
  [1222] = 940,
  [1223] = 945,
  [1224] = 943,
  [1225] = 952,
  [1226] = 98,
  [1227] = 139,
  [1228] = 140,
  [1229] = 947,
  [1230] = 1221,
  [1231] = 101,
  [1232] = 1232,
  [1233] = 1233,
  [1234] = 1221,
  [1235] = 115,
  [1236] = 118,
  [1237] = 102,
  [1238] = 948,
  [1239] = 142,
  [1240] = 1221,
  [1241] = 1221,
  [1242] = 942,
  [1243] = 141,
  [1244] = 946,
  [1245] = 1245,
  [1246] = 1246,
  [1247] = 942,
  [1248] = 1248,
  [1249] = 940,
  [1250] = 951,
  [1251] = 952,
  [1252] = 954,
  [1253] = 953,
  [1254] = 948,
  [1255] = 1255,
  [1256] = 947,
  [1257] = 943,
  [1258] = 1201,
  [1259] = 944,
  [1260] = 945,
  [1261] = 1261,
  [1262] = 1262,
  [1263] = 1263,
  [1264] = 1264,
  [1265] = 1265,
  [1266] = 1266,
  [1267] = 1267,
  [1268] = 1268,
  [1269] = 1269,
  [1270] = 1270,
  [1271] = 1271,
  [1272] = 1272,
  [1273] = 1273,
  [1274] = 1274,
  [1275] = 1275,
  [1276] = 1276,
  [1277] = 1277,
  [1278] = 1278,
  [1279] = 1277,
  [1280] = 1278,
  [1281] = 1281,
  [1282] = 1276,
  [1283] = 1275,
  [1284] = 953,
  [1285] = 1285,
  [1286] = 1286,
  [1287] = 1287,
  [1288] = 1288,
  [1289] = 1289,
  [1290] = 1290,
  [1291] = 1291,
  [1292] = 954,
  [1293] = 1293,
  [1294] = 1285,
  [1295] = 1295,
  [1296] = 1296,
  [1297] = 1295,
  [1298] = 1298,
  [1299] = 1299,
  [1300] = 1300,
  [1301] = 1301,
  [1302] = 1302,
  [1303] = 1303,
  [1304] = 1296,
  [1305] = 1296,
  [1306] = 1306,
  [1307] = 1307,
  [1308] = 952,
  [1309] = 1309,
  [1310] = 1310,
  [1311] = 1286,
  [1312] = 1285,
  [1313] = 1286,
  [1314] = 951,
  [1315] = 1315,
  [1316] = 1316,
  [1317] = 1317,
  [1318] = 1318,
  [1319] = 948,
  [1320] = 1296,
  [1321] = 947,
  [1322] = 946,
  [1323] = 945,
  [1324] = 1201,
  [1325] = 1298,
  [1326] = 1306,
  [1327] = 1288,
  [1328] = 1328,
  [1329] = 1298,
  [1330] = 944,
  [1331] = 1296,
  [1332] = 1296,
  [1333] = 1333,
  [1334] = 1317,
  [1335] = 1335,
  [1336] = 1287,
  [1337] = 943,
  [1338] = 1296,
  [1339] = 1298,
  [1340] = 1287,
  [1341] = 1341,
  [1342] = 1286,
  [1343] = 1287,
  [1344] = 1298,
  [1345] = 942,
  [1346] = 1287,
  [1347] = 1285,
  [1348] = 1286,
  [1349] = 1285,
  [1350] = 1288,
  [1351] = 1351,
  [1352] = 940,
  [1353] = 1296,
  [1354] = 1354,
  [1355] = 1355,
  [1356] = 1356,
  [1357] = 1357,
  [1358] = 1358,
  [1359] = 1359,
  [1360] = 1360,
  [1361] = 1357,
  [1362] = 1362,
  [1363] = 1363,
  [1364] = 1364,
  [1365] = 1365,
  [1366] = 1366,
  [1367] = 1358,
  [1368] = 1368,
  [1369] = 1369,
  [1370] = 1357,
  [1371] = 1357,
  [1372] = 1372,
  [1373] = 1373,
  [1374] = 1372,
  [1375] = 1375,
  [1376] = 1376,
  [1377] = 1357,
  [1378] = 1378,
  [1379] = 1379,
  [1380] = 1380,
  [1381] = 1381,
  [1382] = 1357,
  [1383] = 908,
  [1384] = 1384,
  [1385] = 1373,
  [1386] = 1113,
  [1387] = 1387,
  [1388] = 1388,
  [1389] = 1090,
  [1390] = 1153,
  [1391] = 1163,
  [1392] = 1166,
  [1393] = 1393,
  [1394] = 1394,
  [1395] = 1395,
  [1396] = 1396,
  [1397] = 1397,
  [1398] = 1398,
  [1399] = 1399,
  [1400] = 1400,
  [1401] = 1401,
  [1402] = 1402,
  [1403] = 1006,
  [1404] = 1404,
  [1405] = 1401,
  [1406] = 1406,
  [1407] = 1407,
  [1408] = 1036,
  [1409] = 1401,
  [1410] = 1401,
  [1411] = 1411,
  [1412] = 1401,
  [1413] = 1413,
  [1414] = 1402,
  [1415] = 1415,
  [1416] = 1416,
  [1417] = 1417,
  [1418] = 1418,
  [1419] = 1418,
  [1420] = 1416,
  [1421] = 1416,
  [1422] = 1416,
  [1423] = 1417,
  [1424] = 1415,
  [1425] = 1416,
  [1426] = 1416,
  [1427] = 1415,
  [1428] = 1428,
  [1429] = 1416,
  [1430] = 1417,
  [1431] = 1417,
  [1432] = 1417,
  [1433] = 1418,
  [1434] = 1434,
  [1435] = 1435,
  [1436] = 1436,
  [1437] = 1437,
  [1438] = 1437,
  [1439] = 1439,
  [1440] = 1440,
  [1441] = 1441,
  [1442] = 1442,
  [1443] = 1443,
  [1444] = 1437,
  [1445] = 1445,
  [1446] = 1446,
  [1447] = 1447,
  [1448] = 1436,
  [1449] = 1449,
  [1450] = 1450,
  [1451] = 1446,
  [1452] = 1452,
  [1453] = 1453,
  [1454] = 1436,
  [1455] = 1455,
  [1456] = 1437,
  [1457] = 1457,
  [1458] = 1458,
  [1459] = 1436,
  [1460] = 1460,
  [1461] = 1461,
  [1462] = 886,
  [1463] = 1463,
  [1464] = 1464,
  [1465] = 1465,
  [1466] = 1466,
  [1467] = 1467,
  [1468] = 1468,
  [1469] = 1469,
  [1470] = 1470,
  [1471] = 1471,
  [1472] = 1472,
  [1473] = 1473,
  [1474] = 1474,
  [1475] = 1475,
  [1476] = 1458,
  [1477] = 1436,
  [1478] = 1434,
  [1479] = 1479,
  [1480] = 1480,
  [1481] = 1479,
  [1482] = 1482,
  [1483] = 1483,
  [1484] = 1465,
  [1485] = 1485,
  [1486] = 1486,
  [1487] = 1482,
  [1488] = 1488,
  [1489] = 1449,
  [1490] = 1483,
  [1491] = 1491,
  [1492] = 1491,
  [1493] = 1488,
  [1494] = 1486,
  [1495] = 1485,
  [1496] = 1496,
  [1497] = 1497,
  [1498] = 1036,
  [1499] = 1496,
  [1500] = 1500,
  [1501] = 1496,
  [1502] = 886,
  [1503] = 1503,
  [1504] = 1000,
  [1505] = 1006,
  [1506] = 1496,
  [1507] = 1025,
  [1508] = 1022,
  [1509] = 1273,
  [1510] = 1271,
  [1511] = 1267,
  [1512] = 1497,
  [1513] = 1513,
  [1514] = 1038,
  [1515] = 1014,
  [1516] = 1450,
  [1517] = 989,
  [1518] = 1027,
  [1519] = 1503,
  [1520] = 1496,
  [1521] = 1503,
  [1522] = 1522,
  [1523] = 1497,
  [1524] = 1471,
  [1525] = 1470,
  [1526] = 1469,
  [1527] = 1468,
  [1528] = 1467,
  [1529] = 1466,
  [1530] = 1435,
  [1531] = 1264,
  [1532] = 1464,
  [1533] = 1533,
  [1534] = 1534,
  [1535] = 1463,
  [1536] = 1461,
  [1537] = 1460,
  [1538] = 1538,
  [1539] = 1539,
  [1540] = 1017,
  [1541] = 1497,
  [1542] = 1542,
  [1543] = 1497,
  [1544] = 1503,
  [1545] = 1522,
  [1546] = 1474,
  [1547] = 1475,
  [1548] = 1548,
  [1549] = 1549,
  [1550] = 1549,
  [1551] = 1549,
  [1552] = 1552,
  [1553] = 1553,
  [1554] = 1549,
  [1555] = 1549,
  [1556] = 1090,
  [1557] = 1557,
  [1558] = 1557,
  [1559] = 1559,
  [1560] = 1557,
  [1561] = 1559,
  [1562] = 1559,
  [1563] = 1559,
  [1564] = 1557,
  [1565] = 1559,
  [1566] = 1557,
  [1567] = 1567,
  [1568] = 1568,
  [1569] = 1569,
  [1570] = 1570,
  [1571] = 1571,
  [1572] = 1572,
  [1573] = 1573,
  [1574] = 1572,
  [1575] = 1575,
  [1576] = 1572,
  [1577] = 1572,
  [1578] = 1578,
  [1579] = 1579,
  [1580] = 1580,
  [1581] = 1581,
  [1582] = 1582,
  [1583] = 1583,
  [1584] = 1584,
  [1585] = 1583,
  [1586] = 1586,
  [1587] = 1587,
  [1588] = 1588,
  [1589] = 1589,
  [1590] = 1590,
  [1591] = 1584,
  [1592] = 1583,
  [1593] = 1593,
  [1594] = 1594,
  [1595] = 1595,
  [1596] = 1583,
  [1597] = 1583,
  [1598] = 1583,
  [1599] = 1584,
  [1600] = 1600,
  [1601] = 1584,
  [1602] = 1602,
  [1603] = 1583,
  [1604] = 1584,
  [1605] = 1605,
  [1606] = 1606,
  [1607] = 1607,
  [1608] = 1608,
  [1609] = 1607,
  [1610] = 1610,
  [1611] = 1611,
  [1612] = 1612,
  [1613] = 1613,
  [1614] = 1614,
  [1615] = 1615,
  [1616] = 1616,
  [1617] = 1617,
  [1618] = 1607,
  [1619] = 1619,
  [1620] = 1607,
  [1621] = 1607,
  [1622] = 1622,
  [1623] = 1623,
  [1624] = 1624,
  [1625] = 1625,
  [1626] = 1626,
  [1627] = 1627,
  [1628] = 1628,
  [1629] = 1629,
  [1630] = 1630,
  [1631] = 1631,
  [1632] = 1632,
  [1633] = 1633,
  [1634] = 1632,
  [1635] = 1635,
  [1636] = 1636,
  [1637] = 1637,
  [1638] = 1638,
  [1639] = 1632,
  [1640] = 1632,
  [1641] = 1641,
  [1642] = 1642,
  [1643] = 1643,
  [1644] = 1644,
  [1645] = 1645,
  [1646] = 1632,
  [1647] = 1647,
  [1648] = 1648,
  [1649] = 1649,
  [1650] = 1650,
  [1651] = 1651,
  [1652] = 1650,
  [1653] = 1653,
  [1654] = 1654,
  [1655] = 1655,
  [1656] = 1656,
  [1657] = 1657,
  [1658] = 1650,
  [1659] = 1659,
  [1660] = 1649,
  [1661] = 1650,
  [1662] = 1649,
  [1663] = 1654,
  [1664] = 1654,
  [1665] = 1649,
  [1666] = 1650,
  [1667] = 1654,
  [1668] = 1653,
  [1669] = 1654,
  [1670] = 1670,
  [1671] = 1649,
  [1672] = 1657,
  [1673] = 1673,
  [1674] = 1674,
  [1675] = 1675,
  [1676] = 1676,
  [1677] = 1677,
  [1678] = 1673,
  [1679] = 1679,
  [1680] = 1680,
  [1681] = 1681,
  [1682] = 1682,
  [1683] = 1683,
  [1684] = 1684,
  [1685] = 1685,
  [1686] = 1686,
  [1687] = 1680,
  [1688] = 1688,
  [1689] = 1673,
  [1690] = 1685,
  [1691] = 1680,
  [1692] = 1692,
  [1693] = 1685,
  [1694] = 1685,
  [1695] = 1695,
  [1696] = 1696,
  [1697] = 1685,
  [1698] = 1698,
  [1699] = 1680,
  [1700] = 1700,
  [1701] = 1701,
  [1702] = 1702,
  [1703] = 1703,
  [1704] = 1673,
  [1705] = 1705,
  [1706] = 1706,
  [1707] = 1707,
  [1708] = 1708,
  [1709] = 1673,
  [1710] = 1710,
  [1711] = 1680,
  [1712] = 1712,
  [1713] = 1713,
  [1714] = 1714,
  [1715] = 1715,
  [1716] = 1716,
  [1717] = 1717,
  [1718] = 1718,
  [1719] = 1719,
  [1720] = 1720,
  [1721] = 1721,
  [1722] = 1722,
  [1723] = 1723,
  [1724] = 1724,
  [1725] = 1725,
  [1726] = 1726,
  [1727] = 1727,
  [1728] = 1728,
  [1729] = 1729,
  [1730] = 1730,
  [1731] = 1731,
  [1732] = 1732,
  [1733] = 1733,
  [1734] = 1734,
  [1735] = 1735,
  [1736] = 1736,
  [1737] = 1737,
  [1738] = 1676,
  [1739] = 1739,
  [1740] = 1740,
  [1741] = 1741,
  [1742] = 1742,
  [1743] = 1743,
  [1744] = 1744,
  [1745] = 1740,
  [1746] = 1746,
  [1747] = 1740,
  [1748] = 1746,
  [1749] = 1749,
  [1750] = 1750,
  [1751] = 1751,
  [1752] = 1740,
  [1753] = 1753,
  [1754] = 1753,
  [1755] = 1755,
  [1756] = 1753,
  [1757] = 1753,
  [1758] = 1758,
  [1759] = 1692,
  [1760] = 1753,
  [1761] = 1761,
  [1762] = 1762,
  [1763] = 1753,
  [1764] = 1764,
  [1765] = 1765,
  [1766] = 1677,
  [1767] = 1740,
  [1768] = 1768,
  [1769] = 1753,
  [1770] = 1770,
  [1771] = 1771,
  [1772] = 1740,
  [1773] = 1773,
  [1774] = 1774,
  [1775] = 1749,
  [1776] = 1776,
  [1777] = 1777,
  [1778] = 1778,
  [1779] = 1779,
  [1780] = 1780,
  [1781] = 1781,
  [1782] = 1740,
  [1783] = 1783,
  [1784] = 1784,
  [1785] = 1785,
  [1786] = 1786,
  [1787] = 1787,
  [1788] = 1788,
  [1789] = 1789,
  [1790] = 1790,
  [1791] = 1791,
  [1792] = 1792,
  [1793] = 1793,
  [1794] = 1794,
  [1795] = 1795,
  [1796] = 1796,
  [1797] = 1797,
  [1798] = 1798,
  [1799] = 1799,
  [1800] = 1800,
  [1801] = 1801,
  [1802] = 1735,
  [1803] = 1803,
  [1804] = 1804,
  [1805] = 1805,
  [1806] = 1806,
  [1807] = 1807,
  [1808] = 1807,
  [1809] = 1804,
  [1810] = 1810,
  [1811] = 1811,
  [1812] = 1812,
  [1813] = 1813,
  [1814] = 1813,
  [1815] = 1815,
  [1816] = 1816,
  [1817] = 1817,
  [1818] = 1817,
  [1819] = 1819,
  [1820] = 1820,
  [1821] = 1821,
  [1822] = 1822,
  [1823] = 1823,
  [1824] = 1824,
  [1825] = 1820,
  [1826] = 1807,
  [1827] = 1827,
  [1828] = 1807,
  [1829] = 1777,
  [1830] = 1830,
  [1831] = 1816,
  [1832] = 1832,
  [1833] = 1833,
  [1834] = 1817,
  [1835] = 1804,
  [1836] = 1836,
  [1837] = 1816,
  [1838] = 1838,
  [1839] = 1820,
  [1840] = 1807,
  [1841] = 1841,
  [1842] = 1805,
  [1843] = 1817,
  [1844] = 1844,
  [1845] = 1816,
  [1846] = 1846,
  [1847] = 1807,
  [1848] = 1848,
  [1849] = 1820,
  [1850] = 1850,
  [1851] = 1813,
  [1852] = 1852,
  [1853] = 1817,
  [1854] = 1854,
  [1855] = 1813,
  [1856] = 1805,
  [1857] = 1821,
  [1858] = 1820,
  [1859] = 1821,
  [1860] = 1819,
  [1861] = 1861,
  [1862] = 1819,
  [1863] = 1813,
  [1864] = 1864,
  [1865] = 1865,
  [1866] = 1807,
  [1867] = 1867,
  [1868] = 1868,
  [1869] = 1807,
  [1870] = 1805,
  [1871] = 1821,
  [1872] = 1819,
  [1873] = 1807,
  [1874] = 1816,
  [1875] = 1875,
  [1876] = 1805,
  [1877] = 1804,
  [1878] = 1817,
  [1879] = 1879,
  [1880] = 1880,
  [1881] = 1881,
  [1882] = 1882,
  [1883] = 1882,
  [1884] = 1884,
  [1885] = 1885,
  [1886] = 1886,
  [1887] = 1887,
  [1888] = 1888,
  [1889] = 1882,
  [1890] = 1881,
  [1891] = 1886,
  [1892] = 1892,
  [1893] = 1893,
  [1894] = 1894,
  [1895] = 1895,
  [1896] = 1896,
  [1897] = 1897,
  [1898] = 1898,
  [1899] = 1899,
  [1900] = 1900,
  [1901] = 1901,
  [1902] = 1902,
  [1903] = 1885,
  [1904] = 1904,
  [1905] = 1905,
  [1906] = 1879,
  [1907] = 1902,
  [1908] = 1902,
  [1909] = 1909,
  [1910] = 1899,
  [1911] = 1911,
  [1912] = 1885,
  [1913] = 1880,
  [1914] = 1914,
  [1915] = 1915,
  [1916] = 1916,
  [1917] = 1917,
  [1918] = 1879,
  [1919] = 1919,
  [1920] = 1885,
  [1921] = 1902,
  [1922] = 1879,
  [1923] = 1899,
  [1924] = 1924,
  [1925] = 1924,
  [1926] = 1926,
  [1927] = 1900,
  [1928] = 1928,
  [1929] = 1896,
  [1930] = 1882,
  [1931] = 1931,
  [1932] = 1932,
  [1933] = 1933,
  [1934] = 1934,
  [1935] = 1899,
  [1936] = 1936,
  [1937] = 1892,
  [1938] = 1938,
  [1939] = 1915,
  [1940] = 1881,
  [1941] = 1881,
  [1942] = 1888,
  [1943] = 1892,
  [1944] = 1885,
  [1945] = 1902,
  [1946] = 1879,
  [1947] = 1882,
  [1948] = 1899,
  [1949] = 1900,
  [1950] = 1892,
  [1951] = 1951,
  [1952] = 1952,
  [1953] = 1953,
  [1954] = 1892,
  [1955] = 1955,
  [1956] = 1956,
  [1957] = 1884,
  [1958] = 1958,
  [1959] = 1900,
  [1960] = 1881,
  [1961] = 1882,
  [1962] = 1962,
  [1963] = 1924,
  [1964] = 1900,
  [1965] = 1965,
  [1966] = 1966,
  [1967] = 1967,
  [1968] = 1968,
  [1969] = 1896,
  [1970] = 1970,
  [1971] = 1971,
  [1972] = 1896,
  [1973] = 1677,
  [1974] = 1974,
  [1975] = 1975,
  [1976] = 1879,
  [1977] = 1977,
  [1978] = 1926,
  [1979] = 1979,
  [1980] = 1880,
  [1981] = 1884,
  [1982] = 1953,
  [1983] = 1983,
  [1984] = 1984,
  [1985] = 1892,
  [1986] = 1899,
  [1987] = 1887,
  [1988] = 1988,
  [1989] = 1988,
  [1990] = 1893,
  [1991] = 1896,
  [1992] = 1938,
  [1993] = 1900,
  [1994] = 1955,
  [1995] = 1899,
  [1996] = 1881,
  [1997] = 1879,
  [1998] = 1928,
  [1999] = 1902,
  [2000] = 1931,
  [2001] = 1897,
  [2002] = 1900,
  [2003] = 1926,
  [2004] = 1977,
  [2005] = 1902,
  [2006] = 1885,
  [2007] = 1983,
  [2008] = 1885,
  [2009] = 1882,
  [2010] = 1881,
  [2011] = 1901,
  [2012] = 1892,
  [2013] = 2013,
  [2014] = 1914,
  [2015] = 1915,
  [2016] = 2016,
  [2017] = 1955,
  [2018] = 1915,
  [2019] = 2019,
  [2020] = 1955,
  [2021] = 2021,
  [2022] = 2022,
  [2023] = 2023,
  [2024] = 2024,
  [2025] = 2025,
  [2026] = 2026,
  [2027] = 2027,
  [2028] = 2028,
  [2029] = 2029,
  [2030] = 2030,
  [2031] = 2027,
  [2032] = 2032,
  [2033] = 2026,
  [2034] = 2034,
  [2035] = 2035,
  [2036] = 2036,
  [2037] = 2037,
  [2038] = 2038,
  [2039] = 2039,
  [2040] = 2040,
  [2041] = 2041,
  [2042] = 2030,
  [2043] = 2043,
  [2044] = 2037,
  [2045] = 2030,
  [2046] = 2046,
  [2047] = 2047,
  [2048] = 2048,
  [2049] = 2038,
  [2050] = 2050,
  [2051] = 2026,
  [2052] = 2048,
  [2053] = 2039,
  [2054] = 2030,
  [2055] = 2035,
  [2056] = 2046,
  [2057] = 2057,
  [2058] = 2047,
  [2059] = 2038,
  [2060] = 2060,
  [2061] = 2039,
  [2062] = 2048,
  [2063] = 2037,
  [2064] = 2064,
  [2065] = 2065,
  [2066] = 2030,
  [2067] = 2046,
  [2068] = 2038,
  [2069] = 2027,
  [2070] = 2039,
  [2071] = 2048,
  [2072] = 2037,
  [2073] = 2047,
  [2074] = 2034,
  [2075] = 2035,
  [2076] = 2046,
  [2077] = 2040,
  [2078] = 2040,
  [2079] = 2041,
  [2080] = 2030,
  [2081] = 2046,
  [2082] = 2082,
  [2083] = 2083,
  [2084] = 2084,
  [2085] = 2035,
  [2086] = 2086,
  [2087] = 2087,
  [2088] = 2038,
  [2089] = 2038,
  [2090] = 2047,
  [2091] = 2091,
  [2092] = 2092,
  [2093] = 2026,
  [2094] = 2094,
  [2095] = 2095,
  [2096] = 2096,
  [2097] = 2039,
  [2098] = 2026,
  [2099] = 2048,
  [2100] = 2037,
  [2101] = 2034,
  [2102] = 2102,
  [2103] = 2035,
  [2104] = 2026,
  [2105] = 2035,
  [2106] = 2037,
  [2107] = 2040,
  [2108] = 2026,
  [2109] = 2039,
  [2110] = 2035,
  [2111] = 2027,
  [2112] = 2035,
  [2113] = 2113,
  [2114] = 2027,
  [2115] = 2035,
  [2116] = 2116,
  [2117] = 2026,
  [2118] = 2027,
  [2119] = 2040,
  [2120] = 2120,
  [2121] = 2040,
  [2122] = 2047,
  [2123] = 2026,
  [2124] = 2124,
  [2125] = 2125,
  [2126] = 2126,
  [2127] = 2127,
  [2128] = 2128,
  [2129] = 2129,
  [2130] = 2130,
  [2131] = 2131,
  [2132] = 2132,
  [2133] = 2131,
  [2134] = 2134,
  [2135] = 2135,
  [2136] = 2136,
  [2137] = 1267,
  [2138] = 2138,
  [2139] = 2139,
  [2140] = 2140,
  [2141] = 2141,
  [2142] = 2142,
  [2143] = 2142,
  [2144] = 2144,
  [2145] = 2140,
  [2146] = 2131,
  [2147] = 2141,
  [2148] = 2148,
  [2149] = 2125,
  [2150] = 2150,
  [2151] = 2138,
  [2152] = 2152,
  [2153] = 2139,
  [2154] = 2141,
  [2155] = 2155,
  [2156] = 2142,
  [2157] = 2157,
  [2158] = 2138,
  [2159] = 2159,
  [2160] = 2160,
  [2161] = 2131,
  [2162] = 2162,
  [2163] = 2163,
  [2164] = 2139,
  [2165] = 2135,
  [2166] = 2166,
  [2167] = 2130,
  [2168] = 2138,
  [2169] = 2141,
  [2170] = 2127,
  [2171] = 2131,
  [2172] = 2172,
  [2173] = 2173,
  [2174] = 2138,
  [2175] = 2141,
  [2176] = 2129,
  [2177] = 2131,
  [2178] = 2178,
  [2179] = 2179,
  [2180] = 2180,
  [2181] = 2181,
  [2182] = 2131,
  [2183] = 2132,
  [2184] = 2184,
  [2185] = 2185,
  [2186] = 2186,
  [2187] = 2187,
  [2188] = 2181,
  [2189] = 2189,
  [2190] = 2150,
  [2191] = 2191,
  [2192] = 832,
  [2193] = 2193,
  [2194] = 2194,
  [2195] = 2139,
  [2196] = 2196,
  [2197] = 2197,
  [2198] = 2198,
  [2199] = 2199,
  [2200] = 2142,
  [2201] = 2186,
  [2202] = 2131,
  [2203] = 2152,
  [2204] = 2204,
  [2205] = 2135,
  [2206] = 2206,
  [2207] = 2140,
  [2208] = 2208,
  [2209] = 2209,
  [2210] = 2210,
  [2211] = 2211,
  [2212] = 2212,
  [2213] = 2213,
  [2214] = 2141,
  [2215] = 2185,
  [2216] = 2216,
  [2217] = 2217,
  [2218] = 2184,
  [2219] = 2219,
  [2220] = 2220,
  [2221] = 2139,
  [2222] = 2157,
  [2223] = 2223,
  [2224] = 2224,
  [2225] = 2225,
  [2226] = 2226,
  [2227] = 2227,
  [2228] = 2228,
  [2229] = 2228,
  [2230] = 2224,
  [2231] = 2144,
  [2232] = 2142,
  [2233] = 2233,
  [2234] = 2234,
  [2235] = 2138,
  [2236] = 2236,
  [2237] = 2237,
  [2238] = 2132,
  [2239] = 2239,
  [2240] = 2240,
  [2241] = 2241,
  [2242] = 2242,
  [2243] = 2243,
  [2244] = 2244,
  [2245] = 2163,
  [2246] = 2246,
  [2247] = 2191,
  [2248] = 2187,
  [2249] = 2194,
  [2250] = 2162,
  [2251] = 2186,
  [2252] = 2159,
  [2253] = 831,
  [2254] = 2185,
  [2255] = 2255,
  [2256] = 2184,
  [2257] = 2148,
  [2258] = 2191,
  [2259] = 2259,
  [2260] = 2260,
  [2261] = 2261,
  [2262] = 2130,
  [2263] = 2132,
  [2264] = 2125,
  [2265] = 2144,
  [2266] = 2155,
  [2267] = 2179,
  [2268] = 2180,
  [2269] = 2269,
  [2270] = 2126,
  [2271] = 2271,
  [2272] = 2272,
  [2273] = 2155,
  [2274] = 2142,
  [2275] = 2150,
  [2276] = 2181,
  [2277] = 2277,
  [2278] = 2278,
  [2279] = 2141,
  [2280] = 2280,
  [2281] = 2127,
  [2282] = 2152,
  [2283] = 2283,
  [2284] = 2284,
  [2285] = 2129,
  [2286] = 2286,
  [2287] = 2277,
  [2288] = 2228,
  [2289] = 2148,
  [2290] = 2144,
  [2291] = 2132,
  [2292] = 2292,
  [2293] = 2129,
  [2294] = 2260,
  [2295] = 2138,
  [2296] = 2130,
  [2297] = 2194,
  [2298] = 2179,
  [2299] = 2180,
  [2300] = 2142,
  [2301] = 2144,
  [2302] = 2138,
  [2303] = 2139,
  [2304] = 2162,
  [2305] = 2194,
  [2306] = 2181,
  [2307] = 2219,
  [2308] = 2163,
  [2309] = 2309,
  [2310] = 2310,
  [2311] = 1273,
  [2312] = 2152,
  [2313] = 2313,
  [2314] = 2314,
  [2315] = 2150,
  [2316] = 2140,
  [2317] = 2228,
  [2318] = 2162,
  [2319] = 2144,
  [2320] = 2163,
  [2321] = 2141,
  [2322] = 2322,
  [2323] = 2323,
  [2324] = 1264,
  [2325] = 2325,
  [2326] = 2326,
  [2327] = 2179,
  [2328] = 2180,
  [2329] = 2135,
  [2330] = 2330,
  [2331] = 2331,
  [2332] = 2135,
  [2333] = 2181,
  [2334] = 2334,
  [2335] = 2335,
  [2336] = 2148,
  [2337] = 2125,
  [2338] = 2191,
  [2339] = 2125,
  [2340] = 2340,
  [2341] = 2187,
  [2342] = 2148,
  [2343] = 2150,
  [2344] = 2152,
  [2345] = 2186,
  [2346] = 2139,
  [2347] = 2157,
  [2348] = 2179,
  [2349] = 2349,
  [2350] = 2185,
  [2351] = 2187,
  [2352] = 2179,
  [2353] = 2179,
  [2354] = 2179,
  [2355] = 2138,
  [2356] = 2184,
  [2357] = 2194,
  [2358] = 2358,
  [2359] = 2359,
  [2360] = 2313,
  [2361] = 2361,
  [2362] = 2362,
  [2363] = 2284,
  [2364] = 2162,
  [2365] = 2163,
  [2366] = 2241,
  [2367] = 2139,
  [2368] = 2325,
  [2369] = 2369,
  [2370] = 2370,
  [2371] = 2217,
  [2372] = 2135,
  [2373] = 2373,
  [2374] = 2141,
  [2375] = 2130,
  [2376] = 2242,
  [2377] = 2140,
  [2378] = 2280,
  [2379] = 2379,
  [2380] = 2132,
  [2381] = 2199,
  [2382] = 2382,
  [2383] = 2155,
  [2384] = 2313,
  [2385] = 2385,
  [2386] = 2386,
  [2387] = 2217,
  [2388] = 2388,
  [2389] = 2126,
  [2390] = 2390,
  [2391] = 2132,
  [2392] = 2392,
  [2393] = 2393,
  [2394] = 2142,
  [2395] = 2217,
  [2396] = 2396,
  [2397] = 1271,
  [2398] = 2132,
  [2399] = 2334,
  [2400] = 2400,
  [2401] = 2401,
  [2402] = 2155,
  [2403] = 2217,
  [2404] = 2131,
  [2405] = 2405,
  [2406] = 2406,
  [2407] = 2407,
  [2408] = 2313,
  [2409] = 2409,
  [2410] = 2286,
  [2411] = 2129,
  [2412] = 2126,
  [2413] = 2313,
  [2414] = 2127,
  [2415] = 2180,
  [2416] = 2313,
  [2417] = 2246,
  [2418] = 2127,
  [2419] = 2283,
  [2420] = 2420,
  [2421] = 2179,
  [2422] = 2278,
};

static inline bool sym_number_literal_character_set_1(int32_t c) {
  return (c < 'b'
    ? (c < 'L'
      ? (c < 'D'
        ? c == 'B'
        : c <= 'F')
      : (c <= 'L' || (c < 'W'
        ? c == 'U'
        : c <= 'W')))
    : (c <= 'b' || (c < 'u'
      ? (c < 'l'
        ? (c >= 'd' && c <= 'f')
        : c <= 'l')
      : (c <= 'u' || c == 'w'))));
}

static inline bool sym_number_literal_character_set_2(int32_t c) {
  return (c < 'b'
    ? (c < 'L'
      ? (c < 'D'
        ? c == 'B'
        : (c <= 'D' || c == 'F'))
      : (c <= 'L' || (c < 'W'
        ? c == 'U'
        : c <= 'W')))
    : (c <= 'b' || (c < 'l'
      ? (c < 'f'
        ? c == 'd'
        : c <= 'f')
      : (c <= 'l' || (c < 'w'
        ? c == 'u'
        : c <= 'w')))));
}

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 43488
    ? (c < 4159
      ? (c < 2654
        ? (c < 1808
          ? (c < 895
            ? (c < 192
              ? (c < 'a'
                ? (c < 'M'
                  ? (c < 'A'
                    ? c == '$'
                    : c <= 'K')
                  : (c <= 'T' || (c < '_'
                    ? (c >= 'V' && c <= 'Z')
                    : c <= '_')))
                : (c <= 't' || (c < 181
                  ? (c < 170
                    ? (c >= 'v' && c <= 'z')
                    : c <= 170)
                  : (c <= 181 || c == 186))))
              : (c <= 214 || (c < 748
                ? (c < 710
                  ? (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)
                  : (c <= 721 || (c >= 736 && c <= 740)))
                : (c <= 748 || (c < 886
                  ? (c < 880
                    ? c == 750
                    : c <= 884)
                  : (c <= 887 || (c >= 891 && c <= 893)))))))
            : (c <= 895 || (c < 1488
              ? (c < 1015
                ? (c < 908
                  ? (c < 904
                    ? c == 902
                    : c <= 906)
                  : (c <= 908 || (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)))
                : (c <= 1153 || (c < 1369
                  ? (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)
                  : (c <= 1369 || (c >= 1376 && c <= 1416)))))
              : (c <= 1514 || (c < 1749
                ? (c < 1646
                  ? (c < 1568
                    ? (c >= 1519 && c <= 1522)
                    : c <= 1610)
                  : (c <= 1647 || (c >= 1649 && c <= 1747)))
                : (c <= 1749 || (c < 1786
                  ? (c < 1774
                    ? (c >= 1765 && c <= 1766)
                    : c <= 1775)
                  : (c <= 1788 || c == 1791))))))))
          : (c <= 1808 || (c < 2437
            ? (c < 2112
              ? (c < 2042
                ? (c < 1969
                  ? (c < 1869
                    ? (c >= 1810 && c <= 1839)
                    : c <= 1957)
                  : (c <= 1969 || (c < 2036
                    ? (c >= 1994 && c <= 2026)
                    : c <= 2037)))
                : (c <= 2042 || (c < 2084
                  ? (c < 2074
                    ? (c >= 2048 && c <= 2069)
                    : c <= 2074)
                  : (c <= 2084 || c == 2088))))
              : (c <= 2136 || (c < 2308
                ? (c < 2185
                  ? (c < 2160
                    ? (c >= 2144 && c <= 2154)
                    : c <= 2183)
                  : (c <= 2190 || (c >= 2208 && c <= 2249)))
                : (c <= 2361 || (c < 2392
                  ? (c < 2384
                    ? c == 2365
                    : c <= 2384)
                  : (c <= 2401 || (c >= 2417 && c <= 2432)))))))
            : (c <= 2444 || (c < 2544
              ? (c < 2486
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || c == 2482))
                : (c <= 2489 || (c < 2524
                  ? (c < 2510
                    ? c == 2493
                    : c <= 2510)
                  : (c <= 2525 || (c >= 2527 && c <= 2529)))))
              : (c <= 2545 || (c < 2602
                ? (c < 2575
                  ? (c < 2565
                    ? c == 2556
                    : c <= 2570)
                  : (c <= 2576 || (c >= 2579 && c <= 2600)))
                : (c <= 2608 || (c < 2616
                  ? (c < 2613
                    ? (c >= 2610 && c <= 2611)
                    : c <= 2614)
                  : (c <= 2617 || (c >= 2649 && c <= 2652)))))))))))
        : (c <= 2654 || (c < 3205
          ? (c < 2929
            ? (c < 2809
              ? (c < 2738
                ? (c < 2703
                  ? (c < 2693
                    ? (c >= 2674 && c <= 2676)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))
                : (c <= 2739 || (c < 2768
                  ? (c < 2749
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2749)
                  : (c <= 2768 || (c >= 2784 && c <= 2785)))))
              : (c <= 2809 || (c < 2866
                ? (c < 2835
                  ? (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)
                  : (c <= 2856 || (c >= 2858 && c <= 2864)))
                : (c <= 2867 || (c < 2908
                  ? (c < 2877
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2877)
                  : (c <= 2909 || (c >= 2911 && c <= 2913)))))))
            : (c <= 2929 || (c < 3024
              ? (c < 2972
                ? (c < 2958
                  ? (c < 2949
                    ? c == 2947
                    : c <= 2954)
                  : (c <= 2960 || (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)))
                : (c <= 2972 || (c < 2984
                  ? (c < 2979
                    ? (c >= 2974 && c <= 2975)
                    : c <= 2980)
                  : (c <= 2986 || (c >= 2990 && c <= 3001)))))
              : (c <= 3024 || (c < 3133
                ? (c < 3090
                  ? (c < 3086
                    ? (c >= 3077 && c <= 3084)
                    : c <= 3088)
                  : (c <= 3112 || (c >= 3114 && c <= 3129)))
                : (c <= 3133 || (c < 3168
                  ? (c < 3165
                    ? (c >= 3160 && c <= 3162)
                    : c <= 3165)
                  : (c <= 3169 || c == 3200))))))))
          : (c <= 3212 || (c < 3520
            ? (c < 3346
              ? (c < 3293
                ? (c < 3242
                  ? (c < 3218
                    ? (c >= 3214 && c <= 3216)
                    : c <= 3240)
                  : (c <= 3251 || (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)))
                : (c <= 3294 || (c < 3332
                  ? (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)
                  : (c <= 3340 || (c >= 3342 && c <= 3344)))))
              : (c <= 3386 || (c < 3450
                ? (c < 3412
                  ? (c < 3406
                    ? c == 3389
                    : c <= 3406)
                  : (c <= 3414 || (c >= 3423 && c <= 3425)))
                : (c <= 3455 || (c < 3507
                  ? (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)
                  : (c <= 3515 || c == 3517))))))
            : (c <= 3526 || (c < 3762
              ? (c < 3716
                ? (c < 3648
                  ? (c < 3634
                    ? (c >= 3585 && c <= 3632)
                    : c <= 3634)
                  : (c <= 3654 || (c >= 3713 && c <= 3714)))
                : (c <= 3716 || (c < 3749
                  ? (c < 3724
                    ? (c >= 3718 && c <= 3722)
                    : c <= 3747)
                  : (c <= 3749 || (c >= 3751 && c <= 3760)))))
              : (c <= 3762 || (c < 3840
                ? (c < 3782
                  ? (c < 3776
                    ? c == 3773
                    : c <= 3780)
                  : (c <= 3782 || (c >= 3804 && c <= 3807)))
                : (c <= 3840 || (c < 3976
                  ? (c < 3913
                    ? (c >= 3904 && c <= 3911)
                    : c <= 3948)
                  : (c <= 3980 || (c >= 4096 && c <= 4138)))))))))))))
      : (c <= 4159 || (c < 8126
        ? (c < 6103
          ? (c < 4792
            ? (c < 4304
              ? (c < 4213
                ? (c < 4193
                  ? (c < 4186
                    ? (c >= 4176 && c <= 4181)
                    : c <= 4189)
                  : (c <= 4193 || (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)))
                : (c <= 4225 || (c < 4295
                  ? (c < 4256
                    ? c == 4238
                    : c <= 4293)
                  : (c <= 4295 || c == 4301))))
              : (c <= 4346 || (c < 4698
                ? (c < 4688
                  ? (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)
                  : (c <= 4694 || c == 4696))
                : (c <= 4701 || (c < 4752
                  ? (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)
                  : (c <= 4784 || (c >= 4786 && c <= 4789)))))))
            : (c <= 4798 || (c < 5743
              ? (c < 4888
                ? (c < 4808
                  ? (c < 4802
                    ? c == 4800
                    : c <= 4805)
                  : (c <= 4822 || (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)))
                : (c <= 4954 || (c < 5112
                  ? (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)
                  : (c <= 5117 || (c >= 5121 && c <= 5740)))))
              : (c <= 5759 || (c < 5919
                ? (c < 5870
                  ? (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)
                  : (c <= 5880 || (c >= 5888 && c <= 5905)))
                : (c <= 5937 || (c < 5998
                  ? (c < 5984
                    ? (c >= 5952 && c <= 5969)
                    : c <= 5996)
                  : (c <= 6000 || (c >= 6016 && c <= 6067)))))))))
          : (c <= 6103 || (c < 7258
            ? (c < 6656
              ? (c < 6400
                ? (c < 6272
                  ? (c < 6176
                    ? c == 6108
                    : c <= 6264)
                  : (c <= 6312 || (c < 6320
                    ? c == 6314
                    : c <= 6389)))
                : (c <= 6430 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6480 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c >= 6576 && c <= 6601)))))
              : (c <= 6678 || (c < 7043
                ? (c < 6917
                  ? (c < 6823
                    ? (c >= 6688 && c <= 6740)
                    : c <= 6823)
                  : (c <= 6963 || (c >= 6981 && c <= 6988)))
                : (c <= 7072 || (c < 7168
                  ? (c < 7098
                    ? (c >= 7086 && c <= 7087)
                    : c <= 7141)
                  : (c <= 7203 || (c >= 7245 && c <= 7247)))))))
            : (c <= 7293 || (c < 7960
              ? (c < 7406
                ? (c < 7357
                  ? (c < 7312
                    ? (c >= 7296 && c <= 7304)
                    : c <= 7354)
                  : (c <= 7359 || (c >= 7401 && c <= 7404)))
                : (c <= 7411 || (c < 7424
                  ? (c < 7418
                    ? (c >= 7413 && c <= 7414)
                    : c <= 7418)
                  : (c <= 7615 || (c >= 7680 && c <= 7957)))))
              : (c <= 7965 || (c < 8027
                ? (c < 8016
                  ? (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)
                  : (c <= 8023 || c == 8025))
                : (c <= 8027 || (c < 8064
                  ? (c < 8031
                    ? c == 8029
                    : c <= 8061)
                  : (c <= 8116 || (c >= 8118 && c <= 8124)))))))))))
        : (c <= 8126 || (c < 12293
          ? (c < 8517
            ? (c < 8450
              ? (c < 8178
                ? (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))
                : (c <= 8180 || (c < 8319
                  ? (c < 8305
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8305)
                  : (c <= 8319 || (c >= 8336 && c <= 8348)))))
              : (c <= 8450 || (c < 8484
                ? (c < 8469
                  ? (c < 8458
                    ? c == 8455
                    : c <= 8467)
                  : (c <= 8469 || (c >= 8472 && c <= 8477)))
                : (c <= 8484 || (c < 8490
                  ? (c < 8488
                    ? c == 8486
                    : c <= 8488)
                  : (c <= 8505 || (c >= 8508 && c <= 8511)))))))
            : (c <= 8521 || (c < 11631
              ? (c < 11506
                ? (c < 11264
                  ? (c < 8544
                    ? c == 8526
                    : c <= 8584)
                  : (c <= 11492 || (c >= 11499 && c <= 11502)))
                : (c <= 11507 || (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c >= 11568 && c <= 11623)))))
              : (c <= 11631 || (c < 11704
                ? (c < 11688
                  ? (c < 11680
                    ? (c >= 11648 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c >= 11696 && c <= 11702)))
                : (c <= 11710 || (c < 11728
                  ? (c < 11720
                    ? (c >= 11712 && c <= 11718)
                    : c <= 11726)
                  : (c <= 11734 || (c >= 11736 && c <= 11742)))))))))
          : (c <= 12295 || (c < 42775
            ? (c < 12784
              ? (c < 12449
                ? (c < 12344
                  ? (c < 12337
                    ? (c >= 12321 && c <= 12329)
                    : c <= 12341)
                  : (c <= 12348 || (c < 12445
                    ? (c >= 12353 && c <= 12438)
                    : c <= 12447)))
                : (c <= 12538 || (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c >= 12704 && c <= 12735)))))
              : (c <= 12799 || (c < 42512
                ? (c < 42192
                  ? (c < 19968
                    ? (c >= 13312 && c <= 19903)
                    : c <= 42124)
                  : (c <= 42237 || (c >= 42240 && c <= 42508)))
                : (c <= 42527 || (c < 42623
                  ? (c < 42560
                    ? (c >= 42538 && c <= 42539)
                    : c <= 42606)
                  : (c <= 42653 || (c >= 42656 && c <= 42735)))))))
            : (c <= 42783 || (c < 43072
              ? (c < 42965
                ? (c < 42960
                  ? (c < 42891
                    ? (c >= 42786 && c <= 42888)
                    : c <= 42954)
                  : (c <= 42961 || c == 42963))
                : (c <= 42969 || (c < 43015
                  ? (c < 43011
                    ? (c >= 42994 && c <= 43009)
                    : c <= 43013)
                  : (c <= 43018 || (c >= 43020 && c <= 43042)))))
              : (c <= 43123 || (c < 43274
                ? (c < 43259
                  ? (c < 43250
                    ? (c >= 43138 && c <= 43187)
                    : c <= 43255)
                  : (c <= 43259 || (c >= 43261 && c <= 43262)))
                : (c <= 43301 || (c < 43396
                  ? (c < 43360
                    ? (c >= 43312 && c <= 43334)
                    : c <= 43388)
                  : (c <= 43442 || c == 43471))))))))))))))
    : (c <= 43492 || (c < 70656
      ? (c < 66940
        ? (c < 64848
          ? (c < 43816
            ? (c < 43705
              ? (c < 43616
                ? (c < 43520
                  ? (c < 43514
                    ? (c >= 43494 && c <= 43503)
                    : c <= 43518)
                  : (c <= 43560 || (c < 43588
                    ? (c >= 43584 && c <= 43586)
                    : c <= 43595)))
                : (c <= 43638 || (c < 43697
                  ? (c < 43646
                    ? c == 43642
                    : c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))))
              : (c <= 43709 || (c < 43762
                ? (c < 43739
                  ? (c < 43714
                    ? c == 43712
                    : c <= 43714)
                  : (c <= 43741 || (c >= 43744 && c <= 43754)))
                : (c <= 43764 || (c < 43793
                  ? (c < 43785
                    ? (c >= 43777 && c <= 43782)
                    : c <= 43790)
                  : (c <= 43798 || (c >= 43808 && c <= 43814)))))))
            : (c <= 43822 || (c < 64285
              ? (c < 55243
                ? (c < 43888
                  ? (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)
                  : (c <= 44002 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c >= 64275 && c <= 64279)))))
              : (c <= 64285 || (c < 64320
                ? (c < 64312
                  ? (c < 64298
                    ? (c >= 64287 && c <= 64296)
                    : c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64467
                  ? (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)
                  : (c <= 64605 || (c >= 64612 && c <= 64829)))))))))
          : (c <= 64911 || (c < 65596
            ? (c < 65345
              ? (c < 65145
                ? (c < 65137
                  ? (c < 65008
                    ? (c >= 64914 && c <= 64967)
                    : c <= 65017)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c >= 65313 && c <= 65338)))))
              : (c <= 65370 || (c < 65490
                ? (c < 65474
                  ? (c < 65440
                    ? (c >= 65382 && c <= 65437)
                    : c <= 65470)
                  : (c <= 65479 || (c >= 65482 && c <= 65487)))
                : (c <= 65495 || (c < 65549
                  ? (c < 65536
                    ? (c >= 65498 && c <= 65500)
                    : c <= 65547)
                  : (c <= 65574 || (c >= 65576 && c <= 65594)))))))
            : (c <= 65597 || (c < 66432
              ? (c < 66176
                ? (c < 65664
                  ? (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)
                  : (c <= 65786 || (c >= 65856 && c <= 65908)))
                : (c <= 66204 || (c < 66349
                  ? (c < 66304
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66335)
                  : (c <= 66378 || (c >= 66384 && c <= 66421)))))
              : (c <= 66461 || (c < 66736
                ? (c < 66513
                  ? (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)
                  : (c <= 66517 || (c >= 66560 && c <= 66717)))
                : (c <= 66771 || (c < 66864
                  ? (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)
                  : (c <= 66915 || (c >= 66928 && c <= 66938)))))))))))
        : (c <= 66954 || (c < 68800
          ? (c < 67808
            ? (c < 67463
              ? (c < 67003
                ? (c < 66967
                  ? (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)
                  : (c <= 66977 || (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)))
                : (c <= 67004 || (c < 67424
                  ? (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)
                  : (c <= 67431 || (c >= 67456 && c <= 67461)))))
              : (c <= 67504 || (c < 67639
                ? (c < 67592
                  ? (c < 67584
                    ? (c >= 67506 && c <= 67514)
                    : c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c >= 67712 && c <= 67742)))))))
            : (c <= 67826 || (c < 68192
              ? (c < 68030
                ? (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c >= 67968 && c <= 68023)))
                : (c <= 68031 || (c < 68117
                  ? (c < 68112
                    ? c == 68096
                    : c <= 68115)
                  : (c <= 68119 || (c >= 68121 && c <= 68149)))))
              : (c <= 68220 || (c < 68416
                ? (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68324 || (c >= 68352 && c <= 68405)))
                : (c <= 68437 || (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c >= 68736 && c <= 68786)))))))))
          : (c <= 68850 || (c < 70081
            ? (c < 69745
              ? (c < 69424
                ? (c < 69296
                  ? (c < 69248
                    ? (c >= 68864 && c <= 68899)
                    : c <= 69289)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))
                : (c <= 69445 || (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69505)
                    : c <= 69572)
                  : (c <= 69622 || (c >= 69635 && c <= 69687)))))
              : (c <= 69746 || (c < 69956
                ? (c < 69840
                  ? (c < 69763
                    ? c == 69749
                    : c <= 69807)
                  : (c <= 69864 || (c >= 69891 && c <= 69926)))
                : (c <= 69956 || (c < 70006
                  ? (c < 69968
                    ? c == 69959
                    : c <= 70002)
                  : (c <= 70006 || (c >= 70019 && c <= 70066)))))))
            : (c <= 70084 || (c < 70320
              ? (c < 70272
                ? (c < 70144
                  ? (c < 70108
                    ? c == 70106
                    : c <= 70108)
                  : (c <= 70161 || (c >= 70163 && c <= 70187)))
                : (c <= 70278 || (c < 70287
                  ? (c < 70282
                    ? c == 70280
                    : c <= 70285)
                  : (c <= 70301 || (c >= 70303 && c <= 70312)))))
              : (c <= 70366 || (c < 70450
                ? (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c >= 70442 && c <= 70448)))
                : (c <= 70451 || (c < 70480
                  ? (c < 70461
                    ? (c >= 70453 && c <= 70457)
                    : c <= 70461)
                  : (c <= 70480 || (c >= 70493 && c <= 70497)))))))))))))
      : (c <= 70708 || (c < 119894
        ? (c < 73056
          ? (c < 71999
            ? (c < 71352
              ? (c < 71040
                ? (c < 70784
                  ? (c < 70751
                    ? (c >= 70727 && c <= 70730)
                    : c <= 70753)
                  : (c <= 70831 || (c < 70855
                    ? (c >= 70852 && c <= 70853)
                    : c <= 70855)))
                : (c <= 71086 || (c < 71236
                  ? (c < 71168
                    ? (c >= 71128 && c <= 71131)
                    : c <= 71215)
                  : (c <= 71236 || (c >= 71296 && c <= 71338)))))
              : (c <= 71352 || (c < 71935
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71424 && c <= 71450)
                    : c <= 71494)
                  : (c <= 71723 || (c >= 71840 && c <= 71903)))
                : (c <= 71942 || (c < 71957
                  ? (c < 71948
                    ? c == 71945
                    : c <= 71955)
                  : (c <= 71958 || (c >= 71960 && c <= 71983)))))))
            : (c <= 71999 || (c < 72349
              ? (c < 72192
                ? (c < 72106
                  ? (c < 72096
                    ? c == 72001
                    : c <= 72103)
                  : (c <= 72144 || (c < 72163
                    ? c == 72161
                    : c <= 72163)))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 43494
    ? (c < 4186
      ? (c < 2703
        ? (c < 1969
          ? (c < 908
            ? (c < 710
              ? (c < 181
                ? (c < '_'
                  ? (c < 'A'
                    ? c == '$'
                    : c <= 'Z')
                  : (c <= '_' || (c < 170
                    ? (c >= 'a' && c <= 'z')
                    : c <= 170)))
                : (c <= 181 || (c < 216
                  ? (c < 192
                    ? c == 186
                    : c <= 214)
                  : (c <= 246 || (c >= 248 && c <= 705)))))
              : (c <= 721 || (c < 886
                ? (c < 750
                  ? (c < 748
                    ? (c >= 736 && c <= 740)
                    : c <= 748)
                  : (c <= 750 || (c >= 880 && c <= 884)))
                : (c <= 887 || (c < 902
                  ? (c < 895
                    ? (c >= 891 && c <= 893)
                    : c <= 895)
                  : (c <= 902 || (c >= 904 && c <= 906)))))))
            : (c <= 908 || (c < 1646
              ? (c < 1369
                ? (c < 1015
                  ? (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)
                  : (c <= 1153 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1519
                  ? (c < 1488
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))))
              : (c <= 1647 || (c < 1786
                ? (c < 1765
                  ? (c < 1749
                    ? (c >= 1649 && c <= 1747)
                    : c <= 1749)
                  : (c <= 1766 || (c >= 1774 && c <= 1775)))
                : (c <= 1788 || (c < 1810
                  ? (c < 1808
                    ? c == 1791
                    : c <= 1808)
                  : (c <= 1839 || (c >= 1869 && c <= 1957)))))))))
          : (c <= 1969 || (c < 2474
            ? (c < 2185
              ? (c < 2084
                ? (c < 2042
                  ? (c < 2036
                    ? (c >= 1994 && c <= 2026)
                    : c <= 2037)
                  : (c <= 2042 || (c < 2074
                    ? (c >= 2048 && c <= 2069)
                    : c <= 2074)))
                : (c <= 2084 || (c < 2144
                  ? (c < 2112
                    ? c == 2088
                    : c <= 2136)
                  : (c <= 2154 || (c >= 2160 && c <= 2183)))))
              : (c <= 2190 || (c < 2392
                ? (c < 2365
                  ? (c < 2308
                    ? (c >= 2208 && c <= 2249)
                    : c <= 2361)
                  : (c <= 2365 || c == 2384))
                : (c <= 2401 || (c < 2447
                  ? (c < 2437
                    ? (c >= 2417 && c <= 2432)
                    : c <= 2444)
                  : (c <= 2448 || (c >= 2451 && c <= 2472)))))))
            : (c <= 2480 || (c < 2575
              ? (c < 2524
                ? (c < 2493
                  ? (c < 2486
                    ? c == 2482
                    : c <= 2489)
                  : (c <= 2493 || c == 2510))
                : (c <= 2525 || (c < 2556
                  ? (c < 2544
                    ? (c >= 2527 && c <= 2529)
                    : c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))))
              : (c <= 2576 || (c < 2616
                ? (c < 2610
                  ? (c < 2602
                    ? (c >= 2579 && c <= 2600)
                    : c <= 2608)
                  : (c <= 2611 || (c >= 2613 && c <= 2614)))
                : (c <= 2617 || (c < 2674
                  ? (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)
                  : (c <= 2676 || (c >= 2693 && c <= 2701)))))))))))
        : (c <= 2705 || (c < 3218
          ? (c < 2958
            ? (c < 2835
              ? (c < 2768
                ? (c < 2738
                  ? (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)
                  : (c <= 2739 || (c < 2749
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2749)))
                : (c <= 2768 || (c < 2821
                  ? (c < 2809
                    ? (c >= 2784 && c <= 2785)
                    : c <= 2809)
                  : (c <= 2828 || (c >= 2831 && c <= 2832)))))
              : (c <= 2856 || (c < 2908
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || c == 2877))
                : (c <= 2909 || (c < 2947
                  ? (c < 2929
                    ? (c >= 2911 && c <= 2913)
                    : c <= 2929)
                  : (c <= 2947 || (c >= 2949 && c <= 2954)))))))
            : (c <= 2960 || (c < 3086
              ? (c < 2979
                ? (c < 2972
                  ? (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)
                  : (c <= 2972 || (c >= 2974 && c <= 2975)))
                : (c <= 2980 || (c < 3024
                  ? (c < 2990
                    ? (c >= 2984 && c <= 2986)
                    : c <= 3001)
                  : (c <= 3024 || (c >= 3077 && c <= 3084)))))
              : (c <= 3088 || (c < 3165
                ? (c < 3133
                  ? (c < 3114
                    ? (c >= 3090 && c <= 3112)
                    : c <= 3129)
                  : (c <= 3133 || (c >= 3160 && c <= 3162)))
                : (c <= 3165 || (c < 3205
                  ? (c < 3200
                    ? (c >= 3168 && c <= 3169)
                    : c <= 3200)
                  : (c <= 3212 || (c >= 3214 && c <= 3216)))))))))
          : (c <= 3240 || (c < 3634
            ? (c < 3406
              ? (c < 3313
                ? (c < 3261
                  ? (c < 3253
                    ? (c >= 3242 && c <= 3251)
                    : c <= 3257)
                  : (c <= 3261 || (c < 3296
                    ? (c >= 3293 && c <= 3294)
                    : c <= 3297)))
                : (c <= 3314 || (c < 3346
                  ? (c < 3342
                    ? (c >= 3332 && c <= 3340)
                    : c <= 3344)
                  : (c <= 3386 || c == 3389))))
              : (c <= 3406 || (c < 3482
                ? (c < 3450
                  ? (c < 3423
                    ? (c >= 3412 && c <= 3414)
                    : c <= 3425)
                  : (c <= 3455 || (c >= 3461 && c <= 3478)))
                : (c <= 3505 || (c < 3520
                  ? (c < 3517
                    ? (c >= 3507 && c <= 3515)
                    : c <= 3517)
                  : (c <= 3526 || (c >= 3585 && c <= 3632)))))))
            : (c <= 3634 || (c < 3776
              ? (c < 3724
                ? (c < 3716
                  ? (c < 3713
                    ? (c >= 3648 && c <= 3654)
                    : c <= 3714)
                  : (c <= 3716 || (c >= 3718 && c <= 3722)))
                : (c <= 3747 || (c < 3762
                  ? (c < 3751
                    ? c == 3749
                    : c <= 3760)
                  : (c <= 3762 || c == 3773))))
              : (c <= 3780 || (c < 3913
                ? (c < 3840
                  ? (c < 3804
                    ? c == 3782
                    : c <= 3807)
                  : (c <= 3840 || (c >= 3904 && c <= 3911)))
                : (c <= 3948 || (c < 4159
                  ? (c < 4096
                    ? (c >= 3976 && c <= 3980)
                    : c <= 4138)
                  : (c <= 4159 || (c >= 4176 && c <= 4181)))))))))))))
      : (c <= 4189 || (c < 8130
        ? (c < 6108
          ? (c < 4802
            ? (c < 4682
              ? (c < 4256
                ? (c < 4206
                  ? (c < 4197
                    ? c == 4193
                    : c <= 4198)
                  : (c <= 4208 || (c < 4238
                    ? (c >= 4213 && c <= 4225)
                    : c <= 4238)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c >= 4348 && c <= 4680)))))
              : (c <= 4685 || (c < 4746
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c >= 4704 && c <= 4744)))
                : (c <= 4749 || (c < 4792
                  ? (c < 4786
                    ? (c >= 4752 && c <= 4784)
                    : c <= 4789)
                  : (c <= 4798 || c == 4800))))))
            : (c <= 4805 || (c < 5761
              ? (c < 4992
                ? (c < 4882
                  ? (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)
                  : (c <= 4885 || (c >= 4888 && c <= 4954)))
                : (c <= 5007 || (c < 5121
                  ? (c < 5112
                    ? (c >= 5024 && c <= 5109)
                    : c <= 5117)
                  : (c <= 5740 || (c >= 5743 && c <= 5759)))))
              : (c <= 5786 || (c < 5952
                ? (c < 5888
                  ? (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)
                  : (c <= 5905 || (c >= 5919 && c <= 5937)))
                : (c <= 5969 || (c < 6016
                  ? (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)
                  : (c <= 6067 || c == 6103))))))))
          : (c <= 6108 || (c < 7296
            ? (c < 6688
              ? (c < 6480
                ? (c < 6314
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6312)
                  : (c <= 6314 || (c < 6400
                    ? (c >= 6320 && c <= 6389)
                    : c <= 6430)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c >= 6656 && c <= 6678)))))
              : (c <= 6740 || (c < 7086
                ? (c < 6981
                  ? (c < 6917
                    ? c == 6823
                    : c <= 6963)
                  : (c <= 6988 || (c >= 7043 && c <= 7072)))
                : (c <= 7087 || (c < 7245
                  ? (c < 7168
                    ? (c >= 7098 && c <= 7141)
                    : c <= 7203)
                  : (c <= 7247 || (c >= 7258 && c <= 7293)))))))
            : (c <= 7304 || (c < 7968
              ? (c < 7413
                ? (c < 7401
                  ? (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)
                  : (c <= 7404 || (c >= 7406 && c <= 7411)))
                : (c <= 7414 || (c < 7680
                  ? (c < 7424
                    ? c == 7418
                    : c <= 7615)
                  : (c <= 7957 || (c >= 7960 && c <= 7965)))))
              : (c <= 8005 || (c < 8029
                ? (c < 8025
                  ? (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)
                  : (c <= 8025 || c == 8027))
                : (c <= 8029 || (c < 8118
                  ? (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)
                  : (c <= 8124 || c == 8126))))))))))
        : (c <= 8132 || (c < 12321
          ? (c < 8526
            ? (c < 8455
              ? (c < 8182
                ? (c < 8150
                  ? (c < 8144
                    ? (c >= 8134 && c <= 8140)
                    : c <= 8147)
                  : (c <= 8155 || (c < 8178
                    ? (c >= 8160 && c <= 8172)
                    : c <= 8180)))
                : (c <= 8188 || (c < 8336
                  ? (c < 8319
                    ? c == 8305
                    : c <= 8319)
                  : (c <= 8348 || c == 8450))))
              : (c <= 8455 || (c < 8486
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || c == 8484))
                : (c <= 8486 || (c < 8508
                  ? (c < 8490
                    ? c == 8488
                    : c <= 8505)
                  : (c <= 8511 || (c >= 8517 && c <= 8521)))))))
            : (c <= 8526 || (c < 11648
              ? (c < 11520
                ? (c < 11499
                  ? (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11568
                  ? (c < 11565
                    ? c == 11559
                    : c <= 11565)
                  : (c <= 11623 || c == 11631))))
              : (c <= 11670 || (c < 11712
                ? (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c >= 11704 && c <= 11710)))
                : (c <= 11718 || (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c >= 12293 && c <= 12295)))))))))
          : (c <= 12329 || (c < 42786
            ? (c < 13312
              ? (c < 12540
                ? (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))
                : (c <= 12543 || (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c >= 12784 && c <= 12799)))))
              : (c <= 19903 || (c < 42538
                ? (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c >= 42512 && c <= 42527)))
                : (c <= 42539 || (c < 42656
                  ? (c < 42623
                    ? (c >= 42560 && c <= 42606)
                    : c <= 42653)
                  : (c <= 42735 || (c >= 42775 && c <= 42783)))))))
            : (c <= 42888 || (c < 43138
              ? (c < 42994
                ? (c < 42963
                  ? (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)
                  : (c <= 42963 || (c >= 42965 && c <= 42969)))
                : (c <= 43009 || (c < 43020
                  ? (c < 43015
                    ? (c >= 43011 && c <= 43013)
                    : c <= 43018)
                  : (c <= 43042 || (c >= 43072 && c <= 43123)))))
              : (c <= 43187 || (c < 43312
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43250 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43262 || (c >= 43274 && c <= 43301)))
                : (c <= 43334 || (c < 43471
                  ? (c < 43396
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43442)
                  : (c <= 43471 || (c >= 43488 && c <= 43492)))))))))))))))
    : (c <= 43503 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43824
            ? (c < 43712
              ? (c < 43642
                ? (c < 43584
                  ? (c < 43520
                    ? (c >= 43514 && c <= 43518)
                    : c <= 43560)
                  : (c <= 43586 || (c < 43616
                    ? (c >= 43588 && c <= 43595)
                    : c <= 43638)))
                : (c <= 43642 || (c < 43701
                  ? (c < 43697
                    ? (c >= 43646 && c <= 43695)
                    : c <= 43697)
                  : (c <= 43702 || (c >= 43705 && c <= 43709)))))
              : (c <= 43712 || (c < 43777
                ? (c < 43744
                  ? (c < 43739
                    ? c == 43714
                    : c <= 43741)
                  : (c <= 43754 || (c >= 43762 && c <= 43764)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c >= 43816 && c <= 43822)))))))
            : (c <= 43866 || (c < 64287
              ? (c < 63744
                ? (c < 44032
                  ? (c < 43888
                    ? (c >= 43868 && c <= 43881)
                    : c <= 44002)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 43616
    ? (c < 3782
      ? (c < 2741
        ? (c < 2042
          ? (c < 931
            ? (c < 248
              ? (c < 170
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'z')))
                : (c <= 170 || (c < 186
                  ? (c < 183
                    ? c == 181
                    : c <= 183)
                  : (c <= 186 || (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)))))
              : (c <= 705 || (c < 886
                ? (c < 748
                  ? (c < 736
                    ? (c >= 710 && c <= 721)
                    : c <= 740)
                  : (c <= 748 || (c < 768
                    ? c == 750
                    : c <= 884)))
                : (c <= 887 || (c < 902
                  ? (c < 895
                    ? (c >= 891 && c <= 893)
                    : c <= 895)
                  : (c <= 906 || (c < 910
                    ? c == 908
                    : c <= 929)))))))
            : (c <= 1013 || (c < 1488
              ? (c < 1376
                ? (c < 1162
                  ? (c < 1155
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1159)
                  : (c <= 1327 || (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)))
                : (c <= 1416 || (c < 1473
                  ? (c < 1471
                    ? (c >= 1425 && c <= 1469)
                    : c <= 1471)
                  : (c <= 1474 || (c < 1479
                    ? (c >= 1476 && c <= 1477)
                    : c <= 1479)))))
              : (c <= 1514 || (c < 1759
                ? (c < 1568
                  ? (c < 1552
                    ? (c >= 1519 && c <= 1522)
                    : c <= 1562)
                  : (c <= 1641 || (c < 1749
                    ? (c >= 1646 && c <= 1747)
                    : c <= 1756)))
                : (c <= 1768 || (c < 1808
                  ? (c < 1791
                    ? (c >= 1770 && c <= 1788)
                    : c <= 1791)
                  : (c <= 1866 || (c < 1984
                    ? (c >= 1869 && c <= 1969)
                    : c <= 2037)))))))))
          : (c <= 2042 || (c < 2556
            ? (c < 2447
              ? (c < 2185
                ? (c < 2112
                  ? (c < 2048
                    ? c == 2045
                    : c <= 2093)
                  : (c <= 2139 || (c < 2160
                    ? (c >= 2144 && c <= 2154)
                    : c <= 2183)))
                : (c <= 2190 || (c < 2406
                  ? (c < 2275
                    ? (c >= 2200 && c <= 2273)
                    : c <= 2403)
                  : (c <= 2415 || (c < 2437
                    ? (c >= 2417 && c <= 2435)
                    : c <= 2444)))))
              : (c <= 2448 || (c < 2503
                ? (c < 2482
                  ? (c < 2474
                    ? (c >= 2451 && c <= 2472)
                    : c <= 2480)
                  : (c <= 2482 || (c < 2492
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2500)))
                : (c <= 2504 || (c < 2524
                  ? (c < 2519
                    ? (c >= 2507 && c <= 2510)
                    : c <= 2519)
                  : (c <= 2525 || (c < 2534
                    ? (c >= 2527 && c <= 2531)
                    : c <= 2545)))))))
            : (c <= 2556 || (c < 2631
              ? (c < 2602
                ? (c < 2565
                  ? (c < 2561
                    ? c == 2558
                    : c <= 2563)
                  : (c <= 2570 || (c < 2579
                    ? (c >= 2575 && c <= 2576)
                    : c <= 2600)))
                : (c <= 2608 || (c < 2616
                  ? (c < 2613
                    ? (c >= 2610 && c <= 2611)
                    : c <= 2614)
                  : (c <= 2617 || (c < 2622
                    ? c == 2620
                    : c <= 2626)))))
              : (c <= 2632 || (c < 2689
                ? (c < 2649
                  ? (c < 2641
                    ? (c >= 2635 && c <= 2637)
                    : c <= 2641)
                  : (c <= 2652 || (c < 2662
                    ? c == 2654
                    : c <= 2677)))
                : (c <= 2691 || (c < 2707
                  ? (c < 2703
                    ? (c >= 2693 && c <= 2701)
                    : c <= 2705)
                  : (c <= 2728 || (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)))))))))))
        : (c <= 2745 || (c < 3165
          ? (c < 2949
            ? (c < 2858
              ? (c < 2790
                ? (c < 2763
                  ? (c < 2759
                    ? (c >= 2748 && c <= 2757)
                    : c <= 2761)
                  : (c <= 2765 || (c < 2784
                    ? c == 2768
                    : c <= 2787)))
                : (c <= 2799 || (c < 2821
                  ? (c < 2817
                    ? (c >= 2809 && c <= 2815)
                    : c <= 2819)
                  : (c <= 2828 || (c < 2835
                    ? (c >= 2831 && c <= 2832)
                    : c <= 2856)))))
              : (c <= 2864 || (c < 2901
                ? (c < 2876
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2884 || (c < 2891
                    ? (c >= 2887 && c <= 2888)
                    : c <= 2893)))
                : (c <= 2903 || (c < 2918
                  ? (c < 2911
                    ? (c >= 2908 && c <= 2909)
                    : c <= 2915)
                  : (c <= 2927 || (c < 2946
                    ? c == 2929
                    : c <= 2947)))))))
            : (c <= 2954 || (c < 3024
              ? (c < 2979
                ? (c < 2969
                  ? (c < 2962
                    ? (c >= 2958 && c <= 2960)
                    : c <= 2965)
                  : (c <= 2970 || (c < 2974
                    ? c == 2972
                    : c <= 2975)))
                : (c <= 2980 || (c < 3006
                  ? (c < 2990
                    ? (c >= 2984 && c <= 2986)
                    : c <= 3001)
                  : (c <= 3010 || (c < 3018
                    ? (c >= 3014 && c <= 3016)
                    : c <= 3021)))))
              : (c <= 3024 || (c < 3114
                ? (c < 3072
                  ? (c < 3046
                    ? c == 3031
                    : c <= 3055)
                  : (c <= 3084 || (c < 3090
                    ? (c >= 3086 && c <= 3088)
                    : c <= 3112)))
                : (c <= 3129 || (c < 3146
                  ? (c < 3142
                    ? (c >= 3132 && c <= 3140)
                    : c <= 3144)
                  : (c <= 3149 || (c < 3160
                    ? (c >= 3157 && c <= 3158)
                    : c <= 3162)))))))))
          : (c <= 3165 || (c < 3430
            ? (c < 3285
              ? (c < 3218
                ? (c < 3200
                  ? (c < 3174
                    ? (c >= 3168 && c <= 3171)
                    : c <= 3183)
                  : (c <= 3203 || (c < 3214
                    ? (c >= 3205 && c <= 3212)
                    : c <= 3216)))
                : (c <= 3240 || (c < 3260
                  ? (c < 3253
                    ? (c >= 3242 && c <= 3251)
                    : c <= 3257)
                  : (c <= 3268 || (c < 3274
                    ? (c >= 3270 && c <= 3272)
                    : c <= 3277)))))
              : (c <= 3286 || (c < 3342
                ? (c < 3302
                  ? (c < 3296
                    ? (c >= 3293 && c <= 3294)
                    : c <= 3299)
                  : (c <= 3311 || (c < 3328
                    ? (c >= 3313 && c <= 3314)
                    : c <= 3340)))
                : (c <= 3344 || (c < 3402
                  ? (c < 3398
                    ? (c >= 3346 && c <= 3396)
                    : c <= 3400)
                  : (c <= 3406 || (c < 3423
                    ? (c >= 3412 && c <= 3415)
                    : c <= 3427)))))))
            : (c <= 3439 || (c < 3558
              ? (c < 3517
                ? (c < 3461
                  ? (c < 3457
                    ? (c >= 3450 && c <= 3455)
                    : c <= 3459)
                  : (c <= 3478 || (c < 3507
                    ? (c >= 3482 && c <= 3505)
                    : c <= 3515)))
                : (c <= 3517 || (c < 3535
                  ? (c < 3530
                    ? (c >= 3520 && c <= 3526)
                    : c <= 3530)
                  : (c <= 3540 || (c < 3544
                    ? c == 3542
                    : c <= 3551)))))
              : (c <= 3567 || (c < 3716
                ? (c < 3648
                  ? (c < 3585
                    ? (c >= 3570 && c <= 3571)
                    : c <= 3642)
                  : (c <= 3662 || (c < 3713
                    ? (c >= 3664 && c <= 3673)
                    : c <= 3714)))
                : (c <= 3716 || (c < 3749
                  ? (c < 3724
                    ? (c >= 3718 && c <= 3722)
                    : c <= 3747)
                  : (c <= 3749 || (c < 3776
                    ? (c >= 3751 && c <= 3773)
                    : c <= 3780)))))))))))))
      : (c <= 3782 || (c < 8025
        ? (c < 5888
          ? (c < 4688
            ? (c < 3953
              ? (c < 3872
                ? (c < 3804
                  ? (c < 3792
                    ? (c >= 3784 && c <= 3789)
                    : c <= 3801)
                  : (c <= 3807 || (c < 3864
                    ? c == 3840
                    : c <= 3865)))
                : (c <= 3881 || (c < 3897
                  ? (c < 3895
                    ? c == 3893
                    : c <= 3895)
                  : (c <= 3897 || (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)))))
              : (c <= 3972 || (c < 4256
                ? (c < 4038
                  ? (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)
                  : (c <= 4038 || (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)))))))
            : (c <= 4694 || (c < 4882
              ? (c < 4786
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))))
              : (c <= 4885 || (c < 5112
                ? (c < 4969
                  ? (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)
                  : (c <= 4977 || (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)))))))))
          : (c <= 5909 || (c < 6688
            ? (c < 6176
              ? (c < 6016
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)
                  : (c <= 5996 || (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)))
                : (c <= 6099 || (c < 6112
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6109)
                  : (c <= 6121 || (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)))))
              : (c <= 6264 || (c < 6470
                ? (c < 6400
                  ? (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)
                  : (c <= 6430 || (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)))))))
            : (c <= 6750 || (c < 7232
              ? (c < 6847
                ? (c < 6800
                  ? (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)
                  : (c <= 6809 || (c < 6832
                    ? c == 6823
                    : c <= 6845)))
                : (c <= 6862 || (c < 7019
                  ? (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)
                  : (c <= 7027 || (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)))))
              : (c <= 7241 || (c < 7380
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)))
                : (c <= 7418 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)))))))))))
        : (c <= 8025 || (c < 11720
          ? (c < 8458
            ? (c < 8178
              ? (c < 8126
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)))
                : (c <= 8126 || (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))))
              : (c <= 8180 || (c < 8336
                ? (c < 8276
                  ? (c < 8255
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8256)
                  : (c <= 8276 || (c < 8319
                    ? c == 8305
                    : c <= 8319)))
                : (c <= 8348 || (c < 8421
                  ? (c < 8417
                    ? (c >= 8400 && c <= 8412)
                    : c <= 8417)
                  : (c <= 8432 || (c < 8455
                    ? c == 8450
                    : c <= 8455)))))))
            : (c <= 8467 || (c < 11499
              ? (c < 8490
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || (c < 8488
                    ? c == 8486
                    : c <= 8488)))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)))))
              : (c <= 11507 || (c < 11647
                ? (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)))
                : (c <= 11670 || (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)))))))))
          : (c <= 11726 || (c < 42623
            ? (c < 12540
              ? (c < 12337
                ? (c < 11744
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 11775 || (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12335)))
                : (c <= 12341 || (c < 12441
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12442 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))))
              : (c <= 12543 || (c < 19968
                ? (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)))
                : (c <= 42124 || (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42539 || (c < 42612
                    ? (c >= 42560 && c <= 42607)
                    : c <= 42621)))))))
            : (c <= 42737 || (c < 43232
              ? (c < 42965
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)))
                : (c <= 42969 || (c < 43072
                  ? (c < 43052
                    ? (c >= 42994 && c <= 43047)
                    : c <= 43052)
                  : (c <= 43123 || (c < 43216
                    ? (c >= 43136 && c <= 43205)
                    : c <= 43225)))))
              : (c <= 43255 || (c < 43471
                ? (c < 43312
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43309)
                  : (c <= 43347 || (c < 43392
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43456)))
                : (c <= 43481 || (c < 43584
                  ? (c < 43520
                    ? (c >= 43488 && c <= 43518)
                    : c <= 43574)
                  : (c <= 43597 || (c >= 43600 && c <= 43609)))))))))))))))
    : (c <= 43638 || (c < 71453
      ? (c < 67639
        ? (c < 65345
          ? (c < 64312
            ? (c < 43888
              ? (c < 43785
                ? (c < 43744
                  ? (c < 43739
                    ? (c >= 43642 && c <= 43714)
                    : c <= 43741)
                  : (c <= 43759 || (c < 43777
                    ? (c >= 43762 && c <= 43766)
                    : c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)))))
              : (c <= 44010 || (c < 63744
                ? (c < 44032
                  ? (c < 44016
                    ? (c >= 44012 && c <= 44013)
                    : c <= 44025)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || (c < 64298
                    ? (c >= 64285 && c <= 64296)
                    : c <= 64310)))))))
            : (c <= 64316 || (c < 65075
              ? (c < 64612
                ? (c < 64323
                  ? (c < 64320
                    ? c == 64318
                    : c <= 64321)
                  : (c <= 64324 || (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)))
                : (c <= 64829 || (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65056
                    ? (c >= 65024 && c <= 65039)
                    : c <= 65071)))))
              : (c <= 65076 || (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65101 && c <= 65103)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65296
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65305 || (c < 65343
                    ? (c >= 65313 && c <= 65338)
                    : c <= 65343)))))))))
          : (c <= 65370 || (c < 66513
            ? (c < 65664
              ? (c < 65536
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65382 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)))))
              : (c <= 65786 || (c < 66304
                ? (c < 66176
                  ? (c < 66045
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66045)
                  : (c <= 66204 || (c < 66272
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66272)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66426)
                  : (c <= 66461 || (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)))))))
            : (c <= 66517 || (c < 66979
              ? (c < 66864
                ? (c < 66736
                  ? (c < 66720
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66729)
                  : (c <= 66771 || (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)))
                : (c <= 66915 || (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))))
              : (c <= 66993 || (c < 67456
                ? (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)))
                : (c <= 67461 || (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || (c < 67594
                    ? c == 67592
                    : c <= 67637)))))))))))
        : (c <= 67640 || (c < 69956
          ? (c < 68448
            ? (c < 68101
              ? (c < 67828
                ? (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)))
                : (c <= 67829 || (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68099)))))
              : (c <= 68102 || (c < 68192
                ? (c < 68121
                  ? (c < 68117
                    ? (c >= 68108 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c < 68159
                    ? (c >= 68152 && c <= 68154)
                    : c <= 68159)))
                : (c <= 68220 || (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68326 || (c < 68416
                    ? (c >= 68352 && c <= 68405)
                    : c <= 68437)))))))
            : (c <= 68466 || (c < 69424
              ? (c < 68912
                ? (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68903)))
                : (c <= 68921 || (c < 69296
                  ? (c < 69291
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69292)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))))
              : (c <= 69456 || (c < 69759
                ? (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69509)
                    : c <= 69572)
                  : (c <= 69622 || (c < 69734
                    ? (c >= 69632 && c <= 69702)
                    : c <= 69749)))
                : (c <= 69818 || (c < 69872
                  ? (c < 69840
                    ? c == 69826
                    : c <= 69864)
                  : (c <= 69881 || (c < 69942
                    ? (c >= 69888 && c <= 69940)
                    : c <= 69951)))))))))
          : (c <= 69959 || (c < 70459
            ? (c < 70282
              ? (c < 70108
                ? (c < 70016
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70003)
                    : c <= 70006)
                  : (c <= 70084 || (c < 70094
                    ? (c >= 70089 && c <= 70092)
                    : c <= 70106)))
                : (c <= 70108 || (c < 70206
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70199)
                  : (c <= 70206 || (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)))))
              : (c <= 70285 || (c < 70405
                ? (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70378 || (c < 70400
                    ? (c >= 70384 && c <= 70393)
                    : c <= 70403)))
                : (c <= 70412 || (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)))))))
            : (c <= 70468 || (c < 70855
              ? (c < 70502
                ? (c < 70480
                  ? (c < 70475
                    ? (c >= 70471 && c <= 70472)
                    : c <= 70477)
                  : (c <= 70480 || (c < 70493
                    ? c == 70487
                    : c <= 70499)))
                : (c <= 70508 || (c < 70736
                  ? (c < 70656
                    ? (c >= 70512 && c <= 70516)
                    : c <= 70730)
                  : (c <= 70745 || (c < 70784
                    ? (c >= 70750 && c <= 70753)
                    : c <= 70853)))))
              : (c <= 70855 || (c < 71236
                ? (c < 71096
                  ? (c < 71040
                    ? (c >= 70864 && c <= 70873)
                    : c <= 71093)
                  : (c <= 71104 || (c < 71168
                    ? (c >= 71128 && c <= 71133)
                    : c <= 71232)))
                : (c <= 71236 || (c < 71360
                  ? (c < 71296
                    ? (c >= 71248 && c <= 71257)
                    : c <= 71352)
                  : (c <= 71369 || (c >= 71424 && c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_4(int32_t c) {
  return (c < 43600
    ? (c < 3776
      ? (c < 2738
        ? (c < 1984
          ? (c < 910
            ? (c < 216
              ? (c < 'a'
                ? (c < '9'
                  ? (c < '0'
                    ? c == '$'
                    : c <= '7')
                  : (c <= '9' || (c < '_'
                    ? (c >= 'A' && c <= 'Z')
                    : c <= '_')))
                : (c <= 'z' || (c < 183
                  ? (c < 181
                    ? c == 170
                    : c <= 181)
                  : (c <= 183 || (c < 192
                    ? c == 186
                    : c <= 214)))))
              : (c <= 246 || (c < 768
                ? (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || (c < 750
                    ? c == 748
                    : c <= 750)))
                : (c <= 884 || (c < 895
                  ? (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)
                  : (c <= 895 || (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)))))))
            : (c <= 929 || (c < 1479
              ? (c < 1369
                ? (c < 1155
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1159 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1471
                  ? (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)
                  : (c <= 1471 || (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)))))
              : (c <= 1479 || (c < 1749
                ? (c < 1552
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1562 || (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)))
                : (c <= 1756 || (c < 1791
                  ? (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)
                  : (c <= 1791 || (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)))))))))
          : (c <= 2037 || (c < 2534
            ? (c < 2437
              ? (c < 2160
                ? (c < 2048
                  ? (c < 2045
                    ? c == 2042
                    : c <= 2045)
                  : (c <= 2093 || (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)))
                : (c <= 2183 || (c < 2275
                  ? (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)
                  : (c <= 2403 || (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)))))
              : (c <= 2444 || (c < 2492
                ? (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || (c < 2486
                    ? c == 2482
                    : c <= 2489)))
                : (c <= 2500 || (c < 2519
                  ? (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)
                  : (c <= 2519 || (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)))))))
            : (c <= 2545 || (c < 2622
              ? (c < 2579
                ? (c < 2561
                  ? (c < 2558
                    ? c == 2556
                    : c <= 2558)
                  : (c <= 2563 || (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)))
                : (c <= 2600 || (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)))))
              : (c <= 2626 || (c < 2662
                ? (c < 2641
                  ? (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)
                  : (c <= 2641 || (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)))
                : (c <= 2677 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)
                  : (c <= 2705 || (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)))))))))))
        : (c <= 2739 || (c < 3160
          ? (c < 2946
            ? (c < 2835
              ? (c < 2784
                ? (c < 2759
                  ? (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)
                  : (c <= 2761 || (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)))
                : (c <= 2787 || (c < 2817
                  ? (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)
                  : (c <= 2819 || (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)))))
              : (c <= 2856 || (c < 2891
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)))
                : (c <= 2893 || (c < 2911
                  ? (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)
                  : (c <= 2915 || (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)))))))
            : (c <= 2947 || (c < 3018
              ? (c < 2974
                ? (c < 2962
                  ? (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)
                  : (c <= 2965 || (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)))
                : (c <= 2975 || (c < 2990
                  ? (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)
                  : (c <= 3001 || (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)))))
              : (c <= 3021 || (c < 3090
                ? (c < 3046
                  ? (c < 3031
                    ? c == 3024
                    : c <= 3031)
                  : (c <= 3055 || (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)))
                : (c <= 3112 || (c < 3142
                  ? (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)
                  : (c <= 3144 || (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)))))))))
          : (c <= 3162 || (c < 3423
            ? (c < 3274
              ? (c < 3214
                ? (c < 3174
                  ? (c < 3168
                    ? c == 3165
                    : c <= 3171)
                  : (c <= 3183 || (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)))
                : (c <= 3216 || (c < 3253
                  ? (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)
                  : (c <= 3257 || (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)))))
              : (c <= 3277 || (c < 3328
                ? (c < 3296
                  ? (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)
                  : (c <= 3299 || (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3398
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)
                  : (c <= 3400 || (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)))))))
            : (c <= 3427 || (c < 3544
              ? (c < 3507
                ? (c < 3457
                  ? (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)
                  : (c <= 3459 || (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)))
                : (c <= 3515 || (c < 3530
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3530 || (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)))))
              : (c <= 3551 || (c < 3713
                ? (c < 3585
                  ? (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)
                  : (c <= 3642 || (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)))
                : (c <= 3714 || (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || (c < 3751
                    ? c == 3749
                    : c <= 3773)))))))))))))
      : (c <= 3780 || (c < 8016
        ? (c < 5870
          ? (c < 4682
            ? (c < 3913
              ? (c < 3864
                ? (c < 3792
                  ? (c < 3784
                    ? c == 3782
                    : c <= 3789)
                  : (c <= 3801 || (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)))
                : (c <= 3865 || (c < 3895
                  ? (c < 3893
                    ? (c >= 3872 && c <= 3881)
                    : c <= 3893)
                  : (c <= 3895 || (c < 3902
                    ? c == 3897
                    : c <= 3911)))))
              : (c <= 3948 || (c < 4176
                ? (c < 3993
                  ? (c < 3974
                    ? (c >= 3953 && c <= 3972)
                    : c <= 3991)
                  : (c <= 4028 || (c < 4096
                    ? c == 4038
                    : c <= 4169)))
                : (c <= 4253 || (c < 4301
                  ? (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)
                  : (c <= 4301 || (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)))))))
            : (c <= 4685 || (c < 4824
              ? (c < 4752
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c < 4746
                    ? (c >= 4704 && c <= 4744)
                    : c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c < 4808
                    ? (c >= 4802 && c <= 4805)
                    : c <= 4822)))))
              : (c <= 4880 || (c < 5024
                ? (c < 4957
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 4959 || (c < 4992
                    ? (c >= 4969 && c <= 4977)
                    : c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c < 5792
                    ? (c >= 5761 && c <= 5786)
                    : c <= 5866)))))))))
          : (c <= 5880 || (c < 6656
            ? (c < 6159
              ? (c < 6002
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5909)
                    : c <= 5940)
                  : (c <= 5971 || (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)))
                : (c <= 6003 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6099)
                    : c <= 6103)
                  : (c <= 6109 || (c < 6155
                    ? (c >= 6112 && c <= 6121)
                    : c <= 6157)))))
              : (c <= 6169 || (c < 6448
                ? (c < 6320
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6432
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6443)))
                : (c <= 6459 || (c < 6528
                  ? (c < 6512
                    ? (c >= 6470 && c <= 6509)
                    : c <= 6516)
                  : (c <= 6571 || (c < 6608
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6618)))))))
            : (c <= 6683 || (c < 7168
              ? (c < 6832
                ? (c < 6783
                  ? (c < 6752
                    ? (c >= 6688 && c <= 6750)
                    : c <= 6780)
                  : (c <= 6793 || (c < 6823
                    ? (c >= 6800 && c <= 6809)
                    : c <= 6823)))
                : (c <= 6845 || (c < 6992
                  ? (c < 6912
                    ? (c >= 6847 && c <= 6862)
                    : c <= 6988)
                  : (c <= 7001 || (c < 7040
                    ? (c >= 7019 && c <= 7027)
                    : c <= 7155)))))
              : (c <= 7223 || (c < 7376
                ? (c < 7296
                  ? (c < 7245
                    ? (c >= 7232 && c <= 7241)
                    : c <= 7293)
                  : (c <= 7304 || (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)))
                : (c <= 7378 || (c < 7960
                  ? (c < 7424
                    ? (c >= 7380 && c <= 7418)
                    : c <= 7957)
                  : (c <= 7965 || (c < 8008
                    ? (c >= 7968 && c <= 8005)
                    : c <= 8013)))))))))))
        : (c <= 8023 || (c < 11712
          ? (c < 8455
            ? (c < 8160
              ? (c < 8118
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)))
                : (c <= 8124 || (c < 8134
                  ? (c < 8130
                    ? c == 8126
                    : c <= 8132)
                  : (c <= 8140 || (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)))))
              : (c <= 8172 || (c < 8319
                ? (c < 8255
                  ? (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)
                  : (c <= 8256 || (c < 8305
                    ? c == 8276
                    : c <= 8305)))
                : (c <= 8319 || (c < 8417
                  ? (c < 8400
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8412)
                  : (c <= 8417 || (c < 8450
                    ? (c >= 8421 && c <= 8432)
                    : c <= 8450)))))))
            : (c <= 8455 || (c < 11264
              ? (c < 8488
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || (c < 8486
                    ? c == 8484
                    : c <= 8486)))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || (c < 8544
                    ? c == 8526
                    : c <= 8584)))))
              : (c <= 11492 || (c < 11631
                ? (c < 11559
                  ? (c < 11520
                    ? (c >= 11499 && c <= 11507)
                    : c <= 11557)
                  : (c <= 11559 || (c < 11568
                    ? c == 11565
                    : c <= 11623)))
                : (c <= 11631 || (c < 11688
                  ? (c < 11680
                    ? (c >= 11647 && c <= 11670)
                    : c <= 11686)
                  : (c <= 11694 || (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)))))))))
          : (c <= 11718 || (c < 42612
            ? (c < 12449
              ? (c < 12321
                ? (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c < 12293
                    ? (c >= 11744 && c <= 11775)
                    : c <= 12295)))
                : (c <= 12335 || (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12445
                    ? (c >= 12441 && c <= 12442)
                    : c <= 12447)))))
              : (c <= 12538 || (c < 13312
                ? (c < 12593
                  ? (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)
                  : (c <= 12686 || (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)))
                : (c <= 19903 || (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c < 42560
                    ? (c >= 42512 && c <= 42539)
                    : c <= 42607)))))))
            : (c <= 42621 || (c < 43216
              ? (c < 42963
                ? (c < 42786
                  ? (c < 42775
                    ? (c >= 42623 && c <= 42737)
                    : c <= 42783)
                  : (c <= 42888 || (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)))
                : (c <= 42963 || (c < 43052
                  ? (c < 42994
                    ? (c >= 42965 && c <= 42969)
                    : c <= 43047)
                  : (c <= 43052 || (c < 43136
                    ? (c >= 43072 && c <= 43123)
                    : c <= 43205)))))
              : (c <= 43225 || (c < 43392
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43232 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43309 || (c < 43360
                    ? (c >= 43312 && c <= 43347)
                    : c <= 43388)))
                : (c <= 43456 || (c < 43520
                  ? (c < 43488
                    ? (c >= 43471 && c <= 43481)
                    : c <= 43518)
                  : (c <= 43574 || (c >= 43584 && c <= 43597)))))))))))))))
    : (c <= 43609 || (c < 71453
      ? (c < 67594
        ? (c < 65343
          ? (c < 64298
            ? (c < 43868
              ? (c < 43777
                ? (c < 43739
                  ? (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43714)
                  : (c <= 43741 || (c < 43762
                    ? (c >= 43744 && c <= 43759)
                    : c <= 43766)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c < 43824
                    ? (c >= 43816 && c <= 43822)
                    : c <= 43866)))))
              : (c <= 43881 || (c < 55243
                ? (c < 44016
                  ? (c < 44012
                    ? (c >= 43888 && c <= 44010)
                    : c <= 44013)
                  : (c <= 44025 || (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)))
                : (c <= 55291 || (c < 64256
                  ? (c < 64112
                    ? (c >= 63744 && c <= 64109)
                    : c <= 64217)
                  : (c <= 64262 || (c < 64285
                    ? (c >= 64275 && c <= 64279)
                    : c <= 64296)))))))
            : (c <= 64310 || (c < 65056
              ? (c < 64467
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c < 64326
                    ? (c >= 64323 && c <= 64324)
                    : c <= 64433)))
                : (c <= 64605 || (c < 64914
                  ? (c < 64848
                    ? (c >= 64612 && c <= 64829)
                    : c <= 64911)
                  : (c <= 64967 || (c < 65024
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65039)))))
              : (c <= 65071 || (c < 65145
                ? (c < 65137
                  ? (c < 65101
                    ? (c >= 65075 && c <= 65076)
                    : c <= 65103)
                  : (c <= 65137 || (c < 65143
                    ? c == 65139
                    : c <= 65143)))
                : (c <= 65145 || (c < 65151
                  ? (c < 65149
                    ? c == 65147
                    : c <= 65149)
                  : (c <= 65276 || (c < 65313
                    ? (c >= 65296 && c <= 65305)
                    : c <= 65338)))))))))
          : (c <= 65343 || (c < 66504
            ? (c < 65616
              ? (c < 65498
                ? (c < 65474
                  ? (c < 65382
                    ? (c >= 65345 && c <= 65370)
                    : c <= 65470)
                  : (c <= 65479 || (c < 65490
                    ? (c >= 65482 && c <= 65487)
                    : c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c < 65599
                    ? (c >= 65596 && c <= 65597)
                    : c <= 65613)))))
              : (c <= 65629 || (c < 66272
                ? (c < 66045
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66045 || (c < 66208
                    ? (c >= 66176 && c <= 66204)
                    : c <= 66256)))
                : (c <= 66272 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66426 || (c < 66464
                    ? (c >= 66432 && c <= 66461)
                    : c <= 66499)))))))
            : (c <= 66511 || (c < 66967
              ? (c < 66816
                ? (c < 66720
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66729 || (c < 66776
                    ? (c >= 66736 && c <= 66771)
                    : c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c < 66964
                    ? (c >= 66956 && c <= 66962)
                    : c <= 66965)))))
              : (c <= 66977 || (c < 67424
                ? (c < 67003
                  ? (c < 66995
                    ? (c >= 66979 && c <= 66993)
                    : c <= 67001)
                  : (c <= 67004 || (c < 67392
                    ? (c >= 67072 && c <= 67382)
                    : c <= 67413)))
                : (c <= 67431 || (c < 67506
                  ? (c < 67463
                    ? (c >= 67456 && c <= 67461)
                    : c <= 67504)
                  : (c <= 67514 || (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)))))))))))
        : (c <= 67637 || (c < 69942
          ? (c < 68416
            ? (c < 68096
              ? (c < 67808
                ? (c < 67647
                  ? (c < 67644
                    ? (c >= 67639 && c <= 67640)
                    : c <= 67644)
                  : (c <= 67669 || (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)))
                : (c <= 67826 || (c < 67872
                  ? (c < 67840
                    ? (c >= 67828 && c <= 67829)
                    : c <= 67861)
                  : (c <= 67897 || (c < 68030
                    ? (c >= 67968 && c <= 68023)
                    : c <= 68031)))))
              : (c <= 68099 || (c < 68159
                ? (c < 68117
                  ? (c < 68108
                    ? (c >= 68101 && c <= 68102)
                    : c <= 68115)
                  : (c <= 68119 || (c < 68152
                    ? (c >= 68121 && c <= 68149)
                    : c <= 68154)))
                : (c <= 68159 || (c < 68288
                  ? (c < 68224
                    ? (c >= 68192 && c <= 68220)
                    : c <= 68252)
                  : (c <= 68295 || (c < 68352
                    ? (c >= 68297 && c <= 68326)
                    : c <= 68405)))))))
            : (c <= 68437 || (c < 69415
              ? (c < 68864
                ? (c < 68608
                  ? (c < 68480
                    ? (c >= 68448 && c <= 68466)
                    : c <= 68497)
                  : (c <= 68680 || (c < 68800
                    ? (c >= 68736 && c <= 68786)
                    : c <= 68850)))
                : (c <= 68903 || (c < 69291
                  ? (c < 69248
                    ? (c >= 68912 && c <= 68921)
                    : c <= 69289)
                  : (c <= 69292 || (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)))))
              : (c <= 69415 || (c < 69734
                ? (c < 69552
                  ? (c < 69488
                    ? (c >= 69424 && c <= 69456)
                    : c <= 69509)
                  : (c <= 69572 || (c < 69632
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69702)))
                : (c <= 69749 || (c < 69840
                  ? (c < 69826
                    ? (c >= 69759 && c <= 69818)
                    : c <= 69826)
                  : (c <= 69864 || (c < 69888
                    ? (c >= 69872 && c <= 69881)
                    : c <= 69940)))))))))
          : (c <= 69951 || (c < 70453
            ? (c < 70280
              ? (c < 70094
                ? (c < 70006
                  ? (c < 69968
                    ? (c >= 69956 && c <= 69959)
                    : c <= 70003)
                  : (c <= 70006 || (c < 70089
                    ? (c >= 70016 && c <= 70084)
                    : c <= 70092)))
                : (c <= 70106 || (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70199 || (c < 70272
                    ? c == 70206
                    : c <= 70278)))))
              : (c <= 70280 || (c < 70400
                ? (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c < 70384
                    ? (c >= 70320 && c <= 70378)
                    : c <= 70393)))
                : (c <= 70403 || (c < 70419
                  ? (c < 70415
                    ? (c >= 70405 && c <= 70412)
                    : c <= 70416)
                  : (c <= 70440 || (c < 70450
                    ? (c >= 70442 && c <= 70448)
                    : c <= 70451)))))))
            : (c <= 70457 || (c < 70784
              ? (c < 70493
                ? (c < 70475
                  ? (c < 70471
                    ? (c >= 70459 && c <= 70468)
                    : c <= 70472)
                  : (c <= 70477 || (c < 70487
                    ? c == 70480
                    : c <= 70487)))
                : (c <= 70499 || (c < 70656
                  ? (c < 70512
                    ? (c >= 70502 && c <= 70508)
                    : c <= 70516)
                  : (c <= 70730 || (c < 70750
                    ? (c >= 70736 && c <= 70745)
                    : c <= 70753)))))
              : (c <= 70853 || (c < 71168
                ? (c < 71040
                  ? (c < 70864
                    ? c == 70855
                    : c <= 70873)
                  : (c <= 71093 || (c < 71128
                    ? (c >= 71096 && c <= 71104)
                    : c <= 71133)))
                : (c <= 71232 || (c < 71296
                  ? (c < 71248
                    ? c == 71236
                    : c <= 71257)
                  : (c <= 71352 || (c < 71424
                    ? (c >= 71360 && c <= 71369)
                    : c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(141);
      if (lookahead == '!') ADVANCE(213);
      if (lookahead == '"') ADVANCE(312);
      if (lookahead == '#') ADVANCE(89);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(336);
      if (lookahead == '%') ADVANCE(230);
      if (lookahead == '&') ADVANCE(239);
      if (lookahead == '\'') ADVANCE(303);
      if (lookahead == '(') ADVANCE(145);
      if (lookahead == ')') ADVANCE(148);
      if (lookahead == '*') ADVANCE(226);
      if (lookahead == '+') ADVANCE(221);
      if (lookahead == ',') ADVANCE(147);
      if (lookahead == '-') ADVANCE(216);
      if (lookahead == '.') ADVANCE(279);
      if (lookahead == '/') ADVANCE(228);
      if (lookahead == '0') ADVANCE(285);
      if (lookahead == ':') ADVANCE(263);
      if (lookahead == ';') ADVANCE(252);
      if (lookahead == '<') ADVANCE(246);
      if (lookahead == '=') ADVANCE(262);
      if (lookahead == '>') ADVANCE(242);
      if (lookahead == '?') ADVANCE(264);
      if (lookahead == 'L') ADVANCE(324);
      if (lookahead == 'U') ADVANCE(326);
      if (lookahead == '[') ADVANCE(259);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == ']') ADVANCE(260);
      if (lookahead == '^') ADVANCE(236);
      if (lookahead == 'u') ADVANCE(328);
      if (lookahead == '{') ADVANCE(256);
      if (lookahead == '|') ADVANCE(233);
      if (lookahead == '}') ADVANCE(257);
      if (lookahead == '~') ADVANCE(214);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(139)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(52)
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(52)
      if (lookahead == '\r') SKIP(1)
      if (lookahead == 'U') ADVANCE(135);
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(56)
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(56)
      if (lookahead == '\r') SKIP(3)
      if (lookahead == 'U') ADVANCE(135);
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(55)
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(55)
      if (lookahead == '\r') SKIP(5)
      if (lookahead == 'U') ADVANCE(135);
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(58)
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(58)
      if (lookahead == '\r') SKIP(7)
      if (lookahead == 'U') ADVANCE(135);
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(54)
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(54)
      if (lookahead == '\r') SKIP(9)
      if (lookahead == 'U') ADVANCE(135);
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(60)
      END_STATE();
    case 12:
      if (lookahead == '\n') SKIP(60)
      if (lookahead == '\r') SKIP(11)
      if (lookahead == 'U') ADVANCE(135);
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(64)
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(64)
      if (lookahead == '\r') SKIP(13)
      if (lookahead == 'U') ADVANCE(135);
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 15:
      if (lookahead == '\n') SKIP(65)
      END_STATE();
    case 16:
      if (lookahead == '\n') SKIP(65)
      if (lookahead == '\r') SKIP(15)
      if (lookahead == 'U') ADVANCE(135);
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 17:
      if (lookahead == '\n') SKIP(70)
      END_STATE();
    case 18:
      if (lookahead == '\n') SKIP(70)
      if (lookahead == '\r') SKIP(17)
      if (lookahead == 'U') ADVANCE(135);
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 19:
      if (lookahead == '\n') SKIP(71)
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(71)
      if (lookahead == '\r') SKIP(19)
      if (lookahead == 'U') ADVANCE(135);
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 21:
      if (lookahead == '\n') SKIP(62)
      END_STATE();
    case 22:
      if (lookahead == '\n') SKIP(62)
      if (lookahead == '\r') SKIP(21)
      if (lookahead == 'U') ADVANCE(135);
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 23:
      if (lookahead == '\n') SKIP(63)
      END_STATE();
    case 24:
      if (lookahead == '\n') SKIP(63)
      if (lookahead == '\r') SKIP(23)
      if (lookahead == 'U') ADVANCE(135);
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(61)
      END_STATE();
    case 26:
      if (lookahead == '\n') SKIP(61)
      if (lookahead == '\r') SKIP(25)
      if (lookahead == 'U') ADVANCE(135);
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 27:
      if (lookahead == '\n') SKIP(66)
      END_STATE();
    case 28:
      if (lookahead == '\n') SKIP(66)
      if (lookahead == '\r') SKIP(27)
      if (lookahead == 'U') ADVANCE(135);
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 29:
      if (lookahead == '\n') SKIP(31)
      END_STATE();
    case 30:
      if (lookahead == '\n') SKIP(31)
      if (lookahead == '\r') SKIP(29)
      END_STATE();
    case 31:
      if (lookahead == '\n') ADVANCE(150);
      if (lookahead == '!') ADVANCE(82);
      if (lookahead == '%') ADVANCE(229);
      if (lookahead == '&') ADVANCE(238);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == '*') ADVANCE(225);
      if (lookahead == '+') ADVANCE(220);
      if (lookahead == '-') ADVANCE(215);
      if (lookahead == '/') ADVANCE(227);
      if (lookahead == '<') ADVANCE(247);
      if (lookahead == '=') ADVANCE(83);
      if (lookahead == '>') ADVANCE(243);
      if (lookahead == '\\') SKIP(30)
      if (lookahead == '^') ADVANCE(235);
      if (lookahead == '|') ADVANCE(234);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(31)
      END_STATE();
    case 32:
      if (lookahead == '\n') SKIP(59)
      END_STATE();
    case 33:
      if (lookahead == '\n') SKIP(59)
      if (lookahead == '\r') SKIP(32)
      if (lookahead == 'U') ADVANCE(135);
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 34:
      if (lookahead == '\n') SKIP(69)
      END_STATE();
    case 35:
      if (lookahead == '\n') SKIP(69)
      if (lookahead == '\r') SKIP(34)
      if (lookahead == 'U') ADVANCE(135);
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 36:
      if (lookahead == '\n') SKIP(68)
      END_STATE();
    case 37:
      if (lookahead == '\n') SKIP(68)
      if (lookahead == '\r') SKIP(36)
      if (lookahead == 'U') ADVANCE(135);
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 38:
      if (lookahead == '\n') SKIP(67)
      if (lookahead == '"') ADVANCE(312);
      if (lookahead == '/') ADVANCE(313);
      if (lookahead == '\\') ADVANCE(39);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(316);
      if (lookahead != 0) ADVANCE(317);
      END_STATE();
    case 39:
      if (lookahead == '\n') ADVANCE(319);
      if (lookahead == '\r') ADVANCE(318);
      if (lookahead == 'U') ADVANCE(136);
      if (lookahead == 'u') ADVANCE(128);
      if (lookahead == 'x') ADVANCE(124);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(321);
      if (lookahead != 0) ADVANCE(318);
      END_STATE();
    case 40:
      if (lookahead == '\n') ADVANCE(143);
      if (lookahead == '\r') ADVANCE(44);
      if (lookahead == '(') ADVANCE(145);
      if (lookahead == '/') ADVANCE(170);
      if (lookahead == '\\') ADVANCE(168);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(80)
      if (lookahead != 0) ADVANCE(171);
      END_STATE();
    case 41:
      if (lookahead == '\n') ADVANCE(143);
      if (lookahead == '\r') ADVANCE(44);
      if (lookahead == '/') ADVANCE(170);
      if (lookahead == '\\') ADVANCE(168);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(80)
      if (lookahead != 0) ADVANCE(171);
      END_STATE();
    case 42:
      if (lookahead == '\n') ADVANCE(143);
      if (lookahead == '\r') ADVANCE(43);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == '/') ADVANCE(74);
      if (lookahead == '\\') SKIP(47)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(73)
      END_STATE();
    case 43:
      if (lookahead == '\n') ADVANCE(143);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == '/') ADVANCE(74);
      if (lookahead == '\\') SKIP(47)
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(73)
      END_STATE();
    case 44:
      if (lookahead == '\n') ADVANCE(143);
      if (lookahead == '/') ADVANCE(170);
      if (lookahead == '\\') ADVANCE(168);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(80)
      if (lookahead != 0) ADVANCE(171);
      END_STATE();
    case 45:
      if (lookahead == '\n') SKIP(72)
      if (lookahead == '\'') ADVANCE(303);
      if (lookahead == '/') ADVANCE(306);
      if (lookahead == '\\') ADVANCE(305);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(307);
      if (lookahead != 0) ADVANCE(304);
      END_STATE();
    case 46:
      if (lookahead == '\n') SKIP(73)
      END_STATE();
    case 47:
      if (lookahead == '\n') SKIP(73)
      if (lookahead == '\r') SKIP(46)
      END_STATE();
    case 48:
      if (lookahead == '\n') SKIP(53)
      END_STATE();
    case 49:
      if (lookahead == '\n') SKIP(53)
      if (lookahead == '\r') SKIP(48)
      if (lookahead == 'U') ADVANCE(135);
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 50:
      if (lookahead == '\n') SKIP(57)
      END_STATE();
    case 51:
      if (lookahead == '\n') SKIP(57)
      if (lookahead == '\r') SKIP(50)
      if (lookahead == 'U') ADVANCE(135);
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 52:
      if (lookahead == '!') ADVANCE(213);
      if (lookahead == '"') ADVANCE(312);
      if (lookahead == '#') ADVANCE(89);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(336);
      if (lookahead == '%') ADVANCE(230);
      if (lookahead == '&') ADVANCE(239);
      if (lookahead == '\'') ADVANCE(303);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == ')') ADVANCE(148);
      if (lookahead == '*') ADVANCE(226);
      if (lookahead == '+') ADVANCE(221);
      if (lookahead == ',') ADVANCE(147);
      if (lookahead == '-') ADVANCE(216);
      if (lookahead == '.') ADVANCE(279);
      if (lookahead == '/') ADVANCE(228);
      if (lookahead == '0') ADVANCE(285);
      if (lookahead == ':') ADVANCE(263);
      if (lookahead == ';') ADVANCE(252);
      if (lookahead == '<') ADVANCE(246);
      if (lookahead == '=') ADVANCE(262);
      if (lookahead == '>') ADVANCE(242);
      if (lookahead == '?') ADVANCE(264);
      if (lookahead == 'L') ADVANCE(324);
      if (lookahead == 'U') ADVANCE(326);
      if (lookahead == '[') ADVANCE(259);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == ']') ADVANCE(260);
      if (lookahead == '^') ADVANCE(236);
      if (lookahead == 'u') ADVANCE(328);
      if (lookahead == '{') ADVANCE(256);
      if (lookahead == '|') ADVANCE(233);
      if (lookahead == '}') ADVANCE(257);
      if (lookahead == '~') ADVANCE(214);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(52)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 53:
      if (lookahead == '!') ADVANCE(213);
      if (lookahead == '"') ADVANCE(312);
      if (lookahead == '#') ADVANCE(99);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(336);
      if (lookahead == '%') ADVANCE(230);
      if (lookahead == '&') ADVANCE(239);
      if (lookahead == '\'') ADVANCE(303);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == ')') ADVANCE(148);
      if (lookahead == '*') ADVANCE(226);
      if (lookahead == '+') ADVANCE(221);
      if (lookahead == ',') ADVANCE(147);
      if (lookahead == '-') ADVANCE(216);
      if (lookahead == '.') ADVANCE(279);
      if (lookahead == '/') ADVANCE(228);
      if (lookahead == '0') ADVANCE(285);
      if (lookahead == ':') ADVANCE(263);
      if (lookahead == ';') ADVANCE(252);
      if (lookahead == '<') ADVANCE(246);
      if (lookahead == '=') ADVANCE(262);
      if (lookahead == '>') ADVANCE(242);
      if (lookahead == '?') ADVANCE(264);
      if (lookahead == 'L') ADVANCE(324);
      if (lookahead == 'U') ADVANCE(326);
      if (lookahead == '[') ADVANCE(258);
      if (lookahead == '\\') ADVANCE(49);
      if (lookahead == ']') ADVANCE(260);
      if (lookahead == '^') ADVANCE(236);
      if (lookahead == 'u') ADVANCE(328);
      if (lookahead == '{') ADVANCE(256);
      if (lookahead == '|') ADVANCE(233);
      if (lookahead == '}') ADVANCE(257);
      if (lookahead == '~') ADVANCE(214);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(53)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 54:
      if (lookahead == '!') ADVANCE(213);
      if (lookahead == '"') ADVANCE(312);
      if (lookahead == '#') ADVANCE(103);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(336);
      if (lookahead == '%') ADVANCE(230);
      if (lookahead == '&') ADVANCE(239);
      if (lookahead == '\'') ADVANCE(303);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == '*') ADVANCE(226);
      if (lookahead == '+') ADVANCE(221);
      if (lookahead == ',') ADVANCE(147);
      if (lookahead == '-') ADVANCE(216);
      if (lookahead == '.') ADVANCE(280);
      if (lookahead == '/') ADVANCE(228);
      if (lookahead == '0') ADVANCE(285);
      if (lookahead == '<') ADVANCE(246);
      if (lookahead == '=') ADVANCE(262);
      if (lookahead == '>') ADVANCE(242);
      if (lookahead == '?') ADVANCE(264);
      if (lookahead == 'L') ADVANCE(324);
      if (lookahead == 'U') ADVANCE(326);
      if (lookahead == '[') ADVANCE(258);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == '^') ADVANCE(236);
      if (lookahead == 'u') ADVANCE(328);
      if (lookahead == '{') ADVANCE(256);
      if (lookahead == '|') ADVANCE(233);
      if (lookahead == '~') ADVANCE(214);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(54)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 55:
      if (lookahead == '!') ADVANCE(212);
      if (lookahead == '"') ADVANCE(312);
      if (lookahead == '#') ADVANCE(89);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(336);
      if (lookahead == '&') ADVANCE(237);
      if (lookahead == '\'') ADVANCE(303);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == '*') ADVANCE(225);
      if (lookahead == '+') ADVANCE(222);
      if (lookahead == ',') ADVANCE(147);
      if (lookahead == '-') ADVANCE(217);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '/') ADVANCE(74);
      if (lookahead == '0') ADVANCE(285);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(252);
      if (lookahead == 'L') ADVANCE(324);
      if (lookahead == 'U') ADVANCE(326);
      if (lookahead == '[') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(6);
      if (lookahead == ']') ADVANCE(88);
      if (lookahead == 'u') ADVANCE(328);
      if (lookahead == '{') ADVANCE(256);
      if (lookahead == '~') ADVANCE(214);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(55)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 56:
      if (lookahead == '!') ADVANCE(212);
      if (lookahead == '"') ADVANCE(312);
      if (lookahead == '#') ADVANCE(95);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(336);
      if (lookahead == '&') ADVANCE(237);
      if (lookahead == '\'') ADVANCE(303);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == ')') ADVANCE(148);
      if (lookahead == '*') ADVANCE(225);
      if (lookahead == '+') ADVANCE(222);
      if (lookahead == ',') ADVANCE(147);
      if (lookahead == '-') ADVANCE(217);
      if (lookahead == '.') ADVANCE(280);
      if (lookahead == '/') ADVANCE(74);
      if (lookahead == '0') ADVANCE(285);
      if (lookahead == ':') ADVANCE(263);
      if (lookahead == ';') ADVANCE(252);
      if (lookahead == '=') ADVANCE(261);
      if (lookahead == 'L') ADVANCE(324);
      if (lookahead == 'U') ADVANCE(326);
      if (lookahead == '[') ADVANCE(259);
      if (lookahead == '\\') ADVANCE(4);
      if (lookahead == ']') ADVANCE(260);
      if (lookahead == 'u') ADVANCE(328);
      if (lookahead == '{') ADVANCE(256);
      if (lookahead == '}') ADVANCE(257);
      if (lookahead == '~') ADVANCE(214);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(56)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 57:
      if (lookahead == '!') ADVANCE(212);
      if (lookahead == '"') ADVANCE(312);
      if (lookahead == '#') ADVANCE(91);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(336);
      if (lookahead == '&') ADVANCE(237);
      if (lookahead == '\'') ADVANCE(303);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == '*') ADVANCE(225);
      if (lookahead == '+') ADVANCE(222);
      if (lookahead == '-') ADVANCE(217);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '/') ADVANCE(74);
      if (lookahead == '0') ADVANCE(285);
      if (lookahead == ';') ADVANCE(252);
      if (lookahead == 'L') ADVANCE(324);
      if (lookahead == 'U') ADVANCE(326);
      if (lookahead == '[') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(328);
      if (lookahead == '{') ADVANCE(256);
      if (lookahead == '~') ADVANCE(214);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(57)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 58:
      if (lookahead == '!') ADVANCE(212);
      if (lookahead == '"') ADVANCE(312);
      if (lookahead == '#') ADVANCE(93);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(336);
      if (lookahead == '&') ADVANCE(237);
      if (lookahead == '\'') ADVANCE(303);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == '*') ADVANCE(225);
      if (lookahead == '+') ADVANCE(222);
      if (lookahead == '-') ADVANCE(217);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '/') ADVANCE(74);
      if (lookahead == '0') ADVANCE(285);
      if (lookahead == ';') ADVANCE(252);
      if (lookahead == 'L') ADVANCE(324);
      if (lookahead == 'U') ADVANCE(326);
      if (lookahead == '[') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(8);
      if (lookahead == 'u') ADVANCE(328);
      if (lookahead == '{') ADVANCE(256);
      if (lookahead == '~') ADVANCE(214);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(58)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 59:
      if (lookahead == '!') ADVANCE(212);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(336);
      if (lookahead == '\'') ADVANCE(303);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == ')') ADVANCE(148);
      if (lookahead == '+') ADVANCE(224);
      if (lookahead == '-') ADVANCE(219);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '/') ADVANCE(74);
      if (lookahead == '0') ADVANCE(285);
      if (lookahead == 'L') ADVANCE(333);
      if (lookahead == 'U') ADVANCE(334);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(332);
      if (lookahead == '~') ADVANCE(214);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(59)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 60:
      if (lookahead == '!') ADVANCE(82);
      if (lookahead == '"') ADVANCE(312);
      if (lookahead == '#') ADVANCE(99);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(336);
      if (lookahead == '%') ADVANCE(230);
      if (lookahead == '&') ADVANCE(239);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == ')') ADVANCE(148);
      if (lookahead == '*') ADVANCE(226);
      if (lookahead == '+') ADVANCE(223);
      if (lookahead == ',') ADVANCE(147);
      if (lookahead == '-') ADVANCE(218);
      if (lookahead == '.') ADVANCE(278);
      if (lookahead == '/') ADVANCE(228);
      if (lookahead == ':') ADVANCE(263);
      if (lookahead == ';') ADVANCE(252);
      if (lookahead == '<') ADVANCE(246);
      if (lookahead == '=') ADVANCE(262);
      if (lookahead == '>') ADVANCE(242);
      if (lookahead == '?') ADVANCE(264);
      if (lookahead == 'L') ADVANCE(325);
      if (lookahead == 'U') ADVANCE(327);
      if (lookahead == '[') ADVANCE(259);
      if (lookahead == '\\') ADVANCE(12);
      if (lookahead == ']') ADVANCE(260);
      if (lookahead == '^') ADVANCE(236);
      if (lookahead == 'u') ADVANCE(329);
      if (lookahead == '|') ADVANCE(233);
      if (lookahead == '}') ADVANCE(257);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(60)
      END_STATE();
    case 61:
      if (lookahead == '!') ADVANCE(82);
      if (lookahead == '"') ADVANCE(312);
      if (lookahead == '#') ADVANCE(103);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(336);
      if (lookahead == '%') ADVANCE(230);
      if (lookahead == '&') ADVANCE(239);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == '*') ADVANCE(226);
      if (lookahead == '+') ADVANCE(223);
      if (lookahead == ',') ADVANCE(147);
      if (lookahead == '-') ADVANCE(218);
      if (lookahead == '.') ADVANCE(277);
      if (lookahead == '/') ADVANCE(228);
      if (lookahead == '<') ADVANCE(246);
      if (lookahead == '=') ADVANCE(262);
      if (lookahead == '>') ADVANCE(242);
      if (lookahead == '?') ADVANCE(264);
      if (lookahead == 'L') ADVANCE(325);
      if (lookahead == 'U') ADVANCE(327);
      if (lookahead == '[') ADVANCE(258);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == '^') ADVANCE(236);
      if (lookahead == 'u') ADVANCE(329);
      if (lookahead == '|') ADVANCE(233);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(61)
      END_STATE();
    case 62:
      if (lookahead == '!') ADVANCE(82);
      if (lookahead == '#') ADVANCE(99);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(336);
      if (lookahead == '%') ADVANCE(230);
      if (lookahead == '&') ADVANCE(239);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == ')') ADVANCE(148);
      if (lookahead == '*') ADVANCE(226);
      if (lookahead == '+') ADVANCE(223);
      if (lookahead == ',') ADVANCE(147);
      if (lookahead == '-') ADVANCE(218);
      if (lookahead == '.') ADVANCE(278);
      if (lookahead == '/') ADVANCE(228);
      if (lookahead == ':') ADVANCE(263);
      if (lookahead == ';') ADVANCE(252);
      if (lookahead == '<') ADVANCE(246);
      if (lookahead == '=') ADVANCE(262);
      if (lookahead == '>') ADVANCE(242);
      if (lookahead == '?') ADVANCE(264);
      if (lookahead == '[') ADVANCE(259);
      if (lookahead == '\\') ADVANCE(22);
      if (lookahead == ']') ADVANCE(260);
      if (lookahead == '^') ADVANCE(236);
      if (lookahead == '{') ADVANCE(256);
      if (lookahead == '|') ADVANCE(233);
      if (lookahead == '}') ADVANCE(257);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(62)
      END_STATE();
    case 63:
      if (lookahead == '!') ADVANCE(82);
      if (lookahead == '#') ADVANCE(99);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(336);
      if (lookahead == '%') ADVANCE(230);
      if (lookahead == '&') ADVANCE(239);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == ')') ADVANCE(148);
      if (lookahead == '*') ADVANCE(226);
      if (lookahead == '+') ADVANCE(223);
      if (lookahead == ',') ADVANCE(147);
      if (lookahead == '-') ADVANCE(218);
      if (lookahead == '.') ADVANCE(277);
      if (lookahead == '/') ADVANCE(228);
      if (lookahead == ':') ADVANCE(263);
      if (lookahead == ';') ADVANCE(252);
      if (lookahead == '<') ADVANCE(246);
      if (lookahead == '=') ADVANCE(262);
      if (lookahead == '>') ADVANCE(242);
      if (lookahead == '?') ADVANCE(264);
      if (lookahead == '[') ADVANCE(258);
      if (lookahead == '\\') ADVANCE(24);
      if (lookahead == ']') ADVANCE(88);
      if (lookahead == '^') ADVANCE(236);
      if (lookahead == '|') ADVANCE(233);
      if (lookahead == '}') ADVANCE(257);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(63)
      END_STATE();
    case 64:
      if (lookahead == '!') ADVANCE(82);
      if (lookahead == '#') ADVANCE(90);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(336);
      if (lookahead == '%') ADVANCE(230);
      if (lookahead == '&') ADVANCE(239);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == ')') ADVANCE(148);
      if (lookahead == '*') ADVANCE(226);
      if (lookahead == '+') ADVANCE(223);
      if (lookahead == ',') ADVANCE(147);
      if (lookahead == '-') ADVANCE(218);
      if (lookahead == '.') ADVANCE(278);
      if (lookahead == '/') ADVANCE(228);
      if (lookahead == ':') ADVANCE(263);
      if (lookahead == ';') ADVANCE(252);
      if (lookahead == '<') ADVANCE(246);
      if (lookahead == '=') ADVANCE(262);
      if (lookahead == '>') ADVANCE(242);
      if (lookahead == '?') ADVANCE(264);
      if (lookahead == '[') ADVANCE(259);
      if (lookahead == '\\') ADVANCE(14);
      if (lookahead == '^') ADVANCE(236);
      if (lookahead == '{') ADVANCE(256);
      if (lookahead == '|') ADVANCE(233);
      if (lookahead == '}') ADVANCE(257);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(64)
      END_STATE();
    case 65:
      if (lookahead == '!') ADVANCE(82);
      if (lookahead == '#') ADVANCE(94);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(336);
      if (lookahead == '%') ADVANCE(229);
      if (lookahead == '&') ADVANCE(238);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == ')') ADVANCE(148);
      if (lookahead == '*') ADVANCE(225);
      if (lookahead == '+') ADVANCE(220);
      if (lookahead == ',') ADVANCE(147);
      if (lookahead == '-') ADVANCE(215);
      if (lookahead == '/') ADVANCE(227);
      if (lookahead == ';') ADVANCE(252);
      if (lookahead == '<') ADVANCE(247);
      if (lookahead == '=') ADVANCE(262);
      if (lookahead == '>') ADVANCE(243);
      if (lookahead == '[') ADVANCE(259);
      if (lookahead == '\\') ADVANCE(16);
      if (lookahead == '^') ADVANCE(235);
      if (lookahead == '{') ADVANCE(256);
      if (lookahead == '|') ADVANCE(234);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(65)
      END_STATE();
    case 66:
      if (lookahead == '!') ADVANCE(82);
      if (lookahead == '#') ADVANCE(103);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(336);
      if (lookahead == '%') ADVANCE(230);
      if (lookahead == '&') ADVANCE(239);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == '*') ADVANCE(226);
      if (lookahead == '+') ADVANCE(223);
      if (lookahead == ',') ADVANCE(147);
      if (lookahead == '-') ADVANCE(218);
      if (lookahead == '.') ADVANCE(278);
      if (lookahead == '/') ADVANCE(228);
      if (lookahead == '<') ADVANCE(246);
      if (lookahead == '=') ADVANCE(262);
      if (lookahead == '>') ADVANCE(242);
      if (lookahead == '?') ADVANCE(264);
      if (lookahead == '[') ADVANCE(258);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == ']') ADVANCE(260);
      if (lookahead == '^') ADVANCE(236);
      if (lookahead == '|') ADVANCE(233);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(66)
      END_STATE();
    case 67:
      if (lookahead == '"') ADVANCE(312);
      if (lookahead == '/') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(39);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(67)
      END_STATE();
    case 68:
      if (lookahead == '"') ADVANCE(312);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(336);
      if (lookahead == '/') ADVANCE(74);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == 'L') ADVANCE(325);
      if (lookahead == 'U') ADVANCE(327);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == 'u') ADVANCE(329);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(68)
      END_STATE();
    case 69:
      if (lookahead == '#') ADVANCE(112);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(336);
      if (lookahead == '/') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(35);
      if (lookahead == '}') ADVANCE(257);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(69)
      END_STATE();
    case 70:
      if (lookahead == '#') ADVANCE(96);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(336);
      if (lookahead == '/') ADVANCE(74);
      if (lookahead == '[') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(18);
      if (lookahead == '}') ADVANCE(257);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(70)
      END_STATE();
    case 71:
      if (lookahead == '#') ADVANCE(92);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(336);
      if (lookahead == '/') ADVANCE(74);
      if (lookahead == '[') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(20);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(71)
      END_STATE();
    case 72:
      if (lookahead == '\'') ADVANCE(303);
      if (lookahead == '/') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(39);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(72)
      END_STATE();
    case 73:
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == '/') ADVANCE(74);
      if (lookahead == '\\') SKIP(47)
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(73)
      END_STATE();
    case 74:
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '/') ADVANCE(341);
      END_STATE();
    case 75:
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '/') ADVANCE(337);
      if (lookahead != 0) ADVANCE(76);
      END_STATE();
    case 76:
      if (lookahead == '*') ADVANCE(75);
      if (lookahead != 0) ADVANCE(76);
      END_STATE();
    case 77:
      if (lookahead == '*') ADVANCE(75);
      if (lookahead != 0) ADVANCE(166);
      END_STATE();
    case 78:
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '0') ADVANCE(283);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(284);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(293);
      END_STATE();
    case 79:
      if (lookahead == '.') ADVANCE(146);
      END_STATE();
    case 80:
      if (lookahead == '/') ADVANCE(170);
      if (lookahead == '\\') ADVANCE(168);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(80)
      if (lookahead != 0) ADVANCE(171);
      END_STATE();
    case 81:
      if (lookahead == ':') ADVANCE(253);
      END_STATE();
    case 82:
      if (lookahead == '=') ADVANCE(241);
      END_STATE();
    case 83:
      if (lookahead == '=') ADVANCE(240);
      END_STATE();
    case 84:
      if (lookahead == '>') ADVANCE(322);
      if (lookahead == '\\') ADVANCE(85);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(84);
      END_STATE();
    case 85:
      if (lookahead == '>') ADVANCE(323);
      if (lookahead == '\\') ADVANCE(85);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(84);
      END_STATE();
    case 86:
      if (lookahead == 'U') ADVANCE(135);
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 87:
      if (lookahead == '[') ADVANCE(254);
      END_STATE();
    case 88:
      if (lookahead == ']') ADVANCE(255);
      END_STATE();
    case 89:
      if (lookahead == 'd') ADVANCE(182);
      if (lookahead == 'e') ADVANCE(204);
      if (lookahead == 'i') ADVANCE(190);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(89);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 90:
      if (lookahead == 'd') ADVANCE(182);
      if (lookahead == 'e') ADVANCE(204);
      if (lookahead == 'i') ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(90);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 91:
      if (lookahead == 'd') ADVANCE(182);
      if (lookahead == 'e') ADVANCE(207);
      if (lookahead == 'i') ADVANCE(190);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(91);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 92:
      if (lookahead == 'd') ADVANCE(182);
      if (lookahead == 'e') ADVANCE(207);
      if (lookahead == 'i') ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(92);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 93:
      if (lookahead == 'd') ADVANCE(182);
      if (lookahead == 'e') ADVANCE(206);
      if (lookahead == 'i') ADVANCE(190);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 94:
      if (lookahead == 'd') ADVANCE(182);
      if (lookahead == 'e') ADVANCE(206);
      if (lookahead == 'i') ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(94);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 95:
      if (lookahead == 'd') ADVANCE(182);
      if (lookahead == 'i') ADVANCE(190);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 96:
      if (lookahead == 'd') ADVANCE(182);
      if (lookahead == 'i') ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(96);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 97:
      if (lookahead == 'd') ADVANCE(110);
      END_STATE();
    case 98:
      if (lookahead == 'd') ADVANCE(102);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(113);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(99);
      END_STATE();
    case 100:
      if (lookahead == 'e') ADVANCE(155);
      END_STATE();
    case 101:
      if (lookahead == 'e') ADVANCE(106);
      END_STATE();
    case 102:
      if (lookahead == 'e') ADVANCE(107);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(103);
      END_STATE();
    case 104:
      if (lookahead == 'f') ADVANCE(158);
      END_STATE();
    case 105:
      if (lookahead == 'f') ADVANCE(151);
      END_STATE();
    case 106:
      if (lookahead == 'f') ADVANCE(161);
      END_STATE();
    case 107:
      if (lookahead == 'f') ADVANCE(163);
      END_STATE();
    case 108:
      if (lookahead == 'f') ADVANCE(157);
      END_STATE();
    case 109:
      if (lookahead == 'i') ADVANCE(104);
      if (lookahead == 's') ADVANCE(100);
      END_STATE();
    case 110:
      if (lookahead == 'i') ADVANCE(105);
      END_STATE();
    case 111:
      if (lookahead == 'i') ADVANCE(108);
      if (lookahead == 's') ADVANCE(100);
      END_STATE();
    case 112:
      if (lookahead == 'i') ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(112);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 113:
      if (lookahead == 'l') ADVANCE(109);
      if (lookahead == 'n') ADVANCE(97);
      END_STATE();
    case 114:
      if (lookahead == 'l') ADVANCE(111);
      if (lookahead == 'n') ADVANCE(97);
      END_STATE();
    case 115:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 116:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(282);
      END_STATE();
    case 117:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(284);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(293);
      END_STATE();
    case 118:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(336);
      END_STATE();
    case 119:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(290);
      END_STATE();
    case 120:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(293);
      END_STATE();
    case 121:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(288);
      END_STATE();
    case 122:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(318);
      END_STATE();
    case 123:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(118);
      END_STATE();
    case 124:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(122);
      END_STATE();
    case 125:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(123);
      END_STATE();
    case 126:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(124);
      END_STATE();
    case 127:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(125);
      END_STATE();
    case 128:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(126);
      END_STATE();
    case 129:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(127);
      END_STATE();
    case 130:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(128);
      END_STATE();
    case 131:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(129);
      END_STATE();
    case 132:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(130);
      END_STATE();
    case 133:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(131);
      END_STATE();
    case 134:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(132);
      END_STATE();
    case 135:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(133);
      END_STATE();
    case 136:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(134);
      END_STATE();
    case 137:
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '\\') ADVANCE(341);
      if (lookahead == '\r') ADVANCE(345);
      if (lookahead == '\\') ADVANCE(343);
      END_STATE();
    case 138:
      if (lookahead != 0 &&
          lookahead != '*') ADVANCE(171);
      END_STATE();
    case 139:
      if (eof) ADVANCE(141);
      if (lookahead == '!') ADVANCE(213);
      if (lookahead == '"') ADVANCE(312);
      if (lookahead == '#') ADVANCE(89);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(336);
      if (lookahead == '%') ADVANCE(230);
      if (lookahead == '&') ADVANCE(239);
      if (lookahead == '\'') ADVANCE(303);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == ')') ADVANCE(148);
      if (lookahead == '*') ADVANCE(226);
      if (lookahead == '+') ADVANCE(221);
      if (lookahead == ',') ADVANCE(147);
      if (lookahead == '-') ADVANCE(216);
      if (lookahead == '.') ADVANCE(279);
      if (lookahead == '/') ADVANCE(228);
      if (lookahead == '0') ADVANCE(285);
      if (lookahead == ':') ADVANCE(263);
      if (lookahead == ';') ADVANCE(252);
      if (lookahead == '<') ADVANCE(246);
      if (lookahead == '=') ADVANCE(262);
      if (lookahead == '>') ADVANCE(242);
      if (lookahead == '?') ADVANCE(264);
      if (lookahead == 'L') ADVANCE(324);
      if (lookahead == 'U') ADVANCE(326);
      if (lookahead == '[') ADVANCE(259);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == ']') ADVANCE(260);
      if (lookahead == '^') ADVANCE(236);
      if (lookahead == 'u') ADVANCE(328);
      if (lookahead == '{') ADVANCE(256);
      if (lookahead == '|') ADVANCE(233);
      if (lookahead == '}') ADVANCE(257);
      if (lookahead == '~') ADVANCE(214);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(139)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 140:
      if (eof) ADVANCE(141);
      if (lookahead == '!') ADVANCE(212);
      if (lookahead == '"') ADVANCE(312);
      if (lookahead == '#') ADVANCE(95);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(336);
      if (lookahead == '&') ADVANCE(237);
      if (lookahead == '\'') ADVANCE(303);
      if (lookahead == '(') ADVANCE(211);
      if (lookahead == ')') ADVANCE(148);
      if (lookahead == '*') ADVANCE(225);
      if (lookahead == '+') ADVANCE(222);
      if (lookahead == ',') ADVANCE(147);
      if (lookahead == '-') ADVANCE(217);
      if (lookahead == '.') ADVANCE(280);
      if (lookahead == '/') ADVANCE(74);
      if (lookahead == '0') ADVANCE(285);
      if (lookahead == ':') ADVANCE(263);
      if (lookahead == ';') ADVANCE(252);
      if (lookahead == '=') ADVANCE(261);
      if (lookahead == 'L') ADVANCE(324);
      if (lookahead == 'U') ADVANCE(326);
      if (lookahead == '[') ADVANCE(259);
      if (lookahead == '\\') ADVANCE(4);
      if (lookahead == ']') ADVANCE(260);
      if (lookahead == 'u') ADVANCE(328);
      if (lookahead == '{') ADVANCE(256);
      if (lookahead == '}') ADVANCE(257);
      if (lookahead == '~') ADVANCE(214);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(140)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(aux_sym_preproc_include_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(aux_sym_preproc_include_token2);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(aux_sym_preproc_def_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(aux_sym_preproc_if_token1);
      if (lookahead == 'd') ADVANCE(186);
      if (lookahead == 'n') ADVANCE(180);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(150);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(101);
      if (lookahead == 'n') ADVANCE(98);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(188);
      if (lookahead == 'n') ADVANCE(181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(76);
      if (lookahead == '*') ADVANCE(165);
      if (lookahead == '/') ADVANCE(337);
      if (lookahead == '\\') ADVANCE(172);
      if (lookahead != 0) ADVANCE(166);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(76);
      if (lookahead == '*') ADVANCE(165);
      if (lookahead == '/') ADVANCE(77);
      if (lookahead == '\\') ADVANCE(172);
      if (lookahead != 0) ADVANCE(166);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(341);
      if (lookahead == '\r') ADVANCE(338);
      if (lookahead == '/') ADVANCE(339);
      if (lookahead == '\\') ADVANCE(342);
      if (lookahead != 0) ADVANCE(340);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(80)
      if (lookahead == '\r') ADVANCE(169);
      if (lookahead == '/') ADVANCE(138);
      if (lookahead == '\\') ADVANCE(173);
      if (lookahead != 0) ADVANCE(171);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(80)
      if (lookahead == '/') ADVANCE(138);
      if (lookahead == '\\') ADVANCE(173);
      if (lookahead != 0) ADVANCE(171);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(166);
      if (lookahead == '/') ADVANCE(339);
      if (lookahead == '\\') ADVANCE(173);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(171);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(138);
      if (lookahead == '\\') ADVANCE(173);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(171);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '*' &&
          lookahead != '/' &&
          lookahead != '\\') ADVANCE(166);
      if (lookahead == '\r') ADVANCE(175);
      if (lookahead == '*') ADVANCE(165);
      if (lookahead == '/') ADVANCE(77);
      if (lookahead == '\\') ADVANCE(172);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '/' &&
          lookahead != '\\') ADVANCE(171);
      if (lookahead == '\r') ADVANCE(176);
      if (lookahead == '/') ADVANCE(138);
      if (lookahead == '\\') ADVANCE(173);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '/' &&
          lookahead != '\\') ADVANCE(340);
      if (lookahead == '\r') ADVANCE(344);
      if (lookahead == '/') ADVANCE(339);
      if (lookahead == '\\') ADVANCE(342);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '/' &&
          lookahead != '\\') ADVANCE(166);
      if (lookahead == '*') ADVANCE(165);
      if (lookahead == '/') ADVANCE(77);
      if (lookahead == '\\') ADVANCE(172);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '/' &&
          lookahead != '\\') ADVANCE(171);
      if (lookahead == '/') ADVANCE(138);
      if (lookahead == '\\') ADVANCE(173);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'c') ADVANCE(205);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(202);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(185);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(187);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(189);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(192);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(156);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(144);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(142);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(195);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(196);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(198);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(149);
      if (lookahead == 'n') ADVANCE(177);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(149);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(200);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(159);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(152);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(154);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(162);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(164);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(160);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(208);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(193);
      if (lookahead == 's') ADVANCE(183);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(194);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(199);
      if (lookahead == 's') ADVANCE(183);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(201);
      if (lookahead == 'n') ADVANCE(178);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(209);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(203);
      if (lookahead == 'n') ADVANCE(178);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(178);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(184);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'u') ADVANCE(179);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(210);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(241);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(275);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '0') ADVANCE(285);
      if (lookahead == '=') ADVANCE(269);
      if (lookahead == '>') ADVANCE(281);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(275);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '0') ADVANCE(285);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(275);
      if (lookahead == '=') ADVANCE(269);
      if (lookahead == '>') ADVANCE(281);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '0') ADVANCE(285);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(276);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '0') ADVANCE(285);
      if (lookahead == '=') ADVANCE(268);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(276);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '0') ADVANCE(285);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(276);
      if (lookahead == '=') ADVANCE(268);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '0') ADVANCE(285);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(265);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '/') ADVANCE(341);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '/') ADVANCE(341);
      if (lookahead == '=') ADVANCE(266);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(267);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(274);
      if (lookahead == '|') ADVANCE(231);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(231);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(273);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(232);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(232);
      if (lookahead == '=') ADVANCE(272);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(244);
      if (lookahead == '>') ADVANCE(251);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(244);
      if (lookahead == '>') ADVANCE(250);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(249);
      if (lookahead == '=') ADVANCE(245);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(248);
      if (lookahead == '=') ADVANCE(245);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(270);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(271);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(254);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(240);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(79);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(282);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(282);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(116);
      if (lookahead == 'E' ||
          lookahead == 'P' ||
          lookahead == 'e' ||
          lookahead == 'p') ADVANCE(295);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(282);
      if (sym_number_literal_character_set_1(lookahead)) ADVANCE(298);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(117);
      if (lookahead == '.') ADVANCE(296);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(292);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(291);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(295);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(120);
      if (('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(293);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(293);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(284);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(117);
      if (lookahead == '.') ADVANCE(296);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(291);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(295);
      if (lookahead == 'A' ||
          lookahead == 'C' ||
          lookahead == 'a' ||
          lookahead == 'c') ADVANCE(293);
      if (('B' <= lookahead && lookahead <= 'F') ||
          ('b' <= lookahead && lookahead <= 'f')) ADVANCE(293);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(284);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(115);
      if (lookahead == '.') ADVANCE(296);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(294);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(78);
      if (lookahead == 'E' ||
          lookahead == 'P' ||
          lookahead == 'e' ||
          lookahead == 'p') ADVANCE(295);
      if (('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          ('d' <= lookahead && lookahead <= 'f') ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(115);
      if (lookahead == '.') ADVANCE(296);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(297);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(120);
      if (lookahead == 'E' ||
          lookahead == 'P' ||
          lookahead == 'e' ||
          lookahead == 'p') ADVANCE(295);
      if (('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          ('d' <= lookahead && lookahead <= 'f') ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(115);
      if (lookahead == '.') ADVANCE(296);
      if (lookahead == 'E' ||
          lookahead == 'P' ||
          lookahead == 'e' ||
          lookahead == 'p') ADVANCE(295);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(287);
      if (sym_number_literal_character_set_1(lookahead)) ADVANCE(298);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(121);
      if (lookahead == 'B' ||
          lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(288);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'E') ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(288);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(119);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(121);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(289);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(295);
      if (lookahead == 'B' ||
          ('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'b' ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(290);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(290);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(119);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(289);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(295);
      if (lookahead == 'B' ||
          ('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'b' ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(290);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(290);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(120);
      if (lookahead == '.') ADVANCE(296);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(121);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(291);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(295);
      if (lookahead == 'B' ||
          ('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'b' ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(293);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(293);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(120);
      if (lookahead == '.') ADVANCE(296);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(291);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(295);
      if (lookahead == 'A' ||
          lookahead == 'C' ||
          lookahead == 'a' ||
          lookahead == 'c') ADVANCE(293);
      if (('B' <= lookahead && lookahead <= 'F') ||
          ('b' <= lookahead && lookahead <= 'f')) ADVANCE(293);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(284);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(120);
      if (lookahead == '.') ADVANCE(296);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(291);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(295);
      if (lookahead == 'B' ||
          ('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'b' ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(293);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(293);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '0') ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(287);
      if (sym_number_literal_character_set_2(lookahead)) ADVANCE(298);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(121);
      if (lookahead == 'B' ||
          lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'b' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(288);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'E') ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(288);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(289);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(295);
      if (lookahead == 'B' ||
          ('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'b' ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(290);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'W' ||
          lookahead == 'l' ||
          lookahead == 'u' ||
          lookahead == 'w') ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(290);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(sym_number_literal);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(287);
      if (sym_number_literal_character_set_2(lookahead)) ADVANCE(298);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(sym_number_literal);
      if (sym_number_literal_character_set_2(lookahead)) ADVANCE(298);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_L_SQUOTE);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_u_SQUOTE);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_U_SQUOTE);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_u8_SQUOTE);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\n') ADVANCE(319);
      if (lookahead == '\r') ADVANCE(318);
      if (lookahead == 'U') ADVANCE(136);
      if (lookahead == 'u') ADVANCE(128);
      if (lookahead == 'x') ADVANCE(124);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(321);
      if (lookahead != 0) ADVANCE(318);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '/') ADVANCE(341);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\\') ADVANCE(39);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_L_DQUOTE);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_u_DQUOTE);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_U_DQUOTE);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_u8_DQUOTE);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(315);
      if (lookahead == '/') ADVANCE(317);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(317);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(314);
      if (lookahead == '/') ADVANCE(317);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(315);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(314);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(315);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '/') ADVANCE(313);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(316);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(317);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(317);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(39);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(318);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(320);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(sym_system_lib_string);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(sym_system_lib_string);
      if (lookahead == '>') ADVANCE(322);
      if (lookahead == '\\') ADVANCE(85);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(84);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(308);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(336);
      if (lookahead == '\'') ADVANCE(299);
      if (lookahead == '\\') ADVANCE(86);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(308);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(336);
      if (lookahead == '\\') ADVANCE(86);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(310);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(336);
      if (lookahead == '\'') ADVANCE(301);
      if (lookahead == '\\') ADVANCE(86);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(310);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(336);
      if (lookahead == '\\') ADVANCE(86);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(309);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(336);
      if (lookahead == '\'') ADVANCE(300);
      if (lookahead == '8') ADVANCE(330);
      if (lookahead == '\\') ADVANCE(86);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(309);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(336);
      if (lookahead == '8') ADVANCE(331);
      if (lookahead == '\\') ADVANCE(86);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(311);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(336);
      if (lookahead == '\'') ADVANCE(302);
      if (lookahead == '\\') ADVANCE(86);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(311);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(336);
      if (lookahead == '\\') ADVANCE(86);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(336);
      if (lookahead == '\'') ADVANCE(300);
      if (lookahead == '8') ADVANCE(335);
      if (lookahead == '\\') ADVANCE(86);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(336);
      if (lookahead == '\'') ADVANCE(299);
      if (lookahead == '\\') ADVANCE(86);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(336);
      if (lookahead == '\'') ADVANCE(301);
      if (lookahead == '\\') ADVANCE(86);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(336);
      if (lookahead == '\'') ADVANCE(302);
      if (lookahead == '\\') ADVANCE(86);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(336);
      if (lookahead == '\\') ADVANCE(86);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(341);
      if (lookahead == '/') ADVANCE(339);
      if (lookahead == '\\') ADVANCE(174);
      if (lookahead != 0) ADVANCE(340);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '*') ADVANCE(341);
      if (lookahead == '\\') ADVANCE(167);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(340);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(339);
      if (lookahead == '\\') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(340);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(341);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '/' &&
          lookahead != '\\') ADVANCE(340);
      if (lookahead == '\r') ADVANCE(344);
      if (lookahead == '/') ADVANCE(339);
      if (lookahead == '\\') ADVANCE(342);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '\\') ADVANCE(341);
      if (lookahead == '\r') ADVANCE(345);
      if (lookahead == '\\') ADVANCE(343);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '/' &&
          lookahead != '\\') ADVANCE(340);
      if (lookahead == '/') ADVANCE(339);
      if (lookahead == '\\') ADVANCE(174);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\\') ADVANCE(341);
      if (lookahead == '\\') ADVANCE(137);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'F') ADVANCE(1);
      if (lookahead == 'N') ADVANCE(2);
      if (lookahead == 'T') ADVANCE(3);
      if (lookahead == '\\') SKIP(4)
      if (lookahead == '_') ADVANCE(5);
      if (lookahead == 'a') ADVANCE(6);
      if (lookahead == 'b') ADVANCE(7);
      if (lookahead == 'c') ADVANCE(8);
      if (lookahead == 'd') ADVANCE(9);
      if (lookahead == 'e') ADVANCE(10);
      if (lookahead == 'f') ADVANCE(11);
      if (lookahead == 'g') ADVANCE(12);
      if (lookahead == 'i') ADVANCE(13);
      if (lookahead == 'l') ADVANCE(14);
      if (lookahead == 'm') ADVANCE(15);
      if (lookahead == 'n') ADVANCE(16);
      if (lookahead == 'o') ADVANCE(17);
      if (lookahead == 'p') ADVANCE(18);
      if (lookahead == 'r') ADVANCE(19);
      if (lookahead == 's') ADVANCE(20);
      if (lookahead == 't') ADVANCE(21);
      if (lookahead == 'u') ADVANCE(22);
      if (lookahead == 'v') ADVANCE(23);
      if (lookahead == 'w') ADVANCE(24);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'A') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'U') ADVANCE(26);
      END_STATE();
    case 3:
      if (lookahead == 'R') ADVANCE(27);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(0)
      if (lookahead == '\r') SKIP(28)
      END_STATE();
    case 5:
      if (lookahead == 'A') ADVANCE(29);
      if (lookahead == 'G') ADVANCE(30);
      if (lookahead == 'N') ADVANCE(31);
      if (lookahead == '_') ADVANCE(32);
      if (lookahead == 'a') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(34);
      END_STATE();
    case 6:
      if (lookahead == 'l') ADVANCE(35);
      if (lookahead == 's') ADVANCE(36);
      if (lookahead == 'u') ADVANCE(37);
      END_STATE();
    case 7:
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(40);
      if (lookahead == 'h') ADVANCE(41);
      if (lookahead == 'o') ADVANCE(42);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(43);
      if (lookahead == 'o') ADVANCE(44);
      END_STATE();
    case 10:
      if (lookahead == 'l') ADVANCE(45);
      if (lookahead == 'n') ADVANCE(46);
      if (lookahead == 'x') ADVANCE(47);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(48);
      if (lookahead == 'l') ADVANCE(49);
      if (lookahead == 'o') ADVANCE(50);
      END_STATE();
    case 12:
      if (lookahead == 'o') ADVANCE(51);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(52);
      if (lookahead == 'n') ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'o') ADVANCE(54);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(55);
      END_STATE();
    case 16:
      if (lookahead == 'o') ADVANCE(56);
      if (lookahead == 'u') ADVANCE(57);
      END_STATE();
    case 17:
      if (lookahead == 'f') ADVANCE(58);
      END_STATE();
    case 18:
      if (lookahead == 't') ADVANCE(59);
      END_STATE();
    case 19:
      if (lookahead == 'e') ADVANCE(60);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(61);
      if (lookahead == 'i') ADVANCE(62);
      if (lookahead == 's') ADVANCE(63);
      if (lookahead == 't') ADVANCE(64);
      if (lookahead == 'w') ADVANCE(65);
      END_STATE();
    case 21:
      if (lookahead == 'h') ADVANCE(66);
      if (lookahead == 'r') ADVANCE(67);
      if (lookahead == 'y') ADVANCE(68);
      END_STATE();
    case 22:
      if (lookahead == 'i') ADVANCE(69);
      if (lookahead == 'n') ADVANCE(70);
      END_STATE();
    case 23:
      if (lookahead == 'o') ADVANCE(71);
      END_STATE();
    case 24:
      if (lookahead == 'h') ADVANCE(72);
      END_STATE();
    case 25:
      if (lookahead == 'L') ADVANCE(73);
      END_STATE();
    case 26:
      if (lookahead == 'L') ADVANCE(74);
      END_STATE();
    case 27:
      if (lookahead == 'U') ADVANCE(75);
      END_STATE();
    case 28:
      if (lookahead == '\n') SKIP(0)
      END_STATE();
    case 29:
      if (lookahead == 'l') ADVANCE(76);
      if (lookahead == 't') ADVANCE(77);
      END_STATE();
    case 30:
      if (lookahead == 'e') ADVANCE(78);
      END_STATE();
    case 31:
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 32:
      if (lookahead == 'a') ADVANCE(80);
      if (lookahead == 'b') ADVANCE(81);
      if (lookahead == 'c') ADVANCE(82);
      if (lookahead == 'd') ADVANCE(83);
      if (lookahead == 'e') ADVANCE(84);
      if (lookahead == 'f') ADVANCE(85);
      if (lookahead == 'i') ADVANCE(86);
      if (lookahead == 'l') ADVANCE(87);
      if (lookahead == 'r') ADVANCE(88);
      if (lookahead == 's') ADVANCE(89);
      if (lookahead == 't') ADVANCE(90);
      if (lookahead == 'u') ADVANCE(91);
      if (lookahead == 'v') ADVANCE(92);
      END_STATE();
    case 33:
      if (lookahead == 'l') ADVANCE(93);
      END_STATE();
    case 34:
      if (lookahead == 'n') ADVANCE(94);
      END_STATE();
    case 35:
      if (lookahead == 'i') ADVANCE(95);
      END_STATE();
    case 36:
      if (lookahead == 'm') ADVANCE(96);
      END_STATE();
    case 37:
      if (lookahead == 't') ADVANCE(97);
      END_STATE();
    case 38:
      if (lookahead == 'o') ADVANCE(98);
      END_STATE();
    case 39:
      if (lookahead == 'e') ADVANCE(99);
      END_STATE();
    case 40:
      if (lookahead == 's') ADVANCE(100);
      END_STATE();
    case 41:
      if (lookahead == 'a') ADVANCE(101);
      END_STATE();
    case 42:
      if (lookahead == 'n') ADVANCE(102);
      END_STATE();
    case 43:
      if (lookahead == 'f') ADVANCE(103);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u') ADVANCE(104);
      END_STATE();
    case 45:
      if (lookahead == 's') ADVANCE(105);
      END_STATE();
    case 46:
      if (lookahead == 'u') ADVANCE(106);
      END_STATE();
    case 47:
      if (lookahead == 't') ADVANCE(107);
      END_STATE();
    case 48:
      if (lookahead == 'l') ADVANCE(108);
      END_STATE();
    case 49:
      if (lookahead == 'o') ADVANCE(109);
      END_STATE();
    case 50:
      if (lookahead == 'r') ADVANCE(110);
      END_STATE();
    case 51:
      if (lookahead == 't') ADVANCE(111);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 53:
      if (lookahead == 'l') ADVANCE(112);
      if (lookahead == 't') ADVANCE(113);
      END_STATE();
    case 54:
      if (lookahead == 'n') ADVANCE(114);
      END_STATE();
    case 55:
      if (lookahead == 'x') ADVANCE(115);
      END_STATE();
    case 56:
      if (lookahead == 'r') ADVANCE(116);
      END_STATE();
    case 57:
      if (lookahead == 'l') ADVANCE(117);
      END_STATE();
    case 58:
      if (lookahead == 'f') ADVANCE(118);
      END_STATE();
    case 59:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 60:
      if (lookahead == 'g') ADVANCE(120);
      if (lookahead == 's') ADVANCE(121);
      if (lookahead == 't') ADVANCE(122);
      END_STATE();
    case 61:
      if (lookahead == 'o') ADVANCE(123);
      END_STATE();
    case 62:
      if (lookahead == 'g') ADVANCE(124);
      if (lookahead == 'z') ADVANCE(125);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(126);
      END_STATE();
    case 64:
      if (lookahead == 'a') ADVANCE(127);
      if (lookahead == 'r') ADVANCE(128);
      END_STATE();
    case 65:
      if (lookahead == 'i') ADVANCE(129);
      END_STATE();
    case 66:
      if (lookahead == 'r') ADVANCE(130);
      END_STATE();
    case 67:
      if (lookahead == 'u') ADVANCE(131);
      END_STATE();
    case 68:
      if (lookahead == 'p') ADVANCE(132);
      END_STATE();
    case 69:
      if (lookahead == 'n') ADVANCE(133);
      END_STATE();
    case 70:
      if (lookahead == 'i') ADVANCE(134);
      if (lookahead == 's') ADVANCE(135);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(136);
      if (lookahead == 'l') ADVANCE(137);
      END_STATE();
    case 72:
      if (lookahead == 'i') ADVANCE(138);
      END_STATE();
    case 73:
      if (lookahead == 'S') ADVANCE(139);
      END_STATE();
    case 74:
      if (lookahead == 'L') ADVANCE(140);
      END_STATE();
    case 75:
      if (lookahead == 'E') ADVANCE(141);
      END_STATE();
    case 76:
      if (lookahead == 'i') ADVANCE(142);
      END_STATE();
    case 77:
      if (lookahead == 'o') ADVANCE(143);
      END_STATE();
    case 78:
      if (lookahead == 'n') ADVANCE(144);
      END_STATE();
    case 79:
      if (lookahead == 'r') ADVANCE(145);
      END_STATE();
    case 80:
      if (lookahead == 'l') ADVANCE(146);
      if (lookahead == 's') ADVANCE(147);
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 81:
      if (lookahead == 'a') ADVANCE(149);
      END_STATE();
    case 82:
      if (lookahead == 'd') ADVANCE(150);
      if (lookahead == 'l') ADVANCE(151);
      END_STATE();
    case 83:
      if (lookahead == 'e') ADVANCE(152);
      END_STATE();
    case 84:
      if (lookahead == 'x') ADVANCE(153);
      END_STATE();
    case 85:
      if (lookahead == 'a') ADVANCE(154);
      if (lookahead == 'i') ADVANCE(155);
      if (lookahead == 'o') ADVANCE(156);
      END_STATE();
    case 86:
      if (lookahead == 'n') ADVANCE(157);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(158);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(159);
      END_STATE();
    case 89:
      if (lookahead == 'p') ADVANCE(160);
      if (lookahead == 't') ADVANCE(161);
      END_STATE();
    case 90:
      if (lookahead == 'h') ADVANCE(162);
      if (lookahead == 'r') ADVANCE(163);
      END_STATE();
    case 91:
      if (lookahead == 'n') ADVANCE(164);
      if (lookahead == 'p') ADVANCE(165);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(166);
      END_STATE();
    case 93:
      if (lookahead == 'i') ADVANCE(167);
      END_STATE();
    case 94:
      if (lookahead == 'a') ADVANCE(168);
      END_STATE();
    case 95:
      if (lookahead == 'g') ADVANCE(169);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_asm);
      END_STATE();
    case 97:
      if (lookahead == 'o') ADVANCE(170);
      END_STATE();
    case 98:
      if (lookahead == 'l') ADVANCE(171);
      END_STATE();
    case 99:
      if (lookahead == 'a') ADVANCE(172);
      END_STATE();
    case 100:
      if (lookahead == 'e') ADVANCE(173);
      END_STATE();
    case 101:
      if (lookahead == 'r') ADVANCE(174);
      END_STATE();
    case 102:
      if (lookahead == 's') ADVANCE(175);
      if (lookahead == 't') ADVANCE(176);
      END_STATE();
    case 103:
      if (lookahead == 'a') ADVANCE(177);
      if (lookahead == 'i') ADVANCE(178);
      END_STATE();
    case 104:
      if (lookahead == 'b') ADVANCE(179);
      END_STATE();
    case 105:
      if (lookahead == 'e') ADVANCE(180);
      END_STATE();
    case 106:
      if (lookahead == 'm') ADVANCE(181);
      END_STATE();
    case 107:
      if (lookahead == 'e') ADVANCE(182);
      END_STATE();
    case 108:
      if (lookahead == 's') ADVANCE(183);
      END_STATE();
    case 109:
      if (lookahead == 'a') ADVANCE(184);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 111:
      if (lookahead == 'o') ADVANCE(185);
      END_STATE();
    case 112:
      if (lookahead == 'i') ADVANCE(186);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '1') ADVANCE(187);
      if (lookahead == '3') ADVANCE(188);
      if (lookahead == '6') ADVANCE(189);
      if (lookahead == '8') ADVANCE(190);
      if (lookahead == 'p') ADVANCE(191);
      END_STATE();
    case 114:
      if (lookahead == 'g') ADVANCE(192);
      END_STATE();
    case 115:
      if (lookahead == '_') ADVANCE(193);
      END_STATE();
    case 116:
      if (lookahead == 'e') ADVANCE(194);
      END_STATE();
    case 117:
      if (lookahead == 'l') ADVANCE(195);
      END_STATE();
    case 118:
      if (lookahead == 's') ADVANCE(196);
      END_STATE();
    case 119:
      if (lookahead == 'd') ADVANCE(197);
      END_STATE();
    case 120:
      if (lookahead == 'i') ADVANCE(198);
      END_STATE();
    case 121:
      if (lookahead == 't') ADVANCE(199);
      END_STATE();
    case 122:
      if (lookahead == 'u') ADVANCE(200);
      END_STATE();
    case 123:
      if (lookahead == 'r') ADVANCE(201);
      END_STATE();
    case 124:
      if (lookahead == 'n') ADVANCE(202);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(203);
      END_STATE();
    case 126:
      if (lookahead == 'z') ADVANCE(204);
      END_STATE();
    case 127:
      if (lookahead == 't') ADVANCE(205);
      END_STATE();
    case 128:
      if (lookahead == 'u') ADVANCE(206);
      END_STATE();
    case 129:
      if (lookahead == 't') ADVANCE(207);
      END_STATE();
    case 130:
      if (lookahead == 'e') ADVANCE(208);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(141);
      END_STATE();
    case 132:
      if (lookahead == 'e') ADVANCE(209);
      END_STATE();
    case 133:
      if (lookahead == 't') ADVANCE(210);
      END_STATE();
    case 134:
      if (lookahead == 'o') ADVANCE(211);
      END_STATE();
    case 135:
      if (lookahead == 'i') ADVANCE(212);
      END_STATE();
    case 136:
      if (lookahead == 'd') ADVANCE(171);
      END_STATE();
    case 137:
      if (lookahead == 'a') ADVANCE(213);
      END_STATE();
    case 138:
      if (lookahead == 'l') ADVANCE(214);
      END_STATE();
    case 139:
      if (lookahead == 'E') ADVANCE(215);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_NULL);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 142:
      if (lookahead == 'g') ADVANCE(216);
      END_STATE();
    case 143:
      if (lookahead == 'm') ADVANCE(217);
      END_STATE();
    case 144:
      if (lookahead == 'e') ADVANCE(218);
      END_STATE();
    case 145:
      if (lookahead == 'e') ADVANCE(219);
      END_STATE();
    case 146:
      if (lookahead == 'i') ADVANCE(220);
      END_STATE();
    case 147:
      if (lookahead == 'm') ADVANCE(221);
      END_STATE();
    case 148:
      if (lookahead == 't') ADVANCE(222);
      END_STATE();
    case 149:
      if (lookahead == 's') ADVANCE(223);
      END_STATE();
    case 150:
      if (lookahead == 'e') ADVANCE(224);
      END_STATE();
    case 151:
      if (lookahead == 'r') ADVANCE(225);
      END_STATE();
    case 152:
      if (lookahead == 'c') ADVANCE(226);
      END_STATE();
    case 153:
      if (lookahead == 'c') ADVANCE(227);
      if (lookahead == 't') ADVANCE(228);
      END_STATE();
    case 154:
      if (lookahead == 's') ADVANCE(229);
      END_STATE();
    case 155:
      if (lookahead == 'n') ADVANCE(230);
      END_STATE();
    case 156:
      if (lookahead == 'r') ADVANCE(231);
      END_STATE();
    case 157:
      if (lookahead == 'l') ADVANCE(232);
      END_STATE();
    case 158:
      if (lookahead == 'a') ADVANCE(233);
      END_STATE();
    case 159:
      if (lookahead == 's') ADVANCE(234);
      END_STATE();
    case 160:
      if (lookahead == 't') ADVANCE(235);
      END_STATE();
    case 161:
      if (lookahead == 'd') ADVANCE(236);
      END_STATE();
    case 162:
      if (lookahead == 'i') ADVANCE(237);
      if (lookahead == 'r') ADVANCE(238);
      END_STATE();
    case 163:
      if (lookahead == 'y') ADVANCE(239);
      END_STATE();
    case 164:
      if (lookahead == 'a') ADVANCE(240);
      END_STATE();
    case 165:
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 166:
      if (lookahead == 'c') ADVANCE(242);
      END_STATE();
    case 167:
      if (lookahead == 'g') ADVANCE(243);
      END_STATE();
    case 168:
      if (lookahead == 'l') ADVANCE(244);
      END_STATE();
    case 169:
      if (lookahead == 'n') ADVANCE(245);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_auto);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_primitive_type);
      END_STATE();
    case 172:
      if (lookahead == 'k') ADVANCE(246);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '1') ADVANCE(247);
      if (lookahead == '3') ADVANCE(248);
      if (lookahead == '6') ADVANCE(249);
      if (lookahead == '8') ADVANCE(250);
      if (lookahead == 'p') ADVANCE(251);
      END_STATE();
    case 175:
      if (lookahead == 't') ADVANCE(252);
      END_STATE();
    case 176:
      if (lookahead == 'i') ADVANCE(253);
      END_STATE();
    case 177:
      if (lookahead == 'u') ADVANCE(254);
      END_STATE();
    case 178:
      if (lookahead == 'n') ADVANCE(255);
      END_STATE();
    case 179:
      if (lookahead == 'l') ADVANCE(256);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 182:
      if (lookahead == 'r') ADVANCE(257);
      END_STATE();
    case 183:
      if (lookahead == 'e') ADVANCE(215);
      END_STATE();
    case 184:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 186:
      if (lookahead == 'n') ADVANCE(258);
      END_STATE();
    case 187:
      if (lookahead == '6') ADVANCE(259);
      END_STATE();
    case 188:
      if (lookahead == '2') ADVANCE(260);
      END_STATE();
    case 189:
      if (lookahead == '4') ADVANCE(261);
      END_STATE();
    case 190:
      if (lookahead == '_') ADVANCE(262);
      END_STATE();
    case 191:
      if (lookahead == 't') ADVANCE(263);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 193:
      if (lookahead == 'a') ADVANCE(264);
      END_STATE();
    case 194:
      if (lookahead == 't') ADVANCE(265);
      END_STATE();
    case 195:
      if (lookahead == 'p') ADVANCE(266);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(267);
      END_STATE();
    case 197:
      if (lookahead == 'i') ADVANCE(268);
      END_STATE();
    case 198:
      if (lookahead == 's') ADVANCE(269);
      END_STATE();
    case 199:
      if (lookahead == 'r') ADVANCE(270);
      END_STATE();
    case 200:
      if (lookahead == 'r') ADVANCE(271);
      END_STATE();
    case 201:
      if (lookahead == 't') ADVANCE(272);
      END_STATE();
    case 202:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 203:
      if (lookahead == '_') ADVANCE(274);
      if (lookahead == 'o') ADVANCE(275);
      END_STATE();
    case 204:
      if (lookahead == 'e') ADVANCE(276);
      END_STATE();
    case 205:
      if (lookahead == 'i') ADVANCE(277);
      END_STATE();
    case 206:
      if (lookahead == 'c') ADVANCE(278);
      END_STATE();
    case 207:
      if (lookahead == 'c') ADVANCE(279);
      END_STATE();
    case 208:
      if (lookahead == 'a') ADVANCE(280);
      END_STATE();
    case 209:
      if (lookahead == 'd') ADVANCE(281);
      END_STATE();
    case 210:
      if (lookahead == '1') ADVANCE(282);
      if (lookahead == '3') ADVANCE(283);
      if (lookahead == '6') ADVANCE(284);
      if (lookahead == '8') ADVANCE(285);
      if (lookahead == 'p') ADVANCE(286);
      END_STATE();
    case 211:
      if (lookahead == 'n') ADVANCE(287);
      END_STATE();
    case 212:
      if (lookahead == 'g') ADVANCE(288);
      END_STATE();
    case 213:
      if (lookahead == 't') ADVANCE(289);
      END_STATE();
    case 214:
      if (lookahead == 'e') ADVANCE(290);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 216:
      if (lookahead == 'n') ADVANCE(291);
      END_STATE();
    case 217:
      if (lookahead == 'i') ADVANCE(292);
      END_STATE();
    case 218:
      if (lookahead == 'r') ADVANCE(293);
      END_STATE();
    case 219:
      if (lookahead == 't') ADVANCE(294);
      END_STATE();
    case 220:
      if (lookahead == 'g') ADVANCE(295);
      END_STATE();
    case 221:
      if (lookahead == '_') ADVANCE(296);
      END_STATE();
    case 222:
      if (lookahead == 'r') ADVANCE(297);
      END_STATE();
    case 223:
      if (lookahead == 'e') ADVANCE(298);
      END_STATE();
    case 224:
      if (lookahead == 'c') ADVANCE(299);
      END_STATE();
    case 225:
      if (lookahead == 'c') ADVANCE(300);
      END_STATE();
    case 226:
      if (lookahead == 'l') ADVANCE(301);
      END_STATE();
    case 227:
      if (lookahead == 'e') ADVANCE(302);
      END_STATE();
    case 228:
      if (lookahead == 'e') ADVANCE(303);
      END_STATE();
    case 229:
      if (lookahead == 't') ADVANCE(304);
      END_STATE();
    case 230:
      if (lookahead == 'a') ADVANCE(305);
      END_STATE();
    case 231:
      if (lookahead == 'c') ADVANCE(306);
      END_STATE();
    case 232:
      if (lookahead == 'i') ADVANCE(307);
      END_STATE();
    case 233:
      if (lookahead == 'v') ADVANCE(308);
      END_STATE();
    case 234:
      if (lookahead == 't') ADVANCE(309);
      END_STATE();
    case 235:
      if (lookahead == 'r') ADVANCE(310);
      END_STATE();
    case 236:
      if (lookahead == 'c') ADVANCE(311);
      END_STATE();
    case 237:
      if (lookahead == 's') ADVANCE(312);
      END_STATE();
    case 238:
      if (lookahead == 'e') ADVANCE(313);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym___try);
      END_STATE();
    case 240:
      if (lookahead == 'l') ADVANCE(314);
      END_STATE();
    case 241:
      if (lookahead == 'r') ADVANCE(315);
      END_STATE();
    case 242:
      if (lookahead == 't') ADVANCE(316);
      END_STATE();
    case 243:
      if (lookahead == 'n') ADVANCE(317);
      END_STATE();
    case 244:
      if (lookahead == 'i') ADVANCE(318);
      END_STATE();
    case 245:
      if (lookahead == 'o') ADVANCE(319);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 247:
      if (lookahead == '6') ADVANCE(320);
      END_STATE();
    case 248:
      if (lookahead == '2') ADVANCE(321);
      END_STATE();
    case 249:
      if (lookahead == '4') ADVANCE(322);
      END_STATE();
    case 250:
      if (lookahead == '_') ADVANCE(323);
      END_STATE();
    case 251:
      if (lookahead == 't') ADVANCE(324);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == 'e') ADVANCE(325);
      END_STATE();
    case 253:
      if (lookahead == 'n') ADVANCE(326);
      END_STATE();
    case 254:
      if (lookahead == 'l') ADVANCE(327);
      END_STATE();
    case 255:
      if (lookahead == 'e') ADVANCE(328);
      END_STATE();
    case 256:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 257:
      if (lookahead == 'n') ADVANCE(329);
      END_STATE();
    case 258:
      if (lookahead == 'e') ADVANCE(330);
      END_STATE();
    case 259:
      if (lookahead == '_') ADVANCE(331);
      END_STATE();
    case 260:
      if (lookahead == '_') ADVANCE(332);
      END_STATE();
    case 261:
      if (lookahead == '_') ADVANCE(333);
      END_STATE();
    case 262:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 263:
      if (lookahead == 'r') ADVANCE(334);
      END_STATE();
    case 264:
      if (lookahead == 'l') ADVANCE(335);
      END_STATE();
    case 265:
      if (lookahead == 'u') ADVANCE(336);
      END_STATE();
    case 266:
      if (lookahead == 't') ADVANCE(337);
      END_STATE();
    case 267:
      if (lookahead == 't') ADVANCE(338);
      END_STATE();
    case 268:
      if (lookahead == 'f') ADVANCE(339);
      END_STATE();
    case 269:
      if (lookahead == 't') ADVANCE(340);
      END_STATE();
    case 270:
      if (lookahead == 'i') ADVANCE(341);
      END_STATE();
    case 271:
      if (lookahead == 'n') ADVANCE(342);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 273:
      if (lookahead == 'd') ADVANCE(343);
      END_STATE();
    case 274:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 275:
      if (lookahead == 'f') ADVANCE(344);
      END_STATE();
    case 276:
      if (lookahead == '_') ADVANCE(345);
      END_STATE();
    case 277:
      if (lookahead == 'c') ADVANCE(346);
      END_STATE();
    case 278:
      if (lookahead == 't') ADVANCE(347);
      END_STATE();
    case 279:
      if (lookahead == 'h') ADVANCE(348);
      END_STATE();
    case 280:
      if (lookahead == 'd') ADVANCE(349);
      END_STATE();
    case 281:
      if (lookahead == 'e') ADVANCE(350);
      END_STATE();
    case 282:
      if (lookahead == '6') ADVANCE(351);
      END_STATE();
    case 283:
      if (lookahead == '2') ADVANCE(352);
      END_STATE();
    case 284:
      if (lookahead == '4') ADVANCE(353);
      END_STATE();
    case 285:
      if (lookahead == '_') ADVANCE(354);
      END_STATE();
    case 286:
      if (lookahead == 't') ADVANCE(355);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 288:
      if (lookahead == 'n') ADVANCE(356);
      END_STATE();
    case 289:
      if (lookahead == 'i') ADVANCE(357);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 291:
      if (lookahead == 'o') ADVANCE(358);
      END_STATE();
    case 292:
      if (lookahead == 'c') ADVANCE(359);
      END_STATE();
    case 293:
      if (lookahead == 'i') ADVANCE(360);
      END_STATE();
    case 294:
      if (lookahead == 'u') ADVANCE(361);
      END_STATE();
    case 295:
      if (lookahead == 'n') ADVANCE(362);
      END_STATE();
    case 296:
      if (lookahead == '_') ADVANCE(363);
      END_STATE();
    case 297:
      if (lookahead == 'i') ADVANCE(364);
      END_STATE();
    case 298:
      if (lookahead == 'd') ADVANCE(365);
      END_STATE();
    case 299:
      if (lookahead == 'l') ADVANCE(366);
      END_STATE();
    case 300:
      if (lookahead == 'a') ADVANCE(367);
      END_STATE();
    case 301:
      if (lookahead == 's') ADVANCE(368);
      END_STATE();
    case 302:
      if (lookahead == 'p') ADVANCE(369);
      END_STATE();
    case 303:
      if (lookahead == 'n') ADVANCE(370);
      END_STATE();
    case 304:
      if (lookahead == 'c') ADVANCE(371);
      END_STATE();
    case 305:
      if (lookahead == 'l') ADVANCE(372);
      END_STATE();
    case 306:
      if (lookahead == 'e') ADVANCE(373);
      END_STATE();
    case 307:
      if (lookahead == 'n') ADVANCE(374);
      END_STATE();
    case 308:
      if (lookahead == 'e') ADVANCE(375);
      END_STATE();
    case 309:
      if (lookahead == 'r') ADVANCE(376);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(sym_ms_signed_ptr_modifier);
      END_STATE();
    case 311:
      if (lookahead == 'a') ADVANCE(377);
      END_STATE();
    case 312:
      if (lookahead == 'c') ADVANCE(378);
      END_STATE();
    case 313:
      if (lookahead == 'a') ADVANCE(379);
      END_STATE();
    case 314:
      if (lookahead == 'i') ADVANCE(380);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(sym_ms_unsigned_ptr_modifier);
      END_STATE();
    case 316:
      if (lookahead == 'o') ADVANCE(381);
      END_STATE();
    case 317:
      if (lookahead == 'o') ADVANCE(382);
      END_STATE();
    case 318:
      if (lookahead == 'g') ADVANCE(383);
      END_STATE();
    case 319:
      if (lookahead == 'f') ADVANCE(384);
      END_STATE();
    case 320:
      if (lookahead == '_') ADVANCE(385);
      END_STATE();
    case 321:
      if (lookahead == '_') ADVANCE(386);
      END_STATE();
    case 322:
      if (lookahead == '_') ADVANCE(387);
      END_STATE();
    case 323:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 324:
      if (lookahead == 'r') ADVANCE(388);
      END_STATE();
    case 325:
      if (lookahead == 'x') ADVANCE(389);
      END_STATE();
    case 326:
      if (lookahead == 'u') ADVANCE(390);
      END_STATE();
    case 327:
      if (lookahead == 't') ADVANCE(391);
      END_STATE();
    case 328:
      if (lookahead == 'd') ADVANCE(392);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 331:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 332:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 333:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 334:
      if (lookahead == '_') ADVANCE(393);
      END_STATE();
    case 335:
      if (lookahead == 'i') ADVANCE(394);
      END_STATE();
    case 336:
      if (lookahead == 'r') ADVANCE(395);
      END_STATE();
    case 337:
      if (lookahead == 'r') ADVANCE(396);
      END_STATE();
    case 338:
      if (lookahead == 'o') ADVANCE(397);
      END_STATE();
    case 339:
      if (lookahead == 'f') ADVANCE(398);
      END_STATE();
    case 340:
      if (lookahead == 'e') ADVANCE(399);
      END_STATE();
    case 341:
      if (lookahead == 'c') ADVANCE(400);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_signed);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 345:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 349:
      if (lookahead == '_') ADVANCE(401);
      END_STATE();
    case 350:
      if (lookahead == 'f') ADVANCE(402);
      END_STATE();
    case 351:
      if (lookahead == '_') ADVANCE(403);
      END_STATE();
    case 352:
      if (lookahead == '_') ADVANCE(404);
      END_STATE();
    case 353:
      if (lookahead == '_') ADVANCE(405);
      END_STATE();
    case 354:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 355:
      if (lookahead == 'r') ADVANCE(406);
      END_STATE();
    case 356:
      if (lookahead == 'e') ADVANCE(407);
      END_STATE();
    case 357:
      if (lookahead == 'l') ADVANCE(408);
      END_STATE();
    case 358:
      if (lookahead == 'f') ADVANCE(409);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(anon_sym__Atomic);
      END_STATE();
    case 360:
      if (lookahead == 'c') ADVANCE(410);
      END_STATE();
    case 361:
      if (lookahead == 'r') ADVANCE(411);
      END_STATE();
    case 362:
      if (lookahead == 'o') ADVANCE(412);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(anon_sym___asm__);
      END_STATE();
    case 364:
      if (lookahead == 'b') ADVANCE(413);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym___based);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(anon_sym___cdecl);
      END_STATE();
    case 367:
      if (lookahead == 'l') ADVANCE(414);
      END_STATE();
    case 368:
      if (lookahead == 'p') ADVANCE(415);
      END_STATE();
    case 369:
      if (lookahead == 't') ADVANCE(416);
      END_STATE();
    case 370:
      if (lookahead == 's') ADVANCE(417);
      END_STATE();
    case 371:
      if (lookahead == 'a') ADVANCE(418);
      END_STATE();
    case 372:
      if (lookahead == 'l') ADVANCE(419);
      END_STATE();
    case 373:
      if (lookahead == 'i') ADVANCE(420);
      END_STATE();
    case 374:
      if (lookahead == 'e') ADVANCE(421);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(anon_sym___leave);
      END_STATE();
    case 376:
      if (lookahead == 'i') ADVANCE(422);
      END_STATE();
    case 377:
      if (lookahead == 'l') ADVANCE(423);
      END_STATE();
    case 378:
      if (lookahead == 'a') ADVANCE(424);
      END_STATE();
    case 379:
      if (lookahead == 'd') ADVANCE(425);
      END_STATE();
    case 380:
      if (lookahead == 'g') ADVANCE(426);
      END_STATE();
    case 381:
      if (lookahead == 'r') ADVANCE(427);
      END_STATE();
    case 382:
      if (lookahead == 'f') ADVANCE(428);
      END_STATE();
    case 383:
      if (lookahead == 'n') ADVANCE(429);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(anon_sym_alignof);
      END_STATE();
    case 385:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 386:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 387:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 388:
      if (lookahead == '_') ADVANCE(430);
      END_STATE();
    case 389:
      if (lookahead == 'p') ADVANCE(431);
      END_STATE();
    case 390:
      if (lookahead == 'e') ADVANCE(432);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(anon_sym_defined);
      END_STATE();
    case 393:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 394:
      if (lookahead == 'g') ADVANCE(433);
      END_STATE();
    case 395:
      if (lookahead == 'n') ADVANCE(434);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(anon_sym_nullptr);
      if (lookahead == '_') ADVANCE(435);
      END_STATE();
    case 397:
      if (lookahead == 'f') ADVANCE(436);
      END_STATE();
    case 398:
      if (lookahead == '_') ADVANCE(437);
      END_STATE();
    case 399:
      if (lookahead == 'r') ADVANCE(438);
      END_STATE();
    case 400:
      if (lookahead == 't') ADVANCE(439);
      END_STATE();
    case 401:
      if (lookahead == 'l') ADVANCE(440);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_typedef);
      END_STATE();
    case 403:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 404:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 405:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 406:
      if (lookahead == '_') ADVANCE(441);
      END_STATE();
    case 407:
      if (lookahead == 'd') ADVANCE(442);
      END_STATE();
    case 408:
      if (lookahead == 'e') ADVANCE(443);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym__Alignof);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(anon_sym__Generic);
      END_STATE();
    case 411:
      if (lookahead == 'n') ADVANCE(444);
      END_STATE();
    case 412:
      if (lookahead == 'f') ADVANCE(445);
      END_STATE();
    case 413:
      if (lookahead == 'u') ADVANCE(446);
      END_STATE();
    case 414:
      if (lookahead == 'l') ADVANCE(447);
      END_STATE();
    case 415:
      if (lookahead == 'e') ADVANCE(448);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym___except);
      END_STATE();
    case 417:
      if (lookahead == 'i') ADVANCE(449);
      END_STATE();
    case 418:
      if (lookahead == 'l') ADVANCE(450);
      END_STATE();
    case 419:
      if (lookahead == 'y') ADVANCE(451);
      END_STATE();
    case 420:
      if (lookahead == 'n') ADVANCE(452);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym___inline);
      if (lookahead == '_') ADVANCE(453);
      END_STATE();
    case 422:
      if (lookahead == 'c') ADVANCE(454);
      END_STATE();
    case 423:
      if (lookahead == 'l') ADVANCE(455);
      END_STATE();
    case 424:
      if (lookahead == 'l') ADVANCE(456);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(anon_sym___thread);
      END_STATE();
    case 426:
      if (lookahead == 'n') ADVANCE(457);
      END_STATE();
    case 427:
      if (lookahead == 'c') ADVANCE(458);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(anon_sym__alignof);
      END_STATE();
    case 429:
      if (lookahead == 'e') ADVANCE(459);
      END_STATE();
    case 430:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 431:
      if (lookahead == 'r') ADVANCE(460);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 433:
      if (lookahead == 'n') ADVANCE(461);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(anon_sym_noreturn);
      END_STATE();
    case 435:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym_offsetof);
      END_STATE();
    case 437:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(anon_sym_register);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(anon_sym_restrict);
      END_STATE();
    case 440:
      if (lookahead == 'o') ADVANCE(462);
      END_STATE();
    case 441:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym_unsigned);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(anon_sym__Noreturn);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(anon_sym___alignof);
      if (lookahead == '_') ADVANCE(463);
      END_STATE();
    case 446:
      if (lookahead == 't') ADVANCE(464);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(anon_sym___clrcall);
      END_STATE();
    case 448:
      if (lookahead == 'c') ADVANCE(465);
      END_STATE();
    case 449:
      if (lookahead == 'o') ADVANCE(466);
      END_STATE();
    case 450:
      if (lookahead == 'l') ADVANCE(467);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(anon_sym___finally);
      END_STATE();
    case 452:
      if (lookahead == 'l') ADVANCE(468);
      END_STATE();
    case 453:
      if (lookahead == '_') ADVANCE(469);
      END_STATE();
    case 454:
      if (lookahead == 't') ADVANCE(470);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym___stdcall);
      END_STATE();
    case 456:
      if (lookahead == 'l') ADVANCE(471);
      END_STATE();
    case 457:
      if (lookahead == 'e') ADVANCE(472);
      END_STATE();
    case 458:
      if (lookahead == 'a') ADVANCE(473);
      END_STATE();
    case 459:
      if (lookahead == 'd') ADVANCE(474);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_constexpr);
      END_STATE();
    case 461:
      if (lookahead == '_') ADVANCE(475);
      END_STATE();
    case 462:
      if (lookahead == 'c') ADVANCE(476);
      END_STATE();
    case 463:
      if (lookahead == '_') ADVANCE(477);
      END_STATE();
    case 464:
      if (lookahead == 'e') ADVANCE(478);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym___declspec);
      END_STATE();
    case 466:
      if (lookahead == 'n') ADVANCE(479);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym___fastcall);
      END_STATE();
    case 468:
      if (lookahead == 'i') ADVANCE(480);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym___inline__);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(sym_ms_restrict_modifier);
      if (lookahead == '_') ADVANCE(481);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym___thiscall);
      END_STATE();
    case 472:
      if (lookahead == 'd') ADVANCE(482);
      END_STATE();
    case 473:
      if (lookahead == 'l') ADVANCE(483);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym__unaligned);
      END_STATE();
    case 475:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 476:
      if (lookahead == 'a') ADVANCE(484);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym___alignof__);
      END_STATE();
    case 478:
      if (lookahead == '_') ADVANCE(485);
      END_STATE();
    case 479:
      if (lookahead == '_') ADVANCE(486);
      END_STATE();
    case 480:
      if (lookahead == 'n') ADVANCE(487);
      END_STATE();
    case 481:
      if (lookahead == '_') ADVANCE(488);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym___unaligned);
      END_STATE();
    case 483:
      if (lookahead == 'l') ADVANCE(489);
      END_STATE();
    case 484:
      if (lookahead == 'l') ADVANCE(490);
      END_STATE();
    case 485:
      if (lookahead == '_') ADVANCE(491);
      END_STATE();
    case 486:
      if (lookahead == '_') ADVANCE(492);
      END_STATE();
    case 487:
      if (lookahead == 'e') ADVANCE(493);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(anon_sym___restrict__);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym___vectorcall);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_thread_local);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym___attribute__);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(anon_sym___extension__);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym___forceinline);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 140},
  [2] = {.lex_state = 55},
  [3] = {.lex_state = 55},
  [4] = {.lex_state = 55},
  [5] = {.lex_state = 55},
  [6] = {.lex_state = 55},
  [7] = {.lex_state = 55},
  [8] = {.lex_state = 55},
  [9] = {.lex_state = 55},
  [10] = {.lex_state = 55},
  [11] = {.lex_state = 55},
  [12] = {.lex_state = 58},
  [13] = {.lex_state = 58},
  [14] = {.lex_state = 58},
  [15] = {.lex_state = 58},
  [16] = {.lex_state = 55},
  [17] = {.lex_state = 58},
  [18] = {.lex_state = 58},
  [19] = {.lex_state = 58},
  [20] = {.lex_state = 58},
  [21] = {.lex_state = 58},
  [22] = {.lex_state = 58},
  [23] = {.lex_state = 58},
  [24] = {.lex_state = 58},
  [25] = {.lex_state = 58},
  [26] = {.lex_state = 58},
  [27] = {.lex_state = 58},
  [28] = {.lex_state = 140},
  [29] = {.lex_state = 140},
  [30] = {.lex_state = 140},
  [31] = {.lex_state = 140},
  [32] = {.lex_state = 140},
  [33] = {.lex_state = 140},
  [34] = {.lex_state = 140},
  [35] = {.lex_state = 140},
  [36] = {.lex_state = 57},
  [37] = {.lex_state = 140},
  [38] = {.lex_state = 57},
  [39] = {.lex_state = 140},
  [40] = {.lex_state = 140},
  [41] = {.lex_state = 140},
  [42] = {.lex_state = 140},
  [43] = {.lex_state = 140},
  [44] = {.lex_state = 140},
  [45] = {.lex_state = 140},
  [46] = {.lex_state = 140},
  [47] = {.lex_state = 57},
  [48] = {.lex_state = 140},
  [49] = {.lex_state = 140},
  [50] = {.lex_state = 140},
  [51] = {.lex_state = 140},
  [52] = {.lex_state = 140},
  [53] = {.lex_state = 140},
  [54] = {.lex_state = 55},
  [55] = {.lex_state = 55},
  [56] = {.lex_state = 55},
  [57] = {.lex_state = 55},
  [58] = {.lex_state = 55},
  [59] = {.lex_state = 58},
  [60] = {.lex_state = 58},
  [61] = {.lex_state = 58},
  [62] = {.lex_state = 58},
  [63] = {.lex_state = 58},
  [64] = {.lex_state = 57},
  [65] = {.lex_state = 140},
  [66] = {.lex_state = 57},
  [67] = {.lex_state = 57},
  [68] = {.lex_state = 57},
  [69] = {.lex_state = 140},
  [70] = {.lex_state = 140},
  [71] = {.lex_state = 140},
  [72] = {.lex_state = 57},
  [73] = {.lex_state = 140},
  [74] = {.lex_state = 140},
  [75] = {.lex_state = 140},
  [76] = {.lex_state = 140},
  [77] = {.lex_state = 140},
  [78] = {.lex_state = 140},
  [79] = {.lex_state = 140},
  [80] = {.lex_state = 140},
  [81] = {.lex_state = 140},
  [82] = {.lex_state = 140},
  [83] = {.lex_state = 140},
  [84] = {.lex_state = 140},
  [85] = {.lex_state = 140},
  [86] = {.lex_state = 140},
  [87] = {.lex_state = 140},
  [88] = {.lex_state = 140},
  [89] = {.lex_state = 140},
  [90] = {.lex_state = 55},
  [91] = {.lex_state = 55},
  [92] = {.lex_state = 55},
  [93] = {.lex_state = 55},
  [94] = {.lex_state = 55},
  [95] = {.lex_state = 55},
  [96] = {.lex_state = 140},
  [97] = {.lex_state = 55},
  [98] = {.lex_state = 55},
  [99] = {.lex_state = 55},
  [100] = {.lex_state = 55},
  [101] = {.lex_state = 55},
  [102] = {.lex_state = 55},
  [103] = {.lex_state = 55},
  [104] = {.lex_state = 55},
  [105] = {.lex_state = 55},
  [106] = {.lex_state = 55},
  [107] = {.lex_state = 140},
  [108] = {.lex_state = 55},
  [109] = {.lex_state = 55},
  [110] = {.lex_state = 55},
  [111] = {.lex_state = 55},
  [112] = {.lex_state = 55},
  [113] = {.lex_state = 55},
  [114] = {.lex_state = 55},
  [115] = {.lex_state = 55},
  [116] = {.lex_state = 55},
  [117] = {.lex_state = 55},
  [118] = {.lex_state = 55},
  [119] = {.lex_state = 55},
  [120] = {.lex_state = 55},
  [121] = {.lex_state = 55},
  [122] = {.lex_state = 55},
  [123] = {.lex_state = 55},
  [124] = {.lex_state = 55},
  [125] = {.lex_state = 55},
  [126] = {.lex_state = 55},
  [127] = {.lex_state = 55},
  [128] = {.lex_state = 55},
  [129] = {.lex_state = 55},
  [130] = {.lex_state = 55},
  [131] = {.lex_state = 55},
  [132] = {.lex_state = 55},
  [133] = {.lex_state = 55},
  [134] = {.lex_state = 55},
  [135] = {.lex_state = 55},
  [136] = {.lex_state = 55},
  [137] = {.lex_state = 55},
  [138] = {.lex_state = 55},
  [139] = {.lex_state = 55},
  [140] = {.lex_state = 55},
  [141] = {.lex_state = 55},
  [142] = {.lex_state = 55},
  [143] = {.lex_state = 55},
  [144] = {.lex_state = 55},
  [145] = {.lex_state = 55},
  [146] = {.lex_state = 55},
  [147] = {.lex_state = 55},
  [148] = {.lex_state = 55},
  [149] = {.lex_state = 55},
  [150] = {.lex_state = 55},
  [151] = {.lex_state = 55},
  [152] = {.lex_state = 55},
  [153] = {.lex_state = 55},
  [154] = {.lex_state = 55},
  [155] = {.lex_state = 55},
  [156] = {.lex_state = 55},
  [157] = {.lex_state = 55},
  [158] = {.lex_state = 55},
  [159] = {.lex_state = 55},
  [160] = {.lex_state = 55},
  [161] = {.lex_state = 55},
  [162] = {.lex_state = 55},
  [163] = {.lex_state = 55},
  [164] = {.lex_state = 55},
  [165] = {.lex_state = 55},
  [166] = {.lex_state = 55},
  [167] = {.lex_state = 55},
  [168] = {.lex_state = 55},
  [169] = {.lex_state = 55},
  [170] = {.lex_state = 55},
  [171] = {.lex_state = 58},
  [172] = {.lex_state = 58},
  [173] = {.lex_state = 58},
  [174] = {.lex_state = 58},
  [175] = {.lex_state = 58},
  [176] = {.lex_state = 58},
  [177] = {.lex_state = 58},
  [178] = {.lex_state = 58},
  [179] = {.lex_state = 58},
  [180] = {.lex_state = 58},
  [181] = {.lex_state = 58},
  [182] = {.lex_state = 58},
  [183] = {.lex_state = 58},
  [184] = {.lex_state = 58},
  [185] = {.lex_state = 58},
  [186] = {.lex_state = 58},
  [187] = {.lex_state = 58},
  [188] = {.lex_state = 58},
  [189] = {.lex_state = 58},
  [190] = {.lex_state = 58},
  [191] = {.lex_state = 58},
  [192] = {.lex_state = 58},
  [193] = {.lex_state = 58},
  [194] = {.lex_state = 58},
  [195] = {.lex_state = 58},
  [196] = {.lex_state = 58},
  [197] = {.lex_state = 58},
  [198] = {.lex_state = 58},
  [199] = {.lex_state = 58},
  [200] = {.lex_state = 58},
  [201] = {.lex_state = 58},
  [202] = {.lex_state = 58},
  [203] = {.lex_state = 58},
  [204] = {.lex_state = 58},
  [205] = {.lex_state = 58},
  [206] = {.lex_state = 58},
  [207] = {.lex_state = 58},
  [208] = {.lex_state = 58},
  [209] = {.lex_state = 58},
  [210] = {.lex_state = 58},
  [211] = {.lex_state = 58},
  [212] = {.lex_state = 58},
  [213] = {.lex_state = 58},
  [214] = {.lex_state = 58},
  [215] = {.lex_state = 58},
  [216] = {.lex_state = 58},
  [217] = {.lex_state = 58},
  [218] = {.lex_state = 58},
  [219] = {.lex_state = 58},
  [220] = {.lex_state = 58},
  [221] = {.lex_state = 58},
  [222] = {.lex_state = 58},
  [223] = {.lex_state = 58},
  [224] = {.lex_state = 58},
  [225] = {.lex_state = 58},
  [226] = {.lex_state = 58},
  [227] = {.lex_state = 58},
  [228] = {.lex_state = 58},
  [229] = {.lex_state = 58},
  [230] = {.lex_state = 140},
  [231] = {.lex_state = 58},
  [232] = {.lex_state = 58},
  [233] = {.lex_state = 58},
  [234] = {.lex_state = 58},
  [235] = {.lex_state = 58},
  [236] = {.lex_state = 58},
  [237] = {.lex_state = 58},
  [238] = {.lex_state = 53},
  [239] = {.lex_state = 58},
  [240] = {.lex_state = 53},
  [241] = {.lex_state = 58},
  [242] = {.lex_state = 58},
  [243] = {.lex_state = 140},
  [244] = {.lex_state = 57},
  [245] = {.lex_state = 58},
  [246] = {.lex_state = 58},
  [247] = {.lex_state = 58},
  [248] = {.lex_state = 58},
  [249] = {.lex_state = 58},
  [250] = {.lex_state = 58},
  [251] = {.lex_state = 58},
  [252] = {.lex_state = 58},
  [253] = {.lex_state = 58},
  [254] = {.lex_state = 58},
  [255] = {.lex_state = 140},
  [256] = {.lex_state = 140},
  [257] = {.lex_state = 140},
  [258] = {.lex_state = 140},
  [259] = {.lex_state = 140},
  [260] = {.lex_state = 140},
  [261] = {.lex_state = 140},
  [262] = {.lex_state = 140},
  [263] = {.lex_state = 140},
  [264] = {.lex_state = 140},
  [265] = {.lex_state = 140},
  [266] = {.lex_state = 140},
  [267] = {.lex_state = 140},
  [268] = {.lex_state = 140},
  [269] = {.lex_state = 140},
  [270] = {.lex_state = 140},
  [271] = {.lex_state = 140},
  [272] = {.lex_state = 140},
  [273] = {.lex_state = 140},
  [274] = {.lex_state = 140},
  [275] = {.lex_state = 140},
  [276] = {.lex_state = 140},
  [277] = {.lex_state = 140},
  [278] = {.lex_state = 140},
  [279] = {.lex_state = 140},
  [280] = {.lex_state = 140},
  [281] = {.lex_state = 140},
  [282] = {.lex_state = 140},
  [283] = {.lex_state = 140},
  [284] = {.lex_state = 140},
  [285] = {.lex_state = 140},
  [286] = {.lex_state = 140},
  [287] = {.lex_state = 140},
  [288] = {.lex_state = 140},
  [289] = {.lex_state = 140},
  [290] = {.lex_state = 140},
  [291] = {.lex_state = 140},
  [292] = {.lex_state = 140},
  [293] = {.lex_state = 140},
  [294] = {.lex_state = 140},
  [295] = {.lex_state = 140},
  [296] = {.lex_state = 140},
  [297] = {.lex_state = 140},
  [298] = {.lex_state = 140},
  [299] = {.lex_state = 140},
  [300] = {.lex_state = 140},
  [301] = {.lex_state = 140},
  [302] = {.lex_state = 140},
  [303] = {.lex_state = 140},
  [304] = {.lex_state = 140},
  [305] = {.lex_state = 140},
  [306] = {.lex_state = 140},
  [307] = {.lex_state = 140},
  [308] = {.lex_state = 140},
  [309] = {.lex_state = 140},
  [310] = {.lex_state = 140},
  [311] = {.lex_state = 140},
  [312] = {.lex_state = 140},
  [313] = {.lex_state = 140},
  [314] = {.lex_state = 140},
  [315] = {.lex_state = 140},
  [316] = {.lex_state = 140},
  [317] = {.lex_state = 140},
  [318] = {.lex_state = 140},
  [319] = {.lex_state = 57},
  [320] = {.lex_state = 57},
  [321] = {.lex_state = 140},
  [322] = {.lex_state = 140},
  [323] = {.lex_state = 57},
  [324] = {.lex_state = 140},
  [325] = {.lex_state = 140},
  [326] = {.lex_state = 57},
  [327] = {.lex_state = 57},
  [328] = {.lex_state = 57},
  [329] = {.lex_state = 140},
  [330] = {.lex_state = 140},
  [331] = {.lex_state = 140},
  [332] = {.lex_state = 57},
  [333] = {.lex_state = 57},
  [334] = {.lex_state = 140},
  [335] = {.lex_state = 57},
  [336] = {.lex_state = 140},
  [337] = {.lex_state = 57},
  [338] = {.lex_state = 140},
  [339] = {.lex_state = 140},
  [340] = {.lex_state = 57},
  [341] = {.lex_state = 140},
  [342] = {.lex_state = 57},
  [343] = {.lex_state = 140},
  [344] = {.lex_state = 57},
  [345] = {.lex_state = 57},
  [346] = {.lex_state = 140},
  [347] = {.lex_state = 140},
  [348] = {.lex_state = 57},
  [349] = {.lex_state = 57},
  [350] = {.lex_state = 140},
  [351] = {.lex_state = 140},
  [352] = {.lex_state = 57},
  [353] = {.lex_state = 57},
  [354] = {.lex_state = 140},
  [355] = {.lex_state = 57},
  [356] = {.lex_state = 57},
  [357] = {.lex_state = 140},
  [358] = {.lex_state = 57},
  [359] = {.lex_state = 57},
  [360] = {.lex_state = 57},
  [361] = {.lex_state = 57},
  [362] = {.lex_state = 57},
  [363] = {.lex_state = 57},
  [364] = {.lex_state = 57},
  [365] = {.lex_state = 140},
  [366] = {.lex_state = 140},
  [367] = {.lex_state = 140},
  [368] = {.lex_state = 140},
  [369] = {.lex_state = 140},
  [370] = {.lex_state = 57},
  [371] = {.lex_state = 140},
  [372] = {.lex_state = 140},
  [373] = {.lex_state = 57},
  [374] = {.lex_state = 140},
  [375] = {.lex_state = 140},
  [376] = {.lex_state = 140},
  [377] = {.lex_state = 140},
  [378] = {.lex_state = 57},
  [379] = {.lex_state = 140},
  [380] = {.lex_state = 140},
  [381] = {.lex_state = 140},
  [382] = {.lex_state = 57},
  [383] = {.lex_state = 140},
  [384] = {.lex_state = 57},
  [385] = {.lex_state = 57},
  [386] = {.lex_state = 57},
  [387] = {.lex_state = 57},
  [388] = {.lex_state = 57},
  [389] = {.lex_state = 57},
  [390] = {.lex_state = 57},
  [391] = {.lex_state = 57},
  [392] = {.lex_state = 57},
  [393] = {.lex_state = 57},
  [394] = {.lex_state = 57},
  [395] = {.lex_state = 57},
  [396] = {.lex_state = 57},
  [397] = {.lex_state = 57},
  [398] = {.lex_state = 57},
  [399] = {.lex_state = 57},
  [400] = {.lex_state = 57},
  [401] = {.lex_state = 57},
  [402] = {.lex_state = 57},
  [403] = {.lex_state = 140},
  [404] = {.lex_state = 140},
  [405] = {.lex_state = 140},
  [406] = {.lex_state = 140},
  [407] = {.lex_state = 57},
  [408] = {.lex_state = 140},
  [409] = {.lex_state = 140},
  [410] = {.lex_state = 57},
  [411] = {.lex_state = 140},
  [412] = {.lex_state = 57},
  [413] = {.lex_state = 57},
  [414] = {.lex_state = 140},
  [415] = {.lex_state = 140},
  [416] = {.lex_state = 140},
  [417] = {.lex_state = 140},
  [418] = {.lex_state = 57},
  [419] = {.lex_state = 57},
  [420] = {.lex_state = 57},
  [421] = {.lex_state = 57},
  [422] = {.lex_state = 57},
  [423] = {.lex_state = 140},
  [424] = {.lex_state = 57},
  [425] = {.lex_state = 57},
  [426] = {.lex_state = 57},
  [427] = {.lex_state = 57},
  [428] = {.lex_state = 140},
  [429] = {.lex_state = 140},
  [430] = {.lex_state = 140},
  [431] = {.lex_state = 57},
  [432] = {.lex_state = 140},
  [433] = {.lex_state = 57},
  [434] = {.lex_state = 57},
  [435] = {.lex_state = 140},
  [436] = {.lex_state = 57},
  [437] = {.lex_state = 140},
  [438] = {.lex_state = 140},
  [439] = {.lex_state = 140},
  [440] = {.lex_state = 57},
  [441] = {.lex_state = 140},
  [442] = {.lex_state = 57},
  [443] = {.lex_state = 140},
  [444] = {.lex_state = 140},
  [445] = {.lex_state = 57},
  [446] = {.lex_state = 57},
  [447] = {.lex_state = 57},
  [448] = {.lex_state = 140},
  [449] = {.lex_state = 140},
  [450] = {.lex_state = 57},
  [451] = {.lex_state = 57},
  [452] = {.lex_state = 140},
  [453] = {.lex_state = 140},
  [454] = {.lex_state = 140},
  [455] = {.lex_state = 140},
  [456] = {.lex_state = 140},
  [457] = {.lex_state = 140},
  [458] = {.lex_state = 140},
  [459] = {.lex_state = 140},
  [460] = {.lex_state = 140},
  [461] = {.lex_state = 140},
  [462] = {.lex_state = 140},
  [463] = {.lex_state = 140},
  [464] = {.lex_state = 140},
  [465] = {.lex_state = 57},
  [466] = {.lex_state = 140},
  [467] = {.lex_state = 57},
  [468] = {.lex_state = 140},
  [469] = {.lex_state = 57},
  [470] = {.lex_state = 140},
  [471] = {.lex_state = 57},
  [472] = {.lex_state = 140},
  [473] = {.lex_state = 140},
  [474] = {.lex_state = 140},
  [475] = {.lex_state = 140},
  [476] = {.lex_state = 140},
  [477] = {.lex_state = 140},
  [478] = {.lex_state = 140},
  [479] = {.lex_state = 54},
  [480] = {.lex_state = 140},
  [481] = {.lex_state = 140},
  [482] = {.lex_state = 140},
  [483] = {.lex_state = 140},
  [484] = {.lex_state = 140},
  [485] = {.lex_state = 140},
  [486] = {.lex_state = 140},
  [487] = {.lex_state = 140},
  [488] = {.lex_state = 140},
  [489] = {.lex_state = 140},
  [490] = {.lex_state = 140},
  [491] = {.lex_state = 140},
  [492] = {.lex_state = 140},
  [493] = {.lex_state = 140},
  [494] = {.lex_state = 140},
  [495] = {.lex_state = 140},
  [496] = {.lex_state = 140},
  [497] = {.lex_state = 140},
  [498] = {.lex_state = 140},
  [499] = {.lex_state = 140},
  [500] = {.lex_state = 140},
  [501] = {.lex_state = 140},
  [502] = {.lex_state = 140},
  [503] = {.lex_state = 140},
  [504] = {.lex_state = 140},
  [505] = {.lex_state = 140},
  [506] = {.lex_state = 140},
  [507] = {.lex_state = 140},
  [508] = {.lex_state = 140},
  [509] = {.lex_state = 53},
  [510] = {.lex_state = 140},
  [511] = {.lex_state = 140},
  [512] = {.lex_state = 140},
  [513] = {.lex_state = 140},
  [514] = {.lex_state = 140},
  [515] = {.lex_state = 140},
  [516] = {.lex_state = 140},
  [517] = {.lex_state = 140},
  [518] = {.lex_state = 140},
  [519] = {.lex_state = 140},
  [520] = {.lex_state = 140},
  [521] = {.lex_state = 140},
  [522] = {.lex_state = 140},
  [523] = {.lex_state = 140},
  [524] = {.lex_state = 140},
  [525] = {.lex_state = 140},
  [526] = {.lex_state = 140},
  [527] = {.lex_state = 140},
  [528] = {.lex_state = 140},
  [529] = {.lex_state = 140},
  [530] = {.lex_state = 140},
  [531] = {.lex_state = 140},
  [532] = {.lex_state = 140},
  [533] = {.lex_state = 140},
  [534] = {.lex_state = 140},
  [535] = {.lex_state = 140},
  [536] = {.lex_state = 140},
  [537] = {.lex_state = 140},
  [538] = {.lex_state = 140},
  [539] = {.lex_state = 140},
  [540] = {.lex_state = 140},
  [541] = {.lex_state = 140},
  [542] = {.lex_state = 140},
  [543] = {.lex_state = 140},
  [544] = {.lex_state = 140},
  [545] = {.lex_state = 140},
  [546] = {.lex_state = 140},
  [547] = {.lex_state = 140},
  [548] = {.lex_state = 140},
  [549] = {.lex_state = 140},
  [550] = {.lex_state = 140},
  [551] = {.lex_state = 140},
  [552] = {.lex_state = 140},
  [553] = {.lex_state = 140},
  [554] = {.lex_state = 53},
  [555] = {.lex_state = 53},
  [556] = {.lex_state = 140},
  [557] = {.lex_state = 54},
  [558] = {.lex_state = 53},
  [559] = {.lex_state = 140},
  [560] = {.lex_state = 60},
  [561] = {.lex_state = 60},
  [562] = {.lex_state = 140},
  [563] = {.lex_state = 60},
  [564] = {.lex_state = 60},
  [565] = {.lex_state = 60},
  [566] = {.lex_state = 60},
  [567] = {.lex_state = 60},
  [568] = {.lex_state = 60},
  [569] = {.lex_state = 60},
  [570] = {.lex_state = 60},
  [571] = {.lex_state = 60},
  [572] = {.lex_state = 60},
  [573] = {.lex_state = 64},
  [574] = {.lex_state = 140},
  [575] = {.lex_state = 140},
  [576] = {.lex_state = 140},
  [577] = {.lex_state = 140},
  [578] = {.lex_state = 140},
  [579] = {.lex_state = 140},
  [580] = {.lex_state = 140},
  [581] = {.lex_state = 140},
  [582] = {.lex_state = 140},
  [583] = {.lex_state = 140},
  [584] = {.lex_state = 140},
  [585] = {.lex_state = 140},
  [586] = {.lex_state = 140},
  [587] = {.lex_state = 140},
  [588] = {.lex_state = 140},
  [589] = {.lex_state = 140},
  [590] = {.lex_state = 140},
  [591] = {.lex_state = 64},
  [592] = {.lex_state = 64},
  [593] = {.lex_state = 64},
  [594] = {.lex_state = 64},
  [595] = {.lex_state = 64},
  [596] = {.lex_state = 64},
  [597] = {.lex_state = 64},
  [598] = {.lex_state = 64},
  [599] = {.lex_state = 64},
  [600] = {.lex_state = 65},
  [601] = {.lex_state = 64},
  [602] = {.lex_state = 65},
  [603] = {.lex_state = 65},
  [604] = {.lex_state = 65},
  [605] = {.lex_state = 65},
  [606] = {.lex_state = 65},
  [607] = {.lex_state = 65},
  [608] = {.lex_state = 65},
  [609] = {.lex_state = 65},
  [610] = {.lex_state = 65},
  [611] = {.lex_state = 65},
  [612] = {.lex_state = 65},
  [613] = {.lex_state = 140},
  [614] = {.lex_state = 140},
  [615] = {.lex_state = 140},
  [616] = {.lex_state = 65},
  [617] = {.lex_state = 140},
  [618] = {.lex_state = 140},
  [619] = {.lex_state = 140},
  [620] = {.lex_state = 140},
  [621] = {.lex_state = 140},
  [622] = {.lex_state = 140},
  [623] = {.lex_state = 140},
  [624] = {.lex_state = 140},
  [625] = {.lex_state = 140},
  [626] = {.lex_state = 140},
  [627] = {.lex_state = 140},
  [628] = {.lex_state = 140},
  [629] = {.lex_state = 140},
  [630] = {.lex_state = 140},
  [631] = {.lex_state = 140},
  [632] = {.lex_state = 140},
  [633] = {.lex_state = 140},
  [634] = {.lex_state = 140},
  [635] = {.lex_state = 140},
  [636] = {.lex_state = 140},
  [637] = {.lex_state = 140},
  [638] = {.lex_state = 140},
  [639] = {.lex_state = 140},
  [640] = {.lex_state = 140},
  [641] = {.lex_state = 140},
  [642] = {.lex_state = 140},
  [643] = {.lex_state = 140},
  [644] = {.lex_state = 140},
  [645] = {.lex_state = 140},
  [646] = {.lex_state = 140},
  [647] = {.lex_state = 140},
  [648] = {.lex_state = 140},
  [649] = {.lex_state = 140},
  [650] = {.lex_state = 70},
  [651] = {.lex_state = 140},
  [652] = {.lex_state = 140},
  [653] = {.lex_state = 140},
  [654] = {.lex_state = 140},
  [655] = {.lex_state = 140},
  [656] = {.lex_state = 140},
  [657] = {.lex_state = 140},
  [658] = {.lex_state = 71},
  [659] = {.lex_state = 140},
  [660] = {.lex_state = 70},
  [661] = {.lex_state = 140},
  [662] = {.lex_state = 140},
  [663] = {.lex_state = 140},
  [664] = {.lex_state = 140},
  [665] = {.lex_state = 71},
  [666] = {.lex_state = 140},
  [667] = {.lex_state = 70},
  [668] = {.lex_state = 71},
  [669] = {.lex_state = 140},
  [670] = {.lex_state = 140},
  [671] = {.lex_state = 140},
  [672] = {.lex_state = 140},
  [673] = {.lex_state = 140},
  [674] = {.lex_state = 140},
  [675] = {.lex_state = 140},
  [676] = {.lex_state = 140},
  [677] = {.lex_state = 140},
  [678] = {.lex_state = 140},
  [679] = {.lex_state = 140},
  [680] = {.lex_state = 140},
  [681] = {.lex_state = 140},
  [682] = {.lex_state = 140},
  [683] = {.lex_state = 140},
  [684] = {.lex_state = 140},
  [685] = {.lex_state = 140},
  [686] = {.lex_state = 140},
  [687] = {.lex_state = 140},
  [688] = {.lex_state = 140},
  [689] = {.lex_state = 140},
  [690] = {.lex_state = 140},
  [691] = {.lex_state = 140},
  [692] = {.lex_state = 140},
  [693] = {.lex_state = 140},
  [694] = {.lex_state = 140},
  [695] = {.lex_state = 140},
  [696] = {.lex_state = 140},
  [697] = {.lex_state = 140},
  [698] = {.lex_state = 140},
  [699] = {.lex_state = 140},
  [700] = {.lex_state = 140},
  [701] = {.lex_state = 140},
  [702] = {.lex_state = 140},
  [703] = {.lex_state = 140},
  [704] = {.lex_state = 140},
  [705] = {.lex_state = 140},
  [706] = {.lex_state = 140},
  [707] = {.lex_state = 140},
  [708] = {.lex_state = 140},
  [709] = {.lex_state = 140},
  [710] = {.lex_state = 140},
  [711] = {.lex_state = 140},
  [712] = {.lex_state = 140},
  [713] = {.lex_state = 140},
  [714] = {.lex_state = 140},
  [715] = {.lex_state = 140},
  [716] = {.lex_state = 140},
  [717] = {.lex_state = 140},
  [718] = {.lex_state = 140},
  [719] = {.lex_state = 140},
  [720] = {.lex_state = 140},
  [721] = {.lex_state = 140},
  [722] = {.lex_state = 140},
  [723] = {.lex_state = 140},
  [724] = {.lex_state = 140},
  [725] = {.lex_state = 140},
  [726] = {.lex_state = 140},
  [727] = {.lex_state = 140},
  [728] = {.lex_state = 140},
  [729] = {.lex_state = 140},
  [730] = {.lex_state = 140},
  [731] = {.lex_state = 140},
  [732] = {.lex_state = 140},
  [733] = {.lex_state = 140},
  [734] = {.lex_state = 140},
  [735] = {.lex_state = 140},
  [736] = {.lex_state = 140},
  [737] = {.lex_state = 140},
  [738] = {.lex_state = 140},
  [739] = {.lex_state = 140},
  [740] = {.lex_state = 140},
  [741] = {.lex_state = 140},
  [742] = {.lex_state = 140},
  [743] = {.lex_state = 140},
  [744] = {.lex_state = 140},
  [745] = {.lex_state = 140},
  [746] = {.lex_state = 140},
  [747] = {.lex_state = 140},
  [748] = {.lex_state = 140},
  [749] = {.lex_state = 140},
  [750] = {.lex_state = 140},
  [751] = {.lex_state = 140},
  [752] = {.lex_state = 140},
  [753] = {.lex_state = 140},
  [754] = {.lex_state = 140},
  [755] = {.lex_state = 140},
  [756] = {.lex_state = 140},
  [757] = {.lex_state = 140},
  [758] = {.lex_state = 140},
  [759] = {.lex_state = 140},
  [760] = {.lex_state = 140},
  [761] = {.lex_state = 140},
  [762] = {.lex_state = 140},
  [763] = {.lex_state = 140},
  [764] = {.lex_state = 140},
  [765] = {.lex_state = 140},
  [766] = {.lex_state = 140},
  [767] = {.lex_state = 140},
  [768] = {.lex_state = 140},
  [769] = {.lex_state = 140},
  [770] = {.lex_state = 140},
  [771] = {.lex_state = 140},
  [772] = {.lex_state = 140},
  [773] = {.lex_state = 140},
  [774] = {.lex_state = 140},
  [775] = {.lex_state = 140},
  [776] = {.lex_state = 140},
  [777] = {.lex_state = 140},
  [778] = {.lex_state = 140},
  [779] = {.lex_state = 140},
  [780] = {.lex_state = 140},
  [781] = {.lex_state = 140},
  [782] = {.lex_state = 140},
  [783] = {.lex_state = 140},
  [784] = {.lex_state = 140},
  [785] = {.lex_state = 140},
  [786] = {.lex_state = 140},
  [787] = {.lex_state = 140},
  [788] = {.lex_state = 140},
  [789] = {.lex_state = 140},
  [790] = {.lex_state = 140},
  [791] = {.lex_state = 140},
  [792] = {.lex_state = 140},
  [793] = {.lex_state = 140},
  [794] = {.lex_state = 140},
  [795] = {.lex_state = 140},
  [796] = {.lex_state = 140},
  [797] = {.lex_state = 140},
  [798] = {.lex_state = 140},
  [799] = {.lex_state = 140},
  [800] = {.lex_state = 140},
  [801] = {.lex_state = 140},
  [802] = {.lex_state = 140},
  [803] = {.lex_state = 140},
  [804] = {.lex_state = 140},
  [805] = {.lex_state = 140},
  [806] = {.lex_state = 140},
  [807] = {.lex_state = 140},
  [808] = {.lex_state = 140},
  [809] = {.lex_state = 140},
  [810] = {.lex_state = 140},
  [811] = {.lex_state = 140},
  [812] = {.lex_state = 140},
  [813] = {.lex_state = 140},
  [814] = {.lex_state = 140},
  [815] = {.lex_state = 140},
  [816] = {.lex_state = 140},
  [817] = {.lex_state = 140},
  [818] = {.lex_state = 140},
  [819] = {.lex_state = 140},
  [820] = {.lex_state = 140},
  [821] = {.lex_state = 60},
  [822] = {.lex_state = 64},
  [823] = {.lex_state = 64},
  [824] = {.lex_state = 60},
  [825] = {.lex_state = 60},
  [826] = {.lex_state = 64},
  [827] = {.lex_state = 60},
  [828] = {.lex_state = 64},
  [829] = {.lex_state = 64},
  [830] = {.lex_state = 60},
  [831] = {.lex_state = 60},
  [832] = {.lex_state = 60},
  [833] = {.lex_state = 62},
  [834] = {.lex_state = 62},
  [835] = {.lex_state = 62},
  [836] = {.lex_state = 62},
  [837] = {.lex_state = 62},
  [838] = {.lex_state = 62},
  [839] = {.lex_state = 62},
  [840] = {.lex_state = 62},
  [841] = {.lex_state = 62},
  [842] = {.lex_state = 62},
  [843] = {.lex_state = 62},
  [844] = {.lex_state = 64},
  [845] = {.lex_state = 60},
  [846] = {.lex_state = 140},
  [847] = {.lex_state = 140},
  [848] = {.lex_state = 140},
  [849] = {.lex_state = 64},
  [850] = {.lex_state = 62},
  [851] = {.lex_state = 64},
  [852] = {.lex_state = 64},
  [853] = {.lex_state = 64},
  [854] = {.lex_state = 64},
  [855] = {.lex_state = 64},
  [856] = {.lex_state = 62},
  [857] = {.lex_state = 62},
  [858] = {.lex_state = 62},
  [859] = {.lex_state = 62},
  [860] = {.lex_state = 64},
  [861] = {.lex_state = 62},
  [862] = {.lex_state = 64},
  [863] = {.lex_state = 64},
  [864] = {.lex_state = 62},
  [865] = {.lex_state = 62},
  [866] = {.lex_state = 62},
  [867] = {.lex_state = 64},
  [868] = {.lex_state = 64},
  [869] = {.lex_state = 62},
  [870] = {.lex_state = 62},
  [871] = {.lex_state = 64},
  [872] = {.lex_state = 62},
  [873] = {.lex_state = 64},
  [874] = {.lex_state = 64},
  [875] = {.lex_state = 64},
  [876] = {.lex_state = 64},
  [877] = {.lex_state = 64},
  [878] = {.lex_state = 64},
  [879] = {.lex_state = 64},
  [880] = {.lex_state = 64},
  [881] = {.lex_state = 64},
  [882] = {.lex_state = 62},
  [883] = {.lex_state = 62},
  [884] = {.lex_state = 62},
  [885] = {.lex_state = 64},
  [886] = {.lex_state = 62},
  [887] = {.lex_state = 62},
  [888] = {.lex_state = 64},
  [889] = {.lex_state = 62},
  [890] = {.lex_state = 60},
  [891] = {.lex_state = 62},
  [892] = {.lex_state = 63},
  [893] = {.lex_state = 64},
  [894] = {.lex_state = 64},
  [895] = {.lex_state = 63},
  [896] = {.lex_state = 60},
  [897] = {.lex_state = 63},
  [898] = {.lex_state = 64},
  [899] = {.lex_state = 62},
  [900] = {.lex_state = 62},
  [901] = {.lex_state = 63},
  [902] = {.lex_state = 62},
  [903] = {.lex_state = 61},
  [904] = {.lex_state = 61},
  [905] = {.lex_state = 61},
  [906] = {.lex_state = 60},
  [907] = {.lex_state = 61},
  [908] = {.lex_state = 140},
  [909] = {.lex_state = 61},
  [910] = {.lex_state = 61},
  [911] = {.lex_state = 64},
  [912] = {.lex_state = 64},
  [913] = {.lex_state = 64},
  [914] = {.lex_state = 64},
  [915] = {.lex_state = 64},
  [916] = {.lex_state = 61},
  [917] = {.lex_state = 64},
  [918] = {.lex_state = 61},
  [919] = {.lex_state = 64},
  [920] = {.lex_state = 64},
  [921] = {.lex_state = 64},
  [922] = {.lex_state = 64},
  [923] = {.lex_state = 60},
  [924] = {.lex_state = 64},
  [925] = {.lex_state = 60},
  [926] = {.lex_state = 140},
  [927] = {.lex_state = 60},
  [928] = {.lex_state = 60},
  [929] = {.lex_state = 64},
  [930] = {.lex_state = 64},
  [931] = {.lex_state = 64},
  [932] = {.lex_state = 64},
  [933] = {.lex_state = 64},
  [934] = {.lex_state = 60},
  [935] = {.lex_state = 60},
  [936] = {.lex_state = 64},
  [937] = {.lex_state = 64},
  [938] = {.lex_state = 60},
  [939] = {.lex_state = 64},
  [940] = {.lex_state = 62},
  [941] = {.lex_state = 64},
  [942] = {.lex_state = 62},
  [943] = {.lex_state = 62},
  [944] = {.lex_state = 62},
  [945] = {.lex_state = 62},
  [946] = {.lex_state = 62},
  [947] = {.lex_state = 62},
  [948] = {.lex_state = 62},
  [949] = {.lex_state = 60},
  [950] = {.lex_state = 64},
  [951] = {.lex_state = 62},
  [952] = {.lex_state = 62},
  [953] = {.lex_state = 62},
  [954] = {.lex_state = 62},
  [955] = {.lex_state = 64},
  [956] = {.lex_state = 64},
  [957] = {.lex_state = 64},
  [958] = {.lex_state = 66},
  [959] = {.lex_state = 64},
  [960] = {.lex_state = 64},
  [961] = {.lex_state = 64},
  [962] = {.lex_state = 64},
  [963] = {.lex_state = 64},
  [964] = {.lex_state = 66},
  [965] = {.lex_state = 64},
  [966] = {.lex_state = 64},
  [967] = {.lex_state = 64},
  [968] = {.lex_state = 64},
  [969] = {.lex_state = 64},
  [970] = {.lex_state = 66},
  [971] = {.lex_state = 64},
  [972] = {.lex_state = 64},
  [973] = {.lex_state = 64},
  [974] = {.lex_state = 64},
  [975] = {.lex_state = 64},
  [976] = {.lex_state = 64},
  [977] = {.lex_state = 64},
  [978] = {.lex_state = 64},
  [979] = {.lex_state = 64},
  [980] = {.lex_state = 64},
  [981] = {.lex_state = 66},
  [982] = {.lex_state = 64},
  [983] = {.lex_state = 62},
  [984] = {.lex_state = 64},
  [985] = {.lex_state = 64},
  [986] = {.lex_state = 64},
  [987] = {.lex_state = 66},
  [988] = {.lex_state = 66},
  [989] = {.lex_state = 64},
  [990] = {.lex_state = 66},
  [991] = {.lex_state = 64},
  [992] = {.lex_state = 64},
  [993] = {.lex_state = 66},
  [994] = {.lex_state = 66},
  [995] = {.lex_state = 66},
  [996] = {.lex_state = 66},
  [997] = {.lex_state = 66},
  [998] = {.lex_state = 64},
  [999] = {.lex_state = 66},
  [1000] = {.lex_state = 64},
  [1001] = {.lex_state = 66},
  [1002] = {.lex_state = 66},
  [1003] = {.lex_state = 64},
  [1004] = {.lex_state = 66},
  [1005] = {.lex_state = 66},
  [1006] = {.lex_state = 64},
  [1007] = {.lex_state = 64},
  [1008] = {.lex_state = 64},
  [1009] = {.lex_state = 64},
  [1010] = {.lex_state = 64},
  [1011] = {.lex_state = 64},
  [1012] = {.lex_state = 64},
  [1013] = {.lex_state = 64},
  [1014] = {.lex_state = 64},
  [1015] = {.lex_state = 64},
  [1016] = {.lex_state = 64},
  [1017] = {.lex_state = 64},
  [1018] = {.lex_state = 66},
  [1019] = {.lex_state = 64},
  [1020] = {.lex_state = 64},
  [1021] = {.lex_state = 66},
  [1022] = {.lex_state = 64},
  [1023] = {.lex_state = 64},
  [1024] = {.lex_state = 64},
  [1025] = {.lex_state = 64},
  [1026] = {.lex_state = 64},
  [1027] = {.lex_state = 64},
  [1028] = {.lex_state = 64},
  [1029] = {.lex_state = 64},
  [1030] = {.lex_state = 64},
  [1031] = {.lex_state = 64},
  [1032] = {.lex_state = 66},
  [1033] = {.lex_state = 66},
  [1034] = {.lex_state = 64},
  [1035] = {.lex_state = 64},
  [1036] = {.lex_state = 64},
  [1037] = {.lex_state = 64},
  [1038] = {.lex_state = 64},
  [1039] = {.lex_state = 66},
  [1040] = {.lex_state = 64},
  [1041] = {.lex_state = 64},
  [1042] = {.lex_state = 64},
  [1043] = {.lex_state = 66},
  [1044] = {.lex_state = 64},
  [1045] = {.lex_state = 64},
  [1046] = {.lex_state = 64},
  [1047] = {.lex_state = 66},
  [1048] = {.lex_state = 64},
  [1049] = {.lex_state = 64},
  [1050] = {.lex_state = 66},
  [1051] = {.lex_state = 64},
  [1052] = {.lex_state = 66},
  [1053] = {.lex_state = 66},
  [1054] = {.lex_state = 66},
  [1055] = {.lex_state = 66},
  [1056] = {.lex_state = 66},
  [1057] = {.lex_state = 66},
  [1058] = {.lex_state = 66},
  [1059] = {.lex_state = 64},
  [1060] = {.lex_state = 66},
  [1061] = {.lex_state = 64},
  [1062] = {.lex_state = 64},
  [1063] = {.lex_state = 66},
  [1064] = {.lex_state = 66},
  [1065] = {.lex_state = 66},
  [1066] = {.lex_state = 64},
  [1067] = {.lex_state = 64},
  [1068] = {.lex_state = 64},
  [1069] = {.lex_state = 64},
  [1070] = {.lex_state = 64},
  [1071] = {.lex_state = 66},
  [1072] = {.lex_state = 66},
  [1073] = {.lex_state = 66},
  [1074] = {.lex_state = 66},
  [1075] = {.lex_state = 66},
  [1076] = {.lex_state = 66},
  [1077] = {.lex_state = 66},
  [1078] = {.lex_state = 66},
  [1079] = {.lex_state = 66},
  [1080] = {.lex_state = 66},
  [1081] = {.lex_state = 66},
  [1082] = {.lex_state = 64},
  [1083] = {.lex_state = 64},
  [1084] = {.lex_state = 66},
  [1085] = {.lex_state = 64},
  [1086] = {.lex_state = 64},
  [1087] = {.lex_state = 66},
  [1088] = {.lex_state = 66},
  [1089] = {.lex_state = 64},
  [1090] = {.lex_state = 64},
  [1091] = {.lex_state = 64},
  [1092] = {.lex_state = 64},
  [1093] = {.lex_state = 64},
  [1094] = {.lex_state = 64},
  [1095] = {.lex_state = 65},
  [1096] = {.lex_state = 60},
  [1097] = {.lex_state = 65},
  [1098] = {.lex_state = 60},
  [1099] = {.lex_state = 60},
  [1100] = {.lex_state = 60},
  [1101] = {.lex_state = 60},
  [1102] = {.lex_state = 60},
  [1103] = {.lex_state = 65},
  [1104] = {.lex_state = 64},
  [1105] = {.lex_state = 65},
  [1106] = {.lex_state = 65},
  [1107] = {.lex_state = 65},
  [1108] = {.lex_state = 65},
  [1109] = {.lex_state = 65},
  [1110] = {.lex_state = 65},
  [1111] = {.lex_state = 65},
  [1112] = {.lex_state = 64},
  [1113] = {.lex_state = 64},
  [1114] = {.lex_state = 65},
  [1115] = {.lex_state = 65},
  [1116] = {.lex_state = 65},
  [1117] = {.lex_state = 60},
  [1118] = {.lex_state = 65},
  [1119] = {.lex_state = 60},
  [1120] = {.lex_state = 60},
  [1121] = {.lex_state = 64},
  [1122] = {.lex_state = 64},
  [1123] = {.lex_state = 65},
  [1124] = {.lex_state = 65},
  [1125] = {.lex_state = 65},
  [1126] = {.lex_state = 65},
  [1127] = {.lex_state = 60},
  [1128] = {.lex_state = 60},
  [1129] = {.lex_state = 60},
  [1130] = {.lex_state = 60},
  [1131] = {.lex_state = 60},
  [1132] = {.lex_state = 60},
  [1133] = {.lex_state = 60},
  [1134] = {.lex_state = 60},
  [1135] = {.lex_state = 60},
  [1136] = {.lex_state = 64},
  [1137] = {.lex_state = 64},
  [1138] = {.lex_state = 60},
  [1139] = {.lex_state = 71},
  [1140] = {.lex_state = 71},
  [1141] = {.lex_state = 70},
  [1142] = {.lex_state = 70},
  [1143] = {.lex_state = 71},
  [1144] = {.lex_state = 71},
  [1145] = {.lex_state = 70},
  [1146] = {.lex_state = 70},
  [1147] = {.lex_state = 70},
  [1148] = {.lex_state = 71},
  [1149] = {.lex_state = 71},
  [1150] = {.lex_state = 70},
  [1151] = {.lex_state = 70},
  [1152] = {.lex_state = 60},
  [1153] = {.lex_state = 64},
  [1154] = {.lex_state = 71},
  [1155] = {.lex_state = 71},
  [1156] = {.lex_state = 71},
  [1157] = {.lex_state = 60},
  [1158] = {.lex_state = 71},
  [1159] = {.lex_state = 71},
  [1160] = {.lex_state = 71},
  [1161] = {.lex_state = 70},
  [1162] = {.lex_state = 70},
  [1163] = {.lex_state = 64},
  [1164] = {.lex_state = 70},
  [1165] = {.lex_state = 60},
  [1166] = {.lex_state = 64},
  [1167] = {.lex_state = 70},
  [1168] = {.lex_state = 70},
  [1169] = {.lex_state = 60},
  [1170] = {.lex_state = 71},
  [1171] = {.lex_state = 60},
  [1172] = {.lex_state = 71},
  [1173] = {.lex_state = 70},
  [1174] = {.lex_state = 70},
  [1175] = {.lex_state = 70},
  [1176] = {.lex_state = 71},
  [1177] = {.lex_state = 71},
  [1178] = {.lex_state = 70},
  [1179] = {.lex_state = 70},
  [1180] = {.lex_state = 71},
  [1181] = {.lex_state = 71},
  [1182] = {.lex_state = 70},
  [1183] = {.lex_state = 140},
  [1184] = {.lex_state = 140},
  [1185] = {.lex_state = 140},
  [1186] = {.lex_state = 140},
  [1187] = {.lex_state = 140},
  [1188] = {.lex_state = 140},
  [1189] = {.lex_state = 140},
  [1190] = {.lex_state = 140},
  [1191] = {.lex_state = 140},
  [1192] = {.lex_state = 140},
  [1193] = {.lex_state = 64},
  [1194] = {.lex_state = 64},
  [1195] = {.lex_state = 64},
  [1196] = {.lex_state = 64},
  [1197] = {.lex_state = 64},
  [1198] = {.lex_state = 64},
  [1199] = {.lex_state = 64},
  [1200] = {.lex_state = 64},
  [1201] = {.lex_state = 62},
  [1202] = {.lex_state = 62},
  [1203] = {.lex_state = 62},
  [1204] = {.lex_state = 62},
  [1205] = {.lex_state = 62},
  [1206] = {.lex_state = 62},
  [1207] = {.lex_state = 62},
  [1208] = {.lex_state = 62},
  [1209] = {.lex_state = 62},
  [1210] = {.lex_state = 62},
  [1211] = {.lex_state = 62},
  [1212] = {.lex_state = 62},
  [1213] = {.lex_state = 62},
  [1214] = {.lex_state = 64},
  [1215] = {.lex_state = 64},
  [1216] = {.lex_state = 64},
  [1217] = {.lex_state = 64},
  [1218] = {.lex_state = 64},
  [1219] = {.lex_state = 64},
  [1220] = {.lex_state = 64},
  [1221] = {.lex_state = 64},
  [1222] = {.lex_state = 64},
  [1223] = {.lex_state = 64},
  [1224] = {.lex_state = 64},
  [1225] = {.lex_state = 64},
  [1226] = {.lex_state = 64},
  [1227] = {.lex_state = 64},
  [1228] = {.lex_state = 64},
  [1229] = {.lex_state = 64},
  [1230] = {.lex_state = 64},
  [1231] = {.lex_state = 64},
  [1232] = {.lex_state = 64},
  [1233] = {.lex_state = 64},
  [1234] = {.lex_state = 64},
  [1235] = {.lex_state = 64},
  [1236] = {.lex_state = 64},
  [1237] = {.lex_state = 64},
  [1238] = {.lex_state = 64},
  [1239] = {.lex_state = 64},
  [1240] = {.lex_state = 64},
  [1241] = {.lex_state = 64},
  [1242] = {.lex_state = 64},
  [1243] = {.lex_state = 64},
  [1244] = {.lex_state = 66},
  [1245] = {.lex_state = 64},
  [1246] = {.lex_state = 64},
  [1247] = {.lex_state = 66},
  [1248] = {.lex_state = 64},
  [1249] = {.lex_state = 66},
  [1250] = {.lex_state = 66},
  [1251] = {.lex_state = 66},
  [1252] = {.lex_state = 66},
  [1253] = {.lex_state = 66},
  [1254] = {.lex_state = 66},
  [1255] = {.lex_state = 64},
  [1256] = {.lex_state = 66},
  [1257] = {.lex_state = 66},
  [1258] = {.lex_state = 66},
  [1259] = {.lex_state = 66},
  [1260] = {.lex_state = 66},
  [1261] = {.lex_state = 64},
  [1262] = {.lex_state = 64},
  [1263] = {.lex_state = 64},
  [1264] = {.lex_state = 65},
  [1265] = {.lex_state = 64},
  [1266] = {.lex_state = 64},
  [1267] = {.lex_state = 65},
  [1268] = {.lex_state = 64},
  [1269] = {.lex_state = 64},
  [1270] = {.lex_state = 64},
  [1271] = {.lex_state = 65},
  [1272] = {.lex_state = 64},
  [1273] = {.lex_state = 65},
  [1274] = {.lex_state = 60},
  [1275] = {.lex_state = 60},
  [1276] = {.lex_state = 60},
  [1277] = {.lex_state = 60},
  [1278] = {.lex_state = 60},
  [1279] = {.lex_state = 60},
  [1280] = {.lex_state = 60},
  [1281] = {.lex_state = 64},
  [1282] = {.lex_state = 60},
  [1283] = {.lex_state = 60},
  [1284] = {.lex_state = 60},
  [1285] = {.lex_state = 60},
  [1286] = {.lex_state = 60},
  [1287] = {.lex_state = 64},
  [1288] = {.lex_state = 60},
  [1289] = {.lex_state = 60},
  [1290] = {.lex_state = 60},
  [1291] = {.lex_state = 60},
  [1292] = {.lex_state = 60},
  [1293] = {.lex_state = 60},
  [1294] = {.lex_state = 60},
  [1295] = {.lex_state = 64},
  [1296] = {.lex_state = 60},
  [1297] = {.lex_state = 64},
  [1298] = {.lex_state = 64},
  [1299] = {.lex_state = 60},
  [1300] = {.lex_state = 60},
  [1301] = {.lex_state = 60},
  [1302] = {.lex_state = 60},
  [1303] = {.lex_state = 60},
  [1304] = {.lex_state = 60},
  [1305] = {.lex_state = 60},
  [1306] = {.lex_state = 64},
  [1307] = {.lex_state = 60},
  [1308] = {.lex_state = 60},
  [1309] = {.lex_state = 64},
  [1310] = {.lex_state = 60},
  [1311] = {.lex_state = 60},
  [1312] = {.lex_state = 60},
  [1313] = {.lex_state = 60},
  [1314] = {.lex_state = 60},
  [1315] = {.lex_state = 60},
  [1316] = {.lex_state = 60},
  [1317] = {.lex_state = 64},
  [1318] = {.lex_state = 60},
  [1319] = {.lex_state = 60},
  [1320] = {.lex_state = 60},
  [1321] = {.lex_state = 60},
  [1322] = {.lex_state = 60},
  [1323] = {.lex_state = 60},
  [1324] = {.lex_state = 60},
  [1325] = {.lex_state = 64},
  [1326] = {.lex_state = 64},
  [1327] = {.lex_state = 60},
  [1328] = {.lex_state = 60},
  [1329] = {.lex_state = 64},
  [1330] = {.lex_state = 60},
  [1331] = {.lex_state = 60},
  [1332] = {.lex_state = 60},
  [1333] = {.lex_state = 64},
  [1334] = {.lex_state = 64},
  [1335] = {.lex_state = 60},
  [1336] = {.lex_state = 64},
  [1337] = {.lex_state = 60},
  [1338] = {.lex_state = 60},
  [1339] = {.lex_state = 64},
  [1340] = {.lex_state = 64},
  [1341] = {.lex_state = 60},
  [1342] = {.lex_state = 60},
  [1343] = {.lex_state = 64},
  [1344] = {.lex_state = 64},
  [1345] = {.lex_state = 60},
  [1346] = {.lex_state = 64},
  [1347] = {.lex_state = 60},
  [1348] = {.lex_state = 60},
  [1349] = {.lex_state = 60},
  [1350] = {.lex_state = 60},
  [1351] = {.lex_state = 60},
  [1352] = {.lex_state = 60},
  [1353] = {.lex_state = 60},
  [1354] = {.lex_state = 60},
  [1355] = {.lex_state = 64},
  [1356] = {.lex_state = 60},
  [1357] = {.lex_state = 60},
  [1358] = {.lex_state = 60},
  [1359] = {.lex_state = 60},
  [1360] = {.lex_state = 60},
  [1361] = {.lex_state = 60},
  [1362] = {.lex_state = 64},
  [1363] = {.lex_state = 60},
  [1364] = {.lex_state = 64},
  [1365] = {.lex_state = 60},
  [1366] = {.lex_state = 60},
  [1367] = {.lex_state = 60},
  [1368] = {.lex_state = 64},
  [1369] = {.lex_state = 64},
  [1370] = {.lex_state = 60},
  [1371] = {.lex_state = 60},
  [1372] = {.lex_state = 60},
  [1373] = {.lex_state = 64},
  [1374] = {.lex_state = 60},
  [1375] = {.lex_state = 64},
  [1376] = {.lex_state = 60},
  [1377] = {.lex_state = 60},
  [1378] = {.lex_state = 60},
  [1379] = {.lex_state = 60},
  [1380] = {.lex_state = 60},
  [1381] = {.lex_state = 60},
  [1382] = {.lex_state = 60},
  [1383] = {.lex_state = 64},
  [1384] = {.lex_state = 60},
  [1385] = {.lex_state = 64},
  [1386] = {.lex_state = 64},
  [1387] = {.lex_state = 60},
  [1388] = {.lex_state = 60},
  [1389] = {.lex_state = 64},
  [1390] = {.lex_state = 64},
  [1391] = {.lex_state = 64},
  [1392] = {.lex_state = 64},
  [1393] = {.lex_state = 64},
  [1394] = {.lex_state = 64},
  [1395] = {.lex_state = 64},
  [1396] = {.lex_state = 64},
  [1397] = {.lex_state = 64},
  [1398] = {.lex_state = 64},
  [1399] = {.lex_state = 64},
  [1400] = {.lex_state = 64},
  [1401] = {.lex_state = 64},
  [1402] = {.lex_state = 65},
  [1403] = {.lex_state = 64},
  [1404] = {.lex_state = 64},
  [1405] = {.lex_state = 64},
  [1406] = {.lex_state = 64},
  [1407] = {.lex_state = 64},
  [1408] = {.lex_state = 64},
  [1409] = {.lex_state = 64},
  [1410] = {.lex_state = 64},
  [1411] = {.lex_state = 64},
  [1412] = {.lex_state = 64},
  [1413] = {.lex_state = 64},
  [1414] = {.lex_state = 31},
  [1415] = {.lex_state = 65},
  [1416] = {.lex_state = 64},
  [1417] = {.lex_state = 64},
  [1418] = {.lex_state = 59},
  [1419] = {.lex_state = 59},
  [1420] = {.lex_state = 64},
  [1421] = {.lex_state = 64},
  [1422] = {.lex_state = 64},
  [1423] = {.lex_state = 64},
  [1424] = {.lex_state = 65},
  [1425] = {.lex_state = 64},
  [1426] = {.lex_state = 64},
  [1427] = {.lex_state = 65},
  [1428] = {.lex_state = 64},
  [1429] = {.lex_state = 64},
  [1430] = {.lex_state = 64},
  [1431] = {.lex_state = 64},
  [1432] = {.lex_state = 64},
  [1433] = {.lex_state = 59},
  [1434] = {.lex_state = 59},
  [1435] = {.lex_state = 65},
  [1436] = {.lex_state = 59},
  [1437] = {.lex_state = 59},
  [1438] = {.lex_state = 59},
  [1439] = {.lex_state = 59},
  [1440] = {.lex_state = 59},
  [1441] = {.lex_state = 59},
  [1442] = {.lex_state = 59},
  [1443] = {.lex_state = 64},
  [1444] = {.lex_state = 59},
  [1445] = {.lex_state = 64},
  [1446] = {.lex_state = 59},
  [1447] = {.lex_state = 59},
  [1448] = {.lex_state = 59},
  [1449] = {.lex_state = 59},
  [1450] = {.lex_state = 65},
  [1451] = {.lex_state = 59},
  [1452] = {.lex_state = 59},
  [1453] = {.lex_state = 64},
  [1454] = {.lex_state = 59},
  [1455] = {.lex_state = 59},
  [1456] = {.lex_state = 59},
  [1457] = {.lex_state = 64},
  [1458] = {.lex_state = 59},
  [1459] = {.lex_state = 59},
  [1460] = {.lex_state = 65},
  [1461] = {.lex_state = 65},
  [1462] = {.lex_state = 65},
  [1463] = {.lex_state = 65},
  [1464] = {.lex_state = 65},
  [1465] = {.lex_state = 59},
  [1466] = {.lex_state = 65},
  [1467] = {.lex_state = 65},
  [1468] = {.lex_state = 65},
  [1469] = {.lex_state = 65},
  [1470] = {.lex_state = 65},
  [1471] = {.lex_state = 65},
  [1472] = {.lex_state = 64},
  [1473] = {.lex_state = 65},
  [1474] = {.lex_state = 65},
  [1475] = {.lex_state = 65},
  [1476] = {.lex_state = 59},
  [1477] = {.lex_state = 59},
  [1478] = {.lex_state = 59},
  [1479] = {.lex_state = 59},
  [1480] = {.lex_state = 59},
  [1481] = {.lex_state = 59},
  [1482] = {.lex_state = 59},
  [1483] = {.lex_state = 59},
  [1484] = {.lex_state = 59},
  [1485] = {.lex_state = 59},
  [1486] = {.lex_state = 59},
  [1487] = {.lex_state = 59},
  [1488] = {.lex_state = 59},
  [1489] = {.lex_state = 59},
  [1490] = {.lex_state = 59},
  [1491] = {.lex_state = 59},
  [1492] = {.lex_state = 59},
  [1493] = {.lex_state = 59},
  [1494] = {.lex_state = 59},
  [1495] = {.lex_state = 59},
  [1496] = {.lex_state = 31},
  [1497] = {.lex_state = 64},
  [1498] = {.lex_state = 64},
  [1499] = {.lex_state = 31},
  [1500] = {.lex_state = 31},
  [1501] = {.lex_state = 31},
  [1502] = {.lex_state = 31},
  [1503] = {.lex_state = 31},
  [1504] = {.lex_state = 64},
  [1505] = {.lex_state = 64},
  [1506] = {.lex_state = 31},
  [1507] = {.lex_state = 64},
  [1508] = {.lex_state = 64},
  [1509] = {.lex_state = 31},
  [1510] = {.lex_state = 31},
  [1511] = {.lex_state = 31},
  [1512] = {.lex_state = 64},
  [1513] = {.lex_state = 31},
  [1514] = {.lex_state = 64},
  [1515] = {.lex_state = 64},
  [1516] = {.lex_state = 31},
  [1517] = {.lex_state = 64},
  [1518] = {.lex_state = 64},
  [1519] = {.lex_state = 31},
  [1520] = {.lex_state = 31},
  [1521] = {.lex_state = 31},
  [1522] = {.lex_state = 65},
  [1523] = {.lex_state = 64},
  [1524] = {.lex_state = 31},
  [1525] = {.lex_state = 31},
  [1526] = {.lex_state = 31},
  [1527] = {.lex_state = 31},
  [1528] = {.lex_state = 31},
  [1529] = {.lex_state = 31},
  [1530] = {.lex_state = 31},
  [1531] = {.lex_state = 31},
  [1532] = {.lex_state = 31},
  [1533] = {.lex_state = 31},
  [1534] = {.lex_state = 31},
  [1535] = {.lex_state = 31},
  [1536] = {.lex_state = 31},
  [1537] = {.lex_state = 31},
  [1538] = {.lex_state = 31},
  [1539] = {.lex_state = 31},
  [1540] = {.lex_state = 64},
  [1541] = {.lex_state = 64},
  [1542] = {.lex_state = 31},
  [1543] = {.lex_state = 64},
  [1544] = {.lex_state = 31},
  [1545] = {.lex_state = 65},
  [1546] = {.lex_state = 31},
  [1547] = {.lex_state = 31},
  [1548] = {.lex_state = 64},
  [1549] = {.lex_state = 64},
  [1550] = {.lex_state = 64},
  [1551] = {.lex_state = 64},
  [1552] = {.lex_state = 64},
  [1553] = {.lex_state = 64},
  [1554] = {.lex_state = 64},
  [1555] = {.lex_state = 64},
  [1556] = {.lex_state = 64},
  [1557] = {.lex_state = 64},
  [1558] = {.lex_state = 64},
  [1559] = {.lex_state = 64},
  [1560] = {.lex_state = 64},
  [1561] = {.lex_state = 64},
  [1562] = {.lex_state = 64},
  [1563] = {.lex_state = 64},
  [1564] = {.lex_state = 64},
  [1565] = {.lex_state = 64},
  [1566] = {.lex_state = 64},
  [1567] = {.lex_state = 64},
  [1568] = {.lex_state = 64},
  [1569] = {.lex_state = 64},
  [1570] = {.lex_state = 64},
  [1571] = {.lex_state = 64},
  [1572] = {.lex_state = 64},
  [1573] = {.lex_state = 64},
  [1574] = {.lex_state = 64},
  [1575] = {.lex_state = 64},
  [1576] = {.lex_state = 64},
  [1577] = {.lex_state = 64},
  [1578] = {.lex_state = 64},
  [1579] = {.lex_state = 62},
  [1580] = {.lex_state = 64},
  [1581] = {.lex_state = 64},
  [1582] = {.lex_state = 64},
  [1583] = {.lex_state = 64},
  [1584] = {.lex_state = 64},
  [1585] = {.lex_state = 64},
  [1586] = {.lex_state = 64},
  [1587] = {.lex_state = 64},
  [1588] = {.lex_state = 64},
  [1589] = {.lex_state = 64},
  [1590] = {.lex_state = 69},
  [1591] = {.lex_state = 64},
  [1592] = {.lex_state = 64},
  [1593] = {.lex_state = 64},
  [1594] = {.lex_state = 64},
  [1595] = {.lex_state = 64},
  [1596] = {.lex_state = 64},
  [1597] = {.lex_state = 64},
  [1598] = {.lex_state = 64},
  [1599] = {.lex_state = 64},
  [1600] = {.lex_state = 64},
  [1601] = {.lex_state = 64},
  [1602] = {.lex_state = 69},
  [1603] = {.lex_state = 64},
  [1604] = {.lex_state = 64},
  [1605] = {.lex_state = 64},
  [1606] = {.lex_state = 64},
  [1607] = {.lex_state = 64},
  [1608] = {.lex_state = 64},
  [1609] = {.lex_state = 64},
  [1610] = {.lex_state = 64},
  [1611] = {.lex_state = 62},
  [1612] = {.lex_state = 64},
  [1613] = {.lex_state = 66},
  [1614] = {.lex_state = 64},
  [1615] = {.lex_state = 64},
  [1616] = {.lex_state = 69},
  [1617] = {.lex_state = 66},
  [1618] = {.lex_state = 64},
  [1619] = {.lex_state = 66},
  [1620] = {.lex_state = 64},
  [1621] = {.lex_state = 64},
  [1622] = {.lex_state = 64},
  [1623] = {.lex_state = 60},
  [1624] = {.lex_state = 64},
  [1625] = {.lex_state = 62},
  [1626] = {.lex_state = 64},
  [1627] = {.lex_state = 62},
  [1628] = {.lex_state = 64},
  [1629] = {.lex_state = 0},
  [1630] = {.lex_state = 64},
  [1631] = {.lex_state = 64},
  [1632] = {.lex_state = 140},
  [1633] = {.lex_state = 64},
  [1634] = {.lex_state = 140},
  [1635] = {.lex_state = 64},
  [1636] = {.lex_state = 0},
  [1637] = {.lex_state = 64},
  [1638] = {.lex_state = 64},
  [1639] = {.lex_state = 140},
  [1640] = {.lex_state = 140},
  [1641] = {.lex_state = 64},
  [1642] = {.lex_state = 64},
  [1643] = {.lex_state = 64},
  [1644] = {.lex_state = 64},
  [1645] = {.lex_state = 64},
  [1646] = {.lex_state = 140},
  [1647] = {.lex_state = 64},
  [1648] = {.lex_state = 64},
  [1649] = {.lex_state = 68},
  [1650] = {.lex_state = 140},
  [1651] = {.lex_state = 64},
  [1652] = {.lex_state = 140},
  [1653] = {.lex_state = 60},
  [1654] = {.lex_state = 140},
  [1655] = {.lex_state = 64},
  [1656] = {.lex_state = 140},
  [1657] = {.lex_state = 60},
  [1658] = {.lex_state = 140},
  [1659] = {.lex_state = 60},
  [1660] = {.lex_state = 68},
  [1661] = {.lex_state = 140},
  [1662] = {.lex_state = 68},
  [1663] = {.lex_state = 140},
  [1664] = {.lex_state = 140},
  [1665] = {.lex_state = 68},
  [1666] = {.lex_state = 140},
  [1667] = {.lex_state = 140},
  [1668] = {.lex_state = 60},
  [1669] = {.lex_state = 140},
  [1670] = {.lex_state = 64},
  [1671] = {.lex_state = 68},
  [1672] = {.lex_state = 60},
  [1673] = {.lex_state = 140},
  [1674] = {.lex_state = 64},
  [1675] = {.lex_state = 64},
  [1676] = {.lex_state = 62},
  [1677] = {.lex_state = 62},
  [1678] = {.lex_state = 140},
  [1679] = {.lex_state = 0},
  [1680] = {.lex_state = 140},
  [1681] = {.lex_state = 64},
  [1682] = {.lex_state = 66},
  [1683] = {.lex_state = 66},
  [1684] = {.lex_state = 64},
  [1685] = {.lex_state = 140},
  [1686] = {.lex_state = 64},
  [1687] = {.lex_state = 140},
  [1688] = {.lex_state = 66},
  [1689] = {.lex_state = 140},
  [1690] = {.lex_state = 140},
  [1691] = {.lex_state = 140},
  [1692] = {.lex_state = 62},
  [1693] = {.lex_state = 140},
  [1694] = {.lex_state = 140},
  [1695] = {.lex_state = 66},
  [1696] = {.lex_state = 66},
  [1697] = {.lex_state = 140},
  [1698] = {.lex_state = 66},
  [1699] = {.lex_state = 140},
  [1700] = {.lex_state = 140},
  [1701] = {.lex_state = 66},
  [1702] = {.lex_state = 64},
  [1703] = {.lex_state = 66},
  [1704] = {.lex_state = 140},
  [1705] = {.lex_state = 64},
  [1706] = {.lex_state = 64},
  [1707] = {.lex_state = 66},
  [1708] = {.lex_state = 66},
  [1709] = {.lex_state = 140},
  [1710] = {.lex_state = 64},
  [1711] = {.lex_state = 140},
  [1712] = {.lex_state = 0},
  [1713] = {.lex_state = 66},
  [1714] = {.lex_state = 140},
  [1715] = {.lex_state = 64},
  [1716] = {.lex_state = 140},
  [1717] = {.lex_state = 64},
  [1718] = {.lex_state = 140},
  [1719] = {.lex_state = 64},
  [1720] = {.lex_state = 64},
  [1721] = {.lex_state = 64},
  [1722] = {.lex_state = 0},
  [1723] = {.lex_state = 140},
  [1724] = {.lex_state = 140},
  [1725] = {.lex_state = 64},
  [1726] = {.lex_state = 64},
  [1727] = {.lex_state = 64},
  [1728] = {.lex_state = 64},
  [1729] = {.lex_state = 140},
  [1730] = {.lex_state = 140},
  [1731] = {.lex_state = 64},
  [1732] = {.lex_state = 64},
  [1733] = {.lex_state = 64},
  [1734] = {.lex_state = 0},
  [1735] = {.lex_state = 62},
  [1736] = {.lex_state = 64},
  [1737] = {.lex_state = 64},
  [1738] = {.lex_state = 66},
  [1739] = {.lex_state = 69},
  [1740] = {.lex_state = 64},
  [1741] = {.lex_state = 140},
  [1742] = {.lex_state = 0},
  [1743] = {.lex_state = 140},
  [1744] = {.lex_state = 140},
  [1745] = {.lex_state = 64},
  [1746] = {.lex_state = 64},
  [1747] = {.lex_state = 64},
  [1748] = {.lex_state = 64},
  [1749] = {.lex_state = 64},
  [1750] = {.lex_state = 140},
  [1751] = {.lex_state = 140},
  [1752] = {.lex_state = 64},
  [1753] = {.lex_state = 64},
  [1754] = {.lex_state = 64},
  [1755] = {.lex_state = 140},
  [1756] = {.lex_state = 64},
  [1757] = {.lex_state = 64},
  [1758] = {.lex_state = 0},
  [1759] = {.lex_state = 66},
  [1760] = {.lex_state = 64},
  [1761] = {.lex_state = 69},
  [1762] = {.lex_state = 69},
  [1763] = {.lex_state = 64},
  [1764] = {.lex_state = 69},
  [1765] = {.lex_state = 69},
  [1766] = {.lex_state = 66},
  [1767] = {.lex_state = 64},
  [1768] = {.lex_state = 69},
  [1769] = {.lex_state = 64},
  [1770] = {.lex_state = 69},
  [1771] = {.lex_state = 140},
  [1772] = {.lex_state = 64},
  [1773] = {.lex_state = 140},
  [1774] = {.lex_state = 64},
  [1775] = {.lex_state = 64},
  [1776] = {.lex_state = 69},
  [1777] = {.lex_state = 62},
  [1778] = {.lex_state = 69},
  [1779] = {.lex_state = 0},
  [1780] = {.lex_state = 69},
  [1781] = {.lex_state = 69},
  [1782] = {.lex_state = 64},
  [1783] = {.lex_state = 140},
  [1784] = {.lex_state = 55},
  [1785] = {.lex_state = 140},
  [1786] = {.lex_state = 140},
  [1787] = {.lex_state = 64},
  [1788] = {.lex_state = 140},
  [1789] = {.lex_state = 140},
  [1790] = {.lex_state = 64},
  [1791] = {.lex_state = 140},
  [1792] = {.lex_state = 140},
  [1793] = {.lex_state = 64},
  [1794] = {.lex_state = 140},
  [1795] = {.lex_state = 62},
  [1796] = {.lex_state = 140},
  [1797] = {.lex_state = 140},
  [1798] = {.lex_state = 140},
  [1799] = {.lex_state = 140},
  [1800] = {.lex_state = 140},
  [1801] = {.lex_state = 140},
  [1802] = {.lex_state = 66},
  [1803] = {.lex_state = 64},
  [1804] = {.lex_state = 38},
  [1805] = {.lex_state = 64},
  [1806] = {.lex_state = 55},
  [1807] = {.lex_state = 40},
  [1808] = {.lex_state = 40},
  [1809] = {.lex_state = 38},
  [1810] = {.lex_state = 64},
  [1811] = {.lex_state = 64},
  [1812] = {.lex_state = 64},
  [1813] = {.lex_state = 64},
  [1814] = {.lex_state = 64},
  [1815] = {.lex_state = 0},
  [1816] = {.lex_state = 64},
  [1817] = {.lex_state = 64},
  [1818] = {.lex_state = 64},
  [1819] = {.lex_state = 38},
  [1820] = {.lex_state = 64},
  [1821] = {.lex_state = 45},
  [1822] = {.lex_state = 62},
  [1823] = {.lex_state = 62},
  [1824] = {.lex_state = 64},
  [1825] = {.lex_state = 64},
  [1826] = {.lex_state = 40},
  [1827] = {.lex_state = 0},
  [1828] = {.lex_state = 40},
  [1829] = {.lex_state = 66},
  [1830] = {.lex_state = 62},
  [1831] = {.lex_state = 64},
  [1832] = {.lex_state = 140},
  [1833] = {.lex_state = 64},
  [1834] = {.lex_state = 64},
  [1835] = {.lex_state = 38},
  [1836] = {.lex_state = 0},
  [1837] = {.lex_state = 64},
  [1838] = {.lex_state = 0},
  [1839] = {.lex_state = 64},
  [1840] = {.lex_state = 40},
  [1841] = {.lex_state = 0},
  [1842] = {.lex_state = 64},
  [1843] = {.lex_state = 64},
  [1844] = {.lex_state = 64},
  [1845] = {.lex_state = 64},
  [1846] = {.lex_state = 38},
  [1847] = {.lex_state = 40},
  [1848] = {.lex_state = 0},
  [1849] = {.lex_state = 64},
  [1850] = {.lex_state = 62},
  [1851] = {.lex_state = 64},
  [1852] = {.lex_state = 140},
  [1853] = {.lex_state = 64},
  [1854] = {.lex_state = 64},
  [1855] = {.lex_state = 64},
  [1856] = {.lex_state = 64},
  [1857] = {.lex_state = 45},
  [1858] = {.lex_state = 64},
  [1859] = {.lex_state = 45},
  [1860] = {.lex_state = 38},
  [1861] = {.lex_state = 0},
  [1862] = {.lex_state = 38},
  [1863] = {.lex_state = 64},
  [1864] = {.lex_state = 0},
  [1865] = {.lex_state = 45},
  [1866] = {.lex_state = 40},
  [1867] = {.lex_state = 64},
  [1868] = {.lex_state = 0},
  [1869] = {.lex_state = 40},
  [1870] = {.lex_state = 64},
  [1871] = {.lex_state = 45},
  [1872] = {.lex_state = 38},
  [1873] = {.lex_state = 40},
  [1874] = {.lex_state = 64},
  [1875] = {.lex_state = 0},
  [1876] = {.lex_state = 64},
  [1877] = {.lex_state = 38},
  [1878] = {.lex_state = 64},
  [1879] = {.lex_state = 0},
  [1880] = {.lex_state = 64},
  [1881] = {.lex_state = 0},
  [1882] = {.lex_state = 0},
  [1883] = {.lex_state = 0},
  [1884] = {.lex_state = 55},
  [1885] = {.lex_state = 0},
  [1886] = {.lex_state = 0},
  [1887] = {.lex_state = 0},
  [1888] = {.lex_state = 0},
  [1889] = {.lex_state = 0},
  [1890] = {.lex_state = 0},
  [1891] = {.lex_state = 0},
  [1892] = {.lex_state = 0},
  [1893] = {.lex_state = 0},
  [1894] = {.lex_state = 0},
  [1895] = {.lex_state = 0},
  [1896] = {.lex_state = 42},
  [1897] = {.lex_state = 0},
  [1898] = {.lex_state = 0},
  [1899] = {.lex_state = 0},
  [1900] = {.lex_state = 0},
  [1901] = {.lex_state = 0},
  [1902] = {.lex_state = 0},
  [1903] = {.lex_state = 0},
  [1904] = {.lex_state = 64},
  [1905] = {.lex_state = 0},
  [1906] = {.lex_state = 0},
  [1907] = {.lex_state = 0},
  [1908] = {.lex_state = 0},
  [1909] = {.lex_state = 0},
  [1910] = {.lex_state = 0},
  [1911] = {.lex_state = 0},
  [1912] = {.lex_state = 0},
  [1913] = {.lex_state = 64},
  [1914] = {.lex_state = 0},
  [1915] = {.lex_state = 64},
  [1916] = {.lex_state = 0},
  [1917] = {.lex_state = 64},
  [1918] = {.lex_state = 0},
  [1919] = {.lex_state = 0},
  [1920] = {.lex_state = 0},
  [1921] = {.lex_state = 0},
  [1922] = {.lex_state = 0},
  [1923] = {.lex_state = 0},
  [1924] = {.lex_state = 55},
  [1925] = {.lex_state = 55},
  [1926] = {.lex_state = 0},
  [1927] = {.lex_state = 0},
  [1928] = {.lex_state = 0},
  [1929] = {.lex_state = 42},
  [1930] = {.lex_state = 0},
  [1931] = {.lex_state = 0},
  [1932] = {.lex_state = 64},
  [1933] = {.lex_state = 0},
  [1934] = {.lex_state = 0},
  [1935] = {.lex_state = 0},
  [1936] = {.lex_state = 0},
  [1937] = {.lex_state = 0},
  [1938] = {.lex_state = 0},
  [1939] = {.lex_state = 64},
  [1940] = {.lex_state = 0},
  [1941] = {.lex_state = 0},
  [1942] = {.lex_state = 0},
  [1943] = {.lex_state = 0},
  [1944] = {.lex_state = 0},
  [1945] = {.lex_state = 0},
  [1946] = {.lex_state = 0},
  [1947] = {.lex_state = 0},
  [1948] = {.lex_state = 0},
  [1949] = {.lex_state = 0},
  [1950] = {.lex_state = 0},
  [1951] = {.lex_state = 0},
  [1952] = {.lex_state = 0},
  [1953] = {.lex_state = 0},
  [1954] = {.lex_state = 0},
  [1955] = {.lex_state = 45},
  [1956] = {.lex_state = 0},
  [1957] = {.lex_state = 55},
  [1958] = {.lex_state = 0},
  [1959] = {.lex_state = 0},
  [1960] = {.lex_state = 0},
  [1961] = {.lex_state = 0},
  [1962] = {.lex_state = 0},
  [1963] = {.lex_state = 55},
  [1964] = {.lex_state = 0},
  [1965] = {.lex_state = 0},
  [1966] = {.lex_state = 0},
  [1967] = {.lex_state = 55},
  [1968] = {.lex_state = 64},
  [1969] = {.lex_state = 42},
  [1970] = {.lex_state = 0},
  [1971] = {.lex_state = 64},
  [1972] = {.lex_state = 42},
  [1973] = {.lex_state = 0},
  [1974] = {.lex_state = 0},
  [1975] = {.lex_state = 0},
  [1976] = {.lex_state = 0},
  [1977] = {.lex_state = 0},
  [1978] = {.lex_state = 0},
  [1979] = {.lex_state = 0},
  [1980] = {.lex_state = 64},
  [1981] = {.lex_state = 55},
  [1982] = {.lex_state = 0},
  [1983] = {.lex_state = 0},
  [1984] = {.lex_state = 0},
  [1985] = {.lex_state = 0},
  [1986] = {.lex_state = 0},
  [1987] = {.lex_state = 0},
  [1988] = {.lex_state = 0},
  [1989] = {.lex_state = 0},
  [1990] = {.lex_state = 0},
  [1991] = {.lex_state = 42},
  [1992] = {.lex_state = 0},
  [1993] = {.lex_state = 0},
  [1994] = {.lex_state = 45},
  [1995] = {.lex_state = 0},
  [1996] = {.lex_state = 0},
  [1997] = {.lex_state = 0},
  [1998] = {.lex_state = 0},
  [1999] = {.lex_state = 0},
  [2000] = {.lex_state = 0},
  [2001] = {.lex_state = 0},
  [2002] = {.lex_state = 0},
  [2003] = {.lex_state = 0},
  [2004] = {.lex_state = 0},
  [2005] = {.lex_state = 0},
  [2006] = {.lex_state = 0},
  [2007] = {.lex_state = 0},
  [2008] = {.lex_state = 0},
  [2009] = {.lex_state = 0},
  [2010] = {.lex_state = 0},
  [2011] = {.lex_state = 0},
  [2012] = {.lex_state = 0},
  [2013] = {.lex_state = 0},
  [2014] = {.lex_state = 0},
  [2015] = {.lex_state = 64},
  [2016] = {.lex_state = 0},
  [2017] = {.lex_state = 45},
  [2018] = {.lex_state = 64},
  [2019] = {.lex_state = 64},
  [2020] = {.lex_state = 45},
  [2021] = {.lex_state = 0},
  [2022] = {.lex_state = 0},
  [2023] = {.lex_state = 55},
  [2024] = {.lex_state = 0},
  [2025] = {.lex_state = 64},
  [2026] = {.lex_state = 41},
  [2027] = {.lex_state = 0},
  [2028] = {.lex_state = 55},
  [2029] = {.lex_state = 41},
  [2030] = {.lex_state = 140},
  [2031] = {.lex_state = 0},
  [2032] = {.lex_state = 0},
  [2033] = {.lex_state = 41},
  [2034] = {.lex_state = 64},
  [2035] = {.lex_state = 41},
  [2036] = {.lex_state = 140},
  [2037] = {.lex_state = 140},
  [2038] = {.lex_state = 0},
  [2039] = {.lex_state = 140},
  [2040] = {.lex_state = 0},
  [2041] = {.lex_state = 64},
  [2042] = {.lex_state = 140},
  [2043] = {.lex_state = 0},
  [2044] = {.lex_state = 140},
  [2045] = {.lex_state = 140},
  [2046] = {.lex_state = 140},
  [2047] = {.lex_state = 0},
  [2048] = {.lex_state = 140},
  [2049] = {.lex_state = 0},
  [2050] = {.lex_state = 0},
  [2051] = {.lex_state = 41},
  [2052] = {.lex_state = 140},
  [2053] = {.lex_state = 140},
  [2054] = {.lex_state = 140},
  [2055] = {.lex_state = 41},
  [2056] = {.lex_state = 140},
  [2057] = {.lex_state = 64},
  [2058] = {.lex_state = 0},
  [2059] = {.lex_state = 0},
  [2060] = {.lex_state = 41},
  [2061] = {.lex_state = 140},
  [2062] = {.lex_state = 140},
  [2063] = {.lex_state = 140},
  [2064] = {.lex_state = 0},
  [2065] = {.lex_state = 0},
  [2066] = {.lex_state = 140},
  [2067] = {.lex_state = 140},
  [2068] = {.lex_state = 0},
  [2069] = {.lex_state = 0},
  [2070] = {.lex_state = 140},
  [2071] = {.lex_state = 140},
  [2072] = {.lex_state = 140},
  [2073] = {.lex_state = 0},
  [2074] = {.lex_state = 64},
  [2075] = {.lex_state = 41},
  [2076] = {.lex_state = 140},
  [2077] = {.lex_state = 0},
  [2078] = {.lex_state = 0},
  [2079] = {.lex_state = 64},
  [2080] = {.lex_state = 140},
  [2081] = {.lex_state = 140},
  [2082] = {.lex_state = 0},
  [2083] = {.lex_state = 140},
  [2084] = {.lex_state = 0},
  [2085] = {.lex_state = 41},
  [2086] = {.lex_state = 0},
  [2087] = {.lex_state = 0},
  [2088] = {.lex_state = 0},
  [2089] = {.lex_state = 0},
  [2090] = {.lex_state = 0},
  [2091] = {.lex_state = 64},
  [2092] = {.lex_state = 0},
  [2093] = {.lex_state = 41},
  [2094] = {.lex_state = 55},
  [2095] = {.lex_state = 0},
  [2096] = {.lex_state = 0},
  [2097] = {.lex_state = 140},
  [2098] = {.lex_state = 41},
  [2099] = {.lex_state = 140},
  [2100] = {.lex_state = 140},
  [2101] = {.lex_state = 64},
  [2102] = {.lex_state = 0},
  [2103] = {.lex_state = 41},
  [2104] = {.lex_state = 41},
  [2105] = {.lex_state = 41},
  [2106] = {.lex_state = 140},
  [2107] = {.lex_state = 0},
  [2108] = {.lex_state = 41},
  [2109] = {.lex_state = 140},
  [2110] = {.lex_state = 41},
  [2111] = {.lex_state = 0},
  [2112] = {.lex_state = 41},
  [2113] = {.lex_state = 41},
  [2114] = {.lex_state = 0},
  [2115] = {.lex_state = 41},
  [2116] = {.lex_state = 0},
  [2117] = {.lex_state = 41},
  [2118] = {.lex_state = 0},
  [2119] = {.lex_state = 0},
  [2120] = {.lex_state = 0},
  [2121] = {.lex_state = 0},
  [2122] = {.lex_state = 0},
  [2123] = {.lex_state = 41},
  [2124] = {.lex_state = 53},
  [2125] = {.lex_state = 0},
  [2126] = {.lex_state = 0},
  [2127] = {.lex_state = 53},
  [2128] = {.lex_state = 64},
  [2129] = {.lex_state = 53},
  [2130] = {.lex_state = 53},
  [2131] = {.lex_state = 42},
  [2132] = {.lex_state = 0},
  [2133] = {.lex_state = 42},
  [2134] = {.lex_state = 53},
  [2135] = {.lex_state = 0},
  [2136] = {.lex_state = 140},
  [2137] = {.lex_state = 42},
  [2138] = {.lex_state = 42},
  [2139] = {.lex_state = 0},
  [2140] = {.lex_state = 53},
  [2141] = {.lex_state = 42},
  [2142] = {.lex_state = 0},
  [2143] = {.lex_state = 0},
  [2144] = {.lex_state = 0},
  [2145] = {.lex_state = 53},
  [2146] = {.lex_state = 42},
  [2147] = {.lex_state = 42},
  [2148] = {.lex_state = 0},
  [2149] = {.lex_state = 0},
  [2150] = {.lex_state = 0},
  [2151] = {.lex_state = 42},
  [2152] = {.lex_state = 0},
  [2153] = {.lex_state = 0},
  [2154] = {.lex_state = 42},
  [2155] = {.lex_state = 0},
  [2156] = {.lex_state = 0},
  [2157] = {.lex_state = 0},
  [2158] = {.lex_state = 42},
  [2159] = {.lex_state = 0},
  [2160] = {.lex_state = 0},
  [2161] = {.lex_state = 42},
  [2162] = {.lex_state = 0},
  [2163] = {.lex_state = 0},
  [2164] = {.lex_state = 0},
  [2165] = {.lex_state = 0},
  [2166] = {.lex_state = 64},
  [2167] = {.lex_state = 53},
  [2168] = {.lex_state = 42},
  [2169] = {.lex_state = 42},
  [2170] = {.lex_state = 53},
  [2171] = {.lex_state = 42},
  [2172] = {.lex_state = 64},
  [2173] = {.lex_state = 140},
  [2174] = {.lex_state = 42},
  [2175] = {.lex_state = 42},
  [2176] = {.lex_state = 53},
  [2177] = {.lex_state = 42},
  [2178] = {.lex_state = 64},
  [2179] = {.lex_state = 64},
  [2180] = {.lex_state = 64},
  [2181] = {.lex_state = 64},
  [2182] = {.lex_state = 42},
  [2183] = {.lex_state = 0},
  [2184] = {.lex_state = 53},
  [2185] = {.lex_state = 0},
  [2186] = {.lex_state = 53},
  [2187] = {.lex_state = 53},
  [2188] = {.lex_state = 64},
  [2189] = {.lex_state = 0},
  [2190] = {.lex_state = 0},
  [2191] = {.lex_state = 53},
  [2192] = {.lex_state = 42},
  [2193] = {.lex_state = 64},
  [2194] = {.lex_state = 42},
  [2195] = {.lex_state = 0},
  [2196] = {.lex_state = 53},
  [2197] = {.lex_state = 53},
  [2198] = {.lex_state = 53},
  [2199] = {.lex_state = 0},
  [2200] = {.lex_state = 0},
  [2201] = {.lex_state = 53},
  [2202] = {.lex_state = 42},
  [2203] = {.lex_state = 0},
  [2204] = {.lex_state = 0},
  [2205] = {.lex_state = 0},
  [2206] = {.lex_state = 0},
  [2207] = {.lex_state = 53},
  [2208] = {.lex_state = 0},
  [2209] = {.lex_state = 64},
  [2210] = {.lex_state = 0},
  [2211] = {.lex_state = 64},
  [2212] = {.lex_state = 0},
  [2213] = {.lex_state = 0},
  [2214] = {.lex_state = 42},
  [2215] = {.lex_state = 0},
  [2216] = {.lex_state = 53},
  [2217] = {.lex_state = 64},
  [2218] = {.lex_state = 53},
  [2219] = {.lex_state = 64},
  [2220] = {.lex_state = 0},
  [2221] = {.lex_state = 0},
  [2222] = {.lex_state = 0},
  [2223] = {.lex_state = 64},
  [2224] = {.lex_state = 64},
  [2225] = {.lex_state = 53},
  [2226] = {.lex_state = 0},
  [2227] = {.lex_state = 64},
  [2228] = {.lex_state = 64},
  [2229] = {.lex_state = 64},
  [2230] = {.lex_state = 64},
  [2231] = {.lex_state = 0},
  [2232] = {.lex_state = 0},
  [2233] = {.lex_state = 53},
  [2234] = {.lex_state = 53},
  [2235] = {.lex_state = 42},
  [2236] = {.lex_state = 53},
  [2237] = {.lex_state = 53},
  [2238] = {.lex_state = 0},
  [2239] = {.lex_state = 0},
  [2240] = {.lex_state = 0},
  [2241] = {.lex_state = 0},
  [2242] = {.lex_state = 64},
  [2243] = {.lex_state = 53},
  [2244] = {.lex_state = 53},
  [2245] = {.lex_state = 0},
  [2246] = {.lex_state = 0},
  [2247] = {.lex_state = 53},
  [2248] = {.lex_state = 53},
  [2249] = {.lex_state = 42},
  [2250] = {.lex_state = 0},
  [2251] = {.lex_state = 53},
  [2252] = {.lex_state = 0},
  [2253] = {.lex_state = 42},
  [2254] = {.lex_state = 0},
  [2255] = {.lex_state = 0},
  [2256] = {.lex_state = 53},
  [2257] = {.lex_state = 0},
  [2258] = {.lex_state = 53},
  [2259] = {.lex_state = 0},
  [2260] = {.lex_state = 0},
  [2261] = {.lex_state = 53},
  [2262] = {.lex_state = 53},
  [2263] = {.lex_state = 0},
  [2264] = {.lex_state = 0},
  [2265] = {.lex_state = 0},
  [2266] = {.lex_state = 0},
  [2267] = {.lex_state = 64},
  [2268] = {.lex_state = 64},
  [2269] = {.lex_state = 0},
  [2270] = {.lex_state = 0},
  [2271] = {.lex_state = 0},
  [2272] = {.lex_state = 0},
  [2273] = {.lex_state = 0},
  [2274] = {.lex_state = 0},
  [2275] = {.lex_state = 0},
  [2276] = {.lex_state = 64},
  [2277] = {.lex_state = 0},
  [2278] = {.lex_state = 140},
  [2279] = {.lex_state = 42},
  [2280] = {.lex_state = 0},
  [2281] = {.lex_state = 53},
  [2282] = {.lex_state = 0},
  [2283] = {.lex_state = 140},
  [2284] = {.lex_state = 140},
  [2285] = {.lex_state = 53},
  [2286] = {.lex_state = 0},
  [2287] = {.lex_state = 0},
  [2288] = {.lex_state = 64},
  [2289] = {.lex_state = 0},
  [2290] = {.lex_state = 0},
  [2291] = {.lex_state = 0},
  [2292] = {.lex_state = 64},
  [2293] = {.lex_state = 53},
  [2294] = {.lex_state = 0},
  [2295] = {.lex_state = 42},
  [2296] = {.lex_state = 53},
  [2297] = {.lex_state = 42},
  [2298] = {.lex_state = 64},
  [2299] = {.lex_state = 64},
  [2300] = {.lex_state = 0},
  [2301] = {.lex_state = 0},
  [2302] = {.lex_state = 42},
  [2303] = {.lex_state = 0},
  [2304] = {.lex_state = 0},
  [2305] = {.lex_state = 42},
  [2306] = {.lex_state = 64},
  [2307] = {.lex_state = 64},
  [2308] = {.lex_state = 0},
  [2309] = {.lex_state = 0},
  [2310] = {.lex_state = 0},
  [2311] = {.lex_state = 42},
  [2312] = {.lex_state = 0},
  [2313] = {.lex_state = 140},
  [2314] = {.lex_state = 0},
  [2315] = {.lex_state = 0},
  [2316] = {.lex_state = 53},
  [2317] = {.lex_state = 64},
  [2318] = {.lex_state = 0},
  [2319] = {.lex_state = 0},
  [2320] = {.lex_state = 0},
  [2321] = {.lex_state = 42},
  [2322] = {.lex_state = 64},
  [2323] = {.lex_state = 64},
  [2324] = {.lex_state = 42},
  [2325] = {.lex_state = 64},
  [2326] = {.lex_state = 64},
  [2327] = {.lex_state = 64},
  [2328] = {.lex_state = 64},
  [2329] = {.lex_state = 0},
  [2330] = {.lex_state = 0},
  [2331] = {.lex_state = 53},
  [2332] = {.lex_state = 0},
  [2333] = {.lex_state = 64},
  [2334] = {.lex_state = 0},
  [2335] = {.lex_state = 140},
  [2336] = {.lex_state = 0},
  [2337] = {.lex_state = 0},
  [2338] = {.lex_state = 53},
  [2339] = {.lex_state = 0},
  [2340] = {.lex_state = 64},
  [2341] = {.lex_state = 53},
  [2342] = {.lex_state = 0},
  [2343] = {.lex_state = 0},
  [2344] = {.lex_state = 0},
  [2345] = {.lex_state = 53},
  [2346] = {.lex_state = 0},
  [2347] = {.lex_state = 0},
  [2348] = {.lex_state = 64},
  [2349] = {.lex_state = 0},
  [2350] = {.lex_state = 0},
  [2351] = {.lex_state = 53},
  [2352] = {.lex_state = 64},
  [2353] = {.lex_state = 64},
  [2354] = {.lex_state = 64},
  [2355] = {.lex_state = 42},
  [2356] = {.lex_state = 53},
  [2357] = {.lex_state = 42},
  [2358] = {.lex_state = 0},
  [2359] = {.lex_state = 53},
  [2360] = {.lex_state = 140},
  [2361] = {.lex_state = 53},
  [2362] = {.lex_state = 53},
  [2363] = {.lex_state = 140},
  [2364] = {.lex_state = 0},
  [2365] = {.lex_state = 0},
  [2366] = {.lex_state = 0},
  [2367] = {.lex_state = 0},
  [2368] = {.lex_state = 64},
  [2369] = {.lex_state = 0},
  [2370] = {.lex_state = 64},
  [2371] = {.lex_state = 64},
  [2372] = {.lex_state = 0},
  [2373] = {.lex_state = 140},
  [2374] = {.lex_state = 42},
  [2375] = {.lex_state = 53},
  [2376] = {.lex_state = 64},
  [2377] = {.lex_state = 53},
  [2378] = {.lex_state = 0},
  [2379] = {.lex_state = 0},
  [2380] = {.lex_state = 0},
  [2381] = {.lex_state = 0},
  [2382] = {.lex_state = 0},
  [2383] = {.lex_state = 0},
  [2384] = {.lex_state = 140},
  [2385] = {.lex_state = 0},
  [2386] = {.lex_state = 140},
  [2387] = {.lex_state = 64},
  [2388] = {.lex_state = 140},
  [2389] = {.lex_state = 0},
  [2390] = {.lex_state = 0},
  [2391] = {.lex_state = 0},
  [2392] = {.lex_state = 0},
  [2393] = {.lex_state = 53},
  [2394] = {.lex_state = 0},
  [2395] = {.lex_state = 64},
  [2396] = {.lex_state = 53},
  [2397] = {.lex_state = 42},
  [2398] = {.lex_state = 0},
  [2399] = {.lex_state = 0},
  [2400] = {.lex_state = 53},
  [2401] = {.lex_state = 53},
  [2402] = {.lex_state = 0},
  [2403] = {.lex_state = 64},
  [2404] = {.lex_state = 42},
  [2405] = {.lex_state = 53},
  [2406] = {.lex_state = 53},
  [2407] = {.lex_state = 0},
  [2408] = {.lex_state = 140},
  [2409] = {.lex_state = 0},
  [2410] = {.lex_state = 0},
  [2411] = {.lex_state = 53},
  [2412] = {.lex_state = 0},
  [2413] = {.lex_state = 140},
  [2414] = {.lex_state = 53},
  [2415] = {.lex_state = 64},
  [2416] = {.lex_state = 140},
  [2417] = {.lex_state = 0},
  [2418] = {.lex_state = 53},
  [2419] = {.lex_state = 140},
  [2420] = {.lex_state = 0},
  [2421] = {.lex_state = 64},
  [2422] = {.lex_state = 140},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [aux_sym_preproc_include_token1] = ACTIONS(1),
    [aux_sym_preproc_def_token1] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [aux_sym_preproc_if_token1] = ACTIONS(1),
    [aux_sym_preproc_if_token2] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1),
    [aux_sym_preproc_else_token1] = ACTIONS(1),
    [aux_sym_preproc_elif_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1),
    [sym_preproc_directive] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_defined] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym___extension__] = ACTIONS(1),
    [anon_sym_typedef] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym___attribute__] = ACTIONS(1),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym___declspec] = ACTIONS(1),
    [anon_sym___based] = ACTIONS(1),
    [anon_sym___cdecl] = ACTIONS(1),
    [anon_sym___clrcall] = ACTIONS(1),
    [anon_sym___stdcall] = ACTIONS(1),
    [anon_sym___fastcall] = ACTIONS(1),
    [anon_sym___thiscall] = ACTIONS(1),
    [anon_sym___vectorcall] = ACTIONS(1),
    [sym_ms_restrict_modifier] = ACTIONS(1),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(1),
    [sym_ms_signed_ptr_modifier] = ACTIONS(1),
    [anon_sym__unaligned] = ACTIONS(1),
    [anon_sym___unaligned] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_signed] = ACTIONS(1),
    [anon_sym_unsigned] = ACTIONS(1),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_auto] = ACTIONS(1),
    [anon_sym_register] = ACTIONS(1),
    [anon_sym_inline] = ACTIONS(1),
    [anon_sym___inline] = ACTIONS(1),
    [anon_sym___inline__] = ACTIONS(1),
    [anon_sym___forceinline] = ACTIONS(1),
    [anon_sym_thread_local] = ACTIONS(1),
    [anon_sym___thread] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_constexpr] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_restrict] = ACTIONS(1),
    [anon_sym___restrict__] = ACTIONS(1),
    [anon_sym__Atomic] = ACTIONS(1),
    [anon_sym__Noreturn] = ACTIONS(1),
    [anon_sym_noreturn] = ACTIONS(1),
    [sym_primitive_type] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym___try] = ACTIONS(1),
    [anon_sym___except] = ACTIONS(1),
    [anon_sym___finally] = ACTIONS(1),
    [anon_sym___leave] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(1),
    [anon_sym___alignof__] = ACTIONS(1),
    [anon_sym___alignof] = ACTIONS(1),
    [anon_sym__alignof] = ACTIONS(1),
    [anon_sym_alignof] = ACTIONS(1),
    [anon_sym__Alignof] = ACTIONS(1),
    [anon_sym_offsetof] = ACTIONS(1),
    [anon_sym__Generic] = ACTIONS(1),
    [anon_sym_asm] = ACTIONS(1),
    [anon_sym___asm__] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [sym_number_literal] = ACTIONS(1),
    [anon_sym_L_SQUOTE] = ACTIONS(1),
    [anon_sym_u_SQUOTE] = ACTIONS(1),
    [anon_sym_U_SQUOTE] = ACTIONS(1),
    [anon_sym_u8_SQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_L_DQUOTE] = ACTIONS(1),
    [anon_sym_u_DQUOTE] = ACTIONS(1),
    [anon_sym_U_DQUOTE] = ACTIONS(1),
    [anon_sym_u8_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [anon_sym_NULL] = ACTIONS(1),
    [anon_sym_nullptr] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_translation_unit] = STATE(2259),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym__old_style_function_definition] = STATE(511),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1410),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(912),
    [sym_compound_statement] = STATE(53),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1091),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(53),
    [sym_labeled_statement] = STATE(53),
    [sym__top_level_expression_statement] = STATE(53),
    [sym_if_statement] = STATE(53),
    [sym_switch_statement] = STATE(53),
    [sym_case_statement] = STATE(53),
    [sym_while_statement] = STATE(53),
    [sym_do_statement] = STATE(53),
    [sym_for_statement] = STATE(53),
    [sym_return_statement] = STATE(53),
    [sym_break_statement] = STATE(53),
    [sym_continue_statement] = STATE(53),
    [sym_goto_statement] = STATE(53),
    [sym__expression] = STATE(1387),
    [sym__expression_not_binary] = STATE(1388),
    [sym__string] = STATE(1388),
    [sym_conditional_expression] = STATE(1388),
    [sym_assignment_expression] = STATE(1388),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(1388),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(1388),
    [sym_cast_expression] = STATE(1388),
    [sym_sizeof_expression] = STATE(1388),
    [sym_alignof_expression] = STATE(1388),
    [sym_offsetof_expression] = STATE(1388),
    [sym_generic_expression] = STATE(1388),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(1388),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(1388),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(1388),
    [sym_concatenated_string] = STATE(1388),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(1388),
    [sym__empty_declaration] = STATE(53),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_translation_unit_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(463),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(31),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_default] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(91),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym_preproc_include] = STATE(9),
    [sym_preproc_def] = STATE(9),
    [sym_preproc_function_def] = STATE(9),
    [sym_preproc_call] = STATE(9),
    [sym_preproc_if] = STATE(9),
    [sym_preproc_ifdef] = STATE(9),
    [sym_preproc_else] = STATE(2145),
    [sym_preproc_elif] = STATE(2145),
    [sym_preproc_elifdef] = STATE(2145),
    [sym_function_definition] = STATE(9),
    [sym__old_style_function_definition] = STATE(170),
    [sym_declaration] = STATE(9),
    [sym_type_definition] = STATE(9),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1405),
    [sym_linkage_specification] = STATE(9),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(917),
    [sym_compound_statement] = STATE(9),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1093),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_case_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_goto_statement] = STATE(9),
    [sym_seh_try_statement] = STATE(9),
    [sym_seh_leave_statement] = STATE(9),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(9),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(9),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(432),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(109),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(117),
    [sym_preproc_directive] = ACTIONS(119),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym___extension__] = ACTIONS(123),
    [anon_sym_typedef] = ACTIONS(125),
    [anon_sym_extern] = ACTIONS(127),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_do] = ACTIONS(141),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_continue] = ACTIONS(149),
    [anon_sym_goto] = ACTIONS(151),
    [anon_sym___try] = ACTIONS(153),
    [anon_sym___leave] = ACTIONS(155),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [3] = {
    [sym_preproc_include] = STATE(7),
    [sym_preproc_def] = STATE(7),
    [sym_preproc_function_def] = STATE(7),
    [sym_preproc_call] = STATE(7),
    [sym_preproc_if] = STATE(7),
    [sym_preproc_ifdef] = STATE(7),
    [sym_preproc_else] = STATE(2140),
    [sym_preproc_elif] = STATE(2140),
    [sym_preproc_elifdef] = STATE(2140),
    [sym_function_definition] = STATE(7),
    [sym__old_style_function_definition] = STATE(170),
    [sym_declaration] = STATE(7),
    [sym_type_definition] = STATE(7),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1405),
    [sym_linkage_specification] = STATE(7),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(917),
    [sym_compound_statement] = STATE(7),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1093),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_case_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_goto_statement] = STATE(7),
    [sym_seh_try_statement] = STATE(7),
    [sym_seh_leave_statement] = STATE(7),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(7),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(7),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(432),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(161),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(117),
    [sym_preproc_directive] = ACTIONS(119),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym___extension__] = ACTIONS(123),
    [anon_sym_typedef] = ACTIONS(125),
    [anon_sym_extern] = ACTIONS(127),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_do] = ACTIONS(141),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_continue] = ACTIONS(149),
    [anon_sym_goto] = ACTIONS(151),
    [anon_sym___try] = ACTIONS(153),
    [anon_sym___leave] = ACTIONS(155),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym_preproc_include] = STATE(16),
    [sym_preproc_def] = STATE(16),
    [sym_preproc_function_def] = STATE(16),
    [sym_preproc_call] = STATE(16),
    [sym_preproc_if] = STATE(16),
    [sym_preproc_ifdef] = STATE(16),
    [sym_preproc_else] = STATE(2170),
    [sym_preproc_elif] = STATE(2170),
    [sym_preproc_elifdef] = STATE(2170),
    [sym_function_definition] = STATE(16),
    [sym__old_style_function_definition] = STATE(170),
    [sym_declaration] = STATE(16),
    [sym_type_definition] = STATE(16),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1405),
    [sym_linkage_specification] = STATE(16),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(917),
    [sym_compound_statement] = STATE(16),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1093),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_case_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_goto_statement] = STATE(16),
    [sym_seh_try_statement] = STATE(16),
    [sym_seh_leave_statement] = STATE(16),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(16),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(16),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(432),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(163),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(117),
    [sym_preproc_directive] = ACTIONS(119),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym___extension__] = ACTIONS(123),
    [anon_sym_typedef] = ACTIONS(125),
    [anon_sym_extern] = ACTIONS(127),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_do] = ACTIONS(141),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_continue] = ACTIONS(149),
    [anon_sym_goto] = ACTIONS(151),
    [anon_sym___try] = ACTIONS(153),
    [anon_sym___leave] = ACTIONS(155),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [sym_preproc_include] = STATE(16),
    [sym_preproc_def] = STATE(16),
    [sym_preproc_function_def] = STATE(16),
    [sym_preproc_call] = STATE(16),
    [sym_preproc_if] = STATE(16),
    [sym_preproc_ifdef] = STATE(16),
    [sym_preproc_else] = STATE(2281),
    [sym_preproc_elif] = STATE(2281),
    [sym_preproc_elifdef] = STATE(2281),
    [sym_function_definition] = STATE(16),
    [sym__old_style_function_definition] = STATE(170),
    [sym_declaration] = STATE(16),
    [sym_type_definition] = STATE(16),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1405),
    [sym_linkage_specification] = STATE(16),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(917),
    [sym_compound_statement] = STATE(16),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1093),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_case_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_goto_statement] = STATE(16),
    [sym_seh_try_statement] = STATE(16),
    [sym_seh_leave_statement] = STATE(16),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(16),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(16),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(432),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(165),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(117),
    [sym_preproc_directive] = ACTIONS(119),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym___extension__] = ACTIONS(123),
    [anon_sym_typedef] = ACTIONS(125),
    [anon_sym_extern] = ACTIONS(127),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_do] = ACTIONS(141),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_continue] = ACTIONS(149),
    [anon_sym_goto] = ACTIONS(151),
    [anon_sym___try] = ACTIONS(153),
    [anon_sym___leave] = ACTIONS(155),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [6] = {
    [sym_preproc_include] = STATE(16),
    [sym_preproc_def] = STATE(16),
    [sym_preproc_function_def] = STATE(16),
    [sym_preproc_call] = STATE(16),
    [sym_preproc_if] = STATE(16),
    [sym_preproc_ifdef] = STATE(16),
    [sym_preproc_else] = STATE(2418),
    [sym_preproc_elif] = STATE(2418),
    [sym_preproc_elifdef] = STATE(2418),
    [sym_function_definition] = STATE(16),
    [sym__old_style_function_definition] = STATE(170),
    [sym_declaration] = STATE(16),
    [sym_type_definition] = STATE(16),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1405),
    [sym_linkage_specification] = STATE(16),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(917),
    [sym_compound_statement] = STATE(16),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1093),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_case_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_goto_statement] = STATE(16),
    [sym_seh_try_statement] = STATE(16),
    [sym_seh_leave_statement] = STATE(16),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(16),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(16),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(432),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(167),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(117),
    [sym_preproc_directive] = ACTIONS(119),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym___extension__] = ACTIONS(123),
    [anon_sym_typedef] = ACTIONS(125),
    [anon_sym_extern] = ACTIONS(127),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_do] = ACTIONS(141),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_continue] = ACTIONS(149),
    [anon_sym_goto] = ACTIONS(151),
    [anon_sym___try] = ACTIONS(153),
    [anon_sym___leave] = ACTIONS(155),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [7] = {
    [sym_preproc_include] = STATE(16),
    [sym_preproc_def] = STATE(16),
    [sym_preproc_function_def] = STATE(16),
    [sym_preproc_call] = STATE(16),
    [sym_preproc_if] = STATE(16),
    [sym_preproc_ifdef] = STATE(16),
    [sym_preproc_else] = STATE(2414),
    [sym_preproc_elif] = STATE(2414),
    [sym_preproc_elifdef] = STATE(2414),
    [sym_function_definition] = STATE(16),
    [sym__old_style_function_definition] = STATE(170),
    [sym_declaration] = STATE(16),
    [sym_type_definition] = STATE(16),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1405),
    [sym_linkage_specification] = STATE(16),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(917),
    [sym_compound_statement] = STATE(16),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1093),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_case_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_goto_statement] = STATE(16),
    [sym_seh_try_statement] = STATE(16),
    [sym_seh_leave_statement] = STATE(16),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(16),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(16),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(432),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(117),
    [sym_preproc_directive] = ACTIONS(119),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym___extension__] = ACTIONS(123),
    [anon_sym_typedef] = ACTIONS(125),
    [anon_sym_extern] = ACTIONS(127),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_do] = ACTIONS(141),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_continue] = ACTIONS(149),
    [anon_sym_goto] = ACTIONS(151),
    [anon_sym___try] = ACTIONS(153),
    [anon_sym___leave] = ACTIONS(155),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [8] = {
    [sym_preproc_include] = STATE(4),
    [sym_preproc_def] = STATE(4),
    [sym_preproc_function_def] = STATE(4),
    [sym_preproc_call] = STATE(4),
    [sym_preproc_if] = STATE(4),
    [sym_preproc_ifdef] = STATE(4),
    [sym_preproc_else] = STATE(2207),
    [sym_preproc_elif] = STATE(2207),
    [sym_preproc_elifdef] = STATE(2207),
    [sym_function_definition] = STATE(4),
    [sym__old_style_function_definition] = STATE(170),
    [sym_declaration] = STATE(4),
    [sym_type_definition] = STATE(4),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1405),
    [sym_linkage_specification] = STATE(4),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(917),
    [sym_compound_statement] = STATE(4),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1093),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(4),
    [sym_labeled_statement] = STATE(4),
    [sym_expression_statement] = STATE(4),
    [sym_if_statement] = STATE(4),
    [sym_switch_statement] = STATE(4),
    [sym_case_statement] = STATE(4),
    [sym_while_statement] = STATE(4),
    [sym_do_statement] = STATE(4),
    [sym_for_statement] = STATE(4),
    [sym_return_statement] = STATE(4),
    [sym_break_statement] = STATE(4),
    [sym_continue_statement] = STATE(4),
    [sym_goto_statement] = STATE(4),
    [sym_seh_try_statement] = STATE(4),
    [sym_seh_leave_statement] = STATE(4),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(4),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(4),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(432),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(117),
    [sym_preproc_directive] = ACTIONS(119),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym___extension__] = ACTIONS(123),
    [anon_sym_typedef] = ACTIONS(125),
    [anon_sym_extern] = ACTIONS(127),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_do] = ACTIONS(141),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_continue] = ACTIONS(149),
    [anon_sym_goto] = ACTIONS(151),
    [anon_sym___try] = ACTIONS(153),
    [anon_sym___leave] = ACTIONS(155),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [9] = {
    [sym_preproc_include] = STATE(16),
    [sym_preproc_def] = STATE(16),
    [sym_preproc_function_def] = STATE(16),
    [sym_preproc_call] = STATE(16),
    [sym_preproc_if] = STATE(16),
    [sym_preproc_ifdef] = STATE(16),
    [sym_preproc_else] = STATE(2127),
    [sym_preproc_elif] = STATE(2127),
    [sym_preproc_elifdef] = STATE(2127),
    [sym_function_definition] = STATE(16),
    [sym__old_style_function_definition] = STATE(170),
    [sym_declaration] = STATE(16),
    [sym_type_definition] = STATE(16),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1405),
    [sym_linkage_specification] = STATE(16),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(917),
    [sym_compound_statement] = STATE(16),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1093),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_case_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_goto_statement] = STATE(16),
    [sym_seh_try_statement] = STATE(16),
    [sym_seh_leave_statement] = STATE(16),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(16),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(16),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(432),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(173),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(117),
    [sym_preproc_directive] = ACTIONS(119),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym___extension__] = ACTIONS(123),
    [anon_sym_typedef] = ACTIONS(125),
    [anon_sym_extern] = ACTIONS(127),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_do] = ACTIONS(141),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_continue] = ACTIONS(149),
    [anon_sym_goto] = ACTIONS(151),
    [anon_sym___try] = ACTIONS(153),
    [anon_sym___leave] = ACTIONS(155),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym_preproc_include] = STATE(6),
    [sym_preproc_def] = STATE(6),
    [sym_preproc_function_def] = STATE(6),
    [sym_preproc_call] = STATE(6),
    [sym_preproc_if] = STATE(6),
    [sym_preproc_ifdef] = STATE(6),
    [sym_preproc_else] = STATE(2377),
    [sym_preproc_elif] = STATE(2377),
    [sym_preproc_elifdef] = STATE(2377),
    [sym_function_definition] = STATE(6),
    [sym__old_style_function_definition] = STATE(170),
    [sym_declaration] = STATE(6),
    [sym_type_definition] = STATE(6),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1405),
    [sym_linkage_specification] = STATE(6),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(917),
    [sym_compound_statement] = STATE(6),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1093),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_case_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_goto_statement] = STATE(6),
    [sym_seh_try_statement] = STATE(6),
    [sym_seh_leave_statement] = STATE(6),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(6),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(6),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(432),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(117),
    [sym_preproc_directive] = ACTIONS(119),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym___extension__] = ACTIONS(123),
    [anon_sym_typedef] = ACTIONS(125),
    [anon_sym_extern] = ACTIONS(127),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_do] = ACTIONS(141),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_continue] = ACTIONS(149),
    [anon_sym_goto] = ACTIONS(151),
    [anon_sym___try] = ACTIONS(153),
    [anon_sym___leave] = ACTIONS(155),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [11] = {
    [sym_preproc_include] = STATE(5),
    [sym_preproc_def] = STATE(5),
    [sym_preproc_function_def] = STATE(5),
    [sym_preproc_call] = STATE(5),
    [sym_preproc_if] = STATE(5),
    [sym_preproc_ifdef] = STATE(5),
    [sym_preproc_else] = STATE(2316),
    [sym_preproc_elif] = STATE(2316),
    [sym_preproc_elifdef] = STATE(2316),
    [sym_function_definition] = STATE(5),
    [sym__old_style_function_definition] = STATE(170),
    [sym_declaration] = STATE(5),
    [sym_type_definition] = STATE(5),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1405),
    [sym_linkage_specification] = STATE(5),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(917),
    [sym_compound_statement] = STATE(5),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1093),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(5),
    [sym_labeled_statement] = STATE(5),
    [sym_expression_statement] = STATE(5),
    [sym_if_statement] = STATE(5),
    [sym_switch_statement] = STATE(5),
    [sym_case_statement] = STATE(5),
    [sym_while_statement] = STATE(5),
    [sym_do_statement] = STATE(5),
    [sym_for_statement] = STATE(5),
    [sym_return_statement] = STATE(5),
    [sym_break_statement] = STATE(5),
    [sym_continue_statement] = STATE(5),
    [sym_goto_statement] = STATE(5),
    [sym_seh_try_statement] = STATE(5),
    [sym_seh_leave_statement] = STATE(5),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(5),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(5),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(432),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(117),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(117),
    [sym_preproc_directive] = ACTIONS(119),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym___extension__] = ACTIONS(123),
    [anon_sym_typedef] = ACTIONS(125),
    [anon_sym_extern] = ACTIONS(127),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_do] = ACTIONS(141),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_continue] = ACTIONS(149),
    [anon_sym_goto] = ACTIONS(151),
    [anon_sym___try] = ACTIONS(153),
    [anon_sym___leave] = ACTIONS(155),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [12] = {
    [sym_preproc_include] = STATE(19),
    [sym_preproc_def] = STATE(19),
    [sym_preproc_function_def] = STATE(19),
    [sym_preproc_call] = STATE(19),
    [sym_preproc_if] = STATE(19),
    [sym_preproc_ifdef] = STATE(19),
    [sym_preproc_else] = STATE(2411),
    [sym_preproc_elif] = STATE(2411),
    [sym_function_definition] = STATE(19),
    [sym__old_style_function_definition] = STATE(246),
    [sym_declaration] = STATE(19),
    [sym_type_definition] = STATE(19),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1409),
    [sym_linkage_specification] = STATE(19),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(922),
    [sym_compound_statement] = STATE(19),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1092),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_goto_statement] = STATE(19),
    [sym_seh_try_statement] = STATE(19),
    [sym_seh_leave_statement] = STATE(19),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(19),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(19),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(179),
    [aux_sym_preproc_include_token1] = ACTIONS(181),
    [aux_sym_preproc_def_token1] = ACTIONS(183),
    [aux_sym_preproc_if_token1] = ACTIONS(185),
    [aux_sym_preproc_if_token2] = ACTIONS(187),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(189),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(191),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym___extension__] = ACTIONS(195),
    [anon_sym_typedef] = ACTIONS(197),
    [anon_sym_extern] = ACTIONS(199),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [13] = {
    [sym_preproc_include] = STATE(23),
    [sym_preproc_def] = STATE(23),
    [sym_preproc_function_def] = STATE(23),
    [sym_preproc_call] = STATE(23),
    [sym_preproc_if] = STATE(23),
    [sym_preproc_ifdef] = STATE(23),
    [sym_preproc_else] = STATE(2129),
    [sym_preproc_elif] = STATE(2129),
    [sym_function_definition] = STATE(23),
    [sym__old_style_function_definition] = STATE(246),
    [sym_declaration] = STATE(23),
    [sym_type_definition] = STATE(23),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1409),
    [sym_linkage_specification] = STATE(23),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(922),
    [sym_compound_statement] = STATE(23),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1092),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(23),
    [sym_labeled_statement] = STATE(23),
    [sym_expression_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_switch_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_do_statement] = STATE(23),
    [sym_for_statement] = STATE(23),
    [sym_return_statement] = STATE(23),
    [sym_break_statement] = STATE(23),
    [sym_continue_statement] = STATE(23),
    [sym_goto_statement] = STATE(23),
    [sym_seh_try_statement] = STATE(23),
    [sym_seh_leave_statement] = STATE(23),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(23),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(23),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(179),
    [aux_sym_preproc_include_token1] = ACTIONS(181),
    [aux_sym_preproc_def_token1] = ACTIONS(183),
    [aux_sym_preproc_if_token1] = ACTIONS(185),
    [aux_sym_preproc_if_token2] = ACTIONS(229),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(189),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(191),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym___extension__] = ACTIONS(195),
    [anon_sym_typedef] = ACTIONS(197),
    [anon_sym_extern] = ACTIONS(199),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(2176),
    [sym_preproc_elif] = STATE(2176),
    [sym_function_definition] = STATE(20),
    [sym__old_style_function_definition] = STATE(246),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1409),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(922),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1092),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym_seh_try_statement] = STATE(20),
    [sym_seh_leave_statement] = STATE(20),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(179),
    [aux_sym_preproc_include_token1] = ACTIONS(181),
    [aux_sym_preproc_def_token1] = ACTIONS(183),
    [aux_sym_preproc_if_token1] = ACTIONS(185),
    [aux_sym_preproc_if_token2] = ACTIONS(231),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(189),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(191),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym___extension__] = ACTIONS(195),
    [anon_sym_typedef] = ACTIONS(197),
    [anon_sym_extern] = ACTIONS(199),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(2124),
    [sym_preproc_elif] = STATE(2124),
    [sym_function_definition] = STATE(27),
    [sym__old_style_function_definition] = STATE(246),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1409),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(922),
    [sym_compound_statement] = STATE(27),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1092),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_goto_statement] = STATE(27),
    [sym_seh_try_statement] = STATE(27),
    [sym_seh_leave_statement] = STATE(27),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(27),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(179),
    [aux_sym_preproc_include_token1] = ACTIONS(181),
    [aux_sym_preproc_def_token1] = ACTIONS(183),
    [aux_sym_preproc_if_token1] = ACTIONS(185),
    [aux_sym_preproc_if_token2] = ACTIONS(233),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(189),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(191),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym___extension__] = ACTIONS(195),
    [anon_sym_typedef] = ACTIONS(197),
    [anon_sym_extern] = ACTIONS(199),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [16] = {
    [sym_preproc_include] = STATE(16),
    [sym_preproc_def] = STATE(16),
    [sym_preproc_function_def] = STATE(16),
    [sym_preproc_call] = STATE(16),
    [sym_preproc_if] = STATE(16),
    [sym_preproc_ifdef] = STATE(16),
    [sym_function_definition] = STATE(16),
    [sym__old_style_function_definition] = STATE(170),
    [sym_declaration] = STATE(16),
    [sym_type_definition] = STATE(16),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1405),
    [sym_linkage_specification] = STATE(16),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(917),
    [sym_compound_statement] = STATE(16),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1093),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_case_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_goto_statement] = STATE(16),
    [sym_seh_try_statement] = STATE(16),
    [sym_seh_leave_statement] = STATE(16),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(16),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(16),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(432),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(235),
    [aux_sym_preproc_include_token1] = ACTIONS(238),
    [aux_sym_preproc_def_token1] = ACTIONS(241),
    [aux_sym_preproc_if_token1] = ACTIONS(244),
    [aux_sym_preproc_if_token2] = ACTIONS(247),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(249),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(249),
    [aux_sym_preproc_else_token1] = ACTIONS(247),
    [aux_sym_preproc_elif_token1] = ACTIONS(247),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(247),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(247),
    [sym_preproc_directive] = ACTIONS(252),
    [anon_sym_LPAREN2] = ACTIONS(255),
    [anon_sym_BANG] = ACTIONS(258),
    [anon_sym_TILDE] = ACTIONS(258),
    [anon_sym_DASH] = ACTIONS(261),
    [anon_sym_PLUS] = ACTIONS(261),
    [anon_sym_STAR] = ACTIONS(264),
    [anon_sym_AMP] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(267),
    [anon_sym___extension__] = ACTIONS(270),
    [anon_sym_typedef] = ACTIONS(273),
    [anon_sym_extern] = ACTIONS(276),
    [anon_sym___attribute__] = ACTIONS(279),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(282),
    [anon_sym___declspec] = ACTIONS(285),
    [anon_sym___cdecl] = ACTIONS(288),
    [anon_sym___clrcall] = ACTIONS(288),
    [anon_sym___stdcall] = ACTIONS(288),
    [anon_sym___fastcall] = ACTIONS(288),
    [anon_sym___thiscall] = ACTIONS(288),
    [anon_sym___vectorcall] = ACTIONS(288),
    [anon_sym_LBRACE] = ACTIONS(291),
    [anon_sym_signed] = ACTIONS(294),
    [anon_sym_unsigned] = ACTIONS(294),
    [anon_sym_long] = ACTIONS(294),
    [anon_sym_short] = ACTIONS(294),
    [anon_sym_static] = ACTIONS(297),
    [anon_sym_auto] = ACTIONS(297),
    [anon_sym_register] = ACTIONS(297),
    [anon_sym_inline] = ACTIONS(297),
    [anon_sym___inline] = ACTIONS(297),
    [anon_sym___inline__] = ACTIONS(297),
    [anon_sym___forceinline] = ACTIONS(297),
    [anon_sym_thread_local] = ACTIONS(297),
    [anon_sym___thread] = ACTIONS(297),
    [anon_sym_const] = ACTIONS(300),
    [anon_sym_constexpr] = ACTIONS(300),
    [anon_sym_volatile] = ACTIONS(300),
    [anon_sym_restrict] = ACTIONS(300),
    [anon_sym___restrict__] = ACTIONS(300),
    [anon_sym__Atomic] = ACTIONS(300),
    [anon_sym__Noreturn] = ACTIONS(300),
    [anon_sym_noreturn] = ACTIONS(300),
    [sym_primitive_type] = ACTIONS(303),
    [anon_sym_enum] = ACTIONS(306),
    [anon_sym_struct] = ACTIONS(309),
    [anon_sym_union] = ACTIONS(312),
    [anon_sym_if] = ACTIONS(315),
    [anon_sym_switch] = ACTIONS(318),
    [anon_sym_case] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(324),
    [anon_sym_while] = ACTIONS(327),
    [anon_sym_do] = ACTIONS(330),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(336),
    [anon_sym_break] = ACTIONS(339),
    [anon_sym_continue] = ACTIONS(342),
    [anon_sym_goto] = ACTIONS(345),
    [anon_sym___try] = ACTIONS(348),
    [anon_sym___leave] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(354),
    [anon_sym_PLUS_PLUS] = ACTIONS(354),
    [anon_sym_sizeof] = ACTIONS(357),
    [anon_sym___alignof__] = ACTIONS(360),
    [anon_sym___alignof] = ACTIONS(360),
    [anon_sym__alignof] = ACTIONS(360),
    [anon_sym_alignof] = ACTIONS(360),
    [anon_sym__Alignof] = ACTIONS(360),
    [anon_sym_offsetof] = ACTIONS(363),
    [anon_sym__Generic] = ACTIONS(366),
    [anon_sym_asm] = ACTIONS(369),
    [anon_sym___asm__] = ACTIONS(369),
    [sym_number_literal] = ACTIONS(372),
    [anon_sym_L_SQUOTE] = ACTIONS(375),
    [anon_sym_u_SQUOTE] = ACTIONS(375),
    [anon_sym_U_SQUOTE] = ACTIONS(375),
    [anon_sym_u8_SQUOTE] = ACTIONS(375),
    [anon_sym_SQUOTE] = ACTIONS(375),
    [anon_sym_L_DQUOTE] = ACTIONS(378),
    [anon_sym_u_DQUOTE] = ACTIONS(378),
    [anon_sym_U_DQUOTE] = ACTIONS(378),
    [anon_sym_u8_DQUOTE] = ACTIONS(378),
    [anon_sym_DQUOTE] = ACTIONS(378),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [anon_sym_NULL] = ACTIONS(384),
    [anon_sym_nullptr] = ACTIONS(384),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym_preproc_include] = STATE(24),
    [sym_preproc_def] = STATE(24),
    [sym_preproc_function_def] = STATE(24),
    [sym_preproc_call] = STATE(24),
    [sym_preproc_if] = STATE(24),
    [sym_preproc_ifdef] = STATE(24),
    [sym_preproc_else] = STATE(2293),
    [sym_preproc_elif] = STATE(2293),
    [sym_function_definition] = STATE(24),
    [sym__old_style_function_definition] = STATE(246),
    [sym_declaration] = STATE(24),
    [sym_type_definition] = STATE(24),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1409),
    [sym_linkage_specification] = STATE(24),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(922),
    [sym_compound_statement] = STATE(24),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1092),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(24),
    [sym_labeled_statement] = STATE(24),
    [sym_expression_statement] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_switch_statement] = STATE(24),
    [sym_case_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_do_statement] = STATE(24),
    [sym_for_statement] = STATE(24),
    [sym_return_statement] = STATE(24),
    [sym_break_statement] = STATE(24),
    [sym_continue_statement] = STATE(24),
    [sym_goto_statement] = STATE(24),
    [sym_seh_try_statement] = STATE(24),
    [sym_seh_leave_statement] = STATE(24),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(24),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(24),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(179),
    [aux_sym_preproc_include_token1] = ACTIONS(181),
    [aux_sym_preproc_def_token1] = ACTIONS(183),
    [aux_sym_preproc_if_token1] = ACTIONS(185),
    [aux_sym_preproc_if_token2] = ACTIONS(387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(189),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(191),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym___extension__] = ACTIONS(195),
    [anon_sym_typedef] = ACTIONS(197),
    [anon_sym_extern] = ACTIONS(199),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [18] = {
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(2198),
    [sym_preproc_elif] = STATE(2198),
    [sym_function_definition] = STATE(27),
    [sym__old_style_function_definition] = STATE(246),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1409),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(922),
    [sym_compound_statement] = STATE(27),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1092),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_goto_statement] = STATE(27),
    [sym_seh_try_statement] = STATE(27),
    [sym_seh_leave_statement] = STATE(27),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(27),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(179),
    [aux_sym_preproc_include_token1] = ACTIONS(181),
    [aux_sym_preproc_def_token1] = ACTIONS(183),
    [aux_sym_preproc_if_token1] = ACTIONS(185),
    [aux_sym_preproc_if_token2] = ACTIONS(389),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(189),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(191),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym___extension__] = ACTIONS(195),
    [anon_sym_typedef] = ACTIONS(197),
    [anon_sym_extern] = ACTIONS(199),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(2296),
    [sym_preproc_elif] = STATE(2296),
    [sym_function_definition] = STATE(27),
    [sym__old_style_function_definition] = STATE(246),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1409),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(922),
    [sym_compound_statement] = STATE(27),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1092),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_goto_statement] = STATE(27),
    [sym_seh_try_statement] = STATE(27),
    [sym_seh_leave_statement] = STATE(27),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(27),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(179),
    [aux_sym_preproc_include_token1] = ACTIONS(181),
    [aux_sym_preproc_def_token1] = ACTIONS(183),
    [aux_sym_preproc_if_token1] = ACTIONS(185),
    [aux_sym_preproc_if_token2] = ACTIONS(391),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(189),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(191),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym___extension__] = ACTIONS(195),
    [anon_sym_typedef] = ACTIONS(197),
    [anon_sym_extern] = ACTIONS(199),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [20] = {
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(2130),
    [sym_preproc_elif] = STATE(2130),
    [sym_function_definition] = STATE(27),
    [sym__old_style_function_definition] = STATE(246),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1409),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(922),
    [sym_compound_statement] = STATE(27),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1092),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_goto_statement] = STATE(27),
    [sym_seh_try_statement] = STATE(27),
    [sym_seh_leave_statement] = STATE(27),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(27),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(179),
    [aux_sym_preproc_include_token1] = ACTIONS(181),
    [aux_sym_preproc_def_token1] = ACTIONS(183),
    [aux_sym_preproc_if_token1] = ACTIONS(185),
    [aux_sym_preproc_if_token2] = ACTIONS(393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(189),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(191),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym___extension__] = ACTIONS(195),
    [anon_sym_typedef] = ACTIONS(197),
    [anon_sym_extern] = ACTIONS(199),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [21] = {
    [sym_preproc_include] = STATE(18),
    [sym_preproc_def] = STATE(18),
    [sym_preproc_function_def] = STATE(18),
    [sym_preproc_call] = STATE(18),
    [sym_preproc_if] = STATE(18),
    [sym_preproc_ifdef] = STATE(18),
    [sym_preproc_else] = STATE(2134),
    [sym_preproc_elif] = STATE(2134),
    [sym_function_definition] = STATE(18),
    [sym__old_style_function_definition] = STATE(246),
    [sym_declaration] = STATE(18),
    [sym_type_definition] = STATE(18),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1409),
    [sym_linkage_specification] = STATE(18),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(922),
    [sym_compound_statement] = STATE(18),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1092),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_case_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_goto_statement] = STATE(18),
    [sym_seh_try_statement] = STATE(18),
    [sym_seh_leave_statement] = STATE(18),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(18),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(18),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(179),
    [aux_sym_preproc_include_token1] = ACTIONS(181),
    [aux_sym_preproc_def_token1] = ACTIONS(183),
    [aux_sym_preproc_if_token1] = ACTIONS(185),
    [aux_sym_preproc_if_token2] = ACTIONS(395),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(189),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(191),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym___extension__] = ACTIONS(195),
    [anon_sym_typedef] = ACTIONS(197),
    [anon_sym_extern] = ACTIONS(199),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [22] = {
    [sym_preproc_include] = STATE(25),
    [sym_preproc_def] = STATE(25),
    [sym_preproc_function_def] = STATE(25),
    [sym_preproc_call] = STATE(25),
    [sym_preproc_if] = STATE(25),
    [sym_preproc_ifdef] = STATE(25),
    [sym_preproc_else] = STATE(2285),
    [sym_preproc_elif] = STATE(2285),
    [sym_function_definition] = STATE(25),
    [sym__old_style_function_definition] = STATE(246),
    [sym_declaration] = STATE(25),
    [sym_type_definition] = STATE(25),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1409),
    [sym_linkage_specification] = STATE(25),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(922),
    [sym_compound_statement] = STATE(25),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1092),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_goto_statement] = STATE(25),
    [sym_seh_try_statement] = STATE(25),
    [sym_seh_leave_statement] = STATE(25),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(25),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(25),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(179),
    [aux_sym_preproc_include_token1] = ACTIONS(181),
    [aux_sym_preproc_def_token1] = ACTIONS(183),
    [aux_sym_preproc_if_token1] = ACTIONS(185),
    [aux_sym_preproc_if_token2] = ACTIONS(397),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(189),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(191),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym___extension__] = ACTIONS(195),
    [anon_sym_typedef] = ACTIONS(197),
    [anon_sym_extern] = ACTIONS(199),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [23] = {
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(2167),
    [sym_preproc_elif] = STATE(2167),
    [sym_function_definition] = STATE(27),
    [sym__old_style_function_definition] = STATE(246),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1409),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(922),
    [sym_compound_statement] = STATE(27),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1092),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_goto_statement] = STATE(27),
    [sym_seh_try_statement] = STATE(27),
    [sym_seh_leave_statement] = STATE(27),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(27),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(179),
    [aux_sym_preproc_include_token1] = ACTIONS(181),
    [aux_sym_preproc_def_token1] = ACTIONS(183),
    [aux_sym_preproc_if_token1] = ACTIONS(185),
    [aux_sym_preproc_if_token2] = ACTIONS(399),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(189),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(191),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym___extension__] = ACTIONS(195),
    [anon_sym_typedef] = ACTIONS(197),
    [anon_sym_extern] = ACTIONS(199),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [24] = {
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(2375),
    [sym_preproc_elif] = STATE(2375),
    [sym_function_definition] = STATE(27),
    [sym__old_style_function_definition] = STATE(246),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1409),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(922),
    [sym_compound_statement] = STATE(27),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1092),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_goto_statement] = STATE(27),
    [sym_seh_try_statement] = STATE(27),
    [sym_seh_leave_statement] = STATE(27),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(27),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(179),
    [aux_sym_preproc_include_token1] = ACTIONS(181),
    [aux_sym_preproc_def_token1] = ACTIONS(183),
    [aux_sym_preproc_if_token1] = ACTIONS(185),
    [aux_sym_preproc_if_token2] = ACTIONS(401),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(189),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(191),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym___extension__] = ACTIONS(195),
    [anon_sym_typedef] = ACTIONS(197),
    [anon_sym_extern] = ACTIONS(199),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [25] = {
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(2262),
    [sym_preproc_elif] = STATE(2262),
    [sym_function_definition] = STATE(27),
    [sym__old_style_function_definition] = STATE(246),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1409),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(922),
    [sym_compound_statement] = STATE(27),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1092),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_goto_statement] = STATE(27),
    [sym_seh_try_statement] = STATE(27),
    [sym_seh_leave_statement] = STATE(27),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(27),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(179),
    [aux_sym_preproc_include_token1] = ACTIONS(181),
    [aux_sym_preproc_def_token1] = ACTIONS(183),
    [aux_sym_preproc_if_token1] = ACTIONS(185),
    [aux_sym_preproc_if_token2] = ACTIONS(403),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(189),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(191),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym___extension__] = ACTIONS(195),
    [anon_sym_typedef] = ACTIONS(197),
    [anon_sym_extern] = ACTIONS(199),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [26] = {
    [sym_preproc_include] = STATE(15),
    [sym_preproc_def] = STATE(15),
    [sym_preproc_function_def] = STATE(15),
    [sym_preproc_call] = STATE(15),
    [sym_preproc_if] = STATE(15),
    [sym_preproc_ifdef] = STATE(15),
    [sym_preproc_else] = STATE(2216),
    [sym_preproc_elif] = STATE(2216),
    [sym_function_definition] = STATE(15),
    [sym__old_style_function_definition] = STATE(246),
    [sym_declaration] = STATE(15),
    [sym_type_definition] = STATE(15),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1409),
    [sym_linkage_specification] = STATE(15),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(922),
    [sym_compound_statement] = STATE(15),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1092),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(15),
    [sym_labeled_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_case_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_goto_statement] = STATE(15),
    [sym_seh_try_statement] = STATE(15),
    [sym_seh_leave_statement] = STATE(15),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(15),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(15),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(179),
    [aux_sym_preproc_include_token1] = ACTIONS(181),
    [aux_sym_preproc_def_token1] = ACTIONS(183),
    [aux_sym_preproc_if_token1] = ACTIONS(185),
    [aux_sym_preproc_if_token2] = ACTIONS(405),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(189),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(189),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(191),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym___extension__] = ACTIONS(195),
    [anon_sym_typedef] = ACTIONS(197),
    [anon_sym_extern] = ACTIONS(199),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [27] = {
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_function_definition] = STATE(27),
    [sym__old_style_function_definition] = STATE(246),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1409),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(922),
    [sym_compound_statement] = STATE(27),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1092),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_goto_statement] = STATE(27),
    [sym_seh_try_statement] = STATE(27),
    [sym_seh_leave_statement] = STATE(27),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(27),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(407),
    [aux_sym_preproc_include_token1] = ACTIONS(410),
    [aux_sym_preproc_def_token1] = ACTIONS(413),
    [aux_sym_preproc_if_token1] = ACTIONS(416),
    [aux_sym_preproc_if_token2] = ACTIONS(247),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(419),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(419),
    [aux_sym_preproc_else_token1] = ACTIONS(247),
    [aux_sym_preproc_elif_token1] = ACTIONS(247),
    [sym_preproc_directive] = ACTIONS(422),
    [anon_sym_LPAREN2] = ACTIONS(255),
    [anon_sym_BANG] = ACTIONS(258),
    [anon_sym_TILDE] = ACTIONS(258),
    [anon_sym_DASH] = ACTIONS(261),
    [anon_sym_PLUS] = ACTIONS(261),
    [anon_sym_STAR] = ACTIONS(264),
    [anon_sym_AMP] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym___extension__] = ACTIONS(428),
    [anon_sym_typedef] = ACTIONS(431),
    [anon_sym_extern] = ACTIONS(434),
    [anon_sym___attribute__] = ACTIONS(279),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(282),
    [anon_sym___declspec] = ACTIONS(285),
    [anon_sym___cdecl] = ACTIONS(288),
    [anon_sym___clrcall] = ACTIONS(288),
    [anon_sym___stdcall] = ACTIONS(288),
    [anon_sym___fastcall] = ACTIONS(288),
    [anon_sym___thiscall] = ACTIONS(288),
    [anon_sym___vectorcall] = ACTIONS(288),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_signed] = ACTIONS(294),
    [anon_sym_unsigned] = ACTIONS(294),
    [anon_sym_long] = ACTIONS(294),
    [anon_sym_short] = ACTIONS(294),
    [anon_sym_static] = ACTIONS(297),
    [anon_sym_auto] = ACTIONS(297),
    [anon_sym_register] = ACTIONS(297),
    [anon_sym_inline] = ACTIONS(297),
    [anon_sym___inline] = ACTIONS(297),
    [anon_sym___inline__] = ACTIONS(297),
    [anon_sym___forceinline] = ACTIONS(297),
    [anon_sym_thread_local] = ACTIONS(297),
    [anon_sym___thread] = ACTIONS(297),
    [anon_sym_const] = ACTIONS(300),
    [anon_sym_constexpr] = ACTIONS(300),
    [anon_sym_volatile] = ACTIONS(300),
    [anon_sym_restrict] = ACTIONS(300),
    [anon_sym___restrict__] = ACTIONS(300),
    [anon_sym__Atomic] = ACTIONS(300),
    [anon_sym__Noreturn] = ACTIONS(300),
    [anon_sym_noreturn] = ACTIONS(300),
    [sym_primitive_type] = ACTIONS(303),
    [anon_sym_enum] = ACTIONS(306),
    [anon_sym_struct] = ACTIONS(309),
    [anon_sym_union] = ACTIONS(312),
    [anon_sym_if] = ACTIONS(440),
    [anon_sym_switch] = ACTIONS(443),
    [anon_sym_case] = ACTIONS(446),
    [anon_sym_default] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(452),
    [anon_sym_do] = ACTIONS(455),
    [anon_sym_for] = ACTIONS(458),
    [anon_sym_return] = ACTIONS(461),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_continue] = ACTIONS(467),
    [anon_sym_goto] = ACTIONS(470),
    [anon_sym___try] = ACTIONS(473),
    [anon_sym___leave] = ACTIONS(476),
    [anon_sym_DASH_DASH] = ACTIONS(354),
    [anon_sym_PLUS_PLUS] = ACTIONS(354),
    [anon_sym_sizeof] = ACTIONS(357),
    [anon_sym___alignof__] = ACTIONS(360),
    [anon_sym___alignof] = ACTIONS(360),
    [anon_sym__alignof] = ACTIONS(360),
    [anon_sym_alignof] = ACTIONS(360),
    [anon_sym__Alignof] = ACTIONS(360),
    [anon_sym_offsetof] = ACTIONS(363),
    [anon_sym__Generic] = ACTIONS(366),
    [anon_sym_asm] = ACTIONS(369),
    [anon_sym___asm__] = ACTIONS(369),
    [sym_number_literal] = ACTIONS(372),
    [anon_sym_L_SQUOTE] = ACTIONS(375),
    [anon_sym_u_SQUOTE] = ACTIONS(375),
    [anon_sym_U_SQUOTE] = ACTIONS(375),
    [anon_sym_u8_SQUOTE] = ACTIONS(375),
    [anon_sym_SQUOTE] = ACTIONS(375),
    [anon_sym_L_DQUOTE] = ACTIONS(378),
    [anon_sym_u_DQUOTE] = ACTIONS(378),
    [anon_sym_U_DQUOTE] = ACTIONS(378),
    [anon_sym_u8_DQUOTE] = ACTIONS(378),
    [anon_sym_DQUOTE] = ACTIONS(378),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [anon_sym_NULL] = ACTIONS(384),
    [anon_sym_nullptr] = ACTIONS(384),
    [sym_comment] = ACTIONS(3),
  },
  [28] = {
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym__old_style_function_definition] = STATE(430),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1412),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(913),
    [sym_compound_statement] = STATE(40),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1089),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(40),
    [sym_labeled_statement] = STATE(40),
    [sym_expression_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_switch_statement] = STATE(40),
    [sym_case_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_do_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_return_statement] = STATE(40),
    [sym_break_statement] = STATE(40),
    [sym_continue_statement] = STATE(40),
    [sym_goto_statement] = STATE(40),
    [sym_seh_try_statement] = STATE(40),
    [sym_seh_leave_statement] = STATE(40),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(40),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(479),
    [aux_sym_preproc_include_token1] = ACTIONS(481),
    [aux_sym_preproc_def_token1] = ACTIONS(483),
    [aux_sym_preproc_if_token1] = ACTIONS(485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(487),
    [sym_preproc_directive] = ACTIONS(489),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(497),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(501),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [29] = {
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym__old_style_function_definition] = STATE(430),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1412),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(913),
    [sym_compound_statement] = STATE(40),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1089),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(40),
    [sym_labeled_statement] = STATE(40),
    [sym_expression_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_switch_statement] = STATE(40),
    [sym_case_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_do_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_return_statement] = STATE(40),
    [sym_break_statement] = STATE(40),
    [sym_continue_statement] = STATE(40),
    [sym_goto_statement] = STATE(40),
    [sym_seh_try_statement] = STATE(40),
    [sym_seh_leave_statement] = STATE(40),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(40),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(479),
    [aux_sym_preproc_include_token1] = ACTIONS(481),
    [aux_sym_preproc_def_token1] = ACTIONS(483),
    [aux_sym_preproc_if_token1] = ACTIONS(485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(487),
    [sym_preproc_directive] = ACTIONS(489),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(497),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [30] = {
    [sym_preproc_include] = STATE(32),
    [sym_preproc_def] = STATE(32),
    [sym_preproc_function_def] = STATE(32),
    [sym_preproc_call] = STATE(32),
    [sym_preproc_if] = STATE(32),
    [sym_preproc_ifdef] = STATE(32),
    [sym_function_definition] = STATE(32),
    [sym__old_style_function_definition] = STATE(430),
    [sym_declaration] = STATE(32),
    [sym_type_definition] = STATE(32),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1412),
    [sym_linkage_specification] = STATE(32),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(913),
    [sym_compound_statement] = STATE(32),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1089),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(32),
    [sym_labeled_statement] = STATE(32),
    [sym_expression_statement] = STATE(32),
    [sym_if_statement] = STATE(32),
    [sym_switch_statement] = STATE(32),
    [sym_case_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_do_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_return_statement] = STATE(32),
    [sym_break_statement] = STATE(32),
    [sym_continue_statement] = STATE(32),
    [sym_goto_statement] = STATE(32),
    [sym_seh_try_statement] = STATE(32),
    [sym_seh_leave_statement] = STATE(32),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(32),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(32),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(479),
    [aux_sym_preproc_include_token1] = ACTIONS(481),
    [aux_sym_preproc_def_token1] = ACTIONS(483),
    [aux_sym_preproc_if_token1] = ACTIONS(485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(487),
    [sym_preproc_directive] = ACTIONS(489),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(497),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(531),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [31] = {
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym__old_style_function_definition] = STATE(430),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1412),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(913),
    [sym_compound_statement] = STATE(40),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1089),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(40),
    [sym_labeled_statement] = STATE(40),
    [sym_expression_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_switch_statement] = STATE(40),
    [sym_case_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_do_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_return_statement] = STATE(40),
    [sym_break_statement] = STATE(40),
    [sym_continue_statement] = STATE(40),
    [sym_goto_statement] = STATE(40),
    [sym_seh_try_statement] = STATE(40),
    [sym_seh_leave_statement] = STATE(40),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(40),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(479),
    [aux_sym_preproc_include_token1] = ACTIONS(481),
    [aux_sym_preproc_def_token1] = ACTIONS(483),
    [aux_sym_preproc_if_token1] = ACTIONS(485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(487),
    [sym_preproc_directive] = ACTIONS(489),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(497),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(533),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [32] = {
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym__old_style_function_definition] = STATE(430),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1412),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(913),
    [sym_compound_statement] = STATE(40),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1089),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(40),
    [sym_labeled_statement] = STATE(40),
    [sym_expression_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_switch_statement] = STATE(40),
    [sym_case_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_do_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_return_statement] = STATE(40),
    [sym_break_statement] = STATE(40),
    [sym_continue_statement] = STATE(40),
    [sym_goto_statement] = STATE(40),
    [sym_seh_try_statement] = STATE(40),
    [sym_seh_leave_statement] = STATE(40),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(40),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(479),
    [aux_sym_preproc_include_token1] = ACTIONS(481),
    [aux_sym_preproc_def_token1] = ACTIONS(483),
    [aux_sym_preproc_if_token1] = ACTIONS(485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(487),
    [sym_preproc_directive] = ACTIONS(489),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(497),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(535),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [33] = {
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym__old_style_function_definition] = STATE(430),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1412),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(913),
    [sym_compound_statement] = STATE(40),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1089),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(40),
    [sym_labeled_statement] = STATE(40),
    [sym_expression_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_switch_statement] = STATE(40),
    [sym_case_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_do_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_return_statement] = STATE(40),
    [sym_break_statement] = STATE(40),
    [sym_continue_statement] = STATE(40),
    [sym_goto_statement] = STATE(40),
    [sym_seh_try_statement] = STATE(40),
    [sym_seh_leave_statement] = STATE(40),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(40),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(479),
    [aux_sym_preproc_include_token1] = ACTIONS(481),
    [aux_sym_preproc_def_token1] = ACTIONS(483),
    [aux_sym_preproc_if_token1] = ACTIONS(485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(487),
    [sym_preproc_directive] = ACTIONS(489),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(497),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [34] = {
    [sym_preproc_include] = STATE(31),
    [sym_preproc_def] = STATE(31),
    [sym_preproc_function_def] = STATE(31),
    [sym_preproc_call] = STATE(31),
    [sym_preproc_if] = STATE(31),
    [sym_preproc_ifdef] = STATE(31),
    [sym_function_definition] = STATE(31),
    [sym__old_style_function_definition] = STATE(430),
    [sym_declaration] = STATE(31),
    [sym_type_definition] = STATE(31),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1412),
    [sym_linkage_specification] = STATE(31),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(913),
    [sym_compound_statement] = STATE(31),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1089),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(31),
    [sym_labeled_statement] = STATE(31),
    [sym_expression_statement] = STATE(31),
    [sym_if_statement] = STATE(31),
    [sym_switch_statement] = STATE(31),
    [sym_case_statement] = STATE(31),
    [sym_while_statement] = STATE(31),
    [sym_do_statement] = STATE(31),
    [sym_for_statement] = STATE(31),
    [sym_return_statement] = STATE(31),
    [sym_break_statement] = STATE(31),
    [sym_continue_statement] = STATE(31),
    [sym_goto_statement] = STATE(31),
    [sym_seh_try_statement] = STATE(31),
    [sym_seh_leave_statement] = STATE(31),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(31),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(31),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(479),
    [aux_sym_preproc_include_token1] = ACTIONS(481),
    [aux_sym_preproc_def_token1] = ACTIONS(483),
    [aux_sym_preproc_if_token1] = ACTIONS(485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(487),
    [sym_preproc_directive] = ACTIONS(489),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(497),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [35] = {
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_function_definition] = STATE(33),
    [sym__old_style_function_definition] = STATE(430),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1412),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(913),
    [sym_compound_statement] = STATE(33),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1089),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(33),
    [sym_labeled_statement] = STATE(33),
    [sym_expression_statement] = STATE(33),
    [sym_if_statement] = STATE(33),
    [sym_switch_statement] = STATE(33),
    [sym_case_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_do_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_return_statement] = STATE(33),
    [sym_break_statement] = STATE(33),
    [sym_continue_statement] = STATE(33),
    [sym_goto_statement] = STATE(33),
    [sym_seh_try_statement] = STATE(33),
    [sym_seh_leave_statement] = STATE(33),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(33),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(479),
    [aux_sym_preproc_include_token1] = ACTIONS(481),
    [aux_sym_preproc_def_token1] = ACTIONS(483),
    [aux_sym_preproc_if_token1] = ACTIONS(485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(487),
    [sym_preproc_directive] = ACTIONS(489),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(497),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(541),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [36] = {
    [sym_preproc_include] = STATE(47),
    [sym_preproc_def] = STATE(47),
    [sym_preproc_function_def] = STATE(47),
    [sym_preproc_call] = STATE(47),
    [sym_preproc_if] = STATE(47),
    [sym_preproc_ifdef] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym__old_style_function_definition] = STATE(440),
    [sym_declaration] = STATE(47),
    [sym_type_definition] = STATE(47),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1401),
    [sym_linkage_specification] = STATE(47),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(911),
    [sym_compound_statement] = STATE(47),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1094),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(47),
    [sym_labeled_statement] = STATE(47),
    [sym_expression_statement] = STATE(47),
    [sym_if_statement] = STATE(47),
    [sym_switch_statement] = STATE(47),
    [sym_case_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_do_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_return_statement] = STATE(47),
    [sym_break_statement] = STATE(47),
    [sym_continue_statement] = STATE(47),
    [sym_goto_statement] = STATE(47),
    [sym_seh_try_statement] = STATE(47),
    [sym_seh_leave_statement] = STATE(47),
    [sym__expression] = STATE(1313),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2275),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(47),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(47),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(543),
    [aux_sym_preproc_include_token1] = ACTIONS(545),
    [aux_sym_preproc_def_token1] = ACTIONS(547),
    [aux_sym_preproc_if_token1] = ACTIONS(549),
    [aux_sym_preproc_if_token2] = ACTIONS(551),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(553),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(553),
    [sym_preproc_directive] = ACTIONS(555),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(557),
    [anon_sym___extension__] = ACTIONS(559),
    [anon_sym_typedef] = ACTIONS(561),
    [anon_sym_extern] = ACTIONS(563),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_switch] = ACTIONS(569),
    [anon_sym_case] = ACTIONS(571),
    [anon_sym_default] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(575),
    [anon_sym_do] = ACTIONS(577),
    [anon_sym_for] = ACTIONS(579),
    [anon_sym_return] = ACTIONS(581),
    [anon_sym_break] = ACTIONS(583),
    [anon_sym_continue] = ACTIONS(585),
    [anon_sym_goto] = ACTIONS(587),
    [anon_sym___try] = ACTIONS(589),
    [anon_sym___leave] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [37] = {
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym__old_style_function_definition] = STATE(430),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1412),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(913),
    [sym_compound_statement] = STATE(40),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1089),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(40),
    [sym_labeled_statement] = STATE(40),
    [sym_expression_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_switch_statement] = STATE(40),
    [sym_case_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_do_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_return_statement] = STATE(40),
    [sym_break_statement] = STATE(40),
    [sym_continue_statement] = STATE(40),
    [sym_goto_statement] = STATE(40),
    [sym_seh_try_statement] = STATE(40),
    [sym_seh_leave_statement] = STATE(40),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(40),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(479),
    [aux_sym_preproc_include_token1] = ACTIONS(481),
    [aux_sym_preproc_def_token1] = ACTIONS(483),
    [aux_sym_preproc_if_token1] = ACTIONS(485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(487),
    [sym_preproc_directive] = ACTIONS(489),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(497),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(593),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [38] = {
    [sym_preproc_include] = STATE(36),
    [sym_preproc_def] = STATE(36),
    [sym_preproc_function_def] = STATE(36),
    [sym_preproc_call] = STATE(36),
    [sym_preproc_if] = STATE(36),
    [sym_preproc_ifdef] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym__old_style_function_definition] = STATE(440),
    [sym_declaration] = STATE(36),
    [sym_type_definition] = STATE(36),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1401),
    [sym_linkage_specification] = STATE(36),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(911),
    [sym_compound_statement] = STATE(36),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1094),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(36),
    [sym_labeled_statement] = STATE(36),
    [sym_expression_statement] = STATE(36),
    [sym_if_statement] = STATE(36),
    [sym_switch_statement] = STATE(36),
    [sym_case_statement] = STATE(36),
    [sym_while_statement] = STATE(36),
    [sym_do_statement] = STATE(36),
    [sym_for_statement] = STATE(36),
    [sym_return_statement] = STATE(36),
    [sym_break_statement] = STATE(36),
    [sym_continue_statement] = STATE(36),
    [sym_goto_statement] = STATE(36),
    [sym_seh_try_statement] = STATE(36),
    [sym_seh_leave_statement] = STATE(36),
    [sym__expression] = STATE(1313),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2275),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(36),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(36),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(543),
    [aux_sym_preproc_include_token1] = ACTIONS(545),
    [aux_sym_preproc_def_token1] = ACTIONS(547),
    [aux_sym_preproc_if_token1] = ACTIONS(549),
    [aux_sym_preproc_if_token2] = ACTIONS(595),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(553),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(553),
    [sym_preproc_directive] = ACTIONS(555),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(557),
    [anon_sym___extension__] = ACTIONS(559),
    [anon_sym_typedef] = ACTIONS(561),
    [anon_sym_extern] = ACTIONS(563),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_switch] = ACTIONS(569),
    [anon_sym_case] = ACTIONS(571),
    [anon_sym_default] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(575),
    [anon_sym_do] = ACTIONS(577),
    [anon_sym_for] = ACTIONS(579),
    [anon_sym_return] = ACTIONS(581),
    [anon_sym_break] = ACTIONS(583),
    [anon_sym_continue] = ACTIONS(585),
    [anon_sym_goto] = ACTIONS(587),
    [anon_sym___try] = ACTIONS(589),
    [anon_sym___leave] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [39] = {
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym__old_style_function_definition] = STATE(430),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1412),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(913),
    [sym_compound_statement] = STATE(41),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1089),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(41),
    [sym_labeled_statement] = STATE(41),
    [sym_expression_statement] = STATE(41),
    [sym_if_statement] = STATE(41),
    [sym_switch_statement] = STATE(41),
    [sym_case_statement] = STATE(41),
    [sym_while_statement] = STATE(41),
    [sym_do_statement] = STATE(41),
    [sym_for_statement] = STATE(41),
    [sym_return_statement] = STATE(41),
    [sym_break_statement] = STATE(41),
    [sym_continue_statement] = STATE(41),
    [sym_goto_statement] = STATE(41),
    [sym_seh_try_statement] = STATE(41),
    [sym_seh_leave_statement] = STATE(41),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(41),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(479),
    [aux_sym_preproc_include_token1] = ACTIONS(481),
    [aux_sym_preproc_def_token1] = ACTIONS(483),
    [aux_sym_preproc_if_token1] = ACTIONS(485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(487),
    [sym_preproc_directive] = ACTIONS(489),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(497),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(597),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [40] = {
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym__old_style_function_definition] = STATE(430),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1412),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(913),
    [sym_compound_statement] = STATE(40),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1089),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(40),
    [sym_labeled_statement] = STATE(40),
    [sym_expression_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_switch_statement] = STATE(40),
    [sym_case_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_do_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_return_statement] = STATE(40),
    [sym_break_statement] = STATE(40),
    [sym_continue_statement] = STATE(40),
    [sym_goto_statement] = STATE(40),
    [sym_seh_try_statement] = STATE(40),
    [sym_seh_leave_statement] = STATE(40),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(40),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(599),
    [aux_sym_preproc_include_token1] = ACTIONS(602),
    [aux_sym_preproc_def_token1] = ACTIONS(605),
    [aux_sym_preproc_if_token1] = ACTIONS(608),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(611),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(611),
    [sym_preproc_directive] = ACTIONS(614),
    [anon_sym_LPAREN2] = ACTIONS(255),
    [anon_sym_BANG] = ACTIONS(258),
    [anon_sym_TILDE] = ACTIONS(258),
    [anon_sym_DASH] = ACTIONS(261),
    [anon_sym_PLUS] = ACTIONS(261),
    [anon_sym_STAR] = ACTIONS(264),
    [anon_sym_AMP] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym___extension__] = ACTIONS(620),
    [anon_sym_typedef] = ACTIONS(623),
    [anon_sym_extern] = ACTIONS(626),
    [anon_sym___attribute__] = ACTIONS(279),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(282),
    [anon_sym___declspec] = ACTIONS(285),
    [anon_sym___cdecl] = ACTIONS(288),
    [anon_sym___clrcall] = ACTIONS(288),
    [anon_sym___stdcall] = ACTIONS(288),
    [anon_sym___fastcall] = ACTIONS(288),
    [anon_sym___thiscall] = ACTIONS(288),
    [anon_sym___vectorcall] = ACTIONS(288),
    [anon_sym_LBRACE] = ACTIONS(629),
    [anon_sym_RBRACE] = ACTIONS(632),
    [anon_sym_signed] = ACTIONS(294),
    [anon_sym_unsigned] = ACTIONS(294),
    [anon_sym_long] = ACTIONS(294),
    [anon_sym_short] = ACTIONS(294),
    [anon_sym_static] = ACTIONS(297),
    [anon_sym_auto] = ACTIONS(297),
    [anon_sym_register] = ACTIONS(297),
    [anon_sym_inline] = ACTIONS(297),
    [anon_sym___inline] = ACTIONS(297),
    [anon_sym___inline__] = ACTIONS(297),
    [anon_sym___forceinline] = ACTIONS(297),
    [anon_sym_thread_local] = ACTIONS(297),
    [anon_sym___thread] = ACTIONS(297),
    [anon_sym_const] = ACTIONS(300),
    [anon_sym_constexpr] = ACTIONS(300),
    [anon_sym_volatile] = ACTIONS(300),
    [anon_sym_restrict] = ACTIONS(300),
    [anon_sym___restrict__] = ACTIONS(300),
    [anon_sym__Atomic] = ACTIONS(300),
    [anon_sym__Noreturn] = ACTIONS(300),
    [anon_sym_noreturn] = ACTIONS(300),
    [sym_primitive_type] = ACTIONS(303),
    [anon_sym_enum] = ACTIONS(306),
    [anon_sym_struct] = ACTIONS(309),
    [anon_sym_union] = ACTIONS(312),
    [anon_sym_if] = ACTIONS(634),
    [anon_sym_switch] = ACTIONS(637),
    [anon_sym_case] = ACTIONS(640),
    [anon_sym_default] = ACTIONS(643),
    [anon_sym_while] = ACTIONS(646),
    [anon_sym_do] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(652),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_break] = ACTIONS(658),
    [anon_sym_continue] = ACTIONS(661),
    [anon_sym_goto] = ACTIONS(664),
    [anon_sym___try] = ACTIONS(667),
    [anon_sym___leave] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(354),
    [anon_sym_PLUS_PLUS] = ACTIONS(354),
    [anon_sym_sizeof] = ACTIONS(357),
    [anon_sym___alignof__] = ACTIONS(360),
    [anon_sym___alignof] = ACTIONS(360),
    [anon_sym__alignof] = ACTIONS(360),
    [anon_sym_alignof] = ACTIONS(360),
    [anon_sym__Alignof] = ACTIONS(360),
    [anon_sym_offsetof] = ACTIONS(363),
    [anon_sym__Generic] = ACTIONS(366),
    [anon_sym_asm] = ACTIONS(369),
    [anon_sym___asm__] = ACTIONS(369),
    [sym_number_literal] = ACTIONS(372),
    [anon_sym_L_SQUOTE] = ACTIONS(375),
    [anon_sym_u_SQUOTE] = ACTIONS(375),
    [anon_sym_U_SQUOTE] = ACTIONS(375),
    [anon_sym_u8_SQUOTE] = ACTIONS(375),
    [anon_sym_SQUOTE] = ACTIONS(375),
    [anon_sym_L_DQUOTE] = ACTIONS(378),
    [anon_sym_u_DQUOTE] = ACTIONS(378),
    [anon_sym_U_DQUOTE] = ACTIONS(378),
    [anon_sym_u8_DQUOTE] = ACTIONS(378),
    [anon_sym_DQUOTE] = ACTIONS(378),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [anon_sym_NULL] = ACTIONS(384),
    [anon_sym_nullptr] = ACTIONS(384),
    [sym_comment] = ACTIONS(3),
  },
  [41] = {
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym__old_style_function_definition] = STATE(430),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1412),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(913),
    [sym_compound_statement] = STATE(40),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1089),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(40),
    [sym_labeled_statement] = STATE(40),
    [sym_expression_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_switch_statement] = STATE(40),
    [sym_case_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_do_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_return_statement] = STATE(40),
    [sym_break_statement] = STATE(40),
    [sym_continue_statement] = STATE(40),
    [sym_goto_statement] = STATE(40),
    [sym_seh_try_statement] = STATE(40),
    [sym_seh_leave_statement] = STATE(40),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(40),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(479),
    [aux_sym_preproc_include_token1] = ACTIONS(481),
    [aux_sym_preproc_def_token1] = ACTIONS(483),
    [aux_sym_preproc_if_token1] = ACTIONS(485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(487),
    [sym_preproc_directive] = ACTIONS(489),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(497),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(673),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [42] = {
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym__old_style_function_definition] = STATE(430),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1412),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(913),
    [sym_compound_statement] = STATE(40),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1089),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(40),
    [sym_labeled_statement] = STATE(40),
    [sym_expression_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_switch_statement] = STATE(40),
    [sym_case_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_do_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_return_statement] = STATE(40),
    [sym_break_statement] = STATE(40),
    [sym_continue_statement] = STATE(40),
    [sym_goto_statement] = STATE(40),
    [sym_seh_try_statement] = STATE(40),
    [sym_seh_leave_statement] = STATE(40),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(40),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(479),
    [aux_sym_preproc_include_token1] = ACTIONS(481),
    [aux_sym_preproc_def_token1] = ACTIONS(483),
    [aux_sym_preproc_if_token1] = ACTIONS(485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(487),
    [sym_preproc_directive] = ACTIONS(489),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(497),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(675),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [43] = {
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym__old_style_function_definition] = STATE(430),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1412),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(913),
    [sym_compound_statement] = STATE(40),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1089),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(40),
    [sym_labeled_statement] = STATE(40),
    [sym_expression_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_switch_statement] = STATE(40),
    [sym_case_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_do_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_return_statement] = STATE(40),
    [sym_break_statement] = STATE(40),
    [sym_continue_statement] = STATE(40),
    [sym_goto_statement] = STATE(40),
    [sym_seh_try_statement] = STATE(40),
    [sym_seh_leave_statement] = STATE(40),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(40),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(479),
    [aux_sym_preproc_include_token1] = ACTIONS(481),
    [aux_sym_preproc_def_token1] = ACTIONS(483),
    [aux_sym_preproc_if_token1] = ACTIONS(485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(487),
    [sym_preproc_directive] = ACTIONS(489),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(497),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(677),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [44] = {
    [sym_preproc_include] = STATE(28),
    [sym_preproc_def] = STATE(28),
    [sym_preproc_function_def] = STATE(28),
    [sym_preproc_call] = STATE(28),
    [sym_preproc_if] = STATE(28),
    [sym_preproc_ifdef] = STATE(28),
    [sym_function_definition] = STATE(28),
    [sym__old_style_function_definition] = STATE(430),
    [sym_declaration] = STATE(28),
    [sym_type_definition] = STATE(28),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1412),
    [sym_linkage_specification] = STATE(28),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(913),
    [sym_compound_statement] = STATE(28),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1089),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym_expression_statement] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_case_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_goto_statement] = STATE(28),
    [sym_seh_try_statement] = STATE(28),
    [sym_seh_leave_statement] = STATE(28),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(28),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(28),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(479),
    [aux_sym_preproc_include_token1] = ACTIONS(481),
    [aux_sym_preproc_def_token1] = ACTIONS(483),
    [aux_sym_preproc_if_token1] = ACTIONS(485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(487),
    [sym_preproc_directive] = ACTIONS(489),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(497),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(679),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [45] = {
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym__old_style_function_definition] = STATE(430),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1412),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(913),
    [sym_compound_statement] = STATE(42),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1089),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(42),
    [sym_labeled_statement] = STATE(42),
    [sym_expression_statement] = STATE(42),
    [sym_if_statement] = STATE(42),
    [sym_switch_statement] = STATE(42),
    [sym_case_statement] = STATE(42),
    [sym_while_statement] = STATE(42),
    [sym_do_statement] = STATE(42),
    [sym_for_statement] = STATE(42),
    [sym_return_statement] = STATE(42),
    [sym_break_statement] = STATE(42),
    [sym_continue_statement] = STATE(42),
    [sym_goto_statement] = STATE(42),
    [sym_seh_try_statement] = STATE(42),
    [sym_seh_leave_statement] = STATE(42),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(42),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(479),
    [aux_sym_preproc_include_token1] = ACTIONS(481),
    [aux_sym_preproc_def_token1] = ACTIONS(483),
    [aux_sym_preproc_if_token1] = ACTIONS(485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(487),
    [sym_preproc_directive] = ACTIONS(489),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(497),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(681),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [46] = {
    [sym_preproc_include] = STATE(49),
    [sym_preproc_def] = STATE(49),
    [sym_preproc_function_def] = STATE(49),
    [sym_preproc_call] = STATE(49),
    [sym_preproc_if] = STATE(49),
    [sym_preproc_ifdef] = STATE(49),
    [sym_function_definition] = STATE(49),
    [sym__old_style_function_definition] = STATE(430),
    [sym_declaration] = STATE(49),
    [sym_type_definition] = STATE(49),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1412),
    [sym_linkage_specification] = STATE(49),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(913),
    [sym_compound_statement] = STATE(49),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1089),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(49),
    [sym_labeled_statement] = STATE(49),
    [sym_expression_statement] = STATE(49),
    [sym_if_statement] = STATE(49),
    [sym_switch_statement] = STATE(49),
    [sym_case_statement] = STATE(49),
    [sym_while_statement] = STATE(49),
    [sym_do_statement] = STATE(49),
    [sym_for_statement] = STATE(49),
    [sym_return_statement] = STATE(49),
    [sym_break_statement] = STATE(49),
    [sym_continue_statement] = STATE(49),
    [sym_goto_statement] = STATE(49),
    [sym_seh_try_statement] = STATE(49),
    [sym_seh_leave_statement] = STATE(49),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(49),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(49),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(479),
    [aux_sym_preproc_include_token1] = ACTIONS(481),
    [aux_sym_preproc_def_token1] = ACTIONS(483),
    [aux_sym_preproc_if_token1] = ACTIONS(485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(487),
    [sym_preproc_directive] = ACTIONS(489),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(497),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [47] = {
    [sym_preproc_include] = STATE(47),
    [sym_preproc_def] = STATE(47),
    [sym_preproc_function_def] = STATE(47),
    [sym_preproc_call] = STATE(47),
    [sym_preproc_if] = STATE(47),
    [sym_preproc_ifdef] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym__old_style_function_definition] = STATE(440),
    [sym_declaration] = STATE(47),
    [sym_type_definition] = STATE(47),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1401),
    [sym_linkage_specification] = STATE(47),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(911),
    [sym_compound_statement] = STATE(47),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1094),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(47),
    [sym_labeled_statement] = STATE(47),
    [sym_expression_statement] = STATE(47),
    [sym_if_statement] = STATE(47),
    [sym_switch_statement] = STATE(47),
    [sym_case_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_do_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_return_statement] = STATE(47),
    [sym_break_statement] = STATE(47),
    [sym_continue_statement] = STATE(47),
    [sym_goto_statement] = STATE(47),
    [sym_seh_try_statement] = STATE(47),
    [sym_seh_leave_statement] = STATE(47),
    [sym__expression] = STATE(1313),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2275),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(47),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(47),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(685),
    [aux_sym_preproc_include_token1] = ACTIONS(688),
    [aux_sym_preproc_def_token1] = ACTIONS(691),
    [aux_sym_preproc_if_token1] = ACTIONS(694),
    [aux_sym_preproc_if_token2] = ACTIONS(247),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(697),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(697),
    [sym_preproc_directive] = ACTIONS(700),
    [anon_sym_LPAREN2] = ACTIONS(255),
    [anon_sym_BANG] = ACTIONS(258),
    [anon_sym_TILDE] = ACTIONS(258),
    [anon_sym_DASH] = ACTIONS(261),
    [anon_sym_PLUS] = ACTIONS(261),
    [anon_sym_STAR] = ACTIONS(264),
    [anon_sym_AMP] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym___extension__] = ACTIONS(706),
    [anon_sym_typedef] = ACTIONS(709),
    [anon_sym_extern] = ACTIONS(712),
    [anon_sym___attribute__] = ACTIONS(279),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(282),
    [anon_sym___declspec] = ACTIONS(285),
    [anon_sym___cdecl] = ACTIONS(288),
    [anon_sym___clrcall] = ACTIONS(288),
    [anon_sym___stdcall] = ACTIONS(288),
    [anon_sym___fastcall] = ACTIONS(288),
    [anon_sym___thiscall] = ACTIONS(288),
    [anon_sym___vectorcall] = ACTIONS(288),
    [anon_sym_LBRACE] = ACTIONS(715),
    [anon_sym_signed] = ACTIONS(294),
    [anon_sym_unsigned] = ACTIONS(294),
    [anon_sym_long] = ACTIONS(294),
    [anon_sym_short] = ACTIONS(294),
    [anon_sym_static] = ACTIONS(297),
    [anon_sym_auto] = ACTIONS(297),
    [anon_sym_register] = ACTIONS(297),
    [anon_sym_inline] = ACTIONS(297),
    [anon_sym___inline] = ACTIONS(297),
    [anon_sym___inline__] = ACTIONS(297),
    [anon_sym___forceinline] = ACTIONS(297),
    [anon_sym_thread_local] = ACTIONS(297),
    [anon_sym___thread] = ACTIONS(297),
    [anon_sym_const] = ACTIONS(300),
    [anon_sym_constexpr] = ACTIONS(300),
    [anon_sym_volatile] = ACTIONS(300),
    [anon_sym_restrict] = ACTIONS(300),
    [anon_sym___restrict__] = ACTIONS(300),
    [anon_sym__Atomic] = ACTIONS(300),
    [anon_sym__Noreturn] = ACTIONS(300),
    [anon_sym_noreturn] = ACTIONS(300),
    [sym_primitive_type] = ACTIONS(303),
    [anon_sym_enum] = ACTIONS(306),
    [anon_sym_struct] = ACTIONS(309),
    [anon_sym_union] = ACTIONS(312),
    [anon_sym_if] = ACTIONS(718),
    [anon_sym_switch] = ACTIONS(721),
    [anon_sym_case] = ACTIONS(724),
    [anon_sym_default] = ACTIONS(727),
    [anon_sym_while] = ACTIONS(730),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(736),
    [anon_sym_return] = ACTIONS(739),
    [anon_sym_break] = ACTIONS(742),
    [anon_sym_continue] = ACTIONS(745),
    [anon_sym_goto] = ACTIONS(748),
    [anon_sym___try] = ACTIONS(751),
    [anon_sym___leave] = ACTIONS(754),
    [anon_sym_DASH_DASH] = ACTIONS(354),
    [anon_sym_PLUS_PLUS] = ACTIONS(354),
    [anon_sym_sizeof] = ACTIONS(357),
    [anon_sym___alignof__] = ACTIONS(360),
    [anon_sym___alignof] = ACTIONS(360),
    [anon_sym__alignof] = ACTIONS(360),
    [anon_sym_alignof] = ACTIONS(360),
    [anon_sym__Alignof] = ACTIONS(360),
    [anon_sym_offsetof] = ACTIONS(363),
    [anon_sym__Generic] = ACTIONS(366),
    [anon_sym_asm] = ACTIONS(369),
    [anon_sym___asm__] = ACTIONS(369),
    [sym_number_literal] = ACTIONS(372),
    [anon_sym_L_SQUOTE] = ACTIONS(375),
    [anon_sym_u_SQUOTE] = ACTIONS(375),
    [anon_sym_U_SQUOTE] = ACTIONS(375),
    [anon_sym_u8_SQUOTE] = ACTIONS(375),
    [anon_sym_SQUOTE] = ACTIONS(375),
    [anon_sym_L_DQUOTE] = ACTIONS(378),
    [anon_sym_u_DQUOTE] = ACTIONS(378),
    [anon_sym_U_DQUOTE] = ACTIONS(378),
    [anon_sym_u8_DQUOTE] = ACTIONS(378),
    [anon_sym_DQUOTE] = ACTIONS(378),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [anon_sym_NULL] = ACTIONS(384),
    [anon_sym_nullptr] = ACTIONS(384),
    [sym_comment] = ACTIONS(3),
  },
  [48] = {
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym__old_style_function_definition] = STATE(430),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1412),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(913),
    [sym_compound_statement] = STATE(43),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1089),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(43),
    [sym_labeled_statement] = STATE(43),
    [sym_expression_statement] = STATE(43),
    [sym_if_statement] = STATE(43),
    [sym_switch_statement] = STATE(43),
    [sym_case_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_do_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_return_statement] = STATE(43),
    [sym_break_statement] = STATE(43),
    [sym_continue_statement] = STATE(43),
    [sym_goto_statement] = STATE(43),
    [sym_seh_try_statement] = STATE(43),
    [sym_seh_leave_statement] = STATE(43),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(43),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(479),
    [aux_sym_preproc_include_token1] = ACTIONS(481),
    [aux_sym_preproc_def_token1] = ACTIONS(483),
    [aux_sym_preproc_if_token1] = ACTIONS(485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(487),
    [sym_preproc_directive] = ACTIONS(489),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(497),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(757),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [49] = {
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym__old_style_function_definition] = STATE(430),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1412),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(913),
    [sym_compound_statement] = STATE(40),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1089),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(40),
    [sym_labeled_statement] = STATE(40),
    [sym_expression_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_switch_statement] = STATE(40),
    [sym_case_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_do_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_return_statement] = STATE(40),
    [sym_break_statement] = STATE(40),
    [sym_continue_statement] = STATE(40),
    [sym_goto_statement] = STATE(40),
    [sym_seh_try_statement] = STATE(40),
    [sym_seh_leave_statement] = STATE(40),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(40),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(40),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(479),
    [aux_sym_preproc_include_token1] = ACTIONS(481),
    [aux_sym_preproc_def_token1] = ACTIONS(483),
    [aux_sym_preproc_if_token1] = ACTIONS(485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(487),
    [sym_preproc_directive] = ACTIONS(489),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(497),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(759),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [50] = {
    [sym_preproc_include] = STATE(37),
    [sym_preproc_def] = STATE(37),
    [sym_preproc_function_def] = STATE(37),
    [sym_preproc_call] = STATE(37),
    [sym_preproc_if] = STATE(37),
    [sym_preproc_ifdef] = STATE(37),
    [sym_function_definition] = STATE(37),
    [sym__old_style_function_definition] = STATE(430),
    [sym_declaration] = STATE(37),
    [sym_type_definition] = STATE(37),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1412),
    [sym_linkage_specification] = STATE(37),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(913),
    [sym_compound_statement] = STATE(37),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1089),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(37),
    [sym_labeled_statement] = STATE(37),
    [sym_expression_statement] = STATE(37),
    [sym_if_statement] = STATE(37),
    [sym_switch_statement] = STATE(37),
    [sym_case_statement] = STATE(37),
    [sym_while_statement] = STATE(37),
    [sym_do_statement] = STATE(37),
    [sym_for_statement] = STATE(37),
    [sym_return_statement] = STATE(37),
    [sym_break_statement] = STATE(37),
    [sym_continue_statement] = STATE(37),
    [sym_goto_statement] = STATE(37),
    [sym_seh_try_statement] = STATE(37),
    [sym_seh_leave_statement] = STATE(37),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(37),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(37),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(479),
    [aux_sym_preproc_include_token1] = ACTIONS(481),
    [aux_sym_preproc_def_token1] = ACTIONS(483),
    [aux_sym_preproc_if_token1] = ACTIONS(485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(487),
    [sym_preproc_directive] = ACTIONS(489),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(497),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(761),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [51] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym__old_style_function_definition] = STATE(430),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1412),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(913),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1089),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym_seh_try_statement] = STATE(29),
    [sym_seh_leave_statement] = STATE(29),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(479),
    [aux_sym_preproc_include_token1] = ACTIONS(481),
    [aux_sym_preproc_def_token1] = ACTIONS(483),
    [aux_sym_preproc_if_token1] = ACTIONS(485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(487),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(487),
    [sym_preproc_directive] = ACTIONS(489),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(497),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(763),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [52] = {
    [sym_preproc_include] = STATE(52),
    [sym_preproc_def] = STATE(52),
    [sym_preproc_function_def] = STATE(52),
    [sym_preproc_call] = STATE(52),
    [sym_preproc_if] = STATE(52),
    [sym_preproc_ifdef] = STATE(52),
    [sym_function_definition] = STATE(52),
    [sym__old_style_function_definition] = STATE(511),
    [sym_declaration] = STATE(52),
    [sym_type_definition] = STATE(52),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1410),
    [sym_linkage_specification] = STATE(52),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(912),
    [sym_compound_statement] = STATE(52),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1091),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(52),
    [sym_labeled_statement] = STATE(52),
    [sym__top_level_expression_statement] = STATE(52),
    [sym_if_statement] = STATE(52),
    [sym_switch_statement] = STATE(52),
    [sym_case_statement] = STATE(52),
    [sym_while_statement] = STATE(52),
    [sym_do_statement] = STATE(52),
    [sym_for_statement] = STATE(52),
    [sym_return_statement] = STATE(52),
    [sym_break_statement] = STATE(52),
    [sym_continue_statement] = STATE(52),
    [sym_goto_statement] = STATE(52),
    [sym__expression] = STATE(1387),
    [sym__expression_not_binary] = STATE(1388),
    [sym__string] = STATE(1388),
    [sym_conditional_expression] = STATE(1388),
    [sym_assignment_expression] = STATE(1388),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(1388),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(1388),
    [sym_cast_expression] = STATE(1388),
    [sym_sizeof_expression] = STATE(1388),
    [sym_alignof_expression] = STATE(1388),
    [sym_offsetof_expression] = STATE(1388),
    [sym_generic_expression] = STATE(1388),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(1388),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(1388),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(1388),
    [sym_concatenated_string] = STATE(1388),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(1388),
    [sym__empty_declaration] = STATE(52),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_translation_unit_repeat1] = STATE(52),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(463),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [ts_builtin_sym_end] = ACTIONS(765),
    [sym_identifier] = ACTIONS(767),
    [aux_sym_preproc_include_token1] = ACTIONS(770),
    [aux_sym_preproc_def_token1] = ACTIONS(773),
    [aux_sym_preproc_if_token1] = ACTIONS(776),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(779),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(779),
    [sym_preproc_directive] = ACTIONS(782),
    [anon_sym_LPAREN2] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(788),
    [anon_sym_TILDE] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_AMP] = ACTIONS(794),
    [anon_sym___extension__] = ACTIONS(797),
    [anon_sym_typedef] = ACTIONS(800),
    [anon_sym_extern] = ACTIONS(803),
    [anon_sym___attribute__] = ACTIONS(806),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(809),
    [anon_sym___declspec] = ACTIONS(812),
    [anon_sym___cdecl] = ACTIONS(815),
    [anon_sym___clrcall] = ACTIONS(815),
    [anon_sym___stdcall] = ACTIONS(815),
    [anon_sym___fastcall] = ACTIONS(815),
    [anon_sym___thiscall] = ACTIONS(815),
    [anon_sym___vectorcall] = ACTIONS(815),
    [anon_sym_LBRACE] = ACTIONS(818),
    [anon_sym_signed] = ACTIONS(821),
    [anon_sym_unsigned] = ACTIONS(821),
    [anon_sym_long] = ACTIONS(821),
    [anon_sym_short] = ACTIONS(821),
    [anon_sym_static] = ACTIONS(824),
    [anon_sym_auto] = ACTIONS(824),
    [anon_sym_register] = ACTIONS(824),
    [anon_sym_inline] = ACTIONS(824),
    [anon_sym___inline] = ACTIONS(824),
    [anon_sym___inline__] = ACTIONS(824),
    [anon_sym___forceinline] = ACTIONS(824),
    [anon_sym_thread_local] = ACTIONS(824),
    [anon_sym___thread] = ACTIONS(824),
    [anon_sym_const] = ACTIONS(827),
    [anon_sym_constexpr] = ACTIONS(827),
    [anon_sym_volatile] = ACTIONS(827),
    [anon_sym_restrict] = ACTIONS(827),
    [anon_sym___restrict__] = ACTIONS(827),
    [anon_sym__Atomic] = ACTIONS(827),
    [anon_sym__Noreturn] = ACTIONS(827),
    [anon_sym_noreturn] = ACTIONS(827),
    [sym_primitive_type] = ACTIONS(830),
    [anon_sym_enum] = ACTIONS(833),
    [anon_sym_struct] = ACTIONS(836),
    [anon_sym_union] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(842),
    [anon_sym_switch] = ACTIONS(845),
    [anon_sym_case] = ACTIONS(848),
    [anon_sym_default] = ACTIONS(851),
    [anon_sym_while] = ACTIONS(854),
    [anon_sym_do] = ACTIONS(857),
    [anon_sym_for] = ACTIONS(860),
    [anon_sym_return] = ACTIONS(863),
    [anon_sym_break] = ACTIONS(866),
    [anon_sym_continue] = ACTIONS(869),
    [anon_sym_goto] = ACTIONS(872),
    [anon_sym_DASH_DASH] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(875),
    [anon_sym_sizeof] = ACTIONS(878),
    [anon_sym___alignof__] = ACTIONS(881),
    [anon_sym___alignof] = ACTIONS(881),
    [anon_sym__alignof] = ACTIONS(881),
    [anon_sym_alignof] = ACTIONS(881),
    [anon_sym__Alignof] = ACTIONS(881),
    [anon_sym_offsetof] = ACTIONS(884),
    [anon_sym__Generic] = ACTIONS(887),
    [anon_sym_asm] = ACTIONS(890),
    [anon_sym___asm__] = ACTIONS(890),
    [sym_number_literal] = ACTIONS(893),
    [anon_sym_L_SQUOTE] = ACTIONS(896),
    [anon_sym_u_SQUOTE] = ACTIONS(896),
    [anon_sym_U_SQUOTE] = ACTIONS(896),
    [anon_sym_u8_SQUOTE] = ACTIONS(896),
    [anon_sym_SQUOTE] = ACTIONS(896),
    [anon_sym_L_DQUOTE] = ACTIONS(899),
    [anon_sym_u_DQUOTE] = ACTIONS(899),
    [anon_sym_U_DQUOTE] = ACTIONS(899),
    [anon_sym_u8_DQUOTE] = ACTIONS(899),
    [anon_sym_DQUOTE] = ACTIONS(899),
    [sym_true] = ACTIONS(902),
    [sym_false] = ACTIONS(902),
    [anon_sym_NULL] = ACTIONS(905),
    [anon_sym_nullptr] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
  },
  [53] = {
    [sym_preproc_include] = STATE(52),
    [sym_preproc_def] = STATE(52),
    [sym_preproc_function_def] = STATE(52),
    [sym_preproc_call] = STATE(52),
    [sym_preproc_if] = STATE(52),
    [sym_preproc_ifdef] = STATE(52),
    [sym_function_definition] = STATE(52),
    [sym__old_style_function_definition] = STATE(511),
    [sym_declaration] = STATE(52),
    [sym_type_definition] = STATE(52),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1410),
    [sym_linkage_specification] = STATE(52),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(912),
    [sym_compound_statement] = STATE(52),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(1091),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(52),
    [sym_labeled_statement] = STATE(52),
    [sym__top_level_expression_statement] = STATE(52),
    [sym_if_statement] = STATE(52),
    [sym_switch_statement] = STATE(52),
    [sym_case_statement] = STATE(52),
    [sym_while_statement] = STATE(52),
    [sym_do_statement] = STATE(52),
    [sym_for_statement] = STATE(52),
    [sym_return_statement] = STATE(52),
    [sym_break_statement] = STATE(52),
    [sym_continue_statement] = STATE(52),
    [sym_goto_statement] = STATE(52),
    [sym__expression] = STATE(1387),
    [sym__expression_not_binary] = STATE(1388),
    [sym__string] = STATE(1388),
    [sym_conditional_expression] = STATE(1388),
    [sym_assignment_expression] = STATE(1388),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(1388),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(1388),
    [sym_cast_expression] = STATE(1388),
    [sym_sizeof_expression] = STATE(1388),
    [sym_alignof_expression] = STATE(1388),
    [sym_offsetof_expression] = STATE(1388),
    [sym_generic_expression] = STATE(1388),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(1388),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(1388),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(1388),
    [sym_concatenated_string] = STATE(1388),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(1388),
    [sym__empty_declaration] = STATE(52),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_translation_unit_repeat1] = STATE(52),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(463),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [ts_builtin_sym_end] = ACTIONS(908),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(31),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_default] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(91),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [54] = {
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1421),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(432),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(54),
    [sym_identifier] = ACTIONS(910),
    [aux_sym_preproc_include_token1] = ACTIONS(913),
    [aux_sym_preproc_def_token1] = ACTIONS(913),
    [aux_sym_preproc_if_token1] = ACTIONS(913),
    [aux_sym_preproc_if_token2] = ACTIONS(913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(913),
    [aux_sym_preproc_else_token1] = ACTIONS(913),
    [aux_sym_preproc_elif_token1] = ACTIONS(913),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(913),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(913),
    [sym_preproc_directive] = ACTIONS(913),
    [anon_sym_LPAREN2] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_STAR] = ACTIONS(924),
    [anon_sym_AMP] = ACTIONS(924),
    [anon_sym_SEMI] = ACTIONS(927),
    [anon_sym___extension__] = ACTIONS(930),
    [anon_sym_typedef] = ACTIONS(933),
    [anon_sym_extern] = ACTIONS(936),
    [anon_sym___attribute__] = ACTIONS(939),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(942),
    [anon_sym___declspec] = ACTIONS(945),
    [anon_sym___cdecl] = ACTIONS(913),
    [anon_sym___clrcall] = ACTIONS(913),
    [anon_sym___stdcall] = ACTIONS(913),
    [anon_sym___fastcall] = ACTIONS(913),
    [anon_sym___thiscall] = ACTIONS(913),
    [anon_sym___vectorcall] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(948),
    [anon_sym_signed] = ACTIONS(951),
    [anon_sym_unsigned] = ACTIONS(951),
    [anon_sym_long] = ACTIONS(951),
    [anon_sym_short] = ACTIONS(951),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_auto] = ACTIONS(936),
    [anon_sym_register] = ACTIONS(936),
    [anon_sym_inline] = ACTIONS(936),
    [anon_sym___inline] = ACTIONS(936),
    [anon_sym___inline__] = ACTIONS(936),
    [anon_sym___forceinline] = ACTIONS(936),
    [anon_sym_thread_local] = ACTIONS(936),
    [anon_sym___thread] = ACTIONS(936),
    [anon_sym_const] = ACTIONS(954),
    [anon_sym_constexpr] = ACTIONS(954),
    [anon_sym_volatile] = ACTIONS(954),
    [anon_sym_restrict] = ACTIONS(954),
    [anon_sym___restrict__] = ACTIONS(954),
    [anon_sym__Atomic] = ACTIONS(954),
    [anon_sym__Noreturn] = ACTIONS(954),
    [anon_sym_noreturn] = ACTIONS(954),
    [sym_primitive_type] = ACTIONS(957),
    [anon_sym_enum] = ACTIONS(960),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_union] = ACTIONS(966),
    [anon_sym_if] = ACTIONS(969),
    [anon_sym_else] = ACTIONS(913),
    [anon_sym_switch] = ACTIONS(972),
    [anon_sym_case] = ACTIONS(913),
    [anon_sym_default] = ACTIONS(913),
    [anon_sym_while] = ACTIONS(975),
    [anon_sym_do] = ACTIONS(978),
    [anon_sym_for] = ACTIONS(981),
    [anon_sym_return] = ACTIONS(984),
    [anon_sym_break] = ACTIONS(987),
    [anon_sym_continue] = ACTIONS(990),
    [anon_sym_goto] = ACTIONS(993),
    [anon_sym___try] = ACTIONS(996),
    [anon_sym___leave] = ACTIONS(999),
    [anon_sym_DASH_DASH] = ACTIONS(1002),
    [anon_sym_PLUS_PLUS] = ACTIONS(1002),
    [anon_sym_sizeof] = ACTIONS(1005),
    [anon_sym___alignof__] = ACTIONS(1008),
    [anon_sym___alignof] = ACTIONS(1008),
    [anon_sym__alignof] = ACTIONS(1008),
    [anon_sym_alignof] = ACTIONS(1008),
    [anon_sym__Alignof] = ACTIONS(1008),
    [anon_sym_offsetof] = ACTIONS(1011),
    [anon_sym__Generic] = ACTIONS(1014),
    [anon_sym_asm] = ACTIONS(1017),
    [anon_sym___asm__] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1020),
    [anon_sym_L_SQUOTE] = ACTIONS(1023),
    [anon_sym_u_SQUOTE] = ACTIONS(1023),
    [anon_sym_U_SQUOTE] = ACTIONS(1023),
    [anon_sym_u8_SQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1023),
    [anon_sym_L_DQUOTE] = ACTIONS(1026),
    [anon_sym_u_DQUOTE] = ACTIONS(1026),
    [anon_sym_U_DQUOTE] = ACTIONS(1026),
    [anon_sym_u8_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [sym_true] = ACTIONS(1029),
    [sym_false] = ACTIONS(1029),
    [anon_sym_NULL] = ACTIONS(1032),
    [anon_sym_nullptr] = ACTIONS(1032),
    [sym_comment] = ACTIONS(3),
  },
  [55] = {
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1421),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(432),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(54),
    [sym_identifier] = ACTIONS(1035),
    [aux_sym_preproc_include_token1] = ACTIONS(1037),
    [aux_sym_preproc_def_token1] = ACTIONS(1037),
    [aux_sym_preproc_if_token1] = ACTIONS(1037),
    [aux_sym_preproc_if_token2] = ACTIONS(1037),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1037),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1037),
    [aux_sym_preproc_else_token1] = ACTIONS(1037),
    [aux_sym_preproc_elif_token1] = ACTIONS(1037),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1037),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1037),
    [sym_preproc_directive] = ACTIONS(1037),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym___extension__] = ACTIONS(123),
    [anon_sym_typedef] = ACTIONS(125),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1037),
    [anon_sym___clrcall] = ACTIONS(1037),
    [anon_sym___stdcall] = ACTIONS(1037),
    [anon_sym___fastcall] = ACTIONS(1037),
    [anon_sym___thiscall] = ACTIONS(1037),
    [anon_sym___vectorcall] = ACTIONS(1037),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_else] = ACTIONS(1037),
    [anon_sym_switch] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_do] = ACTIONS(141),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_continue] = ACTIONS(149),
    [anon_sym_goto] = ACTIONS(151),
    [anon_sym___try] = ACTIONS(153),
    [anon_sym___leave] = ACTIONS(155),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [56] = {
    [sym_declaration] = STATE(58),
    [sym_type_definition] = STATE(58),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1421),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(58),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(58),
    [sym_labeled_statement] = STATE(58),
    [sym_expression_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_return_statement] = STATE(58),
    [sym_break_statement] = STATE(58),
    [sym_continue_statement] = STATE(58),
    [sym_goto_statement] = STATE(58),
    [sym_seh_try_statement] = STATE(58),
    [sym_seh_leave_statement] = STATE(58),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(432),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(58),
    [sym_identifier] = ACTIONS(1035),
    [aux_sym_preproc_include_token1] = ACTIONS(1039),
    [aux_sym_preproc_def_token1] = ACTIONS(1039),
    [aux_sym_preproc_if_token1] = ACTIONS(1039),
    [aux_sym_preproc_if_token2] = ACTIONS(1039),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1039),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1039),
    [aux_sym_preproc_else_token1] = ACTIONS(1039),
    [aux_sym_preproc_elif_token1] = ACTIONS(1039),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1039),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1039),
    [sym_preproc_directive] = ACTIONS(1039),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym___extension__] = ACTIONS(123),
    [anon_sym_typedef] = ACTIONS(125),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1039),
    [anon_sym___clrcall] = ACTIONS(1039),
    [anon_sym___stdcall] = ACTIONS(1039),
    [anon_sym___fastcall] = ACTIONS(1039),
    [anon_sym___thiscall] = ACTIONS(1039),
    [anon_sym___vectorcall] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_else] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(1039),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_do] = ACTIONS(141),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_continue] = ACTIONS(149),
    [anon_sym_goto] = ACTIONS(151),
    [anon_sym___try] = ACTIONS(153),
    [anon_sym___leave] = ACTIONS(155),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [57] = {
    [sym_declaration] = STATE(55),
    [sym_type_definition] = STATE(55),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1421),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(55),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(55),
    [sym_labeled_statement] = STATE(55),
    [sym_expression_statement] = STATE(55),
    [sym_if_statement] = STATE(55),
    [sym_switch_statement] = STATE(55),
    [sym_while_statement] = STATE(55),
    [sym_do_statement] = STATE(55),
    [sym_for_statement] = STATE(55),
    [sym_return_statement] = STATE(55),
    [sym_break_statement] = STATE(55),
    [sym_continue_statement] = STATE(55),
    [sym_goto_statement] = STATE(55),
    [sym_seh_try_statement] = STATE(55),
    [sym_seh_leave_statement] = STATE(55),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(432),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(55),
    [sym_identifier] = ACTIONS(1035),
    [aux_sym_preproc_include_token1] = ACTIONS(1041),
    [aux_sym_preproc_def_token1] = ACTIONS(1041),
    [aux_sym_preproc_if_token1] = ACTIONS(1041),
    [aux_sym_preproc_if_token2] = ACTIONS(1041),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1041),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1041),
    [aux_sym_preproc_else_token1] = ACTIONS(1041),
    [aux_sym_preproc_elif_token1] = ACTIONS(1041),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1041),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1041),
    [sym_preproc_directive] = ACTIONS(1041),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym___extension__] = ACTIONS(123),
    [anon_sym_typedef] = ACTIONS(125),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1041),
    [anon_sym___clrcall] = ACTIONS(1041),
    [anon_sym___stdcall] = ACTIONS(1041),
    [anon_sym___fastcall] = ACTIONS(1041),
    [anon_sym___thiscall] = ACTIONS(1041),
    [anon_sym___vectorcall] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_else] = ACTIONS(1041),
    [anon_sym_switch] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(1041),
    [anon_sym_default] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_do] = ACTIONS(141),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_continue] = ACTIONS(149),
    [anon_sym_goto] = ACTIONS(151),
    [anon_sym___try] = ACTIONS(153),
    [anon_sym___leave] = ACTIONS(155),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [58] = {
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1421),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(432),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(54),
    [sym_identifier] = ACTIONS(1035),
    [aux_sym_preproc_include_token1] = ACTIONS(1043),
    [aux_sym_preproc_def_token1] = ACTIONS(1043),
    [aux_sym_preproc_if_token1] = ACTIONS(1043),
    [aux_sym_preproc_if_token2] = ACTIONS(1043),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1043),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1043),
    [aux_sym_preproc_else_token1] = ACTIONS(1043),
    [aux_sym_preproc_elif_token1] = ACTIONS(1043),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1043),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1043),
    [sym_preproc_directive] = ACTIONS(1043),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym___extension__] = ACTIONS(123),
    [anon_sym_typedef] = ACTIONS(125),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1043),
    [anon_sym___clrcall] = ACTIONS(1043),
    [anon_sym___stdcall] = ACTIONS(1043),
    [anon_sym___fastcall] = ACTIONS(1043),
    [anon_sym___thiscall] = ACTIONS(1043),
    [anon_sym___vectorcall] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_else] = ACTIONS(1043),
    [anon_sym_switch] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(1043),
    [anon_sym_default] = ACTIONS(1043),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_do] = ACTIONS(141),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_continue] = ACTIONS(149),
    [anon_sym_goto] = ACTIONS(151),
    [anon_sym___try] = ACTIONS(153),
    [anon_sym___leave] = ACTIONS(155),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [59] = {
    [sym_declaration] = STATE(63),
    [sym_type_definition] = STATE(63),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1426),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(63),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(63),
    [sym_labeled_statement] = STATE(63),
    [sym_expression_statement] = STATE(63),
    [sym_if_statement] = STATE(63),
    [sym_switch_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_do_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_return_statement] = STATE(63),
    [sym_break_statement] = STATE(63),
    [sym_continue_statement] = STATE(63),
    [sym_goto_statement] = STATE(63),
    [sym_seh_try_statement] = STATE(63),
    [sym_seh_leave_statement] = STATE(63),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(63),
    [sym_identifier] = ACTIONS(1045),
    [aux_sym_preproc_include_token1] = ACTIONS(1037),
    [aux_sym_preproc_def_token1] = ACTIONS(1037),
    [aux_sym_preproc_if_token1] = ACTIONS(1037),
    [aux_sym_preproc_if_token2] = ACTIONS(1037),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1037),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1037),
    [aux_sym_preproc_else_token1] = ACTIONS(1037),
    [aux_sym_preproc_elif_token1] = ACTIONS(1037),
    [sym_preproc_directive] = ACTIONS(1037),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym___extension__] = ACTIONS(195),
    [anon_sym_typedef] = ACTIONS(197),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1037),
    [anon_sym___clrcall] = ACTIONS(1037),
    [anon_sym___stdcall] = ACTIONS(1037),
    [anon_sym___fastcall] = ACTIONS(1037),
    [anon_sym___thiscall] = ACTIONS(1037),
    [anon_sym___vectorcall] = ACTIONS(1037),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_else] = ACTIONS(1037),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [60] = {
    [sym_declaration] = STATE(63),
    [sym_type_definition] = STATE(63),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1426),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(63),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(63),
    [sym_labeled_statement] = STATE(63),
    [sym_expression_statement] = STATE(63),
    [sym_if_statement] = STATE(63),
    [sym_switch_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_do_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_return_statement] = STATE(63),
    [sym_break_statement] = STATE(63),
    [sym_continue_statement] = STATE(63),
    [sym_goto_statement] = STATE(63),
    [sym_seh_try_statement] = STATE(63),
    [sym_seh_leave_statement] = STATE(63),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(63),
    [sym_identifier] = ACTIONS(1045),
    [aux_sym_preproc_include_token1] = ACTIONS(1043),
    [aux_sym_preproc_def_token1] = ACTIONS(1043),
    [aux_sym_preproc_if_token1] = ACTIONS(1043),
    [aux_sym_preproc_if_token2] = ACTIONS(1043),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1043),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1043),
    [aux_sym_preproc_else_token1] = ACTIONS(1043),
    [aux_sym_preproc_elif_token1] = ACTIONS(1043),
    [sym_preproc_directive] = ACTIONS(1043),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym___extension__] = ACTIONS(195),
    [anon_sym_typedef] = ACTIONS(197),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1043),
    [anon_sym___clrcall] = ACTIONS(1043),
    [anon_sym___stdcall] = ACTIONS(1043),
    [anon_sym___fastcall] = ACTIONS(1043),
    [anon_sym___thiscall] = ACTIONS(1043),
    [anon_sym___vectorcall] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_else] = ACTIONS(1043),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(1043),
    [anon_sym_default] = ACTIONS(1043),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [61] = {
    [sym_declaration] = STATE(59),
    [sym_type_definition] = STATE(59),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1426),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(59),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(59),
    [sym_labeled_statement] = STATE(59),
    [sym_expression_statement] = STATE(59),
    [sym_if_statement] = STATE(59),
    [sym_switch_statement] = STATE(59),
    [sym_while_statement] = STATE(59),
    [sym_do_statement] = STATE(59),
    [sym_for_statement] = STATE(59),
    [sym_return_statement] = STATE(59),
    [sym_break_statement] = STATE(59),
    [sym_continue_statement] = STATE(59),
    [sym_goto_statement] = STATE(59),
    [sym_seh_try_statement] = STATE(59),
    [sym_seh_leave_statement] = STATE(59),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(59),
    [sym_identifier] = ACTIONS(1045),
    [aux_sym_preproc_include_token1] = ACTIONS(1041),
    [aux_sym_preproc_def_token1] = ACTIONS(1041),
    [aux_sym_preproc_if_token1] = ACTIONS(1041),
    [aux_sym_preproc_if_token2] = ACTIONS(1041),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1041),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1041),
    [aux_sym_preproc_else_token1] = ACTIONS(1041),
    [aux_sym_preproc_elif_token1] = ACTIONS(1041),
    [sym_preproc_directive] = ACTIONS(1041),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym___extension__] = ACTIONS(195),
    [anon_sym_typedef] = ACTIONS(197),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1041),
    [anon_sym___clrcall] = ACTIONS(1041),
    [anon_sym___stdcall] = ACTIONS(1041),
    [anon_sym___fastcall] = ACTIONS(1041),
    [anon_sym___thiscall] = ACTIONS(1041),
    [anon_sym___vectorcall] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_else] = ACTIONS(1041),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(1041),
    [anon_sym_default] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [62] = {
    [sym_declaration] = STATE(60),
    [sym_type_definition] = STATE(60),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1426),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(60),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(60),
    [sym_labeled_statement] = STATE(60),
    [sym_expression_statement] = STATE(60),
    [sym_if_statement] = STATE(60),
    [sym_switch_statement] = STATE(60),
    [sym_while_statement] = STATE(60),
    [sym_do_statement] = STATE(60),
    [sym_for_statement] = STATE(60),
    [sym_return_statement] = STATE(60),
    [sym_break_statement] = STATE(60),
    [sym_continue_statement] = STATE(60),
    [sym_goto_statement] = STATE(60),
    [sym_seh_try_statement] = STATE(60),
    [sym_seh_leave_statement] = STATE(60),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(60),
    [sym_identifier] = ACTIONS(1045),
    [aux_sym_preproc_include_token1] = ACTIONS(1039),
    [aux_sym_preproc_def_token1] = ACTIONS(1039),
    [aux_sym_preproc_if_token1] = ACTIONS(1039),
    [aux_sym_preproc_if_token2] = ACTIONS(1039),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1039),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1039),
    [aux_sym_preproc_else_token1] = ACTIONS(1039),
    [aux_sym_preproc_elif_token1] = ACTIONS(1039),
    [sym_preproc_directive] = ACTIONS(1039),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym___extension__] = ACTIONS(195),
    [anon_sym_typedef] = ACTIONS(197),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1039),
    [anon_sym___clrcall] = ACTIONS(1039),
    [anon_sym___stdcall] = ACTIONS(1039),
    [anon_sym___fastcall] = ACTIONS(1039),
    [anon_sym___thiscall] = ACTIONS(1039),
    [anon_sym___vectorcall] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_else] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(1039),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [63] = {
    [sym_declaration] = STATE(63),
    [sym_type_definition] = STATE(63),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1426),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(63),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(63),
    [sym_labeled_statement] = STATE(63),
    [sym_expression_statement] = STATE(63),
    [sym_if_statement] = STATE(63),
    [sym_switch_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_do_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_return_statement] = STATE(63),
    [sym_break_statement] = STATE(63),
    [sym_continue_statement] = STATE(63),
    [sym_goto_statement] = STATE(63),
    [sym_seh_try_statement] = STATE(63),
    [sym_seh_leave_statement] = STATE(63),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(63),
    [sym_identifier] = ACTIONS(1047),
    [aux_sym_preproc_include_token1] = ACTIONS(913),
    [aux_sym_preproc_def_token1] = ACTIONS(913),
    [aux_sym_preproc_if_token1] = ACTIONS(913),
    [aux_sym_preproc_if_token2] = ACTIONS(913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(913),
    [aux_sym_preproc_else_token1] = ACTIONS(913),
    [aux_sym_preproc_elif_token1] = ACTIONS(913),
    [sym_preproc_directive] = ACTIONS(913),
    [anon_sym_LPAREN2] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_STAR] = ACTIONS(924),
    [anon_sym_AMP] = ACTIONS(924),
    [anon_sym_SEMI] = ACTIONS(1050),
    [anon_sym___extension__] = ACTIONS(1053),
    [anon_sym_typedef] = ACTIONS(1056),
    [anon_sym_extern] = ACTIONS(936),
    [anon_sym___attribute__] = ACTIONS(939),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(942),
    [anon_sym___declspec] = ACTIONS(945),
    [anon_sym___cdecl] = ACTIONS(913),
    [anon_sym___clrcall] = ACTIONS(913),
    [anon_sym___stdcall] = ACTIONS(913),
    [anon_sym___fastcall] = ACTIONS(913),
    [anon_sym___thiscall] = ACTIONS(913),
    [anon_sym___vectorcall] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1059),
    [anon_sym_signed] = ACTIONS(951),
    [anon_sym_unsigned] = ACTIONS(951),
    [anon_sym_long] = ACTIONS(951),
    [anon_sym_short] = ACTIONS(951),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_auto] = ACTIONS(936),
    [anon_sym_register] = ACTIONS(936),
    [anon_sym_inline] = ACTIONS(936),
    [anon_sym___inline] = ACTIONS(936),
    [anon_sym___inline__] = ACTIONS(936),
    [anon_sym___forceinline] = ACTIONS(936),
    [anon_sym_thread_local] = ACTIONS(936),
    [anon_sym___thread] = ACTIONS(936),
    [anon_sym_const] = ACTIONS(954),
    [anon_sym_constexpr] = ACTIONS(954),
    [anon_sym_volatile] = ACTIONS(954),
    [anon_sym_restrict] = ACTIONS(954),
    [anon_sym___restrict__] = ACTIONS(954),
    [anon_sym__Atomic] = ACTIONS(954),
    [anon_sym__Noreturn] = ACTIONS(954),
    [anon_sym_noreturn] = ACTIONS(954),
    [sym_primitive_type] = ACTIONS(957),
    [anon_sym_enum] = ACTIONS(960),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_union] = ACTIONS(966),
    [anon_sym_if] = ACTIONS(1062),
    [anon_sym_else] = ACTIONS(913),
    [anon_sym_switch] = ACTIONS(1065),
    [anon_sym_case] = ACTIONS(913),
    [anon_sym_default] = ACTIONS(913),
    [anon_sym_while] = ACTIONS(1068),
    [anon_sym_do] = ACTIONS(1071),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_return] = ACTIONS(1077),
    [anon_sym_break] = ACTIONS(1080),
    [anon_sym_continue] = ACTIONS(1083),
    [anon_sym_goto] = ACTIONS(1086),
    [anon_sym___try] = ACTIONS(1089),
    [anon_sym___leave] = ACTIONS(1092),
    [anon_sym_DASH_DASH] = ACTIONS(1002),
    [anon_sym_PLUS_PLUS] = ACTIONS(1002),
    [anon_sym_sizeof] = ACTIONS(1005),
    [anon_sym___alignof__] = ACTIONS(1008),
    [anon_sym___alignof] = ACTIONS(1008),
    [anon_sym__alignof] = ACTIONS(1008),
    [anon_sym_alignof] = ACTIONS(1008),
    [anon_sym__Alignof] = ACTIONS(1008),
    [anon_sym_offsetof] = ACTIONS(1011),
    [anon_sym__Generic] = ACTIONS(1014),
    [anon_sym_asm] = ACTIONS(1017),
    [anon_sym___asm__] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1020),
    [anon_sym_L_SQUOTE] = ACTIONS(1023),
    [anon_sym_u_SQUOTE] = ACTIONS(1023),
    [anon_sym_U_SQUOTE] = ACTIONS(1023),
    [anon_sym_u8_SQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1023),
    [anon_sym_L_DQUOTE] = ACTIONS(1026),
    [anon_sym_u_DQUOTE] = ACTIONS(1026),
    [anon_sym_U_DQUOTE] = ACTIONS(1026),
    [anon_sym_u8_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [sym_true] = ACTIONS(1029),
    [sym_false] = ACTIONS(1029),
    [anon_sym_NULL] = ACTIONS(1032),
    [anon_sym_nullptr] = ACTIONS(1032),
    [sym_comment] = ACTIONS(3),
  },
  [64] = {
    [sym_declaration] = STATE(68),
    [sym_type_definition] = STATE(68),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1422),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(68),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(68),
    [sym_labeled_statement] = STATE(68),
    [sym_expression_statement] = STATE(68),
    [sym_if_statement] = STATE(68),
    [sym_switch_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_do_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_return_statement] = STATE(68),
    [sym_break_statement] = STATE(68),
    [sym_continue_statement] = STATE(68),
    [sym_goto_statement] = STATE(68),
    [sym_seh_try_statement] = STATE(68),
    [sym_seh_leave_statement] = STATE(68),
    [sym__expression] = STATE(1313),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2275),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(68),
    [sym_identifier] = ACTIONS(1095),
    [aux_sym_preproc_include_token1] = ACTIONS(1041),
    [aux_sym_preproc_def_token1] = ACTIONS(1041),
    [aux_sym_preproc_if_token1] = ACTIONS(1041),
    [aux_sym_preproc_if_token2] = ACTIONS(1041),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1041),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1041),
    [sym_preproc_directive] = ACTIONS(1041),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(557),
    [anon_sym___extension__] = ACTIONS(559),
    [anon_sym_typedef] = ACTIONS(561),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1041),
    [anon_sym___clrcall] = ACTIONS(1041),
    [anon_sym___stdcall] = ACTIONS(1041),
    [anon_sym___fastcall] = ACTIONS(1041),
    [anon_sym___thiscall] = ACTIONS(1041),
    [anon_sym___vectorcall] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_else] = ACTIONS(1041),
    [anon_sym_switch] = ACTIONS(569),
    [anon_sym_case] = ACTIONS(1041),
    [anon_sym_default] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(575),
    [anon_sym_do] = ACTIONS(577),
    [anon_sym_for] = ACTIONS(579),
    [anon_sym_return] = ACTIONS(581),
    [anon_sym_break] = ACTIONS(583),
    [anon_sym_continue] = ACTIONS(585),
    [anon_sym_goto] = ACTIONS(587),
    [anon_sym___try] = ACTIONS(589),
    [anon_sym___leave] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [65] = {
    [sym_declaration] = STATE(75),
    [sym_type_definition] = STATE(75),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1429),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(75),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(75),
    [sym_labeled_statement] = STATE(75),
    [sym_expression_statement] = STATE(75),
    [sym_if_statement] = STATE(75),
    [sym_switch_statement] = STATE(75),
    [sym_while_statement] = STATE(75),
    [sym_do_statement] = STATE(75),
    [sym_for_statement] = STATE(75),
    [sym_return_statement] = STATE(75),
    [sym_break_statement] = STATE(75),
    [sym_continue_statement] = STATE(75),
    [sym_goto_statement] = STATE(75),
    [sym_seh_try_statement] = STATE(75),
    [sym_seh_leave_statement] = STATE(75),
    [sym__expression] = STATE(1348),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2343),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(463),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(75),
    [ts_builtin_sym_end] = ACTIONS(1097),
    [sym_identifier] = ACTIONS(1099),
    [aux_sym_preproc_include_token1] = ACTIONS(1043),
    [aux_sym_preproc_def_token1] = ACTIONS(1043),
    [aux_sym_preproc_if_token1] = ACTIONS(1043),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1043),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1043),
    [sym_preproc_directive] = ACTIONS(1043),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1101),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1043),
    [anon_sym___clrcall] = ACTIONS(1043),
    [anon_sym___stdcall] = ACTIONS(1043),
    [anon_sym___fastcall] = ACTIONS(1043),
    [anon_sym___thiscall] = ACTIONS(1043),
    [anon_sym___vectorcall] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_else] = ACTIONS(1043),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1043),
    [anon_sym_default] = ACTIONS(1043),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1103),
    [anon_sym___leave] = ACTIONS(1105),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [66] = {
    [sym_declaration] = STATE(66),
    [sym_type_definition] = STATE(66),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1422),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(66),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(66),
    [sym_labeled_statement] = STATE(66),
    [sym_expression_statement] = STATE(66),
    [sym_if_statement] = STATE(66),
    [sym_switch_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_do_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_return_statement] = STATE(66),
    [sym_break_statement] = STATE(66),
    [sym_continue_statement] = STATE(66),
    [sym_goto_statement] = STATE(66),
    [sym_seh_try_statement] = STATE(66),
    [sym_seh_leave_statement] = STATE(66),
    [sym__expression] = STATE(1313),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2275),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(66),
    [sym_identifier] = ACTIONS(1107),
    [aux_sym_preproc_include_token1] = ACTIONS(913),
    [aux_sym_preproc_def_token1] = ACTIONS(913),
    [aux_sym_preproc_if_token1] = ACTIONS(913),
    [aux_sym_preproc_if_token2] = ACTIONS(913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(913),
    [sym_preproc_directive] = ACTIONS(913),
    [anon_sym_LPAREN2] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_STAR] = ACTIONS(924),
    [anon_sym_AMP] = ACTIONS(924),
    [anon_sym_SEMI] = ACTIONS(1110),
    [anon_sym___extension__] = ACTIONS(1113),
    [anon_sym_typedef] = ACTIONS(1116),
    [anon_sym_extern] = ACTIONS(936),
    [anon_sym___attribute__] = ACTIONS(939),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(942),
    [anon_sym___declspec] = ACTIONS(945),
    [anon_sym___cdecl] = ACTIONS(913),
    [anon_sym___clrcall] = ACTIONS(913),
    [anon_sym___stdcall] = ACTIONS(913),
    [anon_sym___fastcall] = ACTIONS(913),
    [anon_sym___thiscall] = ACTIONS(913),
    [anon_sym___vectorcall] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_signed] = ACTIONS(951),
    [anon_sym_unsigned] = ACTIONS(951),
    [anon_sym_long] = ACTIONS(951),
    [anon_sym_short] = ACTIONS(951),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_auto] = ACTIONS(936),
    [anon_sym_register] = ACTIONS(936),
    [anon_sym_inline] = ACTIONS(936),
    [anon_sym___inline] = ACTIONS(936),
    [anon_sym___inline__] = ACTIONS(936),
    [anon_sym___forceinline] = ACTIONS(936),
    [anon_sym_thread_local] = ACTIONS(936),
    [anon_sym___thread] = ACTIONS(936),
    [anon_sym_const] = ACTIONS(954),
    [anon_sym_constexpr] = ACTIONS(954),
    [anon_sym_volatile] = ACTIONS(954),
    [anon_sym_restrict] = ACTIONS(954),
    [anon_sym___restrict__] = ACTIONS(954),
    [anon_sym__Atomic] = ACTIONS(954),
    [anon_sym__Noreturn] = ACTIONS(954),
    [anon_sym_noreturn] = ACTIONS(954),
    [sym_primitive_type] = ACTIONS(957),
    [anon_sym_enum] = ACTIONS(960),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_union] = ACTIONS(966),
    [anon_sym_if] = ACTIONS(1122),
    [anon_sym_else] = ACTIONS(913),
    [anon_sym_switch] = ACTIONS(1125),
    [anon_sym_case] = ACTIONS(913),
    [anon_sym_default] = ACTIONS(913),
    [anon_sym_while] = ACTIONS(1128),
    [anon_sym_do] = ACTIONS(1131),
    [anon_sym_for] = ACTIONS(1134),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_break] = ACTIONS(1140),
    [anon_sym_continue] = ACTIONS(1143),
    [anon_sym_goto] = ACTIONS(1146),
    [anon_sym___try] = ACTIONS(1149),
    [anon_sym___leave] = ACTIONS(1152),
    [anon_sym_DASH_DASH] = ACTIONS(1002),
    [anon_sym_PLUS_PLUS] = ACTIONS(1002),
    [anon_sym_sizeof] = ACTIONS(1005),
    [anon_sym___alignof__] = ACTIONS(1008),
    [anon_sym___alignof] = ACTIONS(1008),
    [anon_sym__alignof] = ACTIONS(1008),
    [anon_sym_alignof] = ACTIONS(1008),
    [anon_sym__Alignof] = ACTIONS(1008),
    [anon_sym_offsetof] = ACTIONS(1011),
    [anon_sym__Generic] = ACTIONS(1014),
    [anon_sym_asm] = ACTIONS(1017),
    [anon_sym___asm__] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1020),
    [anon_sym_L_SQUOTE] = ACTIONS(1023),
    [anon_sym_u_SQUOTE] = ACTIONS(1023),
    [anon_sym_U_SQUOTE] = ACTIONS(1023),
    [anon_sym_u8_SQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1023),
    [anon_sym_L_DQUOTE] = ACTIONS(1026),
    [anon_sym_u_DQUOTE] = ACTIONS(1026),
    [anon_sym_U_DQUOTE] = ACTIONS(1026),
    [anon_sym_u8_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [sym_true] = ACTIONS(1029),
    [sym_false] = ACTIONS(1029),
    [anon_sym_NULL] = ACTIONS(1032),
    [anon_sym_nullptr] = ACTIONS(1032),
    [sym_comment] = ACTIONS(3),
  },
  [67] = {
    [sym_declaration] = STATE(66),
    [sym_type_definition] = STATE(66),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1422),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(66),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(66),
    [sym_labeled_statement] = STATE(66),
    [sym_expression_statement] = STATE(66),
    [sym_if_statement] = STATE(66),
    [sym_switch_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_do_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_return_statement] = STATE(66),
    [sym_break_statement] = STATE(66),
    [sym_continue_statement] = STATE(66),
    [sym_goto_statement] = STATE(66),
    [sym_seh_try_statement] = STATE(66),
    [sym_seh_leave_statement] = STATE(66),
    [sym__expression] = STATE(1313),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2275),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(66),
    [sym_identifier] = ACTIONS(1095),
    [aux_sym_preproc_include_token1] = ACTIONS(1043),
    [aux_sym_preproc_def_token1] = ACTIONS(1043),
    [aux_sym_preproc_if_token1] = ACTIONS(1043),
    [aux_sym_preproc_if_token2] = ACTIONS(1043),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1043),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1043),
    [sym_preproc_directive] = ACTIONS(1043),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(557),
    [anon_sym___extension__] = ACTIONS(559),
    [anon_sym_typedef] = ACTIONS(561),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1043),
    [anon_sym___clrcall] = ACTIONS(1043),
    [anon_sym___stdcall] = ACTIONS(1043),
    [anon_sym___fastcall] = ACTIONS(1043),
    [anon_sym___thiscall] = ACTIONS(1043),
    [anon_sym___vectorcall] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_else] = ACTIONS(1043),
    [anon_sym_switch] = ACTIONS(569),
    [anon_sym_case] = ACTIONS(1043),
    [anon_sym_default] = ACTIONS(1043),
    [anon_sym_while] = ACTIONS(575),
    [anon_sym_do] = ACTIONS(577),
    [anon_sym_for] = ACTIONS(579),
    [anon_sym_return] = ACTIONS(581),
    [anon_sym_break] = ACTIONS(583),
    [anon_sym_continue] = ACTIONS(585),
    [anon_sym_goto] = ACTIONS(587),
    [anon_sym___try] = ACTIONS(589),
    [anon_sym___leave] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [68] = {
    [sym_declaration] = STATE(66),
    [sym_type_definition] = STATE(66),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1422),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(66),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(66),
    [sym_labeled_statement] = STATE(66),
    [sym_expression_statement] = STATE(66),
    [sym_if_statement] = STATE(66),
    [sym_switch_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_do_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_return_statement] = STATE(66),
    [sym_break_statement] = STATE(66),
    [sym_continue_statement] = STATE(66),
    [sym_goto_statement] = STATE(66),
    [sym_seh_try_statement] = STATE(66),
    [sym_seh_leave_statement] = STATE(66),
    [sym__expression] = STATE(1313),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2275),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(66),
    [sym_identifier] = ACTIONS(1095),
    [aux_sym_preproc_include_token1] = ACTIONS(1037),
    [aux_sym_preproc_def_token1] = ACTIONS(1037),
    [aux_sym_preproc_if_token1] = ACTIONS(1037),
    [aux_sym_preproc_if_token2] = ACTIONS(1037),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1037),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1037),
    [sym_preproc_directive] = ACTIONS(1037),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(557),
    [anon_sym___extension__] = ACTIONS(559),
    [anon_sym_typedef] = ACTIONS(561),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1037),
    [anon_sym___clrcall] = ACTIONS(1037),
    [anon_sym___stdcall] = ACTIONS(1037),
    [anon_sym___fastcall] = ACTIONS(1037),
    [anon_sym___thiscall] = ACTIONS(1037),
    [anon_sym___vectorcall] = ACTIONS(1037),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_else] = ACTIONS(1037),
    [anon_sym_switch] = ACTIONS(569),
    [anon_sym_case] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(575),
    [anon_sym_do] = ACTIONS(577),
    [anon_sym_for] = ACTIONS(579),
    [anon_sym_return] = ACTIONS(581),
    [anon_sym_break] = ACTIONS(583),
    [anon_sym_continue] = ACTIONS(585),
    [anon_sym_goto] = ACTIONS(587),
    [anon_sym___try] = ACTIONS(589),
    [anon_sym___leave] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [69] = {
    [sym_declaration] = STATE(69),
    [sym_type_definition] = STATE(69),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1416),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(69),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(69),
    [sym_labeled_statement] = STATE(69),
    [sym_expression_statement] = STATE(69),
    [sym_if_statement] = STATE(69),
    [sym_switch_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_do_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_return_statement] = STATE(69),
    [sym_break_statement] = STATE(69),
    [sym_continue_statement] = STATE(69),
    [sym_goto_statement] = STATE(69),
    [sym_seh_try_statement] = STATE(69),
    [sym_seh_leave_statement] = STATE(69),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(69),
    [sym_identifier] = ACTIONS(1155),
    [aux_sym_preproc_include_token1] = ACTIONS(913),
    [aux_sym_preproc_def_token1] = ACTIONS(913),
    [aux_sym_preproc_if_token1] = ACTIONS(913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(913),
    [sym_preproc_directive] = ACTIONS(913),
    [anon_sym_LPAREN2] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_STAR] = ACTIONS(924),
    [anon_sym_AMP] = ACTIONS(924),
    [anon_sym_SEMI] = ACTIONS(1158),
    [anon_sym___extension__] = ACTIONS(1161),
    [anon_sym_typedef] = ACTIONS(1164),
    [anon_sym_extern] = ACTIONS(936),
    [anon_sym___attribute__] = ACTIONS(939),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(942),
    [anon_sym___declspec] = ACTIONS(945),
    [anon_sym___cdecl] = ACTIONS(913),
    [anon_sym___clrcall] = ACTIONS(913),
    [anon_sym___stdcall] = ACTIONS(913),
    [anon_sym___fastcall] = ACTIONS(913),
    [anon_sym___thiscall] = ACTIONS(913),
    [anon_sym___vectorcall] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(1170),
    [anon_sym_signed] = ACTIONS(951),
    [anon_sym_unsigned] = ACTIONS(951),
    [anon_sym_long] = ACTIONS(951),
    [anon_sym_short] = ACTIONS(951),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_auto] = ACTIONS(936),
    [anon_sym_register] = ACTIONS(936),
    [anon_sym_inline] = ACTIONS(936),
    [anon_sym___inline] = ACTIONS(936),
    [anon_sym___inline__] = ACTIONS(936),
    [anon_sym___forceinline] = ACTIONS(936),
    [anon_sym_thread_local] = ACTIONS(936),
    [anon_sym___thread] = ACTIONS(936),
    [anon_sym_const] = ACTIONS(954),
    [anon_sym_constexpr] = ACTIONS(954),
    [anon_sym_volatile] = ACTIONS(954),
    [anon_sym_restrict] = ACTIONS(954),
    [anon_sym___restrict__] = ACTIONS(954),
    [anon_sym__Atomic] = ACTIONS(954),
    [anon_sym__Noreturn] = ACTIONS(954),
    [anon_sym_noreturn] = ACTIONS(954),
    [sym_primitive_type] = ACTIONS(957),
    [anon_sym_enum] = ACTIONS(960),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_union] = ACTIONS(966),
    [anon_sym_if] = ACTIONS(1172),
    [anon_sym_else] = ACTIONS(913),
    [anon_sym_switch] = ACTIONS(1175),
    [anon_sym_case] = ACTIONS(913),
    [anon_sym_default] = ACTIONS(913),
    [anon_sym_while] = ACTIONS(1178),
    [anon_sym_do] = ACTIONS(1181),
    [anon_sym_for] = ACTIONS(1184),
    [anon_sym_return] = ACTIONS(1187),
    [anon_sym_break] = ACTIONS(1190),
    [anon_sym_continue] = ACTIONS(1193),
    [anon_sym_goto] = ACTIONS(1196),
    [anon_sym___try] = ACTIONS(1199),
    [anon_sym___leave] = ACTIONS(1202),
    [anon_sym_DASH_DASH] = ACTIONS(1002),
    [anon_sym_PLUS_PLUS] = ACTIONS(1002),
    [anon_sym_sizeof] = ACTIONS(1005),
    [anon_sym___alignof__] = ACTIONS(1008),
    [anon_sym___alignof] = ACTIONS(1008),
    [anon_sym__alignof] = ACTIONS(1008),
    [anon_sym_alignof] = ACTIONS(1008),
    [anon_sym__Alignof] = ACTIONS(1008),
    [anon_sym_offsetof] = ACTIONS(1011),
    [anon_sym__Generic] = ACTIONS(1014),
    [anon_sym_asm] = ACTIONS(1017),
    [anon_sym___asm__] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1020),
    [anon_sym_L_SQUOTE] = ACTIONS(1023),
    [anon_sym_u_SQUOTE] = ACTIONS(1023),
    [anon_sym_U_SQUOTE] = ACTIONS(1023),
    [anon_sym_u8_SQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1023),
    [anon_sym_L_DQUOTE] = ACTIONS(1026),
    [anon_sym_u_DQUOTE] = ACTIONS(1026),
    [anon_sym_U_DQUOTE] = ACTIONS(1026),
    [anon_sym_u8_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [sym_true] = ACTIONS(1029),
    [sym_false] = ACTIONS(1029),
    [anon_sym_NULL] = ACTIONS(1032),
    [anon_sym_nullptr] = ACTIONS(1032),
    [sym_comment] = ACTIONS(3),
  },
  [70] = {
    [sym_declaration] = STATE(69),
    [sym_type_definition] = STATE(69),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1416),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(69),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(69),
    [sym_labeled_statement] = STATE(69),
    [sym_expression_statement] = STATE(69),
    [sym_if_statement] = STATE(69),
    [sym_switch_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_do_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_return_statement] = STATE(69),
    [sym_break_statement] = STATE(69),
    [sym_continue_statement] = STATE(69),
    [sym_goto_statement] = STATE(69),
    [sym_seh_try_statement] = STATE(69),
    [sym_seh_leave_statement] = STATE(69),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(69),
    [sym_identifier] = ACTIONS(1205),
    [aux_sym_preproc_include_token1] = ACTIONS(1043),
    [aux_sym_preproc_def_token1] = ACTIONS(1043),
    [aux_sym_preproc_if_token1] = ACTIONS(1043),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1043),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1043),
    [sym_preproc_directive] = ACTIONS(1043),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1043),
    [anon_sym___clrcall] = ACTIONS(1043),
    [anon_sym___stdcall] = ACTIONS(1043),
    [anon_sym___fastcall] = ACTIONS(1043),
    [anon_sym___thiscall] = ACTIONS(1043),
    [anon_sym___vectorcall] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(1097),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_else] = ACTIONS(1043),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(1043),
    [anon_sym_default] = ACTIONS(1043),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [sym_declaration] = STATE(76),
    [sym_type_definition] = STATE(76),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1416),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(76),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(76),
    [sym_labeled_statement] = STATE(76),
    [sym_expression_statement] = STATE(76),
    [sym_if_statement] = STATE(76),
    [sym_switch_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_do_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_return_statement] = STATE(76),
    [sym_break_statement] = STATE(76),
    [sym_continue_statement] = STATE(76),
    [sym_goto_statement] = STATE(76),
    [sym_seh_try_statement] = STATE(76),
    [sym_seh_leave_statement] = STATE(76),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(76),
    [sym_identifier] = ACTIONS(1205),
    [aux_sym_preproc_include_token1] = ACTIONS(1041),
    [aux_sym_preproc_def_token1] = ACTIONS(1041),
    [aux_sym_preproc_if_token1] = ACTIONS(1041),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1041),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1041),
    [sym_preproc_directive] = ACTIONS(1041),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1041),
    [anon_sym___clrcall] = ACTIONS(1041),
    [anon_sym___stdcall] = ACTIONS(1041),
    [anon_sym___fastcall] = ACTIONS(1041),
    [anon_sym___thiscall] = ACTIONS(1041),
    [anon_sym___vectorcall] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(1207),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_else] = ACTIONS(1041),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(1041),
    [anon_sym_default] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [72] = {
    [sym_declaration] = STATE(67),
    [sym_type_definition] = STATE(67),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1422),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(67),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(67),
    [sym_labeled_statement] = STATE(67),
    [sym_expression_statement] = STATE(67),
    [sym_if_statement] = STATE(67),
    [sym_switch_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_do_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_return_statement] = STATE(67),
    [sym_break_statement] = STATE(67),
    [sym_continue_statement] = STATE(67),
    [sym_goto_statement] = STATE(67),
    [sym_seh_try_statement] = STATE(67),
    [sym_seh_leave_statement] = STATE(67),
    [sym__expression] = STATE(1313),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2275),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(416),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(67),
    [sym_identifier] = ACTIONS(1095),
    [aux_sym_preproc_include_token1] = ACTIONS(1039),
    [aux_sym_preproc_def_token1] = ACTIONS(1039),
    [aux_sym_preproc_if_token1] = ACTIONS(1039),
    [aux_sym_preproc_if_token2] = ACTIONS(1039),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1039),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1039),
    [sym_preproc_directive] = ACTIONS(1039),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(557),
    [anon_sym___extension__] = ACTIONS(559),
    [anon_sym_typedef] = ACTIONS(561),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1039),
    [anon_sym___clrcall] = ACTIONS(1039),
    [anon_sym___stdcall] = ACTIONS(1039),
    [anon_sym___fastcall] = ACTIONS(1039),
    [anon_sym___thiscall] = ACTIONS(1039),
    [anon_sym___vectorcall] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_else] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(569),
    [anon_sym_case] = ACTIONS(1039),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(575),
    [anon_sym_do] = ACTIONS(577),
    [anon_sym_for] = ACTIONS(579),
    [anon_sym_return] = ACTIONS(581),
    [anon_sym_break] = ACTIONS(583),
    [anon_sym_continue] = ACTIONS(585),
    [anon_sym_goto] = ACTIONS(587),
    [anon_sym___try] = ACTIONS(589),
    [anon_sym___leave] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [73] = {
    [sym_declaration] = STATE(65),
    [sym_type_definition] = STATE(65),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1429),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(65),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(65),
    [sym_labeled_statement] = STATE(65),
    [sym_expression_statement] = STATE(65),
    [sym_if_statement] = STATE(65),
    [sym_switch_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_do_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_return_statement] = STATE(65),
    [sym_break_statement] = STATE(65),
    [sym_continue_statement] = STATE(65),
    [sym_goto_statement] = STATE(65),
    [sym_seh_try_statement] = STATE(65),
    [sym_seh_leave_statement] = STATE(65),
    [sym__expression] = STATE(1348),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2343),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(463),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(65),
    [ts_builtin_sym_end] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1099),
    [aux_sym_preproc_include_token1] = ACTIONS(1039),
    [aux_sym_preproc_def_token1] = ACTIONS(1039),
    [aux_sym_preproc_if_token1] = ACTIONS(1039),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1039),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1039),
    [sym_preproc_directive] = ACTIONS(1039),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1101),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1039),
    [anon_sym___clrcall] = ACTIONS(1039),
    [anon_sym___stdcall] = ACTIONS(1039),
    [anon_sym___fastcall] = ACTIONS(1039),
    [anon_sym___thiscall] = ACTIONS(1039),
    [anon_sym___vectorcall] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_else] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1039),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1103),
    [anon_sym___leave] = ACTIONS(1105),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [74] = {
    [sym_declaration] = STATE(75),
    [sym_type_definition] = STATE(75),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1429),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(75),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(75),
    [sym_labeled_statement] = STATE(75),
    [sym_expression_statement] = STATE(75),
    [sym_if_statement] = STATE(75),
    [sym_switch_statement] = STATE(75),
    [sym_while_statement] = STATE(75),
    [sym_do_statement] = STATE(75),
    [sym_for_statement] = STATE(75),
    [sym_return_statement] = STATE(75),
    [sym_break_statement] = STATE(75),
    [sym_continue_statement] = STATE(75),
    [sym_goto_statement] = STATE(75),
    [sym_seh_try_statement] = STATE(75),
    [sym_seh_leave_statement] = STATE(75),
    [sym__expression] = STATE(1348),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2343),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(463),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(75),
    [ts_builtin_sym_end] = ACTIONS(1211),
    [sym_identifier] = ACTIONS(1099),
    [aux_sym_preproc_include_token1] = ACTIONS(1037),
    [aux_sym_preproc_def_token1] = ACTIONS(1037),
    [aux_sym_preproc_if_token1] = ACTIONS(1037),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1037),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1037),
    [sym_preproc_directive] = ACTIONS(1037),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1101),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1037),
    [anon_sym___clrcall] = ACTIONS(1037),
    [anon_sym___stdcall] = ACTIONS(1037),
    [anon_sym___fastcall] = ACTIONS(1037),
    [anon_sym___thiscall] = ACTIONS(1037),
    [anon_sym___vectorcall] = ACTIONS(1037),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_else] = ACTIONS(1037),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1103),
    [anon_sym___leave] = ACTIONS(1105),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [75] = {
    [sym_declaration] = STATE(75),
    [sym_type_definition] = STATE(75),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1429),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(75),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(75),
    [sym_labeled_statement] = STATE(75),
    [sym_expression_statement] = STATE(75),
    [sym_if_statement] = STATE(75),
    [sym_switch_statement] = STATE(75),
    [sym_while_statement] = STATE(75),
    [sym_do_statement] = STATE(75),
    [sym_for_statement] = STATE(75),
    [sym_return_statement] = STATE(75),
    [sym_break_statement] = STATE(75),
    [sym_continue_statement] = STATE(75),
    [sym_goto_statement] = STATE(75),
    [sym_seh_try_statement] = STATE(75),
    [sym_seh_leave_statement] = STATE(75),
    [sym__expression] = STATE(1348),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2343),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(463),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(75),
    [ts_builtin_sym_end] = ACTIONS(1170),
    [sym_identifier] = ACTIONS(1213),
    [aux_sym_preproc_include_token1] = ACTIONS(913),
    [aux_sym_preproc_def_token1] = ACTIONS(913),
    [aux_sym_preproc_if_token1] = ACTIONS(913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(913),
    [sym_preproc_directive] = ACTIONS(913),
    [anon_sym_LPAREN2] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_STAR] = ACTIONS(924),
    [anon_sym_AMP] = ACTIONS(924),
    [anon_sym_SEMI] = ACTIONS(1216),
    [anon_sym___extension__] = ACTIONS(1219),
    [anon_sym_typedef] = ACTIONS(1222),
    [anon_sym_extern] = ACTIONS(936),
    [anon_sym___attribute__] = ACTIONS(939),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(942),
    [anon_sym___declspec] = ACTIONS(945),
    [anon_sym___cdecl] = ACTIONS(913),
    [anon_sym___clrcall] = ACTIONS(913),
    [anon_sym___stdcall] = ACTIONS(913),
    [anon_sym___fastcall] = ACTIONS(913),
    [anon_sym___thiscall] = ACTIONS(913),
    [anon_sym___vectorcall] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1225),
    [anon_sym_signed] = ACTIONS(951),
    [anon_sym_unsigned] = ACTIONS(951),
    [anon_sym_long] = ACTIONS(951),
    [anon_sym_short] = ACTIONS(951),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_auto] = ACTIONS(936),
    [anon_sym_register] = ACTIONS(936),
    [anon_sym_inline] = ACTIONS(936),
    [anon_sym___inline] = ACTIONS(936),
    [anon_sym___inline__] = ACTIONS(936),
    [anon_sym___forceinline] = ACTIONS(936),
    [anon_sym_thread_local] = ACTIONS(936),
    [anon_sym___thread] = ACTIONS(936),
    [anon_sym_const] = ACTIONS(954),
    [anon_sym_constexpr] = ACTIONS(954),
    [anon_sym_volatile] = ACTIONS(954),
    [anon_sym_restrict] = ACTIONS(954),
    [anon_sym___restrict__] = ACTIONS(954),
    [anon_sym__Atomic] = ACTIONS(954),
    [anon_sym__Noreturn] = ACTIONS(954),
    [anon_sym_noreturn] = ACTIONS(954),
    [sym_primitive_type] = ACTIONS(957),
    [anon_sym_enum] = ACTIONS(960),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_union] = ACTIONS(966),
    [anon_sym_if] = ACTIONS(1228),
    [anon_sym_else] = ACTIONS(913),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_case] = ACTIONS(913),
    [anon_sym_default] = ACTIONS(913),
    [anon_sym_while] = ACTIONS(1234),
    [anon_sym_do] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1240),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_break] = ACTIONS(1246),
    [anon_sym_continue] = ACTIONS(1249),
    [anon_sym_goto] = ACTIONS(1252),
    [anon_sym___try] = ACTIONS(1255),
    [anon_sym___leave] = ACTIONS(1258),
    [anon_sym_DASH_DASH] = ACTIONS(1002),
    [anon_sym_PLUS_PLUS] = ACTIONS(1002),
    [anon_sym_sizeof] = ACTIONS(1005),
    [anon_sym___alignof__] = ACTIONS(1008),
    [anon_sym___alignof] = ACTIONS(1008),
    [anon_sym__alignof] = ACTIONS(1008),
    [anon_sym_alignof] = ACTIONS(1008),
    [anon_sym__Alignof] = ACTIONS(1008),
    [anon_sym_offsetof] = ACTIONS(1011),
    [anon_sym__Generic] = ACTIONS(1014),
    [anon_sym_asm] = ACTIONS(1017),
    [anon_sym___asm__] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1020),
    [anon_sym_L_SQUOTE] = ACTIONS(1023),
    [anon_sym_u_SQUOTE] = ACTIONS(1023),
    [anon_sym_U_SQUOTE] = ACTIONS(1023),
    [anon_sym_u8_SQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1023),
    [anon_sym_L_DQUOTE] = ACTIONS(1026),
    [anon_sym_u_DQUOTE] = ACTIONS(1026),
    [anon_sym_U_DQUOTE] = ACTIONS(1026),
    [anon_sym_u8_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [sym_true] = ACTIONS(1029),
    [sym_false] = ACTIONS(1029),
    [anon_sym_NULL] = ACTIONS(1032),
    [anon_sym_nullptr] = ACTIONS(1032),
    [sym_comment] = ACTIONS(3),
  },
  [76] = {
    [sym_declaration] = STATE(69),
    [sym_type_definition] = STATE(69),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1416),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(69),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(69),
    [sym_labeled_statement] = STATE(69),
    [sym_expression_statement] = STATE(69),
    [sym_if_statement] = STATE(69),
    [sym_switch_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_do_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_return_statement] = STATE(69),
    [sym_break_statement] = STATE(69),
    [sym_continue_statement] = STATE(69),
    [sym_goto_statement] = STATE(69),
    [sym_seh_try_statement] = STATE(69),
    [sym_seh_leave_statement] = STATE(69),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(69),
    [sym_identifier] = ACTIONS(1205),
    [aux_sym_preproc_include_token1] = ACTIONS(1037),
    [aux_sym_preproc_def_token1] = ACTIONS(1037),
    [aux_sym_preproc_if_token1] = ACTIONS(1037),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1037),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1037),
    [sym_preproc_directive] = ACTIONS(1037),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1037),
    [anon_sym___clrcall] = ACTIONS(1037),
    [anon_sym___stdcall] = ACTIONS(1037),
    [anon_sym___fastcall] = ACTIONS(1037),
    [anon_sym___thiscall] = ACTIONS(1037),
    [anon_sym___vectorcall] = ACTIONS(1037),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(1211),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_else] = ACTIONS(1037),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1037),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [77] = {
    [sym_declaration] = STATE(70),
    [sym_type_definition] = STATE(70),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1416),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(70),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(70),
    [sym_labeled_statement] = STATE(70),
    [sym_expression_statement] = STATE(70),
    [sym_if_statement] = STATE(70),
    [sym_switch_statement] = STATE(70),
    [sym_while_statement] = STATE(70),
    [sym_do_statement] = STATE(70),
    [sym_for_statement] = STATE(70),
    [sym_return_statement] = STATE(70),
    [sym_break_statement] = STATE(70),
    [sym_continue_statement] = STATE(70),
    [sym_goto_statement] = STATE(70),
    [sym_seh_try_statement] = STATE(70),
    [sym_seh_leave_statement] = STATE(70),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(70),
    [sym_identifier] = ACTIONS(1205),
    [aux_sym_preproc_include_token1] = ACTIONS(1039),
    [aux_sym_preproc_def_token1] = ACTIONS(1039),
    [aux_sym_preproc_if_token1] = ACTIONS(1039),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1039),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1039),
    [sym_preproc_directive] = ACTIONS(1039),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(493),
    [anon_sym_typedef] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1039),
    [anon_sym___clrcall] = ACTIONS(1039),
    [anon_sym___stdcall] = ACTIONS(1039),
    [anon_sym___fastcall] = ACTIONS(1039),
    [anon_sym___thiscall] = ACTIONS(1039),
    [anon_sym___vectorcall] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_else] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(1039),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [78] = {
    [sym_declaration] = STATE(74),
    [sym_type_definition] = STATE(74),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1429),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(74),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(74),
    [sym_labeled_statement] = STATE(74),
    [sym_expression_statement] = STATE(74),
    [sym_if_statement] = STATE(74),
    [sym_switch_statement] = STATE(74),
    [sym_while_statement] = STATE(74),
    [sym_do_statement] = STATE(74),
    [sym_for_statement] = STATE(74),
    [sym_return_statement] = STATE(74),
    [sym_break_statement] = STATE(74),
    [sym_continue_statement] = STATE(74),
    [sym_goto_statement] = STATE(74),
    [sym_seh_try_statement] = STATE(74),
    [sym_seh_leave_statement] = STATE(74),
    [sym__expression] = STATE(1348),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2343),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(463),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(74),
    [ts_builtin_sym_end] = ACTIONS(1207),
    [sym_identifier] = ACTIONS(1099),
    [aux_sym_preproc_include_token1] = ACTIONS(1041),
    [aux_sym_preproc_def_token1] = ACTIONS(1041),
    [aux_sym_preproc_if_token1] = ACTIONS(1041),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1041),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1041),
    [sym_preproc_directive] = ACTIONS(1041),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1101),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(1041),
    [anon_sym___clrcall] = ACTIONS(1041),
    [anon_sym___stdcall] = ACTIONS(1041),
    [anon_sym___fastcall] = ACTIONS(1041),
    [anon_sym___thiscall] = ACTIONS(1041),
    [anon_sym___vectorcall] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_else] = ACTIONS(1041),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1041),
    [anon_sym_default] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1103),
    [anon_sym___leave] = ACTIONS(1105),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [79] = {
    [sym_declaration] = STATE(79),
    [sym_type_definition] = STATE(79),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1429),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(79),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(79),
    [sym_labeled_statement] = STATE(79),
    [sym_expression_statement] = STATE(79),
    [sym_if_statement] = STATE(79),
    [sym_switch_statement] = STATE(79),
    [sym_while_statement] = STATE(79),
    [sym_do_statement] = STATE(79),
    [sym_for_statement] = STATE(79),
    [sym_return_statement] = STATE(79),
    [sym_break_statement] = STATE(79),
    [sym_continue_statement] = STATE(79),
    [sym_goto_statement] = STATE(79),
    [sym_seh_try_statement] = STATE(79),
    [sym_seh_leave_statement] = STATE(79),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(79),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_LPAREN2] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_STAR] = ACTIONS(924),
    [anon_sym_AMP] = ACTIONS(924),
    [anon_sym_SEMI] = ACTIONS(1158),
    [anon_sym___extension__] = ACTIONS(1219),
    [anon_sym_typedef] = ACTIONS(1222),
    [anon_sym_extern] = ACTIONS(936),
    [anon_sym___attribute__] = ACTIONS(939),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(942),
    [anon_sym___declspec] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(1225),
    [anon_sym_signed] = ACTIONS(951),
    [anon_sym_unsigned] = ACTIONS(951),
    [anon_sym_long] = ACTIONS(951),
    [anon_sym_short] = ACTIONS(951),
    [anon_sym_static] = ACTIONS(936),
    [anon_sym_auto] = ACTIONS(936),
    [anon_sym_register] = ACTIONS(936),
    [anon_sym_inline] = ACTIONS(936),
    [anon_sym___inline] = ACTIONS(936),
    [anon_sym___inline__] = ACTIONS(936),
    [anon_sym___forceinline] = ACTIONS(936),
    [anon_sym_thread_local] = ACTIONS(936),
    [anon_sym___thread] = ACTIONS(936),
    [anon_sym_const] = ACTIONS(954),
    [anon_sym_constexpr] = ACTIONS(954),
    [anon_sym_volatile] = ACTIONS(954),
    [anon_sym_restrict] = ACTIONS(954),
    [anon_sym___restrict__] = ACTIONS(954),
    [anon_sym__Atomic] = ACTIONS(954),
    [anon_sym__Noreturn] = ACTIONS(954),
    [anon_sym_noreturn] = ACTIONS(954),
    [sym_primitive_type] = ACTIONS(957),
    [anon_sym_enum] = ACTIONS(960),
    [anon_sym_struct] = ACTIONS(963),
    [anon_sym_union] = ACTIONS(966),
    [anon_sym_if] = ACTIONS(1264),
    [anon_sym_else] = ACTIONS(913),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_while] = ACTIONS(1267),
    [anon_sym_do] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1270),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_break] = ACTIONS(1246),
    [anon_sym_continue] = ACTIONS(1249),
    [anon_sym_goto] = ACTIONS(1252),
    [anon_sym___try] = ACTIONS(1273),
    [anon_sym___leave] = ACTIONS(1202),
    [anon_sym_DASH_DASH] = ACTIONS(1002),
    [anon_sym_PLUS_PLUS] = ACTIONS(1002),
    [anon_sym_sizeof] = ACTIONS(1005),
    [anon_sym___alignof__] = ACTIONS(1008),
    [anon_sym___alignof] = ACTIONS(1008),
    [anon_sym__alignof] = ACTIONS(1008),
    [anon_sym_alignof] = ACTIONS(1008),
    [anon_sym__Alignof] = ACTIONS(1008),
    [anon_sym_offsetof] = ACTIONS(1011),
    [anon_sym__Generic] = ACTIONS(1014),
    [anon_sym_asm] = ACTIONS(1017),
    [anon_sym___asm__] = ACTIONS(1017),
    [sym_number_literal] = ACTIONS(1020),
    [anon_sym_L_SQUOTE] = ACTIONS(1023),
    [anon_sym_u_SQUOTE] = ACTIONS(1023),
    [anon_sym_U_SQUOTE] = ACTIONS(1023),
    [anon_sym_u8_SQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1023),
    [anon_sym_L_DQUOTE] = ACTIONS(1026),
    [anon_sym_u_DQUOTE] = ACTIONS(1026),
    [anon_sym_U_DQUOTE] = ACTIONS(1026),
    [anon_sym_u8_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [sym_true] = ACTIONS(1029),
    [sym_false] = ACTIONS(1029),
    [anon_sym_NULL] = ACTIONS(1032),
    [anon_sym_nullptr] = ACTIONS(1032),
    [sym_comment] = ACTIONS(3),
  },
  [80] = {
    [sym_declaration] = STATE(79),
    [sym_type_definition] = STATE(79),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1429),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(79),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(79),
    [sym_labeled_statement] = STATE(79),
    [sym_expression_statement] = STATE(79),
    [sym_if_statement] = STATE(79),
    [sym_switch_statement] = STATE(79),
    [sym_while_statement] = STATE(79),
    [sym_do_statement] = STATE(79),
    [sym_for_statement] = STATE(79),
    [sym_return_statement] = STATE(79),
    [sym_break_statement] = STATE(79),
    [sym_continue_statement] = STATE(79),
    [sym_goto_statement] = STATE(79),
    [sym_seh_try_statement] = STATE(79),
    [sym_seh_leave_statement] = STATE(79),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(79),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(1278),
    [anon_sym_else] = ACTIONS(1043),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(1280),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1282),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1284),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [81] = {
    [sym_declaration] = STATE(83),
    [sym_type_definition] = STATE(83),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1429),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(83),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(83),
    [sym_labeled_statement] = STATE(83),
    [sym_expression_statement] = STATE(83),
    [sym_if_statement] = STATE(83),
    [sym_switch_statement] = STATE(83),
    [sym_while_statement] = STATE(83),
    [sym_do_statement] = STATE(83),
    [sym_for_statement] = STATE(83),
    [sym_return_statement] = STATE(83),
    [sym_break_statement] = STATE(83),
    [sym_continue_statement] = STATE(83),
    [sym_goto_statement] = STATE(83),
    [sym_seh_try_statement] = STATE(83),
    [sym_seh_leave_statement] = STATE(83),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(83),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(1278),
    [anon_sym_else] = ACTIONS(1041),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(1280),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1282),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1284),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [82] = {
    [sym_declaration] = STATE(80),
    [sym_type_definition] = STATE(80),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1429),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(80),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(80),
    [sym_labeled_statement] = STATE(80),
    [sym_expression_statement] = STATE(80),
    [sym_if_statement] = STATE(80),
    [sym_switch_statement] = STATE(80),
    [sym_while_statement] = STATE(80),
    [sym_do_statement] = STATE(80),
    [sym_for_statement] = STATE(80),
    [sym_return_statement] = STATE(80),
    [sym_break_statement] = STATE(80),
    [sym_continue_statement] = STATE(80),
    [sym_goto_statement] = STATE(80),
    [sym_seh_try_statement] = STATE(80),
    [sym_seh_leave_statement] = STATE(80),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(80),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(1278),
    [anon_sym_else] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(1280),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1282),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1284),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [83] = {
    [sym_declaration] = STATE(79),
    [sym_type_definition] = STATE(79),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1429),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(562),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_compound_statement] = STATE(79),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_attributed_statement] = STATE(79),
    [sym_labeled_statement] = STATE(79),
    [sym_expression_statement] = STATE(79),
    [sym_if_statement] = STATE(79),
    [sym_switch_statement] = STATE(79),
    [sym_while_statement] = STATE(79),
    [sym_do_statement] = STATE(79),
    [sym_for_statement] = STATE(79),
    [sym_return_statement] = STATE(79),
    [sym_break_statement] = STATE(79),
    [sym_continue_statement] = STATE(79),
    [sym_goto_statement] = STATE(79),
    [sym_seh_try_statement] = STATE(79),
    [sym_seh_leave_statement] = STATE(79),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [aux_sym_case_statement_repeat1] = STATE(79),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym___extension__] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(35),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(1278),
    [anon_sym_else] = ACTIONS(1037),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(1280),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1282),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1284),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [84] = {
    [sym_declaration] = STATE(637),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1425),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__for_statement_body] = STATE(2301),
    [sym__expression] = STATE(1341),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2269),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1288),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [85] = {
    [sym_declaration] = STATE(637),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1425),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__for_statement_body] = STATE(2265),
    [sym__expression] = STATE(1341),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2269),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1288),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [86] = {
    [sym_declaration] = STATE(637),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1425),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__for_statement_body] = STATE(2231),
    [sym__expression] = STATE(1341),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2269),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1288),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [87] = {
    [sym_declaration] = STATE(637),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1425),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__for_statement_body] = STATE(2144),
    [sym__expression] = STATE(1341),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2269),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1288),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [88] = {
    [sym_declaration] = STATE(637),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1425),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__for_statement_body] = STATE(2290),
    [sym__expression] = STATE(1341),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2269),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1288),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [89] = {
    [sym_declaration] = STATE(637),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1425),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__for_statement_body] = STATE(2319),
    [sym__expression] = STATE(1341),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2269),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1288),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [90] = {
    [sym_else_clause] = STATE(131),
    [sym_identifier] = ACTIONS(1292),
    [aux_sym_preproc_include_token1] = ACTIONS(1292),
    [aux_sym_preproc_def_token1] = ACTIONS(1292),
    [aux_sym_preproc_if_token1] = ACTIONS(1292),
    [aux_sym_preproc_if_token2] = ACTIONS(1292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1292),
    [aux_sym_preproc_else_token1] = ACTIONS(1292),
    [aux_sym_preproc_elif_token1] = ACTIONS(1292),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1292),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1292),
    [sym_preproc_directive] = ACTIONS(1292),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1294),
    [anon_sym_TILDE] = ACTIONS(1294),
    [anon_sym_DASH] = ACTIONS(1292),
    [anon_sym_PLUS] = ACTIONS(1292),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_SEMI] = ACTIONS(1294),
    [anon_sym___extension__] = ACTIONS(1292),
    [anon_sym_typedef] = ACTIONS(1292),
    [anon_sym_extern] = ACTIONS(1292),
    [anon_sym___attribute__] = ACTIONS(1292),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1294),
    [anon_sym___declspec] = ACTIONS(1292),
    [anon_sym___cdecl] = ACTIONS(1292),
    [anon_sym___clrcall] = ACTIONS(1292),
    [anon_sym___stdcall] = ACTIONS(1292),
    [anon_sym___fastcall] = ACTIONS(1292),
    [anon_sym___thiscall] = ACTIONS(1292),
    [anon_sym___vectorcall] = ACTIONS(1292),
    [anon_sym_LBRACE] = ACTIONS(1294),
    [anon_sym_signed] = ACTIONS(1292),
    [anon_sym_unsigned] = ACTIONS(1292),
    [anon_sym_long] = ACTIONS(1292),
    [anon_sym_short] = ACTIONS(1292),
    [anon_sym_static] = ACTIONS(1292),
    [anon_sym_auto] = ACTIONS(1292),
    [anon_sym_register] = ACTIONS(1292),
    [anon_sym_inline] = ACTIONS(1292),
    [anon_sym___inline] = ACTIONS(1292),
    [anon_sym___inline__] = ACTIONS(1292),
    [anon_sym___forceinline] = ACTIONS(1292),
    [anon_sym_thread_local] = ACTIONS(1292),
    [anon_sym___thread] = ACTIONS(1292),
    [anon_sym_const] = ACTIONS(1292),
    [anon_sym_constexpr] = ACTIONS(1292),
    [anon_sym_volatile] = ACTIONS(1292),
    [anon_sym_restrict] = ACTIONS(1292),
    [anon_sym___restrict__] = ACTIONS(1292),
    [anon_sym__Atomic] = ACTIONS(1292),
    [anon_sym__Noreturn] = ACTIONS(1292),
    [anon_sym_noreturn] = ACTIONS(1292),
    [sym_primitive_type] = ACTIONS(1292),
    [anon_sym_enum] = ACTIONS(1292),
    [anon_sym_struct] = ACTIONS(1292),
    [anon_sym_union] = ACTIONS(1292),
    [anon_sym_if] = ACTIONS(1292),
    [anon_sym_else] = ACTIONS(1296),
    [anon_sym_switch] = ACTIONS(1292),
    [anon_sym_case] = ACTIONS(1292),
    [anon_sym_default] = ACTIONS(1292),
    [anon_sym_while] = ACTIONS(1292),
    [anon_sym_do] = ACTIONS(1292),
    [anon_sym_for] = ACTIONS(1292),
    [anon_sym_return] = ACTIONS(1292),
    [anon_sym_break] = ACTIONS(1292),
    [anon_sym_continue] = ACTIONS(1292),
    [anon_sym_goto] = ACTIONS(1292),
    [anon_sym___try] = ACTIONS(1292),
    [anon_sym___leave] = ACTIONS(1292),
    [anon_sym_DASH_DASH] = ACTIONS(1294),
    [anon_sym_PLUS_PLUS] = ACTIONS(1294),
    [anon_sym_sizeof] = ACTIONS(1292),
    [anon_sym___alignof__] = ACTIONS(1292),
    [anon_sym___alignof] = ACTIONS(1292),
    [anon_sym__alignof] = ACTIONS(1292),
    [anon_sym_alignof] = ACTIONS(1292),
    [anon_sym__Alignof] = ACTIONS(1292),
    [anon_sym_offsetof] = ACTIONS(1292),
    [anon_sym__Generic] = ACTIONS(1292),
    [anon_sym_asm] = ACTIONS(1292),
    [anon_sym___asm__] = ACTIONS(1292),
    [sym_number_literal] = ACTIONS(1294),
    [anon_sym_L_SQUOTE] = ACTIONS(1294),
    [anon_sym_u_SQUOTE] = ACTIONS(1294),
    [anon_sym_U_SQUOTE] = ACTIONS(1294),
    [anon_sym_u8_SQUOTE] = ACTIONS(1294),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_L_DQUOTE] = ACTIONS(1294),
    [anon_sym_u_DQUOTE] = ACTIONS(1294),
    [anon_sym_U_DQUOTE] = ACTIONS(1294),
    [anon_sym_u8_DQUOTE] = ACTIONS(1294),
    [anon_sym_DQUOTE] = ACTIONS(1294),
    [sym_true] = ACTIONS(1292),
    [sym_false] = ACTIONS(1292),
    [anon_sym_NULL] = ACTIONS(1292),
    [anon_sym_nullptr] = ACTIONS(1292),
    [sym_comment] = ACTIONS(3),
  },
  [91] = {
    [sym_identifier] = ACTIONS(1298),
    [aux_sym_preproc_include_token1] = ACTIONS(1298),
    [aux_sym_preproc_def_token1] = ACTIONS(1298),
    [aux_sym_preproc_if_token1] = ACTIONS(1298),
    [aux_sym_preproc_if_token2] = ACTIONS(1298),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1298),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1298),
    [aux_sym_preproc_else_token1] = ACTIONS(1298),
    [aux_sym_preproc_elif_token1] = ACTIONS(1298),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1298),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1298),
    [sym_preproc_directive] = ACTIONS(1298),
    [anon_sym_LPAREN2] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1300),
    [anon_sym_TILDE] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1298),
    [anon_sym_PLUS] = ACTIONS(1298),
    [anon_sym_STAR] = ACTIONS(1300),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(1300),
    [anon_sym___extension__] = ACTIONS(1298),
    [anon_sym_typedef] = ACTIONS(1298),
    [anon_sym_extern] = ACTIONS(1298),
    [anon_sym___attribute__] = ACTIONS(1298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1300),
    [anon_sym___declspec] = ACTIONS(1298),
    [anon_sym___cdecl] = ACTIONS(1298),
    [anon_sym___clrcall] = ACTIONS(1298),
    [anon_sym___stdcall] = ACTIONS(1298),
    [anon_sym___fastcall] = ACTIONS(1298),
    [anon_sym___thiscall] = ACTIONS(1298),
    [anon_sym___vectorcall] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_signed] = ACTIONS(1298),
    [anon_sym_unsigned] = ACTIONS(1298),
    [anon_sym_long] = ACTIONS(1298),
    [anon_sym_short] = ACTIONS(1298),
    [anon_sym_static] = ACTIONS(1298),
    [anon_sym_auto] = ACTIONS(1298),
    [anon_sym_register] = ACTIONS(1298),
    [anon_sym_inline] = ACTIONS(1298),
    [anon_sym___inline] = ACTIONS(1298),
    [anon_sym___inline__] = ACTIONS(1298),
    [anon_sym___forceinline] = ACTIONS(1298),
    [anon_sym_thread_local] = ACTIONS(1298),
    [anon_sym___thread] = ACTIONS(1298),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_constexpr] = ACTIONS(1298),
    [anon_sym_volatile] = ACTIONS(1298),
    [anon_sym_restrict] = ACTIONS(1298),
    [anon_sym___restrict__] = ACTIONS(1298),
    [anon_sym__Atomic] = ACTIONS(1298),
    [anon_sym__Noreturn] = ACTIONS(1298),
    [anon_sym_noreturn] = ACTIONS(1298),
    [sym_primitive_type] = ACTIONS(1298),
    [anon_sym_enum] = ACTIONS(1298),
    [anon_sym_struct] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1298),
    [anon_sym_if] = ACTIONS(1298),
    [anon_sym_else] = ACTIONS(1298),
    [anon_sym_switch] = ACTIONS(1298),
    [anon_sym_case] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(1298),
    [anon_sym_do] = ACTIONS(1298),
    [anon_sym_for] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1298),
    [anon_sym_break] = ACTIONS(1298),
    [anon_sym_continue] = ACTIONS(1298),
    [anon_sym_goto] = ACTIONS(1298),
    [anon_sym___try] = ACTIONS(1298),
    [anon_sym___leave] = ACTIONS(1298),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_sizeof] = ACTIONS(1298),
    [anon_sym___alignof__] = ACTIONS(1298),
    [anon_sym___alignof] = ACTIONS(1298),
    [anon_sym__alignof] = ACTIONS(1298),
    [anon_sym_alignof] = ACTIONS(1298),
    [anon_sym__Alignof] = ACTIONS(1298),
    [anon_sym_offsetof] = ACTIONS(1298),
    [anon_sym__Generic] = ACTIONS(1298),
    [anon_sym_asm] = ACTIONS(1298),
    [anon_sym___asm__] = ACTIONS(1298),
    [sym_number_literal] = ACTIONS(1300),
    [anon_sym_L_SQUOTE] = ACTIONS(1300),
    [anon_sym_u_SQUOTE] = ACTIONS(1300),
    [anon_sym_U_SQUOTE] = ACTIONS(1300),
    [anon_sym_u8_SQUOTE] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(1300),
    [anon_sym_L_DQUOTE] = ACTIONS(1300),
    [anon_sym_u_DQUOTE] = ACTIONS(1300),
    [anon_sym_U_DQUOTE] = ACTIONS(1300),
    [anon_sym_u8_DQUOTE] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(1300),
    [sym_true] = ACTIONS(1298),
    [sym_false] = ACTIONS(1298),
    [anon_sym_NULL] = ACTIONS(1298),
    [anon_sym_nullptr] = ACTIONS(1298),
    [sym_comment] = ACTIONS(3),
  },
  [92] = {
    [sym_identifier] = ACTIONS(1302),
    [aux_sym_preproc_include_token1] = ACTIONS(1302),
    [aux_sym_preproc_def_token1] = ACTIONS(1302),
    [aux_sym_preproc_if_token1] = ACTIONS(1302),
    [aux_sym_preproc_if_token2] = ACTIONS(1302),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1302),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1302),
    [aux_sym_preproc_else_token1] = ACTIONS(1302),
    [aux_sym_preproc_elif_token1] = ACTIONS(1302),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1302),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1302),
    [sym_preproc_directive] = ACTIONS(1302),
    [anon_sym_LPAREN2] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_TILDE] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1302),
    [anon_sym_PLUS] = ACTIONS(1302),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym___extension__] = ACTIONS(1302),
    [anon_sym_typedef] = ACTIONS(1302),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym___attribute__] = ACTIONS(1302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1304),
    [anon_sym___declspec] = ACTIONS(1302),
    [anon_sym___cdecl] = ACTIONS(1302),
    [anon_sym___clrcall] = ACTIONS(1302),
    [anon_sym___stdcall] = ACTIONS(1302),
    [anon_sym___fastcall] = ACTIONS(1302),
    [anon_sym___thiscall] = ACTIONS(1302),
    [anon_sym___vectorcall] = ACTIONS(1302),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_signed] = ACTIONS(1302),
    [anon_sym_unsigned] = ACTIONS(1302),
    [anon_sym_long] = ACTIONS(1302),
    [anon_sym_short] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(1302),
    [anon_sym_auto] = ACTIONS(1302),
    [anon_sym_register] = ACTIONS(1302),
    [anon_sym_inline] = ACTIONS(1302),
    [anon_sym___inline] = ACTIONS(1302),
    [anon_sym___inline__] = ACTIONS(1302),
    [anon_sym___forceinline] = ACTIONS(1302),
    [anon_sym_thread_local] = ACTIONS(1302),
    [anon_sym___thread] = ACTIONS(1302),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_constexpr] = ACTIONS(1302),
    [anon_sym_volatile] = ACTIONS(1302),
    [anon_sym_restrict] = ACTIONS(1302),
    [anon_sym___restrict__] = ACTIONS(1302),
    [anon_sym__Atomic] = ACTIONS(1302),
    [anon_sym__Noreturn] = ACTIONS(1302),
    [anon_sym_noreturn] = ACTIONS(1302),
    [sym_primitive_type] = ACTIONS(1302),
    [anon_sym_enum] = ACTIONS(1302),
    [anon_sym_struct] = ACTIONS(1302),
    [anon_sym_union] = ACTIONS(1302),
    [anon_sym_if] = ACTIONS(1302),
    [anon_sym_else] = ACTIONS(1302),
    [anon_sym_switch] = ACTIONS(1302),
    [anon_sym_case] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1302),
    [anon_sym_while] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1302),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_break] = ACTIONS(1302),
    [anon_sym_continue] = ACTIONS(1302),
    [anon_sym_goto] = ACTIONS(1302),
    [anon_sym___try] = ACTIONS(1302),
    [anon_sym___leave] = ACTIONS(1302),
    [anon_sym_DASH_DASH] = ACTIONS(1304),
    [anon_sym_PLUS_PLUS] = ACTIONS(1304),
    [anon_sym_sizeof] = ACTIONS(1302),
    [anon_sym___alignof__] = ACTIONS(1302),
    [anon_sym___alignof] = ACTIONS(1302),
    [anon_sym__alignof] = ACTIONS(1302),
    [anon_sym_alignof] = ACTIONS(1302),
    [anon_sym__Alignof] = ACTIONS(1302),
    [anon_sym_offsetof] = ACTIONS(1302),
    [anon_sym__Generic] = ACTIONS(1302),
    [anon_sym_asm] = ACTIONS(1302),
    [anon_sym___asm__] = ACTIONS(1302),
    [sym_number_literal] = ACTIONS(1304),
    [anon_sym_L_SQUOTE] = ACTIONS(1304),
    [anon_sym_u_SQUOTE] = ACTIONS(1304),
    [anon_sym_U_SQUOTE] = ACTIONS(1304),
    [anon_sym_u8_SQUOTE] = ACTIONS(1304),
    [anon_sym_SQUOTE] = ACTIONS(1304),
    [anon_sym_L_DQUOTE] = ACTIONS(1304),
    [anon_sym_u_DQUOTE] = ACTIONS(1304),
    [anon_sym_U_DQUOTE] = ACTIONS(1304),
    [anon_sym_u8_DQUOTE] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_true] = ACTIONS(1302),
    [sym_false] = ACTIONS(1302),
    [anon_sym_NULL] = ACTIONS(1302),
    [anon_sym_nullptr] = ACTIONS(1302),
    [sym_comment] = ACTIONS(3),
  },
  [93] = {
    [sym_identifier] = ACTIONS(1306),
    [aux_sym_preproc_include_token1] = ACTIONS(1306),
    [aux_sym_preproc_def_token1] = ACTIONS(1306),
    [aux_sym_preproc_if_token1] = ACTIONS(1306),
    [aux_sym_preproc_if_token2] = ACTIONS(1306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1306),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1306),
    [aux_sym_preproc_else_token1] = ACTIONS(1306),
    [aux_sym_preproc_elif_token1] = ACTIONS(1306),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1306),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1306),
    [sym_preproc_directive] = ACTIONS(1306),
    [anon_sym_LPAREN2] = ACTIONS(1308),
    [anon_sym_BANG] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(1308),
    [anon_sym_DASH] = ACTIONS(1306),
    [anon_sym_PLUS] = ACTIONS(1306),
    [anon_sym_STAR] = ACTIONS(1308),
    [anon_sym_AMP] = ACTIONS(1308),
    [anon_sym_SEMI] = ACTIONS(1308),
    [anon_sym___extension__] = ACTIONS(1306),
    [anon_sym_typedef] = ACTIONS(1306),
    [anon_sym_extern] = ACTIONS(1306),
    [anon_sym___attribute__] = ACTIONS(1306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1308),
    [anon_sym___declspec] = ACTIONS(1306),
    [anon_sym___cdecl] = ACTIONS(1306),
    [anon_sym___clrcall] = ACTIONS(1306),
    [anon_sym___stdcall] = ACTIONS(1306),
    [anon_sym___fastcall] = ACTIONS(1306),
    [anon_sym___thiscall] = ACTIONS(1306),
    [anon_sym___vectorcall] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(1308),
    [anon_sym_signed] = ACTIONS(1306),
    [anon_sym_unsigned] = ACTIONS(1306),
    [anon_sym_long] = ACTIONS(1306),
    [anon_sym_short] = ACTIONS(1306),
    [anon_sym_static] = ACTIONS(1306),
    [anon_sym_auto] = ACTIONS(1306),
    [anon_sym_register] = ACTIONS(1306),
    [anon_sym_inline] = ACTIONS(1306),
    [anon_sym___inline] = ACTIONS(1306),
    [anon_sym___inline__] = ACTIONS(1306),
    [anon_sym___forceinline] = ACTIONS(1306),
    [anon_sym_thread_local] = ACTIONS(1306),
    [anon_sym___thread] = ACTIONS(1306),
    [anon_sym_const] = ACTIONS(1306),
    [anon_sym_constexpr] = ACTIONS(1306),
    [anon_sym_volatile] = ACTIONS(1306),
    [anon_sym_restrict] = ACTIONS(1306),
    [anon_sym___restrict__] = ACTIONS(1306),
    [anon_sym__Atomic] = ACTIONS(1306),
    [anon_sym__Noreturn] = ACTIONS(1306),
    [anon_sym_noreturn] = ACTIONS(1306),
    [sym_primitive_type] = ACTIONS(1306),
    [anon_sym_enum] = ACTIONS(1306),
    [anon_sym_struct] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1306),
    [anon_sym_if] = ACTIONS(1306),
    [anon_sym_else] = ACTIONS(1306),
    [anon_sym_switch] = ACTIONS(1306),
    [anon_sym_case] = ACTIONS(1306),
    [anon_sym_default] = ACTIONS(1306),
    [anon_sym_while] = ACTIONS(1306),
    [anon_sym_do] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1306),
    [anon_sym_break] = ACTIONS(1306),
    [anon_sym_continue] = ACTIONS(1306),
    [anon_sym_goto] = ACTIONS(1306),
    [anon_sym___try] = ACTIONS(1306),
    [anon_sym___leave] = ACTIONS(1306),
    [anon_sym_DASH_DASH] = ACTIONS(1308),
    [anon_sym_PLUS_PLUS] = ACTIONS(1308),
    [anon_sym_sizeof] = ACTIONS(1306),
    [anon_sym___alignof__] = ACTIONS(1306),
    [anon_sym___alignof] = ACTIONS(1306),
    [anon_sym__alignof] = ACTIONS(1306),
    [anon_sym_alignof] = ACTIONS(1306),
    [anon_sym__Alignof] = ACTIONS(1306),
    [anon_sym_offsetof] = ACTIONS(1306),
    [anon_sym__Generic] = ACTIONS(1306),
    [anon_sym_asm] = ACTIONS(1306),
    [anon_sym___asm__] = ACTIONS(1306),
    [sym_number_literal] = ACTIONS(1308),
    [anon_sym_L_SQUOTE] = ACTIONS(1308),
    [anon_sym_u_SQUOTE] = ACTIONS(1308),
    [anon_sym_U_SQUOTE] = ACTIONS(1308),
    [anon_sym_u8_SQUOTE] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(1308),
    [anon_sym_L_DQUOTE] = ACTIONS(1308),
    [anon_sym_u_DQUOTE] = ACTIONS(1308),
    [anon_sym_U_DQUOTE] = ACTIONS(1308),
    [anon_sym_u8_DQUOTE] = ACTIONS(1308),
    [anon_sym_DQUOTE] = ACTIONS(1308),
    [sym_true] = ACTIONS(1306),
    [sym_false] = ACTIONS(1306),
    [anon_sym_NULL] = ACTIONS(1306),
    [anon_sym_nullptr] = ACTIONS(1306),
    [sym_comment] = ACTIONS(3),
  },
  [94] = {
    [sym_identifier] = ACTIONS(1310),
    [aux_sym_preproc_include_token1] = ACTIONS(1310),
    [aux_sym_preproc_def_token1] = ACTIONS(1310),
    [aux_sym_preproc_if_token1] = ACTIONS(1310),
    [aux_sym_preproc_if_token2] = ACTIONS(1310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1310),
    [aux_sym_preproc_else_token1] = ACTIONS(1310),
    [aux_sym_preproc_elif_token1] = ACTIONS(1310),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1310),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1310),
    [sym_preproc_directive] = ACTIONS(1310),
    [anon_sym_LPAREN2] = ACTIONS(1312),
    [anon_sym_BANG] = ACTIONS(1312),
    [anon_sym_TILDE] = ACTIONS(1312),
    [anon_sym_DASH] = ACTIONS(1310),
    [anon_sym_PLUS] = ACTIONS(1310),
    [anon_sym_STAR] = ACTIONS(1312),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_SEMI] = ACTIONS(1312),
    [anon_sym___extension__] = ACTIONS(1310),
    [anon_sym_typedef] = ACTIONS(1310),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym___attribute__] = ACTIONS(1310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1312),
    [anon_sym___declspec] = ACTIONS(1310),
    [anon_sym___cdecl] = ACTIONS(1310),
    [anon_sym___clrcall] = ACTIONS(1310),
    [anon_sym___stdcall] = ACTIONS(1310),
    [anon_sym___fastcall] = ACTIONS(1310),
    [anon_sym___thiscall] = ACTIONS(1310),
    [anon_sym___vectorcall] = ACTIONS(1310),
    [anon_sym_LBRACE] = ACTIONS(1312),
    [anon_sym_signed] = ACTIONS(1310),
    [anon_sym_unsigned] = ACTIONS(1310),
    [anon_sym_long] = ACTIONS(1310),
    [anon_sym_short] = ACTIONS(1310),
    [anon_sym_static] = ACTIONS(1310),
    [anon_sym_auto] = ACTIONS(1310),
    [anon_sym_register] = ACTIONS(1310),
    [anon_sym_inline] = ACTIONS(1310),
    [anon_sym___inline] = ACTIONS(1310),
    [anon_sym___inline__] = ACTIONS(1310),
    [anon_sym___forceinline] = ACTIONS(1310),
    [anon_sym_thread_local] = ACTIONS(1310),
    [anon_sym___thread] = ACTIONS(1310),
    [anon_sym_const] = ACTIONS(1310),
    [anon_sym_constexpr] = ACTIONS(1310),
    [anon_sym_volatile] = ACTIONS(1310),
    [anon_sym_restrict] = ACTIONS(1310),
    [anon_sym___restrict__] = ACTIONS(1310),
    [anon_sym__Atomic] = ACTIONS(1310),
    [anon_sym__Noreturn] = ACTIONS(1310),
    [anon_sym_noreturn] = ACTIONS(1310),
    [sym_primitive_type] = ACTIONS(1310),
    [anon_sym_enum] = ACTIONS(1310),
    [anon_sym_struct] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1310),
    [anon_sym_if] = ACTIONS(1310),
    [anon_sym_else] = ACTIONS(1310),
    [anon_sym_switch] = ACTIONS(1310),
    [anon_sym_case] = ACTIONS(1310),
    [anon_sym_default] = ACTIONS(1310),
    [anon_sym_while] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1310),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_break] = ACTIONS(1310),
    [anon_sym_continue] = ACTIONS(1310),
    [anon_sym_goto] = ACTIONS(1310),
    [anon_sym___try] = ACTIONS(1310),
    [anon_sym___leave] = ACTIONS(1310),
    [anon_sym_DASH_DASH] = ACTIONS(1312),
    [anon_sym_PLUS_PLUS] = ACTIONS(1312),
    [anon_sym_sizeof] = ACTIONS(1310),
    [anon_sym___alignof__] = ACTIONS(1310),
    [anon_sym___alignof] = ACTIONS(1310),
    [anon_sym__alignof] = ACTIONS(1310),
    [anon_sym_alignof] = ACTIONS(1310),
    [anon_sym__Alignof] = ACTIONS(1310),
    [anon_sym_offsetof] = ACTIONS(1310),
    [anon_sym__Generic] = ACTIONS(1310),
    [anon_sym_asm] = ACTIONS(1310),
    [anon_sym___asm__] = ACTIONS(1310),
    [sym_number_literal] = ACTIONS(1312),
    [anon_sym_L_SQUOTE] = ACTIONS(1312),
    [anon_sym_u_SQUOTE] = ACTIONS(1312),
    [anon_sym_U_SQUOTE] = ACTIONS(1312),
    [anon_sym_u8_SQUOTE] = ACTIONS(1312),
    [anon_sym_SQUOTE] = ACTIONS(1312),
    [anon_sym_L_DQUOTE] = ACTIONS(1312),
    [anon_sym_u_DQUOTE] = ACTIONS(1312),
    [anon_sym_U_DQUOTE] = ACTIONS(1312),
    [anon_sym_u8_DQUOTE] = ACTIONS(1312),
    [anon_sym_DQUOTE] = ACTIONS(1312),
    [sym_true] = ACTIONS(1310),
    [sym_false] = ACTIONS(1310),
    [anon_sym_NULL] = ACTIONS(1310),
    [anon_sym_nullptr] = ACTIONS(1310),
    [sym_comment] = ACTIONS(3),
  },
  [95] = {
    [sym_identifier] = ACTIONS(1314),
    [aux_sym_preproc_include_token1] = ACTIONS(1314),
    [aux_sym_preproc_def_token1] = ACTIONS(1314),
    [aux_sym_preproc_if_token1] = ACTIONS(1314),
    [aux_sym_preproc_if_token2] = ACTIONS(1314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1314),
    [aux_sym_preproc_else_token1] = ACTIONS(1314),
    [aux_sym_preproc_elif_token1] = ACTIONS(1314),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1314),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1314),
    [sym_preproc_directive] = ACTIONS(1314),
    [anon_sym_LPAREN2] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1314),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym___extension__] = ACTIONS(1314),
    [anon_sym_typedef] = ACTIONS(1314),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym___attribute__] = ACTIONS(1314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1316),
    [anon_sym___declspec] = ACTIONS(1314),
    [anon_sym___cdecl] = ACTIONS(1314),
    [anon_sym___clrcall] = ACTIONS(1314),
    [anon_sym___stdcall] = ACTIONS(1314),
    [anon_sym___fastcall] = ACTIONS(1314),
    [anon_sym___thiscall] = ACTIONS(1314),
    [anon_sym___vectorcall] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_signed] = ACTIONS(1314),
    [anon_sym_unsigned] = ACTIONS(1314),
    [anon_sym_long] = ACTIONS(1314),
    [anon_sym_short] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_auto] = ACTIONS(1314),
    [anon_sym_register] = ACTIONS(1314),
    [anon_sym_inline] = ACTIONS(1314),
    [anon_sym___inline] = ACTIONS(1314),
    [anon_sym___inline__] = ACTIONS(1314),
    [anon_sym___forceinline] = ACTIONS(1314),
    [anon_sym_thread_local] = ACTIONS(1314),
    [anon_sym___thread] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_constexpr] = ACTIONS(1314),
    [anon_sym_volatile] = ACTIONS(1314),
    [anon_sym_restrict] = ACTIONS(1314),
    [anon_sym___restrict__] = ACTIONS(1314),
    [anon_sym__Atomic] = ACTIONS(1314),
    [anon_sym__Noreturn] = ACTIONS(1314),
    [anon_sym_noreturn] = ACTIONS(1314),
    [sym_primitive_type] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_else] = ACTIONS(1314),
    [anon_sym_switch] = ACTIONS(1314),
    [anon_sym_case] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [anon_sym_do] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_goto] = ACTIONS(1314),
    [anon_sym___try] = ACTIONS(1314),
    [anon_sym___leave] = ACTIONS(1314),
    [anon_sym_DASH_DASH] = ACTIONS(1316),
    [anon_sym_PLUS_PLUS] = ACTIONS(1316),
    [anon_sym_sizeof] = ACTIONS(1314),
    [anon_sym___alignof__] = ACTIONS(1314),
    [anon_sym___alignof] = ACTIONS(1314),
    [anon_sym__alignof] = ACTIONS(1314),
    [anon_sym_alignof] = ACTIONS(1314),
    [anon_sym__Alignof] = ACTIONS(1314),
    [anon_sym_offsetof] = ACTIONS(1314),
    [anon_sym__Generic] = ACTIONS(1314),
    [anon_sym_asm] = ACTIONS(1314),
    [anon_sym___asm__] = ACTIONS(1314),
    [sym_number_literal] = ACTIONS(1316),
    [anon_sym_L_SQUOTE] = ACTIONS(1316),
    [anon_sym_u_SQUOTE] = ACTIONS(1316),
    [anon_sym_U_SQUOTE] = ACTIONS(1316),
    [anon_sym_u8_SQUOTE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1316),
    [anon_sym_L_DQUOTE] = ACTIONS(1316),
    [anon_sym_u_DQUOTE] = ACTIONS(1316),
    [anon_sym_U_DQUOTE] = ACTIONS(1316),
    [anon_sym_u8_DQUOTE] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1316),
    [sym_true] = ACTIONS(1314),
    [sym_false] = ACTIONS(1314),
    [anon_sym_NULL] = ACTIONS(1314),
    [anon_sym_nullptr] = ACTIONS(1314),
    [sym_comment] = ACTIONS(3),
  },
  [96] = {
    [ts_builtin_sym_end] = ACTIONS(1318),
    [sym_identifier] = ACTIONS(1320),
    [aux_sym_preproc_include_token1] = ACTIONS(1320),
    [aux_sym_preproc_def_token1] = ACTIONS(1320),
    [anon_sym_COMMA] = ACTIONS(1318),
    [anon_sym_RPAREN] = ACTIONS(1318),
    [aux_sym_preproc_if_token1] = ACTIONS(1320),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1320),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1320),
    [sym_preproc_directive] = ACTIONS(1320),
    [anon_sym_LPAREN2] = ACTIONS(1318),
    [anon_sym_BANG] = ACTIONS(1318),
    [anon_sym_TILDE] = ACTIONS(1318),
    [anon_sym_DASH] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(1320),
    [anon_sym_STAR] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(1318),
    [anon_sym_SEMI] = ACTIONS(1318),
    [anon_sym___extension__] = ACTIONS(1320),
    [anon_sym_typedef] = ACTIONS(1320),
    [anon_sym_extern] = ACTIONS(1320),
    [anon_sym___attribute__] = ACTIONS(1320),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1318),
    [anon_sym___declspec] = ACTIONS(1320),
    [anon_sym___cdecl] = ACTIONS(1320),
    [anon_sym___clrcall] = ACTIONS(1320),
    [anon_sym___stdcall] = ACTIONS(1320),
    [anon_sym___fastcall] = ACTIONS(1320),
    [anon_sym___thiscall] = ACTIONS(1320),
    [anon_sym___vectorcall] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1318),
    [anon_sym_signed] = ACTIONS(1320),
    [anon_sym_unsigned] = ACTIONS(1320),
    [anon_sym_long] = ACTIONS(1320),
    [anon_sym_short] = ACTIONS(1320),
    [anon_sym_static] = ACTIONS(1320),
    [anon_sym_auto] = ACTIONS(1320),
    [anon_sym_register] = ACTIONS(1320),
    [anon_sym_inline] = ACTIONS(1320),
    [anon_sym___inline] = ACTIONS(1320),
    [anon_sym___inline__] = ACTIONS(1320),
    [anon_sym___forceinline] = ACTIONS(1320),
    [anon_sym_thread_local] = ACTIONS(1320),
    [anon_sym___thread] = ACTIONS(1320),
    [anon_sym_const] = ACTIONS(1320),
    [anon_sym_constexpr] = ACTIONS(1320),
    [anon_sym_volatile] = ACTIONS(1320),
    [anon_sym_restrict] = ACTIONS(1320),
    [anon_sym___restrict__] = ACTIONS(1320),
    [anon_sym__Atomic] = ACTIONS(1320),
    [anon_sym__Noreturn] = ACTIONS(1320),
    [anon_sym_noreturn] = ACTIONS(1320),
    [sym_primitive_type] = ACTIONS(1320),
    [anon_sym_enum] = ACTIONS(1320),
    [anon_sym_struct] = ACTIONS(1320),
    [anon_sym_union] = ACTIONS(1320),
    [anon_sym_if] = ACTIONS(1320),
    [anon_sym_else] = ACTIONS(1320),
    [anon_sym_switch] = ACTIONS(1320),
    [anon_sym_case] = ACTIONS(1320),
    [anon_sym_default] = ACTIONS(1320),
    [anon_sym_while] = ACTIONS(1320),
    [anon_sym_do] = ACTIONS(1320),
    [anon_sym_for] = ACTIONS(1320),
    [anon_sym_return] = ACTIONS(1320),
    [anon_sym_break] = ACTIONS(1320),
    [anon_sym_continue] = ACTIONS(1320),
    [anon_sym_goto] = ACTIONS(1320),
    [anon_sym___try] = ACTIONS(1320),
    [anon_sym___except] = ACTIONS(1320),
    [anon_sym___finally] = ACTIONS(1320),
    [anon_sym___leave] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1318),
    [anon_sym_PLUS_PLUS] = ACTIONS(1318),
    [anon_sym_sizeof] = ACTIONS(1320),
    [anon_sym___alignof__] = ACTIONS(1320),
    [anon_sym___alignof] = ACTIONS(1320),
    [anon_sym__alignof] = ACTIONS(1320),
    [anon_sym_alignof] = ACTIONS(1320),
    [anon_sym__Alignof] = ACTIONS(1320),
    [anon_sym_offsetof] = ACTIONS(1320),
    [anon_sym__Generic] = ACTIONS(1320),
    [anon_sym_asm] = ACTIONS(1320),
    [anon_sym___asm__] = ACTIONS(1320),
    [sym_number_literal] = ACTIONS(1318),
    [anon_sym_L_SQUOTE] = ACTIONS(1318),
    [anon_sym_u_SQUOTE] = ACTIONS(1318),
    [anon_sym_U_SQUOTE] = ACTIONS(1318),
    [anon_sym_u8_SQUOTE] = ACTIONS(1318),
    [anon_sym_SQUOTE] = ACTIONS(1318),
    [anon_sym_L_DQUOTE] = ACTIONS(1318),
    [anon_sym_u_DQUOTE] = ACTIONS(1318),
    [anon_sym_U_DQUOTE] = ACTIONS(1318),
    [anon_sym_u8_DQUOTE] = ACTIONS(1318),
    [anon_sym_DQUOTE] = ACTIONS(1318),
    [sym_true] = ACTIONS(1320),
    [sym_false] = ACTIONS(1320),
    [anon_sym_NULL] = ACTIONS(1320),
    [anon_sym_nullptr] = ACTIONS(1320),
    [sym_comment] = ACTIONS(3),
  },
  [97] = {
    [sym_identifier] = ACTIONS(1322),
    [aux_sym_preproc_include_token1] = ACTIONS(1322),
    [aux_sym_preproc_def_token1] = ACTIONS(1322),
    [aux_sym_preproc_if_token1] = ACTIONS(1322),
    [aux_sym_preproc_if_token2] = ACTIONS(1322),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1322),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1322),
    [aux_sym_preproc_else_token1] = ACTIONS(1322),
    [aux_sym_preproc_elif_token1] = ACTIONS(1322),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1322),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1322),
    [sym_preproc_directive] = ACTIONS(1322),
    [anon_sym_LPAREN2] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(1324),
    [anon_sym_TILDE] = ACTIONS(1324),
    [anon_sym_DASH] = ACTIONS(1322),
    [anon_sym_PLUS] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(1324),
    [anon_sym_AMP] = ACTIONS(1324),
    [anon_sym_SEMI] = ACTIONS(1324),
    [anon_sym___extension__] = ACTIONS(1322),
    [anon_sym_typedef] = ACTIONS(1322),
    [anon_sym_extern] = ACTIONS(1322),
    [anon_sym___attribute__] = ACTIONS(1322),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1324),
    [anon_sym___declspec] = ACTIONS(1322),
    [anon_sym___cdecl] = ACTIONS(1322),
    [anon_sym___clrcall] = ACTIONS(1322),
    [anon_sym___stdcall] = ACTIONS(1322),
    [anon_sym___fastcall] = ACTIONS(1322),
    [anon_sym___thiscall] = ACTIONS(1322),
    [anon_sym___vectorcall] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_signed] = ACTIONS(1322),
    [anon_sym_unsigned] = ACTIONS(1322),
    [anon_sym_long] = ACTIONS(1322),
    [anon_sym_short] = ACTIONS(1322),
    [anon_sym_static] = ACTIONS(1322),
    [anon_sym_auto] = ACTIONS(1322),
    [anon_sym_register] = ACTIONS(1322),
    [anon_sym_inline] = ACTIONS(1322),
    [anon_sym___inline] = ACTIONS(1322),
    [anon_sym___inline__] = ACTIONS(1322),
    [anon_sym___forceinline] = ACTIONS(1322),
    [anon_sym_thread_local] = ACTIONS(1322),
    [anon_sym___thread] = ACTIONS(1322),
    [anon_sym_const] = ACTIONS(1322),
    [anon_sym_constexpr] = ACTIONS(1322),
    [anon_sym_volatile] = ACTIONS(1322),
    [anon_sym_restrict] = ACTIONS(1322),
    [anon_sym___restrict__] = ACTIONS(1322),
    [anon_sym__Atomic] = ACTIONS(1322),
    [anon_sym__Noreturn] = ACTIONS(1322),
    [anon_sym_noreturn] = ACTIONS(1322),
    [sym_primitive_type] = ACTIONS(1322),
    [anon_sym_enum] = ACTIONS(1322),
    [anon_sym_struct] = ACTIONS(1322),
    [anon_sym_union] = ACTIONS(1322),
    [anon_sym_if] = ACTIONS(1322),
    [anon_sym_else] = ACTIONS(1322),
    [anon_sym_switch] = ACTIONS(1322),
    [anon_sym_case] = ACTIONS(1322),
    [anon_sym_default] = ACTIONS(1322),
    [anon_sym_while] = ACTIONS(1322),
    [anon_sym_do] = ACTIONS(1322),
    [anon_sym_for] = ACTIONS(1322),
    [anon_sym_return] = ACTIONS(1322),
    [anon_sym_break] = ACTIONS(1322),
    [anon_sym_continue] = ACTIONS(1322),
    [anon_sym_goto] = ACTIONS(1322),
    [anon_sym___try] = ACTIONS(1322),
    [anon_sym___leave] = ACTIONS(1322),
    [anon_sym_DASH_DASH] = ACTIONS(1324),
    [anon_sym_PLUS_PLUS] = ACTIONS(1324),
    [anon_sym_sizeof] = ACTIONS(1322),
    [anon_sym___alignof__] = ACTIONS(1322),
    [anon_sym___alignof] = ACTIONS(1322),
    [anon_sym__alignof] = ACTIONS(1322),
    [anon_sym_alignof] = ACTIONS(1322),
    [anon_sym__Alignof] = ACTIONS(1322),
    [anon_sym_offsetof] = ACTIONS(1322),
    [anon_sym__Generic] = ACTIONS(1322),
    [anon_sym_asm] = ACTIONS(1322),
    [anon_sym___asm__] = ACTIONS(1322),
    [sym_number_literal] = ACTIONS(1324),
    [anon_sym_L_SQUOTE] = ACTIONS(1324),
    [anon_sym_u_SQUOTE] = ACTIONS(1324),
    [anon_sym_U_SQUOTE] = ACTIONS(1324),
    [anon_sym_u8_SQUOTE] = ACTIONS(1324),
    [anon_sym_SQUOTE] = ACTIONS(1324),
    [anon_sym_L_DQUOTE] = ACTIONS(1324),
    [anon_sym_u_DQUOTE] = ACTIONS(1324),
    [anon_sym_U_DQUOTE] = ACTIONS(1324),
    [anon_sym_u8_DQUOTE] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1324),
    [sym_true] = ACTIONS(1322),
    [sym_false] = ACTIONS(1322),
    [anon_sym_NULL] = ACTIONS(1322),
    [anon_sym_nullptr] = ACTIONS(1322),
    [sym_comment] = ACTIONS(3),
  },
  [98] = {
    [sym_identifier] = ACTIONS(1326),
    [aux_sym_preproc_include_token1] = ACTIONS(1326),
    [aux_sym_preproc_def_token1] = ACTIONS(1326),
    [aux_sym_preproc_if_token1] = ACTIONS(1326),
    [aux_sym_preproc_if_token2] = ACTIONS(1326),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1326),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1326),
    [aux_sym_preproc_else_token1] = ACTIONS(1326),
    [aux_sym_preproc_elif_token1] = ACTIONS(1326),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1326),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1326),
    [sym_preproc_directive] = ACTIONS(1326),
    [anon_sym_LPAREN2] = ACTIONS(1328),
    [anon_sym_BANG] = ACTIONS(1328),
    [anon_sym_TILDE] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_PLUS] = ACTIONS(1326),
    [anon_sym_STAR] = ACTIONS(1328),
    [anon_sym_AMP] = ACTIONS(1328),
    [anon_sym_SEMI] = ACTIONS(1328),
    [anon_sym___extension__] = ACTIONS(1326),
    [anon_sym_typedef] = ACTIONS(1326),
    [anon_sym_extern] = ACTIONS(1326),
    [anon_sym___attribute__] = ACTIONS(1326),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1328),
    [anon_sym___declspec] = ACTIONS(1326),
    [anon_sym___cdecl] = ACTIONS(1326),
    [anon_sym___clrcall] = ACTIONS(1326),
    [anon_sym___stdcall] = ACTIONS(1326),
    [anon_sym___fastcall] = ACTIONS(1326),
    [anon_sym___thiscall] = ACTIONS(1326),
    [anon_sym___vectorcall] = ACTIONS(1326),
    [anon_sym_LBRACE] = ACTIONS(1328),
    [anon_sym_signed] = ACTIONS(1326),
    [anon_sym_unsigned] = ACTIONS(1326),
    [anon_sym_long] = ACTIONS(1326),
    [anon_sym_short] = ACTIONS(1326),
    [anon_sym_static] = ACTIONS(1326),
    [anon_sym_auto] = ACTIONS(1326),
    [anon_sym_register] = ACTIONS(1326),
    [anon_sym_inline] = ACTIONS(1326),
    [anon_sym___inline] = ACTIONS(1326),
    [anon_sym___inline__] = ACTIONS(1326),
    [anon_sym___forceinline] = ACTIONS(1326),
    [anon_sym_thread_local] = ACTIONS(1326),
    [anon_sym___thread] = ACTIONS(1326),
    [anon_sym_const] = ACTIONS(1326),
    [anon_sym_constexpr] = ACTIONS(1326),
    [anon_sym_volatile] = ACTIONS(1326),
    [anon_sym_restrict] = ACTIONS(1326),
    [anon_sym___restrict__] = ACTIONS(1326),
    [anon_sym__Atomic] = ACTIONS(1326),
    [anon_sym__Noreturn] = ACTIONS(1326),
    [anon_sym_noreturn] = ACTIONS(1326),
    [sym_primitive_type] = ACTIONS(1326),
    [anon_sym_enum] = ACTIONS(1326),
    [anon_sym_struct] = ACTIONS(1326),
    [anon_sym_union] = ACTIONS(1326),
    [anon_sym_if] = ACTIONS(1326),
    [anon_sym_else] = ACTIONS(1326),
    [anon_sym_switch] = ACTIONS(1326),
    [anon_sym_case] = ACTIONS(1326),
    [anon_sym_default] = ACTIONS(1326),
    [anon_sym_while] = ACTIONS(1326),
    [anon_sym_do] = ACTIONS(1326),
    [anon_sym_for] = ACTIONS(1326),
    [anon_sym_return] = ACTIONS(1326),
    [anon_sym_break] = ACTIONS(1326),
    [anon_sym_continue] = ACTIONS(1326),
    [anon_sym_goto] = ACTIONS(1326),
    [anon_sym___try] = ACTIONS(1326),
    [anon_sym___leave] = ACTIONS(1326),
    [anon_sym_DASH_DASH] = ACTIONS(1328),
    [anon_sym_PLUS_PLUS] = ACTIONS(1328),
    [anon_sym_sizeof] = ACTIONS(1326),
    [anon_sym___alignof__] = ACTIONS(1326),
    [anon_sym___alignof] = ACTIONS(1326),
    [anon_sym__alignof] = ACTIONS(1326),
    [anon_sym_alignof] = ACTIONS(1326),
    [anon_sym__Alignof] = ACTIONS(1326),
    [anon_sym_offsetof] = ACTIONS(1326),
    [anon_sym__Generic] = ACTIONS(1326),
    [anon_sym_asm] = ACTIONS(1326),
    [anon_sym___asm__] = ACTIONS(1326),
    [sym_number_literal] = ACTIONS(1328),
    [anon_sym_L_SQUOTE] = ACTIONS(1328),
    [anon_sym_u_SQUOTE] = ACTIONS(1328),
    [anon_sym_U_SQUOTE] = ACTIONS(1328),
    [anon_sym_u8_SQUOTE] = ACTIONS(1328),
    [anon_sym_SQUOTE] = ACTIONS(1328),
    [anon_sym_L_DQUOTE] = ACTIONS(1328),
    [anon_sym_u_DQUOTE] = ACTIONS(1328),
    [anon_sym_U_DQUOTE] = ACTIONS(1328),
    [anon_sym_u8_DQUOTE] = ACTIONS(1328),
    [anon_sym_DQUOTE] = ACTIONS(1328),
    [sym_true] = ACTIONS(1326),
    [sym_false] = ACTIONS(1326),
    [anon_sym_NULL] = ACTIONS(1326),
    [anon_sym_nullptr] = ACTIONS(1326),
    [sym_comment] = ACTIONS(3),
  },
  [99] = {
    [sym_identifier] = ACTIONS(1330),
    [aux_sym_preproc_include_token1] = ACTIONS(1330),
    [aux_sym_preproc_def_token1] = ACTIONS(1330),
    [aux_sym_preproc_if_token1] = ACTIONS(1330),
    [aux_sym_preproc_if_token2] = ACTIONS(1330),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1330),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1330),
    [aux_sym_preproc_else_token1] = ACTIONS(1330),
    [aux_sym_preproc_elif_token1] = ACTIONS(1330),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1330),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1330),
    [sym_preproc_directive] = ACTIONS(1330),
    [anon_sym_LPAREN2] = ACTIONS(1332),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1332),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_AMP] = ACTIONS(1332),
    [anon_sym_SEMI] = ACTIONS(1332),
    [anon_sym___extension__] = ACTIONS(1330),
    [anon_sym_typedef] = ACTIONS(1330),
    [anon_sym_extern] = ACTIONS(1330),
    [anon_sym___attribute__] = ACTIONS(1330),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1332),
    [anon_sym___declspec] = ACTIONS(1330),
    [anon_sym___cdecl] = ACTIONS(1330),
    [anon_sym___clrcall] = ACTIONS(1330),
    [anon_sym___stdcall] = ACTIONS(1330),
    [anon_sym___fastcall] = ACTIONS(1330),
    [anon_sym___thiscall] = ACTIONS(1330),
    [anon_sym___vectorcall] = ACTIONS(1330),
    [anon_sym_LBRACE] = ACTIONS(1332),
    [anon_sym_signed] = ACTIONS(1330),
    [anon_sym_unsigned] = ACTIONS(1330),
    [anon_sym_long] = ACTIONS(1330),
    [anon_sym_short] = ACTIONS(1330),
    [anon_sym_static] = ACTIONS(1330),
    [anon_sym_auto] = ACTIONS(1330),
    [anon_sym_register] = ACTIONS(1330),
    [anon_sym_inline] = ACTIONS(1330),
    [anon_sym___inline] = ACTIONS(1330),
    [anon_sym___inline__] = ACTIONS(1330),
    [anon_sym___forceinline] = ACTIONS(1330),
    [anon_sym_thread_local] = ACTIONS(1330),
    [anon_sym___thread] = ACTIONS(1330),
    [anon_sym_const] = ACTIONS(1330),
    [anon_sym_constexpr] = ACTIONS(1330),
    [anon_sym_volatile] = ACTIONS(1330),
    [anon_sym_restrict] = ACTIONS(1330),
    [anon_sym___restrict__] = ACTIONS(1330),
    [anon_sym__Atomic] = ACTIONS(1330),
    [anon_sym__Noreturn] = ACTIONS(1330),
    [anon_sym_noreturn] = ACTIONS(1330),
    [sym_primitive_type] = ACTIONS(1330),
    [anon_sym_enum] = ACTIONS(1330),
    [anon_sym_struct] = ACTIONS(1330),
    [anon_sym_union] = ACTIONS(1330),
    [anon_sym_if] = ACTIONS(1330),
    [anon_sym_else] = ACTIONS(1330),
    [anon_sym_switch] = ACTIONS(1330),
    [anon_sym_case] = ACTIONS(1330),
    [anon_sym_default] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1330),
    [anon_sym_do] = ACTIONS(1330),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_return] = ACTIONS(1330),
    [anon_sym_break] = ACTIONS(1330),
    [anon_sym_continue] = ACTIONS(1330),
    [anon_sym_goto] = ACTIONS(1330),
    [anon_sym___try] = ACTIONS(1330),
    [anon_sym___leave] = ACTIONS(1330),
    [anon_sym_DASH_DASH] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(1332),
    [anon_sym_sizeof] = ACTIONS(1330),
    [anon_sym___alignof__] = ACTIONS(1330),
    [anon_sym___alignof] = ACTIONS(1330),
    [anon_sym__alignof] = ACTIONS(1330),
    [anon_sym_alignof] = ACTIONS(1330),
    [anon_sym__Alignof] = ACTIONS(1330),
    [anon_sym_offsetof] = ACTIONS(1330),
    [anon_sym__Generic] = ACTIONS(1330),
    [anon_sym_asm] = ACTIONS(1330),
    [anon_sym___asm__] = ACTIONS(1330),
    [sym_number_literal] = ACTIONS(1332),
    [anon_sym_L_SQUOTE] = ACTIONS(1332),
    [anon_sym_u_SQUOTE] = ACTIONS(1332),
    [anon_sym_U_SQUOTE] = ACTIONS(1332),
    [anon_sym_u8_SQUOTE] = ACTIONS(1332),
    [anon_sym_SQUOTE] = ACTIONS(1332),
    [anon_sym_L_DQUOTE] = ACTIONS(1332),
    [anon_sym_u_DQUOTE] = ACTIONS(1332),
    [anon_sym_U_DQUOTE] = ACTIONS(1332),
    [anon_sym_u8_DQUOTE] = ACTIONS(1332),
    [anon_sym_DQUOTE] = ACTIONS(1332),
    [sym_true] = ACTIONS(1330),
    [sym_false] = ACTIONS(1330),
    [anon_sym_NULL] = ACTIONS(1330),
    [anon_sym_nullptr] = ACTIONS(1330),
    [sym_comment] = ACTIONS(3),
  },
  [100] = {
    [sym_identifier] = ACTIONS(1334),
    [aux_sym_preproc_include_token1] = ACTIONS(1334),
    [aux_sym_preproc_def_token1] = ACTIONS(1334),
    [aux_sym_preproc_if_token1] = ACTIONS(1334),
    [aux_sym_preproc_if_token2] = ACTIONS(1334),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1334),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1334),
    [aux_sym_preproc_else_token1] = ACTIONS(1334),
    [aux_sym_preproc_elif_token1] = ACTIONS(1334),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1334),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1334),
    [sym_preproc_directive] = ACTIONS(1334),
    [anon_sym_LPAREN2] = ACTIONS(1336),
    [anon_sym_BANG] = ACTIONS(1336),
    [anon_sym_TILDE] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_PLUS] = ACTIONS(1334),
    [anon_sym_STAR] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1336),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym___extension__] = ACTIONS(1334),
    [anon_sym_typedef] = ACTIONS(1334),
    [anon_sym_extern] = ACTIONS(1334),
    [anon_sym___attribute__] = ACTIONS(1334),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1336),
    [anon_sym___declspec] = ACTIONS(1334),
    [anon_sym___cdecl] = ACTIONS(1334),
    [anon_sym___clrcall] = ACTIONS(1334),
    [anon_sym___stdcall] = ACTIONS(1334),
    [anon_sym___fastcall] = ACTIONS(1334),
    [anon_sym___thiscall] = ACTIONS(1334),
    [anon_sym___vectorcall] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_signed] = ACTIONS(1334),
    [anon_sym_unsigned] = ACTIONS(1334),
    [anon_sym_long] = ACTIONS(1334),
    [anon_sym_short] = ACTIONS(1334),
    [anon_sym_static] = ACTIONS(1334),
    [anon_sym_auto] = ACTIONS(1334),
    [anon_sym_register] = ACTIONS(1334),
    [anon_sym_inline] = ACTIONS(1334),
    [anon_sym___inline] = ACTIONS(1334),
    [anon_sym___inline__] = ACTIONS(1334),
    [anon_sym___forceinline] = ACTIONS(1334),
    [anon_sym_thread_local] = ACTIONS(1334),
    [anon_sym___thread] = ACTIONS(1334),
    [anon_sym_const] = ACTIONS(1334),
    [anon_sym_constexpr] = ACTIONS(1334),
    [anon_sym_volatile] = ACTIONS(1334),
    [anon_sym_restrict] = ACTIONS(1334),
    [anon_sym___restrict__] = ACTIONS(1334),
    [anon_sym__Atomic] = ACTIONS(1334),
    [anon_sym__Noreturn] = ACTIONS(1334),
    [anon_sym_noreturn] = ACTIONS(1334),
    [sym_primitive_type] = ACTIONS(1334),
    [anon_sym_enum] = ACTIONS(1334),
    [anon_sym_struct] = ACTIONS(1334),
    [anon_sym_union] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1334),
    [anon_sym_else] = ACTIONS(1334),
    [anon_sym_switch] = ACTIONS(1334),
    [anon_sym_case] = ACTIONS(1334),
    [anon_sym_default] = ACTIONS(1334),
    [anon_sym_while] = ACTIONS(1334),
    [anon_sym_do] = ACTIONS(1334),
    [anon_sym_for] = ACTIONS(1334),
    [anon_sym_return] = ACTIONS(1334),
    [anon_sym_break] = ACTIONS(1334),
    [anon_sym_continue] = ACTIONS(1334),
    [anon_sym_goto] = ACTIONS(1334),
    [anon_sym___try] = ACTIONS(1334),
    [anon_sym___leave] = ACTIONS(1334),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_sizeof] = ACTIONS(1334),
    [anon_sym___alignof__] = ACTIONS(1334),
    [anon_sym___alignof] = ACTIONS(1334),
    [anon_sym__alignof] = ACTIONS(1334),
    [anon_sym_alignof] = ACTIONS(1334),
    [anon_sym__Alignof] = ACTIONS(1334),
    [anon_sym_offsetof] = ACTIONS(1334),
    [anon_sym__Generic] = ACTIONS(1334),
    [anon_sym_asm] = ACTIONS(1334),
    [anon_sym___asm__] = ACTIONS(1334),
    [sym_number_literal] = ACTIONS(1336),
    [anon_sym_L_SQUOTE] = ACTIONS(1336),
    [anon_sym_u_SQUOTE] = ACTIONS(1336),
    [anon_sym_U_SQUOTE] = ACTIONS(1336),
    [anon_sym_u8_SQUOTE] = ACTIONS(1336),
    [anon_sym_SQUOTE] = ACTIONS(1336),
    [anon_sym_L_DQUOTE] = ACTIONS(1336),
    [anon_sym_u_DQUOTE] = ACTIONS(1336),
    [anon_sym_U_DQUOTE] = ACTIONS(1336),
    [anon_sym_u8_DQUOTE] = ACTIONS(1336),
    [anon_sym_DQUOTE] = ACTIONS(1336),
    [sym_true] = ACTIONS(1334),
    [sym_false] = ACTIONS(1334),
    [anon_sym_NULL] = ACTIONS(1334),
    [anon_sym_nullptr] = ACTIONS(1334),
    [sym_comment] = ACTIONS(3),
  },
  [101] = {
    [sym_identifier] = ACTIONS(1298),
    [aux_sym_preproc_include_token1] = ACTIONS(1298),
    [aux_sym_preproc_def_token1] = ACTIONS(1298),
    [aux_sym_preproc_if_token1] = ACTIONS(1298),
    [aux_sym_preproc_if_token2] = ACTIONS(1298),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1298),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1298),
    [aux_sym_preproc_else_token1] = ACTIONS(1298),
    [aux_sym_preproc_elif_token1] = ACTIONS(1298),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1298),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1298),
    [sym_preproc_directive] = ACTIONS(1298),
    [anon_sym_LPAREN2] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1300),
    [anon_sym_TILDE] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1298),
    [anon_sym_PLUS] = ACTIONS(1298),
    [anon_sym_STAR] = ACTIONS(1300),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(1300),
    [anon_sym___extension__] = ACTIONS(1298),
    [anon_sym_typedef] = ACTIONS(1298),
    [anon_sym_extern] = ACTIONS(1298),
    [anon_sym___attribute__] = ACTIONS(1298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1300),
    [anon_sym___declspec] = ACTIONS(1298),
    [anon_sym___cdecl] = ACTIONS(1298),
    [anon_sym___clrcall] = ACTIONS(1298),
    [anon_sym___stdcall] = ACTIONS(1298),
    [anon_sym___fastcall] = ACTIONS(1298),
    [anon_sym___thiscall] = ACTIONS(1298),
    [anon_sym___vectorcall] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_signed] = ACTIONS(1298),
    [anon_sym_unsigned] = ACTIONS(1298),
    [anon_sym_long] = ACTIONS(1298),
    [anon_sym_short] = ACTIONS(1298),
    [anon_sym_static] = ACTIONS(1298),
    [anon_sym_auto] = ACTIONS(1298),
    [anon_sym_register] = ACTIONS(1298),
    [anon_sym_inline] = ACTIONS(1298),
    [anon_sym___inline] = ACTIONS(1298),
    [anon_sym___inline__] = ACTIONS(1298),
    [anon_sym___forceinline] = ACTIONS(1298),
    [anon_sym_thread_local] = ACTIONS(1298),
    [anon_sym___thread] = ACTIONS(1298),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_constexpr] = ACTIONS(1298),
    [anon_sym_volatile] = ACTIONS(1298),
    [anon_sym_restrict] = ACTIONS(1298),
    [anon_sym___restrict__] = ACTIONS(1298),
    [anon_sym__Atomic] = ACTIONS(1298),
    [anon_sym__Noreturn] = ACTIONS(1298),
    [anon_sym_noreturn] = ACTIONS(1298),
    [sym_primitive_type] = ACTIONS(1298),
    [anon_sym_enum] = ACTIONS(1298),
    [anon_sym_struct] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1298),
    [anon_sym_if] = ACTIONS(1298),
    [anon_sym_else] = ACTIONS(1298),
    [anon_sym_switch] = ACTIONS(1298),
    [anon_sym_case] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(1298),
    [anon_sym_do] = ACTIONS(1298),
    [anon_sym_for] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1298),
    [anon_sym_break] = ACTIONS(1298),
    [anon_sym_continue] = ACTIONS(1298),
    [anon_sym_goto] = ACTIONS(1298),
    [anon_sym___try] = ACTIONS(1298),
    [anon_sym___leave] = ACTIONS(1298),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_sizeof] = ACTIONS(1298),
    [anon_sym___alignof__] = ACTIONS(1298),
    [anon_sym___alignof] = ACTIONS(1298),
    [anon_sym__alignof] = ACTIONS(1298),
    [anon_sym_alignof] = ACTIONS(1298),
    [anon_sym__Alignof] = ACTIONS(1298),
    [anon_sym_offsetof] = ACTIONS(1298),
    [anon_sym__Generic] = ACTIONS(1298),
    [anon_sym_asm] = ACTIONS(1298),
    [anon_sym___asm__] = ACTIONS(1298),
    [sym_number_literal] = ACTIONS(1300),
    [anon_sym_L_SQUOTE] = ACTIONS(1300),
    [anon_sym_u_SQUOTE] = ACTIONS(1300),
    [anon_sym_U_SQUOTE] = ACTIONS(1300),
    [anon_sym_u8_SQUOTE] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(1300),
    [anon_sym_L_DQUOTE] = ACTIONS(1300),
    [anon_sym_u_DQUOTE] = ACTIONS(1300),
    [anon_sym_U_DQUOTE] = ACTIONS(1300),
    [anon_sym_u8_DQUOTE] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(1300),
    [sym_true] = ACTIONS(1298),
    [sym_false] = ACTIONS(1298),
    [anon_sym_NULL] = ACTIONS(1298),
    [anon_sym_nullptr] = ACTIONS(1298),
    [sym_comment] = ACTIONS(3),
  },
  [102] = {
    [sym_identifier] = ACTIONS(1338),
    [aux_sym_preproc_include_token1] = ACTIONS(1338),
    [aux_sym_preproc_def_token1] = ACTIONS(1338),
    [aux_sym_preproc_if_token1] = ACTIONS(1338),
    [aux_sym_preproc_if_token2] = ACTIONS(1338),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1338),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1338),
    [aux_sym_preproc_else_token1] = ACTIONS(1338),
    [aux_sym_preproc_elif_token1] = ACTIONS(1338),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1338),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1338),
    [sym_preproc_directive] = ACTIONS(1338),
    [anon_sym_LPAREN2] = ACTIONS(1340),
    [anon_sym_BANG] = ACTIONS(1340),
    [anon_sym_TILDE] = ACTIONS(1340),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_PLUS] = ACTIONS(1338),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_SEMI] = ACTIONS(1340),
    [anon_sym___extension__] = ACTIONS(1338),
    [anon_sym_typedef] = ACTIONS(1338),
    [anon_sym_extern] = ACTIONS(1338),
    [anon_sym___attribute__] = ACTIONS(1338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1340),
    [anon_sym___declspec] = ACTIONS(1338),
    [anon_sym___cdecl] = ACTIONS(1338),
    [anon_sym___clrcall] = ACTIONS(1338),
    [anon_sym___stdcall] = ACTIONS(1338),
    [anon_sym___fastcall] = ACTIONS(1338),
    [anon_sym___thiscall] = ACTIONS(1338),
    [anon_sym___vectorcall] = ACTIONS(1338),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_signed] = ACTIONS(1338),
    [anon_sym_unsigned] = ACTIONS(1338),
    [anon_sym_long] = ACTIONS(1338),
    [anon_sym_short] = ACTIONS(1338),
    [anon_sym_static] = ACTIONS(1338),
    [anon_sym_auto] = ACTIONS(1338),
    [anon_sym_register] = ACTIONS(1338),
    [anon_sym_inline] = ACTIONS(1338),
    [anon_sym___inline] = ACTIONS(1338),
    [anon_sym___inline__] = ACTIONS(1338),
    [anon_sym___forceinline] = ACTIONS(1338),
    [anon_sym_thread_local] = ACTIONS(1338),
    [anon_sym___thread] = ACTIONS(1338),
    [anon_sym_const] = ACTIONS(1338),
    [anon_sym_constexpr] = ACTIONS(1338),
    [anon_sym_volatile] = ACTIONS(1338),
    [anon_sym_restrict] = ACTIONS(1338),
    [anon_sym___restrict__] = ACTIONS(1338),
    [anon_sym__Atomic] = ACTIONS(1338),
    [anon_sym__Noreturn] = ACTIONS(1338),
    [anon_sym_noreturn] = ACTIONS(1338),
    [sym_primitive_type] = ACTIONS(1338),
    [anon_sym_enum] = ACTIONS(1338),
    [anon_sym_struct] = ACTIONS(1338),
    [anon_sym_union] = ACTIONS(1338),
    [anon_sym_if] = ACTIONS(1338),
    [anon_sym_else] = ACTIONS(1338),
    [anon_sym_switch] = ACTIONS(1338),
    [anon_sym_case] = ACTIONS(1338),
    [anon_sym_default] = ACTIONS(1338),
    [anon_sym_while] = ACTIONS(1338),
    [anon_sym_do] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1338),
    [anon_sym_return] = ACTIONS(1338),
    [anon_sym_break] = ACTIONS(1338),
    [anon_sym_continue] = ACTIONS(1338),
    [anon_sym_goto] = ACTIONS(1338),
    [anon_sym___try] = ACTIONS(1338),
    [anon_sym___leave] = ACTIONS(1338),
    [anon_sym_DASH_DASH] = ACTIONS(1340),
    [anon_sym_PLUS_PLUS] = ACTIONS(1340),
    [anon_sym_sizeof] = ACTIONS(1338),
    [anon_sym___alignof__] = ACTIONS(1338),
    [anon_sym___alignof] = ACTIONS(1338),
    [anon_sym__alignof] = ACTIONS(1338),
    [anon_sym_alignof] = ACTIONS(1338),
    [anon_sym__Alignof] = ACTIONS(1338),
    [anon_sym_offsetof] = ACTIONS(1338),
    [anon_sym__Generic] = ACTIONS(1338),
    [anon_sym_asm] = ACTIONS(1338),
    [anon_sym___asm__] = ACTIONS(1338),
    [sym_number_literal] = ACTIONS(1340),
    [anon_sym_L_SQUOTE] = ACTIONS(1340),
    [anon_sym_u_SQUOTE] = ACTIONS(1340),
    [anon_sym_U_SQUOTE] = ACTIONS(1340),
    [anon_sym_u8_SQUOTE] = ACTIONS(1340),
    [anon_sym_SQUOTE] = ACTIONS(1340),
    [anon_sym_L_DQUOTE] = ACTIONS(1340),
    [anon_sym_u_DQUOTE] = ACTIONS(1340),
    [anon_sym_U_DQUOTE] = ACTIONS(1340),
    [anon_sym_u8_DQUOTE] = ACTIONS(1340),
    [anon_sym_DQUOTE] = ACTIONS(1340),
    [sym_true] = ACTIONS(1338),
    [sym_false] = ACTIONS(1338),
    [anon_sym_NULL] = ACTIONS(1338),
    [anon_sym_nullptr] = ACTIONS(1338),
    [sym_comment] = ACTIONS(3),
  },
  [103] = {
    [sym_identifier] = ACTIONS(1342),
    [aux_sym_preproc_include_token1] = ACTIONS(1342),
    [aux_sym_preproc_def_token1] = ACTIONS(1342),
    [aux_sym_preproc_if_token1] = ACTIONS(1342),
    [aux_sym_preproc_if_token2] = ACTIONS(1342),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1342),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1342),
    [aux_sym_preproc_else_token1] = ACTIONS(1342),
    [aux_sym_preproc_elif_token1] = ACTIONS(1342),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1342),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1342),
    [sym_preproc_directive] = ACTIONS(1342),
    [anon_sym_LPAREN2] = ACTIONS(1344),
    [anon_sym_BANG] = ACTIONS(1344),
    [anon_sym_TILDE] = ACTIONS(1344),
    [anon_sym_DASH] = ACTIONS(1342),
    [anon_sym_PLUS] = ACTIONS(1342),
    [anon_sym_STAR] = ACTIONS(1344),
    [anon_sym_AMP] = ACTIONS(1344),
    [anon_sym_SEMI] = ACTIONS(1344),
    [anon_sym___extension__] = ACTIONS(1342),
    [anon_sym_typedef] = ACTIONS(1342),
    [anon_sym_extern] = ACTIONS(1342),
    [anon_sym___attribute__] = ACTIONS(1342),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1344),
    [anon_sym___declspec] = ACTIONS(1342),
    [anon_sym___cdecl] = ACTIONS(1342),
    [anon_sym___clrcall] = ACTIONS(1342),
    [anon_sym___stdcall] = ACTIONS(1342),
    [anon_sym___fastcall] = ACTIONS(1342),
    [anon_sym___thiscall] = ACTIONS(1342),
    [anon_sym___vectorcall] = ACTIONS(1342),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_signed] = ACTIONS(1342),
    [anon_sym_unsigned] = ACTIONS(1342),
    [anon_sym_long] = ACTIONS(1342),
    [anon_sym_short] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_auto] = ACTIONS(1342),
    [anon_sym_register] = ACTIONS(1342),
    [anon_sym_inline] = ACTIONS(1342),
    [anon_sym___inline] = ACTIONS(1342),
    [anon_sym___inline__] = ACTIONS(1342),
    [anon_sym___forceinline] = ACTIONS(1342),
    [anon_sym_thread_local] = ACTIONS(1342),
    [anon_sym___thread] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [anon_sym_constexpr] = ACTIONS(1342),
    [anon_sym_volatile] = ACTIONS(1342),
    [anon_sym_restrict] = ACTIONS(1342),
    [anon_sym___restrict__] = ACTIONS(1342),
    [anon_sym__Atomic] = ACTIONS(1342),
    [anon_sym__Noreturn] = ACTIONS(1342),
    [anon_sym_noreturn] = ACTIONS(1342),
    [sym_primitive_type] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_union] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1342),
    [anon_sym_else] = ACTIONS(1342),
    [anon_sym_switch] = ACTIONS(1342),
    [anon_sym_case] = ACTIONS(1342),
    [anon_sym_default] = ACTIONS(1342),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_do] = ACTIONS(1342),
    [anon_sym_for] = ACTIONS(1342),
    [anon_sym_return] = ACTIONS(1342),
    [anon_sym_break] = ACTIONS(1342),
    [anon_sym_continue] = ACTIONS(1342),
    [anon_sym_goto] = ACTIONS(1342),
    [anon_sym___try] = ACTIONS(1342),
    [anon_sym___leave] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(1344),
    [anon_sym_PLUS_PLUS] = ACTIONS(1344),
    [anon_sym_sizeof] = ACTIONS(1342),
    [anon_sym___alignof__] = ACTIONS(1342),
    [anon_sym___alignof] = ACTIONS(1342),
    [anon_sym__alignof] = ACTIONS(1342),
    [anon_sym_alignof] = ACTIONS(1342),
    [anon_sym__Alignof] = ACTIONS(1342),
    [anon_sym_offsetof] = ACTIONS(1342),
    [anon_sym__Generic] = ACTIONS(1342),
    [anon_sym_asm] = ACTIONS(1342),
    [anon_sym___asm__] = ACTIONS(1342),
    [sym_number_literal] = ACTIONS(1344),
    [anon_sym_L_SQUOTE] = ACTIONS(1344),
    [anon_sym_u_SQUOTE] = ACTIONS(1344),
    [anon_sym_U_SQUOTE] = ACTIONS(1344),
    [anon_sym_u8_SQUOTE] = ACTIONS(1344),
    [anon_sym_SQUOTE] = ACTIONS(1344),
    [anon_sym_L_DQUOTE] = ACTIONS(1344),
    [anon_sym_u_DQUOTE] = ACTIONS(1344),
    [anon_sym_U_DQUOTE] = ACTIONS(1344),
    [anon_sym_u8_DQUOTE] = ACTIONS(1344),
    [anon_sym_DQUOTE] = ACTIONS(1344),
    [sym_true] = ACTIONS(1342),
    [sym_false] = ACTIONS(1342),
    [anon_sym_NULL] = ACTIONS(1342),
    [anon_sym_nullptr] = ACTIONS(1342),
    [sym_comment] = ACTIONS(3),
  },
  [104] = {
    [sym_identifier] = ACTIONS(1346),
    [aux_sym_preproc_include_token1] = ACTIONS(1346),
    [aux_sym_preproc_def_token1] = ACTIONS(1346),
    [aux_sym_preproc_if_token1] = ACTIONS(1346),
    [aux_sym_preproc_if_token2] = ACTIONS(1346),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1346),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1346),
    [aux_sym_preproc_else_token1] = ACTIONS(1346),
    [aux_sym_preproc_elif_token1] = ACTIONS(1346),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1346),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1346),
    [sym_preproc_directive] = ACTIONS(1346),
    [anon_sym_LPAREN2] = ACTIONS(1348),
    [anon_sym_BANG] = ACTIONS(1348),
    [anon_sym_TILDE] = ACTIONS(1348),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_STAR] = ACTIONS(1348),
    [anon_sym_AMP] = ACTIONS(1348),
    [anon_sym_SEMI] = ACTIONS(1348),
    [anon_sym___extension__] = ACTIONS(1346),
    [anon_sym_typedef] = ACTIONS(1346),
    [anon_sym_extern] = ACTIONS(1346),
    [anon_sym___attribute__] = ACTIONS(1346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1348),
    [anon_sym___declspec] = ACTIONS(1346),
    [anon_sym___cdecl] = ACTIONS(1346),
    [anon_sym___clrcall] = ACTIONS(1346),
    [anon_sym___stdcall] = ACTIONS(1346),
    [anon_sym___fastcall] = ACTIONS(1346),
    [anon_sym___thiscall] = ACTIONS(1346),
    [anon_sym___vectorcall] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_signed] = ACTIONS(1346),
    [anon_sym_unsigned] = ACTIONS(1346),
    [anon_sym_long] = ACTIONS(1346),
    [anon_sym_short] = ACTIONS(1346),
    [anon_sym_static] = ACTIONS(1346),
    [anon_sym_auto] = ACTIONS(1346),
    [anon_sym_register] = ACTIONS(1346),
    [anon_sym_inline] = ACTIONS(1346),
    [anon_sym___inline] = ACTIONS(1346),
    [anon_sym___inline__] = ACTIONS(1346),
    [anon_sym___forceinline] = ACTIONS(1346),
    [anon_sym_thread_local] = ACTIONS(1346),
    [anon_sym___thread] = ACTIONS(1346),
    [anon_sym_const] = ACTIONS(1346),
    [anon_sym_constexpr] = ACTIONS(1346),
    [anon_sym_volatile] = ACTIONS(1346),
    [anon_sym_restrict] = ACTIONS(1346),
    [anon_sym___restrict__] = ACTIONS(1346),
    [anon_sym__Atomic] = ACTIONS(1346),
    [anon_sym__Noreturn] = ACTIONS(1346),
    [anon_sym_noreturn] = ACTIONS(1346),
    [sym_primitive_type] = ACTIONS(1346),
    [anon_sym_enum] = ACTIONS(1346),
    [anon_sym_struct] = ACTIONS(1346),
    [anon_sym_union] = ACTIONS(1346),
    [anon_sym_if] = ACTIONS(1346),
    [anon_sym_else] = ACTIONS(1346),
    [anon_sym_switch] = ACTIONS(1346),
    [anon_sym_case] = ACTIONS(1346),
    [anon_sym_default] = ACTIONS(1346),
    [anon_sym_while] = ACTIONS(1346),
    [anon_sym_do] = ACTIONS(1346),
    [anon_sym_for] = ACTIONS(1346),
    [anon_sym_return] = ACTIONS(1346),
    [anon_sym_break] = ACTIONS(1346),
    [anon_sym_continue] = ACTIONS(1346),
    [anon_sym_goto] = ACTIONS(1346),
    [anon_sym___try] = ACTIONS(1346),
    [anon_sym___leave] = ACTIONS(1346),
    [anon_sym_DASH_DASH] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(1348),
    [anon_sym_sizeof] = ACTIONS(1346),
    [anon_sym___alignof__] = ACTIONS(1346),
    [anon_sym___alignof] = ACTIONS(1346),
    [anon_sym__alignof] = ACTIONS(1346),
    [anon_sym_alignof] = ACTIONS(1346),
    [anon_sym__Alignof] = ACTIONS(1346),
    [anon_sym_offsetof] = ACTIONS(1346),
    [anon_sym__Generic] = ACTIONS(1346),
    [anon_sym_asm] = ACTIONS(1346),
    [anon_sym___asm__] = ACTIONS(1346),
    [sym_number_literal] = ACTIONS(1348),
    [anon_sym_L_SQUOTE] = ACTIONS(1348),
    [anon_sym_u_SQUOTE] = ACTIONS(1348),
    [anon_sym_U_SQUOTE] = ACTIONS(1348),
    [anon_sym_u8_SQUOTE] = ACTIONS(1348),
    [anon_sym_SQUOTE] = ACTIONS(1348),
    [anon_sym_L_DQUOTE] = ACTIONS(1348),
    [anon_sym_u_DQUOTE] = ACTIONS(1348),
    [anon_sym_U_DQUOTE] = ACTIONS(1348),
    [anon_sym_u8_DQUOTE] = ACTIONS(1348),
    [anon_sym_DQUOTE] = ACTIONS(1348),
    [sym_true] = ACTIONS(1346),
    [sym_false] = ACTIONS(1346),
    [anon_sym_NULL] = ACTIONS(1346),
    [anon_sym_nullptr] = ACTIONS(1346),
    [sym_comment] = ACTIONS(3),
  },
  [105] = {
    [sym_identifier] = ACTIONS(1320),
    [aux_sym_preproc_include_token1] = ACTIONS(1320),
    [aux_sym_preproc_def_token1] = ACTIONS(1320),
    [aux_sym_preproc_if_token1] = ACTIONS(1320),
    [aux_sym_preproc_if_token2] = ACTIONS(1320),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1320),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1320),
    [aux_sym_preproc_else_token1] = ACTIONS(1320),
    [aux_sym_preproc_elif_token1] = ACTIONS(1320),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1320),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1320),
    [sym_preproc_directive] = ACTIONS(1320),
    [anon_sym_LPAREN2] = ACTIONS(1318),
    [anon_sym_BANG] = ACTIONS(1318),
    [anon_sym_TILDE] = ACTIONS(1318),
    [anon_sym_DASH] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(1320),
    [anon_sym_STAR] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(1318),
    [anon_sym_SEMI] = ACTIONS(1318),
    [anon_sym___extension__] = ACTIONS(1320),
    [anon_sym_typedef] = ACTIONS(1320),
    [anon_sym_extern] = ACTIONS(1320),
    [anon_sym___attribute__] = ACTIONS(1320),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1318),
    [anon_sym___declspec] = ACTIONS(1320),
    [anon_sym___cdecl] = ACTIONS(1320),
    [anon_sym___clrcall] = ACTIONS(1320),
    [anon_sym___stdcall] = ACTIONS(1320),
    [anon_sym___fastcall] = ACTIONS(1320),
    [anon_sym___thiscall] = ACTIONS(1320),
    [anon_sym___vectorcall] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1318),
    [anon_sym_signed] = ACTIONS(1320),
    [anon_sym_unsigned] = ACTIONS(1320),
    [anon_sym_long] = ACTIONS(1320),
    [anon_sym_short] = ACTIONS(1320),
    [anon_sym_static] = ACTIONS(1320),
    [anon_sym_auto] = ACTIONS(1320),
    [anon_sym_register] = ACTIONS(1320),
    [anon_sym_inline] = ACTIONS(1320),
    [anon_sym___inline] = ACTIONS(1320),
    [anon_sym___inline__] = ACTIONS(1320),
    [anon_sym___forceinline] = ACTIONS(1320),
    [anon_sym_thread_local] = ACTIONS(1320),
    [anon_sym___thread] = ACTIONS(1320),
    [anon_sym_const] = ACTIONS(1320),
    [anon_sym_constexpr] = ACTIONS(1320),
    [anon_sym_volatile] = ACTIONS(1320),
    [anon_sym_restrict] = ACTIONS(1320),
    [anon_sym___restrict__] = ACTIONS(1320),
    [anon_sym__Atomic] = ACTIONS(1320),
    [anon_sym__Noreturn] = ACTIONS(1320),
    [anon_sym_noreturn] = ACTIONS(1320),
    [sym_primitive_type] = ACTIONS(1320),
    [anon_sym_enum] = ACTIONS(1320),
    [anon_sym_struct] = ACTIONS(1320),
    [anon_sym_union] = ACTIONS(1320),
    [anon_sym_if] = ACTIONS(1320),
    [anon_sym_else] = ACTIONS(1320),
    [anon_sym_switch] = ACTIONS(1320),
    [anon_sym_case] = ACTIONS(1320),
    [anon_sym_default] = ACTIONS(1320),
    [anon_sym_while] = ACTIONS(1320),
    [anon_sym_do] = ACTIONS(1320),
    [anon_sym_for] = ACTIONS(1320),
    [anon_sym_return] = ACTIONS(1320),
    [anon_sym_break] = ACTIONS(1320),
    [anon_sym_continue] = ACTIONS(1320),
    [anon_sym_goto] = ACTIONS(1320),
    [anon_sym___try] = ACTIONS(1320),
    [anon_sym___leave] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1318),
    [anon_sym_PLUS_PLUS] = ACTIONS(1318),
    [anon_sym_sizeof] = ACTIONS(1320),
    [anon_sym___alignof__] = ACTIONS(1320),
    [anon_sym___alignof] = ACTIONS(1320),
    [anon_sym__alignof] = ACTIONS(1320),
    [anon_sym_alignof] = ACTIONS(1320),
    [anon_sym__Alignof] = ACTIONS(1320),
    [anon_sym_offsetof] = ACTIONS(1320),
    [anon_sym__Generic] = ACTIONS(1320),
    [anon_sym_asm] = ACTIONS(1320),
    [anon_sym___asm__] = ACTIONS(1320),
    [sym_number_literal] = ACTIONS(1318),
    [anon_sym_L_SQUOTE] = ACTIONS(1318),
    [anon_sym_u_SQUOTE] = ACTIONS(1318),
    [anon_sym_U_SQUOTE] = ACTIONS(1318),
    [anon_sym_u8_SQUOTE] = ACTIONS(1318),
    [anon_sym_SQUOTE] = ACTIONS(1318),
    [anon_sym_L_DQUOTE] = ACTIONS(1318),
    [anon_sym_u_DQUOTE] = ACTIONS(1318),
    [anon_sym_U_DQUOTE] = ACTIONS(1318),
    [anon_sym_u8_DQUOTE] = ACTIONS(1318),
    [anon_sym_DQUOTE] = ACTIONS(1318),
    [sym_true] = ACTIONS(1320),
    [sym_false] = ACTIONS(1320),
    [anon_sym_NULL] = ACTIONS(1320),
    [anon_sym_nullptr] = ACTIONS(1320),
    [sym_comment] = ACTIONS(3),
  },
  [106] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [107] = {
    [ts_builtin_sym_end] = ACTIONS(1354),
    [sym_identifier] = ACTIONS(1356),
    [aux_sym_preproc_include_token1] = ACTIONS(1356),
    [aux_sym_preproc_def_token1] = ACTIONS(1356),
    [anon_sym_COMMA] = ACTIONS(1354),
    [anon_sym_RPAREN] = ACTIONS(1354),
    [aux_sym_preproc_if_token1] = ACTIONS(1356),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1356),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1356),
    [sym_preproc_directive] = ACTIONS(1356),
    [anon_sym_LPAREN2] = ACTIONS(1354),
    [anon_sym_BANG] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(1354),
    [anon_sym_DASH] = ACTIONS(1356),
    [anon_sym_PLUS] = ACTIONS(1356),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_AMP] = ACTIONS(1354),
    [anon_sym_SEMI] = ACTIONS(1354),
    [anon_sym___extension__] = ACTIONS(1356),
    [anon_sym_typedef] = ACTIONS(1356),
    [anon_sym_extern] = ACTIONS(1356),
    [anon_sym___attribute__] = ACTIONS(1356),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1354),
    [anon_sym___declspec] = ACTIONS(1356),
    [anon_sym___cdecl] = ACTIONS(1356),
    [anon_sym___clrcall] = ACTIONS(1356),
    [anon_sym___stdcall] = ACTIONS(1356),
    [anon_sym___fastcall] = ACTIONS(1356),
    [anon_sym___thiscall] = ACTIONS(1356),
    [anon_sym___vectorcall] = ACTIONS(1356),
    [anon_sym_LBRACE] = ACTIONS(1354),
    [anon_sym_signed] = ACTIONS(1356),
    [anon_sym_unsigned] = ACTIONS(1356),
    [anon_sym_long] = ACTIONS(1356),
    [anon_sym_short] = ACTIONS(1356),
    [anon_sym_static] = ACTIONS(1356),
    [anon_sym_auto] = ACTIONS(1356),
    [anon_sym_register] = ACTIONS(1356),
    [anon_sym_inline] = ACTIONS(1356),
    [anon_sym___inline] = ACTIONS(1356),
    [anon_sym___inline__] = ACTIONS(1356),
    [anon_sym___forceinline] = ACTIONS(1356),
    [anon_sym_thread_local] = ACTIONS(1356),
    [anon_sym___thread] = ACTIONS(1356),
    [anon_sym_const] = ACTIONS(1356),
    [anon_sym_constexpr] = ACTIONS(1356),
    [anon_sym_volatile] = ACTIONS(1356),
    [anon_sym_restrict] = ACTIONS(1356),
    [anon_sym___restrict__] = ACTIONS(1356),
    [anon_sym__Atomic] = ACTIONS(1356),
    [anon_sym__Noreturn] = ACTIONS(1356),
    [anon_sym_noreturn] = ACTIONS(1356),
    [sym_primitive_type] = ACTIONS(1356),
    [anon_sym_enum] = ACTIONS(1356),
    [anon_sym_struct] = ACTIONS(1356),
    [anon_sym_union] = ACTIONS(1356),
    [anon_sym_if] = ACTIONS(1356),
    [anon_sym_else] = ACTIONS(1356),
    [anon_sym_switch] = ACTIONS(1356),
    [anon_sym_case] = ACTIONS(1356),
    [anon_sym_default] = ACTIONS(1356),
    [anon_sym_while] = ACTIONS(1356),
    [anon_sym_do] = ACTIONS(1356),
    [anon_sym_for] = ACTIONS(1356),
    [anon_sym_return] = ACTIONS(1356),
    [anon_sym_break] = ACTIONS(1356),
    [anon_sym_continue] = ACTIONS(1356),
    [anon_sym_goto] = ACTIONS(1356),
    [anon_sym___try] = ACTIONS(1356),
    [anon_sym___except] = ACTIONS(1356),
    [anon_sym___finally] = ACTIONS(1356),
    [anon_sym___leave] = ACTIONS(1356),
    [anon_sym_DASH_DASH] = ACTIONS(1354),
    [anon_sym_PLUS_PLUS] = ACTIONS(1354),
    [anon_sym_sizeof] = ACTIONS(1356),
    [anon_sym___alignof__] = ACTIONS(1356),
    [anon_sym___alignof] = ACTIONS(1356),
    [anon_sym__alignof] = ACTIONS(1356),
    [anon_sym_alignof] = ACTIONS(1356),
    [anon_sym__Alignof] = ACTIONS(1356),
    [anon_sym_offsetof] = ACTIONS(1356),
    [anon_sym__Generic] = ACTIONS(1356),
    [anon_sym_asm] = ACTIONS(1356),
    [anon_sym___asm__] = ACTIONS(1356),
    [sym_number_literal] = ACTIONS(1354),
    [anon_sym_L_SQUOTE] = ACTIONS(1354),
    [anon_sym_u_SQUOTE] = ACTIONS(1354),
    [anon_sym_U_SQUOTE] = ACTIONS(1354),
    [anon_sym_u8_SQUOTE] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(1354),
    [anon_sym_L_DQUOTE] = ACTIONS(1354),
    [anon_sym_u_DQUOTE] = ACTIONS(1354),
    [anon_sym_U_DQUOTE] = ACTIONS(1354),
    [anon_sym_u8_DQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1354),
    [sym_true] = ACTIONS(1356),
    [sym_false] = ACTIONS(1356),
    [anon_sym_NULL] = ACTIONS(1356),
    [anon_sym_nullptr] = ACTIONS(1356),
    [sym_comment] = ACTIONS(3),
  },
  [108] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [109] = {
    [sym_identifier] = ACTIONS(1358),
    [aux_sym_preproc_include_token1] = ACTIONS(1358),
    [aux_sym_preproc_def_token1] = ACTIONS(1358),
    [aux_sym_preproc_if_token1] = ACTIONS(1358),
    [aux_sym_preproc_if_token2] = ACTIONS(1358),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1358),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1358),
    [aux_sym_preproc_else_token1] = ACTIONS(1358),
    [aux_sym_preproc_elif_token1] = ACTIONS(1358),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1358),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1358),
    [sym_preproc_directive] = ACTIONS(1358),
    [anon_sym_LPAREN2] = ACTIONS(1360),
    [anon_sym_BANG] = ACTIONS(1360),
    [anon_sym_TILDE] = ACTIONS(1360),
    [anon_sym_DASH] = ACTIONS(1358),
    [anon_sym_PLUS] = ACTIONS(1358),
    [anon_sym_STAR] = ACTIONS(1360),
    [anon_sym_AMP] = ACTIONS(1360),
    [anon_sym_SEMI] = ACTIONS(1360),
    [anon_sym___extension__] = ACTIONS(1358),
    [anon_sym_typedef] = ACTIONS(1358),
    [anon_sym_extern] = ACTIONS(1358),
    [anon_sym___attribute__] = ACTIONS(1358),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1360),
    [anon_sym___declspec] = ACTIONS(1358),
    [anon_sym___cdecl] = ACTIONS(1358),
    [anon_sym___clrcall] = ACTIONS(1358),
    [anon_sym___stdcall] = ACTIONS(1358),
    [anon_sym___fastcall] = ACTIONS(1358),
    [anon_sym___thiscall] = ACTIONS(1358),
    [anon_sym___vectorcall] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_signed] = ACTIONS(1358),
    [anon_sym_unsigned] = ACTIONS(1358),
    [anon_sym_long] = ACTIONS(1358),
    [anon_sym_short] = ACTIONS(1358),
    [anon_sym_static] = ACTIONS(1358),
    [anon_sym_auto] = ACTIONS(1358),
    [anon_sym_register] = ACTIONS(1358),
    [anon_sym_inline] = ACTIONS(1358),
    [anon_sym___inline] = ACTIONS(1358),
    [anon_sym___inline__] = ACTIONS(1358),
    [anon_sym___forceinline] = ACTIONS(1358),
    [anon_sym_thread_local] = ACTIONS(1358),
    [anon_sym___thread] = ACTIONS(1358),
    [anon_sym_const] = ACTIONS(1358),
    [anon_sym_constexpr] = ACTIONS(1358),
    [anon_sym_volatile] = ACTIONS(1358),
    [anon_sym_restrict] = ACTIONS(1358),
    [anon_sym___restrict__] = ACTIONS(1358),
    [anon_sym__Atomic] = ACTIONS(1358),
    [anon_sym__Noreturn] = ACTIONS(1358),
    [anon_sym_noreturn] = ACTIONS(1358),
    [sym_primitive_type] = ACTIONS(1358),
    [anon_sym_enum] = ACTIONS(1358),
    [anon_sym_struct] = ACTIONS(1358),
    [anon_sym_union] = ACTIONS(1358),
    [anon_sym_if] = ACTIONS(1358),
    [anon_sym_else] = ACTIONS(1358),
    [anon_sym_switch] = ACTIONS(1358),
    [anon_sym_case] = ACTIONS(1358),
    [anon_sym_default] = ACTIONS(1358),
    [anon_sym_while] = ACTIONS(1358),
    [anon_sym_do] = ACTIONS(1358),
    [anon_sym_for] = ACTIONS(1358),
    [anon_sym_return] = ACTIONS(1358),
    [anon_sym_break] = ACTIONS(1358),
    [anon_sym_continue] = ACTIONS(1358),
    [anon_sym_goto] = ACTIONS(1358),
    [anon_sym___try] = ACTIONS(1358),
    [anon_sym___leave] = ACTIONS(1358),
    [anon_sym_DASH_DASH] = ACTIONS(1360),
    [anon_sym_PLUS_PLUS] = ACTIONS(1360),
    [anon_sym_sizeof] = ACTIONS(1358),
    [anon_sym___alignof__] = ACTIONS(1358),
    [anon_sym___alignof] = ACTIONS(1358),
    [anon_sym__alignof] = ACTIONS(1358),
    [anon_sym_alignof] = ACTIONS(1358),
    [anon_sym__Alignof] = ACTIONS(1358),
    [anon_sym_offsetof] = ACTIONS(1358),
    [anon_sym__Generic] = ACTIONS(1358),
    [anon_sym_asm] = ACTIONS(1358),
    [anon_sym___asm__] = ACTIONS(1358),
    [sym_number_literal] = ACTIONS(1360),
    [anon_sym_L_SQUOTE] = ACTIONS(1360),
    [anon_sym_u_SQUOTE] = ACTIONS(1360),
    [anon_sym_U_SQUOTE] = ACTIONS(1360),
    [anon_sym_u8_SQUOTE] = ACTIONS(1360),
    [anon_sym_SQUOTE] = ACTIONS(1360),
    [anon_sym_L_DQUOTE] = ACTIONS(1360),
    [anon_sym_u_DQUOTE] = ACTIONS(1360),
    [anon_sym_U_DQUOTE] = ACTIONS(1360),
    [anon_sym_u8_DQUOTE] = ACTIONS(1360),
    [anon_sym_DQUOTE] = ACTIONS(1360),
    [sym_true] = ACTIONS(1358),
    [sym_false] = ACTIONS(1358),
    [anon_sym_NULL] = ACTIONS(1358),
    [anon_sym_nullptr] = ACTIONS(1358),
    [sym_comment] = ACTIONS(3),
  },
  [110] = {
    [sym_identifier] = ACTIONS(1362),
    [aux_sym_preproc_include_token1] = ACTIONS(1362),
    [aux_sym_preproc_def_token1] = ACTIONS(1362),
    [aux_sym_preproc_if_token1] = ACTIONS(1362),
    [aux_sym_preproc_if_token2] = ACTIONS(1362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1362),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1362),
    [aux_sym_preproc_else_token1] = ACTIONS(1362),
    [aux_sym_preproc_elif_token1] = ACTIONS(1362),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1362),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1362),
    [sym_preproc_directive] = ACTIONS(1362),
    [anon_sym_LPAREN2] = ACTIONS(1364),
    [anon_sym_BANG] = ACTIONS(1364),
    [anon_sym_TILDE] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_STAR] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_SEMI] = ACTIONS(1364),
    [anon_sym___extension__] = ACTIONS(1362),
    [anon_sym_typedef] = ACTIONS(1362),
    [anon_sym_extern] = ACTIONS(1362),
    [anon_sym___attribute__] = ACTIONS(1362),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1364),
    [anon_sym___declspec] = ACTIONS(1362),
    [anon_sym___cdecl] = ACTIONS(1362),
    [anon_sym___clrcall] = ACTIONS(1362),
    [anon_sym___stdcall] = ACTIONS(1362),
    [anon_sym___fastcall] = ACTIONS(1362),
    [anon_sym___thiscall] = ACTIONS(1362),
    [anon_sym___vectorcall] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(1364),
    [anon_sym_signed] = ACTIONS(1362),
    [anon_sym_unsigned] = ACTIONS(1362),
    [anon_sym_long] = ACTIONS(1362),
    [anon_sym_short] = ACTIONS(1362),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_auto] = ACTIONS(1362),
    [anon_sym_register] = ACTIONS(1362),
    [anon_sym_inline] = ACTIONS(1362),
    [anon_sym___inline] = ACTIONS(1362),
    [anon_sym___inline__] = ACTIONS(1362),
    [anon_sym___forceinline] = ACTIONS(1362),
    [anon_sym_thread_local] = ACTIONS(1362),
    [anon_sym___thread] = ACTIONS(1362),
    [anon_sym_const] = ACTIONS(1362),
    [anon_sym_constexpr] = ACTIONS(1362),
    [anon_sym_volatile] = ACTIONS(1362),
    [anon_sym_restrict] = ACTIONS(1362),
    [anon_sym___restrict__] = ACTIONS(1362),
    [anon_sym__Atomic] = ACTIONS(1362),
    [anon_sym__Noreturn] = ACTIONS(1362),
    [anon_sym_noreturn] = ACTIONS(1362),
    [sym_primitive_type] = ACTIONS(1362),
    [anon_sym_enum] = ACTIONS(1362),
    [anon_sym_struct] = ACTIONS(1362),
    [anon_sym_union] = ACTIONS(1362),
    [anon_sym_if] = ACTIONS(1362),
    [anon_sym_else] = ACTIONS(1362),
    [anon_sym_switch] = ACTIONS(1362),
    [anon_sym_case] = ACTIONS(1362),
    [anon_sym_default] = ACTIONS(1362),
    [anon_sym_while] = ACTIONS(1362),
    [anon_sym_do] = ACTIONS(1362),
    [anon_sym_for] = ACTIONS(1362),
    [anon_sym_return] = ACTIONS(1362),
    [anon_sym_break] = ACTIONS(1362),
    [anon_sym_continue] = ACTIONS(1362),
    [anon_sym_goto] = ACTIONS(1362),
    [anon_sym___try] = ACTIONS(1362),
    [anon_sym___leave] = ACTIONS(1362),
    [anon_sym_DASH_DASH] = ACTIONS(1364),
    [anon_sym_PLUS_PLUS] = ACTIONS(1364),
    [anon_sym_sizeof] = ACTIONS(1362),
    [anon_sym___alignof__] = ACTIONS(1362),
    [anon_sym___alignof] = ACTIONS(1362),
    [anon_sym__alignof] = ACTIONS(1362),
    [anon_sym_alignof] = ACTIONS(1362),
    [anon_sym__Alignof] = ACTIONS(1362),
    [anon_sym_offsetof] = ACTIONS(1362),
    [anon_sym__Generic] = ACTIONS(1362),
    [anon_sym_asm] = ACTIONS(1362),
    [anon_sym___asm__] = ACTIONS(1362),
    [sym_number_literal] = ACTIONS(1364),
    [anon_sym_L_SQUOTE] = ACTIONS(1364),
    [anon_sym_u_SQUOTE] = ACTIONS(1364),
    [anon_sym_U_SQUOTE] = ACTIONS(1364),
    [anon_sym_u8_SQUOTE] = ACTIONS(1364),
    [anon_sym_SQUOTE] = ACTIONS(1364),
    [anon_sym_L_DQUOTE] = ACTIONS(1364),
    [anon_sym_u_DQUOTE] = ACTIONS(1364),
    [anon_sym_U_DQUOTE] = ACTIONS(1364),
    [anon_sym_u8_DQUOTE] = ACTIONS(1364),
    [anon_sym_DQUOTE] = ACTIONS(1364),
    [sym_true] = ACTIONS(1362),
    [sym_false] = ACTIONS(1362),
    [anon_sym_NULL] = ACTIONS(1362),
    [anon_sym_nullptr] = ACTIONS(1362),
    [sym_comment] = ACTIONS(3),
  },
  [111] = {
    [sym_identifier] = ACTIONS(1366),
    [aux_sym_preproc_include_token1] = ACTIONS(1366),
    [aux_sym_preproc_def_token1] = ACTIONS(1366),
    [aux_sym_preproc_if_token1] = ACTIONS(1366),
    [aux_sym_preproc_if_token2] = ACTIONS(1366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1366),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1366),
    [aux_sym_preproc_else_token1] = ACTIONS(1366),
    [aux_sym_preproc_elif_token1] = ACTIONS(1366),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1366),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1366),
    [sym_preproc_directive] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_BANG] = ACTIONS(1368),
    [anon_sym_TILDE] = ACTIONS(1368),
    [anon_sym_DASH] = ACTIONS(1366),
    [anon_sym_PLUS] = ACTIONS(1366),
    [anon_sym_STAR] = ACTIONS(1368),
    [anon_sym_AMP] = ACTIONS(1368),
    [anon_sym_SEMI] = ACTIONS(1368),
    [anon_sym___extension__] = ACTIONS(1366),
    [anon_sym_typedef] = ACTIONS(1366),
    [anon_sym_extern] = ACTIONS(1366),
    [anon_sym___attribute__] = ACTIONS(1366),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1368),
    [anon_sym___declspec] = ACTIONS(1366),
    [anon_sym___cdecl] = ACTIONS(1366),
    [anon_sym___clrcall] = ACTIONS(1366),
    [anon_sym___stdcall] = ACTIONS(1366),
    [anon_sym___fastcall] = ACTIONS(1366),
    [anon_sym___thiscall] = ACTIONS(1366),
    [anon_sym___vectorcall] = ACTIONS(1366),
    [anon_sym_LBRACE] = ACTIONS(1368),
    [anon_sym_signed] = ACTIONS(1366),
    [anon_sym_unsigned] = ACTIONS(1366),
    [anon_sym_long] = ACTIONS(1366),
    [anon_sym_short] = ACTIONS(1366),
    [anon_sym_static] = ACTIONS(1366),
    [anon_sym_auto] = ACTIONS(1366),
    [anon_sym_register] = ACTIONS(1366),
    [anon_sym_inline] = ACTIONS(1366),
    [anon_sym___inline] = ACTIONS(1366),
    [anon_sym___inline__] = ACTIONS(1366),
    [anon_sym___forceinline] = ACTIONS(1366),
    [anon_sym_thread_local] = ACTIONS(1366),
    [anon_sym___thread] = ACTIONS(1366),
    [anon_sym_const] = ACTIONS(1366),
    [anon_sym_constexpr] = ACTIONS(1366),
    [anon_sym_volatile] = ACTIONS(1366),
    [anon_sym_restrict] = ACTIONS(1366),
    [anon_sym___restrict__] = ACTIONS(1366),
    [anon_sym__Atomic] = ACTIONS(1366),
    [anon_sym__Noreturn] = ACTIONS(1366),
    [anon_sym_noreturn] = ACTIONS(1366),
    [sym_primitive_type] = ACTIONS(1366),
    [anon_sym_enum] = ACTIONS(1366),
    [anon_sym_struct] = ACTIONS(1366),
    [anon_sym_union] = ACTIONS(1366),
    [anon_sym_if] = ACTIONS(1366),
    [anon_sym_else] = ACTIONS(1366),
    [anon_sym_switch] = ACTIONS(1366),
    [anon_sym_case] = ACTIONS(1366),
    [anon_sym_default] = ACTIONS(1366),
    [anon_sym_while] = ACTIONS(1366),
    [anon_sym_do] = ACTIONS(1366),
    [anon_sym_for] = ACTIONS(1366),
    [anon_sym_return] = ACTIONS(1366),
    [anon_sym_break] = ACTIONS(1366),
    [anon_sym_continue] = ACTIONS(1366),
    [anon_sym_goto] = ACTIONS(1366),
    [anon_sym___try] = ACTIONS(1366),
    [anon_sym___leave] = ACTIONS(1366),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_sizeof] = ACTIONS(1366),
    [anon_sym___alignof__] = ACTIONS(1366),
    [anon_sym___alignof] = ACTIONS(1366),
    [anon_sym__alignof] = ACTIONS(1366),
    [anon_sym_alignof] = ACTIONS(1366),
    [anon_sym__Alignof] = ACTIONS(1366),
    [anon_sym_offsetof] = ACTIONS(1366),
    [anon_sym__Generic] = ACTIONS(1366),
    [anon_sym_asm] = ACTIONS(1366),
    [anon_sym___asm__] = ACTIONS(1366),
    [sym_number_literal] = ACTIONS(1368),
    [anon_sym_L_SQUOTE] = ACTIONS(1368),
    [anon_sym_u_SQUOTE] = ACTIONS(1368),
    [anon_sym_U_SQUOTE] = ACTIONS(1368),
    [anon_sym_u8_SQUOTE] = ACTIONS(1368),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_L_DQUOTE] = ACTIONS(1368),
    [anon_sym_u_DQUOTE] = ACTIONS(1368),
    [anon_sym_U_DQUOTE] = ACTIONS(1368),
    [anon_sym_u8_DQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [sym_true] = ACTIONS(1366),
    [sym_false] = ACTIONS(1366),
    [anon_sym_NULL] = ACTIONS(1366),
    [anon_sym_nullptr] = ACTIONS(1366),
    [sym_comment] = ACTIONS(3),
  },
  [112] = {
    [sym_identifier] = ACTIONS(1370),
    [aux_sym_preproc_include_token1] = ACTIONS(1370),
    [aux_sym_preproc_def_token1] = ACTIONS(1370),
    [aux_sym_preproc_if_token1] = ACTIONS(1370),
    [aux_sym_preproc_if_token2] = ACTIONS(1370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1370),
    [aux_sym_preproc_else_token1] = ACTIONS(1370),
    [aux_sym_preproc_elif_token1] = ACTIONS(1370),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1370),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1370),
    [sym_preproc_directive] = ACTIONS(1370),
    [anon_sym_LPAREN2] = ACTIONS(1372),
    [anon_sym_BANG] = ACTIONS(1372),
    [anon_sym_TILDE] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_STAR] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1372),
    [anon_sym___extension__] = ACTIONS(1370),
    [anon_sym_typedef] = ACTIONS(1370),
    [anon_sym_extern] = ACTIONS(1370),
    [anon_sym___attribute__] = ACTIONS(1370),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1372),
    [anon_sym___declspec] = ACTIONS(1370),
    [anon_sym___cdecl] = ACTIONS(1370),
    [anon_sym___clrcall] = ACTIONS(1370),
    [anon_sym___stdcall] = ACTIONS(1370),
    [anon_sym___fastcall] = ACTIONS(1370),
    [anon_sym___thiscall] = ACTIONS(1370),
    [anon_sym___vectorcall] = ACTIONS(1370),
    [anon_sym_LBRACE] = ACTIONS(1372),
    [anon_sym_signed] = ACTIONS(1370),
    [anon_sym_unsigned] = ACTIONS(1370),
    [anon_sym_long] = ACTIONS(1370),
    [anon_sym_short] = ACTIONS(1370),
    [anon_sym_static] = ACTIONS(1370),
    [anon_sym_auto] = ACTIONS(1370),
    [anon_sym_register] = ACTIONS(1370),
    [anon_sym_inline] = ACTIONS(1370),
    [anon_sym___inline] = ACTIONS(1370),
    [anon_sym___inline__] = ACTIONS(1370),
    [anon_sym___forceinline] = ACTIONS(1370),
    [anon_sym_thread_local] = ACTIONS(1370),
    [anon_sym___thread] = ACTIONS(1370),
    [anon_sym_const] = ACTIONS(1370),
    [anon_sym_constexpr] = ACTIONS(1370),
    [anon_sym_volatile] = ACTIONS(1370),
    [anon_sym_restrict] = ACTIONS(1370),
    [anon_sym___restrict__] = ACTIONS(1370),
    [anon_sym__Atomic] = ACTIONS(1370),
    [anon_sym__Noreturn] = ACTIONS(1370),
    [anon_sym_noreturn] = ACTIONS(1370),
    [sym_primitive_type] = ACTIONS(1370),
    [anon_sym_enum] = ACTIONS(1370),
    [anon_sym_struct] = ACTIONS(1370),
    [anon_sym_union] = ACTIONS(1370),
    [anon_sym_if] = ACTIONS(1370),
    [anon_sym_else] = ACTIONS(1370),
    [anon_sym_switch] = ACTIONS(1370),
    [anon_sym_case] = ACTIONS(1370),
    [anon_sym_default] = ACTIONS(1370),
    [anon_sym_while] = ACTIONS(1370),
    [anon_sym_do] = ACTIONS(1370),
    [anon_sym_for] = ACTIONS(1370),
    [anon_sym_return] = ACTIONS(1370),
    [anon_sym_break] = ACTIONS(1370),
    [anon_sym_continue] = ACTIONS(1370),
    [anon_sym_goto] = ACTIONS(1370),
    [anon_sym___try] = ACTIONS(1370),
    [anon_sym___leave] = ACTIONS(1370),
    [anon_sym_DASH_DASH] = ACTIONS(1372),
    [anon_sym_PLUS_PLUS] = ACTIONS(1372),
    [anon_sym_sizeof] = ACTIONS(1370),
    [anon_sym___alignof__] = ACTIONS(1370),
    [anon_sym___alignof] = ACTIONS(1370),
    [anon_sym__alignof] = ACTIONS(1370),
    [anon_sym_alignof] = ACTIONS(1370),
    [anon_sym__Alignof] = ACTIONS(1370),
    [anon_sym_offsetof] = ACTIONS(1370),
    [anon_sym__Generic] = ACTIONS(1370),
    [anon_sym_asm] = ACTIONS(1370),
    [anon_sym___asm__] = ACTIONS(1370),
    [sym_number_literal] = ACTIONS(1372),
    [anon_sym_L_SQUOTE] = ACTIONS(1372),
    [anon_sym_u_SQUOTE] = ACTIONS(1372),
    [anon_sym_U_SQUOTE] = ACTIONS(1372),
    [anon_sym_u8_SQUOTE] = ACTIONS(1372),
    [anon_sym_SQUOTE] = ACTIONS(1372),
    [anon_sym_L_DQUOTE] = ACTIONS(1372),
    [anon_sym_u_DQUOTE] = ACTIONS(1372),
    [anon_sym_U_DQUOTE] = ACTIONS(1372),
    [anon_sym_u8_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1372),
    [sym_true] = ACTIONS(1370),
    [sym_false] = ACTIONS(1370),
    [anon_sym_NULL] = ACTIONS(1370),
    [anon_sym_nullptr] = ACTIONS(1370),
    [sym_comment] = ACTIONS(3),
  },
  [113] = {
    [sym_identifier] = ACTIONS(1374),
    [aux_sym_preproc_include_token1] = ACTIONS(1374),
    [aux_sym_preproc_def_token1] = ACTIONS(1374),
    [aux_sym_preproc_if_token1] = ACTIONS(1374),
    [aux_sym_preproc_if_token2] = ACTIONS(1374),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1374),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1374),
    [aux_sym_preproc_else_token1] = ACTIONS(1374),
    [aux_sym_preproc_elif_token1] = ACTIONS(1374),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1374),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1374),
    [sym_preproc_directive] = ACTIONS(1374),
    [anon_sym_LPAREN2] = ACTIONS(1376),
    [anon_sym_BANG] = ACTIONS(1376),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_DASH] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1374),
    [anon_sym_STAR] = ACTIONS(1376),
    [anon_sym_AMP] = ACTIONS(1376),
    [anon_sym_SEMI] = ACTIONS(1376),
    [anon_sym___extension__] = ACTIONS(1374),
    [anon_sym_typedef] = ACTIONS(1374),
    [anon_sym_extern] = ACTIONS(1374),
    [anon_sym___attribute__] = ACTIONS(1374),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1376),
    [anon_sym___declspec] = ACTIONS(1374),
    [anon_sym___cdecl] = ACTIONS(1374),
    [anon_sym___clrcall] = ACTIONS(1374),
    [anon_sym___stdcall] = ACTIONS(1374),
    [anon_sym___fastcall] = ACTIONS(1374),
    [anon_sym___thiscall] = ACTIONS(1374),
    [anon_sym___vectorcall] = ACTIONS(1374),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_signed] = ACTIONS(1374),
    [anon_sym_unsigned] = ACTIONS(1374),
    [anon_sym_long] = ACTIONS(1374),
    [anon_sym_short] = ACTIONS(1374),
    [anon_sym_static] = ACTIONS(1374),
    [anon_sym_auto] = ACTIONS(1374),
    [anon_sym_register] = ACTIONS(1374),
    [anon_sym_inline] = ACTIONS(1374),
    [anon_sym___inline] = ACTIONS(1374),
    [anon_sym___inline__] = ACTIONS(1374),
    [anon_sym___forceinline] = ACTIONS(1374),
    [anon_sym_thread_local] = ACTIONS(1374),
    [anon_sym___thread] = ACTIONS(1374),
    [anon_sym_const] = ACTIONS(1374),
    [anon_sym_constexpr] = ACTIONS(1374),
    [anon_sym_volatile] = ACTIONS(1374),
    [anon_sym_restrict] = ACTIONS(1374),
    [anon_sym___restrict__] = ACTIONS(1374),
    [anon_sym__Atomic] = ACTIONS(1374),
    [anon_sym__Noreturn] = ACTIONS(1374),
    [anon_sym_noreturn] = ACTIONS(1374),
    [sym_primitive_type] = ACTIONS(1374),
    [anon_sym_enum] = ACTIONS(1374),
    [anon_sym_struct] = ACTIONS(1374),
    [anon_sym_union] = ACTIONS(1374),
    [anon_sym_if] = ACTIONS(1374),
    [anon_sym_else] = ACTIONS(1374),
    [anon_sym_switch] = ACTIONS(1374),
    [anon_sym_case] = ACTIONS(1374),
    [anon_sym_default] = ACTIONS(1374),
    [anon_sym_while] = ACTIONS(1374),
    [anon_sym_do] = ACTIONS(1374),
    [anon_sym_for] = ACTIONS(1374),
    [anon_sym_return] = ACTIONS(1374),
    [anon_sym_break] = ACTIONS(1374),
    [anon_sym_continue] = ACTIONS(1374),
    [anon_sym_goto] = ACTIONS(1374),
    [anon_sym___try] = ACTIONS(1374),
    [anon_sym___leave] = ACTIONS(1374),
    [anon_sym_DASH_DASH] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1376),
    [anon_sym_sizeof] = ACTIONS(1374),
    [anon_sym___alignof__] = ACTIONS(1374),
    [anon_sym___alignof] = ACTIONS(1374),
    [anon_sym__alignof] = ACTIONS(1374),
    [anon_sym_alignof] = ACTIONS(1374),
    [anon_sym__Alignof] = ACTIONS(1374),
    [anon_sym_offsetof] = ACTIONS(1374),
    [anon_sym__Generic] = ACTIONS(1374),
    [anon_sym_asm] = ACTIONS(1374),
    [anon_sym___asm__] = ACTIONS(1374),
    [sym_number_literal] = ACTIONS(1376),
    [anon_sym_L_SQUOTE] = ACTIONS(1376),
    [anon_sym_u_SQUOTE] = ACTIONS(1376),
    [anon_sym_U_SQUOTE] = ACTIONS(1376),
    [anon_sym_u8_SQUOTE] = ACTIONS(1376),
    [anon_sym_SQUOTE] = ACTIONS(1376),
    [anon_sym_L_DQUOTE] = ACTIONS(1376),
    [anon_sym_u_DQUOTE] = ACTIONS(1376),
    [anon_sym_U_DQUOTE] = ACTIONS(1376),
    [anon_sym_u8_DQUOTE] = ACTIONS(1376),
    [anon_sym_DQUOTE] = ACTIONS(1376),
    [sym_true] = ACTIONS(1374),
    [sym_false] = ACTIONS(1374),
    [anon_sym_NULL] = ACTIONS(1374),
    [anon_sym_nullptr] = ACTIONS(1374),
    [sym_comment] = ACTIONS(3),
  },
  [114] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [115] = {
    [sym_identifier] = ACTIONS(1378),
    [aux_sym_preproc_include_token1] = ACTIONS(1378),
    [aux_sym_preproc_def_token1] = ACTIONS(1378),
    [aux_sym_preproc_if_token1] = ACTIONS(1378),
    [aux_sym_preproc_if_token2] = ACTIONS(1378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1378),
    [aux_sym_preproc_else_token1] = ACTIONS(1378),
    [aux_sym_preproc_elif_token1] = ACTIONS(1378),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1378),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1378),
    [sym_preproc_directive] = ACTIONS(1378),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_BANG] = ACTIONS(1380),
    [anon_sym_TILDE] = ACTIONS(1380),
    [anon_sym_DASH] = ACTIONS(1378),
    [anon_sym_PLUS] = ACTIONS(1378),
    [anon_sym_STAR] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym___extension__] = ACTIONS(1378),
    [anon_sym_typedef] = ACTIONS(1378),
    [anon_sym_extern] = ACTIONS(1378),
    [anon_sym___attribute__] = ACTIONS(1378),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1380),
    [anon_sym___declspec] = ACTIONS(1378),
    [anon_sym___cdecl] = ACTIONS(1378),
    [anon_sym___clrcall] = ACTIONS(1378),
    [anon_sym___stdcall] = ACTIONS(1378),
    [anon_sym___fastcall] = ACTIONS(1378),
    [anon_sym___thiscall] = ACTIONS(1378),
    [anon_sym___vectorcall] = ACTIONS(1378),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_signed] = ACTIONS(1378),
    [anon_sym_unsigned] = ACTIONS(1378),
    [anon_sym_long] = ACTIONS(1378),
    [anon_sym_short] = ACTIONS(1378),
    [anon_sym_static] = ACTIONS(1378),
    [anon_sym_auto] = ACTIONS(1378),
    [anon_sym_register] = ACTIONS(1378),
    [anon_sym_inline] = ACTIONS(1378),
    [anon_sym___inline] = ACTIONS(1378),
    [anon_sym___inline__] = ACTIONS(1378),
    [anon_sym___forceinline] = ACTIONS(1378),
    [anon_sym_thread_local] = ACTIONS(1378),
    [anon_sym___thread] = ACTIONS(1378),
    [anon_sym_const] = ACTIONS(1378),
    [anon_sym_constexpr] = ACTIONS(1378),
    [anon_sym_volatile] = ACTIONS(1378),
    [anon_sym_restrict] = ACTIONS(1378),
    [anon_sym___restrict__] = ACTIONS(1378),
    [anon_sym__Atomic] = ACTIONS(1378),
    [anon_sym__Noreturn] = ACTIONS(1378),
    [anon_sym_noreturn] = ACTIONS(1378),
    [sym_primitive_type] = ACTIONS(1378),
    [anon_sym_enum] = ACTIONS(1378),
    [anon_sym_struct] = ACTIONS(1378),
    [anon_sym_union] = ACTIONS(1378),
    [anon_sym_if] = ACTIONS(1378),
    [anon_sym_else] = ACTIONS(1378),
    [anon_sym_switch] = ACTIONS(1378),
    [anon_sym_case] = ACTIONS(1378),
    [anon_sym_default] = ACTIONS(1378),
    [anon_sym_while] = ACTIONS(1378),
    [anon_sym_do] = ACTIONS(1378),
    [anon_sym_for] = ACTIONS(1378),
    [anon_sym_return] = ACTIONS(1378),
    [anon_sym_break] = ACTIONS(1378),
    [anon_sym_continue] = ACTIONS(1378),
    [anon_sym_goto] = ACTIONS(1378),
    [anon_sym___try] = ACTIONS(1378),
    [anon_sym___leave] = ACTIONS(1378),
    [anon_sym_DASH_DASH] = ACTIONS(1380),
    [anon_sym_PLUS_PLUS] = ACTIONS(1380),
    [anon_sym_sizeof] = ACTIONS(1378),
    [anon_sym___alignof__] = ACTIONS(1378),
    [anon_sym___alignof] = ACTIONS(1378),
    [anon_sym__alignof] = ACTIONS(1378),
    [anon_sym_alignof] = ACTIONS(1378),
    [anon_sym__Alignof] = ACTIONS(1378),
    [anon_sym_offsetof] = ACTIONS(1378),
    [anon_sym__Generic] = ACTIONS(1378),
    [anon_sym_asm] = ACTIONS(1378),
    [anon_sym___asm__] = ACTIONS(1378),
    [sym_number_literal] = ACTIONS(1380),
    [anon_sym_L_SQUOTE] = ACTIONS(1380),
    [anon_sym_u_SQUOTE] = ACTIONS(1380),
    [anon_sym_U_SQUOTE] = ACTIONS(1380),
    [anon_sym_u8_SQUOTE] = ACTIONS(1380),
    [anon_sym_SQUOTE] = ACTIONS(1380),
    [anon_sym_L_DQUOTE] = ACTIONS(1380),
    [anon_sym_u_DQUOTE] = ACTIONS(1380),
    [anon_sym_U_DQUOTE] = ACTIONS(1380),
    [anon_sym_u8_DQUOTE] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [anon_sym_NULL] = ACTIONS(1378),
    [anon_sym_nullptr] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
  },
  [116] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [117] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [118] = {
    [sym_identifier] = ACTIONS(1378),
    [aux_sym_preproc_include_token1] = ACTIONS(1378),
    [aux_sym_preproc_def_token1] = ACTIONS(1378),
    [aux_sym_preproc_if_token1] = ACTIONS(1378),
    [aux_sym_preproc_if_token2] = ACTIONS(1378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1378),
    [aux_sym_preproc_else_token1] = ACTIONS(1378),
    [aux_sym_preproc_elif_token1] = ACTIONS(1378),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1378),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1378),
    [sym_preproc_directive] = ACTIONS(1378),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_BANG] = ACTIONS(1380),
    [anon_sym_TILDE] = ACTIONS(1380),
    [anon_sym_DASH] = ACTIONS(1378),
    [anon_sym_PLUS] = ACTIONS(1378),
    [anon_sym_STAR] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym___extension__] = ACTIONS(1378),
    [anon_sym_typedef] = ACTIONS(1378),
    [anon_sym_extern] = ACTIONS(1378),
    [anon_sym___attribute__] = ACTIONS(1378),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1380),
    [anon_sym___declspec] = ACTIONS(1378),
    [anon_sym___cdecl] = ACTIONS(1378),
    [anon_sym___clrcall] = ACTIONS(1378),
    [anon_sym___stdcall] = ACTIONS(1378),
    [anon_sym___fastcall] = ACTIONS(1378),
    [anon_sym___thiscall] = ACTIONS(1378),
    [anon_sym___vectorcall] = ACTIONS(1378),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_signed] = ACTIONS(1378),
    [anon_sym_unsigned] = ACTIONS(1378),
    [anon_sym_long] = ACTIONS(1378),
    [anon_sym_short] = ACTIONS(1378),
    [anon_sym_static] = ACTIONS(1378),
    [anon_sym_auto] = ACTIONS(1378),
    [anon_sym_register] = ACTIONS(1378),
    [anon_sym_inline] = ACTIONS(1378),
    [anon_sym___inline] = ACTIONS(1378),
    [anon_sym___inline__] = ACTIONS(1378),
    [anon_sym___forceinline] = ACTIONS(1378),
    [anon_sym_thread_local] = ACTIONS(1378),
    [anon_sym___thread] = ACTIONS(1378),
    [anon_sym_const] = ACTIONS(1378),
    [anon_sym_constexpr] = ACTIONS(1378),
    [anon_sym_volatile] = ACTIONS(1378),
    [anon_sym_restrict] = ACTIONS(1378),
    [anon_sym___restrict__] = ACTIONS(1378),
    [anon_sym__Atomic] = ACTIONS(1378),
    [anon_sym__Noreturn] = ACTIONS(1378),
    [anon_sym_noreturn] = ACTIONS(1378),
    [sym_primitive_type] = ACTIONS(1378),
    [anon_sym_enum] = ACTIONS(1378),
    [anon_sym_struct] = ACTIONS(1378),
    [anon_sym_union] = ACTIONS(1378),
    [anon_sym_if] = ACTIONS(1378),
    [anon_sym_else] = ACTIONS(1378),
    [anon_sym_switch] = ACTIONS(1378),
    [anon_sym_case] = ACTIONS(1378),
    [anon_sym_default] = ACTIONS(1378),
    [anon_sym_while] = ACTIONS(1378),
    [anon_sym_do] = ACTIONS(1378),
    [anon_sym_for] = ACTIONS(1378),
    [anon_sym_return] = ACTIONS(1378),
    [anon_sym_break] = ACTIONS(1378),
    [anon_sym_continue] = ACTIONS(1378),
    [anon_sym_goto] = ACTIONS(1378),
    [anon_sym___try] = ACTIONS(1378),
    [anon_sym___leave] = ACTIONS(1378),
    [anon_sym_DASH_DASH] = ACTIONS(1380),
    [anon_sym_PLUS_PLUS] = ACTIONS(1380),
    [anon_sym_sizeof] = ACTIONS(1378),
    [anon_sym___alignof__] = ACTIONS(1378),
    [anon_sym___alignof] = ACTIONS(1378),
    [anon_sym__alignof] = ACTIONS(1378),
    [anon_sym_alignof] = ACTIONS(1378),
    [anon_sym__Alignof] = ACTIONS(1378),
    [anon_sym_offsetof] = ACTIONS(1378),
    [anon_sym__Generic] = ACTIONS(1378),
    [anon_sym_asm] = ACTIONS(1378),
    [anon_sym___asm__] = ACTIONS(1378),
    [sym_number_literal] = ACTIONS(1380),
    [anon_sym_L_SQUOTE] = ACTIONS(1380),
    [anon_sym_u_SQUOTE] = ACTIONS(1380),
    [anon_sym_U_SQUOTE] = ACTIONS(1380),
    [anon_sym_u8_SQUOTE] = ACTIONS(1380),
    [anon_sym_SQUOTE] = ACTIONS(1380),
    [anon_sym_L_DQUOTE] = ACTIONS(1380),
    [anon_sym_u_DQUOTE] = ACTIONS(1380),
    [anon_sym_U_DQUOTE] = ACTIONS(1380),
    [anon_sym_u8_DQUOTE] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [anon_sym_NULL] = ACTIONS(1378),
    [anon_sym_nullptr] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
  },
  [119] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [120] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [121] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [122] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [123] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [124] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [125] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [126] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [127] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [128] = {
    [sym_identifier] = ACTIONS(1382),
    [aux_sym_preproc_include_token1] = ACTIONS(1382),
    [aux_sym_preproc_def_token1] = ACTIONS(1382),
    [aux_sym_preproc_if_token1] = ACTIONS(1382),
    [aux_sym_preproc_if_token2] = ACTIONS(1382),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1382),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1382),
    [aux_sym_preproc_else_token1] = ACTIONS(1382),
    [aux_sym_preproc_elif_token1] = ACTIONS(1382),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1382),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1382),
    [sym_preproc_directive] = ACTIONS(1382),
    [anon_sym_LPAREN2] = ACTIONS(1384),
    [anon_sym_BANG] = ACTIONS(1384),
    [anon_sym_TILDE] = ACTIONS(1384),
    [anon_sym_DASH] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1382),
    [anon_sym_STAR] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym___extension__] = ACTIONS(1382),
    [anon_sym_typedef] = ACTIONS(1382),
    [anon_sym_extern] = ACTIONS(1382),
    [anon_sym___attribute__] = ACTIONS(1382),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1384),
    [anon_sym___declspec] = ACTIONS(1382),
    [anon_sym___cdecl] = ACTIONS(1382),
    [anon_sym___clrcall] = ACTIONS(1382),
    [anon_sym___stdcall] = ACTIONS(1382),
    [anon_sym___fastcall] = ACTIONS(1382),
    [anon_sym___thiscall] = ACTIONS(1382),
    [anon_sym___vectorcall] = ACTIONS(1382),
    [anon_sym_LBRACE] = ACTIONS(1384),
    [anon_sym_signed] = ACTIONS(1382),
    [anon_sym_unsigned] = ACTIONS(1382),
    [anon_sym_long] = ACTIONS(1382),
    [anon_sym_short] = ACTIONS(1382),
    [anon_sym_static] = ACTIONS(1382),
    [anon_sym_auto] = ACTIONS(1382),
    [anon_sym_register] = ACTIONS(1382),
    [anon_sym_inline] = ACTIONS(1382),
    [anon_sym___inline] = ACTIONS(1382),
    [anon_sym___inline__] = ACTIONS(1382),
    [anon_sym___forceinline] = ACTIONS(1382),
    [anon_sym_thread_local] = ACTIONS(1382),
    [anon_sym___thread] = ACTIONS(1382),
    [anon_sym_const] = ACTIONS(1382),
    [anon_sym_constexpr] = ACTIONS(1382),
    [anon_sym_volatile] = ACTIONS(1382),
    [anon_sym_restrict] = ACTIONS(1382),
    [anon_sym___restrict__] = ACTIONS(1382),
    [anon_sym__Atomic] = ACTIONS(1382),
    [anon_sym__Noreturn] = ACTIONS(1382),
    [anon_sym_noreturn] = ACTIONS(1382),
    [sym_primitive_type] = ACTIONS(1382),
    [anon_sym_enum] = ACTIONS(1382),
    [anon_sym_struct] = ACTIONS(1382),
    [anon_sym_union] = ACTIONS(1382),
    [anon_sym_if] = ACTIONS(1382),
    [anon_sym_else] = ACTIONS(1382),
    [anon_sym_switch] = ACTIONS(1382),
    [anon_sym_case] = ACTIONS(1382),
    [anon_sym_default] = ACTIONS(1382),
    [anon_sym_while] = ACTIONS(1382),
    [anon_sym_do] = ACTIONS(1382),
    [anon_sym_for] = ACTIONS(1382),
    [anon_sym_return] = ACTIONS(1382),
    [anon_sym_break] = ACTIONS(1382),
    [anon_sym_continue] = ACTIONS(1382),
    [anon_sym_goto] = ACTIONS(1382),
    [anon_sym___try] = ACTIONS(1382),
    [anon_sym___leave] = ACTIONS(1382),
    [anon_sym_DASH_DASH] = ACTIONS(1384),
    [anon_sym_PLUS_PLUS] = ACTIONS(1384),
    [anon_sym_sizeof] = ACTIONS(1382),
    [anon_sym___alignof__] = ACTIONS(1382),
    [anon_sym___alignof] = ACTIONS(1382),
    [anon_sym__alignof] = ACTIONS(1382),
    [anon_sym_alignof] = ACTIONS(1382),
    [anon_sym__Alignof] = ACTIONS(1382),
    [anon_sym_offsetof] = ACTIONS(1382),
    [anon_sym__Generic] = ACTIONS(1382),
    [anon_sym_asm] = ACTIONS(1382),
    [anon_sym___asm__] = ACTIONS(1382),
    [sym_number_literal] = ACTIONS(1384),
    [anon_sym_L_SQUOTE] = ACTIONS(1384),
    [anon_sym_u_SQUOTE] = ACTIONS(1384),
    [anon_sym_U_SQUOTE] = ACTIONS(1384),
    [anon_sym_u8_SQUOTE] = ACTIONS(1384),
    [anon_sym_SQUOTE] = ACTIONS(1384),
    [anon_sym_L_DQUOTE] = ACTIONS(1384),
    [anon_sym_u_DQUOTE] = ACTIONS(1384),
    [anon_sym_U_DQUOTE] = ACTIONS(1384),
    [anon_sym_u8_DQUOTE] = ACTIONS(1384),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [sym_true] = ACTIONS(1382),
    [sym_false] = ACTIONS(1382),
    [anon_sym_NULL] = ACTIONS(1382),
    [anon_sym_nullptr] = ACTIONS(1382),
    [sym_comment] = ACTIONS(3),
  },
  [129] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [130] = {
    [sym_identifier] = ACTIONS(1386),
    [aux_sym_preproc_include_token1] = ACTIONS(1386),
    [aux_sym_preproc_def_token1] = ACTIONS(1386),
    [aux_sym_preproc_if_token1] = ACTIONS(1386),
    [aux_sym_preproc_if_token2] = ACTIONS(1386),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1386),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1386),
    [aux_sym_preproc_else_token1] = ACTIONS(1386),
    [aux_sym_preproc_elif_token1] = ACTIONS(1386),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1386),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1386),
    [sym_preproc_directive] = ACTIONS(1386),
    [anon_sym_LPAREN2] = ACTIONS(1388),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1388),
    [anon_sym_DASH] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(1386),
    [anon_sym_STAR] = ACTIONS(1388),
    [anon_sym_AMP] = ACTIONS(1388),
    [anon_sym_SEMI] = ACTIONS(1388),
    [anon_sym___extension__] = ACTIONS(1386),
    [anon_sym_typedef] = ACTIONS(1386),
    [anon_sym_extern] = ACTIONS(1386),
    [anon_sym___attribute__] = ACTIONS(1386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1388),
    [anon_sym___declspec] = ACTIONS(1386),
    [anon_sym___cdecl] = ACTIONS(1386),
    [anon_sym___clrcall] = ACTIONS(1386),
    [anon_sym___stdcall] = ACTIONS(1386),
    [anon_sym___fastcall] = ACTIONS(1386),
    [anon_sym___thiscall] = ACTIONS(1386),
    [anon_sym___vectorcall] = ACTIONS(1386),
    [anon_sym_LBRACE] = ACTIONS(1388),
    [anon_sym_signed] = ACTIONS(1386),
    [anon_sym_unsigned] = ACTIONS(1386),
    [anon_sym_long] = ACTIONS(1386),
    [anon_sym_short] = ACTIONS(1386),
    [anon_sym_static] = ACTIONS(1386),
    [anon_sym_auto] = ACTIONS(1386),
    [anon_sym_register] = ACTIONS(1386),
    [anon_sym_inline] = ACTIONS(1386),
    [anon_sym___inline] = ACTIONS(1386),
    [anon_sym___inline__] = ACTIONS(1386),
    [anon_sym___forceinline] = ACTIONS(1386),
    [anon_sym_thread_local] = ACTIONS(1386),
    [anon_sym___thread] = ACTIONS(1386),
    [anon_sym_const] = ACTIONS(1386),
    [anon_sym_constexpr] = ACTIONS(1386),
    [anon_sym_volatile] = ACTIONS(1386),
    [anon_sym_restrict] = ACTIONS(1386),
    [anon_sym___restrict__] = ACTIONS(1386),
    [anon_sym__Atomic] = ACTIONS(1386),
    [anon_sym__Noreturn] = ACTIONS(1386),
    [anon_sym_noreturn] = ACTIONS(1386),
    [sym_primitive_type] = ACTIONS(1386),
    [anon_sym_enum] = ACTIONS(1386),
    [anon_sym_struct] = ACTIONS(1386),
    [anon_sym_union] = ACTIONS(1386),
    [anon_sym_if] = ACTIONS(1386),
    [anon_sym_else] = ACTIONS(1386),
    [anon_sym_switch] = ACTIONS(1386),
    [anon_sym_case] = ACTIONS(1386),
    [anon_sym_default] = ACTIONS(1386),
    [anon_sym_while] = ACTIONS(1386),
    [anon_sym_do] = ACTIONS(1386),
    [anon_sym_for] = ACTIONS(1386),
    [anon_sym_return] = ACTIONS(1386),
    [anon_sym_break] = ACTIONS(1386),
    [anon_sym_continue] = ACTIONS(1386),
    [anon_sym_goto] = ACTIONS(1386),
    [anon_sym___try] = ACTIONS(1386),
    [anon_sym___leave] = ACTIONS(1386),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_sizeof] = ACTIONS(1386),
    [anon_sym___alignof__] = ACTIONS(1386),
    [anon_sym___alignof] = ACTIONS(1386),
    [anon_sym__alignof] = ACTIONS(1386),
    [anon_sym_alignof] = ACTIONS(1386),
    [anon_sym__Alignof] = ACTIONS(1386),
    [anon_sym_offsetof] = ACTIONS(1386),
    [anon_sym__Generic] = ACTIONS(1386),
    [anon_sym_asm] = ACTIONS(1386),
    [anon_sym___asm__] = ACTIONS(1386),
    [sym_number_literal] = ACTIONS(1388),
    [anon_sym_L_SQUOTE] = ACTIONS(1388),
    [anon_sym_u_SQUOTE] = ACTIONS(1388),
    [anon_sym_U_SQUOTE] = ACTIONS(1388),
    [anon_sym_u8_SQUOTE] = ACTIONS(1388),
    [anon_sym_SQUOTE] = ACTIONS(1388),
    [anon_sym_L_DQUOTE] = ACTIONS(1388),
    [anon_sym_u_DQUOTE] = ACTIONS(1388),
    [anon_sym_U_DQUOTE] = ACTIONS(1388),
    [anon_sym_u8_DQUOTE] = ACTIONS(1388),
    [anon_sym_DQUOTE] = ACTIONS(1388),
    [sym_true] = ACTIONS(1386),
    [sym_false] = ACTIONS(1386),
    [anon_sym_NULL] = ACTIONS(1386),
    [anon_sym_nullptr] = ACTIONS(1386),
    [sym_comment] = ACTIONS(3),
  },
  [131] = {
    [sym_identifier] = ACTIONS(1390),
    [aux_sym_preproc_include_token1] = ACTIONS(1390),
    [aux_sym_preproc_def_token1] = ACTIONS(1390),
    [aux_sym_preproc_if_token1] = ACTIONS(1390),
    [aux_sym_preproc_if_token2] = ACTIONS(1390),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1390),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1390),
    [aux_sym_preproc_else_token1] = ACTIONS(1390),
    [aux_sym_preproc_elif_token1] = ACTIONS(1390),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1390),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1390),
    [sym_preproc_directive] = ACTIONS(1390),
    [anon_sym_LPAREN2] = ACTIONS(1392),
    [anon_sym_BANG] = ACTIONS(1392),
    [anon_sym_TILDE] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_AMP] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1392),
    [anon_sym___extension__] = ACTIONS(1390),
    [anon_sym_typedef] = ACTIONS(1390),
    [anon_sym_extern] = ACTIONS(1390),
    [anon_sym___attribute__] = ACTIONS(1390),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1392),
    [anon_sym___declspec] = ACTIONS(1390),
    [anon_sym___cdecl] = ACTIONS(1390),
    [anon_sym___clrcall] = ACTIONS(1390),
    [anon_sym___stdcall] = ACTIONS(1390),
    [anon_sym___fastcall] = ACTIONS(1390),
    [anon_sym___thiscall] = ACTIONS(1390),
    [anon_sym___vectorcall] = ACTIONS(1390),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_signed] = ACTIONS(1390),
    [anon_sym_unsigned] = ACTIONS(1390),
    [anon_sym_long] = ACTIONS(1390),
    [anon_sym_short] = ACTIONS(1390),
    [anon_sym_static] = ACTIONS(1390),
    [anon_sym_auto] = ACTIONS(1390),
    [anon_sym_register] = ACTIONS(1390),
    [anon_sym_inline] = ACTIONS(1390),
    [anon_sym___inline] = ACTIONS(1390),
    [anon_sym___inline__] = ACTIONS(1390),
    [anon_sym___forceinline] = ACTIONS(1390),
    [anon_sym_thread_local] = ACTIONS(1390),
    [anon_sym___thread] = ACTIONS(1390),
    [anon_sym_const] = ACTIONS(1390),
    [anon_sym_constexpr] = ACTIONS(1390),
    [anon_sym_volatile] = ACTIONS(1390),
    [anon_sym_restrict] = ACTIONS(1390),
    [anon_sym___restrict__] = ACTIONS(1390),
    [anon_sym__Atomic] = ACTIONS(1390),
    [anon_sym__Noreturn] = ACTIONS(1390),
    [anon_sym_noreturn] = ACTIONS(1390),
    [sym_primitive_type] = ACTIONS(1390),
    [anon_sym_enum] = ACTIONS(1390),
    [anon_sym_struct] = ACTIONS(1390),
    [anon_sym_union] = ACTIONS(1390),
    [anon_sym_if] = ACTIONS(1390),
    [anon_sym_else] = ACTIONS(1390),
    [anon_sym_switch] = ACTIONS(1390),
    [anon_sym_case] = ACTIONS(1390),
    [anon_sym_default] = ACTIONS(1390),
    [anon_sym_while] = ACTIONS(1390),
    [anon_sym_do] = ACTIONS(1390),
    [anon_sym_for] = ACTIONS(1390),
    [anon_sym_return] = ACTIONS(1390),
    [anon_sym_break] = ACTIONS(1390),
    [anon_sym_continue] = ACTIONS(1390),
    [anon_sym_goto] = ACTIONS(1390),
    [anon_sym___try] = ACTIONS(1390),
    [anon_sym___leave] = ACTIONS(1390),
    [anon_sym_DASH_DASH] = ACTIONS(1392),
    [anon_sym_PLUS_PLUS] = ACTIONS(1392),
    [anon_sym_sizeof] = ACTIONS(1390),
    [anon_sym___alignof__] = ACTIONS(1390),
    [anon_sym___alignof] = ACTIONS(1390),
    [anon_sym__alignof] = ACTIONS(1390),
    [anon_sym_alignof] = ACTIONS(1390),
    [anon_sym__Alignof] = ACTIONS(1390),
    [anon_sym_offsetof] = ACTIONS(1390),
    [anon_sym__Generic] = ACTIONS(1390),
    [anon_sym_asm] = ACTIONS(1390),
    [anon_sym___asm__] = ACTIONS(1390),
    [sym_number_literal] = ACTIONS(1392),
    [anon_sym_L_SQUOTE] = ACTIONS(1392),
    [anon_sym_u_SQUOTE] = ACTIONS(1392),
    [anon_sym_U_SQUOTE] = ACTIONS(1392),
    [anon_sym_u8_SQUOTE] = ACTIONS(1392),
    [anon_sym_SQUOTE] = ACTIONS(1392),
    [anon_sym_L_DQUOTE] = ACTIONS(1392),
    [anon_sym_u_DQUOTE] = ACTIONS(1392),
    [anon_sym_U_DQUOTE] = ACTIONS(1392),
    [anon_sym_u8_DQUOTE] = ACTIONS(1392),
    [anon_sym_DQUOTE] = ACTIONS(1392),
    [sym_true] = ACTIONS(1390),
    [sym_false] = ACTIONS(1390),
    [anon_sym_NULL] = ACTIONS(1390),
    [anon_sym_nullptr] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
  },
  [132] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [133] = {
    [sym_identifier] = ACTIONS(1356),
    [aux_sym_preproc_include_token1] = ACTIONS(1356),
    [aux_sym_preproc_def_token1] = ACTIONS(1356),
    [aux_sym_preproc_if_token1] = ACTIONS(1356),
    [aux_sym_preproc_if_token2] = ACTIONS(1356),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1356),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1356),
    [aux_sym_preproc_else_token1] = ACTIONS(1356),
    [aux_sym_preproc_elif_token1] = ACTIONS(1356),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1356),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1356),
    [sym_preproc_directive] = ACTIONS(1356),
    [anon_sym_LPAREN2] = ACTIONS(1354),
    [anon_sym_BANG] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(1354),
    [anon_sym_DASH] = ACTIONS(1356),
    [anon_sym_PLUS] = ACTIONS(1356),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_AMP] = ACTIONS(1354),
    [anon_sym_SEMI] = ACTIONS(1354),
    [anon_sym___extension__] = ACTIONS(1356),
    [anon_sym_typedef] = ACTIONS(1356),
    [anon_sym_extern] = ACTIONS(1356),
    [anon_sym___attribute__] = ACTIONS(1356),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1354),
    [anon_sym___declspec] = ACTIONS(1356),
    [anon_sym___cdecl] = ACTIONS(1356),
    [anon_sym___clrcall] = ACTIONS(1356),
    [anon_sym___stdcall] = ACTIONS(1356),
    [anon_sym___fastcall] = ACTIONS(1356),
    [anon_sym___thiscall] = ACTIONS(1356),
    [anon_sym___vectorcall] = ACTIONS(1356),
    [anon_sym_LBRACE] = ACTIONS(1354),
    [anon_sym_signed] = ACTIONS(1356),
    [anon_sym_unsigned] = ACTIONS(1356),
    [anon_sym_long] = ACTIONS(1356),
    [anon_sym_short] = ACTIONS(1356),
    [anon_sym_static] = ACTIONS(1356),
    [anon_sym_auto] = ACTIONS(1356),
    [anon_sym_register] = ACTIONS(1356),
    [anon_sym_inline] = ACTIONS(1356),
    [anon_sym___inline] = ACTIONS(1356),
    [anon_sym___inline__] = ACTIONS(1356),
    [anon_sym___forceinline] = ACTIONS(1356),
    [anon_sym_thread_local] = ACTIONS(1356),
    [anon_sym___thread] = ACTIONS(1356),
    [anon_sym_const] = ACTIONS(1356),
    [anon_sym_constexpr] = ACTIONS(1356),
    [anon_sym_volatile] = ACTIONS(1356),
    [anon_sym_restrict] = ACTIONS(1356),
    [anon_sym___restrict__] = ACTIONS(1356),
    [anon_sym__Atomic] = ACTIONS(1356),
    [anon_sym__Noreturn] = ACTIONS(1356),
    [anon_sym_noreturn] = ACTIONS(1356),
    [sym_primitive_type] = ACTIONS(1356),
    [anon_sym_enum] = ACTIONS(1356),
    [anon_sym_struct] = ACTIONS(1356),
    [anon_sym_union] = ACTIONS(1356),
    [anon_sym_if] = ACTIONS(1356),
    [anon_sym_else] = ACTIONS(1356),
    [anon_sym_switch] = ACTIONS(1356),
    [anon_sym_case] = ACTIONS(1356),
    [anon_sym_default] = ACTIONS(1356),
    [anon_sym_while] = ACTIONS(1356),
    [anon_sym_do] = ACTIONS(1356),
    [anon_sym_for] = ACTIONS(1356),
    [anon_sym_return] = ACTIONS(1356),
    [anon_sym_break] = ACTIONS(1356),
    [anon_sym_continue] = ACTIONS(1356),
    [anon_sym_goto] = ACTIONS(1356),
    [anon_sym___try] = ACTIONS(1356),
    [anon_sym___leave] = ACTIONS(1356),
    [anon_sym_DASH_DASH] = ACTIONS(1354),
    [anon_sym_PLUS_PLUS] = ACTIONS(1354),
    [anon_sym_sizeof] = ACTIONS(1356),
    [anon_sym___alignof__] = ACTIONS(1356),
    [anon_sym___alignof] = ACTIONS(1356),
    [anon_sym__alignof] = ACTIONS(1356),
    [anon_sym_alignof] = ACTIONS(1356),
    [anon_sym__Alignof] = ACTIONS(1356),
    [anon_sym_offsetof] = ACTIONS(1356),
    [anon_sym__Generic] = ACTIONS(1356),
    [anon_sym_asm] = ACTIONS(1356),
    [anon_sym___asm__] = ACTIONS(1356),
    [sym_number_literal] = ACTIONS(1354),
    [anon_sym_L_SQUOTE] = ACTIONS(1354),
    [anon_sym_u_SQUOTE] = ACTIONS(1354),
    [anon_sym_U_SQUOTE] = ACTIONS(1354),
    [anon_sym_u8_SQUOTE] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(1354),
    [anon_sym_L_DQUOTE] = ACTIONS(1354),
    [anon_sym_u_DQUOTE] = ACTIONS(1354),
    [anon_sym_U_DQUOTE] = ACTIONS(1354),
    [anon_sym_u8_DQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1354),
    [sym_true] = ACTIONS(1356),
    [sym_false] = ACTIONS(1356),
    [anon_sym_NULL] = ACTIONS(1356),
    [anon_sym_nullptr] = ACTIONS(1356),
    [sym_comment] = ACTIONS(3),
  },
  [134] = {
    [sym_identifier] = ACTIONS(1394),
    [aux_sym_preproc_include_token1] = ACTIONS(1394),
    [aux_sym_preproc_def_token1] = ACTIONS(1394),
    [aux_sym_preproc_if_token1] = ACTIONS(1394),
    [aux_sym_preproc_if_token2] = ACTIONS(1394),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1394),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1394),
    [aux_sym_preproc_else_token1] = ACTIONS(1394),
    [aux_sym_preproc_elif_token1] = ACTIONS(1394),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1394),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1394),
    [sym_preproc_directive] = ACTIONS(1394),
    [anon_sym_LPAREN2] = ACTIONS(1396),
    [anon_sym_BANG] = ACTIONS(1396),
    [anon_sym_TILDE] = ACTIONS(1396),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_PLUS] = ACTIONS(1394),
    [anon_sym_STAR] = ACTIONS(1396),
    [anon_sym_AMP] = ACTIONS(1396),
    [anon_sym_SEMI] = ACTIONS(1396),
    [anon_sym___extension__] = ACTIONS(1394),
    [anon_sym_typedef] = ACTIONS(1394),
    [anon_sym_extern] = ACTIONS(1394),
    [anon_sym___attribute__] = ACTIONS(1394),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1396),
    [anon_sym___declspec] = ACTIONS(1394),
    [anon_sym___cdecl] = ACTIONS(1394),
    [anon_sym___clrcall] = ACTIONS(1394),
    [anon_sym___stdcall] = ACTIONS(1394),
    [anon_sym___fastcall] = ACTIONS(1394),
    [anon_sym___thiscall] = ACTIONS(1394),
    [anon_sym___vectorcall] = ACTIONS(1394),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_signed] = ACTIONS(1394),
    [anon_sym_unsigned] = ACTIONS(1394),
    [anon_sym_long] = ACTIONS(1394),
    [anon_sym_short] = ACTIONS(1394),
    [anon_sym_static] = ACTIONS(1394),
    [anon_sym_auto] = ACTIONS(1394),
    [anon_sym_register] = ACTIONS(1394),
    [anon_sym_inline] = ACTIONS(1394),
    [anon_sym___inline] = ACTIONS(1394),
    [anon_sym___inline__] = ACTIONS(1394),
    [anon_sym___forceinline] = ACTIONS(1394),
    [anon_sym_thread_local] = ACTIONS(1394),
    [anon_sym___thread] = ACTIONS(1394),
    [anon_sym_const] = ACTIONS(1394),
    [anon_sym_constexpr] = ACTIONS(1394),
    [anon_sym_volatile] = ACTIONS(1394),
    [anon_sym_restrict] = ACTIONS(1394),
    [anon_sym___restrict__] = ACTIONS(1394),
    [anon_sym__Atomic] = ACTIONS(1394),
    [anon_sym__Noreturn] = ACTIONS(1394),
    [anon_sym_noreturn] = ACTIONS(1394),
    [sym_primitive_type] = ACTIONS(1394),
    [anon_sym_enum] = ACTIONS(1394),
    [anon_sym_struct] = ACTIONS(1394),
    [anon_sym_union] = ACTIONS(1394),
    [anon_sym_if] = ACTIONS(1394),
    [anon_sym_else] = ACTIONS(1394),
    [anon_sym_switch] = ACTIONS(1394),
    [anon_sym_case] = ACTIONS(1394),
    [anon_sym_default] = ACTIONS(1394),
    [anon_sym_while] = ACTIONS(1394),
    [anon_sym_do] = ACTIONS(1394),
    [anon_sym_for] = ACTIONS(1394),
    [anon_sym_return] = ACTIONS(1394),
    [anon_sym_break] = ACTIONS(1394),
    [anon_sym_continue] = ACTIONS(1394),
    [anon_sym_goto] = ACTIONS(1394),
    [anon_sym___try] = ACTIONS(1394),
    [anon_sym___leave] = ACTIONS(1394),
    [anon_sym_DASH_DASH] = ACTIONS(1396),
    [anon_sym_PLUS_PLUS] = ACTIONS(1396),
    [anon_sym_sizeof] = ACTIONS(1394),
    [anon_sym___alignof__] = ACTIONS(1394),
    [anon_sym___alignof] = ACTIONS(1394),
    [anon_sym__alignof] = ACTIONS(1394),
    [anon_sym_alignof] = ACTIONS(1394),
    [anon_sym__Alignof] = ACTIONS(1394),
    [anon_sym_offsetof] = ACTIONS(1394),
    [anon_sym__Generic] = ACTIONS(1394),
    [anon_sym_asm] = ACTIONS(1394),
    [anon_sym___asm__] = ACTIONS(1394),
    [sym_number_literal] = ACTIONS(1396),
    [anon_sym_L_SQUOTE] = ACTIONS(1396),
    [anon_sym_u_SQUOTE] = ACTIONS(1396),
    [anon_sym_U_SQUOTE] = ACTIONS(1396),
    [anon_sym_u8_SQUOTE] = ACTIONS(1396),
    [anon_sym_SQUOTE] = ACTIONS(1396),
    [anon_sym_L_DQUOTE] = ACTIONS(1396),
    [anon_sym_u_DQUOTE] = ACTIONS(1396),
    [anon_sym_U_DQUOTE] = ACTIONS(1396),
    [anon_sym_u8_DQUOTE] = ACTIONS(1396),
    [anon_sym_DQUOTE] = ACTIONS(1396),
    [sym_true] = ACTIONS(1394),
    [sym_false] = ACTIONS(1394),
    [anon_sym_NULL] = ACTIONS(1394),
    [anon_sym_nullptr] = ACTIONS(1394),
    [sym_comment] = ACTIONS(3),
  },
  [135] = {
    [sym_identifier] = ACTIONS(1398),
    [aux_sym_preproc_include_token1] = ACTIONS(1398),
    [aux_sym_preproc_def_token1] = ACTIONS(1398),
    [aux_sym_preproc_if_token1] = ACTIONS(1398),
    [aux_sym_preproc_if_token2] = ACTIONS(1398),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1398),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1398),
    [aux_sym_preproc_else_token1] = ACTIONS(1398),
    [aux_sym_preproc_elif_token1] = ACTIONS(1398),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1398),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1398),
    [sym_preproc_directive] = ACTIONS(1398),
    [anon_sym_LPAREN2] = ACTIONS(1400),
    [anon_sym_BANG] = ACTIONS(1400),
    [anon_sym_TILDE] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1398),
    [anon_sym_PLUS] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym___extension__] = ACTIONS(1398),
    [anon_sym_typedef] = ACTIONS(1398),
    [anon_sym_extern] = ACTIONS(1398),
    [anon_sym___attribute__] = ACTIONS(1398),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1400),
    [anon_sym___declspec] = ACTIONS(1398),
    [anon_sym___cdecl] = ACTIONS(1398),
    [anon_sym___clrcall] = ACTIONS(1398),
    [anon_sym___stdcall] = ACTIONS(1398),
    [anon_sym___fastcall] = ACTIONS(1398),
    [anon_sym___thiscall] = ACTIONS(1398),
    [anon_sym___vectorcall] = ACTIONS(1398),
    [anon_sym_LBRACE] = ACTIONS(1400),
    [anon_sym_signed] = ACTIONS(1398),
    [anon_sym_unsigned] = ACTIONS(1398),
    [anon_sym_long] = ACTIONS(1398),
    [anon_sym_short] = ACTIONS(1398),
    [anon_sym_static] = ACTIONS(1398),
    [anon_sym_auto] = ACTIONS(1398),
    [anon_sym_register] = ACTIONS(1398),
    [anon_sym_inline] = ACTIONS(1398),
    [anon_sym___inline] = ACTIONS(1398),
    [anon_sym___inline__] = ACTIONS(1398),
    [anon_sym___forceinline] = ACTIONS(1398),
    [anon_sym_thread_local] = ACTIONS(1398),
    [anon_sym___thread] = ACTIONS(1398),
    [anon_sym_const] = ACTIONS(1398),
    [anon_sym_constexpr] = ACTIONS(1398),
    [anon_sym_volatile] = ACTIONS(1398),
    [anon_sym_restrict] = ACTIONS(1398),
    [anon_sym___restrict__] = ACTIONS(1398),
    [anon_sym__Atomic] = ACTIONS(1398),
    [anon_sym__Noreturn] = ACTIONS(1398),
    [anon_sym_noreturn] = ACTIONS(1398),
    [sym_primitive_type] = ACTIONS(1398),
    [anon_sym_enum] = ACTIONS(1398),
    [anon_sym_struct] = ACTIONS(1398),
    [anon_sym_union] = ACTIONS(1398),
    [anon_sym_if] = ACTIONS(1398),
    [anon_sym_else] = ACTIONS(1398),
    [anon_sym_switch] = ACTIONS(1398),
    [anon_sym_case] = ACTIONS(1398),
    [anon_sym_default] = ACTIONS(1398),
    [anon_sym_while] = ACTIONS(1398),
    [anon_sym_do] = ACTIONS(1398),
    [anon_sym_for] = ACTIONS(1398),
    [anon_sym_return] = ACTIONS(1398),
    [anon_sym_break] = ACTIONS(1398),
    [anon_sym_continue] = ACTIONS(1398),
    [anon_sym_goto] = ACTIONS(1398),
    [anon_sym___try] = ACTIONS(1398),
    [anon_sym___leave] = ACTIONS(1398),
    [anon_sym_DASH_DASH] = ACTIONS(1400),
    [anon_sym_PLUS_PLUS] = ACTIONS(1400),
    [anon_sym_sizeof] = ACTIONS(1398),
    [anon_sym___alignof__] = ACTIONS(1398),
    [anon_sym___alignof] = ACTIONS(1398),
    [anon_sym__alignof] = ACTIONS(1398),
    [anon_sym_alignof] = ACTIONS(1398),
    [anon_sym__Alignof] = ACTIONS(1398),
    [anon_sym_offsetof] = ACTIONS(1398),
    [anon_sym__Generic] = ACTIONS(1398),
    [anon_sym_asm] = ACTIONS(1398),
    [anon_sym___asm__] = ACTIONS(1398),
    [sym_number_literal] = ACTIONS(1400),
    [anon_sym_L_SQUOTE] = ACTIONS(1400),
    [anon_sym_u_SQUOTE] = ACTIONS(1400),
    [anon_sym_U_SQUOTE] = ACTIONS(1400),
    [anon_sym_u8_SQUOTE] = ACTIONS(1400),
    [anon_sym_SQUOTE] = ACTIONS(1400),
    [anon_sym_L_DQUOTE] = ACTIONS(1400),
    [anon_sym_u_DQUOTE] = ACTIONS(1400),
    [anon_sym_U_DQUOTE] = ACTIONS(1400),
    [anon_sym_u8_DQUOTE] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(1398),
    [sym_false] = ACTIONS(1398),
    [anon_sym_NULL] = ACTIONS(1398),
    [anon_sym_nullptr] = ACTIONS(1398),
    [sym_comment] = ACTIONS(3),
  },
  [136] = {
    [sym_identifier] = ACTIONS(1402),
    [aux_sym_preproc_include_token1] = ACTIONS(1402),
    [aux_sym_preproc_def_token1] = ACTIONS(1402),
    [aux_sym_preproc_if_token1] = ACTIONS(1402),
    [aux_sym_preproc_if_token2] = ACTIONS(1402),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1402),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1402),
    [aux_sym_preproc_else_token1] = ACTIONS(1402),
    [aux_sym_preproc_elif_token1] = ACTIONS(1402),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1402),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1402),
    [sym_preproc_directive] = ACTIONS(1402),
    [anon_sym_LPAREN2] = ACTIONS(1404),
    [anon_sym_BANG] = ACTIONS(1404),
    [anon_sym_TILDE] = ACTIONS(1404),
    [anon_sym_DASH] = ACTIONS(1402),
    [anon_sym_PLUS] = ACTIONS(1402),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_AMP] = ACTIONS(1404),
    [anon_sym_SEMI] = ACTIONS(1404),
    [anon_sym___extension__] = ACTIONS(1402),
    [anon_sym_typedef] = ACTIONS(1402),
    [anon_sym_extern] = ACTIONS(1402),
    [anon_sym___attribute__] = ACTIONS(1402),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1404),
    [anon_sym___declspec] = ACTIONS(1402),
    [anon_sym___cdecl] = ACTIONS(1402),
    [anon_sym___clrcall] = ACTIONS(1402),
    [anon_sym___stdcall] = ACTIONS(1402),
    [anon_sym___fastcall] = ACTIONS(1402),
    [anon_sym___thiscall] = ACTIONS(1402),
    [anon_sym___vectorcall] = ACTIONS(1402),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_signed] = ACTIONS(1402),
    [anon_sym_unsigned] = ACTIONS(1402),
    [anon_sym_long] = ACTIONS(1402),
    [anon_sym_short] = ACTIONS(1402),
    [anon_sym_static] = ACTIONS(1402),
    [anon_sym_auto] = ACTIONS(1402),
    [anon_sym_register] = ACTIONS(1402),
    [anon_sym_inline] = ACTIONS(1402),
    [anon_sym___inline] = ACTIONS(1402),
    [anon_sym___inline__] = ACTIONS(1402),
    [anon_sym___forceinline] = ACTIONS(1402),
    [anon_sym_thread_local] = ACTIONS(1402),
    [anon_sym___thread] = ACTIONS(1402),
    [anon_sym_const] = ACTIONS(1402),
    [anon_sym_constexpr] = ACTIONS(1402),
    [anon_sym_volatile] = ACTIONS(1402),
    [anon_sym_restrict] = ACTIONS(1402),
    [anon_sym___restrict__] = ACTIONS(1402),
    [anon_sym__Atomic] = ACTIONS(1402),
    [anon_sym__Noreturn] = ACTIONS(1402),
    [anon_sym_noreturn] = ACTIONS(1402),
    [sym_primitive_type] = ACTIONS(1402),
    [anon_sym_enum] = ACTIONS(1402),
    [anon_sym_struct] = ACTIONS(1402),
    [anon_sym_union] = ACTIONS(1402),
    [anon_sym_if] = ACTIONS(1402),
    [anon_sym_else] = ACTIONS(1402),
    [anon_sym_switch] = ACTIONS(1402),
    [anon_sym_case] = ACTIONS(1402),
    [anon_sym_default] = ACTIONS(1402),
    [anon_sym_while] = ACTIONS(1402),
    [anon_sym_do] = ACTIONS(1402),
    [anon_sym_for] = ACTIONS(1402),
    [anon_sym_return] = ACTIONS(1402),
    [anon_sym_break] = ACTIONS(1402),
    [anon_sym_continue] = ACTIONS(1402),
    [anon_sym_goto] = ACTIONS(1402),
    [anon_sym___try] = ACTIONS(1402),
    [anon_sym___leave] = ACTIONS(1402),
    [anon_sym_DASH_DASH] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1404),
    [anon_sym_sizeof] = ACTIONS(1402),
    [anon_sym___alignof__] = ACTIONS(1402),
    [anon_sym___alignof] = ACTIONS(1402),
    [anon_sym__alignof] = ACTIONS(1402),
    [anon_sym_alignof] = ACTIONS(1402),
    [anon_sym__Alignof] = ACTIONS(1402),
    [anon_sym_offsetof] = ACTIONS(1402),
    [anon_sym__Generic] = ACTIONS(1402),
    [anon_sym_asm] = ACTIONS(1402),
    [anon_sym___asm__] = ACTIONS(1402),
    [sym_number_literal] = ACTIONS(1404),
    [anon_sym_L_SQUOTE] = ACTIONS(1404),
    [anon_sym_u_SQUOTE] = ACTIONS(1404),
    [anon_sym_U_SQUOTE] = ACTIONS(1404),
    [anon_sym_u8_SQUOTE] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(1404),
    [anon_sym_L_DQUOTE] = ACTIONS(1404),
    [anon_sym_u_DQUOTE] = ACTIONS(1404),
    [anon_sym_U_DQUOTE] = ACTIONS(1404),
    [anon_sym_u8_DQUOTE] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1404),
    [sym_true] = ACTIONS(1402),
    [sym_false] = ACTIONS(1402),
    [anon_sym_NULL] = ACTIONS(1402),
    [anon_sym_nullptr] = ACTIONS(1402),
    [sym_comment] = ACTIONS(3),
  },
  [137] = {
    [sym_identifier] = ACTIONS(1406),
    [aux_sym_preproc_include_token1] = ACTIONS(1406),
    [aux_sym_preproc_def_token1] = ACTIONS(1406),
    [aux_sym_preproc_if_token1] = ACTIONS(1406),
    [aux_sym_preproc_if_token2] = ACTIONS(1406),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1406),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1406),
    [aux_sym_preproc_else_token1] = ACTIONS(1406),
    [aux_sym_preproc_elif_token1] = ACTIONS(1406),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1406),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1406),
    [sym_preproc_directive] = ACTIONS(1406),
    [anon_sym_LPAREN2] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1408),
    [anon_sym_DASH] = ACTIONS(1406),
    [anon_sym_PLUS] = ACTIONS(1406),
    [anon_sym_STAR] = ACTIONS(1408),
    [anon_sym_AMP] = ACTIONS(1408),
    [anon_sym_SEMI] = ACTIONS(1408),
    [anon_sym___extension__] = ACTIONS(1406),
    [anon_sym_typedef] = ACTIONS(1406),
    [anon_sym_extern] = ACTIONS(1406),
    [anon_sym___attribute__] = ACTIONS(1406),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1408),
    [anon_sym___declspec] = ACTIONS(1406),
    [anon_sym___cdecl] = ACTIONS(1406),
    [anon_sym___clrcall] = ACTIONS(1406),
    [anon_sym___stdcall] = ACTIONS(1406),
    [anon_sym___fastcall] = ACTIONS(1406),
    [anon_sym___thiscall] = ACTIONS(1406),
    [anon_sym___vectorcall] = ACTIONS(1406),
    [anon_sym_LBRACE] = ACTIONS(1408),
    [anon_sym_signed] = ACTIONS(1406),
    [anon_sym_unsigned] = ACTIONS(1406),
    [anon_sym_long] = ACTIONS(1406),
    [anon_sym_short] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_auto] = ACTIONS(1406),
    [anon_sym_register] = ACTIONS(1406),
    [anon_sym_inline] = ACTIONS(1406),
    [anon_sym___inline] = ACTIONS(1406),
    [anon_sym___inline__] = ACTIONS(1406),
    [anon_sym___forceinline] = ACTIONS(1406),
    [anon_sym_thread_local] = ACTIONS(1406),
    [anon_sym___thread] = ACTIONS(1406),
    [anon_sym_const] = ACTIONS(1406),
    [anon_sym_constexpr] = ACTIONS(1406),
    [anon_sym_volatile] = ACTIONS(1406),
    [anon_sym_restrict] = ACTIONS(1406),
    [anon_sym___restrict__] = ACTIONS(1406),
    [anon_sym__Atomic] = ACTIONS(1406),
    [anon_sym__Noreturn] = ACTIONS(1406),
    [anon_sym_noreturn] = ACTIONS(1406),
    [sym_primitive_type] = ACTIONS(1406),
    [anon_sym_enum] = ACTIONS(1406),
    [anon_sym_struct] = ACTIONS(1406),
    [anon_sym_union] = ACTIONS(1406),
    [anon_sym_if] = ACTIONS(1406),
    [anon_sym_else] = ACTIONS(1406),
    [anon_sym_switch] = ACTIONS(1406),
    [anon_sym_case] = ACTIONS(1406),
    [anon_sym_default] = ACTIONS(1406),
    [anon_sym_while] = ACTIONS(1406),
    [anon_sym_do] = ACTIONS(1406),
    [anon_sym_for] = ACTIONS(1406),
    [anon_sym_return] = ACTIONS(1406),
    [anon_sym_break] = ACTIONS(1406),
    [anon_sym_continue] = ACTIONS(1406),
    [anon_sym_goto] = ACTIONS(1406),
    [anon_sym___try] = ACTIONS(1406),
    [anon_sym___leave] = ACTIONS(1406),
    [anon_sym_DASH_DASH] = ACTIONS(1408),
    [anon_sym_PLUS_PLUS] = ACTIONS(1408),
    [anon_sym_sizeof] = ACTIONS(1406),
    [anon_sym___alignof__] = ACTIONS(1406),
    [anon_sym___alignof] = ACTIONS(1406),
    [anon_sym__alignof] = ACTIONS(1406),
    [anon_sym_alignof] = ACTIONS(1406),
    [anon_sym__Alignof] = ACTIONS(1406),
    [anon_sym_offsetof] = ACTIONS(1406),
    [anon_sym__Generic] = ACTIONS(1406),
    [anon_sym_asm] = ACTIONS(1406),
    [anon_sym___asm__] = ACTIONS(1406),
    [sym_number_literal] = ACTIONS(1408),
    [anon_sym_L_SQUOTE] = ACTIONS(1408),
    [anon_sym_u_SQUOTE] = ACTIONS(1408),
    [anon_sym_U_SQUOTE] = ACTIONS(1408),
    [anon_sym_u8_SQUOTE] = ACTIONS(1408),
    [anon_sym_SQUOTE] = ACTIONS(1408),
    [anon_sym_L_DQUOTE] = ACTIONS(1408),
    [anon_sym_u_DQUOTE] = ACTIONS(1408),
    [anon_sym_U_DQUOTE] = ACTIONS(1408),
    [anon_sym_u8_DQUOTE] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1408),
    [sym_true] = ACTIONS(1406),
    [sym_false] = ACTIONS(1406),
    [anon_sym_NULL] = ACTIONS(1406),
    [anon_sym_nullptr] = ACTIONS(1406),
    [sym_comment] = ACTIONS(3),
  },
  [138] = {
    [sym_identifier] = ACTIONS(1410),
    [aux_sym_preproc_include_token1] = ACTIONS(1410),
    [aux_sym_preproc_def_token1] = ACTIONS(1410),
    [aux_sym_preproc_if_token1] = ACTIONS(1410),
    [aux_sym_preproc_if_token2] = ACTIONS(1410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1410),
    [aux_sym_preproc_else_token1] = ACTIONS(1410),
    [aux_sym_preproc_elif_token1] = ACTIONS(1410),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1410),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1410),
    [sym_preproc_directive] = ACTIONS(1410),
    [anon_sym_LPAREN2] = ACTIONS(1412),
    [anon_sym_BANG] = ACTIONS(1412),
    [anon_sym_TILDE] = ACTIONS(1412),
    [anon_sym_DASH] = ACTIONS(1410),
    [anon_sym_PLUS] = ACTIONS(1410),
    [anon_sym_STAR] = ACTIONS(1412),
    [anon_sym_AMP] = ACTIONS(1412),
    [anon_sym_SEMI] = ACTIONS(1412),
    [anon_sym___extension__] = ACTIONS(1410),
    [anon_sym_typedef] = ACTIONS(1410),
    [anon_sym_extern] = ACTIONS(1410),
    [anon_sym___attribute__] = ACTIONS(1410),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1412),
    [anon_sym___declspec] = ACTIONS(1410),
    [anon_sym___cdecl] = ACTIONS(1410),
    [anon_sym___clrcall] = ACTIONS(1410),
    [anon_sym___stdcall] = ACTIONS(1410),
    [anon_sym___fastcall] = ACTIONS(1410),
    [anon_sym___thiscall] = ACTIONS(1410),
    [anon_sym___vectorcall] = ACTIONS(1410),
    [anon_sym_LBRACE] = ACTIONS(1412),
    [anon_sym_signed] = ACTIONS(1410),
    [anon_sym_unsigned] = ACTIONS(1410),
    [anon_sym_long] = ACTIONS(1410),
    [anon_sym_short] = ACTIONS(1410),
    [anon_sym_static] = ACTIONS(1410),
    [anon_sym_auto] = ACTIONS(1410),
    [anon_sym_register] = ACTIONS(1410),
    [anon_sym_inline] = ACTIONS(1410),
    [anon_sym___inline] = ACTIONS(1410),
    [anon_sym___inline__] = ACTIONS(1410),
    [anon_sym___forceinline] = ACTIONS(1410),
    [anon_sym_thread_local] = ACTIONS(1410),
    [anon_sym___thread] = ACTIONS(1410),
    [anon_sym_const] = ACTIONS(1410),
    [anon_sym_constexpr] = ACTIONS(1410),
    [anon_sym_volatile] = ACTIONS(1410),
    [anon_sym_restrict] = ACTIONS(1410),
    [anon_sym___restrict__] = ACTIONS(1410),
    [anon_sym__Atomic] = ACTIONS(1410),
    [anon_sym__Noreturn] = ACTIONS(1410),
    [anon_sym_noreturn] = ACTIONS(1410),
    [sym_primitive_type] = ACTIONS(1410),
    [anon_sym_enum] = ACTIONS(1410),
    [anon_sym_struct] = ACTIONS(1410),
    [anon_sym_union] = ACTIONS(1410),
    [anon_sym_if] = ACTIONS(1410),
    [anon_sym_else] = ACTIONS(1410),
    [anon_sym_switch] = ACTIONS(1410),
    [anon_sym_case] = ACTIONS(1410),
    [anon_sym_default] = ACTIONS(1410),
    [anon_sym_while] = ACTIONS(1410),
    [anon_sym_do] = ACTIONS(1410),
    [anon_sym_for] = ACTIONS(1410),
    [anon_sym_return] = ACTIONS(1410),
    [anon_sym_break] = ACTIONS(1410),
    [anon_sym_continue] = ACTIONS(1410),
    [anon_sym_goto] = ACTIONS(1410),
    [anon_sym___try] = ACTIONS(1410),
    [anon_sym___leave] = ACTIONS(1410),
    [anon_sym_DASH_DASH] = ACTIONS(1412),
    [anon_sym_PLUS_PLUS] = ACTIONS(1412),
    [anon_sym_sizeof] = ACTIONS(1410),
    [anon_sym___alignof__] = ACTIONS(1410),
    [anon_sym___alignof] = ACTIONS(1410),
    [anon_sym__alignof] = ACTIONS(1410),
    [anon_sym_alignof] = ACTIONS(1410),
    [anon_sym__Alignof] = ACTIONS(1410),
    [anon_sym_offsetof] = ACTIONS(1410),
    [anon_sym__Generic] = ACTIONS(1410),
    [anon_sym_asm] = ACTIONS(1410),
    [anon_sym___asm__] = ACTIONS(1410),
    [sym_number_literal] = ACTIONS(1412),
    [anon_sym_L_SQUOTE] = ACTIONS(1412),
    [anon_sym_u_SQUOTE] = ACTIONS(1412),
    [anon_sym_U_SQUOTE] = ACTIONS(1412),
    [anon_sym_u8_SQUOTE] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(1412),
    [anon_sym_L_DQUOTE] = ACTIONS(1412),
    [anon_sym_u_DQUOTE] = ACTIONS(1412),
    [anon_sym_U_DQUOTE] = ACTIONS(1412),
    [anon_sym_u8_DQUOTE] = ACTIONS(1412),
    [anon_sym_DQUOTE] = ACTIONS(1412),
    [sym_true] = ACTIONS(1410),
    [sym_false] = ACTIONS(1410),
    [anon_sym_NULL] = ACTIONS(1410),
    [anon_sym_nullptr] = ACTIONS(1410),
    [sym_comment] = ACTIONS(3),
  },
  [139] = {
    [sym_identifier] = ACTIONS(1414),
    [aux_sym_preproc_include_token1] = ACTIONS(1414),
    [aux_sym_preproc_def_token1] = ACTIONS(1414),
    [aux_sym_preproc_if_token1] = ACTIONS(1414),
    [aux_sym_preproc_if_token2] = ACTIONS(1414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1414),
    [aux_sym_preproc_else_token1] = ACTIONS(1414),
    [aux_sym_preproc_elif_token1] = ACTIONS(1414),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1414),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1414),
    [sym_preproc_directive] = ACTIONS(1414),
    [anon_sym_LPAREN2] = ACTIONS(1416),
    [anon_sym_BANG] = ACTIONS(1416),
    [anon_sym_TILDE] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1416),
    [anon_sym_AMP] = ACTIONS(1416),
    [anon_sym_SEMI] = ACTIONS(1416),
    [anon_sym___extension__] = ACTIONS(1414),
    [anon_sym_typedef] = ACTIONS(1414),
    [anon_sym_extern] = ACTIONS(1414),
    [anon_sym___attribute__] = ACTIONS(1414),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1416),
    [anon_sym___declspec] = ACTIONS(1414),
    [anon_sym___cdecl] = ACTIONS(1414),
    [anon_sym___clrcall] = ACTIONS(1414),
    [anon_sym___stdcall] = ACTIONS(1414),
    [anon_sym___fastcall] = ACTIONS(1414),
    [anon_sym___thiscall] = ACTIONS(1414),
    [anon_sym___vectorcall] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1416),
    [anon_sym_signed] = ACTIONS(1414),
    [anon_sym_unsigned] = ACTIONS(1414),
    [anon_sym_long] = ACTIONS(1414),
    [anon_sym_short] = ACTIONS(1414),
    [anon_sym_static] = ACTIONS(1414),
    [anon_sym_auto] = ACTIONS(1414),
    [anon_sym_register] = ACTIONS(1414),
    [anon_sym_inline] = ACTIONS(1414),
    [anon_sym___inline] = ACTIONS(1414),
    [anon_sym___inline__] = ACTIONS(1414),
    [anon_sym___forceinline] = ACTIONS(1414),
    [anon_sym_thread_local] = ACTIONS(1414),
    [anon_sym___thread] = ACTIONS(1414),
    [anon_sym_const] = ACTIONS(1414),
    [anon_sym_constexpr] = ACTIONS(1414),
    [anon_sym_volatile] = ACTIONS(1414),
    [anon_sym_restrict] = ACTIONS(1414),
    [anon_sym___restrict__] = ACTIONS(1414),
    [anon_sym__Atomic] = ACTIONS(1414),
    [anon_sym__Noreturn] = ACTIONS(1414),
    [anon_sym_noreturn] = ACTIONS(1414),
    [sym_primitive_type] = ACTIONS(1414),
    [anon_sym_enum] = ACTIONS(1414),
    [anon_sym_struct] = ACTIONS(1414),
    [anon_sym_union] = ACTIONS(1414),
    [anon_sym_if] = ACTIONS(1414),
    [anon_sym_else] = ACTIONS(1414),
    [anon_sym_switch] = ACTIONS(1414),
    [anon_sym_case] = ACTIONS(1414),
    [anon_sym_default] = ACTIONS(1414),
    [anon_sym_while] = ACTIONS(1414),
    [anon_sym_do] = ACTIONS(1414),
    [anon_sym_for] = ACTIONS(1414),
    [anon_sym_return] = ACTIONS(1414),
    [anon_sym_break] = ACTIONS(1414),
    [anon_sym_continue] = ACTIONS(1414),
    [anon_sym_goto] = ACTIONS(1414),
    [anon_sym___try] = ACTIONS(1414),
    [anon_sym___leave] = ACTIONS(1414),
    [anon_sym_DASH_DASH] = ACTIONS(1416),
    [anon_sym_PLUS_PLUS] = ACTIONS(1416),
    [anon_sym_sizeof] = ACTIONS(1414),
    [anon_sym___alignof__] = ACTIONS(1414),
    [anon_sym___alignof] = ACTIONS(1414),
    [anon_sym__alignof] = ACTIONS(1414),
    [anon_sym_alignof] = ACTIONS(1414),
    [anon_sym__Alignof] = ACTIONS(1414),
    [anon_sym_offsetof] = ACTIONS(1414),
    [anon_sym__Generic] = ACTIONS(1414),
    [anon_sym_asm] = ACTIONS(1414),
    [anon_sym___asm__] = ACTIONS(1414),
    [sym_number_literal] = ACTIONS(1416),
    [anon_sym_L_SQUOTE] = ACTIONS(1416),
    [anon_sym_u_SQUOTE] = ACTIONS(1416),
    [anon_sym_U_SQUOTE] = ACTIONS(1416),
    [anon_sym_u8_SQUOTE] = ACTIONS(1416),
    [anon_sym_SQUOTE] = ACTIONS(1416),
    [anon_sym_L_DQUOTE] = ACTIONS(1416),
    [anon_sym_u_DQUOTE] = ACTIONS(1416),
    [anon_sym_U_DQUOTE] = ACTIONS(1416),
    [anon_sym_u8_DQUOTE] = ACTIONS(1416),
    [anon_sym_DQUOTE] = ACTIONS(1416),
    [sym_true] = ACTIONS(1414),
    [sym_false] = ACTIONS(1414),
    [anon_sym_NULL] = ACTIONS(1414),
    [anon_sym_nullptr] = ACTIONS(1414),
    [sym_comment] = ACTIONS(3),
  },
  [140] = {
    [sym_identifier] = ACTIONS(1414),
    [aux_sym_preproc_include_token1] = ACTIONS(1414),
    [aux_sym_preproc_def_token1] = ACTIONS(1414),
    [aux_sym_preproc_if_token1] = ACTIONS(1414),
    [aux_sym_preproc_if_token2] = ACTIONS(1414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1414),
    [aux_sym_preproc_else_token1] = ACTIONS(1414),
    [aux_sym_preproc_elif_token1] = ACTIONS(1414),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1414),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1414),
    [sym_preproc_directive] = ACTIONS(1414),
    [anon_sym_LPAREN2] = ACTIONS(1416),
    [anon_sym_BANG] = ACTIONS(1416),
    [anon_sym_TILDE] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1416),
    [anon_sym_AMP] = ACTIONS(1416),
    [anon_sym_SEMI] = ACTIONS(1416),
    [anon_sym___extension__] = ACTIONS(1414),
    [anon_sym_typedef] = ACTIONS(1414),
    [anon_sym_extern] = ACTIONS(1414),
    [anon_sym___attribute__] = ACTIONS(1414),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1416),
    [anon_sym___declspec] = ACTIONS(1414),
    [anon_sym___cdecl] = ACTIONS(1414),
    [anon_sym___clrcall] = ACTIONS(1414),
    [anon_sym___stdcall] = ACTIONS(1414),
    [anon_sym___fastcall] = ACTIONS(1414),
    [anon_sym___thiscall] = ACTIONS(1414),
    [anon_sym___vectorcall] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1416),
    [anon_sym_signed] = ACTIONS(1414),
    [anon_sym_unsigned] = ACTIONS(1414),
    [anon_sym_long] = ACTIONS(1414),
    [anon_sym_short] = ACTIONS(1414),
    [anon_sym_static] = ACTIONS(1414),
    [anon_sym_auto] = ACTIONS(1414),
    [anon_sym_register] = ACTIONS(1414),
    [anon_sym_inline] = ACTIONS(1414),
    [anon_sym___inline] = ACTIONS(1414),
    [anon_sym___inline__] = ACTIONS(1414),
    [anon_sym___forceinline] = ACTIONS(1414),
    [anon_sym_thread_local] = ACTIONS(1414),
    [anon_sym___thread] = ACTIONS(1414),
    [anon_sym_const] = ACTIONS(1414),
    [anon_sym_constexpr] = ACTIONS(1414),
    [anon_sym_volatile] = ACTIONS(1414),
    [anon_sym_restrict] = ACTIONS(1414),
    [anon_sym___restrict__] = ACTIONS(1414),
    [anon_sym__Atomic] = ACTIONS(1414),
    [anon_sym__Noreturn] = ACTIONS(1414),
    [anon_sym_noreturn] = ACTIONS(1414),
    [sym_primitive_type] = ACTIONS(1414),
    [anon_sym_enum] = ACTIONS(1414),
    [anon_sym_struct] = ACTIONS(1414),
    [anon_sym_union] = ACTIONS(1414),
    [anon_sym_if] = ACTIONS(1414),
    [anon_sym_else] = ACTIONS(1414),
    [anon_sym_switch] = ACTIONS(1414),
    [anon_sym_case] = ACTIONS(1414),
    [anon_sym_default] = ACTIONS(1414),
    [anon_sym_while] = ACTIONS(1414),
    [anon_sym_do] = ACTIONS(1414),
    [anon_sym_for] = ACTIONS(1414),
    [anon_sym_return] = ACTIONS(1414),
    [anon_sym_break] = ACTIONS(1414),
    [anon_sym_continue] = ACTIONS(1414),
    [anon_sym_goto] = ACTIONS(1414),
    [anon_sym___try] = ACTIONS(1414),
    [anon_sym___leave] = ACTIONS(1414),
    [anon_sym_DASH_DASH] = ACTIONS(1416),
    [anon_sym_PLUS_PLUS] = ACTIONS(1416),
    [anon_sym_sizeof] = ACTIONS(1414),
    [anon_sym___alignof__] = ACTIONS(1414),
    [anon_sym___alignof] = ACTIONS(1414),
    [anon_sym__alignof] = ACTIONS(1414),
    [anon_sym_alignof] = ACTIONS(1414),
    [anon_sym__Alignof] = ACTIONS(1414),
    [anon_sym_offsetof] = ACTIONS(1414),
    [anon_sym__Generic] = ACTIONS(1414),
    [anon_sym_asm] = ACTIONS(1414),
    [anon_sym___asm__] = ACTIONS(1414),
    [sym_number_literal] = ACTIONS(1416),
    [anon_sym_L_SQUOTE] = ACTIONS(1416),
    [anon_sym_u_SQUOTE] = ACTIONS(1416),
    [anon_sym_U_SQUOTE] = ACTIONS(1416),
    [anon_sym_u8_SQUOTE] = ACTIONS(1416),
    [anon_sym_SQUOTE] = ACTIONS(1416),
    [anon_sym_L_DQUOTE] = ACTIONS(1416),
    [anon_sym_u_DQUOTE] = ACTIONS(1416),
    [anon_sym_U_DQUOTE] = ACTIONS(1416),
    [anon_sym_u8_DQUOTE] = ACTIONS(1416),
    [anon_sym_DQUOTE] = ACTIONS(1416),
    [sym_true] = ACTIONS(1414),
    [sym_false] = ACTIONS(1414),
    [anon_sym_NULL] = ACTIONS(1414),
    [anon_sym_nullptr] = ACTIONS(1414),
    [sym_comment] = ACTIONS(3),
  },
  [141] = {
    [sym_identifier] = ACTIONS(1418),
    [aux_sym_preproc_include_token1] = ACTIONS(1418),
    [aux_sym_preproc_def_token1] = ACTIONS(1418),
    [aux_sym_preproc_if_token1] = ACTIONS(1418),
    [aux_sym_preproc_if_token2] = ACTIONS(1418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1418),
    [aux_sym_preproc_else_token1] = ACTIONS(1418),
    [aux_sym_preproc_elif_token1] = ACTIONS(1418),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1418),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1418),
    [sym_preproc_directive] = ACTIONS(1418),
    [anon_sym_LPAREN2] = ACTIONS(1420),
    [anon_sym_BANG] = ACTIONS(1420),
    [anon_sym_TILDE] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_AMP] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(1420),
    [anon_sym___extension__] = ACTIONS(1418),
    [anon_sym_typedef] = ACTIONS(1418),
    [anon_sym_extern] = ACTIONS(1418),
    [anon_sym___attribute__] = ACTIONS(1418),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1420),
    [anon_sym___declspec] = ACTIONS(1418),
    [anon_sym___cdecl] = ACTIONS(1418),
    [anon_sym___clrcall] = ACTIONS(1418),
    [anon_sym___stdcall] = ACTIONS(1418),
    [anon_sym___fastcall] = ACTIONS(1418),
    [anon_sym___thiscall] = ACTIONS(1418),
    [anon_sym___vectorcall] = ACTIONS(1418),
    [anon_sym_LBRACE] = ACTIONS(1420),
    [anon_sym_signed] = ACTIONS(1418),
    [anon_sym_unsigned] = ACTIONS(1418),
    [anon_sym_long] = ACTIONS(1418),
    [anon_sym_short] = ACTIONS(1418),
    [anon_sym_static] = ACTIONS(1418),
    [anon_sym_auto] = ACTIONS(1418),
    [anon_sym_register] = ACTIONS(1418),
    [anon_sym_inline] = ACTIONS(1418),
    [anon_sym___inline] = ACTIONS(1418),
    [anon_sym___inline__] = ACTIONS(1418),
    [anon_sym___forceinline] = ACTIONS(1418),
    [anon_sym_thread_local] = ACTIONS(1418),
    [anon_sym___thread] = ACTIONS(1418),
    [anon_sym_const] = ACTIONS(1418),
    [anon_sym_constexpr] = ACTIONS(1418),
    [anon_sym_volatile] = ACTIONS(1418),
    [anon_sym_restrict] = ACTIONS(1418),
    [anon_sym___restrict__] = ACTIONS(1418),
    [anon_sym__Atomic] = ACTIONS(1418),
    [anon_sym__Noreturn] = ACTIONS(1418),
    [anon_sym_noreturn] = ACTIONS(1418),
    [sym_primitive_type] = ACTIONS(1418),
    [anon_sym_enum] = ACTIONS(1418),
    [anon_sym_struct] = ACTIONS(1418),
    [anon_sym_union] = ACTIONS(1418),
    [anon_sym_if] = ACTIONS(1418),
    [anon_sym_else] = ACTIONS(1418),
    [anon_sym_switch] = ACTIONS(1418),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_default] = ACTIONS(1418),
    [anon_sym_while] = ACTIONS(1418),
    [anon_sym_do] = ACTIONS(1418),
    [anon_sym_for] = ACTIONS(1418),
    [anon_sym_return] = ACTIONS(1418),
    [anon_sym_break] = ACTIONS(1418),
    [anon_sym_continue] = ACTIONS(1418),
    [anon_sym_goto] = ACTIONS(1418),
    [anon_sym___try] = ACTIONS(1418),
    [anon_sym___leave] = ACTIONS(1418),
    [anon_sym_DASH_DASH] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1420),
    [anon_sym_sizeof] = ACTIONS(1418),
    [anon_sym___alignof__] = ACTIONS(1418),
    [anon_sym___alignof] = ACTIONS(1418),
    [anon_sym__alignof] = ACTIONS(1418),
    [anon_sym_alignof] = ACTIONS(1418),
    [anon_sym__Alignof] = ACTIONS(1418),
    [anon_sym_offsetof] = ACTIONS(1418),
    [anon_sym__Generic] = ACTIONS(1418),
    [anon_sym_asm] = ACTIONS(1418),
    [anon_sym___asm__] = ACTIONS(1418),
    [sym_number_literal] = ACTIONS(1420),
    [anon_sym_L_SQUOTE] = ACTIONS(1420),
    [anon_sym_u_SQUOTE] = ACTIONS(1420),
    [anon_sym_U_SQUOTE] = ACTIONS(1420),
    [anon_sym_u8_SQUOTE] = ACTIONS(1420),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [anon_sym_L_DQUOTE] = ACTIONS(1420),
    [anon_sym_u_DQUOTE] = ACTIONS(1420),
    [anon_sym_U_DQUOTE] = ACTIONS(1420),
    [anon_sym_u8_DQUOTE] = ACTIONS(1420),
    [anon_sym_DQUOTE] = ACTIONS(1420),
    [sym_true] = ACTIONS(1418),
    [sym_false] = ACTIONS(1418),
    [anon_sym_NULL] = ACTIONS(1418),
    [anon_sym_nullptr] = ACTIONS(1418),
    [sym_comment] = ACTIONS(3),
  },
  [142] = {
    [sym_identifier] = ACTIONS(1418),
    [aux_sym_preproc_include_token1] = ACTIONS(1418),
    [aux_sym_preproc_def_token1] = ACTIONS(1418),
    [aux_sym_preproc_if_token1] = ACTIONS(1418),
    [aux_sym_preproc_if_token2] = ACTIONS(1418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1418),
    [aux_sym_preproc_else_token1] = ACTIONS(1418),
    [aux_sym_preproc_elif_token1] = ACTIONS(1418),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1418),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1418),
    [sym_preproc_directive] = ACTIONS(1418),
    [anon_sym_LPAREN2] = ACTIONS(1420),
    [anon_sym_BANG] = ACTIONS(1420),
    [anon_sym_TILDE] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_AMP] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(1420),
    [anon_sym___extension__] = ACTIONS(1418),
    [anon_sym_typedef] = ACTIONS(1418),
    [anon_sym_extern] = ACTIONS(1418),
    [anon_sym___attribute__] = ACTIONS(1418),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1420),
    [anon_sym___declspec] = ACTIONS(1418),
    [anon_sym___cdecl] = ACTIONS(1418),
    [anon_sym___clrcall] = ACTIONS(1418),
    [anon_sym___stdcall] = ACTIONS(1418),
    [anon_sym___fastcall] = ACTIONS(1418),
    [anon_sym___thiscall] = ACTIONS(1418),
    [anon_sym___vectorcall] = ACTIONS(1418),
    [anon_sym_LBRACE] = ACTIONS(1420),
    [anon_sym_signed] = ACTIONS(1418),
    [anon_sym_unsigned] = ACTIONS(1418),
    [anon_sym_long] = ACTIONS(1418),
    [anon_sym_short] = ACTIONS(1418),
    [anon_sym_static] = ACTIONS(1418),
    [anon_sym_auto] = ACTIONS(1418),
    [anon_sym_register] = ACTIONS(1418),
    [anon_sym_inline] = ACTIONS(1418),
    [anon_sym___inline] = ACTIONS(1418),
    [anon_sym___inline__] = ACTIONS(1418),
    [anon_sym___forceinline] = ACTIONS(1418),
    [anon_sym_thread_local] = ACTIONS(1418),
    [anon_sym___thread] = ACTIONS(1418),
    [anon_sym_const] = ACTIONS(1418),
    [anon_sym_constexpr] = ACTIONS(1418),
    [anon_sym_volatile] = ACTIONS(1418),
    [anon_sym_restrict] = ACTIONS(1418),
    [anon_sym___restrict__] = ACTIONS(1418),
    [anon_sym__Atomic] = ACTIONS(1418),
    [anon_sym__Noreturn] = ACTIONS(1418),
    [anon_sym_noreturn] = ACTIONS(1418),
    [sym_primitive_type] = ACTIONS(1418),
    [anon_sym_enum] = ACTIONS(1418),
    [anon_sym_struct] = ACTIONS(1418),
    [anon_sym_union] = ACTIONS(1418),
    [anon_sym_if] = ACTIONS(1418),
    [anon_sym_else] = ACTIONS(1418),
    [anon_sym_switch] = ACTIONS(1418),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_default] = ACTIONS(1418),
    [anon_sym_while] = ACTIONS(1418),
    [anon_sym_do] = ACTIONS(1418),
    [anon_sym_for] = ACTIONS(1418),
    [anon_sym_return] = ACTIONS(1418),
    [anon_sym_break] = ACTIONS(1418),
    [anon_sym_continue] = ACTIONS(1418),
    [anon_sym_goto] = ACTIONS(1418),
    [anon_sym___try] = ACTIONS(1418),
    [anon_sym___leave] = ACTIONS(1418),
    [anon_sym_DASH_DASH] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1420),
    [anon_sym_sizeof] = ACTIONS(1418),
    [anon_sym___alignof__] = ACTIONS(1418),
    [anon_sym___alignof] = ACTIONS(1418),
    [anon_sym__alignof] = ACTIONS(1418),
    [anon_sym_alignof] = ACTIONS(1418),
    [anon_sym__Alignof] = ACTIONS(1418),
    [anon_sym_offsetof] = ACTIONS(1418),
    [anon_sym__Generic] = ACTIONS(1418),
    [anon_sym_asm] = ACTIONS(1418),
    [anon_sym___asm__] = ACTIONS(1418),
    [sym_number_literal] = ACTIONS(1420),
    [anon_sym_L_SQUOTE] = ACTIONS(1420),
    [anon_sym_u_SQUOTE] = ACTIONS(1420),
    [anon_sym_U_SQUOTE] = ACTIONS(1420),
    [anon_sym_u8_SQUOTE] = ACTIONS(1420),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [anon_sym_L_DQUOTE] = ACTIONS(1420),
    [anon_sym_u_DQUOTE] = ACTIONS(1420),
    [anon_sym_U_DQUOTE] = ACTIONS(1420),
    [anon_sym_u8_DQUOTE] = ACTIONS(1420),
    [anon_sym_DQUOTE] = ACTIONS(1420),
    [sym_true] = ACTIONS(1418),
    [sym_false] = ACTIONS(1418),
    [anon_sym_NULL] = ACTIONS(1418),
    [anon_sym_nullptr] = ACTIONS(1418),
    [sym_comment] = ACTIONS(3),
  },
  [143] = {
    [sym_identifier] = ACTIONS(1422),
    [aux_sym_preproc_include_token1] = ACTIONS(1422),
    [aux_sym_preproc_def_token1] = ACTIONS(1422),
    [aux_sym_preproc_if_token1] = ACTIONS(1422),
    [aux_sym_preproc_if_token2] = ACTIONS(1422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1422),
    [aux_sym_preproc_else_token1] = ACTIONS(1422),
    [aux_sym_preproc_elif_token1] = ACTIONS(1422),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1422),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1422),
    [sym_preproc_directive] = ACTIONS(1422),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(1424),
    [anon_sym_TILDE] = ACTIONS(1424),
    [anon_sym_DASH] = ACTIONS(1422),
    [anon_sym_PLUS] = ACTIONS(1422),
    [anon_sym_STAR] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym___extension__] = ACTIONS(1422),
    [anon_sym_typedef] = ACTIONS(1422),
    [anon_sym_extern] = ACTIONS(1422),
    [anon_sym___attribute__] = ACTIONS(1422),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1424),
    [anon_sym___declspec] = ACTIONS(1422),
    [anon_sym___cdecl] = ACTIONS(1422),
    [anon_sym___clrcall] = ACTIONS(1422),
    [anon_sym___stdcall] = ACTIONS(1422),
    [anon_sym___fastcall] = ACTIONS(1422),
    [anon_sym___thiscall] = ACTIONS(1422),
    [anon_sym___vectorcall] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(1424),
    [anon_sym_signed] = ACTIONS(1422),
    [anon_sym_unsigned] = ACTIONS(1422),
    [anon_sym_long] = ACTIONS(1422),
    [anon_sym_short] = ACTIONS(1422),
    [anon_sym_static] = ACTIONS(1422),
    [anon_sym_auto] = ACTIONS(1422),
    [anon_sym_register] = ACTIONS(1422),
    [anon_sym_inline] = ACTIONS(1422),
    [anon_sym___inline] = ACTIONS(1422),
    [anon_sym___inline__] = ACTIONS(1422),
    [anon_sym___forceinline] = ACTIONS(1422),
    [anon_sym_thread_local] = ACTIONS(1422),
    [anon_sym___thread] = ACTIONS(1422),
    [anon_sym_const] = ACTIONS(1422),
    [anon_sym_constexpr] = ACTIONS(1422),
    [anon_sym_volatile] = ACTIONS(1422),
    [anon_sym_restrict] = ACTIONS(1422),
    [anon_sym___restrict__] = ACTIONS(1422),
    [anon_sym__Atomic] = ACTIONS(1422),
    [anon_sym__Noreturn] = ACTIONS(1422),
    [anon_sym_noreturn] = ACTIONS(1422),
    [sym_primitive_type] = ACTIONS(1422),
    [anon_sym_enum] = ACTIONS(1422),
    [anon_sym_struct] = ACTIONS(1422),
    [anon_sym_union] = ACTIONS(1422),
    [anon_sym_if] = ACTIONS(1422),
    [anon_sym_switch] = ACTIONS(1422),
    [anon_sym_case] = ACTIONS(1422),
    [anon_sym_default] = ACTIONS(1422),
    [anon_sym_while] = ACTIONS(1422),
    [anon_sym_do] = ACTIONS(1422),
    [anon_sym_for] = ACTIONS(1422),
    [anon_sym_return] = ACTIONS(1422),
    [anon_sym_break] = ACTIONS(1422),
    [anon_sym_continue] = ACTIONS(1422),
    [anon_sym_goto] = ACTIONS(1422),
    [anon_sym___try] = ACTIONS(1422),
    [anon_sym___leave] = ACTIONS(1422),
    [anon_sym_DASH_DASH] = ACTIONS(1424),
    [anon_sym_PLUS_PLUS] = ACTIONS(1424),
    [anon_sym_sizeof] = ACTIONS(1422),
    [anon_sym___alignof__] = ACTIONS(1422),
    [anon_sym___alignof] = ACTIONS(1422),
    [anon_sym__alignof] = ACTIONS(1422),
    [anon_sym_alignof] = ACTIONS(1422),
    [anon_sym__Alignof] = ACTIONS(1422),
    [anon_sym_offsetof] = ACTIONS(1422),
    [anon_sym__Generic] = ACTIONS(1422),
    [anon_sym_asm] = ACTIONS(1422),
    [anon_sym___asm__] = ACTIONS(1422),
    [sym_number_literal] = ACTIONS(1424),
    [anon_sym_L_SQUOTE] = ACTIONS(1424),
    [anon_sym_u_SQUOTE] = ACTIONS(1424),
    [anon_sym_U_SQUOTE] = ACTIONS(1424),
    [anon_sym_u8_SQUOTE] = ACTIONS(1424),
    [anon_sym_SQUOTE] = ACTIONS(1424),
    [anon_sym_L_DQUOTE] = ACTIONS(1424),
    [anon_sym_u_DQUOTE] = ACTIONS(1424),
    [anon_sym_U_DQUOTE] = ACTIONS(1424),
    [anon_sym_u8_DQUOTE] = ACTIONS(1424),
    [anon_sym_DQUOTE] = ACTIONS(1424),
    [sym_true] = ACTIONS(1422),
    [sym_false] = ACTIONS(1422),
    [anon_sym_NULL] = ACTIONS(1422),
    [anon_sym_nullptr] = ACTIONS(1422),
    [sym_comment] = ACTIONS(3),
  },
  [144] = {
    [sym_identifier] = ACTIONS(1426),
    [aux_sym_preproc_include_token1] = ACTIONS(1426),
    [aux_sym_preproc_def_token1] = ACTIONS(1426),
    [aux_sym_preproc_if_token1] = ACTIONS(1426),
    [aux_sym_preproc_if_token2] = ACTIONS(1426),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1426),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1426),
    [aux_sym_preproc_else_token1] = ACTIONS(1426),
    [aux_sym_preproc_elif_token1] = ACTIONS(1426),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1426),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1426),
    [sym_preproc_directive] = ACTIONS(1426),
    [anon_sym_LPAREN2] = ACTIONS(1428),
    [anon_sym_BANG] = ACTIONS(1428),
    [anon_sym_TILDE] = ACTIONS(1428),
    [anon_sym_DASH] = ACTIONS(1426),
    [anon_sym_PLUS] = ACTIONS(1426),
    [anon_sym_STAR] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1428),
    [anon_sym_SEMI] = ACTIONS(1428),
    [anon_sym___extension__] = ACTIONS(1426),
    [anon_sym_typedef] = ACTIONS(1426),
    [anon_sym_extern] = ACTIONS(1426),
    [anon_sym___attribute__] = ACTIONS(1426),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1428),
    [anon_sym___declspec] = ACTIONS(1426),
    [anon_sym___cdecl] = ACTIONS(1426),
    [anon_sym___clrcall] = ACTIONS(1426),
    [anon_sym___stdcall] = ACTIONS(1426),
    [anon_sym___fastcall] = ACTIONS(1426),
    [anon_sym___thiscall] = ACTIONS(1426),
    [anon_sym___vectorcall] = ACTIONS(1426),
    [anon_sym_LBRACE] = ACTIONS(1428),
    [anon_sym_signed] = ACTIONS(1426),
    [anon_sym_unsigned] = ACTIONS(1426),
    [anon_sym_long] = ACTIONS(1426),
    [anon_sym_short] = ACTIONS(1426),
    [anon_sym_static] = ACTIONS(1426),
    [anon_sym_auto] = ACTIONS(1426),
    [anon_sym_register] = ACTIONS(1426),
    [anon_sym_inline] = ACTIONS(1426),
    [anon_sym___inline] = ACTIONS(1426),
    [anon_sym___inline__] = ACTIONS(1426),
    [anon_sym___forceinline] = ACTIONS(1426),
    [anon_sym_thread_local] = ACTIONS(1426),
    [anon_sym___thread] = ACTIONS(1426),
    [anon_sym_const] = ACTIONS(1426),
    [anon_sym_constexpr] = ACTIONS(1426),
    [anon_sym_volatile] = ACTIONS(1426),
    [anon_sym_restrict] = ACTIONS(1426),
    [anon_sym___restrict__] = ACTIONS(1426),
    [anon_sym__Atomic] = ACTIONS(1426),
    [anon_sym__Noreturn] = ACTIONS(1426),
    [anon_sym_noreturn] = ACTIONS(1426),
    [sym_primitive_type] = ACTIONS(1426),
    [anon_sym_enum] = ACTIONS(1426),
    [anon_sym_struct] = ACTIONS(1426),
    [anon_sym_union] = ACTIONS(1426),
    [anon_sym_if] = ACTIONS(1426),
    [anon_sym_switch] = ACTIONS(1426),
    [anon_sym_case] = ACTIONS(1426),
    [anon_sym_default] = ACTIONS(1426),
    [anon_sym_while] = ACTIONS(1426),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_for] = ACTIONS(1426),
    [anon_sym_return] = ACTIONS(1426),
    [anon_sym_break] = ACTIONS(1426),
    [anon_sym_continue] = ACTIONS(1426),
    [anon_sym_goto] = ACTIONS(1426),
    [anon_sym___try] = ACTIONS(1426),
    [anon_sym___leave] = ACTIONS(1426),
    [anon_sym_DASH_DASH] = ACTIONS(1428),
    [anon_sym_PLUS_PLUS] = ACTIONS(1428),
    [anon_sym_sizeof] = ACTIONS(1426),
    [anon_sym___alignof__] = ACTIONS(1426),
    [anon_sym___alignof] = ACTIONS(1426),
    [anon_sym__alignof] = ACTIONS(1426),
    [anon_sym_alignof] = ACTIONS(1426),
    [anon_sym__Alignof] = ACTIONS(1426),
    [anon_sym_offsetof] = ACTIONS(1426),
    [anon_sym__Generic] = ACTIONS(1426),
    [anon_sym_asm] = ACTIONS(1426),
    [anon_sym___asm__] = ACTIONS(1426),
    [sym_number_literal] = ACTIONS(1428),
    [anon_sym_L_SQUOTE] = ACTIONS(1428),
    [anon_sym_u_SQUOTE] = ACTIONS(1428),
    [anon_sym_U_SQUOTE] = ACTIONS(1428),
    [anon_sym_u8_SQUOTE] = ACTIONS(1428),
    [anon_sym_SQUOTE] = ACTIONS(1428),
    [anon_sym_L_DQUOTE] = ACTIONS(1428),
    [anon_sym_u_DQUOTE] = ACTIONS(1428),
    [anon_sym_U_DQUOTE] = ACTIONS(1428),
    [anon_sym_u8_DQUOTE] = ACTIONS(1428),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [sym_true] = ACTIONS(1426),
    [sym_false] = ACTIONS(1426),
    [anon_sym_NULL] = ACTIONS(1426),
    [anon_sym_nullptr] = ACTIONS(1426),
    [sym_comment] = ACTIONS(3),
  },
  [145] = {
    [sym_identifier] = ACTIONS(1430),
    [aux_sym_preproc_include_token1] = ACTIONS(1430),
    [aux_sym_preproc_def_token1] = ACTIONS(1430),
    [aux_sym_preproc_if_token1] = ACTIONS(1430),
    [aux_sym_preproc_if_token2] = ACTIONS(1430),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1430),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1430),
    [aux_sym_preproc_else_token1] = ACTIONS(1430),
    [aux_sym_preproc_elif_token1] = ACTIONS(1430),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1430),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1430),
    [sym_preproc_directive] = ACTIONS(1430),
    [anon_sym_LPAREN2] = ACTIONS(1432),
    [anon_sym_BANG] = ACTIONS(1432),
    [anon_sym_TILDE] = ACTIONS(1432),
    [anon_sym_DASH] = ACTIONS(1430),
    [anon_sym_PLUS] = ACTIONS(1430),
    [anon_sym_STAR] = ACTIONS(1432),
    [anon_sym_AMP] = ACTIONS(1432),
    [anon_sym_SEMI] = ACTIONS(1432),
    [anon_sym___extension__] = ACTIONS(1430),
    [anon_sym_typedef] = ACTIONS(1430),
    [anon_sym_extern] = ACTIONS(1430),
    [anon_sym___attribute__] = ACTIONS(1430),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(1430),
    [anon_sym___cdecl] = ACTIONS(1430),
    [anon_sym___clrcall] = ACTIONS(1430),
    [anon_sym___stdcall] = ACTIONS(1430),
    [anon_sym___fastcall] = ACTIONS(1430),
    [anon_sym___thiscall] = ACTIONS(1430),
    [anon_sym___vectorcall] = ACTIONS(1430),
    [anon_sym_LBRACE] = ACTIONS(1432),
    [anon_sym_signed] = ACTIONS(1430),
    [anon_sym_unsigned] = ACTIONS(1430),
    [anon_sym_long] = ACTIONS(1430),
    [anon_sym_short] = ACTIONS(1430),
    [anon_sym_static] = ACTIONS(1430),
    [anon_sym_auto] = ACTIONS(1430),
    [anon_sym_register] = ACTIONS(1430),
    [anon_sym_inline] = ACTIONS(1430),
    [anon_sym___inline] = ACTIONS(1430),
    [anon_sym___inline__] = ACTIONS(1430),
    [anon_sym___forceinline] = ACTIONS(1430),
    [anon_sym_thread_local] = ACTIONS(1430),
    [anon_sym___thread] = ACTIONS(1430),
    [anon_sym_const] = ACTIONS(1430),
    [anon_sym_constexpr] = ACTIONS(1430),
    [anon_sym_volatile] = ACTIONS(1430),
    [anon_sym_restrict] = ACTIONS(1430),
    [anon_sym___restrict__] = ACTIONS(1430),
    [anon_sym__Atomic] = ACTIONS(1430),
    [anon_sym__Noreturn] = ACTIONS(1430),
    [anon_sym_noreturn] = ACTIONS(1430),
    [sym_primitive_type] = ACTIONS(1430),
    [anon_sym_enum] = ACTIONS(1430),
    [anon_sym_struct] = ACTIONS(1430),
    [anon_sym_union] = ACTIONS(1430),
    [anon_sym_if] = ACTIONS(1430),
    [anon_sym_switch] = ACTIONS(1430),
    [anon_sym_case] = ACTIONS(1430),
    [anon_sym_default] = ACTIONS(1430),
    [anon_sym_while] = ACTIONS(1430),
    [anon_sym_do] = ACTIONS(1430),
    [anon_sym_for] = ACTIONS(1430),
    [anon_sym_return] = ACTIONS(1430),
    [anon_sym_break] = ACTIONS(1430),
    [anon_sym_continue] = ACTIONS(1430),
    [anon_sym_goto] = ACTIONS(1430),
    [anon_sym___try] = ACTIONS(1430),
    [anon_sym___leave] = ACTIONS(1430),
    [anon_sym_DASH_DASH] = ACTIONS(1432),
    [anon_sym_PLUS_PLUS] = ACTIONS(1432),
    [anon_sym_sizeof] = ACTIONS(1430),
    [anon_sym___alignof__] = ACTIONS(1430),
    [anon_sym___alignof] = ACTIONS(1430),
    [anon_sym__alignof] = ACTIONS(1430),
    [anon_sym_alignof] = ACTIONS(1430),
    [anon_sym__Alignof] = ACTIONS(1430),
    [anon_sym_offsetof] = ACTIONS(1430),
    [anon_sym__Generic] = ACTIONS(1430),
    [anon_sym_asm] = ACTIONS(1430),
    [anon_sym___asm__] = ACTIONS(1430),
    [sym_number_literal] = ACTIONS(1432),
    [anon_sym_L_SQUOTE] = ACTIONS(1432),
    [anon_sym_u_SQUOTE] = ACTIONS(1432),
    [anon_sym_U_SQUOTE] = ACTIONS(1432),
    [anon_sym_u8_SQUOTE] = ACTIONS(1432),
    [anon_sym_SQUOTE] = ACTIONS(1432),
    [anon_sym_L_DQUOTE] = ACTIONS(1432),
    [anon_sym_u_DQUOTE] = ACTIONS(1432),
    [anon_sym_U_DQUOTE] = ACTIONS(1432),
    [anon_sym_u8_DQUOTE] = ACTIONS(1432),
    [anon_sym_DQUOTE] = ACTIONS(1432),
    [sym_true] = ACTIONS(1430),
    [sym_false] = ACTIONS(1430),
    [anon_sym_NULL] = ACTIONS(1430),
    [anon_sym_nullptr] = ACTIONS(1430),
    [sym_comment] = ACTIONS(3),
  },
  [146] = {
    [sym_identifier] = ACTIONS(1434),
    [aux_sym_preproc_include_token1] = ACTIONS(1434),
    [aux_sym_preproc_def_token1] = ACTIONS(1434),
    [aux_sym_preproc_if_token1] = ACTIONS(1434),
    [aux_sym_preproc_if_token2] = ACTIONS(1434),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1434),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1434),
    [aux_sym_preproc_else_token1] = ACTIONS(1434),
    [aux_sym_preproc_elif_token1] = ACTIONS(1434),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1434),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1434),
    [sym_preproc_directive] = ACTIONS(1434),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(1436),
    [anon_sym_TILDE] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_STAR] = ACTIONS(1436),
    [anon_sym_AMP] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1436),
    [anon_sym___extension__] = ACTIONS(1434),
    [anon_sym_typedef] = ACTIONS(1434),
    [anon_sym_extern] = ACTIONS(1434),
    [anon_sym___attribute__] = ACTIONS(1434),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1436),
    [anon_sym___declspec] = ACTIONS(1434),
    [anon_sym___cdecl] = ACTIONS(1434),
    [anon_sym___clrcall] = ACTIONS(1434),
    [anon_sym___stdcall] = ACTIONS(1434),
    [anon_sym___fastcall] = ACTIONS(1434),
    [anon_sym___thiscall] = ACTIONS(1434),
    [anon_sym___vectorcall] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1436),
    [anon_sym_signed] = ACTIONS(1434),
    [anon_sym_unsigned] = ACTIONS(1434),
    [anon_sym_long] = ACTIONS(1434),
    [anon_sym_short] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(1434),
    [anon_sym_auto] = ACTIONS(1434),
    [anon_sym_register] = ACTIONS(1434),
    [anon_sym_inline] = ACTIONS(1434),
    [anon_sym___inline] = ACTIONS(1434),
    [anon_sym___inline__] = ACTIONS(1434),
    [anon_sym___forceinline] = ACTIONS(1434),
    [anon_sym_thread_local] = ACTIONS(1434),
    [anon_sym___thread] = ACTIONS(1434),
    [anon_sym_const] = ACTIONS(1434),
    [anon_sym_constexpr] = ACTIONS(1434),
    [anon_sym_volatile] = ACTIONS(1434),
    [anon_sym_restrict] = ACTIONS(1434),
    [anon_sym___restrict__] = ACTIONS(1434),
    [anon_sym__Atomic] = ACTIONS(1434),
    [anon_sym__Noreturn] = ACTIONS(1434),
    [anon_sym_noreturn] = ACTIONS(1434),
    [sym_primitive_type] = ACTIONS(1434),
    [anon_sym_enum] = ACTIONS(1434),
    [anon_sym_struct] = ACTIONS(1434),
    [anon_sym_union] = ACTIONS(1434),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_switch] = ACTIONS(1434),
    [anon_sym_case] = ACTIONS(1434),
    [anon_sym_default] = ACTIONS(1434),
    [anon_sym_while] = ACTIONS(1434),
    [anon_sym_do] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1434),
    [anon_sym_return] = ACTIONS(1434),
    [anon_sym_break] = ACTIONS(1434),
    [anon_sym_continue] = ACTIONS(1434),
    [anon_sym_goto] = ACTIONS(1434),
    [anon_sym___try] = ACTIONS(1434),
    [anon_sym___leave] = ACTIONS(1434),
    [anon_sym_DASH_DASH] = ACTIONS(1436),
    [anon_sym_PLUS_PLUS] = ACTIONS(1436),
    [anon_sym_sizeof] = ACTIONS(1434),
    [anon_sym___alignof__] = ACTIONS(1434),
    [anon_sym___alignof] = ACTIONS(1434),
    [anon_sym__alignof] = ACTIONS(1434),
    [anon_sym_alignof] = ACTIONS(1434),
    [anon_sym__Alignof] = ACTIONS(1434),
    [anon_sym_offsetof] = ACTIONS(1434),
    [anon_sym__Generic] = ACTIONS(1434),
    [anon_sym_asm] = ACTIONS(1434),
    [anon_sym___asm__] = ACTIONS(1434),
    [sym_number_literal] = ACTIONS(1436),
    [anon_sym_L_SQUOTE] = ACTIONS(1436),
    [anon_sym_u_SQUOTE] = ACTIONS(1436),
    [anon_sym_U_SQUOTE] = ACTIONS(1436),
    [anon_sym_u8_SQUOTE] = ACTIONS(1436),
    [anon_sym_SQUOTE] = ACTIONS(1436),
    [anon_sym_L_DQUOTE] = ACTIONS(1436),
    [anon_sym_u_DQUOTE] = ACTIONS(1436),
    [anon_sym_U_DQUOTE] = ACTIONS(1436),
    [anon_sym_u8_DQUOTE] = ACTIONS(1436),
    [anon_sym_DQUOTE] = ACTIONS(1436),
    [sym_true] = ACTIONS(1434),
    [sym_false] = ACTIONS(1434),
    [anon_sym_NULL] = ACTIONS(1434),
    [anon_sym_nullptr] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
  },
  [147] = {
    [sym_identifier] = ACTIONS(1438),
    [aux_sym_preproc_include_token1] = ACTIONS(1438),
    [aux_sym_preproc_def_token1] = ACTIONS(1438),
    [aux_sym_preproc_if_token1] = ACTIONS(1438),
    [aux_sym_preproc_if_token2] = ACTIONS(1438),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1438),
    [aux_sym_preproc_else_token1] = ACTIONS(1438),
    [aux_sym_preproc_elif_token1] = ACTIONS(1438),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1438),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1438),
    [sym_preproc_directive] = ACTIONS(1438),
    [anon_sym_LPAREN2] = ACTIONS(1440),
    [anon_sym_BANG] = ACTIONS(1440),
    [anon_sym_TILDE] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1438),
    [anon_sym_PLUS] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_SEMI] = ACTIONS(1440),
    [anon_sym___extension__] = ACTIONS(1438),
    [anon_sym_typedef] = ACTIONS(1438),
    [anon_sym_extern] = ACTIONS(1438),
    [anon_sym___attribute__] = ACTIONS(1438),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1440),
    [anon_sym___declspec] = ACTIONS(1438),
    [anon_sym___cdecl] = ACTIONS(1438),
    [anon_sym___clrcall] = ACTIONS(1438),
    [anon_sym___stdcall] = ACTIONS(1438),
    [anon_sym___fastcall] = ACTIONS(1438),
    [anon_sym___thiscall] = ACTIONS(1438),
    [anon_sym___vectorcall] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(1440),
    [anon_sym_signed] = ACTIONS(1438),
    [anon_sym_unsigned] = ACTIONS(1438),
    [anon_sym_long] = ACTIONS(1438),
    [anon_sym_short] = ACTIONS(1438),
    [anon_sym_static] = ACTIONS(1438),
    [anon_sym_auto] = ACTIONS(1438),
    [anon_sym_register] = ACTIONS(1438),
    [anon_sym_inline] = ACTIONS(1438),
    [anon_sym___inline] = ACTIONS(1438),
    [anon_sym___inline__] = ACTIONS(1438),
    [anon_sym___forceinline] = ACTIONS(1438),
    [anon_sym_thread_local] = ACTIONS(1438),
    [anon_sym___thread] = ACTIONS(1438),
    [anon_sym_const] = ACTIONS(1438),
    [anon_sym_constexpr] = ACTIONS(1438),
    [anon_sym_volatile] = ACTIONS(1438),
    [anon_sym_restrict] = ACTIONS(1438),
    [anon_sym___restrict__] = ACTIONS(1438),
    [anon_sym__Atomic] = ACTIONS(1438),
    [anon_sym__Noreturn] = ACTIONS(1438),
    [anon_sym_noreturn] = ACTIONS(1438),
    [sym_primitive_type] = ACTIONS(1438),
    [anon_sym_enum] = ACTIONS(1438),
    [anon_sym_struct] = ACTIONS(1438),
    [anon_sym_union] = ACTIONS(1438),
    [anon_sym_if] = ACTIONS(1438),
    [anon_sym_switch] = ACTIONS(1438),
    [anon_sym_case] = ACTIONS(1438),
    [anon_sym_default] = ACTIONS(1438),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_do] = ACTIONS(1438),
    [anon_sym_for] = ACTIONS(1438),
    [anon_sym_return] = ACTIONS(1438),
    [anon_sym_break] = ACTIONS(1438),
    [anon_sym_continue] = ACTIONS(1438),
    [anon_sym_goto] = ACTIONS(1438),
    [anon_sym___try] = ACTIONS(1438),
    [anon_sym___leave] = ACTIONS(1438),
    [anon_sym_DASH_DASH] = ACTIONS(1440),
    [anon_sym_PLUS_PLUS] = ACTIONS(1440),
    [anon_sym_sizeof] = ACTIONS(1438),
    [anon_sym___alignof__] = ACTIONS(1438),
    [anon_sym___alignof] = ACTIONS(1438),
    [anon_sym__alignof] = ACTIONS(1438),
    [anon_sym_alignof] = ACTIONS(1438),
    [anon_sym__Alignof] = ACTIONS(1438),
    [anon_sym_offsetof] = ACTIONS(1438),
    [anon_sym__Generic] = ACTIONS(1438),
    [anon_sym_asm] = ACTIONS(1438),
    [anon_sym___asm__] = ACTIONS(1438),
    [sym_number_literal] = ACTIONS(1440),
    [anon_sym_L_SQUOTE] = ACTIONS(1440),
    [anon_sym_u_SQUOTE] = ACTIONS(1440),
    [anon_sym_U_SQUOTE] = ACTIONS(1440),
    [anon_sym_u8_SQUOTE] = ACTIONS(1440),
    [anon_sym_SQUOTE] = ACTIONS(1440),
    [anon_sym_L_DQUOTE] = ACTIONS(1440),
    [anon_sym_u_DQUOTE] = ACTIONS(1440),
    [anon_sym_U_DQUOTE] = ACTIONS(1440),
    [anon_sym_u8_DQUOTE] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [sym_true] = ACTIONS(1438),
    [sym_false] = ACTIONS(1438),
    [anon_sym_NULL] = ACTIONS(1438),
    [anon_sym_nullptr] = ACTIONS(1438),
    [sym_comment] = ACTIONS(3),
  },
  [148] = {
    [sym_identifier] = ACTIONS(1442),
    [aux_sym_preproc_include_token1] = ACTIONS(1442),
    [aux_sym_preproc_def_token1] = ACTIONS(1442),
    [aux_sym_preproc_if_token1] = ACTIONS(1442),
    [aux_sym_preproc_if_token2] = ACTIONS(1442),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1442),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1442),
    [aux_sym_preproc_else_token1] = ACTIONS(1442),
    [aux_sym_preproc_elif_token1] = ACTIONS(1442),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1442),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1442),
    [sym_preproc_directive] = ACTIONS(1442),
    [anon_sym_LPAREN2] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1444),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1444),
    [anon_sym___extension__] = ACTIONS(1442),
    [anon_sym_typedef] = ACTIONS(1442),
    [anon_sym_extern] = ACTIONS(1442),
    [anon_sym___attribute__] = ACTIONS(1442),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1444),
    [anon_sym___declspec] = ACTIONS(1442),
    [anon_sym___cdecl] = ACTIONS(1442),
    [anon_sym___clrcall] = ACTIONS(1442),
    [anon_sym___stdcall] = ACTIONS(1442),
    [anon_sym___fastcall] = ACTIONS(1442),
    [anon_sym___thiscall] = ACTIONS(1442),
    [anon_sym___vectorcall] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1444),
    [anon_sym_signed] = ACTIONS(1442),
    [anon_sym_unsigned] = ACTIONS(1442),
    [anon_sym_long] = ACTIONS(1442),
    [anon_sym_short] = ACTIONS(1442),
    [anon_sym_static] = ACTIONS(1442),
    [anon_sym_auto] = ACTIONS(1442),
    [anon_sym_register] = ACTIONS(1442),
    [anon_sym_inline] = ACTIONS(1442),
    [anon_sym___inline] = ACTIONS(1442),
    [anon_sym___inline__] = ACTIONS(1442),
    [anon_sym___forceinline] = ACTIONS(1442),
    [anon_sym_thread_local] = ACTIONS(1442),
    [anon_sym___thread] = ACTIONS(1442),
    [anon_sym_const] = ACTIONS(1442),
    [anon_sym_constexpr] = ACTIONS(1442),
    [anon_sym_volatile] = ACTIONS(1442),
    [anon_sym_restrict] = ACTIONS(1442),
    [anon_sym___restrict__] = ACTIONS(1442),
    [anon_sym__Atomic] = ACTIONS(1442),
    [anon_sym__Noreturn] = ACTIONS(1442),
    [anon_sym_noreturn] = ACTIONS(1442),
    [sym_primitive_type] = ACTIONS(1442),
    [anon_sym_enum] = ACTIONS(1442),
    [anon_sym_struct] = ACTIONS(1442),
    [anon_sym_union] = ACTIONS(1442),
    [anon_sym_if] = ACTIONS(1442),
    [anon_sym_switch] = ACTIONS(1442),
    [anon_sym_case] = ACTIONS(1442),
    [anon_sym_default] = ACTIONS(1442),
    [anon_sym_while] = ACTIONS(1442),
    [anon_sym_do] = ACTIONS(1442),
    [anon_sym_for] = ACTIONS(1442),
    [anon_sym_return] = ACTIONS(1442),
    [anon_sym_break] = ACTIONS(1442),
    [anon_sym_continue] = ACTIONS(1442),
    [anon_sym_goto] = ACTIONS(1442),
    [anon_sym___try] = ACTIONS(1442),
    [anon_sym___leave] = ACTIONS(1442),
    [anon_sym_DASH_DASH] = ACTIONS(1444),
    [anon_sym_PLUS_PLUS] = ACTIONS(1444),
    [anon_sym_sizeof] = ACTIONS(1442),
    [anon_sym___alignof__] = ACTIONS(1442),
    [anon_sym___alignof] = ACTIONS(1442),
    [anon_sym__alignof] = ACTIONS(1442),
    [anon_sym_alignof] = ACTIONS(1442),
    [anon_sym__Alignof] = ACTIONS(1442),
    [anon_sym_offsetof] = ACTIONS(1442),
    [anon_sym__Generic] = ACTIONS(1442),
    [anon_sym_asm] = ACTIONS(1442),
    [anon_sym___asm__] = ACTIONS(1442),
    [sym_number_literal] = ACTIONS(1444),
    [anon_sym_L_SQUOTE] = ACTIONS(1444),
    [anon_sym_u_SQUOTE] = ACTIONS(1444),
    [anon_sym_U_SQUOTE] = ACTIONS(1444),
    [anon_sym_u8_SQUOTE] = ACTIONS(1444),
    [anon_sym_SQUOTE] = ACTIONS(1444),
    [anon_sym_L_DQUOTE] = ACTIONS(1444),
    [anon_sym_u_DQUOTE] = ACTIONS(1444),
    [anon_sym_U_DQUOTE] = ACTIONS(1444),
    [anon_sym_u8_DQUOTE] = ACTIONS(1444),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [sym_true] = ACTIONS(1442),
    [sym_false] = ACTIONS(1442),
    [anon_sym_NULL] = ACTIONS(1442),
    [anon_sym_nullptr] = ACTIONS(1442),
    [sym_comment] = ACTIONS(3),
  },
  [149] = {
    [sym_identifier] = ACTIONS(1446),
    [aux_sym_preproc_include_token1] = ACTIONS(1446),
    [aux_sym_preproc_def_token1] = ACTIONS(1446),
    [aux_sym_preproc_if_token1] = ACTIONS(1446),
    [aux_sym_preproc_if_token2] = ACTIONS(1446),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1446),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1446),
    [aux_sym_preproc_else_token1] = ACTIONS(1446),
    [aux_sym_preproc_elif_token1] = ACTIONS(1446),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1446),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1446),
    [sym_preproc_directive] = ACTIONS(1446),
    [anon_sym_LPAREN2] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1446),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym___extension__] = ACTIONS(1446),
    [anon_sym_typedef] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(1446),
    [anon_sym___attribute__] = ACTIONS(1446),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(1446),
    [anon_sym___cdecl] = ACTIONS(1446),
    [anon_sym___clrcall] = ACTIONS(1446),
    [anon_sym___stdcall] = ACTIONS(1446),
    [anon_sym___fastcall] = ACTIONS(1446),
    [anon_sym___thiscall] = ACTIONS(1446),
    [anon_sym___vectorcall] = ACTIONS(1446),
    [anon_sym_LBRACE] = ACTIONS(1448),
    [anon_sym_signed] = ACTIONS(1446),
    [anon_sym_unsigned] = ACTIONS(1446),
    [anon_sym_long] = ACTIONS(1446),
    [anon_sym_short] = ACTIONS(1446),
    [anon_sym_static] = ACTIONS(1446),
    [anon_sym_auto] = ACTIONS(1446),
    [anon_sym_register] = ACTIONS(1446),
    [anon_sym_inline] = ACTIONS(1446),
    [anon_sym___inline] = ACTIONS(1446),
    [anon_sym___inline__] = ACTIONS(1446),
    [anon_sym___forceinline] = ACTIONS(1446),
    [anon_sym_thread_local] = ACTIONS(1446),
    [anon_sym___thread] = ACTIONS(1446),
    [anon_sym_const] = ACTIONS(1446),
    [anon_sym_constexpr] = ACTIONS(1446),
    [anon_sym_volatile] = ACTIONS(1446),
    [anon_sym_restrict] = ACTIONS(1446),
    [anon_sym___restrict__] = ACTIONS(1446),
    [anon_sym__Atomic] = ACTIONS(1446),
    [anon_sym__Noreturn] = ACTIONS(1446),
    [anon_sym_noreturn] = ACTIONS(1446),
    [sym_primitive_type] = ACTIONS(1446),
    [anon_sym_enum] = ACTIONS(1446),
    [anon_sym_struct] = ACTIONS(1446),
    [anon_sym_union] = ACTIONS(1446),
    [anon_sym_if] = ACTIONS(1446),
    [anon_sym_switch] = ACTIONS(1446),
    [anon_sym_case] = ACTIONS(1446),
    [anon_sym_default] = ACTIONS(1446),
    [anon_sym_while] = ACTIONS(1446),
    [anon_sym_do] = ACTIONS(1446),
    [anon_sym_for] = ACTIONS(1446),
    [anon_sym_return] = ACTIONS(1446),
    [anon_sym_break] = ACTIONS(1446),
    [anon_sym_continue] = ACTIONS(1446),
    [anon_sym_goto] = ACTIONS(1446),
    [anon_sym___try] = ACTIONS(1446),
    [anon_sym___leave] = ACTIONS(1446),
    [anon_sym_DASH_DASH] = ACTIONS(1448),
    [anon_sym_PLUS_PLUS] = ACTIONS(1448),
    [anon_sym_sizeof] = ACTIONS(1446),
    [anon_sym___alignof__] = ACTIONS(1446),
    [anon_sym___alignof] = ACTIONS(1446),
    [anon_sym__alignof] = ACTIONS(1446),
    [anon_sym_alignof] = ACTIONS(1446),
    [anon_sym__Alignof] = ACTIONS(1446),
    [anon_sym_offsetof] = ACTIONS(1446),
    [anon_sym__Generic] = ACTIONS(1446),
    [anon_sym_asm] = ACTIONS(1446),
    [anon_sym___asm__] = ACTIONS(1446),
    [sym_number_literal] = ACTIONS(1448),
    [anon_sym_L_SQUOTE] = ACTIONS(1448),
    [anon_sym_u_SQUOTE] = ACTIONS(1448),
    [anon_sym_U_SQUOTE] = ACTIONS(1448),
    [anon_sym_u8_SQUOTE] = ACTIONS(1448),
    [anon_sym_SQUOTE] = ACTIONS(1448),
    [anon_sym_L_DQUOTE] = ACTIONS(1448),
    [anon_sym_u_DQUOTE] = ACTIONS(1448),
    [anon_sym_U_DQUOTE] = ACTIONS(1448),
    [anon_sym_u8_DQUOTE] = ACTIONS(1448),
    [anon_sym_DQUOTE] = ACTIONS(1448),
    [sym_true] = ACTIONS(1446),
    [sym_false] = ACTIONS(1446),
    [anon_sym_NULL] = ACTIONS(1446),
    [anon_sym_nullptr] = ACTIONS(1446),
    [sym_comment] = ACTIONS(3),
  },
  [150] = {
    [sym_identifier] = ACTIONS(1450),
    [aux_sym_preproc_include_token1] = ACTIONS(1450),
    [aux_sym_preproc_def_token1] = ACTIONS(1450),
    [aux_sym_preproc_if_token1] = ACTIONS(1450),
    [aux_sym_preproc_if_token2] = ACTIONS(1450),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1450),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1450),
    [aux_sym_preproc_else_token1] = ACTIONS(1450),
    [aux_sym_preproc_elif_token1] = ACTIONS(1450),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1450),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1450),
    [sym_preproc_directive] = ACTIONS(1450),
    [anon_sym_LPAREN2] = ACTIONS(1452),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_TILDE] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1450),
    [anon_sym_PLUS] = ACTIONS(1450),
    [anon_sym_STAR] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1452),
    [anon_sym_SEMI] = ACTIONS(1452),
    [anon_sym___extension__] = ACTIONS(1450),
    [anon_sym_typedef] = ACTIONS(1450),
    [anon_sym_extern] = ACTIONS(1450),
    [anon_sym___attribute__] = ACTIONS(1450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1452),
    [anon_sym___declspec] = ACTIONS(1450),
    [anon_sym___cdecl] = ACTIONS(1450),
    [anon_sym___clrcall] = ACTIONS(1450),
    [anon_sym___stdcall] = ACTIONS(1450),
    [anon_sym___fastcall] = ACTIONS(1450),
    [anon_sym___thiscall] = ACTIONS(1450),
    [anon_sym___vectorcall] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(1452),
    [anon_sym_signed] = ACTIONS(1450),
    [anon_sym_unsigned] = ACTIONS(1450),
    [anon_sym_long] = ACTIONS(1450),
    [anon_sym_short] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(1450),
    [anon_sym_auto] = ACTIONS(1450),
    [anon_sym_register] = ACTIONS(1450),
    [anon_sym_inline] = ACTIONS(1450),
    [anon_sym___inline] = ACTIONS(1450),
    [anon_sym___inline__] = ACTIONS(1450),
    [anon_sym___forceinline] = ACTIONS(1450),
    [anon_sym_thread_local] = ACTIONS(1450),
    [anon_sym___thread] = ACTIONS(1450),
    [anon_sym_const] = ACTIONS(1450),
    [anon_sym_constexpr] = ACTIONS(1450),
    [anon_sym_volatile] = ACTIONS(1450),
    [anon_sym_restrict] = ACTIONS(1450),
    [anon_sym___restrict__] = ACTIONS(1450),
    [anon_sym__Atomic] = ACTIONS(1450),
    [anon_sym__Noreturn] = ACTIONS(1450),
    [anon_sym_noreturn] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(1450),
    [anon_sym_enum] = ACTIONS(1450),
    [anon_sym_struct] = ACTIONS(1450),
    [anon_sym_union] = ACTIONS(1450),
    [anon_sym_if] = ACTIONS(1450),
    [anon_sym_switch] = ACTIONS(1450),
    [anon_sym_case] = ACTIONS(1450),
    [anon_sym_default] = ACTIONS(1450),
    [anon_sym_while] = ACTIONS(1450),
    [anon_sym_do] = ACTIONS(1450),
    [anon_sym_for] = ACTIONS(1450),
    [anon_sym_return] = ACTIONS(1450),
    [anon_sym_break] = ACTIONS(1450),
    [anon_sym_continue] = ACTIONS(1450),
    [anon_sym_goto] = ACTIONS(1450),
    [anon_sym___try] = ACTIONS(1450),
    [anon_sym___leave] = ACTIONS(1450),
    [anon_sym_DASH_DASH] = ACTIONS(1452),
    [anon_sym_PLUS_PLUS] = ACTIONS(1452),
    [anon_sym_sizeof] = ACTIONS(1450),
    [anon_sym___alignof__] = ACTIONS(1450),
    [anon_sym___alignof] = ACTIONS(1450),
    [anon_sym__alignof] = ACTIONS(1450),
    [anon_sym_alignof] = ACTIONS(1450),
    [anon_sym__Alignof] = ACTIONS(1450),
    [anon_sym_offsetof] = ACTIONS(1450),
    [anon_sym__Generic] = ACTIONS(1450),
    [anon_sym_asm] = ACTIONS(1450),
    [anon_sym___asm__] = ACTIONS(1450),
    [sym_number_literal] = ACTIONS(1452),
    [anon_sym_L_SQUOTE] = ACTIONS(1452),
    [anon_sym_u_SQUOTE] = ACTIONS(1452),
    [anon_sym_U_SQUOTE] = ACTIONS(1452),
    [anon_sym_u8_SQUOTE] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [anon_sym_L_DQUOTE] = ACTIONS(1452),
    [anon_sym_u_DQUOTE] = ACTIONS(1452),
    [anon_sym_U_DQUOTE] = ACTIONS(1452),
    [anon_sym_u8_DQUOTE] = ACTIONS(1452),
    [anon_sym_DQUOTE] = ACTIONS(1452),
    [sym_true] = ACTIONS(1450),
    [sym_false] = ACTIONS(1450),
    [anon_sym_NULL] = ACTIONS(1450),
    [anon_sym_nullptr] = ACTIONS(1450),
    [sym_comment] = ACTIONS(3),
  },
  [151] = {
    [sym_identifier] = ACTIONS(1454),
    [aux_sym_preproc_include_token1] = ACTIONS(1454),
    [aux_sym_preproc_def_token1] = ACTIONS(1454),
    [aux_sym_preproc_if_token1] = ACTIONS(1454),
    [aux_sym_preproc_if_token2] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1454),
    [aux_sym_preproc_else_token1] = ACTIONS(1454),
    [aux_sym_preproc_elif_token1] = ACTIONS(1454),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1454),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1454),
    [sym_preproc_directive] = ACTIONS(1454),
    [anon_sym_LPAREN2] = ACTIONS(1456),
    [anon_sym_BANG] = ACTIONS(1456),
    [anon_sym_TILDE] = ACTIONS(1456),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_STAR] = ACTIONS(1456),
    [anon_sym_AMP] = ACTIONS(1456),
    [anon_sym_SEMI] = ACTIONS(1456),
    [anon_sym___extension__] = ACTIONS(1454),
    [anon_sym_typedef] = ACTIONS(1454),
    [anon_sym_extern] = ACTIONS(1454),
    [anon_sym___attribute__] = ACTIONS(1454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1456),
    [anon_sym___declspec] = ACTIONS(1454),
    [anon_sym___cdecl] = ACTIONS(1454),
    [anon_sym___clrcall] = ACTIONS(1454),
    [anon_sym___stdcall] = ACTIONS(1454),
    [anon_sym___fastcall] = ACTIONS(1454),
    [anon_sym___thiscall] = ACTIONS(1454),
    [anon_sym___vectorcall] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [anon_sym_signed] = ACTIONS(1454),
    [anon_sym_unsigned] = ACTIONS(1454),
    [anon_sym_long] = ACTIONS(1454),
    [anon_sym_short] = ACTIONS(1454),
    [anon_sym_static] = ACTIONS(1454),
    [anon_sym_auto] = ACTIONS(1454),
    [anon_sym_register] = ACTIONS(1454),
    [anon_sym_inline] = ACTIONS(1454),
    [anon_sym___inline] = ACTIONS(1454),
    [anon_sym___inline__] = ACTIONS(1454),
    [anon_sym___forceinline] = ACTIONS(1454),
    [anon_sym_thread_local] = ACTIONS(1454),
    [anon_sym___thread] = ACTIONS(1454),
    [anon_sym_const] = ACTIONS(1454),
    [anon_sym_constexpr] = ACTIONS(1454),
    [anon_sym_volatile] = ACTIONS(1454),
    [anon_sym_restrict] = ACTIONS(1454),
    [anon_sym___restrict__] = ACTIONS(1454),
    [anon_sym__Atomic] = ACTIONS(1454),
    [anon_sym__Noreturn] = ACTIONS(1454),
    [anon_sym_noreturn] = ACTIONS(1454),
    [sym_primitive_type] = ACTIONS(1454),
    [anon_sym_enum] = ACTIONS(1454),
    [anon_sym_struct] = ACTIONS(1454),
    [anon_sym_union] = ACTIONS(1454),
    [anon_sym_if] = ACTIONS(1454),
    [anon_sym_switch] = ACTIONS(1454),
    [anon_sym_case] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(1454),
    [anon_sym_do] = ACTIONS(1454),
    [anon_sym_for] = ACTIONS(1454),
    [anon_sym_return] = ACTIONS(1454),
    [anon_sym_break] = ACTIONS(1454),
    [anon_sym_continue] = ACTIONS(1454),
    [anon_sym_goto] = ACTIONS(1454),
    [anon_sym___try] = ACTIONS(1454),
    [anon_sym___leave] = ACTIONS(1454),
    [anon_sym_DASH_DASH] = ACTIONS(1456),
    [anon_sym_PLUS_PLUS] = ACTIONS(1456),
    [anon_sym_sizeof] = ACTIONS(1454),
    [anon_sym___alignof__] = ACTIONS(1454),
    [anon_sym___alignof] = ACTIONS(1454),
    [anon_sym__alignof] = ACTIONS(1454),
    [anon_sym_alignof] = ACTIONS(1454),
    [anon_sym__Alignof] = ACTIONS(1454),
    [anon_sym_offsetof] = ACTIONS(1454),
    [anon_sym__Generic] = ACTIONS(1454),
    [anon_sym_asm] = ACTIONS(1454),
    [anon_sym___asm__] = ACTIONS(1454),
    [sym_number_literal] = ACTIONS(1456),
    [anon_sym_L_SQUOTE] = ACTIONS(1456),
    [anon_sym_u_SQUOTE] = ACTIONS(1456),
    [anon_sym_U_SQUOTE] = ACTIONS(1456),
    [anon_sym_u8_SQUOTE] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(1456),
    [anon_sym_L_DQUOTE] = ACTIONS(1456),
    [anon_sym_u_DQUOTE] = ACTIONS(1456),
    [anon_sym_U_DQUOTE] = ACTIONS(1456),
    [anon_sym_u8_DQUOTE] = ACTIONS(1456),
    [anon_sym_DQUOTE] = ACTIONS(1456),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [anon_sym_NULL] = ACTIONS(1454),
    [anon_sym_nullptr] = ACTIONS(1454),
    [sym_comment] = ACTIONS(3),
  },
  [152] = {
    [sym_identifier] = ACTIONS(1458),
    [aux_sym_preproc_include_token1] = ACTIONS(1458),
    [aux_sym_preproc_def_token1] = ACTIONS(1458),
    [aux_sym_preproc_if_token1] = ACTIONS(1458),
    [aux_sym_preproc_if_token2] = ACTIONS(1458),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1458),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1458),
    [aux_sym_preproc_else_token1] = ACTIONS(1458),
    [aux_sym_preproc_elif_token1] = ACTIONS(1458),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1458),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1458),
    [sym_preproc_directive] = ACTIONS(1458),
    [anon_sym_LPAREN2] = ACTIONS(1460),
    [anon_sym_BANG] = ACTIONS(1460),
    [anon_sym_TILDE] = ACTIONS(1460),
    [anon_sym_DASH] = ACTIONS(1458),
    [anon_sym_PLUS] = ACTIONS(1458),
    [anon_sym_STAR] = ACTIONS(1460),
    [anon_sym_AMP] = ACTIONS(1460),
    [anon_sym_SEMI] = ACTIONS(1460),
    [anon_sym___extension__] = ACTIONS(1458),
    [anon_sym_typedef] = ACTIONS(1458),
    [anon_sym_extern] = ACTIONS(1458),
    [anon_sym___attribute__] = ACTIONS(1458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1460),
    [anon_sym___declspec] = ACTIONS(1458),
    [anon_sym___cdecl] = ACTIONS(1458),
    [anon_sym___clrcall] = ACTIONS(1458),
    [anon_sym___stdcall] = ACTIONS(1458),
    [anon_sym___fastcall] = ACTIONS(1458),
    [anon_sym___thiscall] = ACTIONS(1458),
    [anon_sym___vectorcall] = ACTIONS(1458),
    [anon_sym_LBRACE] = ACTIONS(1460),
    [anon_sym_signed] = ACTIONS(1458),
    [anon_sym_unsigned] = ACTIONS(1458),
    [anon_sym_long] = ACTIONS(1458),
    [anon_sym_short] = ACTIONS(1458),
    [anon_sym_static] = ACTIONS(1458),
    [anon_sym_auto] = ACTIONS(1458),
    [anon_sym_register] = ACTIONS(1458),
    [anon_sym_inline] = ACTIONS(1458),
    [anon_sym___inline] = ACTIONS(1458),
    [anon_sym___inline__] = ACTIONS(1458),
    [anon_sym___forceinline] = ACTIONS(1458),
    [anon_sym_thread_local] = ACTIONS(1458),
    [anon_sym___thread] = ACTIONS(1458),
    [anon_sym_const] = ACTIONS(1458),
    [anon_sym_constexpr] = ACTIONS(1458),
    [anon_sym_volatile] = ACTIONS(1458),
    [anon_sym_restrict] = ACTIONS(1458),
    [anon_sym___restrict__] = ACTIONS(1458),
    [anon_sym__Atomic] = ACTIONS(1458),
    [anon_sym__Noreturn] = ACTIONS(1458),
    [anon_sym_noreturn] = ACTIONS(1458),
    [sym_primitive_type] = ACTIONS(1458),
    [anon_sym_enum] = ACTIONS(1458),
    [anon_sym_struct] = ACTIONS(1458),
    [anon_sym_union] = ACTIONS(1458),
    [anon_sym_if] = ACTIONS(1458),
    [anon_sym_switch] = ACTIONS(1458),
    [anon_sym_case] = ACTIONS(1458),
    [anon_sym_default] = ACTIONS(1458),
    [anon_sym_while] = ACTIONS(1458),
    [anon_sym_do] = ACTIONS(1458),
    [anon_sym_for] = ACTIONS(1458),
    [anon_sym_return] = ACTIONS(1458),
    [anon_sym_break] = ACTIONS(1458),
    [anon_sym_continue] = ACTIONS(1458),
    [anon_sym_goto] = ACTIONS(1458),
    [anon_sym___try] = ACTIONS(1458),
    [anon_sym___leave] = ACTIONS(1458),
    [anon_sym_DASH_DASH] = ACTIONS(1460),
    [anon_sym_PLUS_PLUS] = ACTIONS(1460),
    [anon_sym_sizeof] = ACTIONS(1458),
    [anon_sym___alignof__] = ACTIONS(1458),
    [anon_sym___alignof] = ACTIONS(1458),
    [anon_sym__alignof] = ACTIONS(1458),
    [anon_sym_alignof] = ACTIONS(1458),
    [anon_sym__Alignof] = ACTIONS(1458),
    [anon_sym_offsetof] = ACTIONS(1458),
    [anon_sym__Generic] = ACTIONS(1458),
    [anon_sym_asm] = ACTIONS(1458),
    [anon_sym___asm__] = ACTIONS(1458),
    [sym_number_literal] = ACTIONS(1460),
    [anon_sym_L_SQUOTE] = ACTIONS(1460),
    [anon_sym_u_SQUOTE] = ACTIONS(1460),
    [anon_sym_U_SQUOTE] = ACTIONS(1460),
    [anon_sym_u8_SQUOTE] = ACTIONS(1460),
    [anon_sym_SQUOTE] = ACTIONS(1460),
    [anon_sym_L_DQUOTE] = ACTIONS(1460),
    [anon_sym_u_DQUOTE] = ACTIONS(1460),
    [anon_sym_U_DQUOTE] = ACTIONS(1460),
    [anon_sym_u8_DQUOTE] = ACTIONS(1460),
    [anon_sym_DQUOTE] = ACTIONS(1460),
    [sym_true] = ACTIONS(1458),
    [sym_false] = ACTIONS(1458),
    [anon_sym_NULL] = ACTIONS(1458),
    [anon_sym_nullptr] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
  },
  [153] = {
    [sym_identifier] = ACTIONS(1462),
    [aux_sym_preproc_include_token1] = ACTIONS(1462),
    [aux_sym_preproc_def_token1] = ACTIONS(1462),
    [aux_sym_preproc_if_token1] = ACTIONS(1462),
    [aux_sym_preproc_if_token2] = ACTIONS(1462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1462),
    [aux_sym_preproc_else_token1] = ACTIONS(1462),
    [aux_sym_preproc_elif_token1] = ACTIONS(1462),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1462),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1462),
    [sym_preproc_directive] = ACTIONS(1462),
    [anon_sym_LPAREN2] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1464),
    [anon_sym_TILDE] = ACTIONS(1464),
    [anon_sym_DASH] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1462),
    [anon_sym_STAR] = ACTIONS(1464),
    [anon_sym_AMP] = ACTIONS(1464),
    [anon_sym_SEMI] = ACTIONS(1464),
    [anon_sym___extension__] = ACTIONS(1462),
    [anon_sym_typedef] = ACTIONS(1462),
    [anon_sym_extern] = ACTIONS(1462),
    [anon_sym___attribute__] = ACTIONS(1462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1464),
    [anon_sym___declspec] = ACTIONS(1462),
    [anon_sym___cdecl] = ACTIONS(1462),
    [anon_sym___clrcall] = ACTIONS(1462),
    [anon_sym___stdcall] = ACTIONS(1462),
    [anon_sym___fastcall] = ACTIONS(1462),
    [anon_sym___thiscall] = ACTIONS(1462),
    [anon_sym___vectorcall] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_signed] = ACTIONS(1462),
    [anon_sym_unsigned] = ACTIONS(1462),
    [anon_sym_long] = ACTIONS(1462),
    [anon_sym_short] = ACTIONS(1462),
    [anon_sym_static] = ACTIONS(1462),
    [anon_sym_auto] = ACTIONS(1462),
    [anon_sym_register] = ACTIONS(1462),
    [anon_sym_inline] = ACTIONS(1462),
    [anon_sym___inline] = ACTIONS(1462),
    [anon_sym___inline__] = ACTIONS(1462),
    [anon_sym___forceinline] = ACTIONS(1462),
    [anon_sym_thread_local] = ACTIONS(1462),
    [anon_sym___thread] = ACTIONS(1462),
    [anon_sym_const] = ACTIONS(1462),
    [anon_sym_constexpr] = ACTIONS(1462),
    [anon_sym_volatile] = ACTIONS(1462),
    [anon_sym_restrict] = ACTIONS(1462),
    [anon_sym___restrict__] = ACTIONS(1462),
    [anon_sym__Atomic] = ACTIONS(1462),
    [anon_sym__Noreturn] = ACTIONS(1462),
    [anon_sym_noreturn] = ACTIONS(1462),
    [sym_primitive_type] = ACTIONS(1462),
    [anon_sym_enum] = ACTIONS(1462),
    [anon_sym_struct] = ACTIONS(1462),
    [anon_sym_union] = ACTIONS(1462),
    [anon_sym_if] = ACTIONS(1462),
    [anon_sym_switch] = ACTIONS(1462),
    [anon_sym_case] = ACTIONS(1462),
    [anon_sym_default] = ACTIONS(1462),
    [anon_sym_while] = ACTIONS(1462),
    [anon_sym_do] = ACTIONS(1462),
    [anon_sym_for] = ACTIONS(1462),
    [anon_sym_return] = ACTIONS(1462),
    [anon_sym_break] = ACTIONS(1462),
    [anon_sym_continue] = ACTIONS(1462),
    [anon_sym_goto] = ACTIONS(1462),
    [anon_sym___try] = ACTIONS(1462),
    [anon_sym___leave] = ACTIONS(1462),
    [anon_sym_DASH_DASH] = ACTIONS(1464),
    [anon_sym_PLUS_PLUS] = ACTIONS(1464),
    [anon_sym_sizeof] = ACTIONS(1462),
    [anon_sym___alignof__] = ACTIONS(1462),
    [anon_sym___alignof] = ACTIONS(1462),
    [anon_sym__alignof] = ACTIONS(1462),
    [anon_sym_alignof] = ACTIONS(1462),
    [anon_sym__Alignof] = ACTIONS(1462),
    [anon_sym_offsetof] = ACTIONS(1462),
    [anon_sym__Generic] = ACTIONS(1462),
    [anon_sym_asm] = ACTIONS(1462),
    [anon_sym___asm__] = ACTIONS(1462),
    [sym_number_literal] = ACTIONS(1464),
    [anon_sym_L_SQUOTE] = ACTIONS(1464),
    [anon_sym_u_SQUOTE] = ACTIONS(1464),
    [anon_sym_U_SQUOTE] = ACTIONS(1464),
    [anon_sym_u8_SQUOTE] = ACTIONS(1464),
    [anon_sym_SQUOTE] = ACTIONS(1464),
    [anon_sym_L_DQUOTE] = ACTIONS(1464),
    [anon_sym_u_DQUOTE] = ACTIONS(1464),
    [anon_sym_U_DQUOTE] = ACTIONS(1464),
    [anon_sym_u8_DQUOTE] = ACTIONS(1464),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_true] = ACTIONS(1462),
    [sym_false] = ACTIONS(1462),
    [anon_sym_NULL] = ACTIONS(1462),
    [anon_sym_nullptr] = ACTIONS(1462),
    [sym_comment] = ACTIONS(3),
  },
  [154] = {
    [sym_identifier] = ACTIONS(1466),
    [aux_sym_preproc_include_token1] = ACTIONS(1466),
    [aux_sym_preproc_def_token1] = ACTIONS(1466),
    [aux_sym_preproc_if_token1] = ACTIONS(1466),
    [aux_sym_preproc_if_token2] = ACTIONS(1466),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1466),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1466),
    [aux_sym_preproc_else_token1] = ACTIONS(1466),
    [aux_sym_preproc_elif_token1] = ACTIONS(1466),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1466),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1466),
    [sym_preproc_directive] = ACTIONS(1466),
    [anon_sym_LPAREN2] = ACTIONS(1468),
    [anon_sym_BANG] = ACTIONS(1468),
    [anon_sym_TILDE] = ACTIONS(1468),
    [anon_sym_DASH] = ACTIONS(1466),
    [anon_sym_PLUS] = ACTIONS(1466),
    [anon_sym_STAR] = ACTIONS(1468),
    [anon_sym_AMP] = ACTIONS(1468),
    [anon_sym_SEMI] = ACTIONS(1468),
    [anon_sym___extension__] = ACTIONS(1466),
    [anon_sym_typedef] = ACTIONS(1466),
    [anon_sym_extern] = ACTIONS(1466),
    [anon_sym___attribute__] = ACTIONS(1466),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1468),
    [anon_sym___declspec] = ACTIONS(1466),
    [anon_sym___cdecl] = ACTIONS(1466),
    [anon_sym___clrcall] = ACTIONS(1466),
    [anon_sym___stdcall] = ACTIONS(1466),
    [anon_sym___fastcall] = ACTIONS(1466),
    [anon_sym___thiscall] = ACTIONS(1466),
    [anon_sym___vectorcall] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(1468),
    [anon_sym_signed] = ACTIONS(1466),
    [anon_sym_unsigned] = ACTIONS(1466),
    [anon_sym_long] = ACTIONS(1466),
    [anon_sym_short] = ACTIONS(1466),
    [anon_sym_static] = ACTIONS(1466),
    [anon_sym_auto] = ACTIONS(1466),
    [anon_sym_register] = ACTIONS(1466),
    [anon_sym_inline] = ACTIONS(1466),
    [anon_sym___inline] = ACTIONS(1466),
    [anon_sym___inline__] = ACTIONS(1466),
    [anon_sym___forceinline] = ACTIONS(1466),
    [anon_sym_thread_local] = ACTIONS(1466),
    [anon_sym___thread] = ACTIONS(1466),
    [anon_sym_const] = ACTIONS(1466),
    [anon_sym_constexpr] = ACTIONS(1466),
    [anon_sym_volatile] = ACTIONS(1466),
    [anon_sym_restrict] = ACTIONS(1466),
    [anon_sym___restrict__] = ACTIONS(1466),
    [anon_sym__Atomic] = ACTIONS(1466),
    [anon_sym__Noreturn] = ACTIONS(1466),
    [anon_sym_noreturn] = ACTIONS(1466),
    [sym_primitive_type] = ACTIONS(1466),
    [anon_sym_enum] = ACTIONS(1466),
    [anon_sym_struct] = ACTIONS(1466),
    [anon_sym_union] = ACTIONS(1466),
    [anon_sym_if] = ACTIONS(1466),
    [anon_sym_switch] = ACTIONS(1466),
    [anon_sym_case] = ACTIONS(1466),
    [anon_sym_default] = ACTIONS(1466),
    [anon_sym_while] = ACTIONS(1466),
    [anon_sym_do] = ACTIONS(1466),
    [anon_sym_for] = ACTIONS(1466),
    [anon_sym_return] = ACTIONS(1466),
    [anon_sym_break] = ACTIONS(1466),
    [anon_sym_continue] = ACTIONS(1466),
    [anon_sym_goto] = ACTIONS(1466),
    [anon_sym___try] = ACTIONS(1466),
    [anon_sym___leave] = ACTIONS(1466),
    [anon_sym_DASH_DASH] = ACTIONS(1468),
    [anon_sym_PLUS_PLUS] = ACTIONS(1468),
    [anon_sym_sizeof] = ACTIONS(1466),
    [anon_sym___alignof__] = ACTIONS(1466),
    [anon_sym___alignof] = ACTIONS(1466),
    [anon_sym__alignof] = ACTIONS(1466),
    [anon_sym_alignof] = ACTIONS(1466),
    [anon_sym__Alignof] = ACTIONS(1466),
    [anon_sym_offsetof] = ACTIONS(1466),
    [anon_sym__Generic] = ACTIONS(1466),
    [anon_sym_asm] = ACTIONS(1466),
    [anon_sym___asm__] = ACTIONS(1466),
    [sym_number_literal] = ACTIONS(1468),
    [anon_sym_L_SQUOTE] = ACTIONS(1468),
    [anon_sym_u_SQUOTE] = ACTIONS(1468),
    [anon_sym_U_SQUOTE] = ACTIONS(1468),
    [anon_sym_u8_SQUOTE] = ACTIONS(1468),
    [anon_sym_SQUOTE] = ACTIONS(1468),
    [anon_sym_L_DQUOTE] = ACTIONS(1468),
    [anon_sym_u_DQUOTE] = ACTIONS(1468),
    [anon_sym_U_DQUOTE] = ACTIONS(1468),
    [anon_sym_u8_DQUOTE] = ACTIONS(1468),
    [anon_sym_DQUOTE] = ACTIONS(1468),
    [sym_true] = ACTIONS(1466),
    [sym_false] = ACTIONS(1466),
    [anon_sym_NULL] = ACTIONS(1466),
    [anon_sym_nullptr] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
  },
  [155] = {
    [sym_identifier] = ACTIONS(1470),
    [aux_sym_preproc_include_token1] = ACTIONS(1470),
    [aux_sym_preproc_def_token1] = ACTIONS(1470),
    [aux_sym_preproc_if_token1] = ACTIONS(1470),
    [aux_sym_preproc_if_token2] = ACTIONS(1470),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1470),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1470),
    [aux_sym_preproc_else_token1] = ACTIONS(1470),
    [aux_sym_preproc_elif_token1] = ACTIONS(1470),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1470),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1470),
    [sym_preproc_directive] = ACTIONS(1470),
    [anon_sym_LPAREN2] = ACTIONS(1472),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_TILDE] = ACTIONS(1472),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_STAR] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1472),
    [anon_sym_SEMI] = ACTIONS(1472),
    [anon_sym___extension__] = ACTIONS(1470),
    [anon_sym_typedef] = ACTIONS(1470),
    [anon_sym_extern] = ACTIONS(1470),
    [anon_sym___attribute__] = ACTIONS(1470),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1472),
    [anon_sym___declspec] = ACTIONS(1470),
    [anon_sym___cdecl] = ACTIONS(1470),
    [anon_sym___clrcall] = ACTIONS(1470),
    [anon_sym___stdcall] = ACTIONS(1470),
    [anon_sym___fastcall] = ACTIONS(1470),
    [anon_sym___thiscall] = ACTIONS(1470),
    [anon_sym___vectorcall] = ACTIONS(1470),
    [anon_sym_LBRACE] = ACTIONS(1472),
    [anon_sym_signed] = ACTIONS(1470),
    [anon_sym_unsigned] = ACTIONS(1470),
    [anon_sym_long] = ACTIONS(1470),
    [anon_sym_short] = ACTIONS(1470),
    [anon_sym_static] = ACTIONS(1470),
    [anon_sym_auto] = ACTIONS(1470),
    [anon_sym_register] = ACTIONS(1470),
    [anon_sym_inline] = ACTIONS(1470),
    [anon_sym___inline] = ACTIONS(1470),
    [anon_sym___inline__] = ACTIONS(1470),
    [anon_sym___forceinline] = ACTIONS(1470),
    [anon_sym_thread_local] = ACTIONS(1470),
    [anon_sym___thread] = ACTIONS(1470),
    [anon_sym_const] = ACTIONS(1470),
    [anon_sym_constexpr] = ACTIONS(1470),
    [anon_sym_volatile] = ACTIONS(1470),
    [anon_sym_restrict] = ACTIONS(1470),
    [anon_sym___restrict__] = ACTIONS(1470),
    [anon_sym__Atomic] = ACTIONS(1470),
    [anon_sym__Noreturn] = ACTIONS(1470),
    [anon_sym_noreturn] = ACTIONS(1470),
    [sym_primitive_type] = ACTIONS(1470),
    [anon_sym_enum] = ACTIONS(1470),
    [anon_sym_struct] = ACTIONS(1470),
    [anon_sym_union] = ACTIONS(1470),
    [anon_sym_if] = ACTIONS(1470),
    [anon_sym_switch] = ACTIONS(1470),
    [anon_sym_case] = ACTIONS(1470),
    [anon_sym_default] = ACTIONS(1470),
    [anon_sym_while] = ACTIONS(1470),
    [anon_sym_do] = ACTIONS(1470),
    [anon_sym_for] = ACTIONS(1470),
    [anon_sym_return] = ACTIONS(1470),
    [anon_sym_break] = ACTIONS(1470),
    [anon_sym_continue] = ACTIONS(1470),
    [anon_sym_goto] = ACTIONS(1470),
    [anon_sym___try] = ACTIONS(1470),
    [anon_sym___leave] = ACTIONS(1470),
    [anon_sym_DASH_DASH] = ACTIONS(1472),
    [anon_sym_PLUS_PLUS] = ACTIONS(1472),
    [anon_sym_sizeof] = ACTIONS(1470),
    [anon_sym___alignof__] = ACTIONS(1470),
    [anon_sym___alignof] = ACTIONS(1470),
    [anon_sym__alignof] = ACTIONS(1470),
    [anon_sym_alignof] = ACTIONS(1470),
    [anon_sym__Alignof] = ACTIONS(1470),
    [anon_sym_offsetof] = ACTIONS(1470),
    [anon_sym__Generic] = ACTIONS(1470),
    [anon_sym_asm] = ACTIONS(1470),
    [anon_sym___asm__] = ACTIONS(1470),
    [sym_number_literal] = ACTIONS(1472),
    [anon_sym_L_SQUOTE] = ACTIONS(1472),
    [anon_sym_u_SQUOTE] = ACTIONS(1472),
    [anon_sym_U_SQUOTE] = ACTIONS(1472),
    [anon_sym_u8_SQUOTE] = ACTIONS(1472),
    [anon_sym_SQUOTE] = ACTIONS(1472),
    [anon_sym_L_DQUOTE] = ACTIONS(1472),
    [anon_sym_u_DQUOTE] = ACTIONS(1472),
    [anon_sym_U_DQUOTE] = ACTIONS(1472),
    [anon_sym_u8_DQUOTE] = ACTIONS(1472),
    [anon_sym_DQUOTE] = ACTIONS(1472),
    [sym_true] = ACTIONS(1470),
    [sym_false] = ACTIONS(1470),
    [anon_sym_NULL] = ACTIONS(1470),
    [anon_sym_nullptr] = ACTIONS(1470),
    [sym_comment] = ACTIONS(3),
  },
  [156] = {
    [sym_identifier] = ACTIONS(1474),
    [aux_sym_preproc_include_token1] = ACTIONS(1474),
    [aux_sym_preproc_def_token1] = ACTIONS(1474),
    [aux_sym_preproc_if_token1] = ACTIONS(1474),
    [aux_sym_preproc_if_token2] = ACTIONS(1474),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1474),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1474),
    [aux_sym_preproc_else_token1] = ACTIONS(1474),
    [aux_sym_preproc_elif_token1] = ACTIONS(1474),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1474),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1474),
    [sym_preproc_directive] = ACTIONS(1474),
    [anon_sym_LPAREN2] = ACTIONS(1476),
    [anon_sym_BANG] = ACTIONS(1476),
    [anon_sym_TILDE] = ACTIONS(1476),
    [anon_sym_DASH] = ACTIONS(1474),
    [anon_sym_PLUS] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_SEMI] = ACTIONS(1476),
    [anon_sym___extension__] = ACTIONS(1474),
    [anon_sym_typedef] = ACTIONS(1474),
    [anon_sym_extern] = ACTIONS(1474),
    [anon_sym___attribute__] = ACTIONS(1474),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1476),
    [anon_sym___declspec] = ACTIONS(1474),
    [anon_sym___cdecl] = ACTIONS(1474),
    [anon_sym___clrcall] = ACTIONS(1474),
    [anon_sym___stdcall] = ACTIONS(1474),
    [anon_sym___fastcall] = ACTIONS(1474),
    [anon_sym___thiscall] = ACTIONS(1474),
    [anon_sym___vectorcall] = ACTIONS(1474),
    [anon_sym_LBRACE] = ACTIONS(1476),
    [anon_sym_signed] = ACTIONS(1474),
    [anon_sym_unsigned] = ACTIONS(1474),
    [anon_sym_long] = ACTIONS(1474),
    [anon_sym_short] = ACTIONS(1474),
    [anon_sym_static] = ACTIONS(1474),
    [anon_sym_auto] = ACTIONS(1474),
    [anon_sym_register] = ACTIONS(1474),
    [anon_sym_inline] = ACTIONS(1474),
    [anon_sym___inline] = ACTIONS(1474),
    [anon_sym___inline__] = ACTIONS(1474),
    [anon_sym___forceinline] = ACTIONS(1474),
    [anon_sym_thread_local] = ACTIONS(1474),
    [anon_sym___thread] = ACTIONS(1474),
    [anon_sym_const] = ACTIONS(1474),
    [anon_sym_constexpr] = ACTIONS(1474),
    [anon_sym_volatile] = ACTIONS(1474),
    [anon_sym_restrict] = ACTIONS(1474),
    [anon_sym___restrict__] = ACTIONS(1474),
    [anon_sym__Atomic] = ACTIONS(1474),
    [anon_sym__Noreturn] = ACTIONS(1474),
    [anon_sym_noreturn] = ACTIONS(1474),
    [sym_primitive_type] = ACTIONS(1474),
    [anon_sym_enum] = ACTIONS(1474),
    [anon_sym_struct] = ACTIONS(1474),
    [anon_sym_union] = ACTIONS(1474),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_switch] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1474),
    [anon_sym_default] = ACTIONS(1474),
    [anon_sym_while] = ACTIONS(1474),
    [anon_sym_do] = ACTIONS(1474),
    [anon_sym_for] = ACTIONS(1474),
    [anon_sym_return] = ACTIONS(1474),
    [anon_sym_break] = ACTIONS(1474),
    [anon_sym_continue] = ACTIONS(1474),
    [anon_sym_goto] = ACTIONS(1474),
    [anon_sym___try] = ACTIONS(1474),
    [anon_sym___leave] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1476),
    [anon_sym_PLUS_PLUS] = ACTIONS(1476),
    [anon_sym_sizeof] = ACTIONS(1474),
    [anon_sym___alignof__] = ACTIONS(1474),
    [anon_sym___alignof] = ACTIONS(1474),
    [anon_sym__alignof] = ACTIONS(1474),
    [anon_sym_alignof] = ACTIONS(1474),
    [anon_sym__Alignof] = ACTIONS(1474),
    [anon_sym_offsetof] = ACTIONS(1474),
    [anon_sym__Generic] = ACTIONS(1474),
    [anon_sym_asm] = ACTIONS(1474),
    [anon_sym___asm__] = ACTIONS(1474),
    [sym_number_literal] = ACTIONS(1476),
    [anon_sym_L_SQUOTE] = ACTIONS(1476),
    [anon_sym_u_SQUOTE] = ACTIONS(1476),
    [anon_sym_U_SQUOTE] = ACTIONS(1476),
    [anon_sym_u8_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1476),
    [anon_sym_L_DQUOTE] = ACTIONS(1476),
    [anon_sym_u_DQUOTE] = ACTIONS(1476),
    [anon_sym_U_DQUOTE] = ACTIONS(1476),
    [anon_sym_u8_DQUOTE] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [sym_true] = ACTIONS(1474),
    [sym_false] = ACTIONS(1474),
    [anon_sym_NULL] = ACTIONS(1474),
    [anon_sym_nullptr] = ACTIONS(1474),
    [sym_comment] = ACTIONS(3),
  },
  [157] = {
    [sym_identifier] = ACTIONS(1478),
    [aux_sym_preproc_include_token1] = ACTIONS(1478),
    [aux_sym_preproc_def_token1] = ACTIONS(1478),
    [aux_sym_preproc_if_token1] = ACTIONS(1478),
    [aux_sym_preproc_if_token2] = ACTIONS(1478),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1478),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1478),
    [aux_sym_preproc_else_token1] = ACTIONS(1478),
    [aux_sym_preproc_elif_token1] = ACTIONS(1478),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1478),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1478),
    [sym_preproc_directive] = ACTIONS(1478),
    [anon_sym_LPAREN2] = ACTIONS(1480),
    [anon_sym_BANG] = ACTIONS(1480),
    [anon_sym_TILDE] = ACTIONS(1480),
    [anon_sym_DASH] = ACTIONS(1478),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_STAR] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1480),
    [anon_sym_SEMI] = ACTIONS(1480),
    [anon_sym___extension__] = ACTIONS(1478),
    [anon_sym_typedef] = ACTIONS(1478),
    [anon_sym_extern] = ACTIONS(1478),
    [anon_sym___attribute__] = ACTIONS(1478),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1480),
    [anon_sym___declspec] = ACTIONS(1478),
    [anon_sym___cdecl] = ACTIONS(1478),
    [anon_sym___clrcall] = ACTIONS(1478),
    [anon_sym___stdcall] = ACTIONS(1478),
    [anon_sym___fastcall] = ACTIONS(1478),
    [anon_sym___thiscall] = ACTIONS(1478),
    [anon_sym___vectorcall] = ACTIONS(1478),
    [anon_sym_LBRACE] = ACTIONS(1480),
    [anon_sym_signed] = ACTIONS(1478),
    [anon_sym_unsigned] = ACTIONS(1478),
    [anon_sym_long] = ACTIONS(1478),
    [anon_sym_short] = ACTIONS(1478),
    [anon_sym_static] = ACTIONS(1478),
    [anon_sym_auto] = ACTIONS(1478),
    [anon_sym_register] = ACTIONS(1478),
    [anon_sym_inline] = ACTIONS(1478),
    [anon_sym___inline] = ACTIONS(1478),
    [anon_sym___inline__] = ACTIONS(1478),
    [anon_sym___forceinline] = ACTIONS(1478),
    [anon_sym_thread_local] = ACTIONS(1478),
    [anon_sym___thread] = ACTIONS(1478),
    [anon_sym_const] = ACTIONS(1478),
    [anon_sym_constexpr] = ACTIONS(1478),
    [anon_sym_volatile] = ACTIONS(1478),
    [anon_sym_restrict] = ACTIONS(1478),
    [anon_sym___restrict__] = ACTIONS(1478),
    [anon_sym__Atomic] = ACTIONS(1478),
    [anon_sym__Noreturn] = ACTIONS(1478),
    [anon_sym_noreturn] = ACTIONS(1478),
    [sym_primitive_type] = ACTIONS(1478),
    [anon_sym_enum] = ACTIONS(1478),
    [anon_sym_struct] = ACTIONS(1478),
    [anon_sym_union] = ACTIONS(1478),
    [anon_sym_if] = ACTIONS(1478),
    [anon_sym_switch] = ACTIONS(1478),
    [anon_sym_case] = ACTIONS(1478),
    [anon_sym_default] = ACTIONS(1478),
    [anon_sym_while] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_for] = ACTIONS(1478),
    [anon_sym_return] = ACTIONS(1478),
    [anon_sym_break] = ACTIONS(1478),
    [anon_sym_continue] = ACTIONS(1478),
    [anon_sym_goto] = ACTIONS(1478),
    [anon_sym___try] = ACTIONS(1478),
    [anon_sym___leave] = ACTIONS(1478),
    [anon_sym_DASH_DASH] = ACTIONS(1480),
    [anon_sym_PLUS_PLUS] = ACTIONS(1480),
    [anon_sym_sizeof] = ACTIONS(1478),
    [anon_sym___alignof__] = ACTIONS(1478),
    [anon_sym___alignof] = ACTIONS(1478),
    [anon_sym__alignof] = ACTIONS(1478),
    [anon_sym_alignof] = ACTIONS(1478),
    [anon_sym__Alignof] = ACTIONS(1478),
    [anon_sym_offsetof] = ACTIONS(1478),
    [anon_sym__Generic] = ACTIONS(1478),
    [anon_sym_asm] = ACTIONS(1478),
    [anon_sym___asm__] = ACTIONS(1478),
    [sym_number_literal] = ACTIONS(1480),
    [anon_sym_L_SQUOTE] = ACTIONS(1480),
    [anon_sym_u_SQUOTE] = ACTIONS(1480),
    [anon_sym_U_SQUOTE] = ACTIONS(1480),
    [anon_sym_u8_SQUOTE] = ACTIONS(1480),
    [anon_sym_SQUOTE] = ACTIONS(1480),
    [anon_sym_L_DQUOTE] = ACTIONS(1480),
    [anon_sym_u_DQUOTE] = ACTIONS(1480),
    [anon_sym_U_DQUOTE] = ACTIONS(1480),
    [anon_sym_u8_DQUOTE] = ACTIONS(1480),
    [anon_sym_DQUOTE] = ACTIONS(1480),
    [sym_true] = ACTIONS(1478),
    [sym_false] = ACTIONS(1478),
    [anon_sym_NULL] = ACTIONS(1478),
    [anon_sym_nullptr] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
  },
  [158] = {
    [sym_identifier] = ACTIONS(1482),
    [aux_sym_preproc_include_token1] = ACTIONS(1482),
    [aux_sym_preproc_def_token1] = ACTIONS(1482),
    [aux_sym_preproc_if_token1] = ACTIONS(1482),
    [aux_sym_preproc_if_token2] = ACTIONS(1482),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1482),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1482),
    [aux_sym_preproc_else_token1] = ACTIONS(1482),
    [aux_sym_preproc_elif_token1] = ACTIONS(1482),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1482),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1482),
    [sym_preproc_directive] = ACTIONS(1482),
    [anon_sym_LPAREN2] = ACTIONS(1484),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_TILDE] = ACTIONS(1484),
    [anon_sym_DASH] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_STAR] = ACTIONS(1484),
    [anon_sym_AMP] = ACTIONS(1484),
    [anon_sym_SEMI] = ACTIONS(1484),
    [anon_sym___extension__] = ACTIONS(1482),
    [anon_sym_typedef] = ACTIONS(1482),
    [anon_sym_extern] = ACTIONS(1482),
    [anon_sym___attribute__] = ACTIONS(1482),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1484),
    [anon_sym___declspec] = ACTIONS(1482),
    [anon_sym___cdecl] = ACTIONS(1482),
    [anon_sym___clrcall] = ACTIONS(1482),
    [anon_sym___stdcall] = ACTIONS(1482),
    [anon_sym___fastcall] = ACTIONS(1482),
    [anon_sym___thiscall] = ACTIONS(1482),
    [anon_sym___vectorcall] = ACTIONS(1482),
    [anon_sym_LBRACE] = ACTIONS(1484),
    [anon_sym_signed] = ACTIONS(1482),
    [anon_sym_unsigned] = ACTIONS(1482),
    [anon_sym_long] = ACTIONS(1482),
    [anon_sym_short] = ACTIONS(1482),
    [anon_sym_static] = ACTIONS(1482),
    [anon_sym_auto] = ACTIONS(1482),
    [anon_sym_register] = ACTIONS(1482),
    [anon_sym_inline] = ACTIONS(1482),
    [anon_sym___inline] = ACTIONS(1482),
    [anon_sym___inline__] = ACTIONS(1482),
    [anon_sym___forceinline] = ACTIONS(1482),
    [anon_sym_thread_local] = ACTIONS(1482),
    [anon_sym___thread] = ACTIONS(1482),
    [anon_sym_const] = ACTIONS(1482),
    [anon_sym_constexpr] = ACTIONS(1482),
    [anon_sym_volatile] = ACTIONS(1482),
    [anon_sym_restrict] = ACTIONS(1482),
    [anon_sym___restrict__] = ACTIONS(1482),
    [anon_sym__Atomic] = ACTIONS(1482),
    [anon_sym__Noreturn] = ACTIONS(1482),
    [anon_sym_noreturn] = ACTIONS(1482),
    [sym_primitive_type] = ACTIONS(1482),
    [anon_sym_enum] = ACTIONS(1482),
    [anon_sym_struct] = ACTIONS(1482),
    [anon_sym_union] = ACTIONS(1482),
    [anon_sym_if] = ACTIONS(1482),
    [anon_sym_switch] = ACTIONS(1482),
    [anon_sym_case] = ACTIONS(1482),
    [anon_sym_default] = ACTIONS(1482),
    [anon_sym_while] = ACTIONS(1482),
    [anon_sym_do] = ACTIONS(1482),
    [anon_sym_for] = ACTIONS(1482),
    [anon_sym_return] = ACTIONS(1482),
    [anon_sym_break] = ACTIONS(1482),
    [anon_sym_continue] = ACTIONS(1482),
    [anon_sym_goto] = ACTIONS(1482),
    [anon_sym___try] = ACTIONS(1482),
    [anon_sym___leave] = ACTIONS(1482),
    [anon_sym_DASH_DASH] = ACTIONS(1484),
    [anon_sym_PLUS_PLUS] = ACTIONS(1484),
    [anon_sym_sizeof] = ACTIONS(1482),
    [anon_sym___alignof__] = ACTIONS(1482),
    [anon_sym___alignof] = ACTIONS(1482),
    [anon_sym__alignof] = ACTIONS(1482),
    [anon_sym_alignof] = ACTIONS(1482),
    [anon_sym__Alignof] = ACTIONS(1482),
    [anon_sym_offsetof] = ACTIONS(1482),
    [anon_sym__Generic] = ACTIONS(1482),
    [anon_sym_asm] = ACTIONS(1482),
    [anon_sym___asm__] = ACTIONS(1482),
    [sym_number_literal] = ACTIONS(1484),
    [anon_sym_L_SQUOTE] = ACTIONS(1484),
    [anon_sym_u_SQUOTE] = ACTIONS(1484),
    [anon_sym_U_SQUOTE] = ACTIONS(1484),
    [anon_sym_u8_SQUOTE] = ACTIONS(1484),
    [anon_sym_SQUOTE] = ACTIONS(1484),
    [anon_sym_L_DQUOTE] = ACTIONS(1484),
    [anon_sym_u_DQUOTE] = ACTIONS(1484),
    [anon_sym_U_DQUOTE] = ACTIONS(1484),
    [anon_sym_u8_DQUOTE] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(1484),
    [sym_true] = ACTIONS(1482),
    [sym_false] = ACTIONS(1482),
    [anon_sym_NULL] = ACTIONS(1482),
    [anon_sym_nullptr] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
  },
  [159] = {
    [sym_identifier] = ACTIONS(1486),
    [aux_sym_preproc_include_token1] = ACTIONS(1486),
    [aux_sym_preproc_def_token1] = ACTIONS(1486),
    [aux_sym_preproc_if_token1] = ACTIONS(1486),
    [aux_sym_preproc_if_token2] = ACTIONS(1486),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1486),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1486),
    [aux_sym_preproc_else_token1] = ACTIONS(1486),
    [aux_sym_preproc_elif_token1] = ACTIONS(1486),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1486),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1486),
    [sym_preproc_directive] = ACTIONS(1486),
    [anon_sym_LPAREN2] = ACTIONS(1488),
    [anon_sym_BANG] = ACTIONS(1488),
    [anon_sym_TILDE] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_STAR] = ACTIONS(1488),
    [anon_sym_AMP] = ACTIONS(1488),
    [anon_sym_SEMI] = ACTIONS(1488),
    [anon_sym___extension__] = ACTIONS(1486),
    [anon_sym_typedef] = ACTIONS(1486),
    [anon_sym_extern] = ACTIONS(1486),
    [anon_sym___attribute__] = ACTIONS(1486),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1488),
    [anon_sym___declspec] = ACTIONS(1486),
    [anon_sym___cdecl] = ACTIONS(1486),
    [anon_sym___clrcall] = ACTIONS(1486),
    [anon_sym___stdcall] = ACTIONS(1486),
    [anon_sym___fastcall] = ACTIONS(1486),
    [anon_sym___thiscall] = ACTIONS(1486),
    [anon_sym___vectorcall] = ACTIONS(1486),
    [anon_sym_LBRACE] = ACTIONS(1488),
    [anon_sym_signed] = ACTIONS(1486),
    [anon_sym_unsigned] = ACTIONS(1486),
    [anon_sym_long] = ACTIONS(1486),
    [anon_sym_short] = ACTIONS(1486),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_auto] = ACTIONS(1486),
    [anon_sym_register] = ACTIONS(1486),
    [anon_sym_inline] = ACTIONS(1486),
    [anon_sym___inline] = ACTIONS(1486),
    [anon_sym___inline__] = ACTIONS(1486),
    [anon_sym___forceinline] = ACTIONS(1486),
    [anon_sym_thread_local] = ACTIONS(1486),
    [anon_sym___thread] = ACTIONS(1486),
    [anon_sym_const] = ACTIONS(1486),
    [anon_sym_constexpr] = ACTIONS(1486),
    [anon_sym_volatile] = ACTIONS(1486),
    [anon_sym_restrict] = ACTIONS(1486),
    [anon_sym___restrict__] = ACTIONS(1486),
    [anon_sym__Atomic] = ACTIONS(1486),
    [anon_sym__Noreturn] = ACTIONS(1486),
    [anon_sym_noreturn] = ACTIONS(1486),
    [sym_primitive_type] = ACTIONS(1486),
    [anon_sym_enum] = ACTIONS(1486),
    [anon_sym_struct] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(1486),
    [anon_sym_if] = ACTIONS(1486),
    [anon_sym_switch] = ACTIONS(1486),
    [anon_sym_case] = ACTIONS(1486),
    [anon_sym_default] = ACTIONS(1486),
    [anon_sym_while] = ACTIONS(1486),
    [anon_sym_do] = ACTIONS(1486),
    [anon_sym_for] = ACTIONS(1486),
    [anon_sym_return] = ACTIONS(1486),
    [anon_sym_break] = ACTIONS(1486),
    [anon_sym_continue] = ACTIONS(1486),
    [anon_sym_goto] = ACTIONS(1486),
    [anon_sym___try] = ACTIONS(1486),
    [anon_sym___leave] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1488),
    [anon_sym_PLUS_PLUS] = ACTIONS(1488),
    [anon_sym_sizeof] = ACTIONS(1486),
    [anon_sym___alignof__] = ACTIONS(1486),
    [anon_sym___alignof] = ACTIONS(1486),
    [anon_sym__alignof] = ACTIONS(1486),
    [anon_sym_alignof] = ACTIONS(1486),
    [anon_sym__Alignof] = ACTIONS(1486),
    [anon_sym_offsetof] = ACTIONS(1486),
    [anon_sym__Generic] = ACTIONS(1486),
    [anon_sym_asm] = ACTIONS(1486),
    [anon_sym___asm__] = ACTIONS(1486),
    [sym_number_literal] = ACTIONS(1488),
    [anon_sym_L_SQUOTE] = ACTIONS(1488),
    [anon_sym_u_SQUOTE] = ACTIONS(1488),
    [anon_sym_U_SQUOTE] = ACTIONS(1488),
    [anon_sym_u8_SQUOTE] = ACTIONS(1488),
    [anon_sym_SQUOTE] = ACTIONS(1488),
    [anon_sym_L_DQUOTE] = ACTIONS(1488),
    [anon_sym_u_DQUOTE] = ACTIONS(1488),
    [anon_sym_U_DQUOTE] = ACTIONS(1488),
    [anon_sym_u8_DQUOTE] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(1488),
    [sym_true] = ACTIONS(1486),
    [sym_false] = ACTIONS(1486),
    [anon_sym_NULL] = ACTIONS(1486),
    [anon_sym_nullptr] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
  },
  [160] = {
    [sym_identifier] = ACTIONS(1490),
    [aux_sym_preproc_include_token1] = ACTIONS(1490),
    [aux_sym_preproc_def_token1] = ACTIONS(1490),
    [aux_sym_preproc_if_token1] = ACTIONS(1490),
    [aux_sym_preproc_if_token2] = ACTIONS(1490),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1490),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1490),
    [aux_sym_preproc_else_token1] = ACTIONS(1490),
    [aux_sym_preproc_elif_token1] = ACTIONS(1490),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1490),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1490),
    [sym_preproc_directive] = ACTIONS(1490),
    [anon_sym_LPAREN2] = ACTIONS(1492),
    [anon_sym_BANG] = ACTIONS(1492),
    [anon_sym_TILDE] = ACTIONS(1492),
    [anon_sym_DASH] = ACTIONS(1490),
    [anon_sym_PLUS] = ACTIONS(1490),
    [anon_sym_STAR] = ACTIONS(1492),
    [anon_sym_AMP] = ACTIONS(1492),
    [anon_sym_SEMI] = ACTIONS(1492),
    [anon_sym___extension__] = ACTIONS(1490),
    [anon_sym_typedef] = ACTIONS(1490),
    [anon_sym_extern] = ACTIONS(1490),
    [anon_sym___attribute__] = ACTIONS(1490),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1492),
    [anon_sym___declspec] = ACTIONS(1490),
    [anon_sym___cdecl] = ACTIONS(1490),
    [anon_sym___clrcall] = ACTIONS(1490),
    [anon_sym___stdcall] = ACTIONS(1490),
    [anon_sym___fastcall] = ACTIONS(1490),
    [anon_sym___thiscall] = ACTIONS(1490),
    [anon_sym___vectorcall] = ACTIONS(1490),
    [anon_sym_LBRACE] = ACTIONS(1492),
    [anon_sym_signed] = ACTIONS(1490),
    [anon_sym_unsigned] = ACTIONS(1490),
    [anon_sym_long] = ACTIONS(1490),
    [anon_sym_short] = ACTIONS(1490),
    [anon_sym_static] = ACTIONS(1490),
    [anon_sym_auto] = ACTIONS(1490),
    [anon_sym_register] = ACTIONS(1490),
    [anon_sym_inline] = ACTIONS(1490),
    [anon_sym___inline] = ACTIONS(1490),
    [anon_sym___inline__] = ACTIONS(1490),
    [anon_sym___forceinline] = ACTIONS(1490),
    [anon_sym_thread_local] = ACTIONS(1490),
    [anon_sym___thread] = ACTIONS(1490),
    [anon_sym_const] = ACTIONS(1490),
    [anon_sym_constexpr] = ACTIONS(1490),
    [anon_sym_volatile] = ACTIONS(1490),
    [anon_sym_restrict] = ACTIONS(1490),
    [anon_sym___restrict__] = ACTIONS(1490),
    [anon_sym__Atomic] = ACTIONS(1490),
    [anon_sym__Noreturn] = ACTIONS(1490),
    [anon_sym_noreturn] = ACTIONS(1490),
    [sym_primitive_type] = ACTIONS(1490),
    [anon_sym_enum] = ACTIONS(1490),
    [anon_sym_struct] = ACTIONS(1490),
    [anon_sym_union] = ACTIONS(1490),
    [anon_sym_if] = ACTIONS(1490),
    [anon_sym_switch] = ACTIONS(1490),
    [anon_sym_case] = ACTIONS(1490),
    [anon_sym_default] = ACTIONS(1490),
    [anon_sym_while] = ACTIONS(1490),
    [anon_sym_do] = ACTIONS(1490),
    [anon_sym_for] = ACTIONS(1490),
    [anon_sym_return] = ACTIONS(1490),
    [anon_sym_break] = ACTIONS(1490),
    [anon_sym_continue] = ACTIONS(1490),
    [anon_sym_goto] = ACTIONS(1490),
    [anon_sym___try] = ACTIONS(1490),
    [anon_sym___leave] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1492),
    [anon_sym_PLUS_PLUS] = ACTIONS(1492),
    [anon_sym_sizeof] = ACTIONS(1490),
    [anon_sym___alignof__] = ACTIONS(1490),
    [anon_sym___alignof] = ACTIONS(1490),
    [anon_sym__alignof] = ACTIONS(1490),
    [anon_sym_alignof] = ACTIONS(1490),
    [anon_sym__Alignof] = ACTIONS(1490),
    [anon_sym_offsetof] = ACTIONS(1490),
    [anon_sym__Generic] = ACTIONS(1490),
    [anon_sym_asm] = ACTIONS(1490),
    [anon_sym___asm__] = ACTIONS(1490),
    [sym_number_literal] = ACTIONS(1492),
    [anon_sym_L_SQUOTE] = ACTIONS(1492),
    [anon_sym_u_SQUOTE] = ACTIONS(1492),
    [anon_sym_U_SQUOTE] = ACTIONS(1492),
    [anon_sym_u8_SQUOTE] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1492),
    [anon_sym_L_DQUOTE] = ACTIONS(1492),
    [anon_sym_u_DQUOTE] = ACTIONS(1492),
    [anon_sym_U_DQUOTE] = ACTIONS(1492),
    [anon_sym_u8_DQUOTE] = ACTIONS(1492),
    [anon_sym_DQUOTE] = ACTIONS(1492),
    [sym_true] = ACTIONS(1490),
    [sym_false] = ACTIONS(1490),
    [anon_sym_NULL] = ACTIONS(1490),
    [anon_sym_nullptr] = ACTIONS(1490),
    [sym_comment] = ACTIONS(3),
  },
  [161] = {
    [sym_identifier] = ACTIONS(1494),
    [aux_sym_preproc_include_token1] = ACTIONS(1494),
    [aux_sym_preproc_def_token1] = ACTIONS(1494),
    [aux_sym_preproc_if_token1] = ACTIONS(1494),
    [aux_sym_preproc_if_token2] = ACTIONS(1494),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1494),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1494),
    [aux_sym_preproc_else_token1] = ACTIONS(1494),
    [aux_sym_preproc_elif_token1] = ACTIONS(1494),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1494),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1494),
    [sym_preproc_directive] = ACTIONS(1494),
    [anon_sym_LPAREN2] = ACTIONS(1496),
    [anon_sym_BANG] = ACTIONS(1496),
    [anon_sym_TILDE] = ACTIONS(1496),
    [anon_sym_DASH] = ACTIONS(1494),
    [anon_sym_PLUS] = ACTIONS(1494),
    [anon_sym_STAR] = ACTIONS(1496),
    [anon_sym_AMP] = ACTIONS(1496),
    [anon_sym_SEMI] = ACTIONS(1496),
    [anon_sym___extension__] = ACTIONS(1494),
    [anon_sym_typedef] = ACTIONS(1494),
    [anon_sym_extern] = ACTIONS(1494),
    [anon_sym___attribute__] = ACTIONS(1494),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1496),
    [anon_sym___declspec] = ACTIONS(1494),
    [anon_sym___cdecl] = ACTIONS(1494),
    [anon_sym___clrcall] = ACTIONS(1494),
    [anon_sym___stdcall] = ACTIONS(1494),
    [anon_sym___fastcall] = ACTIONS(1494),
    [anon_sym___thiscall] = ACTIONS(1494),
    [anon_sym___vectorcall] = ACTIONS(1494),
    [anon_sym_LBRACE] = ACTIONS(1496),
    [anon_sym_signed] = ACTIONS(1494),
    [anon_sym_unsigned] = ACTIONS(1494),
    [anon_sym_long] = ACTIONS(1494),
    [anon_sym_short] = ACTIONS(1494),
    [anon_sym_static] = ACTIONS(1494),
    [anon_sym_auto] = ACTIONS(1494),
    [anon_sym_register] = ACTIONS(1494),
    [anon_sym_inline] = ACTIONS(1494),
    [anon_sym___inline] = ACTIONS(1494),
    [anon_sym___inline__] = ACTIONS(1494),
    [anon_sym___forceinline] = ACTIONS(1494),
    [anon_sym_thread_local] = ACTIONS(1494),
    [anon_sym___thread] = ACTIONS(1494),
    [anon_sym_const] = ACTIONS(1494),
    [anon_sym_constexpr] = ACTIONS(1494),
    [anon_sym_volatile] = ACTIONS(1494),
    [anon_sym_restrict] = ACTIONS(1494),
    [anon_sym___restrict__] = ACTIONS(1494),
    [anon_sym__Atomic] = ACTIONS(1494),
    [anon_sym__Noreturn] = ACTIONS(1494),
    [anon_sym_noreturn] = ACTIONS(1494),
    [sym_primitive_type] = ACTIONS(1494),
    [anon_sym_enum] = ACTIONS(1494),
    [anon_sym_struct] = ACTIONS(1494),
    [anon_sym_union] = ACTIONS(1494),
    [anon_sym_if] = ACTIONS(1494),
    [anon_sym_switch] = ACTIONS(1494),
    [anon_sym_case] = ACTIONS(1494),
    [anon_sym_default] = ACTIONS(1494),
    [anon_sym_while] = ACTIONS(1494),
    [anon_sym_do] = ACTIONS(1494),
    [anon_sym_for] = ACTIONS(1494),
    [anon_sym_return] = ACTIONS(1494),
    [anon_sym_break] = ACTIONS(1494),
    [anon_sym_continue] = ACTIONS(1494),
    [anon_sym_goto] = ACTIONS(1494),
    [anon_sym___try] = ACTIONS(1494),
    [anon_sym___leave] = ACTIONS(1494),
    [anon_sym_DASH_DASH] = ACTIONS(1496),
    [anon_sym_PLUS_PLUS] = ACTIONS(1496),
    [anon_sym_sizeof] = ACTIONS(1494),
    [anon_sym___alignof__] = ACTIONS(1494),
    [anon_sym___alignof] = ACTIONS(1494),
    [anon_sym__alignof] = ACTIONS(1494),
    [anon_sym_alignof] = ACTIONS(1494),
    [anon_sym__Alignof] = ACTIONS(1494),
    [anon_sym_offsetof] = ACTIONS(1494),
    [anon_sym__Generic] = ACTIONS(1494),
    [anon_sym_asm] = ACTIONS(1494),
    [anon_sym___asm__] = ACTIONS(1494),
    [sym_number_literal] = ACTIONS(1496),
    [anon_sym_L_SQUOTE] = ACTIONS(1496),
    [anon_sym_u_SQUOTE] = ACTIONS(1496),
    [anon_sym_U_SQUOTE] = ACTIONS(1496),
    [anon_sym_u8_SQUOTE] = ACTIONS(1496),
    [anon_sym_SQUOTE] = ACTIONS(1496),
    [anon_sym_L_DQUOTE] = ACTIONS(1496),
    [anon_sym_u_DQUOTE] = ACTIONS(1496),
    [anon_sym_U_DQUOTE] = ACTIONS(1496),
    [anon_sym_u8_DQUOTE] = ACTIONS(1496),
    [anon_sym_DQUOTE] = ACTIONS(1496),
    [sym_true] = ACTIONS(1494),
    [sym_false] = ACTIONS(1494),
    [anon_sym_NULL] = ACTIONS(1494),
    [anon_sym_nullptr] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
  },
  [162] = {
    [sym_identifier] = ACTIONS(1498),
    [aux_sym_preproc_include_token1] = ACTIONS(1498),
    [aux_sym_preproc_def_token1] = ACTIONS(1498),
    [aux_sym_preproc_if_token1] = ACTIONS(1498),
    [aux_sym_preproc_if_token2] = ACTIONS(1498),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1498),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1498),
    [aux_sym_preproc_else_token1] = ACTIONS(1498),
    [aux_sym_preproc_elif_token1] = ACTIONS(1498),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1498),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1498),
    [sym_preproc_directive] = ACTIONS(1498),
    [anon_sym_LPAREN2] = ACTIONS(1500),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_TILDE] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1498),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_SEMI] = ACTIONS(1500),
    [anon_sym___extension__] = ACTIONS(1498),
    [anon_sym_typedef] = ACTIONS(1498),
    [anon_sym_extern] = ACTIONS(1498),
    [anon_sym___attribute__] = ACTIONS(1498),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1500),
    [anon_sym___declspec] = ACTIONS(1498),
    [anon_sym___cdecl] = ACTIONS(1498),
    [anon_sym___clrcall] = ACTIONS(1498),
    [anon_sym___stdcall] = ACTIONS(1498),
    [anon_sym___fastcall] = ACTIONS(1498),
    [anon_sym___thiscall] = ACTIONS(1498),
    [anon_sym___vectorcall] = ACTIONS(1498),
    [anon_sym_LBRACE] = ACTIONS(1500),
    [anon_sym_signed] = ACTIONS(1498),
    [anon_sym_unsigned] = ACTIONS(1498),
    [anon_sym_long] = ACTIONS(1498),
    [anon_sym_short] = ACTIONS(1498),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_auto] = ACTIONS(1498),
    [anon_sym_register] = ACTIONS(1498),
    [anon_sym_inline] = ACTIONS(1498),
    [anon_sym___inline] = ACTIONS(1498),
    [anon_sym___inline__] = ACTIONS(1498),
    [anon_sym___forceinline] = ACTIONS(1498),
    [anon_sym_thread_local] = ACTIONS(1498),
    [anon_sym___thread] = ACTIONS(1498),
    [anon_sym_const] = ACTIONS(1498),
    [anon_sym_constexpr] = ACTIONS(1498),
    [anon_sym_volatile] = ACTIONS(1498),
    [anon_sym_restrict] = ACTIONS(1498),
    [anon_sym___restrict__] = ACTIONS(1498),
    [anon_sym__Atomic] = ACTIONS(1498),
    [anon_sym__Noreturn] = ACTIONS(1498),
    [anon_sym_noreturn] = ACTIONS(1498),
    [sym_primitive_type] = ACTIONS(1498),
    [anon_sym_enum] = ACTIONS(1498),
    [anon_sym_struct] = ACTIONS(1498),
    [anon_sym_union] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1498),
    [anon_sym_switch] = ACTIONS(1498),
    [anon_sym_case] = ACTIONS(1498),
    [anon_sym_default] = ACTIONS(1498),
    [anon_sym_while] = ACTIONS(1498),
    [anon_sym_do] = ACTIONS(1498),
    [anon_sym_for] = ACTIONS(1498),
    [anon_sym_return] = ACTIONS(1498),
    [anon_sym_break] = ACTIONS(1498),
    [anon_sym_continue] = ACTIONS(1498),
    [anon_sym_goto] = ACTIONS(1498),
    [anon_sym___try] = ACTIONS(1498),
    [anon_sym___leave] = ACTIONS(1498),
    [anon_sym_DASH_DASH] = ACTIONS(1500),
    [anon_sym_PLUS_PLUS] = ACTIONS(1500),
    [anon_sym_sizeof] = ACTIONS(1498),
    [anon_sym___alignof__] = ACTIONS(1498),
    [anon_sym___alignof] = ACTIONS(1498),
    [anon_sym__alignof] = ACTIONS(1498),
    [anon_sym_alignof] = ACTIONS(1498),
    [anon_sym__Alignof] = ACTIONS(1498),
    [anon_sym_offsetof] = ACTIONS(1498),
    [anon_sym__Generic] = ACTIONS(1498),
    [anon_sym_asm] = ACTIONS(1498),
    [anon_sym___asm__] = ACTIONS(1498),
    [sym_number_literal] = ACTIONS(1500),
    [anon_sym_L_SQUOTE] = ACTIONS(1500),
    [anon_sym_u_SQUOTE] = ACTIONS(1500),
    [anon_sym_U_SQUOTE] = ACTIONS(1500),
    [anon_sym_u8_SQUOTE] = ACTIONS(1500),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_L_DQUOTE] = ACTIONS(1500),
    [anon_sym_u_DQUOTE] = ACTIONS(1500),
    [anon_sym_U_DQUOTE] = ACTIONS(1500),
    [anon_sym_u8_DQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE] = ACTIONS(1500),
    [sym_true] = ACTIONS(1498),
    [sym_false] = ACTIONS(1498),
    [anon_sym_NULL] = ACTIONS(1498),
    [anon_sym_nullptr] = ACTIONS(1498),
    [sym_comment] = ACTIONS(3),
  },
  [163] = {
    [sym_identifier] = ACTIONS(1502),
    [aux_sym_preproc_include_token1] = ACTIONS(1502),
    [aux_sym_preproc_def_token1] = ACTIONS(1502),
    [aux_sym_preproc_if_token1] = ACTIONS(1502),
    [aux_sym_preproc_if_token2] = ACTIONS(1502),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1502),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1502),
    [aux_sym_preproc_else_token1] = ACTIONS(1502),
    [aux_sym_preproc_elif_token1] = ACTIONS(1502),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1502),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1502),
    [sym_preproc_directive] = ACTIONS(1502),
    [anon_sym_LPAREN2] = ACTIONS(1504),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_TILDE] = ACTIONS(1504),
    [anon_sym_DASH] = ACTIONS(1502),
    [anon_sym_PLUS] = ACTIONS(1502),
    [anon_sym_STAR] = ACTIONS(1504),
    [anon_sym_AMP] = ACTIONS(1504),
    [anon_sym_SEMI] = ACTIONS(1504),
    [anon_sym___extension__] = ACTIONS(1502),
    [anon_sym_typedef] = ACTIONS(1502),
    [anon_sym_extern] = ACTIONS(1502),
    [anon_sym___attribute__] = ACTIONS(1502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1504),
    [anon_sym___declspec] = ACTIONS(1502),
    [anon_sym___cdecl] = ACTIONS(1502),
    [anon_sym___clrcall] = ACTIONS(1502),
    [anon_sym___stdcall] = ACTIONS(1502),
    [anon_sym___fastcall] = ACTIONS(1502),
    [anon_sym___thiscall] = ACTIONS(1502),
    [anon_sym___vectorcall] = ACTIONS(1502),
    [anon_sym_LBRACE] = ACTIONS(1504),
    [anon_sym_signed] = ACTIONS(1502),
    [anon_sym_unsigned] = ACTIONS(1502),
    [anon_sym_long] = ACTIONS(1502),
    [anon_sym_short] = ACTIONS(1502),
    [anon_sym_static] = ACTIONS(1502),
    [anon_sym_auto] = ACTIONS(1502),
    [anon_sym_register] = ACTIONS(1502),
    [anon_sym_inline] = ACTIONS(1502),
    [anon_sym___inline] = ACTIONS(1502),
    [anon_sym___inline__] = ACTIONS(1502),
    [anon_sym___forceinline] = ACTIONS(1502),
    [anon_sym_thread_local] = ACTIONS(1502),
    [anon_sym___thread] = ACTIONS(1502),
    [anon_sym_const] = ACTIONS(1502),
    [anon_sym_constexpr] = ACTIONS(1502),
    [anon_sym_volatile] = ACTIONS(1502),
    [anon_sym_restrict] = ACTIONS(1502),
    [anon_sym___restrict__] = ACTIONS(1502),
    [anon_sym__Atomic] = ACTIONS(1502),
    [anon_sym__Noreturn] = ACTIONS(1502),
    [anon_sym_noreturn] = ACTIONS(1502),
    [sym_primitive_type] = ACTIONS(1502),
    [anon_sym_enum] = ACTIONS(1502),
    [anon_sym_struct] = ACTIONS(1502),
    [anon_sym_union] = ACTIONS(1502),
    [anon_sym_if] = ACTIONS(1502),
    [anon_sym_switch] = ACTIONS(1502),
    [anon_sym_case] = ACTIONS(1502),
    [anon_sym_default] = ACTIONS(1502),
    [anon_sym_while] = ACTIONS(1502),
    [anon_sym_do] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1502),
    [anon_sym_return] = ACTIONS(1502),
    [anon_sym_break] = ACTIONS(1502),
    [anon_sym_continue] = ACTIONS(1502),
    [anon_sym_goto] = ACTIONS(1502),
    [anon_sym___try] = ACTIONS(1502),
    [anon_sym___leave] = ACTIONS(1502),
    [anon_sym_DASH_DASH] = ACTIONS(1504),
    [anon_sym_PLUS_PLUS] = ACTIONS(1504),
    [anon_sym_sizeof] = ACTIONS(1502),
    [anon_sym___alignof__] = ACTIONS(1502),
    [anon_sym___alignof] = ACTIONS(1502),
    [anon_sym__alignof] = ACTIONS(1502),
    [anon_sym_alignof] = ACTIONS(1502),
    [anon_sym__Alignof] = ACTIONS(1502),
    [anon_sym_offsetof] = ACTIONS(1502),
    [anon_sym__Generic] = ACTIONS(1502),
    [anon_sym_asm] = ACTIONS(1502),
    [anon_sym___asm__] = ACTIONS(1502),
    [sym_number_literal] = ACTIONS(1504),
    [anon_sym_L_SQUOTE] = ACTIONS(1504),
    [anon_sym_u_SQUOTE] = ACTIONS(1504),
    [anon_sym_U_SQUOTE] = ACTIONS(1504),
    [anon_sym_u8_SQUOTE] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(1504),
    [anon_sym_L_DQUOTE] = ACTIONS(1504),
    [anon_sym_u_DQUOTE] = ACTIONS(1504),
    [anon_sym_U_DQUOTE] = ACTIONS(1504),
    [anon_sym_u8_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE] = ACTIONS(1504),
    [sym_true] = ACTIONS(1502),
    [sym_false] = ACTIONS(1502),
    [anon_sym_NULL] = ACTIONS(1502),
    [anon_sym_nullptr] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [164] = {
    [sym_identifier] = ACTIONS(1506),
    [aux_sym_preproc_include_token1] = ACTIONS(1506),
    [aux_sym_preproc_def_token1] = ACTIONS(1506),
    [aux_sym_preproc_if_token1] = ACTIONS(1506),
    [aux_sym_preproc_if_token2] = ACTIONS(1506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1506),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1506),
    [aux_sym_preproc_else_token1] = ACTIONS(1506),
    [aux_sym_preproc_elif_token1] = ACTIONS(1506),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1506),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1506),
    [sym_preproc_directive] = ACTIONS(1506),
    [anon_sym_LPAREN2] = ACTIONS(1508),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_TILDE] = ACTIONS(1508),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_typedef] = ACTIONS(1506),
    [anon_sym_extern] = ACTIONS(1506),
    [anon_sym___attribute__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym___declspec] = ACTIONS(1506),
    [anon_sym___cdecl] = ACTIONS(1506),
    [anon_sym___clrcall] = ACTIONS(1506),
    [anon_sym___stdcall] = ACTIONS(1506),
    [anon_sym___fastcall] = ACTIONS(1506),
    [anon_sym___thiscall] = ACTIONS(1506),
    [anon_sym___vectorcall] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1508),
    [anon_sym_signed] = ACTIONS(1506),
    [anon_sym_unsigned] = ACTIONS(1506),
    [anon_sym_long] = ACTIONS(1506),
    [anon_sym_short] = ACTIONS(1506),
    [anon_sym_static] = ACTIONS(1506),
    [anon_sym_auto] = ACTIONS(1506),
    [anon_sym_register] = ACTIONS(1506),
    [anon_sym_inline] = ACTIONS(1506),
    [anon_sym___inline] = ACTIONS(1506),
    [anon_sym___inline__] = ACTIONS(1506),
    [anon_sym___forceinline] = ACTIONS(1506),
    [anon_sym_thread_local] = ACTIONS(1506),
    [anon_sym___thread] = ACTIONS(1506),
    [anon_sym_const] = ACTIONS(1506),
    [anon_sym_constexpr] = ACTIONS(1506),
    [anon_sym_volatile] = ACTIONS(1506),
    [anon_sym_restrict] = ACTIONS(1506),
    [anon_sym___restrict__] = ACTIONS(1506),
    [anon_sym__Atomic] = ACTIONS(1506),
    [anon_sym__Noreturn] = ACTIONS(1506),
    [anon_sym_noreturn] = ACTIONS(1506),
    [sym_primitive_type] = ACTIONS(1506),
    [anon_sym_enum] = ACTIONS(1506),
    [anon_sym_struct] = ACTIONS(1506),
    [anon_sym_union] = ACTIONS(1506),
    [anon_sym_if] = ACTIONS(1506),
    [anon_sym_switch] = ACTIONS(1506),
    [anon_sym_case] = ACTIONS(1506),
    [anon_sym_default] = ACTIONS(1506),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_do] = ACTIONS(1506),
    [anon_sym_for] = ACTIONS(1506),
    [anon_sym_return] = ACTIONS(1506),
    [anon_sym_break] = ACTIONS(1506),
    [anon_sym_continue] = ACTIONS(1506),
    [anon_sym_goto] = ACTIONS(1506),
    [anon_sym___try] = ACTIONS(1506),
    [anon_sym___leave] = ACTIONS(1506),
    [anon_sym_DASH_DASH] = ACTIONS(1508),
    [anon_sym_PLUS_PLUS] = ACTIONS(1508),
    [anon_sym_sizeof] = ACTIONS(1506),
    [anon_sym___alignof__] = ACTIONS(1506),
    [anon_sym___alignof] = ACTIONS(1506),
    [anon_sym__alignof] = ACTIONS(1506),
    [anon_sym_alignof] = ACTIONS(1506),
    [anon_sym__Alignof] = ACTIONS(1506),
    [anon_sym_offsetof] = ACTIONS(1506),
    [anon_sym__Generic] = ACTIONS(1506),
    [anon_sym_asm] = ACTIONS(1506),
    [anon_sym___asm__] = ACTIONS(1506),
    [sym_number_literal] = ACTIONS(1508),
    [anon_sym_L_SQUOTE] = ACTIONS(1508),
    [anon_sym_u_SQUOTE] = ACTIONS(1508),
    [anon_sym_U_SQUOTE] = ACTIONS(1508),
    [anon_sym_u8_SQUOTE] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1508),
    [anon_sym_L_DQUOTE] = ACTIONS(1508),
    [anon_sym_u_DQUOTE] = ACTIONS(1508),
    [anon_sym_U_DQUOTE] = ACTIONS(1508),
    [anon_sym_u8_DQUOTE] = ACTIONS(1508),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_true] = ACTIONS(1506),
    [sym_false] = ACTIONS(1506),
    [anon_sym_NULL] = ACTIONS(1506),
    [anon_sym_nullptr] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
  },
  [165] = {
    [sym_identifier] = ACTIONS(1510),
    [aux_sym_preproc_include_token1] = ACTIONS(1510),
    [aux_sym_preproc_def_token1] = ACTIONS(1510),
    [aux_sym_preproc_if_token1] = ACTIONS(1510),
    [aux_sym_preproc_if_token2] = ACTIONS(1510),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1510),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1510),
    [aux_sym_preproc_else_token1] = ACTIONS(1510),
    [aux_sym_preproc_elif_token1] = ACTIONS(1510),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1510),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1510),
    [sym_preproc_directive] = ACTIONS(1510),
    [anon_sym_LPAREN2] = ACTIONS(1512),
    [anon_sym_BANG] = ACTIONS(1512),
    [anon_sym_TILDE] = ACTIONS(1512),
    [anon_sym_DASH] = ACTIONS(1510),
    [anon_sym_PLUS] = ACTIONS(1510),
    [anon_sym_STAR] = ACTIONS(1512),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym_SEMI] = ACTIONS(1512),
    [anon_sym___extension__] = ACTIONS(1510),
    [anon_sym_typedef] = ACTIONS(1510),
    [anon_sym_extern] = ACTIONS(1510),
    [anon_sym___attribute__] = ACTIONS(1510),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1512),
    [anon_sym___declspec] = ACTIONS(1510),
    [anon_sym___cdecl] = ACTIONS(1510),
    [anon_sym___clrcall] = ACTIONS(1510),
    [anon_sym___stdcall] = ACTIONS(1510),
    [anon_sym___fastcall] = ACTIONS(1510),
    [anon_sym___thiscall] = ACTIONS(1510),
    [anon_sym___vectorcall] = ACTIONS(1510),
    [anon_sym_LBRACE] = ACTIONS(1512),
    [anon_sym_signed] = ACTIONS(1510),
    [anon_sym_unsigned] = ACTIONS(1510),
    [anon_sym_long] = ACTIONS(1510),
    [anon_sym_short] = ACTIONS(1510),
    [anon_sym_static] = ACTIONS(1510),
    [anon_sym_auto] = ACTIONS(1510),
    [anon_sym_register] = ACTIONS(1510),
    [anon_sym_inline] = ACTIONS(1510),
    [anon_sym___inline] = ACTIONS(1510),
    [anon_sym___inline__] = ACTIONS(1510),
    [anon_sym___forceinline] = ACTIONS(1510),
    [anon_sym_thread_local] = ACTIONS(1510),
    [anon_sym___thread] = ACTIONS(1510),
    [anon_sym_const] = ACTIONS(1510),
    [anon_sym_constexpr] = ACTIONS(1510),
    [anon_sym_volatile] = ACTIONS(1510),
    [anon_sym_restrict] = ACTIONS(1510),
    [anon_sym___restrict__] = ACTIONS(1510),
    [anon_sym__Atomic] = ACTIONS(1510),
    [anon_sym__Noreturn] = ACTIONS(1510),
    [anon_sym_noreturn] = ACTIONS(1510),
    [sym_primitive_type] = ACTIONS(1510),
    [anon_sym_enum] = ACTIONS(1510),
    [anon_sym_struct] = ACTIONS(1510),
    [anon_sym_union] = ACTIONS(1510),
    [anon_sym_if] = ACTIONS(1510),
    [anon_sym_switch] = ACTIONS(1510),
    [anon_sym_case] = ACTIONS(1510),
    [anon_sym_default] = ACTIONS(1510),
    [anon_sym_while] = ACTIONS(1510),
    [anon_sym_do] = ACTIONS(1510),
    [anon_sym_for] = ACTIONS(1510),
    [anon_sym_return] = ACTIONS(1510),
    [anon_sym_break] = ACTIONS(1510),
    [anon_sym_continue] = ACTIONS(1510),
    [anon_sym_goto] = ACTIONS(1510),
    [anon_sym___try] = ACTIONS(1510),
    [anon_sym___leave] = ACTIONS(1510),
    [anon_sym_DASH_DASH] = ACTIONS(1512),
    [anon_sym_PLUS_PLUS] = ACTIONS(1512),
    [anon_sym_sizeof] = ACTIONS(1510),
    [anon_sym___alignof__] = ACTIONS(1510),
    [anon_sym___alignof] = ACTIONS(1510),
    [anon_sym__alignof] = ACTIONS(1510),
    [anon_sym_alignof] = ACTIONS(1510),
    [anon_sym__Alignof] = ACTIONS(1510),
    [anon_sym_offsetof] = ACTIONS(1510),
    [anon_sym__Generic] = ACTIONS(1510),
    [anon_sym_asm] = ACTIONS(1510),
    [anon_sym___asm__] = ACTIONS(1510),
    [sym_number_literal] = ACTIONS(1512),
    [anon_sym_L_SQUOTE] = ACTIONS(1512),
    [anon_sym_u_SQUOTE] = ACTIONS(1512),
    [anon_sym_U_SQUOTE] = ACTIONS(1512),
    [anon_sym_u8_SQUOTE] = ACTIONS(1512),
    [anon_sym_SQUOTE] = ACTIONS(1512),
    [anon_sym_L_DQUOTE] = ACTIONS(1512),
    [anon_sym_u_DQUOTE] = ACTIONS(1512),
    [anon_sym_U_DQUOTE] = ACTIONS(1512),
    [anon_sym_u8_DQUOTE] = ACTIONS(1512),
    [anon_sym_DQUOTE] = ACTIONS(1512),
    [sym_true] = ACTIONS(1510),
    [sym_false] = ACTIONS(1510),
    [anon_sym_NULL] = ACTIONS(1510),
    [anon_sym_nullptr] = ACTIONS(1510),
    [sym_comment] = ACTIONS(3),
  },
  [166] = {
    [sym_identifier] = ACTIONS(1514),
    [aux_sym_preproc_include_token1] = ACTIONS(1514),
    [aux_sym_preproc_def_token1] = ACTIONS(1514),
    [aux_sym_preproc_if_token1] = ACTIONS(1514),
    [aux_sym_preproc_if_token2] = ACTIONS(1514),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1514),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1514),
    [aux_sym_preproc_else_token1] = ACTIONS(1514),
    [aux_sym_preproc_elif_token1] = ACTIONS(1514),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1514),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1514),
    [sym_preproc_directive] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(1516),
    [anon_sym_BANG] = ACTIONS(1516),
    [anon_sym_TILDE] = ACTIONS(1516),
    [anon_sym_DASH] = ACTIONS(1514),
    [anon_sym_PLUS] = ACTIONS(1514),
    [anon_sym_STAR] = ACTIONS(1516),
    [anon_sym_AMP] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(1516),
    [anon_sym___extension__] = ACTIONS(1514),
    [anon_sym_typedef] = ACTIONS(1514),
    [anon_sym_extern] = ACTIONS(1514),
    [anon_sym___attribute__] = ACTIONS(1514),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym___declspec] = ACTIONS(1514),
    [anon_sym___cdecl] = ACTIONS(1514),
    [anon_sym___clrcall] = ACTIONS(1514),
    [anon_sym___stdcall] = ACTIONS(1514),
    [anon_sym___fastcall] = ACTIONS(1514),
    [anon_sym___thiscall] = ACTIONS(1514),
    [anon_sym___vectorcall] = ACTIONS(1514),
    [anon_sym_LBRACE] = ACTIONS(1516),
    [anon_sym_signed] = ACTIONS(1514),
    [anon_sym_unsigned] = ACTIONS(1514),
    [anon_sym_long] = ACTIONS(1514),
    [anon_sym_short] = ACTIONS(1514),
    [anon_sym_static] = ACTIONS(1514),
    [anon_sym_auto] = ACTIONS(1514),
    [anon_sym_register] = ACTIONS(1514),
    [anon_sym_inline] = ACTIONS(1514),
    [anon_sym___inline] = ACTIONS(1514),
    [anon_sym___inline__] = ACTIONS(1514),
    [anon_sym___forceinline] = ACTIONS(1514),
    [anon_sym_thread_local] = ACTIONS(1514),
    [anon_sym___thread] = ACTIONS(1514),
    [anon_sym_const] = ACTIONS(1514),
    [anon_sym_constexpr] = ACTIONS(1514),
    [anon_sym_volatile] = ACTIONS(1514),
    [anon_sym_restrict] = ACTIONS(1514),
    [anon_sym___restrict__] = ACTIONS(1514),
    [anon_sym__Atomic] = ACTIONS(1514),
    [anon_sym__Noreturn] = ACTIONS(1514),
    [anon_sym_noreturn] = ACTIONS(1514),
    [sym_primitive_type] = ACTIONS(1514),
    [anon_sym_enum] = ACTIONS(1514),
    [anon_sym_struct] = ACTIONS(1514),
    [anon_sym_union] = ACTIONS(1514),
    [anon_sym_if] = ACTIONS(1514),
    [anon_sym_switch] = ACTIONS(1514),
    [anon_sym_case] = ACTIONS(1514),
    [anon_sym_default] = ACTIONS(1514),
    [anon_sym_while] = ACTIONS(1514),
    [anon_sym_do] = ACTIONS(1514),
    [anon_sym_for] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1514),
    [anon_sym_break] = ACTIONS(1514),
    [anon_sym_continue] = ACTIONS(1514),
    [anon_sym_goto] = ACTIONS(1514),
    [anon_sym___try] = ACTIONS(1514),
    [anon_sym___leave] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1516),
    [anon_sym_PLUS_PLUS] = ACTIONS(1516),
    [anon_sym_sizeof] = ACTIONS(1514),
    [anon_sym___alignof__] = ACTIONS(1514),
    [anon_sym___alignof] = ACTIONS(1514),
    [anon_sym__alignof] = ACTIONS(1514),
    [anon_sym_alignof] = ACTIONS(1514),
    [anon_sym__Alignof] = ACTIONS(1514),
    [anon_sym_offsetof] = ACTIONS(1514),
    [anon_sym__Generic] = ACTIONS(1514),
    [anon_sym_asm] = ACTIONS(1514),
    [anon_sym___asm__] = ACTIONS(1514),
    [sym_number_literal] = ACTIONS(1516),
    [anon_sym_L_SQUOTE] = ACTIONS(1516),
    [anon_sym_u_SQUOTE] = ACTIONS(1516),
    [anon_sym_U_SQUOTE] = ACTIONS(1516),
    [anon_sym_u8_SQUOTE] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1516),
    [anon_sym_L_DQUOTE] = ACTIONS(1516),
    [anon_sym_u_DQUOTE] = ACTIONS(1516),
    [anon_sym_U_DQUOTE] = ACTIONS(1516),
    [anon_sym_u8_DQUOTE] = ACTIONS(1516),
    [anon_sym_DQUOTE] = ACTIONS(1516),
    [sym_true] = ACTIONS(1514),
    [sym_false] = ACTIONS(1514),
    [anon_sym_NULL] = ACTIONS(1514),
    [anon_sym_nullptr] = ACTIONS(1514),
    [sym_comment] = ACTIONS(3),
  },
  [167] = {
    [sym_identifier] = ACTIONS(1518),
    [aux_sym_preproc_include_token1] = ACTIONS(1518),
    [aux_sym_preproc_def_token1] = ACTIONS(1518),
    [aux_sym_preproc_if_token1] = ACTIONS(1518),
    [aux_sym_preproc_if_token2] = ACTIONS(1518),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1518),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1518),
    [aux_sym_preproc_else_token1] = ACTIONS(1518),
    [aux_sym_preproc_elif_token1] = ACTIONS(1518),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1518),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1518),
    [sym_preproc_directive] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(1520),
    [anon_sym_BANG] = ACTIONS(1520),
    [anon_sym_TILDE] = ACTIONS(1520),
    [anon_sym_DASH] = ACTIONS(1518),
    [anon_sym_PLUS] = ACTIONS(1518),
    [anon_sym_STAR] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1520),
    [anon_sym_SEMI] = ACTIONS(1520),
    [anon_sym___extension__] = ACTIONS(1518),
    [anon_sym_typedef] = ACTIONS(1518),
    [anon_sym_extern] = ACTIONS(1518),
    [anon_sym___attribute__] = ACTIONS(1518),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1520),
    [anon_sym___declspec] = ACTIONS(1518),
    [anon_sym___cdecl] = ACTIONS(1518),
    [anon_sym___clrcall] = ACTIONS(1518),
    [anon_sym___stdcall] = ACTIONS(1518),
    [anon_sym___fastcall] = ACTIONS(1518),
    [anon_sym___thiscall] = ACTIONS(1518),
    [anon_sym___vectorcall] = ACTIONS(1518),
    [anon_sym_LBRACE] = ACTIONS(1520),
    [anon_sym_signed] = ACTIONS(1518),
    [anon_sym_unsigned] = ACTIONS(1518),
    [anon_sym_long] = ACTIONS(1518),
    [anon_sym_short] = ACTIONS(1518),
    [anon_sym_static] = ACTIONS(1518),
    [anon_sym_auto] = ACTIONS(1518),
    [anon_sym_register] = ACTIONS(1518),
    [anon_sym_inline] = ACTIONS(1518),
    [anon_sym___inline] = ACTIONS(1518),
    [anon_sym___inline__] = ACTIONS(1518),
    [anon_sym___forceinline] = ACTIONS(1518),
    [anon_sym_thread_local] = ACTIONS(1518),
    [anon_sym___thread] = ACTIONS(1518),
    [anon_sym_const] = ACTIONS(1518),
    [anon_sym_constexpr] = ACTIONS(1518),
    [anon_sym_volatile] = ACTIONS(1518),
    [anon_sym_restrict] = ACTIONS(1518),
    [anon_sym___restrict__] = ACTIONS(1518),
    [anon_sym__Atomic] = ACTIONS(1518),
    [anon_sym__Noreturn] = ACTIONS(1518),
    [anon_sym_noreturn] = ACTIONS(1518),
    [sym_primitive_type] = ACTIONS(1518),
    [anon_sym_enum] = ACTIONS(1518),
    [anon_sym_struct] = ACTIONS(1518),
    [anon_sym_union] = ACTIONS(1518),
    [anon_sym_if] = ACTIONS(1518),
    [anon_sym_switch] = ACTIONS(1518),
    [anon_sym_case] = ACTIONS(1518),
    [anon_sym_default] = ACTIONS(1518),
    [anon_sym_while] = ACTIONS(1518),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_for] = ACTIONS(1518),
    [anon_sym_return] = ACTIONS(1518),
    [anon_sym_break] = ACTIONS(1518),
    [anon_sym_continue] = ACTIONS(1518),
    [anon_sym_goto] = ACTIONS(1518),
    [anon_sym___try] = ACTIONS(1518),
    [anon_sym___leave] = ACTIONS(1518),
    [anon_sym_DASH_DASH] = ACTIONS(1520),
    [anon_sym_PLUS_PLUS] = ACTIONS(1520),
    [anon_sym_sizeof] = ACTIONS(1518),
    [anon_sym___alignof__] = ACTIONS(1518),
    [anon_sym___alignof] = ACTIONS(1518),
    [anon_sym__alignof] = ACTIONS(1518),
    [anon_sym_alignof] = ACTIONS(1518),
    [anon_sym__Alignof] = ACTIONS(1518),
    [anon_sym_offsetof] = ACTIONS(1518),
    [anon_sym__Generic] = ACTIONS(1518),
    [anon_sym_asm] = ACTIONS(1518),
    [anon_sym___asm__] = ACTIONS(1518),
    [sym_number_literal] = ACTIONS(1520),
    [anon_sym_L_SQUOTE] = ACTIONS(1520),
    [anon_sym_u_SQUOTE] = ACTIONS(1520),
    [anon_sym_U_SQUOTE] = ACTIONS(1520),
    [anon_sym_u8_SQUOTE] = ACTIONS(1520),
    [anon_sym_SQUOTE] = ACTIONS(1520),
    [anon_sym_L_DQUOTE] = ACTIONS(1520),
    [anon_sym_u_DQUOTE] = ACTIONS(1520),
    [anon_sym_U_DQUOTE] = ACTIONS(1520),
    [anon_sym_u8_DQUOTE] = ACTIONS(1520),
    [anon_sym_DQUOTE] = ACTIONS(1520),
    [sym_true] = ACTIONS(1518),
    [sym_false] = ACTIONS(1518),
    [anon_sym_NULL] = ACTIONS(1518),
    [anon_sym_nullptr] = ACTIONS(1518),
    [sym_comment] = ACTIONS(3),
  },
  [168] = {
    [sym_identifier] = ACTIONS(1522),
    [aux_sym_preproc_include_token1] = ACTIONS(1522),
    [aux_sym_preproc_def_token1] = ACTIONS(1522),
    [aux_sym_preproc_if_token1] = ACTIONS(1522),
    [aux_sym_preproc_if_token2] = ACTIONS(1522),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1522),
    [aux_sym_preproc_else_token1] = ACTIONS(1522),
    [aux_sym_preproc_elif_token1] = ACTIONS(1522),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1522),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1522),
    [sym_preproc_directive] = ACTIONS(1522),
    [anon_sym_LPAREN2] = ACTIONS(1524),
    [anon_sym_BANG] = ACTIONS(1524),
    [anon_sym_TILDE] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1522),
    [anon_sym_PLUS] = ACTIONS(1522),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym___extension__] = ACTIONS(1522),
    [anon_sym_typedef] = ACTIONS(1522),
    [anon_sym_extern] = ACTIONS(1522),
    [anon_sym___attribute__] = ACTIONS(1522),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1524),
    [anon_sym___declspec] = ACTIONS(1522),
    [anon_sym___cdecl] = ACTIONS(1522),
    [anon_sym___clrcall] = ACTIONS(1522),
    [anon_sym___stdcall] = ACTIONS(1522),
    [anon_sym___fastcall] = ACTIONS(1522),
    [anon_sym___thiscall] = ACTIONS(1522),
    [anon_sym___vectorcall] = ACTIONS(1522),
    [anon_sym_LBRACE] = ACTIONS(1524),
    [anon_sym_signed] = ACTIONS(1522),
    [anon_sym_unsigned] = ACTIONS(1522),
    [anon_sym_long] = ACTIONS(1522),
    [anon_sym_short] = ACTIONS(1522),
    [anon_sym_static] = ACTIONS(1522),
    [anon_sym_auto] = ACTIONS(1522),
    [anon_sym_register] = ACTIONS(1522),
    [anon_sym_inline] = ACTIONS(1522),
    [anon_sym___inline] = ACTIONS(1522),
    [anon_sym___inline__] = ACTIONS(1522),
    [anon_sym___forceinline] = ACTIONS(1522),
    [anon_sym_thread_local] = ACTIONS(1522),
    [anon_sym___thread] = ACTIONS(1522),
    [anon_sym_const] = ACTIONS(1522),
    [anon_sym_constexpr] = ACTIONS(1522),
    [anon_sym_volatile] = ACTIONS(1522),
    [anon_sym_restrict] = ACTIONS(1522),
    [anon_sym___restrict__] = ACTIONS(1522),
    [anon_sym__Atomic] = ACTIONS(1522),
    [anon_sym__Noreturn] = ACTIONS(1522),
    [anon_sym_noreturn] = ACTIONS(1522),
    [sym_primitive_type] = ACTIONS(1522),
    [anon_sym_enum] = ACTIONS(1522),
    [anon_sym_struct] = ACTIONS(1522),
    [anon_sym_union] = ACTIONS(1522),
    [anon_sym_if] = ACTIONS(1522),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1522),
    [anon_sym_default] = ACTIONS(1522),
    [anon_sym_while] = ACTIONS(1522),
    [anon_sym_do] = ACTIONS(1522),
    [anon_sym_for] = ACTIONS(1522),
    [anon_sym_return] = ACTIONS(1522),
    [anon_sym_break] = ACTIONS(1522),
    [anon_sym_continue] = ACTIONS(1522),
    [anon_sym_goto] = ACTIONS(1522),
    [anon_sym___try] = ACTIONS(1522),
    [anon_sym___leave] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1524),
    [anon_sym_PLUS_PLUS] = ACTIONS(1524),
    [anon_sym_sizeof] = ACTIONS(1522),
    [anon_sym___alignof__] = ACTIONS(1522),
    [anon_sym___alignof] = ACTIONS(1522),
    [anon_sym__alignof] = ACTIONS(1522),
    [anon_sym_alignof] = ACTIONS(1522),
    [anon_sym__Alignof] = ACTIONS(1522),
    [anon_sym_offsetof] = ACTIONS(1522),
    [anon_sym__Generic] = ACTIONS(1522),
    [anon_sym_asm] = ACTIONS(1522),
    [anon_sym___asm__] = ACTIONS(1522),
    [sym_number_literal] = ACTIONS(1524),
    [anon_sym_L_SQUOTE] = ACTIONS(1524),
    [anon_sym_u_SQUOTE] = ACTIONS(1524),
    [anon_sym_U_SQUOTE] = ACTIONS(1524),
    [anon_sym_u8_SQUOTE] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(1524),
    [anon_sym_L_DQUOTE] = ACTIONS(1524),
    [anon_sym_u_DQUOTE] = ACTIONS(1524),
    [anon_sym_U_DQUOTE] = ACTIONS(1524),
    [anon_sym_u8_DQUOTE] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1524),
    [sym_true] = ACTIONS(1522),
    [sym_false] = ACTIONS(1522),
    [anon_sym_NULL] = ACTIONS(1522),
    [anon_sym_nullptr] = ACTIONS(1522),
    [sym_comment] = ACTIONS(3),
  },
  [169] = {
    [sym_identifier] = ACTIONS(1526),
    [aux_sym_preproc_include_token1] = ACTIONS(1526),
    [aux_sym_preproc_def_token1] = ACTIONS(1526),
    [aux_sym_preproc_if_token1] = ACTIONS(1526),
    [aux_sym_preproc_if_token2] = ACTIONS(1526),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1526),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1526),
    [aux_sym_preproc_else_token1] = ACTIONS(1526),
    [aux_sym_preproc_elif_token1] = ACTIONS(1526),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1526),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1526),
    [sym_preproc_directive] = ACTIONS(1526),
    [anon_sym_LPAREN2] = ACTIONS(1528),
    [anon_sym_BANG] = ACTIONS(1528),
    [anon_sym_TILDE] = ACTIONS(1528),
    [anon_sym_DASH] = ACTIONS(1526),
    [anon_sym_PLUS] = ACTIONS(1526),
    [anon_sym_STAR] = ACTIONS(1528),
    [anon_sym_AMP] = ACTIONS(1528),
    [anon_sym_SEMI] = ACTIONS(1528),
    [anon_sym___extension__] = ACTIONS(1526),
    [anon_sym_typedef] = ACTIONS(1526),
    [anon_sym_extern] = ACTIONS(1526),
    [anon_sym___attribute__] = ACTIONS(1526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1528),
    [anon_sym___declspec] = ACTIONS(1526),
    [anon_sym___cdecl] = ACTIONS(1526),
    [anon_sym___clrcall] = ACTIONS(1526),
    [anon_sym___stdcall] = ACTIONS(1526),
    [anon_sym___fastcall] = ACTIONS(1526),
    [anon_sym___thiscall] = ACTIONS(1526),
    [anon_sym___vectorcall] = ACTIONS(1526),
    [anon_sym_LBRACE] = ACTIONS(1528),
    [anon_sym_signed] = ACTIONS(1526),
    [anon_sym_unsigned] = ACTIONS(1526),
    [anon_sym_long] = ACTIONS(1526),
    [anon_sym_short] = ACTIONS(1526),
    [anon_sym_static] = ACTIONS(1526),
    [anon_sym_auto] = ACTIONS(1526),
    [anon_sym_register] = ACTIONS(1526),
    [anon_sym_inline] = ACTIONS(1526),
    [anon_sym___inline] = ACTIONS(1526),
    [anon_sym___inline__] = ACTIONS(1526),
    [anon_sym___forceinline] = ACTIONS(1526),
    [anon_sym_thread_local] = ACTIONS(1526),
    [anon_sym___thread] = ACTIONS(1526),
    [anon_sym_const] = ACTIONS(1526),
    [anon_sym_constexpr] = ACTIONS(1526),
    [anon_sym_volatile] = ACTIONS(1526),
    [anon_sym_restrict] = ACTIONS(1526),
    [anon_sym___restrict__] = ACTIONS(1526),
    [anon_sym__Atomic] = ACTIONS(1526),
    [anon_sym__Noreturn] = ACTIONS(1526),
    [anon_sym_noreturn] = ACTIONS(1526),
    [sym_primitive_type] = ACTIONS(1526),
    [anon_sym_enum] = ACTIONS(1526),
    [anon_sym_struct] = ACTIONS(1526),
    [anon_sym_union] = ACTIONS(1526),
    [anon_sym_if] = ACTIONS(1526),
    [anon_sym_switch] = ACTIONS(1526),
    [anon_sym_case] = ACTIONS(1526),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1526),
    [anon_sym_do] = ACTIONS(1526),
    [anon_sym_for] = ACTIONS(1526),
    [anon_sym_return] = ACTIONS(1526),
    [anon_sym_break] = ACTIONS(1526),
    [anon_sym_continue] = ACTIONS(1526),
    [anon_sym_goto] = ACTIONS(1526),
    [anon_sym___try] = ACTIONS(1526),
    [anon_sym___leave] = ACTIONS(1526),
    [anon_sym_DASH_DASH] = ACTIONS(1528),
    [anon_sym_PLUS_PLUS] = ACTIONS(1528),
    [anon_sym_sizeof] = ACTIONS(1526),
    [anon_sym___alignof__] = ACTIONS(1526),
    [anon_sym___alignof] = ACTIONS(1526),
    [anon_sym__alignof] = ACTIONS(1526),
    [anon_sym_alignof] = ACTIONS(1526),
    [anon_sym__Alignof] = ACTIONS(1526),
    [anon_sym_offsetof] = ACTIONS(1526),
    [anon_sym__Generic] = ACTIONS(1526),
    [anon_sym_asm] = ACTIONS(1526),
    [anon_sym___asm__] = ACTIONS(1526),
    [sym_number_literal] = ACTIONS(1528),
    [anon_sym_L_SQUOTE] = ACTIONS(1528),
    [anon_sym_u_SQUOTE] = ACTIONS(1528),
    [anon_sym_U_SQUOTE] = ACTIONS(1528),
    [anon_sym_u8_SQUOTE] = ACTIONS(1528),
    [anon_sym_SQUOTE] = ACTIONS(1528),
    [anon_sym_L_DQUOTE] = ACTIONS(1528),
    [anon_sym_u_DQUOTE] = ACTIONS(1528),
    [anon_sym_U_DQUOTE] = ACTIONS(1528),
    [anon_sym_u8_DQUOTE] = ACTIONS(1528),
    [anon_sym_DQUOTE] = ACTIONS(1528),
    [sym_true] = ACTIONS(1526),
    [sym_false] = ACTIONS(1526),
    [anon_sym_NULL] = ACTIONS(1526),
    [anon_sym_nullptr] = ACTIONS(1526),
    [sym_comment] = ACTIONS(3),
  },
  [170] = {
    [sym_identifier] = ACTIONS(1530),
    [aux_sym_preproc_include_token1] = ACTIONS(1530),
    [aux_sym_preproc_def_token1] = ACTIONS(1530),
    [aux_sym_preproc_if_token1] = ACTIONS(1530),
    [aux_sym_preproc_if_token2] = ACTIONS(1530),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1530),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1530),
    [aux_sym_preproc_else_token1] = ACTIONS(1530),
    [aux_sym_preproc_elif_token1] = ACTIONS(1530),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1530),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1530),
    [sym_preproc_directive] = ACTIONS(1530),
    [anon_sym_LPAREN2] = ACTIONS(1532),
    [anon_sym_BANG] = ACTIONS(1532),
    [anon_sym_TILDE] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(1530),
    [anon_sym_PLUS] = ACTIONS(1530),
    [anon_sym_STAR] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_SEMI] = ACTIONS(1532),
    [anon_sym___extension__] = ACTIONS(1530),
    [anon_sym_typedef] = ACTIONS(1530),
    [anon_sym_extern] = ACTIONS(1530),
    [anon_sym___attribute__] = ACTIONS(1530),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1532),
    [anon_sym___declspec] = ACTIONS(1530),
    [anon_sym___cdecl] = ACTIONS(1530),
    [anon_sym___clrcall] = ACTIONS(1530),
    [anon_sym___stdcall] = ACTIONS(1530),
    [anon_sym___fastcall] = ACTIONS(1530),
    [anon_sym___thiscall] = ACTIONS(1530),
    [anon_sym___vectorcall] = ACTIONS(1530),
    [anon_sym_LBRACE] = ACTIONS(1532),
    [anon_sym_signed] = ACTIONS(1530),
    [anon_sym_unsigned] = ACTIONS(1530),
    [anon_sym_long] = ACTIONS(1530),
    [anon_sym_short] = ACTIONS(1530),
    [anon_sym_static] = ACTIONS(1530),
    [anon_sym_auto] = ACTIONS(1530),
    [anon_sym_register] = ACTIONS(1530),
    [anon_sym_inline] = ACTIONS(1530),
    [anon_sym___inline] = ACTIONS(1530),
    [anon_sym___inline__] = ACTIONS(1530),
    [anon_sym___forceinline] = ACTIONS(1530),
    [anon_sym_thread_local] = ACTIONS(1530),
    [anon_sym___thread] = ACTIONS(1530),
    [anon_sym_const] = ACTIONS(1530),
    [anon_sym_constexpr] = ACTIONS(1530),
    [anon_sym_volatile] = ACTIONS(1530),
    [anon_sym_restrict] = ACTIONS(1530),
    [anon_sym___restrict__] = ACTIONS(1530),
    [anon_sym__Atomic] = ACTIONS(1530),
    [anon_sym__Noreturn] = ACTIONS(1530),
    [anon_sym_noreturn] = ACTIONS(1530),
    [sym_primitive_type] = ACTIONS(1530),
    [anon_sym_enum] = ACTIONS(1530),
    [anon_sym_struct] = ACTIONS(1530),
    [anon_sym_union] = ACTIONS(1530),
    [anon_sym_if] = ACTIONS(1530),
    [anon_sym_switch] = ACTIONS(1530),
    [anon_sym_case] = ACTIONS(1530),
    [anon_sym_default] = ACTIONS(1530),
    [anon_sym_while] = ACTIONS(1530),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1530),
    [anon_sym_return] = ACTIONS(1530),
    [anon_sym_break] = ACTIONS(1530),
    [anon_sym_continue] = ACTIONS(1530),
    [anon_sym_goto] = ACTIONS(1530),
    [anon_sym___try] = ACTIONS(1530),
    [anon_sym___leave] = ACTIONS(1530),
    [anon_sym_DASH_DASH] = ACTIONS(1532),
    [anon_sym_PLUS_PLUS] = ACTIONS(1532),
    [anon_sym_sizeof] = ACTIONS(1530),
    [anon_sym___alignof__] = ACTIONS(1530),
    [anon_sym___alignof] = ACTIONS(1530),
    [anon_sym__alignof] = ACTIONS(1530),
    [anon_sym_alignof] = ACTIONS(1530),
    [anon_sym__Alignof] = ACTIONS(1530),
    [anon_sym_offsetof] = ACTIONS(1530),
    [anon_sym__Generic] = ACTIONS(1530),
    [anon_sym_asm] = ACTIONS(1530),
    [anon_sym___asm__] = ACTIONS(1530),
    [sym_number_literal] = ACTIONS(1532),
    [anon_sym_L_SQUOTE] = ACTIONS(1532),
    [anon_sym_u_SQUOTE] = ACTIONS(1532),
    [anon_sym_U_SQUOTE] = ACTIONS(1532),
    [anon_sym_u8_SQUOTE] = ACTIONS(1532),
    [anon_sym_SQUOTE] = ACTIONS(1532),
    [anon_sym_L_DQUOTE] = ACTIONS(1532),
    [anon_sym_u_DQUOTE] = ACTIONS(1532),
    [anon_sym_U_DQUOTE] = ACTIONS(1532),
    [anon_sym_u8_DQUOTE] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [sym_true] = ACTIONS(1530),
    [sym_false] = ACTIONS(1530),
    [anon_sym_NULL] = ACTIONS(1530),
    [anon_sym_nullptr] = ACTIONS(1530),
    [sym_comment] = ACTIONS(3),
  },
  [171] = {
    [sym_else_clause] = STATE(203),
    [sym_identifier] = ACTIONS(1292),
    [aux_sym_preproc_include_token1] = ACTIONS(1292),
    [aux_sym_preproc_def_token1] = ACTIONS(1292),
    [aux_sym_preproc_if_token1] = ACTIONS(1292),
    [aux_sym_preproc_if_token2] = ACTIONS(1292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1292),
    [aux_sym_preproc_else_token1] = ACTIONS(1292),
    [aux_sym_preproc_elif_token1] = ACTIONS(1292),
    [sym_preproc_directive] = ACTIONS(1292),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1294),
    [anon_sym_TILDE] = ACTIONS(1294),
    [anon_sym_DASH] = ACTIONS(1292),
    [anon_sym_PLUS] = ACTIONS(1292),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_SEMI] = ACTIONS(1294),
    [anon_sym___extension__] = ACTIONS(1292),
    [anon_sym_typedef] = ACTIONS(1292),
    [anon_sym_extern] = ACTIONS(1292),
    [anon_sym___attribute__] = ACTIONS(1292),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1294),
    [anon_sym___declspec] = ACTIONS(1292),
    [anon_sym___cdecl] = ACTIONS(1292),
    [anon_sym___clrcall] = ACTIONS(1292),
    [anon_sym___stdcall] = ACTIONS(1292),
    [anon_sym___fastcall] = ACTIONS(1292),
    [anon_sym___thiscall] = ACTIONS(1292),
    [anon_sym___vectorcall] = ACTIONS(1292),
    [anon_sym_LBRACE] = ACTIONS(1294),
    [anon_sym_signed] = ACTIONS(1292),
    [anon_sym_unsigned] = ACTIONS(1292),
    [anon_sym_long] = ACTIONS(1292),
    [anon_sym_short] = ACTIONS(1292),
    [anon_sym_static] = ACTIONS(1292),
    [anon_sym_auto] = ACTIONS(1292),
    [anon_sym_register] = ACTIONS(1292),
    [anon_sym_inline] = ACTIONS(1292),
    [anon_sym___inline] = ACTIONS(1292),
    [anon_sym___inline__] = ACTIONS(1292),
    [anon_sym___forceinline] = ACTIONS(1292),
    [anon_sym_thread_local] = ACTIONS(1292),
    [anon_sym___thread] = ACTIONS(1292),
    [anon_sym_const] = ACTIONS(1292),
    [anon_sym_constexpr] = ACTIONS(1292),
    [anon_sym_volatile] = ACTIONS(1292),
    [anon_sym_restrict] = ACTIONS(1292),
    [anon_sym___restrict__] = ACTIONS(1292),
    [anon_sym__Atomic] = ACTIONS(1292),
    [anon_sym__Noreturn] = ACTIONS(1292),
    [anon_sym_noreturn] = ACTIONS(1292),
    [sym_primitive_type] = ACTIONS(1292),
    [anon_sym_enum] = ACTIONS(1292),
    [anon_sym_struct] = ACTIONS(1292),
    [anon_sym_union] = ACTIONS(1292),
    [anon_sym_if] = ACTIONS(1292),
    [anon_sym_else] = ACTIONS(1534),
    [anon_sym_switch] = ACTIONS(1292),
    [anon_sym_case] = ACTIONS(1292),
    [anon_sym_default] = ACTIONS(1292),
    [anon_sym_while] = ACTIONS(1292),
    [anon_sym_do] = ACTIONS(1292),
    [anon_sym_for] = ACTIONS(1292),
    [anon_sym_return] = ACTIONS(1292),
    [anon_sym_break] = ACTIONS(1292),
    [anon_sym_continue] = ACTIONS(1292),
    [anon_sym_goto] = ACTIONS(1292),
    [anon_sym___try] = ACTIONS(1292),
    [anon_sym___leave] = ACTIONS(1292),
    [anon_sym_DASH_DASH] = ACTIONS(1294),
    [anon_sym_PLUS_PLUS] = ACTIONS(1294),
    [anon_sym_sizeof] = ACTIONS(1292),
    [anon_sym___alignof__] = ACTIONS(1292),
    [anon_sym___alignof] = ACTIONS(1292),
    [anon_sym__alignof] = ACTIONS(1292),
    [anon_sym_alignof] = ACTIONS(1292),
    [anon_sym__Alignof] = ACTIONS(1292),
    [anon_sym_offsetof] = ACTIONS(1292),
    [anon_sym__Generic] = ACTIONS(1292),
    [anon_sym_asm] = ACTIONS(1292),
    [anon_sym___asm__] = ACTIONS(1292),
    [sym_number_literal] = ACTIONS(1294),
    [anon_sym_L_SQUOTE] = ACTIONS(1294),
    [anon_sym_u_SQUOTE] = ACTIONS(1294),
    [anon_sym_U_SQUOTE] = ACTIONS(1294),
    [anon_sym_u8_SQUOTE] = ACTIONS(1294),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_L_DQUOTE] = ACTIONS(1294),
    [anon_sym_u_DQUOTE] = ACTIONS(1294),
    [anon_sym_U_DQUOTE] = ACTIONS(1294),
    [anon_sym_u8_DQUOTE] = ACTIONS(1294),
    [anon_sym_DQUOTE] = ACTIONS(1294),
    [sym_true] = ACTIONS(1292),
    [sym_false] = ACTIONS(1292),
    [anon_sym_NULL] = ACTIONS(1292),
    [anon_sym_nullptr] = ACTIONS(1292),
    [sym_comment] = ACTIONS(3),
  },
  [172] = {
    [sym_identifier] = ACTIONS(1382),
    [aux_sym_preproc_include_token1] = ACTIONS(1382),
    [aux_sym_preproc_def_token1] = ACTIONS(1382),
    [aux_sym_preproc_if_token1] = ACTIONS(1382),
    [aux_sym_preproc_if_token2] = ACTIONS(1382),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1382),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1382),
    [aux_sym_preproc_else_token1] = ACTIONS(1382),
    [aux_sym_preproc_elif_token1] = ACTIONS(1382),
    [sym_preproc_directive] = ACTIONS(1382),
    [anon_sym_LPAREN2] = ACTIONS(1384),
    [anon_sym_BANG] = ACTIONS(1384),
    [anon_sym_TILDE] = ACTIONS(1384),
    [anon_sym_DASH] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1382),
    [anon_sym_STAR] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym___extension__] = ACTIONS(1382),
    [anon_sym_typedef] = ACTIONS(1382),
    [anon_sym_extern] = ACTIONS(1382),
    [anon_sym___attribute__] = ACTIONS(1382),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1384),
    [anon_sym___declspec] = ACTIONS(1382),
    [anon_sym___cdecl] = ACTIONS(1382),
    [anon_sym___clrcall] = ACTIONS(1382),
    [anon_sym___stdcall] = ACTIONS(1382),
    [anon_sym___fastcall] = ACTIONS(1382),
    [anon_sym___thiscall] = ACTIONS(1382),
    [anon_sym___vectorcall] = ACTIONS(1382),
    [anon_sym_LBRACE] = ACTIONS(1384),
    [anon_sym_signed] = ACTIONS(1382),
    [anon_sym_unsigned] = ACTIONS(1382),
    [anon_sym_long] = ACTIONS(1382),
    [anon_sym_short] = ACTIONS(1382),
    [anon_sym_static] = ACTIONS(1382),
    [anon_sym_auto] = ACTIONS(1382),
    [anon_sym_register] = ACTIONS(1382),
    [anon_sym_inline] = ACTIONS(1382),
    [anon_sym___inline] = ACTIONS(1382),
    [anon_sym___inline__] = ACTIONS(1382),
    [anon_sym___forceinline] = ACTIONS(1382),
    [anon_sym_thread_local] = ACTIONS(1382),
    [anon_sym___thread] = ACTIONS(1382),
    [anon_sym_const] = ACTIONS(1382),
    [anon_sym_constexpr] = ACTIONS(1382),
    [anon_sym_volatile] = ACTIONS(1382),
    [anon_sym_restrict] = ACTIONS(1382),
    [anon_sym___restrict__] = ACTIONS(1382),
    [anon_sym__Atomic] = ACTIONS(1382),
    [anon_sym__Noreturn] = ACTIONS(1382),
    [anon_sym_noreturn] = ACTIONS(1382),
    [sym_primitive_type] = ACTIONS(1382),
    [anon_sym_enum] = ACTIONS(1382),
    [anon_sym_struct] = ACTIONS(1382),
    [anon_sym_union] = ACTIONS(1382),
    [anon_sym_if] = ACTIONS(1382),
    [anon_sym_else] = ACTIONS(1382),
    [anon_sym_switch] = ACTIONS(1382),
    [anon_sym_case] = ACTIONS(1382),
    [anon_sym_default] = ACTIONS(1382),
    [anon_sym_while] = ACTIONS(1382),
    [anon_sym_do] = ACTIONS(1382),
    [anon_sym_for] = ACTIONS(1382),
    [anon_sym_return] = ACTIONS(1382),
    [anon_sym_break] = ACTIONS(1382),
    [anon_sym_continue] = ACTIONS(1382),
    [anon_sym_goto] = ACTIONS(1382),
    [anon_sym___try] = ACTIONS(1382),
    [anon_sym___leave] = ACTIONS(1382),
    [anon_sym_DASH_DASH] = ACTIONS(1384),
    [anon_sym_PLUS_PLUS] = ACTIONS(1384),
    [anon_sym_sizeof] = ACTIONS(1382),
    [anon_sym___alignof__] = ACTIONS(1382),
    [anon_sym___alignof] = ACTIONS(1382),
    [anon_sym__alignof] = ACTIONS(1382),
    [anon_sym_alignof] = ACTIONS(1382),
    [anon_sym__Alignof] = ACTIONS(1382),
    [anon_sym_offsetof] = ACTIONS(1382),
    [anon_sym__Generic] = ACTIONS(1382),
    [anon_sym_asm] = ACTIONS(1382),
    [anon_sym___asm__] = ACTIONS(1382),
    [sym_number_literal] = ACTIONS(1384),
    [anon_sym_L_SQUOTE] = ACTIONS(1384),
    [anon_sym_u_SQUOTE] = ACTIONS(1384),
    [anon_sym_U_SQUOTE] = ACTIONS(1384),
    [anon_sym_u8_SQUOTE] = ACTIONS(1384),
    [anon_sym_SQUOTE] = ACTIONS(1384),
    [anon_sym_L_DQUOTE] = ACTIONS(1384),
    [anon_sym_u_DQUOTE] = ACTIONS(1384),
    [anon_sym_U_DQUOTE] = ACTIONS(1384),
    [anon_sym_u8_DQUOTE] = ACTIONS(1384),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [sym_true] = ACTIONS(1382),
    [sym_false] = ACTIONS(1382),
    [anon_sym_NULL] = ACTIONS(1382),
    [anon_sym_nullptr] = ACTIONS(1382),
    [sym_comment] = ACTIONS(3),
  },
  [173] = {
    [sym_identifier] = ACTIONS(1378),
    [aux_sym_preproc_include_token1] = ACTIONS(1378),
    [aux_sym_preproc_def_token1] = ACTIONS(1378),
    [aux_sym_preproc_if_token1] = ACTIONS(1378),
    [aux_sym_preproc_if_token2] = ACTIONS(1378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1378),
    [aux_sym_preproc_else_token1] = ACTIONS(1378),
    [aux_sym_preproc_elif_token1] = ACTIONS(1378),
    [sym_preproc_directive] = ACTIONS(1378),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_BANG] = ACTIONS(1380),
    [anon_sym_TILDE] = ACTIONS(1380),
    [anon_sym_DASH] = ACTIONS(1378),
    [anon_sym_PLUS] = ACTIONS(1378),
    [anon_sym_STAR] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym___extension__] = ACTIONS(1378),
    [anon_sym_typedef] = ACTIONS(1378),
    [anon_sym_extern] = ACTIONS(1378),
    [anon_sym___attribute__] = ACTIONS(1378),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1380),
    [anon_sym___declspec] = ACTIONS(1378),
    [anon_sym___cdecl] = ACTIONS(1378),
    [anon_sym___clrcall] = ACTIONS(1378),
    [anon_sym___stdcall] = ACTIONS(1378),
    [anon_sym___fastcall] = ACTIONS(1378),
    [anon_sym___thiscall] = ACTIONS(1378),
    [anon_sym___vectorcall] = ACTIONS(1378),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_signed] = ACTIONS(1378),
    [anon_sym_unsigned] = ACTIONS(1378),
    [anon_sym_long] = ACTIONS(1378),
    [anon_sym_short] = ACTIONS(1378),
    [anon_sym_static] = ACTIONS(1378),
    [anon_sym_auto] = ACTIONS(1378),
    [anon_sym_register] = ACTIONS(1378),
    [anon_sym_inline] = ACTIONS(1378),
    [anon_sym___inline] = ACTIONS(1378),
    [anon_sym___inline__] = ACTIONS(1378),
    [anon_sym___forceinline] = ACTIONS(1378),
    [anon_sym_thread_local] = ACTIONS(1378),
    [anon_sym___thread] = ACTIONS(1378),
    [anon_sym_const] = ACTIONS(1378),
    [anon_sym_constexpr] = ACTIONS(1378),
    [anon_sym_volatile] = ACTIONS(1378),
    [anon_sym_restrict] = ACTIONS(1378),
    [anon_sym___restrict__] = ACTIONS(1378),
    [anon_sym__Atomic] = ACTIONS(1378),
    [anon_sym__Noreturn] = ACTIONS(1378),
    [anon_sym_noreturn] = ACTIONS(1378),
    [sym_primitive_type] = ACTIONS(1378),
    [anon_sym_enum] = ACTIONS(1378),
    [anon_sym_struct] = ACTIONS(1378),
    [anon_sym_union] = ACTIONS(1378),
    [anon_sym_if] = ACTIONS(1378),
    [anon_sym_else] = ACTIONS(1378),
    [anon_sym_switch] = ACTIONS(1378),
    [anon_sym_case] = ACTIONS(1378),
    [anon_sym_default] = ACTIONS(1378),
    [anon_sym_while] = ACTIONS(1378),
    [anon_sym_do] = ACTIONS(1378),
    [anon_sym_for] = ACTIONS(1378),
    [anon_sym_return] = ACTIONS(1378),
    [anon_sym_break] = ACTIONS(1378),
    [anon_sym_continue] = ACTIONS(1378),
    [anon_sym_goto] = ACTIONS(1378),
    [anon_sym___try] = ACTIONS(1378),
    [anon_sym___leave] = ACTIONS(1378),
    [anon_sym_DASH_DASH] = ACTIONS(1380),
    [anon_sym_PLUS_PLUS] = ACTIONS(1380),
    [anon_sym_sizeof] = ACTIONS(1378),
    [anon_sym___alignof__] = ACTIONS(1378),
    [anon_sym___alignof] = ACTIONS(1378),
    [anon_sym__alignof] = ACTIONS(1378),
    [anon_sym_alignof] = ACTIONS(1378),
    [anon_sym__Alignof] = ACTIONS(1378),
    [anon_sym_offsetof] = ACTIONS(1378),
    [anon_sym__Generic] = ACTIONS(1378),
    [anon_sym_asm] = ACTIONS(1378),
    [anon_sym___asm__] = ACTIONS(1378),
    [sym_number_literal] = ACTIONS(1380),
    [anon_sym_L_SQUOTE] = ACTIONS(1380),
    [anon_sym_u_SQUOTE] = ACTIONS(1380),
    [anon_sym_U_SQUOTE] = ACTIONS(1380),
    [anon_sym_u8_SQUOTE] = ACTIONS(1380),
    [anon_sym_SQUOTE] = ACTIONS(1380),
    [anon_sym_L_DQUOTE] = ACTIONS(1380),
    [anon_sym_u_DQUOTE] = ACTIONS(1380),
    [anon_sym_U_DQUOTE] = ACTIONS(1380),
    [anon_sym_u8_DQUOTE] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [anon_sym_NULL] = ACTIONS(1378),
    [anon_sym_nullptr] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
  },
  [174] = {
    [sym_identifier] = ACTIONS(1326),
    [aux_sym_preproc_include_token1] = ACTIONS(1326),
    [aux_sym_preproc_def_token1] = ACTIONS(1326),
    [aux_sym_preproc_if_token1] = ACTIONS(1326),
    [aux_sym_preproc_if_token2] = ACTIONS(1326),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1326),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1326),
    [aux_sym_preproc_else_token1] = ACTIONS(1326),
    [aux_sym_preproc_elif_token1] = ACTIONS(1326),
    [sym_preproc_directive] = ACTIONS(1326),
    [anon_sym_LPAREN2] = ACTIONS(1328),
    [anon_sym_BANG] = ACTIONS(1328),
    [anon_sym_TILDE] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_PLUS] = ACTIONS(1326),
    [anon_sym_STAR] = ACTIONS(1328),
    [anon_sym_AMP] = ACTIONS(1328),
    [anon_sym_SEMI] = ACTIONS(1328),
    [anon_sym___extension__] = ACTIONS(1326),
    [anon_sym_typedef] = ACTIONS(1326),
    [anon_sym_extern] = ACTIONS(1326),
    [anon_sym___attribute__] = ACTIONS(1326),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1328),
    [anon_sym___declspec] = ACTIONS(1326),
    [anon_sym___cdecl] = ACTIONS(1326),
    [anon_sym___clrcall] = ACTIONS(1326),
    [anon_sym___stdcall] = ACTIONS(1326),
    [anon_sym___fastcall] = ACTIONS(1326),
    [anon_sym___thiscall] = ACTIONS(1326),
    [anon_sym___vectorcall] = ACTIONS(1326),
    [anon_sym_LBRACE] = ACTIONS(1328),
    [anon_sym_signed] = ACTIONS(1326),
    [anon_sym_unsigned] = ACTIONS(1326),
    [anon_sym_long] = ACTIONS(1326),
    [anon_sym_short] = ACTIONS(1326),
    [anon_sym_static] = ACTIONS(1326),
    [anon_sym_auto] = ACTIONS(1326),
    [anon_sym_register] = ACTIONS(1326),
    [anon_sym_inline] = ACTIONS(1326),
    [anon_sym___inline] = ACTIONS(1326),
    [anon_sym___inline__] = ACTIONS(1326),
    [anon_sym___forceinline] = ACTIONS(1326),
    [anon_sym_thread_local] = ACTIONS(1326),
    [anon_sym___thread] = ACTIONS(1326),
    [anon_sym_const] = ACTIONS(1326),
    [anon_sym_constexpr] = ACTIONS(1326),
    [anon_sym_volatile] = ACTIONS(1326),
    [anon_sym_restrict] = ACTIONS(1326),
    [anon_sym___restrict__] = ACTIONS(1326),
    [anon_sym__Atomic] = ACTIONS(1326),
    [anon_sym__Noreturn] = ACTIONS(1326),
    [anon_sym_noreturn] = ACTIONS(1326),
    [sym_primitive_type] = ACTIONS(1326),
    [anon_sym_enum] = ACTIONS(1326),
    [anon_sym_struct] = ACTIONS(1326),
    [anon_sym_union] = ACTIONS(1326),
    [anon_sym_if] = ACTIONS(1326),
    [anon_sym_else] = ACTIONS(1326),
    [anon_sym_switch] = ACTIONS(1326),
    [anon_sym_case] = ACTIONS(1326),
    [anon_sym_default] = ACTIONS(1326),
    [anon_sym_while] = ACTIONS(1326),
    [anon_sym_do] = ACTIONS(1326),
    [anon_sym_for] = ACTIONS(1326),
    [anon_sym_return] = ACTIONS(1326),
    [anon_sym_break] = ACTIONS(1326),
    [anon_sym_continue] = ACTIONS(1326),
    [anon_sym_goto] = ACTIONS(1326),
    [anon_sym___try] = ACTIONS(1326),
    [anon_sym___leave] = ACTIONS(1326),
    [anon_sym_DASH_DASH] = ACTIONS(1328),
    [anon_sym_PLUS_PLUS] = ACTIONS(1328),
    [anon_sym_sizeof] = ACTIONS(1326),
    [anon_sym___alignof__] = ACTIONS(1326),
    [anon_sym___alignof] = ACTIONS(1326),
    [anon_sym__alignof] = ACTIONS(1326),
    [anon_sym_alignof] = ACTIONS(1326),
    [anon_sym__Alignof] = ACTIONS(1326),
    [anon_sym_offsetof] = ACTIONS(1326),
    [anon_sym__Generic] = ACTIONS(1326),
    [anon_sym_asm] = ACTIONS(1326),
    [anon_sym___asm__] = ACTIONS(1326),
    [sym_number_literal] = ACTIONS(1328),
    [anon_sym_L_SQUOTE] = ACTIONS(1328),
    [anon_sym_u_SQUOTE] = ACTIONS(1328),
    [anon_sym_U_SQUOTE] = ACTIONS(1328),
    [anon_sym_u8_SQUOTE] = ACTIONS(1328),
    [anon_sym_SQUOTE] = ACTIONS(1328),
    [anon_sym_L_DQUOTE] = ACTIONS(1328),
    [anon_sym_u_DQUOTE] = ACTIONS(1328),
    [anon_sym_U_DQUOTE] = ACTIONS(1328),
    [anon_sym_u8_DQUOTE] = ACTIONS(1328),
    [anon_sym_DQUOTE] = ACTIONS(1328),
    [sym_true] = ACTIONS(1326),
    [sym_false] = ACTIONS(1326),
    [anon_sym_NULL] = ACTIONS(1326),
    [anon_sym_nullptr] = ACTIONS(1326),
    [sym_comment] = ACTIONS(3),
  },
  [175] = {
    [sym_identifier] = ACTIONS(1298),
    [aux_sym_preproc_include_token1] = ACTIONS(1298),
    [aux_sym_preproc_def_token1] = ACTIONS(1298),
    [aux_sym_preproc_if_token1] = ACTIONS(1298),
    [aux_sym_preproc_if_token2] = ACTIONS(1298),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1298),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1298),
    [aux_sym_preproc_else_token1] = ACTIONS(1298),
    [aux_sym_preproc_elif_token1] = ACTIONS(1298),
    [sym_preproc_directive] = ACTIONS(1298),
    [anon_sym_LPAREN2] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1300),
    [anon_sym_TILDE] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1298),
    [anon_sym_PLUS] = ACTIONS(1298),
    [anon_sym_STAR] = ACTIONS(1300),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(1300),
    [anon_sym___extension__] = ACTIONS(1298),
    [anon_sym_typedef] = ACTIONS(1298),
    [anon_sym_extern] = ACTIONS(1298),
    [anon_sym___attribute__] = ACTIONS(1298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1300),
    [anon_sym___declspec] = ACTIONS(1298),
    [anon_sym___cdecl] = ACTIONS(1298),
    [anon_sym___clrcall] = ACTIONS(1298),
    [anon_sym___stdcall] = ACTIONS(1298),
    [anon_sym___fastcall] = ACTIONS(1298),
    [anon_sym___thiscall] = ACTIONS(1298),
    [anon_sym___vectorcall] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_signed] = ACTIONS(1298),
    [anon_sym_unsigned] = ACTIONS(1298),
    [anon_sym_long] = ACTIONS(1298),
    [anon_sym_short] = ACTIONS(1298),
    [anon_sym_static] = ACTIONS(1298),
    [anon_sym_auto] = ACTIONS(1298),
    [anon_sym_register] = ACTIONS(1298),
    [anon_sym_inline] = ACTIONS(1298),
    [anon_sym___inline] = ACTIONS(1298),
    [anon_sym___inline__] = ACTIONS(1298),
    [anon_sym___forceinline] = ACTIONS(1298),
    [anon_sym_thread_local] = ACTIONS(1298),
    [anon_sym___thread] = ACTIONS(1298),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_constexpr] = ACTIONS(1298),
    [anon_sym_volatile] = ACTIONS(1298),
    [anon_sym_restrict] = ACTIONS(1298),
    [anon_sym___restrict__] = ACTIONS(1298),
    [anon_sym__Atomic] = ACTIONS(1298),
    [anon_sym__Noreturn] = ACTIONS(1298),
    [anon_sym_noreturn] = ACTIONS(1298),
    [sym_primitive_type] = ACTIONS(1298),
    [anon_sym_enum] = ACTIONS(1298),
    [anon_sym_struct] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1298),
    [anon_sym_if] = ACTIONS(1298),
    [anon_sym_else] = ACTIONS(1298),
    [anon_sym_switch] = ACTIONS(1298),
    [anon_sym_case] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(1298),
    [anon_sym_do] = ACTIONS(1298),
    [anon_sym_for] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1298),
    [anon_sym_break] = ACTIONS(1298),
    [anon_sym_continue] = ACTIONS(1298),
    [anon_sym_goto] = ACTIONS(1298),
    [anon_sym___try] = ACTIONS(1298),
    [anon_sym___leave] = ACTIONS(1298),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_sizeof] = ACTIONS(1298),
    [anon_sym___alignof__] = ACTIONS(1298),
    [anon_sym___alignof] = ACTIONS(1298),
    [anon_sym__alignof] = ACTIONS(1298),
    [anon_sym_alignof] = ACTIONS(1298),
    [anon_sym__Alignof] = ACTIONS(1298),
    [anon_sym_offsetof] = ACTIONS(1298),
    [anon_sym__Generic] = ACTIONS(1298),
    [anon_sym_asm] = ACTIONS(1298),
    [anon_sym___asm__] = ACTIONS(1298),
    [sym_number_literal] = ACTIONS(1300),
    [anon_sym_L_SQUOTE] = ACTIONS(1300),
    [anon_sym_u_SQUOTE] = ACTIONS(1300),
    [anon_sym_U_SQUOTE] = ACTIONS(1300),
    [anon_sym_u8_SQUOTE] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(1300),
    [anon_sym_L_DQUOTE] = ACTIONS(1300),
    [anon_sym_u_DQUOTE] = ACTIONS(1300),
    [anon_sym_U_DQUOTE] = ACTIONS(1300),
    [anon_sym_u8_DQUOTE] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(1300),
    [sym_true] = ACTIONS(1298),
    [sym_false] = ACTIONS(1298),
    [anon_sym_NULL] = ACTIONS(1298),
    [anon_sym_nullptr] = ACTIONS(1298),
    [sym_comment] = ACTIONS(3),
  },
  [176] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [177] = {
    [sym_identifier] = ACTIONS(1298),
    [aux_sym_preproc_include_token1] = ACTIONS(1298),
    [aux_sym_preproc_def_token1] = ACTIONS(1298),
    [aux_sym_preproc_if_token1] = ACTIONS(1298),
    [aux_sym_preproc_if_token2] = ACTIONS(1298),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1298),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1298),
    [aux_sym_preproc_else_token1] = ACTIONS(1298),
    [aux_sym_preproc_elif_token1] = ACTIONS(1298),
    [sym_preproc_directive] = ACTIONS(1298),
    [anon_sym_LPAREN2] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1300),
    [anon_sym_TILDE] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1298),
    [anon_sym_PLUS] = ACTIONS(1298),
    [anon_sym_STAR] = ACTIONS(1300),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(1300),
    [anon_sym___extension__] = ACTIONS(1298),
    [anon_sym_typedef] = ACTIONS(1298),
    [anon_sym_extern] = ACTIONS(1298),
    [anon_sym___attribute__] = ACTIONS(1298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1300),
    [anon_sym___declspec] = ACTIONS(1298),
    [anon_sym___cdecl] = ACTIONS(1298),
    [anon_sym___clrcall] = ACTIONS(1298),
    [anon_sym___stdcall] = ACTIONS(1298),
    [anon_sym___fastcall] = ACTIONS(1298),
    [anon_sym___thiscall] = ACTIONS(1298),
    [anon_sym___vectorcall] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_signed] = ACTIONS(1298),
    [anon_sym_unsigned] = ACTIONS(1298),
    [anon_sym_long] = ACTIONS(1298),
    [anon_sym_short] = ACTIONS(1298),
    [anon_sym_static] = ACTIONS(1298),
    [anon_sym_auto] = ACTIONS(1298),
    [anon_sym_register] = ACTIONS(1298),
    [anon_sym_inline] = ACTIONS(1298),
    [anon_sym___inline] = ACTIONS(1298),
    [anon_sym___inline__] = ACTIONS(1298),
    [anon_sym___forceinline] = ACTIONS(1298),
    [anon_sym_thread_local] = ACTIONS(1298),
    [anon_sym___thread] = ACTIONS(1298),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_constexpr] = ACTIONS(1298),
    [anon_sym_volatile] = ACTIONS(1298),
    [anon_sym_restrict] = ACTIONS(1298),
    [anon_sym___restrict__] = ACTIONS(1298),
    [anon_sym__Atomic] = ACTIONS(1298),
    [anon_sym__Noreturn] = ACTIONS(1298),
    [anon_sym_noreturn] = ACTIONS(1298),
    [sym_primitive_type] = ACTIONS(1298),
    [anon_sym_enum] = ACTIONS(1298),
    [anon_sym_struct] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1298),
    [anon_sym_if] = ACTIONS(1298),
    [anon_sym_else] = ACTIONS(1298),
    [anon_sym_switch] = ACTIONS(1298),
    [anon_sym_case] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(1298),
    [anon_sym_do] = ACTIONS(1298),
    [anon_sym_for] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1298),
    [anon_sym_break] = ACTIONS(1298),
    [anon_sym_continue] = ACTIONS(1298),
    [anon_sym_goto] = ACTIONS(1298),
    [anon_sym___try] = ACTIONS(1298),
    [anon_sym___leave] = ACTIONS(1298),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_sizeof] = ACTIONS(1298),
    [anon_sym___alignof__] = ACTIONS(1298),
    [anon_sym___alignof] = ACTIONS(1298),
    [anon_sym__alignof] = ACTIONS(1298),
    [anon_sym_alignof] = ACTIONS(1298),
    [anon_sym__Alignof] = ACTIONS(1298),
    [anon_sym_offsetof] = ACTIONS(1298),
    [anon_sym__Generic] = ACTIONS(1298),
    [anon_sym_asm] = ACTIONS(1298),
    [anon_sym___asm__] = ACTIONS(1298),
    [sym_number_literal] = ACTIONS(1300),
    [anon_sym_L_SQUOTE] = ACTIONS(1300),
    [anon_sym_u_SQUOTE] = ACTIONS(1300),
    [anon_sym_U_SQUOTE] = ACTIONS(1300),
    [anon_sym_u8_SQUOTE] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(1300),
    [anon_sym_L_DQUOTE] = ACTIONS(1300),
    [anon_sym_u_DQUOTE] = ACTIONS(1300),
    [anon_sym_U_DQUOTE] = ACTIONS(1300),
    [anon_sym_u8_DQUOTE] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(1300),
    [sym_true] = ACTIONS(1298),
    [sym_false] = ACTIONS(1298),
    [anon_sym_NULL] = ACTIONS(1298),
    [anon_sym_nullptr] = ACTIONS(1298),
    [sym_comment] = ACTIONS(3),
  },
  [178] = {
    [sym_identifier] = ACTIONS(1330),
    [aux_sym_preproc_include_token1] = ACTIONS(1330),
    [aux_sym_preproc_def_token1] = ACTIONS(1330),
    [aux_sym_preproc_if_token1] = ACTIONS(1330),
    [aux_sym_preproc_if_token2] = ACTIONS(1330),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1330),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1330),
    [aux_sym_preproc_else_token1] = ACTIONS(1330),
    [aux_sym_preproc_elif_token1] = ACTIONS(1330),
    [sym_preproc_directive] = ACTIONS(1330),
    [anon_sym_LPAREN2] = ACTIONS(1332),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1332),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_AMP] = ACTIONS(1332),
    [anon_sym_SEMI] = ACTIONS(1332),
    [anon_sym___extension__] = ACTIONS(1330),
    [anon_sym_typedef] = ACTIONS(1330),
    [anon_sym_extern] = ACTIONS(1330),
    [anon_sym___attribute__] = ACTIONS(1330),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1332),
    [anon_sym___declspec] = ACTIONS(1330),
    [anon_sym___cdecl] = ACTIONS(1330),
    [anon_sym___clrcall] = ACTIONS(1330),
    [anon_sym___stdcall] = ACTIONS(1330),
    [anon_sym___fastcall] = ACTIONS(1330),
    [anon_sym___thiscall] = ACTIONS(1330),
    [anon_sym___vectorcall] = ACTIONS(1330),
    [anon_sym_LBRACE] = ACTIONS(1332),
    [anon_sym_signed] = ACTIONS(1330),
    [anon_sym_unsigned] = ACTIONS(1330),
    [anon_sym_long] = ACTIONS(1330),
    [anon_sym_short] = ACTIONS(1330),
    [anon_sym_static] = ACTIONS(1330),
    [anon_sym_auto] = ACTIONS(1330),
    [anon_sym_register] = ACTIONS(1330),
    [anon_sym_inline] = ACTIONS(1330),
    [anon_sym___inline] = ACTIONS(1330),
    [anon_sym___inline__] = ACTIONS(1330),
    [anon_sym___forceinline] = ACTIONS(1330),
    [anon_sym_thread_local] = ACTIONS(1330),
    [anon_sym___thread] = ACTIONS(1330),
    [anon_sym_const] = ACTIONS(1330),
    [anon_sym_constexpr] = ACTIONS(1330),
    [anon_sym_volatile] = ACTIONS(1330),
    [anon_sym_restrict] = ACTIONS(1330),
    [anon_sym___restrict__] = ACTIONS(1330),
    [anon_sym__Atomic] = ACTIONS(1330),
    [anon_sym__Noreturn] = ACTIONS(1330),
    [anon_sym_noreturn] = ACTIONS(1330),
    [sym_primitive_type] = ACTIONS(1330),
    [anon_sym_enum] = ACTIONS(1330),
    [anon_sym_struct] = ACTIONS(1330),
    [anon_sym_union] = ACTIONS(1330),
    [anon_sym_if] = ACTIONS(1330),
    [anon_sym_else] = ACTIONS(1330),
    [anon_sym_switch] = ACTIONS(1330),
    [anon_sym_case] = ACTIONS(1330),
    [anon_sym_default] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1330),
    [anon_sym_do] = ACTIONS(1330),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_return] = ACTIONS(1330),
    [anon_sym_break] = ACTIONS(1330),
    [anon_sym_continue] = ACTIONS(1330),
    [anon_sym_goto] = ACTIONS(1330),
    [anon_sym___try] = ACTIONS(1330),
    [anon_sym___leave] = ACTIONS(1330),
    [anon_sym_DASH_DASH] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(1332),
    [anon_sym_sizeof] = ACTIONS(1330),
    [anon_sym___alignof__] = ACTIONS(1330),
    [anon_sym___alignof] = ACTIONS(1330),
    [anon_sym__alignof] = ACTIONS(1330),
    [anon_sym_alignof] = ACTIONS(1330),
    [anon_sym__Alignof] = ACTIONS(1330),
    [anon_sym_offsetof] = ACTIONS(1330),
    [anon_sym__Generic] = ACTIONS(1330),
    [anon_sym_asm] = ACTIONS(1330),
    [anon_sym___asm__] = ACTIONS(1330),
    [sym_number_literal] = ACTIONS(1332),
    [anon_sym_L_SQUOTE] = ACTIONS(1332),
    [anon_sym_u_SQUOTE] = ACTIONS(1332),
    [anon_sym_U_SQUOTE] = ACTIONS(1332),
    [anon_sym_u8_SQUOTE] = ACTIONS(1332),
    [anon_sym_SQUOTE] = ACTIONS(1332),
    [anon_sym_L_DQUOTE] = ACTIONS(1332),
    [anon_sym_u_DQUOTE] = ACTIONS(1332),
    [anon_sym_U_DQUOTE] = ACTIONS(1332),
    [anon_sym_u8_DQUOTE] = ACTIONS(1332),
    [anon_sym_DQUOTE] = ACTIONS(1332),
    [sym_true] = ACTIONS(1330),
    [sym_false] = ACTIONS(1330),
    [anon_sym_NULL] = ACTIONS(1330),
    [anon_sym_nullptr] = ACTIONS(1330),
    [sym_comment] = ACTIONS(3),
  },
  [179] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [180] = {
    [sym_identifier] = ACTIONS(1362),
    [aux_sym_preproc_include_token1] = ACTIONS(1362),
    [aux_sym_preproc_def_token1] = ACTIONS(1362),
    [aux_sym_preproc_if_token1] = ACTIONS(1362),
    [aux_sym_preproc_if_token2] = ACTIONS(1362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1362),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1362),
    [aux_sym_preproc_else_token1] = ACTIONS(1362),
    [aux_sym_preproc_elif_token1] = ACTIONS(1362),
    [sym_preproc_directive] = ACTIONS(1362),
    [anon_sym_LPAREN2] = ACTIONS(1364),
    [anon_sym_BANG] = ACTIONS(1364),
    [anon_sym_TILDE] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_STAR] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_SEMI] = ACTIONS(1364),
    [anon_sym___extension__] = ACTIONS(1362),
    [anon_sym_typedef] = ACTIONS(1362),
    [anon_sym_extern] = ACTIONS(1362),
    [anon_sym___attribute__] = ACTIONS(1362),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1364),
    [anon_sym___declspec] = ACTIONS(1362),
    [anon_sym___cdecl] = ACTIONS(1362),
    [anon_sym___clrcall] = ACTIONS(1362),
    [anon_sym___stdcall] = ACTIONS(1362),
    [anon_sym___fastcall] = ACTIONS(1362),
    [anon_sym___thiscall] = ACTIONS(1362),
    [anon_sym___vectorcall] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(1364),
    [anon_sym_signed] = ACTIONS(1362),
    [anon_sym_unsigned] = ACTIONS(1362),
    [anon_sym_long] = ACTIONS(1362),
    [anon_sym_short] = ACTIONS(1362),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_auto] = ACTIONS(1362),
    [anon_sym_register] = ACTIONS(1362),
    [anon_sym_inline] = ACTIONS(1362),
    [anon_sym___inline] = ACTIONS(1362),
    [anon_sym___inline__] = ACTIONS(1362),
    [anon_sym___forceinline] = ACTIONS(1362),
    [anon_sym_thread_local] = ACTIONS(1362),
    [anon_sym___thread] = ACTIONS(1362),
    [anon_sym_const] = ACTIONS(1362),
    [anon_sym_constexpr] = ACTIONS(1362),
    [anon_sym_volatile] = ACTIONS(1362),
    [anon_sym_restrict] = ACTIONS(1362),
    [anon_sym___restrict__] = ACTIONS(1362),
    [anon_sym__Atomic] = ACTIONS(1362),
    [anon_sym__Noreturn] = ACTIONS(1362),
    [anon_sym_noreturn] = ACTIONS(1362),
    [sym_primitive_type] = ACTIONS(1362),
    [anon_sym_enum] = ACTIONS(1362),
    [anon_sym_struct] = ACTIONS(1362),
    [anon_sym_union] = ACTIONS(1362),
    [anon_sym_if] = ACTIONS(1362),
    [anon_sym_else] = ACTIONS(1362),
    [anon_sym_switch] = ACTIONS(1362),
    [anon_sym_case] = ACTIONS(1362),
    [anon_sym_default] = ACTIONS(1362),
    [anon_sym_while] = ACTIONS(1362),
    [anon_sym_do] = ACTIONS(1362),
    [anon_sym_for] = ACTIONS(1362),
    [anon_sym_return] = ACTIONS(1362),
    [anon_sym_break] = ACTIONS(1362),
    [anon_sym_continue] = ACTIONS(1362),
    [anon_sym_goto] = ACTIONS(1362),
    [anon_sym___try] = ACTIONS(1362),
    [anon_sym___leave] = ACTIONS(1362),
    [anon_sym_DASH_DASH] = ACTIONS(1364),
    [anon_sym_PLUS_PLUS] = ACTIONS(1364),
    [anon_sym_sizeof] = ACTIONS(1362),
    [anon_sym___alignof__] = ACTIONS(1362),
    [anon_sym___alignof] = ACTIONS(1362),
    [anon_sym__alignof] = ACTIONS(1362),
    [anon_sym_alignof] = ACTIONS(1362),
    [anon_sym__Alignof] = ACTIONS(1362),
    [anon_sym_offsetof] = ACTIONS(1362),
    [anon_sym__Generic] = ACTIONS(1362),
    [anon_sym_asm] = ACTIONS(1362),
    [anon_sym___asm__] = ACTIONS(1362),
    [sym_number_literal] = ACTIONS(1364),
    [anon_sym_L_SQUOTE] = ACTIONS(1364),
    [anon_sym_u_SQUOTE] = ACTIONS(1364),
    [anon_sym_U_SQUOTE] = ACTIONS(1364),
    [anon_sym_u8_SQUOTE] = ACTIONS(1364),
    [anon_sym_SQUOTE] = ACTIONS(1364),
    [anon_sym_L_DQUOTE] = ACTIONS(1364),
    [anon_sym_u_DQUOTE] = ACTIONS(1364),
    [anon_sym_U_DQUOTE] = ACTIONS(1364),
    [anon_sym_u8_DQUOTE] = ACTIONS(1364),
    [anon_sym_DQUOTE] = ACTIONS(1364),
    [sym_true] = ACTIONS(1362),
    [sym_false] = ACTIONS(1362),
    [anon_sym_NULL] = ACTIONS(1362),
    [anon_sym_nullptr] = ACTIONS(1362),
    [sym_comment] = ACTIONS(3),
  },
  [181] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [182] = {
    [sym_identifier] = ACTIONS(1358),
    [aux_sym_preproc_include_token1] = ACTIONS(1358),
    [aux_sym_preproc_def_token1] = ACTIONS(1358),
    [aux_sym_preproc_if_token1] = ACTIONS(1358),
    [aux_sym_preproc_if_token2] = ACTIONS(1358),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1358),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1358),
    [aux_sym_preproc_else_token1] = ACTIONS(1358),
    [aux_sym_preproc_elif_token1] = ACTIONS(1358),
    [sym_preproc_directive] = ACTIONS(1358),
    [anon_sym_LPAREN2] = ACTIONS(1360),
    [anon_sym_BANG] = ACTIONS(1360),
    [anon_sym_TILDE] = ACTIONS(1360),
    [anon_sym_DASH] = ACTIONS(1358),
    [anon_sym_PLUS] = ACTIONS(1358),
    [anon_sym_STAR] = ACTIONS(1360),
    [anon_sym_AMP] = ACTIONS(1360),
    [anon_sym_SEMI] = ACTIONS(1360),
    [anon_sym___extension__] = ACTIONS(1358),
    [anon_sym_typedef] = ACTIONS(1358),
    [anon_sym_extern] = ACTIONS(1358),
    [anon_sym___attribute__] = ACTIONS(1358),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1360),
    [anon_sym___declspec] = ACTIONS(1358),
    [anon_sym___cdecl] = ACTIONS(1358),
    [anon_sym___clrcall] = ACTIONS(1358),
    [anon_sym___stdcall] = ACTIONS(1358),
    [anon_sym___fastcall] = ACTIONS(1358),
    [anon_sym___thiscall] = ACTIONS(1358),
    [anon_sym___vectorcall] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_signed] = ACTIONS(1358),
    [anon_sym_unsigned] = ACTIONS(1358),
    [anon_sym_long] = ACTIONS(1358),
    [anon_sym_short] = ACTIONS(1358),
    [anon_sym_static] = ACTIONS(1358),
    [anon_sym_auto] = ACTIONS(1358),
    [anon_sym_register] = ACTIONS(1358),
    [anon_sym_inline] = ACTIONS(1358),
    [anon_sym___inline] = ACTIONS(1358),
    [anon_sym___inline__] = ACTIONS(1358),
    [anon_sym___forceinline] = ACTIONS(1358),
    [anon_sym_thread_local] = ACTIONS(1358),
    [anon_sym___thread] = ACTIONS(1358),
    [anon_sym_const] = ACTIONS(1358),
    [anon_sym_constexpr] = ACTIONS(1358),
    [anon_sym_volatile] = ACTIONS(1358),
    [anon_sym_restrict] = ACTIONS(1358),
    [anon_sym___restrict__] = ACTIONS(1358),
    [anon_sym__Atomic] = ACTIONS(1358),
    [anon_sym__Noreturn] = ACTIONS(1358),
    [anon_sym_noreturn] = ACTIONS(1358),
    [sym_primitive_type] = ACTIONS(1358),
    [anon_sym_enum] = ACTIONS(1358),
    [anon_sym_struct] = ACTIONS(1358),
    [anon_sym_union] = ACTIONS(1358),
    [anon_sym_if] = ACTIONS(1358),
    [anon_sym_else] = ACTIONS(1358),
    [anon_sym_switch] = ACTIONS(1358),
    [anon_sym_case] = ACTIONS(1358),
    [anon_sym_default] = ACTIONS(1358),
    [anon_sym_while] = ACTIONS(1358),
    [anon_sym_do] = ACTIONS(1358),
    [anon_sym_for] = ACTIONS(1358),
    [anon_sym_return] = ACTIONS(1358),
    [anon_sym_break] = ACTIONS(1358),
    [anon_sym_continue] = ACTIONS(1358),
    [anon_sym_goto] = ACTIONS(1358),
    [anon_sym___try] = ACTIONS(1358),
    [anon_sym___leave] = ACTIONS(1358),
    [anon_sym_DASH_DASH] = ACTIONS(1360),
    [anon_sym_PLUS_PLUS] = ACTIONS(1360),
    [anon_sym_sizeof] = ACTIONS(1358),
    [anon_sym___alignof__] = ACTIONS(1358),
    [anon_sym___alignof] = ACTIONS(1358),
    [anon_sym__alignof] = ACTIONS(1358),
    [anon_sym_alignof] = ACTIONS(1358),
    [anon_sym__Alignof] = ACTIONS(1358),
    [anon_sym_offsetof] = ACTIONS(1358),
    [anon_sym__Generic] = ACTIONS(1358),
    [anon_sym_asm] = ACTIONS(1358),
    [anon_sym___asm__] = ACTIONS(1358),
    [sym_number_literal] = ACTIONS(1360),
    [anon_sym_L_SQUOTE] = ACTIONS(1360),
    [anon_sym_u_SQUOTE] = ACTIONS(1360),
    [anon_sym_U_SQUOTE] = ACTIONS(1360),
    [anon_sym_u8_SQUOTE] = ACTIONS(1360),
    [anon_sym_SQUOTE] = ACTIONS(1360),
    [anon_sym_L_DQUOTE] = ACTIONS(1360),
    [anon_sym_u_DQUOTE] = ACTIONS(1360),
    [anon_sym_U_DQUOTE] = ACTIONS(1360),
    [anon_sym_u8_DQUOTE] = ACTIONS(1360),
    [anon_sym_DQUOTE] = ACTIONS(1360),
    [sym_true] = ACTIONS(1358),
    [sym_false] = ACTIONS(1358),
    [anon_sym_NULL] = ACTIONS(1358),
    [anon_sym_nullptr] = ACTIONS(1358),
    [sym_comment] = ACTIONS(3),
  },
  [183] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [184] = {
    [sym_identifier] = ACTIONS(1414),
    [aux_sym_preproc_include_token1] = ACTIONS(1414),
    [aux_sym_preproc_def_token1] = ACTIONS(1414),
    [aux_sym_preproc_if_token1] = ACTIONS(1414),
    [aux_sym_preproc_if_token2] = ACTIONS(1414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1414),
    [aux_sym_preproc_else_token1] = ACTIONS(1414),
    [aux_sym_preproc_elif_token1] = ACTIONS(1414),
    [sym_preproc_directive] = ACTIONS(1414),
    [anon_sym_LPAREN2] = ACTIONS(1416),
    [anon_sym_BANG] = ACTIONS(1416),
    [anon_sym_TILDE] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1416),
    [anon_sym_AMP] = ACTIONS(1416),
    [anon_sym_SEMI] = ACTIONS(1416),
    [anon_sym___extension__] = ACTIONS(1414),
    [anon_sym_typedef] = ACTIONS(1414),
    [anon_sym_extern] = ACTIONS(1414),
    [anon_sym___attribute__] = ACTIONS(1414),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1416),
    [anon_sym___declspec] = ACTIONS(1414),
    [anon_sym___cdecl] = ACTIONS(1414),
    [anon_sym___clrcall] = ACTIONS(1414),
    [anon_sym___stdcall] = ACTIONS(1414),
    [anon_sym___fastcall] = ACTIONS(1414),
    [anon_sym___thiscall] = ACTIONS(1414),
    [anon_sym___vectorcall] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1416),
    [anon_sym_signed] = ACTIONS(1414),
    [anon_sym_unsigned] = ACTIONS(1414),
    [anon_sym_long] = ACTIONS(1414),
    [anon_sym_short] = ACTIONS(1414),
    [anon_sym_static] = ACTIONS(1414),
    [anon_sym_auto] = ACTIONS(1414),
    [anon_sym_register] = ACTIONS(1414),
    [anon_sym_inline] = ACTIONS(1414),
    [anon_sym___inline] = ACTIONS(1414),
    [anon_sym___inline__] = ACTIONS(1414),
    [anon_sym___forceinline] = ACTIONS(1414),
    [anon_sym_thread_local] = ACTIONS(1414),
    [anon_sym___thread] = ACTIONS(1414),
    [anon_sym_const] = ACTIONS(1414),
    [anon_sym_constexpr] = ACTIONS(1414),
    [anon_sym_volatile] = ACTIONS(1414),
    [anon_sym_restrict] = ACTIONS(1414),
    [anon_sym___restrict__] = ACTIONS(1414),
    [anon_sym__Atomic] = ACTIONS(1414),
    [anon_sym__Noreturn] = ACTIONS(1414),
    [anon_sym_noreturn] = ACTIONS(1414),
    [sym_primitive_type] = ACTIONS(1414),
    [anon_sym_enum] = ACTIONS(1414),
    [anon_sym_struct] = ACTIONS(1414),
    [anon_sym_union] = ACTIONS(1414),
    [anon_sym_if] = ACTIONS(1414),
    [anon_sym_else] = ACTIONS(1414),
    [anon_sym_switch] = ACTIONS(1414),
    [anon_sym_case] = ACTIONS(1414),
    [anon_sym_default] = ACTIONS(1414),
    [anon_sym_while] = ACTIONS(1414),
    [anon_sym_do] = ACTIONS(1414),
    [anon_sym_for] = ACTIONS(1414),
    [anon_sym_return] = ACTIONS(1414),
    [anon_sym_break] = ACTIONS(1414),
    [anon_sym_continue] = ACTIONS(1414),
    [anon_sym_goto] = ACTIONS(1414),
    [anon_sym___try] = ACTIONS(1414),
    [anon_sym___leave] = ACTIONS(1414),
    [anon_sym_DASH_DASH] = ACTIONS(1416),
    [anon_sym_PLUS_PLUS] = ACTIONS(1416),
    [anon_sym_sizeof] = ACTIONS(1414),
    [anon_sym___alignof__] = ACTIONS(1414),
    [anon_sym___alignof] = ACTIONS(1414),
    [anon_sym__alignof] = ACTIONS(1414),
    [anon_sym_alignof] = ACTIONS(1414),
    [anon_sym__Alignof] = ACTIONS(1414),
    [anon_sym_offsetof] = ACTIONS(1414),
    [anon_sym__Generic] = ACTIONS(1414),
    [anon_sym_asm] = ACTIONS(1414),
    [anon_sym___asm__] = ACTIONS(1414),
    [sym_number_literal] = ACTIONS(1416),
    [anon_sym_L_SQUOTE] = ACTIONS(1416),
    [anon_sym_u_SQUOTE] = ACTIONS(1416),
    [anon_sym_U_SQUOTE] = ACTIONS(1416),
    [anon_sym_u8_SQUOTE] = ACTIONS(1416),
    [anon_sym_SQUOTE] = ACTIONS(1416),
    [anon_sym_L_DQUOTE] = ACTIONS(1416),
    [anon_sym_u_DQUOTE] = ACTIONS(1416),
    [anon_sym_U_DQUOTE] = ACTIONS(1416),
    [anon_sym_u8_DQUOTE] = ACTIONS(1416),
    [anon_sym_DQUOTE] = ACTIONS(1416),
    [sym_true] = ACTIONS(1414),
    [sym_false] = ACTIONS(1414),
    [anon_sym_NULL] = ACTIONS(1414),
    [anon_sym_nullptr] = ACTIONS(1414),
    [sym_comment] = ACTIONS(3),
  },
  [185] = {
    [sym_identifier] = ACTIONS(1366),
    [aux_sym_preproc_include_token1] = ACTIONS(1366),
    [aux_sym_preproc_def_token1] = ACTIONS(1366),
    [aux_sym_preproc_if_token1] = ACTIONS(1366),
    [aux_sym_preproc_if_token2] = ACTIONS(1366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1366),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1366),
    [aux_sym_preproc_else_token1] = ACTIONS(1366),
    [aux_sym_preproc_elif_token1] = ACTIONS(1366),
    [sym_preproc_directive] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_BANG] = ACTIONS(1368),
    [anon_sym_TILDE] = ACTIONS(1368),
    [anon_sym_DASH] = ACTIONS(1366),
    [anon_sym_PLUS] = ACTIONS(1366),
    [anon_sym_STAR] = ACTIONS(1368),
    [anon_sym_AMP] = ACTIONS(1368),
    [anon_sym_SEMI] = ACTIONS(1368),
    [anon_sym___extension__] = ACTIONS(1366),
    [anon_sym_typedef] = ACTIONS(1366),
    [anon_sym_extern] = ACTIONS(1366),
    [anon_sym___attribute__] = ACTIONS(1366),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1368),
    [anon_sym___declspec] = ACTIONS(1366),
    [anon_sym___cdecl] = ACTIONS(1366),
    [anon_sym___clrcall] = ACTIONS(1366),
    [anon_sym___stdcall] = ACTIONS(1366),
    [anon_sym___fastcall] = ACTIONS(1366),
    [anon_sym___thiscall] = ACTIONS(1366),
    [anon_sym___vectorcall] = ACTIONS(1366),
    [anon_sym_LBRACE] = ACTIONS(1368),
    [anon_sym_signed] = ACTIONS(1366),
    [anon_sym_unsigned] = ACTIONS(1366),
    [anon_sym_long] = ACTIONS(1366),
    [anon_sym_short] = ACTIONS(1366),
    [anon_sym_static] = ACTIONS(1366),
    [anon_sym_auto] = ACTIONS(1366),
    [anon_sym_register] = ACTIONS(1366),
    [anon_sym_inline] = ACTIONS(1366),
    [anon_sym___inline] = ACTIONS(1366),
    [anon_sym___inline__] = ACTIONS(1366),
    [anon_sym___forceinline] = ACTIONS(1366),
    [anon_sym_thread_local] = ACTIONS(1366),
    [anon_sym___thread] = ACTIONS(1366),
    [anon_sym_const] = ACTIONS(1366),
    [anon_sym_constexpr] = ACTIONS(1366),
    [anon_sym_volatile] = ACTIONS(1366),
    [anon_sym_restrict] = ACTIONS(1366),
    [anon_sym___restrict__] = ACTIONS(1366),
    [anon_sym__Atomic] = ACTIONS(1366),
    [anon_sym__Noreturn] = ACTIONS(1366),
    [anon_sym_noreturn] = ACTIONS(1366),
    [sym_primitive_type] = ACTIONS(1366),
    [anon_sym_enum] = ACTIONS(1366),
    [anon_sym_struct] = ACTIONS(1366),
    [anon_sym_union] = ACTIONS(1366),
    [anon_sym_if] = ACTIONS(1366),
    [anon_sym_else] = ACTIONS(1366),
    [anon_sym_switch] = ACTIONS(1366),
    [anon_sym_case] = ACTIONS(1366),
    [anon_sym_default] = ACTIONS(1366),
    [anon_sym_while] = ACTIONS(1366),
    [anon_sym_do] = ACTIONS(1366),
    [anon_sym_for] = ACTIONS(1366),
    [anon_sym_return] = ACTIONS(1366),
    [anon_sym_break] = ACTIONS(1366),
    [anon_sym_continue] = ACTIONS(1366),
    [anon_sym_goto] = ACTIONS(1366),
    [anon_sym___try] = ACTIONS(1366),
    [anon_sym___leave] = ACTIONS(1366),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_sizeof] = ACTIONS(1366),
    [anon_sym___alignof__] = ACTIONS(1366),
    [anon_sym___alignof] = ACTIONS(1366),
    [anon_sym__alignof] = ACTIONS(1366),
    [anon_sym_alignof] = ACTIONS(1366),
    [anon_sym__Alignof] = ACTIONS(1366),
    [anon_sym_offsetof] = ACTIONS(1366),
    [anon_sym__Generic] = ACTIONS(1366),
    [anon_sym_asm] = ACTIONS(1366),
    [anon_sym___asm__] = ACTIONS(1366),
    [sym_number_literal] = ACTIONS(1368),
    [anon_sym_L_SQUOTE] = ACTIONS(1368),
    [anon_sym_u_SQUOTE] = ACTIONS(1368),
    [anon_sym_U_SQUOTE] = ACTIONS(1368),
    [anon_sym_u8_SQUOTE] = ACTIONS(1368),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_L_DQUOTE] = ACTIONS(1368),
    [anon_sym_u_DQUOTE] = ACTIONS(1368),
    [anon_sym_U_DQUOTE] = ACTIONS(1368),
    [anon_sym_u8_DQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [sym_true] = ACTIONS(1366),
    [sym_false] = ACTIONS(1366),
    [anon_sym_NULL] = ACTIONS(1366),
    [anon_sym_nullptr] = ACTIONS(1366),
    [sym_comment] = ACTIONS(3),
  },
  [186] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [187] = {
    [sym_identifier] = ACTIONS(1414),
    [aux_sym_preproc_include_token1] = ACTIONS(1414),
    [aux_sym_preproc_def_token1] = ACTIONS(1414),
    [aux_sym_preproc_if_token1] = ACTIONS(1414),
    [aux_sym_preproc_if_token2] = ACTIONS(1414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1414),
    [aux_sym_preproc_else_token1] = ACTIONS(1414),
    [aux_sym_preproc_elif_token1] = ACTIONS(1414),
    [sym_preproc_directive] = ACTIONS(1414),
    [anon_sym_LPAREN2] = ACTIONS(1416),
    [anon_sym_BANG] = ACTIONS(1416),
    [anon_sym_TILDE] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1416),
    [anon_sym_AMP] = ACTIONS(1416),
    [anon_sym_SEMI] = ACTIONS(1416),
    [anon_sym___extension__] = ACTIONS(1414),
    [anon_sym_typedef] = ACTIONS(1414),
    [anon_sym_extern] = ACTIONS(1414),
    [anon_sym___attribute__] = ACTIONS(1414),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1416),
    [anon_sym___declspec] = ACTIONS(1414),
    [anon_sym___cdecl] = ACTIONS(1414),
    [anon_sym___clrcall] = ACTIONS(1414),
    [anon_sym___stdcall] = ACTIONS(1414),
    [anon_sym___fastcall] = ACTIONS(1414),
    [anon_sym___thiscall] = ACTIONS(1414),
    [anon_sym___vectorcall] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1416),
    [anon_sym_signed] = ACTIONS(1414),
    [anon_sym_unsigned] = ACTIONS(1414),
    [anon_sym_long] = ACTIONS(1414),
    [anon_sym_short] = ACTIONS(1414),
    [anon_sym_static] = ACTIONS(1414),
    [anon_sym_auto] = ACTIONS(1414),
    [anon_sym_register] = ACTIONS(1414),
    [anon_sym_inline] = ACTIONS(1414),
    [anon_sym___inline] = ACTIONS(1414),
    [anon_sym___inline__] = ACTIONS(1414),
    [anon_sym___forceinline] = ACTIONS(1414),
    [anon_sym_thread_local] = ACTIONS(1414),
    [anon_sym___thread] = ACTIONS(1414),
    [anon_sym_const] = ACTIONS(1414),
    [anon_sym_constexpr] = ACTIONS(1414),
    [anon_sym_volatile] = ACTIONS(1414),
    [anon_sym_restrict] = ACTIONS(1414),
    [anon_sym___restrict__] = ACTIONS(1414),
    [anon_sym__Atomic] = ACTIONS(1414),
    [anon_sym__Noreturn] = ACTIONS(1414),
    [anon_sym_noreturn] = ACTIONS(1414),
    [sym_primitive_type] = ACTIONS(1414),
    [anon_sym_enum] = ACTIONS(1414),
    [anon_sym_struct] = ACTIONS(1414),
    [anon_sym_union] = ACTIONS(1414),
    [anon_sym_if] = ACTIONS(1414),
    [anon_sym_else] = ACTIONS(1414),
    [anon_sym_switch] = ACTIONS(1414),
    [anon_sym_case] = ACTIONS(1414),
    [anon_sym_default] = ACTIONS(1414),
    [anon_sym_while] = ACTIONS(1414),
    [anon_sym_do] = ACTIONS(1414),
    [anon_sym_for] = ACTIONS(1414),
    [anon_sym_return] = ACTIONS(1414),
    [anon_sym_break] = ACTIONS(1414),
    [anon_sym_continue] = ACTIONS(1414),
    [anon_sym_goto] = ACTIONS(1414),
    [anon_sym___try] = ACTIONS(1414),
    [anon_sym___leave] = ACTIONS(1414),
    [anon_sym_DASH_DASH] = ACTIONS(1416),
    [anon_sym_PLUS_PLUS] = ACTIONS(1416),
    [anon_sym_sizeof] = ACTIONS(1414),
    [anon_sym___alignof__] = ACTIONS(1414),
    [anon_sym___alignof] = ACTIONS(1414),
    [anon_sym__alignof] = ACTIONS(1414),
    [anon_sym_alignof] = ACTIONS(1414),
    [anon_sym__Alignof] = ACTIONS(1414),
    [anon_sym_offsetof] = ACTIONS(1414),
    [anon_sym__Generic] = ACTIONS(1414),
    [anon_sym_asm] = ACTIONS(1414),
    [anon_sym___asm__] = ACTIONS(1414),
    [sym_number_literal] = ACTIONS(1416),
    [anon_sym_L_SQUOTE] = ACTIONS(1416),
    [anon_sym_u_SQUOTE] = ACTIONS(1416),
    [anon_sym_U_SQUOTE] = ACTIONS(1416),
    [anon_sym_u8_SQUOTE] = ACTIONS(1416),
    [anon_sym_SQUOTE] = ACTIONS(1416),
    [anon_sym_L_DQUOTE] = ACTIONS(1416),
    [anon_sym_u_DQUOTE] = ACTIONS(1416),
    [anon_sym_U_DQUOTE] = ACTIONS(1416),
    [anon_sym_u8_DQUOTE] = ACTIONS(1416),
    [anon_sym_DQUOTE] = ACTIONS(1416),
    [sym_true] = ACTIONS(1414),
    [sym_false] = ACTIONS(1414),
    [anon_sym_NULL] = ACTIONS(1414),
    [anon_sym_nullptr] = ACTIONS(1414),
    [sym_comment] = ACTIONS(3),
  },
  [188] = {
    [sym_identifier] = ACTIONS(1370),
    [aux_sym_preproc_include_token1] = ACTIONS(1370),
    [aux_sym_preproc_def_token1] = ACTIONS(1370),
    [aux_sym_preproc_if_token1] = ACTIONS(1370),
    [aux_sym_preproc_if_token2] = ACTIONS(1370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1370),
    [aux_sym_preproc_else_token1] = ACTIONS(1370),
    [aux_sym_preproc_elif_token1] = ACTIONS(1370),
    [sym_preproc_directive] = ACTIONS(1370),
    [anon_sym_LPAREN2] = ACTIONS(1372),
    [anon_sym_BANG] = ACTIONS(1372),
    [anon_sym_TILDE] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_STAR] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1372),
    [anon_sym___extension__] = ACTIONS(1370),
    [anon_sym_typedef] = ACTIONS(1370),
    [anon_sym_extern] = ACTIONS(1370),
    [anon_sym___attribute__] = ACTIONS(1370),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1372),
    [anon_sym___declspec] = ACTIONS(1370),
    [anon_sym___cdecl] = ACTIONS(1370),
    [anon_sym___clrcall] = ACTIONS(1370),
    [anon_sym___stdcall] = ACTIONS(1370),
    [anon_sym___fastcall] = ACTIONS(1370),
    [anon_sym___thiscall] = ACTIONS(1370),
    [anon_sym___vectorcall] = ACTIONS(1370),
    [anon_sym_LBRACE] = ACTIONS(1372),
    [anon_sym_signed] = ACTIONS(1370),
    [anon_sym_unsigned] = ACTIONS(1370),
    [anon_sym_long] = ACTIONS(1370),
    [anon_sym_short] = ACTIONS(1370),
    [anon_sym_static] = ACTIONS(1370),
    [anon_sym_auto] = ACTIONS(1370),
    [anon_sym_register] = ACTIONS(1370),
    [anon_sym_inline] = ACTIONS(1370),
    [anon_sym___inline] = ACTIONS(1370),
    [anon_sym___inline__] = ACTIONS(1370),
    [anon_sym___forceinline] = ACTIONS(1370),
    [anon_sym_thread_local] = ACTIONS(1370),
    [anon_sym___thread] = ACTIONS(1370),
    [anon_sym_const] = ACTIONS(1370),
    [anon_sym_constexpr] = ACTIONS(1370),
    [anon_sym_volatile] = ACTIONS(1370),
    [anon_sym_restrict] = ACTIONS(1370),
    [anon_sym___restrict__] = ACTIONS(1370),
    [anon_sym__Atomic] = ACTIONS(1370),
    [anon_sym__Noreturn] = ACTIONS(1370),
    [anon_sym_noreturn] = ACTIONS(1370),
    [sym_primitive_type] = ACTIONS(1370),
    [anon_sym_enum] = ACTIONS(1370),
    [anon_sym_struct] = ACTIONS(1370),
    [anon_sym_union] = ACTIONS(1370),
    [anon_sym_if] = ACTIONS(1370),
    [anon_sym_else] = ACTIONS(1370),
    [anon_sym_switch] = ACTIONS(1370),
    [anon_sym_case] = ACTIONS(1370),
    [anon_sym_default] = ACTIONS(1370),
    [anon_sym_while] = ACTIONS(1370),
    [anon_sym_do] = ACTIONS(1370),
    [anon_sym_for] = ACTIONS(1370),
    [anon_sym_return] = ACTIONS(1370),
    [anon_sym_break] = ACTIONS(1370),
    [anon_sym_continue] = ACTIONS(1370),
    [anon_sym_goto] = ACTIONS(1370),
    [anon_sym___try] = ACTIONS(1370),
    [anon_sym___leave] = ACTIONS(1370),
    [anon_sym_DASH_DASH] = ACTIONS(1372),
    [anon_sym_PLUS_PLUS] = ACTIONS(1372),
    [anon_sym_sizeof] = ACTIONS(1370),
    [anon_sym___alignof__] = ACTIONS(1370),
    [anon_sym___alignof] = ACTIONS(1370),
    [anon_sym__alignof] = ACTIONS(1370),
    [anon_sym_alignof] = ACTIONS(1370),
    [anon_sym__Alignof] = ACTIONS(1370),
    [anon_sym_offsetof] = ACTIONS(1370),
    [anon_sym__Generic] = ACTIONS(1370),
    [anon_sym_asm] = ACTIONS(1370),
    [anon_sym___asm__] = ACTIONS(1370),
    [sym_number_literal] = ACTIONS(1372),
    [anon_sym_L_SQUOTE] = ACTIONS(1372),
    [anon_sym_u_SQUOTE] = ACTIONS(1372),
    [anon_sym_U_SQUOTE] = ACTIONS(1372),
    [anon_sym_u8_SQUOTE] = ACTIONS(1372),
    [anon_sym_SQUOTE] = ACTIONS(1372),
    [anon_sym_L_DQUOTE] = ACTIONS(1372),
    [anon_sym_u_DQUOTE] = ACTIONS(1372),
    [anon_sym_U_DQUOTE] = ACTIONS(1372),
    [anon_sym_u8_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1372),
    [sym_true] = ACTIONS(1370),
    [sym_false] = ACTIONS(1370),
    [anon_sym_NULL] = ACTIONS(1370),
    [anon_sym_nullptr] = ACTIONS(1370),
    [sym_comment] = ACTIONS(3),
  },
  [189] = {
    [sym_identifier] = ACTIONS(1374),
    [aux_sym_preproc_include_token1] = ACTIONS(1374),
    [aux_sym_preproc_def_token1] = ACTIONS(1374),
    [aux_sym_preproc_if_token1] = ACTIONS(1374),
    [aux_sym_preproc_if_token2] = ACTIONS(1374),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1374),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1374),
    [aux_sym_preproc_else_token1] = ACTIONS(1374),
    [aux_sym_preproc_elif_token1] = ACTIONS(1374),
    [sym_preproc_directive] = ACTIONS(1374),
    [anon_sym_LPAREN2] = ACTIONS(1376),
    [anon_sym_BANG] = ACTIONS(1376),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_DASH] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1374),
    [anon_sym_STAR] = ACTIONS(1376),
    [anon_sym_AMP] = ACTIONS(1376),
    [anon_sym_SEMI] = ACTIONS(1376),
    [anon_sym___extension__] = ACTIONS(1374),
    [anon_sym_typedef] = ACTIONS(1374),
    [anon_sym_extern] = ACTIONS(1374),
    [anon_sym___attribute__] = ACTIONS(1374),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1376),
    [anon_sym___declspec] = ACTIONS(1374),
    [anon_sym___cdecl] = ACTIONS(1374),
    [anon_sym___clrcall] = ACTIONS(1374),
    [anon_sym___stdcall] = ACTIONS(1374),
    [anon_sym___fastcall] = ACTIONS(1374),
    [anon_sym___thiscall] = ACTIONS(1374),
    [anon_sym___vectorcall] = ACTIONS(1374),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_signed] = ACTIONS(1374),
    [anon_sym_unsigned] = ACTIONS(1374),
    [anon_sym_long] = ACTIONS(1374),
    [anon_sym_short] = ACTIONS(1374),
    [anon_sym_static] = ACTIONS(1374),
    [anon_sym_auto] = ACTIONS(1374),
    [anon_sym_register] = ACTIONS(1374),
    [anon_sym_inline] = ACTIONS(1374),
    [anon_sym___inline] = ACTIONS(1374),
    [anon_sym___inline__] = ACTIONS(1374),
    [anon_sym___forceinline] = ACTIONS(1374),
    [anon_sym_thread_local] = ACTIONS(1374),
    [anon_sym___thread] = ACTIONS(1374),
    [anon_sym_const] = ACTIONS(1374),
    [anon_sym_constexpr] = ACTIONS(1374),
    [anon_sym_volatile] = ACTIONS(1374),
    [anon_sym_restrict] = ACTIONS(1374),
    [anon_sym___restrict__] = ACTIONS(1374),
    [anon_sym__Atomic] = ACTIONS(1374),
    [anon_sym__Noreturn] = ACTIONS(1374),
    [anon_sym_noreturn] = ACTIONS(1374),
    [sym_primitive_type] = ACTIONS(1374),
    [anon_sym_enum] = ACTIONS(1374),
    [anon_sym_struct] = ACTIONS(1374),
    [anon_sym_union] = ACTIONS(1374),
    [anon_sym_if] = ACTIONS(1374),
    [anon_sym_else] = ACTIONS(1374),
    [anon_sym_switch] = ACTIONS(1374),
    [anon_sym_case] = ACTIONS(1374),
    [anon_sym_default] = ACTIONS(1374),
    [anon_sym_while] = ACTIONS(1374),
    [anon_sym_do] = ACTIONS(1374),
    [anon_sym_for] = ACTIONS(1374),
    [anon_sym_return] = ACTIONS(1374),
    [anon_sym_break] = ACTIONS(1374),
    [anon_sym_continue] = ACTIONS(1374),
    [anon_sym_goto] = ACTIONS(1374),
    [anon_sym___try] = ACTIONS(1374),
    [anon_sym___leave] = ACTIONS(1374),
    [anon_sym_DASH_DASH] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1376),
    [anon_sym_sizeof] = ACTIONS(1374),
    [anon_sym___alignof__] = ACTIONS(1374),
    [anon_sym___alignof] = ACTIONS(1374),
    [anon_sym__alignof] = ACTIONS(1374),
    [anon_sym_alignof] = ACTIONS(1374),
    [anon_sym__Alignof] = ACTIONS(1374),
    [anon_sym_offsetof] = ACTIONS(1374),
    [anon_sym__Generic] = ACTIONS(1374),
    [anon_sym_asm] = ACTIONS(1374),
    [anon_sym___asm__] = ACTIONS(1374),
    [sym_number_literal] = ACTIONS(1376),
    [anon_sym_L_SQUOTE] = ACTIONS(1376),
    [anon_sym_u_SQUOTE] = ACTIONS(1376),
    [anon_sym_U_SQUOTE] = ACTIONS(1376),
    [anon_sym_u8_SQUOTE] = ACTIONS(1376),
    [anon_sym_SQUOTE] = ACTIONS(1376),
    [anon_sym_L_DQUOTE] = ACTIONS(1376),
    [anon_sym_u_DQUOTE] = ACTIONS(1376),
    [anon_sym_U_DQUOTE] = ACTIONS(1376),
    [anon_sym_u8_DQUOTE] = ACTIONS(1376),
    [anon_sym_DQUOTE] = ACTIONS(1376),
    [sym_true] = ACTIONS(1374),
    [sym_false] = ACTIONS(1374),
    [anon_sym_NULL] = ACTIONS(1374),
    [anon_sym_nullptr] = ACTIONS(1374),
    [sym_comment] = ACTIONS(3),
  },
  [190] = {
    [sym_identifier] = ACTIONS(1418),
    [aux_sym_preproc_include_token1] = ACTIONS(1418),
    [aux_sym_preproc_def_token1] = ACTIONS(1418),
    [aux_sym_preproc_if_token1] = ACTIONS(1418),
    [aux_sym_preproc_if_token2] = ACTIONS(1418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1418),
    [aux_sym_preproc_else_token1] = ACTIONS(1418),
    [aux_sym_preproc_elif_token1] = ACTIONS(1418),
    [sym_preproc_directive] = ACTIONS(1418),
    [anon_sym_LPAREN2] = ACTIONS(1420),
    [anon_sym_BANG] = ACTIONS(1420),
    [anon_sym_TILDE] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_AMP] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(1420),
    [anon_sym___extension__] = ACTIONS(1418),
    [anon_sym_typedef] = ACTIONS(1418),
    [anon_sym_extern] = ACTIONS(1418),
    [anon_sym___attribute__] = ACTIONS(1418),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1420),
    [anon_sym___declspec] = ACTIONS(1418),
    [anon_sym___cdecl] = ACTIONS(1418),
    [anon_sym___clrcall] = ACTIONS(1418),
    [anon_sym___stdcall] = ACTIONS(1418),
    [anon_sym___fastcall] = ACTIONS(1418),
    [anon_sym___thiscall] = ACTIONS(1418),
    [anon_sym___vectorcall] = ACTIONS(1418),
    [anon_sym_LBRACE] = ACTIONS(1420),
    [anon_sym_signed] = ACTIONS(1418),
    [anon_sym_unsigned] = ACTIONS(1418),
    [anon_sym_long] = ACTIONS(1418),
    [anon_sym_short] = ACTIONS(1418),
    [anon_sym_static] = ACTIONS(1418),
    [anon_sym_auto] = ACTIONS(1418),
    [anon_sym_register] = ACTIONS(1418),
    [anon_sym_inline] = ACTIONS(1418),
    [anon_sym___inline] = ACTIONS(1418),
    [anon_sym___inline__] = ACTIONS(1418),
    [anon_sym___forceinline] = ACTIONS(1418),
    [anon_sym_thread_local] = ACTIONS(1418),
    [anon_sym___thread] = ACTIONS(1418),
    [anon_sym_const] = ACTIONS(1418),
    [anon_sym_constexpr] = ACTIONS(1418),
    [anon_sym_volatile] = ACTIONS(1418),
    [anon_sym_restrict] = ACTIONS(1418),
    [anon_sym___restrict__] = ACTIONS(1418),
    [anon_sym__Atomic] = ACTIONS(1418),
    [anon_sym__Noreturn] = ACTIONS(1418),
    [anon_sym_noreturn] = ACTIONS(1418),
    [sym_primitive_type] = ACTIONS(1418),
    [anon_sym_enum] = ACTIONS(1418),
    [anon_sym_struct] = ACTIONS(1418),
    [anon_sym_union] = ACTIONS(1418),
    [anon_sym_if] = ACTIONS(1418),
    [anon_sym_else] = ACTIONS(1418),
    [anon_sym_switch] = ACTIONS(1418),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_default] = ACTIONS(1418),
    [anon_sym_while] = ACTIONS(1418),
    [anon_sym_do] = ACTIONS(1418),
    [anon_sym_for] = ACTIONS(1418),
    [anon_sym_return] = ACTIONS(1418),
    [anon_sym_break] = ACTIONS(1418),
    [anon_sym_continue] = ACTIONS(1418),
    [anon_sym_goto] = ACTIONS(1418),
    [anon_sym___try] = ACTIONS(1418),
    [anon_sym___leave] = ACTIONS(1418),
    [anon_sym_DASH_DASH] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1420),
    [anon_sym_sizeof] = ACTIONS(1418),
    [anon_sym___alignof__] = ACTIONS(1418),
    [anon_sym___alignof] = ACTIONS(1418),
    [anon_sym__alignof] = ACTIONS(1418),
    [anon_sym_alignof] = ACTIONS(1418),
    [anon_sym__Alignof] = ACTIONS(1418),
    [anon_sym_offsetof] = ACTIONS(1418),
    [anon_sym__Generic] = ACTIONS(1418),
    [anon_sym_asm] = ACTIONS(1418),
    [anon_sym___asm__] = ACTIONS(1418),
    [sym_number_literal] = ACTIONS(1420),
    [anon_sym_L_SQUOTE] = ACTIONS(1420),
    [anon_sym_u_SQUOTE] = ACTIONS(1420),
    [anon_sym_U_SQUOTE] = ACTIONS(1420),
    [anon_sym_u8_SQUOTE] = ACTIONS(1420),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [anon_sym_L_DQUOTE] = ACTIONS(1420),
    [anon_sym_u_DQUOTE] = ACTIONS(1420),
    [anon_sym_U_DQUOTE] = ACTIONS(1420),
    [anon_sym_u8_DQUOTE] = ACTIONS(1420),
    [anon_sym_DQUOTE] = ACTIONS(1420),
    [sym_true] = ACTIONS(1418),
    [sym_false] = ACTIONS(1418),
    [anon_sym_NULL] = ACTIONS(1418),
    [anon_sym_nullptr] = ACTIONS(1418),
    [sym_comment] = ACTIONS(3),
  },
  [191] = {
    [sym_identifier] = ACTIONS(1418),
    [aux_sym_preproc_include_token1] = ACTIONS(1418),
    [aux_sym_preproc_def_token1] = ACTIONS(1418),
    [aux_sym_preproc_if_token1] = ACTIONS(1418),
    [aux_sym_preproc_if_token2] = ACTIONS(1418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1418),
    [aux_sym_preproc_else_token1] = ACTIONS(1418),
    [aux_sym_preproc_elif_token1] = ACTIONS(1418),
    [sym_preproc_directive] = ACTIONS(1418),
    [anon_sym_LPAREN2] = ACTIONS(1420),
    [anon_sym_BANG] = ACTIONS(1420),
    [anon_sym_TILDE] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_AMP] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(1420),
    [anon_sym___extension__] = ACTIONS(1418),
    [anon_sym_typedef] = ACTIONS(1418),
    [anon_sym_extern] = ACTIONS(1418),
    [anon_sym___attribute__] = ACTIONS(1418),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1420),
    [anon_sym___declspec] = ACTIONS(1418),
    [anon_sym___cdecl] = ACTIONS(1418),
    [anon_sym___clrcall] = ACTIONS(1418),
    [anon_sym___stdcall] = ACTIONS(1418),
    [anon_sym___fastcall] = ACTIONS(1418),
    [anon_sym___thiscall] = ACTIONS(1418),
    [anon_sym___vectorcall] = ACTIONS(1418),
    [anon_sym_LBRACE] = ACTIONS(1420),
    [anon_sym_signed] = ACTIONS(1418),
    [anon_sym_unsigned] = ACTIONS(1418),
    [anon_sym_long] = ACTIONS(1418),
    [anon_sym_short] = ACTIONS(1418),
    [anon_sym_static] = ACTIONS(1418),
    [anon_sym_auto] = ACTIONS(1418),
    [anon_sym_register] = ACTIONS(1418),
    [anon_sym_inline] = ACTIONS(1418),
    [anon_sym___inline] = ACTIONS(1418),
    [anon_sym___inline__] = ACTIONS(1418),
    [anon_sym___forceinline] = ACTIONS(1418),
    [anon_sym_thread_local] = ACTIONS(1418),
    [anon_sym___thread] = ACTIONS(1418),
    [anon_sym_const] = ACTIONS(1418),
    [anon_sym_constexpr] = ACTIONS(1418),
    [anon_sym_volatile] = ACTIONS(1418),
    [anon_sym_restrict] = ACTIONS(1418),
    [anon_sym___restrict__] = ACTIONS(1418),
    [anon_sym__Atomic] = ACTIONS(1418),
    [anon_sym__Noreturn] = ACTIONS(1418),
    [anon_sym_noreturn] = ACTIONS(1418),
    [sym_primitive_type] = ACTIONS(1418),
    [anon_sym_enum] = ACTIONS(1418),
    [anon_sym_struct] = ACTIONS(1418),
    [anon_sym_union] = ACTIONS(1418),
    [anon_sym_if] = ACTIONS(1418),
    [anon_sym_else] = ACTIONS(1418),
    [anon_sym_switch] = ACTIONS(1418),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_default] = ACTIONS(1418),
    [anon_sym_while] = ACTIONS(1418),
    [anon_sym_do] = ACTIONS(1418),
    [anon_sym_for] = ACTIONS(1418),
    [anon_sym_return] = ACTIONS(1418),
    [anon_sym_break] = ACTIONS(1418),
    [anon_sym_continue] = ACTIONS(1418),
    [anon_sym_goto] = ACTIONS(1418),
    [anon_sym___try] = ACTIONS(1418),
    [anon_sym___leave] = ACTIONS(1418),
    [anon_sym_DASH_DASH] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1420),
    [anon_sym_sizeof] = ACTIONS(1418),
    [anon_sym___alignof__] = ACTIONS(1418),
    [anon_sym___alignof] = ACTIONS(1418),
    [anon_sym__alignof] = ACTIONS(1418),
    [anon_sym_alignof] = ACTIONS(1418),
    [anon_sym__Alignof] = ACTIONS(1418),
    [anon_sym_offsetof] = ACTIONS(1418),
    [anon_sym__Generic] = ACTIONS(1418),
    [anon_sym_asm] = ACTIONS(1418),
    [anon_sym___asm__] = ACTIONS(1418),
    [sym_number_literal] = ACTIONS(1420),
    [anon_sym_L_SQUOTE] = ACTIONS(1420),
    [anon_sym_u_SQUOTE] = ACTIONS(1420),
    [anon_sym_U_SQUOTE] = ACTIONS(1420),
    [anon_sym_u8_SQUOTE] = ACTIONS(1420),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [anon_sym_L_DQUOTE] = ACTIONS(1420),
    [anon_sym_u_DQUOTE] = ACTIONS(1420),
    [anon_sym_U_DQUOTE] = ACTIONS(1420),
    [anon_sym_u8_DQUOTE] = ACTIONS(1420),
    [anon_sym_DQUOTE] = ACTIONS(1420),
    [sym_true] = ACTIONS(1418),
    [sym_false] = ACTIONS(1418),
    [anon_sym_NULL] = ACTIONS(1418),
    [anon_sym_nullptr] = ACTIONS(1418),
    [sym_comment] = ACTIONS(3),
  },
  [192] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [193] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [194] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [195] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [196] = {
    [sym_identifier] = ACTIONS(1378),
    [aux_sym_preproc_include_token1] = ACTIONS(1378),
    [aux_sym_preproc_def_token1] = ACTIONS(1378),
    [aux_sym_preproc_if_token1] = ACTIONS(1378),
    [aux_sym_preproc_if_token2] = ACTIONS(1378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1378),
    [aux_sym_preproc_else_token1] = ACTIONS(1378),
    [aux_sym_preproc_elif_token1] = ACTIONS(1378),
    [sym_preproc_directive] = ACTIONS(1378),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_BANG] = ACTIONS(1380),
    [anon_sym_TILDE] = ACTIONS(1380),
    [anon_sym_DASH] = ACTIONS(1378),
    [anon_sym_PLUS] = ACTIONS(1378),
    [anon_sym_STAR] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym___extension__] = ACTIONS(1378),
    [anon_sym_typedef] = ACTIONS(1378),
    [anon_sym_extern] = ACTIONS(1378),
    [anon_sym___attribute__] = ACTIONS(1378),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1380),
    [anon_sym___declspec] = ACTIONS(1378),
    [anon_sym___cdecl] = ACTIONS(1378),
    [anon_sym___clrcall] = ACTIONS(1378),
    [anon_sym___stdcall] = ACTIONS(1378),
    [anon_sym___fastcall] = ACTIONS(1378),
    [anon_sym___thiscall] = ACTIONS(1378),
    [anon_sym___vectorcall] = ACTIONS(1378),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_signed] = ACTIONS(1378),
    [anon_sym_unsigned] = ACTIONS(1378),
    [anon_sym_long] = ACTIONS(1378),
    [anon_sym_short] = ACTIONS(1378),
    [anon_sym_static] = ACTIONS(1378),
    [anon_sym_auto] = ACTIONS(1378),
    [anon_sym_register] = ACTIONS(1378),
    [anon_sym_inline] = ACTIONS(1378),
    [anon_sym___inline] = ACTIONS(1378),
    [anon_sym___inline__] = ACTIONS(1378),
    [anon_sym___forceinline] = ACTIONS(1378),
    [anon_sym_thread_local] = ACTIONS(1378),
    [anon_sym___thread] = ACTIONS(1378),
    [anon_sym_const] = ACTIONS(1378),
    [anon_sym_constexpr] = ACTIONS(1378),
    [anon_sym_volatile] = ACTIONS(1378),
    [anon_sym_restrict] = ACTIONS(1378),
    [anon_sym___restrict__] = ACTIONS(1378),
    [anon_sym__Atomic] = ACTIONS(1378),
    [anon_sym__Noreturn] = ACTIONS(1378),
    [anon_sym_noreturn] = ACTIONS(1378),
    [sym_primitive_type] = ACTIONS(1378),
    [anon_sym_enum] = ACTIONS(1378),
    [anon_sym_struct] = ACTIONS(1378),
    [anon_sym_union] = ACTIONS(1378),
    [anon_sym_if] = ACTIONS(1378),
    [anon_sym_else] = ACTIONS(1378),
    [anon_sym_switch] = ACTIONS(1378),
    [anon_sym_case] = ACTIONS(1378),
    [anon_sym_default] = ACTIONS(1378),
    [anon_sym_while] = ACTIONS(1378),
    [anon_sym_do] = ACTIONS(1378),
    [anon_sym_for] = ACTIONS(1378),
    [anon_sym_return] = ACTIONS(1378),
    [anon_sym_break] = ACTIONS(1378),
    [anon_sym_continue] = ACTIONS(1378),
    [anon_sym_goto] = ACTIONS(1378),
    [anon_sym___try] = ACTIONS(1378),
    [anon_sym___leave] = ACTIONS(1378),
    [anon_sym_DASH_DASH] = ACTIONS(1380),
    [anon_sym_PLUS_PLUS] = ACTIONS(1380),
    [anon_sym_sizeof] = ACTIONS(1378),
    [anon_sym___alignof__] = ACTIONS(1378),
    [anon_sym___alignof] = ACTIONS(1378),
    [anon_sym__alignof] = ACTIONS(1378),
    [anon_sym_alignof] = ACTIONS(1378),
    [anon_sym__Alignof] = ACTIONS(1378),
    [anon_sym_offsetof] = ACTIONS(1378),
    [anon_sym__Generic] = ACTIONS(1378),
    [anon_sym_asm] = ACTIONS(1378),
    [anon_sym___asm__] = ACTIONS(1378),
    [sym_number_literal] = ACTIONS(1380),
    [anon_sym_L_SQUOTE] = ACTIONS(1380),
    [anon_sym_u_SQUOTE] = ACTIONS(1380),
    [anon_sym_U_SQUOTE] = ACTIONS(1380),
    [anon_sym_u8_SQUOTE] = ACTIONS(1380),
    [anon_sym_SQUOTE] = ACTIONS(1380),
    [anon_sym_L_DQUOTE] = ACTIONS(1380),
    [anon_sym_u_DQUOTE] = ACTIONS(1380),
    [anon_sym_U_DQUOTE] = ACTIONS(1380),
    [anon_sym_u8_DQUOTE] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [anon_sym_NULL] = ACTIONS(1378),
    [anon_sym_nullptr] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
  },
  [197] = {
    [sym_identifier] = ACTIONS(1338),
    [aux_sym_preproc_include_token1] = ACTIONS(1338),
    [aux_sym_preproc_def_token1] = ACTIONS(1338),
    [aux_sym_preproc_if_token1] = ACTIONS(1338),
    [aux_sym_preproc_if_token2] = ACTIONS(1338),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1338),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1338),
    [aux_sym_preproc_else_token1] = ACTIONS(1338),
    [aux_sym_preproc_elif_token1] = ACTIONS(1338),
    [sym_preproc_directive] = ACTIONS(1338),
    [anon_sym_LPAREN2] = ACTIONS(1340),
    [anon_sym_BANG] = ACTIONS(1340),
    [anon_sym_TILDE] = ACTIONS(1340),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_PLUS] = ACTIONS(1338),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_SEMI] = ACTIONS(1340),
    [anon_sym___extension__] = ACTIONS(1338),
    [anon_sym_typedef] = ACTIONS(1338),
    [anon_sym_extern] = ACTIONS(1338),
    [anon_sym___attribute__] = ACTIONS(1338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1340),
    [anon_sym___declspec] = ACTIONS(1338),
    [anon_sym___cdecl] = ACTIONS(1338),
    [anon_sym___clrcall] = ACTIONS(1338),
    [anon_sym___stdcall] = ACTIONS(1338),
    [anon_sym___fastcall] = ACTIONS(1338),
    [anon_sym___thiscall] = ACTIONS(1338),
    [anon_sym___vectorcall] = ACTIONS(1338),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_signed] = ACTIONS(1338),
    [anon_sym_unsigned] = ACTIONS(1338),
    [anon_sym_long] = ACTIONS(1338),
    [anon_sym_short] = ACTIONS(1338),
    [anon_sym_static] = ACTIONS(1338),
    [anon_sym_auto] = ACTIONS(1338),
    [anon_sym_register] = ACTIONS(1338),
    [anon_sym_inline] = ACTIONS(1338),
    [anon_sym___inline] = ACTIONS(1338),
    [anon_sym___inline__] = ACTIONS(1338),
    [anon_sym___forceinline] = ACTIONS(1338),
    [anon_sym_thread_local] = ACTIONS(1338),
    [anon_sym___thread] = ACTIONS(1338),
    [anon_sym_const] = ACTIONS(1338),
    [anon_sym_constexpr] = ACTIONS(1338),
    [anon_sym_volatile] = ACTIONS(1338),
    [anon_sym_restrict] = ACTIONS(1338),
    [anon_sym___restrict__] = ACTIONS(1338),
    [anon_sym__Atomic] = ACTIONS(1338),
    [anon_sym__Noreturn] = ACTIONS(1338),
    [anon_sym_noreturn] = ACTIONS(1338),
    [sym_primitive_type] = ACTIONS(1338),
    [anon_sym_enum] = ACTIONS(1338),
    [anon_sym_struct] = ACTIONS(1338),
    [anon_sym_union] = ACTIONS(1338),
    [anon_sym_if] = ACTIONS(1338),
    [anon_sym_else] = ACTIONS(1338),
    [anon_sym_switch] = ACTIONS(1338),
    [anon_sym_case] = ACTIONS(1338),
    [anon_sym_default] = ACTIONS(1338),
    [anon_sym_while] = ACTIONS(1338),
    [anon_sym_do] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1338),
    [anon_sym_return] = ACTIONS(1338),
    [anon_sym_break] = ACTIONS(1338),
    [anon_sym_continue] = ACTIONS(1338),
    [anon_sym_goto] = ACTIONS(1338),
    [anon_sym___try] = ACTIONS(1338),
    [anon_sym___leave] = ACTIONS(1338),
    [anon_sym_DASH_DASH] = ACTIONS(1340),
    [anon_sym_PLUS_PLUS] = ACTIONS(1340),
    [anon_sym_sizeof] = ACTIONS(1338),
    [anon_sym___alignof__] = ACTIONS(1338),
    [anon_sym___alignof] = ACTIONS(1338),
    [anon_sym__alignof] = ACTIONS(1338),
    [anon_sym_alignof] = ACTIONS(1338),
    [anon_sym__Alignof] = ACTIONS(1338),
    [anon_sym_offsetof] = ACTIONS(1338),
    [anon_sym__Generic] = ACTIONS(1338),
    [anon_sym_asm] = ACTIONS(1338),
    [anon_sym___asm__] = ACTIONS(1338),
    [sym_number_literal] = ACTIONS(1340),
    [anon_sym_L_SQUOTE] = ACTIONS(1340),
    [anon_sym_u_SQUOTE] = ACTIONS(1340),
    [anon_sym_U_SQUOTE] = ACTIONS(1340),
    [anon_sym_u8_SQUOTE] = ACTIONS(1340),
    [anon_sym_SQUOTE] = ACTIONS(1340),
    [anon_sym_L_DQUOTE] = ACTIONS(1340),
    [anon_sym_u_DQUOTE] = ACTIONS(1340),
    [anon_sym_U_DQUOTE] = ACTIONS(1340),
    [anon_sym_u8_DQUOTE] = ACTIONS(1340),
    [anon_sym_DQUOTE] = ACTIONS(1340),
    [sym_true] = ACTIONS(1338),
    [sym_false] = ACTIONS(1338),
    [anon_sym_NULL] = ACTIONS(1338),
    [anon_sym_nullptr] = ACTIONS(1338),
    [sym_comment] = ACTIONS(3),
  },
  [198] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [199] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [200] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [201] = {
    [sym_identifier] = ACTIONS(1320),
    [aux_sym_preproc_include_token1] = ACTIONS(1320),
    [aux_sym_preproc_def_token1] = ACTIONS(1320),
    [aux_sym_preproc_if_token1] = ACTIONS(1320),
    [aux_sym_preproc_if_token2] = ACTIONS(1320),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1320),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1320),
    [aux_sym_preproc_else_token1] = ACTIONS(1320),
    [aux_sym_preproc_elif_token1] = ACTIONS(1320),
    [sym_preproc_directive] = ACTIONS(1320),
    [anon_sym_LPAREN2] = ACTIONS(1318),
    [anon_sym_BANG] = ACTIONS(1318),
    [anon_sym_TILDE] = ACTIONS(1318),
    [anon_sym_DASH] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(1320),
    [anon_sym_STAR] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(1318),
    [anon_sym_SEMI] = ACTIONS(1318),
    [anon_sym___extension__] = ACTIONS(1320),
    [anon_sym_typedef] = ACTIONS(1320),
    [anon_sym_extern] = ACTIONS(1320),
    [anon_sym___attribute__] = ACTIONS(1320),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1318),
    [anon_sym___declspec] = ACTIONS(1320),
    [anon_sym___cdecl] = ACTIONS(1320),
    [anon_sym___clrcall] = ACTIONS(1320),
    [anon_sym___stdcall] = ACTIONS(1320),
    [anon_sym___fastcall] = ACTIONS(1320),
    [anon_sym___thiscall] = ACTIONS(1320),
    [anon_sym___vectorcall] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1318),
    [anon_sym_signed] = ACTIONS(1320),
    [anon_sym_unsigned] = ACTIONS(1320),
    [anon_sym_long] = ACTIONS(1320),
    [anon_sym_short] = ACTIONS(1320),
    [anon_sym_static] = ACTIONS(1320),
    [anon_sym_auto] = ACTIONS(1320),
    [anon_sym_register] = ACTIONS(1320),
    [anon_sym_inline] = ACTIONS(1320),
    [anon_sym___inline] = ACTIONS(1320),
    [anon_sym___inline__] = ACTIONS(1320),
    [anon_sym___forceinline] = ACTIONS(1320),
    [anon_sym_thread_local] = ACTIONS(1320),
    [anon_sym___thread] = ACTIONS(1320),
    [anon_sym_const] = ACTIONS(1320),
    [anon_sym_constexpr] = ACTIONS(1320),
    [anon_sym_volatile] = ACTIONS(1320),
    [anon_sym_restrict] = ACTIONS(1320),
    [anon_sym___restrict__] = ACTIONS(1320),
    [anon_sym__Atomic] = ACTIONS(1320),
    [anon_sym__Noreturn] = ACTIONS(1320),
    [anon_sym_noreturn] = ACTIONS(1320),
    [sym_primitive_type] = ACTIONS(1320),
    [anon_sym_enum] = ACTIONS(1320),
    [anon_sym_struct] = ACTIONS(1320),
    [anon_sym_union] = ACTIONS(1320),
    [anon_sym_if] = ACTIONS(1320),
    [anon_sym_else] = ACTIONS(1320),
    [anon_sym_switch] = ACTIONS(1320),
    [anon_sym_case] = ACTIONS(1320),
    [anon_sym_default] = ACTIONS(1320),
    [anon_sym_while] = ACTIONS(1320),
    [anon_sym_do] = ACTIONS(1320),
    [anon_sym_for] = ACTIONS(1320),
    [anon_sym_return] = ACTIONS(1320),
    [anon_sym_break] = ACTIONS(1320),
    [anon_sym_continue] = ACTIONS(1320),
    [anon_sym_goto] = ACTIONS(1320),
    [anon_sym___try] = ACTIONS(1320),
    [anon_sym___leave] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1318),
    [anon_sym_PLUS_PLUS] = ACTIONS(1318),
    [anon_sym_sizeof] = ACTIONS(1320),
    [anon_sym___alignof__] = ACTIONS(1320),
    [anon_sym___alignof] = ACTIONS(1320),
    [anon_sym__alignof] = ACTIONS(1320),
    [anon_sym_alignof] = ACTIONS(1320),
    [anon_sym__Alignof] = ACTIONS(1320),
    [anon_sym_offsetof] = ACTIONS(1320),
    [anon_sym__Generic] = ACTIONS(1320),
    [anon_sym_asm] = ACTIONS(1320),
    [anon_sym___asm__] = ACTIONS(1320),
    [sym_number_literal] = ACTIONS(1318),
    [anon_sym_L_SQUOTE] = ACTIONS(1318),
    [anon_sym_u_SQUOTE] = ACTIONS(1318),
    [anon_sym_U_SQUOTE] = ACTIONS(1318),
    [anon_sym_u8_SQUOTE] = ACTIONS(1318),
    [anon_sym_SQUOTE] = ACTIONS(1318),
    [anon_sym_L_DQUOTE] = ACTIONS(1318),
    [anon_sym_u_DQUOTE] = ACTIONS(1318),
    [anon_sym_U_DQUOTE] = ACTIONS(1318),
    [anon_sym_u8_DQUOTE] = ACTIONS(1318),
    [anon_sym_DQUOTE] = ACTIONS(1318),
    [sym_true] = ACTIONS(1320),
    [sym_false] = ACTIONS(1320),
    [anon_sym_NULL] = ACTIONS(1320),
    [anon_sym_nullptr] = ACTIONS(1320),
    [sym_comment] = ACTIONS(3),
  },
  [202] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [203] = {
    [sym_identifier] = ACTIONS(1390),
    [aux_sym_preproc_include_token1] = ACTIONS(1390),
    [aux_sym_preproc_def_token1] = ACTIONS(1390),
    [aux_sym_preproc_if_token1] = ACTIONS(1390),
    [aux_sym_preproc_if_token2] = ACTIONS(1390),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1390),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1390),
    [aux_sym_preproc_else_token1] = ACTIONS(1390),
    [aux_sym_preproc_elif_token1] = ACTIONS(1390),
    [sym_preproc_directive] = ACTIONS(1390),
    [anon_sym_LPAREN2] = ACTIONS(1392),
    [anon_sym_BANG] = ACTIONS(1392),
    [anon_sym_TILDE] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_AMP] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1392),
    [anon_sym___extension__] = ACTIONS(1390),
    [anon_sym_typedef] = ACTIONS(1390),
    [anon_sym_extern] = ACTIONS(1390),
    [anon_sym___attribute__] = ACTIONS(1390),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1392),
    [anon_sym___declspec] = ACTIONS(1390),
    [anon_sym___cdecl] = ACTIONS(1390),
    [anon_sym___clrcall] = ACTIONS(1390),
    [anon_sym___stdcall] = ACTIONS(1390),
    [anon_sym___fastcall] = ACTIONS(1390),
    [anon_sym___thiscall] = ACTIONS(1390),
    [anon_sym___vectorcall] = ACTIONS(1390),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_signed] = ACTIONS(1390),
    [anon_sym_unsigned] = ACTIONS(1390),
    [anon_sym_long] = ACTIONS(1390),
    [anon_sym_short] = ACTIONS(1390),
    [anon_sym_static] = ACTIONS(1390),
    [anon_sym_auto] = ACTIONS(1390),
    [anon_sym_register] = ACTIONS(1390),
    [anon_sym_inline] = ACTIONS(1390),
    [anon_sym___inline] = ACTIONS(1390),
    [anon_sym___inline__] = ACTIONS(1390),
    [anon_sym___forceinline] = ACTIONS(1390),
    [anon_sym_thread_local] = ACTIONS(1390),
    [anon_sym___thread] = ACTIONS(1390),
    [anon_sym_const] = ACTIONS(1390),
    [anon_sym_constexpr] = ACTIONS(1390),
    [anon_sym_volatile] = ACTIONS(1390),
    [anon_sym_restrict] = ACTIONS(1390),
    [anon_sym___restrict__] = ACTIONS(1390),
    [anon_sym__Atomic] = ACTIONS(1390),
    [anon_sym__Noreturn] = ACTIONS(1390),
    [anon_sym_noreturn] = ACTIONS(1390),
    [sym_primitive_type] = ACTIONS(1390),
    [anon_sym_enum] = ACTIONS(1390),
    [anon_sym_struct] = ACTIONS(1390),
    [anon_sym_union] = ACTIONS(1390),
    [anon_sym_if] = ACTIONS(1390),
    [anon_sym_else] = ACTIONS(1390),
    [anon_sym_switch] = ACTIONS(1390),
    [anon_sym_case] = ACTIONS(1390),
    [anon_sym_default] = ACTIONS(1390),
    [anon_sym_while] = ACTIONS(1390),
    [anon_sym_do] = ACTIONS(1390),
    [anon_sym_for] = ACTIONS(1390),
    [anon_sym_return] = ACTIONS(1390),
    [anon_sym_break] = ACTIONS(1390),
    [anon_sym_continue] = ACTIONS(1390),
    [anon_sym_goto] = ACTIONS(1390),
    [anon_sym___try] = ACTIONS(1390),
    [anon_sym___leave] = ACTIONS(1390),
    [anon_sym_DASH_DASH] = ACTIONS(1392),
    [anon_sym_PLUS_PLUS] = ACTIONS(1392),
    [anon_sym_sizeof] = ACTIONS(1390),
    [anon_sym___alignof__] = ACTIONS(1390),
    [anon_sym___alignof] = ACTIONS(1390),
    [anon_sym__alignof] = ACTIONS(1390),
    [anon_sym_alignof] = ACTIONS(1390),
    [anon_sym__Alignof] = ACTIONS(1390),
    [anon_sym_offsetof] = ACTIONS(1390),
    [anon_sym__Generic] = ACTIONS(1390),
    [anon_sym_asm] = ACTIONS(1390),
    [anon_sym___asm__] = ACTIONS(1390),
    [sym_number_literal] = ACTIONS(1392),
    [anon_sym_L_SQUOTE] = ACTIONS(1392),
    [anon_sym_u_SQUOTE] = ACTIONS(1392),
    [anon_sym_U_SQUOTE] = ACTIONS(1392),
    [anon_sym_u8_SQUOTE] = ACTIONS(1392),
    [anon_sym_SQUOTE] = ACTIONS(1392),
    [anon_sym_L_DQUOTE] = ACTIONS(1392),
    [anon_sym_u_DQUOTE] = ACTIONS(1392),
    [anon_sym_U_DQUOTE] = ACTIONS(1392),
    [anon_sym_u8_DQUOTE] = ACTIONS(1392),
    [anon_sym_DQUOTE] = ACTIONS(1392),
    [sym_true] = ACTIONS(1390),
    [sym_false] = ACTIONS(1390),
    [anon_sym_NULL] = ACTIONS(1390),
    [anon_sym_nullptr] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
  },
  [204] = {
    [sym_identifier] = ACTIONS(1386),
    [aux_sym_preproc_include_token1] = ACTIONS(1386),
    [aux_sym_preproc_def_token1] = ACTIONS(1386),
    [aux_sym_preproc_if_token1] = ACTIONS(1386),
    [aux_sym_preproc_if_token2] = ACTIONS(1386),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1386),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1386),
    [aux_sym_preproc_else_token1] = ACTIONS(1386),
    [aux_sym_preproc_elif_token1] = ACTIONS(1386),
    [sym_preproc_directive] = ACTIONS(1386),
    [anon_sym_LPAREN2] = ACTIONS(1388),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1388),
    [anon_sym_DASH] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(1386),
    [anon_sym_STAR] = ACTIONS(1388),
    [anon_sym_AMP] = ACTIONS(1388),
    [anon_sym_SEMI] = ACTIONS(1388),
    [anon_sym___extension__] = ACTIONS(1386),
    [anon_sym_typedef] = ACTIONS(1386),
    [anon_sym_extern] = ACTIONS(1386),
    [anon_sym___attribute__] = ACTIONS(1386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1388),
    [anon_sym___declspec] = ACTIONS(1386),
    [anon_sym___cdecl] = ACTIONS(1386),
    [anon_sym___clrcall] = ACTIONS(1386),
    [anon_sym___stdcall] = ACTIONS(1386),
    [anon_sym___fastcall] = ACTIONS(1386),
    [anon_sym___thiscall] = ACTIONS(1386),
    [anon_sym___vectorcall] = ACTIONS(1386),
    [anon_sym_LBRACE] = ACTIONS(1388),
    [anon_sym_signed] = ACTIONS(1386),
    [anon_sym_unsigned] = ACTIONS(1386),
    [anon_sym_long] = ACTIONS(1386),
    [anon_sym_short] = ACTIONS(1386),
    [anon_sym_static] = ACTIONS(1386),
    [anon_sym_auto] = ACTIONS(1386),
    [anon_sym_register] = ACTIONS(1386),
    [anon_sym_inline] = ACTIONS(1386),
    [anon_sym___inline] = ACTIONS(1386),
    [anon_sym___inline__] = ACTIONS(1386),
    [anon_sym___forceinline] = ACTIONS(1386),
    [anon_sym_thread_local] = ACTIONS(1386),
    [anon_sym___thread] = ACTIONS(1386),
    [anon_sym_const] = ACTIONS(1386),
    [anon_sym_constexpr] = ACTIONS(1386),
    [anon_sym_volatile] = ACTIONS(1386),
    [anon_sym_restrict] = ACTIONS(1386),
    [anon_sym___restrict__] = ACTIONS(1386),
    [anon_sym__Atomic] = ACTIONS(1386),
    [anon_sym__Noreturn] = ACTIONS(1386),
    [anon_sym_noreturn] = ACTIONS(1386),
    [sym_primitive_type] = ACTIONS(1386),
    [anon_sym_enum] = ACTIONS(1386),
    [anon_sym_struct] = ACTIONS(1386),
    [anon_sym_union] = ACTIONS(1386),
    [anon_sym_if] = ACTIONS(1386),
    [anon_sym_else] = ACTIONS(1386),
    [anon_sym_switch] = ACTIONS(1386),
    [anon_sym_case] = ACTIONS(1386),
    [anon_sym_default] = ACTIONS(1386),
    [anon_sym_while] = ACTIONS(1386),
    [anon_sym_do] = ACTIONS(1386),
    [anon_sym_for] = ACTIONS(1386),
    [anon_sym_return] = ACTIONS(1386),
    [anon_sym_break] = ACTIONS(1386),
    [anon_sym_continue] = ACTIONS(1386),
    [anon_sym_goto] = ACTIONS(1386),
    [anon_sym___try] = ACTIONS(1386),
    [anon_sym___leave] = ACTIONS(1386),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_sizeof] = ACTIONS(1386),
    [anon_sym___alignof__] = ACTIONS(1386),
    [anon_sym___alignof] = ACTIONS(1386),
    [anon_sym__alignof] = ACTIONS(1386),
    [anon_sym_alignof] = ACTIONS(1386),
    [anon_sym__Alignof] = ACTIONS(1386),
    [anon_sym_offsetof] = ACTIONS(1386),
    [anon_sym__Generic] = ACTIONS(1386),
    [anon_sym_asm] = ACTIONS(1386),
    [anon_sym___asm__] = ACTIONS(1386),
    [sym_number_literal] = ACTIONS(1388),
    [anon_sym_L_SQUOTE] = ACTIONS(1388),
    [anon_sym_u_SQUOTE] = ACTIONS(1388),
    [anon_sym_U_SQUOTE] = ACTIONS(1388),
    [anon_sym_u8_SQUOTE] = ACTIONS(1388),
    [anon_sym_SQUOTE] = ACTIONS(1388),
    [anon_sym_L_DQUOTE] = ACTIONS(1388),
    [anon_sym_u_DQUOTE] = ACTIONS(1388),
    [anon_sym_U_DQUOTE] = ACTIONS(1388),
    [anon_sym_u8_DQUOTE] = ACTIONS(1388),
    [anon_sym_DQUOTE] = ACTIONS(1388),
    [sym_true] = ACTIONS(1386),
    [sym_false] = ACTIONS(1386),
    [anon_sym_NULL] = ACTIONS(1386),
    [anon_sym_nullptr] = ACTIONS(1386),
    [sym_comment] = ACTIONS(3),
  },
  [205] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [206] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [207] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [aux_sym_preproc_else_token1] = ACTIONS(1350),
    [aux_sym_preproc_elif_token1] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [208] = {
    [sym_identifier] = ACTIONS(1398),
    [aux_sym_preproc_include_token1] = ACTIONS(1398),
    [aux_sym_preproc_def_token1] = ACTIONS(1398),
    [aux_sym_preproc_if_token1] = ACTIONS(1398),
    [aux_sym_preproc_if_token2] = ACTIONS(1398),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1398),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1398),
    [aux_sym_preproc_else_token1] = ACTIONS(1398),
    [aux_sym_preproc_elif_token1] = ACTIONS(1398),
    [sym_preproc_directive] = ACTIONS(1398),
    [anon_sym_LPAREN2] = ACTIONS(1400),
    [anon_sym_BANG] = ACTIONS(1400),
    [anon_sym_TILDE] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1398),
    [anon_sym_PLUS] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym___extension__] = ACTIONS(1398),
    [anon_sym_typedef] = ACTIONS(1398),
    [anon_sym_extern] = ACTIONS(1398),
    [anon_sym___attribute__] = ACTIONS(1398),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1400),
    [anon_sym___declspec] = ACTIONS(1398),
    [anon_sym___cdecl] = ACTIONS(1398),
    [anon_sym___clrcall] = ACTIONS(1398),
    [anon_sym___stdcall] = ACTIONS(1398),
    [anon_sym___fastcall] = ACTIONS(1398),
    [anon_sym___thiscall] = ACTIONS(1398),
    [anon_sym___vectorcall] = ACTIONS(1398),
    [anon_sym_LBRACE] = ACTIONS(1400),
    [anon_sym_signed] = ACTIONS(1398),
    [anon_sym_unsigned] = ACTIONS(1398),
    [anon_sym_long] = ACTIONS(1398),
    [anon_sym_short] = ACTIONS(1398),
    [anon_sym_static] = ACTIONS(1398),
    [anon_sym_auto] = ACTIONS(1398),
    [anon_sym_register] = ACTIONS(1398),
    [anon_sym_inline] = ACTIONS(1398),
    [anon_sym___inline] = ACTIONS(1398),
    [anon_sym___inline__] = ACTIONS(1398),
    [anon_sym___forceinline] = ACTIONS(1398),
    [anon_sym_thread_local] = ACTIONS(1398),
    [anon_sym___thread] = ACTIONS(1398),
    [anon_sym_const] = ACTIONS(1398),
    [anon_sym_constexpr] = ACTIONS(1398),
    [anon_sym_volatile] = ACTIONS(1398),
    [anon_sym_restrict] = ACTIONS(1398),
    [anon_sym___restrict__] = ACTIONS(1398),
    [anon_sym__Atomic] = ACTIONS(1398),
    [anon_sym__Noreturn] = ACTIONS(1398),
    [anon_sym_noreturn] = ACTIONS(1398),
    [sym_primitive_type] = ACTIONS(1398),
    [anon_sym_enum] = ACTIONS(1398),
    [anon_sym_struct] = ACTIONS(1398),
    [anon_sym_union] = ACTIONS(1398),
    [anon_sym_if] = ACTIONS(1398),
    [anon_sym_else] = ACTIONS(1398),
    [anon_sym_switch] = ACTIONS(1398),
    [anon_sym_case] = ACTIONS(1398),
    [anon_sym_default] = ACTIONS(1398),
    [anon_sym_while] = ACTIONS(1398),
    [anon_sym_do] = ACTIONS(1398),
    [anon_sym_for] = ACTIONS(1398),
    [anon_sym_return] = ACTIONS(1398),
    [anon_sym_break] = ACTIONS(1398),
    [anon_sym_continue] = ACTIONS(1398),
    [anon_sym_goto] = ACTIONS(1398),
    [anon_sym___try] = ACTIONS(1398),
    [anon_sym___leave] = ACTIONS(1398),
    [anon_sym_DASH_DASH] = ACTIONS(1400),
    [anon_sym_PLUS_PLUS] = ACTIONS(1400),
    [anon_sym_sizeof] = ACTIONS(1398),
    [anon_sym___alignof__] = ACTIONS(1398),
    [anon_sym___alignof] = ACTIONS(1398),
    [anon_sym__alignof] = ACTIONS(1398),
    [anon_sym_alignof] = ACTIONS(1398),
    [anon_sym__Alignof] = ACTIONS(1398),
    [anon_sym_offsetof] = ACTIONS(1398),
    [anon_sym__Generic] = ACTIONS(1398),
    [anon_sym_asm] = ACTIONS(1398),
    [anon_sym___asm__] = ACTIONS(1398),
    [sym_number_literal] = ACTIONS(1400),
    [anon_sym_L_SQUOTE] = ACTIONS(1400),
    [anon_sym_u_SQUOTE] = ACTIONS(1400),
    [anon_sym_U_SQUOTE] = ACTIONS(1400),
    [anon_sym_u8_SQUOTE] = ACTIONS(1400),
    [anon_sym_SQUOTE] = ACTIONS(1400),
    [anon_sym_L_DQUOTE] = ACTIONS(1400),
    [anon_sym_u_DQUOTE] = ACTIONS(1400),
    [anon_sym_U_DQUOTE] = ACTIONS(1400),
    [anon_sym_u8_DQUOTE] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(1398),
    [sym_false] = ACTIONS(1398),
    [anon_sym_NULL] = ACTIONS(1398),
    [anon_sym_nullptr] = ACTIONS(1398),
    [sym_comment] = ACTIONS(3),
  },
  [209] = {
    [sym_identifier] = ACTIONS(1334),
    [aux_sym_preproc_include_token1] = ACTIONS(1334),
    [aux_sym_preproc_def_token1] = ACTIONS(1334),
    [aux_sym_preproc_if_token1] = ACTIONS(1334),
    [aux_sym_preproc_if_token2] = ACTIONS(1334),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1334),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1334),
    [aux_sym_preproc_else_token1] = ACTIONS(1334),
    [aux_sym_preproc_elif_token1] = ACTIONS(1334),
    [sym_preproc_directive] = ACTIONS(1334),
    [anon_sym_LPAREN2] = ACTIONS(1336),
    [anon_sym_BANG] = ACTIONS(1336),
    [anon_sym_TILDE] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_PLUS] = ACTIONS(1334),
    [anon_sym_STAR] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1336),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym___extension__] = ACTIONS(1334),
    [anon_sym_typedef] = ACTIONS(1334),
    [anon_sym_extern] = ACTIONS(1334),
    [anon_sym___attribute__] = ACTIONS(1334),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1336),
    [anon_sym___declspec] = ACTIONS(1334),
    [anon_sym___cdecl] = ACTIONS(1334),
    [anon_sym___clrcall] = ACTIONS(1334),
    [anon_sym___stdcall] = ACTIONS(1334),
    [anon_sym___fastcall] = ACTIONS(1334),
    [anon_sym___thiscall] = ACTIONS(1334),
    [anon_sym___vectorcall] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_signed] = ACTIONS(1334),
    [anon_sym_unsigned] = ACTIONS(1334),
    [anon_sym_long] = ACTIONS(1334),
    [anon_sym_short] = ACTIONS(1334),
    [anon_sym_static] = ACTIONS(1334),
    [anon_sym_auto] = ACTIONS(1334),
    [anon_sym_register] = ACTIONS(1334),
    [anon_sym_inline] = ACTIONS(1334),
    [anon_sym___inline] = ACTIONS(1334),
    [anon_sym___inline__] = ACTIONS(1334),
    [anon_sym___forceinline] = ACTIONS(1334),
    [anon_sym_thread_local] = ACTIONS(1334),
    [anon_sym___thread] = ACTIONS(1334),
    [anon_sym_const] = ACTIONS(1334),
    [anon_sym_constexpr] = ACTIONS(1334),
    [anon_sym_volatile] = ACTIONS(1334),
    [anon_sym_restrict] = ACTIONS(1334),
    [anon_sym___restrict__] = ACTIONS(1334),
    [anon_sym__Atomic] = ACTIONS(1334),
    [anon_sym__Noreturn] = ACTIONS(1334),
    [anon_sym_noreturn] = ACTIONS(1334),
    [sym_primitive_type] = ACTIONS(1334),
    [anon_sym_enum] = ACTIONS(1334),
    [anon_sym_struct] = ACTIONS(1334),
    [anon_sym_union] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1334),
    [anon_sym_else] = ACTIONS(1334),
    [anon_sym_switch] = ACTIONS(1334),
    [anon_sym_case] = ACTIONS(1334),
    [anon_sym_default] = ACTIONS(1334),
    [anon_sym_while] = ACTIONS(1334),
    [anon_sym_do] = ACTIONS(1334),
    [anon_sym_for] = ACTIONS(1334),
    [anon_sym_return] = ACTIONS(1334),
    [anon_sym_break] = ACTIONS(1334),
    [anon_sym_continue] = ACTIONS(1334),
    [anon_sym_goto] = ACTIONS(1334),
    [anon_sym___try] = ACTIONS(1334),
    [anon_sym___leave] = ACTIONS(1334),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_sizeof] = ACTIONS(1334),
    [anon_sym___alignof__] = ACTIONS(1334),
    [anon_sym___alignof] = ACTIONS(1334),
    [anon_sym__alignof] = ACTIONS(1334),
    [anon_sym_alignof] = ACTIONS(1334),
    [anon_sym__Alignof] = ACTIONS(1334),
    [anon_sym_offsetof] = ACTIONS(1334),
    [anon_sym__Generic] = ACTIONS(1334),
    [anon_sym_asm] = ACTIONS(1334),
    [anon_sym___asm__] = ACTIONS(1334),
    [sym_number_literal] = ACTIONS(1336),
    [anon_sym_L_SQUOTE] = ACTIONS(1336),
    [anon_sym_u_SQUOTE] = ACTIONS(1336),
    [anon_sym_U_SQUOTE] = ACTIONS(1336),
    [anon_sym_u8_SQUOTE] = ACTIONS(1336),
    [anon_sym_SQUOTE] = ACTIONS(1336),
    [anon_sym_L_DQUOTE] = ACTIONS(1336),
    [anon_sym_u_DQUOTE] = ACTIONS(1336),
    [anon_sym_U_DQUOTE] = ACTIONS(1336),
    [anon_sym_u8_DQUOTE] = ACTIONS(1336),
    [anon_sym_DQUOTE] = ACTIONS(1336),
    [sym_true] = ACTIONS(1334),
    [sym_false] = ACTIONS(1334),
    [anon_sym_NULL] = ACTIONS(1334),
    [anon_sym_nullptr] = ACTIONS(1334),
    [sym_comment] = ACTIONS(3),
  },
  [210] = {
    [sym_identifier] = ACTIONS(1394),
    [aux_sym_preproc_include_token1] = ACTIONS(1394),
    [aux_sym_preproc_def_token1] = ACTIONS(1394),
    [aux_sym_preproc_if_token1] = ACTIONS(1394),
    [aux_sym_preproc_if_token2] = ACTIONS(1394),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1394),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1394),
    [aux_sym_preproc_else_token1] = ACTIONS(1394),
    [aux_sym_preproc_elif_token1] = ACTIONS(1394),
    [sym_preproc_directive] = ACTIONS(1394),
    [anon_sym_LPAREN2] = ACTIONS(1396),
    [anon_sym_BANG] = ACTIONS(1396),
    [anon_sym_TILDE] = ACTIONS(1396),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_PLUS] = ACTIONS(1394),
    [anon_sym_STAR] = ACTIONS(1396),
    [anon_sym_AMP] = ACTIONS(1396),
    [anon_sym_SEMI] = ACTIONS(1396),
    [anon_sym___extension__] = ACTIONS(1394),
    [anon_sym_typedef] = ACTIONS(1394),
    [anon_sym_extern] = ACTIONS(1394),
    [anon_sym___attribute__] = ACTIONS(1394),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1396),
    [anon_sym___declspec] = ACTIONS(1394),
    [anon_sym___cdecl] = ACTIONS(1394),
    [anon_sym___clrcall] = ACTIONS(1394),
    [anon_sym___stdcall] = ACTIONS(1394),
    [anon_sym___fastcall] = ACTIONS(1394),
    [anon_sym___thiscall] = ACTIONS(1394),
    [anon_sym___vectorcall] = ACTIONS(1394),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_signed] = ACTIONS(1394),
    [anon_sym_unsigned] = ACTIONS(1394),
    [anon_sym_long] = ACTIONS(1394),
    [anon_sym_short] = ACTIONS(1394),
    [anon_sym_static] = ACTIONS(1394),
    [anon_sym_auto] = ACTIONS(1394),
    [anon_sym_register] = ACTIONS(1394),
    [anon_sym_inline] = ACTIONS(1394),
    [anon_sym___inline] = ACTIONS(1394),
    [anon_sym___inline__] = ACTIONS(1394),
    [anon_sym___forceinline] = ACTIONS(1394),
    [anon_sym_thread_local] = ACTIONS(1394),
    [anon_sym___thread] = ACTIONS(1394),
    [anon_sym_const] = ACTIONS(1394),
    [anon_sym_constexpr] = ACTIONS(1394),
    [anon_sym_volatile] = ACTIONS(1394),
    [anon_sym_restrict] = ACTIONS(1394),
    [anon_sym___restrict__] = ACTIONS(1394),
    [anon_sym__Atomic] = ACTIONS(1394),
    [anon_sym__Noreturn] = ACTIONS(1394),
    [anon_sym_noreturn] = ACTIONS(1394),
    [sym_primitive_type] = ACTIONS(1394),
    [anon_sym_enum] = ACTIONS(1394),
    [anon_sym_struct] = ACTIONS(1394),
    [anon_sym_union] = ACTIONS(1394),
    [anon_sym_if] = ACTIONS(1394),
    [anon_sym_else] = ACTIONS(1394),
    [anon_sym_switch] = ACTIONS(1394),
    [anon_sym_case] = ACTIONS(1394),
    [anon_sym_default] = ACTIONS(1394),
    [anon_sym_while] = ACTIONS(1394),
    [anon_sym_do] = ACTIONS(1394),
    [anon_sym_for] = ACTIONS(1394),
    [anon_sym_return] = ACTIONS(1394),
    [anon_sym_break] = ACTIONS(1394),
    [anon_sym_continue] = ACTIONS(1394),
    [anon_sym_goto] = ACTIONS(1394),
    [anon_sym___try] = ACTIONS(1394),
    [anon_sym___leave] = ACTIONS(1394),
    [anon_sym_DASH_DASH] = ACTIONS(1396),
    [anon_sym_PLUS_PLUS] = ACTIONS(1396),
    [anon_sym_sizeof] = ACTIONS(1394),
    [anon_sym___alignof__] = ACTIONS(1394),
    [anon_sym___alignof] = ACTIONS(1394),
    [anon_sym__alignof] = ACTIONS(1394),
    [anon_sym_alignof] = ACTIONS(1394),
    [anon_sym__Alignof] = ACTIONS(1394),
    [anon_sym_offsetof] = ACTIONS(1394),
    [anon_sym__Generic] = ACTIONS(1394),
    [anon_sym_asm] = ACTIONS(1394),
    [anon_sym___asm__] = ACTIONS(1394),
    [sym_number_literal] = ACTIONS(1396),
    [anon_sym_L_SQUOTE] = ACTIONS(1396),
    [anon_sym_u_SQUOTE] = ACTIONS(1396),
    [anon_sym_U_SQUOTE] = ACTIONS(1396),
    [anon_sym_u8_SQUOTE] = ACTIONS(1396),
    [anon_sym_SQUOTE] = ACTIONS(1396),
    [anon_sym_L_DQUOTE] = ACTIONS(1396),
    [anon_sym_u_DQUOTE] = ACTIONS(1396),
    [anon_sym_U_DQUOTE] = ACTIONS(1396),
    [anon_sym_u8_DQUOTE] = ACTIONS(1396),
    [anon_sym_DQUOTE] = ACTIONS(1396),
    [sym_true] = ACTIONS(1394),
    [sym_false] = ACTIONS(1394),
    [anon_sym_NULL] = ACTIONS(1394),
    [anon_sym_nullptr] = ACTIONS(1394),
    [sym_comment] = ACTIONS(3),
  },
  [211] = {
    [sym_identifier] = ACTIONS(1402),
    [aux_sym_preproc_include_token1] = ACTIONS(1402),
    [aux_sym_preproc_def_token1] = ACTIONS(1402),
    [aux_sym_preproc_if_token1] = ACTIONS(1402),
    [aux_sym_preproc_if_token2] = ACTIONS(1402),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1402),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1402),
    [aux_sym_preproc_else_token1] = ACTIONS(1402),
    [aux_sym_preproc_elif_token1] = ACTIONS(1402),
    [sym_preproc_directive] = ACTIONS(1402),
    [anon_sym_LPAREN2] = ACTIONS(1404),
    [anon_sym_BANG] = ACTIONS(1404),
    [anon_sym_TILDE] = ACTIONS(1404),
    [anon_sym_DASH] = ACTIONS(1402),
    [anon_sym_PLUS] = ACTIONS(1402),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_AMP] = ACTIONS(1404),
    [anon_sym_SEMI] = ACTIONS(1404),
    [anon_sym___extension__] = ACTIONS(1402),
    [anon_sym_typedef] = ACTIONS(1402),
    [anon_sym_extern] = ACTIONS(1402),
    [anon_sym___attribute__] = ACTIONS(1402),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1404),
    [anon_sym___declspec] = ACTIONS(1402),
    [anon_sym___cdecl] = ACTIONS(1402),
    [anon_sym___clrcall] = ACTIONS(1402),
    [anon_sym___stdcall] = ACTIONS(1402),
    [anon_sym___fastcall] = ACTIONS(1402),
    [anon_sym___thiscall] = ACTIONS(1402),
    [anon_sym___vectorcall] = ACTIONS(1402),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_signed] = ACTIONS(1402),
    [anon_sym_unsigned] = ACTIONS(1402),
    [anon_sym_long] = ACTIONS(1402),
    [anon_sym_short] = ACTIONS(1402),
    [anon_sym_static] = ACTIONS(1402),
    [anon_sym_auto] = ACTIONS(1402),
    [anon_sym_register] = ACTIONS(1402),
    [anon_sym_inline] = ACTIONS(1402),
    [anon_sym___inline] = ACTIONS(1402),
    [anon_sym___inline__] = ACTIONS(1402),
    [anon_sym___forceinline] = ACTIONS(1402),
    [anon_sym_thread_local] = ACTIONS(1402),
    [anon_sym___thread] = ACTIONS(1402),
    [anon_sym_const] = ACTIONS(1402),
    [anon_sym_constexpr] = ACTIONS(1402),
    [anon_sym_volatile] = ACTIONS(1402),
    [anon_sym_restrict] = ACTIONS(1402),
    [anon_sym___restrict__] = ACTIONS(1402),
    [anon_sym__Atomic] = ACTIONS(1402),
    [anon_sym__Noreturn] = ACTIONS(1402),
    [anon_sym_noreturn] = ACTIONS(1402),
    [sym_primitive_type] = ACTIONS(1402),
    [anon_sym_enum] = ACTIONS(1402),
    [anon_sym_struct] = ACTIONS(1402),
    [anon_sym_union] = ACTIONS(1402),
    [anon_sym_if] = ACTIONS(1402),
    [anon_sym_else] = ACTIONS(1402),
    [anon_sym_switch] = ACTIONS(1402),
    [anon_sym_case] = ACTIONS(1402),
    [anon_sym_default] = ACTIONS(1402),
    [anon_sym_while] = ACTIONS(1402),
    [anon_sym_do] = ACTIONS(1402),
    [anon_sym_for] = ACTIONS(1402),
    [anon_sym_return] = ACTIONS(1402),
    [anon_sym_break] = ACTIONS(1402),
    [anon_sym_continue] = ACTIONS(1402),
    [anon_sym_goto] = ACTIONS(1402),
    [anon_sym___try] = ACTIONS(1402),
    [anon_sym___leave] = ACTIONS(1402),
    [anon_sym_DASH_DASH] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1404),
    [anon_sym_sizeof] = ACTIONS(1402),
    [anon_sym___alignof__] = ACTIONS(1402),
    [anon_sym___alignof] = ACTIONS(1402),
    [anon_sym__alignof] = ACTIONS(1402),
    [anon_sym_alignof] = ACTIONS(1402),
    [anon_sym__Alignof] = ACTIONS(1402),
    [anon_sym_offsetof] = ACTIONS(1402),
    [anon_sym__Generic] = ACTIONS(1402),
    [anon_sym_asm] = ACTIONS(1402),
    [anon_sym___asm__] = ACTIONS(1402),
    [sym_number_literal] = ACTIONS(1404),
    [anon_sym_L_SQUOTE] = ACTIONS(1404),
    [anon_sym_u_SQUOTE] = ACTIONS(1404),
    [anon_sym_U_SQUOTE] = ACTIONS(1404),
    [anon_sym_u8_SQUOTE] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(1404),
    [anon_sym_L_DQUOTE] = ACTIONS(1404),
    [anon_sym_u_DQUOTE] = ACTIONS(1404),
    [anon_sym_U_DQUOTE] = ACTIONS(1404),
    [anon_sym_u8_DQUOTE] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1404),
    [sym_true] = ACTIONS(1402),
    [sym_false] = ACTIONS(1402),
    [anon_sym_NULL] = ACTIONS(1402),
    [anon_sym_nullptr] = ACTIONS(1402),
    [sym_comment] = ACTIONS(3),
  },
  [212] = {
    [sym_identifier] = ACTIONS(1302),
    [aux_sym_preproc_include_token1] = ACTIONS(1302),
    [aux_sym_preproc_def_token1] = ACTIONS(1302),
    [aux_sym_preproc_if_token1] = ACTIONS(1302),
    [aux_sym_preproc_if_token2] = ACTIONS(1302),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1302),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1302),
    [aux_sym_preproc_else_token1] = ACTIONS(1302),
    [aux_sym_preproc_elif_token1] = ACTIONS(1302),
    [sym_preproc_directive] = ACTIONS(1302),
    [anon_sym_LPAREN2] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_TILDE] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1302),
    [anon_sym_PLUS] = ACTIONS(1302),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym___extension__] = ACTIONS(1302),
    [anon_sym_typedef] = ACTIONS(1302),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym___attribute__] = ACTIONS(1302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1304),
    [anon_sym___declspec] = ACTIONS(1302),
    [anon_sym___cdecl] = ACTIONS(1302),
    [anon_sym___clrcall] = ACTIONS(1302),
    [anon_sym___stdcall] = ACTIONS(1302),
    [anon_sym___fastcall] = ACTIONS(1302),
    [anon_sym___thiscall] = ACTIONS(1302),
    [anon_sym___vectorcall] = ACTIONS(1302),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_signed] = ACTIONS(1302),
    [anon_sym_unsigned] = ACTIONS(1302),
    [anon_sym_long] = ACTIONS(1302),
    [anon_sym_short] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(1302),
    [anon_sym_auto] = ACTIONS(1302),
    [anon_sym_register] = ACTIONS(1302),
    [anon_sym_inline] = ACTIONS(1302),
    [anon_sym___inline] = ACTIONS(1302),
    [anon_sym___inline__] = ACTIONS(1302),
    [anon_sym___forceinline] = ACTIONS(1302),
    [anon_sym_thread_local] = ACTIONS(1302),
    [anon_sym___thread] = ACTIONS(1302),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_constexpr] = ACTIONS(1302),
    [anon_sym_volatile] = ACTIONS(1302),
    [anon_sym_restrict] = ACTIONS(1302),
    [anon_sym___restrict__] = ACTIONS(1302),
    [anon_sym__Atomic] = ACTIONS(1302),
    [anon_sym__Noreturn] = ACTIONS(1302),
    [anon_sym_noreturn] = ACTIONS(1302),
    [sym_primitive_type] = ACTIONS(1302),
    [anon_sym_enum] = ACTIONS(1302),
    [anon_sym_struct] = ACTIONS(1302),
    [anon_sym_union] = ACTIONS(1302),
    [anon_sym_if] = ACTIONS(1302),
    [anon_sym_else] = ACTIONS(1302),
    [anon_sym_switch] = ACTIONS(1302),
    [anon_sym_case] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1302),
    [anon_sym_while] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1302),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_break] = ACTIONS(1302),
    [anon_sym_continue] = ACTIONS(1302),
    [anon_sym_goto] = ACTIONS(1302),
    [anon_sym___try] = ACTIONS(1302),
    [anon_sym___leave] = ACTIONS(1302),
    [anon_sym_DASH_DASH] = ACTIONS(1304),
    [anon_sym_PLUS_PLUS] = ACTIONS(1304),
    [anon_sym_sizeof] = ACTIONS(1302),
    [anon_sym___alignof__] = ACTIONS(1302),
    [anon_sym___alignof] = ACTIONS(1302),
    [anon_sym__alignof] = ACTIONS(1302),
    [anon_sym_alignof] = ACTIONS(1302),
    [anon_sym__Alignof] = ACTIONS(1302),
    [anon_sym_offsetof] = ACTIONS(1302),
    [anon_sym__Generic] = ACTIONS(1302),
    [anon_sym_asm] = ACTIONS(1302),
    [anon_sym___asm__] = ACTIONS(1302),
    [sym_number_literal] = ACTIONS(1304),
    [anon_sym_L_SQUOTE] = ACTIONS(1304),
    [anon_sym_u_SQUOTE] = ACTIONS(1304),
    [anon_sym_U_SQUOTE] = ACTIONS(1304),
    [anon_sym_u8_SQUOTE] = ACTIONS(1304),
    [anon_sym_SQUOTE] = ACTIONS(1304),
    [anon_sym_L_DQUOTE] = ACTIONS(1304),
    [anon_sym_u_DQUOTE] = ACTIONS(1304),
    [anon_sym_U_DQUOTE] = ACTIONS(1304),
    [anon_sym_u8_DQUOTE] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_true] = ACTIONS(1302),
    [sym_false] = ACTIONS(1302),
    [anon_sym_NULL] = ACTIONS(1302),
    [anon_sym_nullptr] = ACTIONS(1302),
    [sym_comment] = ACTIONS(3),
  },
  [213] = {
    [sym_identifier] = ACTIONS(1356),
    [aux_sym_preproc_include_token1] = ACTIONS(1356),
    [aux_sym_preproc_def_token1] = ACTIONS(1356),
    [aux_sym_preproc_if_token1] = ACTIONS(1356),
    [aux_sym_preproc_if_token2] = ACTIONS(1356),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1356),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1356),
    [aux_sym_preproc_else_token1] = ACTIONS(1356),
    [aux_sym_preproc_elif_token1] = ACTIONS(1356),
    [sym_preproc_directive] = ACTIONS(1356),
    [anon_sym_LPAREN2] = ACTIONS(1354),
    [anon_sym_BANG] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(1354),
    [anon_sym_DASH] = ACTIONS(1356),
    [anon_sym_PLUS] = ACTIONS(1356),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_AMP] = ACTIONS(1354),
    [anon_sym_SEMI] = ACTIONS(1354),
    [anon_sym___extension__] = ACTIONS(1356),
    [anon_sym_typedef] = ACTIONS(1356),
    [anon_sym_extern] = ACTIONS(1356),
    [anon_sym___attribute__] = ACTIONS(1356),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1354),
    [anon_sym___declspec] = ACTIONS(1356),
    [anon_sym___cdecl] = ACTIONS(1356),
    [anon_sym___clrcall] = ACTIONS(1356),
    [anon_sym___stdcall] = ACTIONS(1356),
    [anon_sym___fastcall] = ACTIONS(1356),
    [anon_sym___thiscall] = ACTIONS(1356),
    [anon_sym___vectorcall] = ACTIONS(1356),
    [anon_sym_LBRACE] = ACTIONS(1354),
    [anon_sym_signed] = ACTIONS(1356),
    [anon_sym_unsigned] = ACTIONS(1356),
    [anon_sym_long] = ACTIONS(1356),
    [anon_sym_short] = ACTIONS(1356),
    [anon_sym_static] = ACTIONS(1356),
    [anon_sym_auto] = ACTIONS(1356),
    [anon_sym_register] = ACTIONS(1356),
    [anon_sym_inline] = ACTIONS(1356),
    [anon_sym___inline] = ACTIONS(1356),
    [anon_sym___inline__] = ACTIONS(1356),
    [anon_sym___forceinline] = ACTIONS(1356),
    [anon_sym_thread_local] = ACTIONS(1356),
    [anon_sym___thread] = ACTIONS(1356),
    [anon_sym_const] = ACTIONS(1356),
    [anon_sym_constexpr] = ACTIONS(1356),
    [anon_sym_volatile] = ACTIONS(1356),
    [anon_sym_restrict] = ACTIONS(1356),
    [anon_sym___restrict__] = ACTIONS(1356),
    [anon_sym__Atomic] = ACTIONS(1356),
    [anon_sym__Noreturn] = ACTIONS(1356),
    [anon_sym_noreturn] = ACTIONS(1356),
    [sym_primitive_type] = ACTIONS(1356),
    [anon_sym_enum] = ACTIONS(1356),
    [anon_sym_struct] = ACTIONS(1356),
    [anon_sym_union] = ACTIONS(1356),
    [anon_sym_if] = ACTIONS(1356),
    [anon_sym_else] = ACTIONS(1356),
    [anon_sym_switch] = ACTIONS(1356),
    [anon_sym_case] = ACTIONS(1356),
    [anon_sym_default] = ACTIONS(1356),
    [anon_sym_while] = ACTIONS(1356),
    [anon_sym_do] = ACTIONS(1356),
    [anon_sym_for] = ACTIONS(1356),
    [anon_sym_return] = ACTIONS(1356),
    [anon_sym_break] = ACTIONS(1356),
    [anon_sym_continue] = ACTIONS(1356),
    [anon_sym_goto] = ACTIONS(1356),
    [anon_sym___try] = ACTIONS(1356),
    [anon_sym___leave] = ACTIONS(1356),
    [anon_sym_DASH_DASH] = ACTIONS(1354),
    [anon_sym_PLUS_PLUS] = ACTIONS(1354),
    [anon_sym_sizeof] = ACTIONS(1356),
    [anon_sym___alignof__] = ACTIONS(1356),
    [anon_sym___alignof] = ACTIONS(1356),
    [anon_sym__alignof] = ACTIONS(1356),
    [anon_sym_alignof] = ACTIONS(1356),
    [anon_sym__Alignof] = ACTIONS(1356),
    [anon_sym_offsetof] = ACTIONS(1356),
    [anon_sym__Generic] = ACTIONS(1356),
    [anon_sym_asm] = ACTIONS(1356),
    [anon_sym___asm__] = ACTIONS(1356),
    [sym_number_literal] = ACTIONS(1354),
    [anon_sym_L_SQUOTE] = ACTIONS(1354),
    [anon_sym_u_SQUOTE] = ACTIONS(1354),
    [anon_sym_U_SQUOTE] = ACTIONS(1354),
    [anon_sym_u8_SQUOTE] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(1354),
    [anon_sym_L_DQUOTE] = ACTIONS(1354),
    [anon_sym_u_DQUOTE] = ACTIONS(1354),
    [anon_sym_U_DQUOTE] = ACTIONS(1354),
    [anon_sym_u8_DQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1354),
    [sym_true] = ACTIONS(1356),
    [sym_false] = ACTIONS(1356),
    [anon_sym_NULL] = ACTIONS(1356),
    [anon_sym_nullptr] = ACTIONS(1356),
    [sym_comment] = ACTIONS(3),
  },
  [214] = {
    [sym_identifier] = ACTIONS(1406),
    [aux_sym_preproc_include_token1] = ACTIONS(1406),
    [aux_sym_preproc_def_token1] = ACTIONS(1406),
    [aux_sym_preproc_if_token1] = ACTIONS(1406),
    [aux_sym_preproc_if_token2] = ACTIONS(1406),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1406),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1406),
    [aux_sym_preproc_else_token1] = ACTIONS(1406),
    [aux_sym_preproc_elif_token1] = ACTIONS(1406),
    [sym_preproc_directive] = ACTIONS(1406),
    [anon_sym_LPAREN2] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1408),
    [anon_sym_DASH] = ACTIONS(1406),
    [anon_sym_PLUS] = ACTIONS(1406),
    [anon_sym_STAR] = ACTIONS(1408),
    [anon_sym_AMP] = ACTIONS(1408),
    [anon_sym_SEMI] = ACTIONS(1408),
    [anon_sym___extension__] = ACTIONS(1406),
    [anon_sym_typedef] = ACTIONS(1406),
    [anon_sym_extern] = ACTIONS(1406),
    [anon_sym___attribute__] = ACTIONS(1406),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1408),
    [anon_sym___declspec] = ACTIONS(1406),
    [anon_sym___cdecl] = ACTIONS(1406),
    [anon_sym___clrcall] = ACTIONS(1406),
    [anon_sym___stdcall] = ACTIONS(1406),
    [anon_sym___fastcall] = ACTIONS(1406),
    [anon_sym___thiscall] = ACTIONS(1406),
    [anon_sym___vectorcall] = ACTIONS(1406),
    [anon_sym_LBRACE] = ACTIONS(1408),
    [anon_sym_signed] = ACTIONS(1406),
    [anon_sym_unsigned] = ACTIONS(1406),
    [anon_sym_long] = ACTIONS(1406),
    [anon_sym_short] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_auto] = ACTIONS(1406),
    [anon_sym_register] = ACTIONS(1406),
    [anon_sym_inline] = ACTIONS(1406),
    [anon_sym___inline] = ACTIONS(1406),
    [anon_sym___inline__] = ACTIONS(1406),
    [anon_sym___forceinline] = ACTIONS(1406),
    [anon_sym_thread_local] = ACTIONS(1406),
    [anon_sym___thread] = ACTIONS(1406),
    [anon_sym_const] = ACTIONS(1406),
    [anon_sym_constexpr] = ACTIONS(1406),
    [anon_sym_volatile] = ACTIONS(1406),
    [anon_sym_restrict] = ACTIONS(1406),
    [anon_sym___restrict__] = ACTIONS(1406),
    [anon_sym__Atomic] = ACTIONS(1406),
    [anon_sym__Noreturn] = ACTIONS(1406),
    [anon_sym_noreturn] = ACTIONS(1406),
    [sym_primitive_type] = ACTIONS(1406),
    [anon_sym_enum] = ACTIONS(1406),
    [anon_sym_struct] = ACTIONS(1406),
    [anon_sym_union] = ACTIONS(1406),
    [anon_sym_if] = ACTIONS(1406),
    [anon_sym_else] = ACTIONS(1406),
    [anon_sym_switch] = ACTIONS(1406),
    [anon_sym_case] = ACTIONS(1406),
    [anon_sym_default] = ACTIONS(1406),
    [anon_sym_while] = ACTIONS(1406),
    [anon_sym_do] = ACTIONS(1406),
    [anon_sym_for] = ACTIONS(1406),
    [anon_sym_return] = ACTIONS(1406),
    [anon_sym_break] = ACTIONS(1406),
    [anon_sym_continue] = ACTIONS(1406),
    [anon_sym_goto] = ACTIONS(1406),
    [anon_sym___try] = ACTIONS(1406),
    [anon_sym___leave] = ACTIONS(1406),
    [anon_sym_DASH_DASH] = ACTIONS(1408),
    [anon_sym_PLUS_PLUS] = ACTIONS(1408),
    [anon_sym_sizeof] = ACTIONS(1406),
    [anon_sym___alignof__] = ACTIONS(1406),
    [anon_sym___alignof] = ACTIONS(1406),
    [anon_sym__alignof] = ACTIONS(1406),
    [anon_sym_alignof] = ACTIONS(1406),
    [anon_sym__Alignof] = ACTIONS(1406),
    [anon_sym_offsetof] = ACTIONS(1406),
    [anon_sym__Generic] = ACTIONS(1406),
    [anon_sym_asm] = ACTIONS(1406),
    [anon_sym___asm__] = ACTIONS(1406),
    [sym_number_literal] = ACTIONS(1408),
    [anon_sym_L_SQUOTE] = ACTIONS(1408),
    [anon_sym_u_SQUOTE] = ACTIONS(1408),
    [anon_sym_U_SQUOTE] = ACTIONS(1408),
    [anon_sym_u8_SQUOTE] = ACTIONS(1408),
    [anon_sym_SQUOTE] = ACTIONS(1408),
    [anon_sym_L_DQUOTE] = ACTIONS(1408),
    [anon_sym_u_DQUOTE] = ACTIONS(1408),
    [anon_sym_U_DQUOTE] = ACTIONS(1408),
    [anon_sym_u8_DQUOTE] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1408),
    [sym_true] = ACTIONS(1406),
    [sym_false] = ACTIONS(1406),
    [anon_sym_NULL] = ACTIONS(1406),
    [anon_sym_nullptr] = ACTIONS(1406),
    [sym_comment] = ACTIONS(3),
  },
  [215] = {
    [sym_identifier] = ACTIONS(1410),
    [aux_sym_preproc_include_token1] = ACTIONS(1410),
    [aux_sym_preproc_def_token1] = ACTIONS(1410),
    [aux_sym_preproc_if_token1] = ACTIONS(1410),
    [aux_sym_preproc_if_token2] = ACTIONS(1410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1410),
    [aux_sym_preproc_else_token1] = ACTIONS(1410),
    [aux_sym_preproc_elif_token1] = ACTIONS(1410),
    [sym_preproc_directive] = ACTIONS(1410),
    [anon_sym_LPAREN2] = ACTIONS(1412),
    [anon_sym_BANG] = ACTIONS(1412),
    [anon_sym_TILDE] = ACTIONS(1412),
    [anon_sym_DASH] = ACTIONS(1410),
    [anon_sym_PLUS] = ACTIONS(1410),
    [anon_sym_STAR] = ACTIONS(1412),
    [anon_sym_AMP] = ACTIONS(1412),
    [anon_sym_SEMI] = ACTIONS(1412),
    [anon_sym___extension__] = ACTIONS(1410),
    [anon_sym_typedef] = ACTIONS(1410),
    [anon_sym_extern] = ACTIONS(1410),
    [anon_sym___attribute__] = ACTIONS(1410),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1412),
    [anon_sym___declspec] = ACTIONS(1410),
    [anon_sym___cdecl] = ACTIONS(1410),
    [anon_sym___clrcall] = ACTIONS(1410),
    [anon_sym___stdcall] = ACTIONS(1410),
    [anon_sym___fastcall] = ACTIONS(1410),
    [anon_sym___thiscall] = ACTIONS(1410),
    [anon_sym___vectorcall] = ACTIONS(1410),
    [anon_sym_LBRACE] = ACTIONS(1412),
    [anon_sym_signed] = ACTIONS(1410),
    [anon_sym_unsigned] = ACTIONS(1410),
    [anon_sym_long] = ACTIONS(1410),
    [anon_sym_short] = ACTIONS(1410),
    [anon_sym_static] = ACTIONS(1410),
    [anon_sym_auto] = ACTIONS(1410),
    [anon_sym_register] = ACTIONS(1410),
    [anon_sym_inline] = ACTIONS(1410),
    [anon_sym___inline] = ACTIONS(1410),
    [anon_sym___inline__] = ACTIONS(1410),
    [anon_sym___forceinline] = ACTIONS(1410),
    [anon_sym_thread_local] = ACTIONS(1410),
    [anon_sym___thread] = ACTIONS(1410),
    [anon_sym_const] = ACTIONS(1410),
    [anon_sym_constexpr] = ACTIONS(1410),
    [anon_sym_volatile] = ACTIONS(1410),
    [anon_sym_restrict] = ACTIONS(1410),
    [anon_sym___restrict__] = ACTIONS(1410),
    [anon_sym__Atomic] = ACTIONS(1410),
    [anon_sym__Noreturn] = ACTIONS(1410),
    [anon_sym_noreturn] = ACTIONS(1410),
    [sym_primitive_type] = ACTIONS(1410),
    [anon_sym_enum] = ACTIONS(1410),
    [anon_sym_struct] = ACTIONS(1410),
    [anon_sym_union] = ACTIONS(1410),
    [anon_sym_if] = ACTIONS(1410),
    [anon_sym_else] = ACTIONS(1410),
    [anon_sym_switch] = ACTIONS(1410),
    [anon_sym_case] = ACTIONS(1410),
    [anon_sym_default] = ACTIONS(1410),
    [anon_sym_while] = ACTIONS(1410),
    [anon_sym_do] = ACTIONS(1410),
    [anon_sym_for] = ACTIONS(1410),
    [anon_sym_return] = ACTIONS(1410),
    [anon_sym_break] = ACTIONS(1410),
    [anon_sym_continue] = ACTIONS(1410),
    [anon_sym_goto] = ACTIONS(1410),
    [anon_sym___try] = ACTIONS(1410),
    [anon_sym___leave] = ACTIONS(1410),
    [anon_sym_DASH_DASH] = ACTIONS(1412),
    [anon_sym_PLUS_PLUS] = ACTIONS(1412),
    [anon_sym_sizeof] = ACTIONS(1410),
    [anon_sym___alignof__] = ACTIONS(1410),
    [anon_sym___alignof] = ACTIONS(1410),
    [anon_sym__alignof] = ACTIONS(1410),
    [anon_sym_alignof] = ACTIONS(1410),
    [anon_sym__Alignof] = ACTIONS(1410),
    [anon_sym_offsetof] = ACTIONS(1410),
    [anon_sym__Generic] = ACTIONS(1410),
    [anon_sym_asm] = ACTIONS(1410),
    [anon_sym___asm__] = ACTIONS(1410),
    [sym_number_literal] = ACTIONS(1412),
    [anon_sym_L_SQUOTE] = ACTIONS(1412),
    [anon_sym_u_SQUOTE] = ACTIONS(1412),
    [anon_sym_U_SQUOTE] = ACTIONS(1412),
    [anon_sym_u8_SQUOTE] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(1412),
    [anon_sym_L_DQUOTE] = ACTIONS(1412),
    [anon_sym_u_DQUOTE] = ACTIONS(1412),
    [anon_sym_U_DQUOTE] = ACTIONS(1412),
    [anon_sym_u8_DQUOTE] = ACTIONS(1412),
    [anon_sym_DQUOTE] = ACTIONS(1412),
    [sym_true] = ACTIONS(1410),
    [sym_false] = ACTIONS(1410),
    [anon_sym_NULL] = ACTIONS(1410),
    [anon_sym_nullptr] = ACTIONS(1410),
    [sym_comment] = ACTIONS(3),
  },
  [216] = {
    [sym_identifier] = ACTIONS(1306),
    [aux_sym_preproc_include_token1] = ACTIONS(1306),
    [aux_sym_preproc_def_token1] = ACTIONS(1306),
    [aux_sym_preproc_if_token1] = ACTIONS(1306),
    [aux_sym_preproc_if_token2] = ACTIONS(1306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1306),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1306),
    [aux_sym_preproc_else_token1] = ACTIONS(1306),
    [aux_sym_preproc_elif_token1] = ACTIONS(1306),
    [sym_preproc_directive] = ACTIONS(1306),
    [anon_sym_LPAREN2] = ACTIONS(1308),
    [anon_sym_BANG] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(1308),
    [anon_sym_DASH] = ACTIONS(1306),
    [anon_sym_PLUS] = ACTIONS(1306),
    [anon_sym_STAR] = ACTIONS(1308),
    [anon_sym_AMP] = ACTIONS(1308),
    [anon_sym_SEMI] = ACTIONS(1308),
    [anon_sym___extension__] = ACTIONS(1306),
    [anon_sym_typedef] = ACTIONS(1306),
    [anon_sym_extern] = ACTIONS(1306),
    [anon_sym___attribute__] = ACTIONS(1306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1308),
    [anon_sym___declspec] = ACTIONS(1306),
    [anon_sym___cdecl] = ACTIONS(1306),
    [anon_sym___clrcall] = ACTIONS(1306),
    [anon_sym___stdcall] = ACTIONS(1306),
    [anon_sym___fastcall] = ACTIONS(1306),
    [anon_sym___thiscall] = ACTIONS(1306),
    [anon_sym___vectorcall] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(1308),
    [anon_sym_signed] = ACTIONS(1306),
    [anon_sym_unsigned] = ACTIONS(1306),
    [anon_sym_long] = ACTIONS(1306),
    [anon_sym_short] = ACTIONS(1306),
    [anon_sym_static] = ACTIONS(1306),
    [anon_sym_auto] = ACTIONS(1306),
    [anon_sym_register] = ACTIONS(1306),
    [anon_sym_inline] = ACTIONS(1306),
    [anon_sym___inline] = ACTIONS(1306),
    [anon_sym___inline__] = ACTIONS(1306),
    [anon_sym___forceinline] = ACTIONS(1306),
    [anon_sym_thread_local] = ACTIONS(1306),
    [anon_sym___thread] = ACTIONS(1306),
    [anon_sym_const] = ACTIONS(1306),
    [anon_sym_constexpr] = ACTIONS(1306),
    [anon_sym_volatile] = ACTIONS(1306),
    [anon_sym_restrict] = ACTIONS(1306),
    [anon_sym___restrict__] = ACTIONS(1306),
    [anon_sym__Atomic] = ACTIONS(1306),
    [anon_sym__Noreturn] = ACTIONS(1306),
    [anon_sym_noreturn] = ACTIONS(1306),
    [sym_primitive_type] = ACTIONS(1306),
    [anon_sym_enum] = ACTIONS(1306),
    [anon_sym_struct] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1306),
    [anon_sym_if] = ACTIONS(1306),
    [anon_sym_else] = ACTIONS(1306),
    [anon_sym_switch] = ACTIONS(1306),
    [anon_sym_case] = ACTIONS(1306),
    [anon_sym_default] = ACTIONS(1306),
    [anon_sym_while] = ACTIONS(1306),
    [anon_sym_do] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1306),
    [anon_sym_break] = ACTIONS(1306),
    [anon_sym_continue] = ACTIONS(1306),
    [anon_sym_goto] = ACTIONS(1306),
    [anon_sym___try] = ACTIONS(1306),
    [anon_sym___leave] = ACTIONS(1306),
    [anon_sym_DASH_DASH] = ACTIONS(1308),
    [anon_sym_PLUS_PLUS] = ACTIONS(1308),
    [anon_sym_sizeof] = ACTIONS(1306),
    [anon_sym___alignof__] = ACTIONS(1306),
    [anon_sym___alignof] = ACTIONS(1306),
    [anon_sym__alignof] = ACTIONS(1306),
    [anon_sym_alignof] = ACTIONS(1306),
    [anon_sym__Alignof] = ACTIONS(1306),
    [anon_sym_offsetof] = ACTIONS(1306),
    [anon_sym__Generic] = ACTIONS(1306),
    [anon_sym_asm] = ACTIONS(1306),
    [anon_sym___asm__] = ACTIONS(1306),
    [sym_number_literal] = ACTIONS(1308),
    [anon_sym_L_SQUOTE] = ACTIONS(1308),
    [anon_sym_u_SQUOTE] = ACTIONS(1308),
    [anon_sym_U_SQUOTE] = ACTIONS(1308),
    [anon_sym_u8_SQUOTE] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(1308),
    [anon_sym_L_DQUOTE] = ACTIONS(1308),
    [anon_sym_u_DQUOTE] = ACTIONS(1308),
    [anon_sym_U_DQUOTE] = ACTIONS(1308),
    [anon_sym_u8_DQUOTE] = ACTIONS(1308),
    [anon_sym_DQUOTE] = ACTIONS(1308),
    [sym_true] = ACTIONS(1306),
    [sym_false] = ACTIONS(1306),
    [anon_sym_NULL] = ACTIONS(1306),
    [anon_sym_nullptr] = ACTIONS(1306),
    [sym_comment] = ACTIONS(3),
  },
  [217] = {
    [sym_identifier] = ACTIONS(1310),
    [aux_sym_preproc_include_token1] = ACTIONS(1310),
    [aux_sym_preproc_def_token1] = ACTIONS(1310),
    [aux_sym_preproc_if_token1] = ACTIONS(1310),
    [aux_sym_preproc_if_token2] = ACTIONS(1310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1310),
    [aux_sym_preproc_else_token1] = ACTIONS(1310),
    [aux_sym_preproc_elif_token1] = ACTIONS(1310),
    [sym_preproc_directive] = ACTIONS(1310),
    [anon_sym_LPAREN2] = ACTIONS(1312),
    [anon_sym_BANG] = ACTIONS(1312),
    [anon_sym_TILDE] = ACTIONS(1312),
    [anon_sym_DASH] = ACTIONS(1310),
    [anon_sym_PLUS] = ACTIONS(1310),
    [anon_sym_STAR] = ACTIONS(1312),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_SEMI] = ACTIONS(1312),
    [anon_sym___extension__] = ACTIONS(1310),
    [anon_sym_typedef] = ACTIONS(1310),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym___attribute__] = ACTIONS(1310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1312),
    [anon_sym___declspec] = ACTIONS(1310),
    [anon_sym___cdecl] = ACTIONS(1310),
    [anon_sym___clrcall] = ACTIONS(1310),
    [anon_sym___stdcall] = ACTIONS(1310),
    [anon_sym___fastcall] = ACTIONS(1310),
    [anon_sym___thiscall] = ACTIONS(1310),
    [anon_sym___vectorcall] = ACTIONS(1310),
    [anon_sym_LBRACE] = ACTIONS(1312),
    [anon_sym_signed] = ACTIONS(1310),
    [anon_sym_unsigned] = ACTIONS(1310),
    [anon_sym_long] = ACTIONS(1310),
    [anon_sym_short] = ACTIONS(1310),
    [anon_sym_static] = ACTIONS(1310),
    [anon_sym_auto] = ACTIONS(1310),
    [anon_sym_register] = ACTIONS(1310),
    [anon_sym_inline] = ACTIONS(1310),
    [anon_sym___inline] = ACTIONS(1310),
    [anon_sym___inline__] = ACTIONS(1310),
    [anon_sym___forceinline] = ACTIONS(1310),
    [anon_sym_thread_local] = ACTIONS(1310),
    [anon_sym___thread] = ACTIONS(1310),
    [anon_sym_const] = ACTIONS(1310),
    [anon_sym_constexpr] = ACTIONS(1310),
    [anon_sym_volatile] = ACTIONS(1310),
    [anon_sym_restrict] = ACTIONS(1310),
    [anon_sym___restrict__] = ACTIONS(1310),
    [anon_sym__Atomic] = ACTIONS(1310),
    [anon_sym__Noreturn] = ACTIONS(1310),
    [anon_sym_noreturn] = ACTIONS(1310),
    [sym_primitive_type] = ACTIONS(1310),
    [anon_sym_enum] = ACTIONS(1310),
    [anon_sym_struct] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1310),
    [anon_sym_if] = ACTIONS(1310),
    [anon_sym_else] = ACTIONS(1310),
    [anon_sym_switch] = ACTIONS(1310),
    [anon_sym_case] = ACTIONS(1310),
    [anon_sym_default] = ACTIONS(1310),
    [anon_sym_while] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1310),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_break] = ACTIONS(1310),
    [anon_sym_continue] = ACTIONS(1310),
    [anon_sym_goto] = ACTIONS(1310),
    [anon_sym___try] = ACTIONS(1310),
    [anon_sym___leave] = ACTIONS(1310),
    [anon_sym_DASH_DASH] = ACTIONS(1312),
    [anon_sym_PLUS_PLUS] = ACTIONS(1312),
    [anon_sym_sizeof] = ACTIONS(1310),
    [anon_sym___alignof__] = ACTIONS(1310),
    [anon_sym___alignof] = ACTIONS(1310),
    [anon_sym__alignof] = ACTIONS(1310),
    [anon_sym_alignof] = ACTIONS(1310),
    [anon_sym__Alignof] = ACTIONS(1310),
    [anon_sym_offsetof] = ACTIONS(1310),
    [anon_sym__Generic] = ACTIONS(1310),
    [anon_sym_asm] = ACTIONS(1310),
    [anon_sym___asm__] = ACTIONS(1310),
    [sym_number_literal] = ACTIONS(1312),
    [anon_sym_L_SQUOTE] = ACTIONS(1312),
    [anon_sym_u_SQUOTE] = ACTIONS(1312),
    [anon_sym_U_SQUOTE] = ACTIONS(1312),
    [anon_sym_u8_SQUOTE] = ACTIONS(1312),
    [anon_sym_SQUOTE] = ACTIONS(1312),
    [anon_sym_L_DQUOTE] = ACTIONS(1312),
    [anon_sym_u_DQUOTE] = ACTIONS(1312),
    [anon_sym_U_DQUOTE] = ACTIONS(1312),
    [anon_sym_u8_DQUOTE] = ACTIONS(1312),
    [anon_sym_DQUOTE] = ACTIONS(1312),
    [sym_true] = ACTIONS(1310),
    [sym_false] = ACTIONS(1310),
    [anon_sym_NULL] = ACTIONS(1310),
    [anon_sym_nullptr] = ACTIONS(1310),
    [sym_comment] = ACTIONS(3),
  },
  [218] = {
    [sym_identifier] = ACTIONS(1314),
    [aux_sym_preproc_include_token1] = ACTIONS(1314),
    [aux_sym_preproc_def_token1] = ACTIONS(1314),
    [aux_sym_preproc_if_token1] = ACTIONS(1314),
    [aux_sym_preproc_if_token2] = ACTIONS(1314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1314),
    [aux_sym_preproc_else_token1] = ACTIONS(1314),
    [aux_sym_preproc_elif_token1] = ACTIONS(1314),
    [sym_preproc_directive] = ACTIONS(1314),
    [anon_sym_LPAREN2] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1314),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym___extension__] = ACTIONS(1314),
    [anon_sym_typedef] = ACTIONS(1314),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym___attribute__] = ACTIONS(1314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1316),
    [anon_sym___declspec] = ACTIONS(1314),
    [anon_sym___cdecl] = ACTIONS(1314),
    [anon_sym___clrcall] = ACTIONS(1314),
    [anon_sym___stdcall] = ACTIONS(1314),
    [anon_sym___fastcall] = ACTIONS(1314),
    [anon_sym___thiscall] = ACTIONS(1314),
    [anon_sym___vectorcall] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_signed] = ACTIONS(1314),
    [anon_sym_unsigned] = ACTIONS(1314),
    [anon_sym_long] = ACTIONS(1314),
    [anon_sym_short] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_auto] = ACTIONS(1314),
    [anon_sym_register] = ACTIONS(1314),
    [anon_sym_inline] = ACTIONS(1314),
    [anon_sym___inline] = ACTIONS(1314),
    [anon_sym___inline__] = ACTIONS(1314),
    [anon_sym___forceinline] = ACTIONS(1314),
    [anon_sym_thread_local] = ACTIONS(1314),
    [anon_sym___thread] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_constexpr] = ACTIONS(1314),
    [anon_sym_volatile] = ACTIONS(1314),
    [anon_sym_restrict] = ACTIONS(1314),
    [anon_sym___restrict__] = ACTIONS(1314),
    [anon_sym__Atomic] = ACTIONS(1314),
    [anon_sym__Noreturn] = ACTIONS(1314),
    [anon_sym_noreturn] = ACTIONS(1314),
    [sym_primitive_type] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_else] = ACTIONS(1314),
    [anon_sym_switch] = ACTIONS(1314),
    [anon_sym_case] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [anon_sym_do] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_goto] = ACTIONS(1314),
    [anon_sym___try] = ACTIONS(1314),
    [anon_sym___leave] = ACTIONS(1314),
    [anon_sym_DASH_DASH] = ACTIONS(1316),
    [anon_sym_PLUS_PLUS] = ACTIONS(1316),
    [anon_sym_sizeof] = ACTIONS(1314),
    [anon_sym___alignof__] = ACTIONS(1314),
    [anon_sym___alignof] = ACTIONS(1314),
    [anon_sym__alignof] = ACTIONS(1314),
    [anon_sym_alignof] = ACTIONS(1314),
    [anon_sym__Alignof] = ACTIONS(1314),
    [anon_sym_offsetof] = ACTIONS(1314),
    [anon_sym__Generic] = ACTIONS(1314),
    [anon_sym_asm] = ACTIONS(1314),
    [anon_sym___asm__] = ACTIONS(1314),
    [sym_number_literal] = ACTIONS(1316),
    [anon_sym_L_SQUOTE] = ACTIONS(1316),
    [anon_sym_u_SQUOTE] = ACTIONS(1316),
    [anon_sym_U_SQUOTE] = ACTIONS(1316),
    [anon_sym_u8_SQUOTE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1316),
    [anon_sym_L_DQUOTE] = ACTIONS(1316),
    [anon_sym_u_DQUOTE] = ACTIONS(1316),
    [anon_sym_U_DQUOTE] = ACTIONS(1316),
    [anon_sym_u8_DQUOTE] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1316),
    [sym_true] = ACTIONS(1314),
    [sym_false] = ACTIONS(1314),
    [anon_sym_NULL] = ACTIONS(1314),
    [anon_sym_nullptr] = ACTIONS(1314),
    [sym_comment] = ACTIONS(3),
  },
  [219] = {
    [sym_identifier] = ACTIONS(1322),
    [aux_sym_preproc_include_token1] = ACTIONS(1322),
    [aux_sym_preproc_def_token1] = ACTIONS(1322),
    [aux_sym_preproc_if_token1] = ACTIONS(1322),
    [aux_sym_preproc_if_token2] = ACTIONS(1322),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1322),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1322),
    [aux_sym_preproc_else_token1] = ACTIONS(1322),
    [aux_sym_preproc_elif_token1] = ACTIONS(1322),
    [sym_preproc_directive] = ACTIONS(1322),
    [anon_sym_LPAREN2] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(1324),
    [anon_sym_TILDE] = ACTIONS(1324),
    [anon_sym_DASH] = ACTIONS(1322),
    [anon_sym_PLUS] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(1324),
    [anon_sym_AMP] = ACTIONS(1324),
    [anon_sym_SEMI] = ACTIONS(1324),
    [anon_sym___extension__] = ACTIONS(1322),
    [anon_sym_typedef] = ACTIONS(1322),
    [anon_sym_extern] = ACTIONS(1322),
    [anon_sym___attribute__] = ACTIONS(1322),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1324),
    [anon_sym___declspec] = ACTIONS(1322),
    [anon_sym___cdecl] = ACTIONS(1322),
    [anon_sym___clrcall] = ACTIONS(1322),
    [anon_sym___stdcall] = ACTIONS(1322),
    [anon_sym___fastcall] = ACTIONS(1322),
    [anon_sym___thiscall] = ACTIONS(1322),
    [anon_sym___vectorcall] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_signed] = ACTIONS(1322),
    [anon_sym_unsigned] = ACTIONS(1322),
    [anon_sym_long] = ACTIONS(1322),
    [anon_sym_short] = ACTIONS(1322),
    [anon_sym_static] = ACTIONS(1322),
    [anon_sym_auto] = ACTIONS(1322),
    [anon_sym_register] = ACTIONS(1322),
    [anon_sym_inline] = ACTIONS(1322),
    [anon_sym___inline] = ACTIONS(1322),
    [anon_sym___inline__] = ACTIONS(1322),
    [anon_sym___forceinline] = ACTIONS(1322),
    [anon_sym_thread_local] = ACTIONS(1322),
    [anon_sym___thread] = ACTIONS(1322),
    [anon_sym_const] = ACTIONS(1322),
    [anon_sym_constexpr] = ACTIONS(1322),
    [anon_sym_volatile] = ACTIONS(1322),
    [anon_sym_restrict] = ACTIONS(1322),
    [anon_sym___restrict__] = ACTIONS(1322),
    [anon_sym__Atomic] = ACTIONS(1322),
    [anon_sym__Noreturn] = ACTIONS(1322),
    [anon_sym_noreturn] = ACTIONS(1322),
    [sym_primitive_type] = ACTIONS(1322),
    [anon_sym_enum] = ACTIONS(1322),
    [anon_sym_struct] = ACTIONS(1322),
    [anon_sym_union] = ACTIONS(1322),
    [anon_sym_if] = ACTIONS(1322),
    [anon_sym_else] = ACTIONS(1322),
    [anon_sym_switch] = ACTIONS(1322),
    [anon_sym_case] = ACTIONS(1322),
    [anon_sym_default] = ACTIONS(1322),
    [anon_sym_while] = ACTIONS(1322),
    [anon_sym_do] = ACTIONS(1322),
    [anon_sym_for] = ACTIONS(1322),
    [anon_sym_return] = ACTIONS(1322),
    [anon_sym_break] = ACTIONS(1322),
    [anon_sym_continue] = ACTIONS(1322),
    [anon_sym_goto] = ACTIONS(1322),
    [anon_sym___try] = ACTIONS(1322),
    [anon_sym___leave] = ACTIONS(1322),
    [anon_sym_DASH_DASH] = ACTIONS(1324),
    [anon_sym_PLUS_PLUS] = ACTIONS(1324),
    [anon_sym_sizeof] = ACTIONS(1322),
    [anon_sym___alignof__] = ACTIONS(1322),
    [anon_sym___alignof] = ACTIONS(1322),
    [anon_sym__alignof] = ACTIONS(1322),
    [anon_sym_alignof] = ACTIONS(1322),
    [anon_sym__Alignof] = ACTIONS(1322),
    [anon_sym_offsetof] = ACTIONS(1322),
    [anon_sym__Generic] = ACTIONS(1322),
    [anon_sym_asm] = ACTIONS(1322),
    [anon_sym___asm__] = ACTIONS(1322),
    [sym_number_literal] = ACTIONS(1324),
    [anon_sym_L_SQUOTE] = ACTIONS(1324),
    [anon_sym_u_SQUOTE] = ACTIONS(1324),
    [anon_sym_U_SQUOTE] = ACTIONS(1324),
    [anon_sym_u8_SQUOTE] = ACTIONS(1324),
    [anon_sym_SQUOTE] = ACTIONS(1324),
    [anon_sym_L_DQUOTE] = ACTIONS(1324),
    [anon_sym_u_DQUOTE] = ACTIONS(1324),
    [anon_sym_U_DQUOTE] = ACTIONS(1324),
    [anon_sym_u8_DQUOTE] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1324),
    [sym_true] = ACTIONS(1322),
    [sym_false] = ACTIONS(1322),
    [anon_sym_NULL] = ACTIONS(1322),
    [anon_sym_nullptr] = ACTIONS(1322),
    [sym_comment] = ACTIONS(3),
  },
  [220] = {
    [sym_identifier] = ACTIONS(1342),
    [aux_sym_preproc_include_token1] = ACTIONS(1342),
    [aux_sym_preproc_def_token1] = ACTIONS(1342),
    [aux_sym_preproc_if_token1] = ACTIONS(1342),
    [aux_sym_preproc_if_token2] = ACTIONS(1342),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1342),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1342),
    [aux_sym_preproc_else_token1] = ACTIONS(1342),
    [aux_sym_preproc_elif_token1] = ACTIONS(1342),
    [sym_preproc_directive] = ACTIONS(1342),
    [anon_sym_LPAREN2] = ACTIONS(1344),
    [anon_sym_BANG] = ACTIONS(1344),
    [anon_sym_TILDE] = ACTIONS(1344),
    [anon_sym_DASH] = ACTIONS(1342),
    [anon_sym_PLUS] = ACTIONS(1342),
    [anon_sym_STAR] = ACTIONS(1344),
    [anon_sym_AMP] = ACTIONS(1344),
    [anon_sym_SEMI] = ACTIONS(1344),
    [anon_sym___extension__] = ACTIONS(1342),
    [anon_sym_typedef] = ACTIONS(1342),
    [anon_sym_extern] = ACTIONS(1342),
    [anon_sym___attribute__] = ACTIONS(1342),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1344),
    [anon_sym___declspec] = ACTIONS(1342),
    [anon_sym___cdecl] = ACTIONS(1342),
    [anon_sym___clrcall] = ACTIONS(1342),
    [anon_sym___stdcall] = ACTIONS(1342),
    [anon_sym___fastcall] = ACTIONS(1342),
    [anon_sym___thiscall] = ACTIONS(1342),
    [anon_sym___vectorcall] = ACTIONS(1342),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_signed] = ACTIONS(1342),
    [anon_sym_unsigned] = ACTIONS(1342),
    [anon_sym_long] = ACTIONS(1342),
    [anon_sym_short] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_auto] = ACTIONS(1342),
    [anon_sym_register] = ACTIONS(1342),
    [anon_sym_inline] = ACTIONS(1342),
    [anon_sym___inline] = ACTIONS(1342),
    [anon_sym___inline__] = ACTIONS(1342),
    [anon_sym___forceinline] = ACTIONS(1342),
    [anon_sym_thread_local] = ACTIONS(1342),
    [anon_sym___thread] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [anon_sym_constexpr] = ACTIONS(1342),
    [anon_sym_volatile] = ACTIONS(1342),
    [anon_sym_restrict] = ACTIONS(1342),
    [anon_sym___restrict__] = ACTIONS(1342),
    [anon_sym__Atomic] = ACTIONS(1342),
    [anon_sym__Noreturn] = ACTIONS(1342),
    [anon_sym_noreturn] = ACTIONS(1342),
    [sym_primitive_type] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_union] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1342),
    [anon_sym_else] = ACTIONS(1342),
    [anon_sym_switch] = ACTIONS(1342),
    [anon_sym_case] = ACTIONS(1342),
    [anon_sym_default] = ACTIONS(1342),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_do] = ACTIONS(1342),
    [anon_sym_for] = ACTIONS(1342),
    [anon_sym_return] = ACTIONS(1342),
    [anon_sym_break] = ACTIONS(1342),
    [anon_sym_continue] = ACTIONS(1342),
    [anon_sym_goto] = ACTIONS(1342),
    [anon_sym___try] = ACTIONS(1342),
    [anon_sym___leave] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(1344),
    [anon_sym_PLUS_PLUS] = ACTIONS(1344),
    [anon_sym_sizeof] = ACTIONS(1342),
    [anon_sym___alignof__] = ACTIONS(1342),
    [anon_sym___alignof] = ACTIONS(1342),
    [anon_sym__alignof] = ACTIONS(1342),
    [anon_sym_alignof] = ACTIONS(1342),
    [anon_sym__Alignof] = ACTIONS(1342),
    [anon_sym_offsetof] = ACTIONS(1342),
    [anon_sym__Generic] = ACTIONS(1342),
    [anon_sym_asm] = ACTIONS(1342),
    [anon_sym___asm__] = ACTIONS(1342),
    [sym_number_literal] = ACTIONS(1344),
    [anon_sym_L_SQUOTE] = ACTIONS(1344),
    [anon_sym_u_SQUOTE] = ACTIONS(1344),
    [anon_sym_U_SQUOTE] = ACTIONS(1344),
    [anon_sym_u8_SQUOTE] = ACTIONS(1344),
    [anon_sym_SQUOTE] = ACTIONS(1344),
    [anon_sym_L_DQUOTE] = ACTIONS(1344),
    [anon_sym_u_DQUOTE] = ACTIONS(1344),
    [anon_sym_U_DQUOTE] = ACTIONS(1344),
    [anon_sym_u8_DQUOTE] = ACTIONS(1344),
    [anon_sym_DQUOTE] = ACTIONS(1344),
    [sym_true] = ACTIONS(1342),
    [sym_false] = ACTIONS(1342),
    [anon_sym_NULL] = ACTIONS(1342),
    [anon_sym_nullptr] = ACTIONS(1342),
    [sym_comment] = ACTIONS(3),
  },
  [221] = {
    [sym_identifier] = ACTIONS(1346),
    [aux_sym_preproc_include_token1] = ACTIONS(1346),
    [aux_sym_preproc_def_token1] = ACTIONS(1346),
    [aux_sym_preproc_if_token1] = ACTIONS(1346),
    [aux_sym_preproc_if_token2] = ACTIONS(1346),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1346),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1346),
    [aux_sym_preproc_else_token1] = ACTIONS(1346),
    [aux_sym_preproc_elif_token1] = ACTIONS(1346),
    [sym_preproc_directive] = ACTIONS(1346),
    [anon_sym_LPAREN2] = ACTIONS(1348),
    [anon_sym_BANG] = ACTIONS(1348),
    [anon_sym_TILDE] = ACTIONS(1348),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_STAR] = ACTIONS(1348),
    [anon_sym_AMP] = ACTIONS(1348),
    [anon_sym_SEMI] = ACTIONS(1348),
    [anon_sym___extension__] = ACTIONS(1346),
    [anon_sym_typedef] = ACTIONS(1346),
    [anon_sym_extern] = ACTIONS(1346),
    [anon_sym___attribute__] = ACTIONS(1346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1348),
    [anon_sym___declspec] = ACTIONS(1346),
    [anon_sym___cdecl] = ACTIONS(1346),
    [anon_sym___clrcall] = ACTIONS(1346),
    [anon_sym___stdcall] = ACTIONS(1346),
    [anon_sym___fastcall] = ACTIONS(1346),
    [anon_sym___thiscall] = ACTIONS(1346),
    [anon_sym___vectorcall] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_signed] = ACTIONS(1346),
    [anon_sym_unsigned] = ACTIONS(1346),
    [anon_sym_long] = ACTIONS(1346),
    [anon_sym_short] = ACTIONS(1346),
    [anon_sym_static] = ACTIONS(1346),
    [anon_sym_auto] = ACTIONS(1346),
    [anon_sym_register] = ACTIONS(1346),
    [anon_sym_inline] = ACTIONS(1346),
    [anon_sym___inline] = ACTIONS(1346),
    [anon_sym___inline__] = ACTIONS(1346),
    [anon_sym___forceinline] = ACTIONS(1346),
    [anon_sym_thread_local] = ACTIONS(1346),
    [anon_sym___thread] = ACTIONS(1346),
    [anon_sym_const] = ACTIONS(1346),
    [anon_sym_constexpr] = ACTIONS(1346),
    [anon_sym_volatile] = ACTIONS(1346),
    [anon_sym_restrict] = ACTIONS(1346),
    [anon_sym___restrict__] = ACTIONS(1346),
    [anon_sym__Atomic] = ACTIONS(1346),
    [anon_sym__Noreturn] = ACTIONS(1346),
    [anon_sym_noreturn] = ACTIONS(1346),
    [sym_primitive_type] = ACTIONS(1346),
    [anon_sym_enum] = ACTIONS(1346),
    [anon_sym_struct] = ACTIONS(1346),
    [anon_sym_union] = ACTIONS(1346),
    [anon_sym_if] = ACTIONS(1346),
    [anon_sym_else] = ACTIONS(1346),
    [anon_sym_switch] = ACTIONS(1346),
    [anon_sym_case] = ACTIONS(1346),
    [anon_sym_default] = ACTIONS(1346),
    [anon_sym_while] = ACTIONS(1346),
    [anon_sym_do] = ACTIONS(1346),
    [anon_sym_for] = ACTIONS(1346),
    [anon_sym_return] = ACTIONS(1346),
    [anon_sym_break] = ACTIONS(1346),
    [anon_sym_continue] = ACTIONS(1346),
    [anon_sym_goto] = ACTIONS(1346),
    [anon_sym___try] = ACTIONS(1346),
    [anon_sym___leave] = ACTIONS(1346),
    [anon_sym_DASH_DASH] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(1348),
    [anon_sym_sizeof] = ACTIONS(1346),
    [anon_sym___alignof__] = ACTIONS(1346),
    [anon_sym___alignof] = ACTIONS(1346),
    [anon_sym__alignof] = ACTIONS(1346),
    [anon_sym_alignof] = ACTIONS(1346),
    [anon_sym__Alignof] = ACTIONS(1346),
    [anon_sym_offsetof] = ACTIONS(1346),
    [anon_sym__Generic] = ACTIONS(1346),
    [anon_sym_asm] = ACTIONS(1346),
    [anon_sym___asm__] = ACTIONS(1346),
    [sym_number_literal] = ACTIONS(1348),
    [anon_sym_L_SQUOTE] = ACTIONS(1348),
    [anon_sym_u_SQUOTE] = ACTIONS(1348),
    [anon_sym_U_SQUOTE] = ACTIONS(1348),
    [anon_sym_u8_SQUOTE] = ACTIONS(1348),
    [anon_sym_SQUOTE] = ACTIONS(1348),
    [anon_sym_L_DQUOTE] = ACTIONS(1348),
    [anon_sym_u_DQUOTE] = ACTIONS(1348),
    [anon_sym_U_DQUOTE] = ACTIONS(1348),
    [anon_sym_u8_DQUOTE] = ACTIONS(1348),
    [anon_sym_DQUOTE] = ACTIONS(1348),
    [sym_true] = ACTIONS(1346),
    [sym_false] = ACTIONS(1346),
    [anon_sym_NULL] = ACTIONS(1346),
    [anon_sym_nullptr] = ACTIONS(1346),
    [sym_comment] = ACTIONS(3),
  },
  [222] = {
    [sym_identifier] = ACTIONS(1478),
    [aux_sym_preproc_include_token1] = ACTIONS(1478),
    [aux_sym_preproc_def_token1] = ACTIONS(1478),
    [aux_sym_preproc_if_token1] = ACTIONS(1478),
    [aux_sym_preproc_if_token2] = ACTIONS(1478),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1478),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1478),
    [aux_sym_preproc_else_token1] = ACTIONS(1478),
    [aux_sym_preproc_elif_token1] = ACTIONS(1478),
    [sym_preproc_directive] = ACTIONS(1478),
    [anon_sym_LPAREN2] = ACTIONS(1480),
    [anon_sym_BANG] = ACTIONS(1480),
    [anon_sym_TILDE] = ACTIONS(1480),
    [anon_sym_DASH] = ACTIONS(1478),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_STAR] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1480),
    [anon_sym_SEMI] = ACTIONS(1480),
    [anon_sym___extension__] = ACTIONS(1478),
    [anon_sym_typedef] = ACTIONS(1478),
    [anon_sym_extern] = ACTIONS(1478),
    [anon_sym___attribute__] = ACTIONS(1478),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1480),
    [anon_sym___declspec] = ACTIONS(1478),
    [anon_sym___cdecl] = ACTIONS(1478),
    [anon_sym___clrcall] = ACTIONS(1478),
    [anon_sym___stdcall] = ACTIONS(1478),
    [anon_sym___fastcall] = ACTIONS(1478),
    [anon_sym___thiscall] = ACTIONS(1478),
    [anon_sym___vectorcall] = ACTIONS(1478),
    [anon_sym_LBRACE] = ACTIONS(1480),
    [anon_sym_signed] = ACTIONS(1478),
    [anon_sym_unsigned] = ACTIONS(1478),
    [anon_sym_long] = ACTIONS(1478),
    [anon_sym_short] = ACTIONS(1478),
    [anon_sym_static] = ACTIONS(1478),
    [anon_sym_auto] = ACTIONS(1478),
    [anon_sym_register] = ACTIONS(1478),
    [anon_sym_inline] = ACTIONS(1478),
    [anon_sym___inline] = ACTIONS(1478),
    [anon_sym___inline__] = ACTIONS(1478),
    [anon_sym___forceinline] = ACTIONS(1478),
    [anon_sym_thread_local] = ACTIONS(1478),
    [anon_sym___thread] = ACTIONS(1478),
    [anon_sym_const] = ACTIONS(1478),
    [anon_sym_constexpr] = ACTIONS(1478),
    [anon_sym_volatile] = ACTIONS(1478),
    [anon_sym_restrict] = ACTIONS(1478),
    [anon_sym___restrict__] = ACTIONS(1478),
    [anon_sym__Atomic] = ACTIONS(1478),
    [anon_sym__Noreturn] = ACTIONS(1478),
    [anon_sym_noreturn] = ACTIONS(1478),
    [sym_primitive_type] = ACTIONS(1478),
    [anon_sym_enum] = ACTIONS(1478),
    [anon_sym_struct] = ACTIONS(1478),
    [anon_sym_union] = ACTIONS(1478),
    [anon_sym_if] = ACTIONS(1478),
    [anon_sym_switch] = ACTIONS(1478),
    [anon_sym_case] = ACTIONS(1478),
    [anon_sym_default] = ACTIONS(1478),
    [anon_sym_while] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_for] = ACTIONS(1478),
    [anon_sym_return] = ACTIONS(1478),
    [anon_sym_break] = ACTIONS(1478),
    [anon_sym_continue] = ACTIONS(1478),
    [anon_sym_goto] = ACTIONS(1478),
    [anon_sym___try] = ACTIONS(1478),
    [anon_sym___leave] = ACTIONS(1478),
    [anon_sym_DASH_DASH] = ACTIONS(1480),
    [anon_sym_PLUS_PLUS] = ACTIONS(1480),
    [anon_sym_sizeof] = ACTIONS(1478),
    [anon_sym___alignof__] = ACTIONS(1478),
    [anon_sym___alignof] = ACTIONS(1478),
    [anon_sym__alignof] = ACTIONS(1478),
    [anon_sym_alignof] = ACTIONS(1478),
    [anon_sym__Alignof] = ACTIONS(1478),
    [anon_sym_offsetof] = ACTIONS(1478),
    [anon_sym__Generic] = ACTIONS(1478),
    [anon_sym_asm] = ACTIONS(1478),
    [anon_sym___asm__] = ACTIONS(1478),
    [sym_number_literal] = ACTIONS(1480),
    [anon_sym_L_SQUOTE] = ACTIONS(1480),
    [anon_sym_u_SQUOTE] = ACTIONS(1480),
    [anon_sym_U_SQUOTE] = ACTIONS(1480),
    [anon_sym_u8_SQUOTE] = ACTIONS(1480),
    [anon_sym_SQUOTE] = ACTIONS(1480),
    [anon_sym_L_DQUOTE] = ACTIONS(1480),
    [anon_sym_u_DQUOTE] = ACTIONS(1480),
    [anon_sym_U_DQUOTE] = ACTIONS(1480),
    [anon_sym_u8_DQUOTE] = ACTIONS(1480),
    [anon_sym_DQUOTE] = ACTIONS(1480),
    [sym_true] = ACTIONS(1478),
    [sym_false] = ACTIONS(1478),
    [anon_sym_NULL] = ACTIONS(1478),
    [anon_sym_nullptr] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
  },
  [223] = {
    [sym_identifier] = ACTIONS(1522),
    [aux_sym_preproc_include_token1] = ACTIONS(1522),
    [aux_sym_preproc_def_token1] = ACTIONS(1522),
    [aux_sym_preproc_if_token1] = ACTIONS(1522),
    [aux_sym_preproc_if_token2] = ACTIONS(1522),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1522),
    [aux_sym_preproc_else_token1] = ACTIONS(1522),
    [aux_sym_preproc_elif_token1] = ACTIONS(1522),
    [sym_preproc_directive] = ACTIONS(1522),
    [anon_sym_LPAREN2] = ACTIONS(1524),
    [anon_sym_BANG] = ACTIONS(1524),
    [anon_sym_TILDE] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1522),
    [anon_sym_PLUS] = ACTIONS(1522),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym___extension__] = ACTIONS(1522),
    [anon_sym_typedef] = ACTIONS(1522),
    [anon_sym_extern] = ACTIONS(1522),
    [anon_sym___attribute__] = ACTIONS(1522),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1524),
    [anon_sym___declspec] = ACTIONS(1522),
    [anon_sym___cdecl] = ACTIONS(1522),
    [anon_sym___clrcall] = ACTIONS(1522),
    [anon_sym___stdcall] = ACTIONS(1522),
    [anon_sym___fastcall] = ACTIONS(1522),
    [anon_sym___thiscall] = ACTIONS(1522),
    [anon_sym___vectorcall] = ACTIONS(1522),
    [anon_sym_LBRACE] = ACTIONS(1524),
    [anon_sym_signed] = ACTIONS(1522),
    [anon_sym_unsigned] = ACTIONS(1522),
    [anon_sym_long] = ACTIONS(1522),
    [anon_sym_short] = ACTIONS(1522),
    [anon_sym_static] = ACTIONS(1522),
    [anon_sym_auto] = ACTIONS(1522),
    [anon_sym_register] = ACTIONS(1522),
    [anon_sym_inline] = ACTIONS(1522),
    [anon_sym___inline] = ACTIONS(1522),
    [anon_sym___inline__] = ACTIONS(1522),
    [anon_sym___forceinline] = ACTIONS(1522),
    [anon_sym_thread_local] = ACTIONS(1522),
    [anon_sym___thread] = ACTIONS(1522),
    [anon_sym_const] = ACTIONS(1522),
    [anon_sym_constexpr] = ACTIONS(1522),
    [anon_sym_volatile] = ACTIONS(1522),
    [anon_sym_restrict] = ACTIONS(1522),
    [anon_sym___restrict__] = ACTIONS(1522),
    [anon_sym__Atomic] = ACTIONS(1522),
    [anon_sym__Noreturn] = ACTIONS(1522),
    [anon_sym_noreturn] = ACTIONS(1522),
    [sym_primitive_type] = ACTIONS(1522),
    [anon_sym_enum] = ACTIONS(1522),
    [anon_sym_struct] = ACTIONS(1522),
    [anon_sym_union] = ACTIONS(1522),
    [anon_sym_if] = ACTIONS(1522),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1522),
    [anon_sym_default] = ACTIONS(1522),
    [anon_sym_while] = ACTIONS(1522),
    [anon_sym_do] = ACTIONS(1522),
    [anon_sym_for] = ACTIONS(1522),
    [anon_sym_return] = ACTIONS(1522),
    [anon_sym_break] = ACTIONS(1522),
    [anon_sym_continue] = ACTIONS(1522),
    [anon_sym_goto] = ACTIONS(1522),
    [anon_sym___try] = ACTIONS(1522),
    [anon_sym___leave] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1524),
    [anon_sym_PLUS_PLUS] = ACTIONS(1524),
    [anon_sym_sizeof] = ACTIONS(1522),
    [anon_sym___alignof__] = ACTIONS(1522),
    [anon_sym___alignof] = ACTIONS(1522),
    [anon_sym__alignof] = ACTIONS(1522),
    [anon_sym_alignof] = ACTIONS(1522),
    [anon_sym__Alignof] = ACTIONS(1522),
    [anon_sym_offsetof] = ACTIONS(1522),
    [anon_sym__Generic] = ACTIONS(1522),
    [anon_sym_asm] = ACTIONS(1522),
    [anon_sym___asm__] = ACTIONS(1522),
    [sym_number_literal] = ACTIONS(1524),
    [anon_sym_L_SQUOTE] = ACTIONS(1524),
    [anon_sym_u_SQUOTE] = ACTIONS(1524),
    [anon_sym_U_SQUOTE] = ACTIONS(1524),
    [anon_sym_u8_SQUOTE] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(1524),
    [anon_sym_L_DQUOTE] = ACTIONS(1524),
    [anon_sym_u_DQUOTE] = ACTIONS(1524),
    [anon_sym_U_DQUOTE] = ACTIONS(1524),
    [anon_sym_u8_DQUOTE] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1524),
    [sym_true] = ACTIONS(1522),
    [sym_false] = ACTIONS(1522),
    [anon_sym_NULL] = ACTIONS(1522),
    [anon_sym_nullptr] = ACTIONS(1522),
    [sym_comment] = ACTIONS(3),
  },
  [224] = {
    [sym_identifier] = ACTIONS(1426),
    [aux_sym_preproc_include_token1] = ACTIONS(1426),
    [aux_sym_preproc_def_token1] = ACTIONS(1426),
    [aux_sym_preproc_if_token1] = ACTIONS(1426),
    [aux_sym_preproc_if_token2] = ACTIONS(1426),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1426),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1426),
    [aux_sym_preproc_else_token1] = ACTIONS(1426),
    [aux_sym_preproc_elif_token1] = ACTIONS(1426),
    [sym_preproc_directive] = ACTIONS(1426),
    [anon_sym_LPAREN2] = ACTIONS(1428),
    [anon_sym_BANG] = ACTIONS(1428),
    [anon_sym_TILDE] = ACTIONS(1428),
    [anon_sym_DASH] = ACTIONS(1426),
    [anon_sym_PLUS] = ACTIONS(1426),
    [anon_sym_STAR] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1428),
    [anon_sym_SEMI] = ACTIONS(1428),
    [anon_sym___extension__] = ACTIONS(1426),
    [anon_sym_typedef] = ACTIONS(1426),
    [anon_sym_extern] = ACTIONS(1426),
    [anon_sym___attribute__] = ACTIONS(1426),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1428),
    [anon_sym___declspec] = ACTIONS(1426),
    [anon_sym___cdecl] = ACTIONS(1426),
    [anon_sym___clrcall] = ACTIONS(1426),
    [anon_sym___stdcall] = ACTIONS(1426),
    [anon_sym___fastcall] = ACTIONS(1426),
    [anon_sym___thiscall] = ACTIONS(1426),
    [anon_sym___vectorcall] = ACTIONS(1426),
    [anon_sym_LBRACE] = ACTIONS(1428),
    [anon_sym_signed] = ACTIONS(1426),
    [anon_sym_unsigned] = ACTIONS(1426),
    [anon_sym_long] = ACTIONS(1426),
    [anon_sym_short] = ACTIONS(1426),
    [anon_sym_static] = ACTIONS(1426),
    [anon_sym_auto] = ACTIONS(1426),
    [anon_sym_register] = ACTIONS(1426),
    [anon_sym_inline] = ACTIONS(1426),
    [anon_sym___inline] = ACTIONS(1426),
    [anon_sym___inline__] = ACTIONS(1426),
    [anon_sym___forceinline] = ACTIONS(1426),
    [anon_sym_thread_local] = ACTIONS(1426),
    [anon_sym___thread] = ACTIONS(1426),
    [anon_sym_const] = ACTIONS(1426),
    [anon_sym_constexpr] = ACTIONS(1426),
    [anon_sym_volatile] = ACTIONS(1426),
    [anon_sym_restrict] = ACTIONS(1426),
    [anon_sym___restrict__] = ACTIONS(1426),
    [anon_sym__Atomic] = ACTIONS(1426),
    [anon_sym__Noreturn] = ACTIONS(1426),
    [anon_sym_noreturn] = ACTIONS(1426),
    [sym_primitive_type] = ACTIONS(1426),
    [anon_sym_enum] = ACTIONS(1426),
    [anon_sym_struct] = ACTIONS(1426),
    [anon_sym_union] = ACTIONS(1426),
    [anon_sym_if] = ACTIONS(1426),
    [anon_sym_switch] = ACTIONS(1426),
    [anon_sym_case] = ACTIONS(1426),
    [anon_sym_default] = ACTIONS(1426),
    [anon_sym_while] = ACTIONS(1426),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_for] = ACTIONS(1426),
    [anon_sym_return] = ACTIONS(1426),
    [anon_sym_break] = ACTIONS(1426),
    [anon_sym_continue] = ACTIONS(1426),
    [anon_sym_goto] = ACTIONS(1426),
    [anon_sym___try] = ACTIONS(1426),
    [anon_sym___leave] = ACTIONS(1426),
    [anon_sym_DASH_DASH] = ACTIONS(1428),
    [anon_sym_PLUS_PLUS] = ACTIONS(1428),
    [anon_sym_sizeof] = ACTIONS(1426),
    [anon_sym___alignof__] = ACTIONS(1426),
    [anon_sym___alignof] = ACTIONS(1426),
    [anon_sym__alignof] = ACTIONS(1426),
    [anon_sym_alignof] = ACTIONS(1426),
    [anon_sym__Alignof] = ACTIONS(1426),
    [anon_sym_offsetof] = ACTIONS(1426),
    [anon_sym__Generic] = ACTIONS(1426),
    [anon_sym_asm] = ACTIONS(1426),
    [anon_sym___asm__] = ACTIONS(1426),
    [sym_number_literal] = ACTIONS(1428),
    [anon_sym_L_SQUOTE] = ACTIONS(1428),
    [anon_sym_u_SQUOTE] = ACTIONS(1428),
    [anon_sym_U_SQUOTE] = ACTIONS(1428),
    [anon_sym_u8_SQUOTE] = ACTIONS(1428),
    [anon_sym_SQUOTE] = ACTIONS(1428),
    [anon_sym_L_DQUOTE] = ACTIONS(1428),
    [anon_sym_u_DQUOTE] = ACTIONS(1428),
    [anon_sym_U_DQUOTE] = ACTIONS(1428),
    [anon_sym_u8_DQUOTE] = ACTIONS(1428),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [sym_true] = ACTIONS(1426),
    [sym_false] = ACTIONS(1426),
    [anon_sym_NULL] = ACTIONS(1426),
    [anon_sym_nullptr] = ACTIONS(1426),
    [sym_comment] = ACTIONS(3),
  },
  [225] = {
    [sym_identifier] = ACTIONS(1430),
    [aux_sym_preproc_include_token1] = ACTIONS(1430),
    [aux_sym_preproc_def_token1] = ACTIONS(1430),
    [aux_sym_preproc_if_token1] = ACTIONS(1430),
    [aux_sym_preproc_if_token2] = ACTIONS(1430),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1430),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1430),
    [aux_sym_preproc_else_token1] = ACTIONS(1430),
    [aux_sym_preproc_elif_token1] = ACTIONS(1430),
    [sym_preproc_directive] = ACTIONS(1430),
    [anon_sym_LPAREN2] = ACTIONS(1432),
    [anon_sym_BANG] = ACTIONS(1432),
    [anon_sym_TILDE] = ACTIONS(1432),
    [anon_sym_DASH] = ACTIONS(1430),
    [anon_sym_PLUS] = ACTIONS(1430),
    [anon_sym_STAR] = ACTIONS(1432),
    [anon_sym_AMP] = ACTIONS(1432),
    [anon_sym_SEMI] = ACTIONS(1432),
    [anon_sym___extension__] = ACTIONS(1430),
    [anon_sym_typedef] = ACTIONS(1430),
    [anon_sym_extern] = ACTIONS(1430),
    [anon_sym___attribute__] = ACTIONS(1430),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(1430),
    [anon_sym___cdecl] = ACTIONS(1430),
    [anon_sym___clrcall] = ACTIONS(1430),
    [anon_sym___stdcall] = ACTIONS(1430),
    [anon_sym___fastcall] = ACTIONS(1430),
    [anon_sym___thiscall] = ACTIONS(1430),
    [anon_sym___vectorcall] = ACTIONS(1430),
    [anon_sym_LBRACE] = ACTIONS(1432),
    [anon_sym_signed] = ACTIONS(1430),
    [anon_sym_unsigned] = ACTIONS(1430),
    [anon_sym_long] = ACTIONS(1430),
    [anon_sym_short] = ACTIONS(1430),
    [anon_sym_static] = ACTIONS(1430),
    [anon_sym_auto] = ACTIONS(1430),
    [anon_sym_register] = ACTIONS(1430),
    [anon_sym_inline] = ACTIONS(1430),
    [anon_sym___inline] = ACTIONS(1430),
    [anon_sym___inline__] = ACTIONS(1430),
    [anon_sym___forceinline] = ACTIONS(1430),
    [anon_sym_thread_local] = ACTIONS(1430),
    [anon_sym___thread] = ACTIONS(1430),
    [anon_sym_const] = ACTIONS(1430),
    [anon_sym_constexpr] = ACTIONS(1430),
    [anon_sym_volatile] = ACTIONS(1430),
    [anon_sym_restrict] = ACTIONS(1430),
    [anon_sym___restrict__] = ACTIONS(1430),
    [anon_sym__Atomic] = ACTIONS(1430),
    [anon_sym__Noreturn] = ACTIONS(1430),
    [anon_sym_noreturn] = ACTIONS(1430),
    [sym_primitive_type] = ACTIONS(1430),
    [anon_sym_enum] = ACTIONS(1430),
    [anon_sym_struct] = ACTIONS(1430),
    [anon_sym_union] = ACTIONS(1430),
    [anon_sym_if] = ACTIONS(1430),
    [anon_sym_switch] = ACTIONS(1430),
    [anon_sym_case] = ACTIONS(1430),
    [anon_sym_default] = ACTIONS(1430),
    [anon_sym_while] = ACTIONS(1430),
    [anon_sym_do] = ACTIONS(1430),
    [anon_sym_for] = ACTIONS(1430),
    [anon_sym_return] = ACTIONS(1430),
    [anon_sym_break] = ACTIONS(1430),
    [anon_sym_continue] = ACTIONS(1430),
    [anon_sym_goto] = ACTIONS(1430),
    [anon_sym___try] = ACTIONS(1430),
    [anon_sym___leave] = ACTIONS(1430),
    [anon_sym_DASH_DASH] = ACTIONS(1432),
    [anon_sym_PLUS_PLUS] = ACTIONS(1432),
    [anon_sym_sizeof] = ACTIONS(1430),
    [anon_sym___alignof__] = ACTIONS(1430),
    [anon_sym___alignof] = ACTIONS(1430),
    [anon_sym__alignof] = ACTIONS(1430),
    [anon_sym_alignof] = ACTIONS(1430),
    [anon_sym__Alignof] = ACTIONS(1430),
    [anon_sym_offsetof] = ACTIONS(1430),
    [anon_sym__Generic] = ACTIONS(1430),
    [anon_sym_asm] = ACTIONS(1430),
    [anon_sym___asm__] = ACTIONS(1430),
    [sym_number_literal] = ACTIONS(1432),
    [anon_sym_L_SQUOTE] = ACTIONS(1432),
    [anon_sym_u_SQUOTE] = ACTIONS(1432),
    [anon_sym_U_SQUOTE] = ACTIONS(1432),
    [anon_sym_u8_SQUOTE] = ACTIONS(1432),
    [anon_sym_SQUOTE] = ACTIONS(1432),
    [anon_sym_L_DQUOTE] = ACTIONS(1432),
    [anon_sym_u_DQUOTE] = ACTIONS(1432),
    [anon_sym_U_DQUOTE] = ACTIONS(1432),
    [anon_sym_u8_DQUOTE] = ACTIONS(1432),
    [anon_sym_DQUOTE] = ACTIONS(1432),
    [sym_true] = ACTIONS(1430),
    [sym_false] = ACTIONS(1430),
    [anon_sym_NULL] = ACTIONS(1430),
    [anon_sym_nullptr] = ACTIONS(1430),
    [sym_comment] = ACTIONS(3),
  },
  [226] = {
    [sym_identifier] = ACTIONS(1434),
    [aux_sym_preproc_include_token1] = ACTIONS(1434),
    [aux_sym_preproc_def_token1] = ACTIONS(1434),
    [aux_sym_preproc_if_token1] = ACTIONS(1434),
    [aux_sym_preproc_if_token2] = ACTIONS(1434),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1434),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1434),
    [aux_sym_preproc_else_token1] = ACTIONS(1434),
    [aux_sym_preproc_elif_token1] = ACTIONS(1434),
    [sym_preproc_directive] = ACTIONS(1434),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(1436),
    [anon_sym_TILDE] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_STAR] = ACTIONS(1436),
    [anon_sym_AMP] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1436),
    [anon_sym___extension__] = ACTIONS(1434),
    [anon_sym_typedef] = ACTIONS(1434),
    [anon_sym_extern] = ACTIONS(1434),
    [anon_sym___attribute__] = ACTIONS(1434),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1436),
    [anon_sym___declspec] = ACTIONS(1434),
    [anon_sym___cdecl] = ACTIONS(1434),
    [anon_sym___clrcall] = ACTIONS(1434),
    [anon_sym___stdcall] = ACTIONS(1434),
    [anon_sym___fastcall] = ACTIONS(1434),
    [anon_sym___thiscall] = ACTIONS(1434),
    [anon_sym___vectorcall] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1436),
    [anon_sym_signed] = ACTIONS(1434),
    [anon_sym_unsigned] = ACTIONS(1434),
    [anon_sym_long] = ACTIONS(1434),
    [anon_sym_short] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(1434),
    [anon_sym_auto] = ACTIONS(1434),
    [anon_sym_register] = ACTIONS(1434),
    [anon_sym_inline] = ACTIONS(1434),
    [anon_sym___inline] = ACTIONS(1434),
    [anon_sym___inline__] = ACTIONS(1434),
    [anon_sym___forceinline] = ACTIONS(1434),
    [anon_sym_thread_local] = ACTIONS(1434),
    [anon_sym___thread] = ACTIONS(1434),
    [anon_sym_const] = ACTIONS(1434),
    [anon_sym_constexpr] = ACTIONS(1434),
    [anon_sym_volatile] = ACTIONS(1434),
    [anon_sym_restrict] = ACTIONS(1434),
    [anon_sym___restrict__] = ACTIONS(1434),
    [anon_sym__Atomic] = ACTIONS(1434),
    [anon_sym__Noreturn] = ACTIONS(1434),
    [anon_sym_noreturn] = ACTIONS(1434),
    [sym_primitive_type] = ACTIONS(1434),
    [anon_sym_enum] = ACTIONS(1434),
    [anon_sym_struct] = ACTIONS(1434),
    [anon_sym_union] = ACTIONS(1434),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_switch] = ACTIONS(1434),
    [anon_sym_case] = ACTIONS(1434),
    [anon_sym_default] = ACTIONS(1434),
    [anon_sym_while] = ACTIONS(1434),
    [anon_sym_do] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1434),
    [anon_sym_return] = ACTIONS(1434),
    [anon_sym_break] = ACTIONS(1434),
    [anon_sym_continue] = ACTIONS(1434),
    [anon_sym_goto] = ACTIONS(1434),
    [anon_sym___try] = ACTIONS(1434),
    [anon_sym___leave] = ACTIONS(1434),
    [anon_sym_DASH_DASH] = ACTIONS(1436),
    [anon_sym_PLUS_PLUS] = ACTIONS(1436),
    [anon_sym_sizeof] = ACTIONS(1434),
    [anon_sym___alignof__] = ACTIONS(1434),
    [anon_sym___alignof] = ACTIONS(1434),
    [anon_sym__alignof] = ACTIONS(1434),
    [anon_sym_alignof] = ACTIONS(1434),
    [anon_sym__Alignof] = ACTIONS(1434),
    [anon_sym_offsetof] = ACTIONS(1434),
    [anon_sym__Generic] = ACTIONS(1434),
    [anon_sym_asm] = ACTIONS(1434),
    [anon_sym___asm__] = ACTIONS(1434),
    [sym_number_literal] = ACTIONS(1436),
    [anon_sym_L_SQUOTE] = ACTIONS(1436),
    [anon_sym_u_SQUOTE] = ACTIONS(1436),
    [anon_sym_U_SQUOTE] = ACTIONS(1436),
    [anon_sym_u8_SQUOTE] = ACTIONS(1436),
    [anon_sym_SQUOTE] = ACTIONS(1436),
    [anon_sym_L_DQUOTE] = ACTIONS(1436),
    [anon_sym_u_DQUOTE] = ACTIONS(1436),
    [anon_sym_U_DQUOTE] = ACTIONS(1436),
    [anon_sym_u8_DQUOTE] = ACTIONS(1436),
    [anon_sym_DQUOTE] = ACTIONS(1436),
    [sym_true] = ACTIONS(1434),
    [sym_false] = ACTIONS(1434),
    [anon_sym_NULL] = ACTIONS(1434),
    [anon_sym_nullptr] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
  },
  [227] = {
    [sym_identifier] = ACTIONS(1518),
    [aux_sym_preproc_include_token1] = ACTIONS(1518),
    [aux_sym_preproc_def_token1] = ACTIONS(1518),
    [aux_sym_preproc_if_token1] = ACTIONS(1518),
    [aux_sym_preproc_if_token2] = ACTIONS(1518),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1518),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1518),
    [aux_sym_preproc_else_token1] = ACTIONS(1518),
    [aux_sym_preproc_elif_token1] = ACTIONS(1518),
    [sym_preproc_directive] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(1520),
    [anon_sym_BANG] = ACTIONS(1520),
    [anon_sym_TILDE] = ACTIONS(1520),
    [anon_sym_DASH] = ACTIONS(1518),
    [anon_sym_PLUS] = ACTIONS(1518),
    [anon_sym_STAR] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1520),
    [anon_sym_SEMI] = ACTIONS(1520),
    [anon_sym___extension__] = ACTIONS(1518),
    [anon_sym_typedef] = ACTIONS(1518),
    [anon_sym_extern] = ACTIONS(1518),
    [anon_sym___attribute__] = ACTIONS(1518),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1520),
    [anon_sym___declspec] = ACTIONS(1518),
    [anon_sym___cdecl] = ACTIONS(1518),
    [anon_sym___clrcall] = ACTIONS(1518),
    [anon_sym___stdcall] = ACTIONS(1518),
    [anon_sym___fastcall] = ACTIONS(1518),
    [anon_sym___thiscall] = ACTIONS(1518),
    [anon_sym___vectorcall] = ACTIONS(1518),
    [anon_sym_LBRACE] = ACTIONS(1520),
    [anon_sym_signed] = ACTIONS(1518),
    [anon_sym_unsigned] = ACTIONS(1518),
    [anon_sym_long] = ACTIONS(1518),
    [anon_sym_short] = ACTIONS(1518),
    [anon_sym_static] = ACTIONS(1518),
    [anon_sym_auto] = ACTIONS(1518),
    [anon_sym_register] = ACTIONS(1518),
    [anon_sym_inline] = ACTIONS(1518),
    [anon_sym___inline] = ACTIONS(1518),
    [anon_sym___inline__] = ACTIONS(1518),
    [anon_sym___forceinline] = ACTIONS(1518),
    [anon_sym_thread_local] = ACTIONS(1518),
    [anon_sym___thread] = ACTIONS(1518),
    [anon_sym_const] = ACTIONS(1518),
    [anon_sym_constexpr] = ACTIONS(1518),
    [anon_sym_volatile] = ACTIONS(1518),
    [anon_sym_restrict] = ACTIONS(1518),
    [anon_sym___restrict__] = ACTIONS(1518),
    [anon_sym__Atomic] = ACTIONS(1518),
    [anon_sym__Noreturn] = ACTIONS(1518),
    [anon_sym_noreturn] = ACTIONS(1518),
    [sym_primitive_type] = ACTIONS(1518),
    [anon_sym_enum] = ACTIONS(1518),
    [anon_sym_struct] = ACTIONS(1518),
    [anon_sym_union] = ACTIONS(1518),
    [anon_sym_if] = ACTIONS(1518),
    [anon_sym_switch] = ACTIONS(1518),
    [anon_sym_case] = ACTIONS(1518),
    [anon_sym_default] = ACTIONS(1518),
    [anon_sym_while] = ACTIONS(1518),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_for] = ACTIONS(1518),
    [anon_sym_return] = ACTIONS(1518),
    [anon_sym_break] = ACTIONS(1518),
    [anon_sym_continue] = ACTIONS(1518),
    [anon_sym_goto] = ACTIONS(1518),
    [anon_sym___try] = ACTIONS(1518),
    [anon_sym___leave] = ACTIONS(1518),
    [anon_sym_DASH_DASH] = ACTIONS(1520),
    [anon_sym_PLUS_PLUS] = ACTIONS(1520),
    [anon_sym_sizeof] = ACTIONS(1518),
    [anon_sym___alignof__] = ACTIONS(1518),
    [anon_sym___alignof] = ACTIONS(1518),
    [anon_sym__alignof] = ACTIONS(1518),
    [anon_sym_alignof] = ACTIONS(1518),
    [anon_sym__Alignof] = ACTIONS(1518),
    [anon_sym_offsetof] = ACTIONS(1518),
    [anon_sym__Generic] = ACTIONS(1518),
    [anon_sym_asm] = ACTIONS(1518),
    [anon_sym___asm__] = ACTIONS(1518),
    [sym_number_literal] = ACTIONS(1520),
    [anon_sym_L_SQUOTE] = ACTIONS(1520),
    [anon_sym_u_SQUOTE] = ACTIONS(1520),
    [anon_sym_U_SQUOTE] = ACTIONS(1520),
    [anon_sym_u8_SQUOTE] = ACTIONS(1520),
    [anon_sym_SQUOTE] = ACTIONS(1520),
    [anon_sym_L_DQUOTE] = ACTIONS(1520),
    [anon_sym_u_DQUOTE] = ACTIONS(1520),
    [anon_sym_U_DQUOTE] = ACTIONS(1520),
    [anon_sym_u8_DQUOTE] = ACTIONS(1520),
    [anon_sym_DQUOTE] = ACTIONS(1520),
    [sym_true] = ACTIONS(1518),
    [sym_false] = ACTIONS(1518),
    [anon_sym_NULL] = ACTIONS(1518),
    [anon_sym_nullptr] = ACTIONS(1518),
    [sym_comment] = ACTIONS(3),
  },
  [228] = {
    [sym_identifier] = ACTIONS(1458),
    [aux_sym_preproc_include_token1] = ACTIONS(1458),
    [aux_sym_preproc_def_token1] = ACTIONS(1458),
    [aux_sym_preproc_if_token1] = ACTIONS(1458),
    [aux_sym_preproc_if_token2] = ACTIONS(1458),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1458),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1458),
    [aux_sym_preproc_else_token1] = ACTIONS(1458),
    [aux_sym_preproc_elif_token1] = ACTIONS(1458),
    [sym_preproc_directive] = ACTIONS(1458),
    [anon_sym_LPAREN2] = ACTIONS(1460),
    [anon_sym_BANG] = ACTIONS(1460),
    [anon_sym_TILDE] = ACTIONS(1460),
    [anon_sym_DASH] = ACTIONS(1458),
    [anon_sym_PLUS] = ACTIONS(1458),
    [anon_sym_STAR] = ACTIONS(1460),
    [anon_sym_AMP] = ACTIONS(1460),
    [anon_sym_SEMI] = ACTIONS(1460),
    [anon_sym___extension__] = ACTIONS(1458),
    [anon_sym_typedef] = ACTIONS(1458),
    [anon_sym_extern] = ACTIONS(1458),
    [anon_sym___attribute__] = ACTIONS(1458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1460),
    [anon_sym___declspec] = ACTIONS(1458),
    [anon_sym___cdecl] = ACTIONS(1458),
    [anon_sym___clrcall] = ACTIONS(1458),
    [anon_sym___stdcall] = ACTIONS(1458),
    [anon_sym___fastcall] = ACTIONS(1458),
    [anon_sym___thiscall] = ACTIONS(1458),
    [anon_sym___vectorcall] = ACTIONS(1458),
    [anon_sym_LBRACE] = ACTIONS(1460),
    [anon_sym_signed] = ACTIONS(1458),
    [anon_sym_unsigned] = ACTIONS(1458),
    [anon_sym_long] = ACTIONS(1458),
    [anon_sym_short] = ACTIONS(1458),
    [anon_sym_static] = ACTIONS(1458),
    [anon_sym_auto] = ACTIONS(1458),
    [anon_sym_register] = ACTIONS(1458),
    [anon_sym_inline] = ACTIONS(1458),
    [anon_sym___inline] = ACTIONS(1458),
    [anon_sym___inline__] = ACTIONS(1458),
    [anon_sym___forceinline] = ACTIONS(1458),
    [anon_sym_thread_local] = ACTIONS(1458),
    [anon_sym___thread] = ACTIONS(1458),
    [anon_sym_const] = ACTIONS(1458),
    [anon_sym_constexpr] = ACTIONS(1458),
    [anon_sym_volatile] = ACTIONS(1458),
    [anon_sym_restrict] = ACTIONS(1458),
    [anon_sym___restrict__] = ACTIONS(1458),
    [anon_sym__Atomic] = ACTIONS(1458),
    [anon_sym__Noreturn] = ACTIONS(1458),
    [anon_sym_noreturn] = ACTIONS(1458),
    [sym_primitive_type] = ACTIONS(1458),
    [anon_sym_enum] = ACTIONS(1458),
    [anon_sym_struct] = ACTIONS(1458),
    [anon_sym_union] = ACTIONS(1458),
    [anon_sym_if] = ACTIONS(1458),
    [anon_sym_switch] = ACTIONS(1458),
    [anon_sym_case] = ACTIONS(1458),
    [anon_sym_default] = ACTIONS(1458),
    [anon_sym_while] = ACTIONS(1458),
    [anon_sym_do] = ACTIONS(1458),
    [anon_sym_for] = ACTIONS(1458),
    [anon_sym_return] = ACTIONS(1458),
    [anon_sym_break] = ACTIONS(1458),
    [anon_sym_continue] = ACTIONS(1458),
    [anon_sym_goto] = ACTIONS(1458),
    [anon_sym___try] = ACTIONS(1458),
    [anon_sym___leave] = ACTIONS(1458),
    [anon_sym_DASH_DASH] = ACTIONS(1460),
    [anon_sym_PLUS_PLUS] = ACTIONS(1460),
    [anon_sym_sizeof] = ACTIONS(1458),
    [anon_sym___alignof__] = ACTIONS(1458),
    [anon_sym___alignof] = ACTIONS(1458),
    [anon_sym__alignof] = ACTIONS(1458),
    [anon_sym_alignof] = ACTIONS(1458),
    [anon_sym__Alignof] = ACTIONS(1458),
    [anon_sym_offsetof] = ACTIONS(1458),
    [anon_sym__Generic] = ACTIONS(1458),
    [anon_sym_asm] = ACTIONS(1458),
    [anon_sym___asm__] = ACTIONS(1458),
    [sym_number_literal] = ACTIONS(1460),
    [anon_sym_L_SQUOTE] = ACTIONS(1460),
    [anon_sym_u_SQUOTE] = ACTIONS(1460),
    [anon_sym_U_SQUOTE] = ACTIONS(1460),
    [anon_sym_u8_SQUOTE] = ACTIONS(1460),
    [anon_sym_SQUOTE] = ACTIONS(1460),
    [anon_sym_L_DQUOTE] = ACTIONS(1460),
    [anon_sym_u_DQUOTE] = ACTIONS(1460),
    [anon_sym_U_DQUOTE] = ACTIONS(1460),
    [anon_sym_u8_DQUOTE] = ACTIONS(1460),
    [anon_sym_DQUOTE] = ACTIONS(1460),
    [sym_true] = ACTIONS(1458),
    [sym_false] = ACTIONS(1458),
    [anon_sym_NULL] = ACTIONS(1458),
    [anon_sym_nullptr] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
  },
  [229] = {
    [sym_identifier] = ACTIONS(1510),
    [aux_sym_preproc_include_token1] = ACTIONS(1510),
    [aux_sym_preproc_def_token1] = ACTIONS(1510),
    [aux_sym_preproc_if_token1] = ACTIONS(1510),
    [aux_sym_preproc_if_token2] = ACTIONS(1510),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1510),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1510),
    [aux_sym_preproc_else_token1] = ACTIONS(1510),
    [aux_sym_preproc_elif_token1] = ACTIONS(1510),
    [sym_preproc_directive] = ACTIONS(1510),
    [anon_sym_LPAREN2] = ACTIONS(1512),
    [anon_sym_BANG] = ACTIONS(1512),
    [anon_sym_TILDE] = ACTIONS(1512),
    [anon_sym_DASH] = ACTIONS(1510),
    [anon_sym_PLUS] = ACTIONS(1510),
    [anon_sym_STAR] = ACTIONS(1512),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym_SEMI] = ACTIONS(1512),
    [anon_sym___extension__] = ACTIONS(1510),
    [anon_sym_typedef] = ACTIONS(1510),
    [anon_sym_extern] = ACTIONS(1510),
    [anon_sym___attribute__] = ACTIONS(1510),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1512),
    [anon_sym___declspec] = ACTIONS(1510),
    [anon_sym___cdecl] = ACTIONS(1510),
    [anon_sym___clrcall] = ACTIONS(1510),
    [anon_sym___stdcall] = ACTIONS(1510),
    [anon_sym___fastcall] = ACTIONS(1510),
    [anon_sym___thiscall] = ACTIONS(1510),
    [anon_sym___vectorcall] = ACTIONS(1510),
    [anon_sym_LBRACE] = ACTIONS(1512),
    [anon_sym_signed] = ACTIONS(1510),
    [anon_sym_unsigned] = ACTIONS(1510),
    [anon_sym_long] = ACTIONS(1510),
    [anon_sym_short] = ACTIONS(1510),
    [anon_sym_static] = ACTIONS(1510),
    [anon_sym_auto] = ACTIONS(1510),
    [anon_sym_register] = ACTIONS(1510),
    [anon_sym_inline] = ACTIONS(1510),
    [anon_sym___inline] = ACTIONS(1510),
    [anon_sym___inline__] = ACTIONS(1510),
    [anon_sym___forceinline] = ACTIONS(1510),
    [anon_sym_thread_local] = ACTIONS(1510),
    [anon_sym___thread] = ACTIONS(1510),
    [anon_sym_const] = ACTIONS(1510),
    [anon_sym_constexpr] = ACTIONS(1510),
    [anon_sym_volatile] = ACTIONS(1510),
    [anon_sym_restrict] = ACTIONS(1510),
    [anon_sym___restrict__] = ACTIONS(1510),
    [anon_sym__Atomic] = ACTIONS(1510),
    [anon_sym__Noreturn] = ACTIONS(1510),
    [anon_sym_noreturn] = ACTIONS(1510),
    [sym_primitive_type] = ACTIONS(1510),
    [anon_sym_enum] = ACTIONS(1510),
    [anon_sym_struct] = ACTIONS(1510),
    [anon_sym_union] = ACTIONS(1510),
    [anon_sym_if] = ACTIONS(1510),
    [anon_sym_switch] = ACTIONS(1510),
    [anon_sym_case] = ACTIONS(1510),
    [anon_sym_default] = ACTIONS(1510),
    [anon_sym_while] = ACTIONS(1510),
    [anon_sym_do] = ACTIONS(1510),
    [anon_sym_for] = ACTIONS(1510),
    [anon_sym_return] = ACTIONS(1510),
    [anon_sym_break] = ACTIONS(1510),
    [anon_sym_continue] = ACTIONS(1510),
    [anon_sym_goto] = ACTIONS(1510),
    [anon_sym___try] = ACTIONS(1510),
    [anon_sym___leave] = ACTIONS(1510),
    [anon_sym_DASH_DASH] = ACTIONS(1512),
    [anon_sym_PLUS_PLUS] = ACTIONS(1512),
    [anon_sym_sizeof] = ACTIONS(1510),
    [anon_sym___alignof__] = ACTIONS(1510),
    [anon_sym___alignof] = ACTIONS(1510),
    [anon_sym__alignof] = ACTIONS(1510),
    [anon_sym_alignof] = ACTIONS(1510),
    [anon_sym__Alignof] = ACTIONS(1510),
    [anon_sym_offsetof] = ACTIONS(1510),
    [anon_sym__Generic] = ACTIONS(1510),
    [anon_sym_asm] = ACTIONS(1510),
    [anon_sym___asm__] = ACTIONS(1510),
    [sym_number_literal] = ACTIONS(1512),
    [anon_sym_L_SQUOTE] = ACTIONS(1512),
    [anon_sym_u_SQUOTE] = ACTIONS(1512),
    [anon_sym_U_SQUOTE] = ACTIONS(1512),
    [anon_sym_u8_SQUOTE] = ACTIONS(1512),
    [anon_sym_SQUOTE] = ACTIONS(1512),
    [anon_sym_L_DQUOTE] = ACTIONS(1512),
    [anon_sym_u_DQUOTE] = ACTIONS(1512),
    [anon_sym_U_DQUOTE] = ACTIONS(1512),
    [anon_sym_u8_DQUOTE] = ACTIONS(1512),
    [anon_sym_DQUOTE] = ACTIONS(1512),
    [sym_true] = ACTIONS(1510),
    [sym_false] = ACTIONS(1510),
    [anon_sym_NULL] = ACTIONS(1510),
    [anon_sym_nullptr] = ACTIONS(1510),
    [sym_comment] = ACTIONS(3),
  },
  [230] = {
    [sym_else_clause] = STATE(325),
    [ts_builtin_sym_end] = ACTIONS(1294),
    [sym_identifier] = ACTIONS(1292),
    [aux_sym_preproc_include_token1] = ACTIONS(1292),
    [aux_sym_preproc_def_token1] = ACTIONS(1292),
    [aux_sym_preproc_if_token1] = ACTIONS(1292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1292),
    [sym_preproc_directive] = ACTIONS(1292),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1294),
    [anon_sym_TILDE] = ACTIONS(1294),
    [anon_sym_DASH] = ACTIONS(1292),
    [anon_sym_PLUS] = ACTIONS(1292),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_SEMI] = ACTIONS(1294),
    [anon_sym___extension__] = ACTIONS(1292),
    [anon_sym_typedef] = ACTIONS(1292),
    [anon_sym_extern] = ACTIONS(1292),
    [anon_sym___attribute__] = ACTIONS(1292),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1294),
    [anon_sym___declspec] = ACTIONS(1292),
    [anon_sym___cdecl] = ACTIONS(1292),
    [anon_sym___clrcall] = ACTIONS(1292),
    [anon_sym___stdcall] = ACTIONS(1292),
    [anon_sym___fastcall] = ACTIONS(1292),
    [anon_sym___thiscall] = ACTIONS(1292),
    [anon_sym___vectorcall] = ACTIONS(1292),
    [anon_sym_LBRACE] = ACTIONS(1294),
    [anon_sym_signed] = ACTIONS(1292),
    [anon_sym_unsigned] = ACTIONS(1292),
    [anon_sym_long] = ACTIONS(1292),
    [anon_sym_short] = ACTIONS(1292),
    [anon_sym_static] = ACTIONS(1292),
    [anon_sym_auto] = ACTIONS(1292),
    [anon_sym_register] = ACTIONS(1292),
    [anon_sym_inline] = ACTIONS(1292),
    [anon_sym___inline] = ACTIONS(1292),
    [anon_sym___inline__] = ACTIONS(1292),
    [anon_sym___forceinline] = ACTIONS(1292),
    [anon_sym_thread_local] = ACTIONS(1292),
    [anon_sym___thread] = ACTIONS(1292),
    [anon_sym_const] = ACTIONS(1292),
    [anon_sym_constexpr] = ACTIONS(1292),
    [anon_sym_volatile] = ACTIONS(1292),
    [anon_sym_restrict] = ACTIONS(1292),
    [anon_sym___restrict__] = ACTIONS(1292),
    [anon_sym__Atomic] = ACTIONS(1292),
    [anon_sym__Noreturn] = ACTIONS(1292),
    [anon_sym_noreturn] = ACTIONS(1292),
    [sym_primitive_type] = ACTIONS(1292),
    [anon_sym_enum] = ACTIONS(1292),
    [anon_sym_struct] = ACTIONS(1292),
    [anon_sym_union] = ACTIONS(1292),
    [anon_sym_if] = ACTIONS(1292),
    [anon_sym_else] = ACTIONS(1536),
    [anon_sym_switch] = ACTIONS(1292),
    [anon_sym_case] = ACTIONS(1292),
    [anon_sym_default] = ACTIONS(1292),
    [anon_sym_while] = ACTIONS(1292),
    [anon_sym_do] = ACTIONS(1292),
    [anon_sym_for] = ACTIONS(1292),
    [anon_sym_return] = ACTIONS(1292),
    [anon_sym_break] = ACTIONS(1292),
    [anon_sym_continue] = ACTIONS(1292),
    [anon_sym_goto] = ACTIONS(1292),
    [anon_sym___try] = ACTIONS(1292),
    [anon_sym___leave] = ACTIONS(1292),
    [anon_sym_DASH_DASH] = ACTIONS(1294),
    [anon_sym_PLUS_PLUS] = ACTIONS(1294),
    [anon_sym_sizeof] = ACTIONS(1292),
    [anon_sym___alignof__] = ACTIONS(1292),
    [anon_sym___alignof] = ACTIONS(1292),
    [anon_sym__alignof] = ACTIONS(1292),
    [anon_sym_alignof] = ACTIONS(1292),
    [anon_sym__Alignof] = ACTIONS(1292),
    [anon_sym_offsetof] = ACTIONS(1292),
    [anon_sym__Generic] = ACTIONS(1292),
    [anon_sym_asm] = ACTIONS(1292),
    [anon_sym___asm__] = ACTIONS(1292),
    [sym_number_literal] = ACTIONS(1294),
    [anon_sym_L_SQUOTE] = ACTIONS(1294),
    [anon_sym_u_SQUOTE] = ACTIONS(1294),
    [anon_sym_U_SQUOTE] = ACTIONS(1294),
    [anon_sym_u8_SQUOTE] = ACTIONS(1294),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_L_DQUOTE] = ACTIONS(1294),
    [anon_sym_u_DQUOTE] = ACTIONS(1294),
    [anon_sym_U_DQUOTE] = ACTIONS(1294),
    [anon_sym_u8_DQUOTE] = ACTIONS(1294),
    [anon_sym_DQUOTE] = ACTIONS(1294),
    [sym_true] = ACTIONS(1292),
    [sym_false] = ACTIONS(1292),
    [anon_sym_NULL] = ACTIONS(1292),
    [anon_sym_nullptr] = ACTIONS(1292),
    [sym_comment] = ACTIONS(3),
  },
  [231] = {
    [sym_identifier] = ACTIONS(1438),
    [aux_sym_preproc_include_token1] = ACTIONS(1438),
    [aux_sym_preproc_def_token1] = ACTIONS(1438),
    [aux_sym_preproc_if_token1] = ACTIONS(1438),
    [aux_sym_preproc_if_token2] = ACTIONS(1438),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1438),
    [aux_sym_preproc_else_token1] = ACTIONS(1438),
    [aux_sym_preproc_elif_token1] = ACTIONS(1438),
    [sym_preproc_directive] = ACTIONS(1438),
    [anon_sym_LPAREN2] = ACTIONS(1440),
    [anon_sym_BANG] = ACTIONS(1440),
    [anon_sym_TILDE] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1438),
    [anon_sym_PLUS] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_SEMI] = ACTIONS(1440),
    [anon_sym___extension__] = ACTIONS(1438),
    [anon_sym_typedef] = ACTIONS(1438),
    [anon_sym_extern] = ACTIONS(1438),
    [anon_sym___attribute__] = ACTIONS(1438),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1440),
    [anon_sym___declspec] = ACTIONS(1438),
    [anon_sym___cdecl] = ACTIONS(1438),
    [anon_sym___clrcall] = ACTIONS(1438),
    [anon_sym___stdcall] = ACTIONS(1438),
    [anon_sym___fastcall] = ACTIONS(1438),
    [anon_sym___thiscall] = ACTIONS(1438),
    [anon_sym___vectorcall] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(1440),
    [anon_sym_signed] = ACTIONS(1438),
    [anon_sym_unsigned] = ACTIONS(1438),
    [anon_sym_long] = ACTIONS(1438),
    [anon_sym_short] = ACTIONS(1438),
    [anon_sym_static] = ACTIONS(1438),
    [anon_sym_auto] = ACTIONS(1438),
    [anon_sym_register] = ACTIONS(1438),
    [anon_sym_inline] = ACTIONS(1438),
    [anon_sym___inline] = ACTIONS(1438),
    [anon_sym___inline__] = ACTIONS(1438),
    [anon_sym___forceinline] = ACTIONS(1438),
    [anon_sym_thread_local] = ACTIONS(1438),
    [anon_sym___thread] = ACTIONS(1438),
    [anon_sym_const] = ACTIONS(1438),
    [anon_sym_constexpr] = ACTIONS(1438),
    [anon_sym_volatile] = ACTIONS(1438),
    [anon_sym_restrict] = ACTIONS(1438),
    [anon_sym___restrict__] = ACTIONS(1438),
    [anon_sym__Atomic] = ACTIONS(1438),
    [anon_sym__Noreturn] = ACTIONS(1438),
    [anon_sym_noreturn] = ACTIONS(1438),
    [sym_primitive_type] = ACTIONS(1438),
    [anon_sym_enum] = ACTIONS(1438),
    [anon_sym_struct] = ACTIONS(1438),
    [anon_sym_union] = ACTIONS(1438),
    [anon_sym_if] = ACTIONS(1438),
    [anon_sym_switch] = ACTIONS(1438),
    [anon_sym_case] = ACTIONS(1438),
    [anon_sym_default] = ACTIONS(1438),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_do] = ACTIONS(1438),
    [anon_sym_for] = ACTIONS(1438),
    [anon_sym_return] = ACTIONS(1438),
    [anon_sym_break] = ACTIONS(1438),
    [anon_sym_continue] = ACTIONS(1438),
    [anon_sym_goto] = ACTIONS(1438),
    [anon_sym___try] = ACTIONS(1438),
    [anon_sym___leave] = ACTIONS(1438),
    [anon_sym_DASH_DASH] = ACTIONS(1440),
    [anon_sym_PLUS_PLUS] = ACTIONS(1440),
    [anon_sym_sizeof] = ACTIONS(1438),
    [anon_sym___alignof__] = ACTIONS(1438),
    [anon_sym___alignof] = ACTIONS(1438),
    [anon_sym__alignof] = ACTIONS(1438),
    [anon_sym_alignof] = ACTIONS(1438),
    [anon_sym__Alignof] = ACTIONS(1438),
    [anon_sym_offsetof] = ACTIONS(1438),
    [anon_sym__Generic] = ACTIONS(1438),
    [anon_sym_asm] = ACTIONS(1438),
    [anon_sym___asm__] = ACTIONS(1438),
    [sym_number_literal] = ACTIONS(1440),
    [anon_sym_L_SQUOTE] = ACTIONS(1440),
    [anon_sym_u_SQUOTE] = ACTIONS(1440),
    [anon_sym_U_SQUOTE] = ACTIONS(1440),
    [anon_sym_u8_SQUOTE] = ACTIONS(1440),
    [anon_sym_SQUOTE] = ACTIONS(1440),
    [anon_sym_L_DQUOTE] = ACTIONS(1440),
    [anon_sym_u_DQUOTE] = ACTIONS(1440),
    [anon_sym_U_DQUOTE] = ACTIONS(1440),
    [anon_sym_u8_DQUOTE] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [sym_true] = ACTIONS(1438),
    [sym_false] = ACTIONS(1438),
    [anon_sym_NULL] = ACTIONS(1438),
    [anon_sym_nullptr] = ACTIONS(1438),
    [sym_comment] = ACTIONS(3),
  },
  [232] = {
    [sym_identifier] = ACTIONS(1526),
    [aux_sym_preproc_include_token1] = ACTIONS(1526),
    [aux_sym_preproc_def_token1] = ACTIONS(1526),
    [aux_sym_preproc_if_token1] = ACTIONS(1526),
    [aux_sym_preproc_if_token2] = ACTIONS(1526),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1526),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1526),
    [aux_sym_preproc_else_token1] = ACTIONS(1526),
    [aux_sym_preproc_elif_token1] = ACTIONS(1526),
    [sym_preproc_directive] = ACTIONS(1526),
    [anon_sym_LPAREN2] = ACTIONS(1528),
    [anon_sym_BANG] = ACTIONS(1528),
    [anon_sym_TILDE] = ACTIONS(1528),
    [anon_sym_DASH] = ACTIONS(1526),
    [anon_sym_PLUS] = ACTIONS(1526),
    [anon_sym_STAR] = ACTIONS(1528),
    [anon_sym_AMP] = ACTIONS(1528),
    [anon_sym_SEMI] = ACTIONS(1528),
    [anon_sym___extension__] = ACTIONS(1526),
    [anon_sym_typedef] = ACTIONS(1526),
    [anon_sym_extern] = ACTIONS(1526),
    [anon_sym___attribute__] = ACTIONS(1526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1528),
    [anon_sym___declspec] = ACTIONS(1526),
    [anon_sym___cdecl] = ACTIONS(1526),
    [anon_sym___clrcall] = ACTIONS(1526),
    [anon_sym___stdcall] = ACTIONS(1526),
    [anon_sym___fastcall] = ACTIONS(1526),
    [anon_sym___thiscall] = ACTIONS(1526),
    [anon_sym___vectorcall] = ACTIONS(1526),
    [anon_sym_LBRACE] = ACTIONS(1528),
    [anon_sym_signed] = ACTIONS(1526),
    [anon_sym_unsigned] = ACTIONS(1526),
    [anon_sym_long] = ACTIONS(1526),
    [anon_sym_short] = ACTIONS(1526),
    [anon_sym_static] = ACTIONS(1526),
    [anon_sym_auto] = ACTIONS(1526),
    [anon_sym_register] = ACTIONS(1526),
    [anon_sym_inline] = ACTIONS(1526),
    [anon_sym___inline] = ACTIONS(1526),
    [anon_sym___inline__] = ACTIONS(1526),
    [anon_sym___forceinline] = ACTIONS(1526),
    [anon_sym_thread_local] = ACTIONS(1526),
    [anon_sym___thread] = ACTIONS(1526),
    [anon_sym_const] = ACTIONS(1526),
    [anon_sym_constexpr] = ACTIONS(1526),
    [anon_sym_volatile] = ACTIONS(1526),
    [anon_sym_restrict] = ACTIONS(1526),
    [anon_sym___restrict__] = ACTIONS(1526),
    [anon_sym__Atomic] = ACTIONS(1526),
    [anon_sym__Noreturn] = ACTIONS(1526),
    [anon_sym_noreturn] = ACTIONS(1526),
    [sym_primitive_type] = ACTIONS(1526),
    [anon_sym_enum] = ACTIONS(1526),
    [anon_sym_struct] = ACTIONS(1526),
    [anon_sym_union] = ACTIONS(1526),
    [anon_sym_if] = ACTIONS(1526),
    [anon_sym_switch] = ACTIONS(1526),
    [anon_sym_case] = ACTIONS(1526),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1526),
    [anon_sym_do] = ACTIONS(1526),
    [anon_sym_for] = ACTIONS(1526),
    [anon_sym_return] = ACTIONS(1526),
    [anon_sym_break] = ACTIONS(1526),
    [anon_sym_continue] = ACTIONS(1526),
    [anon_sym_goto] = ACTIONS(1526),
    [anon_sym___try] = ACTIONS(1526),
    [anon_sym___leave] = ACTIONS(1526),
    [anon_sym_DASH_DASH] = ACTIONS(1528),
    [anon_sym_PLUS_PLUS] = ACTIONS(1528),
    [anon_sym_sizeof] = ACTIONS(1526),
    [anon_sym___alignof__] = ACTIONS(1526),
    [anon_sym___alignof] = ACTIONS(1526),
    [anon_sym__alignof] = ACTIONS(1526),
    [anon_sym_alignof] = ACTIONS(1526),
    [anon_sym__Alignof] = ACTIONS(1526),
    [anon_sym_offsetof] = ACTIONS(1526),
    [anon_sym__Generic] = ACTIONS(1526),
    [anon_sym_asm] = ACTIONS(1526),
    [anon_sym___asm__] = ACTIONS(1526),
    [sym_number_literal] = ACTIONS(1528),
    [anon_sym_L_SQUOTE] = ACTIONS(1528),
    [anon_sym_u_SQUOTE] = ACTIONS(1528),
    [anon_sym_U_SQUOTE] = ACTIONS(1528),
    [anon_sym_u8_SQUOTE] = ACTIONS(1528),
    [anon_sym_SQUOTE] = ACTIONS(1528),
    [anon_sym_L_DQUOTE] = ACTIONS(1528),
    [anon_sym_u_DQUOTE] = ACTIONS(1528),
    [anon_sym_U_DQUOTE] = ACTIONS(1528),
    [anon_sym_u8_DQUOTE] = ACTIONS(1528),
    [anon_sym_DQUOTE] = ACTIONS(1528),
    [sym_true] = ACTIONS(1526),
    [sym_false] = ACTIONS(1526),
    [anon_sym_NULL] = ACTIONS(1526),
    [anon_sym_nullptr] = ACTIONS(1526),
    [sym_comment] = ACTIONS(3),
  },
  [233] = {
    [sym_identifier] = ACTIONS(1506),
    [aux_sym_preproc_include_token1] = ACTIONS(1506),
    [aux_sym_preproc_def_token1] = ACTIONS(1506),
    [aux_sym_preproc_if_token1] = ACTIONS(1506),
    [aux_sym_preproc_if_token2] = ACTIONS(1506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1506),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1506),
    [aux_sym_preproc_else_token1] = ACTIONS(1506),
    [aux_sym_preproc_elif_token1] = ACTIONS(1506),
    [sym_preproc_directive] = ACTIONS(1506),
    [anon_sym_LPAREN2] = ACTIONS(1508),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_TILDE] = ACTIONS(1508),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_typedef] = ACTIONS(1506),
    [anon_sym_extern] = ACTIONS(1506),
    [anon_sym___attribute__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym___declspec] = ACTIONS(1506),
    [anon_sym___cdecl] = ACTIONS(1506),
    [anon_sym___clrcall] = ACTIONS(1506),
    [anon_sym___stdcall] = ACTIONS(1506),
    [anon_sym___fastcall] = ACTIONS(1506),
    [anon_sym___thiscall] = ACTIONS(1506),
    [anon_sym___vectorcall] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1508),
    [anon_sym_signed] = ACTIONS(1506),
    [anon_sym_unsigned] = ACTIONS(1506),
    [anon_sym_long] = ACTIONS(1506),
    [anon_sym_short] = ACTIONS(1506),
    [anon_sym_static] = ACTIONS(1506),
    [anon_sym_auto] = ACTIONS(1506),
    [anon_sym_register] = ACTIONS(1506),
    [anon_sym_inline] = ACTIONS(1506),
    [anon_sym___inline] = ACTIONS(1506),
    [anon_sym___inline__] = ACTIONS(1506),
    [anon_sym___forceinline] = ACTIONS(1506),
    [anon_sym_thread_local] = ACTIONS(1506),
    [anon_sym___thread] = ACTIONS(1506),
    [anon_sym_const] = ACTIONS(1506),
    [anon_sym_constexpr] = ACTIONS(1506),
    [anon_sym_volatile] = ACTIONS(1506),
    [anon_sym_restrict] = ACTIONS(1506),
    [anon_sym___restrict__] = ACTIONS(1506),
    [anon_sym__Atomic] = ACTIONS(1506),
    [anon_sym__Noreturn] = ACTIONS(1506),
    [anon_sym_noreturn] = ACTIONS(1506),
    [sym_primitive_type] = ACTIONS(1506),
    [anon_sym_enum] = ACTIONS(1506),
    [anon_sym_struct] = ACTIONS(1506),
    [anon_sym_union] = ACTIONS(1506),
    [anon_sym_if] = ACTIONS(1506),
    [anon_sym_switch] = ACTIONS(1506),
    [anon_sym_case] = ACTIONS(1506),
    [anon_sym_default] = ACTIONS(1506),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_do] = ACTIONS(1506),
    [anon_sym_for] = ACTIONS(1506),
    [anon_sym_return] = ACTIONS(1506),
    [anon_sym_break] = ACTIONS(1506),
    [anon_sym_continue] = ACTIONS(1506),
    [anon_sym_goto] = ACTIONS(1506),
    [anon_sym___try] = ACTIONS(1506),
    [anon_sym___leave] = ACTIONS(1506),
    [anon_sym_DASH_DASH] = ACTIONS(1508),
    [anon_sym_PLUS_PLUS] = ACTIONS(1508),
    [anon_sym_sizeof] = ACTIONS(1506),
    [anon_sym___alignof__] = ACTIONS(1506),
    [anon_sym___alignof] = ACTIONS(1506),
    [anon_sym__alignof] = ACTIONS(1506),
    [anon_sym_alignof] = ACTIONS(1506),
    [anon_sym__Alignof] = ACTIONS(1506),
    [anon_sym_offsetof] = ACTIONS(1506),
    [anon_sym__Generic] = ACTIONS(1506),
    [anon_sym_asm] = ACTIONS(1506),
    [anon_sym___asm__] = ACTIONS(1506),
    [sym_number_literal] = ACTIONS(1508),
    [anon_sym_L_SQUOTE] = ACTIONS(1508),
    [anon_sym_u_SQUOTE] = ACTIONS(1508),
    [anon_sym_U_SQUOTE] = ACTIONS(1508),
    [anon_sym_u8_SQUOTE] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1508),
    [anon_sym_L_DQUOTE] = ACTIONS(1508),
    [anon_sym_u_DQUOTE] = ACTIONS(1508),
    [anon_sym_U_DQUOTE] = ACTIONS(1508),
    [anon_sym_u8_DQUOTE] = ACTIONS(1508),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_true] = ACTIONS(1506),
    [sym_false] = ACTIONS(1506),
    [anon_sym_NULL] = ACTIONS(1506),
    [anon_sym_nullptr] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
  },
  [234] = {
    [sym_identifier] = ACTIONS(1494),
    [aux_sym_preproc_include_token1] = ACTIONS(1494),
    [aux_sym_preproc_def_token1] = ACTIONS(1494),
    [aux_sym_preproc_if_token1] = ACTIONS(1494),
    [aux_sym_preproc_if_token2] = ACTIONS(1494),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1494),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1494),
    [aux_sym_preproc_else_token1] = ACTIONS(1494),
    [aux_sym_preproc_elif_token1] = ACTIONS(1494),
    [sym_preproc_directive] = ACTIONS(1494),
    [anon_sym_LPAREN2] = ACTIONS(1496),
    [anon_sym_BANG] = ACTIONS(1496),
    [anon_sym_TILDE] = ACTIONS(1496),
    [anon_sym_DASH] = ACTIONS(1494),
    [anon_sym_PLUS] = ACTIONS(1494),
    [anon_sym_STAR] = ACTIONS(1496),
    [anon_sym_AMP] = ACTIONS(1496),
    [anon_sym_SEMI] = ACTIONS(1496),
    [anon_sym___extension__] = ACTIONS(1494),
    [anon_sym_typedef] = ACTIONS(1494),
    [anon_sym_extern] = ACTIONS(1494),
    [anon_sym___attribute__] = ACTIONS(1494),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1496),
    [anon_sym___declspec] = ACTIONS(1494),
    [anon_sym___cdecl] = ACTIONS(1494),
    [anon_sym___clrcall] = ACTIONS(1494),
    [anon_sym___stdcall] = ACTIONS(1494),
    [anon_sym___fastcall] = ACTIONS(1494),
    [anon_sym___thiscall] = ACTIONS(1494),
    [anon_sym___vectorcall] = ACTIONS(1494),
    [anon_sym_LBRACE] = ACTIONS(1496),
    [anon_sym_signed] = ACTIONS(1494),
    [anon_sym_unsigned] = ACTIONS(1494),
    [anon_sym_long] = ACTIONS(1494),
    [anon_sym_short] = ACTIONS(1494),
    [anon_sym_static] = ACTIONS(1494),
    [anon_sym_auto] = ACTIONS(1494),
    [anon_sym_register] = ACTIONS(1494),
    [anon_sym_inline] = ACTIONS(1494),
    [anon_sym___inline] = ACTIONS(1494),
    [anon_sym___inline__] = ACTIONS(1494),
    [anon_sym___forceinline] = ACTIONS(1494),
    [anon_sym_thread_local] = ACTIONS(1494),
    [anon_sym___thread] = ACTIONS(1494),
    [anon_sym_const] = ACTIONS(1494),
    [anon_sym_constexpr] = ACTIONS(1494),
    [anon_sym_volatile] = ACTIONS(1494),
    [anon_sym_restrict] = ACTIONS(1494),
    [anon_sym___restrict__] = ACTIONS(1494),
    [anon_sym__Atomic] = ACTIONS(1494),
    [anon_sym__Noreturn] = ACTIONS(1494),
    [anon_sym_noreturn] = ACTIONS(1494),
    [sym_primitive_type] = ACTIONS(1494),
    [anon_sym_enum] = ACTIONS(1494),
    [anon_sym_struct] = ACTIONS(1494),
    [anon_sym_union] = ACTIONS(1494),
    [anon_sym_if] = ACTIONS(1494),
    [anon_sym_switch] = ACTIONS(1494),
    [anon_sym_case] = ACTIONS(1494),
    [anon_sym_default] = ACTIONS(1494),
    [anon_sym_while] = ACTIONS(1494),
    [anon_sym_do] = ACTIONS(1494),
    [anon_sym_for] = ACTIONS(1494),
    [anon_sym_return] = ACTIONS(1494),
    [anon_sym_break] = ACTIONS(1494),
    [anon_sym_continue] = ACTIONS(1494),
    [anon_sym_goto] = ACTIONS(1494),
    [anon_sym___try] = ACTIONS(1494),
    [anon_sym___leave] = ACTIONS(1494),
    [anon_sym_DASH_DASH] = ACTIONS(1496),
    [anon_sym_PLUS_PLUS] = ACTIONS(1496),
    [anon_sym_sizeof] = ACTIONS(1494),
    [anon_sym___alignof__] = ACTIONS(1494),
    [anon_sym___alignof] = ACTIONS(1494),
    [anon_sym__alignof] = ACTIONS(1494),
    [anon_sym_alignof] = ACTIONS(1494),
    [anon_sym__Alignof] = ACTIONS(1494),
    [anon_sym_offsetof] = ACTIONS(1494),
    [anon_sym__Generic] = ACTIONS(1494),
    [anon_sym_asm] = ACTIONS(1494),
    [anon_sym___asm__] = ACTIONS(1494),
    [sym_number_literal] = ACTIONS(1496),
    [anon_sym_L_SQUOTE] = ACTIONS(1496),
    [anon_sym_u_SQUOTE] = ACTIONS(1496),
    [anon_sym_U_SQUOTE] = ACTIONS(1496),
    [anon_sym_u8_SQUOTE] = ACTIONS(1496),
    [anon_sym_SQUOTE] = ACTIONS(1496),
    [anon_sym_L_DQUOTE] = ACTIONS(1496),
    [anon_sym_u_DQUOTE] = ACTIONS(1496),
    [anon_sym_U_DQUOTE] = ACTIONS(1496),
    [anon_sym_u8_DQUOTE] = ACTIONS(1496),
    [anon_sym_DQUOTE] = ACTIONS(1496),
    [sym_true] = ACTIONS(1494),
    [sym_false] = ACTIONS(1494),
    [anon_sym_NULL] = ACTIONS(1494),
    [anon_sym_nullptr] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
  },
  [235] = {
    [sym_identifier] = ACTIONS(1446),
    [aux_sym_preproc_include_token1] = ACTIONS(1446),
    [aux_sym_preproc_def_token1] = ACTIONS(1446),
    [aux_sym_preproc_if_token1] = ACTIONS(1446),
    [aux_sym_preproc_if_token2] = ACTIONS(1446),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1446),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1446),
    [aux_sym_preproc_else_token1] = ACTIONS(1446),
    [aux_sym_preproc_elif_token1] = ACTIONS(1446),
    [sym_preproc_directive] = ACTIONS(1446),
    [anon_sym_LPAREN2] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1446),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym___extension__] = ACTIONS(1446),
    [anon_sym_typedef] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(1446),
    [anon_sym___attribute__] = ACTIONS(1446),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(1446),
    [anon_sym___cdecl] = ACTIONS(1446),
    [anon_sym___clrcall] = ACTIONS(1446),
    [anon_sym___stdcall] = ACTIONS(1446),
    [anon_sym___fastcall] = ACTIONS(1446),
    [anon_sym___thiscall] = ACTIONS(1446),
    [anon_sym___vectorcall] = ACTIONS(1446),
    [anon_sym_LBRACE] = ACTIONS(1448),
    [anon_sym_signed] = ACTIONS(1446),
    [anon_sym_unsigned] = ACTIONS(1446),
    [anon_sym_long] = ACTIONS(1446),
    [anon_sym_short] = ACTIONS(1446),
    [anon_sym_static] = ACTIONS(1446),
    [anon_sym_auto] = ACTIONS(1446),
    [anon_sym_register] = ACTIONS(1446),
    [anon_sym_inline] = ACTIONS(1446),
    [anon_sym___inline] = ACTIONS(1446),
    [anon_sym___inline__] = ACTIONS(1446),
    [anon_sym___forceinline] = ACTIONS(1446),
    [anon_sym_thread_local] = ACTIONS(1446),
    [anon_sym___thread] = ACTIONS(1446),
    [anon_sym_const] = ACTIONS(1446),
    [anon_sym_constexpr] = ACTIONS(1446),
    [anon_sym_volatile] = ACTIONS(1446),
    [anon_sym_restrict] = ACTIONS(1446),
    [anon_sym___restrict__] = ACTIONS(1446),
    [anon_sym__Atomic] = ACTIONS(1446),
    [anon_sym__Noreturn] = ACTIONS(1446),
    [anon_sym_noreturn] = ACTIONS(1446),
    [sym_primitive_type] = ACTIONS(1446),
    [anon_sym_enum] = ACTIONS(1446),
    [anon_sym_struct] = ACTIONS(1446),
    [anon_sym_union] = ACTIONS(1446),
    [anon_sym_if] = ACTIONS(1446),
    [anon_sym_switch] = ACTIONS(1446),
    [anon_sym_case] = ACTIONS(1446),
    [anon_sym_default] = ACTIONS(1446),
    [anon_sym_while] = ACTIONS(1446),
    [anon_sym_do] = ACTIONS(1446),
    [anon_sym_for] = ACTIONS(1446),
    [anon_sym_return] = ACTIONS(1446),
    [anon_sym_break] = ACTIONS(1446),
    [anon_sym_continue] = ACTIONS(1446),
    [anon_sym_goto] = ACTIONS(1446),
    [anon_sym___try] = ACTIONS(1446),
    [anon_sym___leave] = ACTIONS(1446),
    [anon_sym_DASH_DASH] = ACTIONS(1448),
    [anon_sym_PLUS_PLUS] = ACTIONS(1448),
    [anon_sym_sizeof] = ACTIONS(1446),
    [anon_sym___alignof__] = ACTIONS(1446),
    [anon_sym___alignof] = ACTIONS(1446),
    [anon_sym__alignof] = ACTIONS(1446),
    [anon_sym_alignof] = ACTIONS(1446),
    [anon_sym__Alignof] = ACTIONS(1446),
    [anon_sym_offsetof] = ACTIONS(1446),
    [anon_sym__Generic] = ACTIONS(1446),
    [anon_sym_asm] = ACTIONS(1446),
    [anon_sym___asm__] = ACTIONS(1446),
    [sym_number_literal] = ACTIONS(1448),
    [anon_sym_L_SQUOTE] = ACTIONS(1448),
    [anon_sym_u_SQUOTE] = ACTIONS(1448),
    [anon_sym_U_SQUOTE] = ACTIONS(1448),
    [anon_sym_u8_SQUOTE] = ACTIONS(1448),
    [anon_sym_SQUOTE] = ACTIONS(1448),
    [anon_sym_L_DQUOTE] = ACTIONS(1448),
    [anon_sym_u_DQUOTE] = ACTIONS(1448),
    [anon_sym_U_DQUOTE] = ACTIONS(1448),
    [anon_sym_u8_DQUOTE] = ACTIONS(1448),
    [anon_sym_DQUOTE] = ACTIONS(1448),
    [sym_true] = ACTIONS(1446),
    [sym_false] = ACTIONS(1446),
    [anon_sym_NULL] = ACTIONS(1446),
    [anon_sym_nullptr] = ACTIONS(1446),
    [sym_comment] = ACTIONS(3),
  },
  [236] = {
    [sym_identifier] = ACTIONS(1474),
    [aux_sym_preproc_include_token1] = ACTIONS(1474),
    [aux_sym_preproc_def_token1] = ACTIONS(1474),
    [aux_sym_preproc_if_token1] = ACTIONS(1474),
    [aux_sym_preproc_if_token2] = ACTIONS(1474),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1474),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1474),
    [aux_sym_preproc_else_token1] = ACTIONS(1474),
    [aux_sym_preproc_elif_token1] = ACTIONS(1474),
    [sym_preproc_directive] = ACTIONS(1474),
    [anon_sym_LPAREN2] = ACTIONS(1476),
    [anon_sym_BANG] = ACTIONS(1476),
    [anon_sym_TILDE] = ACTIONS(1476),
    [anon_sym_DASH] = ACTIONS(1474),
    [anon_sym_PLUS] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_SEMI] = ACTIONS(1476),
    [anon_sym___extension__] = ACTIONS(1474),
    [anon_sym_typedef] = ACTIONS(1474),
    [anon_sym_extern] = ACTIONS(1474),
    [anon_sym___attribute__] = ACTIONS(1474),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1476),
    [anon_sym___declspec] = ACTIONS(1474),
    [anon_sym___cdecl] = ACTIONS(1474),
    [anon_sym___clrcall] = ACTIONS(1474),
    [anon_sym___stdcall] = ACTIONS(1474),
    [anon_sym___fastcall] = ACTIONS(1474),
    [anon_sym___thiscall] = ACTIONS(1474),
    [anon_sym___vectorcall] = ACTIONS(1474),
    [anon_sym_LBRACE] = ACTIONS(1476),
    [anon_sym_signed] = ACTIONS(1474),
    [anon_sym_unsigned] = ACTIONS(1474),
    [anon_sym_long] = ACTIONS(1474),
    [anon_sym_short] = ACTIONS(1474),
    [anon_sym_static] = ACTIONS(1474),
    [anon_sym_auto] = ACTIONS(1474),
    [anon_sym_register] = ACTIONS(1474),
    [anon_sym_inline] = ACTIONS(1474),
    [anon_sym___inline] = ACTIONS(1474),
    [anon_sym___inline__] = ACTIONS(1474),
    [anon_sym___forceinline] = ACTIONS(1474),
    [anon_sym_thread_local] = ACTIONS(1474),
    [anon_sym___thread] = ACTIONS(1474),
    [anon_sym_const] = ACTIONS(1474),
    [anon_sym_constexpr] = ACTIONS(1474),
    [anon_sym_volatile] = ACTIONS(1474),
    [anon_sym_restrict] = ACTIONS(1474),
    [anon_sym___restrict__] = ACTIONS(1474),
    [anon_sym__Atomic] = ACTIONS(1474),
    [anon_sym__Noreturn] = ACTIONS(1474),
    [anon_sym_noreturn] = ACTIONS(1474),
    [sym_primitive_type] = ACTIONS(1474),
    [anon_sym_enum] = ACTIONS(1474),
    [anon_sym_struct] = ACTIONS(1474),
    [anon_sym_union] = ACTIONS(1474),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_switch] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1474),
    [anon_sym_default] = ACTIONS(1474),
    [anon_sym_while] = ACTIONS(1474),
    [anon_sym_do] = ACTIONS(1474),
    [anon_sym_for] = ACTIONS(1474),
    [anon_sym_return] = ACTIONS(1474),
    [anon_sym_break] = ACTIONS(1474),
    [anon_sym_continue] = ACTIONS(1474),
    [anon_sym_goto] = ACTIONS(1474),
    [anon_sym___try] = ACTIONS(1474),
    [anon_sym___leave] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1476),
    [anon_sym_PLUS_PLUS] = ACTIONS(1476),
    [anon_sym_sizeof] = ACTIONS(1474),
    [anon_sym___alignof__] = ACTIONS(1474),
    [anon_sym___alignof] = ACTIONS(1474),
    [anon_sym__alignof] = ACTIONS(1474),
    [anon_sym_alignof] = ACTIONS(1474),
    [anon_sym__Alignof] = ACTIONS(1474),
    [anon_sym_offsetof] = ACTIONS(1474),
    [anon_sym__Generic] = ACTIONS(1474),
    [anon_sym_asm] = ACTIONS(1474),
    [anon_sym___asm__] = ACTIONS(1474),
    [sym_number_literal] = ACTIONS(1476),
    [anon_sym_L_SQUOTE] = ACTIONS(1476),
    [anon_sym_u_SQUOTE] = ACTIONS(1476),
    [anon_sym_U_SQUOTE] = ACTIONS(1476),
    [anon_sym_u8_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1476),
    [anon_sym_L_DQUOTE] = ACTIONS(1476),
    [anon_sym_u_DQUOTE] = ACTIONS(1476),
    [anon_sym_U_DQUOTE] = ACTIONS(1476),
    [anon_sym_u8_DQUOTE] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [sym_true] = ACTIONS(1474),
    [sym_false] = ACTIONS(1474),
    [anon_sym_NULL] = ACTIONS(1474),
    [anon_sym_nullptr] = ACTIONS(1474),
    [sym_comment] = ACTIONS(3),
  },
  [237] = {
    [sym_identifier] = ACTIONS(1490),
    [aux_sym_preproc_include_token1] = ACTIONS(1490),
    [aux_sym_preproc_def_token1] = ACTIONS(1490),
    [aux_sym_preproc_if_token1] = ACTIONS(1490),
    [aux_sym_preproc_if_token2] = ACTIONS(1490),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1490),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1490),
    [aux_sym_preproc_else_token1] = ACTIONS(1490),
    [aux_sym_preproc_elif_token1] = ACTIONS(1490),
    [sym_preproc_directive] = ACTIONS(1490),
    [anon_sym_LPAREN2] = ACTIONS(1492),
    [anon_sym_BANG] = ACTIONS(1492),
    [anon_sym_TILDE] = ACTIONS(1492),
    [anon_sym_DASH] = ACTIONS(1490),
    [anon_sym_PLUS] = ACTIONS(1490),
    [anon_sym_STAR] = ACTIONS(1492),
    [anon_sym_AMP] = ACTIONS(1492),
    [anon_sym_SEMI] = ACTIONS(1492),
    [anon_sym___extension__] = ACTIONS(1490),
    [anon_sym_typedef] = ACTIONS(1490),
    [anon_sym_extern] = ACTIONS(1490),
    [anon_sym___attribute__] = ACTIONS(1490),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1492),
    [anon_sym___declspec] = ACTIONS(1490),
    [anon_sym___cdecl] = ACTIONS(1490),
    [anon_sym___clrcall] = ACTIONS(1490),
    [anon_sym___stdcall] = ACTIONS(1490),
    [anon_sym___fastcall] = ACTIONS(1490),
    [anon_sym___thiscall] = ACTIONS(1490),
    [anon_sym___vectorcall] = ACTIONS(1490),
    [anon_sym_LBRACE] = ACTIONS(1492),
    [anon_sym_signed] = ACTIONS(1490),
    [anon_sym_unsigned] = ACTIONS(1490),
    [anon_sym_long] = ACTIONS(1490),
    [anon_sym_short] = ACTIONS(1490),
    [anon_sym_static] = ACTIONS(1490),
    [anon_sym_auto] = ACTIONS(1490),
    [anon_sym_register] = ACTIONS(1490),
    [anon_sym_inline] = ACTIONS(1490),
    [anon_sym___inline] = ACTIONS(1490),
    [anon_sym___inline__] = ACTIONS(1490),
    [anon_sym___forceinline] = ACTIONS(1490),
    [anon_sym_thread_local] = ACTIONS(1490),
    [anon_sym___thread] = ACTIONS(1490),
    [anon_sym_const] = ACTIONS(1490),
    [anon_sym_constexpr] = ACTIONS(1490),
    [anon_sym_volatile] = ACTIONS(1490),
    [anon_sym_restrict] = ACTIONS(1490),
    [anon_sym___restrict__] = ACTIONS(1490),
    [anon_sym__Atomic] = ACTIONS(1490),
    [anon_sym__Noreturn] = ACTIONS(1490),
    [anon_sym_noreturn] = ACTIONS(1490),
    [sym_primitive_type] = ACTIONS(1490),
    [anon_sym_enum] = ACTIONS(1490),
    [anon_sym_struct] = ACTIONS(1490),
    [anon_sym_union] = ACTIONS(1490),
    [anon_sym_if] = ACTIONS(1490),
    [anon_sym_switch] = ACTIONS(1490),
    [anon_sym_case] = ACTIONS(1490),
    [anon_sym_default] = ACTIONS(1490),
    [anon_sym_while] = ACTIONS(1490),
    [anon_sym_do] = ACTIONS(1490),
    [anon_sym_for] = ACTIONS(1490),
    [anon_sym_return] = ACTIONS(1490),
    [anon_sym_break] = ACTIONS(1490),
    [anon_sym_continue] = ACTIONS(1490),
    [anon_sym_goto] = ACTIONS(1490),
    [anon_sym___try] = ACTIONS(1490),
    [anon_sym___leave] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1492),
    [anon_sym_PLUS_PLUS] = ACTIONS(1492),
    [anon_sym_sizeof] = ACTIONS(1490),
    [anon_sym___alignof__] = ACTIONS(1490),
    [anon_sym___alignof] = ACTIONS(1490),
    [anon_sym__alignof] = ACTIONS(1490),
    [anon_sym_alignof] = ACTIONS(1490),
    [anon_sym__Alignof] = ACTIONS(1490),
    [anon_sym_offsetof] = ACTIONS(1490),
    [anon_sym__Generic] = ACTIONS(1490),
    [anon_sym_asm] = ACTIONS(1490),
    [anon_sym___asm__] = ACTIONS(1490),
    [sym_number_literal] = ACTIONS(1492),
    [anon_sym_L_SQUOTE] = ACTIONS(1492),
    [anon_sym_u_SQUOTE] = ACTIONS(1492),
    [anon_sym_U_SQUOTE] = ACTIONS(1492),
    [anon_sym_u8_SQUOTE] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1492),
    [anon_sym_L_DQUOTE] = ACTIONS(1492),
    [anon_sym_u_DQUOTE] = ACTIONS(1492),
    [anon_sym_U_DQUOTE] = ACTIONS(1492),
    [anon_sym_u8_DQUOTE] = ACTIONS(1492),
    [anon_sym_DQUOTE] = ACTIONS(1492),
    [sym_true] = ACTIONS(1490),
    [sym_false] = ACTIONS(1490),
    [anon_sym_NULL] = ACTIONS(1490),
    [anon_sym_nullptr] = ACTIONS(1490),
    [sym_comment] = ACTIONS(3),
  },
  [238] = {
    [sym__expression] = STATE(902),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(884),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_call_expression] = STATE(884),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(884),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(884),
    [sym_initializer_list] = STATE(861),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_identifier] = ACTIONS(1538),
    [anon_sym_COMMA] = ACTIONS(1540),
    [anon_sym_RPAREN] = ACTIONS(1540),
    [anon_sym_LPAREN2] = ACTIONS(1540),
    [anon_sym_BANG] = ACTIONS(1542),
    [anon_sym_TILDE] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1546),
    [anon_sym_PLUS] = ACTIONS(1546),
    [anon_sym_STAR] = ACTIONS(1546),
    [anon_sym_SLASH] = ACTIONS(1546),
    [anon_sym_PERCENT] = ACTIONS(1546),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE] = ACTIONS(1546),
    [anon_sym_CARET] = ACTIONS(1546),
    [anon_sym_AMP] = ACTIONS(1546),
    [anon_sym_EQ_EQ] = ACTIONS(1540),
    [anon_sym_BANG_EQ] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1540),
    [anon_sym_LT_EQ] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1546),
    [anon_sym_GT_GT] = ACTIONS(1546),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym___attribute__] = ACTIONS(1546),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1540),
    [anon_sym_EQ] = ACTIONS(1546),
    [anon_sym_COLON] = ACTIONS(1540),
    [anon_sym_QMARK] = ACTIONS(1540),
    [anon_sym_STAR_EQ] = ACTIONS(1540),
    [anon_sym_SLASH_EQ] = ACTIONS(1540),
    [anon_sym_PERCENT_EQ] = ACTIONS(1540),
    [anon_sym_PLUS_EQ] = ACTIONS(1540),
    [anon_sym_DASH_EQ] = ACTIONS(1540),
    [anon_sym_LT_LT_EQ] = ACTIONS(1540),
    [anon_sym_GT_GT_EQ] = ACTIONS(1540),
    [anon_sym_AMP_EQ] = ACTIONS(1540),
    [anon_sym_CARET_EQ] = ACTIONS(1540),
    [anon_sym_PIPE_EQ] = ACTIONS(1540),
    [anon_sym_DASH_DASH] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1540),
    [anon_sym_sizeof] = ACTIONS(1550),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(1546),
    [anon_sym_DASH_GT] = ACTIONS(1540),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [239] = {
    [sym_identifier] = ACTIONS(1514),
    [aux_sym_preproc_include_token1] = ACTIONS(1514),
    [aux_sym_preproc_def_token1] = ACTIONS(1514),
    [aux_sym_preproc_if_token1] = ACTIONS(1514),
    [aux_sym_preproc_if_token2] = ACTIONS(1514),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1514),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1514),
    [aux_sym_preproc_else_token1] = ACTIONS(1514),
    [aux_sym_preproc_elif_token1] = ACTIONS(1514),
    [sym_preproc_directive] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(1516),
    [anon_sym_BANG] = ACTIONS(1516),
    [anon_sym_TILDE] = ACTIONS(1516),
    [anon_sym_DASH] = ACTIONS(1514),
    [anon_sym_PLUS] = ACTIONS(1514),
    [anon_sym_STAR] = ACTIONS(1516),
    [anon_sym_AMP] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(1516),
    [anon_sym___extension__] = ACTIONS(1514),
    [anon_sym_typedef] = ACTIONS(1514),
    [anon_sym_extern] = ACTIONS(1514),
    [anon_sym___attribute__] = ACTIONS(1514),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym___declspec] = ACTIONS(1514),
    [anon_sym___cdecl] = ACTIONS(1514),
    [anon_sym___clrcall] = ACTIONS(1514),
    [anon_sym___stdcall] = ACTIONS(1514),
    [anon_sym___fastcall] = ACTIONS(1514),
    [anon_sym___thiscall] = ACTIONS(1514),
    [anon_sym___vectorcall] = ACTIONS(1514),
    [anon_sym_LBRACE] = ACTIONS(1516),
    [anon_sym_signed] = ACTIONS(1514),
    [anon_sym_unsigned] = ACTIONS(1514),
    [anon_sym_long] = ACTIONS(1514),
    [anon_sym_short] = ACTIONS(1514),
    [anon_sym_static] = ACTIONS(1514),
    [anon_sym_auto] = ACTIONS(1514),
    [anon_sym_register] = ACTIONS(1514),
    [anon_sym_inline] = ACTIONS(1514),
    [anon_sym___inline] = ACTIONS(1514),
    [anon_sym___inline__] = ACTIONS(1514),
    [anon_sym___forceinline] = ACTIONS(1514),
    [anon_sym_thread_local] = ACTIONS(1514),
    [anon_sym___thread] = ACTIONS(1514),
    [anon_sym_const] = ACTIONS(1514),
    [anon_sym_constexpr] = ACTIONS(1514),
    [anon_sym_volatile] = ACTIONS(1514),
    [anon_sym_restrict] = ACTIONS(1514),
    [anon_sym___restrict__] = ACTIONS(1514),
    [anon_sym__Atomic] = ACTIONS(1514),
    [anon_sym__Noreturn] = ACTIONS(1514),
    [anon_sym_noreturn] = ACTIONS(1514),
    [sym_primitive_type] = ACTIONS(1514),
    [anon_sym_enum] = ACTIONS(1514),
    [anon_sym_struct] = ACTIONS(1514),
    [anon_sym_union] = ACTIONS(1514),
    [anon_sym_if] = ACTIONS(1514),
    [anon_sym_switch] = ACTIONS(1514),
    [anon_sym_case] = ACTIONS(1514),
    [anon_sym_default] = ACTIONS(1514),
    [anon_sym_while] = ACTIONS(1514),
    [anon_sym_do] = ACTIONS(1514),
    [anon_sym_for] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1514),
    [anon_sym_break] = ACTIONS(1514),
    [anon_sym_continue] = ACTIONS(1514),
    [anon_sym_goto] = ACTIONS(1514),
    [anon_sym___try] = ACTIONS(1514),
    [anon_sym___leave] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1516),
    [anon_sym_PLUS_PLUS] = ACTIONS(1516),
    [anon_sym_sizeof] = ACTIONS(1514),
    [anon_sym___alignof__] = ACTIONS(1514),
    [anon_sym___alignof] = ACTIONS(1514),
    [anon_sym__alignof] = ACTIONS(1514),
    [anon_sym_alignof] = ACTIONS(1514),
    [anon_sym__Alignof] = ACTIONS(1514),
    [anon_sym_offsetof] = ACTIONS(1514),
    [anon_sym__Generic] = ACTIONS(1514),
    [anon_sym_asm] = ACTIONS(1514),
    [anon_sym___asm__] = ACTIONS(1514),
    [sym_number_literal] = ACTIONS(1516),
    [anon_sym_L_SQUOTE] = ACTIONS(1516),
    [anon_sym_u_SQUOTE] = ACTIONS(1516),
    [anon_sym_U_SQUOTE] = ACTIONS(1516),
    [anon_sym_u8_SQUOTE] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1516),
    [anon_sym_L_DQUOTE] = ACTIONS(1516),
    [anon_sym_u_DQUOTE] = ACTIONS(1516),
    [anon_sym_U_DQUOTE] = ACTIONS(1516),
    [anon_sym_u8_DQUOTE] = ACTIONS(1516),
    [anon_sym_DQUOTE] = ACTIONS(1516),
    [sym_true] = ACTIONS(1514),
    [sym_false] = ACTIONS(1514),
    [anon_sym_NULL] = ACTIONS(1514),
    [anon_sym_nullptr] = ACTIONS(1514),
    [sym_comment] = ACTIONS(3),
  },
  [240] = {
    [sym__expression] = STATE(902),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(884),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_call_expression] = STATE(884),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(884),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(884),
    [sym_initializer_list] = STATE(861),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(890),
    [sym_null] = STATE(884),
    [sym_identifier] = ACTIONS(1546),
    [anon_sym_COMMA] = ACTIONS(1540),
    [aux_sym_preproc_if_token2] = ACTIONS(1540),
    [aux_sym_preproc_else_token1] = ACTIONS(1540),
    [aux_sym_preproc_elif_token1] = ACTIONS(1546),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1540),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1540),
    [anon_sym_LPAREN2] = ACTIONS(1540),
    [anon_sym_BANG] = ACTIONS(1552),
    [anon_sym_TILDE] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1546),
    [anon_sym_PLUS] = ACTIONS(1546),
    [anon_sym_STAR] = ACTIONS(1546),
    [anon_sym_SLASH] = ACTIONS(1546),
    [anon_sym_PERCENT] = ACTIONS(1546),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE] = ACTIONS(1546),
    [anon_sym_CARET] = ACTIONS(1546),
    [anon_sym_AMP] = ACTIONS(1546),
    [anon_sym_EQ_EQ] = ACTIONS(1540),
    [anon_sym_BANG_EQ] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1540),
    [anon_sym_LT_EQ] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1546),
    [anon_sym_GT_GT] = ACTIONS(1546),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1540),
    [anon_sym_EQ] = ACTIONS(1546),
    [anon_sym_QMARK] = ACTIONS(1540),
    [anon_sym_STAR_EQ] = ACTIONS(1540),
    [anon_sym_SLASH_EQ] = ACTIONS(1540),
    [anon_sym_PERCENT_EQ] = ACTIONS(1540),
    [anon_sym_PLUS_EQ] = ACTIONS(1540),
    [anon_sym_DASH_EQ] = ACTIONS(1540),
    [anon_sym_LT_LT_EQ] = ACTIONS(1540),
    [anon_sym_GT_GT_EQ] = ACTIONS(1540),
    [anon_sym_AMP_EQ] = ACTIONS(1540),
    [anon_sym_CARET_EQ] = ACTIONS(1540),
    [anon_sym_PIPE_EQ] = ACTIONS(1540),
    [anon_sym_DASH_DASH] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1540),
    [anon_sym_sizeof] = ACTIONS(1556),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(1546),
    [anon_sym_DASH_GT] = ACTIONS(1540),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [241] = {
    [sym_identifier] = ACTIONS(1486),
    [aux_sym_preproc_include_token1] = ACTIONS(1486),
    [aux_sym_preproc_def_token1] = ACTIONS(1486),
    [aux_sym_preproc_if_token1] = ACTIONS(1486),
    [aux_sym_preproc_if_token2] = ACTIONS(1486),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1486),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1486),
    [aux_sym_preproc_else_token1] = ACTIONS(1486),
    [aux_sym_preproc_elif_token1] = ACTIONS(1486),
    [sym_preproc_directive] = ACTIONS(1486),
    [anon_sym_LPAREN2] = ACTIONS(1488),
    [anon_sym_BANG] = ACTIONS(1488),
    [anon_sym_TILDE] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_STAR] = ACTIONS(1488),
    [anon_sym_AMP] = ACTIONS(1488),
    [anon_sym_SEMI] = ACTIONS(1488),
    [anon_sym___extension__] = ACTIONS(1486),
    [anon_sym_typedef] = ACTIONS(1486),
    [anon_sym_extern] = ACTIONS(1486),
    [anon_sym___attribute__] = ACTIONS(1486),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1488),
    [anon_sym___declspec] = ACTIONS(1486),
    [anon_sym___cdecl] = ACTIONS(1486),
    [anon_sym___clrcall] = ACTIONS(1486),
    [anon_sym___stdcall] = ACTIONS(1486),
    [anon_sym___fastcall] = ACTIONS(1486),
    [anon_sym___thiscall] = ACTIONS(1486),
    [anon_sym___vectorcall] = ACTIONS(1486),
    [anon_sym_LBRACE] = ACTIONS(1488),
    [anon_sym_signed] = ACTIONS(1486),
    [anon_sym_unsigned] = ACTIONS(1486),
    [anon_sym_long] = ACTIONS(1486),
    [anon_sym_short] = ACTIONS(1486),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_auto] = ACTIONS(1486),
    [anon_sym_register] = ACTIONS(1486),
    [anon_sym_inline] = ACTIONS(1486),
    [anon_sym___inline] = ACTIONS(1486),
    [anon_sym___inline__] = ACTIONS(1486),
    [anon_sym___forceinline] = ACTIONS(1486),
    [anon_sym_thread_local] = ACTIONS(1486),
    [anon_sym___thread] = ACTIONS(1486),
    [anon_sym_const] = ACTIONS(1486),
    [anon_sym_constexpr] = ACTIONS(1486),
    [anon_sym_volatile] = ACTIONS(1486),
    [anon_sym_restrict] = ACTIONS(1486),
    [anon_sym___restrict__] = ACTIONS(1486),
    [anon_sym__Atomic] = ACTIONS(1486),
    [anon_sym__Noreturn] = ACTIONS(1486),
    [anon_sym_noreturn] = ACTIONS(1486),
    [sym_primitive_type] = ACTIONS(1486),
    [anon_sym_enum] = ACTIONS(1486),
    [anon_sym_struct] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(1486),
    [anon_sym_if] = ACTIONS(1486),
    [anon_sym_switch] = ACTIONS(1486),
    [anon_sym_case] = ACTIONS(1486),
    [anon_sym_default] = ACTIONS(1486),
    [anon_sym_while] = ACTIONS(1486),
    [anon_sym_do] = ACTIONS(1486),
    [anon_sym_for] = ACTIONS(1486),
    [anon_sym_return] = ACTIONS(1486),
    [anon_sym_break] = ACTIONS(1486),
    [anon_sym_continue] = ACTIONS(1486),
    [anon_sym_goto] = ACTIONS(1486),
    [anon_sym___try] = ACTIONS(1486),
    [anon_sym___leave] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1488),
    [anon_sym_PLUS_PLUS] = ACTIONS(1488),
    [anon_sym_sizeof] = ACTIONS(1486),
    [anon_sym___alignof__] = ACTIONS(1486),
    [anon_sym___alignof] = ACTIONS(1486),
    [anon_sym__alignof] = ACTIONS(1486),
    [anon_sym_alignof] = ACTIONS(1486),
    [anon_sym__Alignof] = ACTIONS(1486),
    [anon_sym_offsetof] = ACTIONS(1486),
    [anon_sym__Generic] = ACTIONS(1486),
    [anon_sym_asm] = ACTIONS(1486),
    [anon_sym___asm__] = ACTIONS(1486),
    [sym_number_literal] = ACTIONS(1488),
    [anon_sym_L_SQUOTE] = ACTIONS(1488),
    [anon_sym_u_SQUOTE] = ACTIONS(1488),
    [anon_sym_U_SQUOTE] = ACTIONS(1488),
    [anon_sym_u8_SQUOTE] = ACTIONS(1488),
    [anon_sym_SQUOTE] = ACTIONS(1488),
    [anon_sym_L_DQUOTE] = ACTIONS(1488),
    [anon_sym_u_DQUOTE] = ACTIONS(1488),
    [anon_sym_U_DQUOTE] = ACTIONS(1488),
    [anon_sym_u8_DQUOTE] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(1488),
    [sym_true] = ACTIONS(1486),
    [sym_false] = ACTIONS(1486),
    [anon_sym_NULL] = ACTIONS(1486),
    [anon_sym_nullptr] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
  },
  [242] = {
    [sym_identifier] = ACTIONS(1470),
    [aux_sym_preproc_include_token1] = ACTIONS(1470),
    [aux_sym_preproc_def_token1] = ACTIONS(1470),
    [aux_sym_preproc_if_token1] = ACTIONS(1470),
    [aux_sym_preproc_if_token2] = ACTIONS(1470),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1470),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1470),
    [aux_sym_preproc_else_token1] = ACTIONS(1470),
    [aux_sym_preproc_elif_token1] = ACTIONS(1470),
    [sym_preproc_directive] = ACTIONS(1470),
    [anon_sym_LPAREN2] = ACTIONS(1472),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_TILDE] = ACTIONS(1472),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_STAR] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1472),
    [anon_sym_SEMI] = ACTIONS(1472),
    [anon_sym___extension__] = ACTIONS(1470),
    [anon_sym_typedef] = ACTIONS(1470),
    [anon_sym_extern] = ACTIONS(1470),
    [anon_sym___attribute__] = ACTIONS(1470),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1472),
    [anon_sym___declspec] = ACTIONS(1470),
    [anon_sym___cdecl] = ACTIONS(1470),
    [anon_sym___clrcall] = ACTIONS(1470),
    [anon_sym___stdcall] = ACTIONS(1470),
    [anon_sym___fastcall] = ACTIONS(1470),
    [anon_sym___thiscall] = ACTIONS(1470),
    [anon_sym___vectorcall] = ACTIONS(1470),
    [anon_sym_LBRACE] = ACTIONS(1472),
    [anon_sym_signed] = ACTIONS(1470),
    [anon_sym_unsigned] = ACTIONS(1470),
    [anon_sym_long] = ACTIONS(1470),
    [anon_sym_short] = ACTIONS(1470),
    [anon_sym_static] = ACTIONS(1470),
    [anon_sym_auto] = ACTIONS(1470),
    [anon_sym_register] = ACTIONS(1470),
    [anon_sym_inline] = ACTIONS(1470),
    [anon_sym___inline] = ACTIONS(1470),
    [anon_sym___inline__] = ACTIONS(1470),
    [anon_sym___forceinline] = ACTIONS(1470),
    [anon_sym_thread_local] = ACTIONS(1470),
    [anon_sym___thread] = ACTIONS(1470),
    [anon_sym_const] = ACTIONS(1470),
    [anon_sym_constexpr] = ACTIONS(1470),
    [anon_sym_volatile] = ACTIONS(1470),
    [anon_sym_restrict] = ACTIONS(1470),
    [anon_sym___restrict__] = ACTIONS(1470),
    [anon_sym__Atomic] = ACTIONS(1470),
    [anon_sym__Noreturn] = ACTIONS(1470),
    [anon_sym_noreturn] = ACTIONS(1470),
    [sym_primitive_type] = ACTIONS(1470),
    [anon_sym_enum] = ACTIONS(1470),
    [anon_sym_struct] = ACTIONS(1470),
    [anon_sym_union] = ACTIONS(1470),
    [anon_sym_if] = ACTIONS(1470),
    [anon_sym_switch] = ACTIONS(1470),
    [anon_sym_case] = ACTIONS(1470),
    [anon_sym_default] = ACTIONS(1470),
    [anon_sym_while] = ACTIONS(1470),
    [anon_sym_do] = ACTIONS(1470),
    [anon_sym_for] = ACTIONS(1470),
    [anon_sym_return] = ACTIONS(1470),
    [anon_sym_break] = ACTIONS(1470),
    [anon_sym_continue] = ACTIONS(1470),
    [anon_sym_goto] = ACTIONS(1470),
    [anon_sym___try] = ACTIONS(1470),
    [anon_sym___leave] = ACTIONS(1470),
    [anon_sym_DASH_DASH] = ACTIONS(1472),
    [anon_sym_PLUS_PLUS] = ACTIONS(1472),
    [anon_sym_sizeof] = ACTIONS(1470),
    [anon_sym___alignof__] = ACTIONS(1470),
    [anon_sym___alignof] = ACTIONS(1470),
    [anon_sym__alignof] = ACTIONS(1470),
    [anon_sym_alignof] = ACTIONS(1470),
    [anon_sym__Alignof] = ACTIONS(1470),
    [anon_sym_offsetof] = ACTIONS(1470),
    [anon_sym__Generic] = ACTIONS(1470),
    [anon_sym_asm] = ACTIONS(1470),
    [anon_sym___asm__] = ACTIONS(1470),
    [sym_number_literal] = ACTIONS(1472),
    [anon_sym_L_SQUOTE] = ACTIONS(1472),
    [anon_sym_u_SQUOTE] = ACTIONS(1472),
    [anon_sym_U_SQUOTE] = ACTIONS(1472),
    [anon_sym_u8_SQUOTE] = ACTIONS(1472),
    [anon_sym_SQUOTE] = ACTIONS(1472),
    [anon_sym_L_DQUOTE] = ACTIONS(1472),
    [anon_sym_u_DQUOTE] = ACTIONS(1472),
    [anon_sym_U_DQUOTE] = ACTIONS(1472),
    [anon_sym_u8_DQUOTE] = ACTIONS(1472),
    [anon_sym_DQUOTE] = ACTIONS(1472),
    [sym_true] = ACTIONS(1470),
    [sym_false] = ACTIONS(1470),
    [anon_sym_NULL] = ACTIONS(1470),
    [anon_sym_nullptr] = ACTIONS(1470),
    [sym_comment] = ACTIONS(3),
  },
  [243] = {
    [sym_else_clause] = STATE(271),
    [sym_identifier] = ACTIONS(1292),
    [aux_sym_preproc_include_token1] = ACTIONS(1292),
    [aux_sym_preproc_def_token1] = ACTIONS(1292),
    [aux_sym_preproc_if_token1] = ACTIONS(1292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1292),
    [sym_preproc_directive] = ACTIONS(1292),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1294),
    [anon_sym_TILDE] = ACTIONS(1294),
    [anon_sym_DASH] = ACTIONS(1292),
    [anon_sym_PLUS] = ACTIONS(1292),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_SEMI] = ACTIONS(1294),
    [anon_sym___extension__] = ACTIONS(1292),
    [anon_sym_typedef] = ACTIONS(1292),
    [anon_sym_extern] = ACTIONS(1292),
    [anon_sym___attribute__] = ACTIONS(1292),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1294),
    [anon_sym___declspec] = ACTIONS(1292),
    [anon_sym___cdecl] = ACTIONS(1292),
    [anon_sym___clrcall] = ACTIONS(1292),
    [anon_sym___stdcall] = ACTIONS(1292),
    [anon_sym___fastcall] = ACTIONS(1292),
    [anon_sym___thiscall] = ACTIONS(1292),
    [anon_sym___vectorcall] = ACTIONS(1292),
    [anon_sym_LBRACE] = ACTIONS(1294),
    [anon_sym_RBRACE] = ACTIONS(1294),
    [anon_sym_signed] = ACTIONS(1292),
    [anon_sym_unsigned] = ACTIONS(1292),
    [anon_sym_long] = ACTIONS(1292),
    [anon_sym_short] = ACTIONS(1292),
    [anon_sym_static] = ACTIONS(1292),
    [anon_sym_auto] = ACTIONS(1292),
    [anon_sym_register] = ACTIONS(1292),
    [anon_sym_inline] = ACTIONS(1292),
    [anon_sym___inline] = ACTIONS(1292),
    [anon_sym___inline__] = ACTIONS(1292),
    [anon_sym___forceinline] = ACTIONS(1292),
    [anon_sym_thread_local] = ACTIONS(1292),
    [anon_sym___thread] = ACTIONS(1292),
    [anon_sym_const] = ACTIONS(1292),
    [anon_sym_constexpr] = ACTIONS(1292),
    [anon_sym_volatile] = ACTIONS(1292),
    [anon_sym_restrict] = ACTIONS(1292),
    [anon_sym___restrict__] = ACTIONS(1292),
    [anon_sym__Atomic] = ACTIONS(1292),
    [anon_sym__Noreturn] = ACTIONS(1292),
    [anon_sym_noreturn] = ACTIONS(1292),
    [sym_primitive_type] = ACTIONS(1292),
    [anon_sym_enum] = ACTIONS(1292),
    [anon_sym_struct] = ACTIONS(1292),
    [anon_sym_union] = ACTIONS(1292),
    [anon_sym_if] = ACTIONS(1292),
    [anon_sym_else] = ACTIONS(1558),
    [anon_sym_switch] = ACTIONS(1292),
    [anon_sym_case] = ACTIONS(1292),
    [anon_sym_default] = ACTIONS(1292),
    [anon_sym_while] = ACTIONS(1292),
    [anon_sym_do] = ACTIONS(1292),
    [anon_sym_for] = ACTIONS(1292),
    [anon_sym_return] = ACTIONS(1292),
    [anon_sym_break] = ACTIONS(1292),
    [anon_sym_continue] = ACTIONS(1292),
    [anon_sym_goto] = ACTIONS(1292),
    [anon_sym___try] = ACTIONS(1292),
    [anon_sym___leave] = ACTIONS(1292),
    [anon_sym_DASH_DASH] = ACTIONS(1294),
    [anon_sym_PLUS_PLUS] = ACTIONS(1294),
    [anon_sym_sizeof] = ACTIONS(1292),
    [anon_sym___alignof__] = ACTIONS(1292),
    [anon_sym___alignof] = ACTIONS(1292),
    [anon_sym__alignof] = ACTIONS(1292),
    [anon_sym_alignof] = ACTIONS(1292),
    [anon_sym__Alignof] = ACTIONS(1292),
    [anon_sym_offsetof] = ACTIONS(1292),
    [anon_sym__Generic] = ACTIONS(1292),
    [anon_sym_asm] = ACTIONS(1292),
    [anon_sym___asm__] = ACTIONS(1292),
    [sym_number_literal] = ACTIONS(1294),
    [anon_sym_L_SQUOTE] = ACTIONS(1294),
    [anon_sym_u_SQUOTE] = ACTIONS(1294),
    [anon_sym_U_SQUOTE] = ACTIONS(1294),
    [anon_sym_u8_SQUOTE] = ACTIONS(1294),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_L_DQUOTE] = ACTIONS(1294),
    [anon_sym_u_DQUOTE] = ACTIONS(1294),
    [anon_sym_U_DQUOTE] = ACTIONS(1294),
    [anon_sym_u8_DQUOTE] = ACTIONS(1294),
    [anon_sym_DQUOTE] = ACTIONS(1294),
    [sym_true] = ACTIONS(1292),
    [sym_false] = ACTIONS(1292),
    [anon_sym_NULL] = ACTIONS(1292),
    [anon_sym_nullptr] = ACTIONS(1292),
    [sym_comment] = ACTIONS(3),
  },
  [244] = {
    [sym_else_clause] = STATE(352),
    [sym_identifier] = ACTIONS(1292),
    [aux_sym_preproc_include_token1] = ACTIONS(1292),
    [aux_sym_preproc_def_token1] = ACTIONS(1292),
    [aux_sym_preproc_if_token1] = ACTIONS(1292),
    [aux_sym_preproc_if_token2] = ACTIONS(1292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1292),
    [sym_preproc_directive] = ACTIONS(1292),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1294),
    [anon_sym_TILDE] = ACTIONS(1294),
    [anon_sym_DASH] = ACTIONS(1292),
    [anon_sym_PLUS] = ACTIONS(1292),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_SEMI] = ACTIONS(1294),
    [anon_sym___extension__] = ACTIONS(1292),
    [anon_sym_typedef] = ACTIONS(1292),
    [anon_sym_extern] = ACTIONS(1292),
    [anon_sym___attribute__] = ACTIONS(1292),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1294),
    [anon_sym___declspec] = ACTIONS(1292),
    [anon_sym___cdecl] = ACTIONS(1292),
    [anon_sym___clrcall] = ACTIONS(1292),
    [anon_sym___stdcall] = ACTIONS(1292),
    [anon_sym___fastcall] = ACTIONS(1292),
    [anon_sym___thiscall] = ACTIONS(1292),
    [anon_sym___vectorcall] = ACTIONS(1292),
    [anon_sym_LBRACE] = ACTIONS(1294),
    [anon_sym_signed] = ACTIONS(1292),
    [anon_sym_unsigned] = ACTIONS(1292),
    [anon_sym_long] = ACTIONS(1292),
    [anon_sym_short] = ACTIONS(1292),
    [anon_sym_static] = ACTIONS(1292),
    [anon_sym_auto] = ACTIONS(1292),
    [anon_sym_register] = ACTIONS(1292),
    [anon_sym_inline] = ACTIONS(1292),
    [anon_sym___inline] = ACTIONS(1292),
    [anon_sym___inline__] = ACTIONS(1292),
    [anon_sym___forceinline] = ACTIONS(1292),
    [anon_sym_thread_local] = ACTIONS(1292),
    [anon_sym___thread] = ACTIONS(1292),
    [anon_sym_const] = ACTIONS(1292),
    [anon_sym_constexpr] = ACTIONS(1292),
    [anon_sym_volatile] = ACTIONS(1292),
    [anon_sym_restrict] = ACTIONS(1292),
    [anon_sym___restrict__] = ACTIONS(1292),
    [anon_sym__Atomic] = ACTIONS(1292),
    [anon_sym__Noreturn] = ACTIONS(1292),
    [anon_sym_noreturn] = ACTIONS(1292),
    [sym_primitive_type] = ACTIONS(1292),
    [anon_sym_enum] = ACTIONS(1292),
    [anon_sym_struct] = ACTIONS(1292),
    [anon_sym_union] = ACTIONS(1292),
    [anon_sym_if] = ACTIONS(1292),
    [anon_sym_else] = ACTIONS(1560),
    [anon_sym_switch] = ACTIONS(1292),
    [anon_sym_case] = ACTIONS(1292),
    [anon_sym_default] = ACTIONS(1292),
    [anon_sym_while] = ACTIONS(1292),
    [anon_sym_do] = ACTIONS(1292),
    [anon_sym_for] = ACTIONS(1292),
    [anon_sym_return] = ACTIONS(1292),
    [anon_sym_break] = ACTIONS(1292),
    [anon_sym_continue] = ACTIONS(1292),
    [anon_sym_goto] = ACTIONS(1292),
    [anon_sym___try] = ACTIONS(1292),
    [anon_sym___leave] = ACTIONS(1292),
    [anon_sym_DASH_DASH] = ACTIONS(1294),
    [anon_sym_PLUS_PLUS] = ACTIONS(1294),
    [anon_sym_sizeof] = ACTIONS(1292),
    [anon_sym___alignof__] = ACTIONS(1292),
    [anon_sym___alignof] = ACTIONS(1292),
    [anon_sym__alignof] = ACTIONS(1292),
    [anon_sym_alignof] = ACTIONS(1292),
    [anon_sym__Alignof] = ACTIONS(1292),
    [anon_sym_offsetof] = ACTIONS(1292),
    [anon_sym__Generic] = ACTIONS(1292),
    [anon_sym_asm] = ACTIONS(1292),
    [anon_sym___asm__] = ACTIONS(1292),
    [sym_number_literal] = ACTIONS(1294),
    [anon_sym_L_SQUOTE] = ACTIONS(1294),
    [anon_sym_u_SQUOTE] = ACTIONS(1294),
    [anon_sym_U_SQUOTE] = ACTIONS(1294),
    [anon_sym_u8_SQUOTE] = ACTIONS(1294),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_L_DQUOTE] = ACTIONS(1294),
    [anon_sym_u_DQUOTE] = ACTIONS(1294),
    [anon_sym_U_DQUOTE] = ACTIONS(1294),
    [anon_sym_u8_DQUOTE] = ACTIONS(1294),
    [anon_sym_DQUOTE] = ACTIONS(1294),
    [sym_true] = ACTIONS(1292),
    [sym_false] = ACTIONS(1292),
    [anon_sym_NULL] = ACTIONS(1292),
    [anon_sym_nullptr] = ACTIONS(1292),
    [sym_comment] = ACTIONS(3),
  },
  [245] = {
    [sym_identifier] = ACTIONS(1462),
    [aux_sym_preproc_include_token1] = ACTIONS(1462),
    [aux_sym_preproc_def_token1] = ACTIONS(1462),
    [aux_sym_preproc_if_token1] = ACTIONS(1462),
    [aux_sym_preproc_if_token2] = ACTIONS(1462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1462),
    [aux_sym_preproc_else_token1] = ACTIONS(1462),
    [aux_sym_preproc_elif_token1] = ACTIONS(1462),
    [sym_preproc_directive] = ACTIONS(1462),
    [anon_sym_LPAREN2] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1464),
    [anon_sym_TILDE] = ACTIONS(1464),
    [anon_sym_DASH] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1462),
    [anon_sym_STAR] = ACTIONS(1464),
    [anon_sym_AMP] = ACTIONS(1464),
    [anon_sym_SEMI] = ACTIONS(1464),
    [anon_sym___extension__] = ACTIONS(1462),
    [anon_sym_typedef] = ACTIONS(1462),
    [anon_sym_extern] = ACTIONS(1462),
    [anon_sym___attribute__] = ACTIONS(1462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1464),
    [anon_sym___declspec] = ACTIONS(1462),
    [anon_sym___cdecl] = ACTIONS(1462),
    [anon_sym___clrcall] = ACTIONS(1462),
    [anon_sym___stdcall] = ACTIONS(1462),
    [anon_sym___fastcall] = ACTIONS(1462),
    [anon_sym___thiscall] = ACTIONS(1462),
    [anon_sym___vectorcall] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_signed] = ACTIONS(1462),
    [anon_sym_unsigned] = ACTIONS(1462),
    [anon_sym_long] = ACTIONS(1462),
    [anon_sym_short] = ACTIONS(1462),
    [anon_sym_static] = ACTIONS(1462),
    [anon_sym_auto] = ACTIONS(1462),
    [anon_sym_register] = ACTIONS(1462),
    [anon_sym_inline] = ACTIONS(1462),
    [anon_sym___inline] = ACTIONS(1462),
    [anon_sym___inline__] = ACTIONS(1462),
    [anon_sym___forceinline] = ACTIONS(1462),
    [anon_sym_thread_local] = ACTIONS(1462),
    [anon_sym___thread] = ACTIONS(1462),
    [anon_sym_const] = ACTIONS(1462),
    [anon_sym_constexpr] = ACTIONS(1462),
    [anon_sym_volatile] = ACTIONS(1462),
    [anon_sym_restrict] = ACTIONS(1462),
    [anon_sym___restrict__] = ACTIONS(1462),
    [anon_sym__Atomic] = ACTIONS(1462),
    [anon_sym__Noreturn] = ACTIONS(1462),
    [anon_sym_noreturn] = ACTIONS(1462),
    [sym_primitive_type] = ACTIONS(1462),
    [anon_sym_enum] = ACTIONS(1462),
    [anon_sym_struct] = ACTIONS(1462),
    [anon_sym_union] = ACTIONS(1462),
    [anon_sym_if] = ACTIONS(1462),
    [anon_sym_switch] = ACTIONS(1462),
    [anon_sym_case] = ACTIONS(1462),
    [anon_sym_default] = ACTIONS(1462),
    [anon_sym_while] = ACTIONS(1462),
    [anon_sym_do] = ACTIONS(1462),
    [anon_sym_for] = ACTIONS(1462),
    [anon_sym_return] = ACTIONS(1462),
    [anon_sym_break] = ACTIONS(1462),
    [anon_sym_continue] = ACTIONS(1462),
    [anon_sym_goto] = ACTIONS(1462),
    [anon_sym___try] = ACTIONS(1462),
    [anon_sym___leave] = ACTIONS(1462),
    [anon_sym_DASH_DASH] = ACTIONS(1464),
    [anon_sym_PLUS_PLUS] = ACTIONS(1464),
    [anon_sym_sizeof] = ACTIONS(1462),
    [anon_sym___alignof__] = ACTIONS(1462),
    [anon_sym___alignof] = ACTIONS(1462),
    [anon_sym__alignof] = ACTIONS(1462),
    [anon_sym_alignof] = ACTIONS(1462),
    [anon_sym__Alignof] = ACTIONS(1462),
    [anon_sym_offsetof] = ACTIONS(1462),
    [anon_sym__Generic] = ACTIONS(1462),
    [anon_sym_asm] = ACTIONS(1462),
    [anon_sym___asm__] = ACTIONS(1462),
    [sym_number_literal] = ACTIONS(1464),
    [anon_sym_L_SQUOTE] = ACTIONS(1464),
    [anon_sym_u_SQUOTE] = ACTIONS(1464),
    [anon_sym_U_SQUOTE] = ACTIONS(1464),
    [anon_sym_u8_SQUOTE] = ACTIONS(1464),
    [anon_sym_SQUOTE] = ACTIONS(1464),
    [anon_sym_L_DQUOTE] = ACTIONS(1464),
    [anon_sym_u_DQUOTE] = ACTIONS(1464),
    [anon_sym_U_DQUOTE] = ACTIONS(1464),
    [anon_sym_u8_DQUOTE] = ACTIONS(1464),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_true] = ACTIONS(1462),
    [sym_false] = ACTIONS(1462),
    [anon_sym_NULL] = ACTIONS(1462),
    [anon_sym_nullptr] = ACTIONS(1462),
    [sym_comment] = ACTIONS(3),
  },
  [246] = {
    [sym_identifier] = ACTIONS(1530),
    [aux_sym_preproc_include_token1] = ACTIONS(1530),
    [aux_sym_preproc_def_token1] = ACTIONS(1530),
    [aux_sym_preproc_if_token1] = ACTIONS(1530),
    [aux_sym_preproc_if_token2] = ACTIONS(1530),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1530),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1530),
    [aux_sym_preproc_else_token1] = ACTIONS(1530),
    [aux_sym_preproc_elif_token1] = ACTIONS(1530),
    [sym_preproc_directive] = ACTIONS(1530),
    [anon_sym_LPAREN2] = ACTIONS(1532),
    [anon_sym_BANG] = ACTIONS(1532),
    [anon_sym_TILDE] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(1530),
    [anon_sym_PLUS] = ACTIONS(1530),
    [anon_sym_STAR] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_SEMI] = ACTIONS(1532),
    [anon_sym___extension__] = ACTIONS(1530),
    [anon_sym_typedef] = ACTIONS(1530),
    [anon_sym_extern] = ACTIONS(1530),
    [anon_sym___attribute__] = ACTIONS(1530),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1532),
    [anon_sym___declspec] = ACTIONS(1530),
    [anon_sym___cdecl] = ACTIONS(1530),
    [anon_sym___clrcall] = ACTIONS(1530),
    [anon_sym___stdcall] = ACTIONS(1530),
    [anon_sym___fastcall] = ACTIONS(1530),
    [anon_sym___thiscall] = ACTIONS(1530),
    [anon_sym___vectorcall] = ACTIONS(1530),
    [anon_sym_LBRACE] = ACTIONS(1532),
    [anon_sym_signed] = ACTIONS(1530),
    [anon_sym_unsigned] = ACTIONS(1530),
    [anon_sym_long] = ACTIONS(1530),
    [anon_sym_short] = ACTIONS(1530),
    [anon_sym_static] = ACTIONS(1530),
    [anon_sym_auto] = ACTIONS(1530),
    [anon_sym_register] = ACTIONS(1530),
    [anon_sym_inline] = ACTIONS(1530),
    [anon_sym___inline] = ACTIONS(1530),
    [anon_sym___inline__] = ACTIONS(1530),
    [anon_sym___forceinline] = ACTIONS(1530),
    [anon_sym_thread_local] = ACTIONS(1530),
    [anon_sym___thread] = ACTIONS(1530),
    [anon_sym_const] = ACTIONS(1530),
    [anon_sym_constexpr] = ACTIONS(1530),
    [anon_sym_volatile] = ACTIONS(1530),
    [anon_sym_restrict] = ACTIONS(1530),
    [anon_sym___restrict__] = ACTIONS(1530),
    [anon_sym__Atomic] = ACTIONS(1530),
    [anon_sym__Noreturn] = ACTIONS(1530),
    [anon_sym_noreturn] = ACTIONS(1530),
    [sym_primitive_type] = ACTIONS(1530),
    [anon_sym_enum] = ACTIONS(1530),
    [anon_sym_struct] = ACTIONS(1530),
    [anon_sym_union] = ACTIONS(1530),
    [anon_sym_if] = ACTIONS(1530),
    [anon_sym_switch] = ACTIONS(1530),
    [anon_sym_case] = ACTIONS(1530),
    [anon_sym_default] = ACTIONS(1530),
    [anon_sym_while] = ACTIONS(1530),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1530),
    [anon_sym_return] = ACTIONS(1530),
    [anon_sym_break] = ACTIONS(1530),
    [anon_sym_continue] = ACTIONS(1530),
    [anon_sym_goto] = ACTIONS(1530),
    [anon_sym___try] = ACTIONS(1530),
    [anon_sym___leave] = ACTIONS(1530),
    [anon_sym_DASH_DASH] = ACTIONS(1532),
    [anon_sym_PLUS_PLUS] = ACTIONS(1532),
    [anon_sym_sizeof] = ACTIONS(1530),
    [anon_sym___alignof__] = ACTIONS(1530),
    [anon_sym___alignof] = ACTIONS(1530),
    [anon_sym__alignof] = ACTIONS(1530),
    [anon_sym_alignof] = ACTIONS(1530),
    [anon_sym__Alignof] = ACTIONS(1530),
    [anon_sym_offsetof] = ACTIONS(1530),
    [anon_sym__Generic] = ACTIONS(1530),
    [anon_sym_asm] = ACTIONS(1530),
    [anon_sym___asm__] = ACTIONS(1530),
    [sym_number_literal] = ACTIONS(1532),
    [anon_sym_L_SQUOTE] = ACTIONS(1532),
    [anon_sym_u_SQUOTE] = ACTIONS(1532),
    [anon_sym_U_SQUOTE] = ACTIONS(1532),
    [anon_sym_u8_SQUOTE] = ACTIONS(1532),
    [anon_sym_SQUOTE] = ACTIONS(1532),
    [anon_sym_L_DQUOTE] = ACTIONS(1532),
    [anon_sym_u_DQUOTE] = ACTIONS(1532),
    [anon_sym_U_DQUOTE] = ACTIONS(1532),
    [anon_sym_u8_DQUOTE] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [sym_true] = ACTIONS(1530),
    [sym_false] = ACTIONS(1530),
    [anon_sym_NULL] = ACTIONS(1530),
    [anon_sym_nullptr] = ACTIONS(1530),
    [sym_comment] = ACTIONS(3),
  },
  [247] = {
    [sym_identifier] = ACTIONS(1454),
    [aux_sym_preproc_include_token1] = ACTIONS(1454),
    [aux_sym_preproc_def_token1] = ACTIONS(1454),
    [aux_sym_preproc_if_token1] = ACTIONS(1454),
    [aux_sym_preproc_if_token2] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1454),
    [aux_sym_preproc_else_token1] = ACTIONS(1454),
    [aux_sym_preproc_elif_token1] = ACTIONS(1454),
    [sym_preproc_directive] = ACTIONS(1454),
    [anon_sym_LPAREN2] = ACTIONS(1456),
    [anon_sym_BANG] = ACTIONS(1456),
    [anon_sym_TILDE] = ACTIONS(1456),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_STAR] = ACTIONS(1456),
    [anon_sym_AMP] = ACTIONS(1456),
    [anon_sym_SEMI] = ACTIONS(1456),
    [anon_sym___extension__] = ACTIONS(1454),
    [anon_sym_typedef] = ACTIONS(1454),
    [anon_sym_extern] = ACTIONS(1454),
    [anon_sym___attribute__] = ACTIONS(1454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1456),
    [anon_sym___declspec] = ACTIONS(1454),
    [anon_sym___cdecl] = ACTIONS(1454),
    [anon_sym___clrcall] = ACTIONS(1454),
    [anon_sym___stdcall] = ACTIONS(1454),
    [anon_sym___fastcall] = ACTIONS(1454),
    [anon_sym___thiscall] = ACTIONS(1454),
    [anon_sym___vectorcall] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [anon_sym_signed] = ACTIONS(1454),
    [anon_sym_unsigned] = ACTIONS(1454),
    [anon_sym_long] = ACTIONS(1454),
    [anon_sym_short] = ACTIONS(1454),
    [anon_sym_static] = ACTIONS(1454),
    [anon_sym_auto] = ACTIONS(1454),
    [anon_sym_register] = ACTIONS(1454),
    [anon_sym_inline] = ACTIONS(1454),
    [anon_sym___inline] = ACTIONS(1454),
    [anon_sym___inline__] = ACTIONS(1454),
    [anon_sym___forceinline] = ACTIONS(1454),
    [anon_sym_thread_local] = ACTIONS(1454),
    [anon_sym___thread] = ACTIONS(1454),
    [anon_sym_const] = ACTIONS(1454),
    [anon_sym_constexpr] = ACTIONS(1454),
    [anon_sym_volatile] = ACTIONS(1454),
    [anon_sym_restrict] = ACTIONS(1454),
    [anon_sym___restrict__] = ACTIONS(1454),
    [anon_sym__Atomic] = ACTIONS(1454),
    [anon_sym__Noreturn] = ACTIONS(1454),
    [anon_sym_noreturn] = ACTIONS(1454),
    [sym_primitive_type] = ACTIONS(1454),
    [anon_sym_enum] = ACTIONS(1454),
    [anon_sym_struct] = ACTIONS(1454),
    [anon_sym_union] = ACTIONS(1454),
    [anon_sym_if] = ACTIONS(1454),
    [anon_sym_switch] = ACTIONS(1454),
    [anon_sym_case] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(1454),
    [anon_sym_do] = ACTIONS(1454),
    [anon_sym_for] = ACTIONS(1454),
    [anon_sym_return] = ACTIONS(1454),
    [anon_sym_break] = ACTIONS(1454),
    [anon_sym_continue] = ACTIONS(1454),
    [anon_sym_goto] = ACTIONS(1454),
    [anon_sym___try] = ACTIONS(1454),
    [anon_sym___leave] = ACTIONS(1454),
    [anon_sym_DASH_DASH] = ACTIONS(1456),
    [anon_sym_PLUS_PLUS] = ACTIONS(1456),
    [anon_sym_sizeof] = ACTIONS(1454),
    [anon_sym___alignof__] = ACTIONS(1454),
    [anon_sym___alignof] = ACTIONS(1454),
    [anon_sym__alignof] = ACTIONS(1454),
    [anon_sym_alignof] = ACTIONS(1454),
    [anon_sym__Alignof] = ACTIONS(1454),
    [anon_sym_offsetof] = ACTIONS(1454),
    [anon_sym__Generic] = ACTIONS(1454),
    [anon_sym_asm] = ACTIONS(1454),
    [anon_sym___asm__] = ACTIONS(1454),
    [sym_number_literal] = ACTIONS(1456),
    [anon_sym_L_SQUOTE] = ACTIONS(1456),
    [anon_sym_u_SQUOTE] = ACTIONS(1456),
    [anon_sym_U_SQUOTE] = ACTIONS(1456),
    [anon_sym_u8_SQUOTE] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(1456),
    [anon_sym_L_DQUOTE] = ACTIONS(1456),
    [anon_sym_u_DQUOTE] = ACTIONS(1456),
    [anon_sym_U_DQUOTE] = ACTIONS(1456),
    [anon_sym_u8_DQUOTE] = ACTIONS(1456),
    [anon_sym_DQUOTE] = ACTIONS(1456),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [anon_sym_NULL] = ACTIONS(1454),
    [anon_sym_nullptr] = ACTIONS(1454),
    [sym_comment] = ACTIONS(3),
  },
  [248] = {
    [sym_identifier] = ACTIONS(1422),
    [aux_sym_preproc_include_token1] = ACTIONS(1422),
    [aux_sym_preproc_def_token1] = ACTIONS(1422),
    [aux_sym_preproc_if_token1] = ACTIONS(1422),
    [aux_sym_preproc_if_token2] = ACTIONS(1422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1422),
    [aux_sym_preproc_else_token1] = ACTIONS(1422),
    [aux_sym_preproc_elif_token1] = ACTIONS(1422),
    [sym_preproc_directive] = ACTIONS(1422),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(1424),
    [anon_sym_TILDE] = ACTIONS(1424),
    [anon_sym_DASH] = ACTIONS(1422),
    [anon_sym_PLUS] = ACTIONS(1422),
    [anon_sym_STAR] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym___extension__] = ACTIONS(1422),
    [anon_sym_typedef] = ACTIONS(1422),
    [anon_sym_extern] = ACTIONS(1422),
    [anon_sym___attribute__] = ACTIONS(1422),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1424),
    [anon_sym___declspec] = ACTIONS(1422),
    [anon_sym___cdecl] = ACTIONS(1422),
    [anon_sym___clrcall] = ACTIONS(1422),
    [anon_sym___stdcall] = ACTIONS(1422),
    [anon_sym___fastcall] = ACTIONS(1422),
    [anon_sym___thiscall] = ACTIONS(1422),
    [anon_sym___vectorcall] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(1424),
    [anon_sym_signed] = ACTIONS(1422),
    [anon_sym_unsigned] = ACTIONS(1422),
    [anon_sym_long] = ACTIONS(1422),
    [anon_sym_short] = ACTIONS(1422),
    [anon_sym_static] = ACTIONS(1422),
    [anon_sym_auto] = ACTIONS(1422),
    [anon_sym_register] = ACTIONS(1422),
    [anon_sym_inline] = ACTIONS(1422),
    [anon_sym___inline] = ACTIONS(1422),
    [anon_sym___inline__] = ACTIONS(1422),
    [anon_sym___forceinline] = ACTIONS(1422),
    [anon_sym_thread_local] = ACTIONS(1422),
    [anon_sym___thread] = ACTIONS(1422),
    [anon_sym_const] = ACTIONS(1422),
    [anon_sym_constexpr] = ACTIONS(1422),
    [anon_sym_volatile] = ACTIONS(1422),
    [anon_sym_restrict] = ACTIONS(1422),
    [anon_sym___restrict__] = ACTIONS(1422),
    [anon_sym__Atomic] = ACTIONS(1422),
    [anon_sym__Noreturn] = ACTIONS(1422),
    [anon_sym_noreturn] = ACTIONS(1422),
    [sym_primitive_type] = ACTIONS(1422),
    [anon_sym_enum] = ACTIONS(1422),
    [anon_sym_struct] = ACTIONS(1422),
    [anon_sym_union] = ACTIONS(1422),
    [anon_sym_if] = ACTIONS(1422),
    [anon_sym_switch] = ACTIONS(1422),
    [anon_sym_case] = ACTIONS(1422),
    [anon_sym_default] = ACTIONS(1422),
    [anon_sym_while] = ACTIONS(1422),
    [anon_sym_do] = ACTIONS(1422),
    [anon_sym_for] = ACTIONS(1422),
    [anon_sym_return] = ACTIONS(1422),
    [anon_sym_break] = ACTIONS(1422),
    [anon_sym_continue] = ACTIONS(1422),
    [anon_sym_goto] = ACTIONS(1422),
    [anon_sym___try] = ACTIONS(1422),
    [anon_sym___leave] = ACTIONS(1422),
    [anon_sym_DASH_DASH] = ACTIONS(1424),
    [anon_sym_PLUS_PLUS] = ACTIONS(1424),
    [anon_sym_sizeof] = ACTIONS(1422),
    [anon_sym___alignof__] = ACTIONS(1422),
    [anon_sym___alignof] = ACTIONS(1422),
    [anon_sym__alignof] = ACTIONS(1422),
    [anon_sym_alignof] = ACTIONS(1422),
    [anon_sym__Alignof] = ACTIONS(1422),
    [anon_sym_offsetof] = ACTIONS(1422),
    [anon_sym__Generic] = ACTIONS(1422),
    [anon_sym_asm] = ACTIONS(1422),
    [anon_sym___asm__] = ACTIONS(1422),
    [sym_number_literal] = ACTIONS(1424),
    [anon_sym_L_SQUOTE] = ACTIONS(1424),
    [anon_sym_u_SQUOTE] = ACTIONS(1424),
    [anon_sym_U_SQUOTE] = ACTIONS(1424),
    [anon_sym_u8_SQUOTE] = ACTIONS(1424),
    [anon_sym_SQUOTE] = ACTIONS(1424),
    [anon_sym_L_DQUOTE] = ACTIONS(1424),
    [anon_sym_u_DQUOTE] = ACTIONS(1424),
    [anon_sym_U_DQUOTE] = ACTIONS(1424),
    [anon_sym_u8_DQUOTE] = ACTIONS(1424),
    [anon_sym_DQUOTE] = ACTIONS(1424),
    [sym_true] = ACTIONS(1422),
    [sym_false] = ACTIONS(1422),
    [anon_sym_NULL] = ACTIONS(1422),
    [anon_sym_nullptr] = ACTIONS(1422),
    [sym_comment] = ACTIONS(3),
  },
  [249] = {
    [sym_identifier] = ACTIONS(1502),
    [aux_sym_preproc_include_token1] = ACTIONS(1502),
    [aux_sym_preproc_def_token1] = ACTIONS(1502),
    [aux_sym_preproc_if_token1] = ACTIONS(1502),
    [aux_sym_preproc_if_token2] = ACTIONS(1502),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1502),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1502),
    [aux_sym_preproc_else_token1] = ACTIONS(1502),
    [aux_sym_preproc_elif_token1] = ACTIONS(1502),
    [sym_preproc_directive] = ACTIONS(1502),
    [anon_sym_LPAREN2] = ACTIONS(1504),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_TILDE] = ACTIONS(1504),
    [anon_sym_DASH] = ACTIONS(1502),
    [anon_sym_PLUS] = ACTIONS(1502),
    [anon_sym_STAR] = ACTIONS(1504),
    [anon_sym_AMP] = ACTIONS(1504),
    [anon_sym_SEMI] = ACTIONS(1504),
    [anon_sym___extension__] = ACTIONS(1502),
    [anon_sym_typedef] = ACTIONS(1502),
    [anon_sym_extern] = ACTIONS(1502),
    [anon_sym___attribute__] = ACTIONS(1502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1504),
    [anon_sym___declspec] = ACTIONS(1502),
    [anon_sym___cdecl] = ACTIONS(1502),
    [anon_sym___clrcall] = ACTIONS(1502),
    [anon_sym___stdcall] = ACTIONS(1502),
    [anon_sym___fastcall] = ACTIONS(1502),
    [anon_sym___thiscall] = ACTIONS(1502),
    [anon_sym___vectorcall] = ACTIONS(1502),
    [anon_sym_LBRACE] = ACTIONS(1504),
    [anon_sym_signed] = ACTIONS(1502),
    [anon_sym_unsigned] = ACTIONS(1502),
    [anon_sym_long] = ACTIONS(1502),
    [anon_sym_short] = ACTIONS(1502),
    [anon_sym_static] = ACTIONS(1502),
    [anon_sym_auto] = ACTIONS(1502),
    [anon_sym_register] = ACTIONS(1502),
    [anon_sym_inline] = ACTIONS(1502),
    [anon_sym___inline] = ACTIONS(1502),
    [anon_sym___inline__] = ACTIONS(1502),
    [anon_sym___forceinline] = ACTIONS(1502),
    [anon_sym_thread_local] = ACTIONS(1502),
    [anon_sym___thread] = ACTIONS(1502),
    [anon_sym_const] = ACTIONS(1502),
    [anon_sym_constexpr] = ACTIONS(1502),
    [anon_sym_volatile] = ACTIONS(1502),
    [anon_sym_restrict] = ACTIONS(1502),
    [anon_sym___restrict__] = ACTIONS(1502),
    [anon_sym__Atomic] = ACTIONS(1502),
    [anon_sym__Noreturn] = ACTIONS(1502),
    [anon_sym_noreturn] = ACTIONS(1502),
    [sym_primitive_type] = ACTIONS(1502),
    [anon_sym_enum] = ACTIONS(1502),
    [anon_sym_struct] = ACTIONS(1502),
    [anon_sym_union] = ACTIONS(1502),
    [anon_sym_if] = ACTIONS(1502),
    [anon_sym_switch] = ACTIONS(1502),
    [anon_sym_case] = ACTIONS(1502),
    [anon_sym_default] = ACTIONS(1502),
    [anon_sym_while] = ACTIONS(1502),
    [anon_sym_do] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1502),
    [anon_sym_return] = ACTIONS(1502),
    [anon_sym_break] = ACTIONS(1502),
    [anon_sym_continue] = ACTIONS(1502),
    [anon_sym_goto] = ACTIONS(1502),
    [anon_sym___try] = ACTIONS(1502),
    [anon_sym___leave] = ACTIONS(1502),
    [anon_sym_DASH_DASH] = ACTIONS(1504),
    [anon_sym_PLUS_PLUS] = ACTIONS(1504),
    [anon_sym_sizeof] = ACTIONS(1502),
    [anon_sym___alignof__] = ACTIONS(1502),
    [anon_sym___alignof] = ACTIONS(1502),
    [anon_sym__alignof] = ACTIONS(1502),
    [anon_sym_alignof] = ACTIONS(1502),
    [anon_sym__Alignof] = ACTIONS(1502),
    [anon_sym_offsetof] = ACTIONS(1502),
    [anon_sym__Generic] = ACTIONS(1502),
    [anon_sym_asm] = ACTIONS(1502),
    [anon_sym___asm__] = ACTIONS(1502),
    [sym_number_literal] = ACTIONS(1504),
    [anon_sym_L_SQUOTE] = ACTIONS(1504),
    [anon_sym_u_SQUOTE] = ACTIONS(1504),
    [anon_sym_U_SQUOTE] = ACTIONS(1504),
    [anon_sym_u8_SQUOTE] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(1504),
    [anon_sym_L_DQUOTE] = ACTIONS(1504),
    [anon_sym_u_DQUOTE] = ACTIONS(1504),
    [anon_sym_U_DQUOTE] = ACTIONS(1504),
    [anon_sym_u8_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE] = ACTIONS(1504),
    [sym_true] = ACTIONS(1502),
    [sym_false] = ACTIONS(1502),
    [anon_sym_NULL] = ACTIONS(1502),
    [anon_sym_nullptr] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [250] = {
    [sym_identifier] = ACTIONS(1450),
    [aux_sym_preproc_include_token1] = ACTIONS(1450),
    [aux_sym_preproc_def_token1] = ACTIONS(1450),
    [aux_sym_preproc_if_token1] = ACTIONS(1450),
    [aux_sym_preproc_if_token2] = ACTIONS(1450),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1450),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1450),
    [aux_sym_preproc_else_token1] = ACTIONS(1450),
    [aux_sym_preproc_elif_token1] = ACTIONS(1450),
    [sym_preproc_directive] = ACTIONS(1450),
    [anon_sym_LPAREN2] = ACTIONS(1452),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_TILDE] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1450),
    [anon_sym_PLUS] = ACTIONS(1450),
    [anon_sym_STAR] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1452),
    [anon_sym_SEMI] = ACTIONS(1452),
    [anon_sym___extension__] = ACTIONS(1450),
    [anon_sym_typedef] = ACTIONS(1450),
    [anon_sym_extern] = ACTIONS(1450),
    [anon_sym___attribute__] = ACTIONS(1450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1452),
    [anon_sym___declspec] = ACTIONS(1450),
    [anon_sym___cdecl] = ACTIONS(1450),
    [anon_sym___clrcall] = ACTIONS(1450),
    [anon_sym___stdcall] = ACTIONS(1450),
    [anon_sym___fastcall] = ACTIONS(1450),
    [anon_sym___thiscall] = ACTIONS(1450),
    [anon_sym___vectorcall] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(1452),
    [anon_sym_signed] = ACTIONS(1450),
    [anon_sym_unsigned] = ACTIONS(1450),
    [anon_sym_long] = ACTIONS(1450),
    [anon_sym_short] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(1450),
    [anon_sym_auto] = ACTIONS(1450),
    [anon_sym_register] = ACTIONS(1450),
    [anon_sym_inline] = ACTIONS(1450),
    [anon_sym___inline] = ACTIONS(1450),
    [anon_sym___inline__] = ACTIONS(1450),
    [anon_sym___forceinline] = ACTIONS(1450),
    [anon_sym_thread_local] = ACTIONS(1450),
    [anon_sym___thread] = ACTIONS(1450),
    [anon_sym_const] = ACTIONS(1450),
    [anon_sym_constexpr] = ACTIONS(1450),
    [anon_sym_volatile] = ACTIONS(1450),
    [anon_sym_restrict] = ACTIONS(1450),
    [anon_sym___restrict__] = ACTIONS(1450),
    [anon_sym__Atomic] = ACTIONS(1450),
    [anon_sym__Noreturn] = ACTIONS(1450),
    [anon_sym_noreturn] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(1450),
    [anon_sym_enum] = ACTIONS(1450),
    [anon_sym_struct] = ACTIONS(1450),
    [anon_sym_union] = ACTIONS(1450),
    [anon_sym_if] = ACTIONS(1450),
    [anon_sym_switch] = ACTIONS(1450),
    [anon_sym_case] = ACTIONS(1450),
    [anon_sym_default] = ACTIONS(1450),
    [anon_sym_while] = ACTIONS(1450),
    [anon_sym_do] = ACTIONS(1450),
    [anon_sym_for] = ACTIONS(1450),
    [anon_sym_return] = ACTIONS(1450),
    [anon_sym_break] = ACTIONS(1450),
    [anon_sym_continue] = ACTIONS(1450),
    [anon_sym_goto] = ACTIONS(1450),
    [anon_sym___try] = ACTIONS(1450),
    [anon_sym___leave] = ACTIONS(1450),
    [anon_sym_DASH_DASH] = ACTIONS(1452),
    [anon_sym_PLUS_PLUS] = ACTIONS(1452),
    [anon_sym_sizeof] = ACTIONS(1450),
    [anon_sym___alignof__] = ACTIONS(1450),
    [anon_sym___alignof] = ACTIONS(1450),
    [anon_sym__alignof] = ACTIONS(1450),
    [anon_sym_alignof] = ACTIONS(1450),
    [anon_sym__Alignof] = ACTIONS(1450),
    [anon_sym_offsetof] = ACTIONS(1450),
    [anon_sym__Generic] = ACTIONS(1450),
    [anon_sym_asm] = ACTIONS(1450),
    [anon_sym___asm__] = ACTIONS(1450),
    [sym_number_literal] = ACTIONS(1452),
    [anon_sym_L_SQUOTE] = ACTIONS(1452),
    [anon_sym_u_SQUOTE] = ACTIONS(1452),
    [anon_sym_U_SQUOTE] = ACTIONS(1452),
    [anon_sym_u8_SQUOTE] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [anon_sym_L_DQUOTE] = ACTIONS(1452),
    [anon_sym_u_DQUOTE] = ACTIONS(1452),
    [anon_sym_U_DQUOTE] = ACTIONS(1452),
    [anon_sym_u8_DQUOTE] = ACTIONS(1452),
    [anon_sym_DQUOTE] = ACTIONS(1452),
    [sym_true] = ACTIONS(1450),
    [sym_false] = ACTIONS(1450),
    [anon_sym_NULL] = ACTIONS(1450),
    [anon_sym_nullptr] = ACTIONS(1450),
    [sym_comment] = ACTIONS(3),
  },
  [251] = {
    [sym_identifier] = ACTIONS(1442),
    [aux_sym_preproc_include_token1] = ACTIONS(1442),
    [aux_sym_preproc_def_token1] = ACTIONS(1442),
    [aux_sym_preproc_if_token1] = ACTIONS(1442),
    [aux_sym_preproc_if_token2] = ACTIONS(1442),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1442),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1442),
    [aux_sym_preproc_else_token1] = ACTIONS(1442),
    [aux_sym_preproc_elif_token1] = ACTIONS(1442),
    [sym_preproc_directive] = ACTIONS(1442),
    [anon_sym_LPAREN2] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1444),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1444),
    [anon_sym___extension__] = ACTIONS(1442),
    [anon_sym_typedef] = ACTIONS(1442),
    [anon_sym_extern] = ACTIONS(1442),
    [anon_sym___attribute__] = ACTIONS(1442),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1444),
    [anon_sym___declspec] = ACTIONS(1442),
    [anon_sym___cdecl] = ACTIONS(1442),
    [anon_sym___clrcall] = ACTIONS(1442),
    [anon_sym___stdcall] = ACTIONS(1442),
    [anon_sym___fastcall] = ACTIONS(1442),
    [anon_sym___thiscall] = ACTIONS(1442),
    [anon_sym___vectorcall] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1444),
    [anon_sym_signed] = ACTIONS(1442),
    [anon_sym_unsigned] = ACTIONS(1442),
    [anon_sym_long] = ACTIONS(1442),
    [anon_sym_short] = ACTIONS(1442),
    [anon_sym_static] = ACTIONS(1442),
    [anon_sym_auto] = ACTIONS(1442),
    [anon_sym_register] = ACTIONS(1442),
    [anon_sym_inline] = ACTIONS(1442),
    [anon_sym___inline] = ACTIONS(1442),
    [anon_sym___inline__] = ACTIONS(1442),
    [anon_sym___forceinline] = ACTIONS(1442),
    [anon_sym_thread_local] = ACTIONS(1442),
    [anon_sym___thread] = ACTIONS(1442),
    [anon_sym_const] = ACTIONS(1442),
    [anon_sym_constexpr] = ACTIONS(1442),
    [anon_sym_volatile] = ACTIONS(1442),
    [anon_sym_restrict] = ACTIONS(1442),
    [anon_sym___restrict__] = ACTIONS(1442),
    [anon_sym__Atomic] = ACTIONS(1442),
    [anon_sym__Noreturn] = ACTIONS(1442),
    [anon_sym_noreturn] = ACTIONS(1442),
    [sym_primitive_type] = ACTIONS(1442),
    [anon_sym_enum] = ACTIONS(1442),
    [anon_sym_struct] = ACTIONS(1442),
    [anon_sym_union] = ACTIONS(1442),
    [anon_sym_if] = ACTIONS(1442),
    [anon_sym_switch] = ACTIONS(1442),
    [anon_sym_case] = ACTIONS(1442),
    [anon_sym_default] = ACTIONS(1442),
    [anon_sym_while] = ACTIONS(1442),
    [anon_sym_do] = ACTIONS(1442),
    [anon_sym_for] = ACTIONS(1442),
    [anon_sym_return] = ACTIONS(1442),
    [anon_sym_break] = ACTIONS(1442),
    [anon_sym_continue] = ACTIONS(1442),
    [anon_sym_goto] = ACTIONS(1442),
    [anon_sym___try] = ACTIONS(1442),
    [anon_sym___leave] = ACTIONS(1442),
    [anon_sym_DASH_DASH] = ACTIONS(1444),
    [anon_sym_PLUS_PLUS] = ACTIONS(1444),
    [anon_sym_sizeof] = ACTIONS(1442),
    [anon_sym___alignof__] = ACTIONS(1442),
    [anon_sym___alignof] = ACTIONS(1442),
    [anon_sym__alignof] = ACTIONS(1442),
    [anon_sym_alignof] = ACTIONS(1442),
    [anon_sym__Alignof] = ACTIONS(1442),
    [anon_sym_offsetof] = ACTIONS(1442),
    [anon_sym__Generic] = ACTIONS(1442),
    [anon_sym_asm] = ACTIONS(1442),
    [anon_sym___asm__] = ACTIONS(1442),
    [sym_number_literal] = ACTIONS(1444),
    [anon_sym_L_SQUOTE] = ACTIONS(1444),
    [anon_sym_u_SQUOTE] = ACTIONS(1444),
    [anon_sym_U_SQUOTE] = ACTIONS(1444),
    [anon_sym_u8_SQUOTE] = ACTIONS(1444),
    [anon_sym_SQUOTE] = ACTIONS(1444),
    [anon_sym_L_DQUOTE] = ACTIONS(1444),
    [anon_sym_u_DQUOTE] = ACTIONS(1444),
    [anon_sym_U_DQUOTE] = ACTIONS(1444),
    [anon_sym_u8_DQUOTE] = ACTIONS(1444),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [sym_true] = ACTIONS(1442),
    [sym_false] = ACTIONS(1442),
    [anon_sym_NULL] = ACTIONS(1442),
    [anon_sym_nullptr] = ACTIONS(1442),
    [sym_comment] = ACTIONS(3),
  },
  [252] = {
    [sym_identifier] = ACTIONS(1498),
    [aux_sym_preproc_include_token1] = ACTIONS(1498),
    [aux_sym_preproc_def_token1] = ACTIONS(1498),
    [aux_sym_preproc_if_token1] = ACTIONS(1498),
    [aux_sym_preproc_if_token2] = ACTIONS(1498),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1498),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1498),
    [aux_sym_preproc_else_token1] = ACTIONS(1498),
    [aux_sym_preproc_elif_token1] = ACTIONS(1498),
    [sym_preproc_directive] = ACTIONS(1498),
    [anon_sym_LPAREN2] = ACTIONS(1500),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_TILDE] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1498),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_SEMI] = ACTIONS(1500),
    [anon_sym___extension__] = ACTIONS(1498),
    [anon_sym_typedef] = ACTIONS(1498),
    [anon_sym_extern] = ACTIONS(1498),
    [anon_sym___attribute__] = ACTIONS(1498),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1500),
    [anon_sym___declspec] = ACTIONS(1498),
    [anon_sym___cdecl] = ACTIONS(1498),
    [anon_sym___clrcall] = ACTIONS(1498),
    [anon_sym___stdcall] = ACTIONS(1498),
    [anon_sym___fastcall] = ACTIONS(1498),
    [anon_sym___thiscall] = ACTIONS(1498),
    [anon_sym___vectorcall] = ACTIONS(1498),
    [anon_sym_LBRACE] = ACTIONS(1500),
    [anon_sym_signed] = ACTIONS(1498),
    [anon_sym_unsigned] = ACTIONS(1498),
    [anon_sym_long] = ACTIONS(1498),
    [anon_sym_short] = ACTIONS(1498),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_auto] = ACTIONS(1498),
    [anon_sym_register] = ACTIONS(1498),
    [anon_sym_inline] = ACTIONS(1498),
    [anon_sym___inline] = ACTIONS(1498),
    [anon_sym___inline__] = ACTIONS(1498),
    [anon_sym___forceinline] = ACTIONS(1498),
    [anon_sym_thread_local] = ACTIONS(1498),
    [anon_sym___thread] = ACTIONS(1498),
    [anon_sym_const] = ACTIONS(1498),
    [anon_sym_constexpr] = ACTIONS(1498),
    [anon_sym_volatile] = ACTIONS(1498),
    [anon_sym_restrict] = ACTIONS(1498),
    [anon_sym___restrict__] = ACTIONS(1498),
    [anon_sym__Atomic] = ACTIONS(1498),
    [anon_sym__Noreturn] = ACTIONS(1498),
    [anon_sym_noreturn] = ACTIONS(1498),
    [sym_primitive_type] = ACTIONS(1498),
    [anon_sym_enum] = ACTIONS(1498),
    [anon_sym_struct] = ACTIONS(1498),
    [anon_sym_union] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1498),
    [anon_sym_switch] = ACTIONS(1498),
    [anon_sym_case] = ACTIONS(1498),
    [anon_sym_default] = ACTIONS(1498),
    [anon_sym_while] = ACTIONS(1498),
    [anon_sym_do] = ACTIONS(1498),
    [anon_sym_for] = ACTIONS(1498),
    [anon_sym_return] = ACTIONS(1498),
    [anon_sym_break] = ACTIONS(1498),
    [anon_sym_continue] = ACTIONS(1498),
    [anon_sym_goto] = ACTIONS(1498),
    [anon_sym___try] = ACTIONS(1498),
    [anon_sym___leave] = ACTIONS(1498),
    [anon_sym_DASH_DASH] = ACTIONS(1500),
    [anon_sym_PLUS_PLUS] = ACTIONS(1500),
    [anon_sym_sizeof] = ACTIONS(1498),
    [anon_sym___alignof__] = ACTIONS(1498),
    [anon_sym___alignof] = ACTIONS(1498),
    [anon_sym__alignof] = ACTIONS(1498),
    [anon_sym_alignof] = ACTIONS(1498),
    [anon_sym__Alignof] = ACTIONS(1498),
    [anon_sym_offsetof] = ACTIONS(1498),
    [anon_sym__Generic] = ACTIONS(1498),
    [anon_sym_asm] = ACTIONS(1498),
    [anon_sym___asm__] = ACTIONS(1498),
    [sym_number_literal] = ACTIONS(1500),
    [anon_sym_L_SQUOTE] = ACTIONS(1500),
    [anon_sym_u_SQUOTE] = ACTIONS(1500),
    [anon_sym_U_SQUOTE] = ACTIONS(1500),
    [anon_sym_u8_SQUOTE] = ACTIONS(1500),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_L_DQUOTE] = ACTIONS(1500),
    [anon_sym_u_DQUOTE] = ACTIONS(1500),
    [anon_sym_U_DQUOTE] = ACTIONS(1500),
    [anon_sym_u8_DQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE] = ACTIONS(1500),
    [sym_true] = ACTIONS(1498),
    [sym_false] = ACTIONS(1498),
    [anon_sym_NULL] = ACTIONS(1498),
    [anon_sym_nullptr] = ACTIONS(1498),
    [sym_comment] = ACTIONS(3),
  },
  [253] = {
    [sym_identifier] = ACTIONS(1466),
    [aux_sym_preproc_include_token1] = ACTIONS(1466),
    [aux_sym_preproc_def_token1] = ACTIONS(1466),
    [aux_sym_preproc_if_token1] = ACTIONS(1466),
    [aux_sym_preproc_if_token2] = ACTIONS(1466),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1466),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1466),
    [aux_sym_preproc_else_token1] = ACTIONS(1466),
    [aux_sym_preproc_elif_token1] = ACTIONS(1466),
    [sym_preproc_directive] = ACTIONS(1466),
    [anon_sym_LPAREN2] = ACTIONS(1468),
    [anon_sym_BANG] = ACTIONS(1468),
    [anon_sym_TILDE] = ACTIONS(1468),
    [anon_sym_DASH] = ACTIONS(1466),
    [anon_sym_PLUS] = ACTIONS(1466),
    [anon_sym_STAR] = ACTIONS(1468),
    [anon_sym_AMP] = ACTIONS(1468),
    [anon_sym_SEMI] = ACTIONS(1468),
    [anon_sym___extension__] = ACTIONS(1466),
    [anon_sym_typedef] = ACTIONS(1466),
    [anon_sym_extern] = ACTIONS(1466),
    [anon_sym___attribute__] = ACTIONS(1466),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1468),
    [anon_sym___declspec] = ACTIONS(1466),
    [anon_sym___cdecl] = ACTIONS(1466),
    [anon_sym___clrcall] = ACTIONS(1466),
    [anon_sym___stdcall] = ACTIONS(1466),
    [anon_sym___fastcall] = ACTIONS(1466),
    [anon_sym___thiscall] = ACTIONS(1466),
    [anon_sym___vectorcall] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(1468),
    [anon_sym_signed] = ACTIONS(1466),
    [anon_sym_unsigned] = ACTIONS(1466),
    [anon_sym_long] = ACTIONS(1466),
    [anon_sym_short] = ACTIONS(1466),
    [anon_sym_static] = ACTIONS(1466),
    [anon_sym_auto] = ACTIONS(1466),
    [anon_sym_register] = ACTIONS(1466),
    [anon_sym_inline] = ACTIONS(1466),
    [anon_sym___inline] = ACTIONS(1466),
    [anon_sym___inline__] = ACTIONS(1466),
    [anon_sym___forceinline] = ACTIONS(1466),
    [anon_sym_thread_local] = ACTIONS(1466),
    [anon_sym___thread] = ACTIONS(1466),
    [anon_sym_const] = ACTIONS(1466),
    [anon_sym_constexpr] = ACTIONS(1466),
    [anon_sym_volatile] = ACTIONS(1466),
    [anon_sym_restrict] = ACTIONS(1466),
    [anon_sym___restrict__] = ACTIONS(1466),
    [anon_sym__Atomic] = ACTIONS(1466),
    [anon_sym__Noreturn] = ACTIONS(1466),
    [anon_sym_noreturn] = ACTIONS(1466),
    [sym_primitive_type] = ACTIONS(1466),
    [anon_sym_enum] = ACTIONS(1466),
    [anon_sym_struct] = ACTIONS(1466),
    [anon_sym_union] = ACTIONS(1466),
    [anon_sym_if] = ACTIONS(1466),
    [anon_sym_switch] = ACTIONS(1466),
    [anon_sym_case] = ACTIONS(1466),
    [anon_sym_default] = ACTIONS(1466),
    [anon_sym_while] = ACTIONS(1466),
    [anon_sym_do] = ACTIONS(1466),
    [anon_sym_for] = ACTIONS(1466),
    [anon_sym_return] = ACTIONS(1466),
    [anon_sym_break] = ACTIONS(1466),
    [anon_sym_continue] = ACTIONS(1466),
    [anon_sym_goto] = ACTIONS(1466),
    [anon_sym___try] = ACTIONS(1466),
    [anon_sym___leave] = ACTIONS(1466),
    [anon_sym_DASH_DASH] = ACTIONS(1468),
    [anon_sym_PLUS_PLUS] = ACTIONS(1468),
    [anon_sym_sizeof] = ACTIONS(1466),
    [anon_sym___alignof__] = ACTIONS(1466),
    [anon_sym___alignof] = ACTIONS(1466),
    [anon_sym__alignof] = ACTIONS(1466),
    [anon_sym_alignof] = ACTIONS(1466),
    [anon_sym__Alignof] = ACTIONS(1466),
    [anon_sym_offsetof] = ACTIONS(1466),
    [anon_sym__Generic] = ACTIONS(1466),
    [anon_sym_asm] = ACTIONS(1466),
    [anon_sym___asm__] = ACTIONS(1466),
    [sym_number_literal] = ACTIONS(1468),
    [anon_sym_L_SQUOTE] = ACTIONS(1468),
    [anon_sym_u_SQUOTE] = ACTIONS(1468),
    [anon_sym_U_SQUOTE] = ACTIONS(1468),
    [anon_sym_u8_SQUOTE] = ACTIONS(1468),
    [anon_sym_SQUOTE] = ACTIONS(1468),
    [anon_sym_L_DQUOTE] = ACTIONS(1468),
    [anon_sym_u_DQUOTE] = ACTIONS(1468),
    [anon_sym_U_DQUOTE] = ACTIONS(1468),
    [anon_sym_u8_DQUOTE] = ACTIONS(1468),
    [anon_sym_DQUOTE] = ACTIONS(1468),
    [sym_true] = ACTIONS(1466),
    [sym_false] = ACTIONS(1466),
    [anon_sym_NULL] = ACTIONS(1466),
    [anon_sym_nullptr] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
  },
  [254] = {
    [sym_identifier] = ACTIONS(1482),
    [aux_sym_preproc_include_token1] = ACTIONS(1482),
    [aux_sym_preproc_def_token1] = ACTIONS(1482),
    [aux_sym_preproc_if_token1] = ACTIONS(1482),
    [aux_sym_preproc_if_token2] = ACTIONS(1482),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1482),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1482),
    [aux_sym_preproc_else_token1] = ACTIONS(1482),
    [aux_sym_preproc_elif_token1] = ACTIONS(1482),
    [sym_preproc_directive] = ACTIONS(1482),
    [anon_sym_LPAREN2] = ACTIONS(1484),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_TILDE] = ACTIONS(1484),
    [anon_sym_DASH] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_STAR] = ACTIONS(1484),
    [anon_sym_AMP] = ACTIONS(1484),
    [anon_sym_SEMI] = ACTIONS(1484),
    [anon_sym___extension__] = ACTIONS(1482),
    [anon_sym_typedef] = ACTIONS(1482),
    [anon_sym_extern] = ACTIONS(1482),
    [anon_sym___attribute__] = ACTIONS(1482),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1484),
    [anon_sym___declspec] = ACTIONS(1482),
    [anon_sym___cdecl] = ACTIONS(1482),
    [anon_sym___clrcall] = ACTIONS(1482),
    [anon_sym___stdcall] = ACTIONS(1482),
    [anon_sym___fastcall] = ACTIONS(1482),
    [anon_sym___thiscall] = ACTIONS(1482),
    [anon_sym___vectorcall] = ACTIONS(1482),
    [anon_sym_LBRACE] = ACTIONS(1484),
    [anon_sym_signed] = ACTIONS(1482),
    [anon_sym_unsigned] = ACTIONS(1482),
    [anon_sym_long] = ACTIONS(1482),
    [anon_sym_short] = ACTIONS(1482),
    [anon_sym_static] = ACTIONS(1482),
    [anon_sym_auto] = ACTIONS(1482),
    [anon_sym_register] = ACTIONS(1482),
    [anon_sym_inline] = ACTIONS(1482),
    [anon_sym___inline] = ACTIONS(1482),
    [anon_sym___inline__] = ACTIONS(1482),
    [anon_sym___forceinline] = ACTIONS(1482),
    [anon_sym_thread_local] = ACTIONS(1482),
    [anon_sym___thread] = ACTIONS(1482),
    [anon_sym_const] = ACTIONS(1482),
    [anon_sym_constexpr] = ACTIONS(1482),
    [anon_sym_volatile] = ACTIONS(1482),
    [anon_sym_restrict] = ACTIONS(1482),
    [anon_sym___restrict__] = ACTIONS(1482),
    [anon_sym__Atomic] = ACTIONS(1482),
    [anon_sym__Noreturn] = ACTIONS(1482),
    [anon_sym_noreturn] = ACTIONS(1482),
    [sym_primitive_type] = ACTIONS(1482),
    [anon_sym_enum] = ACTIONS(1482),
    [anon_sym_struct] = ACTIONS(1482),
    [anon_sym_union] = ACTIONS(1482),
    [anon_sym_if] = ACTIONS(1482),
    [anon_sym_switch] = ACTIONS(1482),
    [anon_sym_case] = ACTIONS(1482),
    [anon_sym_default] = ACTIONS(1482),
    [anon_sym_while] = ACTIONS(1482),
    [anon_sym_do] = ACTIONS(1482),
    [anon_sym_for] = ACTIONS(1482),
    [anon_sym_return] = ACTIONS(1482),
    [anon_sym_break] = ACTIONS(1482),
    [anon_sym_continue] = ACTIONS(1482),
    [anon_sym_goto] = ACTIONS(1482),
    [anon_sym___try] = ACTIONS(1482),
    [anon_sym___leave] = ACTIONS(1482),
    [anon_sym_DASH_DASH] = ACTIONS(1484),
    [anon_sym_PLUS_PLUS] = ACTIONS(1484),
    [anon_sym_sizeof] = ACTIONS(1482),
    [anon_sym___alignof__] = ACTIONS(1482),
    [anon_sym___alignof] = ACTIONS(1482),
    [anon_sym__alignof] = ACTIONS(1482),
    [anon_sym_alignof] = ACTIONS(1482),
    [anon_sym__Alignof] = ACTIONS(1482),
    [anon_sym_offsetof] = ACTIONS(1482),
    [anon_sym__Generic] = ACTIONS(1482),
    [anon_sym_asm] = ACTIONS(1482),
    [anon_sym___asm__] = ACTIONS(1482),
    [sym_number_literal] = ACTIONS(1484),
    [anon_sym_L_SQUOTE] = ACTIONS(1484),
    [anon_sym_u_SQUOTE] = ACTIONS(1484),
    [anon_sym_U_SQUOTE] = ACTIONS(1484),
    [anon_sym_u8_SQUOTE] = ACTIONS(1484),
    [anon_sym_SQUOTE] = ACTIONS(1484),
    [anon_sym_L_DQUOTE] = ACTIONS(1484),
    [anon_sym_u_DQUOTE] = ACTIONS(1484),
    [anon_sym_U_DQUOTE] = ACTIONS(1484),
    [anon_sym_u8_DQUOTE] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(1484),
    [sym_true] = ACTIONS(1482),
    [sym_false] = ACTIONS(1482),
    [anon_sym_NULL] = ACTIONS(1482),
    [anon_sym_nullptr] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
  },
  [255] = {
    [sym_identifier] = ACTIONS(1402),
    [aux_sym_preproc_include_token1] = ACTIONS(1402),
    [aux_sym_preproc_def_token1] = ACTIONS(1402),
    [aux_sym_preproc_if_token1] = ACTIONS(1402),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1402),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1402),
    [sym_preproc_directive] = ACTIONS(1402),
    [anon_sym_LPAREN2] = ACTIONS(1404),
    [anon_sym_BANG] = ACTIONS(1404),
    [anon_sym_TILDE] = ACTIONS(1404),
    [anon_sym_DASH] = ACTIONS(1402),
    [anon_sym_PLUS] = ACTIONS(1402),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_AMP] = ACTIONS(1404),
    [anon_sym_SEMI] = ACTIONS(1404),
    [anon_sym___extension__] = ACTIONS(1402),
    [anon_sym_typedef] = ACTIONS(1402),
    [anon_sym_extern] = ACTIONS(1402),
    [anon_sym___attribute__] = ACTIONS(1402),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1404),
    [anon_sym___declspec] = ACTIONS(1402),
    [anon_sym___cdecl] = ACTIONS(1402),
    [anon_sym___clrcall] = ACTIONS(1402),
    [anon_sym___stdcall] = ACTIONS(1402),
    [anon_sym___fastcall] = ACTIONS(1402),
    [anon_sym___thiscall] = ACTIONS(1402),
    [anon_sym___vectorcall] = ACTIONS(1402),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_RBRACE] = ACTIONS(1404),
    [anon_sym_signed] = ACTIONS(1402),
    [anon_sym_unsigned] = ACTIONS(1402),
    [anon_sym_long] = ACTIONS(1402),
    [anon_sym_short] = ACTIONS(1402),
    [anon_sym_static] = ACTIONS(1402),
    [anon_sym_auto] = ACTIONS(1402),
    [anon_sym_register] = ACTIONS(1402),
    [anon_sym_inline] = ACTIONS(1402),
    [anon_sym___inline] = ACTIONS(1402),
    [anon_sym___inline__] = ACTIONS(1402),
    [anon_sym___forceinline] = ACTIONS(1402),
    [anon_sym_thread_local] = ACTIONS(1402),
    [anon_sym___thread] = ACTIONS(1402),
    [anon_sym_const] = ACTIONS(1402),
    [anon_sym_constexpr] = ACTIONS(1402),
    [anon_sym_volatile] = ACTIONS(1402),
    [anon_sym_restrict] = ACTIONS(1402),
    [anon_sym___restrict__] = ACTIONS(1402),
    [anon_sym__Atomic] = ACTIONS(1402),
    [anon_sym__Noreturn] = ACTIONS(1402),
    [anon_sym_noreturn] = ACTIONS(1402),
    [sym_primitive_type] = ACTIONS(1402),
    [anon_sym_enum] = ACTIONS(1402),
    [anon_sym_struct] = ACTIONS(1402),
    [anon_sym_union] = ACTIONS(1402),
    [anon_sym_if] = ACTIONS(1402),
    [anon_sym_else] = ACTIONS(1402),
    [anon_sym_switch] = ACTIONS(1402),
    [anon_sym_case] = ACTIONS(1402),
    [anon_sym_default] = ACTIONS(1402),
    [anon_sym_while] = ACTIONS(1402),
    [anon_sym_do] = ACTIONS(1402),
    [anon_sym_for] = ACTIONS(1402),
    [anon_sym_return] = ACTIONS(1402),
    [anon_sym_break] = ACTIONS(1402),
    [anon_sym_continue] = ACTIONS(1402),
    [anon_sym_goto] = ACTIONS(1402),
    [anon_sym___try] = ACTIONS(1402),
    [anon_sym___leave] = ACTIONS(1402),
    [anon_sym_DASH_DASH] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1404),
    [anon_sym_sizeof] = ACTIONS(1402),
    [anon_sym___alignof__] = ACTIONS(1402),
    [anon_sym___alignof] = ACTIONS(1402),
    [anon_sym__alignof] = ACTIONS(1402),
    [anon_sym_alignof] = ACTIONS(1402),
    [anon_sym__Alignof] = ACTIONS(1402),
    [anon_sym_offsetof] = ACTIONS(1402),
    [anon_sym__Generic] = ACTIONS(1402),
    [anon_sym_asm] = ACTIONS(1402),
    [anon_sym___asm__] = ACTIONS(1402),
    [sym_number_literal] = ACTIONS(1404),
    [anon_sym_L_SQUOTE] = ACTIONS(1404),
    [anon_sym_u_SQUOTE] = ACTIONS(1404),
    [anon_sym_U_SQUOTE] = ACTIONS(1404),
    [anon_sym_u8_SQUOTE] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(1404),
    [anon_sym_L_DQUOTE] = ACTIONS(1404),
    [anon_sym_u_DQUOTE] = ACTIONS(1404),
    [anon_sym_U_DQUOTE] = ACTIONS(1404),
    [anon_sym_u8_DQUOTE] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1404),
    [sym_true] = ACTIONS(1402),
    [sym_false] = ACTIONS(1402),
    [anon_sym_NULL] = ACTIONS(1402),
    [anon_sym_nullptr] = ACTIONS(1402),
    [sym_comment] = ACTIONS(3),
  },
  [256] = {
    [sym_identifier] = ACTIONS(1418),
    [aux_sym_preproc_include_token1] = ACTIONS(1418),
    [aux_sym_preproc_def_token1] = ACTIONS(1418),
    [aux_sym_preproc_if_token1] = ACTIONS(1418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1418),
    [sym_preproc_directive] = ACTIONS(1418),
    [anon_sym_LPAREN2] = ACTIONS(1420),
    [anon_sym_BANG] = ACTIONS(1420),
    [anon_sym_TILDE] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_AMP] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(1420),
    [anon_sym___extension__] = ACTIONS(1418),
    [anon_sym_typedef] = ACTIONS(1418),
    [anon_sym_extern] = ACTIONS(1418),
    [anon_sym___attribute__] = ACTIONS(1418),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1420),
    [anon_sym___declspec] = ACTIONS(1418),
    [anon_sym___cdecl] = ACTIONS(1418),
    [anon_sym___clrcall] = ACTIONS(1418),
    [anon_sym___stdcall] = ACTIONS(1418),
    [anon_sym___fastcall] = ACTIONS(1418),
    [anon_sym___thiscall] = ACTIONS(1418),
    [anon_sym___vectorcall] = ACTIONS(1418),
    [anon_sym_LBRACE] = ACTIONS(1420),
    [anon_sym_RBRACE] = ACTIONS(1420),
    [anon_sym_signed] = ACTIONS(1418),
    [anon_sym_unsigned] = ACTIONS(1418),
    [anon_sym_long] = ACTIONS(1418),
    [anon_sym_short] = ACTIONS(1418),
    [anon_sym_static] = ACTIONS(1418),
    [anon_sym_auto] = ACTIONS(1418),
    [anon_sym_register] = ACTIONS(1418),
    [anon_sym_inline] = ACTIONS(1418),
    [anon_sym___inline] = ACTIONS(1418),
    [anon_sym___inline__] = ACTIONS(1418),
    [anon_sym___forceinline] = ACTIONS(1418),
    [anon_sym_thread_local] = ACTIONS(1418),
    [anon_sym___thread] = ACTIONS(1418),
    [anon_sym_const] = ACTIONS(1418),
    [anon_sym_constexpr] = ACTIONS(1418),
    [anon_sym_volatile] = ACTIONS(1418),
    [anon_sym_restrict] = ACTIONS(1418),
    [anon_sym___restrict__] = ACTIONS(1418),
    [anon_sym__Atomic] = ACTIONS(1418),
    [anon_sym__Noreturn] = ACTIONS(1418),
    [anon_sym_noreturn] = ACTIONS(1418),
    [sym_primitive_type] = ACTIONS(1418),
    [anon_sym_enum] = ACTIONS(1418),
    [anon_sym_struct] = ACTIONS(1418),
    [anon_sym_union] = ACTIONS(1418),
    [anon_sym_if] = ACTIONS(1418),
    [anon_sym_else] = ACTIONS(1418),
    [anon_sym_switch] = ACTIONS(1418),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_default] = ACTIONS(1418),
    [anon_sym_while] = ACTIONS(1418),
    [anon_sym_do] = ACTIONS(1418),
    [anon_sym_for] = ACTIONS(1418),
    [anon_sym_return] = ACTIONS(1418),
    [anon_sym_break] = ACTIONS(1418),
    [anon_sym_continue] = ACTIONS(1418),
    [anon_sym_goto] = ACTIONS(1418),
    [anon_sym___try] = ACTIONS(1418),
    [anon_sym___leave] = ACTIONS(1418),
    [anon_sym_DASH_DASH] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1420),
    [anon_sym_sizeof] = ACTIONS(1418),
    [anon_sym___alignof__] = ACTIONS(1418),
    [anon_sym___alignof] = ACTIONS(1418),
    [anon_sym__alignof] = ACTIONS(1418),
    [anon_sym_alignof] = ACTIONS(1418),
    [anon_sym__Alignof] = ACTIONS(1418),
    [anon_sym_offsetof] = ACTIONS(1418),
    [anon_sym__Generic] = ACTIONS(1418),
    [anon_sym_asm] = ACTIONS(1418),
    [anon_sym___asm__] = ACTIONS(1418),
    [sym_number_literal] = ACTIONS(1420),
    [anon_sym_L_SQUOTE] = ACTIONS(1420),
    [anon_sym_u_SQUOTE] = ACTIONS(1420),
    [anon_sym_U_SQUOTE] = ACTIONS(1420),
    [anon_sym_u8_SQUOTE] = ACTIONS(1420),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [anon_sym_L_DQUOTE] = ACTIONS(1420),
    [anon_sym_u_DQUOTE] = ACTIONS(1420),
    [anon_sym_U_DQUOTE] = ACTIONS(1420),
    [anon_sym_u8_DQUOTE] = ACTIONS(1420),
    [anon_sym_DQUOTE] = ACTIONS(1420),
    [sym_true] = ACTIONS(1418),
    [sym_false] = ACTIONS(1418),
    [anon_sym_NULL] = ACTIONS(1418),
    [anon_sym_nullptr] = ACTIONS(1418),
    [sym_comment] = ACTIONS(3),
  },
  [257] = {
    [sym_identifier] = ACTIONS(1414),
    [aux_sym_preproc_include_token1] = ACTIONS(1414),
    [aux_sym_preproc_def_token1] = ACTIONS(1414),
    [aux_sym_preproc_if_token1] = ACTIONS(1414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1414),
    [sym_preproc_directive] = ACTIONS(1414),
    [anon_sym_LPAREN2] = ACTIONS(1416),
    [anon_sym_BANG] = ACTIONS(1416),
    [anon_sym_TILDE] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1416),
    [anon_sym_AMP] = ACTIONS(1416),
    [anon_sym_SEMI] = ACTIONS(1416),
    [anon_sym___extension__] = ACTIONS(1414),
    [anon_sym_typedef] = ACTIONS(1414),
    [anon_sym_extern] = ACTIONS(1414),
    [anon_sym___attribute__] = ACTIONS(1414),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1416),
    [anon_sym___declspec] = ACTIONS(1414),
    [anon_sym___cdecl] = ACTIONS(1414),
    [anon_sym___clrcall] = ACTIONS(1414),
    [anon_sym___stdcall] = ACTIONS(1414),
    [anon_sym___fastcall] = ACTIONS(1414),
    [anon_sym___thiscall] = ACTIONS(1414),
    [anon_sym___vectorcall] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1416),
    [anon_sym_RBRACE] = ACTIONS(1416),
    [anon_sym_signed] = ACTIONS(1414),
    [anon_sym_unsigned] = ACTIONS(1414),
    [anon_sym_long] = ACTIONS(1414),
    [anon_sym_short] = ACTIONS(1414),
    [anon_sym_static] = ACTIONS(1414),
    [anon_sym_auto] = ACTIONS(1414),
    [anon_sym_register] = ACTIONS(1414),
    [anon_sym_inline] = ACTIONS(1414),
    [anon_sym___inline] = ACTIONS(1414),
    [anon_sym___inline__] = ACTIONS(1414),
    [anon_sym___forceinline] = ACTIONS(1414),
    [anon_sym_thread_local] = ACTIONS(1414),
    [anon_sym___thread] = ACTIONS(1414),
    [anon_sym_const] = ACTIONS(1414),
    [anon_sym_constexpr] = ACTIONS(1414),
    [anon_sym_volatile] = ACTIONS(1414),
    [anon_sym_restrict] = ACTIONS(1414),
    [anon_sym___restrict__] = ACTIONS(1414),
    [anon_sym__Atomic] = ACTIONS(1414),
    [anon_sym__Noreturn] = ACTIONS(1414),
    [anon_sym_noreturn] = ACTIONS(1414),
    [sym_primitive_type] = ACTIONS(1414),
    [anon_sym_enum] = ACTIONS(1414),
    [anon_sym_struct] = ACTIONS(1414),
    [anon_sym_union] = ACTIONS(1414),
    [anon_sym_if] = ACTIONS(1414),
    [anon_sym_else] = ACTIONS(1414),
    [anon_sym_switch] = ACTIONS(1414),
    [anon_sym_case] = ACTIONS(1414),
    [anon_sym_default] = ACTIONS(1414),
    [anon_sym_while] = ACTIONS(1414),
    [anon_sym_do] = ACTIONS(1414),
    [anon_sym_for] = ACTIONS(1414),
    [anon_sym_return] = ACTIONS(1414),
    [anon_sym_break] = ACTIONS(1414),
    [anon_sym_continue] = ACTIONS(1414),
    [anon_sym_goto] = ACTIONS(1414),
    [anon_sym___try] = ACTIONS(1414),
    [anon_sym___leave] = ACTIONS(1414),
    [anon_sym_DASH_DASH] = ACTIONS(1416),
    [anon_sym_PLUS_PLUS] = ACTIONS(1416),
    [anon_sym_sizeof] = ACTIONS(1414),
    [anon_sym___alignof__] = ACTIONS(1414),
    [anon_sym___alignof] = ACTIONS(1414),
    [anon_sym__alignof] = ACTIONS(1414),
    [anon_sym_alignof] = ACTIONS(1414),
    [anon_sym__Alignof] = ACTIONS(1414),
    [anon_sym_offsetof] = ACTIONS(1414),
    [anon_sym__Generic] = ACTIONS(1414),
    [anon_sym_asm] = ACTIONS(1414),
    [anon_sym___asm__] = ACTIONS(1414),
    [sym_number_literal] = ACTIONS(1416),
    [anon_sym_L_SQUOTE] = ACTIONS(1416),
    [anon_sym_u_SQUOTE] = ACTIONS(1416),
    [anon_sym_U_SQUOTE] = ACTIONS(1416),
    [anon_sym_u8_SQUOTE] = ACTIONS(1416),
    [anon_sym_SQUOTE] = ACTIONS(1416),
    [anon_sym_L_DQUOTE] = ACTIONS(1416),
    [anon_sym_u_DQUOTE] = ACTIONS(1416),
    [anon_sym_U_DQUOTE] = ACTIONS(1416),
    [anon_sym_u8_DQUOTE] = ACTIONS(1416),
    [anon_sym_DQUOTE] = ACTIONS(1416),
    [sym_true] = ACTIONS(1414),
    [sym_false] = ACTIONS(1414),
    [anon_sym_NULL] = ACTIONS(1414),
    [anon_sym_nullptr] = ACTIONS(1414),
    [sym_comment] = ACTIONS(3),
  },
  [258] = {
    [sym_identifier] = ACTIONS(1414),
    [aux_sym_preproc_include_token1] = ACTIONS(1414),
    [aux_sym_preproc_def_token1] = ACTIONS(1414),
    [aux_sym_preproc_if_token1] = ACTIONS(1414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1414),
    [sym_preproc_directive] = ACTIONS(1414),
    [anon_sym_LPAREN2] = ACTIONS(1416),
    [anon_sym_BANG] = ACTIONS(1416),
    [anon_sym_TILDE] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1416),
    [anon_sym_AMP] = ACTIONS(1416),
    [anon_sym_SEMI] = ACTIONS(1416),
    [anon_sym___extension__] = ACTIONS(1414),
    [anon_sym_typedef] = ACTIONS(1414),
    [anon_sym_extern] = ACTIONS(1414),
    [anon_sym___attribute__] = ACTIONS(1414),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1416),
    [anon_sym___declspec] = ACTIONS(1414),
    [anon_sym___cdecl] = ACTIONS(1414),
    [anon_sym___clrcall] = ACTIONS(1414),
    [anon_sym___stdcall] = ACTIONS(1414),
    [anon_sym___fastcall] = ACTIONS(1414),
    [anon_sym___thiscall] = ACTIONS(1414),
    [anon_sym___vectorcall] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1416),
    [anon_sym_RBRACE] = ACTIONS(1416),
    [anon_sym_signed] = ACTIONS(1414),
    [anon_sym_unsigned] = ACTIONS(1414),
    [anon_sym_long] = ACTIONS(1414),
    [anon_sym_short] = ACTIONS(1414),
    [anon_sym_static] = ACTIONS(1414),
    [anon_sym_auto] = ACTIONS(1414),
    [anon_sym_register] = ACTIONS(1414),
    [anon_sym_inline] = ACTIONS(1414),
    [anon_sym___inline] = ACTIONS(1414),
    [anon_sym___inline__] = ACTIONS(1414),
    [anon_sym___forceinline] = ACTIONS(1414),
    [anon_sym_thread_local] = ACTIONS(1414),
    [anon_sym___thread] = ACTIONS(1414),
    [anon_sym_const] = ACTIONS(1414),
    [anon_sym_constexpr] = ACTIONS(1414),
    [anon_sym_volatile] = ACTIONS(1414),
    [anon_sym_restrict] = ACTIONS(1414),
    [anon_sym___restrict__] = ACTIONS(1414),
    [anon_sym__Atomic] = ACTIONS(1414),
    [anon_sym__Noreturn] = ACTIONS(1414),
    [anon_sym_noreturn] = ACTIONS(1414),
    [sym_primitive_type] = ACTIONS(1414),
    [anon_sym_enum] = ACTIONS(1414),
    [anon_sym_struct] = ACTIONS(1414),
    [anon_sym_union] = ACTIONS(1414),
    [anon_sym_if] = ACTIONS(1414),
    [anon_sym_else] = ACTIONS(1414),
    [anon_sym_switch] = ACTIONS(1414),
    [anon_sym_case] = ACTIONS(1414),
    [anon_sym_default] = ACTIONS(1414),
    [anon_sym_while] = ACTIONS(1414),
    [anon_sym_do] = ACTIONS(1414),
    [anon_sym_for] = ACTIONS(1414),
    [anon_sym_return] = ACTIONS(1414),
    [anon_sym_break] = ACTIONS(1414),
    [anon_sym_continue] = ACTIONS(1414),
    [anon_sym_goto] = ACTIONS(1414),
    [anon_sym___try] = ACTIONS(1414),
    [anon_sym___leave] = ACTIONS(1414),
    [anon_sym_DASH_DASH] = ACTIONS(1416),
    [anon_sym_PLUS_PLUS] = ACTIONS(1416),
    [anon_sym_sizeof] = ACTIONS(1414),
    [anon_sym___alignof__] = ACTIONS(1414),
    [anon_sym___alignof] = ACTIONS(1414),
    [anon_sym__alignof] = ACTIONS(1414),
    [anon_sym_alignof] = ACTIONS(1414),
    [anon_sym__Alignof] = ACTIONS(1414),
    [anon_sym_offsetof] = ACTIONS(1414),
    [anon_sym__Generic] = ACTIONS(1414),
    [anon_sym_asm] = ACTIONS(1414),
    [anon_sym___asm__] = ACTIONS(1414),
    [sym_number_literal] = ACTIONS(1416),
    [anon_sym_L_SQUOTE] = ACTIONS(1416),
    [anon_sym_u_SQUOTE] = ACTIONS(1416),
    [anon_sym_U_SQUOTE] = ACTIONS(1416),
    [anon_sym_u8_SQUOTE] = ACTIONS(1416),
    [anon_sym_SQUOTE] = ACTIONS(1416),
    [anon_sym_L_DQUOTE] = ACTIONS(1416),
    [anon_sym_u_DQUOTE] = ACTIONS(1416),
    [anon_sym_U_DQUOTE] = ACTIONS(1416),
    [anon_sym_u8_DQUOTE] = ACTIONS(1416),
    [anon_sym_DQUOTE] = ACTIONS(1416),
    [sym_true] = ACTIONS(1414),
    [sym_false] = ACTIONS(1414),
    [anon_sym_NULL] = ACTIONS(1414),
    [anon_sym_nullptr] = ACTIONS(1414),
    [sym_comment] = ACTIONS(3),
  },
  [259] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [260] = {
    [sym_identifier] = ACTIONS(1410),
    [aux_sym_preproc_include_token1] = ACTIONS(1410),
    [aux_sym_preproc_def_token1] = ACTIONS(1410),
    [aux_sym_preproc_if_token1] = ACTIONS(1410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1410),
    [sym_preproc_directive] = ACTIONS(1410),
    [anon_sym_LPAREN2] = ACTIONS(1412),
    [anon_sym_BANG] = ACTIONS(1412),
    [anon_sym_TILDE] = ACTIONS(1412),
    [anon_sym_DASH] = ACTIONS(1410),
    [anon_sym_PLUS] = ACTIONS(1410),
    [anon_sym_STAR] = ACTIONS(1412),
    [anon_sym_AMP] = ACTIONS(1412),
    [anon_sym_SEMI] = ACTIONS(1412),
    [anon_sym___extension__] = ACTIONS(1410),
    [anon_sym_typedef] = ACTIONS(1410),
    [anon_sym_extern] = ACTIONS(1410),
    [anon_sym___attribute__] = ACTIONS(1410),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1412),
    [anon_sym___declspec] = ACTIONS(1410),
    [anon_sym___cdecl] = ACTIONS(1410),
    [anon_sym___clrcall] = ACTIONS(1410),
    [anon_sym___stdcall] = ACTIONS(1410),
    [anon_sym___fastcall] = ACTIONS(1410),
    [anon_sym___thiscall] = ACTIONS(1410),
    [anon_sym___vectorcall] = ACTIONS(1410),
    [anon_sym_LBRACE] = ACTIONS(1412),
    [anon_sym_RBRACE] = ACTIONS(1412),
    [anon_sym_signed] = ACTIONS(1410),
    [anon_sym_unsigned] = ACTIONS(1410),
    [anon_sym_long] = ACTIONS(1410),
    [anon_sym_short] = ACTIONS(1410),
    [anon_sym_static] = ACTIONS(1410),
    [anon_sym_auto] = ACTIONS(1410),
    [anon_sym_register] = ACTIONS(1410),
    [anon_sym_inline] = ACTIONS(1410),
    [anon_sym___inline] = ACTIONS(1410),
    [anon_sym___inline__] = ACTIONS(1410),
    [anon_sym___forceinline] = ACTIONS(1410),
    [anon_sym_thread_local] = ACTIONS(1410),
    [anon_sym___thread] = ACTIONS(1410),
    [anon_sym_const] = ACTIONS(1410),
    [anon_sym_constexpr] = ACTIONS(1410),
    [anon_sym_volatile] = ACTIONS(1410),
    [anon_sym_restrict] = ACTIONS(1410),
    [anon_sym___restrict__] = ACTIONS(1410),
    [anon_sym__Atomic] = ACTIONS(1410),
    [anon_sym__Noreturn] = ACTIONS(1410),
    [anon_sym_noreturn] = ACTIONS(1410),
    [sym_primitive_type] = ACTIONS(1410),
    [anon_sym_enum] = ACTIONS(1410),
    [anon_sym_struct] = ACTIONS(1410),
    [anon_sym_union] = ACTIONS(1410),
    [anon_sym_if] = ACTIONS(1410),
    [anon_sym_else] = ACTIONS(1410),
    [anon_sym_switch] = ACTIONS(1410),
    [anon_sym_case] = ACTIONS(1410),
    [anon_sym_default] = ACTIONS(1410),
    [anon_sym_while] = ACTIONS(1410),
    [anon_sym_do] = ACTIONS(1410),
    [anon_sym_for] = ACTIONS(1410),
    [anon_sym_return] = ACTIONS(1410),
    [anon_sym_break] = ACTIONS(1410),
    [anon_sym_continue] = ACTIONS(1410),
    [anon_sym_goto] = ACTIONS(1410),
    [anon_sym___try] = ACTIONS(1410),
    [anon_sym___leave] = ACTIONS(1410),
    [anon_sym_DASH_DASH] = ACTIONS(1412),
    [anon_sym_PLUS_PLUS] = ACTIONS(1412),
    [anon_sym_sizeof] = ACTIONS(1410),
    [anon_sym___alignof__] = ACTIONS(1410),
    [anon_sym___alignof] = ACTIONS(1410),
    [anon_sym__alignof] = ACTIONS(1410),
    [anon_sym_alignof] = ACTIONS(1410),
    [anon_sym__Alignof] = ACTIONS(1410),
    [anon_sym_offsetof] = ACTIONS(1410),
    [anon_sym__Generic] = ACTIONS(1410),
    [anon_sym_asm] = ACTIONS(1410),
    [anon_sym___asm__] = ACTIONS(1410),
    [sym_number_literal] = ACTIONS(1412),
    [anon_sym_L_SQUOTE] = ACTIONS(1412),
    [anon_sym_u_SQUOTE] = ACTIONS(1412),
    [anon_sym_U_SQUOTE] = ACTIONS(1412),
    [anon_sym_u8_SQUOTE] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(1412),
    [anon_sym_L_DQUOTE] = ACTIONS(1412),
    [anon_sym_u_DQUOTE] = ACTIONS(1412),
    [anon_sym_U_DQUOTE] = ACTIONS(1412),
    [anon_sym_u8_DQUOTE] = ACTIONS(1412),
    [anon_sym_DQUOTE] = ACTIONS(1412),
    [sym_true] = ACTIONS(1410),
    [sym_false] = ACTIONS(1410),
    [anon_sym_NULL] = ACTIONS(1410),
    [anon_sym_nullptr] = ACTIONS(1410),
    [sym_comment] = ACTIONS(3),
  },
  [261] = {
    [sym_identifier] = ACTIONS(1406),
    [aux_sym_preproc_include_token1] = ACTIONS(1406),
    [aux_sym_preproc_def_token1] = ACTIONS(1406),
    [aux_sym_preproc_if_token1] = ACTIONS(1406),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1406),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1406),
    [sym_preproc_directive] = ACTIONS(1406),
    [anon_sym_LPAREN2] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1408),
    [anon_sym_DASH] = ACTIONS(1406),
    [anon_sym_PLUS] = ACTIONS(1406),
    [anon_sym_STAR] = ACTIONS(1408),
    [anon_sym_AMP] = ACTIONS(1408),
    [anon_sym_SEMI] = ACTIONS(1408),
    [anon_sym___extension__] = ACTIONS(1406),
    [anon_sym_typedef] = ACTIONS(1406),
    [anon_sym_extern] = ACTIONS(1406),
    [anon_sym___attribute__] = ACTIONS(1406),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1408),
    [anon_sym___declspec] = ACTIONS(1406),
    [anon_sym___cdecl] = ACTIONS(1406),
    [anon_sym___clrcall] = ACTIONS(1406),
    [anon_sym___stdcall] = ACTIONS(1406),
    [anon_sym___fastcall] = ACTIONS(1406),
    [anon_sym___thiscall] = ACTIONS(1406),
    [anon_sym___vectorcall] = ACTIONS(1406),
    [anon_sym_LBRACE] = ACTIONS(1408),
    [anon_sym_RBRACE] = ACTIONS(1408),
    [anon_sym_signed] = ACTIONS(1406),
    [anon_sym_unsigned] = ACTIONS(1406),
    [anon_sym_long] = ACTIONS(1406),
    [anon_sym_short] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_auto] = ACTIONS(1406),
    [anon_sym_register] = ACTIONS(1406),
    [anon_sym_inline] = ACTIONS(1406),
    [anon_sym___inline] = ACTIONS(1406),
    [anon_sym___inline__] = ACTIONS(1406),
    [anon_sym___forceinline] = ACTIONS(1406),
    [anon_sym_thread_local] = ACTIONS(1406),
    [anon_sym___thread] = ACTIONS(1406),
    [anon_sym_const] = ACTIONS(1406),
    [anon_sym_constexpr] = ACTIONS(1406),
    [anon_sym_volatile] = ACTIONS(1406),
    [anon_sym_restrict] = ACTIONS(1406),
    [anon_sym___restrict__] = ACTIONS(1406),
    [anon_sym__Atomic] = ACTIONS(1406),
    [anon_sym__Noreturn] = ACTIONS(1406),
    [anon_sym_noreturn] = ACTIONS(1406),
    [sym_primitive_type] = ACTIONS(1406),
    [anon_sym_enum] = ACTIONS(1406),
    [anon_sym_struct] = ACTIONS(1406),
    [anon_sym_union] = ACTIONS(1406),
    [anon_sym_if] = ACTIONS(1406),
    [anon_sym_else] = ACTIONS(1406),
    [anon_sym_switch] = ACTIONS(1406),
    [anon_sym_case] = ACTIONS(1406),
    [anon_sym_default] = ACTIONS(1406),
    [anon_sym_while] = ACTIONS(1406),
    [anon_sym_do] = ACTIONS(1406),
    [anon_sym_for] = ACTIONS(1406),
    [anon_sym_return] = ACTIONS(1406),
    [anon_sym_break] = ACTIONS(1406),
    [anon_sym_continue] = ACTIONS(1406),
    [anon_sym_goto] = ACTIONS(1406),
    [anon_sym___try] = ACTIONS(1406),
    [anon_sym___leave] = ACTIONS(1406),
    [anon_sym_DASH_DASH] = ACTIONS(1408),
    [anon_sym_PLUS_PLUS] = ACTIONS(1408),
    [anon_sym_sizeof] = ACTIONS(1406),
    [anon_sym___alignof__] = ACTIONS(1406),
    [anon_sym___alignof] = ACTIONS(1406),
    [anon_sym__alignof] = ACTIONS(1406),
    [anon_sym_alignof] = ACTIONS(1406),
    [anon_sym__Alignof] = ACTIONS(1406),
    [anon_sym_offsetof] = ACTIONS(1406),
    [anon_sym__Generic] = ACTIONS(1406),
    [anon_sym_asm] = ACTIONS(1406),
    [anon_sym___asm__] = ACTIONS(1406),
    [sym_number_literal] = ACTIONS(1408),
    [anon_sym_L_SQUOTE] = ACTIONS(1408),
    [anon_sym_u_SQUOTE] = ACTIONS(1408),
    [anon_sym_U_SQUOTE] = ACTIONS(1408),
    [anon_sym_u8_SQUOTE] = ACTIONS(1408),
    [anon_sym_SQUOTE] = ACTIONS(1408),
    [anon_sym_L_DQUOTE] = ACTIONS(1408),
    [anon_sym_u_DQUOTE] = ACTIONS(1408),
    [anon_sym_U_DQUOTE] = ACTIONS(1408),
    [anon_sym_u8_DQUOTE] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1408),
    [sym_true] = ACTIONS(1406),
    [sym_false] = ACTIONS(1406),
    [anon_sym_NULL] = ACTIONS(1406),
    [anon_sym_nullptr] = ACTIONS(1406),
    [sym_comment] = ACTIONS(3),
  },
  [262] = {
    [sym_identifier] = ACTIONS(1346),
    [aux_sym_preproc_include_token1] = ACTIONS(1346),
    [aux_sym_preproc_def_token1] = ACTIONS(1346),
    [aux_sym_preproc_if_token1] = ACTIONS(1346),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1346),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1346),
    [sym_preproc_directive] = ACTIONS(1346),
    [anon_sym_LPAREN2] = ACTIONS(1348),
    [anon_sym_BANG] = ACTIONS(1348),
    [anon_sym_TILDE] = ACTIONS(1348),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_STAR] = ACTIONS(1348),
    [anon_sym_AMP] = ACTIONS(1348),
    [anon_sym_SEMI] = ACTIONS(1348),
    [anon_sym___extension__] = ACTIONS(1346),
    [anon_sym_typedef] = ACTIONS(1346),
    [anon_sym_extern] = ACTIONS(1346),
    [anon_sym___attribute__] = ACTIONS(1346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1348),
    [anon_sym___declspec] = ACTIONS(1346),
    [anon_sym___cdecl] = ACTIONS(1346),
    [anon_sym___clrcall] = ACTIONS(1346),
    [anon_sym___stdcall] = ACTIONS(1346),
    [anon_sym___fastcall] = ACTIONS(1346),
    [anon_sym___thiscall] = ACTIONS(1346),
    [anon_sym___vectorcall] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_RBRACE] = ACTIONS(1348),
    [anon_sym_signed] = ACTIONS(1346),
    [anon_sym_unsigned] = ACTIONS(1346),
    [anon_sym_long] = ACTIONS(1346),
    [anon_sym_short] = ACTIONS(1346),
    [anon_sym_static] = ACTIONS(1346),
    [anon_sym_auto] = ACTIONS(1346),
    [anon_sym_register] = ACTIONS(1346),
    [anon_sym_inline] = ACTIONS(1346),
    [anon_sym___inline] = ACTIONS(1346),
    [anon_sym___inline__] = ACTIONS(1346),
    [anon_sym___forceinline] = ACTIONS(1346),
    [anon_sym_thread_local] = ACTIONS(1346),
    [anon_sym___thread] = ACTIONS(1346),
    [anon_sym_const] = ACTIONS(1346),
    [anon_sym_constexpr] = ACTIONS(1346),
    [anon_sym_volatile] = ACTIONS(1346),
    [anon_sym_restrict] = ACTIONS(1346),
    [anon_sym___restrict__] = ACTIONS(1346),
    [anon_sym__Atomic] = ACTIONS(1346),
    [anon_sym__Noreturn] = ACTIONS(1346),
    [anon_sym_noreturn] = ACTIONS(1346),
    [sym_primitive_type] = ACTIONS(1346),
    [anon_sym_enum] = ACTIONS(1346),
    [anon_sym_struct] = ACTIONS(1346),
    [anon_sym_union] = ACTIONS(1346),
    [anon_sym_if] = ACTIONS(1346),
    [anon_sym_else] = ACTIONS(1346),
    [anon_sym_switch] = ACTIONS(1346),
    [anon_sym_case] = ACTIONS(1346),
    [anon_sym_default] = ACTIONS(1346),
    [anon_sym_while] = ACTIONS(1346),
    [anon_sym_do] = ACTIONS(1346),
    [anon_sym_for] = ACTIONS(1346),
    [anon_sym_return] = ACTIONS(1346),
    [anon_sym_break] = ACTIONS(1346),
    [anon_sym_continue] = ACTIONS(1346),
    [anon_sym_goto] = ACTIONS(1346),
    [anon_sym___try] = ACTIONS(1346),
    [anon_sym___leave] = ACTIONS(1346),
    [anon_sym_DASH_DASH] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(1348),
    [anon_sym_sizeof] = ACTIONS(1346),
    [anon_sym___alignof__] = ACTIONS(1346),
    [anon_sym___alignof] = ACTIONS(1346),
    [anon_sym__alignof] = ACTIONS(1346),
    [anon_sym_alignof] = ACTIONS(1346),
    [anon_sym__Alignof] = ACTIONS(1346),
    [anon_sym_offsetof] = ACTIONS(1346),
    [anon_sym__Generic] = ACTIONS(1346),
    [anon_sym_asm] = ACTIONS(1346),
    [anon_sym___asm__] = ACTIONS(1346),
    [sym_number_literal] = ACTIONS(1348),
    [anon_sym_L_SQUOTE] = ACTIONS(1348),
    [anon_sym_u_SQUOTE] = ACTIONS(1348),
    [anon_sym_U_SQUOTE] = ACTIONS(1348),
    [anon_sym_u8_SQUOTE] = ACTIONS(1348),
    [anon_sym_SQUOTE] = ACTIONS(1348),
    [anon_sym_L_DQUOTE] = ACTIONS(1348),
    [anon_sym_u_DQUOTE] = ACTIONS(1348),
    [anon_sym_U_DQUOTE] = ACTIONS(1348),
    [anon_sym_u8_DQUOTE] = ACTIONS(1348),
    [anon_sym_DQUOTE] = ACTIONS(1348),
    [sym_true] = ACTIONS(1346),
    [sym_false] = ACTIONS(1346),
    [anon_sym_NULL] = ACTIONS(1346),
    [anon_sym_nullptr] = ACTIONS(1346),
    [sym_comment] = ACTIONS(3),
  },
  [263] = {
    [sym_identifier] = ACTIONS(1342),
    [aux_sym_preproc_include_token1] = ACTIONS(1342),
    [aux_sym_preproc_def_token1] = ACTIONS(1342),
    [aux_sym_preproc_if_token1] = ACTIONS(1342),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1342),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1342),
    [sym_preproc_directive] = ACTIONS(1342),
    [anon_sym_LPAREN2] = ACTIONS(1344),
    [anon_sym_BANG] = ACTIONS(1344),
    [anon_sym_TILDE] = ACTIONS(1344),
    [anon_sym_DASH] = ACTIONS(1342),
    [anon_sym_PLUS] = ACTIONS(1342),
    [anon_sym_STAR] = ACTIONS(1344),
    [anon_sym_AMP] = ACTIONS(1344),
    [anon_sym_SEMI] = ACTIONS(1344),
    [anon_sym___extension__] = ACTIONS(1342),
    [anon_sym_typedef] = ACTIONS(1342),
    [anon_sym_extern] = ACTIONS(1342),
    [anon_sym___attribute__] = ACTIONS(1342),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1344),
    [anon_sym___declspec] = ACTIONS(1342),
    [anon_sym___cdecl] = ACTIONS(1342),
    [anon_sym___clrcall] = ACTIONS(1342),
    [anon_sym___stdcall] = ACTIONS(1342),
    [anon_sym___fastcall] = ACTIONS(1342),
    [anon_sym___thiscall] = ACTIONS(1342),
    [anon_sym___vectorcall] = ACTIONS(1342),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_RBRACE] = ACTIONS(1344),
    [anon_sym_signed] = ACTIONS(1342),
    [anon_sym_unsigned] = ACTIONS(1342),
    [anon_sym_long] = ACTIONS(1342),
    [anon_sym_short] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_auto] = ACTIONS(1342),
    [anon_sym_register] = ACTIONS(1342),
    [anon_sym_inline] = ACTIONS(1342),
    [anon_sym___inline] = ACTIONS(1342),
    [anon_sym___inline__] = ACTIONS(1342),
    [anon_sym___forceinline] = ACTIONS(1342),
    [anon_sym_thread_local] = ACTIONS(1342),
    [anon_sym___thread] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [anon_sym_constexpr] = ACTIONS(1342),
    [anon_sym_volatile] = ACTIONS(1342),
    [anon_sym_restrict] = ACTIONS(1342),
    [anon_sym___restrict__] = ACTIONS(1342),
    [anon_sym__Atomic] = ACTIONS(1342),
    [anon_sym__Noreturn] = ACTIONS(1342),
    [anon_sym_noreturn] = ACTIONS(1342),
    [sym_primitive_type] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_union] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1342),
    [anon_sym_else] = ACTIONS(1342),
    [anon_sym_switch] = ACTIONS(1342),
    [anon_sym_case] = ACTIONS(1342),
    [anon_sym_default] = ACTIONS(1342),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_do] = ACTIONS(1342),
    [anon_sym_for] = ACTIONS(1342),
    [anon_sym_return] = ACTIONS(1342),
    [anon_sym_break] = ACTIONS(1342),
    [anon_sym_continue] = ACTIONS(1342),
    [anon_sym_goto] = ACTIONS(1342),
    [anon_sym___try] = ACTIONS(1342),
    [anon_sym___leave] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(1344),
    [anon_sym_PLUS_PLUS] = ACTIONS(1344),
    [anon_sym_sizeof] = ACTIONS(1342),
    [anon_sym___alignof__] = ACTIONS(1342),
    [anon_sym___alignof] = ACTIONS(1342),
    [anon_sym__alignof] = ACTIONS(1342),
    [anon_sym_alignof] = ACTIONS(1342),
    [anon_sym__Alignof] = ACTIONS(1342),
    [anon_sym_offsetof] = ACTIONS(1342),
    [anon_sym__Generic] = ACTIONS(1342),
    [anon_sym_asm] = ACTIONS(1342),
    [anon_sym___asm__] = ACTIONS(1342),
    [sym_number_literal] = ACTIONS(1344),
    [anon_sym_L_SQUOTE] = ACTIONS(1344),
    [anon_sym_u_SQUOTE] = ACTIONS(1344),
    [anon_sym_U_SQUOTE] = ACTIONS(1344),
    [anon_sym_u8_SQUOTE] = ACTIONS(1344),
    [anon_sym_SQUOTE] = ACTIONS(1344),
    [anon_sym_L_DQUOTE] = ACTIONS(1344),
    [anon_sym_u_DQUOTE] = ACTIONS(1344),
    [anon_sym_U_DQUOTE] = ACTIONS(1344),
    [anon_sym_u8_DQUOTE] = ACTIONS(1344),
    [anon_sym_DQUOTE] = ACTIONS(1344),
    [sym_true] = ACTIONS(1342),
    [sym_false] = ACTIONS(1342),
    [anon_sym_NULL] = ACTIONS(1342),
    [anon_sym_nullptr] = ACTIONS(1342),
    [sym_comment] = ACTIONS(3),
  },
  [264] = {
    [ts_builtin_sym_end] = ACTIONS(1304),
    [sym_identifier] = ACTIONS(1302),
    [aux_sym_preproc_include_token1] = ACTIONS(1302),
    [aux_sym_preproc_def_token1] = ACTIONS(1302),
    [aux_sym_preproc_if_token1] = ACTIONS(1302),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1302),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1302),
    [sym_preproc_directive] = ACTIONS(1302),
    [anon_sym_LPAREN2] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_TILDE] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1302),
    [anon_sym_PLUS] = ACTIONS(1302),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym___extension__] = ACTIONS(1302),
    [anon_sym_typedef] = ACTIONS(1302),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym___attribute__] = ACTIONS(1302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1304),
    [anon_sym___declspec] = ACTIONS(1302),
    [anon_sym___cdecl] = ACTIONS(1302),
    [anon_sym___clrcall] = ACTIONS(1302),
    [anon_sym___stdcall] = ACTIONS(1302),
    [anon_sym___fastcall] = ACTIONS(1302),
    [anon_sym___thiscall] = ACTIONS(1302),
    [anon_sym___vectorcall] = ACTIONS(1302),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_signed] = ACTIONS(1302),
    [anon_sym_unsigned] = ACTIONS(1302),
    [anon_sym_long] = ACTIONS(1302),
    [anon_sym_short] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(1302),
    [anon_sym_auto] = ACTIONS(1302),
    [anon_sym_register] = ACTIONS(1302),
    [anon_sym_inline] = ACTIONS(1302),
    [anon_sym___inline] = ACTIONS(1302),
    [anon_sym___inline__] = ACTIONS(1302),
    [anon_sym___forceinline] = ACTIONS(1302),
    [anon_sym_thread_local] = ACTIONS(1302),
    [anon_sym___thread] = ACTIONS(1302),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_constexpr] = ACTIONS(1302),
    [anon_sym_volatile] = ACTIONS(1302),
    [anon_sym_restrict] = ACTIONS(1302),
    [anon_sym___restrict__] = ACTIONS(1302),
    [anon_sym__Atomic] = ACTIONS(1302),
    [anon_sym__Noreturn] = ACTIONS(1302),
    [anon_sym_noreturn] = ACTIONS(1302),
    [sym_primitive_type] = ACTIONS(1302),
    [anon_sym_enum] = ACTIONS(1302),
    [anon_sym_struct] = ACTIONS(1302),
    [anon_sym_union] = ACTIONS(1302),
    [anon_sym_if] = ACTIONS(1302),
    [anon_sym_else] = ACTIONS(1302),
    [anon_sym_switch] = ACTIONS(1302),
    [anon_sym_case] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1302),
    [anon_sym_while] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1302),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_break] = ACTIONS(1302),
    [anon_sym_continue] = ACTIONS(1302),
    [anon_sym_goto] = ACTIONS(1302),
    [anon_sym___try] = ACTIONS(1302),
    [anon_sym___leave] = ACTIONS(1302),
    [anon_sym_DASH_DASH] = ACTIONS(1304),
    [anon_sym_PLUS_PLUS] = ACTIONS(1304),
    [anon_sym_sizeof] = ACTIONS(1302),
    [anon_sym___alignof__] = ACTIONS(1302),
    [anon_sym___alignof] = ACTIONS(1302),
    [anon_sym__alignof] = ACTIONS(1302),
    [anon_sym_alignof] = ACTIONS(1302),
    [anon_sym__Alignof] = ACTIONS(1302),
    [anon_sym_offsetof] = ACTIONS(1302),
    [anon_sym__Generic] = ACTIONS(1302),
    [anon_sym_asm] = ACTIONS(1302),
    [anon_sym___asm__] = ACTIONS(1302),
    [sym_number_literal] = ACTIONS(1304),
    [anon_sym_L_SQUOTE] = ACTIONS(1304),
    [anon_sym_u_SQUOTE] = ACTIONS(1304),
    [anon_sym_U_SQUOTE] = ACTIONS(1304),
    [anon_sym_u8_SQUOTE] = ACTIONS(1304),
    [anon_sym_SQUOTE] = ACTIONS(1304),
    [anon_sym_L_DQUOTE] = ACTIONS(1304),
    [anon_sym_u_DQUOTE] = ACTIONS(1304),
    [anon_sym_U_DQUOTE] = ACTIONS(1304),
    [anon_sym_u8_DQUOTE] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_true] = ACTIONS(1302),
    [sym_false] = ACTIONS(1302),
    [anon_sym_NULL] = ACTIONS(1302),
    [anon_sym_nullptr] = ACTIONS(1302),
    [sym_comment] = ACTIONS(3),
  },
  [265] = {
    [sym_identifier] = ACTIONS(1398),
    [aux_sym_preproc_include_token1] = ACTIONS(1398),
    [aux_sym_preproc_def_token1] = ACTIONS(1398),
    [aux_sym_preproc_if_token1] = ACTIONS(1398),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1398),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1398),
    [sym_preproc_directive] = ACTIONS(1398),
    [anon_sym_LPAREN2] = ACTIONS(1400),
    [anon_sym_BANG] = ACTIONS(1400),
    [anon_sym_TILDE] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1398),
    [anon_sym_PLUS] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym___extension__] = ACTIONS(1398),
    [anon_sym_typedef] = ACTIONS(1398),
    [anon_sym_extern] = ACTIONS(1398),
    [anon_sym___attribute__] = ACTIONS(1398),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1400),
    [anon_sym___declspec] = ACTIONS(1398),
    [anon_sym___cdecl] = ACTIONS(1398),
    [anon_sym___clrcall] = ACTIONS(1398),
    [anon_sym___stdcall] = ACTIONS(1398),
    [anon_sym___fastcall] = ACTIONS(1398),
    [anon_sym___thiscall] = ACTIONS(1398),
    [anon_sym___vectorcall] = ACTIONS(1398),
    [anon_sym_LBRACE] = ACTIONS(1400),
    [anon_sym_RBRACE] = ACTIONS(1400),
    [anon_sym_signed] = ACTIONS(1398),
    [anon_sym_unsigned] = ACTIONS(1398),
    [anon_sym_long] = ACTIONS(1398),
    [anon_sym_short] = ACTIONS(1398),
    [anon_sym_static] = ACTIONS(1398),
    [anon_sym_auto] = ACTIONS(1398),
    [anon_sym_register] = ACTIONS(1398),
    [anon_sym_inline] = ACTIONS(1398),
    [anon_sym___inline] = ACTIONS(1398),
    [anon_sym___inline__] = ACTIONS(1398),
    [anon_sym___forceinline] = ACTIONS(1398),
    [anon_sym_thread_local] = ACTIONS(1398),
    [anon_sym___thread] = ACTIONS(1398),
    [anon_sym_const] = ACTIONS(1398),
    [anon_sym_constexpr] = ACTIONS(1398),
    [anon_sym_volatile] = ACTIONS(1398),
    [anon_sym_restrict] = ACTIONS(1398),
    [anon_sym___restrict__] = ACTIONS(1398),
    [anon_sym__Atomic] = ACTIONS(1398),
    [anon_sym__Noreturn] = ACTIONS(1398),
    [anon_sym_noreturn] = ACTIONS(1398),
    [sym_primitive_type] = ACTIONS(1398),
    [anon_sym_enum] = ACTIONS(1398),
    [anon_sym_struct] = ACTIONS(1398),
    [anon_sym_union] = ACTIONS(1398),
    [anon_sym_if] = ACTIONS(1398),
    [anon_sym_else] = ACTIONS(1398),
    [anon_sym_switch] = ACTIONS(1398),
    [anon_sym_case] = ACTIONS(1398),
    [anon_sym_default] = ACTIONS(1398),
    [anon_sym_while] = ACTIONS(1398),
    [anon_sym_do] = ACTIONS(1398),
    [anon_sym_for] = ACTIONS(1398),
    [anon_sym_return] = ACTIONS(1398),
    [anon_sym_break] = ACTIONS(1398),
    [anon_sym_continue] = ACTIONS(1398),
    [anon_sym_goto] = ACTIONS(1398),
    [anon_sym___try] = ACTIONS(1398),
    [anon_sym___leave] = ACTIONS(1398),
    [anon_sym_DASH_DASH] = ACTIONS(1400),
    [anon_sym_PLUS_PLUS] = ACTIONS(1400),
    [anon_sym_sizeof] = ACTIONS(1398),
    [anon_sym___alignof__] = ACTIONS(1398),
    [anon_sym___alignof] = ACTIONS(1398),
    [anon_sym__alignof] = ACTIONS(1398),
    [anon_sym_alignof] = ACTIONS(1398),
    [anon_sym__Alignof] = ACTIONS(1398),
    [anon_sym_offsetof] = ACTIONS(1398),
    [anon_sym__Generic] = ACTIONS(1398),
    [anon_sym_asm] = ACTIONS(1398),
    [anon_sym___asm__] = ACTIONS(1398),
    [sym_number_literal] = ACTIONS(1400),
    [anon_sym_L_SQUOTE] = ACTIONS(1400),
    [anon_sym_u_SQUOTE] = ACTIONS(1400),
    [anon_sym_U_SQUOTE] = ACTIONS(1400),
    [anon_sym_u8_SQUOTE] = ACTIONS(1400),
    [anon_sym_SQUOTE] = ACTIONS(1400),
    [anon_sym_L_DQUOTE] = ACTIONS(1400),
    [anon_sym_u_DQUOTE] = ACTIONS(1400),
    [anon_sym_U_DQUOTE] = ACTIONS(1400),
    [anon_sym_u8_DQUOTE] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(1398),
    [sym_false] = ACTIONS(1398),
    [anon_sym_NULL] = ACTIONS(1398),
    [anon_sym_nullptr] = ACTIONS(1398),
    [sym_comment] = ACTIONS(3),
  },
  [266] = {
    [ts_builtin_sym_end] = ACTIONS(1416),
    [sym_identifier] = ACTIONS(1414),
    [aux_sym_preproc_include_token1] = ACTIONS(1414),
    [aux_sym_preproc_def_token1] = ACTIONS(1414),
    [aux_sym_preproc_if_token1] = ACTIONS(1414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1414),
    [sym_preproc_directive] = ACTIONS(1414),
    [anon_sym_LPAREN2] = ACTIONS(1416),
    [anon_sym_BANG] = ACTIONS(1416),
    [anon_sym_TILDE] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1416),
    [anon_sym_AMP] = ACTIONS(1416),
    [anon_sym_SEMI] = ACTIONS(1416),
    [anon_sym___extension__] = ACTIONS(1414),
    [anon_sym_typedef] = ACTIONS(1414),
    [anon_sym_extern] = ACTIONS(1414),
    [anon_sym___attribute__] = ACTIONS(1414),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1416),
    [anon_sym___declspec] = ACTIONS(1414),
    [anon_sym___cdecl] = ACTIONS(1414),
    [anon_sym___clrcall] = ACTIONS(1414),
    [anon_sym___stdcall] = ACTIONS(1414),
    [anon_sym___fastcall] = ACTIONS(1414),
    [anon_sym___thiscall] = ACTIONS(1414),
    [anon_sym___vectorcall] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1416),
    [anon_sym_signed] = ACTIONS(1414),
    [anon_sym_unsigned] = ACTIONS(1414),
    [anon_sym_long] = ACTIONS(1414),
    [anon_sym_short] = ACTIONS(1414),
    [anon_sym_static] = ACTIONS(1414),
    [anon_sym_auto] = ACTIONS(1414),
    [anon_sym_register] = ACTIONS(1414),
    [anon_sym_inline] = ACTIONS(1414),
    [anon_sym___inline] = ACTIONS(1414),
    [anon_sym___inline__] = ACTIONS(1414),
    [anon_sym___forceinline] = ACTIONS(1414),
    [anon_sym_thread_local] = ACTIONS(1414),
    [anon_sym___thread] = ACTIONS(1414),
    [anon_sym_const] = ACTIONS(1414),
    [anon_sym_constexpr] = ACTIONS(1414),
    [anon_sym_volatile] = ACTIONS(1414),
    [anon_sym_restrict] = ACTIONS(1414),
    [anon_sym___restrict__] = ACTIONS(1414),
    [anon_sym__Atomic] = ACTIONS(1414),
    [anon_sym__Noreturn] = ACTIONS(1414),
    [anon_sym_noreturn] = ACTIONS(1414),
    [sym_primitive_type] = ACTIONS(1414),
    [anon_sym_enum] = ACTIONS(1414),
    [anon_sym_struct] = ACTIONS(1414),
    [anon_sym_union] = ACTIONS(1414),
    [anon_sym_if] = ACTIONS(1414),
    [anon_sym_else] = ACTIONS(1414),
    [anon_sym_switch] = ACTIONS(1414),
    [anon_sym_case] = ACTIONS(1414),
    [anon_sym_default] = ACTIONS(1414),
    [anon_sym_while] = ACTIONS(1414),
    [anon_sym_do] = ACTIONS(1414),
    [anon_sym_for] = ACTIONS(1414),
    [anon_sym_return] = ACTIONS(1414),
    [anon_sym_break] = ACTIONS(1414),
    [anon_sym_continue] = ACTIONS(1414),
    [anon_sym_goto] = ACTIONS(1414),
    [anon_sym___try] = ACTIONS(1414),
    [anon_sym___leave] = ACTIONS(1414),
    [anon_sym_DASH_DASH] = ACTIONS(1416),
    [anon_sym_PLUS_PLUS] = ACTIONS(1416),
    [anon_sym_sizeof] = ACTIONS(1414),
    [anon_sym___alignof__] = ACTIONS(1414),
    [anon_sym___alignof] = ACTIONS(1414),
    [anon_sym__alignof] = ACTIONS(1414),
    [anon_sym_alignof] = ACTIONS(1414),
    [anon_sym__Alignof] = ACTIONS(1414),
    [anon_sym_offsetof] = ACTIONS(1414),
    [anon_sym__Generic] = ACTIONS(1414),
    [anon_sym_asm] = ACTIONS(1414),
    [anon_sym___asm__] = ACTIONS(1414),
    [sym_number_literal] = ACTIONS(1416),
    [anon_sym_L_SQUOTE] = ACTIONS(1416),
    [anon_sym_u_SQUOTE] = ACTIONS(1416),
    [anon_sym_U_SQUOTE] = ACTIONS(1416),
    [anon_sym_u8_SQUOTE] = ACTIONS(1416),
    [anon_sym_SQUOTE] = ACTIONS(1416),
    [anon_sym_L_DQUOTE] = ACTIONS(1416),
    [anon_sym_u_DQUOTE] = ACTIONS(1416),
    [anon_sym_U_DQUOTE] = ACTIONS(1416),
    [anon_sym_u8_DQUOTE] = ACTIONS(1416),
    [anon_sym_DQUOTE] = ACTIONS(1416),
    [sym_true] = ACTIONS(1414),
    [sym_false] = ACTIONS(1414),
    [anon_sym_NULL] = ACTIONS(1414),
    [anon_sym_nullptr] = ACTIONS(1414),
    [sym_comment] = ACTIONS(3),
  },
  [267] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [268] = {
    [ts_builtin_sym_end] = ACTIONS(1416),
    [sym_identifier] = ACTIONS(1414),
    [aux_sym_preproc_include_token1] = ACTIONS(1414),
    [aux_sym_preproc_def_token1] = ACTIONS(1414),
    [aux_sym_preproc_if_token1] = ACTIONS(1414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1414),
    [sym_preproc_directive] = ACTIONS(1414),
    [anon_sym_LPAREN2] = ACTIONS(1416),
    [anon_sym_BANG] = ACTIONS(1416),
    [anon_sym_TILDE] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1416),
    [anon_sym_AMP] = ACTIONS(1416),
    [anon_sym_SEMI] = ACTIONS(1416),
    [anon_sym___extension__] = ACTIONS(1414),
    [anon_sym_typedef] = ACTIONS(1414),
    [anon_sym_extern] = ACTIONS(1414),
    [anon_sym___attribute__] = ACTIONS(1414),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1416),
    [anon_sym___declspec] = ACTIONS(1414),
    [anon_sym___cdecl] = ACTIONS(1414),
    [anon_sym___clrcall] = ACTIONS(1414),
    [anon_sym___stdcall] = ACTIONS(1414),
    [anon_sym___fastcall] = ACTIONS(1414),
    [anon_sym___thiscall] = ACTIONS(1414),
    [anon_sym___vectorcall] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1416),
    [anon_sym_signed] = ACTIONS(1414),
    [anon_sym_unsigned] = ACTIONS(1414),
    [anon_sym_long] = ACTIONS(1414),
    [anon_sym_short] = ACTIONS(1414),
    [anon_sym_static] = ACTIONS(1414),
    [anon_sym_auto] = ACTIONS(1414),
    [anon_sym_register] = ACTIONS(1414),
    [anon_sym_inline] = ACTIONS(1414),
    [anon_sym___inline] = ACTIONS(1414),
    [anon_sym___inline__] = ACTIONS(1414),
    [anon_sym___forceinline] = ACTIONS(1414),
    [anon_sym_thread_local] = ACTIONS(1414),
    [anon_sym___thread] = ACTIONS(1414),
    [anon_sym_const] = ACTIONS(1414),
    [anon_sym_constexpr] = ACTIONS(1414),
    [anon_sym_volatile] = ACTIONS(1414),
    [anon_sym_restrict] = ACTIONS(1414),
    [anon_sym___restrict__] = ACTIONS(1414),
    [anon_sym__Atomic] = ACTIONS(1414),
    [anon_sym__Noreturn] = ACTIONS(1414),
    [anon_sym_noreturn] = ACTIONS(1414),
    [sym_primitive_type] = ACTIONS(1414),
    [anon_sym_enum] = ACTIONS(1414),
    [anon_sym_struct] = ACTIONS(1414),
    [anon_sym_union] = ACTIONS(1414),
    [anon_sym_if] = ACTIONS(1414),
    [anon_sym_else] = ACTIONS(1414),
    [anon_sym_switch] = ACTIONS(1414),
    [anon_sym_case] = ACTIONS(1414),
    [anon_sym_default] = ACTIONS(1414),
    [anon_sym_while] = ACTIONS(1414),
    [anon_sym_do] = ACTIONS(1414),
    [anon_sym_for] = ACTIONS(1414),
    [anon_sym_return] = ACTIONS(1414),
    [anon_sym_break] = ACTIONS(1414),
    [anon_sym_continue] = ACTIONS(1414),
    [anon_sym_goto] = ACTIONS(1414),
    [anon_sym___try] = ACTIONS(1414),
    [anon_sym___leave] = ACTIONS(1414),
    [anon_sym_DASH_DASH] = ACTIONS(1416),
    [anon_sym_PLUS_PLUS] = ACTIONS(1416),
    [anon_sym_sizeof] = ACTIONS(1414),
    [anon_sym___alignof__] = ACTIONS(1414),
    [anon_sym___alignof] = ACTIONS(1414),
    [anon_sym__alignof] = ACTIONS(1414),
    [anon_sym_alignof] = ACTIONS(1414),
    [anon_sym__Alignof] = ACTIONS(1414),
    [anon_sym_offsetof] = ACTIONS(1414),
    [anon_sym__Generic] = ACTIONS(1414),
    [anon_sym_asm] = ACTIONS(1414),
    [anon_sym___asm__] = ACTIONS(1414),
    [sym_number_literal] = ACTIONS(1416),
    [anon_sym_L_SQUOTE] = ACTIONS(1416),
    [anon_sym_u_SQUOTE] = ACTIONS(1416),
    [anon_sym_U_SQUOTE] = ACTIONS(1416),
    [anon_sym_u8_SQUOTE] = ACTIONS(1416),
    [anon_sym_SQUOTE] = ACTIONS(1416),
    [anon_sym_L_DQUOTE] = ACTIONS(1416),
    [anon_sym_u_DQUOTE] = ACTIONS(1416),
    [anon_sym_U_DQUOTE] = ACTIONS(1416),
    [anon_sym_u8_DQUOTE] = ACTIONS(1416),
    [anon_sym_DQUOTE] = ACTIONS(1416),
    [sym_true] = ACTIONS(1414),
    [sym_false] = ACTIONS(1414),
    [anon_sym_NULL] = ACTIONS(1414),
    [anon_sym_nullptr] = ACTIONS(1414),
    [sym_comment] = ACTIONS(3),
  },
  [269] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [270] = {
    [ts_builtin_sym_end] = ACTIONS(1420),
    [sym_identifier] = ACTIONS(1418),
    [aux_sym_preproc_include_token1] = ACTIONS(1418),
    [aux_sym_preproc_def_token1] = ACTIONS(1418),
    [aux_sym_preproc_if_token1] = ACTIONS(1418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1418),
    [sym_preproc_directive] = ACTIONS(1418),
    [anon_sym_LPAREN2] = ACTIONS(1420),
    [anon_sym_BANG] = ACTIONS(1420),
    [anon_sym_TILDE] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_AMP] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(1420),
    [anon_sym___extension__] = ACTIONS(1418),
    [anon_sym_typedef] = ACTIONS(1418),
    [anon_sym_extern] = ACTIONS(1418),
    [anon_sym___attribute__] = ACTIONS(1418),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1420),
    [anon_sym___declspec] = ACTIONS(1418),
    [anon_sym___cdecl] = ACTIONS(1418),
    [anon_sym___clrcall] = ACTIONS(1418),
    [anon_sym___stdcall] = ACTIONS(1418),
    [anon_sym___fastcall] = ACTIONS(1418),
    [anon_sym___thiscall] = ACTIONS(1418),
    [anon_sym___vectorcall] = ACTIONS(1418),
    [anon_sym_LBRACE] = ACTIONS(1420),
    [anon_sym_signed] = ACTIONS(1418),
    [anon_sym_unsigned] = ACTIONS(1418),
    [anon_sym_long] = ACTIONS(1418),
    [anon_sym_short] = ACTIONS(1418),
    [anon_sym_static] = ACTIONS(1418),
    [anon_sym_auto] = ACTIONS(1418),
    [anon_sym_register] = ACTIONS(1418),
    [anon_sym_inline] = ACTIONS(1418),
    [anon_sym___inline] = ACTIONS(1418),
    [anon_sym___inline__] = ACTIONS(1418),
    [anon_sym___forceinline] = ACTIONS(1418),
    [anon_sym_thread_local] = ACTIONS(1418),
    [anon_sym___thread] = ACTIONS(1418),
    [anon_sym_const] = ACTIONS(1418),
    [anon_sym_constexpr] = ACTIONS(1418),
    [anon_sym_volatile] = ACTIONS(1418),
    [anon_sym_restrict] = ACTIONS(1418),
    [anon_sym___restrict__] = ACTIONS(1418),
    [anon_sym__Atomic] = ACTIONS(1418),
    [anon_sym__Noreturn] = ACTIONS(1418),
    [anon_sym_noreturn] = ACTIONS(1418),
    [sym_primitive_type] = ACTIONS(1418),
    [anon_sym_enum] = ACTIONS(1418),
    [anon_sym_struct] = ACTIONS(1418),
    [anon_sym_union] = ACTIONS(1418),
    [anon_sym_if] = ACTIONS(1418),
    [anon_sym_else] = ACTIONS(1418),
    [anon_sym_switch] = ACTIONS(1418),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_default] = ACTIONS(1418),
    [anon_sym_while] = ACTIONS(1418),
    [anon_sym_do] = ACTIONS(1418),
    [anon_sym_for] = ACTIONS(1418),
    [anon_sym_return] = ACTIONS(1418),
    [anon_sym_break] = ACTIONS(1418),
    [anon_sym_continue] = ACTIONS(1418),
    [anon_sym_goto] = ACTIONS(1418),
    [anon_sym___try] = ACTIONS(1418),
    [anon_sym___leave] = ACTIONS(1418),
    [anon_sym_DASH_DASH] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1420),
    [anon_sym_sizeof] = ACTIONS(1418),
    [anon_sym___alignof__] = ACTIONS(1418),
    [anon_sym___alignof] = ACTIONS(1418),
    [anon_sym__alignof] = ACTIONS(1418),
    [anon_sym_alignof] = ACTIONS(1418),
    [anon_sym__Alignof] = ACTIONS(1418),
    [anon_sym_offsetof] = ACTIONS(1418),
    [anon_sym__Generic] = ACTIONS(1418),
    [anon_sym_asm] = ACTIONS(1418),
    [anon_sym___asm__] = ACTIONS(1418),
    [sym_number_literal] = ACTIONS(1420),
    [anon_sym_L_SQUOTE] = ACTIONS(1420),
    [anon_sym_u_SQUOTE] = ACTIONS(1420),
    [anon_sym_U_SQUOTE] = ACTIONS(1420),
    [anon_sym_u8_SQUOTE] = ACTIONS(1420),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [anon_sym_L_DQUOTE] = ACTIONS(1420),
    [anon_sym_u_DQUOTE] = ACTIONS(1420),
    [anon_sym_U_DQUOTE] = ACTIONS(1420),
    [anon_sym_u8_DQUOTE] = ACTIONS(1420),
    [anon_sym_DQUOTE] = ACTIONS(1420),
    [sym_true] = ACTIONS(1418),
    [sym_false] = ACTIONS(1418),
    [anon_sym_NULL] = ACTIONS(1418),
    [anon_sym_nullptr] = ACTIONS(1418),
    [sym_comment] = ACTIONS(3),
  },
  [271] = {
    [sym_identifier] = ACTIONS(1390),
    [aux_sym_preproc_include_token1] = ACTIONS(1390),
    [aux_sym_preproc_def_token1] = ACTIONS(1390),
    [aux_sym_preproc_if_token1] = ACTIONS(1390),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1390),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1390),
    [sym_preproc_directive] = ACTIONS(1390),
    [anon_sym_LPAREN2] = ACTIONS(1392),
    [anon_sym_BANG] = ACTIONS(1392),
    [anon_sym_TILDE] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_AMP] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1392),
    [anon_sym___extension__] = ACTIONS(1390),
    [anon_sym_typedef] = ACTIONS(1390),
    [anon_sym_extern] = ACTIONS(1390),
    [anon_sym___attribute__] = ACTIONS(1390),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1392),
    [anon_sym___declspec] = ACTIONS(1390),
    [anon_sym___cdecl] = ACTIONS(1390),
    [anon_sym___clrcall] = ACTIONS(1390),
    [anon_sym___stdcall] = ACTIONS(1390),
    [anon_sym___fastcall] = ACTIONS(1390),
    [anon_sym___thiscall] = ACTIONS(1390),
    [anon_sym___vectorcall] = ACTIONS(1390),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_RBRACE] = ACTIONS(1392),
    [anon_sym_signed] = ACTIONS(1390),
    [anon_sym_unsigned] = ACTIONS(1390),
    [anon_sym_long] = ACTIONS(1390),
    [anon_sym_short] = ACTIONS(1390),
    [anon_sym_static] = ACTIONS(1390),
    [anon_sym_auto] = ACTIONS(1390),
    [anon_sym_register] = ACTIONS(1390),
    [anon_sym_inline] = ACTIONS(1390),
    [anon_sym___inline] = ACTIONS(1390),
    [anon_sym___inline__] = ACTIONS(1390),
    [anon_sym___forceinline] = ACTIONS(1390),
    [anon_sym_thread_local] = ACTIONS(1390),
    [anon_sym___thread] = ACTIONS(1390),
    [anon_sym_const] = ACTIONS(1390),
    [anon_sym_constexpr] = ACTIONS(1390),
    [anon_sym_volatile] = ACTIONS(1390),
    [anon_sym_restrict] = ACTIONS(1390),
    [anon_sym___restrict__] = ACTIONS(1390),
    [anon_sym__Atomic] = ACTIONS(1390),
    [anon_sym__Noreturn] = ACTIONS(1390),
    [anon_sym_noreturn] = ACTIONS(1390),
    [sym_primitive_type] = ACTIONS(1390),
    [anon_sym_enum] = ACTIONS(1390),
    [anon_sym_struct] = ACTIONS(1390),
    [anon_sym_union] = ACTIONS(1390),
    [anon_sym_if] = ACTIONS(1390),
    [anon_sym_else] = ACTIONS(1390),
    [anon_sym_switch] = ACTIONS(1390),
    [anon_sym_case] = ACTIONS(1390),
    [anon_sym_default] = ACTIONS(1390),
    [anon_sym_while] = ACTIONS(1390),
    [anon_sym_do] = ACTIONS(1390),
    [anon_sym_for] = ACTIONS(1390),
    [anon_sym_return] = ACTIONS(1390),
    [anon_sym_break] = ACTIONS(1390),
    [anon_sym_continue] = ACTIONS(1390),
    [anon_sym_goto] = ACTIONS(1390),
    [anon_sym___try] = ACTIONS(1390),
    [anon_sym___leave] = ACTIONS(1390),
    [anon_sym_DASH_DASH] = ACTIONS(1392),
    [anon_sym_PLUS_PLUS] = ACTIONS(1392),
    [anon_sym_sizeof] = ACTIONS(1390),
    [anon_sym___alignof__] = ACTIONS(1390),
    [anon_sym___alignof] = ACTIONS(1390),
    [anon_sym__alignof] = ACTIONS(1390),
    [anon_sym_alignof] = ACTIONS(1390),
    [anon_sym__Alignof] = ACTIONS(1390),
    [anon_sym_offsetof] = ACTIONS(1390),
    [anon_sym__Generic] = ACTIONS(1390),
    [anon_sym_asm] = ACTIONS(1390),
    [anon_sym___asm__] = ACTIONS(1390),
    [sym_number_literal] = ACTIONS(1392),
    [anon_sym_L_SQUOTE] = ACTIONS(1392),
    [anon_sym_u_SQUOTE] = ACTIONS(1392),
    [anon_sym_U_SQUOTE] = ACTIONS(1392),
    [anon_sym_u8_SQUOTE] = ACTIONS(1392),
    [anon_sym_SQUOTE] = ACTIONS(1392),
    [anon_sym_L_DQUOTE] = ACTIONS(1392),
    [anon_sym_u_DQUOTE] = ACTIONS(1392),
    [anon_sym_U_DQUOTE] = ACTIONS(1392),
    [anon_sym_u8_DQUOTE] = ACTIONS(1392),
    [anon_sym_DQUOTE] = ACTIONS(1392),
    [sym_true] = ACTIONS(1390),
    [sym_false] = ACTIONS(1390),
    [anon_sym_NULL] = ACTIONS(1390),
    [anon_sym_nullptr] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
  },
  [272] = {
    [sym_identifier] = ACTIONS(1394),
    [aux_sym_preproc_include_token1] = ACTIONS(1394),
    [aux_sym_preproc_def_token1] = ACTIONS(1394),
    [aux_sym_preproc_if_token1] = ACTIONS(1394),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1394),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1394),
    [sym_preproc_directive] = ACTIONS(1394),
    [anon_sym_LPAREN2] = ACTIONS(1396),
    [anon_sym_BANG] = ACTIONS(1396),
    [anon_sym_TILDE] = ACTIONS(1396),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_PLUS] = ACTIONS(1394),
    [anon_sym_STAR] = ACTIONS(1396),
    [anon_sym_AMP] = ACTIONS(1396),
    [anon_sym_SEMI] = ACTIONS(1396),
    [anon_sym___extension__] = ACTIONS(1394),
    [anon_sym_typedef] = ACTIONS(1394),
    [anon_sym_extern] = ACTIONS(1394),
    [anon_sym___attribute__] = ACTIONS(1394),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1396),
    [anon_sym___declspec] = ACTIONS(1394),
    [anon_sym___cdecl] = ACTIONS(1394),
    [anon_sym___clrcall] = ACTIONS(1394),
    [anon_sym___stdcall] = ACTIONS(1394),
    [anon_sym___fastcall] = ACTIONS(1394),
    [anon_sym___thiscall] = ACTIONS(1394),
    [anon_sym___vectorcall] = ACTIONS(1394),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_RBRACE] = ACTIONS(1396),
    [anon_sym_signed] = ACTIONS(1394),
    [anon_sym_unsigned] = ACTIONS(1394),
    [anon_sym_long] = ACTIONS(1394),
    [anon_sym_short] = ACTIONS(1394),
    [anon_sym_static] = ACTIONS(1394),
    [anon_sym_auto] = ACTIONS(1394),
    [anon_sym_register] = ACTIONS(1394),
    [anon_sym_inline] = ACTIONS(1394),
    [anon_sym___inline] = ACTIONS(1394),
    [anon_sym___inline__] = ACTIONS(1394),
    [anon_sym___forceinline] = ACTIONS(1394),
    [anon_sym_thread_local] = ACTIONS(1394),
    [anon_sym___thread] = ACTIONS(1394),
    [anon_sym_const] = ACTIONS(1394),
    [anon_sym_constexpr] = ACTIONS(1394),
    [anon_sym_volatile] = ACTIONS(1394),
    [anon_sym_restrict] = ACTIONS(1394),
    [anon_sym___restrict__] = ACTIONS(1394),
    [anon_sym__Atomic] = ACTIONS(1394),
    [anon_sym__Noreturn] = ACTIONS(1394),
    [anon_sym_noreturn] = ACTIONS(1394),
    [sym_primitive_type] = ACTIONS(1394),
    [anon_sym_enum] = ACTIONS(1394),
    [anon_sym_struct] = ACTIONS(1394),
    [anon_sym_union] = ACTIONS(1394),
    [anon_sym_if] = ACTIONS(1394),
    [anon_sym_else] = ACTIONS(1394),
    [anon_sym_switch] = ACTIONS(1394),
    [anon_sym_case] = ACTIONS(1394),
    [anon_sym_default] = ACTIONS(1394),
    [anon_sym_while] = ACTIONS(1394),
    [anon_sym_do] = ACTIONS(1394),
    [anon_sym_for] = ACTIONS(1394),
    [anon_sym_return] = ACTIONS(1394),
    [anon_sym_break] = ACTIONS(1394),
    [anon_sym_continue] = ACTIONS(1394),
    [anon_sym_goto] = ACTIONS(1394),
    [anon_sym___try] = ACTIONS(1394),
    [anon_sym___leave] = ACTIONS(1394),
    [anon_sym_DASH_DASH] = ACTIONS(1396),
    [anon_sym_PLUS_PLUS] = ACTIONS(1396),
    [anon_sym_sizeof] = ACTIONS(1394),
    [anon_sym___alignof__] = ACTIONS(1394),
    [anon_sym___alignof] = ACTIONS(1394),
    [anon_sym__alignof] = ACTIONS(1394),
    [anon_sym_alignof] = ACTIONS(1394),
    [anon_sym__Alignof] = ACTIONS(1394),
    [anon_sym_offsetof] = ACTIONS(1394),
    [anon_sym__Generic] = ACTIONS(1394),
    [anon_sym_asm] = ACTIONS(1394),
    [anon_sym___asm__] = ACTIONS(1394),
    [sym_number_literal] = ACTIONS(1396),
    [anon_sym_L_SQUOTE] = ACTIONS(1396),
    [anon_sym_u_SQUOTE] = ACTIONS(1396),
    [anon_sym_U_SQUOTE] = ACTIONS(1396),
    [anon_sym_u8_SQUOTE] = ACTIONS(1396),
    [anon_sym_SQUOTE] = ACTIONS(1396),
    [anon_sym_L_DQUOTE] = ACTIONS(1396),
    [anon_sym_u_DQUOTE] = ACTIONS(1396),
    [anon_sym_U_DQUOTE] = ACTIONS(1396),
    [anon_sym_u8_DQUOTE] = ACTIONS(1396),
    [anon_sym_DQUOTE] = ACTIONS(1396),
    [sym_true] = ACTIONS(1394),
    [sym_false] = ACTIONS(1394),
    [anon_sym_NULL] = ACTIONS(1394),
    [anon_sym_nullptr] = ACTIONS(1394),
    [sym_comment] = ACTIONS(3),
  },
  [273] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [274] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [275] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [276] = {
    [ts_builtin_sym_end] = ACTIONS(1412),
    [sym_identifier] = ACTIONS(1410),
    [aux_sym_preproc_include_token1] = ACTIONS(1410),
    [aux_sym_preproc_def_token1] = ACTIONS(1410),
    [aux_sym_preproc_if_token1] = ACTIONS(1410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1410),
    [sym_preproc_directive] = ACTIONS(1410),
    [anon_sym_LPAREN2] = ACTIONS(1412),
    [anon_sym_BANG] = ACTIONS(1412),
    [anon_sym_TILDE] = ACTIONS(1412),
    [anon_sym_DASH] = ACTIONS(1410),
    [anon_sym_PLUS] = ACTIONS(1410),
    [anon_sym_STAR] = ACTIONS(1412),
    [anon_sym_AMP] = ACTIONS(1412),
    [anon_sym_SEMI] = ACTIONS(1412),
    [anon_sym___extension__] = ACTIONS(1410),
    [anon_sym_typedef] = ACTIONS(1410),
    [anon_sym_extern] = ACTIONS(1410),
    [anon_sym___attribute__] = ACTIONS(1410),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1412),
    [anon_sym___declspec] = ACTIONS(1410),
    [anon_sym___cdecl] = ACTIONS(1410),
    [anon_sym___clrcall] = ACTIONS(1410),
    [anon_sym___stdcall] = ACTIONS(1410),
    [anon_sym___fastcall] = ACTIONS(1410),
    [anon_sym___thiscall] = ACTIONS(1410),
    [anon_sym___vectorcall] = ACTIONS(1410),
    [anon_sym_LBRACE] = ACTIONS(1412),
    [anon_sym_signed] = ACTIONS(1410),
    [anon_sym_unsigned] = ACTIONS(1410),
    [anon_sym_long] = ACTIONS(1410),
    [anon_sym_short] = ACTIONS(1410),
    [anon_sym_static] = ACTIONS(1410),
    [anon_sym_auto] = ACTIONS(1410),
    [anon_sym_register] = ACTIONS(1410),
    [anon_sym_inline] = ACTIONS(1410),
    [anon_sym___inline] = ACTIONS(1410),
    [anon_sym___inline__] = ACTIONS(1410),
    [anon_sym___forceinline] = ACTIONS(1410),
    [anon_sym_thread_local] = ACTIONS(1410),
    [anon_sym___thread] = ACTIONS(1410),
    [anon_sym_const] = ACTIONS(1410),
    [anon_sym_constexpr] = ACTIONS(1410),
    [anon_sym_volatile] = ACTIONS(1410),
    [anon_sym_restrict] = ACTIONS(1410),
    [anon_sym___restrict__] = ACTIONS(1410),
    [anon_sym__Atomic] = ACTIONS(1410),
    [anon_sym__Noreturn] = ACTIONS(1410),
    [anon_sym_noreturn] = ACTIONS(1410),
    [sym_primitive_type] = ACTIONS(1410),
    [anon_sym_enum] = ACTIONS(1410),
    [anon_sym_struct] = ACTIONS(1410),
    [anon_sym_union] = ACTIONS(1410),
    [anon_sym_if] = ACTIONS(1410),
    [anon_sym_else] = ACTIONS(1410),
    [anon_sym_switch] = ACTIONS(1410),
    [anon_sym_case] = ACTIONS(1410),
    [anon_sym_default] = ACTIONS(1410),
    [anon_sym_while] = ACTIONS(1410),
    [anon_sym_do] = ACTIONS(1410),
    [anon_sym_for] = ACTIONS(1410),
    [anon_sym_return] = ACTIONS(1410),
    [anon_sym_break] = ACTIONS(1410),
    [anon_sym_continue] = ACTIONS(1410),
    [anon_sym_goto] = ACTIONS(1410),
    [anon_sym___try] = ACTIONS(1410),
    [anon_sym___leave] = ACTIONS(1410),
    [anon_sym_DASH_DASH] = ACTIONS(1412),
    [anon_sym_PLUS_PLUS] = ACTIONS(1412),
    [anon_sym_sizeof] = ACTIONS(1410),
    [anon_sym___alignof__] = ACTIONS(1410),
    [anon_sym___alignof] = ACTIONS(1410),
    [anon_sym__alignof] = ACTIONS(1410),
    [anon_sym_alignof] = ACTIONS(1410),
    [anon_sym__Alignof] = ACTIONS(1410),
    [anon_sym_offsetof] = ACTIONS(1410),
    [anon_sym__Generic] = ACTIONS(1410),
    [anon_sym_asm] = ACTIONS(1410),
    [anon_sym___asm__] = ACTIONS(1410),
    [sym_number_literal] = ACTIONS(1412),
    [anon_sym_L_SQUOTE] = ACTIONS(1412),
    [anon_sym_u_SQUOTE] = ACTIONS(1412),
    [anon_sym_U_SQUOTE] = ACTIONS(1412),
    [anon_sym_u8_SQUOTE] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(1412),
    [anon_sym_L_DQUOTE] = ACTIONS(1412),
    [anon_sym_u_DQUOTE] = ACTIONS(1412),
    [anon_sym_U_DQUOTE] = ACTIONS(1412),
    [anon_sym_u8_DQUOTE] = ACTIONS(1412),
    [anon_sym_DQUOTE] = ACTIONS(1412),
    [sym_true] = ACTIONS(1410),
    [sym_false] = ACTIONS(1410),
    [anon_sym_NULL] = ACTIONS(1410),
    [anon_sym_nullptr] = ACTIONS(1410),
    [sym_comment] = ACTIONS(3),
  },
  [277] = {
    [ts_builtin_sym_end] = ACTIONS(1408),
    [sym_identifier] = ACTIONS(1406),
    [aux_sym_preproc_include_token1] = ACTIONS(1406),
    [aux_sym_preproc_def_token1] = ACTIONS(1406),
    [aux_sym_preproc_if_token1] = ACTIONS(1406),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1406),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1406),
    [sym_preproc_directive] = ACTIONS(1406),
    [anon_sym_LPAREN2] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1408),
    [anon_sym_DASH] = ACTIONS(1406),
    [anon_sym_PLUS] = ACTIONS(1406),
    [anon_sym_STAR] = ACTIONS(1408),
    [anon_sym_AMP] = ACTIONS(1408),
    [anon_sym_SEMI] = ACTIONS(1408),
    [anon_sym___extension__] = ACTIONS(1406),
    [anon_sym_typedef] = ACTIONS(1406),
    [anon_sym_extern] = ACTIONS(1406),
    [anon_sym___attribute__] = ACTIONS(1406),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1408),
    [anon_sym___declspec] = ACTIONS(1406),
    [anon_sym___cdecl] = ACTIONS(1406),
    [anon_sym___clrcall] = ACTIONS(1406),
    [anon_sym___stdcall] = ACTIONS(1406),
    [anon_sym___fastcall] = ACTIONS(1406),
    [anon_sym___thiscall] = ACTIONS(1406),
    [anon_sym___vectorcall] = ACTIONS(1406),
    [anon_sym_LBRACE] = ACTIONS(1408),
    [anon_sym_signed] = ACTIONS(1406),
    [anon_sym_unsigned] = ACTIONS(1406),
    [anon_sym_long] = ACTIONS(1406),
    [anon_sym_short] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_auto] = ACTIONS(1406),
    [anon_sym_register] = ACTIONS(1406),
    [anon_sym_inline] = ACTIONS(1406),
    [anon_sym___inline] = ACTIONS(1406),
    [anon_sym___inline__] = ACTIONS(1406),
    [anon_sym___forceinline] = ACTIONS(1406),
    [anon_sym_thread_local] = ACTIONS(1406),
    [anon_sym___thread] = ACTIONS(1406),
    [anon_sym_const] = ACTIONS(1406),
    [anon_sym_constexpr] = ACTIONS(1406),
    [anon_sym_volatile] = ACTIONS(1406),
    [anon_sym_restrict] = ACTIONS(1406),
    [anon_sym___restrict__] = ACTIONS(1406),
    [anon_sym__Atomic] = ACTIONS(1406),
    [anon_sym__Noreturn] = ACTIONS(1406),
    [anon_sym_noreturn] = ACTIONS(1406),
    [sym_primitive_type] = ACTIONS(1406),
    [anon_sym_enum] = ACTIONS(1406),
    [anon_sym_struct] = ACTIONS(1406),
    [anon_sym_union] = ACTIONS(1406),
    [anon_sym_if] = ACTIONS(1406),
    [anon_sym_else] = ACTIONS(1406),
    [anon_sym_switch] = ACTIONS(1406),
    [anon_sym_case] = ACTIONS(1406),
    [anon_sym_default] = ACTIONS(1406),
    [anon_sym_while] = ACTIONS(1406),
    [anon_sym_do] = ACTIONS(1406),
    [anon_sym_for] = ACTIONS(1406),
    [anon_sym_return] = ACTIONS(1406),
    [anon_sym_break] = ACTIONS(1406),
    [anon_sym_continue] = ACTIONS(1406),
    [anon_sym_goto] = ACTIONS(1406),
    [anon_sym___try] = ACTIONS(1406),
    [anon_sym___leave] = ACTIONS(1406),
    [anon_sym_DASH_DASH] = ACTIONS(1408),
    [anon_sym_PLUS_PLUS] = ACTIONS(1408),
    [anon_sym_sizeof] = ACTIONS(1406),
    [anon_sym___alignof__] = ACTIONS(1406),
    [anon_sym___alignof] = ACTIONS(1406),
    [anon_sym__alignof] = ACTIONS(1406),
    [anon_sym_alignof] = ACTIONS(1406),
    [anon_sym__Alignof] = ACTIONS(1406),
    [anon_sym_offsetof] = ACTIONS(1406),
    [anon_sym__Generic] = ACTIONS(1406),
    [anon_sym_asm] = ACTIONS(1406),
    [anon_sym___asm__] = ACTIONS(1406),
    [sym_number_literal] = ACTIONS(1408),
    [anon_sym_L_SQUOTE] = ACTIONS(1408),
    [anon_sym_u_SQUOTE] = ACTIONS(1408),
    [anon_sym_U_SQUOTE] = ACTIONS(1408),
    [anon_sym_u8_SQUOTE] = ACTIONS(1408),
    [anon_sym_SQUOTE] = ACTIONS(1408),
    [anon_sym_L_DQUOTE] = ACTIONS(1408),
    [anon_sym_u_DQUOTE] = ACTIONS(1408),
    [anon_sym_U_DQUOTE] = ACTIONS(1408),
    [anon_sym_u8_DQUOTE] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1408),
    [sym_true] = ACTIONS(1406),
    [sym_false] = ACTIONS(1406),
    [anon_sym_NULL] = ACTIONS(1406),
    [anon_sym_nullptr] = ACTIONS(1406),
    [sym_comment] = ACTIONS(3),
  },
  [278] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [279] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [280] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [281] = {
    [ts_builtin_sym_end] = ACTIONS(1360),
    [sym_identifier] = ACTIONS(1358),
    [aux_sym_preproc_include_token1] = ACTIONS(1358),
    [aux_sym_preproc_def_token1] = ACTIONS(1358),
    [aux_sym_preproc_if_token1] = ACTIONS(1358),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1358),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1358),
    [sym_preproc_directive] = ACTIONS(1358),
    [anon_sym_LPAREN2] = ACTIONS(1360),
    [anon_sym_BANG] = ACTIONS(1360),
    [anon_sym_TILDE] = ACTIONS(1360),
    [anon_sym_DASH] = ACTIONS(1358),
    [anon_sym_PLUS] = ACTIONS(1358),
    [anon_sym_STAR] = ACTIONS(1360),
    [anon_sym_AMP] = ACTIONS(1360),
    [anon_sym_SEMI] = ACTIONS(1360),
    [anon_sym___extension__] = ACTIONS(1358),
    [anon_sym_typedef] = ACTIONS(1358),
    [anon_sym_extern] = ACTIONS(1358),
    [anon_sym___attribute__] = ACTIONS(1358),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1360),
    [anon_sym___declspec] = ACTIONS(1358),
    [anon_sym___cdecl] = ACTIONS(1358),
    [anon_sym___clrcall] = ACTIONS(1358),
    [anon_sym___stdcall] = ACTIONS(1358),
    [anon_sym___fastcall] = ACTIONS(1358),
    [anon_sym___thiscall] = ACTIONS(1358),
    [anon_sym___vectorcall] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_signed] = ACTIONS(1358),
    [anon_sym_unsigned] = ACTIONS(1358),
    [anon_sym_long] = ACTIONS(1358),
    [anon_sym_short] = ACTIONS(1358),
    [anon_sym_static] = ACTIONS(1358),
    [anon_sym_auto] = ACTIONS(1358),
    [anon_sym_register] = ACTIONS(1358),
    [anon_sym_inline] = ACTIONS(1358),
    [anon_sym___inline] = ACTIONS(1358),
    [anon_sym___inline__] = ACTIONS(1358),
    [anon_sym___forceinline] = ACTIONS(1358),
    [anon_sym_thread_local] = ACTIONS(1358),
    [anon_sym___thread] = ACTIONS(1358),
    [anon_sym_const] = ACTIONS(1358),
    [anon_sym_constexpr] = ACTIONS(1358),
    [anon_sym_volatile] = ACTIONS(1358),
    [anon_sym_restrict] = ACTIONS(1358),
    [anon_sym___restrict__] = ACTIONS(1358),
    [anon_sym__Atomic] = ACTIONS(1358),
    [anon_sym__Noreturn] = ACTIONS(1358),
    [anon_sym_noreturn] = ACTIONS(1358),
    [sym_primitive_type] = ACTIONS(1358),
    [anon_sym_enum] = ACTIONS(1358),
    [anon_sym_struct] = ACTIONS(1358),
    [anon_sym_union] = ACTIONS(1358),
    [anon_sym_if] = ACTIONS(1358),
    [anon_sym_else] = ACTIONS(1358),
    [anon_sym_switch] = ACTIONS(1358),
    [anon_sym_case] = ACTIONS(1358),
    [anon_sym_default] = ACTIONS(1358),
    [anon_sym_while] = ACTIONS(1358),
    [anon_sym_do] = ACTIONS(1358),
    [anon_sym_for] = ACTIONS(1358),
    [anon_sym_return] = ACTIONS(1358),
    [anon_sym_break] = ACTIONS(1358),
    [anon_sym_continue] = ACTIONS(1358),
    [anon_sym_goto] = ACTIONS(1358),
    [anon_sym___try] = ACTIONS(1358),
    [anon_sym___leave] = ACTIONS(1358),
    [anon_sym_DASH_DASH] = ACTIONS(1360),
    [anon_sym_PLUS_PLUS] = ACTIONS(1360),
    [anon_sym_sizeof] = ACTIONS(1358),
    [anon_sym___alignof__] = ACTIONS(1358),
    [anon_sym___alignof] = ACTIONS(1358),
    [anon_sym__alignof] = ACTIONS(1358),
    [anon_sym_alignof] = ACTIONS(1358),
    [anon_sym__Alignof] = ACTIONS(1358),
    [anon_sym_offsetof] = ACTIONS(1358),
    [anon_sym__Generic] = ACTIONS(1358),
    [anon_sym_asm] = ACTIONS(1358),
    [anon_sym___asm__] = ACTIONS(1358),
    [sym_number_literal] = ACTIONS(1360),
    [anon_sym_L_SQUOTE] = ACTIONS(1360),
    [anon_sym_u_SQUOTE] = ACTIONS(1360),
    [anon_sym_U_SQUOTE] = ACTIONS(1360),
    [anon_sym_u8_SQUOTE] = ACTIONS(1360),
    [anon_sym_SQUOTE] = ACTIONS(1360),
    [anon_sym_L_DQUOTE] = ACTIONS(1360),
    [anon_sym_u_DQUOTE] = ACTIONS(1360),
    [anon_sym_U_DQUOTE] = ACTIONS(1360),
    [anon_sym_u8_DQUOTE] = ACTIONS(1360),
    [anon_sym_DQUOTE] = ACTIONS(1360),
    [sym_true] = ACTIONS(1358),
    [sym_false] = ACTIONS(1358),
    [anon_sym_NULL] = ACTIONS(1358),
    [anon_sym_nullptr] = ACTIONS(1358),
    [sym_comment] = ACTIONS(3),
  },
  [282] = {
    [ts_builtin_sym_end] = ACTIONS(1388),
    [sym_identifier] = ACTIONS(1386),
    [aux_sym_preproc_include_token1] = ACTIONS(1386),
    [aux_sym_preproc_def_token1] = ACTIONS(1386),
    [aux_sym_preproc_if_token1] = ACTIONS(1386),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1386),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1386),
    [sym_preproc_directive] = ACTIONS(1386),
    [anon_sym_LPAREN2] = ACTIONS(1388),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1388),
    [anon_sym_DASH] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(1386),
    [anon_sym_STAR] = ACTIONS(1388),
    [anon_sym_AMP] = ACTIONS(1388),
    [anon_sym_SEMI] = ACTIONS(1388),
    [anon_sym___extension__] = ACTIONS(1386),
    [anon_sym_typedef] = ACTIONS(1386),
    [anon_sym_extern] = ACTIONS(1386),
    [anon_sym___attribute__] = ACTIONS(1386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1388),
    [anon_sym___declspec] = ACTIONS(1386),
    [anon_sym___cdecl] = ACTIONS(1386),
    [anon_sym___clrcall] = ACTIONS(1386),
    [anon_sym___stdcall] = ACTIONS(1386),
    [anon_sym___fastcall] = ACTIONS(1386),
    [anon_sym___thiscall] = ACTIONS(1386),
    [anon_sym___vectorcall] = ACTIONS(1386),
    [anon_sym_LBRACE] = ACTIONS(1388),
    [anon_sym_signed] = ACTIONS(1386),
    [anon_sym_unsigned] = ACTIONS(1386),
    [anon_sym_long] = ACTIONS(1386),
    [anon_sym_short] = ACTIONS(1386),
    [anon_sym_static] = ACTIONS(1386),
    [anon_sym_auto] = ACTIONS(1386),
    [anon_sym_register] = ACTIONS(1386),
    [anon_sym_inline] = ACTIONS(1386),
    [anon_sym___inline] = ACTIONS(1386),
    [anon_sym___inline__] = ACTIONS(1386),
    [anon_sym___forceinline] = ACTIONS(1386),
    [anon_sym_thread_local] = ACTIONS(1386),
    [anon_sym___thread] = ACTIONS(1386),
    [anon_sym_const] = ACTIONS(1386),
    [anon_sym_constexpr] = ACTIONS(1386),
    [anon_sym_volatile] = ACTIONS(1386),
    [anon_sym_restrict] = ACTIONS(1386),
    [anon_sym___restrict__] = ACTIONS(1386),
    [anon_sym__Atomic] = ACTIONS(1386),
    [anon_sym__Noreturn] = ACTIONS(1386),
    [anon_sym_noreturn] = ACTIONS(1386),
    [sym_primitive_type] = ACTIONS(1386),
    [anon_sym_enum] = ACTIONS(1386),
    [anon_sym_struct] = ACTIONS(1386),
    [anon_sym_union] = ACTIONS(1386),
    [anon_sym_if] = ACTIONS(1386),
    [anon_sym_else] = ACTIONS(1386),
    [anon_sym_switch] = ACTIONS(1386),
    [anon_sym_case] = ACTIONS(1386),
    [anon_sym_default] = ACTIONS(1386),
    [anon_sym_while] = ACTIONS(1386),
    [anon_sym_do] = ACTIONS(1386),
    [anon_sym_for] = ACTIONS(1386),
    [anon_sym_return] = ACTIONS(1386),
    [anon_sym_break] = ACTIONS(1386),
    [anon_sym_continue] = ACTIONS(1386),
    [anon_sym_goto] = ACTIONS(1386),
    [anon_sym___try] = ACTIONS(1386),
    [anon_sym___leave] = ACTIONS(1386),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_sizeof] = ACTIONS(1386),
    [anon_sym___alignof__] = ACTIONS(1386),
    [anon_sym___alignof] = ACTIONS(1386),
    [anon_sym__alignof] = ACTIONS(1386),
    [anon_sym_alignof] = ACTIONS(1386),
    [anon_sym__Alignof] = ACTIONS(1386),
    [anon_sym_offsetof] = ACTIONS(1386),
    [anon_sym__Generic] = ACTIONS(1386),
    [anon_sym_asm] = ACTIONS(1386),
    [anon_sym___asm__] = ACTIONS(1386),
    [sym_number_literal] = ACTIONS(1388),
    [anon_sym_L_SQUOTE] = ACTIONS(1388),
    [anon_sym_u_SQUOTE] = ACTIONS(1388),
    [anon_sym_U_SQUOTE] = ACTIONS(1388),
    [anon_sym_u8_SQUOTE] = ACTIONS(1388),
    [anon_sym_SQUOTE] = ACTIONS(1388),
    [anon_sym_L_DQUOTE] = ACTIONS(1388),
    [anon_sym_u_DQUOTE] = ACTIONS(1388),
    [anon_sym_U_DQUOTE] = ACTIONS(1388),
    [anon_sym_u8_DQUOTE] = ACTIONS(1388),
    [anon_sym_DQUOTE] = ACTIONS(1388),
    [sym_true] = ACTIONS(1386),
    [sym_false] = ACTIONS(1386),
    [anon_sym_NULL] = ACTIONS(1386),
    [anon_sym_nullptr] = ACTIONS(1386),
    [sym_comment] = ACTIONS(3),
  },
  [283] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [284] = {
    [sym_identifier] = ACTIONS(1382),
    [aux_sym_preproc_include_token1] = ACTIONS(1382),
    [aux_sym_preproc_def_token1] = ACTIONS(1382),
    [aux_sym_preproc_if_token1] = ACTIONS(1382),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1382),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1382),
    [sym_preproc_directive] = ACTIONS(1382),
    [anon_sym_LPAREN2] = ACTIONS(1384),
    [anon_sym_BANG] = ACTIONS(1384),
    [anon_sym_TILDE] = ACTIONS(1384),
    [anon_sym_DASH] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1382),
    [anon_sym_STAR] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym___extension__] = ACTIONS(1382),
    [anon_sym_typedef] = ACTIONS(1382),
    [anon_sym_extern] = ACTIONS(1382),
    [anon_sym___attribute__] = ACTIONS(1382),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1384),
    [anon_sym___declspec] = ACTIONS(1382),
    [anon_sym___cdecl] = ACTIONS(1382),
    [anon_sym___clrcall] = ACTIONS(1382),
    [anon_sym___stdcall] = ACTIONS(1382),
    [anon_sym___fastcall] = ACTIONS(1382),
    [anon_sym___thiscall] = ACTIONS(1382),
    [anon_sym___vectorcall] = ACTIONS(1382),
    [anon_sym_LBRACE] = ACTIONS(1384),
    [anon_sym_RBRACE] = ACTIONS(1384),
    [anon_sym_signed] = ACTIONS(1382),
    [anon_sym_unsigned] = ACTIONS(1382),
    [anon_sym_long] = ACTIONS(1382),
    [anon_sym_short] = ACTIONS(1382),
    [anon_sym_static] = ACTIONS(1382),
    [anon_sym_auto] = ACTIONS(1382),
    [anon_sym_register] = ACTIONS(1382),
    [anon_sym_inline] = ACTIONS(1382),
    [anon_sym___inline] = ACTIONS(1382),
    [anon_sym___inline__] = ACTIONS(1382),
    [anon_sym___forceinline] = ACTIONS(1382),
    [anon_sym_thread_local] = ACTIONS(1382),
    [anon_sym___thread] = ACTIONS(1382),
    [anon_sym_const] = ACTIONS(1382),
    [anon_sym_constexpr] = ACTIONS(1382),
    [anon_sym_volatile] = ACTIONS(1382),
    [anon_sym_restrict] = ACTIONS(1382),
    [anon_sym___restrict__] = ACTIONS(1382),
    [anon_sym__Atomic] = ACTIONS(1382),
    [anon_sym__Noreturn] = ACTIONS(1382),
    [anon_sym_noreturn] = ACTIONS(1382),
    [sym_primitive_type] = ACTIONS(1382),
    [anon_sym_enum] = ACTIONS(1382),
    [anon_sym_struct] = ACTIONS(1382),
    [anon_sym_union] = ACTIONS(1382),
    [anon_sym_if] = ACTIONS(1382),
    [anon_sym_else] = ACTIONS(1382),
    [anon_sym_switch] = ACTIONS(1382),
    [anon_sym_case] = ACTIONS(1382),
    [anon_sym_default] = ACTIONS(1382),
    [anon_sym_while] = ACTIONS(1382),
    [anon_sym_do] = ACTIONS(1382),
    [anon_sym_for] = ACTIONS(1382),
    [anon_sym_return] = ACTIONS(1382),
    [anon_sym_break] = ACTIONS(1382),
    [anon_sym_continue] = ACTIONS(1382),
    [anon_sym_goto] = ACTIONS(1382),
    [anon_sym___try] = ACTIONS(1382),
    [anon_sym___leave] = ACTIONS(1382),
    [anon_sym_DASH_DASH] = ACTIONS(1384),
    [anon_sym_PLUS_PLUS] = ACTIONS(1384),
    [anon_sym_sizeof] = ACTIONS(1382),
    [anon_sym___alignof__] = ACTIONS(1382),
    [anon_sym___alignof] = ACTIONS(1382),
    [anon_sym__alignof] = ACTIONS(1382),
    [anon_sym_alignof] = ACTIONS(1382),
    [anon_sym__Alignof] = ACTIONS(1382),
    [anon_sym_offsetof] = ACTIONS(1382),
    [anon_sym__Generic] = ACTIONS(1382),
    [anon_sym_asm] = ACTIONS(1382),
    [anon_sym___asm__] = ACTIONS(1382),
    [sym_number_literal] = ACTIONS(1384),
    [anon_sym_L_SQUOTE] = ACTIONS(1384),
    [anon_sym_u_SQUOTE] = ACTIONS(1384),
    [anon_sym_U_SQUOTE] = ACTIONS(1384),
    [anon_sym_u8_SQUOTE] = ACTIONS(1384),
    [anon_sym_SQUOTE] = ACTIONS(1384),
    [anon_sym_L_DQUOTE] = ACTIONS(1384),
    [anon_sym_u_DQUOTE] = ACTIONS(1384),
    [anon_sym_U_DQUOTE] = ACTIONS(1384),
    [anon_sym_u8_DQUOTE] = ACTIONS(1384),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [sym_true] = ACTIONS(1382),
    [sym_false] = ACTIONS(1382),
    [anon_sym_NULL] = ACTIONS(1382),
    [anon_sym_nullptr] = ACTIONS(1382),
    [sym_comment] = ACTIONS(3),
  },
  [285] = {
    [ts_builtin_sym_end] = ACTIONS(1364),
    [sym_identifier] = ACTIONS(1362),
    [aux_sym_preproc_include_token1] = ACTIONS(1362),
    [aux_sym_preproc_def_token1] = ACTIONS(1362),
    [aux_sym_preproc_if_token1] = ACTIONS(1362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1362),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1362),
    [sym_preproc_directive] = ACTIONS(1362),
    [anon_sym_LPAREN2] = ACTIONS(1364),
    [anon_sym_BANG] = ACTIONS(1364),
    [anon_sym_TILDE] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_STAR] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_SEMI] = ACTIONS(1364),
    [anon_sym___extension__] = ACTIONS(1362),
    [anon_sym_typedef] = ACTIONS(1362),
    [anon_sym_extern] = ACTIONS(1362),
    [anon_sym___attribute__] = ACTIONS(1362),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1364),
    [anon_sym___declspec] = ACTIONS(1362),
    [anon_sym___cdecl] = ACTIONS(1362),
    [anon_sym___clrcall] = ACTIONS(1362),
    [anon_sym___stdcall] = ACTIONS(1362),
    [anon_sym___fastcall] = ACTIONS(1362),
    [anon_sym___thiscall] = ACTIONS(1362),
    [anon_sym___vectorcall] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(1364),
    [anon_sym_signed] = ACTIONS(1362),
    [anon_sym_unsigned] = ACTIONS(1362),
    [anon_sym_long] = ACTIONS(1362),
    [anon_sym_short] = ACTIONS(1362),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_auto] = ACTIONS(1362),
    [anon_sym_register] = ACTIONS(1362),
    [anon_sym_inline] = ACTIONS(1362),
    [anon_sym___inline] = ACTIONS(1362),
    [anon_sym___inline__] = ACTIONS(1362),
    [anon_sym___forceinline] = ACTIONS(1362),
    [anon_sym_thread_local] = ACTIONS(1362),
    [anon_sym___thread] = ACTIONS(1362),
    [anon_sym_const] = ACTIONS(1362),
    [anon_sym_constexpr] = ACTIONS(1362),
    [anon_sym_volatile] = ACTIONS(1362),
    [anon_sym_restrict] = ACTIONS(1362),
    [anon_sym___restrict__] = ACTIONS(1362),
    [anon_sym__Atomic] = ACTIONS(1362),
    [anon_sym__Noreturn] = ACTIONS(1362),
    [anon_sym_noreturn] = ACTIONS(1362),
    [sym_primitive_type] = ACTIONS(1362),
    [anon_sym_enum] = ACTIONS(1362),
    [anon_sym_struct] = ACTIONS(1362),
    [anon_sym_union] = ACTIONS(1362),
    [anon_sym_if] = ACTIONS(1362),
    [anon_sym_else] = ACTIONS(1362),
    [anon_sym_switch] = ACTIONS(1362),
    [anon_sym_case] = ACTIONS(1362),
    [anon_sym_default] = ACTIONS(1362),
    [anon_sym_while] = ACTIONS(1362),
    [anon_sym_do] = ACTIONS(1362),
    [anon_sym_for] = ACTIONS(1362),
    [anon_sym_return] = ACTIONS(1362),
    [anon_sym_break] = ACTIONS(1362),
    [anon_sym_continue] = ACTIONS(1362),
    [anon_sym_goto] = ACTIONS(1362),
    [anon_sym___try] = ACTIONS(1362),
    [anon_sym___leave] = ACTIONS(1362),
    [anon_sym_DASH_DASH] = ACTIONS(1364),
    [anon_sym_PLUS_PLUS] = ACTIONS(1364),
    [anon_sym_sizeof] = ACTIONS(1362),
    [anon_sym___alignof__] = ACTIONS(1362),
    [anon_sym___alignof] = ACTIONS(1362),
    [anon_sym__alignof] = ACTIONS(1362),
    [anon_sym_alignof] = ACTIONS(1362),
    [anon_sym__Alignof] = ACTIONS(1362),
    [anon_sym_offsetof] = ACTIONS(1362),
    [anon_sym__Generic] = ACTIONS(1362),
    [anon_sym_asm] = ACTIONS(1362),
    [anon_sym___asm__] = ACTIONS(1362),
    [sym_number_literal] = ACTIONS(1364),
    [anon_sym_L_SQUOTE] = ACTIONS(1364),
    [anon_sym_u_SQUOTE] = ACTIONS(1364),
    [anon_sym_U_SQUOTE] = ACTIONS(1364),
    [anon_sym_u8_SQUOTE] = ACTIONS(1364),
    [anon_sym_SQUOTE] = ACTIONS(1364),
    [anon_sym_L_DQUOTE] = ACTIONS(1364),
    [anon_sym_u_DQUOTE] = ACTIONS(1364),
    [anon_sym_U_DQUOTE] = ACTIONS(1364),
    [anon_sym_u8_DQUOTE] = ACTIONS(1364),
    [anon_sym_DQUOTE] = ACTIONS(1364),
    [sym_true] = ACTIONS(1362),
    [sym_false] = ACTIONS(1362),
    [anon_sym_NULL] = ACTIONS(1362),
    [anon_sym_nullptr] = ACTIONS(1362),
    [sym_comment] = ACTIONS(3),
  },
  [286] = {
    [sym_identifier] = ACTIONS(1302),
    [aux_sym_preproc_include_token1] = ACTIONS(1302),
    [aux_sym_preproc_def_token1] = ACTIONS(1302),
    [aux_sym_preproc_if_token1] = ACTIONS(1302),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1302),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1302),
    [sym_preproc_directive] = ACTIONS(1302),
    [anon_sym_LPAREN2] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_TILDE] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1302),
    [anon_sym_PLUS] = ACTIONS(1302),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym___extension__] = ACTIONS(1302),
    [anon_sym_typedef] = ACTIONS(1302),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym___attribute__] = ACTIONS(1302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1304),
    [anon_sym___declspec] = ACTIONS(1302),
    [anon_sym___cdecl] = ACTIONS(1302),
    [anon_sym___clrcall] = ACTIONS(1302),
    [anon_sym___stdcall] = ACTIONS(1302),
    [anon_sym___fastcall] = ACTIONS(1302),
    [anon_sym___thiscall] = ACTIONS(1302),
    [anon_sym___vectorcall] = ACTIONS(1302),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_RBRACE] = ACTIONS(1304),
    [anon_sym_signed] = ACTIONS(1302),
    [anon_sym_unsigned] = ACTIONS(1302),
    [anon_sym_long] = ACTIONS(1302),
    [anon_sym_short] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(1302),
    [anon_sym_auto] = ACTIONS(1302),
    [anon_sym_register] = ACTIONS(1302),
    [anon_sym_inline] = ACTIONS(1302),
    [anon_sym___inline] = ACTIONS(1302),
    [anon_sym___inline__] = ACTIONS(1302),
    [anon_sym___forceinline] = ACTIONS(1302),
    [anon_sym_thread_local] = ACTIONS(1302),
    [anon_sym___thread] = ACTIONS(1302),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_constexpr] = ACTIONS(1302),
    [anon_sym_volatile] = ACTIONS(1302),
    [anon_sym_restrict] = ACTIONS(1302),
    [anon_sym___restrict__] = ACTIONS(1302),
    [anon_sym__Atomic] = ACTIONS(1302),
    [anon_sym__Noreturn] = ACTIONS(1302),
    [anon_sym_noreturn] = ACTIONS(1302),
    [sym_primitive_type] = ACTIONS(1302),
    [anon_sym_enum] = ACTIONS(1302),
    [anon_sym_struct] = ACTIONS(1302),
    [anon_sym_union] = ACTIONS(1302),
    [anon_sym_if] = ACTIONS(1302),
    [anon_sym_else] = ACTIONS(1302),
    [anon_sym_switch] = ACTIONS(1302),
    [anon_sym_case] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1302),
    [anon_sym_while] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1302),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_break] = ACTIONS(1302),
    [anon_sym_continue] = ACTIONS(1302),
    [anon_sym_goto] = ACTIONS(1302),
    [anon_sym___try] = ACTIONS(1302),
    [anon_sym___leave] = ACTIONS(1302),
    [anon_sym_DASH_DASH] = ACTIONS(1304),
    [anon_sym_PLUS_PLUS] = ACTIONS(1304),
    [anon_sym_sizeof] = ACTIONS(1302),
    [anon_sym___alignof__] = ACTIONS(1302),
    [anon_sym___alignof] = ACTIONS(1302),
    [anon_sym__alignof] = ACTIONS(1302),
    [anon_sym_alignof] = ACTIONS(1302),
    [anon_sym__Alignof] = ACTIONS(1302),
    [anon_sym_offsetof] = ACTIONS(1302),
    [anon_sym__Generic] = ACTIONS(1302),
    [anon_sym_asm] = ACTIONS(1302),
    [anon_sym___asm__] = ACTIONS(1302),
    [sym_number_literal] = ACTIONS(1304),
    [anon_sym_L_SQUOTE] = ACTIONS(1304),
    [anon_sym_u_SQUOTE] = ACTIONS(1304),
    [anon_sym_U_SQUOTE] = ACTIONS(1304),
    [anon_sym_u8_SQUOTE] = ACTIONS(1304),
    [anon_sym_SQUOTE] = ACTIONS(1304),
    [anon_sym_L_DQUOTE] = ACTIONS(1304),
    [anon_sym_u_DQUOTE] = ACTIONS(1304),
    [anon_sym_U_DQUOTE] = ACTIONS(1304),
    [anon_sym_u8_DQUOTE] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_true] = ACTIONS(1302),
    [sym_false] = ACTIONS(1302),
    [anon_sym_NULL] = ACTIONS(1302),
    [anon_sym_nullptr] = ACTIONS(1302),
    [sym_comment] = ACTIONS(3),
  },
  [287] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [288] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [289] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [290] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [291] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [292] = {
    [ts_builtin_sym_end] = ACTIONS(1368),
    [sym_identifier] = ACTIONS(1366),
    [aux_sym_preproc_include_token1] = ACTIONS(1366),
    [aux_sym_preproc_def_token1] = ACTIONS(1366),
    [aux_sym_preproc_if_token1] = ACTIONS(1366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1366),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1366),
    [sym_preproc_directive] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_BANG] = ACTIONS(1368),
    [anon_sym_TILDE] = ACTIONS(1368),
    [anon_sym_DASH] = ACTIONS(1366),
    [anon_sym_PLUS] = ACTIONS(1366),
    [anon_sym_STAR] = ACTIONS(1368),
    [anon_sym_AMP] = ACTIONS(1368),
    [anon_sym_SEMI] = ACTIONS(1368),
    [anon_sym___extension__] = ACTIONS(1366),
    [anon_sym_typedef] = ACTIONS(1366),
    [anon_sym_extern] = ACTIONS(1366),
    [anon_sym___attribute__] = ACTIONS(1366),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1368),
    [anon_sym___declspec] = ACTIONS(1366),
    [anon_sym___cdecl] = ACTIONS(1366),
    [anon_sym___clrcall] = ACTIONS(1366),
    [anon_sym___stdcall] = ACTIONS(1366),
    [anon_sym___fastcall] = ACTIONS(1366),
    [anon_sym___thiscall] = ACTIONS(1366),
    [anon_sym___vectorcall] = ACTIONS(1366),
    [anon_sym_LBRACE] = ACTIONS(1368),
    [anon_sym_signed] = ACTIONS(1366),
    [anon_sym_unsigned] = ACTIONS(1366),
    [anon_sym_long] = ACTIONS(1366),
    [anon_sym_short] = ACTIONS(1366),
    [anon_sym_static] = ACTIONS(1366),
    [anon_sym_auto] = ACTIONS(1366),
    [anon_sym_register] = ACTIONS(1366),
    [anon_sym_inline] = ACTIONS(1366),
    [anon_sym___inline] = ACTIONS(1366),
    [anon_sym___inline__] = ACTIONS(1366),
    [anon_sym___forceinline] = ACTIONS(1366),
    [anon_sym_thread_local] = ACTIONS(1366),
    [anon_sym___thread] = ACTIONS(1366),
    [anon_sym_const] = ACTIONS(1366),
    [anon_sym_constexpr] = ACTIONS(1366),
    [anon_sym_volatile] = ACTIONS(1366),
    [anon_sym_restrict] = ACTIONS(1366),
    [anon_sym___restrict__] = ACTIONS(1366),
    [anon_sym__Atomic] = ACTIONS(1366),
    [anon_sym__Noreturn] = ACTIONS(1366),
    [anon_sym_noreturn] = ACTIONS(1366),
    [sym_primitive_type] = ACTIONS(1366),
    [anon_sym_enum] = ACTIONS(1366),
    [anon_sym_struct] = ACTIONS(1366),
    [anon_sym_union] = ACTIONS(1366),
    [anon_sym_if] = ACTIONS(1366),
    [anon_sym_else] = ACTIONS(1366),
    [anon_sym_switch] = ACTIONS(1366),
    [anon_sym_case] = ACTIONS(1366),
    [anon_sym_default] = ACTIONS(1366),
    [anon_sym_while] = ACTIONS(1366),
    [anon_sym_do] = ACTIONS(1366),
    [anon_sym_for] = ACTIONS(1366),
    [anon_sym_return] = ACTIONS(1366),
    [anon_sym_break] = ACTIONS(1366),
    [anon_sym_continue] = ACTIONS(1366),
    [anon_sym_goto] = ACTIONS(1366),
    [anon_sym___try] = ACTIONS(1366),
    [anon_sym___leave] = ACTIONS(1366),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_sizeof] = ACTIONS(1366),
    [anon_sym___alignof__] = ACTIONS(1366),
    [anon_sym___alignof] = ACTIONS(1366),
    [anon_sym__alignof] = ACTIONS(1366),
    [anon_sym_alignof] = ACTIONS(1366),
    [anon_sym__Alignof] = ACTIONS(1366),
    [anon_sym_offsetof] = ACTIONS(1366),
    [anon_sym__Generic] = ACTIONS(1366),
    [anon_sym_asm] = ACTIONS(1366),
    [anon_sym___asm__] = ACTIONS(1366),
    [sym_number_literal] = ACTIONS(1368),
    [anon_sym_L_SQUOTE] = ACTIONS(1368),
    [anon_sym_u_SQUOTE] = ACTIONS(1368),
    [anon_sym_U_SQUOTE] = ACTIONS(1368),
    [anon_sym_u8_SQUOTE] = ACTIONS(1368),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_L_DQUOTE] = ACTIONS(1368),
    [anon_sym_u_DQUOTE] = ACTIONS(1368),
    [anon_sym_U_DQUOTE] = ACTIONS(1368),
    [anon_sym_u8_DQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [sym_true] = ACTIONS(1366),
    [sym_false] = ACTIONS(1366),
    [anon_sym_NULL] = ACTIONS(1366),
    [anon_sym_nullptr] = ACTIONS(1366),
    [sym_comment] = ACTIONS(3),
  },
  [293] = {
    [ts_builtin_sym_end] = ACTIONS(1372),
    [sym_identifier] = ACTIONS(1370),
    [aux_sym_preproc_include_token1] = ACTIONS(1370),
    [aux_sym_preproc_def_token1] = ACTIONS(1370),
    [aux_sym_preproc_if_token1] = ACTIONS(1370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1370),
    [sym_preproc_directive] = ACTIONS(1370),
    [anon_sym_LPAREN2] = ACTIONS(1372),
    [anon_sym_BANG] = ACTIONS(1372),
    [anon_sym_TILDE] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_STAR] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1372),
    [anon_sym___extension__] = ACTIONS(1370),
    [anon_sym_typedef] = ACTIONS(1370),
    [anon_sym_extern] = ACTIONS(1370),
    [anon_sym___attribute__] = ACTIONS(1370),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1372),
    [anon_sym___declspec] = ACTIONS(1370),
    [anon_sym___cdecl] = ACTIONS(1370),
    [anon_sym___clrcall] = ACTIONS(1370),
    [anon_sym___stdcall] = ACTIONS(1370),
    [anon_sym___fastcall] = ACTIONS(1370),
    [anon_sym___thiscall] = ACTIONS(1370),
    [anon_sym___vectorcall] = ACTIONS(1370),
    [anon_sym_LBRACE] = ACTIONS(1372),
    [anon_sym_signed] = ACTIONS(1370),
    [anon_sym_unsigned] = ACTIONS(1370),
    [anon_sym_long] = ACTIONS(1370),
    [anon_sym_short] = ACTIONS(1370),
    [anon_sym_static] = ACTIONS(1370),
    [anon_sym_auto] = ACTIONS(1370),
    [anon_sym_register] = ACTIONS(1370),
    [anon_sym_inline] = ACTIONS(1370),
    [anon_sym___inline] = ACTIONS(1370),
    [anon_sym___inline__] = ACTIONS(1370),
    [anon_sym___forceinline] = ACTIONS(1370),
    [anon_sym_thread_local] = ACTIONS(1370),
    [anon_sym___thread] = ACTIONS(1370),
    [anon_sym_const] = ACTIONS(1370),
    [anon_sym_constexpr] = ACTIONS(1370),
    [anon_sym_volatile] = ACTIONS(1370),
    [anon_sym_restrict] = ACTIONS(1370),
    [anon_sym___restrict__] = ACTIONS(1370),
    [anon_sym__Atomic] = ACTIONS(1370),
    [anon_sym__Noreturn] = ACTIONS(1370),
    [anon_sym_noreturn] = ACTIONS(1370),
    [sym_primitive_type] = ACTIONS(1370),
    [anon_sym_enum] = ACTIONS(1370),
    [anon_sym_struct] = ACTIONS(1370),
    [anon_sym_union] = ACTIONS(1370),
    [anon_sym_if] = ACTIONS(1370),
    [anon_sym_else] = ACTIONS(1370),
    [anon_sym_switch] = ACTIONS(1370),
    [anon_sym_case] = ACTIONS(1370),
    [anon_sym_default] = ACTIONS(1370),
    [anon_sym_while] = ACTIONS(1370),
    [anon_sym_do] = ACTIONS(1370),
    [anon_sym_for] = ACTIONS(1370),
    [anon_sym_return] = ACTIONS(1370),
    [anon_sym_break] = ACTIONS(1370),
    [anon_sym_continue] = ACTIONS(1370),
    [anon_sym_goto] = ACTIONS(1370),
    [anon_sym___try] = ACTIONS(1370),
    [anon_sym___leave] = ACTIONS(1370),
    [anon_sym_DASH_DASH] = ACTIONS(1372),
    [anon_sym_PLUS_PLUS] = ACTIONS(1372),
    [anon_sym_sizeof] = ACTIONS(1370),
    [anon_sym___alignof__] = ACTIONS(1370),
    [anon_sym___alignof] = ACTIONS(1370),
    [anon_sym__alignof] = ACTIONS(1370),
    [anon_sym_alignof] = ACTIONS(1370),
    [anon_sym__Alignof] = ACTIONS(1370),
    [anon_sym_offsetof] = ACTIONS(1370),
    [anon_sym__Generic] = ACTIONS(1370),
    [anon_sym_asm] = ACTIONS(1370),
    [anon_sym___asm__] = ACTIONS(1370),
    [sym_number_literal] = ACTIONS(1372),
    [anon_sym_L_SQUOTE] = ACTIONS(1372),
    [anon_sym_u_SQUOTE] = ACTIONS(1372),
    [anon_sym_U_SQUOTE] = ACTIONS(1372),
    [anon_sym_u8_SQUOTE] = ACTIONS(1372),
    [anon_sym_SQUOTE] = ACTIONS(1372),
    [anon_sym_L_DQUOTE] = ACTIONS(1372),
    [anon_sym_u_DQUOTE] = ACTIONS(1372),
    [anon_sym_U_DQUOTE] = ACTIONS(1372),
    [anon_sym_u8_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1372),
    [sym_true] = ACTIONS(1370),
    [sym_false] = ACTIONS(1370),
    [anon_sym_NULL] = ACTIONS(1370),
    [anon_sym_nullptr] = ACTIONS(1370),
    [sym_comment] = ACTIONS(3),
  },
  [294] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [295] = {
    [sym_identifier] = ACTIONS(1378),
    [aux_sym_preproc_include_token1] = ACTIONS(1378),
    [aux_sym_preproc_def_token1] = ACTIONS(1378),
    [aux_sym_preproc_if_token1] = ACTIONS(1378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1378),
    [sym_preproc_directive] = ACTIONS(1378),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_BANG] = ACTIONS(1380),
    [anon_sym_TILDE] = ACTIONS(1380),
    [anon_sym_DASH] = ACTIONS(1378),
    [anon_sym_PLUS] = ACTIONS(1378),
    [anon_sym_STAR] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym___extension__] = ACTIONS(1378),
    [anon_sym_typedef] = ACTIONS(1378),
    [anon_sym_extern] = ACTIONS(1378),
    [anon_sym___attribute__] = ACTIONS(1378),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1380),
    [anon_sym___declspec] = ACTIONS(1378),
    [anon_sym___cdecl] = ACTIONS(1378),
    [anon_sym___clrcall] = ACTIONS(1378),
    [anon_sym___stdcall] = ACTIONS(1378),
    [anon_sym___fastcall] = ACTIONS(1378),
    [anon_sym___thiscall] = ACTIONS(1378),
    [anon_sym___vectorcall] = ACTIONS(1378),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_RBRACE] = ACTIONS(1380),
    [anon_sym_signed] = ACTIONS(1378),
    [anon_sym_unsigned] = ACTIONS(1378),
    [anon_sym_long] = ACTIONS(1378),
    [anon_sym_short] = ACTIONS(1378),
    [anon_sym_static] = ACTIONS(1378),
    [anon_sym_auto] = ACTIONS(1378),
    [anon_sym_register] = ACTIONS(1378),
    [anon_sym_inline] = ACTIONS(1378),
    [anon_sym___inline] = ACTIONS(1378),
    [anon_sym___inline__] = ACTIONS(1378),
    [anon_sym___forceinline] = ACTIONS(1378),
    [anon_sym_thread_local] = ACTIONS(1378),
    [anon_sym___thread] = ACTIONS(1378),
    [anon_sym_const] = ACTIONS(1378),
    [anon_sym_constexpr] = ACTIONS(1378),
    [anon_sym_volatile] = ACTIONS(1378),
    [anon_sym_restrict] = ACTIONS(1378),
    [anon_sym___restrict__] = ACTIONS(1378),
    [anon_sym__Atomic] = ACTIONS(1378),
    [anon_sym__Noreturn] = ACTIONS(1378),
    [anon_sym_noreturn] = ACTIONS(1378),
    [sym_primitive_type] = ACTIONS(1378),
    [anon_sym_enum] = ACTIONS(1378),
    [anon_sym_struct] = ACTIONS(1378),
    [anon_sym_union] = ACTIONS(1378),
    [anon_sym_if] = ACTIONS(1378),
    [anon_sym_else] = ACTIONS(1378),
    [anon_sym_switch] = ACTIONS(1378),
    [anon_sym_case] = ACTIONS(1378),
    [anon_sym_default] = ACTIONS(1378),
    [anon_sym_while] = ACTIONS(1378),
    [anon_sym_do] = ACTIONS(1378),
    [anon_sym_for] = ACTIONS(1378),
    [anon_sym_return] = ACTIONS(1378),
    [anon_sym_break] = ACTIONS(1378),
    [anon_sym_continue] = ACTIONS(1378),
    [anon_sym_goto] = ACTIONS(1378),
    [anon_sym___try] = ACTIONS(1378),
    [anon_sym___leave] = ACTIONS(1378),
    [anon_sym_DASH_DASH] = ACTIONS(1380),
    [anon_sym_PLUS_PLUS] = ACTIONS(1380),
    [anon_sym_sizeof] = ACTIONS(1378),
    [anon_sym___alignof__] = ACTIONS(1378),
    [anon_sym___alignof] = ACTIONS(1378),
    [anon_sym__alignof] = ACTIONS(1378),
    [anon_sym_alignof] = ACTIONS(1378),
    [anon_sym__Alignof] = ACTIONS(1378),
    [anon_sym_offsetof] = ACTIONS(1378),
    [anon_sym__Generic] = ACTIONS(1378),
    [anon_sym_asm] = ACTIONS(1378),
    [anon_sym___asm__] = ACTIONS(1378),
    [sym_number_literal] = ACTIONS(1380),
    [anon_sym_L_SQUOTE] = ACTIONS(1380),
    [anon_sym_u_SQUOTE] = ACTIONS(1380),
    [anon_sym_U_SQUOTE] = ACTIONS(1380),
    [anon_sym_u8_SQUOTE] = ACTIONS(1380),
    [anon_sym_SQUOTE] = ACTIONS(1380),
    [anon_sym_L_DQUOTE] = ACTIONS(1380),
    [anon_sym_u_DQUOTE] = ACTIONS(1380),
    [anon_sym_U_DQUOTE] = ACTIONS(1380),
    [anon_sym_u8_DQUOTE] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [anon_sym_NULL] = ACTIONS(1378),
    [anon_sym_nullptr] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
  },
  [296] = {
    [sym_identifier] = ACTIONS(1338),
    [aux_sym_preproc_include_token1] = ACTIONS(1338),
    [aux_sym_preproc_def_token1] = ACTIONS(1338),
    [aux_sym_preproc_if_token1] = ACTIONS(1338),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1338),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1338),
    [sym_preproc_directive] = ACTIONS(1338),
    [anon_sym_LPAREN2] = ACTIONS(1340),
    [anon_sym_BANG] = ACTIONS(1340),
    [anon_sym_TILDE] = ACTIONS(1340),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_PLUS] = ACTIONS(1338),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_SEMI] = ACTIONS(1340),
    [anon_sym___extension__] = ACTIONS(1338),
    [anon_sym_typedef] = ACTIONS(1338),
    [anon_sym_extern] = ACTIONS(1338),
    [anon_sym___attribute__] = ACTIONS(1338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1340),
    [anon_sym___declspec] = ACTIONS(1338),
    [anon_sym___cdecl] = ACTIONS(1338),
    [anon_sym___clrcall] = ACTIONS(1338),
    [anon_sym___stdcall] = ACTIONS(1338),
    [anon_sym___fastcall] = ACTIONS(1338),
    [anon_sym___thiscall] = ACTIONS(1338),
    [anon_sym___vectorcall] = ACTIONS(1338),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(1340),
    [anon_sym_signed] = ACTIONS(1338),
    [anon_sym_unsigned] = ACTIONS(1338),
    [anon_sym_long] = ACTIONS(1338),
    [anon_sym_short] = ACTIONS(1338),
    [anon_sym_static] = ACTIONS(1338),
    [anon_sym_auto] = ACTIONS(1338),
    [anon_sym_register] = ACTIONS(1338),
    [anon_sym_inline] = ACTIONS(1338),
    [anon_sym___inline] = ACTIONS(1338),
    [anon_sym___inline__] = ACTIONS(1338),
    [anon_sym___forceinline] = ACTIONS(1338),
    [anon_sym_thread_local] = ACTIONS(1338),
    [anon_sym___thread] = ACTIONS(1338),
    [anon_sym_const] = ACTIONS(1338),
    [anon_sym_constexpr] = ACTIONS(1338),
    [anon_sym_volatile] = ACTIONS(1338),
    [anon_sym_restrict] = ACTIONS(1338),
    [anon_sym___restrict__] = ACTIONS(1338),
    [anon_sym__Atomic] = ACTIONS(1338),
    [anon_sym__Noreturn] = ACTIONS(1338),
    [anon_sym_noreturn] = ACTIONS(1338),
    [sym_primitive_type] = ACTIONS(1338),
    [anon_sym_enum] = ACTIONS(1338),
    [anon_sym_struct] = ACTIONS(1338),
    [anon_sym_union] = ACTIONS(1338),
    [anon_sym_if] = ACTIONS(1338),
    [anon_sym_else] = ACTIONS(1338),
    [anon_sym_switch] = ACTIONS(1338),
    [anon_sym_case] = ACTIONS(1338),
    [anon_sym_default] = ACTIONS(1338),
    [anon_sym_while] = ACTIONS(1338),
    [anon_sym_do] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1338),
    [anon_sym_return] = ACTIONS(1338),
    [anon_sym_break] = ACTIONS(1338),
    [anon_sym_continue] = ACTIONS(1338),
    [anon_sym_goto] = ACTIONS(1338),
    [anon_sym___try] = ACTIONS(1338),
    [anon_sym___leave] = ACTIONS(1338),
    [anon_sym_DASH_DASH] = ACTIONS(1340),
    [anon_sym_PLUS_PLUS] = ACTIONS(1340),
    [anon_sym_sizeof] = ACTIONS(1338),
    [anon_sym___alignof__] = ACTIONS(1338),
    [anon_sym___alignof] = ACTIONS(1338),
    [anon_sym__alignof] = ACTIONS(1338),
    [anon_sym_alignof] = ACTIONS(1338),
    [anon_sym__Alignof] = ACTIONS(1338),
    [anon_sym_offsetof] = ACTIONS(1338),
    [anon_sym__Generic] = ACTIONS(1338),
    [anon_sym_asm] = ACTIONS(1338),
    [anon_sym___asm__] = ACTIONS(1338),
    [sym_number_literal] = ACTIONS(1340),
    [anon_sym_L_SQUOTE] = ACTIONS(1340),
    [anon_sym_u_SQUOTE] = ACTIONS(1340),
    [anon_sym_U_SQUOTE] = ACTIONS(1340),
    [anon_sym_u8_SQUOTE] = ACTIONS(1340),
    [anon_sym_SQUOTE] = ACTIONS(1340),
    [anon_sym_L_DQUOTE] = ACTIONS(1340),
    [anon_sym_u_DQUOTE] = ACTIONS(1340),
    [anon_sym_U_DQUOTE] = ACTIONS(1340),
    [anon_sym_u8_DQUOTE] = ACTIONS(1340),
    [anon_sym_DQUOTE] = ACTIONS(1340),
    [sym_true] = ACTIONS(1338),
    [sym_false] = ACTIONS(1338),
    [anon_sym_NULL] = ACTIONS(1338),
    [anon_sym_nullptr] = ACTIONS(1338),
    [sym_comment] = ACTIONS(3),
  },
  [297] = {
    [sym_identifier] = ACTIONS(1378),
    [aux_sym_preproc_include_token1] = ACTIONS(1378),
    [aux_sym_preproc_def_token1] = ACTIONS(1378),
    [aux_sym_preproc_if_token1] = ACTIONS(1378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1378),
    [sym_preproc_directive] = ACTIONS(1378),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_BANG] = ACTIONS(1380),
    [anon_sym_TILDE] = ACTIONS(1380),
    [anon_sym_DASH] = ACTIONS(1378),
    [anon_sym_PLUS] = ACTIONS(1378),
    [anon_sym_STAR] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym___extension__] = ACTIONS(1378),
    [anon_sym_typedef] = ACTIONS(1378),
    [anon_sym_extern] = ACTIONS(1378),
    [anon_sym___attribute__] = ACTIONS(1378),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1380),
    [anon_sym___declspec] = ACTIONS(1378),
    [anon_sym___cdecl] = ACTIONS(1378),
    [anon_sym___clrcall] = ACTIONS(1378),
    [anon_sym___stdcall] = ACTIONS(1378),
    [anon_sym___fastcall] = ACTIONS(1378),
    [anon_sym___thiscall] = ACTIONS(1378),
    [anon_sym___vectorcall] = ACTIONS(1378),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_RBRACE] = ACTIONS(1380),
    [anon_sym_signed] = ACTIONS(1378),
    [anon_sym_unsigned] = ACTIONS(1378),
    [anon_sym_long] = ACTIONS(1378),
    [anon_sym_short] = ACTIONS(1378),
    [anon_sym_static] = ACTIONS(1378),
    [anon_sym_auto] = ACTIONS(1378),
    [anon_sym_register] = ACTIONS(1378),
    [anon_sym_inline] = ACTIONS(1378),
    [anon_sym___inline] = ACTIONS(1378),
    [anon_sym___inline__] = ACTIONS(1378),
    [anon_sym___forceinline] = ACTIONS(1378),
    [anon_sym_thread_local] = ACTIONS(1378),
    [anon_sym___thread] = ACTIONS(1378),
    [anon_sym_const] = ACTIONS(1378),
    [anon_sym_constexpr] = ACTIONS(1378),
    [anon_sym_volatile] = ACTIONS(1378),
    [anon_sym_restrict] = ACTIONS(1378),
    [anon_sym___restrict__] = ACTIONS(1378),
    [anon_sym__Atomic] = ACTIONS(1378),
    [anon_sym__Noreturn] = ACTIONS(1378),
    [anon_sym_noreturn] = ACTIONS(1378),
    [sym_primitive_type] = ACTIONS(1378),
    [anon_sym_enum] = ACTIONS(1378),
    [anon_sym_struct] = ACTIONS(1378),
    [anon_sym_union] = ACTIONS(1378),
    [anon_sym_if] = ACTIONS(1378),
    [anon_sym_else] = ACTIONS(1378),
    [anon_sym_switch] = ACTIONS(1378),
    [anon_sym_case] = ACTIONS(1378),
    [anon_sym_default] = ACTIONS(1378),
    [anon_sym_while] = ACTIONS(1378),
    [anon_sym_do] = ACTIONS(1378),
    [anon_sym_for] = ACTIONS(1378),
    [anon_sym_return] = ACTIONS(1378),
    [anon_sym_break] = ACTIONS(1378),
    [anon_sym_continue] = ACTIONS(1378),
    [anon_sym_goto] = ACTIONS(1378),
    [anon_sym___try] = ACTIONS(1378),
    [anon_sym___leave] = ACTIONS(1378),
    [anon_sym_DASH_DASH] = ACTIONS(1380),
    [anon_sym_PLUS_PLUS] = ACTIONS(1380),
    [anon_sym_sizeof] = ACTIONS(1378),
    [anon_sym___alignof__] = ACTIONS(1378),
    [anon_sym___alignof] = ACTIONS(1378),
    [anon_sym__alignof] = ACTIONS(1378),
    [anon_sym_alignof] = ACTIONS(1378),
    [anon_sym__Alignof] = ACTIONS(1378),
    [anon_sym_offsetof] = ACTIONS(1378),
    [anon_sym__Generic] = ACTIONS(1378),
    [anon_sym_asm] = ACTIONS(1378),
    [anon_sym___asm__] = ACTIONS(1378),
    [sym_number_literal] = ACTIONS(1380),
    [anon_sym_L_SQUOTE] = ACTIONS(1380),
    [anon_sym_u_SQUOTE] = ACTIONS(1380),
    [anon_sym_U_SQUOTE] = ACTIONS(1380),
    [anon_sym_u8_SQUOTE] = ACTIONS(1380),
    [anon_sym_SQUOTE] = ACTIONS(1380),
    [anon_sym_L_DQUOTE] = ACTIONS(1380),
    [anon_sym_u_DQUOTE] = ACTIONS(1380),
    [anon_sym_U_DQUOTE] = ACTIONS(1380),
    [anon_sym_u8_DQUOTE] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [anon_sym_NULL] = ACTIONS(1378),
    [anon_sym_nullptr] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
  },
  [298] = {
    [ts_builtin_sym_end] = ACTIONS(1420),
    [sym_identifier] = ACTIONS(1418),
    [aux_sym_preproc_include_token1] = ACTIONS(1418),
    [aux_sym_preproc_def_token1] = ACTIONS(1418),
    [aux_sym_preproc_if_token1] = ACTIONS(1418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1418),
    [sym_preproc_directive] = ACTIONS(1418),
    [anon_sym_LPAREN2] = ACTIONS(1420),
    [anon_sym_BANG] = ACTIONS(1420),
    [anon_sym_TILDE] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_AMP] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(1420),
    [anon_sym___extension__] = ACTIONS(1418),
    [anon_sym_typedef] = ACTIONS(1418),
    [anon_sym_extern] = ACTIONS(1418),
    [anon_sym___attribute__] = ACTIONS(1418),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1420),
    [anon_sym___declspec] = ACTIONS(1418),
    [anon_sym___cdecl] = ACTIONS(1418),
    [anon_sym___clrcall] = ACTIONS(1418),
    [anon_sym___stdcall] = ACTIONS(1418),
    [anon_sym___fastcall] = ACTIONS(1418),
    [anon_sym___thiscall] = ACTIONS(1418),
    [anon_sym___vectorcall] = ACTIONS(1418),
    [anon_sym_LBRACE] = ACTIONS(1420),
    [anon_sym_signed] = ACTIONS(1418),
    [anon_sym_unsigned] = ACTIONS(1418),
    [anon_sym_long] = ACTIONS(1418),
    [anon_sym_short] = ACTIONS(1418),
    [anon_sym_static] = ACTIONS(1418),
    [anon_sym_auto] = ACTIONS(1418),
    [anon_sym_register] = ACTIONS(1418),
    [anon_sym_inline] = ACTIONS(1418),
    [anon_sym___inline] = ACTIONS(1418),
    [anon_sym___inline__] = ACTIONS(1418),
    [anon_sym___forceinline] = ACTIONS(1418),
    [anon_sym_thread_local] = ACTIONS(1418),
    [anon_sym___thread] = ACTIONS(1418),
    [anon_sym_const] = ACTIONS(1418),
    [anon_sym_constexpr] = ACTIONS(1418),
    [anon_sym_volatile] = ACTIONS(1418),
    [anon_sym_restrict] = ACTIONS(1418),
    [anon_sym___restrict__] = ACTIONS(1418),
    [anon_sym__Atomic] = ACTIONS(1418),
    [anon_sym__Noreturn] = ACTIONS(1418),
    [anon_sym_noreturn] = ACTIONS(1418),
    [sym_primitive_type] = ACTIONS(1418),
    [anon_sym_enum] = ACTIONS(1418),
    [anon_sym_struct] = ACTIONS(1418),
    [anon_sym_union] = ACTIONS(1418),
    [anon_sym_if] = ACTIONS(1418),
    [anon_sym_else] = ACTIONS(1418),
    [anon_sym_switch] = ACTIONS(1418),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_default] = ACTIONS(1418),
    [anon_sym_while] = ACTIONS(1418),
    [anon_sym_do] = ACTIONS(1418),
    [anon_sym_for] = ACTIONS(1418),
    [anon_sym_return] = ACTIONS(1418),
    [anon_sym_break] = ACTIONS(1418),
    [anon_sym_continue] = ACTIONS(1418),
    [anon_sym_goto] = ACTIONS(1418),
    [anon_sym___try] = ACTIONS(1418),
    [anon_sym___leave] = ACTIONS(1418),
    [anon_sym_DASH_DASH] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1420),
    [anon_sym_sizeof] = ACTIONS(1418),
    [anon_sym___alignof__] = ACTIONS(1418),
    [anon_sym___alignof] = ACTIONS(1418),
    [anon_sym__alignof] = ACTIONS(1418),
    [anon_sym_alignof] = ACTIONS(1418),
    [anon_sym__Alignof] = ACTIONS(1418),
    [anon_sym_offsetof] = ACTIONS(1418),
    [anon_sym__Generic] = ACTIONS(1418),
    [anon_sym_asm] = ACTIONS(1418),
    [anon_sym___asm__] = ACTIONS(1418),
    [sym_number_literal] = ACTIONS(1420),
    [anon_sym_L_SQUOTE] = ACTIONS(1420),
    [anon_sym_u_SQUOTE] = ACTIONS(1420),
    [anon_sym_U_SQUOTE] = ACTIONS(1420),
    [anon_sym_u8_SQUOTE] = ACTIONS(1420),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [anon_sym_L_DQUOTE] = ACTIONS(1420),
    [anon_sym_u_DQUOTE] = ACTIONS(1420),
    [anon_sym_U_DQUOTE] = ACTIONS(1420),
    [anon_sym_u8_DQUOTE] = ACTIONS(1420),
    [anon_sym_DQUOTE] = ACTIONS(1420),
    [sym_true] = ACTIONS(1418),
    [sym_false] = ACTIONS(1418),
    [anon_sym_NULL] = ACTIONS(1418),
    [anon_sym_nullptr] = ACTIONS(1418),
    [sym_comment] = ACTIONS(3),
  },
  [299] = {
    [sym_identifier] = ACTIONS(1298),
    [aux_sym_preproc_include_token1] = ACTIONS(1298),
    [aux_sym_preproc_def_token1] = ACTIONS(1298),
    [aux_sym_preproc_if_token1] = ACTIONS(1298),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1298),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1298),
    [sym_preproc_directive] = ACTIONS(1298),
    [anon_sym_LPAREN2] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1300),
    [anon_sym_TILDE] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1298),
    [anon_sym_PLUS] = ACTIONS(1298),
    [anon_sym_STAR] = ACTIONS(1300),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(1300),
    [anon_sym___extension__] = ACTIONS(1298),
    [anon_sym_typedef] = ACTIONS(1298),
    [anon_sym_extern] = ACTIONS(1298),
    [anon_sym___attribute__] = ACTIONS(1298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1300),
    [anon_sym___declspec] = ACTIONS(1298),
    [anon_sym___cdecl] = ACTIONS(1298),
    [anon_sym___clrcall] = ACTIONS(1298),
    [anon_sym___stdcall] = ACTIONS(1298),
    [anon_sym___fastcall] = ACTIONS(1298),
    [anon_sym___thiscall] = ACTIONS(1298),
    [anon_sym___vectorcall] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_RBRACE] = ACTIONS(1300),
    [anon_sym_signed] = ACTIONS(1298),
    [anon_sym_unsigned] = ACTIONS(1298),
    [anon_sym_long] = ACTIONS(1298),
    [anon_sym_short] = ACTIONS(1298),
    [anon_sym_static] = ACTIONS(1298),
    [anon_sym_auto] = ACTIONS(1298),
    [anon_sym_register] = ACTIONS(1298),
    [anon_sym_inline] = ACTIONS(1298),
    [anon_sym___inline] = ACTIONS(1298),
    [anon_sym___inline__] = ACTIONS(1298),
    [anon_sym___forceinline] = ACTIONS(1298),
    [anon_sym_thread_local] = ACTIONS(1298),
    [anon_sym___thread] = ACTIONS(1298),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_constexpr] = ACTIONS(1298),
    [anon_sym_volatile] = ACTIONS(1298),
    [anon_sym_restrict] = ACTIONS(1298),
    [anon_sym___restrict__] = ACTIONS(1298),
    [anon_sym__Atomic] = ACTIONS(1298),
    [anon_sym__Noreturn] = ACTIONS(1298),
    [anon_sym_noreturn] = ACTIONS(1298),
    [sym_primitive_type] = ACTIONS(1298),
    [anon_sym_enum] = ACTIONS(1298),
    [anon_sym_struct] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1298),
    [anon_sym_if] = ACTIONS(1298),
    [anon_sym_else] = ACTIONS(1298),
    [anon_sym_switch] = ACTIONS(1298),
    [anon_sym_case] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(1298),
    [anon_sym_do] = ACTIONS(1298),
    [anon_sym_for] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1298),
    [anon_sym_break] = ACTIONS(1298),
    [anon_sym_continue] = ACTIONS(1298),
    [anon_sym_goto] = ACTIONS(1298),
    [anon_sym___try] = ACTIONS(1298),
    [anon_sym___leave] = ACTIONS(1298),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_sizeof] = ACTIONS(1298),
    [anon_sym___alignof__] = ACTIONS(1298),
    [anon_sym___alignof] = ACTIONS(1298),
    [anon_sym__alignof] = ACTIONS(1298),
    [anon_sym_alignof] = ACTIONS(1298),
    [anon_sym__Alignof] = ACTIONS(1298),
    [anon_sym_offsetof] = ACTIONS(1298),
    [anon_sym__Generic] = ACTIONS(1298),
    [anon_sym_asm] = ACTIONS(1298),
    [anon_sym___asm__] = ACTIONS(1298),
    [sym_number_literal] = ACTIONS(1300),
    [anon_sym_L_SQUOTE] = ACTIONS(1300),
    [anon_sym_u_SQUOTE] = ACTIONS(1300),
    [anon_sym_U_SQUOTE] = ACTIONS(1300),
    [anon_sym_u8_SQUOTE] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(1300),
    [anon_sym_L_DQUOTE] = ACTIONS(1300),
    [anon_sym_u_DQUOTE] = ACTIONS(1300),
    [anon_sym_U_DQUOTE] = ACTIONS(1300),
    [anon_sym_u8_DQUOTE] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(1300),
    [sym_true] = ACTIONS(1298),
    [sym_false] = ACTIONS(1298),
    [anon_sym_NULL] = ACTIONS(1298),
    [anon_sym_nullptr] = ACTIONS(1298),
    [sym_comment] = ACTIONS(3),
  },
  [300] = {
    [sym_identifier] = ACTIONS(1298),
    [aux_sym_preproc_include_token1] = ACTIONS(1298),
    [aux_sym_preproc_def_token1] = ACTIONS(1298),
    [aux_sym_preproc_if_token1] = ACTIONS(1298),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1298),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1298),
    [sym_preproc_directive] = ACTIONS(1298),
    [anon_sym_LPAREN2] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1300),
    [anon_sym_TILDE] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1298),
    [anon_sym_PLUS] = ACTIONS(1298),
    [anon_sym_STAR] = ACTIONS(1300),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(1300),
    [anon_sym___extension__] = ACTIONS(1298),
    [anon_sym_typedef] = ACTIONS(1298),
    [anon_sym_extern] = ACTIONS(1298),
    [anon_sym___attribute__] = ACTIONS(1298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1300),
    [anon_sym___declspec] = ACTIONS(1298),
    [anon_sym___cdecl] = ACTIONS(1298),
    [anon_sym___clrcall] = ACTIONS(1298),
    [anon_sym___stdcall] = ACTIONS(1298),
    [anon_sym___fastcall] = ACTIONS(1298),
    [anon_sym___thiscall] = ACTIONS(1298),
    [anon_sym___vectorcall] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_RBRACE] = ACTIONS(1300),
    [anon_sym_signed] = ACTIONS(1298),
    [anon_sym_unsigned] = ACTIONS(1298),
    [anon_sym_long] = ACTIONS(1298),
    [anon_sym_short] = ACTIONS(1298),
    [anon_sym_static] = ACTIONS(1298),
    [anon_sym_auto] = ACTIONS(1298),
    [anon_sym_register] = ACTIONS(1298),
    [anon_sym_inline] = ACTIONS(1298),
    [anon_sym___inline] = ACTIONS(1298),
    [anon_sym___inline__] = ACTIONS(1298),
    [anon_sym___forceinline] = ACTIONS(1298),
    [anon_sym_thread_local] = ACTIONS(1298),
    [anon_sym___thread] = ACTIONS(1298),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_constexpr] = ACTIONS(1298),
    [anon_sym_volatile] = ACTIONS(1298),
    [anon_sym_restrict] = ACTIONS(1298),
    [anon_sym___restrict__] = ACTIONS(1298),
    [anon_sym__Atomic] = ACTIONS(1298),
    [anon_sym__Noreturn] = ACTIONS(1298),
    [anon_sym_noreturn] = ACTIONS(1298),
    [sym_primitive_type] = ACTIONS(1298),
    [anon_sym_enum] = ACTIONS(1298),
    [anon_sym_struct] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1298),
    [anon_sym_if] = ACTIONS(1298),
    [anon_sym_else] = ACTIONS(1298),
    [anon_sym_switch] = ACTIONS(1298),
    [anon_sym_case] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(1298),
    [anon_sym_do] = ACTIONS(1298),
    [anon_sym_for] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1298),
    [anon_sym_break] = ACTIONS(1298),
    [anon_sym_continue] = ACTIONS(1298),
    [anon_sym_goto] = ACTIONS(1298),
    [anon_sym___try] = ACTIONS(1298),
    [anon_sym___leave] = ACTIONS(1298),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_sizeof] = ACTIONS(1298),
    [anon_sym___alignof__] = ACTIONS(1298),
    [anon_sym___alignof] = ACTIONS(1298),
    [anon_sym__alignof] = ACTIONS(1298),
    [anon_sym_alignof] = ACTIONS(1298),
    [anon_sym__Alignof] = ACTIONS(1298),
    [anon_sym_offsetof] = ACTIONS(1298),
    [anon_sym__Generic] = ACTIONS(1298),
    [anon_sym_asm] = ACTIONS(1298),
    [anon_sym___asm__] = ACTIONS(1298),
    [sym_number_literal] = ACTIONS(1300),
    [anon_sym_L_SQUOTE] = ACTIONS(1300),
    [anon_sym_u_SQUOTE] = ACTIONS(1300),
    [anon_sym_U_SQUOTE] = ACTIONS(1300),
    [anon_sym_u8_SQUOTE] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(1300),
    [anon_sym_L_DQUOTE] = ACTIONS(1300),
    [anon_sym_u_DQUOTE] = ACTIONS(1300),
    [anon_sym_U_DQUOTE] = ACTIONS(1300),
    [anon_sym_u8_DQUOTE] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(1300),
    [sym_true] = ACTIONS(1298),
    [sym_false] = ACTIONS(1298),
    [anon_sym_NULL] = ACTIONS(1298),
    [anon_sym_nullptr] = ACTIONS(1298),
    [sym_comment] = ACTIONS(3),
  },
  [301] = {
    [ts_builtin_sym_end] = ACTIONS(1324),
    [sym_identifier] = ACTIONS(1322),
    [aux_sym_preproc_include_token1] = ACTIONS(1322),
    [aux_sym_preproc_def_token1] = ACTIONS(1322),
    [aux_sym_preproc_if_token1] = ACTIONS(1322),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1322),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1322),
    [sym_preproc_directive] = ACTIONS(1322),
    [anon_sym_LPAREN2] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(1324),
    [anon_sym_TILDE] = ACTIONS(1324),
    [anon_sym_DASH] = ACTIONS(1322),
    [anon_sym_PLUS] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(1324),
    [anon_sym_AMP] = ACTIONS(1324),
    [anon_sym_SEMI] = ACTIONS(1324),
    [anon_sym___extension__] = ACTIONS(1322),
    [anon_sym_typedef] = ACTIONS(1322),
    [anon_sym_extern] = ACTIONS(1322),
    [anon_sym___attribute__] = ACTIONS(1322),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1324),
    [anon_sym___declspec] = ACTIONS(1322),
    [anon_sym___cdecl] = ACTIONS(1322),
    [anon_sym___clrcall] = ACTIONS(1322),
    [anon_sym___stdcall] = ACTIONS(1322),
    [anon_sym___fastcall] = ACTIONS(1322),
    [anon_sym___thiscall] = ACTIONS(1322),
    [anon_sym___vectorcall] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_signed] = ACTIONS(1322),
    [anon_sym_unsigned] = ACTIONS(1322),
    [anon_sym_long] = ACTIONS(1322),
    [anon_sym_short] = ACTIONS(1322),
    [anon_sym_static] = ACTIONS(1322),
    [anon_sym_auto] = ACTIONS(1322),
    [anon_sym_register] = ACTIONS(1322),
    [anon_sym_inline] = ACTIONS(1322),
    [anon_sym___inline] = ACTIONS(1322),
    [anon_sym___inline__] = ACTIONS(1322),
    [anon_sym___forceinline] = ACTIONS(1322),
    [anon_sym_thread_local] = ACTIONS(1322),
    [anon_sym___thread] = ACTIONS(1322),
    [anon_sym_const] = ACTIONS(1322),
    [anon_sym_constexpr] = ACTIONS(1322),
    [anon_sym_volatile] = ACTIONS(1322),
    [anon_sym_restrict] = ACTIONS(1322),
    [anon_sym___restrict__] = ACTIONS(1322),
    [anon_sym__Atomic] = ACTIONS(1322),
    [anon_sym__Noreturn] = ACTIONS(1322),
    [anon_sym_noreturn] = ACTIONS(1322),
    [sym_primitive_type] = ACTIONS(1322),
    [anon_sym_enum] = ACTIONS(1322),
    [anon_sym_struct] = ACTIONS(1322),
    [anon_sym_union] = ACTIONS(1322),
    [anon_sym_if] = ACTIONS(1322),
    [anon_sym_else] = ACTIONS(1322),
    [anon_sym_switch] = ACTIONS(1322),
    [anon_sym_case] = ACTIONS(1322),
    [anon_sym_default] = ACTIONS(1322),
    [anon_sym_while] = ACTIONS(1322),
    [anon_sym_do] = ACTIONS(1322),
    [anon_sym_for] = ACTIONS(1322),
    [anon_sym_return] = ACTIONS(1322),
    [anon_sym_break] = ACTIONS(1322),
    [anon_sym_continue] = ACTIONS(1322),
    [anon_sym_goto] = ACTIONS(1322),
    [anon_sym___try] = ACTIONS(1322),
    [anon_sym___leave] = ACTIONS(1322),
    [anon_sym_DASH_DASH] = ACTIONS(1324),
    [anon_sym_PLUS_PLUS] = ACTIONS(1324),
    [anon_sym_sizeof] = ACTIONS(1322),
    [anon_sym___alignof__] = ACTIONS(1322),
    [anon_sym___alignof] = ACTIONS(1322),
    [anon_sym__alignof] = ACTIONS(1322),
    [anon_sym_alignof] = ACTIONS(1322),
    [anon_sym__Alignof] = ACTIONS(1322),
    [anon_sym_offsetof] = ACTIONS(1322),
    [anon_sym__Generic] = ACTIONS(1322),
    [anon_sym_asm] = ACTIONS(1322),
    [anon_sym___asm__] = ACTIONS(1322),
    [sym_number_literal] = ACTIONS(1324),
    [anon_sym_L_SQUOTE] = ACTIONS(1324),
    [anon_sym_u_SQUOTE] = ACTIONS(1324),
    [anon_sym_U_SQUOTE] = ACTIONS(1324),
    [anon_sym_u8_SQUOTE] = ACTIONS(1324),
    [anon_sym_SQUOTE] = ACTIONS(1324),
    [anon_sym_L_DQUOTE] = ACTIONS(1324),
    [anon_sym_u_DQUOTE] = ACTIONS(1324),
    [anon_sym_U_DQUOTE] = ACTIONS(1324),
    [anon_sym_u8_DQUOTE] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1324),
    [sym_true] = ACTIONS(1322),
    [sym_false] = ACTIONS(1322),
    [anon_sym_NULL] = ACTIONS(1322),
    [anon_sym_nullptr] = ACTIONS(1322),
    [sym_comment] = ACTIONS(3),
  },
  [302] = {
    [sym_identifier] = ACTIONS(1330),
    [aux_sym_preproc_include_token1] = ACTIONS(1330),
    [aux_sym_preproc_def_token1] = ACTIONS(1330),
    [aux_sym_preproc_if_token1] = ACTIONS(1330),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1330),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1330),
    [sym_preproc_directive] = ACTIONS(1330),
    [anon_sym_LPAREN2] = ACTIONS(1332),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1332),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_AMP] = ACTIONS(1332),
    [anon_sym_SEMI] = ACTIONS(1332),
    [anon_sym___extension__] = ACTIONS(1330),
    [anon_sym_typedef] = ACTIONS(1330),
    [anon_sym_extern] = ACTIONS(1330),
    [anon_sym___attribute__] = ACTIONS(1330),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1332),
    [anon_sym___declspec] = ACTIONS(1330),
    [anon_sym___cdecl] = ACTIONS(1330),
    [anon_sym___clrcall] = ACTIONS(1330),
    [anon_sym___stdcall] = ACTIONS(1330),
    [anon_sym___fastcall] = ACTIONS(1330),
    [anon_sym___thiscall] = ACTIONS(1330),
    [anon_sym___vectorcall] = ACTIONS(1330),
    [anon_sym_LBRACE] = ACTIONS(1332),
    [anon_sym_RBRACE] = ACTIONS(1332),
    [anon_sym_signed] = ACTIONS(1330),
    [anon_sym_unsigned] = ACTIONS(1330),
    [anon_sym_long] = ACTIONS(1330),
    [anon_sym_short] = ACTIONS(1330),
    [anon_sym_static] = ACTIONS(1330),
    [anon_sym_auto] = ACTIONS(1330),
    [anon_sym_register] = ACTIONS(1330),
    [anon_sym_inline] = ACTIONS(1330),
    [anon_sym___inline] = ACTIONS(1330),
    [anon_sym___inline__] = ACTIONS(1330),
    [anon_sym___forceinline] = ACTIONS(1330),
    [anon_sym_thread_local] = ACTIONS(1330),
    [anon_sym___thread] = ACTIONS(1330),
    [anon_sym_const] = ACTIONS(1330),
    [anon_sym_constexpr] = ACTIONS(1330),
    [anon_sym_volatile] = ACTIONS(1330),
    [anon_sym_restrict] = ACTIONS(1330),
    [anon_sym___restrict__] = ACTIONS(1330),
    [anon_sym__Atomic] = ACTIONS(1330),
    [anon_sym__Noreturn] = ACTIONS(1330),
    [anon_sym_noreturn] = ACTIONS(1330),
    [sym_primitive_type] = ACTIONS(1330),
    [anon_sym_enum] = ACTIONS(1330),
    [anon_sym_struct] = ACTIONS(1330),
    [anon_sym_union] = ACTIONS(1330),
    [anon_sym_if] = ACTIONS(1330),
    [anon_sym_else] = ACTIONS(1330),
    [anon_sym_switch] = ACTIONS(1330),
    [anon_sym_case] = ACTIONS(1330),
    [anon_sym_default] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1330),
    [anon_sym_do] = ACTIONS(1330),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_return] = ACTIONS(1330),
    [anon_sym_break] = ACTIONS(1330),
    [anon_sym_continue] = ACTIONS(1330),
    [anon_sym_goto] = ACTIONS(1330),
    [anon_sym___try] = ACTIONS(1330),
    [anon_sym___leave] = ACTIONS(1330),
    [anon_sym_DASH_DASH] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(1332),
    [anon_sym_sizeof] = ACTIONS(1330),
    [anon_sym___alignof__] = ACTIONS(1330),
    [anon_sym___alignof] = ACTIONS(1330),
    [anon_sym__alignof] = ACTIONS(1330),
    [anon_sym_alignof] = ACTIONS(1330),
    [anon_sym__Alignof] = ACTIONS(1330),
    [anon_sym_offsetof] = ACTIONS(1330),
    [anon_sym__Generic] = ACTIONS(1330),
    [anon_sym_asm] = ACTIONS(1330),
    [anon_sym___asm__] = ACTIONS(1330),
    [sym_number_literal] = ACTIONS(1332),
    [anon_sym_L_SQUOTE] = ACTIONS(1332),
    [anon_sym_u_SQUOTE] = ACTIONS(1332),
    [anon_sym_U_SQUOTE] = ACTIONS(1332),
    [anon_sym_u8_SQUOTE] = ACTIONS(1332),
    [anon_sym_SQUOTE] = ACTIONS(1332),
    [anon_sym_L_DQUOTE] = ACTIONS(1332),
    [anon_sym_u_DQUOTE] = ACTIONS(1332),
    [anon_sym_U_DQUOTE] = ACTIONS(1332),
    [anon_sym_u8_DQUOTE] = ACTIONS(1332),
    [anon_sym_DQUOTE] = ACTIONS(1332),
    [sym_true] = ACTIONS(1330),
    [sym_false] = ACTIONS(1330),
    [anon_sym_NULL] = ACTIONS(1330),
    [anon_sym_nullptr] = ACTIONS(1330),
    [sym_comment] = ACTIONS(3),
  },
  [303] = {
    [ts_builtin_sym_end] = ACTIONS(1328),
    [sym_identifier] = ACTIONS(1326),
    [aux_sym_preproc_include_token1] = ACTIONS(1326),
    [aux_sym_preproc_def_token1] = ACTIONS(1326),
    [aux_sym_preproc_if_token1] = ACTIONS(1326),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1326),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1326),
    [sym_preproc_directive] = ACTIONS(1326),
    [anon_sym_LPAREN2] = ACTIONS(1328),
    [anon_sym_BANG] = ACTIONS(1328),
    [anon_sym_TILDE] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_PLUS] = ACTIONS(1326),
    [anon_sym_STAR] = ACTIONS(1328),
    [anon_sym_AMP] = ACTIONS(1328),
    [anon_sym_SEMI] = ACTIONS(1328),
    [anon_sym___extension__] = ACTIONS(1326),
    [anon_sym_typedef] = ACTIONS(1326),
    [anon_sym_extern] = ACTIONS(1326),
    [anon_sym___attribute__] = ACTIONS(1326),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1328),
    [anon_sym___declspec] = ACTIONS(1326),
    [anon_sym___cdecl] = ACTIONS(1326),
    [anon_sym___clrcall] = ACTIONS(1326),
    [anon_sym___stdcall] = ACTIONS(1326),
    [anon_sym___fastcall] = ACTIONS(1326),
    [anon_sym___thiscall] = ACTIONS(1326),
    [anon_sym___vectorcall] = ACTIONS(1326),
    [anon_sym_LBRACE] = ACTIONS(1328),
    [anon_sym_signed] = ACTIONS(1326),
    [anon_sym_unsigned] = ACTIONS(1326),
    [anon_sym_long] = ACTIONS(1326),
    [anon_sym_short] = ACTIONS(1326),
    [anon_sym_static] = ACTIONS(1326),
    [anon_sym_auto] = ACTIONS(1326),
    [anon_sym_register] = ACTIONS(1326),
    [anon_sym_inline] = ACTIONS(1326),
    [anon_sym___inline] = ACTIONS(1326),
    [anon_sym___inline__] = ACTIONS(1326),
    [anon_sym___forceinline] = ACTIONS(1326),
    [anon_sym_thread_local] = ACTIONS(1326),
    [anon_sym___thread] = ACTIONS(1326),
    [anon_sym_const] = ACTIONS(1326),
    [anon_sym_constexpr] = ACTIONS(1326),
    [anon_sym_volatile] = ACTIONS(1326),
    [anon_sym_restrict] = ACTIONS(1326),
    [anon_sym___restrict__] = ACTIONS(1326),
    [anon_sym__Atomic] = ACTIONS(1326),
    [anon_sym__Noreturn] = ACTIONS(1326),
    [anon_sym_noreturn] = ACTIONS(1326),
    [sym_primitive_type] = ACTIONS(1326),
    [anon_sym_enum] = ACTIONS(1326),
    [anon_sym_struct] = ACTIONS(1326),
    [anon_sym_union] = ACTIONS(1326),
    [anon_sym_if] = ACTIONS(1326),
    [anon_sym_else] = ACTIONS(1326),
    [anon_sym_switch] = ACTIONS(1326),
    [anon_sym_case] = ACTIONS(1326),
    [anon_sym_default] = ACTIONS(1326),
    [anon_sym_while] = ACTIONS(1326),
    [anon_sym_do] = ACTIONS(1326),
    [anon_sym_for] = ACTIONS(1326),
    [anon_sym_return] = ACTIONS(1326),
    [anon_sym_break] = ACTIONS(1326),
    [anon_sym_continue] = ACTIONS(1326),
    [anon_sym_goto] = ACTIONS(1326),
    [anon_sym___try] = ACTIONS(1326),
    [anon_sym___leave] = ACTIONS(1326),
    [anon_sym_DASH_DASH] = ACTIONS(1328),
    [anon_sym_PLUS_PLUS] = ACTIONS(1328),
    [anon_sym_sizeof] = ACTIONS(1326),
    [anon_sym___alignof__] = ACTIONS(1326),
    [anon_sym___alignof] = ACTIONS(1326),
    [anon_sym__alignof] = ACTIONS(1326),
    [anon_sym_alignof] = ACTIONS(1326),
    [anon_sym__Alignof] = ACTIONS(1326),
    [anon_sym_offsetof] = ACTIONS(1326),
    [anon_sym__Generic] = ACTIONS(1326),
    [anon_sym_asm] = ACTIONS(1326),
    [anon_sym___asm__] = ACTIONS(1326),
    [sym_number_literal] = ACTIONS(1328),
    [anon_sym_L_SQUOTE] = ACTIONS(1328),
    [anon_sym_u_SQUOTE] = ACTIONS(1328),
    [anon_sym_U_SQUOTE] = ACTIONS(1328),
    [anon_sym_u8_SQUOTE] = ACTIONS(1328),
    [anon_sym_SQUOTE] = ACTIONS(1328),
    [anon_sym_L_DQUOTE] = ACTIONS(1328),
    [anon_sym_u_DQUOTE] = ACTIONS(1328),
    [anon_sym_U_DQUOTE] = ACTIONS(1328),
    [anon_sym_u8_DQUOTE] = ACTIONS(1328),
    [anon_sym_DQUOTE] = ACTIONS(1328),
    [sym_true] = ACTIONS(1326),
    [sym_false] = ACTIONS(1326),
    [anon_sym_NULL] = ACTIONS(1326),
    [anon_sym_nullptr] = ACTIONS(1326),
    [sym_comment] = ACTIONS(3),
  },
  [304] = {
    [ts_builtin_sym_end] = ACTIONS(1404),
    [sym_identifier] = ACTIONS(1402),
    [aux_sym_preproc_include_token1] = ACTIONS(1402),
    [aux_sym_preproc_def_token1] = ACTIONS(1402),
    [aux_sym_preproc_if_token1] = ACTIONS(1402),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1402),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1402),
    [sym_preproc_directive] = ACTIONS(1402),
    [anon_sym_LPAREN2] = ACTIONS(1404),
    [anon_sym_BANG] = ACTIONS(1404),
    [anon_sym_TILDE] = ACTIONS(1404),
    [anon_sym_DASH] = ACTIONS(1402),
    [anon_sym_PLUS] = ACTIONS(1402),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_AMP] = ACTIONS(1404),
    [anon_sym_SEMI] = ACTIONS(1404),
    [anon_sym___extension__] = ACTIONS(1402),
    [anon_sym_typedef] = ACTIONS(1402),
    [anon_sym_extern] = ACTIONS(1402),
    [anon_sym___attribute__] = ACTIONS(1402),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1404),
    [anon_sym___declspec] = ACTIONS(1402),
    [anon_sym___cdecl] = ACTIONS(1402),
    [anon_sym___clrcall] = ACTIONS(1402),
    [anon_sym___stdcall] = ACTIONS(1402),
    [anon_sym___fastcall] = ACTIONS(1402),
    [anon_sym___thiscall] = ACTIONS(1402),
    [anon_sym___vectorcall] = ACTIONS(1402),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_signed] = ACTIONS(1402),
    [anon_sym_unsigned] = ACTIONS(1402),
    [anon_sym_long] = ACTIONS(1402),
    [anon_sym_short] = ACTIONS(1402),
    [anon_sym_static] = ACTIONS(1402),
    [anon_sym_auto] = ACTIONS(1402),
    [anon_sym_register] = ACTIONS(1402),
    [anon_sym_inline] = ACTIONS(1402),
    [anon_sym___inline] = ACTIONS(1402),
    [anon_sym___inline__] = ACTIONS(1402),
    [anon_sym___forceinline] = ACTIONS(1402),
    [anon_sym_thread_local] = ACTIONS(1402),
    [anon_sym___thread] = ACTIONS(1402),
    [anon_sym_const] = ACTIONS(1402),
    [anon_sym_constexpr] = ACTIONS(1402),
    [anon_sym_volatile] = ACTIONS(1402),
    [anon_sym_restrict] = ACTIONS(1402),
    [anon_sym___restrict__] = ACTIONS(1402),
    [anon_sym__Atomic] = ACTIONS(1402),
    [anon_sym__Noreturn] = ACTIONS(1402),
    [anon_sym_noreturn] = ACTIONS(1402),
    [sym_primitive_type] = ACTIONS(1402),
    [anon_sym_enum] = ACTIONS(1402),
    [anon_sym_struct] = ACTIONS(1402),
    [anon_sym_union] = ACTIONS(1402),
    [anon_sym_if] = ACTIONS(1402),
    [anon_sym_else] = ACTIONS(1402),
    [anon_sym_switch] = ACTIONS(1402),
    [anon_sym_case] = ACTIONS(1402),
    [anon_sym_default] = ACTIONS(1402),
    [anon_sym_while] = ACTIONS(1402),
    [anon_sym_do] = ACTIONS(1402),
    [anon_sym_for] = ACTIONS(1402),
    [anon_sym_return] = ACTIONS(1402),
    [anon_sym_break] = ACTIONS(1402),
    [anon_sym_continue] = ACTIONS(1402),
    [anon_sym_goto] = ACTIONS(1402),
    [anon_sym___try] = ACTIONS(1402),
    [anon_sym___leave] = ACTIONS(1402),
    [anon_sym_DASH_DASH] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1404),
    [anon_sym_sizeof] = ACTIONS(1402),
    [anon_sym___alignof__] = ACTIONS(1402),
    [anon_sym___alignof] = ACTIONS(1402),
    [anon_sym__alignof] = ACTIONS(1402),
    [anon_sym_alignof] = ACTIONS(1402),
    [anon_sym__Alignof] = ACTIONS(1402),
    [anon_sym_offsetof] = ACTIONS(1402),
    [anon_sym__Generic] = ACTIONS(1402),
    [anon_sym_asm] = ACTIONS(1402),
    [anon_sym___asm__] = ACTIONS(1402),
    [sym_number_literal] = ACTIONS(1404),
    [anon_sym_L_SQUOTE] = ACTIONS(1404),
    [anon_sym_u_SQUOTE] = ACTIONS(1404),
    [anon_sym_U_SQUOTE] = ACTIONS(1404),
    [anon_sym_u8_SQUOTE] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(1404),
    [anon_sym_L_DQUOTE] = ACTIONS(1404),
    [anon_sym_u_DQUOTE] = ACTIONS(1404),
    [anon_sym_U_DQUOTE] = ACTIONS(1404),
    [anon_sym_u8_DQUOTE] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1404),
    [sym_true] = ACTIONS(1402),
    [sym_false] = ACTIONS(1402),
    [anon_sym_NULL] = ACTIONS(1402),
    [anon_sym_nullptr] = ACTIONS(1402),
    [sym_comment] = ACTIONS(3),
  },
  [305] = {
    [ts_builtin_sym_end] = ACTIONS(1400),
    [sym_identifier] = ACTIONS(1398),
    [aux_sym_preproc_include_token1] = ACTIONS(1398),
    [aux_sym_preproc_def_token1] = ACTIONS(1398),
    [aux_sym_preproc_if_token1] = ACTIONS(1398),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1398),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1398),
    [sym_preproc_directive] = ACTIONS(1398),
    [anon_sym_LPAREN2] = ACTIONS(1400),
    [anon_sym_BANG] = ACTIONS(1400),
    [anon_sym_TILDE] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1398),
    [anon_sym_PLUS] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym___extension__] = ACTIONS(1398),
    [anon_sym_typedef] = ACTIONS(1398),
    [anon_sym_extern] = ACTIONS(1398),
    [anon_sym___attribute__] = ACTIONS(1398),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1400),
    [anon_sym___declspec] = ACTIONS(1398),
    [anon_sym___cdecl] = ACTIONS(1398),
    [anon_sym___clrcall] = ACTIONS(1398),
    [anon_sym___stdcall] = ACTIONS(1398),
    [anon_sym___fastcall] = ACTIONS(1398),
    [anon_sym___thiscall] = ACTIONS(1398),
    [anon_sym___vectorcall] = ACTIONS(1398),
    [anon_sym_LBRACE] = ACTIONS(1400),
    [anon_sym_signed] = ACTIONS(1398),
    [anon_sym_unsigned] = ACTIONS(1398),
    [anon_sym_long] = ACTIONS(1398),
    [anon_sym_short] = ACTIONS(1398),
    [anon_sym_static] = ACTIONS(1398),
    [anon_sym_auto] = ACTIONS(1398),
    [anon_sym_register] = ACTIONS(1398),
    [anon_sym_inline] = ACTIONS(1398),
    [anon_sym___inline] = ACTIONS(1398),
    [anon_sym___inline__] = ACTIONS(1398),
    [anon_sym___forceinline] = ACTIONS(1398),
    [anon_sym_thread_local] = ACTIONS(1398),
    [anon_sym___thread] = ACTIONS(1398),
    [anon_sym_const] = ACTIONS(1398),
    [anon_sym_constexpr] = ACTIONS(1398),
    [anon_sym_volatile] = ACTIONS(1398),
    [anon_sym_restrict] = ACTIONS(1398),
    [anon_sym___restrict__] = ACTIONS(1398),
    [anon_sym__Atomic] = ACTIONS(1398),
    [anon_sym__Noreturn] = ACTIONS(1398),
    [anon_sym_noreturn] = ACTIONS(1398),
    [sym_primitive_type] = ACTIONS(1398),
    [anon_sym_enum] = ACTIONS(1398),
    [anon_sym_struct] = ACTIONS(1398),
    [anon_sym_union] = ACTIONS(1398),
    [anon_sym_if] = ACTIONS(1398),
    [anon_sym_else] = ACTIONS(1398),
    [anon_sym_switch] = ACTIONS(1398),
    [anon_sym_case] = ACTIONS(1398),
    [anon_sym_default] = ACTIONS(1398),
    [anon_sym_while] = ACTIONS(1398),
    [anon_sym_do] = ACTIONS(1398),
    [anon_sym_for] = ACTIONS(1398),
    [anon_sym_return] = ACTIONS(1398),
    [anon_sym_break] = ACTIONS(1398),
    [anon_sym_continue] = ACTIONS(1398),
    [anon_sym_goto] = ACTIONS(1398),
    [anon_sym___try] = ACTIONS(1398),
    [anon_sym___leave] = ACTIONS(1398),
    [anon_sym_DASH_DASH] = ACTIONS(1400),
    [anon_sym_PLUS_PLUS] = ACTIONS(1400),
    [anon_sym_sizeof] = ACTIONS(1398),
    [anon_sym___alignof__] = ACTIONS(1398),
    [anon_sym___alignof] = ACTIONS(1398),
    [anon_sym__alignof] = ACTIONS(1398),
    [anon_sym_alignof] = ACTIONS(1398),
    [anon_sym__Alignof] = ACTIONS(1398),
    [anon_sym_offsetof] = ACTIONS(1398),
    [anon_sym__Generic] = ACTIONS(1398),
    [anon_sym_asm] = ACTIONS(1398),
    [anon_sym___asm__] = ACTIONS(1398),
    [sym_number_literal] = ACTIONS(1400),
    [anon_sym_L_SQUOTE] = ACTIONS(1400),
    [anon_sym_u_SQUOTE] = ACTIONS(1400),
    [anon_sym_U_SQUOTE] = ACTIONS(1400),
    [anon_sym_u8_SQUOTE] = ACTIONS(1400),
    [anon_sym_SQUOTE] = ACTIONS(1400),
    [anon_sym_L_DQUOTE] = ACTIONS(1400),
    [anon_sym_u_DQUOTE] = ACTIONS(1400),
    [anon_sym_U_DQUOTE] = ACTIONS(1400),
    [anon_sym_u8_DQUOTE] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(1398),
    [sym_false] = ACTIONS(1398),
    [anon_sym_NULL] = ACTIONS(1398),
    [anon_sym_nullptr] = ACTIONS(1398),
    [sym_comment] = ACTIONS(3),
  },
  [306] = {
    [sym_identifier] = ACTIONS(1374),
    [aux_sym_preproc_include_token1] = ACTIONS(1374),
    [aux_sym_preproc_def_token1] = ACTIONS(1374),
    [aux_sym_preproc_if_token1] = ACTIONS(1374),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1374),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1374),
    [sym_preproc_directive] = ACTIONS(1374),
    [anon_sym_LPAREN2] = ACTIONS(1376),
    [anon_sym_BANG] = ACTIONS(1376),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_DASH] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1374),
    [anon_sym_STAR] = ACTIONS(1376),
    [anon_sym_AMP] = ACTIONS(1376),
    [anon_sym_SEMI] = ACTIONS(1376),
    [anon_sym___extension__] = ACTIONS(1374),
    [anon_sym_typedef] = ACTIONS(1374),
    [anon_sym_extern] = ACTIONS(1374),
    [anon_sym___attribute__] = ACTIONS(1374),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1376),
    [anon_sym___declspec] = ACTIONS(1374),
    [anon_sym___cdecl] = ACTIONS(1374),
    [anon_sym___clrcall] = ACTIONS(1374),
    [anon_sym___stdcall] = ACTIONS(1374),
    [anon_sym___fastcall] = ACTIONS(1374),
    [anon_sym___thiscall] = ACTIONS(1374),
    [anon_sym___vectorcall] = ACTIONS(1374),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_RBRACE] = ACTIONS(1376),
    [anon_sym_signed] = ACTIONS(1374),
    [anon_sym_unsigned] = ACTIONS(1374),
    [anon_sym_long] = ACTIONS(1374),
    [anon_sym_short] = ACTIONS(1374),
    [anon_sym_static] = ACTIONS(1374),
    [anon_sym_auto] = ACTIONS(1374),
    [anon_sym_register] = ACTIONS(1374),
    [anon_sym_inline] = ACTIONS(1374),
    [anon_sym___inline] = ACTIONS(1374),
    [anon_sym___inline__] = ACTIONS(1374),
    [anon_sym___forceinline] = ACTIONS(1374),
    [anon_sym_thread_local] = ACTIONS(1374),
    [anon_sym___thread] = ACTIONS(1374),
    [anon_sym_const] = ACTIONS(1374),
    [anon_sym_constexpr] = ACTIONS(1374),
    [anon_sym_volatile] = ACTIONS(1374),
    [anon_sym_restrict] = ACTIONS(1374),
    [anon_sym___restrict__] = ACTIONS(1374),
    [anon_sym__Atomic] = ACTIONS(1374),
    [anon_sym__Noreturn] = ACTIONS(1374),
    [anon_sym_noreturn] = ACTIONS(1374),
    [sym_primitive_type] = ACTIONS(1374),
    [anon_sym_enum] = ACTIONS(1374),
    [anon_sym_struct] = ACTIONS(1374),
    [anon_sym_union] = ACTIONS(1374),
    [anon_sym_if] = ACTIONS(1374),
    [anon_sym_else] = ACTIONS(1374),
    [anon_sym_switch] = ACTIONS(1374),
    [anon_sym_case] = ACTIONS(1374),
    [anon_sym_default] = ACTIONS(1374),
    [anon_sym_while] = ACTIONS(1374),
    [anon_sym_do] = ACTIONS(1374),
    [anon_sym_for] = ACTIONS(1374),
    [anon_sym_return] = ACTIONS(1374),
    [anon_sym_break] = ACTIONS(1374),
    [anon_sym_continue] = ACTIONS(1374),
    [anon_sym_goto] = ACTIONS(1374),
    [anon_sym___try] = ACTIONS(1374),
    [anon_sym___leave] = ACTIONS(1374),
    [anon_sym_DASH_DASH] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1376),
    [anon_sym_sizeof] = ACTIONS(1374),
    [anon_sym___alignof__] = ACTIONS(1374),
    [anon_sym___alignof] = ACTIONS(1374),
    [anon_sym__alignof] = ACTIONS(1374),
    [anon_sym_alignof] = ACTIONS(1374),
    [anon_sym__Alignof] = ACTIONS(1374),
    [anon_sym_offsetof] = ACTIONS(1374),
    [anon_sym__Generic] = ACTIONS(1374),
    [anon_sym_asm] = ACTIONS(1374),
    [anon_sym___asm__] = ACTIONS(1374),
    [sym_number_literal] = ACTIONS(1376),
    [anon_sym_L_SQUOTE] = ACTIONS(1376),
    [anon_sym_u_SQUOTE] = ACTIONS(1376),
    [anon_sym_U_SQUOTE] = ACTIONS(1376),
    [anon_sym_u8_SQUOTE] = ACTIONS(1376),
    [anon_sym_SQUOTE] = ACTIONS(1376),
    [anon_sym_L_DQUOTE] = ACTIONS(1376),
    [anon_sym_u_DQUOTE] = ACTIONS(1376),
    [anon_sym_U_DQUOTE] = ACTIONS(1376),
    [anon_sym_u8_DQUOTE] = ACTIONS(1376),
    [anon_sym_DQUOTE] = ACTIONS(1376),
    [sym_true] = ACTIONS(1374),
    [sym_false] = ACTIONS(1374),
    [anon_sym_NULL] = ACTIONS(1374),
    [anon_sym_nullptr] = ACTIONS(1374),
    [sym_comment] = ACTIONS(3),
  },
  [307] = {
    [sym_identifier] = ACTIONS(1370),
    [aux_sym_preproc_include_token1] = ACTIONS(1370),
    [aux_sym_preproc_def_token1] = ACTIONS(1370),
    [aux_sym_preproc_if_token1] = ACTIONS(1370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1370),
    [sym_preproc_directive] = ACTIONS(1370),
    [anon_sym_LPAREN2] = ACTIONS(1372),
    [anon_sym_BANG] = ACTIONS(1372),
    [anon_sym_TILDE] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_STAR] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1372),
    [anon_sym___extension__] = ACTIONS(1370),
    [anon_sym_typedef] = ACTIONS(1370),
    [anon_sym_extern] = ACTIONS(1370),
    [anon_sym___attribute__] = ACTIONS(1370),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1372),
    [anon_sym___declspec] = ACTIONS(1370),
    [anon_sym___cdecl] = ACTIONS(1370),
    [anon_sym___clrcall] = ACTIONS(1370),
    [anon_sym___stdcall] = ACTIONS(1370),
    [anon_sym___fastcall] = ACTIONS(1370),
    [anon_sym___thiscall] = ACTIONS(1370),
    [anon_sym___vectorcall] = ACTIONS(1370),
    [anon_sym_LBRACE] = ACTIONS(1372),
    [anon_sym_RBRACE] = ACTIONS(1372),
    [anon_sym_signed] = ACTIONS(1370),
    [anon_sym_unsigned] = ACTIONS(1370),
    [anon_sym_long] = ACTIONS(1370),
    [anon_sym_short] = ACTIONS(1370),
    [anon_sym_static] = ACTIONS(1370),
    [anon_sym_auto] = ACTIONS(1370),
    [anon_sym_register] = ACTIONS(1370),
    [anon_sym_inline] = ACTIONS(1370),
    [anon_sym___inline] = ACTIONS(1370),
    [anon_sym___inline__] = ACTIONS(1370),
    [anon_sym___forceinline] = ACTIONS(1370),
    [anon_sym_thread_local] = ACTIONS(1370),
    [anon_sym___thread] = ACTIONS(1370),
    [anon_sym_const] = ACTIONS(1370),
    [anon_sym_constexpr] = ACTIONS(1370),
    [anon_sym_volatile] = ACTIONS(1370),
    [anon_sym_restrict] = ACTIONS(1370),
    [anon_sym___restrict__] = ACTIONS(1370),
    [anon_sym__Atomic] = ACTIONS(1370),
    [anon_sym__Noreturn] = ACTIONS(1370),
    [anon_sym_noreturn] = ACTIONS(1370),
    [sym_primitive_type] = ACTIONS(1370),
    [anon_sym_enum] = ACTIONS(1370),
    [anon_sym_struct] = ACTIONS(1370),
    [anon_sym_union] = ACTIONS(1370),
    [anon_sym_if] = ACTIONS(1370),
    [anon_sym_else] = ACTIONS(1370),
    [anon_sym_switch] = ACTIONS(1370),
    [anon_sym_case] = ACTIONS(1370),
    [anon_sym_default] = ACTIONS(1370),
    [anon_sym_while] = ACTIONS(1370),
    [anon_sym_do] = ACTIONS(1370),
    [anon_sym_for] = ACTIONS(1370),
    [anon_sym_return] = ACTIONS(1370),
    [anon_sym_break] = ACTIONS(1370),
    [anon_sym_continue] = ACTIONS(1370),
    [anon_sym_goto] = ACTIONS(1370),
    [anon_sym___try] = ACTIONS(1370),
    [anon_sym___leave] = ACTIONS(1370),
    [anon_sym_DASH_DASH] = ACTIONS(1372),
    [anon_sym_PLUS_PLUS] = ACTIONS(1372),
    [anon_sym_sizeof] = ACTIONS(1370),
    [anon_sym___alignof__] = ACTIONS(1370),
    [anon_sym___alignof] = ACTIONS(1370),
    [anon_sym__alignof] = ACTIONS(1370),
    [anon_sym_alignof] = ACTIONS(1370),
    [anon_sym__Alignof] = ACTIONS(1370),
    [anon_sym_offsetof] = ACTIONS(1370),
    [anon_sym__Generic] = ACTIONS(1370),
    [anon_sym_asm] = ACTIONS(1370),
    [anon_sym___asm__] = ACTIONS(1370),
    [sym_number_literal] = ACTIONS(1372),
    [anon_sym_L_SQUOTE] = ACTIONS(1372),
    [anon_sym_u_SQUOTE] = ACTIONS(1372),
    [anon_sym_U_SQUOTE] = ACTIONS(1372),
    [anon_sym_u8_SQUOTE] = ACTIONS(1372),
    [anon_sym_SQUOTE] = ACTIONS(1372),
    [anon_sym_L_DQUOTE] = ACTIONS(1372),
    [anon_sym_u_DQUOTE] = ACTIONS(1372),
    [anon_sym_U_DQUOTE] = ACTIONS(1372),
    [anon_sym_u8_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1372),
    [sym_true] = ACTIONS(1370),
    [sym_false] = ACTIONS(1370),
    [anon_sym_NULL] = ACTIONS(1370),
    [anon_sym_nullptr] = ACTIONS(1370),
    [sym_comment] = ACTIONS(3),
  },
  [308] = {
    [ts_builtin_sym_end] = ACTIONS(1376),
    [sym_identifier] = ACTIONS(1374),
    [aux_sym_preproc_include_token1] = ACTIONS(1374),
    [aux_sym_preproc_def_token1] = ACTIONS(1374),
    [aux_sym_preproc_if_token1] = ACTIONS(1374),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1374),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1374),
    [sym_preproc_directive] = ACTIONS(1374),
    [anon_sym_LPAREN2] = ACTIONS(1376),
    [anon_sym_BANG] = ACTIONS(1376),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_DASH] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1374),
    [anon_sym_STAR] = ACTIONS(1376),
    [anon_sym_AMP] = ACTIONS(1376),
    [anon_sym_SEMI] = ACTIONS(1376),
    [anon_sym___extension__] = ACTIONS(1374),
    [anon_sym_typedef] = ACTIONS(1374),
    [anon_sym_extern] = ACTIONS(1374),
    [anon_sym___attribute__] = ACTIONS(1374),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1376),
    [anon_sym___declspec] = ACTIONS(1374),
    [anon_sym___cdecl] = ACTIONS(1374),
    [anon_sym___clrcall] = ACTIONS(1374),
    [anon_sym___stdcall] = ACTIONS(1374),
    [anon_sym___fastcall] = ACTIONS(1374),
    [anon_sym___thiscall] = ACTIONS(1374),
    [anon_sym___vectorcall] = ACTIONS(1374),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_signed] = ACTIONS(1374),
    [anon_sym_unsigned] = ACTIONS(1374),
    [anon_sym_long] = ACTIONS(1374),
    [anon_sym_short] = ACTIONS(1374),
    [anon_sym_static] = ACTIONS(1374),
    [anon_sym_auto] = ACTIONS(1374),
    [anon_sym_register] = ACTIONS(1374),
    [anon_sym_inline] = ACTIONS(1374),
    [anon_sym___inline] = ACTIONS(1374),
    [anon_sym___inline__] = ACTIONS(1374),
    [anon_sym___forceinline] = ACTIONS(1374),
    [anon_sym_thread_local] = ACTIONS(1374),
    [anon_sym___thread] = ACTIONS(1374),
    [anon_sym_const] = ACTIONS(1374),
    [anon_sym_constexpr] = ACTIONS(1374),
    [anon_sym_volatile] = ACTIONS(1374),
    [anon_sym_restrict] = ACTIONS(1374),
    [anon_sym___restrict__] = ACTIONS(1374),
    [anon_sym__Atomic] = ACTIONS(1374),
    [anon_sym__Noreturn] = ACTIONS(1374),
    [anon_sym_noreturn] = ACTIONS(1374),
    [sym_primitive_type] = ACTIONS(1374),
    [anon_sym_enum] = ACTIONS(1374),
    [anon_sym_struct] = ACTIONS(1374),
    [anon_sym_union] = ACTIONS(1374),
    [anon_sym_if] = ACTIONS(1374),
    [anon_sym_else] = ACTIONS(1374),
    [anon_sym_switch] = ACTIONS(1374),
    [anon_sym_case] = ACTIONS(1374),
    [anon_sym_default] = ACTIONS(1374),
    [anon_sym_while] = ACTIONS(1374),
    [anon_sym_do] = ACTIONS(1374),
    [anon_sym_for] = ACTIONS(1374),
    [anon_sym_return] = ACTIONS(1374),
    [anon_sym_break] = ACTIONS(1374),
    [anon_sym_continue] = ACTIONS(1374),
    [anon_sym_goto] = ACTIONS(1374),
    [anon_sym___try] = ACTIONS(1374),
    [anon_sym___leave] = ACTIONS(1374),
    [anon_sym_DASH_DASH] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1376),
    [anon_sym_sizeof] = ACTIONS(1374),
    [anon_sym___alignof__] = ACTIONS(1374),
    [anon_sym___alignof] = ACTIONS(1374),
    [anon_sym__alignof] = ACTIONS(1374),
    [anon_sym_alignof] = ACTIONS(1374),
    [anon_sym__Alignof] = ACTIONS(1374),
    [anon_sym_offsetof] = ACTIONS(1374),
    [anon_sym__Generic] = ACTIONS(1374),
    [anon_sym_asm] = ACTIONS(1374),
    [anon_sym___asm__] = ACTIONS(1374),
    [sym_number_literal] = ACTIONS(1376),
    [anon_sym_L_SQUOTE] = ACTIONS(1376),
    [anon_sym_u_SQUOTE] = ACTIONS(1376),
    [anon_sym_U_SQUOTE] = ACTIONS(1376),
    [anon_sym_u8_SQUOTE] = ACTIONS(1376),
    [anon_sym_SQUOTE] = ACTIONS(1376),
    [anon_sym_L_DQUOTE] = ACTIONS(1376),
    [anon_sym_u_DQUOTE] = ACTIONS(1376),
    [anon_sym_U_DQUOTE] = ACTIONS(1376),
    [anon_sym_u8_DQUOTE] = ACTIONS(1376),
    [anon_sym_DQUOTE] = ACTIONS(1376),
    [sym_true] = ACTIONS(1374),
    [sym_false] = ACTIONS(1374),
    [anon_sym_NULL] = ACTIONS(1374),
    [anon_sym_nullptr] = ACTIONS(1374),
    [sym_comment] = ACTIONS(3),
  },
  [309] = {
    [sym_identifier] = ACTIONS(1334),
    [aux_sym_preproc_include_token1] = ACTIONS(1334),
    [aux_sym_preproc_def_token1] = ACTIONS(1334),
    [aux_sym_preproc_if_token1] = ACTIONS(1334),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1334),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1334),
    [sym_preproc_directive] = ACTIONS(1334),
    [anon_sym_LPAREN2] = ACTIONS(1336),
    [anon_sym_BANG] = ACTIONS(1336),
    [anon_sym_TILDE] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_PLUS] = ACTIONS(1334),
    [anon_sym_STAR] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1336),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym___extension__] = ACTIONS(1334),
    [anon_sym_typedef] = ACTIONS(1334),
    [anon_sym_extern] = ACTIONS(1334),
    [anon_sym___attribute__] = ACTIONS(1334),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1336),
    [anon_sym___declspec] = ACTIONS(1334),
    [anon_sym___cdecl] = ACTIONS(1334),
    [anon_sym___clrcall] = ACTIONS(1334),
    [anon_sym___stdcall] = ACTIONS(1334),
    [anon_sym___fastcall] = ACTIONS(1334),
    [anon_sym___thiscall] = ACTIONS(1334),
    [anon_sym___vectorcall] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [anon_sym_signed] = ACTIONS(1334),
    [anon_sym_unsigned] = ACTIONS(1334),
    [anon_sym_long] = ACTIONS(1334),
    [anon_sym_short] = ACTIONS(1334),
    [anon_sym_static] = ACTIONS(1334),
    [anon_sym_auto] = ACTIONS(1334),
    [anon_sym_register] = ACTIONS(1334),
    [anon_sym_inline] = ACTIONS(1334),
    [anon_sym___inline] = ACTIONS(1334),
    [anon_sym___inline__] = ACTIONS(1334),
    [anon_sym___forceinline] = ACTIONS(1334),
    [anon_sym_thread_local] = ACTIONS(1334),
    [anon_sym___thread] = ACTIONS(1334),
    [anon_sym_const] = ACTIONS(1334),
    [anon_sym_constexpr] = ACTIONS(1334),
    [anon_sym_volatile] = ACTIONS(1334),
    [anon_sym_restrict] = ACTIONS(1334),
    [anon_sym___restrict__] = ACTIONS(1334),
    [anon_sym__Atomic] = ACTIONS(1334),
    [anon_sym__Noreturn] = ACTIONS(1334),
    [anon_sym_noreturn] = ACTIONS(1334),
    [sym_primitive_type] = ACTIONS(1334),
    [anon_sym_enum] = ACTIONS(1334),
    [anon_sym_struct] = ACTIONS(1334),
    [anon_sym_union] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1334),
    [anon_sym_else] = ACTIONS(1334),
    [anon_sym_switch] = ACTIONS(1334),
    [anon_sym_case] = ACTIONS(1334),
    [anon_sym_default] = ACTIONS(1334),
    [anon_sym_while] = ACTIONS(1334),
    [anon_sym_do] = ACTIONS(1334),
    [anon_sym_for] = ACTIONS(1334),
    [anon_sym_return] = ACTIONS(1334),
    [anon_sym_break] = ACTIONS(1334),
    [anon_sym_continue] = ACTIONS(1334),
    [anon_sym_goto] = ACTIONS(1334),
    [anon_sym___try] = ACTIONS(1334),
    [anon_sym___leave] = ACTIONS(1334),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_sizeof] = ACTIONS(1334),
    [anon_sym___alignof__] = ACTIONS(1334),
    [anon_sym___alignof] = ACTIONS(1334),
    [anon_sym__alignof] = ACTIONS(1334),
    [anon_sym_alignof] = ACTIONS(1334),
    [anon_sym__Alignof] = ACTIONS(1334),
    [anon_sym_offsetof] = ACTIONS(1334),
    [anon_sym__Generic] = ACTIONS(1334),
    [anon_sym_asm] = ACTIONS(1334),
    [anon_sym___asm__] = ACTIONS(1334),
    [sym_number_literal] = ACTIONS(1336),
    [anon_sym_L_SQUOTE] = ACTIONS(1336),
    [anon_sym_u_SQUOTE] = ACTIONS(1336),
    [anon_sym_U_SQUOTE] = ACTIONS(1336),
    [anon_sym_u8_SQUOTE] = ACTIONS(1336),
    [anon_sym_SQUOTE] = ACTIONS(1336),
    [anon_sym_L_DQUOTE] = ACTIONS(1336),
    [anon_sym_u_DQUOTE] = ACTIONS(1336),
    [anon_sym_U_DQUOTE] = ACTIONS(1336),
    [anon_sym_u8_DQUOTE] = ACTIONS(1336),
    [anon_sym_DQUOTE] = ACTIONS(1336),
    [sym_true] = ACTIONS(1334),
    [sym_false] = ACTIONS(1334),
    [anon_sym_NULL] = ACTIONS(1334),
    [anon_sym_nullptr] = ACTIONS(1334),
    [sym_comment] = ACTIONS(3),
  },
  [310] = {
    [ts_builtin_sym_end] = ACTIONS(1332),
    [sym_identifier] = ACTIONS(1330),
    [aux_sym_preproc_include_token1] = ACTIONS(1330),
    [aux_sym_preproc_def_token1] = ACTIONS(1330),
    [aux_sym_preproc_if_token1] = ACTIONS(1330),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1330),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1330),
    [sym_preproc_directive] = ACTIONS(1330),
    [anon_sym_LPAREN2] = ACTIONS(1332),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1332),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_AMP] = ACTIONS(1332),
    [anon_sym_SEMI] = ACTIONS(1332),
    [anon_sym___extension__] = ACTIONS(1330),
    [anon_sym_typedef] = ACTIONS(1330),
    [anon_sym_extern] = ACTIONS(1330),
    [anon_sym___attribute__] = ACTIONS(1330),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1332),
    [anon_sym___declspec] = ACTIONS(1330),
    [anon_sym___cdecl] = ACTIONS(1330),
    [anon_sym___clrcall] = ACTIONS(1330),
    [anon_sym___stdcall] = ACTIONS(1330),
    [anon_sym___fastcall] = ACTIONS(1330),
    [anon_sym___thiscall] = ACTIONS(1330),
    [anon_sym___vectorcall] = ACTIONS(1330),
    [anon_sym_LBRACE] = ACTIONS(1332),
    [anon_sym_signed] = ACTIONS(1330),
    [anon_sym_unsigned] = ACTIONS(1330),
    [anon_sym_long] = ACTIONS(1330),
    [anon_sym_short] = ACTIONS(1330),
    [anon_sym_static] = ACTIONS(1330),
    [anon_sym_auto] = ACTIONS(1330),
    [anon_sym_register] = ACTIONS(1330),
    [anon_sym_inline] = ACTIONS(1330),
    [anon_sym___inline] = ACTIONS(1330),
    [anon_sym___inline__] = ACTIONS(1330),
    [anon_sym___forceinline] = ACTIONS(1330),
    [anon_sym_thread_local] = ACTIONS(1330),
    [anon_sym___thread] = ACTIONS(1330),
    [anon_sym_const] = ACTIONS(1330),
    [anon_sym_constexpr] = ACTIONS(1330),
    [anon_sym_volatile] = ACTIONS(1330),
    [anon_sym_restrict] = ACTIONS(1330),
    [anon_sym___restrict__] = ACTIONS(1330),
    [anon_sym__Atomic] = ACTIONS(1330),
    [anon_sym__Noreturn] = ACTIONS(1330),
    [anon_sym_noreturn] = ACTIONS(1330),
    [sym_primitive_type] = ACTIONS(1330),
    [anon_sym_enum] = ACTIONS(1330),
    [anon_sym_struct] = ACTIONS(1330),
    [anon_sym_union] = ACTIONS(1330),
    [anon_sym_if] = ACTIONS(1330),
    [anon_sym_else] = ACTIONS(1330),
    [anon_sym_switch] = ACTIONS(1330),
    [anon_sym_case] = ACTIONS(1330),
    [anon_sym_default] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1330),
    [anon_sym_do] = ACTIONS(1330),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_return] = ACTIONS(1330),
    [anon_sym_break] = ACTIONS(1330),
    [anon_sym_continue] = ACTIONS(1330),
    [anon_sym_goto] = ACTIONS(1330),
    [anon_sym___try] = ACTIONS(1330),
    [anon_sym___leave] = ACTIONS(1330),
    [anon_sym_DASH_DASH] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(1332),
    [anon_sym_sizeof] = ACTIONS(1330),
    [anon_sym___alignof__] = ACTIONS(1330),
    [anon_sym___alignof] = ACTIONS(1330),
    [anon_sym__alignof] = ACTIONS(1330),
    [anon_sym_alignof] = ACTIONS(1330),
    [anon_sym__Alignof] = ACTIONS(1330),
    [anon_sym_offsetof] = ACTIONS(1330),
    [anon_sym__Generic] = ACTIONS(1330),
    [anon_sym_asm] = ACTIONS(1330),
    [anon_sym___asm__] = ACTIONS(1330),
    [sym_number_literal] = ACTIONS(1332),
    [anon_sym_L_SQUOTE] = ACTIONS(1332),
    [anon_sym_u_SQUOTE] = ACTIONS(1332),
    [anon_sym_U_SQUOTE] = ACTIONS(1332),
    [anon_sym_u8_SQUOTE] = ACTIONS(1332),
    [anon_sym_SQUOTE] = ACTIONS(1332),
    [anon_sym_L_DQUOTE] = ACTIONS(1332),
    [anon_sym_u_DQUOTE] = ACTIONS(1332),
    [anon_sym_U_DQUOTE] = ACTIONS(1332),
    [anon_sym_u8_DQUOTE] = ACTIONS(1332),
    [anon_sym_DQUOTE] = ACTIONS(1332),
    [sym_true] = ACTIONS(1330),
    [sym_false] = ACTIONS(1330),
    [anon_sym_NULL] = ACTIONS(1330),
    [anon_sym_nullptr] = ACTIONS(1330),
    [sym_comment] = ACTIONS(3),
  },
  [311] = {
    [ts_builtin_sym_end] = ACTIONS(1352),
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [312] = {
    [sym_identifier] = ACTIONS(1326),
    [aux_sym_preproc_include_token1] = ACTIONS(1326),
    [aux_sym_preproc_def_token1] = ACTIONS(1326),
    [aux_sym_preproc_if_token1] = ACTIONS(1326),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1326),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1326),
    [sym_preproc_directive] = ACTIONS(1326),
    [anon_sym_LPAREN2] = ACTIONS(1328),
    [anon_sym_BANG] = ACTIONS(1328),
    [anon_sym_TILDE] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_PLUS] = ACTIONS(1326),
    [anon_sym_STAR] = ACTIONS(1328),
    [anon_sym_AMP] = ACTIONS(1328),
    [anon_sym_SEMI] = ACTIONS(1328),
    [anon_sym___extension__] = ACTIONS(1326),
    [anon_sym_typedef] = ACTIONS(1326),
    [anon_sym_extern] = ACTIONS(1326),
    [anon_sym___attribute__] = ACTIONS(1326),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1328),
    [anon_sym___declspec] = ACTIONS(1326),
    [anon_sym___cdecl] = ACTIONS(1326),
    [anon_sym___clrcall] = ACTIONS(1326),
    [anon_sym___stdcall] = ACTIONS(1326),
    [anon_sym___fastcall] = ACTIONS(1326),
    [anon_sym___thiscall] = ACTIONS(1326),
    [anon_sym___vectorcall] = ACTIONS(1326),
    [anon_sym_LBRACE] = ACTIONS(1328),
    [anon_sym_RBRACE] = ACTIONS(1328),
    [anon_sym_signed] = ACTIONS(1326),
    [anon_sym_unsigned] = ACTIONS(1326),
    [anon_sym_long] = ACTIONS(1326),
    [anon_sym_short] = ACTIONS(1326),
    [anon_sym_static] = ACTIONS(1326),
    [anon_sym_auto] = ACTIONS(1326),
    [anon_sym_register] = ACTIONS(1326),
    [anon_sym_inline] = ACTIONS(1326),
    [anon_sym___inline] = ACTIONS(1326),
    [anon_sym___inline__] = ACTIONS(1326),
    [anon_sym___forceinline] = ACTIONS(1326),
    [anon_sym_thread_local] = ACTIONS(1326),
    [anon_sym___thread] = ACTIONS(1326),
    [anon_sym_const] = ACTIONS(1326),
    [anon_sym_constexpr] = ACTIONS(1326),
    [anon_sym_volatile] = ACTIONS(1326),
    [anon_sym_restrict] = ACTIONS(1326),
    [anon_sym___restrict__] = ACTIONS(1326),
    [anon_sym__Atomic] = ACTIONS(1326),
    [anon_sym__Noreturn] = ACTIONS(1326),
    [anon_sym_noreturn] = ACTIONS(1326),
    [sym_primitive_type] = ACTIONS(1326),
    [anon_sym_enum] = ACTIONS(1326),
    [anon_sym_struct] = ACTIONS(1326),
    [anon_sym_union] = ACTIONS(1326),
    [anon_sym_if] = ACTIONS(1326),
    [anon_sym_else] = ACTIONS(1326),
    [anon_sym_switch] = ACTIONS(1326),
    [anon_sym_case] = ACTIONS(1326),
    [anon_sym_default] = ACTIONS(1326),
    [anon_sym_while] = ACTIONS(1326),
    [anon_sym_do] = ACTIONS(1326),
    [anon_sym_for] = ACTIONS(1326),
    [anon_sym_return] = ACTIONS(1326),
    [anon_sym_break] = ACTIONS(1326),
    [anon_sym_continue] = ACTIONS(1326),
    [anon_sym_goto] = ACTIONS(1326),
    [anon_sym___try] = ACTIONS(1326),
    [anon_sym___leave] = ACTIONS(1326),
    [anon_sym_DASH_DASH] = ACTIONS(1328),
    [anon_sym_PLUS_PLUS] = ACTIONS(1328),
    [anon_sym_sizeof] = ACTIONS(1326),
    [anon_sym___alignof__] = ACTIONS(1326),
    [anon_sym___alignof] = ACTIONS(1326),
    [anon_sym__alignof] = ACTIONS(1326),
    [anon_sym_alignof] = ACTIONS(1326),
    [anon_sym__Alignof] = ACTIONS(1326),
    [anon_sym_offsetof] = ACTIONS(1326),
    [anon_sym__Generic] = ACTIONS(1326),
    [anon_sym_asm] = ACTIONS(1326),
    [anon_sym___asm__] = ACTIONS(1326),
    [sym_number_literal] = ACTIONS(1328),
    [anon_sym_L_SQUOTE] = ACTIONS(1328),
    [anon_sym_u_SQUOTE] = ACTIONS(1328),
    [anon_sym_U_SQUOTE] = ACTIONS(1328),
    [anon_sym_u8_SQUOTE] = ACTIONS(1328),
    [anon_sym_SQUOTE] = ACTIONS(1328),
    [anon_sym_L_DQUOTE] = ACTIONS(1328),
    [anon_sym_u_DQUOTE] = ACTIONS(1328),
    [anon_sym_U_DQUOTE] = ACTIONS(1328),
    [anon_sym_u8_DQUOTE] = ACTIONS(1328),
    [anon_sym_DQUOTE] = ACTIONS(1328),
    [sym_true] = ACTIONS(1326),
    [sym_false] = ACTIONS(1326),
    [anon_sym_NULL] = ACTIONS(1326),
    [anon_sym_nullptr] = ACTIONS(1326),
    [sym_comment] = ACTIONS(3),
  },
  [313] = {
    [ts_builtin_sym_end] = ACTIONS(1352),
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [314] = {
    [ts_builtin_sym_end] = ACTIONS(1352),
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [315] = {
    [ts_builtin_sym_end] = ACTIONS(1336),
    [sym_identifier] = ACTIONS(1334),
    [aux_sym_preproc_include_token1] = ACTIONS(1334),
    [aux_sym_preproc_def_token1] = ACTIONS(1334),
    [aux_sym_preproc_if_token1] = ACTIONS(1334),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1334),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1334),
    [sym_preproc_directive] = ACTIONS(1334),
    [anon_sym_LPAREN2] = ACTIONS(1336),
    [anon_sym_BANG] = ACTIONS(1336),
    [anon_sym_TILDE] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_PLUS] = ACTIONS(1334),
    [anon_sym_STAR] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1336),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym___extension__] = ACTIONS(1334),
    [anon_sym_typedef] = ACTIONS(1334),
    [anon_sym_extern] = ACTIONS(1334),
    [anon_sym___attribute__] = ACTIONS(1334),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1336),
    [anon_sym___declspec] = ACTIONS(1334),
    [anon_sym___cdecl] = ACTIONS(1334),
    [anon_sym___clrcall] = ACTIONS(1334),
    [anon_sym___stdcall] = ACTIONS(1334),
    [anon_sym___fastcall] = ACTIONS(1334),
    [anon_sym___thiscall] = ACTIONS(1334),
    [anon_sym___vectorcall] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_signed] = ACTIONS(1334),
    [anon_sym_unsigned] = ACTIONS(1334),
    [anon_sym_long] = ACTIONS(1334),
    [anon_sym_short] = ACTIONS(1334),
    [anon_sym_static] = ACTIONS(1334),
    [anon_sym_auto] = ACTIONS(1334),
    [anon_sym_register] = ACTIONS(1334),
    [anon_sym_inline] = ACTIONS(1334),
    [anon_sym___inline] = ACTIONS(1334),
    [anon_sym___inline__] = ACTIONS(1334),
    [anon_sym___forceinline] = ACTIONS(1334),
    [anon_sym_thread_local] = ACTIONS(1334),
    [anon_sym___thread] = ACTIONS(1334),
    [anon_sym_const] = ACTIONS(1334),
    [anon_sym_constexpr] = ACTIONS(1334),
    [anon_sym_volatile] = ACTIONS(1334),
    [anon_sym_restrict] = ACTIONS(1334),
    [anon_sym___restrict__] = ACTIONS(1334),
    [anon_sym__Atomic] = ACTIONS(1334),
    [anon_sym__Noreturn] = ACTIONS(1334),
    [anon_sym_noreturn] = ACTIONS(1334),
    [sym_primitive_type] = ACTIONS(1334),
    [anon_sym_enum] = ACTIONS(1334),
    [anon_sym_struct] = ACTIONS(1334),
    [anon_sym_union] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1334),
    [anon_sym_else] = ACTIONS(1334),
    [anon_sym_switch] = ACTIONS(1334),
    [anon_sym_case] = ACTIONS(1334),
    [anon_sym_default] = ACTIONS(1334),
    [anon_sym_while] = ACTIONS(1334),
    [anon_sym_do] = ACTIONS(1334),
    [anon_sym_for] = ACTIONS(1334),
    [anon_sym_return] = ACTIONS(1334),
    [anon_sym_break] = ACTIONS(1334),
    [anon_sym_continue] = ACTIONS(1334),
    [anon_sym_goto] = ACTIONS(1334),
    [anon_sym___try] = ACTIONS(1334),
    [anon_sym___leave] = ACTIONS(1334),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_sizeof] = ACTIONS(1334),
    [anon_sym___alignof__] = ACTIONS(1334),
    [anon_sym___alignof] = ACTIONS(1334),
    [anon_sym__alignof] = ACTIONS(1334),
    [anon_sym_alignof] = ACTIONS(1334),
    [anon_sym__Alignof] = ACTIONS(1334),
    [anon_sym_offsetof] = ACTIONS(1334),
    [anon_sym__Generic] = ACTIONS(1334),
    [anon_sym_asm] = ACTIONS(1334),
    [anon_sym___asm__] = ACTIONS(1334),
    [sym_number_literal] = ACTIONS(1336),
    [anon_sym_L_SQUOTE] = ACTIONS(1336),
    [anon_sym_u_SQUOTE] = ACTIONS(1336),
    [anon_sym_U_SQUOTE] = ACTIONS(1336),
    [anon_sym_u8_SQUOTE] = ACTIONS(1336),
    [anon_sym_SQUOTE] = ACTIONS(1336),
    [anon_sym_L_DQUOTE] = ACTIONS(1336),
    [anon_sym_u_DQUOTE] = ACTIONS(1336),
    [anon_sym_U_DQUOTE] = ACTIONS(1336),
    [anon_sym_u8_DQUOTE] = ACTIONS(1336),
    [anon_sym_DQUOTE] = ACTIONS(1336),
    [sym_true] = ACTIONS(1334),
    [sym_false] = ACTIONS(1334),
    [anon_sym_NULL] = ACTIONS(1334),
    [anon_sym_nullptr] = ACTIONS(1334),
    [sym_comment] = ACTIONS(3),
  },
  [316] = {
    [ts_builtin_sym_end] = ACTIONS(1352),
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [317] = {
    [ts_builtin_sym_end] = ACTIONS(1352),
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [318] = {
    [ts_builtin_sym_end] = ACTIONS(1352),
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [319] = {
    [sym_identifier] = ACTIONS(1394),
    [aux_sym_preproc_include_token1] = ACTIONS(1394),
    [aux_sym_preproc_def_token1] = ACTIONS(1394),
    [aux_sym_preproc_if_token1] = ACTIONS(1394),
    [aux_sym_preproc_if_token2] = ACTIONS(1394),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1394),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1394),
    [sym_preproc_directive] = ACTIONS(1394),
    [anon_sym_LPAREN2] = ACTIONS(1396),
    [anon_sym_BANG] = ACTIONS(1396),
    [anon_sym_TILDE] = ACTIONS(1396),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_PLUS] = ACTIONS(1394),
    [anon_sym_STAR] = ACTIONS(1396),
    [anon_sym_AMP] = ACTIONS(1396),
    [anon_sym_SEMI] = ACTIONS(1396),
    [anon_sym___extension__] = ACTIONS(1394),
    [anon_sym_typedef] = ACTIONS(1394),
    [anon_sym_extern] = ACTIONS(1394),
    [anon_sym___attribute__] = ACTIONS(1394),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1396),
    [anon_sym___declspec] = ACTIONS(1394),
    [anon_sym___cdecl] = ACTIONS(1394),
    [anon_sym___clrcall] = ACTIONS(1394),
    [anon_sym___stdcall] = ACTIONS(1394),
    [anon_sym___fastcall] = ACTIONS(1394),
    [anon_sym___thiscall] = ACTIONS(1394),
    [anon_sym___vectorcall] = ACTIONS(1394),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_signed] = ACTIONS(1394),
    [anon_sym_unsigned] = ACTIONS(1394),
    [anon_sym_long] = ACTIONS(1394),
    [anon_sym_short] = ACTIONS(1394),
    [anon_sym_static] = ACTIONS(1394),
    [anon_sym_auto] = ACTIONS(1394),
    [anon_sym_register] = ACTIONS(1394),
    [anon_sym_inline] = ACTIONS(1394),
    [anon_sym___inline] = ACTIONS(1394),
    [anon_sym___inline__] = ACTIONS(1394),
    [anon_sym___forceinline] = ACTIONS(1394),
    [anon_sym_thread_local] = ACTIONS(1394),
    [anon_sym___thread] = ACTIONS(1394),
    [anon_sym_const] = ACTIONS(1394),
    [anon_sym_constexpr] = ACTIONS(1394),
    [anon_sym_volatile] = ACTIONS(1394),
    [anon_sym_restrict] = ACTIONS(1394),
    [anon_sym___restrict__] = ACTIONS(1394),
    [anon_sym__Atomic] = ACTIONS(1394),
    [anon_sym__Noreturn] = ACTIONS(1394),
    [anon_sym_noreturn] = ACTIONS(1394),
    [sym_primitive_type] = ACTIONS(1394),
    [anon_sym_enum] = ACTIONS(1394),
    [anon_sym_struct] = ACTIONS(1394),
    [anon_sym_union] = ACTIONS(1394),
    [anon_sym_if] = ACTIONS(1394),
    [anon_sym_else] = ACTIONS(1394),
    [anon_sym_switch] = ACTIONS(1394),
    [anon_sym_case] = ACTIONS(1394),
    [anon_sym_default] = ACTIONS(1394),
    [anon_sym_while] = ACTIONS(1394),
    [anon_sym_do] = ACTIONS(1394),
    [anon_sym_for] = ACTIONS(1394),
    [anon_sym_return] = ACTIONS(1394),
    [anon_sym_break] = ACTIONS(1394),
    [anon_sym_continue] = ACTIONS(1394),
    [anon_sym_goto] = ACTIONS(1394),
    [anon_sym___try] = ACTIONS(1394),
    [anon_sym___leave] = ACTIONS(1394),
    [anon_sym_DASH_DASH] = ACTIONS(1396),
    [anon_sym_PLUS_PLUS] = ACTIONS(1396),
    [anon_sym_sizeof] = ACTIONS(1394),
    [anon_sym___alignof__] = ACTIONS(1394),
    [anon_sym___alignof] = ACTIONS(1394),
    [anon_sym__alignof] = ACTIONS(1394),
    [anon_sym_alignof] = ACTIONS(1394),
    [anon_sym__Alignof] = ACTIONS(1394),
    [anon_sym_offsetof] = ACTIONS(1394),
    [anon_sym__Generic] = ACTIONS(1394),
    [anon_sym_asm] = ACTIONS(1394),
    [anon_sym___asm__] = ACTIONS(1394),
    [sym_number_literal] = ACTIONS(1396),
    [anon_sym_L_SQUOTE] = ACTIONS(1396),
    [anon_sym_u_SQUOTE] = ACTIONS(1396),
    [anon_sym_U_SQUOTE] = ACTIONS(1396),
    [anon_sym_u8_SQUOTE] = ACTIONS(1396),
    [anon_sym_SQUOTE] = ACTIONS(1396),
    [anon_sym_L_DQUOTE] = ACTIONS(1396),
    [anon_sym_u_DQUOTE] = ACTIONS(1396),
    [anon_sym_U_DQUOTE] = ACTIONS(1396),
    [anon_sym_u8_DQUOTE] = ACTIONS(1396),
    [anon_sym_DQUOTE] = ACTIONS(1396),
    [sym_true] = ACTIONS(1394),
    [sym_false] = ACTIONS(1394),
    [anon_sym_NULL] = ACTIONS(1394),
    [anon_sym_nullptr] = ACTIONS(1394),
    [sym_comment] = ACTIONS(3),
  },
  [320] = {
    [sym_identifier] = ACTIONS(1356),
    [aux_sym_preproc_include_token1] = ACTIONS(1356),
    [aux_sym_preproc_def_token1] = ACTIONS(1356),
    [aux_sym_preproc_if_token1] = ACTIONS(1356),
    [aux_sym_preproc_if_token2] = ACTIONS(1356),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1356),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1356),
    [sym_preproc_directive] = ACTIONS(1356),
    [anon_sym_LPAREN2] = ACTIONS(1354),
    [anon_sym_BANG] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(1354),
    [anon_sym_DASH] = ACTIONS(1356),
    [anon_sym_PLUS] = ACTIONS(1356),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_AMP] = ACTIONS(1354),
    [anon_sym_SEMI] = ACTIONS(1354),
    [anon_sym___extension__] = ACTIONS(1356),
    [anon_sym_typedef] = ACTIONS(1356),
    [anon_sym_extern] = ACTIONS(1356),
    [anon_sym___attribute__] = ACTIONS(1356),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1354),
    [anon_sym___declspec] = ACTIONS(1356),
    [anon_sym___cdecl] = ACTIONS(1356),
    [anon_sym___clrcall] = ACTIONS(1356),
    [anon_sym___stdcall] = ACTIONS(1356),
    [anon_sym___fastcall] = ACTIONS(1356),
    [anon_sym___thiscall] = ACTIONS(1356),
    [anon_sym___vectorcall] = ACTIONS(1356),
    [anon_sym_LBRACE] = ACTIONS(1354),
    [anon_sym_signed] = ACTIONS(1356),
    [anon_sym_unsigned] = ACTIONS(1356),
    [anon_sym_long] = ACTIONS(1356),
    [anon_sym_short] = ACTIONS(1356),
    [anon_sym_static] = ACTIONS(1356),
    [anon_sym_auto] = ACTIONS(1356),
    [anon_sym_register] = ACTIONS(1356),
    [anon_sym_inline] = ACTIONS(1356),
    [anon_sym___inline] = ACTIONS(1356),
    [anon_sym___inline__] = ACTIONS(1356),
    [anon_sym___forceinline] = ACTIONS(1356),
    [anon_sym_thread_local] = ACTIONS(1356),
    [anon_sym___thread] = ACTIONS(1356),
    [anon_sym_const] = ACTIONS(1356),
    [anon_sym_constexpr] = ACTIONS(1356),
    [anon_sym_volatile] = ACTIONS(1356),
    [anon_sym_restrict] = ACTIONS(1356),
    [anon_sym___restrict__] = ACTIONS(1356),
    [anon_sym__Atomic] = ACTIONS(1356),
    [anon_sym__Noreturn] = ACTIONS(1356),
    [anon_sym_noreturn] = ACTIONS(1356),
    [sym_primitive_type] = ACTIONS(1356),
    [anon_sym_enum] = ACTIONS(1356),
    [anon_sym_struct] = ACTIONS(1356),
    [anon_sym_union] = ACTIONS(1356),
    [anon_sym_if] = ACTIONS(1356),
    [anon_sym_else] = ACTIONS(1356),
    [anon_sym_switch] = ACTIONS(1356),
    [anon_sym_case] = ACTIONS(1356),
    [anon_sym_default] = ACTIONS(1356),
    [anon_sym_while] = ACTIONS(1356),
    [anon_sym_do] = ACTIONS(1356),
    [anon_sym_for] = ACTIONS(1356),
    [anon_sym_return] = ACTIONS(1356),
    [anon_sym_break] = ACTIONS(1356),
    [anon_sym_continue] = ACTIONS(1356),
    [anon_sym_goto] = ACTIONS(1356),
    [anon_sym___try] = ACTIONS(1356),
    [anon_sym___leave] = ACTIONS(1356),
    [anon_sym_DASH_DASH] = ACTIONS(1354),
    [anon_sym_PLUS_PLUS] = ACTIONS(1354),
    [anon_sym_sizeof] = ACTIONS(1356),
    [anon_sym___alignof__] = ACTIONS(1356),
    [anon_sym___alignof] = ACTIONS(1356),
    [anon_sym__alignof] = ACTIONS(1356),
    [anon_sym_alignof] = ACTIONS(1356),
    [anon_sym__Alignof] = ACTIONS(1356),
    [anon_sym_offsetof] = ACTIONS(1356),
    [anon_sym__Generic] = ACTIONS(1356),
    [anon_sym_asm] = ACTIONS(1356),
    [anon_sym___asm__] = ACTIONS(1356),
    [sym_number_literal] = ACTIONS(1354),
    [anon_sym_L_SQUOTE] = ACTIONS(1354),
    [anon_sym_u_SQUOTE] = ACTIONS(1354),
    [anon_sym_U_SQUOTE] = ACTIONS(1354),
    [anon_sym_u8_SQUOTE] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(1354),
    [anon_sym_L_DQUOTE] = ACTIONS(1354),
    [anon_sym_u_DQUOTE] = ACTIONS(1354),
    [anon_sym_U_DQUOTE] = ACTIONS(1354),
    [anon_sym_u8_DQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1354),
    [sym_true] = ACTIONS(1356),
    [sym_false] = ACTIONS(1356),
    [anon_sym_NULL] = ACTIONS(1356),
    [anon_sym_nullptr] = ACTIONS(1356),
    [sym_comment] = ACTIONS(3),
  },
  [321] = {
    [sym_identifier] = ACTIONS(1366),
    [aux_sym_preproc_include_token1] = ACTIONS(1366),
    [aux_sym_preproc_def_token1] = ACTIONS(1366),
    [aux_sym_preproc_if_token1] = ACTIONS(1366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1366),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1366),
    [sym_preproc_directive] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_BANG] = ACTIONS(1368),
    [anon_sym_TILDE] = ACTIONS(1368),
    [anon_sym_DASH] = ACTIONS(1366),
    [anon_sym_PLUS] = ACTIONS(1366),
    [anon_sym_STAR] = ACTIONS(1368),
    [anon_sym_AMP] = ACTIONS(1368),
    [anon_sym_SEMI] = ACTIONS(1368),
    [anon_sym___extension__] = ACTIONS(1366),
    [anon_sym_typedef] = ACTIONS(1366),
    [anon_sym_extern] = ACTIONS(1366),
    [anon_sym___attribute__] = ACTIONS(1366),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1368),
    [anon_sym___declspec] = ACTIONS(1366),
    [anon_sym___cdecl] = ACTIONS(1366),
    [anon_sym___clrcall] = ACTIONS(1366),
    [anon_sym___stdcall] = ACTIONS(1366),
    [anon_sym___fastcall] = ACTIONS(1366),
    [anon_sym___thiscall] = ACTIONS(1366),
    [anon_sym___vectorcall] = ACTIONS(1366),
    [anon_sym_LBRACE] = ACTIONS(1368),
    [anon_sym_RBRACE] = ACTIONS(1368),
    [anon_sym_signed] = ACTIONS(1366),
    [anon_sym_unsigned] = ACTIONS(1366),
    [anon_sym_long] = ACTIONS(1366),
    [anon_sym_short] = ACTIONS(1366),
    [anon_sym_static] = ACTIONS(1366),
    [anon_sym_auto] = ACTIONS(1366),
    [anon_sym_register] = ACTIONS(1366),
    [anon_sym_inline] = ACTIONS(1366),
    [anon_sym___inline] = ACTIONS(1366),
    [anon_sym___inline__] = ACTIONS(1366),
    [anon_sym___forceinline] = ACTIONS(1366),
    [anon_sym_thread_local] = ACTIONS(1366),
    [anon_sym___thread] = ACTIONS(1366),
    [anon_sym_const] = ACTIONS(1366),
    [anon_sym_constexpr] = ACTIONS(1366),
    [anon_sym_volatile] = ACTIONS(1366),
    [anon_sym_restrict] = ACTIONS(1366),
    [anon_sym___restrict__] = ACTIONS(1366),
    [anon_sym__Atomic] = ACTIONS(1366),
    [anon_sym__Noreturn] = ACTIONS(1366),
    [anon_sym_noreturn] = ACTIONS(1366),
    [sym_primitive_type] = ACTIONS(1366),
    [anon_sym_enum] = ACTIONS(1366),
    [anon_sym_struct] = ACTIONS(1366),
    [anon_sym_union] = ACTIONS(1366),
    [anon_sym_if] = ACTIONS(1366),
    [anon_sym_else] = ACTIONS(1366),
    [anon_sym_switch] = ACTIONS(1366),
    [anon_sym_case] = ACTIONS(1366),
    [anon_sym_default] = ACTIONS(1366),
    [anon_sym_while] = ACTIONS(1366),
    [anon_sym_do] = ACTIONS(1366),
    [anon_sym_for] = ACTIONS(1366),
    [anon_sym_return] = ACTIONS(1366),
    [anon_sym_break] = ACTIONS(1366),
    [anon_sym_continue] = ACTIONS(1366),
    [anon_sym_goto] = ACTIONS(1366),
    [anon_sym___try] = ACTIONS(1366),
    [anon_sym___leave] = ACTIONS(1366),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_sizeof] = ACTIONS(1366),
    [anon_sym___alignof__] = ACTIONS(1366),
    [anon_sym___alignof] = ACTIONS(1366),
    [anon_sym__alignof] = ACTIONS(1366),
    [anon_sym_alignof] = ACTIONS(1366),
    [anon_sym__Alignof] = ACTIONS(1366),
    [anon_sym_offsetof] = ACTIONS(1366),
    [anon_sym__Generic] = ACTIONS(1366),
    [anon_sym_asm] = ACTIONS(1366),
    [anon_sym___asm__] = ACTIONS(1366),
    [sym_number_literal] = ACTIONS(1368),
    [anon_sym_L_SQUOTE] = ACTIONS(1368),
    [anon_sym_u_SQUOTE] = ACTIONS(1368),
    [anon_sym_U_SQUOTE] = ACTIONS(1368),
    [anon_sym_u8_SQUOTE] = ACTIONS(1368),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_L_DQUOTE] = ACTIONS(1368),
    [anon_sym_u_DQUOTE] = ACTIONS(1368),
    [anon_sym_U_DQUOTE] = ACTIONS(1368),
    [anon_sym_u8_DQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [sym_true] = ACTIONS(1366),
    [sym_false] = ACTIONS(1366),
    [anon_sym_NULL] = ACTIONS(1366),
    [anon_sym_nullptr] = ACTIONS(1366),
    [sym_comment] = ACTIONS(3),
  },
  [322] = {
    [sym_identifier] = ACTIONS(1362),
    [aux_sym_preproc_include_token1] = ACTIONS(1362),
    [aux_sym_preproc_def_token1] = ACTIONS(1362),
    [aux_sym_preproc_if_token1] = ACTIONS(1362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1362),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1362),
    [sym_preproc_directive] = ACTIONS(1362),
    [anon_sym_LPAREN2] = ACTIONS(1364),
    [anon_sym_BANG] = ACTIONS(1364),
    [anon_sym_TILDE] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_STAR] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_SEMI] = ACTIONS(1364),
    [anon_sym___extension__] = ACTIONS(1362),
    [anon_sym_typedef] = ACTIONS(1362),
    [anon_sym_extern] = ACTIONS(1362),
    [anon_sym___attribute__] = ACTIONS(1362),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1364),
    [anon_sym___declspec] = ACTIONS(1362),
    [anon_sym___cdecl] = ACTIONS(1362),
    [anon_sym___clrcall] = ACTIONS(1362),
    [anon_sym___stdcall] = ACTIONS(1362),
    [anon_sym___fastcall] = ACTIONS(1362),
    [anon_sym___thiscall] = ACTIONS(1362),
    [anon_sym___vectorcall] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(1364),
    [anon_sym_RBRACE] = ACTIONS(1364),
    [anon_sym_signed] = ACTIONS(1362),
    [anon_sym_unsigned] = ACTIONS(1362),
    [anon_sym_long] = ACTIONS(1362),
    [anon_sym_short] = ACTIONS(1362),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_auto] = ACTIONS(1362),
    [anon_sym_register] = ACTIONS(1362),
    [anon_sym_inline] = ACTIONS(1362),
    [anon_sym___inline] = ACTIONS(1362),
    [anon_sym___inline__] = ACTIONS(1362),
    [anon_sym___forceinline] = ACTIONS(1362),
    [anon_sym_thread_local] = ACTIONS(1362),
    [anon_sym___thread] = ACTIONS(1362),
    [anon_sym_const] = ACTIONS(1362),
    [anon_sym_constexpr] = ACTIONS(1362),
    [anon_sym_volatile] = ACTIONS(1362),
    [anon_sym_restrict] = ACTIONS(1362),
    [anon_sym___restrict__] = ACTIONS(1362),
    [anon_sym__Atomic] = ACTIONS(1362),
    [anon_sym__Noreturn] = ACTIONS(1362),
    [anon_sym_noreturn] = ACTIONS(1362),
    [sym_primitive_type] = ACTIONS(1362),
    [anon_sym_enum] = ACTIONS(1362),
    [anon_sym_struct] = ACTIONS(1362),
    [anon_sym_union] = ACTIONS(1362),
    [anon_sym_if] = ACTIONS(1362),
    [anon_sym_else] = ACTIONS(1362),
    [anon_sym_switch] = ACTIONS(1362),
    [anon_sym_case] = ACTIONS(1362),
    [anon_sym_default] = ACTIONS(1362),
    [anon_sym_while] = ACTIONS(1362),
    [anon_sym_do] = ACTIONS(1362),
    [anon_sym_for] = ACTIONS(1362),
    [anon_sym_return] = ACTIONS(1362),
    [anon_sym_break] = ACTIONS(1362),
    [anon_sym_continue] = ACTIONS(1362),
    [anon_sym_goto] = ACTIONS(1362),
    [anon_sym___try] = ACTIONS(1362),
    [anon_sym___leave] = ACTIONS(1362),
    [anon_sym_DASH_DASH] = ACTIONS(1364),
    [anon_sym_PLUS_PLUS] = ACTIONS(1364),
    [anon_sym_sizeof] = ACTIONS(1362),
    [anon_sym___alignof__] = ACTIONS(1362),
    [anon_sym___alignof] = ACTIONS(1362),
    [anon_sym__alignof] = ACTIONS(1362),
    [anon_sym_alignof] = ACTIONS(1362),
    [anon_sym__Alignof] = ACTIONS(1362),
    [anon_sym_offsetof] = ACTIONS(1362),
    [anon_sym__Generic] = ACTIONS(1362),
    [anon_sym_asm] = ACTIONS(1362),
    [anon_sym___asm__] = ACTIONS(1362),
    [sym_number_literal] = ACTIONS(1364),
    [anon_sym_L_SQUOTE] = ACTIONS(1364),
    [anon_sym_u_SQUOTE] = ACTIONS(1364),
    [anon_sym_U_SQUOTE] = ACTIONS(1364),
    [anon_sym_u8_SQUOTE] = ACTIONS(1364),
    [anon_sym_SQUOTE] = ACTIONS(1364),
    [anon_sym_L_DQUOTE] = ACTIONS(1364),
    [anon_sym_u_DQUOTE] = ACTIONS(1364),
    [anon_sym_U_DQUOTE] = ACTIONS(1364),
    [anon_sym_u8_DQUOTE] = ACTIONS(1364),
    [anon_sym_DQUOTE] = ACTIONS(1364),
    [sym_true] = ACTIONS(1362),
    [sym_false] = ACTIONS(1362),
    [anon_sym_NULL] = ACTIONS(1362),
    [anon_sym_nullptr] = ACTIONS(1362),
    [sym_comment] = ACTIONS(3),
  },
  [323] = {
    [sym_identifier] = ACTIONS(1306),
    [aux_sym_preproc_include_token1] = ACTIONS(1306),
    [aux_sym_preproc_def_token1] = ACTIONS(1306),
    [aux_sym_preproc_if_token1] = ACTIONS(1306),
    [aux_sym_preproc_if_token2] = ACTIONS(1306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1306),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1306),
    [sym_preproc_directive] = ACTIONS(1306),
    [anon_sym_LPAREN2] = ACTIONS(1308),
    [anon_sym_BANG] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(1308),
    [anon_sym_DASH] = ACTIONS(1306),
    [anon_sym_PLUS] = ACTIONS(1306),
    [anon_sym_STAR] = ACTIONS(1308),
    [anon_sym_AMP] = ACTIONS(1308),
    [anon_sym_SEMI] = ACTIONS(1308),
    [anon_sym___extension__] = ACTIONS(1306),
    [anon_sym_typedef] = ACTIONS(1306),
    [anon_sym_extern] = ACTIONS(1306),
    [anon_sym___attribute__] = ACTIONS(1306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1308),
    [anon_sym___declspec] = ACTIONS(1306),
    [anon_sym___cdecl] = ACTIONS(1306),
    [anon_sym___clrcall] = ACTIONS(1306),
    [anon_sym___stdcall] = ACTIONS(1306),
    [anon_sym___fastcall] = ACTIONS(1306),
    [anon_sym___thiscall] = ACTIONS(1306),
    [anon_sym___vectorcall] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(1308),
    [anon_sym_signed] = ACTIONS(1306),
    [anon_sym_unsigned] = ACTIONS(1306),
    [anon_sym_long] = ACTIONS(1306),
    [anon_sym_short] = ACTIONS(1306),
    [anon_sym_static] = ACTIONS(1306),
    [anon_sym_auto] = ACTIONS(1306),
    [anon_sym_register] = ACTIONS(1306),
    [anon_sym_inline] = ACTIONS(1306),
    [anon_sym___inline] = ACTIONS(1306),
    [anon_sym___inline__] = ACTIONS(1306),
    [anon_sym___forceinline] = ACTIONS(1306),
    [anon_sym_thread_local] = ACTIONS(1306),
    [anon_sym___thread] = ACTIONS(1306),
    [anon_sym_const] = ACTIONS(1306),
    [anon_sym_constexpr] = ACTIONS(1306),
    [anon_sym_volatile] = ACTIONS(1306),
    [anon_sym_restrict] = ACTIONS(1306),
    [anon_sym___restrict__] = ACTIONS(1306),
    [anon_sym__Atomic] = ACTIONS(1306),
    [anon_sym__Noreturn] = ACTIONS(1306),
    [anon_sym_noreturn] = ACTIONS(1306),
    [sym_primitive_type] = ACTIONS(1306),
    [anon_sym_enum] = ACTIONS(1306),
    [anon_sym_struct] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1306),
    [anon_sym_if] = ACTIONS(1306),
    [anon_sym_else] = ACTIONS(1306),
    [anon_sym_switch] = ACTIONS(1306),
    [anon_sym_case] = ACTIONS(1306),
    [anon_sym_default] = ACTIONS(1306),
    [anon_sym_while] = ACTIONS(1306),
    [anon_sym_do] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1306),
    [anon_sym_break] = ACTIONS(1306),
    [anon_sym_continue] = ACTIONS(1306),
    [anon_sym_goto] = ACTIONS(1306),
    [anon_sym___try] = ACTIONS(1306),
    [anon_sym___leave] = ACTIONS(1306),
    [anon_sym_DASH_DASH] = ACTIONS(1308),
    [anon_sym_PLUS_PLUS] = ACTIONS(1308),
    [anon_sym_sizeof] = ACTIONS(1306),
    [anon_sym___alignof__] = ACTIONS(1306),
    [anon_sym___alignof] = ACTIONS(1306),
    [anon_sym__alignof] = ACTIONS(1306),
    [anon_sym_alignof] = ACTIONS(1306),
    [anon_sym__Alignof] = ACTIONS(1306),
    [anon_sym_offsetof] = ACTIONS(1306),
    [anon_sym__Generic] = ACTIONS(1306),
    [anon_sym_asm] = ACTIONS(1306),
    [anon_sym___asm__] = ACTIONS(1306),
    [sym_number_literal] = ACTIONS(1308),
    [anon_sym_L_SQUOTE] = ACTIONS(1308),
    [anon_sym_u_SQUOTE] = ACTIONS(1308),
    [anon_sym_U_SQUOTE] = ACTIONS(1308),
    [anon_sym_u8_SQUOTE] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(1308),
    [anon_sym_L_DQUOTE] = ACTIONS(1308),
    [anon_sym_u_DQUOTE] = ACTIONS(1308),
    [anon_sym_U_DQUOTE] = ACTIONS(1308),
    [anon_sym_u8_DQUOTE] = ACTIONS(1308),
    [anon_sym_DQUOTE] = ACTIONS(1308),
    [sym_true] = ACTIONS(1306),
    [sym_false] = ACTIONS(1306),
    [anon_sym_NULL] = ACTIONS(1306),
    [anon_sym_nullptr] = ACTIONS(1306),
    [sym_comment] = ACTIONS(3),
  },
  [324] = {
    [sym_identifier] = ACTIONS(1358),
    [aux_sym_preproc_include_token1] = ACTIONS(1358),
    [aux_sym_preproc_def_token1] = ACTIONS(1358),
    [aux_sym_preproc_if_token1] = ACTIONS(1358),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1358),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1358),
    [sym_preproc_directive] = ACTIONS(1358),
    [anon_sym_LPAREN2] = ACTIONS(1360),
    [anon_sym_BANG] = ACTIONS(1360),
    [anon_sym_TILDE] = ACTIONS(1360),
    [anon_sym_DASH] = ACTIONS(1358),
    [anon_sym_PLUS] = ACTIONS(1358),
    [anon_sym_STAR] = ACTIONS(1360),
    [anon_sym_AMP] = ACTIONS(1360),
    [anon_sym_SEMI] = ACTIONS(1360),
    [anon_sym___extension__] = ACTIONS(1358),
    [anon_sym_typedef] = ACTIONS(1358),
    [anon_sym_extern] = ACTIONS(1358),
    [anon_sym___attribute__] = ACTIONS(1358),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1360),
    [anon_sym___declspec] = ACTIONS(1358),
    [anon_sym___cdecl] = ACTIONS(1358),
    [anon_sym___clrcall] = ACTIONS(1358),
    [anon_sym___stdcall] = ACTIONS(1358),
    [anon_sym___fastcall] = ACTIONS(1358),
    [anon_sym___thiscall] = ACTIONS(1358),
    [anon_sym___vectorcall] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_RBRACE] = ACTIONS(1360),
    [anon_sym_signed] = ACTIONS(1358),
    [anon_sym_unsigned] = ACTIONS(1358),
    [anon_sym_long] = ACTIONS(1358),
    [anon_sym_short] = ACTIONS(1358),
    [anon_sym_static] = ACTIONS(1358),
    [anon_sym_auto] = ACTIONS(1358),
    [anon_sym_register] = ACTIONS(1358),
    [anon_sym_inline] = ACTIONS(1358),
    [anon_sym___inline] = ACTIONS(1358),
    [anon_sym___inline__] = ACTIONS(1358),
    [anon_sym___forceinline] = ACTIONS(1358),
    [anon_sym_thread_local] = ACTIONS(1358),
    [anon_sym___thread] = ACTIONS(1358),
    [anon_sym_const] = ACTIONS(1358),
    [anon_sym_constexpr] = ACTIONS(1358),
    [anon_sym_volatile] = ACTIONS(1358),
    [anon_sym_restrict] = ACTIONS(1358),
    [anon_sym___restrict__] = ACTIONS(1358),
    [anon_sym__Atomic] = ACTIONS(1358),
    [anon_sym__Noreturn] = ACTIONS(1358),
    [anon_sym_noreturn] = ACTIONS(1358),
    [sym_primitive_type] = ACTIONS(1358),
    [anon_sym_enum] = ACTIONS(1358),
    [anon_sym_struct] = ACTIONS(1358),
    [anon_sym_union] = ACTIONS(1358),
    [anon_sym_if] = ACTIONS(1358),
    [anon_sym_else] = ACTIONS(1358),
    [anon_sym_switch] = ACTIONS(1358),
    [anon_sym_case] = ACTIONS(1358),
    [anon_sym_default] = ACTIONS(1358),
    [anon_sym_while] = ACTIONS(1358),
    [anon_sym_do] = ACTIONS(1358),
    [anon_sym_for] = ACTIONS(1358),
    [anon_sym_return] = ACTIONS(1358),
    [anon_sym_break] = ACTIONS(1358),
    [anon_sym_continue] = ACTIONS(1358),
    [anon_sym_goto] = ACTIONS(1358),
    [anon_sym___try] = ACTIONS(1358),
    [anon_sym___leave] = ACTIONS(1358),
    [anon_sym_DASH_DASH] = ACTIONS(1360),
    [anon_sym_PLUS_PLUS] = ACTIONS(1360),
    [anon_sym_sizeof] = ACTIONS(1358),
    [anon_sym___alignof__] = ACTIONS(1358),
    [anon_sym___alignof] = ACTIONS(1358),
    [anon_sym__alignof] = ACTIONS(1358),
    [anon_sym_alignof] = ACTIONS(1358),
    [anon_sym__Alignof] = ACTIONS(1358),
    [anon_sym_offsetof] = ACTIONS(1358),
    [anon_sym__Generic] = ACTIONS(1358),
    [anon_sym_asm] = ACTIONS(1358),
    [anon_sym___asm__] = ACTIONS(1358),
    [sym_number_literal] = ACTIONS(1360),
    [anon_sym_L_SQUOTE] = ACTIONS(1360),
    [anon_sym_u_SQUOTE] = ACTIONS(1360),
    [anon_sym_U_SQUOTE] = ACTIONS(1360),
    [anon_sym_u8_SQUOTE] = ACTIONS(1360),
    [anon_sym_SQUOTE] = ACTIONS(1360),
    [anon_sym_L_DQUOTE] = ACTIONS(1360),
    [anon_sym_u_DQUOTE] = ACTIONS(1360),
    [anon_sym_U_DQUOTE] = ACTIONS(1360),
    [anon_sym_u8_DQUOTE] = ACTIONS(1360),
    [anon_sym_DQUOTE] = ACTIONS(1360),
    [sym_true] = ACTIONS(1358),
    [sym_false] = ACTIONS(1358),
    [anon_sym_NULL] = ACTIONS(1358),
    [anon_sym_nullptr] = ACTIONS(1358),
    [sym_comment] = ACTIONS(3),
  },
  [325] = {
    [ts_builtin_sym_end] = ACTIONS(1392),
    [sym_identifier] = ACTIONS(1390),
    [aux_sym_preproc_include_token1] = ACTIONS(1390),
    [aux_sym_preproc_def_token1] = ACTIONS(1390),
    [aux_sym_preproc_if_token1] = ACTIONS(1390),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1390),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1390),
    [sym_preproc_directive] = ACTIONS(1390),
    [anon_sym_LPAREN2] = ACTIONS(1392),
    [anon_sym_BANG] = ACTIONS(1392),
    [anon_sym_TILDE] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_AMP] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1392),
    [anon_sym___extension__] = ACTIONS(1390),
    [anon_sym_typedef] = ACTIONS(1390),
    [anon_sym_extern] = ACTIONS(1390),
    [anon_sym___attribute__] = ACTIONS(1390),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1392),
    [anon_sym___declspec] = ACTIONS(1390),
    [anon_sym___cdecl] = ACTIONS(1390),
    [anon_sym___clrcall] = ACTIONS(1390),
    [anon_sym___stdcall] = ACTIONS(1390),
    [anon_sym___fastcall] = ACTIONS(1390),
    [anon_sym___thiscall] = ACTIONS(1390),
    [anon_sym___vectorcall] = ACTIONS(1390),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_signed] = ACTIONS(1390),
    [anon_sym_unsigned] = ACTIONS(1390),
    [anon_sym_long] = ACTIONS(1390),
    [anon_sym_short] = ACTIONS(1390),
    [anon_sym_static] = ACTIONS(1390),
    [anon_sym_auto] = ACTIONS(1390),
    [anon_sym_register] = ACTIONS(1390),
    [anon_sym_inline] = ACTIONS(1390),
    [anon_sym___inline] = ACTIONS(1390),
    [anon_sym___inline__] = ACTIONS(1390),
    [anon_sym___forceinline] = ACTIONS(1390),
    [anon_sym_thread_local] = ACTIONS(1390),
    [anon_sym___thread] = ACTIONS(1390),
    [anon_sym_const] = ACTIONS(1390),
    [anon_sym_constexpr] = ACTIONS(1390),
    [anon_sym_volatile] = ACTIONS(1390),
    [anon_sym_restrict] = ACTIONS(1390),
    [anon_sym___restrict__] = ACTIONS(1390),
    [anon_sym__Atomic] = ACTIONS(1390),
    [anon_sym__Noreturn] = ACTIONS(1390),
    [anon_sym_noreturn] = ACTIONS(1390),
    [sym_primitive_type] = ACTIONS(1390),
    [anon_sym_enum] = ACTIONS(1390),
    [anon_sym_struct] = ACTIONS(1390),
    [anon_sym_union] = ACTIONS(1390),
    [anon_sym_if] = ACTIONS(1390),
    [anon_sym_else] = ACTIONS(1390),
    [anon_sym_switch] = ACTIONS(1390),
    [anon_sym_case] = ACTIONS(1390),
    [anon_sym_default] = ACTIONS(1390),
    [anon_sym_while] = ACTIONS(1390),
    [anon_sym_do] = ACTIONS(1390),
    [anon_sym_for] = ACTIONS(1390),
    [anon_sym_return] = ACTIONS(1390),
    [anon_sym_break] = ACTIONS(1390),
    [anon_sym_continue] = ACTIONS(1390),
    [anon_sym_goto] = ACTIONS(1390),
    [anon_sym___try] = ACTIONS(1390),
    [anon_sym___leave] = ACTIONS(1390),
    [anon_sym_DASH_DASH] = ACTIONS(1392),
    [anon_sym_PLUS_PLUS] = ACTIONS(1392),
    [anon_sym_sizeof] = ACTIONS(1390),
    [anon_sym___alignof__] = ACTIONS(1390),
    [anon_sym___alignof] = ACTIONS(1390),
    [anon_sym__alignof] = ACTIONS(1390),
    [anon_sym_alignof] = ACTIONS(1390),
    [anon_sym__Alignof] = ACTIONS(1390),
    [anon_sym_offsetof] = ACTIONS(1390),
    [anon_sym__Generic] = ACTIONS(1390),
    [anon_sym_asm] = ACTIONS(1390),
    [anon_sym___asm__] = ACTIONS(1390),
    [sym_number_literal] = ACTIONS(1392),
    [anon_sym_L_SQUOTE] = ACTIONS(1392),
    [anon_sym_u_SQUOTE] = ACTIONS(1392),
    [anon_sym_U_SQUOTE] = ACTIONS(1392),
    [anon_sym_u8_SQUOTE] = ACTIONS(1392),
    [anon_sym_SQUOTE] = ACTIONS(1392),
    [anon_sym_L_DQUOTE] = ACTIONS(1392),
    [anon_sym_u_DQUOTE] = ACTIONS(1392),
    [anon_sym_U_DQUOTE] = ACTIONS(1392),
    [anon_sym_u8_DQUOTE] = ACTIONS(1392),
    [anon_sym_DQUOTE] = ACTIONS(1392),
    [sym_true] = ACTIONS(1390),
    [sym_false] = ACTIONS(1390),
    [anon_sym_NULL] = ACTIONS(1390),
    [anon_sym_nullptr] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
  },
  [326] = {
    [sym_identifier] = ACTIONS(1310),
    [aux_sym_preproc_include_token1] = ACTIONS(1310),
    [aux_sym_preproc_def_token1] = ACTIONS(1310),
    [aux_sym_preproc_if_token1] = ACTIONS(1310),
    [aux_sym_preproc_if_token2] = ACTIONS(1310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1310),
    [sym_preproc_directive] = ACTIONS(1310),
    [anon_sym_LPAREN2] = ACTIONS(1312),
    [anon_sym_BANG] = ACTIONS(1312),
    [anon_sym_TILDE] = ACTIONS(1312),
    [anon_sym_DASH] = ACTIONS(1310),
    [anon_sym_PLUS] = ACTIONS(1310),
    [anon_sym_STAR] = ACTIONS(1312),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_SEMI] = ACTIONS(1312),
    [anon_sym___extension__] = ACTIONS(1310),
    [anon_sym_typedef] = ACTIONS(1310),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym___attribute__] = ACTIONS(1310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1312),
    [anon_sym___declspec] = ACTIONS(1310),
    [anon_sym___cdecl] = ACTIONS(1310),
    [anon_sym___clrcall] = ACTIONS(1310),
    [anon_sym___stdcall] = ACTIONS(1310),
    [anon_sym___fastcall] = ACTIONS(1310),
    [anon_sym___thiscall] = ACTIONS(1310),
    [anon_sym___vectorcall] = ACTIONS(1310),
    [anon_sym_LBRACE] = ACTIONS(1312),
    [anon_sym_signed] = ACTIONS(1310),
    [anon_sym_unsigned] = ACTIONS(1310),
    [anon_sym_long] = ACTIONS(1310),
    [anon_sym_short] = ACTIONS(1310),
    [anon_sym_static] = ACTIONS(1310),
    [anon_sym_auto] = ACTIONS(1310),
    [anon_sym_register] = ACTIONS(1310),
    [anon_sym_inline] = ACTIONS(1310),
    [anon_sym___inline] = ACTIONS(1310),
    [anon_sym___inline__] = ACTIONS(1310),
    [anon_sym___forceinline] = ACTIONS(1310),
    [anon_sym_thread_local] = ACTIONS(1310),
    [anon_sym___thread] = ACTIONS(1310),
    [anon_sym_const] = ACTIONS(1310),
    [anon_sym_constexpr] = ACTIONS(1310),
    [anon_sym_volatile] = ACTIONS(1310),
    [anon_sym_restrict] = ACTIONS(1310),
    [anon_sym___restrict__] = ACTIONS(1310),
    [anon_sym__Atomic] = ACTIONS(1310),
    [anon_sym__Noreturn] = ACTIONS(1310),
    [anon_sym_noreturn] = ACTIONS(1310),
    [sym_primitive_type] = ACTIONS(1310),
    [anon_sym_enum] = ACTIONS(1310),
    [anon_sym_struct] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1310),
    [anon_sym_if] = ACTIONS(1310),
    [anon_sym_else] = ACTIONS(1310),
    [anon_sym_switch] = ACTIONS(1310),
    [anon_sym_case] = ACTIONS(1310),
    [anon_sym_default] = ACTIONS(1310),
    [anon_sym_while] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1310),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_break] = ACTIONS(1310),
    [anon_sym_continue] = ACTIONS(1310),
    [anon_sym_goto] = ACTIONS(1310),
    [anon_sym___try] = ACTIONS(1310),
    [anon_sym___leave] = ACTIONS(1310),
    [anon_sym_DASH_DASH] = ACTIONS(1312),
    [anon_sym_PLUS_PLUS] = ACTIONS(1312),
    [anon_sym_sizeof] = ACTIONS(1310),
    [anon_sym___alignof__] = ACTIONS(1310),
    [anon_sym___alignof] = ACTIONS(1310),
    [anon_sym__alignof] = ACTIONS(1310),
    [anon_sym_alignof] = ACTIONS(1310),
    [anon_sym__Alignof] = ACTIONS(1310),
    [anon_sym_offsetof] = ACTIONS(1310),
    [anon_sym__Generic] = ACTIONS(1310),
    [anon_sym_asm] = ACTIONS(1310),
    [anon_sym___asm__] = ACTIONS(1310),
    [sym_number_literal] = ACTIONS(1312),
    [anon_sym_L_SQUOTE] = ACTIONS(1312),
    [anon_sym_u_SQUOTE] = ACTIONS(1312),
    [anon_sym_U_SQUOTE] = ACTIONS(1312),
    [anon_sym_u8_SQUOTE] = ACTIONS(1312),
    [anon_sym_SQUOTE] = ACTIONS(1312),
    [anon_sym_L_DQUOTE] = ACTIONS(1312),
    [anon_sym_u_DQUOTE] = ACTIONS(1312),
    [anon_sym_U_DQUOTE] = ACTIONS(1312),
    [anon_sym_u8_DQUOTE] = ACTIONS(1312),
    [anon_sym_DQUOTE] = ACTIONS(1312),
    [sym_true] = ACTIONS(1310),
    [sym_false] = ACTIONS(1310),
    [anon_sym_NULL] = ACTIONS(1310),
    [anon_sym_nullptr] = ACTIONS(1310),
    [sym_comment] = ACTIONS(3),
  },
  [327] = {
    [sym_identifier] = ACTIONS(1314),
    [aux_sym_preproc_include_token1] = ACTIONS(1314),
    [aux_sym_preproc_def_token1] = ACTIONS(1314),
    [aux_sym_preproc_if_token1] = ACTIONS(1314),
    [aux_sym_preproc_if_token2] = ACTIONS(1314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1314),
    [sym_preproc_directive] = ACTIONS(1314),
    [anon_sym_LPAREN2] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1314),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym___extension__] = ACTIONS(1314),
    [anon_sym_typedef] = ACTIONS(1314),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym___attribute__] = ACTIONS(1314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1316),
    [anon_sym___declspec] = ACTIONS(1314),
    [anon_sym___cdecl] = ACTIONS(1314),
    [anon_sym___clrcall] = ACTIONS(1314),
    [anon_sym___stdcall] = ACTIONS(1314),
    [anon_sym___fastcall] = ACTIONS(1314),
    [anon_sym___thiscall] = ACTIONS(1314),
    [anon_sym___vectorcall] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_signed] = ACTIONS(1314),
    [anon_sym_unsigned] = ACTIONS(1314),
    [anon_sym_long] = ACTIONS(1314),
    [anon_sym_short] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_auto] = ACTIONS(1314),
    [anon_sym_register] = ACTIONS(1314),
    [anon_sym_inline] = ACTIONS(1314),
    [anon_sym___inline] = ACTIONS(1314),
    [anon_sym___inline__] = ACTIONS(1314),
    [anon_sym___forceinline] = ACTIONS(1314),
    [anon_sym_thread_local] = ACTIONS(1314),
    [anon_sym___thread] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_constexpr] = ACTIONS(1314),
    [anon_sym_volatile] = ACTIONS(1314),
    [anon_sym_restrict] = ACTIONS(1314),
    [anon_sym___restrict__] = ACTIONS(1314),
    [anon_sym__Atomic] = ACTIONS(1314),
    [anon_sym__Noreturn] = ACTIONS(1314),
    [anon_sym_noreturn] = ACTIONS(1314),
    [sym_primitive_type] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_else] = ACTIONS(1314),
    [anon_sym_switch] = ACTIONS(1314),
    [anon_sym_case] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [anon_sym_do] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_goto] = ACTIONS(1314),
    [anon_sym___try] = ACTIONS(1314),
    [anon_sym___leave] = ACTIONS(1314),
    [anon_sym_DASH_DASH] = ACTIONS(1316),
    [anon_sym_PLUS_PLUS] = ACTIONS(1316),
    [anon_sym_sizeof] = ACTIONS(1314),
    [anon_sym___alignof__] = ACTIONS(1314),
    [anon_sym___alignof] = ACTIONS(1314),
    [anon_sym__alignof] = ACTIONS(1314),
    [anon_sym_alignof] = ACTIONS(1314),
    [anon_sym__Alignof] = ACTIONS(1314),
    [anon_sym_offsetof] = ACTIONS(1314),
    [anon_sym__Generic] = ACTIONS(1314),
    [anon_sym_asm] = ACTIONS(1314),
    [anon_sym___asm__] = ACTIONS(1314),
    [sym_number_literal] = ACTIONS(1316),
    [anon_sym_L_SQUOTE] = ACTIONS(1316),
    [anon_sym_u_SQUOTE] = ACTIONS(1316),
    [anon_sym_U_SQUOTE] = ACTIONS(1316),
    [anon_sym_u8_SQUOTE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1316),
    [anon_sym_L_DQUOTE] = ACTIONS(1316),
    [anon_sym_u_DQUOTE] = ACTIONS(1316),
    [anon_sym_U_DQUOTE] = ACTIONS(1316),
    [anon_sym_u8_DQUOTE] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1316),
    [sym_true] = ACTIONS(1314),
    [sym_false] = ACTIONS(1314),
    [anon_sym_NULL] = ACTIONS(1314),
    [anon_sym_nullptr] = ACTIONS(1314),
    [sym_comment] = ACTIONS(3),
  },
  [328] = {
    [sym_identifier] = ACTIONS(1322),
    [aux_sym_preproc_include_token1] = ACTIONS(1322),
    [aux_sym_preproc_def_token1] = ACTIONS(1322),
    [aux_sym_preproc_if_token1] = ACTIONS(1322),
    [aux_sym_preproc_if_token2] = ACTIONS(1322),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1322),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1322),
    [sym_preproc_directive] = ACTIONS(1322),
    [anon_sym_LPAREN2] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(1324),
    [anon_sym_TILDE] = ACTIONS(1324),
    [anon_sym_DASH] = ACTIONS(1322),
    [anon_sym_PLUS] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(1324),
    [anon_sym_AMP] = ACTIONS(1324),
    [anon_sym_SEMI] = ACTIONS(1324),
    [anon_sym___extension__] = ACTIONS(1322),
    [anon_sym_typedef] = ACTIONS(1322),
    [anon_sym_extern] = ACTIONS(1322),
    [anon_sym___attribute__] = ACTIONS(1322),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1324),
    [anon_sym___declspec] = ACTIONS(1322),
    [anon_sym___cdecl] = ACTIONS(1322),
    [anon_sym___clrcall] = ACTIONS(1322),
    [anon_sym___stdcall] = ACTIONS(1322),
    [anon_sym___fastcall] = ACTIONS(1322),
    [anon_sym___thiscall] = ACTIONS(1322),
    [anon_sym___vectorcall] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_signed] = ACTIONS(1322),
    [anon_sym_unsigned] = ACTIONS(1322),
    [anon_sym_long] = ACTIONS(1322),
    [anon_sym_short] = ACTIONS(1322),
    [anon_sym_static] = ACTIONS(1322),
    [anon_sym_auto] = ACTIONS(1322),
    [anon_sym_register] = ACTIONS(1322),
    [anon_sym_inline] = ACTIONS(1322),
    [anon_sym___inline] = ACTIONS(1322),
    [anon_sym___inline__] = ACTIONS(1322),
    [anon_sym___forceinline] = ACTIONS(1322),
    [anon_sym_thread_local] = ACTIONS(1322),
    [anon_sym___thread] = ACTIONS(1322),
    [anon_sym_const] = ACTIONS(1322),
    [anon_sym_constexpr] = ACTIONS(1322),
    [anon_sym_volatile] = ACTIONS(1322),
    [anon_sym_restrict] = ACTIONS(1322),
    [anon_sym___restrict__] = ACTIONS(1322),
    [anon_sym__Atomic] = ACTIONS(1322),
    [anon_sym__Noreturn] = ACTIONS(1322),
    [anon_sym_noreturn] = ACTIONS(1322),
    [sym_primitive_type] = ACTIONS(1322),
    [anon_sym_enum] = ACTIONS(1322),
    [anon_sym_struct] = ACTIONS(1322),
    [anon_sym_union] = ACTIONS(1322),
    [anon_sym_if] = ACTIONS(1322),
    [anon_sym_else] = ACTIONS(1322),
    [anon_sym_switch] = ACTIONS(1322),
    [anon_sym_case] = ACTIONS(1322),
    [anon_sym_default] = ACTIONS(1322),
    [anon_sym_while] = ACTIONS(1322),
    [anon_sym_do] = ACTIONS(1322),
    [anon_sym_for] = ACTIONS(1322),
    [anon_sym_return] = ACTIONS(1322),
    [anon_sym_break] = ACTIONS(1322),
    [anon_sym_continue] = ACTIONS(1322),
    [anon_sym_goto] = ACTIONS(1322),
    [anon_sym___try] = ACTIONS(1322),
    [anon_sym___leave] = ACTIONS(1322),
    [anon_sym_DASH_DASH] = ACTIONS(1324),
    [anon_sym_PLUS_PLUS] = ACTIONS(1324),
    [anon_sym_sizeof] = ACTIONS(1322),
    [anon_sym___alignof__] = ACTIONS(1322),
    [anon_sym___alignof] = ACTIONS(1322),
    [anon_sym__alignof] = ACTIONS(1322),
    [anon_sym_alignof] = ACTIONS(1322),
    [anon_sym__Alignof] = ACTIONS(1322),
    [anon_sym_offsetof] = ACTIONS(1322),
    [anon_sym__Generic] = ACTIONS(1322),
    [anon_sym_asm] = ACTIONS(1322),
    [anon_sym___asm__] = ACTIONS(1322),
    [sym_number_literal] = ACTIONS(1324),
    [anon_sym_L_SQUOTE] = ACTIONS(1324),
    [anon_sym_u_SQUOTE] = ACTIONS(1324),
    [anon_sym_U_SQUOTE] = ACTIONS(1324),
    [anon_sym_u8_SQUOTE] = ACTIONS(1324),
    [anon_sym_SQUOTE] = ACTIONS(1324),
    [anon_sym_L_DQUOTE] = ACTIONS(1324),
    [anon_sym_u_DQUOTE] = ACTIONS(1324),
    [anon_sym_U_DQUOTE] = ACTIONS(1324),
    [anon_sym_u8_DQUOTE] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1324),
    [sym_true] = ACTIONS(1322),
    [sym_false] = ACTIONS(1322),
    [anon_sym_NULL] = ACTIONS(1322),
    [anon_sym_nullptr] = ACTIONS(1322),
    [sym_comment] = ACTIONS(3),
  },
  [329] = {
    [ts_builtin_sym_end] = ACTIONS(1380),
    [sym_identifier] = ACTIONS(1378),
    [aux_sym_preproc_include_token1] = ACTIONS(1378),
    [aux_sym_preproc_def_token1] = ACTIONS(1378),
    [aux_sym_preproc_if_token1] = ACTIONS(1378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1378),
    [sym_preproc_directive] = ACTIONS(1378),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_BANG] = ACTIONS(1380),
    [anon_sym_TILDE] = ACTIONS(1380),
    [anon_sym_DASH] = ACTIONS(1378),
    [anon_sym_PLUS] = ACTIONS(1378),
    [anon_sym_STAR] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym___extension__] = ACTIONS(1378),
    [anon_sym_typedef] = ACTIONS(1378),
    [anon_sym_extern] = ACTIONS(1378),
    [anon_sym___attribute__] = ACTIONS(1378),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1380),
    [anon_sym___declspec] = ACTIONS(1378),
    [anon_sym___cdecl] = ACTIONS(1378),
    [anon_sym___clrcall] = ACTIONS(1378),
    [anon_sym___stdcall] = ACTIONS(1378),
    [anon_sym___fastcall] = ACTIONS(1378),
    [anon_sym___thiscall] = ACTIONS(1378),
    [anon_sym___vectorcall] = ACTIONS(1378),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_signed] = ACTIONS(1378),
    [anon_sym_unsigned] = ACTIONS(1378),
    [anon_sym_long] = ACTIONS(1378),
    [anon_sym_short] = ACTIONS(1378),
    [anon_sym_static] = ACTIONS(1378),
    [anon_sym_auto] = ACTIONS(1378),
    [anon_sym_register] = ACTIONS(1378),
    [anon_sym_inline] = ACTIONS(1378),
    [anon_sym___inline] = ACTIONS(1378),
    [anon_sym___inline__] = ACTIONS(1378),
    [anon_sym___forceinline] = ACTIONS(1378),
    [anon_sym_thread_local] = ACTIONS(1378),
    [anon_sym___thread] = ACTIONS(1378),
    [anon_sym_const] = ACTIONS(1378),
    [anon_sym_constexpr] = ACTIONS(1378),
    [anon_sym_volatile] = ACTIONS(1378),
    [anon_sym_restrict] = ACTIONS(1378),
    [anon_sym___restrict__] = ACTIONS(1378),
    [anon_sym__Atomic] = ACTIONS(1378),
    [anon_sym__Noreturn] = ACTIONS(1378),
    [anon_sym_noreturn] = ACTIONS(1378),
    [sym_primitive_type] = ACTIONS(1378),
    [anon_sym_enum] = ACTIONS(1378),
    [anon_sym_struct] = ACTIONS(1378),
    [anon_sym_union] = ACTIONS(1378),
    [anon_sym_if] = ACTIONS(1378),
    [anon_sym_else] = ACTIONS(1378),
    [anon_sym_switch] = ACTIONS(1378),
    [anon_sym_case] = ACTIONS(1378),
    [anon_sym_default] = ACTIONS(1378),
    [anon_sym_while] = ACTIONS(1378),
    [anon_sym_do] = ACTIONS(1378),
    [anon_sym_for] = ACTIONS(1378),
    [anon_sym_return] = ACTIONS(1378),
    [anon_sym_break] = ACTIONS(1378),
    [anon_sym_continue] = ACTIONS(1378),
    [anon_sym_goto] = ACTIONS(1378),
    [anon_sym___try] = ACTIONS(1378),
    [anon_sym___leave] = ACTIONS(1378),
    [anon_sym_DASH_DASH] = ACTIONS(1380),
    [anon_sym_PLUS_PLUS] = ACTIONS(1380),
    [anon_sym_sizeof] = ACTIONS(1378),
    [anon_sym___alignof__] = ACTIONS(1378),
    [anon_sym___alignof] = ACTIONS(1378),
    [anon_sym__alignof] = ACTIONS(1378),
    [anon_sym_alignof] = ACTIONS(1378),
    [anon_sym__Alignof] = ACTIONS(1378),
    [anon_sym_offsetof] = ACTIONS(1378),
    [anon_sym__Generic] = ACTIONS(1378),
    [anon_sym_asm] = ACTIONS(1378),
    [anon_sym___asm__] = ACTIONS(1378),
    [sym_number_literal] = ACTIONS(1380),
    [anon_sym_L_SQUOTE] = ACTIONS(1380),
    [anon_sym_u_SQUOTE] = ACTIONS(1380),
    [anon_sym_U_SQUOTE] = ACTIONS(1380),
    [anon_sym_u8_SQUOTE] = ACTIONS(1380),
    [anon_sym_SQUOTE] = ACTIONS(1380),
    [anon_sym_L_DQUOTE] = ACTIONS(1380),
    [anon_sym_u_DQUOTE] = ACTIONS(1380),
    [anon_sym_U_DQUOTE] = ACTIONS(1380),
    [anon_sym_u8_DQUOTE] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [anon_sym_NULL] = ACTIONS(1378),
    [anon_sym_nullptr] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
  },
  [330] = {
    [ts_builtin_sym_end] = ACTIONS(1352),
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [331] = {
    [ts_builtin_sym_end] = ACTIONS(1352),
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [332] = {
    [sym_identifier] = ACTIONS(1342),
    [aux_sym_preproc_include_token1] = ACTIONS(1342),
    [aux_sym_preproc_def_token1] = ACTIONS(1342),
    [aux_sym_preproc_if_token1] = ACTIONS(1342),
    [aux_sym_preproc_if_token2] = ACTIONS(1342),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1342),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1342),
    [sym_preproc_directive] = ACTIONS(1342),
    [anon_sym_LPAREN2] = ACTIONS(1344),
    [anon_sym_BANG] = ACTIONS(1344),
    [anon_sym_TILDE] = ACTIONS(1344),
    [anon_sym_DASH] = ACTIONS(1342),
    [anon_sym_PLUS] = ACTIONS(1342),
    [anon_sym_STAR] = ACTIONS(1344),
    [anon_sym_AMP] = ACTIONS(1344),
    [anon_sym_SEMI] = ACTIONS(1344),
    [anon_sym___extension__] = ACTIONS(1342),
    [anon_sym_typedef] = ACTIONS(1342),
    [anon_sym_extern] = ACTIONS(1342),
    [anon_sym___attribute__] = ACTIONS(1342),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1344),
    [anon_sym___declspec] = ACTIONS(1342),
    [anon_sym___cdecl] = ACTIONS(1342),
    [anon_sym___clrcall] = ACTIONS(1342),
    [anon_sym___stdcall] = ACTIONS(1342),
    [anon_sym___fastcall] = ACTIONS(1342),
    [anon_sym___thiscall] = ACTIONS(1342),
    [anon_sym___vectorcall] = ACTIONS(1342),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_signed] = ACTIONS(1342),
    [anon_sym_unsigned] = ACTIONS(1342),
    [anon_sym_long] = ACTIONS(1342),
    [anon_sym_short] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_auto] = ACTIONS(1342),
    [anon_sym_register] = ACTIONS(1342),
    [anon_sym_inline] = ACTIONS(1342),
    [anon_sym___inline] = ACTIONS(1342),
    [anon_sym___inline__] = ACTIONS(1342),
    [anon_sym___forceinline] = ACTIONS(1342),
    [anon_sym_thread_local] = ACTIONS(1342),
    [anon_sym___thread] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [anon_sym_constexpr] = ACTIONS(1342),
    [anon_sym_volatile] = ACTIONS(1342),
    [anon_sym_restrict] = ACTIONS(1342),
    [anon_sym___restrict__] = ACTIONS(1342),
    [anon_sym__Atomic] = ACTIONS(1342),
    [anon_sym__Noreturn] = ACTIONS(1342),
    [anon_sym_noreturn] = ACTIONS(1342),
    [sym_primitive_type] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_union] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1342),
    [anon_sym_else] = ACTIONS(1342),
    [anon_sym_switch] = ACTIONS(1342),
    [anon_sym_case] = ACTIONS(1342),
    [anon_sym_default] = ACTIONS(1342),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_do] = ACTIONS(1342),
    [anon_sym_for] = ACTIONS(1342),
    [anon_sym_return] = ACTIONS(1342),
    [anon_sym_break] = ACTIONS(1342),
    [anon_sym_continue] = ACTIONS(1342),
    [anon_sym_goto] = ACTIONS(1342),
    [anon_sym___try] = ACTIONS(1342),
    [anon_sym___leave] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(1344),
    [anon_sym_PLUS_PLUS] = ACTIONS(1344),
    [anon_sym_sizeof] = ACTIONS(1342),
    [anon_sym___alignof__] = ACTIONS(1342),
    [anon_sym___alignof] = ACTIONS(1342),
    [anon_sym__alignof] = ACTIONS(1342),
    [anon_sym_alignof] = ACTIONS(1342),
    [anon_sym__Alignof] = ACTIONS(1342),
    [anon_sym_offsetof] = ACTIONS(1342),
    [anon_sym__Generic] = ACTIONS(1342),
    [anon_sym_asm] = ACTIONS(1342),
    [anon_sym___asm__] = ACTIONS(1342),
    [sym_number_literal] = ACTIONS(1344),
    [anon_sym_L_SQUOTE] = ACTIONS(1344),
    [anon_sym_u_SQUOTE] = ACTIONS(1344),
    [anon_sym_U_SQUOTE] = ACTIONS(1344),
    [anon_sym_u8_SQUOTE] = ACTIONS(1344),
    [anon_sym_SQUOTE] = ACTIONS(1344),
    [anon_sym_L_DQUOTE] = ACTIONS(1344),
    [anon_sym_u_DQUOTE] = ACTIONS(1344),
    [anon_sym_U_DQUOTE] = ACTIONS(1344),
    [anon_sym_u8_DQUOTE] = ACTIONS(1344),
    [anon_sym_DQUOTE] = ACTIONS(1344),
    [sym_true] = ACTIONS(1342),
    [sym_false] = ACTIONS(1342),
    [anon_sym_NULL] = ACTIONS(1342),
    [anon_sym_nullptr] = ACTIONS(1342),
    [sym_comment] = ACTIONS(3),
  },
  [333] = {
    [sym_identifier] = ACTIONS(1346),
    [aux_sym_preproc_include_token1] = ACTIONS(1346),
    [aux_sym_preproc_def_token1] = ACTIONS(1346),
    [aux_sym_preproc_if_token1] = ACTIONS(1346),
    [aux_sym_preproc_if_token2] = ACTIONS(1346),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1346),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1346),
    [sym_preproc_directive] = ACTIONS(1346),
    [anon_sym_LPAREN2] = ACTIONS(1348),
    [anon_sym_BANG] = ACTIONS(1348),
    [anon_sym_TILDE] = ACTIONS(1348),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_STAR] = ACTIONS(1348),
    [anon_sym_AMP] = ACTIONS(1348),
    [anon_sym_SEMI] = ACTIONS(1348),
    [anon_sym___extension__] = ACTIONS(1346),
    [anon_sym_typedef] = ACTIONS(1346),
    [anon_sym_extern] = ACTIONS(1346),
    [anon_sym___attribute__] = ACTIONS(1346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1348),
    [anon_sym___declspec] = ACTIONS(1346),
    [anon_sym___cdecl] = ACTIONS(1346),
    [anon_sym___clrcall] = ACTIONS(1346),
    [anon_sym___stdcall] = ACTIONS(1346),
    [anon_sym___fastcall] = ACTIONS(1346),
    [anon_sym___thiscall] = ACTIONS(1346),
    [anon_sym___vectorcall] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_signed] = ACTIONS(1346),
    [anon_sym_unsigned] = ACTIONS(1346),
    [anon_sym_long] = ACTIONS(1346),
    [anon_sym_short] = ACTIONS(1346),
    [anon_sym_static] = ACTIONS(1346),
    [anon_sym_auto] = ACTIONS(1346),
    [anon_sym_register] = ACTIONS(1346),
    [anon_sym_inline] = ACTIONS(1346),
    [anon_sym___inline] = ACTIONS(1346),
    [anon_sym___inline__] = ACTIONS(1346),
    [anon_sym___forceinline] = ACTIONS(1346),
    [anon_sym_thread_local] = ACTIONS(1346),
    [anon_sym___thread] = ACTIONS(1346),
    [anon_sym_const] = ACTIONS(1346),
    [anon_sym_constexpr] = ACTIONS(1346),
    [anon_sym_volatile] = ACTIONS(1346),
    [anon_sym_restrict] = ACTIONS(1346),
    [anon_sym___restrict__] = ACTIONS(1346),
    [anon_sym__Atomic] = ACTIONS(1346),
    [anon_sym__Noreturn] = ACTIONS(1346),
    [anon_sym_noreturn] = ACTIONS(1346),
    [sym_primitive_type] = ACTIONS(1346),
    [anon_sym_enum] = ACTIONS(1346),
    [anon_sym_struct] = ACTIONS(1346),
    [anon_sym_union] = ACTIONS(1346),
    [anon_sym_if] = ACTIONS(1346),
    [anon_sym_else] = ACTIONS(1346),
    [anon_sym_switch] = ACTIONS(1346),
    [anon_sym_case] = ACTIONS(1346),
    [anon_sym_default] = ACTIONS(1346),
    [anon_sym_while] = ACTIONS(1346),
    [anon_sym_do] = ACTIONS(1346),
    [anon_sym_for] = ACTIONS(1346),
    [anon_sym_return] = ACTIONS(1346),
    [anon_sym_break] = ACTIONS(1346),
    [anon_sym_continue] = ACTIONS(1346),
    [anon_sym_goto] = ACTIONS(1346),
    [anon_sym___try] = ACTIONS(1346),
    [anon_sym___leave] = ACTIONS(1346),
    [anon_sym_DASH_DASH] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(1348),
    [anon_sym_sizeof] = ACTIONS(1346),
    [anon_sym___alignof__] = ACTIONS(1346),
    [anon_sym___alignof] = ACTIONS(1346),
    [anon_sym__alignof] = ACTIONS(1346),
    [anon_sym_alignof] = ACTIONS(1346),
    [anon_sym__Alignof] = ACTIONS(1346),
    [anon_sym_offsetof] = ACTIONS(1346),
    [anon_sym__Generic] = ACTIONS(1346),
    [anon_sym_asm] = ACTIONS(1346),
    [anon_sym___asm__] = ACTIONS(1346),
    [sym_number_literal] = ACTIONS(1348),
    [anon_sym_L_SQUOTE] = ACTIONS(1348),
    [anon_sym_u_SQUOTE] = ACTIONS(1348),
    [anon_sym_U_SQUOTE] = ACTIONS(1348),
    [anon_sym_u8_SQUOTE] = ACTIONS(1348),
    [anon_sym_SQUOTE] = ACTIONS(1348),
    [anon_sym_L_DQUOTE] = ACTIONS(1348),
    [anon_sym_u_DQUOTE] = ACTIONS(1348),
    [anon_sym_U_DQUOTE] = ACTIONS(1348),
    [anon_sym_u8_DQUOTE] = ACTIONS(1348),
    [anon_sym_DQUOTE] = ACTIONS(1348),
    [sym_true] = ACTIONS(1346),
    [sym_false] = ACTIONS(1346),
    [anon_sym_NULL] = ACTIONS(1346),
    [anon_sym_nullptr] = ACTIONS(1346),
    [sym_comment] = ACTIONS(3),
  },
  [334] = {
    [ts_builtin_sym_end] = ACTIONS(1380),
    [sym_identifier] = ACTIONS(1378),
    [aux_sym_preproc_include_token1] = ACTIONS(1378),
    [aux_sym_preproc_def_token1] = ACTIONS(1378),
    [aux_sym_preproc_if_token1] = ACTIONS(1378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1378),
    [sym_preproc_directive] = ACTIONS(1378),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_BANG] = ACTIONS(1380),
    [anon_sym_TILDE] = ACTIONS(1380),
    [anon_sym_DASH] = ACTIONS(1378),
    [anon_sym_PLUS] = ACTIONS(1378),
    [anon_sym_STAR] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym___extension__] = ACTIONS(1378),
    [anon_sym_typedef] = ACTIONS(1378),
    [anon_sym_extern] = ACTIONS(1378),
    [anon_sym___attribute__] = ACTIONS(1378),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1380),
    [anon_sym___declspec] = ACTIONS(1378),
    [anon_sym___cdecl] = ACTIONS(1378),
    [anon_sym___clrcall] = ACTIONS(1378),
    [anon_sym___stdcall] = ACTIONS(1378),
    [anon_sym___fastcall] = ACTIONS(1378),
    [anon_sym___thiscall] = ACTIONS(1378),
    [anon_sym___vectorcall] = ACTIONS(1378),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_signed] = ACTIONS(1378),
    [anon_sym_unsigned] = ACTIONS(1378),
    [anon_sym_long] = ACTIONS(1378),
    [anon_sym_short] = ACTIONS(1378),
    [anon_sym_static] = ACTIONS(1378),
    [anon_sym_auto] = ACTIONS(1378),
    [anon_sym_register] = ACTIONS(1378),
    [anon_sym_inline] = ACTIONS(1378),
    [anon_sym___inline] = ACTIONS(1378),
    [anon_sym___inline__] = ACTIONS(1378),
    [anon_sym___forceinline] = ACTIONS(1378),
    [anon_sym_thread_local] = ACTIONS(1378),
    [anon_sym___thread] = ACTIONS(1378),
    [anon_sym_const] = ACTIONS(1378),
    [anon_sym_constexpr] = ACTIONS(1378),
    [anon_sym_volatile] = ACTIONS(1378),
    [anon_sym_restrict] = ACTIONS(1378),
    [anon_sym___restrict__] = ACTIONS(1378),
    [anon_sym__Atomic] = ACTIONS(1378),
    [anon_sym__Noreturn] = ACTIONS(1378),
    [anon_sym_noreturn] = ACTIONS(1378),
    [sym_primitive_type] = ACTIONS(1378),
    [anon_sym_enum] = ACTIONS(1378),
    [anon_sym_struct] = ACTIONS(1378),
    [anon_sym_union] = ACTIONS(1378),
    [anon_sym_if] = ACTIONS(1378),
    [anon_sym_else] = ACTIONS(1378),
    [anon_sym_switch] = ACTIONS(1378),
    [anon_sym_case] = ACTIONS(1378),
    [anon_sym_default] = ACTIONS(1378),
    [anon_sym_while] = ACTIONS(1378),
    [anon_sym_do] = ACTIONS(1378),
    [anon_sym_for] = ACTIONS(1378),
    [anon_sym_return] = ACTIONS(1378),
    [anon_sym_break] = ACTIONS(1378),
    [anon_sym_continue] = ACTIONS(1378),
    [anon_sym_goto] = ACTIONS(1378),
    [anon_sym___try] = ACTIONS(1378),
    [anon_sym___leave] = ACTIONS(1378),
    [anon_sym_DASH_DASH] = ACTIONS(1380),
    [anon_sym_PLUS_PLUS] = ACTIONS(1380),
    [anon_sym_sizeof] = ACTIONS(1378),
    [anon_sym___alignof__] = ACTIONS(1378),
    [anon_sym___alignof] = ACTIONS(1378),
    [anon_sym__alignof] = ACTIONS(1378),
    [anon_sym_alignof] = ACTIONS(1378),
    [anon_sym__Alignof] = ACTIONS(1378),
    [anon_sym_offsetof] = ACTIONS(1378),
    [anon_sym__Generic] = ACTIONS(1378),
    [anon_sym_asm] = ACTIONS(1378),
    [anon_sym___asm__] = ACTIONS(1378),
    [sym_number_literal] = ACTIONS(1380),
    [anon_sym_L_SQUOTE] = ACTIONS(1380),
    [anon_sym_u_SQUOTE] = ACTIONS(1380),
    [anon_sym_U_SQUOTE] = ACTIONS(1380),
    [anon_sym_u8_SQUOTE] = ACTIONS(1380),
    [anon_sym_SQUOTE] = ACTIONS(1380),
    [anon_sym_L_DQUOTE] = ACTIONS(1380),
    [anon_sym_u_DQUOTE] = ACTIONS(1380),
    [anon_sym_U_DQUOTE] = ACTIONS(1380),
    [anon_sym_u8_DQUOTE] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [anon_sym_NULL] = ACTIONS(1378),
    [anon_sym_nullptr] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
  },
  [335] = {
    [sym_identifier] = ACTIONS(1320),
    [aux_sym_preproc_include_token1] = ACTIONS(1320),
    [aux_sym_preproc_def_token1] = ACTIONS(1320),
    [aux_sym_preproc_if_token1] = ACTIONS(1320),
    [aux_sym_preproc_if_token2] = ACTIONS(1320),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1320),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1320),
    [sym_preproc_directive] = ACTIONS(1320),
    [anon_sym_LPAREN2] = ACTIONS(1318),
    [anon_sym_BANG] = ACTIONS(1318),
    [anon_sym_TILDE] = ACTIONS(1318),
    [anon_sym_DASH] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(1320),
    [anon_sym_STAR] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(1318),
    [anon_sym_SEMI] = ACTIONS(1318),
    [anon_sym___extension__] = ACTIONS(1320),
    [anon_sym_typedef] = ACTIONS(1320),
    [anon_sym_extern] = ACTIONS(1320),
    [anon_sym___attribute__] = ACTIONS(1320),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1318),
    [anon_sym___declspec] = ACTIONS(1320),
    [anon_sym___cdecl] = ACTIONS(1320),
    [anon_sym___clrcall] = ACTIONS(1320),
    [anon_sym___stdcall] = ACTIONS(1320),
    [anon_sym___fastcall] = ACTIONS(1320),
    [anon_sym___thiscall] = ACTIONS(1320),
    [anon_sym___vectorcall] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1318),
    [anon_sym_signed] = ACTIONS(1320),
    [anon_sym_unsigned] = ACTIONS(1320),
    [anon_sym_long] = ACTIONS(1320),
    [anon_sym_short] = ACTIONS(1320),
    [anon_sym_static] = ACTIONS(1320),
    [anon_sym_auto] = ACTIONS(1320),
    [anon_sym_register] = ACTIONS(1320),
    [anon_sym_inline] = ACTIONS(1320),
    [anon_sym___inline] = ACTIONS(1320),
    [anon_sym___inline__] = ACTIONS(1320),
    [anon_sym___forceinline] = ACTIONS(1320),
    [anon_sym_thread_local] = ACTIONS(1320),
    [anon_sym___thread] = ACTIONS(1320),
    [anon_sym_const] = ACTIONS(1320),
    [anon_sym_constexpr] = ACTIONS(1320),
    [anon_sym_volatile] = ACTIONS(1320),
    [anon_sym_restrict] = ACTIONS(1320),
    [anon_sym___restrict__] = ACTIONS(1320),
    [anon_sym__Atomic] = ACTIONS(1320),
    [anon_sym__Noreturn] = ACTIONS(1320),
    [anon_sym_noreturn] = ACTIONS(1320),
    [sym_primitive_type] = ACTIONS(1320),
    [anon_sym_enum] = ACTIONS(1320),
    [anon_sym_struct] = ACTIONS(1320),
    [anon_sym_union] = ACTIONS(1320),
    [anon_sym_if] = ACTIONS(1320),
    [anon_sym_else] = ACTIONS(1320),
    [anon_sym_switch] = ACTIONS(1320),
    [anon_sym_case] = ACTIONS(1320),
    [anon_sym_default] = ACTIONS(1320),
    [anon_sym_while] = ACTIONS(1320),
    [anon_sym_do] = ACTIONS(1320),
    [anon_sym_for] = ACTIONS(1320),
    [anon_sym_return] = ACTIONS(1320),
    [anon_sym_break] = ACTIONS(1320),
    [anon_sym_continue] = ACTIONS(1320),
    [anon_sym_goto] = ACTIONS(1320),
    [anon_sym___try] = ACTIONS(1320),
    [anon_sym___leave] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1318),
    [anon_sym_PLUS_PLUS] = ACTIONS(1318),
    [anon_sym_sizeof] = ACTIONS(1320),
    [anon_sym___alignof__] = ACTIONS(1320),
    [anon_sym___alignof] = ACTIONS(1320),
    [anon_sym__alignof] = ACTIONS(1320),
    [anon_sym_alignof] = ACTIONS(1320),
    [anon_sym__Alignof] = ACTIONS(1320),
    [anon_sym_offsetof] = ACTIONS(1320),
    [anon_sym__Generic] = ACTIONS(1320),
    [anon_sym_asm] = ACTIONS(1320),
    [anon_sym___asm__] = ACTIONS(1320),
    [sym_number_literal] = ACTIONS(1318),
    [anon_sym_L_SQUOTE] = ACTIONS(1318),
    [anon_sym_u_SQUOTE] = ACTIONS(1318),
    [anon_sym_U_SQUOTE] = ACTIONS(1318),
    [anon_sym_u8_SQUOTE] = ACTIONS(1318),
    [anon_sym_SQUOTE] = ACTIONS(1318),
    [anon_sym_L_DQUOTE] = ACTIONS(1318),
    [anon_sym_u_DQUOTE] = ACTIONS(1318),
    [anon_sym_U_DQUOTE] = ACTIONS(1318),
    [anon_sym_u8_DQUOTE] = ACTIONS(1318),
    [anon_sym_DQUOTE] = ACTIONS(1318),
    [sym_true] = ACTIONS(1320),
    [sym_false] = ACTIONS(1320),
    [anon_sym_NULL] = ACTIONS(1320),
    [anon_sym_nullptr] = ACTIONS(1320),
    [sym_comment] = ACTIONS(3),
  },
  [336] = {
    [ts_builtin_sym_end] = ACTIONS(1352),
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [337] = {
    [sym_identifier] = ACTIONS(1358),
    [aux_sym_preproc_include_token1] = ACTIONS(1358),
    [aux_sym_preproc_def_token1] = ACTIONS(1358),
    [aux_sym_preproc_if_token1] = ACTIONS(1358),
    [aux_sym_preproc_if_token2] = ACTIONS(1358),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1358),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1358),
    [sym_preproc_directive] = ACTIONS(1358),
    [anon_sym_LPAREN2] = ACTIONS(1360),
    [anon_sym_BANG] = ACTIONS(1360),
    [anon_sym_TILDE] = ACTIONS(1360),
    [anon_sym_DASH] = ACTIONS(1358),
    [anon_sym_PLUS] = ACTIONS(1358),
    [anon_sym_STAR] = ACTIONS(1360),
    [anon_sym_AMP] = ACTIONS(1360),
    [anon_sym_SEMI] = ACTIONS(1360),
    [anon_sym___extension__] = ACTIONS(1358),
    [anon_sym_typedef] = ACTIONS(1358),
    [anon_sym_extern] = ACTIONS(1358),
    [anon_sym___attribute__] = ACTIONS(1358),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1360),
    [anon_sym___declspec] = ACTIONS(1358),
    [anon_sym___cdecl] = ACTIONS(1358),
    [anon_sym___clrcall] = ACTIONS(1358),
    [anon_sym___stdcall] = ACTIONS(1358),
    [anon_sym___fastcall] = ACTIONS(1358),
    [anon_sym___thiscall] = ACTIONS(1358),
    [anon_sym___vectorcall] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_signed] = ACTIONS(1358),
    [anon_sym_unsigned] = ACTIONS(1358),
    [anon_sym_long] = ACTIONS(1358),
    [anon_sym_short] = ACTIONS(1358),
    [anon_sym_static] = ACTIONS(1358),
    [anon_sym_auto] = ACTIONS(1358),
    [anon_sym_register] = ACTIONS(1358),
    [anon_sym_inline] = ACTIONS(1358),
    [anon_sym___inline] = ACTIONS(1358),
    [anon_sym___inline__] = ACTIONS(1358),
    [anon_sym___forceinline] = ACTIONS(1358),
    [anon_sym_thread_local] = ACTIONS(1358),
    [anon_sym___thread] = ACTIONS(1358),
    [anon_sym_const] = ACTIONS(1358),
    [anon_sym_constexpr] = ACTIONS(1358),
    [anon_sym_volatile] = ACTIONS(1358),
    [anon_sym_restrict] = ACTIONS(1358),
    [anon_sym___restrict__] = ACTIONS(1358),
    [anon_sym__Atomic] = ACTIONS(1358),
    [anon_sym__Noreturn] = ACTIONS(1358),
    [anon_sym_noreturn] = ACTIONS(1358),
    [sym_primitive_type] = ACTIONS(1358),
    [anon_sym_enum] = ACTIONS(1358),
    [anon_sym_struct] = ACTIONS(1358),
    [anon_sym_union] = ACTIONS(1358),
    [anon_sym_if] = ACTIONS(1358),
    [anon_sym_else] = ACTIONS(1358),
    [anon_sym_switch] = ACTIONS(1358),
    [anon_sym_case] = ACTIONS(1358),
    [anon_sym_default] = ACTIONS(1358),
    [anon_sym_while] = ACTIONS(1358),
    [anon_sym_do] = ACTIONS(1358),
    [anon_sym_for] = ACTIONS(1358),
    [anon_sym_return] = ACTIONS(1358),
    [anon_sym_break] = ACTIONS(1358),
    [anon_sym_continue] = ACTIONS(1358),
    [anon_sym_goto] = ACTIONS(1358),
    [anon_sym___try] = ACTIONS(1358),
    [anon_sym___leave] = ACTIONS(1358),
    [anon_sym_DASH_DASH] = ACTIONS(1360),
    [anon_sym_PLUS_PLUS] = ACTIONS(1360),
    [anon_sym_sizeof] = ACTIONS(1358),
    [anon_sym___alignof__] = ACTIONS(1358),
    [anon_sym___alignof] = ACTIONS(1358),
    [anon_sym__alignof] = ACTIONS(1358),
    [anon_sym_alignof] = ACTIONS(1358),
    [anon_sym__Alignof] = ACTIONS(1358),
    [anon_sym_offsetof] = ACTIONS(1358),
    [anon_sym__Generic] = ACTIONS(1358),
    [anon_sym_asm] = ACTIONS(1358),
    [anon_sym___asm__] = ACTIONS(1358),
    [sym_number_literal] = ACTIONS(1360),
    [anon_sym_L_SQUOTE] = ACTIONS(1360),
    [anon_sym_u_SQUOTE] = ACTIONS(1360),
    [anon_sym_U_SQUOTE] = ACTIONS(1360),
    [anon_sym_u8_SQUOTE] = ACTIONS(1360),
    [anon_sym_SQUOTE] = ACTIONS(1360),
    [anon_sym_L_DQUOTE] = ACTIONS(1360),
    [anon_sym_u_DQUOTE] = ACTIONS(1360),
    [anon_sym_U_DQUOTE] = ACTIONS(1360),
    [anon_sym_u8_DQUOTE] = ACTIONS(1360),
    [anon_sym_DQUOTE] = ACTIONS(1360),
    [sym_true] = ACTIONS(1358),
    [sym_false] = ACTIONS(1358),
    [anon_sym_NULL] = ACTIONS(1358),
    [anon_sym_nullptr] = ACTIONS(1358),
    [sym_comment] = ACTIONS(3),
  },
  [338] = {
    [ts_builtin_sym_end] = ACTIONS(1352),
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [339] = {
    [sym_identifier] = ACTIONS(1320),
    [aux_sym_preproc_include_token1] = ACTIONS(1320),
    [aux_sym_preproc_def_token1] = ACTIONS(1320),
    [aux_sym_preproc_if_token1] = ACTIONS(1320),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1320),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1320),
    [sym_preproc_directive] = ACTIONS(1320),
    [anon_sym_LPAREN2] = ACTIONS(1318),
    [anon_sym_BANG] = ACTIONS(1318),
    [anon_sym_TILDE] = ACTIONS(1318),
    [anon_sym_DASH] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(1320),
    [anon_sym_STAR] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(1318),
    [anon_sym_SEMI] = ACTIONS(1318),
    [anon_sym___extension__] = ACTIONS(1320),
    [anon_sym_typedef] = ACTIONS(1320),
    [anon_sym_extern] = ACTIONS(1320),
    [anon_sym___attribute__] = ACTIONS(1320),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1318),
    [anon_sym___declspec] = ACTIONS(1320),
    [anon_sym___cdecl] = ACTIONS(1320),
    [anon_sym___clrcall] = ACTIONS(1320),
    [anon_sym___stdcall] = ACTIONS(1320),
    [anon_sym___fastcall] = ACTIONS(1320),
    [anon_sym___thiscall] = ACTIONS(1320),
    [anon_sym___vectorcall] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1318),
    [anon_sym_RBRACE] = ACTIONS(1318),
    [anon_sym_signed] = ACTIONS(1320),
    [anon_sym_unsigned] = ACTIONS(1320),
    [anon_sym_long] = ACTIONS(1320),
    [anon_sym_short] = ACTIONS(1320),
    [anon_sym_static] = ACTIONS(1320),
    [anon_sym_auto] = ACTIONS(1320),
    [anon_sym_register] = ACTIONS(1320),
    [anon_sym_inline] = ACTIONS(1320),
    [anon_sym___inline] = ACTIONS(1320),
    [anon_sym___inline__] = ACTIONS(1320),
    [anon_sym___forceinline] = ACTIONS(1320),
    [anon_sym_thread_local] = ACTIONS(1320),
    [anon_sym___thread] = ACTIONS(1320),
    [anon_sym_const] = ACTIONS(1320),
    [anon_sym_constexpr] = ACTIONS(1320),
    [anon_sym_volatile] = ACTIONS(1320),
    [anon_sym_restrict] = ACTIONS(1320),
    [anon_sym___restrict__] = ACTIONS(1320),
    [anon_sym__Atomic] = ACTIONS(1320),
    [anon_sym__Noreturn] = ACTIONS(1320),
    [anon_sym_noreturn] = ACTIONS(1320),
    [sym_primitive_type] = ACTIONS(1320),
    [anon_sym_enum] = ACTIONS(1320),
    [anon_sym_struct] = ACTIONS(1320),
    [anon_sym_union] = ACTIONS(1320),
    [anon_sym_if] = ACTIONS(1320),
    [anon_sym_else] = ACTIONS(1320),
    [anon_sym_switch] = ACTIONS(1320),
    [anon_sym_case] = ACTIONS(1320),
    [anon_sym_default] = ACTIONS(1320),
    [anon_sym_while] = ACTIONS(1320),
    [anon_sym_do] = ACTIONS(1320),
    [anon_sym_for] = ACTIONS(1320),
    [anon_sym_return] = ACTIONS(1320),
    [anon_sym_break] = ACTIONS(1320),
    [anon_sym_continue] = ACTIONS(1320),
    [anon_sym_goto] = ACTIONS(1320),
    [anon_sym___try] = ACTIONS(1320),
    [anon_sym___leave] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1318),
    [anon_sym_PLUS_PLUS] = ACTIONS(1318),
    [anon_sym_sizeof] = ACTIONS(1320),
    [anon_sym___alignof__] = ACTIONS(1320),
    [anon_sym___alignof] = ACTIONS(1320),
    [anon_sym__alignof] = ACTIONS(1320),
    [anon_sym_alignof] = ACTIONS(1320),
    [anon_sym__Alignof] = ACTIONS(1320),
    [anon_sym_offsetof] = ACTIONS(1320),
    [anon_sym__Generic] = ACTIONS(1320),
    [anon_sym_asm] = ACTIONS(1320),
    [anon_sym___asm__] = ACTIONS(1320),
    [sym_number_literal] = ACTIONS(1318),
    [anon_sym_L_SQUOTE] = ACTIONS(1318),
    [anon_sym_u_SQUOTE] = ACTIONS(1318),
    [anon_sym_U_SQUOTE] = ACTIONS(1318),
    [anon_sym_u8_SQUOTE] = ACTIONS(1318),
    [anon_sym_SQUOTE] = ACTIONS(1318),
    [anon_sym_L_DQUOTE] = ACTIONS(1318),
    [anon_sym_u_DQUOTE] = ACTIONS(1318),
    [anon_sym_U_DQUOTE] = ACTIONS(1318),
    [anon_sym_u8_DQUOTE] = ACTIONS(1318),
    [anon_sym_DQUOTE] = ACTIONS(1318),
    [sym_true] = ACTIONS(1320),
    [sym_false] = ACTIONS(1320),
    [anon_sym_NULL] = ACTIONS(1320),
    [anon_sym_nullptr] = ACTIONS(1320),
    [sym_comment] = ACTIONS(3),
  },
  [340] = {
    [sym_identifier] = ACTIONS(1362),
    [aux_sym_preproc_include_token1] = ACTIONS(1362),
    [aux_sym_preproc_def_token1] = ACTIONS(1362),
    [aux_sym_preproc_if_token1] = ACTIONS(1362),
    [aux_sym_preproc_if_token2] = ACTIONS(1362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1362),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1362),
    [sym_preproc_directive] = ACTIONS(1362),
    [anon_sym_LPAREN2] = ACTIONS(1364),
    [anon_sym_BANG] = ACTIONS(1364),
    [anon_sym_TILDE] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_STAR] = ACTIONS(1364),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_SEMI] = ACTIONS(1364),
    [anon_sym___extension__] = ACTIONS(1362),
    [anon_sym_typedef] = ACTIONS(1362),
    [anon_sym_extern] = ACTIONS(1362),
    [anon_sym___attribute__] = ACTIONS(1362),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1364),
    [anon_sym___declspec] = ACTIONS(1362),
    [anon_sym___cdecl] = ACTIONS(1362),
    [anon_sym___clrcall] = ACTIONS(1362),
    [anon_sym___stdcall] = ACTIONS(1362),
    [anon_sym___fastcall] = ACTIONS(1362),
    [anon_sym___thiscall] = ACTIONS(1362),
    [anon_sym___vectorcall] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(1364),
    [anon_sym_signed] = ACTIONS(1362),
    [anon_sym_unsigned] = ACTIONS(1362),
    [anon_sym_long] = ACTIONS(1362),
    [anon_sym_short] = ACTIONS(1362),
    [anon_sym_static] = ACTIONS(1362),
    [anon_sym_auto] = ACTIONS(1362),
    [anon_sym_register] = ACTIONS(1362),
    [anon_sym_inline] = ACTIONS(1362),
    [anon_sym___inline] = ACTIONS(1362),
    [anon_sym___inline__] = ACTIONS(1362),
    [anon_sym___forceinline] = ACTIONS(1362),
    [anon_sym_thread_local] = ACTIONS(1362),
    [anon_sym___thread] = ACTIONS(1362),
    [anon_sym_const] = ACTIONS(1362),
    [anon_sym_constexpr] = ACTIONS(1362),
    [anon_sym_volatile] = ACTIONS(1362),
    [anon_sym_restrict] = ACTIONS(1362),
    [anon_sym___restrict__] = ACTIONS(1362),
    [anon_sym__Atomic] = ACTIONS(1362),
    [anon_sym__Noreturn] = ACTIONS(1362),
    [anon_sym_noreturn] = ACTIONS(1362),
    [sym_primitive_type] = ACTIONS(1362),
    [anon_sym_enum] = ACTIONS(1362),
    [anon_sym_struct] = ACTIONS(1362),
    [anon_sym_union] = ACTIONS(1362),
    [anon_sym_if] = ACTIONS(1362),
    [anon_sym_else] = ACTIONS(1362),
    [anon_sym_switch] = ACTIONS(1362),
    [anon_sym_case] = ACTIONS(1362),
    [anon_sym_default] = ACTIONS(1362),
    [anon_sym_while] = ACTIONS(1362),
    [anon_sym_do] = ACTIONS(1362),
    [anon_sym_for] = ACTIONS(1362),
    [anon_sym_return] = ACTIONS(1362),
    [anon_sym_break] = ACTIONS(1362),
    [anon_sym_continue] = ACTIONS(1362),
    [anon_sym_goto] = ACTIONS(1362),
    [anon_sym___try] = ACTIONS(1362),
    [anon_sym___leave] = ACTIONS(1362),
    [anon_sym_DASH_DASH] = ACTIONS(1364),
    [anon_sym_PLUS_PLUS] = ACTIONS(1364),
    [anon_sym_sizeof] = ACTIONS(1362),
    [anon_sym___alignof__] = ACTIONS(1362),
    [anon_sym___alignof] = ACTIONS(1362),
    [anon_sym__alignof] = ACTIONS(1362),
    [anon_sym_alignof] = ACTIONS(1362),
    [anon_sym__Alignof] = ACTIONS(1362),
    [anon_sym_offsetof] = ACTIONS(1362),
    [anon_sym__Generic] = ACTIONS(1362),
    [anon_sym_asm] = ACTIONS(1362),
    [anon_sym___asm__] = ACTIONS(1362),
    [sym_number_literal] = ACTIONS(1364),
    [anon_sym_L_SQUOTE] = ACTIONS(1364),
    [anon_sym_u_SQUOTE] = ACTIONS(1364),
    [anon_sym_U_SQUOTE] = ACTIONS(1364),
    [anon_sym_u8_SQUOTE] = ACTIONS(1364),
    [anon_sym_SQUOTE] = ACTIONS(1364),
    [anon_sym_L_DQUOTE] = ACTIONS(1364),
    [anon_sym_u_DQUOTE] = ACTIONS(1364),
    [anon_sym_U_DQUOTE] = ACTIONS(1364),
    [anon_sym_u8_DQUOTE] = ACTIONS(1364),
    [anon_sym_DQUOTE] = ACTIONS(1364),
    [sym_true] = ACTIONS(1362),
    [sym_false] = ACTIONS(1362),
    [anon_sym_NULL] = ACTIONS(1362),
    [anon_sym_nullptr] = ACTIONS(1362),
    [sym_comment] = ACTIONS(3),
  },
  [341] = {
    [ts_builtin_sym_end] = ACTIONS(1348),
    [sym_identifier] = ACTIONS(1346),
    [aux_sym_preproc_include_token1] = ACTIONS(1346),
    [aux_sym_preproc_def_token1] = ACTIONS(1346),
    [aux_sym_preproc_if_token1] = ACTIONS(1346),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1346),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1346),
    [sym_preproc_directive] = ACTIONS(1346),
    [anon_sym_LPAREN2] = ACTIONS(1348),
    [anon_sym_BANG] = ACTIONS(1348),
    [anon_sym_TILDE] = ACTIONS(1348),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_STAR] = ACTIONS(1348),
    [anon_sym_AMP] = ACTIONS(1348),
    [anon_sym_SEMI] = ACTIONS(1348),
    [anon_sym___extension__] = ACTIONS(1346),
    [anon_sym_typedef] = ACTIONS(1346),
    [anon_sym_extern] = ACTIONS(1346),
    [anon_sym___attribute__] = ACTIONS(1346),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1348),
    [anon_sym___declspec] = ACTIONS(1346),
    [anon_sym___cdecl] = ACTIONS(1346),
    [anon_sym___clrcall] = ACTIONS(1346),
    [anon_sym___stdcall] = ACTIONS(1346),
    [anon_sym___fastcall] = ACTIONS(1346),
    [anon_sym___thiscall] = ACTIONS(1346),
    [anon_sym___vectorcall] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_signed] = ACTIONS(1346),
    [anon_sym_unsigned] = ACTIONS(1346),
    [anon_sym_long] = ACTIONS(1346),
    [anon_sym_short] = ACTIONS(1346),
    [anon_sym_static] = ACTIONS(1346),
    [anon_sym_auto] = ACTIONS(1346),
    [anon_sym_register] = ACTIONS(1346),
    [anon_sym_inline] = ACTIONS(1346),
    [anon_sym___inline] = ACTIONS(1346),
    [anon_sym___inline__] = ACTIONS(1346),
    [anon_sym___forceinline] = ACTIONS(1346),
    [anon_sym_thread_local] = ACTIONS(1346),
    [anon_sym___thread] = ACTIONS(1346),
    [anon_sym_const] = ACTIONS(1346),
    [anon_sym_constexpr] = ACTIONS(1346),
    [anon_sym_volatile] = ACTIONS(1346),
    [anon_sym_restrict] = ACTIONS(1346),
    [anon_sym___restrict__] = ACTIONS(1346),
    [anon_sym__Atomic] = ACTIONS(1346),
    [anon_sym__Noreturn] = ACTIONS(1346),
    [anon_sym_noreturn] = ACTIONS(1346),
    [sym_primitive_type] = ACTIONS(1346),
    [anon_sym_enum] = ACTIONS(1346),
    [anon_sym_struct] = ACTIONS(1346),
    [anon_sym_union] = ACTIONS(1346),
    [anon_sym_if] = ACTIONS(1346),
    [anon_sym_else] = ACTIONS(1346),
    [anon_sym_switch] = ACTIONS(1346),
    [anon_sym_case] = ACTIONS(1346),
    [anon_sym_default] = ACTIONS(1346),
    [anon_sym_while] = ACTIONS(1346),
    [anon_sym_do] = ACTIONS(1346),
    [anon_sym_for] = ACTIONS(1346),
    [anon_sym_return] = ACTIONS(1346),
    [anon_sym_break] = ACTIONS(1346),
    [anon_sym_continue] = ACTIONS(1346),
    [anon_sym_goto] = ACTIONS(1346),
    [anon_sym___try] = ACTIONS(1346),
    [anon_sym___leave] = ACTIONS(1346),
    [anon_sym_DASH_DASH] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(1348),
    [anon_sym_sizeof] = ACTIONS(1346),
    [anon_sym___alignof__] = ACTIONS(1346),
    [anon_sym___alignof] = ACTIONS(1346),
    [anon_sym__alignof] = ACTIONS(1346),
    [anon_sym_alignof] = ACTIONS(1346),
    [anon_sym__Alignof] = ACTIONS(1346),
    [anon_sym_offsetof] = ACTIONS(1346),
    [anon_sym__Generic] = ACTIONS(1346),
    [anon_sym_asm] = ACTIONS(1346),
    [anon_sym___asm__] = ACTIONS(1346),
    [sym_number_literal] = ACTIONS(1348),
    [anon_sym_L_SQUOTE] = ACTIONS(1348),
    [anon_sym_u_SQUOTE] = ACTIONS(1348),
    [anon_sym_U_SQUOTE] = ACTIONS(1348),
    [anon_sym_u8_SQUOTE] = ACTIONS(1348),
    [anon_sym_SQUOTE] = ACTIONS(1348),
    [anon_sym_L_DQUOTE] = ACTIONS(1348),
    [anon_sym_u_DQUOTE] = ACTIONS(1348),
    [anon_sym_U_DQUOTE] = ACTIONS(1348),
    [anon_sym_u8_DQUOTE] = ACTIONS(1348),
    [anon_sym_DQUOTE] = ACTIONS(1348),
    [sym_true] = ACTIONS(1346),
    [sym_false] = ACTIONS(1346),
    [anon_sym_NULL] = ACTIONS(1346),
    [anon_sym_nullptr] = ACTIONS(1346),
    [sym_comment] = ACTIONS(3),
  },
  [342] = {
    [sym_identifier] = ACTIONS(1366),
    [aux_sym_preproc_include_token1] = ACTIONS(1366),
    [aux_sym_preproc_def_token1] = ACTIONS(1366),
    [aux_sym_preproc_if_token1] = ACTIONS(1366),
    [aux_sym_preproc_if_token2] = ACTIONS(1366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1366),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1366),
    [sym_preproc_directive] = ACTIONS(1366),
    [anon_sym_LPAREN2] = ACTIONS(1368),
    [anon_sym_BANG] = ACTIONS(1368),
    [anon_sym_TILDE] = ACTIONS(1368),
    [anon_sym_DASH] = ACTIONS(1366),
    [anon_sym_PLUS] = ACTIONS(1366),
    [anon_sym_STAR] = ACTIONS(1368),
    [anon_sym_AMP] = ACTIONS(1368),
    [anon_sym_SEMI] = ACTIONS(1368),
    [anon_sym___extension__] = ACTIONS(1366),
    [anon_sym_typedef] = ACTIONS(1366),
    [anon_sym_extern] = ACTIONS(1366),
    [anon_sym___attribute__] = ACTIONS(1366),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1368),
    [anon_sym___declspec] = ACTIONS(1366),
    [anon_sym___cdecl] = ACTIONS(1366),
    [anon_sym___clrcall] = ACTIONS(1366),
    [anon_sym___stdcall] = ACTIONS(1366),
    [anon_sym___fastcall] = ACTIONS(1366),
    [anon_sym___thiscall] = ACTIONS(1366),
    [anon_sym___vectorcall] = ACTIONS(1366),
    [anon_sym_LBRACE] = ACTIONS(1368),
    [anon_sym_signed] = ACTIONS(1366),
    [anon_sym_unsigned] = ACTIONS(1366),
    [anon_sym_long] = ACTIONS(1366),
    [anon_sym_short] = ACTIONS(1366),
    [anon_sym_static] = ACTIONS(1366),
    [anon_sym_auto] = ACTIONS(1366),
    [anon_sym_register] = ACTIONS(1366),
    [anon_sym_inline] = ACTIONS(1366),
    [anon_sym___inline] = ACTIONS(1366),
    [anon_sym___inline__] = ACTIONS(1366),
    [anon_sym___forceinline] = ACTIONS(1366),
    [anon_sym_thread_local] = ACTIONS(1366),
    [anon_sym___thread] = ACTIONS(1366),
    [anon_sym_const] = ACTIONS(1366),
    [anon_sym_constexpr] = ACTIONS(1366),
    [anon_sym_volatile] = ACTIONS(1366),
    [anon_sym_restrict] = ACTIONS(1366),
    [anon_sym___restrict__] = ACTIONS(1366),
    [anon_sym__Atomic] = ACTIONS(1366),
    [anon_sym__Noreturn] = ACTIONS(1366),
    [anon_sym_noreturn] = ACTIONS(1366),
    [sym_primitive_type] = ACTIONS(1366),
    [anon_sym_enum] = ACTIONS(1366),
    [anon_sym_struct] = ACTIONS(1366),
    [anon_sym_union] = ACTIONS(1366),
    [anon_sym_if] = ACTIONS(1366),
    [anon_sym_else] = ACTIONS(1366),
    [anon_sym_switch] = ACTIONS(1366),
    [anon_sym_case] = ACTIONS(1366),
    [anon_sym_default] = ACTIONS(1366),
    [anon_sym_while] = ACTIONS(1366),
    [anon_sym_do] = ACTIONS(1366),
    [anon_sym_for] = ACTIONS(1366),
    [anon_sym_return] = ACTIONS(1366),
    [anon_sym_break] = ACTIONS(1366),
    [anon_sym_continue] = ACTIONS(1366),
    [anon_sym_goto] = ACTIONS(1366),
    [anon_sym___try] = ACTIONS(1366),
    [anon_sym___leave] = ACTIONS(1366),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [anon_sym_sizeof] = ACTIONS(1366),
    [anon_sym___alignof__] = ACTIONS(1366),
    [anon_sym___alignof] = ACTIONS(1366),
    [anon_sym__alignof] = ACTIONS(1366),
    [anon_sym_alignof] = ACTIONS(1366),
    [anon_sym__Alignof] = ACTIONS(1366),
    [anon_sym_offsetof] = ACTIONS(1366),
    [anon_sym__Generic] = ACTIONS(1366),
    [anon_sym_asm] = ACTIONS(1366),
    [anon_sym___asm__] = ACTIONS(1366),
    [sym_number_literal] = ACTIONS(1368),
    [anon_sym_L_SQUOTE] = ACTIONS(1368),
    [anon_sym_u_SQUOTE] = ACTIONS(1368),
    [anon_sym_U_SQUOTE] = ACTIONS(1368),
    [anon_sym_u8_SQUOTE] = ACTIONS(1368),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_L_DQUOTE] = ACTIONS(1368),
    [anon_sym_u_DQUOTE] = ACTIONS(1368),
    [anon_sym_U_DQUOTE] = ACTIONS(1368),
    [anon_sym_u8_DQUOTE] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [sym_true] = ACTIONS(1366),
    [sym_false] = ACTIONS(1366),
    [anon_sym_NULL] = ACTIONS(1366),
    [anon_sym_nullptr] = ACTIONS(1366),
    [sym_comment] = ACTIONS(3),
  },
  [343] = {
    [ts_builtin_sym_end] = ACTIONS(1344),
    [sym_identifier] = ACTIONS(1342),
    [aux_sym_preproc_include_token1] = ACTIONS(1342),
    [aux_sym_preproc_def_token1] = ACTIONS(1342),
    [aux_sym_preproc_if_token1] = ACTIONS(1342),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1342),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1342),
    [sym_preproc_directive] = ACTIONS(1342),
    [anon_sym_LPAREN2] = ACTIONS(1344),
    [anon_sym_BANG] = ACTIONS(1344),
    [anon_sym_TILDE] = ACTIONS(1344),
    [anon_sym_DASH] = ACTIONS(1342),
    [anon_sym_PLUS] = ACTIONS(1342),
    [anon_sym_STAR] = ACTIONS(1344),
    [anon_sym_AMP] = ACTIONS(1344),
    [anon_sym_SEMI] = ACTIONS(1344),
    [anon_sym___extension__] = ACTIONS(1342),
    [anon_sym_typedef] = ACTIONS(1342),
    [anon_sym_extern] = ACTIONS(1342),
    [anon_sym___attribute__] = ACTIONS(1342),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1344),
    [anon_sym___declspec] = ACTIONS(1342),
    [anon_sym___cdecl] = ACTIONS(1342),
    [anon_sym___clrcall] = ACTIONS(1342),
    [anon_sym___stdcall] = ACTIONS(1342),
    [anon_sym___fastcall] = ACTIONS(1342),
    [anon_sym___thiscall] = ACTIONS(1342),
    [anon_sym___vectorcall] = ACTIONS(1342),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_signed] = ACTIONS(1342),
    [anon_sym_unsigned] = ACTIONS(1342),
    [anon_sym_long] = ACTIONS(1342),
    [anon_sym_short] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_auto] = ACTIONS(1342),
    [anon_sym_register] = ACTIONS(1342),
    [anon_sym_inline] = ACTIONS(1342),
    [anon_sym___inline] = ACTIONS(1342),
    [anon_sym___inline__] = ACTIONS(1342),
    [anon_sym___forceinline] = ACTIONS(1342),
    [anon_sym_thread_local] = ACTIONS(1342),
    [anon_sym___thread] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [anon_sym_constexpr] = ACTIONS(1342),
    [anon_sym_volatile] = ACTIONS(1342),
    [anon_sym_restrict] = ACTIONS(1342),
    [anon_sym___restrict__] = ACTIONS(1342),
    [anon_sym__Atomic] = ACTIONS(1342),
    [anon_sym__Noreturn] = ACTIONS(1342),
    [anon_sym_noreturn] = ACTIONS(1342),
    [sym_primitive_type] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_union] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1342),
    [anon_sym_else] = ACTIONS(1342),
    [anon_sym_switch] = ACTIONS(1342),
    [anon_sym_case] = ACTIONS(1342),
    [anon_sym_default] = ACTIONS(1342),
    [anon_sym_while] = ACTIONS(1342),
    [anon_sym_do] = ACTIONS(1342),
    [anon_sym_for] = ACTIONS(1342),
    [anon_sym_return] = ACTIONS(1342),
    [anon_sym_break] = ACTIONS(1342),
    [anon_sym_continue] = ACTIONS(1342),
    [anon_sym_goto] = ACTIONS(1342),
    [anon_sym___try] = ACTIONS(1342),
    [anon_sym___leave] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(1344),
    [anon_sym_PLUS_PLUS] = ACTIONS(1344),
    [anon_sym_sizeof] = ACTIONS(1342),
    [anon_sym___alignof__] = ACTIONS(1342),
    [anon_sym___alignof] = ACTIONS(1342),
    [anon_sym__alignof] = ACTIONS(1342),
    [anon_sym_alignof] = ACTIONS(1342),
    [anon_sym__Alignof] = ACTIONS(1342),
    [anon_sym_offsetof] = ACTIONS(1342),
    [anon_sym__Generic] = ACTIONS(1342),
    [anon_sym_asm] = ACTIONS(1342),
    [anon_sym___asm__] = ACTIONS(1342),
    [sym_number_literal] = ACTIONS(1344),
    [anon_sym_L_SQUOTE] = ACTIONS(1344),
    [anon_sym_u_SQUOTE] = ACTIONS(1344),
    [anon_sym_U_SQUOTE] = ACTIONS(1344),
    [anon_sym_u8_SQUOTE] = ACTIONS(1344),
    [anon_sym_SQUOTE] = ACTIONS(1344),
    [anon_sym_L_DQUOTE] = ACTIONS(1344),
    [anon_sym_u_DQUOTE] = ACTIONS(1344),
    [anon_sym_U_DQUOTE] = ACTIONS(1344),
    [anon_sym_u8_DQUOTE] = ACTIONS(1344),
    [anon_sym_DQUOTE] = ACTIONS(1344),
    [sym_true] = ACTIONS(1342),
    [sym_false] = ACTIONS(1342),
    [anon_sym_NULL] = ACTIONS(1342),
    [anon_sym_nullptr] = ACTIONS(1342),
    [sym_comment] = ACTIONS(3),
  },
  [344] = {
    [sym_identifier] = ACTIONS(1370),
    [aux_sym_preproc_include_token1] = ACTIONS(1370),
    [aux_sym_preproc_def_token1] = ACTIONS(1370),
    [aux_sym_preproc_if_token1] = ACTIONS(1370),
    [aux_sym_preproc_if_token2] = ACTIONS(1370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1370),
    [sym_preproc_directive] = ACTIONS(1370),
    [anon_sym_LPAREN2] = ACTIONS(1372),
    [anon_sym_BANG] = ACTIONS(1372),
    [anon_sym_TILDE] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_STAR] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1372),
    [anon_sym_SEMI] = ACTIONS(1372),
    [anon_sym___extension__] = ACTIONS(1370),
    [anon_sym_typedef] = ACTIONS(1370),
    [anon_sym_extern] = ACTIONS(1370),
    [anon_sym___attribute__] = ACTIONS(1370),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1372),
    [anon_sym___declspec] = ACTIONS(1370),
    [anon_sym___cdecl] = ACTIONS(1370),
    [anon_sym___clrcall] = ACTIONS(1370),
    [anon_sym___stdcall] = ACTIONS(1370),
    [anon_sym___fastcall] = ACTIONS(1370),
    [anon_sym___thiscall] = ACTIONS(1370),
    [anon_sym___vectorcall] = ACTIONS(1370),
    [anon_sym_LBRACE] = ACTIONS(1372),
    [anon_sym_signed] = ACTIONS(1370),
    [anon_sym_unsigned] = ACTIONS(1370),
    [anon_sym_long] = ACTIONS(1370),
    [anon_sym_short] = ACTIONS(1370),
    [anon_sym_static] = ACTIONS(1370),
    [anon_sym_auto] = ACTIONS(1370),
    [anon_sym_register] = ACTIONS(1370),
    [anon_sym_inline] = ACTIONS(1370),
    [anon_sym___inline] = ACTIONS(1370),
    [anon_sym___inline__] = ACTIONS(1370),
    [anon_sym___forceinline] = ACTIONS(1370),
    [anon_sym_thread_local] = ACTIONS(1370),
    [anon_sym___thread] = ACTIONS(1370),
    [anon_sym_const] = ACTIONS(1370),
    [anon_sym_constexpr] = ACTIONS(1370),
    [anon_sym_volatile] = ACTIONS(1370),
    [anon_sym_restrict] = ACTIONS(1370),
    [anon_sym___restrict__] = ACTIONS(1370),
    [anon_sym__Atomic] = ACTIONS(1370),
    [anon_sym__Noreturn] = ACTIONS(1370),
    [anon_sym_noreturn] = ACTIONS(1370),
    [sym_primitive_type] = ACTIONS(1370),
    [anon_sym_enum] = ACTIONS(1370),
    [anon_sym_struct] = ACTIONS(1370),
    [anon_sym_union] = ACTIONS(1370),
    [anon_sym_if] = ACTIONS(1370),
    [anon_sym_else] = ACTIONS(1370),
    [anon_sym_switch] = ACTIONS(1370),
    [anon_sym_case] = ACTIONS(1370),
    [anon_sym_default] = ACTIONS(1370),
    [anon_sym_while] = ACTIONS(1370),
    [anon_sym_do] = ACTIONS(1370),
    [anon_sym_for] = ACTIONS(1370),
    [anon_sym_return] = ACTIONS(1370),
    [anon_sym_break] = ACTIONS(1370),
    [anon_sym_continue] = ACTIONS(1370),
    [anon_sym_goto] = ACTIONS(1370),
    [anon_sym___try] = ACTIONS(1370),
    [anon_sym___leave] = ACTIONS(1370),
    [anon_sym_DASH_DASH] = ACTIONS(1372),
    [anon_sym_PLUS_PLUS] = ACTIONS(1372),
    [anon_sym_sizeof] = ACTIONS(1370),
    [anon_sym___alignof__] = ACTIONS(1370),
    [anon_sym___alignof] = ACTIONS(1370),
    [anon_sym__alignof] = ACTIONS(1370),
    [anon_sym_alignof] = ACTIONS(1370),
    [anon_sym__Alignof] = ACTIONS(1370),
    [anon_sym_offsetof] = ACTIONS(1370),
    [anon_sym__Generic] = ACTIONS(1370),
    [anon_sym_asm] = ACTIONS(1370),
    [anon_sym___asm__] = ACTIONS(1370),
    [sym_number_literal] = ACTIONS(1372),
    [anon_sym_L_SQUOTE] = ACTIONS(1372),
    [anon_sym_u_SQUOTE] = ACTIONS(1372),
    [anon_sym_U_SQUOTE] = ACTIONS(1372),
    [anon_sym_u8_SQUOTE] = ACTIONS(1372),
    [anon_sym_SQUOTE] = ACTIONS(1372),
    [anon_sym_L_DQUOTE] = ACTIONS(1372),
    [anon_sym_u_DQUOTE] = ACTIONS(1372),
    [anon_sym_U_DQUOTE] = ACTIONS(1372),
    [anon_sym_u8_DQUOTE] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1372),
    [sym_true] = ACTIONS(1370),
    [sym_false] = ACTIONS(1370),
    [anon_sym_NULL] = ACTIONS(1370),
    [anon_sym_nullptr] = ACTIONS(1370),
    [sym_comment] = ACTIONS(3),
  },
  [345] = {
    [sym_identifier] = ACTIONS(1374),
    [aux_sym_preproc_include_token1] = ACTIONS(1374),
    [aux_sym_preproc_def_token1] = ACTIONS(1374),
    [aux_sym_preproc_if_token1] = ACTIONS(1374),
    [aux_sym_preproc_if_token2] = ACTIONS(1374),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1374),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1374),
    [sym_preproc_directive] = ACTIONS(1374),
    [anon_sym_LPAREN2] = ACTIONS(1376),
    [anon_sym_BANG] = ACTIONS(1376),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_DASH] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1374),
    [anon_sym_STAR] = ACTIONS(1376),
    [anon_sym_AMP] = ACTIONS(1376),
    [anon_sym_SEMI] = ACTIONS(1376),
    [anon_sym___extension__] = ACTIONS(1374),
    [anon_sym_typedef] = ACTIONS(1374),
    [anon_sym_extern] = ACTIONS(1374),
    [anon_sym___attribute__] = ACTIONS(1374),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1376),
    [anon_sym___declspec] = ACTIONS(1374),
    [anon_sym___cdecl] = ACTIONS(1374),
    [anon_sym___clrcall] = ACTIONS(1374),
    [anon_sym___stdcall] = ACTIONS(1374),
    [anon_sym___fastcall] = ACTIONS(1374),
    [anon_sym___thiscall] = ACTIONS(1374),
    [anon_sym___vectorcall] = ACTIONS(1374),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_signed] = ACTIONS(1374),
    [anon_sym_unsigned] = ACTIONS(1374),
    [anon_sym_long] = ACTIONS(1374),
    [anon_sym_short] = ACTIONS(1374),
    [anon_sym_static] = ACTIONS(1374),
    [anon_sym_auto] = ACTIONS(1374),
    [anon_sym_register] = ACTIONS(1374),
    [anon_sym_inline] = ACTIONS(1374),
    [anon_sym___inline] = ACTIONS(1374),
    [anon_sym___inline__] = ACTIONS(1374),
    [anon_sym___forceinline] = ACTIONS(1374),
    [anon_sym_thread_local] = ACTIONS(1374),
    [anon_sym___thread] = ACTIONS(1374),
    [anon_sym_const] = ACTIONS(1374),
    [anon_sym_constexpr] = ACTIONS(1374),
    [anon_sym_volatile] = ACTIONS(1374),
    [anon_sym_restrict] = ACTIONS(1374),
    [anon_sym___restrict__] = ACTIONS(1374),
    [anon_sym__Atomic] = ACTIONS(1374),
    [anon_sym__Noreturn] = ACTIONS(1374),
    [anon_sym_noreturn] = ACTIONS(1374),
    [sym_primitive_type] = ACTIONS(1374),
    [anon_sym_enum] = ACTIONS(1374),
    [anon_sym_struct] = ACTIONS(1374),
    [anon_sym_union] = ACTIONS(1374),
    [anon_sym_if] = ACTIONS(1374),
    [anon_sym_else] = ACTIONS(1374),
    [anon_sym_switch] = ACTIONS(1374),
    [anon_sym_case] = ACTIONS(1374),
    [anon_sym_default] = ACTIONS(1374),
    [anon_sym_while] = ACTIONS(1374),
    [anon_sym_do] = ACTIONS(1374),
    [anon_sym_for] = ACTIONS(1374),
    [anon_sym_return] = ACTIONS(1374),
    [anon_sym_break] = ACTIONS(1374),
    [anon_sym_continue] = ACTIONS(1374),
    [anon_sym_goto] = ACTIONS(1374),
    [anon_sym___try] = ACTIONS(1374),
    [anon_sym___leave] = ACTIONS(1374),
    [anon_sym_DASH_DASH] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1376),
    [anon_sym_sizeof] = ACTIONS(1374),
    [anon_sym___alignof__] = ACTIONS(1374),
    [anon_sym___alignof] = ACTIONS(1374),
    [anon_sym__alignof] = ACTIONS(1374),
    [anon_sym_alignof] = ACTIONS(1374),
    [anon_sym__Alignof] = ACTIONS(1374),
    [anon_sym_offsetof] = ACTIONS(1374),
    [anon_sym__Generic] = ACTIONS(1374),
    [anon_sym_asm] = ACTIONS(1374),
    [anon_sym___asm__] = ACTIONS(1374),
    [sym_number_literal] = ACTIONS(1376),
    [anon_sym_L_SQUOTE] = ACTIONS(1376),
    [anon_sym_u_SQUOTE] = ACTIONS(1376),
    [anon_sym_U_SQUOTE] = ACTIONS(1376),
    [anon_sym_u8_SQUOTE] = ACTIONS(1376),
    [anon_sym_SQUOTE] = ACTIONS(1376),
    [anon_sym_L_DQUOTE] = ACTIONS(1376),
    [anon_sym_u_DQUOTE] = ACTIONS(1376),
    [anon_sym_U_DQUOTE] = ACTIONS(1376),
    [anon_sym_u8_DQUOTE] = ACTIONS(1376),
    [anon_sym_DQUOTE] = ACTIONS(1376),
    [sym_true] = ACTIONS(1374),
    [sym_false] = ACTIONS(1374),
    [anon_sym_NULL] = ACTIONS(1374),
    [anon_sym_nullptr] = ACTIONS(1374),
    [sym_comment] = ACTIONS(3),
  },
  [346] = {
    [ts_builtin_sym_end] = ACTIONS(1352),
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [347] = {
    [ts_builtin_sym_end] = ACTIONS(1352),
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [348] = {
    [sym_identifier] = ACTIONS(1382),
    [aux_sym_preproc_include_token1] = ACTIONS(1382),
    [aux_sym_preproc_def_token1] = ACTIONS(1382),
    [aux_sym_preproc_if_token1] = ACTIONS(1382),
    [aux_sym_preproc_if_token2] = ACTIONS(1382),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1382),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1382),
    [sym_preproc_directive] = ACTIONS(1382),
    [anon_sym_LPAREN2] = ACTIONS(1384),
    [anon_sym_BANG] = ACTIONS(1384),
    [anon_sym_TILDE] = ACTIONS(1384),
    [anon_sym_DASH] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1382),
    [anon_sym_STAR] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym___extension__] = ACTIONS(1382),
    [anon_sym_typedef] = ACTIONS(1382),
    [anon_sym_extern] = ACTIONS(1382),
    [anon_sym___attribute__] = ACTIONS(1382),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1384),
    [anon_sym___declspec] = ACTIONS(1382),
    [anon_sym___cdecl] = ACTIONS(1382),
    [anon_sym___clrcall] = ACTIONS(1382),
    [anon_sym___stdcall] = ACTIONS(1382),
    [anon_sym___fastcall] = ACTIONS(1382),
    [anon_sym___thiscall] = ACTIONS(1382),
    [anon_sym___vectorcall] = ACTIONS(1382),
    [anon_sym_LBRACE] = ACTIONS(1384),
    [anon_sym_signed] = ACTIONS(1382),
    [anon_sym_unsigned] = ACTIONS(1382),
    [anon_sym_long] = ACTIONS(1382),
    [anon_sym_short] = ACTIONS(1382),
    [anon_sym_static] = ACTIONS(1382),
    [anon_sym_auto] = ACTIONS(1382),
    [anon_sym_register] = ACTIONS(1382),
    [anon_sym_inline] = ACTIONS(1382),
    [anon_sym___inline] = ACTIONS(1382),
    [anon_sym___inline__] = ACTIONS(1382),
    [anon_sym___forceinline] = ACTIONS(1382),
    [anon_sym_thread_local] = ACTIONS(1382),
    [anon_sym___thread] = ACTIONS(1382),
    [anon_sym_const] = ACTIONS(1382),
    [anon_sym_constexpr] = ACTIONS(1382),
    [anon_sym_volatile] = ACTIONS(1382),
    [anon_sym_restrict] = ACTIONS(1382),
    [anon_sym___restrict__] = ACTIONS(1382),
    [anon_sym__Atomic] = ACTIONS(1382),
    [anon_sym__Noreturn] = ACTIONS(1382),
    [anon_sym_noreturn] = ACTIONS(1382),
    [sym_primitive_type] = ACTIONS(1382),
    [anon_sym_enum] = ACTIONS(1382),
    [anon_sym_struct] = ACTIONS(1382),
    [anon_sym_union] = ACTIONS(1382),
    [anon_sym_if] = ACTIONS(1382),
    [anon_sym_else] = ACTIONS(1382),
    [anon_sym_switch] = ACTIONS(1382),
    [anon_sym_case] = ACTIONS(1382),
    [anon_sym_default] = ACTIONS(1382),
    [anon_sym_while] = ACTIONS(1382),
    [anon_sym_do] = ACTIONS(1382),
    [anon_sym_for] = ACTIONS(1382),
    [anon_sym_return] = ACTIONS(1382),
    [anon_sym_break] = ACTIONS(1382),
    [anon_sym_continue] = ACTIONS(1382),
    [anon_sym_goto] = ACTIONS(1382),
    [anon_sym___try] = ACTIONS(1382),
    [anon_sym___leave] = ACTIONS(1382),
    [anon_sym_DASH_DASH] = ACTIONS(1384),
    [anon_sym_PLUS_PLUS] = ACTIONS(1384),
    [anon_sym_sizeof] = ACTIONS(1382),
    [anon_sym___alignof__] = ACTIONS(1382),
    [anon_sym___alignof] = ACTIONS(1382),
    [anon_sym__alignof] = ACTIONS(1382),
    [anon_sym_alignof] = ACTIONS(1382),
    [anon_sym__Alignof] = ACTIONS(1382),
    [anon_sym_offsetof] = ACTIONS(1382),
    [anon_sym__Generic] = ACTIONS(1382),
    [anon_sym_asm] = ACTIONS(1382),
    [anon_sym___asm__] = ACTIONS(1382),
    [sym_number_literal] = ACTIONS(1384),
    [anon_sym_L_SQUOTE] = ACTIONS(1384),
    [anon_sym_u_SQUOTE] = ACTIONS(1384),
    [anon_sym_U_SQUOTE] = ACTIONS(1384),
    [anon_sym_u8_SQUOTE] = ACTIONS(1384),
    [anon_sym_SQUOTE] = ACTIONS(1384),
    [anon_sym_L_DQUOTE] = ACTIONS(1384),
    [anon_sym_u_DQUOTE] = ACTIONS(1384),
    [anon_sym_U_DQUOTE] = ACTIONS(1384),
    [anon_sym_u8_DQUOTE] = ACTIONS(1384),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [sym_true] = ACTIONS(1382),
    [sym_false] = ACTIONS(1382),
    [anon_sym_NULL] = ACTIONS(1382),
    [anon_sym_nullptr] = ACTIONS(1382),
    [sym_comment] = ACTIONS(3),
  },
  [349] = {
    [sym_identifier] = ACTIONS(1386),
    [aux_sym_preproc_include_token1] = ACTIONS(1386),
    [aux_sym_preproc_def_token1] = ACTIONS(1386),
    [aux_sym_preproc_if_token1] = ACTIONS(1386),
    [aux_sym_preproc_if_token2] = ACTIONS(1386),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1386),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1386),
    [sym_preproc_directive] = ACTIONS(1386),
    [anon_sym_LPAREN2] = ACTIONS(1388),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1388),
    [anon_sym_DASH] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(1386),
    [anon_sym_STAR] = ACTIONS(1388),
    [anon_sym_AMP] = ACTIONS(1388),
    [anon_sym_SEMI] = ACTIONS(1388),
    [anon_sym___extension__] = ACTIONS(1386),
    [anon_sym_typedef] = ACTIONS(1386),
    [anon_sym_extern] = ACTIONS(1386),
    [anon_sym___attribute__] = ACTIONS(1386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1388),
    [anon_sym___declspec] = ACTIONS(1386),
    [anon_sym___cdecl] = ACTIONS(1386),
    [anon_sym___clrcall] = ACTIONS(1386),
    [anon_sym___stdcall] = ACTIONS(1386),
    [anon_sym___fastcall] = ACTIONS(1386),
    [anon_sym___thiscall] = ACTIONS(1386),
    [anon_sym___vectorcall] = ACTIONS(1386),
    [anon_sym_LBRACE] = ACTIONS(1388),
    [anon_sym_signed] = ACTIONS(1386),
    [anon_sym_unsigned] = ACTIONS(1386),
    [anon_sym_long] = ACTIONS(1386),
    [anon_sym_short] = ACTIONS(1386),
    [anon_sym_static] = ACTIONS(1386),
    [anon_sym_auto] = ACTIONS(1386),
    [anon_sym_register] = ACTIONS(1386),
    [anon_sym_inline] = ACTIONS(1386),
    [anon_sym___inline] = ACTIONS(1386),
    [anon_sym___inline__] = ACTIONS(1386),
    [anon_sym___forceinline] = ACTIONS(1386),
    [anon_sym_thread_local] = ACTIONS(1386),
    [anon_sym___thread] = ACTIONS(1386),
    [anon_sym_const] = ACTIONS(1386),
    [anon_sym_constexpr] = ACTIONS(1386),
    [anon_sym_volatile] = ACTIONS(1386),
    [anon_sym_restrict] = ACTIONS(1386),
    [anon_sym___restrict__] = ACTIONS(1386),
    [anon_sym__Atomic] = ACTIONS(1386),
    [anon_sym__Noreturn] = ACTIONS(1386),
    [anon_sym_noreturn] = ACTIONS(1386),
    [sym_primitive_type] = ACTIONS(1386),
    [anon_sym_enum] = ACTIONS(1386),
    [anon_sym_struct] = ACTIONS(1386),
    [anon_sym_union] = ACTIONS(1386),
    [anon_sym_if] = ACTIONS(1386),
    [anon_sym_else] = ACTIONS(1386),
    [anon_sym_switch] = ACTIONS(1386),
    [anon_sym_case] = ACTIONS(1386),
    [anon_sym_default] = ACTIONS(1386),
    [anon_sym_while] = ACTIONS(1386),
    [anon_sym_do] = ACTIONS(1386),
    [anon_sym_for] = ACTIONS(1386),
    [anon_sym_return] = ACTIONS(1386),
    [anon_sym_break] = ACTIONS(1386),
    [anon_sym_continue] = ACTIONS(1386),
    [anon_sym_goto] = ACTIONS(1386),
    [anon_sym___try] = ACTIONS(1386),
    [anon_sym___leave] = ACTIONS(1386),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_sizeof] = ACTIONS(1386),
    [anon_sym___alignof__] = ACTIONS(1386),
    [anon_sym___alignof] = ACTIONS(1386),
    [anon_sym__alignof] = ACTIONS(1386),
    [anon_sym_alignof] = ACTIONS(1386),
    [anon_sym__Alignof] = ACTIONS(1386),
    [anon_sym_offsetof] = ACTIONS(1386),
    [anon_sym__Generic] = ACTIONS(1386),
    [anon_sym_asm] = ACTIONS(1386),
    [anon_sym___asm__] = ACTIONS(1386),
    [sym_number_literal] = ACTIONS(1388),
    [anon_sym_L_SQUOTE] = ACTIONS(1388),
    [anon_sym_u_SQUOTE] = ACTIONS(1388),
    [anon_sym_U_SQUOTE] = ACTIONS(1388),
    [anon_sym_u8_SQUOTE] = ACTIONS(1388),
    [anon_sym_SQUOTE] = ACTIONS(1388),
    [anon_sym_L_DQUOTE] = ACTIONS(1388),
    [anon_sym_u_DQUOTE] = ACTIONS(1388),
    [anon_sym_U_DQUOTE] = ACTIONS(1388),
    [anon_sym_u8_DQUOTE] = ACTIONS(1388),
    [anon_sym_DQUOTE] = ACTIONS(1388),
    [sym_true] = ACTIONS(1386),
    [sym_false] = ACTIONS(1386),
    [anon_sym_NULL] = ACTIONS(1386),
    [anon_sym_nullptr] = ACTIONS(1386),
    [sym_comment] = ACTIONS(3),
  },
  [350] = {
    [sym_identifier] = ACTIONS(1322),
    [aux_sym_preproc_include_token1] = ACTIONS(1322),
    [aux_sym_preproc_def_token1] = ACTIONS(1322),
    [aux_sym_preproc_if_token1] = ACTIONS(1322),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1322),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1322),
    [sym_preproc_directive] = ACTIONS(1322),
    [anon_sym_LPAREN2] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(1324),
    [anon_sym_TILDE] = ACTIONS(1324),
    [anon_sym_DASH] = ACTIONS(1322),
    [anon_sym_PLUS] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(1324),
    [anon_sym_AMP] = ACTIONS(1324),
    [anon_sym_SEMI] = ACTIONS(1324),
    [anon_sym___extension__] = ACTIONS(1322),
    [anon_sym_typedef] = ACTIONS(1322),
    [anon_sym_extern] = ACTIONS(1322),
    [anon_sym___attribute__] = ACTIONS(1322),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1324),
    [anon_sym___declspec] = ACTIONS(1322),
    [anon_sym___cdecl] = ACTIONS(1322),
    [anon_sym___clrcall] = ACTIONS(1322),
    [anon_sym___stdcall] = ACTIONS(1322),
    [anon_sym___fastcall] = ACTIONS(1322),
    [anon_sym___thiscall] = ACTIONS(1322),
    [anon_sym___vectorcall] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_RBRACE] = ACTIONS(1324),
    [anon_sym_signed] = ACTIONS(1322),
    [anon_sym_unsigned] = ACTIONS(1322),
    [anon_sym_long] = ACTIONS(1322),
    [anon_sym_short] = ACTIONS(1322),
    [anon_sym_static] = ACTIONS(1322),
    [anon_sym_auto] = ACTIONS(1322),
    [anon_sym_register] = ACTIONS(1322),
    [anon_sym_inline] = ACTIONS(1322),
    [anon_sym___inline] = ACTIONS(1322),
    [anon_sym___inline__] = ACTIONS(1322),
    [anon_sym___forceinline] = ACTIONS(1322),
    [anon_sym_thread_local] = ACTIONS(1322),
    [anon_sym___thread] = ACTIONS(1322),
    [anon_sym_const] = ACTIONS(1322),
    [anon_sym_constexpr] = ACTIONS(1322),
    [anon_sym_volatile] = ACTIONS(1322),
    [anon_sym_restrict] = ACTIONS(1322),
    [anon_sym___restrict__] = ACTIONS(1322),
    [anon_sym__Atomic] = ACTIONS(1322),
    [anon_sym__Noreturn] = ACTIONS(1322),
    [anon_sym_noreturn] = ACTIONS(1322),
    [sym_primitive_type] = ACTIONS(1322),
    [anon_sym_enum] = ACTIONS(1322),
    [anon_sym_struct] = ACTIONS(1322),
    [anon_sym_union] = ACTIONS(1322),
    [anon_sym_if] = ACTIONS(1322),
    [anon_sym_else] = ACTIONS(1322),
    [anon_sym_switch] = ACTIONS(1322),
    [anon_sym_case] = ACTIONS(1322),
    [anon_sym_default] = ACTIONS(1322),
    [anon_sym_while] = ACTIONS(1322),
    [anon_sym_do] = ACTIONS(1322),
    [anon_sym_for] = ACTIONS(1322),
    [anon_sym_return] = ACTIONS(1322),
    [anon_sym_break] = ACTIONS(1322),
    [anon_sym_continue] = ACTIONS(1322),
    [anon_sym_goto] = ACTIONS(1322),
    [anon_sym___try] = ACTIONS(1322),
    [anon_sym___leave] = ACTIONS(1322),
    [anon_sym_DASH_DASH] = ACTIONS(1324),
    [anon_sym_PLUS_PLUS] = ACTIONS(1324),
    [anon_sym_sizeof] = ACTIONS(1322),
    [anon_sym___alignof__] = ACTIONS(1322),
    [anon_sym___alignof] = ACTIONS(1322),
    [anon_sym__alignof] = ACTIONS(1322),
    [anon_sym_alignof] = ACTIONS(1322),
    [anon_sym__Alignof] = ACTIONS(1322),
    [anon_sym_offsetof] = ACTIONS(1322),
    [anon_sym__Generic] = ACTIONS(1322),
    [anon_sym_asm] = ACTIONS(1322),
    [anon_sym___asm__] = ACTIONS(1322),
    [sym_number_literal] = ACTIONS(1324),
    [anon_sym_L_SQUOTE] = ACTIONS(1324),
    [anon_sym_u_SQUOTE] = ACTIONS(1324),
    [anon_sym_U_SQUOTE] = ACTIONS(1324),
    [anon_sym_u8_SQUOTE] = ACTIONS(1324),
    [anon_sym_SQUOTE] = ACTIONS(1324),
    [anon_sym_L_DQUOTE] = ACTIONS(1324),
    [anon_sym_u_DQUOTE] = ACTIONS(1324),
    [anon_sym_U_DQUOTE] = ACTIONS(1324),
    [anon_sym_u8_DQUOTE] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1324),
    [sym_true] = ACTIONS(1322),
    [sym_false] = ACTIONS(1322),
    [anon_sym_NULL] = ACTIONS(1322),
    [anon_sym_nullptr] = ACTIONS(1322),
    [sym_comment] = ACTIONS(3),
  },
  [351] = {
    [sym_identifier] = ACTIONS(1386),
    [aux_sym_preproc_include_token1] = ACTIONS(1386),
    [aux_sym_preproc_def_token1] = ACTIONS(1386),
    [aux_sym_preproc_if_token1] = ACTIONS(1386),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1386),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1386),
    [sym_preproc_directive] = ACTIONS(1386),
    [anon_sym_LPAREN2] = ACTIONS(1388),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1388),
    [anon_sym_DASH] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(1386),
    [anon_sym_STAR] = ACTIONS(1388),
    [anon_sym_AMP] = ACTIONS(1388),
    [anon_sym_SEMI] = ACTIONS(1388),
    [anon_sym___extension__] = ACTIONS(1386),
    [anon_sym_typedef] = ACTIONS(1386),
    [anon_sym_extern] = ACTIONS(1386),
    [anon_sym___attribute__] = ACTIONS(1386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1388),
    [anon_sym___declspec] = ACTIONS(1386),
    [anon_sym___cdecl] = ACTIONS(1386),
    [anon_sym___clrcall] = ACTIONS(1386),
    [anon_sym___stdcall] = ACTIONS(1386),
    [anon_sym___fastcall] = ACTIONS(1386),
    [anon_sym___thiscall] = ACTIONS(1386),
    [anon_sym___vectorcall] = ACTIONS(1386),
    [anon_sym_LBRACE] = ACTIONS(1388),
    [anon_sym_RBRACE] = ACTIONS(1388),
    [anon_sym_signed] = ACTIONS(1386),
    [anon_sym_unsigned] = ACTIONS(1386),
    [anon_sym_long] = ACTIONS(1386),
    [anon_sym_short] = ACTIONS(1386),
    [anon_sym_static] = ACTIONS(1386),
    [anon_sym_auto] = ACTIONS(1386),
    [anon_sym_register] = ACTIONS(1386),
    [anon_sym_inline] = ACTIONS(1386),
    [anon_sym___inline] = ACTIONS(1386),
    [anon_sym___inline__] = ACTIONS(1386),
    [anon_sym___forceinline] = ACTIONS(1386),
    [anon_sym_thread_local] = ACTIONS(1386),
    [anon_sym___thread] = ACTIONS(1386),
    [anon_sym_const] = ACTIONS(1386),
    [anon_sym_constexpr] = ACTIONS(1386),
    [anon_sym_volatile] = ACTIONS(1386),
    [anon_sym_restrict] = ACTIONS(1386),
    [anon_sym___restrict__] = ACTIONS(1386),
    [anon_sym__Atomic] = ACTIONS(1386),
    [anon_sym__Noreturn] = ACTIONS(1386),
    [anon_sym_noreturn] = ACTIONS(1386),
    [sym_primitive_type] = ACTIONS(1386),
    [anon_sym_enum] = ACTIONS(1386),
    [anon_sym_struct] = ACTIONS(1386),
    [anon_sym_union] = ACTIONS(1386),
    [anon_sym_if] = ACTIONS(1386),
    [anon_sym_else] = ACTIONS(1386),
    [anon_sym_switch] = ACTIONS(1386),
    [anon_sym_case] = ACTIONS(1386),
    [anon_sym_default] = ACTIONS(1386),
    [anon_sym_while] = ACTIONS(1386),
    [anon_sym_do] = ACTIONS(1386),
    [anon_sym_for] = ACTIONS(1386),
    [anon_sym_return] = ACTIONS(1386),
    [anon_sym_break] = ACTIONS(1386),
    [anon_sym_continue] = ACTIONS(1386),
    [anon_sym_goto] = ACTIONS(1386),
    [anon_sym___try] = ACTIONS(1386),
    [anon_sym___leave] = ACTIONS(1386),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_sizeof] = ACTIONS(1386),
    [anon_sym___alignof__] = ACTIONS(1386),
    [anon_sym___alignof] = ACTIONS(1386),
    [anon_sym__alignof] = ACTIONS(1386),
    [anon_sym_alignof] = ACTIONS(1386),
    [anon_sym__Alignof] = ACTIONS(1386),
    [anon_sym_offsetof] = ACTIONS(1386),
    [anon_sym__Generic] = ACTIONS(1386),
    [anon_sym_asm] = ACTIONS(1386),
    [anon_sym___asm__] = ACTIONS(1386),
    [sym_number_literal] = ACTIONS(1388),
    [anon_sym_L_SQUOTE] = ACTIONS(1388),
    [anon_sym_u_SQUOTE] = ACTIONS(1388),
    [anon_sym_U_SQUOTE] = ACTIONS(1388),
    [anon_sym_u8_SQUOTE] = ACTIONS(1388),
    [anon_sym_SQUOTE] = ACTIONS(1388),
    [anon_sym_L_DQUOTE] = ACTIONS(1388),
    [anon_sym_u_DQUOTE] = ACTIONS(1388),
    [anon_sym_U_DQUOTE] = ACTIONS(1388),
    [anon_sym_u8_DQUOTE] = ACTIONS(1388),
    [anon_sym_DQUOTE] = ACTIONS(1388),
    [sym_true] = ACTIONS(1386),
    [sym_false] = ACTIONS(1386),
    [anon_sym_NULL] = ACTIONS(1386),
    [anon_sym_nullptr] = ACTIONS(1386),
    [sym_comment] = ACTIONS(3),
  },
  [352] = {
    [sym_identifier] = ACTIONS(1390),
    [aux_sym_preproc_include_token1] = ACTIONS(1390),
    [aux_sym_preproc_def_token1] = ACTIONS(1390),
    [aux_sym_preproc_if_token1] = ACTIONS(1390),
    [aux_sym_preproc_if_token2] = ACTIONS(1390),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1390),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1390),
    [sym_preproc_directive] = ACTIONS(1390),
    [anon_sym_LPAREN2] = ACTIONS(1392),
    [anon_sym_BANG] = ACTIONS(1392),
    [anon_sym_TILDE] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_AMP] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1392),
    [anon_sym___extension__] = ACTIONS(1390),
    [anon_sym_typedef] = ACTIONS(1390),
    [anon_sym_extern] = ACTIONS(1390),
    [anon_sym___attribute__] = ACTIONS(1390),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1392),
    [anon_sym___declspec] = ACTIONS(1390),
    [anon_sym___cdecl] = ACTIONS(1390),
    [anon_sym___clrcall] = ACTIONS(1390),
    [anon_sym___stdcall] = ACTIONS(1390),
    [anon_sym___fastcall] = ACTIONS(1390),
    [anon_sym___thiscall] = ACTIONS(1390),
    [anon_sym___vectorcall] = ACTIONS(1390),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_signed] = ACTIONS(1390),
    [anon_sym_unsigned] = ACTIONS(1390),
    [anon_sym_long] = ACTIONS(1390),
    [anon_sym_short] = ACTIONS(1390),
    [anon_sym_static] = ACTIONS(1390),
    [anon_sym_auto] = ACTIONS(1390),
    [anon_sym_register] = ACTIONS(1390),
    [anon_sym_inline] = ACTIONS(1390),
    [anon_sym___inline] = ACTIONS(1390),
    [anon_sym___inline__] = ACTIONS(1390),
    [anon_sym___forceinline] = ACTIONS(1390),
    [anon_sym_thread_local] = ACTIONS(1390),
    [anon_sym___thread] = ACTIONS(1390),
    [anon_sym_const] = ACTIONS(1390),
    [anon_sym_constexpr] = ACTIONS(1390),
    [anon_sym_volatile] = ACTIONS(1390),
    [anon_sym_restrict] = ACTIONS(1390),
    [anon_sym___restrict__] = ACTIONS(1390),
    [anon_sym__Atomic] = ACTIONS(1390),
    [anon_sym__Noreturn] = ACTIONS(1390),
    [anon_sym_noreturn] = ACTIONS(1390),
    [sym_primitive_type] = ACTIONS(1390),
    [anon_sym_enum] = ACTIONS(1390),
    [anon_sym_struct] = ACTIONS(1390),
    [anon_sym_union] = ACTIONS(1390),
    [anon_sym_if] = ACTIONS(1390),
    [anon_sym_else] = ACTIONS(1390),
    [anon_sym_switch] = ACTIONS(1390),
    [anon_sym_case] = ACTIONS(1390),
    [anon_sym_default] = ACTIONS(1390),
    [anon_sym_while] = ACTIONS(1390),
    [anon_sym_do] = ACTIONS(1390),
    [anon_sym_for] = ACTIONS(1390),
    [anon_sym_return] = ACTIONS(1390),
    [anon_sym_break] = ACTIONS(1390),
    [anon_sym_continue] = ACTIONS(1390),
    [anon_sym_goto] = ACTIONS(1390),
    [anon_sym___try] = ACTIONS(1390),
    [anon_sym___leave] = ACTIONS(1390),
    [anon_sym_DASH_DASH] = ACTIONS(1392),
    [anon_sym_PLUS_PLUS] = ACTIONS(1392),
    [anon_sym_sizeof] = ACTIONS(1390),
    [anon_sym___alignof__] = ACTIONS(1390),
    [anon_sym___alignof] = ACTIONS(1390),
    [anon_sym__alignof] = ACTIONS(1390),
    [anon_sym_alignof] = ACTIONS(1390),
    [anon_sym__Alignof] = ACTIONS(1390),
    [anon_sym_offsetof] = ACTIONS(1390),
    [anon_sym__Generic] = ACTIONS(1390),
    [anon_sym_asm] = ACTIONS(1390),
    [anon_sym___asm__] = ACTIONS(1390),
    [sym_number_literal] = ACTIONS(1392),
    [anon_sym_L_SQUOTE] = ACTIONS(1392),
    [anon_sym_u_SQUOTE] = ACTIONS(1392),
    [anon_sym_U_SQUOTE] = ACTIONS(1392),
    [anon_sym_u8_SQUOTE] = ACTIONS(1392),
    [anon_sym_SQUOTE] = ACTIONS(1392),
    [anon_sym_L_DQUOTE] = ACTIONS(1392),
    [anon_sym_u_DQUOTE] = ACTIONS(1392),
    [anon_sym_U_DQUOTE] = ACTIONS(1392),
    [anon_sym_u8_DQUOTE] = ACTIONS(1392),
    [anon_sym_DQUOTE] = ACTIONS(1392),
    [sym_true] = ACTIONS(1390),
    [sym_false] = ACTIONS(1390),
    [anon_sym_NULL] = ACTIONS(1390),
    [anon_sym_nullptr] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
  },
  [353] = {
    [sym_identifier] = ACTIONS(1326),
    [aux_sym_preproc_include_token1] = ACTIONS(1326),
    [aux_sym_preproc_def_token1] = ACTIONS(1326),
    [aux_sym_preproc_if_token1] = ACTIONS(1326),
    [aux_sym_preproc_if_token2] = ACTIONS(1326),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1326),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1326),
    [sym_preproc_directive] = ACTIONS(1326),
    [anon_sym_LPAREN2] = ACTIONS(1328),
    [anon_sym_BANG] = ACTIONS(1328),
    [anon_sym_TILDE] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_PLUS] = ACTIONS(1326),
    [anon_sym_STAR] = ACTIONS(1328),
    [anon_sym_AMP] = ACTIONS(1328),
    [anon_sym_SEMI] = ACTIONS(1328),
    [anon_sym___extension__] = ACTIONS(1326),
    [anon_sym_typedef] = ACTIONS(1326),
    [anon_sym_extern] = ACTIONS(1326),
    [anon_sym___attribute__] = ACTIONS(1326),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1328),
    [anon_sym___declspec] = ACTIONS(1326),
    [anon_sym___cdecl] = ACTIONS(1326),
    [anon_sym___clrcall] = ACTIONS(1326),
    [anon_sym___stdcall] = ACTIONS(1326),
    [anon_sym___fastcall] = ACTIONS(1326),
    [anon_sym___thiscall] = ACTIONS(1326),
    [anon_sym___vectorcall] = ACTIONS(1326),
    [anon_sym_LBRACE] = ACTIONS(1328),
    [anon_sym_signed] = ACTIONS(1326),
    [anon_sym_unsigned] = ACTIONS(1326),
    [anon_sym_long] = ACTIONS(1326),
    [anon_sym_short] = ACTIONS(1326),
    [anon_sym_static] = ACTIONS(1326),
    [anon_sym_auto] = ACTIONS(1326),
    [anon_sym_register] = ACTIONS(1326),
    [anon_sym_inline] = ACTIONS(1326),
    [anon_sym___inline] = ACTIONS(1326),
    [anon_sym___inline__] = ACTIONS(1326),
    [anon_sym___forceinline] = ACTIONS(1326),
    [anon_sym_thread_local] = ACTIONS(1326),
    [anon_sym___thread] = ACTIONS(1326),
    [anon_sym_const] = ACTIONS(1326),
    [anon_sym_constexpr] = ACTIONS(1326),
    [anon_sym_volatile] = ACTIONS(1326),
    [anon_sym_restrict] = ACTIONS(1326),
    [anon_sym___restrict__] = ACTIONS(1326),
    [anon_sym__Atomic] = ACTIONS(1326),
    [anon_sym__Noreturn] = ACTIONS(1326),
    [anon_sym_noreturn] = ACTIONS(1326),
    [sym_primitive_type] = ACTIONS(1326),
    [anon_sym_enum] = ACTIONS(1326),
    [anon_sym_struct] = ACTIONS(1326),
    [anon_sym_union] = ACTIONS(1326),
    [anon_sym_if] = ACTIONS(1326),
    [anon_sym_else] = ACTIONS(1326),
    [anon_sym_switch] = ACTIONS(1326),
    [anon_sym_case] = ACTIONS(1326),
    [anon_sym_default] = ACTIONS(1326),
    [anon_sym_while] = ACTIONS(1326),
    [anon_sym_do] = ACTIONS(1326),
    [anon_sym_for] = ACTIONS(1326),
    [anon_sym_return] = ACTIONS(1326),
    [anon_sym_break] = ACTIONS(1326),
    [anon_sym_continue] = ACTIONS(1326),
    [anon_sym_goto] = ACTIONS(1326),
    [anon_sym___try] = ACTIONS(1326),
    [anon_sym___leave] = ACTIONS(1326),
    [anon_sym_DASH_DASH] = ACTIONS(1328),
    [anon_sym_PLUS_PLUS] = ACTIONS(1328),
    [anon_sym_sizeof] = ACTIONS(1326),
    [anon_sym___alignof__] = ACTIONS(1326),
    [anon_sym___alignof] = ACTIONS(1326),
    [anon_sym__alignof] = ACTIONS(1326),
    [anon_sym_alignof] = ACTIONS(1326),
    [anon_sym__Alignof] = ACTIONS(1326),
    [anon_sym_offsetof] = ACTIONS(1326),
    [anon_sym__Generic] = ACTIONS(1326),
    [anon_sym_asm] = ACTIONS(1326),
    [anon_sym___asm__] = ACTIONS(1326),
    [sym_number_literal] = ACTIONS(1328),
    [anon_sym_L_SQUOTE] = ACTIONS(1328),
    [anon_sym_u_SQUOTE] = ACTIONS(1328),
    [anon_sym_U_SQUOTE] = ACTIONS(1328),
    [anon_sym_u8_SQUOTE] = ACTIONS(1328),
    [anon_sym_SQUOTE] = ACTIONS(1328),
    [anon_sym_L_DQUOTE] = ACTIONS(1328),
    [anon_sym_u_DQUOTE] = ACTIONS(1328),
    [anon_sym_U_DQUOTE] = ACTIONS(1328),
    [anon_sym_u8_DQUOTE] = ACTIONS(1328),
    [anon_sym_DQUOTE] = ACTIONS(1328),
    [sym_true] = ACTIONS(1326),
    [sym_false] = ACTIONS(1326),
    [anon_sym_NULL] = ACTIONS(1326),
    [anon_sym_nullptr] = ACTIONS(1326),
    [sym_comment] = ACTIONS(3),
  },
  [354] = {
    [sym_identifier] = ACTIONS(1314),
    [aux_sym_preproc_include_token1] = ACTIONS(1314),
    [aux_sym_preproc_def_token1] = ACTIONS(1314),
    [aux_sym_preproc_if_token1] = ACTIONS(1314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1314),
    [sym_preproc_directive] = ACTIONS(1314),
    [anon_sym_LPAREN2] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1314),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym___extension__] = ACTIONS(1314),
    [anon_sym_typedef] = ACTIONS(1314),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym___attribute__] = ACTIONS(1314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1316),
    [anon_sym___declspec] = ACTIONS(1314),
    [anon_sym___cdecl] = ACTIONS(1314),
    [anon_sym___clrcall] = ACTIONS(1314),
    [anon_sym___stdcall] = ACTIONS(1314),
    [anon_sym___fastcall] = ACTIONS(1314),
    [anon_sym___thiscall] = ACTIONS(1314),
    [anon_sym___vectorcall] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_RBRACE] = ACTIONS(1316),
    [anon_sym_signed] = ACTIONS(1314),
    [anon_sym_unsigned] = ACTIONS(1314),
    [anon_sym_long] = ACTIONS(1314),
    [anon_sym_short] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_auto] = ACTIONS(1314),
    [anon_sym_register] = ACTIONS(1314),
    [anon_sym_inline] = ACTIONS(1314),
    [anon_sym___inline] = ACTIONS(1314),
    [anon_sym___inline__] = ACTIONS(1314),
    [anon_sym___forceinline] = ACTIONS(1314),
    [anon_sym_thread_local] = ACTIONS(1314),
    [anon_sym___thread] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_constexpr] = ACTIONS(1314),
    [anon_sym_volatile] = ACTIONS(1314),
    [anon_sym_restrict] = ACTIONS(1314),
    [anon_sym___restrict__] = ACTIONS(1314),
    [anon_sym__Atomic] = ACTIONS(1314),
    [anon_sym__Noreturn] = ACTIONS(1314),
    [anon_sym_noreturn] = ACTIONS(1314),
    [sym_primitive_type] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_else] = ACTIONS(1314),
    [anon_sym_switch] = ACTIONS(1314),
    [anon_sym_case] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [anon_sym_do] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_goto] = ACTIONS(1314),
    [anon_sym___try] = ACTIONS(1314),
    [anon_sym___leave] = ACTIONS(1314),
    [anon_sym_DASH_DASH] = ACTIONS(1316),
    [anon_sym_PLUS_PLUS] = ACTIONS(1316),
    [anon_sym_sizeof] = ACTIONS(1314),
    [anon_sym___alignof__] = ACTIONS(1314),
    [anon_sym___alignof] = ACTIONS(1314),
    [anon_sym__alignof] = ACTIONS(1314),
    [anon_sym_alignof] = ACTIONS(1314),
    [anon_sym__Alignof] = ACTIONS(1314),
    [anon_sym_offsetof] = ACTIONS(1314),
    [anon_sym__Generic] = ACTIONS(1314),
    [anon_sym_asm] = ACTIONS(1314),
    [anon_sym___asm__] = ACTIONS(1314),
    [sym_number_literal] = ACTIONS(1316),
    [anon_sym_L_SQUOTE] = ACTIONS(1316),
    [anon_sym_u_SQUOTE] = ACTIONS(1316),
    [anon_sym_U_SQUOTE] = ACTIONS(1316),
    [anon_sym_u8_SQUOTE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1316),
    [anon_sym_L_DQUOTE] = ACTIONS(1316),
    [anon_sym_u_DQUOTE] = ACTIONS(1316),
    [anon_sym_U_DQUOTE] = ACTIONS(1316),
    [anon_sym_u8_DQUOTE] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1316),
    [sym_true] = ACTIONS(1314),
    [sym_false] = ACTIONS(1314),
    [anon_sym_NULL] = ACTIONS(1314),
    [anon_sym_nullptr] = ACTIONS(1314),
    [sym_comment] = ACTIONS(3),
  },
  [355] = {
    [sym_identifier] = ACTIONS(1298),
    [aux_sym_preproc_include_token1] = ACTIONS(1298),
    [aux_sym_preproc_def_token1] = ACTIONS(1298),
    [aux_sym_preproc_if_token1] = ACTIONS(1298),
    [aux_sym_preproc_if_token2] = ACTIONS(1298),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1298),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1298),
    [sym_preproc_directive] = ACTIONS(1298),
    [anon_sym_LPAREN2] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1300),
    [anon_sym_TILDE] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1298),
    [anon_sym_PLUS] = ACTIONS(1298),
    [anon_sym_STAR] = ACTIONS(1300),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(1300),
    [anon_sym___extension__] = ACTIONS(1298),
    [anon_sym_typedef] = ACTIONS(1298),
    [anon_sym_extern] = ACTIONS(1298),
    [anon_sym___attribute__] = ACTIONS(1298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1300),
    [anon_sym___declspec] = ACTIONS(1298),
    [anon_sym___cdecl] = ACTIONS(1298),
    [anon_sym___clrcall] = ACTIONS(1298),
    [anon_sym___stdcall] = ACTIONS(1298),
    [anon_sym___fastcall] = ACTIONS(1298),
    [anon_sym___thiscall] = ACTIONS(1298),
    [anon_sym___vectorcall] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_signed] = ACTIONS(1298),
    [anon_sym_unsigned] = ACTIONS(1298),
    [anon_sym_long] = ACTIONS(1298),
    [anon_sym_short] = ACTIONS(1298),
    [anon_sym_static] = ACTIONS(1298),
    [anon_sym_auto] = ACTIONS(1298),
    [anon_sym_register] = ACTIONS(1298),
    [anon_sym_inline] = ACTIONS(1298),
    [anon_sym___inline] = ACTIONS(1298),
    [anon_sym___inline__] = ACTIONS(1298),
    [anon_sym___forceinline] = ACTIONS(1298),
    [anon_sym_thread_local] = ACTIONS(1298),
    [anon_sym___thread] = ACTIONS(1298),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_constexpr] = ACTIONS(1298),
    [anon_sym_volatile] = ACTIONS(1298),
    [anon_sym_restrict] = ACTIONS(1298),
    [anon_sym___restrict__] = ACTIONS(1298),
    [anon_sym__Atomic] = ACTIONS(1298),
    [anon_sym__Noreturn] = ACTIONS(1298),
    [anon_sym_noreturn] = ACTIONS(1298),
    [sym_primitive_type] = ACTIONS(1298),
    [anon_sym_enum] = ACTIONS(1298),
    [anon_sym_struct] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1298),
    [anon_sym_if] = ACTIONS(1298),
    [anon_sym_else] = ACTIONS(1298),
    [anon_sym_switch] = ACTIONS(1298),
    [anon_sym_case] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(1298),
    [anon_sym_do] = ACTIONS(1298),
    [anon_sym_for] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1298),
    [anon_sym_break] = ACTIONS(1298),
    [anon_sym_continue] = ACTIONS(1298),
    [anon_sym_goto] = ACTIONS(1298),
    [anon_sym___try] = ACTIONS(1298),
    [anon_sym___leave] = ACTIONS(1298),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_sizeof] = ACTIONS(1298),
    [anon_sym___alignof__] = ACTIONS(1298),
    [anon_sym___alignof] = ACTIONS(1298),
    [anon_sym__alignof] = ACTIONS(1298),
    [anon_sym_alignof] = ACTIONS(1298),
    [anon_sym__Alignof] = ACTIONS(1298),
    [anon_sym_offsetof] = ACTIONS(1298),
    [anon_sym__Generic] = ACTIONS(1298),
    [anon_sym_asm] = ACTIONS(1298),
    [anon_sym___asm__] = ACTIONS(1298),
    [sym_number_literal] = ACTIONS(1300),
    [anon_sym_L_SQUOTE] = ACTIONS(1300),
    [anon_sym_u_SQUOTE] = ACTIONS(1300),
    [anon_sym_U_SQUOTE] = ACTIONS(1300),
    [anon_sym_u8_SQUOTE] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(1300),
    [anon_sym_L_DQUOTE] = ACTIONS(1300),
    [anon_sym_u_DQUOTE] = ACTIONS(1300),
    [anon_sym_U_DQUOTE] = ACTIONS(1300),
    [anon_sym_u8_DQUOTE] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(1300),
    [sym_true] = ACTIONS(1298),
    [sym_false] = ACTIONS(1298),
    [anon_sym_NULL] = ACTIONS(1298),
    [anon_sym_nullptr] = ACTIONS(1298),
    [sym_comment] = ACTIONS(3),
  },
  [356] = {
    [sym_identifier] = ACTIONS(1298),
    [aux_sym_preproc_include_token1] = ACTIONS(1298),
    [aux_sym_preproc_def_token1] = ACTIONS(1298),
    [aux_sym_preproc_if_token1] = ACTIONS(1298),
    [aux_sym_preproc_if_token2] = ACTIONS(1298),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1298),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1298),
    [sym_preproc_directive] = ACTIONS(1298),
    [anon_sym_LPAREN2] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1300),
    [anon_sym_TILDE] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1298),
    [anon_sym_PLUS] = ACTIONS(1298),
    [anon_sym_STAR] = ACTIONS(1300),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(1300),
    [anon_sym___extension__] = ACTIONS(1298),
    [anon_sym_typedef] = ACTIONS(1298),
    [anon_sym_extern] = ACTIONS(1298),
    [anon_sym___attribute__] = ACTIONS(1298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1300),
    [anon_sym___declspec] = ACTIONS(1298),
    [anon_sym___cdecl] = ACTIONS(1298),
    [anon_sym___clrcall] = ACTIONS(1298),
    [anon_sym___stdcall] = ACTIONS(1298),
    [anon_sym___fastcall] = ACTIONS(1298),
    [anon_sym___thiscall] = ACTIONS(1298),
    [anon_sym___vectorcall] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_signed] = ACTIONS(1298),
    [anon_sym_unsigned] = ACTIONS(1298),
    [anon_sym_long] = ACTIONS(1298),
    [anon_sym_short] = ACTIONS(1298),
    [anon_sym_static] = ACTIONS(1298),
    [anon_sym_auto] = ACTIONS(1298),
    [anon_sym_register] = ACTIONS(1298),
    [anon_sym_inline] = ACTIONS(1298),
    [anon_sym___inline] = ACTIONS(1298),
    [anon_sym___inline__] = ACTIONS(1298),
    [anon_sym___forceinline] = ACTIONS(1298),
    [anon_sym_thread_local] = ACTIONS(1298),
    [anon_sym___thread] = ACTIONS(1298),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_constexpr] = ACTIONS(1298),
    [anon_sym_volatile] = ACTIONS(1298),
    [anon_sym_restrict] = ACTIONS(1298),
    [anon_sym___restrict__] = ACTIONS(1298),
    [anon_sym__Atomic] = ACTIONS(1298),
    [anon_sym__Noreturn] = ACTIONS(1298),
    [anon_sym_noreturn] = ACTIONS(1298),
    [sym_primitive_type] = ACTIONS(1298),
    [anon_sym_enum] = ACTIONS(1298),
    [anon_sym_struct] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1298),
    [anon_sym_if] = ACTIONS(1298),
    [anon_sym_else] = ACTIONS(1298),
    [anon_sym_switch] = ACTIONS(1298),
    [anon_sym_case] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(1298),
    [anon_sym_do] = ACTIONS(1298),
    [anon_sym_for] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1298),
    [anon_sym_break] = ACTIONS(1298),
    [anon_sym_continue] = ACTIONS(1298),
    [anon_sym_goto] = ACTIONS(1298),
    [anon_sym___try] = ACTIONS(1298),
    [anon_sym___leave] = ACTIONS(1298),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_sizeof] = ACTIONS(1298),
    [anon_sym___alignof__] = ACTIONS(1298),
    [anon_sym___alignof] = ACTIONS(1298),
    [anon_sym__alignof] = ACTIONS(1298),
    [anon_sym_alignof] = ACTIONS(1298),
    [anon_sym__Alignof] = ACTIONS(1298),
    [anon_sym_offsetof] = ACTIONS(1298),
    [anon_sym__Generic] = ACTIONS(1298),
    [anon_sym_asm] = ACTIONS(1298),
    [anon_sym___asm__] = ACTIONS(1298),
    [sym_number_literal] = ACTIONS(1300),
    [anon_sym_L_SQUOTE] = ACTIONS(1300),
    [anon_sym_u_SQUOTE] = ACTIONS(1300),
    [anon_sym_U_SQUOTE] = ACTIONS(1300),
    [anon_sym_u8_SQUOTE] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(1300),
    [anon_sym_L_DQUOTE] = ACTIONS(1300),
    [anon_sym_u_DQUOTE] = ACTIONS(1300),
    [anon_sym_U_DQUOTE] = ACTIONS(1300),
    [anon_sym_u8_DQUOTE] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(1300),
    [sym_true] = ACTIONS(1298),
    [sym_false] = ACTIONS(1298),
    [anon_sym_NULL] = ACTIONS(1298),
    [anon_sym_nullptr] = ACTIONS(1298),
    [sym_comment] = ACTIONS(3),
  },
  [357] = {
    [sym_identifier] = ACTIONS(1310),
    [aux_sym_preproc_include_token1] = ACTIONS(1310),
    [aux_sym_preproc_def_token1] = ACTIONS(1310),
    [aux_sym_preproc_if_token1] = ACTIONS(1310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1310),
    [sym_preproc_directive] = ACTIONS(1310),
    [anon_sym_LPAREN2] = ACTIONS(1312),
    [anon_sym_BANG] = ACTIONS(1312),
    [anon_sym_TILDE] = ACTIONS(1312),
    [anon_sym_DASH] = ACTIONS(1310),
    [anon_sym_PLUS] = ACTIONS(1310),
    [anon_sym_STAR] = ACTIONS(1312),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_SEMI] = ACTIONS(1312),
    [anon_sym___extension__] = ACTIONS(1310),
    [anon_sym_typedef] = ACTIONS(1310),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym___attribute__] = ACTIONS(1310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1312),
    [anon_sym___declspec] = ACTIONS(1310),
    [anon_sym___cdecl] = ACTIONS(1310),
    [anon_sym___clrcall] = ACTIONS(1310),
    [anon_sym___stdcall] = ACTIONS(1310),
    [anon_sym___fastcall] = ACTIONS(1310),
    [anon_sym___thiscall] = ACTIONS(1310),
    [anon_sym___vectorcall] = ACTIONS(1310),
    [anon_sym_LBRACE] = ACTIONS(1312),
    [anon_sym_RBRACE] = ACTIONS(1312),
    [anon_sym_signed] = ACTIONS(1310),
    [anon_sym_unsigned] = ACTIONS(1310),
    [anon_sym_long] = ACTIONS(1310),
    [anon_sym_short] = ACTIONS(1310),
    [anon_sym_static] = ACTIONS(1310),
    [anon_sym_auto] = ACTIONS(1310),
    [anon_sym_register] = ACTIONS(1310),
    [anon_sym_inline] = ACTIONS(1310),
    [anon_sym___inline] = ACTIONS(1310),
    [anon_sym___inline__] = ACTIONS(1310),
    [anon_sym___forceinline] = ACTIONS(1310),
    [anon_sym_thread_local] = ACTIONS(1310),
    [anon_sym___thread] = ACTIONS(1310),
    [anon_sym_const] = ACTIONS(1310),
    [anon_sym_constexpr] = ACTIONS(1310),
    [anon_sym_volatile] = ACTIONS(1310),
    [anon_sym_restrict] = ACTIONS(1310),
    [anon_sym___restrict__] = ACTIONS(1310),
    [anon_sym__Atomic] = ACTIONS(1310),
    [anon_sym__Noreturn] = ACTIONS(1310),
    [anon_sym_noreturn] = ACTIONS(1310),
    [sym_primitive_type] = ACTIONS(1310),
    [anon_sym_enum] = ACTIONS(1310),
    [anon_sym_struct] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1310),
    [anon_sym_if] = ACTIONS(1310),
    [anon_sym_else] = ACTIONS(1310),
    [anon_sym_switch] = ACTIONS(1310),
    [anon_sym_case] = ACTIONS(1310),
    [anon_sym_default] = ACTIONS(1310),
    [anon_sym_while] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1310),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_break] = ACTIONS(1310),
    [anon_sym_continue] = ACTIONS(1310),
    [anon_sym_goto] = ACTIONS(1310),
    [anon_sym___try] = ACTIONS(1310),
    [anon_sym___leave] = ACTIONS(1310),
    [anon_sym_DASH_DASH] = ACTIONS(1312),
    [anon_sym_PLUS_PLUS] = ACTIONS(1312),
    [anon_sym_sizeof] = ACTIONS(1310),
    [anon_sym___alignof__] = ACTIONS(1310),
    [anon_sym___alignof] = ACTIONS(1310),
    [anon_sym__alignof] = ACTIONS(1310),
    [anon_sym_alignof] = ACTIONS(1310),
    [anon_sym__Alignof] = ACTIONS(1310),
    [anon_sym_offsetof] = ACTIONS(1310),
    [anon_sym__Generic] = ACTIONS(1310),
    [anon_sym_asm] = ACTIONS(1310),
    [anon_sym___asm__] = ACTIONS(1310),
    [sym_number_literal] = ACTIONS(1312),
    [anon_sym_L_SQUOTE] = ACTIONS(1312),
    [anon_sym_u_SQUOTE] = ACTIONS(1312),
    [anon_sym_U_SQUOTE] = ACTIONS(1312),
    [anon_sym_u8_SQUOTE] = ACTIONS(1312),
    [anon_sym_SQUOTE] = ACTIONS(1312),
    [anon_sym_L_DQUOTE] = ACTIONS(1312),
    [anon_sym_u_DQUOTE] = ACTIONS(1312),
    [anon_sym_U_DQUOTE] = ACTIONS(1312),
    [anon_sym_u8_DQUOTE] = ACTIONS(1312),
    [anon_sym_DQUOTE] = ACTIONS(1312),
    [sym_true] = ACTIONS(1310),
    [sym_false] = ACTIONS(1310),
    [anon_sym_NULL] = ACTIONS(1310),
    [anon_sym_nullptr] = ACTIONS(1310),
    [sym_comment] = ACTIONS(3),
  },
  [358] = {
    [sym_identifier] = ACTIONS(1338),
    [aux_sym_preproc_include_token1] = ACTIONS(1338),
    [aux_sym_preproc_def_token1] = ACTIONS(1338),
    [aux_sym_preproc_if_token1] = ACTIONS(1338),
    [aux_sym_preproc_if_token2] = ACTIONS(1338),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1338),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1338),
    [sym_preproc_directive] = ACTIONS(1338),
    [anon_sym_LPAREN2] = ACTIONS(1340),
    [anon_sym_BANG] = ACTIONS(1340),
    [anon_sym_TILDE] = ACTIONS(1340),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_PLUS] = ACTIONS(1338),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_SEMI] = ACTIONS(1340),
    [anon_sym___extension__] = ACTIONS(1338),
    [anon_sym_typedef] = ACTIONS(1338),
    [anon_sym_extern] = ACTIONS(1338),
    [anon_sym___attribute__] = ACTIONS(1338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1340),
    [anon_sym___declspec] = ACTIONS(1338),
    [anon_sym___cdecl] = ACTIONS(1338),
    [anon_sym___clrcall] = ACTIONS(1338),
    [anon_sym___stdcall] = ACTIONS(1338),
    [anon_sym___fastcall] = ACTIONS(1338),
    [anon_sym___thiscall] = ACTIONS(1338),
    [anon_sym___vectorcall] = ACTIONS(1338),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_signed] = ACTIONS(1338),
    [anon_sym_unsigned] = ACTIONS(1338),
    [anon_sym_long] = ACTIONS(1338),
    [anon_sym_short] = ACTIONS(1338),
    [anon_sym_static] = ACTIONS(1338),
    [anon_sym_auto] = ACTIONS(1338),
    [anon_sym_register] = ACTIONS(1338),
    [anon_sym_inline] = ACTIONS(1338),
    [anon_sym___inline] = ACTIONS(1338),
    [anon_sym___inline__] = ACTIONS(1338),
    [anon_sym___forceinline] = ACTIONS(1338),
    [anon_sym_thread_local] = ACTIONS(1338),
    [anon_sym___thread] = ACTIONS(1338),
    [anon_sym_const] = ACTIONS(1338),
    [anon_sym_constexpr] = ACTIONS(1338),
    [anon_sym_volatile] = ACTIONS(1338),
    [anon_sym_restrict] = ACTIONS(1338),
    [anon_sym___restrict__] = ACTIONS(1338),
    [anon_sym__Atomic] = ACTIONS(1338),
    [anon_sym__Noreturn] = ACTIONS(1338),
    [anon_sym_noreturn] = ACTIONS(1338),
    [sym_primitive_type] = ACTIONS(1338),
    [anon_sym_enum] = ACTIONS(1338),
    [anon_sym_struct] = ACTIONS(1338),
    [anon_sym_union] = ACTIONS(1338),
    [anon_sym_if] = ACTIONS(1338),
    [anon_sym_else] = ACTIONS(1338),
    [anon_sym_switch] = ACTIONS(1338),
    [anon_sym_case] = ACTIONS(1338),
    [anon_sym_default] = ACTIONS(1338),
    [anon_sym_while] = ACTIONS(1338),
    [anon_sym_do] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1338),
    [anon_sym_return] = ACTIONS(1338),
    [anon_sym_break] = ACTIONS(1338),
    [anon_sym_continue] = ACTIONS(1338),
    [anon_sym_goto] = ACTIONS(1338),
    [anon_sym___try] = ACTIONS(1338),
    [anon_sym___leave] = ACTIONS(1338),
    [anon_sym_DASH_DASH] = ACTIONS(1340),
    [anon_sym_PLUS_PLUS] = ACTIONS(1340),
    [anon_sym_sizeof] = ACTIONS(1338),
    [anon_sym___alignof__] = ACTIONS(1338),
    [anon_sym___alignof] = ACTIONS(1338),
    [anon_sym__alignof] = ACTIONS(1338),
    [anon_sym_alignof] = ACTIONS(1338),
    [anon_sym__Alignof] = ACTIONS(1338),
    [anon_sym_offsetof] = ACTIONS(1338),
    [anon_sym__Generic] = ACTIONS(1338),
    [anon_sym_asm] = ACTIONS(1338),
    [anon_sym___asm__] = ACTIONS(1338),
    [sym_number_literal] = ACTIONS(1340),
    [anon_sym_L_SQUOTE] = ACTIONS(1340),
    [anon_sym_u_SQUOTE] = ACTIONS(1340),
    [anon_sym_U_SQUOTE] = ACTIONS(1340),
    [anon_sym_u8_SQUOTE] = ACTIONS(1340),
    [anon_sym_SQUOTE] = ACTIONS(1340),
    [anon_sym_L_DQUOTE] = ACTIONS(1340),
    [anon_sym_u_DQUOTE] = ACTIONS(1340),
    [anon_sym_U_DQUOTE] = ACTIONS(1340),
    [anon_sym_u8_DQUOTE] = ACTIONS(1340),
    [anon_sym_DQUOTE] = ACTIONS(1340),
    [sym_true] = ACTIONS(1338),
    [sym_false] = ACTIONS(1338),
    [anon_sym_NULL] = ACTIONS(1338),
    [anon_sym_nullptr] = ACTIONS(1338),
    [sym_comment] = ACTIONS(3),
  },
  [359] = {
    [sym_identifier] = ACTIONS(1414),
    [aux_sym_preproc_include_token1] = ACTIONS(1414),
    [aux_sym_preproc_def_token1] = ACTIONS(1414),
    [aux_sym_preproc_if_token1] = ACTIONS(1414),
    [aux_sym_preproc_if_token2] = ACTIONS(1414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1414),
    [sym_preproc_directive] = ACTIONS(1414),
    [anon_sym_LPAREN2] = ACTIONS(1416),
    [anon_sym_BANG] = ACTIONS(1416),
    [anon_sym_TILDE] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1416),
    [anon_sym_AMP] = ACTIONS(1416),
    [anon_sym_SEMI] = ACTIONS(1416),
    [anon_sym___extension__] = ACTIONS(1414),
    [anon_sym_typedef] = ACTIONS(1414),
    [anon_sym_extern] = ACTIONS(1414),
    [anon_sym___attribute__] = ACTIONS(1414),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1416),
    [anon_sym___declspec] = ACTIONS(1414),
    [anon_sym___cdecl] = ACTIONS(1414),
    [anon_sym___clrcall] = ACTIONS(1414),
    [anon_sym___stdcall] = ACTIONS(1414),
    [anon_sym___fastcall] = ACTIONS(1414),
    [anon_sym___thiscall] = ACTIONS(1414),
    [anon_sym___vectorcall] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1416),
    [anon_sym_signed] = ACTIONS(1414),
    [anon_sym_unsigned] = ACTIONS(1414),
    [anon_sym_long] = ACTIONS(1414),
    [anon_sym_short] = ACTIONS(1414),
    [anon_sym_static] = ACTIONS(1414),
    [anon_sym_auto] = ACTIONS(1414),
    [anon_sym_register] = ACTIONS(1414),
    [anon_sym_inline] = ACTIONS(1414),
    [anon_sym___inline] = ACTIONS(1414),
    [anon_sym___inline__] = ACTIONS(1414),
    [anon_sym___forceinline] = ACTIONS(1414),
    [anon_sym_thread_local] = ACTIONS(1414),
    [anon_sym___thread] = ACTIONS(1414),
    [anon_sym_const] = ACTIONS(1414),
    [anon_sym_constexpr] = ACTIONS(1414),
    [anon_sym_volatile] = ACTIONS(1414),
    [anon_sym_restrict] = ACTIONS(1414),
    [anon_sym___restrict__] = ACTIONS(1414),
    [anon_sym__Atomic] = ACTIONS(1414),
    [anon_sym__Noreturn] = ACTIONS(1414),
    [anon_sym_noreturn] = ACTIONS(1414),
    [sym_primitive_type] = ACTIONS(1414),
    [anon_sym_enum] = ACTIONS(1414),
    [anon_sym_struct] = ACTIONS(1414),
    [anon_sym_union] = ACTIONS(1414),
    [anon_sym_if] = ACTIONS(1414),
    [anon_sym_else] = ACTIONS(1414),
    [anon_sym_switch] = ACTIONS(1414),
    [anon_sym_case] = ACTIONS(1414),
    [anon_sym_default] = ACTIONS(1414),
    [anon_sym_while] = ACTIONS(1414),
    [anon_sym_do] = ACTIONS(1414),
    [anon_sym_for] = ACTIONS(1414),
    [anon_sym_return] = ACTIONS(1414),
    [anon_sym_break] = ACTIONS(1414),
    [anon_sym_continue] = ACTIONS(1414),
    [anon_sym_goto] = ACTIONS(1414),
    [anon_sym___try] = ACTIONS(1414),
    [anon_sym___leave] = ACTIONS(1414),
    [anon_sym_DASH_DASH] = ACTIONS(1416),
    [anon_sym_PLUS_PLUS] = ACTIONS(1416),
    [anon_sym_sizeof] = ACTIONS(1414),
    [anon_sym___alignof__] = ACTIONS(1414),
    [anon_sym___alignof] = ACTIONS(1414),
    [anon_sym__alignof] = ACTIONS(1414),
    [anon_sym_alignof] = ACTIONS(1414),
    [anon_sym__Alignof] = ACTIONS(1414),
    [anon_sym_offsetof] = ACTIONS(1414),
    [anon_sym__Generic] = ACTIONS(1414),
    [anon_sym_asm] = ACTIONS(1414),
    [anon_sym___asm__] = ACTIONS(1414),
    [sym_number_literal] = ACTIONS(1416),
    [anon_sym_L_SQUOTE] = ACTIONS(1416),
    [anon_sym_u_SQUOTE] = ACTIONS(1416),
    [anon_sym_U_SQUOTE] = ACTIONS(1416),
    [anon_sym_u8_SQUOTE] = ACTIONS(1416),
    [anon_sym_SQUOTE] = ACTIONS(1416),
    [anon_sym_L_DQUOTE] = ACTIONS(1416),
    [anon_sym_u_DQUOTE] = ACTIONS(1416),
    [anon_sym_U_DQUOTE] = ACTIONS(1416),
    [anon_sym_u8_DQUOTE] = ACTIONS(1416),
    [anon_sym_DQUOTE] = ACTIONS(1416),
    [sym_true] = ACTIONS(1414),
    [sym_false] = ACTIONS(1414),
    [anon_sym_NULL] = ACTIONS(1414),
    [anon_sym_nullptr] = ACTIONS(1414),
    [sym_comment] = ACTIONS(3),
  },
  [360] = {
    [sym_identifier] = ACTIONS(1414),
    [aux_sym_preproc_include_token1] = ACTIONS(1414),
    [aux_sym_preproc_def_token1] = ACTIONS(1414),
    [aux_sym_preproc_if_token1] = ACTIONS(1414),
    [aux_sym_preproc_if_token2] = ACTIONS(1414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1414),
    [sym_preproc_directive] = ACTIONS(1414),
    [anon_sym_LPAREN2] = ACTIONS(1416),
    [anon_sym_BANG] = ACTIONS(1416),
    [anon_sym_TILDE] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1416),
    [anon_sym_AMP] = ACTIONS(1416),
    [anon_sym_SEMI] = ACTIONS(1416),
    [anon_sym___extension__] = ACTIONS(1414),
    [anon_sym_typedef] = ACTIONS(1414),
    [anon_sym_extern] = ACTIONS(1414),
    [anon_sym___attribute__] = ACTIONS(1414),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1416),
    [anon_sym___declspec] = ACTIONS(1414),
    [anon_sym___cdecl] = ACTIONS(1414),
    [anon_sym___clrcall] = ACTIONS(1414),
    [anon_sym___stdcall] = ACTIONS(1414),
    [anon_sym___fastcall] = ACTIONS(1414),
    [anon_sym___thiscall] = ACTIONS(1414),
    [anon_sym___vectorcall] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1416),
    [anon_sym_signed] = ACTIONS(1414),
    [anon_sym_unsigned] = ACTIONS(1414),
    [anon_sym_long] = ACTIONS(1414),
    [anon_sym_short] = ACTIONS(1414),
    [anon_sym_static] = ACTIONS(1414),
    [anon_sym_auto] = ACTIONS(1414),
    [anon_sym_register] = ACTIONS(1414),
    [anon_sym_inline] = ACTIONS(1414),
    [anon_sym___inline] = ACTIONS(1414),
    [anon_sym___inline__] = ACTIONS(1414),
    [anon_sym___forceinline] = ACTIONS(1414),
    [anon_sym_thread_local] = ACTIONS(1414),
    [anon_sym___thread] = ACTIONS(1414),
    [anon_sym_const] = ACTIONS(1414),
    [anon_sym_constexpr] = ACTIONS(1414),
    [anon_sym_volatile] = ACTIONS(1414),
    [anon_sym_restrict] = ACTIONS(1414),
    [anon_sym___restrict__] = ACTIONS(1414),
    [anon_sym__Atomic] = ACTIONS(1414),
    [anon_sym__Noreturn] = ACTIONS(1414),
    [anon_sym_noreturn] = ACTIONS(1414),
    [sym_primitive_type] = ACTIONS(1414),
    [anon_sym_enum] = ACTIONS(1414),
    [anon_sym_struct] = ACTIONS(1414),
    [anon_sym_union] = ACTIONS(1414),
    [anon_sym_if] = ACTIONS(1414),
    [anon_sym_else] = ACTIONS(1414),
    [anon_sym_switch] = ACTIONS(1414),
    [anon_sym_case] = ACTIONS(1414),
    [anon_sym_default] = ACTIONS(1414),
    [anon_sym_while] = ACTIONS(1414),
    [anon_sym_do] = ACTIONS(1414),
    [anon_sym_for] = ACTIONS(1414),
    [anon_sym_return] = ACTIONS(1414),
    [anon_sym_break] = ACTIONS(1414),
    [anon_sym_continue] = ACTIONS(1414),
    [anon_sym_goto] = ACTIONS(1414),
    [anon_sym___try] = ACTIONS(1414),
    [anon_sym___leave] = ACTIONS(1414),
    [anon_sym_DASH_DASH] = ACTIONS(1416),
    [anon_sym_PLUS_PLUS] = ACTIONS(1416),
    [anon_sym_sizeof] = ACTIONS(1414),
    [anon_sym___alignof__] = ACTIONS(1414),
    [anon_sym___alignof] = ACTIONS(1414),
    [anon_sym__alignof] = ACTIONS(1414),
    [anon_sym_alignof] = ACTIONS(1414),
    [anon_sym__Alignof] = ACTIONS(1414),
    [anon_sym_offsetof] = ACTIONS(1414),
    [anon_sym__Generic] = ACTIONS(1414),
    [anon_sym_asm] = ACTIONS(1414),
    [anon_sym___asm__] = ACTIONS(1414),
    [sym_number_literal] = ACTIONS(1416),
    [anon_sym_L_SQUOTE] = ACTIONS(1416),
    [anon_sym_u_SQUOTE] = ACTIONS(1416),
    [anon_sym_U_SQUOTE] = ACTIONS(1416),
    [anon_sym_u8_SQUOTE] = ACTIONS(1416),
    [anon_sym_SQUOTE] = ACTIONS(1416),
    [anon_sym_L_DQUOTE] = ACTIONS(1416),
    [anon_sym_u_DQUOTE] = ACTIONS(1416),
    [anon_sym_U_DQUOTE] = ACTIONS(1416),
    [anon_sym_u8_DQUOTE] = ACTIONS(1416),
    [anon_sym_DQUOTE] = ACTIONS(1416),
    [sym_true] = ACTIONS(1414),
    [sym_false] = ACTIONS(1414),
    [anon_sym_NULL] = ACTIONS(1414),
    [anon_sym_nullptr] = ACTIONS(1414),
    [sym_comment] = ACTIONS(3),
  },
  [361] = {
    [sym_identifier] = ACTIONS(1418),
    [aux_sym_preproc_include_token1] = ACTIONS(1418),
    [aux_sym_preproc_def_token1] = ACTIONS(1418),
    [aux_sym_preproc_if_token1] = ACTIONS(1418),
    [aux_sym_preproc_if_token2] = ACTIONS(1418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1418),
    [sym_preproc_directive] = ACTIONS(1418),
    [anon_sym_LPAREN2] = ACTIONS(1420),
    [anon_sym_BANG] = ACTIONS(1420),
    [anon_sym_TILDE] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_AMP] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(1420),
    [anon_sym___extension__] = ACTIONS(1418),
    [anon_sym_typedef] = ACTIONS(1418),
    [anon_sym_extern] = ACTIONS(1418),
    [anon_sym___attribute__] = ACTIONS(1418),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1420),
    [anon_sym___declspec] = ACTIONS(1418),
    [anon_sym___cdecl] = ACTIONS(1418),
    [anon_sym___clrcall] = ACTIONS(1418),
    [anon_sym___stdcall] = ACTIONS(1418),
    [anon_sym___fastcall] = ACTIONS(1418),
    [anon_sym___thiscall] = ACTIONS(1418),
    [anon_sym___vectorcall] = ACTIONS(1418),
    [anon_sym_LBRACE] = ACTIONS(1420),
    [anon_sym_signed] = ACTIONS(1418),
    [anon_sym_unsigned] = ACTIONS(1418),
    [anon_sym_long] = ACTIONS(1418),
    [anon_sym_short] = ACTIONS(1418),
    [anon_sym_static] = ACTIONS(1418),
    [anon_sym_auto] = ACTIONS(1418),
    [anon_sym_register] = ACTIONS(1418),
    [anon_sym_inline] = ACTIONS(1418),
    [anon_sym___inline] = ACTIONS(1418),
    [anon_sym___inline__] = ACTIONS(1418),
    [anon_sym___forceinline] = ACTIONS(1418),
    [anon_sym_thread_local] = ACTIONS(1418),
    [anon_sym___thread] = ACTIONS(1418),
    [anon_sym_const] = ACTIONS(1418),
    [anon_sym_constexpr] = ACTIONS(1418),
    [anon_sym_volatile] = ACTIONS(1418),
    [anon_sym_restrict] = ACTIONS(1418),
    [anon_sym___restrict__] = ACTIONS(1418),
    [anon_sym__Atomic] = ACTIONS(1418),
    [anon_sym__Noreturn] = ACTIONS(1418),
    [anon_sym_noreturn] = ACTIONS(1418),
    [sym_primitive_type] = ACTIONS(1418),
    [anon_sym_enum] = ACTIONS(1418),
    [anon_sym_struct] = ACTIONS(1418),
    [anon_sym_union] = ACTIONS(1418),
    [anon_sym_if] = ACTIONS(1418),
    [anon_sym_else] = ACTIONS(1418),
    [anon_sym_switch] = ACTIONS(1418),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_default] = ACTIONS(1418),
    [anon_sym_while] = ACTIONS(1418),
    [anon_sym_do] = ACTIONS(1418),
    [anon_sym_for] = ACTIONS(1418),
    [anon_sym_return] = ACTIONS(1418),
    [anon_sym_break] = ACTIONS(1418),
    [anon_sym_continue] = ACTIONS(1418),
    [anon_sym_goto] = ACTIONS(1418),
    [anon_sym___try] = ACTIONS(1418),
    [anon_sym___leave] = ACTIONS(1418),
    [anon_sym_DASH_DASH] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1420),
    [anon_sym_sizeof] = ACTIONS(1418),
    [anon_sym___alignof__] = ACTIONS(1418),
    [anon_sym___alignof] = ACTIONS(1418),
    [anon_sym__alignof] = ACTIONS(1418),
    [anon_sym_alignof] = ACTIONS(1418),
    [anon_sym__Alignof] = ACTIONS(1418),
    [anon_sym_offsetof] = ACTIONS(1418),
    [anon_sym__Generic] = ACTIONS(1418),
    [anon_sym_asm] = ACTIONS(1418),
    [anon_sym___asm__] = ACTIONS(1418),
    [sym_number_literal] = ACTIONS(1420),
    [anon_sym_L_SQUOTE] = ACTIONS(1420),
    [anon_sym_u_SQUOTE] = ACTIONS(1420),
    [anon_sym_U_SQUOTE] = ACTIONS(1420),
    [anon_sym_u8_SQUOTE] = ACTIONS(1420),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [anon_sym_L_DQUOTE] = ACTIONS(1420),
    [anon_sym_u_DQUOTE] = ACTIONS(1420),
    [anon_sym_U_DQUOTE] = ACTIONS(1420),
    [anon_sym_u8_DQUOTE] = ACTIONS(1420),
    [anon_sym_DQUOTE] = ACTIONS(1420),
    [sym_true] = ACTIONS(1418),
    [sym_false] = ACTIONS(1418),
    [anon_sym_NULL] = ACTIONS(1418),
    [anon_sym_nullptr] = ACTIONS(1418),
    [sym_comment] = ACTIONS(3),
  },
  [362] = {
    [sym_identifier] = ACTIONS(1418),
    [aux_sym_preproc_include_token1] = ACTIONS(1418),
    [aux_sym_preproc_def_token1] = ACTIONS(1418),
    [aux_sym_preproc_if_token1] = ACTIONS(1418),
    [aux_sym_preproc_if_token2] = ACTIONS(1418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1418),
    [sym_preproc_directive] = ACTIONS(1418),
    [anon_sym_LPAREN2] = ACTIONS(1420),
    [anon_sym_BANG] = ACTIONS(1420),
    [anon_sym_TILDE] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_AMP] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(1420),
    [anon_sym___extension__] = ACTIONS(1418),
    [anon_sym_typedef] = ACTIONS(1418),
    [anon_sym_extern] = ACTIONS(1418),
    [anon_sym___attribute__] = ACTIONS(1418),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1420),
    [anon_sym___declspec] = ACTIONS(1418),
    [anon_sym___cdecl] = ACTIONS(1418),
    [anon_sym___clrcall] = ACTIONS(1418),
    [anon_sym___stdcall] = ACTIONS(1418),
    [anon_sym___fastcall] = ACTIONS(1418),
    [anon_sym___thiscall] = ACTIONS(1418),
    [anon_sym___vectorcall] = ACTIONS(1418),
    [anon_sym_LBRACE] = ACTIONS(1420),
    [anon_sym_signed] = ACTIONS(1418),
    [anon_sym_unsigned] = ACTIONS(1418),
    [anon_sym_long] = ACTIONS(1418),
    [anon_sym_short] = ACTIONS(1418),
    [anon_sym_static] = ACTIONS(1418),
    [anon_sym_auto] = ACTIONS(1418),
    [anon_sym_register] = ACTIONS(1418),
    [anon_sym_inline] = ACTIONS(1418),
    [anon_sym___inline] = ACTIONS(1418),
    [anon_sym___inline__] = ACTIONS(1418),
    [anon_sym___forceinline] = ACTIONS(1418),
    [anon_sym_thread_local] = ACTIONS(1418),
    [anon_sym___thread] = ACTIONS(1418),
    [anon_sym_const] = ACTIONS(1418),
    [anon_sym_constexpr] = ACTIONS(1418),
    [anon_sym_volatile] = ACTIONS(1418),
    [anon_sym_restrict] = ACTIONS(1418),
    [anon_sym___restrict__] = ACTIONS(1418),
    [anon_sym__Atomic] = ACTIONS(1418),
    [anon_sym__Noreturn] = ACTIONS(1418),
    [anon_sym_noreturn] = ACTIONS(1418),
    [sym_primitive_type] = ACTIONS(1418),
    [anon_sym_enum] = ACTIONS(1418),
    [anon_sym_struct] = ACTIONS(1418),
    [anon_sym_union] = ACTIONS(1418),
    [anon_sym_if] = ACTIONS(1418),
    [anon_sym_else] = ACTIONS(1418),
    [anon_sym_switch] = ACTIONS(1418),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_default] = ACTIONS(1418),
    [anon_sym_while] = ACTIONS(1418),
    [anon_sym_do] = ACTIONS(1418),
    [anon_sym_for] = ACTIONS(1418),
    [anon_sym_return] = ACTIONS(1418),
    [anon_sym_break] = ACTIONS(1418),
    [anon_sym_continue] = ACTIONS(1418),
    [anon_sym_goto] = ACTIONS(1418),
    [anon_sym___try] = ACTIONS(1418),
    [anon_sym___leave] = ACTIONS(1418),
    [anon_sym_DASH_DASH] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1420),
    [anon_sym_sizeof] = ACTIONS(1418),
    [anon_sym___alignof__] = ACTIONS(1418),
    [anon_sym___alignof] = ACTIONS(1418),
    [anon_sym__alignof] = ACTIONS(1418),
    [anon_sym_alignof] = ACTIONS(1418),
    [anon_sym__Alignof] = ACTIONS(1418),
    [anon_sym_offsetof] = ACTIONS(1418),
    [anon_sym__Generic] = ACTIONS(1418),
    [anon_sym_asm] = ACTIONS(1418),
    [anon_sym___asm__] = ACTIONS(1418),
    [sym_number_literal] = ACTIONS(1420),
    [anon_sym_L_SQUOTE] = ACTIONS(1420),
    [anon_sym_u_SQUOTE] = ACTIONS(1420),
    [anon_sym_U_SQUOTE] = ACTIONS(1420),
    [anon_sym_u8_SQUOTE] = ACTIONS(1420),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [anon_sym_L_DQUOTE] = ACTIONS(1420),
    [anon_sym_u_DQUOTE] = ACTIONS(1420),
    [anon_sym_U_DQUOTE] = ACTIONS(1420),
    [anon_sym_u8_DQUOTE] = ACTIONS(1420),
    [anon_sym_DQUOTE] = ACTIONS(1420),
    [sym_true] = ACTIONS(1418),
    [sym_false] = ACTIONS(1418),
    [anon_sym_NULL] = ACTIONS(1418),
    [anon_sym_nullptr] = ACTIONS(1418),
    [sym_comment] = ACTIONS(3),
  },
  [363] = {
    [sym_identifier] = ACTIONS(1378),
    [aux_sym_preproc_include_token1] = ACTIONS(1378),
    [aux_sym_preproc_def_token1] = ACTIONS(1378),
    [aux_sym_preproc_if_token1] = ACTIONS(1378),
    [aux_sym_preproc_if_token2] = ACTIONS(1378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1378),
    [sym_preproc_directive] = ACTIONS(1378),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_BANG] = ACTIONS(1380),
    [anon_sym_TILDE] = ACTIONS(1380),
    [anon_sym_DASH] = ACTIONS(1378),
    [anon_sym_PLUS] = ACTIONS(1378),
    [anon_sym_STAR] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym___extension__] = ACTIONS(1378),
    [anon_sym_typedef] = ACTIONS(1378),
    [anon_sym_extern] = ACTIONS(1378),
    [anon_sym___attribute__] = ACTIONS(1378),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1380),
    [anon_sym___declspec] = ACTIONS(1378),
    [anon_sym___cdecl] = ACTIONS(1378),
    [anon_sym___clrcall] = ACTIONS(1378),
    [anon_sym___stdcall] = ACTIONS(1378),
    [anon_sym___fastcall] = ACTIONS(1378),
    [anon_sym___thiscall] = ACTIONS(1378),
    [anon_sym___vectorcall] = ACTIONS(1378),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_signed] = ACTIONS(1378),
    [anon_sym_unsigned] = ACTIONS(1378),
    [anon_sym_long] = ACTIONS(1378),
    [anon_sym_short] = ACTIONS(1378),
    [anon_sym_static] = ACTIONS(1378),
    [anon_sym_auto] = ACTIONS(1378),
    [anon_sym_register] = ACTIONS(1378),
    [anon_sym_inline] = ACTIONS(1378),
    [anon_sym___inline] = ACTIONS(1378),
    [anon_sym___inline__] = ACTIONS(1378),
    [anon_sym___forceinline] = ACTIONS(1378),
    [anon_sym_thread_local] = ACTIONS(1378),
    [anon_sym___thread] = ACTIONS(1378),
    [anon_sym_const] = ACTIONS(1378),
    [anon_sym_constexpr] = ACTIONS(1378),
    [anon_sym_volatile] = ACTIONS(1378),
    [anon_sym_restrict] = ACTIONS(1378),
    [anon_sym___restrict__] = ACTIONS(1378),
    [anon_sym__Atomic] = ACTIONS(1378),
    [anon_sym__Noreturn] = ACTIONS(1378),
    [anon_sym_noreturn] = ACTIONS(1378),
    [sym_primitive_type] = ACTIONS(1378),
    [anon_sym_enum] = ACTIONS(1378),
    [anon_sym_struct] = ACTIONS(1378),
    [anon_sym_union] = ACTIONS(1378),
    [anon_sym_if] = ACTIONS(1378),
    [anon_sym_else] = ACTIONS(1378),
    [anon_sym_switch] = ACTIONS(1378),
    [anon_sym_case] = ACTIONS(1378),
    [anon_sym_default] = ACTIONS(1378),
    [anon_sym_while] = ACTIONS(1378),
    [anon_sym_do] = ACTIONS(1378),
    [anon_sym_for] = ACTIONS(1378),
    [anon_sym_return] = ACTIONS(1378),
    [anon_sym_break] = ACTIONS(1378),
    [anon_sym_continue] = ACTIONS(1378),
    [anon_sym_goto] = ACTIONS(1378),
    [anon_sym___try] = ACTIONS(1378),
    [anon_sym___leave] = ACTIONS(1378),
    [anon_sym_DASH_DASH] = ACTIONS(1380),
    [anon_sym_PLUS_PLUS] = ACTIONS(1380),
    [anon_sym_sizeof] = ACTIONS(1378),
    [anon_sym___alignof__] = ACTIONS(1378),
    [anon_sym___alignof] = ACTIONS(1378),
    [anon_sym__alignof] = ACTIONS(1378),
    [anon_sym_alignof] = ACTIONS(1378),
    [anon_sym__Alignof] = ACTIONS(1378),
    [anon_sym_offsetof] = ACTIONS(1378),
    [anon_sym__Generic] = ACTIONS(1378),
    [anon_sym_asm] = ACTIONS(1378),
    [anon_sym___asm__] = ACTIONS(1378),
    [sym_number_literal] = ACTIONS(1380),
    [anon_sym_L_SQUOTE] = ACTIONS(1380),
    [anon_sym_u_SQUOTE] = ACTIONS(1380),
    [anon_sym_U_SQUOTE] = ACTIONS(1380),
    [anon_sym_u8_SQUOTE] = ACTIONS(1380),
    [anon_sym_SQUOTE] = ACTIONS(1380),
    [anon_sym_L_DQUOTE] = ACTIONS(1380),
    [anon_sym_u_DQUOTE] = ACTIONS(1380),
    [anon_sym_U_DQUOTE] = ACTIONS(1380),
    [anon_sym_u8_DQUOTE] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [anon_sym_NULL] = ACTIONS(1378),
    [anon_sym_nullptr] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
  },
  [364] = {
    [sym_identifier] = ACTIONS(1378),
    [aux_sym_preproc_include_token1] = ACTIONS(1378),
    [aux_sym_preproc_def_token1] = ACTIONS(1378),
    [aux_sym_preproc_if_token1] = ACTIONS(1378),
    [aux_sym_preproc_if_token2] = ACTIONS(1378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1378),
    [sym_preproc_directive] = ACTIONS(1378),
    [anon_sym_LPAREN2] = ACTIONS(1380),
    [anon_sym_BANG] = ACTIONS(1380),
    [anon_sym_TILDE] = ACTIONS(1380),
    [anon_sym_DASH] = ACTIONS(1378),
    [anon_sym_PLUS] = ACTIONS(1378),
    [anon_sym_STAR] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym___extension__] = ACTIONS(1378),
    [anon_sym_typedef] = ACTIONS(1378),
    [anon_sym_extern] = ACTIONS(1378),
    [anon_sym___attribute__] = ACTIONS(1378),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1380),
    [anon_sym___declspec] = ACTIONS(1378),
    [anon_sym___cdecl] = ACTIONS(1378),
    [anon_sym___clrcall] = ACTIONS(1378),
    [anon_sym___stdcall] = ACTIONS(1378),
    [anon_sym___fastcall] = ACTIONS(1378),
    [anon_sym___thiscall] = ACTIONS(1378),
    [anon_sym___vectorcall] = ACTIONS(1378),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_signed] = ACTIONS(1378),
    [anon_sym_unsigned] = ACTIONS(1378),
    [anon_sym_long] = ACTIONS(1378),
    [anon_sym_short] = ACTIONS(1378),
    [anon_sym_static] = ACTIONS(1378),
    [anon_sym_auto] = ACTIONS(1378),
    [anon_sym_register] = ACTIONS(1378),
    [anon_sym_inline] = ACTIONS(1378),
    [anon_sym___inline] = ACTIONS(1378),
    [anon_sym___inline__] = ACTIONS(1378),
    [anon_sym___forceinline] = ACTIONS(1378),
    [anon_sym_thread_local] = ACTIONS(1378),
    [anon_sym___thread] = ACTIONS(1378),
    [anon_sym_const] = ACTIONS(1378),
    [anon_sym_constexpr] = ACTIONS(1378),
    [anon_sym_volatile] = ACTIONS(1378),
    [anon_sym_restrict] = ACTIONS(1378),
    [anon_sym___restrict__] = ACTIONS(1378),
    [anon_sym__Atomic] = ACTIONS(1378),
    [anon_sym__Noreturn] = ACTIONS(1378),
    [anon_sym_noreturn] = ACTIONS(1378),
    [sym_primitive_type] = ACTIONS(1378),
    [anon_sym_enum] = ACTIONS(1378),
    [anon_sym_struct] = ACTIONS(1378),
    [anon_sym_union] = ACTIONS(1378),
    [anon_sym_if] = ACTIONS(1378),
    [anon_sym_else] = ACTIONS(1378),
    [anon_sym_switch] = ACTIONS(1378),
    [anon_sym_case] = ACTIONS(1378),
    [anon_sym_default] = ACTIONS(1378),
    [anon_sym_while] = ACTIONS(1378),
    [anon_sym_do] = ACTIONS(1378),
    [anon_sym_for] = ACTIONS(1378),
    [anon_sym_return] = ACTIONS(1378),
    [anon_sym_break] = ACTIONS(1378),
    [anon_sym_continue] = ACTIONS(1378),
    [anon_sym_goto] = ACTIONS(1378),
    [anon_sym___try] = ACTIONS(1378),
    [anon_sym___leave] = ACTIONS(1378),
    [anon_sym_DASH_DASH] = ACTIONS(1380),
    [anon_sym_PLUS_PLUS] = ACTIONS(1380),
    [anon_sym_sizeof] = ACTIONS(1378),
    [anon_sym___alignof__] = ACTIONS(1378),
    [anon_sym___alignof] = ACTIONS(1378),
    [anon_sym__alignof] = ACTIONS(1378),
    [anon_sym_alignof] = ACTIONS(1378),
    [anon_sym__Alignof] = ACTIONS(1378),
    [anon_sym_offsetof] = ACTIONS(1378),
    [anon_sym__Generic] = ACTIONS(1378),
    [anon_sym_asm] = ACTIONS(1378),
    [anon_sym___asm__] = ACTIONS(1378),
    [sym_number_literal] = ACTIONS(1380),
    [anon_sym_L_SQUOTE] = ACTIONS(1380),
    [anon_sym_u_SQUOTE] = ACTIONS(1380),
    [anon_sym_U_SQUOTE] = ACTIONS(1380),
    [anon_sym_u8_SQUOTE] = ACTIONS(1380),
    [anon_sym_SQUOTE] = ACTIONS(1380),
    [anon_sym_L_DQUOTE] = ACTIONS(1380),
    [anon_sym_u_DQUOTE] = ACTIONS(1380),
    [anon_sym_U_DQUOTE] = ACTIONS(1380),
    [anon_sym_u8_DQUOTE] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [anon_sym_NULL] = ACTIONS(1378),
    [anon_sym_nullptr] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
  },
  [365] = {
    [ts_builtin_sym_end] = ACTIONS(1352),
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [366] = {
    [sym_identifier] = ACTIONS(1306),
    [aux_sym_preproc_include_token1] = ACTIONS(1306),
    [aux_sym_preproc_def_token1] = ACTIONS(1306),
    [aux_sym_preproc_if_token1] = ACTIONS(1306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1306),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1306),
    [sym_preproc_directive] = ACTIONS(1306),
    [anon_sym_LPAREN2] = ACTIONS(1308),
    [anon_sym_BANG] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(1308),
    [anon_sym_DASH] = ACTIONS(1306),
    [anon_sym_PLUS] = ACTIONS(1306),
    [anon_sym_STAR] = ACTIONS(1308),
    [anon_sym_AMP] = ACTIONS(1308),
    [anon_sym_SEMI] = ACTIONS(1308),
    [anon_sym___extension__] = ACTIONS(1306),
    [anon_sym_typedef] = ACTIONS(1306),
    [anon_sym_extern] = ACTIONS(1306),
    [anon_sym___attribute__] = ACTIONS(1306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1308),
    [anon_sym___declspec] = ACTIONS(1306),
    [anon_sym___cdecl] = ACTIONS(1306),
    [anon_sym___clrcall] = ACTIONS(1306),
    [anon_sym___stdcall] = ACTIONS(1306),
    [anon_sym___fastcall] = ACTIONS(1306),
    [anon_sym___thiscall] = ACTIONS(1306),
    [anon_sym___vectorcall] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(1308),
    [anon_sym_RBRACE] = ACTIONS(1308),
    [anon_sym_signed] = ACTIONS(1306),
    [anon_sym_unsigned] = ACTIONS(1306),
    [anon_sym_long] = ACTIONS(1306),
    [anon_sym_short] = ACTIONS(1306),
    [anon_sym_static] = ACTIONS(1306),
    [anon_sym_auto] = ACTIONS(1306),
    [anon_sym_register] = ACTIONS(1306),
    [anon_sym_inline] = ACTIONS(1306),
    [anon_sym___inline] = ACTIONS(1306),
    [anon_sym___inline__] = ACTIONS(1306),
    [anon_sym___forceinline] = ACTIONS(1306),
    [anon_sym_thread_local] = ACTIONS(1306),
    [anon_sym___thread] = ACTIONS(1306),
    [anon_sym_const] = ACTIONS(1306),
    [anon_sym_constexpr] = ACTIONS(1306),
    [anon_sym_volatile] = ACTIONS(1306),
    [anon_sym_restrict] = ACTIONS(1306),
    [anon_sym___restrict__] = ACTIONS(1306),
    [anon_sym__Atomic] = ACTIONS(1306),
    [anon_sym__Noreturn] = ACTIONS(1306),
    [anon_sym_noreturn] = ACTIONS(1306),
    [sym_primitive_type] = ACTIONS(1306),
    [anon_sym_enum] = ACTIONS(1306),
    [anon_sym_struct] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1306),
    [anon_sym_if] = ACTIONS(1306),
    [anon_sym_else] = ACTIONS(1306),
    [anon_sym_switch] = ACTIONS(1306),
    [anon_sym_case] = ACTIONS(1306),
    [anon_sym_default] = ACTIONS(1306),
    [anon_sym_while] = ACTIONS(1306),
    [anon_sym_do] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1306),
    [anon_sym_break] = ACTIONS(1306),
    [anon_sym_continue] = ACTIONS(1306),
    [anon_sym_goto] = ACTIONS(1306),
    [anon_sym___try] = ACTIONS(1306),
    [anon_sym___leave] = ACTIONS(1306),
    [anon_sym_DASH_DASH] = ACTIONS(1308),
    [anon_sym_PLUS_PLUS] = ACTIONS(1308),
    [anon_sym_sizeof] = ACTIONS(1306),
    [anon_sym___alignof__] = ACTIONS(1306),
    [anon_sym___alignof] = ACTIONS(1306),
    [anon_sym__alignof] = ACTIONS(1306),
    [anon_sym_alignof] = ACTIONS(1306),
    [anon_sym__Alignof] = ACTIONS(1306),
    [anon_sym_offsetof] = ACTIONS(1306),
    [anon_sym__Generic] = ACTIONS(1306),
    [anon_sym_asm] = ACTIONS(1306),
    [anon_sym___asm__] = ACTIONS(1306),
    [sym_number_literal] = ACTIONS(1308),
    [anon_sym_L_SQUOTE] = ACTIONS(1308),
    [anon_sym_u_SQUOTE] = ACTIONS(1308),
    [anon_sym_U_SQUOTE] = ACTIONS(1308),
    [anon_sym_u8_SQUOTE] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(1308),
    [anon_sym_L_DQUOTE] = ACTIONS(1308),
    [anon_sym_u_DQUOTE] = ACTIONS(1308),
    [anon_sym_U_DQUOTE] = ACTIONS(1308),
    [anon_sym_u8_DQUOTE] = ACTIONS(1308),
    [anon_sym_DQUOTE] = ACTIONS(1308),
    [sym_true] = ACTIONS(1306),
    [sym_false] = ACTIONS(1306),
    [anon_sym_NULL] = ACTIONS(1306),
    [anon_sym_nullptr] = ACTIONS(1306),
    [sym_comment] = ACTIONS(3),
  },
  [367] = {
    [ts_builtin_sym_end] = ACTIONS(1352),
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [368] = {
    [ts_builtin_sym_end] = ACTIONS(1352),
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [369] = {
    [ts_builtin_sym_end] = ACTIONS(1352),
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [370] = {
    [sym_identifier] = ACTIONS(1410),
    [aux_sym_preproc_include_token1] = ACTIONS(1410),
    [aux_sym_preproc_def_token1] = ACTIONS(1410),
    [aux_sym_preproc_if_token1] = ACTIONS(1410),
    [aux_sym_preproc_if_token2] = ACTIONS(1410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1410),
    [sym_preproc_directive] = ACTIONS(1410),
    [anon_sym_LPAREN2] = ACTIONS(1412),
    [anon_sym_BANG] = ACTIONS(1412),
    [anon_sym_TILDE] = ACTIONS(1412),
    [anon_sym_DASH] = ACTIONS(1410),
    [anon_sym_PLUS] = ACTIONS(1410),
    [anon_sym_STAR] = ACTIONS(1412),
    [anon_sym_AMP] = ACTIONS(1412),
    [anon_sym_SEMI] = ACTIONS(1412),
    [anon_sym___extension__] = ACTIONS(1410),
    [anon_sym_typedef] = ACTIONS(1410),
    [anon_sym_extern] = ACTIONS(1410),
    [anon_sym___attribute__] = ACTIONS(1410),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1412),
    [anon_sym___declspec] = ACTIONS(1410),
    [anon_sym___cdecl] = ACTIONS(1410),
    [anon_sym___clrcall] = ACTIONS(1410),
    [anon_sym___stdcall] = ACTIONS(1410),
    [anon_sym___fastcall] = ACTIONS(1410),
    [anon_sym___thiscall] = ACTIONS(1410),
    [anon_sym___vectorcall] = ACTIONS(1410),
    [anon_sym_LBRACE] = ACTIONS(1412),
    [anon_sym_signed] = ACTIONS(1410),
    [anon_sym_unsigned] = ACTIONS(1410),
    [anon_sym_long] = ACTIONS(1410),
    [anon_sym_short] = ACTIONS(1410),
    [anon_sym_static] = ACTIONS(1410),
    [anon_sym_auto] = ACTIONS(1410),
    [anon_sym_register] = ACTIONS(1410),
    [anon_sym_inline] = ACTIONS(1410),
    [anon_sym___inline] = ACTIONS(1410),
    [anon_sym___inline__] = ACTIONS(1410),
    [anon_sym___forceinline] = ACTIONS(1410),
    [anon_sym_thread_local] = ACTIONS(1410),
    [anon_sym___thread] = ACTIONS(1410),
    [anon_sym_const] = ACTIONS(1410),
    [anon_sym_constexpr] = ACTIONS(1410),
    [anon_sym_volatile] = ACTIONS(1410),
    [anon_sym_restrict] = ACTIONS(1410),
    [anon_sym___restrict__] = ACTIONS(1410),
    [anon_sym__Atomic] = ACTIONS(1410),
    [anon_sym__Noreturn] = ACTIONS(1410),
    [anon_sym_noreturn] = ACTIONS(1410),
    [sym_primitive_type] = ACTIONS(1410),
    [anon_sym_enum] = ACTIONS(1410),
    [anon_sym_struct] = ACTIONS(1410),
    [anon_sym_union] = ACTIONS(1410),
    [anon_sym_if] = ACTIONS(1410),
    [anon_sym_else] = ACTIONS(1410),
    [anon_sym_switch] = ACTIONS(1410),
    [anon_sym_case] = ACTIONS(1410),
    [anon_sym_default] = ACTIONS(1410),
    [anon_sym_while] = ACTIONS(1410),
    [anon_sym_do] = ACTIONS(1410),
    [anon_sym_for] = ACTIONS(1410),
    [anon_sym_return] = ACTIONS(1410),
    [anon_sym_break] = ACTIONS(1410),
    [anon_sym_continue] = ACTIONS(1410),
    [anon_sym_goto] = ACTIONS(1410),
    [anon_sym___try] = ACTIONS(1410),
    [anon_sym___leave] = ACTIONS(1410),
    [anon_sym_DASH_DASH] = ACTIONS(1412),
    [anon_sym_PLUS_PLUS] = ACTIONS(1412),
    [anon_sym_sizeof] = ACTIONS(1410),
    [anon_sym___alignof__] = ACTIONS(1410),
    [anon_sym___alignof] = ACTIONS(1410),
    [anon_sym__alignof] = ACTIONS(1410),
    [anon_sym_alignof] = ACTIONS(1410),
    [anon_sym__Alignof] = ACTIONS(1410),
    [anon_sym_offsetof] = ACTIONS(1410),
    [anon_sym__Generic] = ACTIONS(1410),
    [anon_sym_asm] = ACTIONS(1410),
    [anon_sym___asm__] = ACTIONS(1410),
    [sym_number_literal] = ACTIONS(1412),
    [anon_sym_L_SQUOTE] = ACTIONS(1412),
    [anon_sym_u_SQUOTE] = ACTIONS(1412),
    [anon_sym_U_SQUOTE] = ACTIONS(1412),
    [anon_sym_u8_SQUOTE] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(1412),
    [anon_sym_L_DQUOTE] = ACTIONS(1412),
    [anon_sym_u_DQUOTE] = ACTIONS(1412),
    [anon_sym_U_DQUOTE] = ACTIONS(1412),
    [anon_sym_u8_DQUOTE] = ACTIONS(1412),
    [anon_sym_DQUOTE] = ACTIONS(1412),
    [sym_true] = ACTIONS(1410),
    [sym_false] = ACTIONS(1410),
    [anon_sym_NULL] = ACTIONS(1410),
    [anon_sym_nullptr] = ACTIONS(1410),
    [sym_comment] = ACTIONS(3),
  },
  [371] = {
    [sym_identifier] = ACTIONS(1418),
    [aux_sym_preproc_include_token1] = ACTIONS(1418),
    [aux_sym_preproc_def_token1] = ACTIONS(1418),
    [aux_sym_preproc_if_token1] = ACTIONS(1418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1418),
    [sym_preproc_directive] = ACTIONS(1418),
    [anon_sym_LPAREN2] = ACTIONS(1420),
    [anon_sym_BANG] = ACTIONS(1420),
    [anon_sym_TILDE] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_AMP] = ACTIONS(1420),
    [anon_sym_SEMI] = ACTIONS(1420),
    [anon_sym___extension__] = ACTIONS(1418),
    [anon_sym_typedef] = ACTIONS(1418),
    [anon_sym_extern] = ACTIONS(1418),
    [anon_sym___attribute__] = ACTIONS(1418),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1420),
    [anon_sym___declspec] = ACTIONS(1418),
    [anon_sym___cdecl] = ACTIONS(1418),
    [anon_sym___clrcall] = ACTIONS(1418),
    [anon_sym___stdcall] = ACTIONS(1418),
    [anon_sym___fastcall] = ACTIONS(1418),
    [anon_sym___thiscall] = ACTIONS(1418),
    [anon_sym___vectorcall] = ACTIONS(1418),
    [anon_sym_LBRACE] = ACTIONS(1420),
    [anon_sym_RBRACE] = ACTIONS(1420),
    [anon_sym_signed] = ACTIONS(1418),
    [anon_sym_unsigned] = ACTIONS(1418),
    [anon_sym_long] = ACTIONS(1418),
    [anon_sym_short] = ACTIONS(1418),
    [anon_sym_static] = ACTIONS(1418),
    [anon_sym_auto] = ACTIONS(1418),
    [anon_sym_register] = ACTIONS(1418),
    [anon_sym_inline] = ACTIONS(1418),
    [anon_sym___inline] = ACTIONS(1418),
    [anon_sym___inline__] = ACTIONS(1418),
    [anon_sym___forceinline] = ACTIONS(1418),
    [anon_sym_thread_local] = ACTIONS(1418),
    [anon_sym___thread] = ACTIONS(1418),
    [anon_sym_const] = ACTIONS(1418),
    [anon_sym_constexpr] = ACTIONS(1418),
    [anon_sym_volatile] = ACTIONS(1418),
    [anon_sym_restrict] = ACTIONS(1418),
    [anon_sym___restrict__] = ACTIONS(1418),
    [anon_sym__Atomic] = ACTIONS(1418),
    [anon_sym__Noreturn] = ACTIONS(1418),
    [anon_sym_noreturn] = ACTIONS(1418),
    [sym_primitive_type] = ACTIONS(1418),
    [anon_sym_enum] = ACTIONS(1418),
    [anon_sym_struct] = ACTIONS(1418),
    [anon_sym_union] = ACTIONS(1418),
    [anon_sym_if] = ACTIONS(1418),
    [anon_sym_else] = ACTIONS(1418),
    [anon_sym_switch] = ACTIONS(1418),
    [anon_sym_case] = ACTIONS(1418),
    [anon_sym_default] = ACTIONS(1418),
    [anon_sym_while] = ACTIONS(1418),
    [anon_sym_do] = ACTIONS(1418),
    [anon_sym_for] = ACTIONS(1418),
    [anon_sym_return] = ACTIONS(1418),
    [anon_sym_break] = ACTIONS(1418),
    [anon_sym_continue] = ACTIONS(1418),
    [anon_sym_goto] = ACTIONS(1418),
    [anon_sym___try] = ACTIONS(1418),
    [anon_sym___leave] = ACTIONS(1418),
    [anon_sym_DASH_DASH] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1420),
    [anon_sym_sizeof] = ACTIONS(1418),
    [anon_sym___alignof__] = ACTIONS(1418),
    [anon_sym___alignof] = ACTIONS(1418),
    [anon_sym__alignof] = ACTIONS(1418),
    [anon_sym_alignof] = ACTIONS(1418),
    [anon_sym__Alignof] = ACTIONS(1418),
    [anon_sym_offsetof] = ACTIONS(1418),
    [anon_sym__Generic] = ACTIONS(1418),
    [anon_sym_asm] = ACTIONS(1418),
    [anon_sym___asm__] = ACTIONS(1418),
    [sym_number_literal] = ACTIONS(1420),
    [anon_sym_L_SQUOTE] = ACTIONS(1420),
    [anon_sym_u_SQUOTE] = ACTIONS(1420),
    [anon_sym_U_SQUOTE] = ACTIONS(1420),
    [anon_sym_u8_SQUOTE] = ACTIONS(1420),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [anon_sym_L_DQUOTE] = ACTIONS(1420),
    [anon_sym_u_DQUOTE] = ACTIONS(1420),
    [anon_sym_U_DQUOTE] = ACTIONS(1420),
    [anon_sym_u8_DQUOTE] = ACTIONS(1420),
    [anon_sym_DQUOTE] = ACTIONS(1420),
    [sym_true] = ACTIONS(1418),
    [sym_false] = ACTIONS(1418),
    [anon_sym_NULL] = ACTIONS(1418),
    [anon_sym_nullptr] = ACTIONS(1418),
    [sym_comment] = ACTIONS(3),
  },
  [372] = {
    [sym_identifier] = ACTIONS(1356),
    [aux_sym_preproc_include_token1] = ACTIONS(1356),
    [aux_sym_preproc_def_token1] = ACTIONS(1356),
    [aux_sym_preproc_if_token1] = ACTIONS(1356),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1356),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1356),
    [sym_preproc_directive] = ACTIONS(1356),
    [anon_sym_LPAREN2] = ACTIONS(1354),
    [anon_sym_BANG] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(1354),
    [anon_sym_DASH] = ACTIONS(1356),
    [anon_sym_PLUS] = ACTIONS(1356),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_AMP] = ACTIONS(1354),
    [anon_sym_SEMI] = ACTIONS(1354),
    [anon_sym___extension__] = ACTIONS(1356),
    [anon_sym_typedef] = ACTIONS(1356),
    [anon_sym_extern] = ACTIONS(1356),
    [anon_sym___attribute__] = ACTIONS(1356),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1354),
    [anon_sym___declspec] = ACTIONS(1356),
    [anon_sym___cdecl] = ACTIONS(1356),
    [anon_sym___clrcall] = ACTIONS(1356),
    [anon_sym___stdcall] = ACTIONS(1356),
    [anon_sym___fastcall] = ACTIONS(1356),
    [anon_sym___thiscall] = ACTIONS(1356),
    [anon_sym___vectorcall] = ACTIONS(1356),
    [anon_sym_LBRACE] = ACTIONS(1354),
    [anon_sym_RBRACE] = ACTIONS(1354),
    [anon_sym_signed] = ACTIONS(1356),
    [anon_sym_unsigned] = ACTIONS(1356),
    [anon_sym_long] = ACTIONS(1356),
    [anon_sym_short] = ACTIONS(1356),
    [anon_sym_static] = ACTIONS(1356),
    [anon_sym_auto] = ACTIONS(1356),
    [anon_sym_register] = ACTIONS(1356),
    [anon_sym_inline] = ACTIONS(1356),
    [anon_sym___inline] = ACTIONS(1356),
    [anon_sym___inline__] = ACTIONS(1356),
    [anon_sym___forceinline] = ACTIONS(1356),
    [anon_sym_thread_local] = ACTIONS(1356),
    [anon_sym___thread] = ACTIONS(1356),
    [anon_sym_const] = ACTIONS(1356),
    [anon_sym_constexpr] = ACTIONS(1356),
    [anon_sym_volatile] = ACTIONS(1356),
    [anon_sym_restrict] = ACTIONS(1356),
    [anon_sym___restrict__] = ACTIONS(1356),
    [anon_sym__Atomic] = ACTIONS(1356),
    [anon_sym__Noreturn] = ACTIONS(1356),
    [anon_sym_noreturn] = ACTIONS(1356),
    [sym_primitive_type] = ACTIONS(1356),
    [anon_sym_enum] = ACTIONS(1356),
    [anon_sym_struct] = ACTIONS(1356),
    [anon_sym_union] = ACTIONS(1356),
    [anon_sym_if] = ACTIONS(1356),
    [anon_sym_else] = ACTIONS(1356),
    [anon_sym_switch] = ACTIONS(1356),
    [anon_sym_case] = ACTIONS(1356),
    [anon_sym_default] = ACTIONS(1356),
    [anon_sym_while] = ACTIONS(1356),
    [anon_sym_do] = ACTIONS(1356),
    [anon_sym_for] = ACTIONS(1356),
    [anon_sym_return] = ACTIONS(1356),
    [anon_sym_break] = ACTIONS(1356),
    [anon_sym_continue] = ACTIONS(1356),
    [anon_sym_goto] = ACTIONS(1356),
    [anon_sym___try] = ACTIONS(1356),
    [anon_sym___leave] = ACTIONS(1356),
    [anon_sym_DASH_DASH] = ACTIONS(1354),
    [anon_sym_PLUS_PLUS] = ACTIONS(1354),
    [anon_sym_sizeof] = ACTIONS(1356),
    [anon_sym___alignof__] = ACTIONS(1356),
    [anon_sym___alignof] = ACTIONS(1356),
    [anon_sym__alignof] = ACTIONS(1356),
    [anon_sym_alignof] = ACTIONS(1356),
    [anon_sym__Alignof] = ACTIONS(1356),
    [anon_sym_offsetof] = ACTIONS(1356),
    [anon_sym__Generic] = ACTIONS(1356),
    [anon_sym_asm] = ACTIONS(1356),
    [anon_sym___asm__] = ACTIONS(1356),
    [sym_number_literal] = ACTIONS(1354),
    [anon_sym_L_SQUOTE] = ACTIONS(1354),
    [anon_sym_u_SQUOTE] = ACTIONS(1354),
    [anon_sym_U_SQUOTE] = ACTIONS(1354),
    [anon_sym_u8_SQUOTE] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(1354),
    [anon_sym_L_DQUOTE] = ACTIONS(1354),
    [anon_sym_u_DQUOTE] = ACTIONS(1354),
    [anon_sym_U_DQUOTE] = ACTIONS(1354),
    [anon_sym_u8_DQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1354),
    [sym_true] = ACTIONS(1356),
    [sym_false] = ACTIONS(1356),
    [anon_sym_NULL] = ACTIONS(1356),
    [anon_sym_nullptr] = ACTIONS(1356),
    [sym_comment] = ACTIONS(3),
  },
  [373] = {
    [sym_identifier] = ACTIONS(1406),
    [aux_sym_preproc_include_token1] = ACTIONS(1406),
    [aux_sym_preproc_def_token1] = ACTIONS(1406),
    [aux_sym_preproc_if_token1] = ACTIONS(1406),
    [aux_sym_preproc_if_token2] = ACTIONS(1406),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1406),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1406),
    [sym_preproc_directive] = ACTIONS(1406),
    [anon_sym_LPAREN2] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1408),
    [anon_sym_DASH] = ACTIONS(1406),
    [anon_sym_PLUS] = ACTIONS(1406),
    [anon_sym_STAR] = ACTIONS(1408),
    [anon_sym_AMP] = ACTIONS(1408),
    [anon_sym_SEMI] = ACTIONS(1408),
    [anon_sym___extension__] = ACTIONS(1406),
    [anon_sym_typedef] = ACTIONS(1406),
    [anon_sym_extern] = ACTIONS(1406),
    [anon_sym___attribute__] = ACTIONS(1406),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1408),
    [anon_sym___declspec] = ACTIONS(1406),
    [anon_sym___cdecl] = ACTIONS(1406),
    [anon_sym___clrcall] = ACTIONS(1406),
    [anon_sym___stdcall] = ACTIONS(1406),
    [anon_sym___fastcall] = ACTIONS(1406),
    [anon_sym___thiscall] = ACTIONS(1406),
    [anon_sym___vectorcall] = ACTIONS(1406),
    [anon_sym_LBRACE] = ACTIONS(1408),
    [anon_sym_signed] = ACTIONS(1406),
    [anon_sym_unsigned] = ACTIONS(1406),
    [anon_sym_long] = ACTIONS(1406),
    [anon_sym_short] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_auto] = ACTIONS(1406),
    [anon_sym_register] = ACTIONS(1406),
    [anon_sym_inline] = ACTIONS(1406),
    [anon_sym___inline] = ACTIONS(1406),
    [anon_sym___inline__] = ACTIONS(1406),
    [anon_sym___forceinline] = ACTIONS(1406),
    [anon_sym_thread_local] = ACTIONS(1406),
    [anon_sym___thread] = ACTIONS(1406),
    [anon_sym_const] = ACTIONS(1406),
    [anon_sym_constexpr] = ACTIONS(1406),
    [anon_sym_volatile] = ACTIONS(1406),
    [anon_sym_restrict] = ACTIONS(1406),
    [anon_sym___restrict__] = ACTIONS(1406),
    [anon_sym__Atomic] = ACTIONS(1406),
    [anon_sym__Noreturn] = ACTIONS(1406),
    [anon_sym_noreturn] = ACTIONS(1406),
    [sym_primitive_type] = ACTIONS(1406),
    [anon_sym_enum] = ACTIONS(1406),
    [anon_sym_struct] = ACTIONS(1406),
    [anon_sym_union] = ACTIONS(1406),
    [anon_sym_if] = ACTIONS(1406),
    [anon_sym_else] = ACTIONS(1406),
    [anon_sym_switch] = ACTIONS(1406),
    [anon_sym_case] = ACTIONS(1406),
    [anon_sym_default] = ACTIONS(1406),
    [anon_sym_while] = ACTIONS(1406),
    [anon_sym_do] = ACTIONS(1406),
    [anon_sym_for] = ACTIONS(1406),
    [anon_sym_return] = ACTIONS(1406),
    [anon_sym_break] = ACTIONS(1406),
    [anon_sym_continue] = ACTIONS(1406),
    [anon_sym_goto] = ACTIONS(1406),
    [anon_sym___try] = ACTIONS(1406),
    [anon_sym___leave] = ACTIONS(1406),
    [anon_sym_DASH_DASH] = ACTIONS(1408),
    [anon_sym_PLUS_PLUS] = ACTIONS(1408),
    [anon_sym_sizeof] = ACTIONS(1406),
    [anon_sym___alignof__] = ACTIONS(1406),
    [anon_sym___alignof] = ACTIONS(1406),
    [anon_sym__alignof] = ACTIONS(1406),
    [anon_sym_alignof] = ACTIONS(1406),
    [anon_sym__Alignof] = ACTIONS(1406),
    [anon_sym_offsetof] = ACTIONS(1406),
    [anon_sym__Generic] = ACTIONS(1406),
    [anon_sym_asm] = ACTIONS(1406),
    [anon_sym___asm__] = ACTIONS(1406),
    [sym_number_literal] = ACTIONS(1408),
    [anon_sym_L_SQUOTE] = ACTIONS(1408),
    [anon_sym_u_SQUOTE] = ACTIONS(1408),
    [anon_sym_U_SQUOTE] = ACTIONS(1408),
    [anon_sym_u8_SQUOTE] = ACTIONS(1408),
    [anon_sym_SQUOTE] = ACTIONS(1408),
    [anon_sym_L_DQUOTE] = ACTIONS(1408),
    [anon_sym_u_DQUOTE] = ACTIONS(1408),
    [anon_sym_U_DQUOTE] = ACTIONS(1408),
    [anon_sym_u8_DQUOTE] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1408),
    [sym_true] = ACTIONS(1406),
    [sym_false] = ACTIONS(1406),
    [anon_sym_NULL] = ACTIONS(1406),
    [anon_sym_nullptr] = ACTIONS(1406),
    [sym_comment] = ACTIONS(3),
  },
  [374] = {
    [ts_builtin_sym_end] = ACTIONS(1316),
    [sym_identifier] = ACTIONS(1314),
    [aux_sym_preproc_include_token1] = ACTIONS(1314),
    [aux_sym_preproc_def_token1] = ACTIONS(1314),
    [aux_sym_preproc_if_token1] = ACTIONS(1314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1314),
    [sym_preproc_directive] = ACTIONS(1314),
    [anon_sym_LPAREN2] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1314),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_SEMI] = ACTIONS(1316),
    [anon_sym___extension__] = ACTIONS(1314),
    [anon_sym_typedef] = ACTIONS(1314),
    [anon_sym_extern] = ACTIONS(1314),
    [anon_sym___attribute__] = ACTIONS(1314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1316),
    [anon_sym___declspec] = ACTIONS(1314),
    [anon_sym___cdecl] = ACTIONS(1314),
    [anon_sym___clrcall] = ACTIONS(1314),
    [anon_sym___stdcall] = ACTIONS(1314),
    [anon_sym___fastcall] = ACTIONS(1314),
    [anon_sym___thiscall] = ACTIONS(1314),
    [anon_sym___vectorcall] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_signed] = ACTIONS(1314),
    [anon_sym_unsigned] = ACTIONS(1314),
    [anon_sym_long] = ACTIONS(1314),
    [anon_sym_short] = ACTIONS(1314),
    [anon_sym_static] = ACTIONS(1314),
    [anon_sym_auto] = ACTIONS(1314),
    [anon_sym_register] = ACTIONS(1314),
    [anon_sym_inline] = ACTIONS(1314),
    [anon_sym___inline] = ACTIONS(1314),
    [anon_sym___inline__] = ACTIONS(1314),
    [anon_sym___forceinline] = ACTIONS(1314),
    [anon_sym_thread_local] = ACTIONS(1314),
    [anon_sym___thread] = ACTIONS(1314),
    [anon_sym_const] = ACTIONS(1314),
    [anon_sym_constexpr] = ACTIONS(1314),
    [anon_sym_volatile] = ACTIONS(1314),
    [anon_sym_restrict] = ACTIONS(1314),
    [anon_sym___restrict__] = ACTIONS(1314),
    [anon_sym__Atomic] = ACTIONS(1314),
    [anon_sym__Noreturn] = ACTIONS(1314),
    [anon_sym_noreturn] = ACTIONS(1314),
    [sym_primitive_type] = ACTIONS(1314),
    [anon_sym_enum] = ACTIONS(1314),
    [anon_sym_struct] = ACTIONS(1314),
    [anon_sym_union] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_else] = ACTIONS(1314),
    [anon_sym_switch] = ACTIONS(1314),
    [anon_sym_case] = ACTIONS(1314),
    [anon_sym_default] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [anon_sym_do] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_goto] = ACTIONS(1314),
    [anon_sym___try] = ACTIONS(1314),
    [anon_sym___leave] = ACTIONS(1314),
    [anon_sym_DASH_DASH] = ACTIONS(1316),
    [anon_sym_PLUS_PLUS] = ACTIONS(1316),
    [anon_sym_sizeof] = ACTIONS(1314),
    [anon_sym___alignof__] = ACTIONS(1314),
    [anon_sym___alignof] = ACTIONS(1314),
    [anon_sym__alignof] = ACTIONS(1314),
    [anon_sym_alignof] = ACTIONS(1314),
    [anon_sym__Alignof] = ACTIONS(1314),
    [anon_sym_offsetof] = ACTIONS(1314),
    [anon_sym__Generic] = ACTIONS(1314),
    [anon_sym_asm] = ACTIONS(1314),
    [anon_sym___asm__] = ACTIONS(1314),
    [sym_number_literal] = ACTIONS(1316),
    [anon_sym_L_SQUOTE] = ACTIONS(1316),
    [anon_sym_u_SQUOTE] = ACTIONS(1316),
    [anon_sym_U_SQUOTE] = ACTIONS(1316),
    [anon_sym_u8_SQUOTE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1316),
    [anon_sym_L_DQUOTE] = ACTIONS(1316),
    [anon_sym_u_DQUOTE] = ACTIONS(1316),
    [anon_sym_U_DQUOTE] = ACTIONS(1316),
    [anon_sym_u8_DQUOTE] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1316),
    [sym_true] = ACTIONS(1314),
    [sym_false] = ACTIONS(1314),
    [anon_sym_NULL] = ACTIONS(1314),
    [anon_sym_nullptr] = ACTIONS(1314),
    [sym_comment] = ACTIONS(3),
  },
  [375] = {
    [ts_builtin_sym_end] = ACTIONS(1312),
    [sym_identifier] = ACTIONS(1310),
    [aux_sym_preproc_include_token1] = ACTIONS(1310),
    [aux_sym_preproc_def_token1] = ACTIONS(1310),
    [aux_sym_preproc_if_token1] = ACTIONS(1310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1310),
    [sym_preproc_directive] = ACTIONS(1310),
    [anon_sym_LPAREN2] = ACTIONS(1312),
    [anon_sym_BANG] = ACTIONS(1312),
    [anon_sym_TILDE] = ACTIONS(1312),
    [anon_sym_DASH] = ACTIONS(1310),
    [anon_sym_PLUS] = ACTIONS(1310),
    [anon_sym_STAR] = ACTIONS(1312),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_SEMI] = ACTIONS(1312),
    [anon_sym___extension__] = ACTIONS(1310),
    [anon_sym_typedef] = ACTIONS(1310),
    [anon_sym_extern] = ACTIONS(1310),
    [anon_sym___attribute__] = ACTIONS(1310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1312),
    [anon_sym___declspec] = ACTIONS(1310),
    [anon_sym___cdecl] = ACTIONS(1310),
    [anon_sym___clrcall] = ACTIONS(1310),
    [anon_sym___stdcall] = ACTIONS(1310),
    [anon_sym___fastcall] = ACTIONS(1310),
    [anon_sym___thiscall] = ACTIONS(1310),
    [anon_sym___vectorcall] = ACTIONS(1310),
    [anon_sym_LBRACE] = ACTIONS(1312),
    [anon_sym_signed] = ACTIONS(1310),
    [anon_sym_unsigned] = ACTIONS(1310),
    [anon_sym_long] = ACTIONS(1310),
    [anon_sym_short] = ACTIONS(1310),
    [anon_sym_static] = ACTIONS(1310),
    [anon_sym_auto] = ACTIONS(1310),
    [anon_sym_register] = ACTIONS(1310),
    [anon_sym_inline] = ACTIONS(1310),
    [anon_sym___inline] = ACTIONS(1310),
    [anon_sym___inline__] = ACTIONS(1310),
    [anon_sym___forceinline] = ACTIONS(1310),
    [anon_sym_thread_local] = ACTIONS(1310),
    [anon_sym___thread] = ACTIONS(1310),
    [anon_sym_const] = ACTIONS(1310),
    [anon_sym_constexpr] = ACTIONS(1310),
    [anon_sym_volatile] = ACTIONS(1310),
    [anon_sym_restrict] = ACTIONS(1310),
    [anon_sym___restrict__] = ACTIONS(1310),
    [anon_sym__Atomic] = ACTIONS(1310),
    [anon_sym__Noreturn] = ACTIONS(1310),
    [anon_sym_noreturn] = ACTIONS(1310),
    [sym_primitive_type] = ACTIONS(1310),
    [anon_sym_enum] = ACTIONS(1310),
    [anon_sym_struct] = ACTIONS(1310),
    [anon_sym_union] = ACTIONS(1310),
    [anon_sym_if] = ACTIONS(1310),
    [anon_sym_else] = ACTIONS(1310),
    [anon_sym_switch] = ACTIONS(1310),
    [anon_sym_case] = ACTIONS(1310),
    [anon_sym_default] = ACTIONS(1310),
    [anon_sym_while] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1310),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_break] = ACTIONS(1310),
    [anon_sym_continue] = ACTIONS(1310),
    [anon_sym_goto] = ACTIONS(1310),
    [anon_sym___try] = ACTIONS(1310),
    [anon_sym___leave] = ACTIONS(1310),
    [anon_sym_DASH_DASH] = ACTIONS(1312),
    [anon_sym_PLUS_PLUS] = ACTIONS(1312),
    [anon_sym_sizeof] = ACTIONS(1310),
    [anon_sym___alignof__] = ACTIONS(1310),
    [anon_sym___alignof] = ACTIONS(1310),
    [anon_sym__alignof] = ACTIONS(1310),
    [anon_sym_alignof] = ACTIONS(1310),
    [anon_sym__Alignof] = ACTIONS(1310),
    [anon_sym_offsetof] = ACTIONS(1310),
    [anon_sym__Generic] = ACTIONS(1310),
    [anon_sym_asm] = ACTIONS(1310),
    [anon_sym___asm__] = ACTIONS(1310),
    [sym_number_literal] = ACTIONS(1312),
    [anon_sym_L_SQUOTE] = ACTIONS(1312),
    [anon_sym_u_SQUOTE] = ACTIONS(1312),
    [anon_sym_U_SQUOTE] = ACTIONS(1312),
    [anon_sym_u8_SQUOTE] = ACTIONS(1312),
    [anon_sym_SQUOTE] = ACTIONS(1312),
    [anon_sym_L_DQUOTE] = ACTIONS(1312),
    [anon_sym_u_DQUOTE] = ACTIONS(1312),
    [anon_sym_U_DQUOTE] = ACTIONS(1312),
    [anon_sym_u8_DQUOTE] = ACTIONS(1312),
    [anon_sym_DQUOTE] = ACTIONS(1312),
    [sym_true] = ACTIONS(1310),
    [sym_false] = ACTIONS(1310),
    [anon_sym_NULL] = ACTIONS(1310),
    [anon_sym_nullptr] = ACTIONS(1310),
    [sym_comment] = ACTIONS(3),
  },
  [376] = {
    [ts_builtin_sym_end] = ACTIONS(1308),
    [sym_identifier] = ACTIONS(1306),
    [aux_sym_preproc_include_token1] = ACTIONS(1306),
    [aux_sym_preproc_def_token1] = ACTIONS(1306),
    [aux_sym_preproc_if_token1] = ACTIONS(1306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1306),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1306),
    [sym_preproc_directive] = ACTIONS(1306),
    [anon_sym_LPAREN2] = ACTIONS(1308),
    [anon_sym_BANG] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(1308),
    [anon_sym_DASH] = ACTIONS(1306),
    [anon_sym_PLUS] = ACTIONS(1306),
    [anon_sym_STAR] = ACTIONS(1308),
    [anon_sym_AMP] = ACTIONS(1308),
    [anon_sym_SEMI] = ACTIONS(1308),
    [anon_sym___extension__] = ACTIONS(1306),
    [anon_sym_typedef] = ACTIONS(1306),
    [anon_sym_extern] = ACTIONS(1306),
    [anon_sym___attribute__] = ACTIONS(1306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1308),
    [anon_sym___declspec] = ACTIONS(1306),
    [anon_sym___cdecl] = ACTIONS(1306),
    [anon_sym___clrcall] = ACTIONS(1306),
    [anon_sym___stdcall] = ACTIONS(1306),
    [anon_sym___fastcall] = ACTIONS(1306),
    [anon_sym___thiscall] = ACTIONS(1306),
    [anon_sym___vectorcall] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(1308),
    [anon_sym_signed] = ACTIONS(1306),
    [anon_sym_unsigned] = ACTIONS(1306),
    [anon_sym_long] = ACTIONS(1306),
    [anon_sym_short] = ACTIONS(1306),
    [anon_sym_static] = ACTIONS(1306),
    [anon_sym_auto] = ACTIONS(1306),
    [anon_sym_register] = ACTIONS(1306),
    [anon_sym_inline] = ACTIONS(1306),
    [anon_sym___inline] = ACTIONS(1306),
    [anon_sym___inline__] = ACTIONS(1306),
    [anon_sym___forceinline] = ACTIONS(1306),
    [anon_sym_thread_local] = ACTIONS(1306),
    [anon_sym___thread] = ACTIONS(1306),
    [anon_sym_const] = ACTIONS(1306),
    [anon_sym_constexpr] = ACTIONS(1306),
    [anon_sym_volatile] = ACTIONS(1306),
    [anon_sym_restrict] = ACTIONS(1306),
    [anon_sym___restrict__] = ACTIONS(1306),
    [anon_sym__Atomic] = ACTIONS(1306),
    [anon_sym__Noreturn] = ACTIONS(1306),
    [anon_sym_noreturn] = ACTIONS(1306),
    [sym_primitive_type] = ACTIONS(1306),
    [anon_sym_enum] = ACTIONS(1306),
    [anon_sym_struct] = ACTIONS(1306),
    [anon_sym_union] = ACTIONS(1306),
    [anon_sym_if] = ACTIONS(1306),
    [anon_sym_else] = ACTIONS(1306),
    [anon_sym_switch] = ACTIONS(1306),
    [anon_sym_case] = ACTIONS(1306),
    [anon_sym_default] = ACTIONS(1306),
    [anon_sym_while] = ACTIONS(1306),
    [anon_sym_do] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1306),
    [anon_sym_break] = ACTIONS(1306),
    [anon_sym_continue] = ACTIONS(1306),
    [anon_sym_goto] = ACTIONS(1306),
    [anon_sym___try] = ACTIONS(1306),
    [anon_sym___leave] = ACTIONS(1306),
    [anon_sym_DASH_DASH] = ACTIONS(1308),
    [anon_sym_PLUS_PLUS] = ACTIONS(1308),
    [anon_sym_sizeof] = ACTIONS(1306),
    [anon_sym___alignof__] = ACTIONS(1306),
    [anon_sym___alignof] = ACTIONS(1306),
    [anon_sym__alignof] = ACTIONS(1306),
    [anon_sym_alignof] = ACTIONS(1306),
    [anon_sym__Alignof] = ACTIONS(1306),
    [anon_sym_offsetof] = ACTIONS(1306),
    [anon_sym__Generic] = ACTIONS(1306),
    [anon_sym_asm] = ACTIONS(1306),
    [anon_sym___asm__] = ACTIONS(1306),
    [sym_number_literal] = ACTIONS(1308),
    [anon_sym_L_SQUOTE] = ACTIONS(1308),
    [anon_sym_u_SQUOTE] = ACTIONS(1308),
    [anon_sym_U_SQUOTE] = ACTIONS(1308),
    [anon_sym_u8_SQUOTE] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(1308),
    [anon_sym_L_DQUOTE] = ACTIONS(1308),
    [anon_sym_u_DQUOTE] = ACTIONS(1308),
    [anon_sym_U_DQUOTE] = ACTIONS(1308),
    [anon_sym_u8_DQUOTE] = ACTIONS(1308),
    [anon_sym_DQUOTE] = ACTIONS(1308),
    [sym_true] = ACTIONS(1306),
    [sym_false] = ACTIONS(1306),
    [anon_sym_NULL] = ACTIONS(1306),
    [anon_sym_nullptr] = ACTIONS(1306),
    [sym_comment] = ACTIONS(3),
  },
  [377] = {
    [ts_builtin_sym_end] = ACTIONS(1340),
    [sym_identifier] = ACTIONS(1338),
    [aux_sym_preproc_include_token1] = ACTIONS(1338),
    [aux_sym_preproc_def_token1] = ACTIONS(1338),
    [aux_sym_preproc_if_token1] = ACTIONS(1338),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1338),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1338),
    [sym_preproc_directive] = ACTIONS(1338),
    [anon_sym_LPAREN2] = ACTIONS(1340),
    [anon_sym_BANG] = ACTIONS(1340),
    [anon_sym_TILDE] = ACTIONS(1340),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_PLUS] = ACTIONS(1338),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_SEMI] = ACTIONS(1340),
    [anon_sym___extension__] = ACTIONS(1338),
    [anon_sym_typedef] = ACTIONS(1338),
    [anon_sym_extern] = ACTIONS(1338),
    [anon_sym___attribute__] = ACTIONS(1338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1340),
    [anon_sym___declspec] = ACTIONS(1338),
    [anon_sym___cdecl] = ACTIONS(1338),
    [anon_sym___clrcall] = ACTIONS(1338),
    [anon_sym___stdcall] = ACTIONS(1338),
    [anon_sym___fastcall] = ACTIONS(1338),
    [anon_sym___thiscall] = ACTIONS(1338),
    [anon_sym___vectorcall] = ACTIONS(1338),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_signed] = ACTIONS(1338),
    [anon_sym_unsigned] = ACTIONS(1338),
    [anon_sym_long] = ACTIONS(1338),
    [anon_sym_short] = ACTIONS(1338),
    [anon_sym_static] = ACTIONS(1338),
    [anon_sym_auto] = ACTIONS(1338),
    [anon_sym_register] = ACTIONS(1338),
    [anon_sym_inline] = ACTIONS(1338),
    [anon_sym___inline] = ACTIONS(1338),
    [anon_sym___inline__] = ACTIONS(1338),
    [anon_sym___forceinline] = ACTIONS(1338),
    [anon_sym_thread_local] = ACTIONS(1338),
    [anon_sym___thread] = ACTIONS(1338),
    [anon_sym_const] = ACTIONS(1338),
    [anon_sym_constexpr] = ACTIONS(1338),
    [anon_sym_volatile] = ACTIONS(1338),
    [anon_sym_restrict] = ACTIONS(1338),
    [anon_sym___restrict__] = ACTIONS(1338),
    [anon_sym__Atomic] = ACTIONS(1338),
    [anon_sym__Noreturn] = ACTIONS(1338),
    [anon_sym_noreturn] = ACTIONS(1338),
    [sym_primitive_type] = ACTIONS(1338),
    [anon_sym_enum] = ACTIONS(1338),
    [anon_sym_struct] = ACTIONS(1338),
    [anon_sym_union] = ACTIONS(1338),
    [anon_sym_if] = ACTIONS(1338),
    [anon_sym_else] = ACTIONS(1338),
    [anon_sym_switch] = ACTIONS(1338),
    [anon_sym_case] = ACTIONS(1338),
    [anon_sym_default] = ACTIONS(1338),
    [anon_sym_while] = ACTIONS(1338),
    [anon_sym_do] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1338),
    [anon_sym_return] = ACTIONS(1338),
    [anon_sym_break] = ACTIONS(1338),
    [anon_sym_continue] = ACTIONS(1338),
    [anon_sym_goto] = ACTIONS(1338),
    [anon_sym___try] = ACTIONS(1338),
    [anon_sym___leave] = ACTIONS(1338),
    [anon_sym_DASH_DASH] = ACTIONS(1340),
    [anon_sym_PLUS_PLUS] = ACTIONS(1340),
    [anon_sym_sizeof] = ACTIONS(1338),
    [anon_sym___alignof__] = ACTIONS(1338),
    [anon_sym___alignof] = ACTIONS(1338),
    [anon_sym__alignof] = ACTIONS(1338),
    [anon_sym_alignof] = ACTIONS(1338),
    [anon_sym__Alignof] = ACTIONS(1338),
    [anon_sym_offsetof] = ACTIONS(1338),
    [anon_sym__Generic] = ACTIONS(1338),
    [anon_sym_asm] = ACTIONS(1338),
    [anon_sym___asm__] = ACTIONS(1338),
    [sym_number_literal] = ACTIONS(1340),
    [anon_sym_L_SQUOTE] = ACTIONS(1340),
    [anon_sym_u_SQUOTE] = ACTIONS(1340),
    [anon_sym_U_SQUOTE] = ACTIONS(1340),
    [anon_sym_u8_SQUOTE] = ACTIONS(1340),
    [anon_sym_SQUOTE] = ACTIONS(1340),
    [anon_sym_L_DQUOTE] = ACTIONS(1340),
    [anon_sym_u_DQUOTE] = ACTIONS(1340),
    [anon_sym_U_DQUOTE] = ACTIONS(1340),
    [anon_sym_u8_DQUOTE] = ACTIONS(1340),
    [anon_sym_DQUOTE] = ACTIONS(1340),
    [sym_true] = ACTIONS(1338),
    [sym_false] = ACTIONS(1338),
    [anon_sym_NULL] = ACTIONS(1338),
    [anon_sym_nullptr] = ACTIONS(1338),
    [sym_comment] = ACTIONS(3),
  },
  [378] = {
    [sym_identifier] = ACTIONS(1302),
    [aux_sym_preproc_include_token1] = ACTIONS(1302),
    [aux_sym_preproc_def_token1] = ACTIONS(1302),
    [aux_sym_preproc_if_token1] = ACTIONS(1302),
    [aux_sym_preproc_if_token2] = ACTIONS(1302),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1302),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1302),
    [sym_preproc_directive] = ACTIONS(1302),
    [anon_sym_LPAREN2] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_TILDE] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1302),
    [anon_sym_PLUS] = ACTIONS(1302),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym___extension__] = ACTIONS(1302),
    [anon_sym_typedef] = ACTIONS(1302),
    [anon_sym_extern] = ACTIONS(1302),
    [anon_sym___attribute__] = ACTIONS(1302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1304),
    [anon_sym___declspec] = ACTIONS(1302),
    [anon_sym___cdecl] = ACTIONS(1302),
    [anon_sym___clrcall] = ACTIONS(1302),
    [anon_sym___stdcall] = ACTIONS(1302),
    [anon_sym___fastcall] = ACTIONS(1302),
    [anon_sym___thiscall] = ACTIONS(1302),
    [anon_sym___vectorcall] = ACTIONS(1302),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_signed] = ACTIONS(1302),
    [anon_sym_unsigned] = ACTIONS(1302),
    [anon_sym_long] = ACTIONS(1302),
    [anon_sym_short] = ACTIONS(1302),
    [anon_sym_static] = ACTIONS(1302),
    [anon_sym_auto] = ACTIONS(1302),
    [anon_sym_register] = ACTIONS(1302),
    [anon_sym_inline] = ACTIONS(1302),
    [anon_sym___inline] = ACTIONS(1302),
    [anon_sym___inline__] = ACTIONS(1302),
    [anon_sym___forceinline] = ACTIONS(1302),
    [anon_sym_thread_local] = ACTIONS(1302),
    [anon_sym___thread] = ACTIONS(1302),
    [anon_sym_const] = ACTIONS(1302),
    [anon_sym_constexpr] = ACTIONS(1302),
    [anon_sym_volatile] = ACTIONS(1302),
    [anon_sym_restrict] = ACTIONS(1302),
    [anon_sym___restrict__] = ACTIONS(1302),
    [anon_sym__Atomic] = ACTIONS(1302),
    [anon_sym__Noreturn] = ACTIONS(1302),
    [anon_sym_noreturn] = ACTIONS(1302),
    [sym_primitive_type] = ACTIONS(1302),
    [anon_sym_enum] = ACTIONS(1302),
    [anon_sym_struct] = ACTIONS(1302),
    [anon_sym_union] = ACTIONS(1302),
    [anon_sym_if] = ACTIONS(1302),
    [anon_sym_else] = ACTIONS(1302),
    [anon_sym_switch] = ACTIONS(1302),
    [anon_sym_case] = ACTIONS(1302),
    [anon_sym_default] = ACTIONS(1302),
    [anon_sym_while] = ACTIONS(1302),
    [anon_sym_do] = ACTIONS(1302),
    [anon_sym_for] = ACTIONS(1302),
    [anon_sym_return] = ACTIONS(1302),
    [anon_sym_break] = ACTIONS(1302),
    [anon_sym_continue] = ACTIONS(1302),
    [anon_sym_goto] = ACTIONS(1302),
    [anon_sym___try] = ACTIONS(1302),
    [anon_sym___leave] = ACTIONS(1302),
    [anon_sym_DASH_DASH] = ACTIONS(1304),
    [anon_sym_PLUS_PLUS] = ACTIONS(1304),
    [anon_sym_sizeof] = ACTIONS(1302),
    [anon_sym___alignof__] = ACTIONS(1302),
    [anon_sym___alignof] = ACTIONS(1302),
    [anon_sym__alignof] = ACTIONS(1302),
    [anon_sym_alignof] = ACTIONS(1302),
    [anon_sym__Alignof] = ACTIONS(1302),
    [anon_sym_offsetof] = ACTIONS(1302),
    [anon_sym__Generic] = ACTIONS(1302),
    [anon_sym_asm] = ACTIONS(1302),
    [anon_sym___asm__] = ACTIONS(1302),
    [sym_number_literal] = ACTIONS(1304),
    [anon_sym_L_SQUOTE] = ACTIONS(1304),
    [anon_sym_u_SQUOTE] = ACTIONS(1304),
    [anon_sym_U_SQUOTE] = ACTIONS(1304),
    [anon_sym_u8_SQUOTE] = ACTIONS(1304),
    [anon_sym_SQUOTE] = ACTIONS(1304),
    [anon_sym_L_DQUOTE] = ACTIONS(1304),
    [anon_sym_u_DQUOTE] = ACTIONS(1304),
    [anon_sym_U_DQUOTE] = ACTIONS(1304),
    [anon_sym_u8_DQUOTE] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_true] = ACTIONS(1302),
    [sym_false] = ACTIONS(1302),
    [anon_sym_NULL] = ACTIONS(1302),
    [anon_sym_nullptr] = ACTIONS(1302),
    [sym_comment] = ACTIONS(3),
  },
  [379] = {
    [ts_builtin_sym_end] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1382),
    [aux_sym_preproc_include_token1] = ACTIONS(1382),
    [aux_sym_preproc_def_token1] = ACTIONS(1382),
    [aux_sym_preproc_if_token1] = ACTIONS(1382),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1382),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1382),
    [sym_preproc_directive] = ACTIONS(1382),
    [anon_sym_LPAREN2] = ACTIONS(1384),
    [anon_sym_BANG] = ACTIONS(1384),
    [anon_sym_TILDE] = ACTIONS(1384),
    [anon_sym_DASH] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1382),
    [anon_sym_STAR] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym___extension__] = ACTIONS(1382),
    [anon_sym_typedef] = ACTIONS(1382),
    [anon_sym_extern] = ACTIONS(1382),
    [anon_sym___attribute__] = ACTIONS(1382),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1384),
    [anon_sym___declspec] = ACTIONS(1382),
    [anon_sym___cdecl] = ACTIONS(1382),
    [anon_sym___clrcall] = ACTIONS(1382),
    [anon_sym___stdcall] = ACTIONS(1382),
    [anon_sym___fastcall] = ACTIONS(1382),
    [anon_sym___thiscall] = ACTIONS(1382),
    [anon_sym___vectorcall] = ACTIONS(1382),
    [anon_sym_LBRACE] = ACTIONS(1384),
    [anon_sym_signed] = ACTIONS(1382),
    [anon_sym_unsigned] = ACTIONS(1382),
    [anon_sym_long] = ACTIONS(1382),
    [anon_sym_short] = ACTIONS(1382),
    [anon_sym_static] = ACTIONS(1382),
    [anon_sym_auto] = ACTIONS(1382),
    [anon_sym_register] = ACTIONS(1382),
    [anon_sym_inline] = ACTIONS(1382),
    [anon_sym___inline] = ACTIONS(1382),
    [anon_sym___inline__] = ACTIONS(1382),
    [anon_sym___forceinline] = ACTIONS(1382),
    [anon_sym_thread_local] = ACTIONS(1382),
    [anon_sym___thread] = ACTIONS(1382),
    [anon_sym_const] = ACTIONS(1382),
    [anon_sym_constexpr] = ACTIONS(1382),
    [anon_sym_volatile] = ACTIONS(1382),
    [anon_sym_restrict] = ACTIONS(1382),
    [anon_sym___restrict__] = ACTIONS(1382),
    [anon_sym__Atomic] = ACTIONS(1382),
    [anon_sym__Noreturn] = ACTIONS(1382),
    [anon_sym_noreturn] = ACTIONS(1382),
    [sym_primitive_type] = ACTIONS(1382),
    [anon_sym_enum] = ACTIONS(1382),
    [anon_sym_struct] = ACTIONS(1382),
    [anon_sym_union] = ACTIONS(1382),
    [anon_sym_if] = ACTIONS(1382),
    [anon_sym_else] = ACTIONS(1382),
    [anon_sym_switch] = ACTIONS(1382),
    [anon_sym_case] = ACTIONS(1382),
    [anon_sym_default] = ACTIONS(1382),
    [anon_sym_while] = ACTIONS(1382),
    [anon_sym_do] = ACTIONS(1382),
    [anon_sym_for] = ACTIONS(1382),
    [anon_sym_return] = ACTIONS(1382),
    [anon_sym_break] = ACTIONS(1382),
    [anon_sym_continue] = ACTIONS(1382),
    [anon_sym_goto] = ACTIONS(1382),
    [anon_sym___try] = ACTIONS(1382),
    [anon_sym___leave] = ACTIONS(1382),
    [anon_sym_DASH_DASH] = ACTIONS(1384),
    [anon_sym_PLUS_PLUS] = ACTIONS(1384),
    [anon_sym_sizeof] = ACTIONS(1382),
    [anon_sym___alignof__] = ACTIONS(1382),
    [anon_sym___alignof] = ACTIONS(1382),
    [anon_sym__alignof] = ACTIONS(1382),
    [anon_sym_alignof] = ACTIONS(1382),
    [anon_sym__Alignof] = ACTIONS(1382),
    [anon_sym_offsetof] = ACTIONS(1382),
    [anon_sym__Generic] = ACTIONS(1382),
    [anon_sym_asm] = ACTIONS(1382),
    [anon_sym___asm__] = ACTIONS(1382),
    [sym_number_literal] = ACTIONS(1384),
    [anon_sym_L_SQUOTE] = ACTIONS(1384),
    [anon_sym_u_SQUOTE] = ACTIONS(1384),
    [anon_sym_U_SQUOTE] = ACTIONS(1384),
    [anon_sym_u8_SQUOTE] = ACTIONS(1384),
    [anon_sym_SQUOTE] = ACTIONS(1384),
    [anon_sym_L_DQUOTE] = ACTIONS(1384),
    [anon_sym_u_DQUOTE] = ACTIONS(1384),
    [anon_sym_U_DQUOTE] = ACTIONS(1384),
    [anon_sym_u8_DQUOTE] = ACTIONS(1384),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [sym_true] = ACTIONS(1382),
    [sym_false] = ACTIONS(1382),
    [anon_sym_NULL] = ACTIONS(1382),
    [anon_sym_nullptr] = ACTIONS(1382),
    [sym_comment] = ACTIONS(3),
  },
  [380] = {
    [ts_builtin_sym_end] = ACTIONS(1300),
    [sym_identifier] = ACTIONS(1298),
    [aux_sym_preproc_include_token1] = ACTIONS(1298),
    [aux_sym_preproc_def_token1] = ACTIONS(1298),
    [aux_sym_preproc_if_token1] = ACTIONS(1298),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1298),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1298),
    [sym_preproc_directive] = ACTIONS(1298),
    [anon_sym_LPAREN2] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1300),
    [anon_sym_TILDE] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1298),
    [anon_sym_PLUS] = ACTIONS(1298),
    [anon_sym_STAR] = ACTIONS(1300),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(1300),
    [anon_sym___extension__] = ACTIONS(1298),
    [anon_sym_typedef] = ACTIONS(1298),
    [anon_sym_extern] = ACTIONS(1298),
    [anon_sym___attribute__] = ACTIONS(1298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1300),
    [anon_sym___declspec] = ACTIONS(1298),
    [anon_sym___cdecl] = ACTIONS(1298),
    [anon_sym___clrcall] = ACTIONS(1298),
    [anon_sym___stdcall] = ACTIONS(1298),
    [anon_sym___fastcall] = ACTIONS(1298),
    [anon_sym___thiscall] = ACTIONS(1298),
    [anon_sym___vectorcall] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_signed] = ACTIONS(1298),
    [anon_sym_unsigned] = ACTIONS(1298),
    [anon_sym_long] = ACTIONS(1298),
    [anon_sym_short] = ACTIONS(1298),
    [anon_sym_static] = ACTIONS(1298),
    [anon_sym_auto] = ACTIONS(1298),
    [anon_sym_register] = ACTIONS(1298),
    [anon_sym_inline] = ACTIONS(1298),
    [anon_sym___inline] = ACTIONS(1298),
    [anon_sym___inline__] = ACTIONS(1298),
    [anon_sym___forceinline] = ACTIONS(1298),
    [anon_sym_thread_local] = ACTIONS(1298),
    [anon_sym___thread] = ACTIONS(1298),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_constexpr] = ACTIONS(1298),
    [anon_sym_volatile] = ACTIONS(1298),
    [anon_sym_restrict] = ACTIONS(1298),
    [anon_sym___restrict__] = ACTIONS(1298),
    [anon_sym__Atomic] = ACTIONS(1298),
    [anon_sym__Noreturn] = ACTIONS(1298),
    [anon_sym_noreturn] = ACTIONS(1298),
    [sym_primitive_type] = ACTIONS(1298),
    [anon_sym_enum] = ACTIONS(1298),
    [anon_sym_struct] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1298),
    [anon_sym_if] = ACTIONS(1298),
    [anon_sym_else] = ACTIONS(1298),
    [anon_sym_switch] = ACTIONS(1298),
    [anon_sym_case] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(1298),
    [anon_sym_do] = ACTIONS(1298),
    [anon_sym_for] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1298),
    [anon_sym_break] = ACTIONS(1298),
    [anon_sym_continue] = ACTIONS(1298),
    [anon_sym_goto] = ACTIONS(1298),
    [anon_sym___try] = ACTIONS(1298),
    [anon_sym___leave] = ACTIONS(1298),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_sizeof] = ACTIONS(1298),
    [anon_sym___alignof__] = ACTIONS(1298),
    [anon_sym___alignof] = ACTIONS(1298),
    [anon_sym__alignof] = ACTIONS(1298),
    [anon_sym_alignof] = ACTIONS(1298),
    [anon_sym__Alignof] = ACTIONS(1298),
    [anon_sym_offsetof] = ACTIONS(1298),
    [anon_sym__Generic] = ACTIONS(1298),
    [anon_sym_asm] = ACTIONS(1298),
    [anon_sym___asm__] = ACTIONS(1298),
    [sym_number_literal] = ACTIONS(1300),
    [anon_sym_L_SQUOTE] = ACTIONS(1300),
    [anon_sym_u_SQUOTE] = ACTIONS(1300),
    [anon_sym_U_SQUOTE] = ACTIONS(1300),
    [anon_sym_u8_SQUOTE] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(1300),
    [anon_sym_L_DQUOTE] = ACTIONS(1300),
    [anon_sym_u_DQUOTE] = ACTIONS(1300),
    [anon_sym_U_DQUOTE] = ACTIONS(1300),
    [anon_sym_u8_DQUOTE] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(1300),
    [sym_true] = ACTIONS(1298),
    [sym_false] = ACTIONS(1298),
    [anon_sym_NULL] = ACTIONS(1298),
    [anon_sym_nullptr] = ACTIONS(1298),
    [sym_comment] = ACTIONS(3),
  },
  [381] = {
    [ts_builtin_sym_end] = ACTIONS(1300),
    [sym_identifier] = ACTIONS(1298),
    [aux_sym_preproc_include_token1] = ACTIONS(1298),
    [aux_sym_preproc_def_token1] = ACTIONS(1298),
    [aux_sym_preproc_if_token1] = ACTIONS(1298),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1298),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1298),
    [sym_preproc_directive] = ACTIONS(1298),
    [anon_sym_LPAREN2] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1300),
    [anon_sym_TILDE] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1298),
    [anon_sym_PLUS] = ACTIONS(1298),
    [anon_sym_STAR] = ACTIONS(1300),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(1300),
    [anon_sym___extension__] = ACTIONS(1298),
    [anon_sym_typedef] = ACTIONS(1298),
    [anon_sym_extern] = ACTIONS(1298),
    [anon_sym___attribute__] = ACTIONS(1298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1300),
    [anon_sym___declspec] = ACTIONS(1298),
    [anon_sym___cdecl] = ACTIONS(1298),
    [anon_sym___clrcall] = ACTIONS(1298),
    [anon_sym___stdcall] = ACTIONS(1298),
    [anon_sym___fastcall] = ACTIONS(1298),
    [anon_sym___thiscall] = ACTIONS(1298),
    [anon_sym___vectorcall] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_signed] = ACTIONS(1298),
    [anon_sym_unsigned] = ACTIONS(1298),
    [anon_sym_long] = ACTIONS(1298),
    [anon_sym_short] = ACTIONS(1298),
    [anon_sym_static] = ACTIONS(1298),
    [anon_sym_auto] = ACTIONS(1298),
    [anon_sym_register] = ACTIONS(1298),
    [anon_sym_inline] = ACTIONS(1298),
    [anon_sym___inline] = ACTIONS(1298),
    [anon_sym___inline__] = ACTIONS(1298),
    [anon_sym___forceinline] = ACTIONS(1298),
    [anon_sym_thread_local] = ACTIONS(1298),
    [anon_sym___thread] = ACTIONS(1298),
    [anon_sym_const] = ACTIONS(1298),
    [anon_sym_constexpr] = ACTIONS(1298),
    [anon_sym_volatile] = ACTIONS(1298),
    [anon_sym_restrict] = ACTIONS(1298),
    [anon_sym___restrict__] = ACTIONS(1298),
    [anon_sym__Atomic] = ACTIONS(1298),
    [anon_sym__Noreturn] = ACTIONS(1298),
    [anon_sym_noreturn] = ACTIONS(1298),
    [sym_primitive_type] = ACTIONS(1298),
    [anon_sym_enum] = ACTIONS(1298),
    [anon_sym_struct] = ACTIONS(1298),
    [anon_sym_union] = ACTIONS(1298),
    [anon_sym_if] = ACTIONS(1298),
    [anon_sym_else] = ACTIONS(1298),
    [anon_sym_switch] = ACTIONS(1298),
    [anon_sym_case] = ACTIONS(1298),
    [anon_sym_default] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(1298),
    [anon_sym_do] = ACTIONS(1298),
    [anon_sym_for] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1298),
    [anon_sym_break] = ACTIONS(1298),
    [anon_sym_continue] = ACTIONS(1298),
    [anon_sym_goto] = ACTIONS(1298),
    [anon_sym___try] = ACTIONS(1298),
    [anon_sym___leave] = ACTIONS(1298),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [anon_sym_sizeof] = ACTIONS(1298),
    [anon_sym___alignof__] = ACTIONS(1298),
    [anon_sym___alignof] = ACTIONS(1298),
    [anon_sym__alignof] = ACTIONS(1298),
    [anon_sym_alignof] = ACTIONS(1298),
    [anon_sym__Alignof] = ACTIONS(1298),
    [anon_sym_offsetof] = ACTIONS(1298),
    [anon_sym__Generic] = ACTIONS(1298),
    [anon_sym_asm] = ACTIONS(1298),
    [anon_sym___asm__] = ACTIONS(1298),
    [sym_number_literal] = ACTIONS(1300),
    [anon_sym_L_SQUOTE] = ACTIONS(1300),
    [anon_sym_u_SQUOTE] = ACTIONS(1300),
    [anon_sym_U_SQUOTE] = ACTIONS(1300),
    [anon_sym_u8_SQUOTE] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(1300),
    [anon_sym_L_DQUOTE] = ACTIONS(1300),
    [anon_sym_u_DQUOTE] = ACTIONS(1300),
    [anon_sym_U_DQUOTE] = ACTIONS(1300),
    [anon_sym_u8_DQUOTE] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(1300),
    [sym_true] = ACTIONS(1298),
    [sym_false] = ACTIONS(1298),
    [anon_sym_NULL] = ACTIONS(1298),
    [anon_sym_nullptr] = ACTIONS(1298),
    [sym_comment] = ACTIONS(3),
  },
  [382] = {
    [sym_identifier] = ACTIONS(1402),
    [aux_sym_preproc_include_token1] = ACTIONS(1402),
    [aux_sym_preproc_def_token1] = ACTIONS(1402),
    [aux_sym_preproc_if_token1] = ACTIONS(1402),
    [aux_sym_preproc_if_token2] = ACTIONS(1402),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1402),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1402),
    [sym_preproc_directive] = ACTIONS(1402),
    [anon_sym_LPAREN2] = ACTIONS(1404),
    [anon_sym_BANG] = ACTIONS(1404),
    [anon_sym_TILDE] = ACTIONS(1404),
    [anon_sym_DASH] = ACTIONS(1402),
    [anon_sym_PLUS] = ACTIONS(1402),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_AMP] = ACTIONS(1404),
    [anon_sym_SEMI] = ACTIONS(1404),
    [anon_sym___extension__] = ACTIONS(1402),
    [anon_sym_typedef] = ACTIONS(1402),
    [anon_sym_extern] = ACTIONS(1402),
    [anon_sym___attribute__] = ACTIONS(1402),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1404),
    [anon_sym___declspec] = ACTIONS(1402),
    [anon_sym___cdecl] = ACTIONS(1402),
    [anon_sym___clrcall] = ACTIONS(1402),
    [anon_sym___stdcall] = ACTIONS(1402),
    [anon_sym___fastcall] = ACTIONS(1402),
    [anon_sym___thiscall] = ACTIONS(1402),
    [anon_sym___vectorcall] = ACTIONS(1402),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_signed] = ACTIONS(1402),
    [anon_sym_unsigned] = ACTIONS(1402),
    [anon_sym_long] = ACTIONS(1402),
    [anon_sym_short] = ACTIONS(1402),
    [anon_sym_static] = ACTIONS(1402),
    [anon_sym_auto] = ACTIONS(1402),
    [anon_sym_register] = ACTIONS(1402),
    [anon_sym_inline] = ACTIONS(1402),
    [anon_sym___inline] = ACTIONS(1402),
    [anon_sym___inline__] = ACTIONS(1402),
    [anon_sym___forceinline] = ACTIONS(1402),
    [anon_sym_thread_local] = ACTIONS(1402),
    [anon_sym___thread] = ACTIONS(1402),
    [anon_sym_const] = ACTIONS(1402),
    [anon_sym_constexpr] = ACTIONS(1402),
    [anon_sym_volatile] = ACTIONS(1402),
    [anon_sym_restrict] = ACTIONS(1402),
    [anon_sym___restrict__] = ACTIONS(1402),
    [anon_sym__Atomic] = ACTIONS(1402),
    [anon_sym__Noreturn] = ACTIONS(1402),
    [anon_sym_noreturn] = ACTIONS(1402),
    [sym_primitive_type] = ACTIONS(1402),
    [anon_sym_enum] = ACTIONS(1402),
    [anon_sym_struct] = ACTIONS(1402),
    [anon_sym_union] = ACTIONS(1402),
    [anon_sym_if] = ACTIONS(1402),
    [anon_sym_else] = ACTIONS(1402),
    [anon_sym_switch] = ACTIONS(1402),
    [anon_sym_case] = ACTIONS(1402),
    [anon_sym_default] = ACTIONS(1402),
    [anon_sym_while] = ACTIONS(1402),
    [anon_sym_do] = ACTIONS(1402),
    [anon_sym_for] = ACTIONS(1402),
    [anon_sym_return] = ACTIONS(1402),
    [anon_sym_break] = ACTIONS(1402),
    [anon_sym_continue] = ACTIONS(1402),
    [anon_sym_goto] = ACTIONS(1402),
    [anon_sym___try] = ACTIONS(1402),
    [anon_sym___leave] = ACTIONS(1402),
    [anon_sym_DASH_DASH] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1404),
    [anon_sym_sizeof] = ACTIONS(1402),
    [anon_sym___alignof__] = ACTIONS(1402),
    [anon_sym___alignof] = ACTIONS(1402),
    [anon_sym__alignof] = ACTIONS(1402),
    [anon_sym_alignof] = ACTIONS(1402),
    [anon_sym__Alignof] = ACTIONS(1402),
    [anon_sym_offsetof] = ACTIONS(1402),
    [anon_sym__Generic] = ACTIONS(1402),
    [anon_sym_asm] = ACTIONS(1402),
    [anon_sym___asm__] = ACTIONS(1402),
    [sym_number_literal] = ACTIONS(1404),
    [anon_sym_L_SQUOTE] = ACTIONS(1404),
    [anon_sym_u_SQUOTE] = ACTIONS(1404),
    [anon_sym_U_SQUOTE] = ACTIONS(1404),
    [anon_sym_u8_SQUOTE] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(1404),
    [anon_sym_L_DQUOTE] = ACTIONS(1404),
    [anon_sym_u_DQUOTE] = ACTIONS(1404),
    [anon_sym_U_DQUOTE] = ACTIONS(1404),
    [anon_sym_u8_DQUOTE] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1404),
    [sym_true] = ACTIONS(1402),
    [sym_false] = ACTIONS(1402),
    [anon_sym_NULL] = ACTIONS(1402),
    [anon_sym_nullptr] = ACTIONS(1402),
    [sym_comment] = ACTIONS(3),
  },
  [383] = {
    [ts_builtin_sym_end] = ACTIONS(1396),
    [sym_identifier] = ACTIONS(1394),
    [aux_sym_preproc_include_token1] = ACTIONS(1394),
    [aux_sym_preproc_def_token1] = ACTIONS(1394),
    [aux_sym_preproc_if_token1] = ACTIONS(1394),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1394),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1394),
    [sym_preproc_directive] = ACTIONS(1394),
    [anon_sym_LPAREN2] = ACTIONS(1396),
    [anon_sym_BANG] = ACTIONS(1396),
    [anon_sym_TILDE] = ACTIONS(1396),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_PLUS] = ACTIONS(1394),
    [anon_sym_STAR] = ACTIONS(1396),
    [anon_sym_AMP] = ACTIONS(1396),
    [anon_sym_SEMI] = ACTIONS(1396),
    [anon_sym___extension__] = ACTIONS(1394),
    [anon_sym_typedef] = ACTIONS(1394),
    [anon_sym_extern] = ACTIONS(1394),
    [anon_sym___attribute__] = ACTIONS(1394),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1396),
    [anon_sym___declspec] = ACTIONS(1394),
    [anon_sym___cdecl] = ACTIONS(1394),
    [anon_sym___clrcall] = ACTIONS(1394),
    [anon_sym___stdcall] = ACTIONS(1394),
    [anon_sym___fastcall] = ACTIONS(1394),
    [anon_sym___thiscall] = ACTIONS(1394),
    [anon_sym___vectorcall] = ACTIONS(1394),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_signed] = ACTIONS(1394),
    [anon_sym_unsigned] = ACTIONS(1394),
    [anon_sym_long] = ACTIONS(1394),
    [anon_sym_short] = ACTIONS(1394),
    [anon_sym_static] = ACTIONS(1394),
    [anon_sym_auto] = ACTIONS(1394),
    [anon_sym_register] = ACTIONS(1394),
    [anon_sym_inline] = ACTIONS(1394),
    [anon_sym___inline] = ACTIONS(1394),
    [anon_sym___inline__] = ACTIONS(1394),
    [anon_sym___forceinline] = ACTIONS(1394),
    [anon_sym_thread_local] = ACTIONS(1394),
    [anon_sym___thread] = ACTIONS(1394),
    [anon_sym_const] = ACTIONS(1394),
    [anon_sym_constexpr] = ACTIONS(1394),
    [anon_sym_volatile] = ACTIONS(1394),
    [anon_sym_restrict] = ACTIONS(1394),
    [anon_sym___restrict__] = ACTIONS(1394),
    [anon_sym__Atomic] = ACTIONS(1394),
    [anon_sym__Noreturn] = ACTIONS(1394),
    [anon_sym_noreturn] = ACTIONS(1394),
    [sym_primitive_type] = ACTIONS(1394),
    [anon_sym_enum] = ACTIONS(1394),
    [anon_sym_struct] = ACTIONS(1394),
    [anon_sym_union] = ACTIONS(1394),
    [anon_sym_if] = ACTIONS(1394),
    [anon_sym_else] = ACTIONS(1394),
    [anon_sym_switch] = ACTIONS(1394),
    [anon_sym_case] = ACTIONS(1394),
    [anon_sym_default] = ACTIONS(1394),
    [anon_sym_while] = ACTIONS(1394),
    [anon_sym_do] = ACTIONS(1394),
    [anon_sym_for] = ACTIONS(1394),
    [anon_sym_return] = ACTIONS(1394),
    [anon_sym_break] = ACTIONS(1394),
    [anon_sym_continue] = ACTIONS(1394),
    [anon_sym_goto] = ACTIONS(1394),
    [anon_sym___try] = ACTIONS(1394),
    [anon_sym___leave] = ACTIONS(1394),
    [anon_sym_DASH_DASH] = ACTIONS(1396),
    [anon_sym_PLUS_PLUS] = ACTIONS(1396),
    [anon_sym_sizeof] = ACTIONS(1394),
    [anon_sym___alignof__] = ACTIONS(1394),
    [anon_sym___alignof] = ACTIONS(1394),
    [anon_sym__alignof] = ACTIONS(1394),
    [anon_sym_alignof] = ACTIONS(1394),
    [anon_sym__Alignof] = ACTIONS(1394),
    [anon_sym_offsetof] = ACTIONS(1394),
    [anon_sym__Generic] = ACTIONS(1394),
    [anon_sym_asm] = ACTIONS(1394),
    [anon_sym___asm__] = ACTIONS(1394),
    [sym_number_literal] = ACTIONS(1396),
    [anon_sym_L_SQUOTE] = ACTIONS(1396),
    [anon_sym_u_SQUOTE] = ACTIONS(1396),
    [anon_sym_U_SQUOTE] = ACTIONS(1396),
    [anon_sym_u8_SQUOTE] = ACTIONS(1396),
    [anon_sym_SQUOTE] = ACTIONS(1396),
    [anon_sym_L_DQUOTE] = ACTIONS(1396),
    [anon_sym_u_DQUOTE] = ACTIONS(1396),
    [anon_sym_U_DQUOTE] = ACTIONS(1396),
    [anon_sym_u8_DQUOTE] = ACTIONS(1396),
    [anon_sym_DQUOTE] = ACTIONS(1396),
    [sym_true] = ACTIONS(1394),
    [sym_false] = ACTIONS(1394),
    [anon_sym_NULL] = ACTIONS(1394),
    [anon_sym_nullptr] = ACTIONS(1394),
    [sym_comment] = ACTIONS(3),
  },
  [384] = {
    [sym_identifier] = ACTIONS(1398),
    [aux_sym_preproc_include_token1] = ACTIONS(1398),
    [aux_sym_preproc_def_token1] = ACTIONS(1398),
    [aux_sym_preproc_if_token1] = ACTIONS(1398),
    [aux_sym_preproc_if_token2] = ACTIONS(1398),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1398),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1398),
    [sym_preproc_directive] = ACTIONS(1398),
    [anon_sym_LPAREN2] = ACTIONS(1400),
    [anon_sym_BANG] = ACTIONS(1400),
    [anon_sym_TILDE] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1398),
    [anon_sym_PLUS] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym___extension__] = ACTIONS(1398),
    [anon_sym_typedef] = ACTIONS(1398),
    [anon_sym_extern] = ACTIONS(1398),
    [anon_sym___attribute__] = ACTIONS(1398),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1400),
    [anon_sym___declspec] = ACTIONS(1398),
    [anon_sym___cdecl] = ACTIONS(1398),
    [anon_sym___clrcall] = ACTIONS(1398),
    [anon_sym___stdcall] = ACTIONS(1398),
    [anon_sym___fastcall] = ACTIONS(1398),
    [anon_sym___thiscall] = ACTIONS(1398),
    [anon_sym___vectorcall] = ACTIONS(1398),
    [anon_sym_LBRACE] = ACTIONS(1400),
    [anon_sym_signed] = ACTIONS(1398),
    [anon_sym_unsigned] = ACTIONS(1398),
    [anon_sym_long] = ACTIONS(1398),
    [anon_sym_short] = ACTIONS(1398),
    [anon_sym_static] = ACTIONS(1398),
    [anon_sym_auto] = ACTIONS(1398),
    [anon_sym_register] = ACTIONS(1398),
    [anon_sym_inline] = ACTIONS(1398),
    [anon_sym___inline] = ACTIONS(1398),
    [anon_sym___inline__] = ACTIONS(1398),
    [anon_sym___forceinline] = ACTIONS(1398),
    [anon_sym_thread_local] = ACTIONS(1398),
    [anon_sym___thread] = ACTIONS(1398),
    [anon_sym_const] = ACTIONS(1398),
    [anon_sym_constexpr] = ACTIONS(1398),
    [anon_sym_volatile] = ACTIONS(1398),
    [anon_sym_restrict] = ACTIONS(1398),
    [anon_sym___restrict__] = ACTIONS(1398),
    [anon_sym__Atomic] = ACTIONS(1398),
    [anon_sym__Noreturn] = ACTIONS(1398),
    [anon_sym_noreturn] = ACTIONS(1398),
    [sym_primitive_type] = ACTIONS(1398),
    [anon_sym_enum] = ACTIONS(1398),
    [anon_sym_struct] = ACTIONS(1398),
    [anon_sym_union] = ACTIONS(1398),
    [anon_sym_if] = ACTIONS(1398),
    [anon_sym_else] = ACTIONS(1398),
    [anon_sym_switch] = ACTIONS(1398),
    [anon_sym_case] = ACTIONS(1398),
    [anon_sym_default] = ACTIONS(1398),
    [anon_sym_while] = ACTIONS(1398),
    [anon_sym_do] = ACTIONS(1398),
    [anon_sym_for] = ACTIONS(1398),
    [anon_sym_return] = ACTIONS(1398),
    [anon_sym_break] = ACTIONS(1398),
    [anon_sym_continue] = ACTIONS(1398),
    [anon_sym_goto] = ACTIONS(1398),
    [anon_sym___try] = ACTIONS(1398),
    [anon_sym___leave] = ACTIONS(1398),
    [anon_sym_DASH_DASH] = ACTIONS(1400),
    [anon_sym_PLUS_PLUS] = ACTIONS(1400),
    [anon_sym_sizeof] = ACTIONS(1398),
    [anon_sym___alignof__] = ACTIONS(1398),
    [anon_sym___alignof] = ACTIONS(1398),
    [anon_sym__alignof] = ACTIONS(1398),
    [anon_sym_alignof] = ACTIONS(1398),
    [anon_sym__Alignof] = ACTIONS(1398),
    [anon_sym_offsetof] = ACTIONS(1398),
    [anon_sym__Generic] = ACTIONS(1398),
    [anon_sym_asm] = ACTIONS(1398),
    [anon_sym___asm__] = ACTIONS(1398),
    [sym_number_literal] = ACTIONS(1400),
    [anon_sym_L_SQUOTE] = ACTIONS(1400),
    [anon_sym_u_SQUOTE] = ACTIONS(1400),
    [anon_sym_U_SQUOTE] = ACTIONS(1400),
    [anon_sym_u8_SQUOTE] = ACTIONS(1400),
    [anon_sym_SQUOTE] = ACTIONS(1400),
    [anon_sym_L_DQUOTE] = ACTIONS(1400),
    [anon_sym_u_DQUOTE] = ACTIONS(1400),
    [anon_sym_U_DQUOTE] = ACTIONS(1400),
    [anon_sym_u8_DQUOTE] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [sym_true] = ACTIONS(1398),
    [sym_false] = ACTIONS(1398),
    [anon_sym_NULL] = ACTIONS(1398),
    [anon_sym_nullptr] = ACTIONS(1398),
    [sym_comment] = ACTIONS(3),
  },
  [385] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [386] = {
    [sym_identifier] = ACTIONS(1330),
    [aux_sym_preproc_include_token1] = ACTIONS(1330),
    [aux_sym_preproc_def_token1] = ACTIONS(1330),
    [aux_sym_preproc_if_token1] = ACTIONS(1330),
    [aux_sym_preproc_if_token2] = ACTIONS(1330),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1330),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1330),
    [sym_preproc_directive] = ACTIONS(1330),
    [anon_sym_LPAREN2] = ACTIONS(1332),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1332),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_AMP] = ACTIONS(1332),
    [anon_sym_SEMI] = ACTIONS(1332),
    [anon_sym___extension__] = ACTIONS(1330),
    [anon_sym_typedef] = ACTIONS(1330),
    [anon_sym_extern] = ACTIONS(1330),
    [anon_sym___attribute__] = ACTIONS(1330),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1332),
    [anon_sym___declspec] = ACTIONS(1330),
    [anon_sym___cdecl] = ACTIONS(1330),
    [anon_sym___clrcall] = ACTIONS(1330),
    [anon_sym___stdcall] = ACTIONS(1330),
    [anon_sym___fastcall] = ACTIONS(1330),
    [anon_sym___thiscall] = ACTIONS(1330),
    [anon_sym___vectorcall] = ACTIONS(1330),
    [anon_sym_LBRACE] = ACTIONS(1332),
    [anon_sym_signed] = ACTIONS(1330),
    [anon_sym_unsigned] = ACTIONS(1330),
    [anon_sym_long] = ACTIONS(1330),
    [anon_sym_short] = ACTIONS(1330),
    [anon_sym_static] = ACTIONS(1330),
    [anon_sym_auto] = ACTIONS(1330),
    [anon_sym_register] = ACTIONS(1330),
    [anon_sym_inline] = ACTIONS(1330),
    [anon_sym___inline] = ACTIONS(1330),
    [anon_sym___inline__] = ACTIONS(1330),
    [anon_sym___forceinline] = ACTIONS(1330),
    [anon_sym_thread_local] = ACTIONS(1330),
    [anon_sym___thread] = ACTIONS(1330),
    [anon_sym_const] = ACTIONS(1330),
    [anon_sym_constexpr] = ACTIONS(1330),
    [anon_sym_volatile] = ACTIONS(1330),
    [anon_sym_restrict] = ACTIONS(1330),
    [anon_sym___restrict__] = ACTIONS(1330),
    [anon_sym__Atomic] = ACTIONS(1330),
    [anon_sym__Noreturn] = ACTIONS(1330),
    [anon_sym_noreturn] = ACTIONS(1330),
    [sym_primitive_type] = ACTIONS(1330),
    [anon_sym_enum] = ACTIONS(1330),
    [anon_sym_struct] = ACTIONS(1330),
    [anon_sym_union] = ACTIONS(1330),
    [anon_sym_if] = ACTIONS(1330),
    [anon_sym_else] = ACTIONS(1330),
    [anon_sym_switch] = ACTIONS(1330),
    [anon_sym_case] = ACTIONS(1330),
    [anon_sym_default] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1330),
    [anon_sym_do] = ACTIONS(1330),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_return] = ACTIONS(1330),
    [anon_sym_break] = ACTIONS(1330),
    [anon_sym_continue] = ACTIONS(1330),
    [anon_sym_goto] = ACTIONS(1330),
    [anon_sym___try] = ACTIONS(1330),
    [anon_sym___leave] = ACTIONS(1330),
    [anon_sym_DASH_DASH] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(1332),
    [anon_sym_sizeof] = ACTIONS(1330),
    [anon_sym___alignof__] = ACTIONS(1330),
    [anon_sym___alignof] = ACTIONS(1330),
    [anon_sym__alignof] = ACTIONS(1330),
    [anon_sym_alignof] = ACTIONS(1330),
    [anon_sym__Alignof] = ACTIONS(1330),
    [anon_sym_offsetof] = ACTIONS(1330),
    [anon_sym__Generic] = ACTIONS(1330),
    [anon_sym_asm] = ACTIONS(1330),
    [anon_sym___asm__] = ACTIONS(1330),
    [sym_number_literal] = ACTIONS(1332),
    [anon_sym_L_SQUOTE] = ACTIONS(1332),
    [anon_sym_u_SQUOTE] = ACTIONS(1332),
    [anon_sym_U_SQUOTE] = ACTIONS(1332),
    [anon_sym_u8_SQUOTE] = ACTIONS(1332),
    [anon_sym_SQUOTE] = ACTIONS(1332),
    [anon_sym_L_DQUOTE] = ACTIONS(1332),
    [anon_sym_u_DQUOTE] = ACTIONS(1332),
    [anon_sym_U_DQUOTE] = ACTIONS(1332),
    [anon_sym_u8_DQUOTE] = ACTIONS(1332),
    [anon_sym_DQUOTE] = ACTIONS(1332),
    [sym_true] = ACTIONS(1330),
    [sym_false] = ACTIONS(1330),
    [anon_sym_NULL] = ACTIONS(1330),
    [anon_sym_nullptr] = ACTIONS(1330),
    [sym_comment] = ACTIONS(3),
  },
  [387] = {
    [sym_identifier] = ACTIONS(1334),
    [aux_sym_preproc_include_token1] = ACTIONS(1334),
    [aux_sym_preproc_def_token1] = ACTIONS(1334),
    [aux_sym_preproc_if_token1] = ACTIONS(1334),
    [aux_sym_preproc_if_token2] = ACTIONS(1334),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1334),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1334),
    [sym_preproc_directive] = ACTIONS(1334),
    [anon_sym_LPAREN2] = ACTIONS(1336),
    [anon_sym_BANG] = ACTIONS(1336),
    [anon_sym_TILDE] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_PLUS] = ACTIONS(1334),
    [anon_sym_STAR] = ACTIONS(1336),
    [anon_sym_AMP] = ACTIONS(1336),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym___extension__] = ACTIONS(1334),
    [anon_sym_typedef] = ACTIONS(1334),
    [anon_sym_extern] = ACTIONS(1334),
    [anon_sym___attribute__] = ACTIONS(1334),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1336),
    [anon_sym___declspec] = ACTIONS(1334),
    [anon_sym___cdecl] = ACTIONS(1334),
    [anon_sym___clrcall] = ACTIONS(1334),
    [anon_sym___stdcall] = ACTIONS(1334),
    [anon_sym___fastcall] = ACTIONS(1334),
    [anon_sym___thiscall] = ACTIONS(1334),
    [anon_sym___vectorcall] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_signed] = ACTIONS(1334),
    [anon_sym_unsigned] = ACTIONS(1334),
    [anon_sym_long] = ACTIONS(1334),
    [anon_sym_short] = ACTIONS(1334),
    [anon_sym_static] = ACTIONS(1334),
    [anon_sym_auto] = ACTIONS(1334),
    [anon_sym_register] = ACTIONS(1334),
    [anon_sym_inline] = ACTIONS(1334),
    [anon_sym___inline] = ACTIONS(1334),
    [anon_sym___inline__] = ACTIONS(1334),
    [anon_sym___forceinline] = ACTIONS(1334),
    [anon_sym_thread_local] = ACTIONS(1334),
    [anon_sym___thread] = ACTIONS(1334),
    [anon_sym_const] = ACTIONS(1334),
    [anon_sym_constexpr] = ACTIONS(1334),
    [anon_sym_volatile] = ACTIONS(1334),
    [anon_sym_restrict] = ACTIONS(1334),
    [anon_sym___restrict__] = ACTIONS(1334),
    [anon_sym__Atomic] = ACTIONS(1334),
    [anon_sym__Noreturn] = ACTIONS(1334),
    [anon_sym_noreturn] = ACTIONS(1334),
    [sym_primitive_type] = ACTIONS(1334),
    [anon_sym_enum] = ACTIONS(1334),
    [anon_sym_struct] = ACTIONS(1334),
    [anon_sym_union] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1334),
    [anon_sym_else] = ACTIONS(1334),
    [anon_sym_switch] = ACTIONS(1334),
    [anon_sym_case] = ACTIONS(1334),
    [anon_sym_default] = ACTIONS(1334),
    [anon_sym_while] = ACTIONS(1334),
    [anon_sym_do] = ACTIONS(1334),
    [anon_sym_for] = ACTIONS(1334),
    [anon_sym_return] = ACTIONS(1334),
    [anon_sym_break] = ACTIONS(1334),
    [anon_sym_continue] = ACTIONS(1334),
    [anon_sym_goto] = ACTIONS(1334),
    [anon_sym___try] = ACTIONS(1334),
    [anon_sym___leave] = ACTIONS(1334),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_sizeof] = ACTIONS(1334),
    [anon_sym___alignof__] = ACTIONS(1334),
    [anon_sym___alignof] = ACTIONS(1334),
    [anon_sym__alignof] = ACTIONS(1334),
    [anon_sym_alignof] = ACTIONS(1334),
    [anon_sym__Alignof] = ACTIONS(1334),
    [anon_sym_offsetof] = ACTIONS(1334),
    [anon_sym__Generic] = ACTIONS(1334),
    [anon_sym_asm] = ACTIONS(1334),
    [anon_sym___asm__] = ACTIONS(1334),
    [sym_number_literal] = ACTIONS(1336),
    [anon_sym_L_SQUOTE] = ACTIONS(1336),
    [anon_sym_u_SQUOTE] = ACTIONS(1336),
    [anon_sym_U_SQUOTE] = ACTIONS(1336),
    [anon_sym_u8_SQUOTE] = ACTIONS(1336),
    [anon_sym_SQUOTE] = ACTIONS(1336),
    [anon_sym_L_DQUOTE] = ACTIONS(1336),
    [anon_sym_u_DQUOTE] = ACTIONS(1336),
    [anon_sym_U_DQUOTE] = ACTIONS(1336),
    [anon_sym_u8_DQUOTE] = ACTIONS(1336),
    [anon_sym_DQUOTE] = ACTIONS(1336),
    [sym_true] = ACTIONS(1334),
    [sym_false] = ACTIONS(1334),
    [anon_sym_NULL] = ACTIONS(1334),
    [anon_sym_nullptr] = ACTIONS(1334),
    [sym_comment] = ACTIONS(3),
  },
  [388] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [389] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [390] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [391] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [392] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [393] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [394] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [395] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [396] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [397] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [398] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [399] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [400] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [401] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [402] = {
    [sym_identifier] = ACTIONS(1350),
    [aux_sym_preproc_include_token1] = ACTIONS(1350),
    [aux_sym_preproc_def_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token1] = ACTIONS(1350),
    [aux_sym_preproc_if_token2] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1350),
    [sym_preproc_directive] = ACTIONS(1350),
    [anon_sym_LPAREN2] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym___extension__] = ACTIONS(1350),
    [anon_sym_typedef] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym___attribute__] = ACTIONS(1350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1352),
    [anon_sym___declspec] = ACTIONS(1350),
    [anon_sym___cdecl] = ACTIONS(1350),
    [anon_sym___clrcall] = ACTIONS(1350),
    [anon_sym___stdcall] = ACTIONS(1350),
    [anon_sym___fastcall] = ACTIONS(1350),
    [anon_sym___thiscall] = ACTIONS(1350),
    [anon_sym___vectorcall] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_signed] = ACTIONS(1350),
    [anon_sym_unsigned] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_auto] = ACTIONS(1350),
    [anon_sym_register] = ACTIONS(1350),
    [anon_sym_inline] = ACTIONS(1350),
    [anon_sym___inline] = ACTIONS(1350),
    [anon_sym___inline__] = ACTIONS(1350),
    [anon_sym___forceinline] = ACTIONS(1350),
    [anon_sym_thread_local] = ACTIONS(1350),
    [anon_sym___thread] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [anon_sym_constexpr] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_restrict] = ACTIONS(1350),
    [anon_sym___restrict__] = ACTIONS(1350),
    [anon_sym__Atomic] = ACTIONS(1350),
    [anon_sym__Noreturn] = ACTIONS(1350),
    [anon_sym_noreturn] = ACTIONS(1350),
    [sym_primitive_type] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_union] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_else] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1350),
    [anon_sym_default] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_do] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_goto] = ACTIONS(1350),
    [anon_sym___try] = ACTIONS(1350),
    [anon_sym___leave] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [anon_sym_sizeof] = ACTIONS(1350),
    [anon_sym___alignof__] = ACTIONS(1350),
    [anon_sym___alignof] = ACTIONS(1350),
    [anon_sym__alignof] = ACTIONS(1350),
    [anon_sym_alignof] = ACTIONS(1350),
    [anon_sym__Alignof] = ACTIONS(1350),
    [anon_sym_offsetof] = ACTIONS(1350),
    [anon_sym__Generic] = ACTIONS(1350),
    [anon_sym_asm] = ACTIONS(1350),
    [anon_sym___asm__] = ACTIONS(1350),
    [sym_number_literal] = ACTIONS(1352),
    [anon_sym_L_SQUOTE] = ACTIONS(1352),
    [anon_sym_u_SQUOTE] = ACTIONS(1352),
    [anon_sym_U_SQUOTE] = ACTIONS(1352),
    [anon_sym_u8_SQUOTE] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_L_DQUOTE] = ACTIONS(1352),
    [anon_sym_u_DQUOTE] = ACTIONS(1352),
    [anon_sym_U_DQUOTE] = ACTIONS(1352),
    [anon_sym_u8_DQUOTE] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [anon_sym_NULL] = ACTIONS(1350),
    [anon_sym_nullptr] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [403] = {
    [sym_attribute_declaration] = STATE(411),
    [sym_compound_statement] = STATE(180),
    [sym_attributed_statement] = STATE(180),
    [sym_labeled_statement] = STATE(180),
    [sym_expression_statement] = STATE(180),
    [sym_if_statement] = STATE(180),
    [sym_switch_statement] = STATE(180),
    [sym_case_statement] = STATE(180),
    [sym_while_statement] = STATE(180),
    [sym_do_statement] = STATE(180),
    [sym_for_statement] = STATE(180),
    [sym_return_statement] = STATE(180),
    [sym_break_statement] = STATE(180),
    [sym_continue_statement] = STATE(180),
    [sym_goto_statement] = STATE(180),
    [sym_seh_try_statement] = STATE(180),
    [sym_seh_leave_statement] = STATE(180),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [sym_identifier] = ACTIONS(1562),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [404] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(2371),
    [sym_attributed_statement] = STATE(2371),
    [sym_labeled_statement] = STATE(2371),
    [sym_expression_statement] = STATE(2371),
    [sym_if_statement] = STATE(2371),
    [sym_switch_statement] = STATE(2371),
    [sym_case_statement] = STATE(2371),
    [sym_while_statement] = STATE(2371),
    [sym_do_statement] = STATE(2371),
    [sym_for_statement] = STATE(2371),
    [sym_return_statement] = STATE(2371),
    [sym_break_statement] = STATE(2371),
    [sym_continue_statement] = STATE(2371),
    [sym_goto_statement] = STATE(2371),
    [sym_seh_try_statement] = STATE(2371),
    [sym_seh_leave_statement] = STATE(2371),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1566),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1278),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1568),
    [anon_sym_default] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1280),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1282),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1284),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [405] = {
    [sym_attribute_declaration] = STATE(416),
    [sym_compound_statement] = STATE(385),
    [sym_attributed_statement] = STATE(402),
    [sym_labeled_statement] = STATE(401),
    [sym_expression_statement] = STATE(400),
    [sym_if_statement] = STATE(399),
    [sym_switch_statement] = STATE(398),
    [sym_case_statement] = STATE(397),
    [sym_while_statement] = STATE(396),
    [sym_do_statement] = STATE(395),
    [sym_for_statement] = STATE(394),
    [sym_return_statement] = STATE(393),
    [sym_break_statement] = STATE(392),
    [sym_continue_statement] = STATE(391),
    [sym_goto_statement] = STATE(390),
    [sym_seh_try_statement] = STATE(389),
    [sym_seh_leave_statement] = STATE(388),
    [sym__expression] = STATE(1313),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2275),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(416),
    [sym_identifier] = ACTIONS(1572),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_switch] = ACTIONS(569),
    [anon_sym_case] = ACTIONS(571),
    [anon_sym_default] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(575),
    [anon_sym_do] = ACTIONS(577),
    [anon_sym_for] = ACTIONS(579),
    [anon_sym_return] = ACTIONS(581),
    [anon_sym_break] = ACTIONS(583),
    [anon_sym_continue] = ACTIONS(585),
    [anon_sym_goto] = ACTIONS(587),
    [anon_sym___try] = ACTIONS(589),
    [anon_sym___leave] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [406] = {
    [sym_attribute_declaration] = STATE(416),
    [sym_compound_statement] = STATE(382),
    [sym_attributed_statement] = STATE(382),
    [sym_labeled_statement] = STATE(382),
    [sym_expression_statement] = STATE(382),
    [sym_if_statement] = STATE(382),
    [sym_switch_statement] = STATE(382),
    [sym_case_statement] = STATE(382),
    [sym_while_statement] = STATE(382),
    [sym_do_statement] = STATE(382),
    [sym_for_statement] = STATE(382),
    [sym_return_statement] = STATE(382),
    [sym_break_statement] = STATE(382),
    [sym_continue_statement] = STATE(382),
    [sym_goto_statement] = STATE(382),
    [sym_seh_try_statement] = STATE(382),
    [sym_seh_leave_statement] = STATE(382),
    [sym__expression] = STATE(1313),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2275),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(416),
    [sym_identifier] = ACTIONS(1572),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_switch] = ACTIONS(569),
    [anon_sym_case] = ACTIONS(571),
    [anon_sym_default] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(575),
    [anon_sym_do] = ACTIONS(577),
    [anon_sym_for] = ACTIONS(579),
    [anon_sym_return] = ACTIONS(581),
    [anon_sym_break] = ACTIONS(583),
    [anon_sym_continue] = ACTIONS(585),
    [anon_sym_goto] = ACTIONS(587),
    [anon_sym___try] = ACTIONS(589),
    [anon_sym___leave] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [407] = {
    [sym_identifier] = ACTIONS(1442),
    [aux_sym_preproc_include_token1] = ACTIONS(1442),
    [aux_sym_preproc_def_token1] = ACTIONS(1442),
    [aux_sym_preproc_if_token1] = ACTIONS(1442),
    [aux_sym_preproc_if_token2] = ACTIONS(1442),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1442),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1442),
    [sym_preproc_directive] = ACTIONS(1442),
    [anon_sym_LPAREN2] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1444),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1444),
    [anon_sym___extension__] = ACTIONS(1442),
    [anon_sym_typedef] = ACTIONS(1442),
    [anon_sym_extern] = ACTIONS(1442),
    [anon_sym___attribute__] = ACTIONS(1442),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1444),
    [anon_sym___declspec] = ACTIONS(1442),
    [anon_sym___cdecl] = ACTIONS(1442),
    [anon_sym___clrcall] = ACTIONS(1442),
    [anon_sym___stdcall] = ACTIONS(1442),
    [anon_sym___fastcall] = ACTIONS(1442),
    [anon_sym___thiscall] = ACTIONS(1442),
    [anon_sym___vectorcall] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1444),
    [anon_sym_signed] = ACTIONS(1442),
    [anon_sym_unsigned] = ACTIONS(1442),
    [anon_sym_long] = ACTIONS(1442),
    [anon_sym_short] = ACTIONS(1442),
    [anon_sym_static] = ACTIONS(1442),
    [anon_sym_auto] = ACTIONS(1442),
    [anon_sym_register] = ACTIONS(1442),
    [anon_sym_inline] = ACTIONS(1442),
    [anon_sym___inline] = ACTIONS(1442),
    [anon_sym___inline__] = ACTIONS(1442),
    [anon_sym___forceinline] = ACTIONS(1442),
    [anon_sym_thread_local] = ACTIONS(1442),
    [anon_sym___thread] = ACTIONS(1442),
    [anon_sym_const] = ACTIONS(1442),
    [anon_sym_constexpr] = ACTIONS(1442),
    [anon_sym_volatile] = ACTIONS(1442),
    [anon_sym_restrict] = ACTIONS(1442),
    [anon_sym___restrict__] = ACTIONS(1442),
    [anon_sym__Atomic] = ACTIONS(1442),
    [anon_sym__Noreturn] = ACTIONS(1442),
    [anon_sym_noreturn] = ACTIONS(1442),
    [sym_primitive_type] = ACTIONS(1442),
    [anon_sym_enum] = ACTIONS(1442),
    [anon_sym_struct] = ACTIONS(1442),
    [anon_sym_union] = ACTIONS(1442),
    [anon_sym_if] = ACTIONS(1442),
    [anon_sym_switch] = ACTIONS(1442),
    [anon_sym_case] = ACTIONS(1442),
    [anon_sym_default] = ACTIONS(1442),
    [anon_sym_while] = ACTIONS(1442),
    [anon_sym_do] = ACTIONS(1442),
    [anon_sym_for] = ACTIONS(1442),
    [anon_sym_return] = ACTIONS(1442),
    [anon_sym_break] = ACTIONS(1442),
    [anon_sym_continue] = ACTIONS(1442),
    [anon_sym_goto] = ACTIONS(1442),
    [anon_sym___try] = ACTIONS(1442),
    [anon_sym___leave] = ACTIONS(1442),
    [anon_sym_DASH_DASH] = ACTIONS(1444),
    [anon_sym_PLUS_PLUS] = ACTIONS(1444),
    [anon_sym_sizeof] = ACTIONS(1442),
    [anon_sym___alignof__] = ACTIONS(1442),
    [anon_sym___alignof] = ACTIONS(1442),
    [anon_sym__alignof] = ACTIONS(1442),
    [anon_sym_alignof] = ACTIONS(1442),
    [anon_sym__Alignof] = ACTIONS(1442),
    [anon_sym_offsetof] = ACTIONS(1442),
    [anon_sym__Generic] = ACTIONS(1442),
    [anon_sym_asm] = ACTIONS(1442),
    [anon_sym___asm__] = ACTIONS(1442),
    [sym_number_literal] = ACTIONS(1444),
    [anon_sym_L_SQUOTE] = ACTIONS(1444),
    [anon_sym_u_SQUOTE] = ACTIONS(1444),
    [anon_sym_U_SQUOTE] = ACTIONS(1444),
    [anon_sym_u8_SQUOTE] = ACTIONS(1444),
    [anon_sym_SQUOTE] = ACTIONS(1444),
    [anon_sym_L_DQUOTE] = ACTIONS(1444),
    [anon_sym_u_DQUOTE] = ACTIONS(1444),
    [anon_sym_U_DQUOTE] = ACTIONS(1444),
    [anon_sym_u8_DQUOTE] = ACTIONS(1444),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [sym_true] = ACTIONS(1442),
    [sym_false] = ACTIONS(1442),
    [anon_sym_NULL] = ACTIONS(1442),
    [anon_sym_nullptr] = ACTIONS(1442),
    [sym_comment] = ACTIONS(3),
  },
  [408] = {
    [sym_attribute_declaration] = STATE(463),
    [sym_compound_statement] = STATE(308),
    [sym_attributed_statement] = STATE(308),
    [sym_labeled_statement] = STATE(308),
    [sym_expression_statement] = STATE(308),
    [sym_if_statement] = STATE(308),
    [sym_switch_statement] = STATE(308),
    [sym_case_statement] = STATE(308),
    [sym_while_statement] = STATE(308),
    [sym_do_statement] = STATE(308),
    [sym_for_statement] = STATE(308),
    [sym_return_statement] = STATE(308),
    [sym_break_statement] = STATE(308),
    [sym_continue_statement] = STATE(308),
    [sym_goto_statement] = STATE(308),
    [sym_seh_try_statement] = STATE(308),
    [sym_seh_leave_statement] = STATE(308),
    [sym__expression] = STATE(1348),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2343),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(463),
    [sym_identifier] = ACTIONS(1574),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1101),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_default] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1103),
    [anon_sym___leave] = ACTIONS(1105),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [409] = {
    [sym_attribute_declaration] = STATE(409),
    [sym_compound_statement] = STATE(328),
    [sym_attributed_statement] = STATE(328),
    [sym_labeled_statement] = STATE(328),
    [sym_expression_statement] = STATE(328),
    [sym_if_statement] = STATE(328),
    [sym_switch_statement] = STATE(328),
    [sym_case_statement] = STATE(328),
    [sym_while_statement] = STATE(328),
    [sym_do_statement] = STATE(328),
    [sym_for_statement] = STATE(328),
    [sym_return_statement] = STATE(328),
    [sym_break_statement] = STATE(328),
    [sym_continue_statement] = STATE(328),
    [sym_goto_statement] = STATE(328),
    [sym_seh_try_statement] = STATE(328),
    [sym_seh_leave_statement] = STATE(328),
    [sym__expression] = STATE(1313),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2275),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(409),
    [sym_identifier] = ACTIONS(1576),
    [anon_sym_LPAREN2] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1582),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1588),
    [anon_sym_SEMI] = ACTIONS(1591),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1594),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1600),
    [anon_sym_switch] = ACTIONS(1603),
    [anon_sym_case] = ACTIONS(1606),
    [anon_sym_default] = ACTIONS(1609),
    [anon_sym_while] = ACTIONS(1612),
    [anon_sym_do] = ACTIONS(1615),
    [anon_sym_for] = ACTIONS(1618),
    [anon_sym_return] = ACTIONS(1621),
    [anon_sym_break] = ACTIONS(1624),
    [anon_sym_continue] = ACTIONS(1627),
    [anon_sym_goto] = ACTIONS(1630),
    [anon_sym___try] = ACTIONS(1633),
    [anon_sym___leave] = ACTIONS(1636),
    [anon_sym_DASH_DASH] = ACTIONS(1639),
    [anon_sym_PLUS_PLUS] = ACTIONS(1639),
    [anon_sym_sizeof] = ACTIONS(1642),
    [anon_sym___alignof__] = ACTIONS(1645),
    [anon_sym___alignof] = ACTIONS(1645),
    [anon_sym__alignof] = ACTIONS(1645),
    [anon_sym_alignof] = ACTIONS(1645),
    [anon_sym__Alignof] = ACTIONS(1645),
    [anon_sym_offsetof] = ACTIONS(1648),
    [anon_sym__Generic] = ACTIONS(1651),
    [anon_sym_asm] = ACTIONS(1654),
    [anon_sym___asm__] = ACTIONS(1654),
    [sym_number_literal] = ACTIONS(1657),
    [anon_sym_L_SQUOTE] = ACTIONS(1660),
    [anon_sym_u_SQUOTE] = ACTIONS(1660),
    [anon_sym_U_SQUOTE] = ACTIONS(1660),
    [anon_sym_u8_SQUOTE] = ACTIONS(1660),
    [anon_sym_SQUOTE] = ACTIONS(1660),
    [anon_sym_L_DQUOTE] = ACTIONS(1663),
    [anon_sym_u_DQUOTE] = ACTIONS(1663),
    [anon_sym_U_DQUOTE] = ACTIONS(1663),
    [anon_sym_u8_DQUOTE] = ACTIONS(1663),
    [anon_sym_DQUOTE] = ACTIONS(1663),
    [sym_true] = ACTIONS(1666),
    [sym_false] = ACTIONS(1666),
    [anon_sym_NULL] = ACTIONS(1669),
    [anon_sym_nullptr] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
  },
  [410] = {
    [sym_identifier] = ACTIONS(1446),
    [aux_sym_preproc_include_token1] = ACTIONS(1446),
    [aux_sym_preproc_def_token1] = ACTIONS(1446),
    [aux_sym_preproc_if_token1] = ACTIONS(1446),
    [aux_sym_preproc_if_token2] = ACTIONS(1446),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1446),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1446),
    [sym_preproc_directive] = ACTIONS(1446),
    [anon_sym_LPAREN2] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1446),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym___extension__] = ACTIONS(1446),
    [anon_sym_typedef] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(1446),
    [anon_sym___attribute__] = ACTIONS(1446),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(1446),
    [anon_sym___cdecl] = ACTIONS(1446),
    [anon_sym___clrcall] = ACTIONS(1446),
    [anon_sym___stdcall] = ACTIONS(1446),
    [anon_sym___fastcall] = ACTIONS(1446),
    [anon_sym___thiscall] = ACTIONS(1446),
    [anon_sym___vectorcall] = ACTIONS(1446),
    [anon_sym_LBRACE] = ACTIONS(1448),
    [anon_sym_signed] = ACTIONS(1446),
    [anon_sym_unsigned] = ACTIONS(1446),
    [anon_sym_long] = ACTIONS(1446),
    [anon_sym_short] = ACTIONS(1446),
    [anon_sym_static] = ACTIONS(1446),
    [anon_sym_auto] = ACTIONS(1446),
    [anon_sym_register] = ACTIONS(1446),
    [anon_sym_inline] = ACTIONS(1446),
    [anon_sym___inline] = ACTIONS(1446),
    [anon_sym___inline__] = ACTIONS(1446),
    [anon_sym___forceinline] = ACTIONS(1446),
    [anon_sym_thread_local] = ACTIONS(1446),
    [anon_sym___thread] = ACTIONS(1446),
    [anon_sym_const] = ACTIONS(1446),
    [anon_sym_constexpr] = ACTIONS(1446),
    [anon_sym_volatile] = ACTIONS(1446),
    [anon_sym_restrict] = ACTIONS(1446),
    [anon_sym___restrict__] = ACTIONS(1446),
    [anon_sym__Atomic] = ACTIONS(1446),
    [anon_sym__Noreturn] = ACTIONS(1446),
    [anon_sym_noreturn] = ACTIONS(1446),
    [sym_primitive_type] = ACTIONS(1446),
    [anon_sym_enum] = ACTIONS(1446),
    [anon_sym_struct] = ACTIONS(1446),
    [anon_sym_union] = ACTIONS(1446),
    [anon_sym_if] = ACTIONS(1446),
    [anon_sym_switch] = ACTIONS(1446),
    [anon_sym_case] = ACTIONS(1446),
    [anon_sym_default] = ACTIONS(1446),
    [anon_sym_while] = ACTIONS(1446),
    [anon_sym_do] = ACTIONS(1446),
    [anon_sym_for] = ACTIONS(1446),
    [anon_sym_return] = ACTIONS(1446),
    [anon_sym_break] = ACTIONS(1446),
    [anon_sym_continue] = ACTIONS(1446),
    [anon_sym_goto] = ACTIONS(1446),
    [anon_sym___try] = ACTIONS(1446),
    [anon_sym___leave] = ACTIONS(1446),
    [anon_sym_DASH_DASH] = ACTIONS(1448),
    [anon_sym_PLUS_PLUS] = ACTIONS(1448),
    [anon_sym_sizeof] = ACTIONS(1446),
    [anon_sym___alignof__] = ACTIONS(1446),
    [anon_sym___alignof] = ACTIONS(1446),
    [anon_sym__alignof] = ACTIONS(1446),
    [anon_sym_alignof] = ACTIONS(1446),
    [anon_sym__Alignof] = ACTIONS(1446),
    [anon_sym_offsetof] = ACTIONS(1446),
    [anon_sym__Generic] = ACTIONS(1446),
    [anon_sym_asm] = ACTIONS(1446),
    [anon_sym___asm__] = ACTIONS(1446),
    [sym_number_literal] = ACTIONS(1448),
    [anon_sym_L_SQUOTE] = ACTIONS(1448),
    [anon_sym_u_SQUOTE] = ACTIONS(1448),
    [anon_sym_U_SQUOTE] = ACTIONS(1448),
    [anon_sym_u8_SQUOTE] = ACTIONS(1448),
    [anon_sym_SQUOTE] = ACTIONS(1448),
    [anon_sym_L_DQUOTE] = ACTIONS(1448),
    [anon_sym_u_DQUOTE] = ACTIONS(1448),
    [anon_sym_U_DQUOTE] = ACTIONS(1448),
    [anon_sym_u8_DQUOTE] = ACTIONS(1448),
    [anon_sym_DQUOTE] = ACTIONS(1448),
    [sym_true] = ACTIONS(1446),
    [sym_false] = ACTIONS(1446),
    [anon_sym_NULL] = ACTIONS(1446),
    [anon_sym_nullptr] = ACTIONS(1446),
    [sym_comment] = ACTIONS(3),
  },
  [411] = {
    [sym_attribute_declaration] = STATE(443),
    [sym_compound_statement] = STATE(219),
    [sym_attributed_statement] = STATE(219),
    [sym_labeled_statement] = STATE(219),
    [sym_expression_statement] = STATE(219),
    [sym_if_statement] = STATE(219),
    [sym_switch_statement] = STATE(219),
    [sym_case_statement] = STATE(219),
    [sym_while_statement] = STATE(219),
    [sym_do_statement] = STATE(219),
    [sym_for_statement] = STATE(219),
    [sym_return_statement] = STATE(219),
    [sym_break_statement] = STATE(219),
    [sym_continue_statement] = STATE(219),
    [sym_goto_statement] = STATE(219),
    [sym_seh_try_statement] = STATE(219),
    [sym_seh_leave_statement] = STATE(219),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(443),
    [sym_identifier] = ACTIONS(1562),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [412] = {
    [sym_identifier] = ACTIONS(1450),
    [aux_sym_preproc_include_token1] = ACTIONS(1450),
    [aux_sym_preproc_def_token1] = ACTIONS(1450),
    [aux_sym_preproc_if_token1] = ACTIONS(1450),
    [aux_sym_preproc_if_token2] = ACTIONS(1450),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1450),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1450),
    [sym_preproc_directive] = ACTIONS(1450),
    [anon_sym_LPAREN2] = ACTIONS(1452),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_TILDE] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1450),
    [anon_sym_PLUS] = ACTIONS(1450),
    [anon_sym_STAR] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1452),
    [anon_sym_SEMI] = ACTIONS(1452),
    [anon_sym___extension__] = ACTIONS(1450),
    [anon_sym_typedef] = ACTIONS(1450),
    [anon_sym_extern] = ACTIONS(1450),
    [anon_sym___attribute__] = ACTIONS(1450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1452),
    [anon_sym___declspec] = ACTIONS(1450),
    [anon_sym___cdecl] = ACTIONS(1450),
    [anon_sym___clrcall] = ACTIONS(1450),
    [anon_sym___stdcall] = ACTIONS(1450),
    [anon_sym___fastcall] = ACTIONS(1450),
    [anon_sym___thiscall] = ACTIONS(1450),
    [anon_sym___vectorcall] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(1452),
    [anon_sym_signed] = ACTIONS(1450),
    [anon_sym_unsigned] = ACTIONS(1450),
    [anon_sym_long] = ACTIONS(1450),
    [anon_sym_short] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(1450),
    [anon_sym_auto] = ACTIONS(1450),
    [anon_sym_register] = ACTIONS(1450),
    [anon_sym_inline] = ACTIONS(1450),
    [anon_sym___inline] = ACTIONS(1450),
    [anon_sym___inline__] = ACTIONS(1450),
    [anon_sym___forceinline] = ACTIONS(1450),
    [anon_sym_thread_local] = ACTIONS(1450),
    [anon_sym___thread] = ACTIONS(1450),
    [anon_sym_const] = ACTIONS(1450),
    [anon_sym_constexpr] = ACTIONS(1450),
    [anon_sym_volatile] = ACTIONS(1450),
    [anon_sym_restrict] = ACTIONS(1450),
    [anon_sym___restrict__] = ACTIONS(1450),
    [anon_sym__Atomic] = ACTIONS(1450),
    [anon_sym__Noreturn] = ACTIONS(1450),
    [anon_sym_noreturn] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(1450),
    [anon_sym_enum] = ACTIONS(1450),
    [anon_sym_struct] = ACTIONS(1450),
    [anon_sym_union] = ACTIONS(1450),
    [anon_sym_if] = ACTIONS(1450),
    [anon_sym_switch] = ACTIONS(1450),
    [anon_sym_case] = ACTIONS(1450),
    [anon_sym_default] = ACTIONS(1450),
    [anon_sym_while] = ACTIONS(1450),
    [anon_sym_do] = ACTIONS(1450),
    [anon_sym_for] = ACTIONS(1450),
    [anon_sym_return] = ACTIONS(1450),
    [anon_sym_break] = ACTIONS(1450),
    [anon_sym_continue] = ACTIONS(1450),
    [anon_sym_goto] = ACTIONS(1450),
    [anon_sym___try] = ACTIONS(1450),
    [anon_sym___leave] = ACTIONS(1450),
    [anon_sym_DASH_DASH] = ACTIONS(1452),
    [anon_sym_PLUS_PLUS] = ACTIONS(1452),
    [anon_sym_sizeof] = ACTIONS(1450),
    [anon_sym___alignof__] = ACTIONS(1450),
    [anon_sym___alignof] = ACTIONS(1450),
    [anon_sym__alignof] = ACTIONS(1450),
    [anon_sym_alignof] = ACTIONS(1450),
    [anon_sym__Alignof] = ACTIONS(1450),
    [anon_sym_offsetof] = ACTIONS(1450),
    [anon_sym__Generic] = ACTIONS(1450),
    [anon_sym_asm] = ACTIONS(1450),
    [anon_sym___asm__] = ACTIONS(1450),
    [sym_number_literal] = ACTIONS(1452),
    [anon_sym_L_SQUOTE] = ACTIONS(1452),
    [anon_sym_u_SQUOTE] = ACTIONS(1452),
    [anon_sym_U_SQUOTE] = ACTIONS(1452),
    [anon_sym_u8_SQUOTE] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [anon_sym_L_DQUOTE] = ACTIONS(1452),
    [anon_sym_u_DQUOTE] = ACTIONS(1452),
    [anon_sym_U_DQUOTE] = ACTIONS(1452),
    [anon_sym_u8_DQUOTE] = ACTIONS(1452),
    [anon_sym_DQUOTE] = ACTIONS(1452),
    [sym_true] = ACTIONS(1450),
    [sym_false] = ACTIONS(1450),
    [anon_sym_NULL] = ACTIONS(1450),
    [anon_sym_nullptr] = ACTIONS(1450),
    [sym_comment] = ACTIONS(3),
  },
  [413] = {
    [sym_identifier] = ACTIONS(1422),
    [aux_sym_preproc_include_token1] = ACTIONS(1422),
    [aux_sym_preproc_def_token1] = ACTIONS(1422),
    [aux_sym_preproc_if_token1] = ACTIONS(1422),
    [aux_sym_preproc_if_token2] = ACTIONS(1422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1422),
    [sym_preproc_directive] = ACTIONS(1422),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(1424),
    [anon_sym_TILDE] = ACTIONS(1424),
    [anon_sym_DASH] = ACTIONS(1422),
    [anon_sym_PLUS] = ACTIONS(1422),
    [anon_sym_STAR] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym___extension__] = ACTIONS(1422),
    [anon_sym_typedef] = ACTIONS(1422),
    [anon_sym_extern] = ACTIONS(1422),
    [anon_sym___attribute__] = ACTIONS(1422),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1424),
    [anon_sym___declspec] = ACTIONS(1422),
    [anon_sym___cdecl] = ACTIONS(1422),
    [anon_sym___clrcall] = ACTIONS(1422),
    [anon_sym___stdcall] = ACTIONS(1422),
    [anon_sym___fastcall] = ACTIONS(1422),
    [anon_sym___thiscall] = ACTIONS(1422),
    [anon_sym___vectorcall] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(1424),
    [anon_sym_signed] = ACTIONS(1422),
    [anon_sym_unsigned] = ACTIONS(1422),
    [anon_sym_long] = ACTIONS(1422),
    [anon_sym_short] = ACTIONS(1422),
    [anon_sym_static] = ACTIONS(1422),
    [anon_sym_auto] = ACTIONS(1422),
    [anon_sym_register] = ACTIONS(1422),
    [anon_sym_inline] = ACTIONS(1422),
    [anon_sym___inline] = ACTIONS(1422),
    [anon_sym___inline__] = ACTIONS(1422),
    [anon_sym___forceinline] = ACTIONS(1422),
    [anon_sym_thread_local] = ACTIONS(1422),
    [anon_sym___thread] = ACTIONS(1422),
    [anon_sym_const] = ACTIONS(1422),
    [anon_sym_constexpr] = ACTIONS(1422),
    [anon_sym_volatile] = ACTIONS(1422),
    [anon_sym_restrict] = ACTIONS(1422),
    [anon_sym___restrict__] = ACTIONS(1422),
    [anon_sym__Atomic] = ACTIONS(1422),
    [anon_sym__Noreturn] = ACTIONS(1422),
    [anon_sym_noreturn] = ACTIONS(1422),
    [sym_primitive_type] = ACTIONS(1422),
    [anon_sym_enum] = ACTIONS(1422),
    [anon_sym_struct] = ACTIONS(1422),
    [anon_sym_union] = ACTIONS(1422),
    [anon_sym_if] = ACTIONS(1422),
    [anon_sym_switch] = ACTIONS(1422),
    [anon_sym_case] = ACTIONS(1422),
    [anon_sym_default] = ACTIONS(1422),
    [anon_sym_while] = ACTIONS(1422),
    [anon_sym_do] = ACTIONS(1422),
    [anon_sym_for] = ACTIONS(1422),
    [anon_sym_return] = ACTIONS(1422),
    [anon_sym_break] = ACTIONS(1422),
    [anon_sym_continue] = ACTIONS(1422),
    [anon_sym_goto] = ACTIONS(1422),
    [anon_sym___try] = ACTIONS(1422),
    [anon_sym___leave] = ACTIONS(1422),
    [anon_sym_DASH_DASH] = ACTIONS(1424),
    [anon_sym_PLUS_PLUS] = ACTIONS(1424),
    [anon_sym_sizeof] = ACTIONS(1422),
    [anon_sym___alignof__] = ACTIONS(1422),
    [anon_sym___alignof] = ACTIONS(1422),
    [anon_sym__alignof] = ACTIONS(1422),
    [anon_sym_alignof] = ACTIONS(1422),
    [anon_sym__Alignof] = ACTIONS(1422),
    [anon_sym_offsetof] = ACTIONS(1422),
    [anon_sym__Generic] = ACTIONS(1422),
    [anon_sym_asm] = ACTIONS(1422),
    [anon_sym___asm__] = ACTIONS(1422),
    [sym_number_literal] = ACTIONS(1424),
    [anon_sym_L_SQUOTE] = ACTIONS(1424),
    [anon_sym_u_SQUOTE] = ACTIONS(1424),
    [anon_sym_U_SQUOTE] = ACTIONS(1424),
    [anon_sym_u8_SQUOTE] = ACTIONS(1424),
    [anon_sym_SQUOTE] = ACTIONS(1424),
    [anon_sym_L_DQUOTE] = ACTIONS(1424),
    [anon_sym_u_DQUOTE] = ACTIONS(1424),
    [anon_sym_U_DQUOTE] = ACTIONS(1424),
    [anon_sym_u8_DQUOTE] = ACTIONS(1424),
    [anon_sym_DQUOTE] = ACTIONS(1424),
    [sym_true] = ACTIONS(1422),
    [sym_false] = ACTIONS(1422),
    [anon_sym_NULL] = ACTIONS(1422),
    [anon_sym_nullptr] = ACTIONS(1422),
    [sym_comment] = ACTIONS(3),
  },
  [414] = {
    [sym_attribute_declaration] = STATE(463),
    [sym_compound_statement] = STATE(285),
    [sym_attributed_statement] = STATE(285),
    [sym_labeled_statement] = STATE(285),
    [sym_expression_statement] = STATE(285),
    [sym_if_statement] = STATE(285),
    [sym_switch_statement] = STATE(285),
    [sym_case_statement] = STATE(285),
    [sym_while_statement] = STATE(285),
    [sym_do_statement] = STATE(285),
    [sym_for_statement] = STATE(285),
    [sym_return_statement] = STATE(285),
    [sym_break_statement] = STATE(285),
    [sym_continue_statement] = STATE(285),
    [sym_goto_statement] = STATE(285),
    [sym_seh_try_statement] = STATE(285),
    [sym_seh_leave_statement] = STATE(285),
    [sym__expression] = STATE(1348),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2343),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(463),
    [sym_identifier] = ACTIONS(1574),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1101),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_default] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1103),
    [anon_sym___leave] = ACTIONS(1105),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [415] = {
    [sym_attribute_declaration] = STATE(463),
    [sym_compound_statement] = STATE(230),
    [sym_attributed_statement] = STATE(230),
    [sym_labeled_statement] = STATE(230),
    [sym_expression_statement] = STATE(230),
    [sym_if_statement] = STATE(230),
    [sym_switch_statement] = STATE(230),
    [sym_case_statement] = STATE(230),
    [sym_while_statement] = STATE(230),
    [sym_do_statement] = STATE(230),
    [sym_for_statement] = STATE(230),
    [sym_return_statement] = STATE(230),
    [sym_break_statement] = STATE(230),
    [sym_continue_statement] = STATE(230),
    [sym_goto_statement] = STATE(230),
    [sym_seh_try_statement] = STATE(230),
    [sym_seh_leave_statement] = STATE(230),
    [sym__expression] = STATE(1348),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2343),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(463),
    [sym_identifier] = ACTIONS(1574),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1101),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_default] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1103),
    [anon_sym___leave] = ACTIONS(1105),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [416] = {
    [sym_attribute_declaration] = STATE(409),
    [sym_compound_statement] = STATE(328),
    [sym_attributed_statement] = STATE(328),
    [sym_labeled_statement] = STATE(328),
    [sym_expression_statement] = STATE(328),
    [sym_if_statement] = STATE(328),
    [sym_switch_statement] = STATE(328),
    [sym_case_statement] = STATE(328),
    [sym_while_statement] = STATE(328),
    [sym_do_statement] = STATE(328),
    [sym_for_statement] = STATE(328),
    [sym_return_statement] = STATE(328),
    [sym_break_statement] = STATE(328),
    [sym_continue_statement] = STATE(328),
    [sym_goto_statement] = STATE(328),
    [sym_seh_try_statement] = STATE(328),
    [sym_seh_leave_statement] = STATE(328),
    [sym__expression] = STATE(1313),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2275),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(409),
    [sym_identifier] = ACTIONS(1572),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_switch] = ACTIONS(569),
    [anon_sym_case] = ACTIONS(571),
    [anon_sym_default] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(575),
    [anon_sym_do] = ACTIONS(577),
    [anon_sym_for] = ACTIONS(579),
    [anon_sym_return] = ACTIONS(581),
    [anon_sym_break] = ACTIONS(583),
    [anon_sym_continue] = ACTIONS(585),
    [anon_sym_goto] = ACTIONS(587),
    [anon_sym___try] = ACTIONS(589),
    [anon_sym___leave] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [417] = {
    [sym_attribute_declaration] = STATE(416),
    [sym_compound_statement] = STATE(345),
    [sym_attributed_statement] = STATE(345),
    [sym_labeled_statement] = STATE(345),
    [sym_expression_statement] = STATE(345),
    [sym_if_statement] = STATE(345),
    [sym_switch_statement] = STATE(345),
    [sym_case_statement] = STATE(345),
    [sym_while_statement] = STATE(345),
    [sym_do_statement] = STATE(345),
    [sym_for_statement] = STATE(345),
    [sym_return_statement] = STATE(345),
    [sym_break_statement] = STATE(345),
    [sym_continue_statement] = STATE(345),
    [sym_goto_statement] = STATE(345),
    [sym_seh_try_statement] = STATE(345),
    [sym_seh_leave_statement] = STATE(345),
    [sym__expression] = STATE(1313),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2275),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(416),
    [sym_identifier] = ACTIONS(1572),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_switch] = ACTIONS(569),
    [anon_sym_case] = ACTIONS(571),
    [anon_sym_default] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(575),
    [anon_sym_do] = ACTIONS(577),
    [anon_sym_for] = ACTIONS(579),
    [anon_sym_return] = ACTIONS(581),
    [anon_sym_break] = ACTIONS(583),
    [anon_sym_continue] = ACTIONS(585),
    [anon_sym_goto] = ACTIONS(587),
    [anon_sym___try] = ACTIONS(589),
    [anon_sym___leave] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [418] = {
    [sym_identifier] = ACTIONS(1486),
    [aux_sym_preproc_include_token1] = ACTIONS(1486),
    [aux_sym_preproc_def_token1] = ACTIONS(1486),
    [aux_sym_preproc_if_token1] = ACTIONS(1486),
    [aux_sym_preproc_if_token2] = ACTIONS(1486),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1486),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1486),
    [sym_preproc_directive] = ACTIONS(1486),
    [anon_sym_LPAREN2] = ACTIONS(1488),
    [anon_sym_BANG] = ACTIONS(1488),
    [anon_sym_TILDE] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_STAR] = ACTIONS(1488),
    [anon_sym_AMP] = ACTIONS(1488),
    [anon_sym_SEMI] = ACTIONS(1488),
    [anon_sym___extension__] = ACTIONS(1486),
    [anon_sym_typedef] = ACTIONS(1486),
    [anon_sym_extern] = ACTIONS(1486),
    [anon_sym___attribute__] = ACTIONS(1486),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1488),
    [anon_sym___declspec] = ACTIONS(1486),
    [anon_sym___cdecl] = ACTIONS(1486),
    [anon_sym___clrcall] = ACTIONS(1486),
    [anon_sym___stdcall] = ACTIONS(1486),
    [anon_sym___fastcall] = ACTIONS(1486),
    [anon_sym___thiscall] = ACTIONS(1486),
    [anon_sym___vectorcall] = ACTIONS(1486),
    [anon_sym_LBRACE] = ACTIONS(1488),
    [anon_sym_signed] = ACTIONS(1486),
    [anon_sym_unsigned] = ACTIONS(1486),
    [anon_sym_long] = ACTIONS(1486),
    [anon_sym_short] = ACTIONS(1486),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_auto] = ACTIONS(1486),
    [anon_sym_register] = ACTIONS(1486),
    [anon_sym_inline] = ACTIONS(1486),
    [anon_sym___inline] = ACTIONS(1486),
    [anon_sym___inline__] = ACTIONS(1486),
    [anon_sym___forceinline] = ACTIONS(1486),
    [anon_sym_thread_local] = ACTIONS(1486),
    [anon_sym___thread] = ACTIONS(1486),
    [anon_sym_const] = ACTIONS(1486),
    [anon_sym_constexpr] = ACTIONS(1486),
    [anon_sym_volatile] = ACTIONS(1486),
    [anon_sym_restrict] = ACTIONS(1486),
    [anon_sym___restrict__] = ACTIONS(1486),
    [anon_sym__Atomic] = ACTIONS(1486),
    [anon_sym__Noreturn] = ACTIONS(1486),
    [anon_sym_noreturn] = ACTIONS(1486),
    [sym_primitive_type] = ACTIONS(1486),
    [anon_sym_enum] = ACTIONS(1486),
    [anon_sym_struct] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(1486),
    [anon_sym_if] = ACTIONS(1486),
    [anon_sym_switch] = ACTIONS(1486),
    [anon_sym_case] = ACTIONS(1486),
    [anon_sym_default] = ACTIONS(1486),
    [anon_sym_while] = ACTIONS(1486),
    [anon_sym_do] = ACTIONS(1486),
    [anon_sym_for] = ACTIONS(1486),
    [anon_sym_return] = ACTIONS(1486),
    [anon_sym_break] = ACTIONS(1486),
    [anon_sym_continue] = ACTIONS(1486),
    [anon_sym_goto] = ACTIONS(1486),
    [anon_sym___try] = ACTIONS(1486),
    [anon_sym___leave] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1488),
    [anon_sym_PLUS_PLUS] = ACTIONS(1488),
    [anon_sym_sizeof] = ACTIONS(1486),
    [anon_sym___alignof__] = ACTIONS(1486),
    [anon_sym___alignof] = ACTIONS(1486),
    [anon_sym__alignof] = ACTIONS(1486),
    [anon_sym_alignof] = ACTIONS(1486),
    [anon_sym__Alignof] = ACTIONS(1486),
    [anon_sym_offsetof] = ACTIONS(1486),
    [anon_sym__Generic] = ACTIONS(1486),
    [anon_sym_asm] = ACTIONS(1486),
    [anon_sym___asm__] = ACTIONS(1486),
    [sym_number_literal] = ACTIONS(1488),
    [anon_sym_L_SQUOTE] = ACTIONS(1488),
    [anon_sym_u_SQUOTE] = ACTIONS(1488),
    [anon_sym_U_SQUOTE] = ACTIONS(1488),
    [anon_sym_u8_SQUOTE] = ACTIONS(1488),
    [anon_sym_SQUOTE] = ACTIONS(1488),
    [anon_sym_L_DQUOTE] = ACTIONS(1488),
    [anon_sym_u_DQUOTE] = ACTIONS(1488),
    [anon_sym_U_DQUOTE] = ACTIONS(1488),
    [anon_sym_u8_DQUOTE] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(1488),
    [sym_true] = ACTIONS(1486),
    [sym_false] = ACTIONS(1486),
    [anon_sym_NULL] = ACTIONS(1486),
    [anon_sym_nullptr] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
  },
  [419] = {
    [sym_identifier] = ACTIONS(1454),
    [aux_sym_preproc_include_token1] = ACTIONS(1454),
    [aux_sym_preproc_def_token1] = ACTIONS(1454),
    [aux_sym_preproc_if_token1] = ACTIONS(1454),
    [aux_sym_preproc_if_token2] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1454),
    [sym_preproc_directive] = ACTIONS(1454),
    [anon_sym_LPAREN2] = ACTIONS(1456),
    [anon_sym_BANG] = ACTIONS(1456),
    [anon_sym_TILDE] = ACTIONS(1456),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_STAR] = ACTIONS(1456),
    [anon_sym_AMP] = ACTIONS(1456),
    [anon_sym_SEMI] = ACTIONS(1456),
    [anon_sym___extension__] = ACTIONS(1454),
    [anon_sym_typedef] = ACTIONS(1454),
    [anon_sym_extern] = ACTIONS(1454),
    [anon_sym___attribute__] = ACTIONS(1454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1456),
    [anon_sym___declspec] = ACTIONS(1454),
    [anon_sym___cdecl] = ACTIONS(1454),
    [anon_sym___clrcall] = ACTIONS(1454),
    [anon_sym___stdcall] = ACTIONS(1454),
    [anon_sym___fastcall] = ACTIONS(1454),
    [anon_sym___thiscall] = ACTIONS(1454),
    [anon_sym___vectorcall] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [anon_sym_signed] = ACTIONS(1454),
    [anon_sym_unsigned] = ACTIONS(1454),
    [anon_sym_long] = ACTIONS(1454),
    [anon_sym_short] = ACTIONS(1454),
    [anon_sym_static] = ACTIONS(1454),
    [anon_sym_auto] = ACTIONS(1454),
    [anon_sym_register] = ACTIONS(1454),
    [anon_sym_inline] = ACTIONS(1454),
    [anon_sym___inline] = ACTIONS(1454),
    [anon_sym___inline__] = ACTIONS(1454),
    [anon_sym___forceinline] = ACTIONS(1454),
    [anon_sym_thread_local] = ACTIONS(1454),
    [anon_sym___thread] = ACTIONS(1454),
    [anon_sym_const] = ACTIONS(1454),
    [anon_sym_constexpr] = ACTIONS(1454),
    [anon_sym_volatile] = ACTIONS(1454),
    [anon_sym_restrict] = ACTIONS(1454),
    [anon_sym___restrict__] = ACTIONS(1454),
    [anon_sym__Atomic] = ACTIONS(1454),
    [anon_sym__Noreturn] = ACTIONS(1454),
    [anon_sym_noreturn] = ACTIONS(1454),
    [sym_primitive_type] = ACTIONS(1454),
    [anon_sym_enum] = ACTIONS(1454),
    [anon_sym_struct] = ACTIONS(1454),
    [anon_sym_union] = ACTIONS(1454),
    [anon_sym_if] = ACTIONS(1454),
    [anon_sym_switch] = ACTIONS(1454),
    [anon_sym_case] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(1454),
    [anon_sym_do] = ACTIONS(1454),
    [anon_sym_for] = ACTIONS(1454),
    [anon_sym_return] = ACTIONS(1454),
    [anon_sym_break] = ACTIONS(1454),
    [anon_sym_continue] = ACTIONS(1454),
    [anon_sym_goto] = ACTIONS(1454),
    [anon_sym___try] = ACTIONS(1454),
    [anon_sym___leave] = ACTIONS(1454),
    [anon_sym_DASH_DASH] = ACTIONS(1456),
    [anon_sym_PLUS_PLUS] = ACTIONS(1456),
    [anon_sym_sizeof] = ACTIONS(1454),
    [anon_sym___alignof__] = ACTIONS(1454),
    [anon_sym___alignof] = ACTIONS(1454),
    [anon_sym__alignof] = ACTIONS(1454),
    [anon_sym_alignof] = ACTIONS(1454),
    [anon_sym__Alignof] = ACTIONS(1454),
    [anon_sym_offsetof] = ACTIONS(1454),
    [anon_sym__Generic] = ACTIONS(1454),
    [anon_sym_asm] = ACTIONS(1454),
    [anon_sym___asm__] = ACTIONS(1454),
    [sym_number_literal] = ACTIONS(1456),
    [anon_sym_L_SQUOTE] = ACTIONS(1456),
    [anon_sym_u_SQUOTE] = ACTIONS(1456),
    [anon_sym_U_SQUOTE] = ACTIONS(1456),
    [anon_sym_u8_SQUOTE] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(1456),
    [anon_sym_L_DQUOTE] = ACTIONS(1456),
    [anon_sym_u_DQUOTE] = ACTIONS(1456),
    [anon_sym_U_DQUOTE] = ACTIONS(1456),
    [anon_sym_u8_DQUOTE] = ACTIONS(1456),
    [anon_sym_DQUOTE] = ACTIONS(1456),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [anon_sym_NULL] = ACTIONS(1454),
    [anon_sym_nullptr] = ACTIONS(1454),
    [sym_comment] = ACTIONS(3),
  },
  [420] = {
    [sym_identifier] = ACTIONS(1470),
    [aux_sym_preproc_include_token1] = ACTIONS(1470),
    [aux_sym_preproc_def_token1] = ACTIONS(1470),
    [aux_sym_preproc_if_token1] = ACTIONS(1470),
    [aux_sym_preproc_if_token2] = ACTIONS(1470),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1470),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1470),
    [sym_preproc_directive] = ACTIONS(1470),
    [anon_sym_LPAREN2] = ACTIONS(1472),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_TILDE] = ACTIONS(1472),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_STAR] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1472),
    [anon_sym_SEMI] = ACTIONS(1472),
    [anon_sym___extension__] = ACTIONS(1470),
    [anon_sym_typedef] = ACTIONS(1470),
    [anon_sym_extern] = ACTIONS(1470),
    [anon_sym___attribute__] = ACTIONS(1470),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1472),
    [anon_sym___declspec] = ACTIONS(1470),
    [anon_sym___cdecl] = ACTIONS(1470),
    [anon_sym___clrcall] = ACTIONS(1470),
    [anon_sym___stdcall] = ACTIONS(1470),
    [anon_sym___fastcall] = ACTIONS(1470),
    [anon_sym___thiscall] = ACTIONS(1470),
    [anon_sym___vectorcall] = ACTIONS(1470),
    [anon_sym_LBRACE] = ACTIONS(1472),
    [anon_sym_signed] = ACTIONS(1470),
    [anon_sym_unsigned] = ACTIONS(1470),
    [anon_sym_long] = ACTIONS(1470),
    [anon_sym_short] = ACTIONS(1470),
    [anon_sym_static] = ACTIONS(1470),
    [anon_sym_auto] = ACTIONS(1470),
    [anon_sym_register] = ACTIONS(1470),
    [anon_sym_inline] = ACTIONS(1470),
    [anon_sym___inline] = ACTIONS(1470),
    [anon_sym___inline__] = ACTIONS(1470),
    [anon_sym___forceinline] = ACTIONS(1470),
    [anon_sym_thread_local] = ACTIONS(1470),
    [anon_sym___thread] = ACTIONS(1470),
    [anon_sym_const] = ACTIONS(1470),
    [anon_sym_constexpr] = ACTIONS(1470),
    [anon_sym_volatile] = ACTIONS(1470),
    [anon_sym_restrict] = ACTIONS(1470),
    [anon_sym___restrict__] = ACTIONS(1470),
    [anon_sym__Atomic] = ACTIONS(1470),
    [anon_sym__Noreturn] = ACTIONS(1470),
    [anon_sym_noreturn] = ACTIONS(1470),
    [sym_primitive_type] = ACTIONS(1470),
    [anon_sym_enum] = ACTIONS(1470),
    [anon_sym_struct] = ACTIONS(1470),
    [anon_sym_union] = ACTIONS(1470),
    [anon_sym_if] = ACTIONS(1470),
    [anon_sym_switch] = ACTIONS(1470),
    [anon_sym_case] = ACTIONS(1470),
    [anon_sym_default] = ACTIONS(1470),
    [anon_sym_while] = ACTIONS(1470),
    [anon_sym_do] = ACTIONS(1470),
    [anon_sym_for] = ACTIONS(1470),
    [anon_sym_return] = ACTIONS(1470),
    [anon_sym_break] = ACTIONS(1470),
    [anon_sym_continue] = ACTIONS(1470),
    [anon_sym_goto] = ACTIONS(1470),
    [anon_sym___try] = ACTIONS(1470),
    [anon_sym___leave] = ACTIONS(1470),
    [anon_sym_DASH_DASH] = ACTIONS(1472),
    [anon_sym_PLUS_PLUS] = ACTIONS(1472),
    [anon_sym_sizeof] = ACTIONS(1470),
    [anon_sym___alignof__] = ACTIONS(1470),
    [anon_sym___alignof] = ACTIONS(1470),
    [anon_sym__alignof] = ACTIONS(1470),
    [anon_sym_alignof] = ACTIONS(1470),
    [anon_sym__Alignof] = ACTIONS(1470),
    [anon_sym_offsetof] = ACTIONS(1470),
    [anon_sym__Generic] = ACTIONS(1470),
    [anon_sym_asm] = ACTIONS(1470),
    [anon_sym___asm__] = ACTIONS(1470),
    [sym_number_literal] = ACTIONS(1472),
    [anon_sym_L_SQUOTE] = ACTIONS(1472),
    [anon_sym_u_SQUOTE] = ACTIONS(1472),
    [anon_sym_U_SQUOTE] = ACTIONS(1472),
    [anon_sym_u8_SQUOTE] = ACTIONS(1472),
    [anon_sym_SQUOTE] = ACTIONS(1472),
    [anon_sym_L_DQUOTE] = ACTIONS(1472),
    [anon_sym_u_DQUOTE] = ACTIONS(1472),
    [anon_sym_U_DQUOTE] = ACTIONS(1472),
    [anon_sym_u8_DQUOTE] = ACTIONS(1472),
    [anon_sym_DQUOTE] = ACTIONS(1472),
    [sym_true] = ACTIONS(1470),
    [sym_false] = ACTIONS(1470),
    [anon_sym_NULL] = ACTIONS(1470),
    [anon_sym_nullptr] = ACTIONS(1470),
    [sym_comment] = ACTIONS(3),
  },
  [421] = {
    [sym_identifier] = ACTIONS(1426),
    [aux_sym_preproc_include_token1] = ACTIONS(1426),
    [aux_sym_preproc_def_token1] = ACTIONS(1426),
    [aux_sym_preproc_if_token1] = ACTIONS(1426),
    [aux_sym_preproc_if_token2] = ACTIONS(1426),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1426),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1426),
    [sym_preproc_directive] = ACTIONS(1426),
    [anon_sym_LPAREN2] = ACTIONS(1428),
    [anon_sym_BANG] = ACTIONS(1428),
    [anon_sym_TILDE] = ACTIONS(1428),
    [anon_sym_DASH] = ACTIONS(1426),
    [anon_sym_PLUS] = ACTIONS(1426),
    [anon_sym_STAR] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1428),
    [anon_sym_SEMI] = ACTIONS(1428),
    [anon_sym___extension__] = ACTIONS(1426),
    [anon_sym_typedef] = ACTIONS(1426),
    [anon_sym_extern] = ACTIONS(1426),
    [anon_sym___attribute__] = ACTIONS(1426),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1428),
    [anon_sym___declspec] = ACTIONS(1426),
    [anon_sym___cdecl] = ACTIONS(1426),
    [anon_sym___clrcall] = ACTIONS(1426),
    [anon_sym___stdcall] = ACTIONS(1426),
    [anon_sym___fastcall] = ACTIONS(1426),
    [anon_sym___thiscall] = ACTIONS(1426),
    [anon_sym___vectorcall] = ACTIONS(1426),
    [anon_sym_LBRACE] = ACTIONS(1428),
    [anon_sym_signed] = ACTIONS(1426),
    [anon_sym_unsigned] = ACTIONS(1426),
    [anon_sym_long] = ACTIONS(1426),
    [anon_sym_short] = ACTIONS(1426),
    [anon_sym_static] = ACTIONS(1426),
    [anon_sym_auto] = ACTIONS(1426),
    [anon_sym_register] = ACTIONS(1426),
    [anon_sym_inline] = ACTIONS(1426),
    [anon_sym___inline] = ACTIONS(1426),
    [anon_sym___inline__] = ACTIONS(1426),
    [anon_sym___forceinline] = ACTIONS(1426),
    [anon_sym_thread_local] = ACTIONS(1426),
    [anon_sym___thread] = ACTIONS(1426),
    [anon_sym_const] = ACTIONS(1426),
    [anon_sym_constexpr] = ACTIONS(1426),
    [anon_sym_volatile] = ACTIONS(1426),
    [anon_sym_restrict] = ACTIONS(1426),
    [anon_sym___restrict__] = ACTIONS(1426),
    [anon_sym__Atomic] = ACTIONS(1426),
    [anon_sym__Noreturn] = ACTIONS(1426),
    [anon_sym_noreturn] = ACTIONS(1426),
    [sym_primitive_type] = ACTIONS(1426),
    [anon_sym_enum] = ACTIONS(1426),
    [anon_sym_struct] = ACTIONS(1426),
    [anon_sym_union] = ACTIONS(1426),
    [anon_sym_if] = ACTIONS(1426),
    [anon_sym_switch] = ACTIONS(1426),
    [anon_sym_case] = ACTIONS(1426),
    [anon_sym_default] = ACTIONS(1426),
    [anon_sym_while] = ACTIONS(1426),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_for] = ACTIONS(1426),
    [anon_sym_return] = ACTIONS(1426),
    [anon_sym_break] = ACTIONS(1426),
    [anon_sym_continue] = ACTIONS(1426),
    [anon_sym_goto] = ACTIONS(1426),
    [anon_sym___try] = ACTIONS(1426),
    [anon_sym___leave] = ACTIONS(1426),
    [anon_sym_DASH_DASH] = ACTIONS(1428),
    [anon_sym_PLUS_PLUS] = ACTIONS(1428),
    [anon_sym_sizeof] = ACTIONS(1426),
    [anon_sym___alignof__] = ACTIONS(1426),
    [anon_sym___alignof] = ACTIONS(1426),
    [anon_sym__alignof] = ACTIONS(1426),
    [anon_sym_alignof] = ACTIONS(1426),
    [anon_sym__Alignof] = ACTIONS(1426),
    [anon_sym_offsetof] = ACTIONS(1426),
    [anon_sym__Generic] = ACTIONS(1426),
    [anon_sym_asm] = ACTIONS(1426),
    [anon_sym___asm__] = ACTIONS(1426),
    [sym_number_literal] = ACTIONS(1428),
    [anon_sym_L_SQUOTE] = ACTIONS(1428),
    [anon_sym_u_SQUOTE] = ACTIONS(1428),
    [anon_sym_U_SQUOTE] = ACTIONS(1428),
    [anon_sym_u8_SQUOTE] = ACTIONS(1428),
    [anon_sym_SQUOTE] = ACTIONS(1428),
    [anon_sym_L_DQUOTE] = ACTIONS(1428),
    [anon_sym_u_DQUOTE] = ACTIONS(1428),
    [anon_sym_U_DQUOTE] = ACTIONS(1428),
    [anon_sym_u8_DQUOTE] = ACTIONS(1428),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [sym_true] = ACTIONS(1426),
    [sym_false] = ACTIONS(1426),
    [anon_sym_NULL] = ACTIONS(1426),
    [anon_sym_nullptr] = ACTIONS(1426),
    [sym_comment] = ACTIONS(3),
  },
  [422] = {
    [sym_identifier] = ACTIONS(1478),
    [aux_sym_preproc_include_token1] = ACTIONS(1478),
    [aux_sym_preproc_def_token1] = ACTIONS(1478),
    [aux_sym_preproc_if_token1] = ACTIONS(1478),
    [aux_sym_preproc_if_token2] = ACTIONS(1478),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1478),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1478),
    [sym_preproc_directive] = ACTIONS(1478),
    [anon_sym_LPAREN2] = ACTIONS(1480),
    [anon_sym_BANG] = ACTIONS(1480),
    [anon_sym_TILDE] = ACTIONS(1480),
    [anon_sym_DASH] = ACTIONS(1478),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_STAR] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1480),
    [anon_sym_SEMI] = ACTIONS(1480),
    [anon_sym___extension__] = ACTIONS(1478),
    [anon_sym_typedef] = ACTIONS(1478),
    [anon_sym_extern] = ACTIONS(1478),
    [anon_sym___attribute__] = ACTIONS(1478),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1480),
    [anon_sym___declspec] = ACTIONS(1478),
    [anon_sym___cdecl] = ACTIONS(1478),
    [anon_sym___clrcall] = ACTIONS(1478),
    [anon_sym___stdcall] = ACTIONS(1478),
    [anon_sym___fastcall] = ACTIONS(1478),
    [anon_sym___thiscall] = ACTIONS(1478),
    [anon_sym___vectorcall] = ACTIONS(1478),
    [anon_sym_LBRACE] = ACTIONS(1480),
    [anon_sym_signed] = ACTIONS(1478),
    [anon_sym_unsigned] = ACTIONS(1478),
    [anon_sym_long] = ACTIONS(1478),
    [anon_sym_short] = ACTIONS(1478),
    [anon_sym_static] = ACTIONS(1478),
    [anon_sym_auto] = ACTIONS(1478),
    [anon_sym_register] = ACTIONS(1478),
    [anon_sym_inline] = ACTIONS(1478),
    [anon_sym___inline] = ACTIONS(1478),
    [anon_sym___inline__] = ACTIONS(1478),
    [anon_sym___forceinline] = ACTIONS(1478),
    [anon_sym_thread_local] = ACTIONS(1478),
    [anon_sym___thread] = ACTIONS(1478),
    [anon_sym_const] = ACTIONS(1478),
    [anon_sym_constexpr] = ACTIONS(1478),
    [anon_sym_volatile] = ACTIONS(1478),
    [anon_sym_restrict] = ACTIONS(1478),
    [anon_sym___restrict__] = ACTIONS(1478),
    [anon_sym__Atomic] = ACTIONS(1478),
    [anon_sym__Noreturn] = ACTIONS(1478),
    [anon_sym_noreturn] = ACTIONS(1478),
    [sym_primitive_type] = ACTIONS(1478),
    [anon_sym_enum] = ACTIONS(1478),
    [anon_sym_struct] = ACTIONS(1478),
    [anon_sym_union] = ACTIONS(1478),
    [anon_sym_if] = ACTIONS(1478),
    [anon_sym_switch] = ACTIONS(1478),
    [anon_sym_case] = ACTIONS(1478),
    [anon_sym_default] = ACTIONS(1478),
    [anon_sym_while] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_for] = ACTIONS(1478),
    [anon_sym_return] = ACTIONS(1478),
    [anon_sym_break] = ACTIONS(1478),
    [anon_sym_continue] = ACTIONS(1478),
    [anon_sym_goto] = ACTIONS(1478),
    [anon_sym___try] = ACTIONS(1478),
    [anon_sym___leave] = ACTIONS(1478),
    [anon_sym_DASH_DASH] = ACTIONS(1480),
    [anon_sym_PLUS_PLUS] = ACTIONS(1480),
    [anon_sym_sizeof] = ACTIONS(1478),
    [anon_sym___alignof__] = ACTIONS(1478),
    [anon_sym___alignof] = ACTIONS(1478),
    [anon_sym__alignof] = ACTIONS(1478),
    [anon_sym_alignof] = ACTIONS(1478),
    [anon_sym__Alignof] = ACTIONS(1478),
    [anon_sym_offsetof] = ACTIONS(1478),
    [anon_sym__Generic] = ACTIONS(1478),
    [anon_sym_asm] = ACTIONS(1478),
    [anon_sym___asm__] = ACTIONS(1478),
    [sym_number_literal] = ACTIONS(1480),
    [anon_sym_L_SQUOTE] = ACTIONS(1480),
    [anon_sym_u_SQUOTE] = ACTIONS(1480),
    [anon_sym_U_SQUOTE] = ACTIONS(1480),
    [anon_sym_u8_SQUOTE] = ACTIONS(1480),
    [anon_sym_SQUOTE] = ACTIONS(1480),
    [anon_sym_L_DQUOTE] = ACTIONS(1480),
    [anon_sym_u_DQUOTE] = ACTIONS(1480),
    [anon_sym_U_DQUOTE] = ACTIONS(1480),
    [anon_sym_u8_DQUOTE] = ACTIONS(1480),
    [anon_sym_DQUOTE] = ACTIONS(1480),
    [sym_true] = ACTIONS(1478),
    [sym_false] = ACTIONS(1478),
    [anon_sym_NULL] = ACTIONS(1478),
    [anon_sym_nullptr] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
  },
  [423] = {
    [sym_attribute_declaration] = STATE(423),
    [sym_compound_statement] = STATE(301),
    [sym_attributed_statement] = STATE(301),
    [sym_labeled_statement] = STATE(301),
    [sym_expression_statement] = STATE(301),
    [sym_if_statement] = STATE(301),
    [sym_switch_statement] = STATE(301),
    [sym_case_statement] = STATE(301),
    [sym_while_statement] = STATE(301),
    [sym_do_statement] = STATE(301),
    [sym_for_statement] = STATE(301),
    [sym_return_statement] = STATE(301),
    [sym_break_statement] = STATE(301),
    [sym_continue_statement] = STATE(301),
    [sym_goto_statement] = STATE(301),
    [sym_seh_try_statement] = STATE(301),
    [sym_seh_leave_statement] = STATE(301),
    [sym__expression] = STATE(1348),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2343),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(1672),
    [anon_sym_LPAREN2] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1582),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1588),
    [anon_sym_SEMI] = ACTIONS(1675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1594),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_switch] = ACTIONS(1684),
    [anon_sym_case] = ACTIONS(1687),
    [anon_sym_default] = ACTIONS(1690),
    [anon_sym_while] = ACTIONS(1693),
    [anon_sym_do] = ACTIONS(1696),
    [anon_sym_for] = ACTIONS(1699),
    [anon_sym_return] = ACTIONS(1702),
    [anon_sym_break] = ACTIONS(1705),
    [anon_sym_continue] = ACTIONS(1708),
    [anon_sym_goto] = ACTIONS(1711),
    [anon_sym___try] = ACTIONS(1714),
    [anon_sym___leave] = ACTIONS(1717),
    [anon_sym_DASH_DASH] = ACTIONS(1639),
    [anon_sym_PLUS_PLUS] = ACTIONS(1639),
    [anon_sym_sizeof] = ACTIONS(1642),
    [anon_sym___alignof__] = ACTIONS(1645),
    [anon_sym___alignof] = ACTIONS(1645),
    [anon_sym__alignof] = ACTIONS(1645),
    [anon_sym_alignof] = ACTIONS(1645),
    [anon_sym__Alignof] = ACTIONS(1645),
    [anon_sym_offsetof] = ACTIONS(1648),
    [anon_sym__Generic] = ACTIONS(1651),
    [anon_sym_asm] = ACTIONS(1654),
    [anon_sym___asm__] = ACTIONS(1654),
    [sym_number_literal] = ACTIONS(1657),
    [anon_sym_L_SQUOTE] = ACTIONS(1660),
    [anon_sym_u_SQUOTE] = ACTIONS(1660),
    [anon_sym_U_SQUOTE] = ACTIONS(1660),
    [anon_sym_u8_SQUOTE] = ACTIONS(1660),
    [anon_sym_SQUOTE] = ACTIONS(1660),
    [anon_sym_L_DQUOTE] = ACTIONS(1663),
    [anon_sym_u_DQUOTE] = ACTIONS(1663),
    [anon_sym_U_DQUOTE] = ACTIONS(1663),
    [anon_sym_u8_DQUOTE] = ACTIONS(1663),
    [anon_sym_DQUOTE] = ACTIONS(1663),
    [sym_true] = ACTIONS(1666),
    [sym_false] = ACTIONS(1666),
    [anon_sym_NULL] = ACTIONS(1669),
    [anon_sym_nullptr] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
  },
  [424] = {
    [sym_identifier] = ACTIONS(1514),
    [aux_sym_preproc_include_token1] = ACTIONS(1514),
    [aux_sym_preproc_def_token1] = ACTIONS(1514),
    [aux_sym_preproc_if_token1] = ACTIONS(1514),
    [aux_sym_preproc_if_token2] = ACTIONS(1514),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1514),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1514),
    [sym_preproc_directive] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(1516),
    [anon_sym_BANG] = ACTIONS(1516),
    [anon_sym_TILDE] = ACTIONS(1516),
    [anon_sym_DASH] = ACTIONS(1514),
    [anon_sym_PLUS] = ACTIONS(1514),
    [anon_sym_STAR] = ACTIONS(1516),
    [anon_sym_AMP] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(1516),
    [anon_sym___extension__] = ACTIONS(1514),
    [anon_sym_typedef] = ACTIONS(1514),
    [anon_sym_extern] = ACTIONS(1514),
    [anon_sym___attribute__] = ACTIONS(1514),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym___declspec] = ACTIONS(1514),
    [anon_sym___cdecl] = ACTIONS(1514),
    [anon_sym___clrcall] = ACTIONS(1514),
    [anon_sym___stdcall] = ACTIONS(1514),
    [anon_sym___fastcall] = ACTIONS(1514),
    [anon_sym___thiscall] = ACTIONS(1514),
    [anon_sym___vectorcall] = ACTIONS(1514),
    [anon_sym_LBRACE] = ACTIONS(1516),
    [anon_sym_signed] = ACTIONS(1514),
    [anon_sym_unsigned] = ACTIONS(1514),
    [anon_sym_long] = ACTIONS(1514),
    [anon_sym_short] = ACTIONS(1514),
    [anon_sym_static] = ACTIONS(1514),
    [anon_sym_auto] = ACTIONS(1514),
    [anon_sym_register] = ACTIONS(1514),
    [anon_sym_inline] = ACTIONS(1514),
    [anon_sym___inline] = ACTIONS(1514),
    [anon_sym___inline__] = ACTIONS(1514),
    [anon_sym___forceinline] = ACTIONS(1514),
    [anon_sym_thread_local] = ACTIONS(1514),
    [anon_sym___thread] = ACTIONS(1514),
    [anon_sym_const] = ACTIONS(1514),
    [anon_sym_constexpr] = ACTIONS(1514),
    [anon_sym_volatile] = ACTIONS(1514),
    [anon_sym_restrict] = ACTIONS(1514),
    [anon_sym___restrict__] = ACTIONS(1514),
    [anon_sym__Atomic] = ACTIONS(1514),
    [anon_sym__Noreturn] = ACTIONS(1514),
    [anon_sym_noreturn] = ACTIONS(1514),
    [sym_primitive_type] = ACTIONS(1514),
    [anon_sym_enum] = ACTIONS(1514),
    [anon_sym_struct] = ACTIONS(1514),
    [anon_sym_union] = ACTIONS(1514),
    [anon_sym_if] = ACTIONS(1514),
    [anon_sym_switch] = ACTIONS(1514),
    [anon_sym_case] = ACTIONS(1514),
    [anon_sym_default] = ACTIONS(1514),
    [anon_sym_while] = ACTIONS(1514),
    [anon_sym_do] = ACTIONS(1514),
    [anon_sym_for] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1514),
    [anon_sym_break] = ACTIONS(1514),
    [anon_sym_continue] = ACTIONS(1514),
    [anon_sym_goto] = ACTIONS(1514),
    [anon_sym___try] = ACTIONS(1514),
    [anon_sym___leave] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1516),
    [anon_sym_PLUS_PLUS] = ACTIONS(1516),
    [anon_sym_sizeof] = ACTIONS(1514),
    [anon_sym___alignof__] = ACTIONS(1514),
    [anon_sym___alignof] = ACTIONS(1514),
    [anon_sym__alignof] = ACTIONS(1514),
    [anon_sym_alignof] = ACTIONS(1514),
    [anon_sym__Alignof] = ACTIONS(1514),
    [anon_sym_offsetof] = ACTIONS(1514),
    [anon_sym__Generic] = ACTIONS(1514),
    [anon_sym_asm] = ACTIONS(1514),
    [anon_sym___asm__] = ACTIONS(1514),
    [sym_number_literal] = ACTIONS(1516),
    [anon_sym_L_SQUOTE] = ACTIONS(1516),
    [anon_sym_u_SQUOTE] = ACTIONS(1516),
    [anon_sym_U_SQUOTE] = ACTIONS(1516),
    [anon_sym_u8_SQUOTE] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1516),
    [anon_sym_L_DQUOTE] = ACTIONS(1516),
    [anon_sym_u_DQUOTE] = ACTIONS(1516),
    [anon_sym_U_DQUOTE] = ACTIONS(1516),
    [anon_sym_u8_DQUOTE] = ACTIONS(1516),
    [anon_sym_DQUOTE] = ACTIONS(1516),
    [sym_true] = ACTIONS(1514),
    [sym_false] = ACTIONS(1514),
    [anon_sym_NULL] = ACTIONS(1514),
    [anon_sym_nullptr] = ACTIONS(1514),
    [sym_comment] = ACTIONS(3),
  },
  [425] = {
    [sym_identifier] = ACTIONS(1526),
    [aux_sym_preproc_include_token1] = ACTIONS(1526),
    [aux_sym_preproc_def_token1] = ACTIONS(1526),
    [aux_sym_preproc_if_token1] = ACTIONS(1526),
    [aux_sym_preproc_if_token2] = ACTIONS(1526),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1526),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1526),
    [sym_preproc_directive] = ACTIONS(1526),
    [anon_sym_LPAREN2] = ACTIONS(1528),
    [anon_sym_BANG] = ACTIONS(1528),
    [anon_sym_TILDE] = ACTIONS(1528),
    [anon_sym_DASH] = ACTIONS(1526),
    [anon_sym_PLUS] = ACTIONS(1526),
    [anon_sym_STAR] = ACTIONS(1528),
    [anon_sym_AMP] = ACTIONS(1528),
    [anon_sym_SEMI] = ACTIONS(1528),
    [anon_sym___extension__] = ACTIONS(1526),
    [anon_sym_typedef] = ACTIONS(1526),
    [anon_sym_extern] = ACTIONS(1526),
    [anon_sym___attribute__] = ACTIONS(1526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1528),
    [anon_sym___declspec] = ACTIONS(1526),
    [anon_sym___cdecl] = ACTIONS(1526),
    [anon_sym___clrcall] = ACTIONS(1526),
    [anon_sym___stdcall] = ACTIONS(1526),
    [anon_sym___fastcall] = ACTIONS(1526),
    [anon_sym___thiscall] = ACTIONS(1526),
    [anon_sym___vectorcall] = ACTIONS(1526),
    [anon_sym_LBRACE] = ACTIONS(1528),
    [anon_sym_signed] = ACTIONS(1526),
    [anon_sym_unsigned] = ACTIONS(1526),
    [anon_sym_long] = ACTIONS(1526),
    [anon_sym_short] = ACTIONS(1526),
    [anon_sym_static] = ACTIONS(1526),
    [anon_sym_auto] = ACTIONS(1526),
    [anon_sym_register] = ACTIONS(1526),
    [anon_sym_inline] = ACTIONS(1526),
    [anon_sym___inline] = ACTIONS(1526),
    [anon_sym___inline__] = ACTIONS(1526),
    [anon_sym___forceinline] = ACTIONS(1526),
    [anon_sym_thread_local] = ACTIONS(1526),
    [anon_sym___thread] = ACTIONS(1526),
    [anon_sym_const] = ACTIONS(1526),
    [anon_sym_constexpr] = ACTIONS(1526),
    [anon_sym_volatile] = ACTIONS(1526),
    [anon_sym_restrict] = ACTIONS(1526),
    [anon_sym___restrict__] = ACTIONS(1526),
    [anon_sym__Atomic] = ACTIONS(1526),
    [anon_sym__Noreturn] = ACTIONS(1526),
    [anon_sym_noreturn] = ACTIONS(1526),
    [sym_primitive_type] = ACTIONS(1526),
    [anon_sym_enum] = ACTIONS(1526),
    [anon_sym_struct] = ACTIONS(1526),
    [anon_sym_union] = ACTIONS(1526),
    [anon_sym_if] = ACTIONS(1526),
    [anon_sym_switch] = ACTIONS(1526),
    [anon_sym_case] = ACTIONS(1526),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1526),
    [anon_sym_do] = ACTIONS(1526),
    [anon_sym_for] = ACTIONS(1526),
    [anon_sym_return] = ACTIONS(1526),
    [anon_sym_break] = ACTIONS(1526),
    [anon_sym_continue] = ACTIONS(1526),
    [anon_sym_goto] = ACTIONS(1526),
    [anon_sym___try] = ACTIONS(1526),
    [anon_sym___leave] = ACTIONS(1526),
    [anon_sym_DASH_DASH] = ACTIONS(1528),
    [anon_sym_PLUS_PLUS] = ACTIONS(1528),
    [anon_sym_sizeof] = ACTIONS(1526),
    [anon_sym___alignof__] = ACTIONS(1526),
    [anon_sym___alignof] = ACTIONS(1526),
    [anon_sym__alignof] = ACTIONS(1526),
    [anon_sym_alignof] = ACTIONS(1526),
    [anon_sym__Alignof] = ACTIONS(1526),
    [anon_sym_offsetof] = ACTIONS(1526),
    [anon_sym__Generic] = ACTIONS(1526),
    [anon_sym_asm] = ACTIONS(1526),
    [anon_sym___asm__] = ACTIONS(1526),
    [sym_number_literal] = ACTIONS(1528),
    [anon_sym_L_SQUOTE] = ACTIONS(1528),
    [anon_sym_u_SQUOTE] = ACTIONS(1528),
    [anon_sym_U_SQUOTE] = ACTIONS(1528),
    [anon_sym_u8_SQUOTE] = ACTIONS(1528),
    [anon_sym_SQUOTE] = ACTIONS(1528),
    [anon_sym_L_DQUOTE] = ACTIONS(1528),
    [anon_sym_u_DQUOTE] = ACTIONS(1528),
    [anon_sym_U_DQUOTE] = ACTIONS(1528),
    [anon_sym_u8_DQUOTE] = ACTIONS(1528),
    [anon_sym_DQUOTE] = ACTIONS(1528),
    [sym_true] = ACTIONS(1526),
    [sym_false] = ACTIONS(1526),
    [anon_sym_NULL] = ACTIONS(1526),
    [anon_sym_nullptr] = ACTIONS(1526),
    [sym_comment] = ACTIONS(3),
  },
  [426] = {
    [sym_identifier] = ACTIONS(1522),
    [aux_sym_preproc_include_token1] = ACTIONS(1522),
    [aux_sym_preproc_def_token1] = ACTIONS(1522),
    [aux_sym_preproc_if_token1] = ACTIONS(1522),
    [aux_sym_preproc_if_token2] = ACTIONS(1522),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1522),
    [sym_preproc_directive] = ACTIONS(1522),
    [anon_sym_LPAREN2] = ACTIONS(1524),
    [anon_sym_BANG] = ACTIONS(1524),
    [anon_sym_TILDE] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1522),
    [anon_sym_PLUS] = ACTIONS(1522),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym___extension__] = ACTIONS(1522),
    [anon_sym_typedef] = ACTIONS(1522),
    [anon_sym_extern] = ACTIONS(1522),
    [anon_sym___attribute__] = ACTIONS(1522),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1524),
    [anon_sym___declspec] = ACTIONS(1522),
    [anon_sym___cdecl] = ACTIONS(1522),
    [anon_sym___clrcall] = ACTIONS(1522),
    [anon_sym___stdcall] = ACTIONS(1522),
    [anon_sym___fastcall] = ACTIONS(1522),
    [anon_sym___thiscall] = ACTIONS(1522),
    [anon_sym___vectorcall] = ACTIONS(1522),
    [anon_sym_LBRACE] = ACTIONS(1524),
    [anon_sym_signed] = ACTIONS(1522),
    [anon_sym_unsigned] = ACTIONS(1522),
    [anon_sym_long] = ACTIONS(1522),
    [anon_sym_short] = ACTIONS(1522),
    [anon_sym_static] = ACTIONS(1522),
    [anon_sym_auto] = ACTIONS(1522),
    [anon_sym_register] = ACTIONS(1522),
    [anon_sym_inline] = ACTIONS(1522),
    [anon_sym___inline] = ACTIONS(1522),
    [anon_sym___inline__] = ACTIONS(1522),
    [anon_sym___forceinline] = ACTIONS(1522),
    [anon_sym_thread_local] = ACTIONS(1522),
    [anon_sym___thread] = ACTIONS(1522),
    [anon_sym_const] = ACTIONS(1522),
    [anon_sym_constexpr] = ACTIONS(1522),
    [anon_sym_volatile] = ACTIONS(1522),
    [anon_sym_restrict] = ACTIONS(1522),
    [anon_sym___restrict__] = ACTIONS(1522),
    [anon_sym__Atomic] = ACTIONS(1522),
    [anon_sym__Noreturn] = ACTIONS(1522),
    [anon_sym_noreturn] = ACTIONS(1522),
    [sym_primitive_type] = ACTIONS(1522),
    [anon_sym_enum] = ACTIONS(1522),
    [anon_sym_struct] = ACTIONS(1522),
    [anon_sym_union] = ACTIONS(1522),
    [anon_sym_if] = ACTIONS(1522),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1522),
    [anon_sym_default] = ACTIONS(1522),
    [anon_sym_while] = ACTIONS(1522),
    [anon_sym_do] = ACTIONS(1522),
    [anon_sym_for] = ACTIONS(1522),
    [anon_sym_return] = ACTIONS(1522),
    [anon_sym_break] = ACTIONS(1522),
    [anon_sym_continue] = ACTIONS(1522),
    [anon_sym_goto] = ACTIONS(1522),
    [anon_sym___try] = ACTIONS(1522),
    [anon_sym___leave] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1524),
    [anon_sym_PLUS_PLUS] = ACTIONS(1524),
    [anon_sym_sizeof] = ACTIONS(1522),
    [anon_sym___alignof__] = ACTIONS(1522),
    [anon_sym___alignof] = ACTIONS(1522),
    [anon_sym__alignof] = ACTIONS(1522),
    [anon_sym_alignof] = ACTIONS(1522),
    [anon_sym__Alignof] = ACTIONS(1522),
    [anon_sym_offsetof] = ACTIONS(1522),
    [anon_sym__Generic] = ACTIONS(1522),
    [anon_sym_asm] = ACTIONS(1522),
    [anon_sym___asm__] = ACTIONS(1522),
    [sym_number_literal] = ACTIONS(1524),
    [anon_sym_L_SQUOTE] = ACTIONS(1524),
    [anon_sym_u_SQUOTE] = ACTIONS(1524),
    [anon_sym_U_SQUOTE] = ACTIONS(1524),
    [anon_sym_u8_SQUOTE] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(1524),
    [anon_sym_L_DQUOTE] = ACTIONS(1524),
    [anon_sym_u_DQUOTE] = ACTIONS(1524),
    [anon_sym_U_DQUOTE] = ACTIONS(1524),
    [anon_sym_u8_DQUOTE] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1524),
    [sym_true] = ACTIONS(1522),
    [sym_false] = ACTIONS(1522),
    [anon_sym_NULL] = ACTIONS(1522),
    [anon_sym_nullptr] = ACTIONS(1522),
    [sym_comment] = ACTIONS(3),
  },
  [427] = {
    [sym_identifier] = ACTIONS(1518),
    [aux_sym_preproc_include_token1] = ACTIONS(1518),
    [aux_sym_preproc_def_token1] = ACTIONS(1518),
    [aux_sym_preproc_if_token1] = ACTIONS(1518),
    [aux_sym_preproc_if_token2] = ACTIONS(1518),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1518),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1518),
    [sym_preproc_directive] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(1520),
    [anon_sym_BANG] = ACTIONS(1520),
    [anon_sym_TILDE] = ACTIONS(1520),
    [anon_sym_DASH] = ACTIONS(1518),
    [anon_sym_PLUS] = ACTIONS(1518),
    [anon_sym_STAR] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1520),
    [anon_sym_SEMI] = ACTIONS(1520),
    [anon_sym___extension__] = ACTIONS(1518),
    [anon_sym_typedef] = ACTIONS(1518),
    [anon_sym_extern] = ACTIONS(1518),
    [anon_sym___attribute__] = ACTIONS(1518),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1520),
    [anon_sym___declspec] = ACTIONS(1518),
    [anon_sym___cdecl] = ACTIONS(1518),
    [anon_sym___clrcall] = ACTIONS(1518),
    [anon_sym___stdcall] = ACTIONS(1518),
    [anon_sym___fastcall] = ACTIONS(1518),
    [anon_sym___thiscall] = ACTIONS(1518),
    [anon_sym___vectorcall] = ACTIONS(1518),
    [anon_sym_LBRACE] = ACTIONS(1520),
    [anon_sym_signed] = ACTIONS(1518),
    [anon_sym_unsigned] = ACTIONS(1518),
    [anon_sym_long] = ACTIONS(1518),
    [anon_sym_short] = ACTIONS(1518),
    [anon_sym_static] = ACTIONS(1518),
    [anon_sym_auto] = ACTIONS(1518),
    [anon_sym_register] = ACTIONS(1518),
    [anon_sym_inline] = ACTIONS(1518),
    [anon_sym___inline] = ACTIONS(1518),
    [anon_sym___inline__] = ACTIONS(1518),
    [anon_sym___forceinline] = ACTIONS(1518),
    [anon_sym_thread_local] = ACTIONS(1518),
    [anon_sym___thread] = ACTIONS(1518),
    [anon_sym_const] = ACTIONS(1518),
    [anon_sym_constexpr] = ACTIONS(1518),
    [anon_sym_volatile] = ACTIONS(1518),
    [anon_sym_restrict] = ACTIONS(1518),
    [anon_sym___restrict__] = ACTIONS(1518),
    [anon_sym__Atomic] = ACTIONS(1518),
    [anon_sym__Noreturn] = ACTIONS(1518),
    [anon_sym_noreturn] = ACTIONS(1518),
    [sym_primitive_type] = ACTIONS(1518),
    [anon_sym_enum] = ACTIONS(1518),
    [anon_sym_struct] = ACTIONS(1518),
    [anon_sym_union] = ACTIONS(1518),
    [anon_sym_if] = ACTIONS(1518),
    [anon_sym_switch] = ACTIONS(1518),
    [anon_sym_case] = ACTIONS(1518),
    [anon_sym_default] = ACTIONS(1518),
    [anon_sym_while] = ACTIONS(1518),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_for] = ACTIONS(1518),
    [anon_sym_return] = ACTIONS(1518),
    [anon_sym_break] = ACTIONS(1518),
    [anon_sym_continue] = ACTIONS(1518),
    [anon_sym_goto] = ACTIONS(1518),
    [anon_sym___try] = ACTIONS(1518),
    [anon_sym___leave] = ACTIONS(1518),
    [anon_sym_DASH_DASH] = ACTIONS(1520),
    [anon_sym_PLUS_PLUS] = ACTIONS(1520),
    [anon_sym_sizeof] = ACTIONS(1518),
    [anon_sym___alignof__] = ACTIONS(1518),
    [anon_sym___alignof] = ACTIONS(1518),
    [anon_sym__alignof] = ACTIONS(1518),
    [anon_sym_alignof] = ACTIONS(1518),
    [anon_sym__Alignof] = ACTIONS(1518),
    [anon_sym_offsetof] = ACTIONS(1518),
    [anon_sym__Generic] = ACTIONS(1518),
    [anon_sym_asm] = ACTIONS(1518),
    [anon_sym___asm__] = ACTIONS(1518),
    [sym_number_literal] = ACTIONS(1520),
    [anon_sym_L_SQUOTE] = ACTIONS(1520),
    [anon_sym_u_SQUOTE] = ACTIONS(1520),
    [anon_sym_U_SQUOTE] = ACTIONS(1520),
    [anon_sym_u8_SQUOTE] = ACTIONS(1520),
    [anon_sym_SQUOTE] = ACTIONS(1520),
    [anon_sym_L_DQUOTE] = ACTIONS(1520),
    [anon_sym_u_DQUOTE] = ACTIONS(1520),
    [anon_sym_U_DQUOTE] = ACTIONS(1520),
    [anon_sym_u8_DQUOTE] = ACTIONS(1520),
    [anon_sym_DQUOTE] = ACTIONS(1520),
    [sym_true] = ACTIONS(1518),
    [sym_false] = ACTIONS(1518),
    [anon_sym_NULL] = ACTIONS(1518),
    [anon_sym_nullptr] = ACTIONS(1518),
    [sym_comment] = ACTIONS(3),
  },
  [428] = {
    [sym_attribute_declaration] = STATE(416),
    [sym_compound_statement] = STATE(340),
    [sym_attributed_statement] = STATE(340),
    [sym_labeled_statement] = STATE(340),
    [sym_expression_statement] = STATE(340),
    [sym_if_statement] = STATE(340),
    [sym_switch_statement] = STATE(340),
    [sym_case_statement] = STATE(340),
    [sym_while_statement] = STATE(340),
    [sym_do_statement] = STATE(340),
    [sym_for_statement] = STATE(340),
    [sym_return_statement] = STATE(340),
    [sym_break_statement] = STATE(340),
    [sym_continue_statement] = STATE(340),
    [sym_goto_statement] = STATE(340),
    [sym_seh_try_statement] = STATE(340),
    [sym_seh_leave_statement] = STATE(340),
    [sym__expression] = STATE(1313),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2275),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(416),
    [sym_identifier] = ACTIONS(1572),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_switch] = ACTIONS(569),
    [anon_sym_case] = ACTIONS(571),
    [anon_sym_default] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(575),
    [anon_sym_do] = ACTIONS(577),
    [anon_sym_for] = ACTIONS(579),
    [anon_sym_return] = ACTIONS(581),
    [anon_sym_break] = ACTIONS(583),
    [anon_sym_continue] = ACTIONS(585),
    [anon_sym_goto] = ACTIONS(587),
    [anon_sym___try] = ACTIONS(589),
    [anon_sym___leave] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [429] = {
    [sym_attribute_declaration] = STATE(416),
    [sym_compound_statement] = STATE(244),
    [sym_attributed_statement] = STATE(244),
    [sym_labeled_statement] = STATE(244),
    [sym_expression_statement] = STATE(244),
    [sym_if_statement] = STATE(244),
    [sym_switch_statement] = STATE(244),
    [sym_case_statement] = STATE(244),
    [sym_while_statement] = STATE(244),
    [sym_do_statement] = STATE(244),
    [sym_for_statement] = STATE(244),
    [sym_return_statement] = STATE(244),
    [sym_break_statement] = STATE(244),
    [sym_continue_statement] = STATE(244),
    [sym_goto_statement] = STATE(244),
    [sym_seh_try_statement] = STATE(244),
    [sym_seh_leave_statement] = STATE(244),
    [sym__expression] = STATE(1313),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2275),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(416),
    [sym_identifier] = ACTIONS(1572),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_switch] = ACTIONS(569),
    [anon_sym_case] = ACTIONS(571),
    [anon_sym_default] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(575),
    [anon_sym_do] = ACTIONS(577),
    [anon_sym_for] = ACTIONS(579),
    [anon_sym_return] = ACTIONS(581),
    [anon_sym_break] = ACTIONS(583),
    [anon_sym_continue] = ACTIONS(585),
    [anon_sym_goto] = ACTIONS(587),
    [anon_sym___try] = ACTIONS(589),
    [anon_sym___leave] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [430] = {
    [sym_identifier] = ACTIONS(1530),
    [aux_sym_preproc_include_token1] = ACTIONS(1530),
    [aux_sym_preproc_def_token1] = ACTIONS(1530),
    [aux_sym_preproc_if_token1] = ACTIONS(1530),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1530),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1530),
    [sym_preproc_directive] = ACTIONS(1530),
    [anon_sym_LPAREN2] = ACTIONS(1532),
    [anon_sym_BANG] = ACTIONS(1532),
    [anon_sym_TILDE] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(1530),
    [anon_sym_PLUS] = ACTIONS(1530),
    [anon_sym_STAR] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_SEMI] = ACTIONS(1532),
    [anon_sym___extension__] = ACTIONS(1530),
    [anon_sym_typedef] = ACTIONS(1530),
    [anon_sym_extern] = ACTIONS(1530),
    [anon_sym___attribute__] = ACTIONS(1530),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1532),
    [anon_sym___declspec] = ACTIONS(1530),
    [anon_sym___cdecl] = ACTIONS(1530),
    [anon_sym___clrcall] = ACTIONS(1530),
    [anon_sym___stdcall] = ACTIONS(1530),
    [anon_sym___fastcall] = ACTIONS(1530),
    [anon_sym___thiscall] = ACTIONS(1530),
    [anon_sym___vectorcall] = ACTIONS(1530),
    [anon_sym_LBRACE] = ACTIONS(1532),
    [anon_sym_RBRACE] = ACTIONS(1532),
    [anon_sym_signed] = ACTIONS(1530),
    [anon_sym_unsigned] = ACTIONS(1530),
    [anon_sym_long] = ACTIONS(1530),
    [anon_sym_short] = ACTIONS(1530),
    [anon_sym_static] = ACTIONS(1530),
    [anon_sym_auto] = ACTIONS(1530),
    [anon_sym_register] = ACTIONS(1530),
    [anon_sym_inline] = ACTIONS(1530),
    [anon_sym___inline] = ACTIONS(1530),
    [anon_sym___inline__] = ACTIONS(1530),
    [anon_sym___forceinline] = ACTIONS(1530),
    [anon_sym_thread_local] = ACTIONS(1530),
    [anon_sym___thread] = ACTIONS(1530),
    [anon_sym_const] = ACTIONS(1530),
    [anon_sym_constexpr] = ACTIONS(1530),
    [anon_sym_volatile] = ACTIONS(1530),
    [anon_sym_restrict] = ACTIONS(1530),
    [anon_sym___restrict__] = ACTIONS(1530),
    [anon_sym__Atomic] = ACTIONS(1530),
    [anon_sym__Noreturn] = ACTIONS(1530),
    [anon_sym_noreturn] = ACTIONS(1530),
    [sym_primitive_type] = ACTIONS(1530),
    [anon_sym_enum] = ACTIONS(1530),
    [anon_sym_struct] = ACTIONS(1530),
    [anon_sym_union] = ACTIONS(1530),
    [anon_sym_if] = ACTIONS(1530),
    [anon_sym_switch] = ACTIONS(1530),
    [anon_sym_case] = ACTIONS(1530),
    [anon_sym_default] = ACTIONS(1530),
    [anon_sym_while] = ACTIONS(1530),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1530),
    [anon_sym_return] = ACTIONS(1530),
    [anon_sym_break] = ACTIONS(1530),
    [anon_sym_continue] = ACTIONS(1530),
    [anon_sym_goto] = ACTIONS(1530),
    [anon_sym___try] = ACTIONS(1530),
    [anon_sym___leave] = ACTIONS(1530),
    [anon_sym_DASH_DASH] = ACTIONS(1532),
    [anon_sym_PLUS_PLUS] = ACTIONS(1532),
    [anon_sym_sizeof] = ACTIONS(1530),
    [anon_sym___alignof__] = ACTIONS(1530),
    [anon_sym___alignof] = ACTIONS(1530),
    [anon_sym__alignof] = ACTIONS(1530),
    [anon_sym_alignof] = ACTIONS(1530),
    [anon_sym__Alignof] = ACTIONS(1530),
    [anon_sym_offsetof] = ACTIONS(1530),
    [anon_sym__Generic] = ACTIONS(1530),
    [anon_sym_asm] = ACTIONS(1530),
    [anon_sym___asm__] = ACTIONS(1530),
    [sym_number_literal] = ACTIONS(1532),
    [anon_sym_L_SQUOTE] = ACTIONS(1532),
    [anon_sym_u_SQUOTE] = ACTIONS(1532),
    [anon_sym_U_SQUOTE] = ACTIONS(1532),
    [anon_sym_u8_SQUOTE] = ACTIONS(1532),
    [anon_sym_SQUOTE] = ACTIONS(1532),
    [anon_sym_L_DQUOTE] = ACTIONS(1532),
    [anon_sym_u_DQUOTE] = ACTIONS(1532),
    [anon_sym_U_DQUOTE] = ACTIONS(1532),
    [anon_sym_u8_DQUOTE] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [sym_true] = ACTIONS(1530),
    [sym_false] = ACTIONS(1530),
    [anon_sym_NULL] = ACTIONS(1530),
    [anon_sym_nullptr] = ACTIONS(1530),
    [sym_comment] = ACTIONS(3),
  },
  [431] = {
    [sym_identifier] = ACTIONS(1510),
    [aux_sym_preproc_include_token1] = ACTIONS(1510),
    [aux_sym_preproc_def_token1] = ACTIONS(1510),
    [aux_sym_preproc_if_token1] = ACTIONS(1510),
    [aux_sym_preproc_if_token2] = ACTIONS(1510),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1510),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1510),
    [sym_preproc_directive] = ACTIONS(1510),
    [anon_sym_LPAREN2] = ACTIONS(1512),
    [anon_sym_BANG] = ACTIONS(1512),
    [anon_sym_TILDE] = ACTIONS(1512),
    [anon_sym_DASH] = ACTIONS(1510),
    [anon_sym_PLUS] = ACTIONS(1510),
    [anon_sym_STAR] = ACTIONS(1512),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym_SEMI] = ACTIONS(1512),
    [anon_sym___extension__] = ACTIONS(1510),
    [anon_sym_typedef] = ACTIONS(1510),
    [anon_sym_extern] = ACTIONS(1510),
    [anon_sym___attribute__] = ACTIONS(1510),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1512),
    [anon_sym___declspec] = ACTIONS(1510),
    [anon_sym___cdecl] = ACTIONS(1510),
    [anon_sym___clrcall] = ACTIONS(1510),
    [anon_sym___stdcall] = ACTIONS(1510),
    [anon_sym___fastcall] = ACTIONS(1510),
    [anon_sym___thiscall] = ACTIONS(1510),
    [anon_sym___vectorcall] = ACTIONS(1510),
    [anon_sym_LBRACE] = ACTIONS(1512),
    [anon_sym_signed] = ACTIONS(1510),
    [anon_sym_unsigned] = ACTIONS(1510),
    [anon_sym_long] = ACTIONS(1510),
    [anon_sym_short] = ACTIONS(1510),
    [anon_sym_static] = ACTIONS(1510),
    [anon_sym_auto] = ACTIONS(1510),
    [anon_sym_register] = ACTIONS(1510),
    [anon_sym_inline] = ACTIONS(1510),
    [anon_sym___inline] = ACTIONS(1510),
    [anon_sym___inline__] = ACTIONS(1510),
    [anon_sym___forceinline] = ACTIONS(1510),
    [anon_sym_thread_local] = ACTIONS(1510),
    [anon_sym___thread] = ACTIONS(1510),
    [anon_sym_const] = ACTIONS(1510),
    [anon_sym_constexpr] = ACTIONS(1510),
    [anon_sym_volatile] = ACTIONS(1510),
    [anon_sym_restrict] = ACTIONS(1510),
    [anon_sym___restrict__] = ACTIONS(1510),
    [anon_sym__Atomic] = ACTIONS(1510),
    [anon_sym__Noreturn] = ACTIONS(1510),
    [anon_sym_noreturn] = ACTIONS(1510),
    [sym_primitive_type] = ACTIONS(1510),
    [anon_sym_enum] = ACTIONS(1510),
    [anon_sym_struct] = ACTIONS(1510),
    [anon_sym_union] = ACTIONS(1510),
    [anon_sym_if] = ACTIONS(1510),
    [anon_sym_switch] = ACTIONS(1510),
    [anon_sym_case] = ACTIONS(1510),
    [anon_sym_default] = ACTIONS(1510),
    [anon_sym_while] = ACTIONS(1510),
    [anon_sym_do] = ACTIONS(1510),
    [anon_sym_for] = ACTIONS(1510),
    [anon_sym_return] = ACTIONS(1510),
    [anon_sym_break] = ACTIONS(1510),
    [anon_sym_continue] = ACTIONS(1510),
    [anon_sym_goto] = ACTIONS(1510),
    [anon_sym___try] = ACTIONS(1510),
    [anon_sym___leave] = ACTIONS(1510),
    [anon_sym_DASH_DASH] = ACTIONS(1512),
    [anon_sym_PLUS_PLUS] = ACTIONS(1512),
    [anon_sym_sizeof] = ACTIONS(1510),
    [anon_sym___alignof__] = ACTIONS(1510),
    [anon_sym___alignof] = ACTIONS(1510),
    [anon_sym__alignof] = ACTIONS(1510),
    [anon_sym_alignof] = ACTIONS(1510),
    [anon_sym__Alignof] = ACTIONS(1510),
    [anon_sym_offsetof] = ACTIONS(1510),
    [anon_sym__Generic] = ACTIONS(1510),
    [anon_sym_asm] = ACTIONS(1510),
    [anon_sym___asm__] = ACTIONS(1510),
    [sym_number_literal] = ACTIONS(1512),
    [anon_sym_L_SQUOTE] = ACTIONS(1512),
    [anon_sym_u_SQUOTE] = ACTIONS(1512),
    [anon_sym_U_SQUOTE] = ACTIONS(1512),
    [anon_sym_u8_SQUOTE] = ACTIONS(1512),
    [anon_sym_SQUOTE] = ACTIONS(1512),
    [anon_sym_L_DQUOTE] = ACTIONS(1512),
    [anon_sym_u_DQUOTE] = ACTIONS(1512),
    [anon_sym_U_DQUOTE] = ACTIONS(1512),
    [anon_sym_u8_DQUOTE] = ACTIONS(1512),
    [anon_sym_DQUOTE] = ACTIONS(1512),
    [sym_true] = ACTIONS(1510),
    [sym_false] = ACTIONS(1510),
    [anon_sym_NULL] = ACTIONS(1510),
    [anon_sym_nullptr] = ACTIONS(1510),
    [sym_comment] = ACTIONS(3),
  },
  [432] = {
    [sym_attribute_declaration] = STATE(499),
    [sym_compound_statement] = STATE(97),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_case_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym_seh_try_statement] = STATE(97),
    [sym_seh_leave_statement] = STATE(97),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(499),
    [sym_identifier] = ACTIONS(1720),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_do] = ACTIONS(141),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_continue] = ACTIONS(149),
    [anon_sym_goto] = ACTIONS(151),
    [anon_sym___try] = ACTIONS(153),
    [anon_sym___leave] = ACTIONS(155),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [433] = {
    [sym_identifier] = ACTIONS(1506),
    [aux_sym_preproc_include_token1] = ACTIONS(1506),
    [aux_sym_preproc_def_token1] = ACTIONS(1506),
    [aux_sym_preproc_if_token1] = ACTIONS(1506),
    [aux_sym_preproc_if_token2] = ACTIONS(1506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1506),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1506),
    [sym_preproc_directive] = ACTIONS(1506),
    [anon_sym_LPAREN2] = ACTIONS(1508),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_TILDE] = ACTIONS(1508),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_typedef] = ACTIONS(1506),
    [anon_sym_extern] = ACTIONS(1506),
    [anon_sym___attribute__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym___declspec] = ACTIONS(1506),
    [anon_sym___cdecl] = ACTIONS(1506),
    [anon_sym___clrcall] = ACTIONS(1506),
    [anon_sym___stdcall] = ACTIONS(1506),
    [anon_sym___fastcall] = ACTIONS(1506),
    [anon_sym___thiscall] = ACTIONS(1506),
    [anon_sym___vectorcall] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1508),
    [anon_sym_signed] = ACTIONS(1506),
    [anon_sym_unsigned] = ACTIONS(1506),
    [anon_sym_long] = ACTIONS(1506),
    [anon_sym_short] = ACTIONS(1506),
    [anon_sym_static] = ACTIONS(1506),
    [anon_sym_auto] = ACTIONS(1506),
    [anon_sym_register] = ACTIONS(1506),
    [anon_sym_inline] = ACTIONS(1506),
    [anon_sym___inline] = ACTIONS(1506),
    [anon_sym___inline__] = ACTIONS(1506),
    [anon_sym___forceinline] = ACTIONS(1506),
    [anon_sym_thread_local] = ACTIONS(1506),
    [anon_sym___thread] = ACTIONS(1506),
    [anon_sym_const] = ACTIONS(1506),
    [anon_sym_constexpr] = ACTIONS(1506),
    [anon_sym_volatile] = ACTIONS(1506),
    [anon_sym_restrict] = ACTIONS(1506),
    [anon_sym___restrict__] = ACTIONS(1506),
    [anon_sym__Atomic] = ACTIONS(1506),
    [anon_sym__Noreturn] = ACTIONS(1506),
    [anon_sym_noreturn] = ACTIONS(1506),
    [sym_primitive_type] = ACTIONS(1506),
    [anon_sym_enum] = ACTIONS(1506),
    [anon_sym_struct] = ACTIONS(1506),
    [anon_sym_union] = ACTIONS(1506),
    [anon_sym_if] = ACTIONS(1506),
    [anon_sym_switch] = ACTIONS(1506),
    [anon_sym_case] = ACTIONS(1506),
    [anon_sym_default] = ACTIONS(1506),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_do] = ACTIONS(1506),
    [anon_sym_for] = ACTIONS(1506),
    [anon_sym_return] = ACTIONS(1506),
    [anon_sym_break] = ACTIONS(1506),
    [anon_sym_continue] = ACTIONS(1506),
    [anon_sym_goto] = ACTIONS(1506),
    [anon_sym___try] = ACTIONS(1506),
    [anon_sym___leave] = ACTIONS(1506),
    [anon_sym_DASH_DASH] = ACTIONS(1508),
    [anon_sym_PLUS_PLUS] = ACTIONS(1508),
    [anon_sym_sizeof] = ACTIONS(1506),
    [anon_sym___alignof__] = ACTIONS(1506),
    [anon_sym___alignof] = ACTIONS(1506),
    [anon_sym__alignof] = ACTIONS(1506),
    [anon_sym_alignof] = ACTIONS(1506),
    [anon_sym__Alignof] = ACTIONS(1506),
    [anon_sym_offsetof] = ACTIONS(1506),
    [anon_sym__Generic] = ACTIONS(1506),
    [anon_sym_asm] = ACTIONS(1506),
    [anon_sym___asm__] = ACTIONS(1506),
    [sym_number_literal] = ACTIONS(1508),
    [anon_sym_L_SQUOTE] = ACTIONS(1508),
    [anon_sym_u_SQUOTE] = ACTIONS(1508),
    [anon_sym_U_SQUOTE] = ACTIONS(1508),
    [anon_sym_u8_SQUOTE] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1508),
    [anon_sym_L_DQUOTE] = ACTIONS(1508),
    [anon_sym_u_DQUOTE] = ACTIONS(1508),
    [anon_sym_U_DQUOTE] = ACTIONS(1508),
    [anon_sym_u8_DQUOTE] = ACTIONS(1508),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_true] = ACTIONS(1506),
    [sym_false] = ACTIONS(1506),
    [anon_sym_NULL] = ACTIONS(1506),
    [anon_sym_nullptr] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
  },
  [434] = {
    [sym_identifier] = ACTIONS(1494),
    [aux_sym_preproc_include_token1] = ACTIONS(1494),
    [aux_sym_preproc_def_token1] = ACTIONS(1494),
    [aux_sym_preproc_if_token1] = ACTIONS(1494),
    [aux_sym_preproc_if_token2] = ACTIONS(1494),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1494),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1494),
    [sym_preproc_directive] = ACTIONS(1494),
    [anon_sym_LPAREN2] = ACTIONS(1496),
    [anon_sym_BANG] = ACTIONS(1496),
    [anon_sym_TILDE] = ACTIONS(1496),
    [anon_sym_DASH] = ACTIONS(1494),
    [anon_sym_PLUS] = ACTIONS(1494),
    [anon_sym_STAR] = ACTIONS(1496),
    [anon_sym_AMP] = ACTIONS(1496),
    [anon_sym_SEMI] = ACTIONS(1496),
    [anon_sym___extension__] = ACTIONS(1494),
    [anon_sym_typedef] = ACTIONS(1494),
    [anon_sym_extern] = ACTIONS(1494),
    [anon_sym___attribute__] = ACTIONS(1494),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1496),
    [anon_sym___declspec] = ACTIONS(1494),
    [anon_sym___cdecl] = ACTIONS(1494),
    [anon_sym___clrcall] = ACTIONS(1494),
    [anon_sym___stdcall] = ACTIONS(1494),
    [anon_sym___fastcall] = ACTIONS(1494),
    [anon_sym___thiscall] = ACTIONS(1494),
    [anon_sym___vectorcall] = ACTIONS(1494),
    [anon_sym_LBRACE] = ACTIONS(1496),
    [anon_sym_signed] = ACTIONS(1494),
    [anon_sym_unsigned] = ACTIONS(1494),
    [anon_sym_long] = ACTIONS(1494),
    [anon_sym_short] = ACTIONS(1494),
    [anon_sym_static] = ACTIONS(1494),
    [anon_sym_auto] = ACTIONS(1494),
    [anon_sym_register] = ACTIONS(1494),
    [anon_sym_inline] = ACTIONS(1494),
    [anon_sym___inline] = ACTIONS(1494),
    [anon_sym___inline__] = ACTIONS(1494),
    [anon_sym___forceinline] = ACTIONS(1494),
    [anon_sym_thread_local] = ACTIONS(1494),
    [anon_sym___thread] = ACTIONS(1494),
    [anon_sym_const] = ACTIONS(1494),
    [anon_sym_constexpr] = ACTIONS(1494),
    [anon_sym_volatile] = ACTIONS(1494),
    [anon_sym_restrict] = ACTIONS(1494),
    [anon_sym___restrict__] = ACTIONS(1494),
    [anon_sym__Atomic] = ACTIONS(1494),
    [anon_sym__Noreturn] = ACTIONS(1494),
    [anon_sym_noreturn] = ACTIONS(1494),
    [sym_primitive_type] = ACTIONS(1494),
    [anon_sym_enum] = ACTIONS(1494),
    [anon_sym_struct] = ACTIONS(1494),
    [anon_sym_union] = ACTIONS(1494),
    [anon_sym_if] = ACTIONS(1494),
    [anon_sym_switch] = ACTIONS(1494),
    [anon_sym_case] = ACTIONS(1494),
    [anon_sym_default] = ACTIONS(1494),
    [anon_sym_while] = ACTIONS(1494),
    [anon_sym_do] = ACTIONS(1494),
    [anon_sym_for] = ACTIONS(1494),
    [anon_sym_return] = ACTIONS(1494),
    [anon_sym_break] = ACTIONS(1494),
    [anon_sym_continue] = ACTIONS(1494),
    [anon_sym_goto] = ACTIONS(1494),
    [anon_sym___try] = ACTIONS(1494),
    [anon_sym___leave] = ACTIONS(1494),
    [anon_sym_DASH_DASH] = ACTIONS(1496),
    [anon_sym_PLUS_PLUS] = ACTIONS(1496),
    [anon_sym_sizeof] = ACTIONS(1494),
    [anon_sym___alignof__] = ACTIONS(1494),
    [anon_sym___alignof] = ACTIONS(1494),
    [anon_sym__alignof] = ACTIONS(1494),
    [anon_sym_alignof] = ACTIONS(1494),
    [anon_sym__Alignof] = ACTIONS(1494),
    [anon_sym_offsetof] = ACTIONS(1494),
    [anon_sym__Generic] = ACTIONS(1494),
    [anon_sym_asm] = ACTIONS(1494),
    [anon_sym___asm__] = ACTIONS(1494),
    [sym_number_literal] = ACTIONS(1496),
    [anon_sym_L_SQUOTE] = ACTIONS(1496),
    [anon_sym_u_SQUOTE] = ACTIONS(1496),
    [anon_sym_U_SQUOTE] = ACTIONS(1496),
    [anon_sym_u8_SQUOTE] = ACTIONS(1496),
    [anon_sym_SQUOTE] = ACTIONS(1496),
    [anon_sym_L_DQUOTE] = ACTIONS(1496),
    [anon_sym_u_DQUOTE] = ACTIONS(1496),
    [anon_sym_U_DQUOTE] = ACTIONS(1496),
    [anon_sym_u8_DQUOTE] = ACTIONS(1496),
    [anon_sym_DQUOTE] = ACTIONS(1496),
    [sym_true] = ACTIONS(1494),
    [sym_false] = ACTIONS(1494),
    [anon_sym_NULL] = ACTIONS(1494),
    [anon_sym_nullptr] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
  },
  [435] = {
    [sym_attribute_declaration] = STATE(411),
    [sym_compound_statement] = STATE(207),
    [sym_attributed_statement] = STATE(205),
    [sym_labeled_statement] = STATE(200),
    [sym_expression_statement] = STATE(195),
    [sym_if_statement] = STATE(192),
    [sym_switch_statement] = STATE(186),
    [sym_case_statement] = STATE(206),
    [sym_while_statement] = STATE(179),
    [sym_do_statement] = STATE(176),
    [sym_for_statement] = STATE(181),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(193),
    [sym_continue_statement] = STATE(194),
    [sym_goto_statement] = STATE(198),
    [sym_seh_try_statement] = STATE(199),
    [sym_seh_leave_statement] = STATE(202),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [sym_identifier] = ACTIONS(1562),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [436] = {
    [sym_identifier] = ACTIONS(1474),
    [aux_sym_preproc_include_token1] = ACTIONS(1474),
    [aux_sym_preproc_def_token1] = ACTIONS(1474),
    [aux_sym_preproc_if_token1] = ACTIONS(1474),
    [aux_sym_preproc_if_token2] = ACTIONS(1474),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1474),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1474),
    [sym_preproc_directive] = ACTIONS(1474),
    [anon_sym_LPAREN2] = ACTIONS(1476),
    [anon_sym_BANG] = ACTIONS(1476),
    [anon_sym_TILDE] = ACTIONS(1476),
    [anon_sym_DASH] = ACTIONS(1474),
    [anon_sym_PLUS] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_SEMI] = ACTIONS(1476),
    [anon_sym___extension__] = ACTIONS(1474),
    [anon_sym_typedef] = ACTIONS(1474),
    [anon_sym_extern] = ACTIONS(1474),
    [anon_sym___attribute__] = ACTIONS(1474),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1476),
    [anon_sym___declspec] = ACTIONS(1474),
    [anon_sym___cdecl] = ACTIONS(1474),
    [anon_sym___clrcall] = ACTIONS(1474),
    [anon_sym___stdcall] = ACTIONS(1474),
    [anon_sym___fastcall] = ACTIONS(1474),
    [anon_sym___thiscall] = ACTIONS(1474),
    [anon_sym___vectorcall] = ACTIONS(1474),
    [anon_sym_LBRACE] = ACTIONS(1476),
    [anon_sym_signed] = ACTIONS(1474),
    [anon_sym_unsigned] = ACTIONS(1474),
    [anon_sym_long] = ACTIONS(1474),
    [anon_sym_short] = ACTIONS(1474),
    [anon_sym_static] = ACTIONS(1474),
    [anon_sym_auto] = ACTIONS(1474),
    [anon_sym_register] = ACTIONS(1474),
    [anon_sym_inline] = ACTIONS(1474),
    [anon_sym___inline] = ACTIONS(1474),
    [anon_sym___inline__] = ACTIONS(1474),
    [anon_sym___forceinline] = ACTIONS(1474),
    [anon_sym_thread_local] = ACTIONS(1474),
    [anon_sym___thread] = ACTIONS(1474),
    [anon_sym_const] = ACTIONS(1474),
    [anon_sym_constexpr] = ACTIONS(1474),
    [anon_sym_volatile] = ACTIONS(1474),
    [anon_sym_restrict] = ACTIONS(1474),
    [anon_sym___restrict__] = ACTIONS(1474),
    [anon_sym__Atomic] = ACTIONS(1474),
    [anon_sym__Noreturn] = ACTIONS(1474),
    [anon_sym_noreturn] = ACTIONS(1474),
    [sym_primitive_type] = ACTIONS(1474),
    [anon_sym_enum] = ACTIONS(1474),
    [anon_sym_struct] = ACTIONS(1474),
    [anon_sym_union] = ACTIONS(1474),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_switch] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1474),
    [anon_sym_default] = ACTIONS(1474),
    [anon_sym_while] = ACTIONS(1474),
    [anon_sym_do] = ACTIONS(1474),
    [anon_sym_for] = ACTIONS(1474),
    [anon_sym_return] = ACTIONS(1474),
    [anon_sym_break] = ACTIONS(1474),
    [anon_sym_continue] = ACTIONS(1474),
    [anon_sym_goto] = ACTIONS(1474),
    [anon_sym___try] = ACTIONS(1474),
    [anon_sym___leave] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1476),
    [anon_sym_PLUS_PLUS] = ACTIONS(1476),
    [anon_sym_sizeof] = ACTIONS(1474),
    [anon_sym___alignof__] = ACTIONS(1474),
    [anon_sym___alignof] = ACTIONS(1474),
    [anon_sym__alignof] = ACTIONS(1474),
    [anon_sym_alignof] = ACTIONS(1474),
    [anon_sym__Alignof] = ACTIONS(1474),
    [anon_sym_offsetof] = ACTIONS(1474),
    [anon_sym__Generic] = ACTIONS(1474),
    [anon_sym_asm] = ACTIONS(1474),
    [anon_sym___asm__] = ACTIONS(1474),
    [sym_number_literal] = ACTIONS(1476),
    [anon_sym_L_SQUOTE] = ACTIONS(1476),
    [anon_sym_u_SQUOTE] = ACTIONS(1476),
    [anon_sym_U_SQUOTE] = ACTIONS(1476),
    [anon_sym_u8_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1476),
    [anon_sym_L_DQUOTE] = ACTIONS(1476),
    [anon_sym_u_DQUOTE] = ACTIONS(1476),
    [anon_sym_U_DQUOTE] = ACTIONS(1476),
    [anon_sym_u8_DQUOTE] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [sym_true] = ACTIONS(1474),
    [sym_false] = ACTIONS(1474),
    [anon_sym_NULL] = ACTIONS(1474),
    [anon_sym_nullptr] = ACTIONS(1474),
    [sym_comment] = ACTIONS(3),
  },
  [437] = {
    [sym_attribute_declaration] = STATE(411),
    [sym_compound_statement] = STATE(211),
    [sym_attributed_statement] = STATE(211),
    [sym_labeled_statement] = STATE(211),
    [sym_expression_statement] = STATE(211),
    [sym_if_statement] = STATE(211),
    [sym_switch_statement] = STATE(211),
    [sym_case_statement] = STATE(211),
    [sym_while_statement] = STATE(211),
    [sym_do_statement] = STATE(211),
    [sym_for_statement] = STATE(211),
    [sym_return_statement] = STATE(211),
    [sym_break_statement] = STATE(211),
    [sym_continue_statement] = STATE(211),
    [sym_goto_statement] = STATE(211),
    [sym_seh_try_statement] = STATE(211),
    [sym_seh_leave_statement] = STATE(211),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [sym_identifier] = ACTIONS(1562),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [438] = {
    [sym_identifier] = ACTIONS(1446),
    [aux_sym_preproc_include_token1] = ACTIONS(1446),
    [aux_sym_preproc_def_token1] = ACTIONS(1446),
    [aux_sym_preproc_if_token1] = ACTIONS(1446),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1446),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1446),
    [sym_preproc_directive] = ACTIONS(1446),
    [anon_sym_LPAREN2] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1446),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym___extension__] = ACTIONS(1446),
    [anon_sym_typedef] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(1446),
    [anon_sym___attribute__] = ACTIONS(1446),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(1446),
    [anon_sym___cdecl] = ACTIONS(1446),
    [anon_sym___clrcall] = ACTIONS(1446),
    [anon_sym___stdcall] = ACTIONS(1446),
    [anon_sym___fastcall] = ACTIONS(1446),
    [anon_sym___thiscall] = ACTIONS(1446),
    [anon_sym___vectorcall] = ACTIONS(1446),
    [anon_sym_LBRACE] = ACTIONS(1448),
    [anon_sym_RBRACE] = ACTIONS(1448),
    [anon_sym_signed] = ACTIONS(1446),
    [anon_sym_unsigned] = ACTIONS(1446),
    [anon_sym_long] = ACTIONS(1446),
    [anon_sym_short] = ACTIONS(1446),
    [anon_sym_static] = ACTIONS(1446),
    [anon_sym_auto] = ACTIONS(1446),
    [anon_sym_register] = ACTIONS(1446),
    [anon_sym_inline] = ACTIONS(1446),
    [anon_sym___inline] = ACTIONS(1446),
    [anon_sym___inline__] = ACTIONS(1446),
    [anon_sym___forceinline] = ACTIONS(1446),
    [anon_sym_thread_local] = ACTIONS(1446),
    [anon_sym___thread] = ACTIONS(1446),
    [anon_sym_const] = ACTIONS(1446),
    [anon_sym_constexpr] = ACTIONS(1446),
    [anon_sym_volatile] = ACTIONS(1446),
    [anon_sym_restrict] = ACTIONS(1446),
    [anon_sym___restrict__] = ACTIONS(1446),
    [anon_sym__Atomic] = ACTIONS(1446),
    [anon_sym__Noreturn] = ACTIONS(1446),
    [anon_sym_noreturn] = ACTIONS(1446),
    [sym_primitive_type] = ACTIONS(1446),
    [anon_sym_enum] = ACTIONS(1446),
    [anon_sym_struct] = ACTIONS(1446),
    [anon_sym_union] = ACTIONS(1446),
    [anon_sym_if] = ACTIONS(1446),
    [anon_sym_switch] = ACTIONS(1446),
    [anon_sym_case] = ACTIONS(1446),
    [anon_sym_default] = ACTIONS(1446),
    [anon_sym_while] = ACTIONS(1446),
    [anon_sym_do] = ACTIONS(1446),
    [anon_sym_for] = ACTIONS(1446),
    [anon_sym_return] = ACTIONS(1446),
    [anon_sym_break] = ACTIONS(1446),
    [anon_sym_continue] = ACTIONS(1446),
    [anon_sym_goto] = ACTIONS(1446),
    [anon_sym___try] = ACTIONS(1446),
    [anon_sym___leave] = ACTIONS(1446),
    [anon_sym_DASH_DASH] = ACTIONS(1448),
    [anon_sym_PLUS_PLUS] = ACTIONS(1448),
    [anon_sym_sizeof] = ACTIONS(1446),
    [anon_sym___alignof__] = ACTIONS(1446),
    [anon_sym___alignof] = ACTIONS(1446),
    [anon_sym__alignof] = ACTIONS(1446),
    [anon_sym_alignof] = ACTIONS(1446),
    [anon_sym__Alignof] = ACTIONS(1446),
    [anon_sym_offsetof] = ACTIONS(1446),
    [anon_sym__Generic] = ACTIONS(1446),
    [anon_sym_asm] = ACTIONS(1446),
    [anon_sym___asm__] = ACTIONS(1446),
    [sym_number_literal] = ACTIONS(1448),
    [anon_sym_L_SQUOTE] = ACTIONS(1448),
    [anon_sym_u_SQUOTE] = ACTIONS(1448),
    [anon_sym_U_SQUOTE] = ACTIONS(1448),
    [anon_sym_u8_SQUOTE] = ACTIONS(1448),
    [anon_sym_SQUOTE] = ACTIONS(1448),
    [anon_sym_L_DQUOTE] = ACTIONS(1448),
    [anon_sym_u_DQUOTE] = ACTIONS(1448),
    [anon_sym_U_DQUOTE] = ACTIONS(1448),
    [anon_sym_u8_DQUOTE] = ACTIONS(1448),
    [anon_sym_DQUOTE] = ACTIONS(1448),
    [sym_true] = ACTIONS(1446),
    [sym_false] = ACTIONS(1446),
    [anon_sym_NULL] = ACTIONS(1446),
    [anon_sym_nullptr] = ACTIONS(1446),
    [sym_comment] = ACTIONS(3),
  },
  [439] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(559),
    [sym_attributed_statement] = STATE(559),
    [sym_labeled_statement] = STATE(559),
    [sym_expression_statement] = STATE(559),
    [sym_if_statement] = STATE(559),
    [sym_switch_statement] = STATE(559),
    [sym_case_statement] = STATE(559),
    [sym_while_statement] = STATE(559),
    [sym_do_statement] = STATE(559),
    [sym_for_statement] = STATE(559),
    [sym_return_statement] = STATE(559),
    [sym_break_statement] = STATE(559),
    [sym_continue_statement] = STATE(559),
    [sym_goto_statement] = STATE(559),
    [sym_seh_try_statement] = STATE(559),
    [sym_seh_leave_statement] = STATE(559),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1566),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1278),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1568),
    [anon_sym_default] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1280),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1282),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1284),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [440] = {
    [sym_identifier] = ACTIONS(1530),
    [aux_sym_preproc_include_token1] = ACTIONS(1530),
    [aux_sym_preproc_def_token1] = ACTIONS(1530),
    [aux_sym_preproc_if_token1] = ACTIONS(1530),
    [aux_sym_preproc_if_token2] = ACTIONS(1530),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1530),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1530),
    [sym_preproc_directive] = ACTIONS(1530),
    [anon_sym_LPAREN2] = ACTIONS(1532),
    [anon_sym_BANG] = ACTIONS(1532),
    [anon_sym_TILDE] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(1530),
    [anon_sym_PLUS] = ACTIONS(1530),
    [anon_sym_STAR] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_SEMI] = ACTIONS(1532),
    [anon_sym___extension__] = ACTIONS(1530),
    [anon_sym_typedef] = ACTIONS(1530),
    [anon_sym_extern] = ACTIONS(1530),
    [anon_sym___attribute__] = ACTIONS(1530),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1532),
    [anon_sym___declspec] = ACTIONS(1530),
    [anon_sym___cdecl] = ACTIONS(1530),
    [anon_sym___clrcall] = ACTIONS(1530),
    [anon_sym___stdcall] = ACTIONS(1530),
    [anon_sym___fastcall] = ACTIONS(1530),
    [anon_sym___thiscall] = ACTIONS(1530),
    [anon_sym___vectorcall] = ACTIONS(1530),
    [anon_sym_LBRACE] = ACTIONS(1532),
    [anon_sym_signed] = ACTIONS(1530),
    [anon_sym_unsigned] = ACTIONS(1530),
    [anon_sym_long] = ACTIONS(1530),
    [anon_sym_short] = ACTIONS(1530),
    [anon_sym_static] = ACTIONS(1530),
    [anon_sym_auto] = ACTIONS(1530),
    [anon_sym_register] = ACTIONS(1530),
    [anon_sym_inline] = ACTIONS(1530),
    [anon_sym___inline] = ACTIONS(1530),
    [anon_sym___inline__] = ACTIONS(1530),
    [anon_sym___forceinline] = ACTIONS(1530),
    [anon_sym_thread_local] = ACTIONS(1530),
    [anon_sym___thread] = ACTIONS(1530),
    [anon_sym_const] = ACTIONS(1530),
    [anon_sym_constexpr] = ACTIONS(1530),
    [anon_sym_volatile] = ACTIONS(1530),
    [anon_sym_restrict] = ACTIONS(1530),
    [anon_sym___restrict__] = ACTIONS(1530),
    [anon_sym__Atomic] = ACTIONS(1530),
    [anon_sym__Noreturn] = ACTIONS(1530),
    [anon_sym_noreturn] = ACTIONS(1530),
    [sym_primitive_type] = ACTIONS(1530),
    [anon_sym_enum] = ACTIONS(1530),
    [anon_sym_struct] = ACTIONS(1530),
    [anon_sym_union] = ACTIONS(1530),
    [anon_sym_if] = ACTIONS(1530),
    [anon_sym_switch] = ACTIONS(1530),
    [anon_sym_case] = ACTIONS(1530),
    [anon_sym_default] = ACTIONS(1530),
    [anon_sym_while] = ACTIONS(1530),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1530),
    [anon_sym_return] = ACTIONS(1530),
    [anon_sym_break] = ACTIONS(1530),
    [anon_sym_continue] = ACTIONS(1530),
    [anon_sym_goto] = ACTIONS(1530),
    [anon_sym___try] = ACTIONS(1530),
    [anon_sym___leave] = ACTIONS(1530),
    [anon_sym_DASH_DASH] = ACTIONS(1532),
    [anon_sym_PLUS_PLUS] = ACTIONS(1532),
    [anon_sym_sizeof] = ACTIONS(1530),
    [anon_sym___alignof__] = ACTIONS(1530),
    [anon_sym___alignof] = ACTIONS(1530),
    [anon_sym__alignof] = ACTIONS(1530),
    [anon_sym_alignof] = ACTIONS(1530),
    [anon_sym__Alignof] = ACTIONS(1530),
    [anon_sym_offsetof] = ACTIONS(1530),
    [anon_sym__Generic] = ACTIONS(1530),
    [anon_sym_asm] = ACTIONS(1530),
    [anon_sym___asm__] = ACTIONS(1530),
    [sym_number_literal] = ACTIONS(1532),
    [anon_sym_L_SQUOTE] = ACTIONS(1532),
    [anon_sym_u_SQUOTE] = ACTIONS(1532),
    [anon_sym_U_SQUOTE] = ACTIONS(1532),
    [anon_sym_u8_SQUOTE] = ACTIONS(1532),
    [anon_sym_SQUOTE] = ACTIONS(1532),
    [anon_sym_L_DQUOTE] = ACTIONS(1532),
    [anon_sym_u_DQUOTE] = ACTIONS(1532),
    [anon_sym_U_DQUOTE] = ACTIONS(1532),
    [anon_sym_u8_DQUOTE] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [sym_true] = ACTIONS(1530),
    [sym_false] = ACTIONS(1530),
    [anon_sym_NULL] = ACTIONS(1530),
    [anon_sym_nullptr] = ACTIONS(1530),
    [sym_comment] = ACTIONS(3),
  },
  [441] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(2403),
    [sym_attributed_statement] = STATE(2403),
    [sym_labeled_statement] = STATE(2403),
    [sym_expression_statement] = STATE(2403),
    [sym_if_statement] = STATE(2403),
    [sym_switch_statement] = STATE(2403),
    [sym_case_statement] = STATE(2403),
    [sym_while_statement] = STATE(2403),
    [sym_do_statement] = STATE(2403),
    [sym_for_statement] = STATE(2403),
    [sym_return_statement] = STATE(2403),
    [sym_break_statement] = STATE(2403),
    [sym_continue_statement] = STATE(2403),
    [sym_goto_statement] = STATE(2403),
    [sym_seh_try_statement] = STATE(2403),
    [sym_seh_leave_statement] = STATE(2403),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1566),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1278),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1568),
    [anon_sym_default] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1280),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1282),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1284),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [442] = {
    [sym_identifier] = ACTIONS(1502),
    [aux_sym_preproc_include_token1] = ACTIONS(1502),
    [aux_sym_preproc_def_token1] = ACTIONS(1502),
    [aux_sym_preproc_if_token1] = ACTIONS(1502),
    [aux_sym_preproc_if_token2] = ACTIONS(1502),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1502),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1502),
    [sym_preproc_directive] = ACTIONS(1502),
    [anon_sym_LPAREN2] = ACTIONS(1504),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_TILDE] = ACTIONS(1504),
    [anon_sym_DASH] = ACTIONS(1502),
    [anon_sym_PLUS] = ACTIONS(1502),
    [anon_sym_STAR] = ACTIONS(1504),
    [anon_sym_AMP] = ACTIONS(1504),
    [anon_sym_SEMI] = ACTIONS(1504),
    [anon_sym___extension__] = ACTIONS(1502),
    [anon_sym_typedef] = ACTIONS(1502),
    [anon_sym_extern] = ACTIONS(1502),
    [anon_sym___attribute__] = ACTIONS(1502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1504),
    [anon_sym___declspec] = ACTIONS(1502),
    [anon_sym___cdecl] = ACTIONS(1502),
    [anon_sym___clrcall] = ACTIONS(1502),
    [anon_sym___stdcall] = ACTIONS(1502),
    [anon_sym___fastcall] = ACTIONS(1502),
    [anon_sym___thiscall] = ACTIONS(1502),
    [anon_sym___vectorcall] = ACTIONS(1502),
    [anon_sym_LBRACE] = ACTIONS(1504),
    [anon_sym_signed] = ACTIONS(1502),
    [anon_sym_unsigned] = ACTIONS(1502),
    [anon_sym_long] = ACTIONS(1502),
    [anon_sym_short] = ACTIONS(1502),
    [anon_sym_static] = ACTIONS(1502),
    [anon_sym_auto] = ACTIONS(1502),
    [anon_sym_register] = ACTIONS(1502),
    [anon_sym_inline] = ACTIONS(1502),
    [anon_sym___inline] = ACTIONS(1502),
    [anon_sym___inline__] = ACTIONS(1502),
    [anon_sym___forceinline] = ACTIONS(1502),
    [anon_sym_thread_local] = ACTIONS(1502),
    [anon_sym___thread] = ACTIONS(1502),
    [anon_sym_const] = ACTIONS(1502),
    [anon_sym_constexpr] = ACTIONS(1502),
    [anon_sym_volatile] = ACTIONS(1502),
    [anon_sym_restrict] = ACTIONS(1502),
    [anon_sym___restrict__] = ACTIONS(1502),
    [anon_sym__Atomic] = ACTIONS(1502),
    [anon_sym__Noreturn] = ACTIONS(1502),
    [anon_sym_noreturn] = ACTIONS(1502),
    [sym_primitive_type] = ACTIONS(1502),
    [anon_sym_enum] = ACTIONS(1502),
    [anon_sym_struct] = ACTIONS(1502),
    [anon_sym_union] = ACTIONS(1502),
    [anon_sym_if] = ACTIONS(1502),
    [anon_sym_switch] = ACTIONS(1502),
    [anon_sym_case] = ACTIONS(1502),
    [anon_sym_default] = ACTIONS(1502),
    [anon_sym_while] = ACTIONS(1502),
    [anon_sym_do] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1502),
    [anon_sym_return] = ACTIONS(1502),
    [anon_sym_break] = ACTIONS(1502),
    [anon_sym_continue] = ACTIONS(1502),
    [anon_sym_goto] = ACTIONS(1502),
    [anon_sym___try] = ACTIONS(1502),
    [anon_sym___leave] = ACTIONS(1502),
    [anon_sym_DASH_DASH] = ACTIONS(1504),
    [anon_sym_PLUS_PLUS] = ACTIONS(1504),
    [anon_sym_sizeof] = ACTIONS(1502),
    [anon_sym___alignof__] = ACTIONS(1502),
    [anon_sym___alignof] = ACTIONS(1502),
    [anon_sym__alignof] = ACTIONS(1502),
    [anon_sym_alignof] = ACTIONS(1502),
    [anon_sym__Alignof] = ACTIONS(1502),
    [anon_sym_offsetof] = ACTIONS(1502),
    [anon_sym__Generic] = ACTIONS(1502),
    [anon_sym_asm] = ACTIONS(1502),
    [anon_sym___asm__] = ACTIONS(1502),
    [sym_number_literal] = ACTIONS(1504),
    [anon_sym_L_SQUOTE] = ACTIONS(1504),
    [anon_sym_u_SQUOTE] = ACTIONS(1504),
    [anon_sym_U_SQUOTE] = ACTIONS(1504),
    [anon_sym_u8_SQUOTE] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(1504),
    [anon_sym_L_DQUOTE] = ACTIONS(1504),
    [anon_sym_u_DQUOTE] = ACTIONS(1504),
    [anon_sym_U_DQUOTE] = ACTIONS(1504),
    [anon_sym_u8_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE] = ACTIONS(1504),
    [sym_true] = ACTIONS(1502),
    [sym_false] = ACTIONS(1502),
    [anon_sym_NULL] = ACTIONS(1502),
    [anon_sym_nullptr] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [443] = {
    [sym_attribute_declaration] = STATE(443),
    [sym_compound_statement] = STATE(219),
    [sym_attributed_statement] = STATE(219),
    [sym_labeled_statement] = STATE(219),
    [sym_expression_statement] = STATE(219),
    [sym_if_statement] = STATE(219),
    [sym_switch_statement] = STATE(219),
    [sym_case_statement] = STATE(219),
    [sym_while_statement] = STATE(219),
    [sym_do_statement] = STATE(219),
    [sym_for_statement] = STATE(219),
    [sym_return_statement] = STATE(219),
    [sym_break_statement] = STATE(219),
    [sym_continue_statement] = STATE(219),
    [sym_goto_statement] = STATE(219),
    [sym_seh_try_statement] = STATE(219),
    [sym_seh_leave_statement] = STATE(219),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(443),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_LPAREN2] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1582),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1588),
    [anon_sym_SEMI] = ACTIONS(1725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1594),
    [anon_sym_LBRACE] = ACTIONS(1728),
    [anon_sym_if] = ACTIONS(1731),
    [anon_sym_switch] = ACTIONS(1734),
    [anon_sym_case] = ACTIONS(1737),
    [anon_sym_default] = ACTIONS(1740),
    [anon_sym_while] = ACTIONS(1743),
    [anon_sym_do] = ACTIONS(1746),
    [anon_sym_for] = ACTIONS(1749),
    [anon_sym_return] = ACTIONS(1752),
    [anon_sym_break] = ACTIONS(1755),
    [anon_sym_continue] = ACTIONS(1758),
    [anon_sym_goto] = ACTIONS(1761),
    [anon_sym___try] = ACTIONS(1764),
    [anon_sym___leave] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1639),
    [anon_sym_PLUS_PLUS] = ACTIONS(1639),
    [anon_sym_sizeof] = ACTIONS(1642),
    [anon_sym___alignof__] = ACTIONS(1645),
    [anon_sym___alignof] = ACTIONS(1645),
    [anon_sym__alignof] = ACTIONS(1645),
    [anon_sym_alignof] = ACTIONS(1645),
    [anon_sym__Alignof] = ACTIONS(1645),
    [anon_sym_offsetof] = ACTIONS(1648),
    [anon_sym__Generic] = ACTIONS(1651),
    [anon_sym_asm] = ACTIONS(1654),
    [anon_sym___asm__] = ACTIONS(1654),
    [sym_number_literal] = ACTIONS(1657),
    [anon_sym_L_SQUOTE] = ACTIONS(1660),
    [anon_sym_u_SQUOTE] = ACTIONS(1660),
    [anon_sym_U_SQUOTE] = ACTIONS(1660),
    [anon_sym_u8_SQUOTE] = ACTIONS(1660),
    [anon_sym_SQUOTE] = ACTIONS(1660),
    [anon_sym_L_DQUOTE] = ACTIONS(1663),
    [anon_sym_u_DQUOTE] = ACTIONS(1663),
    [anon_sym_U_DQUOTE] = ACTIONS(1663),
    [anon_sym_u8_DQUOTE] = ACTIONS(1663),
    [anon_sym_DQUOTE] = ACTIONS(1663),
    [sym_true] = ACTIONS(1666),
    [sym_false] = ACTIONS(1666),
    [anon_sym_NULL] = ACTIONS(1669),
    [anon_sym_nullptr] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
  },
  [444] = {
    [sym_identifier] = ACTIONS(1490),
    [aux_sym_preproc_include_token1] = ACTIONS(1490),
    [aux_sym_preproc_def_token1] = ACTIONS(1490),
    [aux_sym_preproc_if_token1] = ACTIONS(1490),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1490),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1490),
    [sym_preproc_directive] = ACTIONS(1490),
    [anon_sym_LPAREN2] = ACTIONS(1492),
    [anon_sym_BANG] = ACTIONS(1492),
    [anon_sym_TILDE] = ACTIONS(1492),
    [anon_sym_DASH] = ACTIONS(1490),
    [anon_sym_PLUS] = ACTIONS(1490),
    [anon_sym_STAR] = ACTIONS(1492),
    [anon_sym_AMP] = ACTIONS(1492),
    [anon_sym_SEMI] = ACTIONS(1492),
    [anon_sym___extension__] = ACTIONS(1490),
    [anon_sym_typedef] = ACTIONS(1490),
    [anon_sym_extern] = ACTIONS(1490),
    [anon_sym___attribute__] = ACTIONS(1490),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1492),
    [anon_sym___declspec] = ACTIONS(1490),
    [anon_sym___cdecl] = ACTIONS(1490),
    [anon_sym___clrcall] = ACTIONS(1490),
    [anon_sym___stdcall] = ACTIONS(1490),
    [anon_sym___fastcall] = ACTIONS(1490),
    [anon_sym___thiscall] = ACTIONS(1490),
    [anon_sym___vectorcall] = ACTIONS(1490),
    [anon_sym_LBRACE] = ACTIONS(1492),
    [anon_sym_RBRACE] = ACTIONS(1492),
    [anon_sym_signed] = ACTIONS(1490),
    [anon_sym_unsigned] = ACTIONS(1490),
    [anon_sym_long] = ACTIONS(1490),
    [anon_sym_short] = ACTIONS(1490),
    [anon_sym_static] = ACTIONS(1490),
    [anon_sym_auto] = ACTIONS(1490),
    [anon_sym_register] = ACTIONS(1490),
    [anon_sym_inline] = ACTIONS(1490),
    [anon_sym___inline] = ACTIONS(1490),
    [anon_sym___inline__] = ACTIONS(1490),
    [anon_sym___forceinline] = ACTIONS(1490),
    [anon_sym_thread_local] = ACTIONS(1490),
    [anon_sym___thread] = ACTIONS(1490),
    [anon_sym_const] = ACTIONS(1490),
    [anon_sym_constexpr] = ACTIONS(1490),
    [anon_sym_volatile] = ACTIONS(1490),
    [anon_sym_restrict] = ACTIONS(1490),
    [anon_sym___restrict__] = ACTIONS(1490),
    [anon_sym__Atomic] = ACTIONS(1490),
    [anon_sym__Noreturn] = ACTIONS(1490),
    [anon_sym_noreturn] = ACTIONS(1490),
    [sym_primitive_type] = ACTIONS(1490),
    [anon_sym_enum] = ACTIONS(1490),
    [anon_sym_struct] = ACTIONS(1490),
    [anon_sym_union] = ACTIONS(1490),
    [anon_sym_if] = ACTIONS(1490),
    [anon_sym_switch] = ACTIONS(1490),
    [anon_sym_case] = ACTIONS(1490),
    [anon_sym_default] = ACTIONS(1490),
    [anon_sym_while] = ACTIONS(1490),
    [anon_sym_do] = ACTIONS(1490),
    [anon_sym_for] = ACTIONS(1490),
    [anon_sym_return] = ACTIONS(1490),
    [anon_sym_break] = ACTIONS(1490),
    [anon_sym_continue] = ACTIONS(1490),
    [anon_sym_goto] = ACTIONS(1490),
    [anon_sym___try] = ACTIONS(1490),
    [anon_sym___leave] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1492),
    [anon_sym_PLUS_PLUS] = ACTIONS(1492),
    [anon_sym_sizeof] = ACTIONS(1490),
    [anon_sym___alignof__] = ACTIONS(1490),
    [anon_sym___alignof] = ACTIONS(1490),
    [anon_sym__alignof] = ACTIONS(1490),
    [anon_sym_alignof] = ACTIONS(1490),
    [anon_sym__Alignof] = ACTIONS(1490),
    [anon_sym_offsetof] = ACTIONS(1490),
    [anon_sym__Generic] = ACTIONS(1490),
    [anon_sym_asm] = ACTIONS(1490),
    [anon_sym___asm__] = ACTIONS(1490),
    [sym_number_literal] = ACTIONS(1492),
    [anon_sym_L_SQUOTE] = ACTIONS(1492),
    [anon_sym_u_SQUOTE] = ACTIONS(1492),
    [anon_sym_U_SQUOTE] = ACTIONS(1492),
    [anon_sym_u8_SQUOTE] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1492),
    [anon_sym_L_DQUOTE] = ACTIONS(1492),
    [anon_sym_u_DQUOTE] = ACTIONS(1492),
    [anon_sym_U_DQUOTE] = ACTIONS(1492),
    [anon_sym_u8_DQUOTE] = ACTIONS(1492),
    [anon_sym_DQUOTE] = ACTIONS(1492),
    [sym_true] = ACTIONS(1490),
    [sym_false] = ACTIONS(1490),
    [anon_sym_NULL] = ACTIONS(1490),
    [anon_sym_nullptr] = ACTIONS(1490),
    [sym_comment] = ACTIONS(3),
  },
  [445] = {
    [sym_identifier] = ACTIONS(1498),
    [aux_sym_preproc_include_token1] = ACTIONS(1498),
    [aux_sym_preproc_def_token1] = ACTIONS(1498),
    [aux_sym_preproc_if_token1] = ACTIONS(1498),
    [aux_sym_preproc_if_token2] = ACTIONS(1498),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1498),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1498),
    [sym_preproc_directive] = ACTIONS(1498),
    [anon_sym_LPAREN2] = ACTIONS(1500),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_TILDE] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1498),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_SEMI] = ACTIONS(1500),
    [anon_sym___extension__] = ACTIONS(1498),
    [anon_sym_typedef] = ACTIONS(1498),
    [anon_sym_extern] = ACTIONS(1498),
    [anon_sym___attribute__] = ACTIONS(1498),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1500),
    [anon_sym___declspec] = ACTIONS(1498),
    [anon_sym___cdecl] = ACTIONS(1498),
    [anon_sym___clrcall] = ACTIONS(1498),
    [anon_sym___stdcall] = ACTIONS(1498),
    [anon_sym___fastcall] = ACTIONS(1498),
    [anon_sym___thiscall] = ACTIONS(1498),
    [anon_sym___vectorcall] = ACTIONS(1498),
    [anon_sym_LBRACE] = ACTIONS(1500),
    [anon_sym_signed] = ACTIONS(1498),
    [anon_sym_unsigned] = ACTIONS(1498),
    [anon_sym_long] = ACTIONS(1498),
    [anon_sym_short] = ACTIONS(1498),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_auto] = ACTIONS(1498),
    [anon_sym_register] = ACTIONS(1498),
    [anon_sym_inline] = ACTIONS(1498),
    [anon_sym___inline] = ACTIONS(1498),
    [anon_sym___inline__] = ACTIONS(1498),
    [anon_sym___forceinline] = ACTIONS(1498),
    [anon_sym_thread_local] = ACTIONS(1498),
    [anon_sym___thread] = ACTIONS(1498),
    [anon_sym_const] = ACTIONS(1498),
    [anon_sym_constexpr] = ACTIONS(1498),
    [anon_sym_volatile] = ACTIONS(1498),
    [anon_sym_restrict] = ACTIONS(1498),
    [anon_sym___restrict__] = ACTIONS(1498),
    [anon_sym__Atomic] = ACTIONS(1498),
    [anon_sym__Noreturn] = ACTIONS(1498),
    [anon_sym_noreturn] = ACTIONS(1498),
    [sym_primitive_type] = ACTIONS(1498),
    [anon_sym_enum] = ACTIONS(1498),
    [anon_sym_struct] = ACTIONS(1498),
    [anon_sym_union] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1498),
    [anon_sym_switch] = ACTIONS(1498),
    [anon_sym_case] = ACTIONS(1498),
    [anon_sym_default] = ACTIONS(1498),
    [anon_sym_while] = ACTIONS(1498),
    [anon_sym_do] = ACTIONS(1498),
    [anon_sym_for] = ACTIONS(1498),
    [anon_sym_return] = ACTIONS(1498),
    [anon_sym_break] = ACTIONS(1498),
    [anon_sym_continue] = ACTIONS(1498),
    [anon_sym_goto] = ACTIONS(1498),
    [anon_sym___try] = ACTIONS(1498),
    [anon_sym___leave] = ACTIONS(1498),
    [anon_sym_DASH_DASH] = ACTIONS(1500),
    [anon_sym_PLUS_PLUS] = ACTIONS(1500),
    [anon_sym_sizeof] = ACTIONS(1498),
    [anon_sym___alignof__] = ACTIONS(1498),
    [anon_sym___alignof] = ACTIONS(1498),
    [anon_sym__alignof] = ACTIONS(1498),
    [anon_sym_alignof] = ACTIONS(1498),
    [anon_sym__Alignof] = ACTIONS(1498),
    [anon_sym_offsetof] = ACTIONS(1498),
    [anon_sym__Generic] = ACTIONS(1498),
    [anon_sym_asm] = ACTIONS(1498),
    [anon_sym___asm__] = ACTIONS(1498),
    [sym_number_literal] = ACTIONS(1500),
    [anon_sym_L_SQUOTE] = ACTIONS(1500),
    [anon_sym_u_SQUOTE] = ACTIONS(1500),
    [anon_sym_U_SQUOTE] = ACTIONS(1500),
    [anon_sym_u8_SQUOTE] = ACTIONS(1500),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_L_DQUOTE] = ACTIONS(1500),
    [anon_sym_u_DQUOTE] = ACTIONS(1500),
    [anon_sym_U_DQUOTE] = ACTIONS(1500),
    [anon_sym_u8_DQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE] = ACTIONS(1500),
    [sym_true] = ACTIONS(1498),
    [sym_false] = ACTIONS(1498),
    [anon_sym_NULL] = ACTIONS(1498),
    [anon_sym_nullptr] = ACTIONS(1498),
    [sym_comment] = ACTIONS(3),
  },
  [446] = {
    [sym_identifier] = ACTIONS(1490),
    [aux_sym_preproc_include_token1] = ACTIONS(1490),
    [aux_sym_preproc_def_token1] = ACTIONS(1490),
    [aux_sym_preproc_if_token1] = ACTIONS(1490),
    [aux_sym_preproc_if_token2] = ACTIONS(1490),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1490),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1490),
    [sym_preproc_directive] = ACTIONS(1490),
    [anon_sym_LPAREN2] = ACTIONS(1492),
    [anon_sym_BANG] = ACTIONS(1492),
    [anon_sym_TILDE] = ACTIONS(1492),
    [anon_sym_DASH] = ACTIONS(1490),
    [anon_sym_PLUS] = ACTIONS(1490),
    [anon_sym_STAR] = ACTIONS(1492),
    [anon_sym_AMP] = ACTIONS(1492),
    [anon_sym_SEMI] = ACTIONS(1492),
    [anon_sym___extension__] = ACTIONS(1490),
    [anon_sym_typedef] = ACTIONS(1490),
    [anon_sym_extern] = ACTIONS(1490),
    [anon_sym___attribute__] = ACTIONS(1490),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1492),
    [anon_sym___declspec] = ACTIONS(1490),
    [anon_sym___cdecl] = ACTIONS(1490),
    [anon_sym___clrcall] = ACTIONS(1490),
    [anon_sym___stdcall] = ACTIONS(1490),
    [anon_sym___fastcall] = ACTIONS(1490),
    [anon_sym___thiscall] = ACTIONS(1490),
    [anon_sym___vectorcall] = ACTIONS(1490),
    [anon_sym_LBRACE] = ACTIONS(1492),
    [anon_sym_signed] = ACTIONS(1490),
    [anon_sym_unsigned] = ACTIONS(1490),
    [anon_sym_long] = ACTIONS(1490),
    [anon_sym_short] = ACTIONS(1490),
    [anon_sym_static] = ACTIONS(1490),
    [anon_sym_auto] = ACTIONS(1490),
    [anon_sym_register] = ACTIONS(1490),
    [anon_sym_inline] = ACTIONS(1490),
    [anon_sym___inline] = ACTIONS(1490),
    [anon_sym___inline__] = ACTIONS(1490),
    [anon_sym___forceinline] = ACTIONS(1490),
    [anon_sym_thread_local] = ACTIONS(1490),
    [anon_sym___thread] = ACTIONS(1490),
    [anon_sym_const] = ACTIONS(1490),
    [anon_sym_constexpr] = ACTIONS(1490),
    [anon_sym_volatile] = ACTIONS(1490),
    [anon_sym_restrict] = ACTIONS(1490),
    [anon_sym___restrict__] = ACTIONS(1490),
    [anon_sym__Atomic] = ACTIONS(1490),
    [anon_sym__Noreturn] = ACTIONS(1490),
    [anon_sym_noreturn] = ACTIONS(1490),
    [sym_primitive_type] = ACTIONS(1490),
    [anon_sym_enum] = ACTIONS(1490),
    [anon_sym_struct] = ACTIONS(1490),
    [anon_sym_union] = ACTIONS(1490),
    [anon_sym_if] = ACTIONS(1490),
    [anon_sym_switch] = ACTIONS(1490),
    [anon_sym_case] = ACTIONS(1490),
    [anon_sym_default] = ACTIONS(1490),
    [anon_sym_while] = ACTIONS(1490),
    [anon_sym_do] = ACTIONS(1490),
    [anon_sym_for] = ACTIONS(1490),
    [anon_sym_return] = ACTIONS(1490),
    [anon_sym_break] = ACTIONS(1490),
    [anon_sym_continue] = ACTIONS(1490),
    [anon_sym_goto] = ACTIONS(1490),
    [anon_sym___try] = ACTIONS(1490),
    [anon_sym___leave] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1492),
    [anon_sym_PLUS_PLUS] = ACTIONS(1492),
    [anon_sym_sizeof] = ACTIONS(1490),
    [anon_sym___alignof__] = ACTIONS(1490),
    [anon_sym___alignof] = ACTIONS(1490),
    [anon_sym__alignof] = ACTIONS(1490),
    [anon_sym_alignof] = ACTIONS(1490),
    [anon_sym__Alignof] = ACTIONS(1490),
    [anon_sym_offsetof] = ACTIONS(1490),
    [anon_sym__Generic] = ACTIONS(1490),
    [anon_sym_asm] = ACTIONS(1490),
    [anon_sym___asm__] = ACTIONS(1490),
    [sym_number_literal] = ACTIONS(1492),
    [anon_sym_L_SQUOTE] = ACTIONS(1492),
    [anon_sym_u_SQUOTE] = ACTIONS(1492),
    [anon_sym_U_SQUOTE] = ACTIONS(1492),
    [anon_sym_u8_SQUOTE] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1492),
    [anon_sym_L_DQUOTE] = ACTIONS(1492),
    [anon_sym_u_DQUOTE] = ACTIONS(1492),
    [anon_sym_U_DQUOTE] = ACTIONS(1492),
    [anon_sym_u8_DQUOTE] = ACTIONS(1492),
    [anon_sym_DQUOTE] = ACTIONS(1492),
    [sym_true] = ACTIONS(1490),
    [sym_false] = ACTIONS(1490),
    [anon_sym_NULL] = ACTIONS(1490),
    [anon_sym_nullptr] = ACTIONS(1490),
    [sym_comment] = ACTIONS(3),
  },
  [447] = {
    [sym_identifier] = ACTIONS(1482),
    [aux_sym_preproc_include_token1] = ACTIONS(1482),
    [aux_sym_preproc_def_token1] = ACTIONS(1482),
    [aux_sym_preproc_if_token1] = ACTIONS(1482),
    [aux_sym_preproc_if_token2] = ACTIONS(1482),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1482),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1482),
    [sym_preproc_directive] = ACTIONS(1482),
    [anon_sym_LPAREN2] = ACTIONS(1484),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_TILDE] = ACTIONS(1484),
    [anon_sym_DASH] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_STAR] = ACTIONS(1484),
    [anon_sym_AMP] = ACTIONS(1484),
    [anon_sym_SEMI] = ACTIONS(1484),
    [anon_sym___extension__] = ACTIONS(1482),
    [anon_sym_typedef] = ACTIONS(1482),
    [anon_sym_extern] = ACTIONS(1482),
    [anon_sym___attribute__] = ACTIONS(1482),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1484),
    [anon_sym___declspec] = ACTIONS(1482),
    [anon_sym___cdecl] = ACTIONS(1482),
    [anon_sym___clrcall] = ACTIONS(1482),
    [anon_sym___stdcall] = ACTIONS(1482),
    [anon_sym___fastcall] = ACTIONS(1482),
    [anon_sym___thiscall] = ACTIONS(1482),
    [anon_sym___vectorcall] = ACTIONS(1482),
    [anon_sym_LBRACE] = ACTIONS(1484),
    [anon_sym_signed] = ACTIONS(1482),
    [anon_sym_unsigned] = ACTIONS(1482),
    [anon_sym_long] = ACTIONS(1482),
    [anon_sym_short] = ACTIONS(1482),
    [anon_sym_static] = ACTIONS(1482),
    [anon_sym_auto] = ACTIONS(1482),
    [anon_sym_register] = ACTIONS(1482),
    [anon_sym_inline] = ACTIONS(1482),
    [anon_sym___inline] = ACTIONS(1482),
    [anon_sym___inline__] = ACTIONS(1482),
    [anon_sym___forceinline] = ACTIONS(1482),
    [anon_sym_thread_local] = ACTIONS(1482),
    [anon_sym___thread] = ACTIONS(1482),
    [anon_sym_const] = ACTIONS(1482),
    [anon_sym_constexpr] = ACTIONS(1482),
    [anon_sym_volatile] = ACTIONS(1482),
    [anon_sym_restrict] = ACTIONS(1482),
    [anon_sym___restrict__] = ACTIONS(1482),
    [anon_sym__Atomic] = ACTIONS(1482),
    [anon_sym__Noreturn] = ACTIONS(1482),
    [anon_sym_noreturn] = ACTIONS(1482),
    [sym_primitive_type] = ACTIONS(1482),
    [anon_sym_enum] = ACTIONS(1482),
    [anon_sym_struct] = ACTIONS(1482),
    [anon_sym_union] = ACTIONS(1482),
    [anon_sym_if] = ACTIONS(1482),
    [anon_sym_switch] = ACTIONS(1482),
    [anon_sym_case] = ACTIONS(1482),
    [anon_sym_default] = ACTIONS(1482),
    [anon_sym_while] = ACTIONS(1482),
    [anon_sym_do] = ACTIONS(1482),
    [anon_sym_for] = ACTIONS(1482),
    [anon_sym_return] = ACTIONS(1482),
    [anon_sym_break] = ACTIONS(1482),
    [anon_sym_continue] = ACTIONS(1482),
    [anon_sym_goto] = ACTIONS(1482),
    [anon_sym___try] = ACTIONS(1482),
    [anon_sym___leave] = ACTIONS(1482),
    [anon_sym_DASH_DASH] = ACTIONS(1484),
    [anon_sym_PLUS_PLUS] = ACTIONS(1484),
    [anon_sym_sizeof] = ACTIONS(1482),
    [anon_sym___alignof__] = ACTIONS(1482),
    [anon_sym___alignof] = ACTIONS(1482),
    [anon_sym__alignof] = ACTIONS(1482),
    [anon_sym_alignof] = ACTIONS(1482),
    [anon_sym__Alignof] = ACTIONS(1482),
    [anon_sym_offsetof] = ACTIONS(1482),
    [anon_sym__Generic] = ACTIONS(1482),
    [anon_sym_asm] = ACTIONS(1482),
    [anon_sym___asm__] = ACTIONS(1482),
    [sym_number_literal] = ACTIONS(1484),
    [anon_sym_L_SQUOTE] = ACTIONS(1484),
    [anon_sym_u_SQUOTE] = ACTIONS(1484),
    [anon_sym_U_SQUOTE] = ACTIONS(1484),
    [anon_sym_u8_SQUOTE] = ACTIONS(1484),
    [anon_sym_SQUOTE] = ACTIONS(1484),
    [anon_sym_L_DQUOTE] = ACTIONS(1484),
    [anon_sym_u_DQUOTE] = ACTIONS(1484),
    [anon_sym_U_DQUOTE] = ACTIONS(1484),
    [anon_sym_u8_DQUOTE] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(1484),
    [sym_true] = ACTIONS(1482),
    [sym_false] = ACTIONS(1482),
    [anon_sym_NULL] = ACTIONS(1482),
    [anon_sym_nullptr] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
  },
  [448] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(2395),
    [sym_attributed_statement] = STATE(2395),
    [sym_labeled_statement] = STATE(2395),
    [sym_expression_statement] = STATE(2395),
    [sym_if_statement] = STATE(2395),
    [sym_switch_statement] = STATE(2395),
    [sym_case_statement] = STATE(2395),
    [sym_while_statement] = STATE(2395),
    [sym_do_statement] = STATE(2395),
    [sym_for_statement] = STATE(2395),
    [sym_return_statement] = STATE(2395),
    [sym_break_statement] = STATE(2395),
    [sym_continue_statement] = STATE(2395),
    [sym_goto_statement] = STATE(2395),
    [sym_seh_try_statement] = STATE(2395),
    [sym_seh_leave_statement] = STATE(2395),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1566),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1278),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1568),
    [anon_sym_default] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1280),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1282),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1284),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [449] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(2387),
    [sym_attributed_statement] = STATE(2387),
    [sym_labeled_statement] = STATE(2387),
    [sym_expression_statement] = STATE(2387),
    [sym_if_statement] = STATE(2387),
    [sym_switch_statement] = STATE(2387),
    [sym_case_statement] = STATE(2387),
    [sym_while_statement] = STATE(2387),
    [sym_do_statement] = STATE(2387),
    [sym_for_statement] = STATE(2387),
    [sym_return_statement] = STATE(2387),
    [sym_break_statement] = STATE(2387),
    [sym_continue_statement] = STATE(2387),
    [sym_goto_statement] = STATE(2387),
    [sym_seh_try_statement] = STATE(2387),
    [sym_seh_leave_statement] = STATE(2387),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1566),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1278),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1568),
    [anon_sym_default] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1280),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1282),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1284),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [450] = {
    [sym_identifier] = ACTIONS(1466),
    [aux_sym_preproc_include_token1] = ACTIONS(1466),
    [aux_sym_preproc_def_token1] = ACTIONS(1466),
    [aux_sym_preproc_if_token1] = ACTIONS(1466),
    [aux_sym_preproc_if_token2] = ACTIONS(1466),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1466),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1466),
    [sym_preproc_directive] = ACTIONS(1466),
    [anon_sym_LPAREN2] = ACTIONS(1468),
    [anon_sym_BANG] = ACTIONS(1468),
    [anon_sym_TILDE] = ACTIONS(1468),
    [anon_sym_DASH] = ACTIONS(1466),
    [anon_sym_PLUS] = ACTIONS(1466),
    [anon_sym_STAR] = ACTIONS(1468),
    [anon_sym_AMP] = ACTIONS(1468),
    [anon_sym_SEMI] = ACTIONS(1468),
    [anon_sym___extension__] = ACTIONS(1466),
    [anon_sym_typedef] = ACTIONS(1466),
    [anon_sym_extern] = ACTIONS(1466),
    [anon_sym___attribute__] = ACTIONS(1466),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1468),
    [anon_sym___declspec] = ACTIONS(1466),
    [anon_sym___cdecl] = ACTIONS(1466),
    [anon_sym___clrcall] = ACTIONS(1466),
    [anon_sym___stdcall] = ACTIONS(1466),
    [anon_sym___fastcall] = ACTIONS(1466),
    [anon_sym___thiscall] = ACTIONS(1466),
    [anon_sym___vectorcall] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(1468),
    [anon_sym_signed] = ACTIONS(1466),
    [anon_sym_unsigned] = ACTIONS(1466),
    [anon_sym_long] = ACTIONS(1466),
    [anon_sym_short] = ACTIONS(1466),
    [anon_sym_static] = ACTIONS(1466),
    [anon_sym_auto] = ACTIONS(1466),
    [anon_sym_register] = ACTIONS(1466),
    [anon_sym_inline] = ACTIONS(1466),
    [anon_sym___inline] = ACTIONS(1466),
    [anon_sym___inline__] = ACTIONS(1466),
    [anon_sym___forceinline] = ACTIONS(1466),
    [anon_sym_thread_local] = ACTIONS(1466),
    [anon_sym___thread] = ACTIONS(1466),
    [anon_sym_const] = ACTIONS(1466),
    [anon_sym_constexpr] = ACTIONS(1466),
    [anon_sym_volatile] = ACTIONS(1466),
    [anon_sym_restrict] = ACTIONS(1466),
    [anon_sym___restrict__] = ACTIONS(1466),
    [anon_sym__Atomic] = ACTIONS(1466),
    [anon_sym__Noreturn] = ACTIONS(1466),
    [anon_sym_noreturn] = ACTIONS(1466),
    [sym_primitive_type] = ACTIONS(1466),
    [anon_sym_enum] = ACTIONS(1466),
    [anon_sym_struct] = ACTIONS(1466),
    [anon_sym_union] = ACTIONS(1466),
    [anon_sym_if] = ACTIONS(1466),
    [anon_sym_switch] = ACTIONS(1466),
    [anon_sym_case] = ACTIONS(1466),
    [anon_sym_default] = ACTIONS(1466),
    [anon_sym_while] = ACTIONS(1466),
    [anon_sym_do] = ACTIONS(1466),
    [anon_sym_for] = ACTIONS(1466),
    [anon_sym_return] = ACTIONS(1466),
    [anon_sym_break] = ACTIONS(1466),
    [anon_sym_continue] = ACTIONS(1466),
    [anon_sym_goto] = ACTIONS(1466),
    [anon_sym___try] = ACTIONS(1466),
    [anon_sym___leave] = ACTIONS(1466),
    [anon_sym_DASH_DASH] = ACTIONS(1468),
    [anon_sym_PLUS_PLUS] = ACTIONS(1468),
    [anon_sym_sizeof] = ACTIONS(1466),
    [anon_sym___alignof__] = ACTIONS(1466),
    [anon_sym___alignof] = ACTIONS(1466),
    [anon_sym__alignof] = ACTIONS(1466),
    [anon_sym_alignof] = ACTIONS(1466),
    [anon_sym__Alignof] = ACTIONS(1466),
    [anon_sym_offsetof] = ACTIONS(1466),
    [anon_sym__Generic] = ACTIONS(1466),
    [anon_sym_asm] = ACTIONS(1466),
    [anon_sym___asm__] = ACTIONS(1466),
    [sym_number_literal] = ACTIONS(1468),
    [anon_sym_L_SQUOTE] = ACTIONS(1468),
    [anon_sym_u_SQUOTE] = ACTIONS(1468),
    [anon_sym_U_SQUOTE] = ACTIONS(1468),
    [anon_sym_u8_SQUOTE] = ACTIONS(1468),
    [anon_sym_SQUOTE] = ACTIONS(1468),
    [anon_sym_L_DQUOTE] = ACTIONS(1468),
    [anon_sym_u_DQUOTE] = ACTIONS(1468),
    [anon_sym_U_DQUOTE] = ACTIONS(1468),
    [anon_sym_u8_DQUOTE] = ACTIONS(1468),
    [anon_sym_DQUOTE] = ACTIONS(1468),
    [sym_true] = ACTIONS(1466),
    [sym_false] = ACTIONS(1466),
    [anon_sym_NULL] = ACTIONS(1466),
    [anon_sym_nullptr] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
  },
  [451] = {
    [sym_identifier] = ACTIONS(1462),
    [aux_sym_preproc_include_token1] = ACTIONS(1462),
    [aux_sym_preproc_def_token1] = ACTIONS(1462),
    [aux_sym_preproc_if_token1] = ACTIONS(1462),
    [aux_sym_preproc_if_token2] = ACTIONS(1462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1462),
    [sym_preproc_directive] = ACTIONS(1462),
    [anon_sym_LPAREN2] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1464),
    [anon_sym_TILDE] = ACTIONS(1464),
    [anon_sym_DASH] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1462),
    [anon_sym_STAR] = ACTIONS(1464),
    [anon_sym_AMP] = ACTIONS(1464),
    [anon_sym_SEMI] = ACTIONS(1464),
    [anon_sym___extension__] = ACTIONS(1462),
    [anon_sym_typedef] = ACTIONS(1462),
    [anon_sym_extern] = ACTIONS(1462),
    [anon_sym___attribute__] = ACTIONS(1462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1464),
    [anon_sym___declspec] = ACTIONS(1462),
    [anon_sym___cdecl] = ACTIONS(1462),
    [anon_sym___clrcall] = ACTIONS(1462),
    [anon_sym___stdcall] = ACTIONS(1462),
    [anon_sym___fastcall] = ACTIONS(1462),
    [anon_sym___thiscall] = ACTIONS(1462),
    [anon_sym___vectorcall] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_signed] = ACTIONS(1462),
    [anon_sym_unsigned] = ACTIONS(1462),
    [anon_sym_long] = ACTIONS(1462),
    [anon_sym_short] = ACTIONS(1462),
    [anon_sym_static] = ACTIONS(1462),
    [anon_sym_auto] = ACTIONS(1462),
    [anon_sym_register] = ACTIONS(1462),
    [anon_sym_inline] = ACTIONS(1462),
    [anon_sym___inline] = ACTIONS(1462),
    [anon_sym___inline__] = ACTIONS(1462),
    [anon_sym___forceinline] = ACTIONS(1462),
    [anon_sym_thread_local] = ACTIONS(1462),
    [anon_sym___thread] = ACTIONS(1462),
    [anon_sym_const] = ACTIONS(1462),
    [anon_sym_constexpr] = ACTIONS(1462),
    [anon_sym_volatile] = ACTIONS(1462),
    [anon_sym_restrict] = ACTIONS(1462),
    [anon_sym___restrict__] = ACTIONS(1462),
    [anon_sym__Atomic] = ACTIONS(1462),
    [anon_sym__Noreturn] = ACTIONS(1462),
    [anon_sym_noreturn] = ACTIONS(1462),
    [sym_primitive_type] = ACTIONS(1462),
    [anon_sym_enum] = ACTIONS(1462),
    [anon_sym_struct] = ACTIONS(1462),
    [anon_sym_union] = ACTIONS(1462),
    [anon_sym_if] = ACTIONS(1462),
    [anon_sym_switch] = ACTIONS(1462),
    [anon_sym_case] = ACTIONS(1462),
    [anon_sym_default] = ACTIONS(1462),
    [anon_sym_while] = ACTIONS(1462),
    [anon_sym_do] = ACTIONS(1462),
    [anon_sym_for] = ACTIONS(1462),
    [anon_sym_return] = ACTIONS(1462),
    [anon_sym_break] = ACTIONS(1462),
    [anon_sym_continue] = ACTIONS(1462),
    [anon_sym_goto] = ACTIONS(1462),
    [anon_sym___try] = ACTIONS(1462),
    [anon_sym___leave] = ACTIONS(1462),
    [anon_sym_DASH_DASH] = ACTIONS(1464),
    [anon_sym_PLUS_PLUS] = ACTIONS(1464),
    [anon_sym_sizeof] = ACTIONS(1462),
    [anon_sym___alignof__] = ACTIONS(1462),
    [anon_sym___alignof] = ACTIONS(1462),
    [anon_sym__alignof] = ACTIONS(1462),
    [anon_sym_alignof] = ACTIONS(1462),
    [anon_sym__Alignof] = ACTIONS(1462),
    [anon_sym_offsetof] = ACTIONS(1462),
    [anon_sym__Generic] = ACTIONS(1462),
    [anon_sym_asm] = ACTIONS(1462),
    [anon_sym___asm__] = ACTIONS(1462),
    [sym_number_literal] = ACTIONS(1464),
    [anon_sym_L_SQUOTE] = ACTIONS(1464),
    [anon_sym_u_SQUOTE] = ACTIONS(1464),
    [anon_sym_U_SQUOTE] = ACTIONS(1464),
    [anon_sym_u8_SQUOTE] = ACTIONS(1464),
    [anon_sym_SQUOTE] = ACTIONS(1464),
    [anon_sym_L_DQUOTE] = ACTIONS(1464),
    [anon_sym_u_DQUOTE] = ACTIONS(1464),
    [anon_sym_U_DQUOTE] = ACTIONS(1464),
    [anon_sym_u8_DQUOTE] = ACTIONS(1464),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_true] = ACTIONS(1462),
    [sym_false] = ACTIONS(1462),
    [anon_sym_NULL] = ACTIONS(1462),
    [anon_sym_nullptr] = ACTIONS(1462),
    [sym_comment] = ACTIONS(3),
  },
  [452] = {
    [sym_identifier] = ACTIONS(1442),
    [aux_sym_preproc_include_token1] = ACTIONS(1442),
    [aux_sym_preproc_def_token1] = ACTIONS(1442),
    [aux_sym_preproc_if_token1] = ACTIONS(1442),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1442),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1442),
    [sym_preproc_directive] = ACTIONS(1442),
    [anon_sym_LPAREN2] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1444),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1444),
    [anon_sym___extension__] = ACTIONS(1442),
    [anon_sym_typedef] = ACTIONS(1442),
    [anon_sym_extern] = ACTIONS(1442),
    [anon_sym___attribute__] = ACTIONS(1442),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1444),
    [anon_sym___declspec] = ACTIONS(1442),
    [anon_sym___cdecl] = ACTIONS(1442),
    [anon_sym___clrcall] = ACTIONS(1442),
    [anon_sym___stdcall] = ACTIONS(1442),
    [anon_sym___fastcall] = ACTIONS(1442),
    [anon_sym___thiscall] = ACTIONS(1442),
    [anon_sym___vectorcall] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1444),
    [anon_sym_RBRACE] = ACTIONS(1444),
    [anon_sym_signed] = ACTIONS(1442),
    [anon_sym_unsigned] = ACTIONS(1442),
    [anon_sym_long] = ACTIONS(1442),
    [anon_sym_short] = ACTIONS(1442),
    [anon_sym_static] = ACTIONS(1442),
    [anon_sym_auto] = ACTIONS(1442),
    [anon_sym_register] = ACTIONS(1442),
    [anon_sym_inline] = ACTIONS(1442),
    [anon_sym___inline] = ACTIONS(1442),
    [anon_sym___inline__] = ACTIONS(1442),
    [anon_sym___forceinline] = ACTIONS(1442),
    [anon_sym_thread_local] = ACTIONS(1442),
    [anon_sym___thread] = ACTIONS(1442),
    [anon_sym_const] = ACTIONS(1442),
    [anon_sym_constexpr] = ACTIONS(1442),
    [anon_sym_volatile] = ACTIONS(1442),
    [anon_sym_restrict] = ACTIONS(1442),
    [anon_sym___restrict__] = ACTIONS(1442),
    [anon_sym__Atomic] = ACTIONS(1442),
    [anon_sym__Noreturn] = ACTIONS(1442),
    [anon_sym_noreturn] = ACTIONS(1442),
    [sym_primitive_type] = ACTIONS(1442),
    [anon_sym_enum] = ACTIONS(1442),
    [anon_sym_struct] = ACTIONS(1442),
    [anon_sym_union] = ACTIONS(1442),
    [anon_sym_if] = ACTIONS(1442),
    [anon_sym_switch] = ACTIONS(1442),
    [anon_sym_case] = ACTIONS(1442),
    [anon_sym_default] = ACTIONS(1442),
    [anon_sym_while] = ACTIONS(1442),
    [anon_sym_do] = ACTIONS(1442),
    [anon_sym_for] = ACTIONS(1442),
    [anon_sym_return] = ACTIONS(1442),
    [anon_sym_break] = ACTIONS(1442),
    [anon_sym_continue] = ACTIONS(1442),
    [anon_sym_goto] = ACTIONS(1442),
    [anon_sym___try] = ACTIONS(1442),
    [anon_sym___leave] = ACTIONS(1442),
    [anon_sym_DASH_DASH] = ACTIONS(1444),
    [anon_sym_PLUS_PLUS] = ACTIONS(1444),
    [anon_sym_sizeof] = ACTIONS(1442),
    [anon_sym___alignof__] = ACTIONS(1442),
    [anon_sym___alignof] = ACTIONS(1442),
    [anon_sym__alignof] = ACTIONS(1442),
    [anon_sym_alignof] = ACTIONS(1442),
    [anon_sym__Alignof] = ACTIONS(1442),
    [anon_sym_offsetof] = ACTIONS(1442),
    [anon_sym__Generic] = ACTIONS(1442),
    [anon_sym_asm] = ACTIONS(1442),
    [anon_sym___asm__] = ACTIONS(1442),
    [sym_number_literal] = ACTIONS(1444),
    [anon_sym_L_SQUOTE] = ACTIONS(1444),
    [anon_sym_u_SQUOTE] = ACTIONS(1444),
    [anon_sym_U_SQUOTE] = ACTIONS(1444),
    [anon_sym_u8_SQUOTE] = ACTIONS(1444),
    [anon_sym_SQUOTE] = ACTIONS(1444),
    [anon_sym_L_DQUOTE] = ACTIONS(1444),
    [anon_sym_u_DQUOTE] = ACTIONS(1444),
    [anon_sym_U_DQUOTE] = ACTIONS(1444),
    [anon_sym_u8_DQUOTE] = ACTIONS(1444),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [sym_true] = ACTIONS(1442),
    [sym_false] = ACTIONS(1442),
    [anon_sym_NULL] = ACTIONS(1442),
    [anon_sym_nullptr] = ACTIONS(1442),
    [sym_comment] = ACTIONS(3),
  },
  [453] = {
    [sym_identifier] = ACTIONS(1450),
    [aux_sym_preproc_include_token1] = ACTIONS(1450),
    [aux_sym_preproc_def_token1] = ACTIONS(1450),
    [aux_sym_preproc_if_token1] = ACTIONS(1450),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1450),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1450),
    [sym_preproc_directive] = ACTIONS(1450),
    [anon_sym_LPAREN2] = ACTIONS(1452),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_TILDE] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1450),
    [anon_sym_PLUS] = ACTIONS(1450),
    [anon_sym_STAR] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1452),
    [anon_sym_SEMI] = ACTIONS(1452),
    [anon_sym___extension__] = ACTIONS(1450),
    [anon_sym_typedef] = ACTIONS(1450),
    [anon_sym_extern] = ACTIONS(1450),
    [anon_sym___attribute__] = ACTIONS(1450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1452),
    [anon_sym___declspec] = ACTIONS(1450),
    [anon_sym___cdecl] = ACTIONS(1450),
    [anon_sym___clrcall] = ACTIONS(1450),
    [anon_sym___stdcall] = ACTIONS(1450),
    [anon_sym___fastcall] = ACTIONS(1450),
    [anon_sym___thiscall] = ACTIONS(1450),
    [anon_sym___vectorcall] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(1452),
    [anon_sym_RBRACE] = ACTIONS(1452),
    [anon_sym_signed] = ACTIONS(1450),
    [anon_sym_unsigned] = ACTIONS(1450),
    [anon_sym_long] = ACTIONS(1450),
    [anon_sym_short] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(1450),
    [anon_sym_auto] = ACTIONS(1450),
    [anon_sym_register] = ACTIONS(1450),
    [anon_sym_inline] = ACTIONS(1450),
    [anon_sym___inline] = ACTIONS(1450),
    [anon_sym___inline__] = ACTIONS(1450),
    [anon_sym___forceinline] = ACTIONS(1450),
    [anon_sym_thread_local] = ACTIONS(1450),
    [anon_sym___thread] = ACTIONS(1450),
    [anon_sym_const] = ACTIONS(1450),
    [anon_sym_constexpr] = ACTIONS(1450),
    [anon_sym_volatile] = ACTIONS(1450),
    [anon_sym_restrict] = ACTIONS(1450),
    [anon_sym___restrict__] = ACTIONS(1450),
    [anon_sym__Atomic] = ACTIONS(1450),
    [anon_sym__Noreturn] = ACTIONS(1450),
    [anon_sym_noreturn] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(1450),
    [anon_sym_enum] = ACTIONS(1450),
    [anon_sym_struct] = ACTIONS(1450),
    [anon_sym_union] = ACTIONS(1450),
    [anon_sym_if] = ACTIONS(1450),
    [anon_sym_switch] = ACTIONS(1450),
    [anon_sym_case] = ACTIONS(1450),
    [anon_sym_default] = ACTIONS(1450),
    [anon_sym_while] = ACTIONS(1450),
    [anon_sym_do] = ACTIONS(1450),
    [anon_sym_for] = ACTIONS(1450),
    [anon_sym_return] = ACTIONS(1450),
    [anon_sym_break] = ACTIONS(1450),
    [anon_sym_continue] = ACTIONS(1450),
    [anon_sym_goto] = ACTIONS(1450),
    [anon_sym___try] = ACTIONS(1450),
    [anon_sym___leave] = ACTIONS(1450),
    [anon_sym_DASH_DASH] = ACTIONS(1452),
    [anon_sym_PLUS_PLUS] = ACTIONS(1452),
    [anon_sym_sizeof] = ACTIONS(1450),
    [anon_sym___alignof__] = ACTIONS(1450),
    [anon_sym___alignof] = ACTIONS(1450),
    [anon_sym__alignof] = ACTIONS(1450),
    [anon_sym_alignof] = ACTIONS(1450),
    [anon_sym__Alignof] = ACTIONS(1450),
    [anon_sym_offsetof] = ACTIONS(1450),
    [anon_sym__Generic] = ACTIONS(1450),
    [anon_sym_asm] = ACTIONS(1450),
    [anon_sym___asm__] = ACTIONS(1450),
    [sym_number_literal] = ACTIONS(1452),
    [anon_sym_L_SQUOTE] = ACTIONS(1452),
    [anon_sym_u_SQUOTE] = ACTIONS(1452),
    [anon_sym_U_SQUOTE] = ACTIONS(1452),
    [anon_sym_u8_SQUOTE] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [anon_sym_L_DQUOTE] = ACTIONS(1452),
    [anon_sym_u_DQUOTE] = ACTIONS(1452),
    [anon_sym_U_DQUOTE] = ACTIONS(1452),
    [anon_sym_u8_DQUOTE] = ACTIONS(1452),
    [anon_sym_DQUOTE] = ACTIONS(1452),
    [sym_true] = ACTIONS(1450),
    [sym_false] = ACTIONS(1450),
    [anon_sym_NULL] = ACTIONS(1450),
    [anon_sym_nullptr] = ACTIONS(1450),
    [sym_comment] = ACTIONS(3),
  },
  [454] = {
    [sym_attribute_declaration] = STATE(473),
    [sym_compound_statement] = STATE(350),
    [sym_attributed_statement] = STATE(350),
    [sym_labeled_statement] = STATE(350),
    [sym_expression_statement] = STATE(350),
    [sym_if_statement] = STATE(350),
    [sym_switch_statement] = STATE(350),
    [sym_case_statement] = STATE(350),
    [sym_while_statement] = STATE(350),
    [sym_do_statement] = STATE(350),
    [sym_for_statement] = STATE(350),
    [sym_return_statement] = STATE(350),
    [sym_break_statement] = STATE(350),
    [sym_continue_statement] = STATE(350),
    [sym_goto_statement] = STATE(350),
    [sym_seh_try_statement] = STATE(350),
    [sym_seh_leave_statement] = STATE(350),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(473),
    [sym_identifier] = ACTIONS(1770),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [455] = {
    [sym_attribute_declaration] = STATE(454),
    [sym_compound_statement] = STATE(243),
    [sym_attributed_statement] = STATE(243),
    [sym_labeled_statement] = STATE(243),
    [sym_expression_statement] = STATE(243),
    [sym_if_statement] = STATE(243),
    [sym_switch_statement] = STATE(243),
    [sym_case_statement] = STATE(243),
    [sym_while_statement] = STATE(243),
    [sym_do_statement] = STATE(243),
    [sym_for_statement] = STATE(243),
    [sym_return_statement] = STATE(243),
    [sym_break_statement] = STATE(243),
    [sym_continue_statement] = STATE(243),
    [sym_goto_statement] = STATE(243),
    [sym_seh_try_statement] = STATE(243),
    [sym_seh_leave_statement] = STATE(243),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [sym_identifier] = ACTIONS(1770),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [456] = {
    [sym_identifier] = ACTIONS(1498),
    [aux_sym_preproc_include_token1] = ACTIONS(1498),
    [aux_sym_preproc_def_token1] = ACTIONS(1498),
    [aux_sym_preproc_if_token1] = ACTIONS(1498),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1498),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1498),
    [sym_preproc_directive] = ACTIONS(1498),
    [anon_sym_LPAREN2] = ACTIONS(1500),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_TILDE] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1498),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_SEMI] = ACTIONS(1500),
    [anon_sym___extension__] = ACTIONS(1498),
    [anon_sym_typedef] = ACTIONS(1498),
    [anon_sym_extern] = ACTIONS(1498),
    [anon_sym___attribute__] = ACTIONS(1498),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1500),
    [anon_sym___declspec] = ACTIONS(1498),
    [anon_sym___cdecl] = ACTIONS(1498),
    [anon_sym___clrcall] = ACTIONS(1498),
    [anon_sym___stdcall] = ACTIONS(1498),
    [anon_sym___fastcall] = ACTIONS(1498),
    [anon_sym___thiscall] = ACTIONS(1498),
    [anon_sym___vectorcall] = ACTIONS(1498),
    [anon_sym_LBRACE] = ACTIONS(1500),
    [anon_sym_RBRACE] = ACTIONS(1500),
    [anon_sym_signed] = ACTIONS(1498),
    [anon_sym_unsigned] = ACTIONS(1498),
    [anon_sym_long] = ACTIONS(1498),
    [anon_sym_short] = ACTIONS(1498),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_auto] = ACTIONS(1498),
    [anon_sym_register] = ACTIONS(1498),
    [anon_sym_inline] = ACTIONS(1498),
    [anon_sym___inline] = ACTIONS(1498),
    [anon_sym___inline__] = ACTIONS(1498),
    [anon_sym___forceinline] = ACTIONS(1498),
    [anon_sym_thread_local] = ACTIONS(1498),
    [anon_sym___thread] = ACTIONS(1498),
    [anon_sym_const] = ACTIONS(1498),
    [anon_sym_constexpr] = ACTIONS(1498),
    [anon_sym_volatile] = ACTIONS(1498),
    [anon_sym_restrict] = ACTIONS(1498),
    [anon_sym___restrict__] = ACTIONS(1498),
    [anon_sym__Atomic] = ACTIONS(1498),
    [anon_sym__Noreturn] = ACTIONS(1498),
    [anon_sym_noreturn] = ACTIONS(1498),
    [sym_primitive_type] = ACTIONS(1498),
    [anon_sym_enum] = ACTIONS(1498),
    [anon_sym_struct] = ACTIONS(1498),
    [anon_sym_union] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1498),
    [anon_sym_switch] = ACTIONS(1498),
    [anon_sym_case] = ACTIONS(1498),
    [anon_sym_default] = ACTIONS(1498),
    [anon_sym_while] = ACTIONS(1498),
    [anon_sym_do] = ACTIONS(1498),
    [anon_sym_for] = ACTIONS(1498),
    [anon_sym_return] = ACTIONS(1498),
    [anon_sym_break] = ACTIONS(1498),
    [anon_sym_continue] = ACTIONS(1498),
    [anon_sym_goto] = ACTIONS(1498),
    [anon_sym___try] = ACTIONS(1498),
    [anon_sym___leave] = ACTIONS(1498),
    [anon_sym_DASH_DASH] = ACTIONS(1500),
    [anon_sym_PLUS_PLUS] = ACTIONS(1500),
    [anon_sym_sizeof] = ACTIONS(1498),
    [anon_sym___alignof__] = ACTIONS(1498),
    [anon_sym___alignof] = ACTIONS(1498),
    [anon_sym__alignof] = ACTIONS(1498),
    [anon_sym_alignof] = ACTIONS(1498),
    [anon_sym__Alignof] = ACTIONS(1498),
    [anon_sym_offsetof] = ACTIONS(1498),
    [anon_sym__Generic] = ACTIONS(1498),
    [anon_sym_asm] = ACTIONS(1498),
    [anon_sym___asm__] = ACTIONS(1498),
    [sym_number_literal] = ACTIONS(1500),
    [anon_sym_L_SQUOTE] = ACTIONS(1500),
    [anon_sym_u_SQUOTE] = ACTIONS(1500),
    [anon_sym_U_SQUOTE] = ACTIONS(1500),
    [anon_sym_u8_SQUOTE] = ACTIONS(1500),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_L_DQUOTE] = ACTIONS(1500),
    [anon_sym_u_DQUOTE] = ACTIONS(1500),
    [anon_sym_U_DQUOTE] = ACTIONS(1500),
    [anon_sym_u8_DQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE] = ACTIONS(1500),
    [sym_true] = ACTIONS(1498),
    [sym_false] = ACTIONS(1498),
    [anon_sym_NULL] = ACTIONS(1498),
    [anon_sym_nullptr] = ACTIONS(1498),
    [sym_comment] = ACTIONS(3),
  },
  [457] = {
    [sym_attribute_declaration] = STATE(454),
    [sym_compound_statement] = STATE(322),
    [sym_attributed_statement] = STATE(322),
    [sym_labeled_statement] = STATE(322),
    [sym_expression_statement] = STATE(322),
    [sym_if_statement] = STATE(322),
    [sym_switch_statement] = STATE(322),
    [sym_case_statement] = STATE(322),
    [sym_while_statement] = STATE(322),
    [sym_do_statement] = STATE(322),
    [sym_for_statement] = STATE(322),
    [sym_return_statement] = STATE(322),
    [sym_break_statement] = STATE(322),
    [sym_continue_statement] = STATE(322),
    [sym_goto_statement] = STATE(322),
    [sym_seh_try_statement] = STATE(322),
    [sym_seh_leave_statement] = STATE(322),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [sym_identifier] = ACTIONS(1770),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [458] = {
    [sym_attribute_declaration] = STATE(411),
    [sym_compound_statement] = STATE(189),
    [sym_attributed_statement] = STATE(189),
    [sym_labeled_statement] = STATE(189),
    [sym_expression_statement] = STATE(189),
    [sym_if_statement] = STATE(189),
    [sym_switch_statement] = STATE(189),
    [sym_case_statement] = STATE(189),
    [sym_while_statement] = STATE(189),
    [sym_do_statement] = STATE(189),
    [sym_for_statement] = STATE(189),
    [sym_return_statement] = STATE(189),
    [sym_break_statement] = STATE(189),
    [sym_continue_statement] = STATE(189),
    [sym_goto_statement] = STATE(189),
    [sym_seh_try_statement] = STATE(189),
    [sym_seh_leave_statement] = STATE(189),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [sym_identifier] = ACTIONS(1562),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [459] = {
    [sym_attribute_declaration] = STATE(454),
    [sym_compound_statement] = STATE(306),
    [sym_attributed_statement] = STATE(306),
    [sym_labeled_statement] = STATE(306),
    [sym_expression_statement] = STATE(306),
    [sym_if_statement] = STATE(306),
    [sym_switch_statement] = STATE(306),
    [sym_case_statement] = STATE(306),
    [sym_while_statement] = STATE(306),
    [sym_do_statement] = STATE(306),
    [sym_for_statement] = STATE(306),
    [sym_return_statement] = STATE(306),
    [sym_break_statement] = STATE(306),
    [sym_continue_statement] = STATE(306),
    [sym_goto_statement] = STATE(306),
    [sym_seh_try_statement] = STATE(306),
    [sym_seh_leave_statement] = STATE(306),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [sym_identifier] = ACTIONS(1770),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [460] = {
    [sym_identifier] = ACTIONS(1422),
    [aux_sym_preproc_include_token1] = ACTIONS(1422),
    [aux_sym_preproc_def_token1] = ACTIONS(1422),
    [aux_sym_preproc_if_token1] = ACTIONS(1422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1422),
    [sym_preproc_directive] = ACTIONS(1422),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(1424),
    [anon_sym_TILDE] = ACTIONS(1424),
    [anon_sym_DASH] = ACTIONS(1422),
    [anon_sym_PLUS] = ACTIONS(1422),
    [anon_sym_STAR] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym___extension__] = ACTIONS(1422),
    [anon_sym_typedef] = ACTIONS(1422),
    [anon_sym_extern] = ACTIONS(1422),
    [anon_sym___attribute__] = ACTIONS(1422),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1424),
    [anon_sym___declspec] = ACTIONS(1422),
    [anon_sym___cdecl] = ACTIONS(1422),
    [anon_sym___clrcall] = ACTIONS(1422),
    [anon_sym___stdcall] = ACTIONS(1422),
    [anon_sym___fastcall] = ACTIONS(1422),
    [anon_sym___thiscall] = ACTIONS(1422),
    [anon_sym___vectorcall] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(1424),
    [anon_sym_RBRACE] = ACTIONS(1424),
    [anon_sym_signed] = ACTIONS(1422),
    [anon_sym_unsigned] = ACTIONS(1422),
    [anon_sym_long] = ACTIONS(1422),
    [anon_sym_short] = ACTIONS(1422),
    [anon_sym_static] = ACTIONS(1422),
    [anon_sym_auto] = ACTIONS(1422),
    [anon_sym_register] = ACTIONS(1422),
    [anon_sym_inline] = ACTIONS(1422),
    [anon_sym___inline] = ACTIONS(1422),
    [anon_sym___inline__] = ACTIONS(1422),
    [anon_sym___forceinline] = ACTIONS(1422),
    [anon_sym_thread_local] = ACTIONS(1422),
    [anon_sym___thread] = ACTIONS(1422),
    [anon_sym_const] = ACTIONS(1422),
    [anon_sym_constexpr] = ACTIONS(1422),
    [anon_sym_volatile] = ACTIONS(1422),
    [anon_sym_restrict] = ACTIONS(1422),
    [anon_sym___restrict__] = ACTIONS(1422),
    [anon_sym__Atomic] = ACTIONS(1422),
    [anon_sym__Noreturn] = ACTIONS(1422),
    [anon_sym_noreturn] = ACTIONS(1422),
    [sym_primitive_type] = ACTIONS(1422),
    [anon_sym_enum] = ACTIONS(1422),
    [anon_sym_struct] = ACTIONS(1422),
    [anon_sym_union] = ACTIONS(1422),
    [anon_sym_if] = ACTIONS(1422),
    [anon_sym_switch] = ACTIONS(1422),
    [anon_sym_case] = ACTIONS(1422),
    [anon_sym_default] = ACTIONS(1422),
    [anon_sym_while] = ACTIONS(1422),
    [anon_sym_do] = ACTIONS(1422),
    [anon_sym_for] = ACTIONS(1422),
    [anon_sym_return] = ACTIONS(1422),
    [anon_sym_break] = ACTIONS(1422),
    [anon_sym_continue] = ACTIONS(1422),
    [anon_sym_goto] = ACTIONS(1422),
    [anon_sym___try] = ACTIONS(1422),
    [anon_sym___leave] = ACTIONS(1422),
    [anon_sym_DASH_DASH] = ACTIONS(1424),
    [anon_sym_PLUS_PLUS] = ACTIONS(1424),
    [anon_sym_sizeof] = ACTIONS(1422),
    [anon_sym___alignof__] = ACTIONS(1422),
    [anon_sym___alignof] = ACTIONS(1422),
    [anon_sym__alignof] = ACTIONS(1422),
    [anon_sym_alignof] = ACTIONS(1422),
    [anon_sym__Alignof] = ACTIONS(1422),
    [anon_sym_offsetof] = ACTIONS(1422),
    [anon_sym__Generic] = ACTIONS(1422),
    [anon_sym_asm] = ACTIONS(1422),
    [anon_sym___asm__] = ACTIONS(1422),
    [sym_number_literal] = ACTIONS(1424),
    [anon_sym_L_SQUOTE] = ACTIONS(1424),
    [anon_sym_u_SQUOTE] = ACTIONS(1424),
    [anon_sym_U_SQUOTE] = ACTIONS(1424),
    [anon_sym_u8_SQUOTE] = ACTIONS(1424),
    [anon_sym_SQUOTE] = ACTIONS(1424),
    [anon_sym_L_DQUOTE] = ACTIONS(1424),
    [anon_sym_u_DQUOTE] = ACTIONS(1424),
    [anon_sym_U_DQUOTE] = ACTIONS(1424),
    [anon_sym_u8_DQUOTE] = ACTIONS(1424),
    [anon_sym_DQUOTE] = ACTIONS(1424),
    [sym_true] = ACTIONS(1422),
    [sym_false] = ACTIONS(1422),
    [anon_sym_NULL] = ACTIONS(1422),
    [anon_sym_nullptr] = ACTIONS(1422),
    [sym_comment] = ACTIONS(3),
  },
  [461] = {
    [sym_attribute_declaration] = STATE(432),
    [sym_compound_statement] = STATE(90),
    [sym_attributed_statement] = STATE(90),
    [sym_labeled_statement] = STATE(90),
    [sym_expression_statement] = STATE(90),
    [sym_if_statement] = STATE(90),
    [sym_switch_statement] = STATE(90),
    [sym_case_statement] = STATE(90),
    [sym_while_statement] = STATE(90),
    [sym_do_statement] = STATE(90),
    [sym_for_statement] = STATE(90),
    [sym_return_statement] = STATE(90),
    [sym_break_statement] = STATE(90),
    [sym_continue_statement] = STATE(90),
    [sym_goto_statement] = STATE(90),
    [sym_seh_try_statement] = STATE(90),
    [sym_seh_leave_statement] = STATE(90),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(432),
    [sym_identifier] = ACTIONS(1720),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_do] = ACTIONS(141),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_continue] = ACTIONS(149),
    [anon_sym_goto] = ACTIONS(151),
    [anon_sym___try] = ACTIONS(153),
    [anon_sym___leave] = ACTIONS(155),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [462] = {
    [sym_attribute_declaration] = STATE(432),
    [sym_compound_statement] = STATE(110),
    [sym_attributed_statement] = STATE(110),
    [sym_labeled_statement] = STATE(110),
    [sym_expression_statement] = STATE(110),
    [sym_if_statement] = STATE(110),
    [sym_switch_statement] = STATE(110),
    [sym_case_statement] = STATE(110),
    [sym_while_statement] = STATE(110),
    [sym_do_statement] = STATE(110),
    [sym_for_statement] = STATE(110),
    [sym_return_statement] = STATE(110),
    [sym_break_statement] = STATE(110),
    [sym_continue_statement] = STATE(110),
    [sym_goto_statement] = STATE(110),
    [sym_seh_try_statement] = STATE(110),
    [sym_seh_leave_statement] = STATE(110),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(432),
    [sym_identifier] = ACTIONS(1720),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_do] = ACTIONS(141),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_continue] = ACTIONS(149),
    [anon_sym_goto] = ACTIONS(151),
    [anon_sym___try] = ACTIONS(153),
    [anon_sym___leave] = ACTIONS(155),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [463] = {
    [sym_attribute_declaration] = STATE(423),
    [sym_compound_statement] = STATE(301),
    [sym_attributed_statement] = STATE(301),
    [sym_labeled_statement] = STATE(301),
    [sym_expression_statement] = STATE(301),
    [sym_if_statement] = STATE(301),
    [sym_switch_statement] = STATE(301),
    [sym_case_statement] = STATE(301),
    [sym_while_statement] = STATE(301),
    [sym_do_statement] = STATE(301),
    [sym_for_statement] = STATE(301),
    [sym_return_statement] = STATE(301),
    [sym_break_statement] = STATE(301),
    [sym_continue_statement] = STATE(301),
    [sym_goto_statement] = STATE(301),
    [sym_seh_try_statement] = STATE(301),
    [sym_seh_leave_statement] = STATE(301),
    [sym__expression] = STATE(1348),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2343),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(1574),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1101),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_default] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1103),
    [anon_sym___leave] = ACTIONS(1105),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [464] = {
    [sym_identifier] = ACTIONS(1438),
    [aux_sym_preproc_include_token1] = ACTIONS(1438),
    [aux_sym_preproc_def_token1] = ACTIONS(1438),
    [aux_sym_preproc_if_token1] = ACTIONS(1438),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1438),
    [sym_preproc_directive] = ACTIONS(1438),
    [anon_sym_LPAREN2] = ACTIONS(1440),
    [anon_sym_BANG] = ACTIONS(1440),
    [anon_sym_TILDE] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1438),
    [anon_sym_PLUS] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_SEMI] = ACTIONS(1440),
    [anon_sym___extension__] = ACTIONS(1438),
    [anon_sym_typedef] = ACTIONS(1438),
    [anon_sym_extern] = ACTIONS(1438),
    [anon_sym___attribute__] = ACTIONS(1438),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1440),
    [anon_sym___declspec] = ACTIONS(1438),
    [anon_sym___cdecl] = ACTIONS(1438),
    [anon_sym___clrcall] = ACTIONS(1438),
    [anon_sym___stdcall] = ACTIONS(1438),
    [anon_sym___fastcall] = ACTIONS(1438),
    [anon_sym___thiscall] = ACTIONS(1438),
    [anon_sym___vectorcall] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(1440),
    [anon_sym_RBRACE] = ACTIONS(1440),
    [anon_sym_signed] = ACTIONS(1438),
    [anon_sym_unsigned] = ACTIONS(1438),
    [anon_sym_long] = ACTIONS(1438),
    [anon_sym_short] = ACTIONS(1438),
    [anon_sym_static] = ACTIONS(1438),
    [anon_sym_auto] = ACTIONS(1438),
    [anon_sym_register] = ACTIONS(1438),
    [anon_sym_inline] = ACTIONS(1438),
    [anon_sym___inline] = ACTIONS(1438),
    [anon_sym___inline__] = ACTIONS(1438),
    [anon_sym___forceinline] = ACTIONS(1438),
    [anon_sym_thread_local] = ACTIONS(1438),
    [anon_sym___thread] = ACTIONS(1438),
    [anon_sym_const] = ACTIONS(1438),
    [anon_sym_constexpr] = ACTIONS(1438),
    [anon_sym_volatile] = ACTIONS(1438),
    [anon_sym_restrict] = ACTIONS(1438),
    [anon_sym___restrict__] = ACTIONS(1438),
    [anon_sym__Atomic] = ACTIONS(1438),
    [anon_sym__Noreturn] = ACTIONS(1438),
    [anon_sym_noreturn] = ACTIONS(1438),
    [sym_primitive_type] = ACTIONS(1438),
    [anon_sym_enum] = ACTIONS(1438),
    [anon_sym_struct] = ACTIONS(1438),
    [anon_sym_union] = ACTIONS(1438),
    [anon_sym_if] = ACTIONS(1438),
    [anon_sym_switch] = ACTIONS(1438),
    [anon_sym_case] = ACTIONS(1438),
    [anon_sym_default] = ACTIONS(1438),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_do] = ACTIONS(1438),
    [anon_sym_for] = ACTIONS(1438),
    [anon_sym_return] = ACTIONS(1438),
    [anon_sym_break] = ACTIONS(1438),
    [anon_sym_continue] = ACTIONS(1438),
    [anon_sym_goto] = ACTIONS(1438),
    [anon_sym___try] = ACTIONS(1438),
    [anon_sym___leave] = ACTIONS(1438),
    [anon_sym_DASH_DASH] = ACTIONS(1440),
    [anon_sym_PLUS_PLUS] = ACTIONS(1440),
    [anon_sym_sizeof] = ACTIONS(1438),
    [anon_sym___alignof__] = ACTIONS(1438),
    [anon_sym___alignof] = ACTIONS(1438),
    [anon_sym__alignof] = ACTIONS(1438),
    [anon_sym_alignof] = ACTIONS(1438),
    [anon_sym__Alignof] = ACTIONS(1438),
    [anon_sym_offsetof] = ACTIONS(1438),
    [anon_sym__Generic] = ACTIONS(1438),
    [anon_sym_asm] = ACTIONS(1438),
    [anon_sym___asm__] = ACTIONS(1438),
    [sym_number_literal] = ACTIONS(1440),
    [anon_sym_L_SQUOTE] = ACTIONS(1440),
    [anon_sym_u_SQUOTE] = ACTIONS(1440),
    [anon_sym_U_SQUOTE] = ACTIONS(1440),
    [anon_sym_u8_SQUOTE] = ACTIONS(1440),
    [anon_sym_SQUOTE] = ACTIONS(1440),
    [anon_sym_L_DQUOTE] = ACTIONS(1440),
    [anon_sym_u_DQUOTE] = ACTIONS(1440),
    [anon_sym_U_DQUOTE] = ACTIONS(1440),
    [anon_sym_u8_DQUOTE] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [sym_true] = ACTIONS(1438),
    [sym_false] = ACTIONS(1438),
    [anon_sym_NULL] = ACTIONS(1438),
    [anon_sym_nullptr] = ACTIONS(1438),
    [sym_comment] = ACTIONS(3),
  },
  [465] = {
    [sym_identifier] = ACTIONS(1458),
    [aux_sym_preproc_include_token1] = ACTIONS(1458),
    [aux_sym_preproc_def_token1] = ACTIONS(1458),
    [aux_sym_preproc_if_token1] = ACTIONS(1458),
    [aux_sym_preproc_if_token2] = ACTIONS(1458),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1458),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1458),
    [sym_preproc_directive] = ACTIONS(1458),
    [anon_sym_LPAREN2] = ACTIONS(1460),
    [anon_sym_BANG] = ACTIONS(1460),
    [anon_sym_TILDE] = ACTIONS(1460),
    [anon_sym_DASH] = ACTIONS(1458),
    [anon_sym_PLUS] = ACTIONS(1458),
    [anon_sym_STAR] = ACTIONS(1460),
    [anon_sym_AMP] = ACTIONS(1460),
    [anon_sym_SEMI] = ACTIONS(1460),
    [anon_sym___extension__] = ACTIONS(1458),
    [anon_sym_typedef] = ACTIONS(1458),
    [anon_sym_extern] = ACTIONS(1458),
    [anon_sym___attribute__] = ACTIONS(1458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1460),
    [anon_sym___declspec] = ACTIONS(1458),
    [anon_sym___cdecl] = ACTIONS(1458),
    [anon_sym___clrcall] = ACTIONS(1458),
    [anon_sym___stdcall] = ACTIONS(1458),
    [anon_sym___fastcall] = ACTIONS(1458),
    [anon_sym___thiscall] = ACTIONS(1458),
    [anon_sym___vectorcall] = ACTIONS(1458),
    [anon_sym_LBRACE] = ACTIONS(1460),
    [anon_sym_signed] = ACTIONS(1458),
    [anon_sym_unsigned] = ACTIONS(1458),
    [anon_sym_long] = ACTIONS(1458),
    [anon_sym_short] = ACTIONS(1458),
    [anon_sym_static] = ACTIONS(1458),
    [anon_sym_auto] = ACTIONS(1458),
    [anon_sym_register] = ACTIONS(1458),
    [anon_sym_inline] = ACTIONS(1458),
    [anon_sym___inline] = ACTIONS(1458),
    [anon_sym___inline__] = ACTIONS(1458),
    [anon_sym___forceinline] = ACTIONS(1458),
    [anon_sym_thread_local] = ACTIONS(1458),
    [anon_sym___thread] = ACTIONS(1458),
    [anon_sym_const] = ACTIONS(1458),
    [anon_sym_constexpr] = ACTIONS(1458),
    [anon_sym_volatile] = ACTIONS(1458),
    [anon_sym_restrict] = ACTIONS(1458),
    [anon_sym___restrict__] = ACTIONS(1458),
    [anon_sym__Atomic] = ACTIONS(1458),
    [anon_sym__Noreturn] = ACTIONS(1458),
    [anon_sym_noreturn] = ACTIONS(1458),
    [sym_primitive_type] = ACTIONS(1458),
    [anon_sym_enum] = ACTIONS(1458),
    [anon_sym_struct] = ACTIONS(1458),
    [anon_sym_union] = ACTIONS(1458),
    [anon_sym_if] = ACTIONS(1458),
    [anon_sym_switch] = ACTIONS(1458),
    [anon_sym_case] = ACTIONS(1458),
    [anon_sym_default] = ACTIONS(1458),
    [anon_sym_while] = ACTIONS(1458),
    [anon_sym_do] = ACTIONS(1458),
    [anon_sym_for] = ACTIONS(1458),
    [anon_sym_return] = ACTIONS(1458),
    [anon_sym_break] = ACTIONS(1458),
    [anon_sym_continue] = ACTIONS(1458),
    [anon_sym_goto] = ACTIONS(1458),
    [anon_sym___try] = ACTIONS(1458),
    [anon_sym___leave] = ACTIONS(1458),
    [anon_sym_DASH_DASH] = ACTIONS(1460),
    [anon_sym_PLUS_PLUS] = ACTIONS(1460),
    [anon_sym_sizeof] = ACTIONS(1458),
    [anon_sym___alignof__] = ACTIONS(1458),
    [anon_sym___alignof] = ACTIONS(1458),
    [anon_sym__alignof] = ACTIONS(1458),
    [anon_sym_alignof] = ACTIONS(1458),
    [anon_sym__Alignof] = ACTIONS(1458),
    [anon_sym_offsetof] = ACTIONS(1458),
    [anon_sym__Generic] = ACTIONS(1458),
    [anon_sym_asm] = ACTIONS(1458),
    [anon_sym___asm__] = ACTIONS(1458),
    [sym_number_literal] = ACTIONS(1460),
    [anon_sym_L_SQUOTE] = ACTIONS(1460),
    [anon_sym_u_SQUOTE] = ACTIONS(1460),
    [anon_sym_U_SQUOTE] = ACTIONS(1460),
    [anon_sym_u8_SQUOTE] = ACTIONS(1460),
    [anon_sym_SQUOTE] = ACTIONS(1460),
    [anon_sym_L_DQUOTE] = ACTIONS(1460),
    [anon_sym_u_DQUOTE] = ACTIONS(1460),
    [anon_sym_U_DQUOTE] = ACTIONS(1460),
    [anon_sym_u8_DQUOTE] = ACTIONS(1460),
    [anon_sym_DQUOTE] = ACTIONS(1460),
    [sym_true] = ACTIONS(1458),
    [sym_false] = ACTIONS(1458),
    [anon_sym_NULL] = ACTIONS(1458),
    [anon_sym_nullptr] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
  },
  [466] = {
    [sym_attribute_declaration] = STATE(411),
    [sym_compound_statement] = STATE(171),
    [sym_attributed_statement] = STATE(171),
    [sym_labeled_statement] = STATE(171),
    [sym_expression_statement] = STATE(171),
    [sym_if_statement] = STATE(171),
    [sym_switch_statement] = STATE(171),
    [sym_case_statement] = STATE(171),
    [sym_while_statement] = STATE(171),
    [sym_do_statement] = STATE(171),
    [sym_for_statement] = STATE(171),
    [sym_return_statement] = STATE(171),
    [sym_break_statement] = STATE(171),
    [sym_continue_statement] = STATE(171),
    [sym_goto_statement] = STATE(171),
    [sym_seh_try_statement] = STATE(171),
    [sym_seh_leave_statement] = STATE(171),
    [sym__expression] = STATE(1342),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2315),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(411),
    [sym_identifier] = ACTIONS(1562),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_switch] = ACTIONS(205),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(209),
    [anon_sym_while] = ACTIONS(211),
    [anon_sym_do] = ACTIONS(213),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_continue] = ACTIONS(221),
    [anon_sym_goto] = ACTIONS(223),
    [anon_sym___try] = ACTIONS(225),
    [anon_sym___leave] = ACTIONS(227),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [467] = {
    [sym_identifier] = ACTIONS(1434),
    [aux_sym_preproc_include_token1] = ACTIONS(1434),
    [aux_sym_preproc_def_token1] = ACTIONS(1434),
    [aux_sym_preproc_if_token1] = ACTIONS(1434),
    [aux_sym_preproc_if_token2] = ACTIONS(1434),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1434),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1434),
    [sym_preproc_directive] = ACTIONS(1434),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(1436),
    [anon_sym_TILDE] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_STAR] = ACTIONS(1436),
    [anon_sym_AMP] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1436),
    [anon_sym___extension__] = ACTIONS(1434),
    [anon_sym_typedef] = ACTIONS(1434),
    [anon_sym_extern] = ACTIONS(1434),
    [anon_sym___attribute__] = ACTIONS(1434),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1436),
    [anon_sym___declspec] = ACTIONS(1434),
    [anon_sym___cdecl] = ACTIONS(1434),
    [anon_sym___clrcall] = ACTIONS(1434),
    [anon_sym___stdcall] = ACTIONS(1434),
    [anon_sym___fastcall] = ACTIONS(1434),
    [anon_sym___thiscall] = ACTIONS(1434),
    [anon_sym___vectorcall] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1436),
    [anon_sym_signed] = ACTIONS(1434),
    [anon_sym_unsigned] = ACTIONS(1434),
    [anon_sym_long] = ACTIONS(1434),
    [anon_sym_short] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(1434),
    [anon_sym_auto] = ACTIONS(1434),
    [anon_sym_register] = ACTIONS(1434),
    [anon_sym_inline] = ACTIONS(1434),
    [anon_sym___inline] = ACTIONS(1434),
    [anon_sym___inline__] = ACTIONS(1434),
    [anon_sym___forceinline] = ACTIONS(1434),
    [anon_sym_thread_local] = ACTIONS(1434),
    [anon_sym___thread] = ACTIONS(1434),
    [anon_sym_const] = ACTIONS(1434),
    [anon_sym_constexpr] = ACTIONS(1434),
    [anon_sym_volatile] = ACTIONS(1434),
    [anon_sym_restrict] = ACTIONS(1434),
    [anon_sym___restrict__] = ACTIONS(1434),
    [anon_sym__Atomic] = ACTIONS(1434),
    [anon_sym__Noreturn] = ACTIONS(1434),
    [anon_sym_noreturn] = ACTIONS(1434),
    [sym_primitive_type] = ACTIONS(1434),
    [anon_sym_enum] = ACTIONS(1434),
    [anon_sym_struct] = ACTIONS(1434),
    [anon_sym_union] = ACTIONS(1434),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_switch] = ACTIONS(1434),
    [anon_sym_case] = ACTIONS(1434),
    [anon_sym_default] = ACTIONS(1434),
    [anon_sym_while] = ACTIONS(1434),
    [anon_sym_do] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1434),
    [anon_sym_return] = ACTIONS(1434),
    [anon_sym_break] = ACTIONS(1434),
    [anon_sym_continue] = ACTIONS(1434),
    [anon_sym_goto] = ACTIONS(1434),
    [anon_sym___try] = ACTIONS(1434),
    [anon_sym___leave] = ACTIONS(1434),
    [anon_sym_DASH_DASH] = ACTIONS(1436),
    [anon_sym_PLUS_PLUS] = ACTIONS(1436),
    [anon_sym_sizeof] = ACTIONS(1434),
    [anon_sym___alignof__] = ACTIONS(1434),
    [anon_sym___alignof] = ACTIONS(1434),
    [anon_sym__alignof] = ACTIONS(1434),
    [anon_sym_alignof] = ACTIONS(1434),
    [anon_sym__Alignof] = ACTIONS(1434),
    [anon_sym_offsetof] = ACTIONS(1434),
    [anon_sym__Generic] = ACTIONS(1434),
    [anon_sym_asm] = ACTIONS(1434),
    [anon_sym___asm__] = ACTIONS(1434),
    [sym_number_literal] = ACTIONS(1436),
    [anon_sym_L_SQUOTE] = ACTIONS(1436),
    [anon_sym_u_SQUOTE] = ACTIONS(1436),
    [anon_sym_U_SQUOTE] = ACTIONS(1436),
    [anon_sym_u8_SQUOTE] = ACTIONS(1436),
    [anon_sym_SQUOTE] = ACTIONS(1436),
    [anon_sym_L_DQUOTE] = ACTIONS(1436),
    [anon_sym_u_DQUOTE] = ACTIONS(1436),
    [anon_sym_U_DQUOTE] = ACTIONS(1436),
    [anon_sym_u8_DQUOTE] = ACTIONS(1436),
    [anon_sym_DQUOTE] = ACTIONS(1436),
    [sym_true] = ACTIONS(1434),
    [sym_false] = ACTIONS(1434),
    [anon_sym_NULL] = ACTIONS(1434),
    [anon_sym_nullptr] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
  },
  [468] = {
    [sym_identifier] = ACTIONS(1426),
    [aux_sym_preproc_include_token1] = ACTIONS(1426),
    [aux_sym_preproc_def_token1] = ACTIONS(1426),
    [aux_sym_preproc_if_token1] = ACTIONS(1426),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1426),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1426),
    [sym_preproc_directive] = ACTIONS(1426),
    [anon_sym_LPAREN2] = ACTIONS(1428),
    [anon_sym_BANG] = ACTIONS(1428),
    [anon_sym_TILDE] = ACTIONS(1428),
    [anon_sym_DASH] = ACTIONS(1426),
    [anon_sym_PLUS] = ACTIONS(1426),
    [anon_sym_STAR] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1428),
    [anon_sym_SEMI] = ACTIONS(1428),
    [anon_sym___extension__] = ACTIONS(1426),
    [anon_sym_typedef] = ACTIONS(1426),
    [anon_sym_extern] = ACTIONS(1426),
    [anon_sym___attribute__] = ACTIONS(1426),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1428),
    [anon_sym___declspec] = ACTIONS(1426),
    [anon_sym___cdecl] = ACTIONS(1426),
    [anon_sym___clrcall] = ACTIONS(1426),
    [anon_sym___stdcall] = ACTIONS(1426),
    [anon_sym___fastcall] = ACTIONS(1426),
    [anon_sym___thiscall] = ACTIONS(1426),
    [anon_sym___vectorcall] = ACTIONS(1426),
    [anon_sym_LBRACE] = ACTIONS(1428),
    [anon_sym_RBRACE] = ACTIONS(1428),
    [anon_sym_signed] = ACTIONS(1426),
    [anon_sym_unsigned] = ACTIONS(1426),
    [anon_sym_long] = ACTIONS(1426),
    [anon_sym_short] = ACTIONS(1426),
    [anon_sym_static] = ACTIONS(1426),
    [anon_sym_auto] = ACTIONS(1426),
    [anon_sym_register] = ACTIONS(1426),
    [anon_sym_inline] = ACTIONS(1426),
    [anon_sym___inline] = ACTIONS(1426),
    [anon_sym___inline__] = ACTIONS(1426),
    [anon_sym___forceinline] = ACTIONS(1426),
    [anon_sym_thread_local] = ACTIONS(1426),
    [anon_sym___thread] = ACTIONS(1426),
    [anon_sym_const] = ACTIONS(1426),
    [anon_sym_constexpr] = ACTIONS(1426),
    [anon_sym_volatile] = ACTIONS(1426),
    [anon_sym_restrict] = ACTIONS(1426),
    [anon_sym___restrict__] = ACTIONS(1426),
    [anon_sym__Atomic] = ACTIONS(1426),
    [anon_sym__Noreturn] = ACTIONS(1426),
    [anon_sym_noreturn] = ACTIONS(1426),
    [sym_primitive_type] = ACTIONS(1426),
    [anon_sym_enum] = ACTIONS(1426),
    [anon_sym_struct] = ACTIONS(1426),
    [anon_sym_union] = ACTIONS(1426),
    [anon_sym_if] = ACTIONS(1426),
    [anon_sym_switch] = ACTIONS(1426),
    [anon_sym_case] = ACTIONS(1426),
    [anon_sym_default] = ACTIONS(1426),
    [anon_sym_while] = ACTIONS(1426),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_for] = ACTIONS(1426),
    [anon_sym_return] = ACTIONS(1426),
    [anon_sym_break] = ACTIONS(1426),
    [anon_sym_continue] = ACTIONS(1426),
    [anon_sym_goto] = ACTIONS(1426),
    [anon_sym___try] = ACTIONS(1426),
    [anon_sym___leave] = ACTIONS(1426),
    [anon_sym_DASH_DASH] = ACTIONS(1428),
    [anon_sym_PLUS_PLUS] = ACTIONS(1428),
    [anon_sym_sizeof] = ACTIONS(1426),
    [anon_sym___alignof__] = ACTIONS(1426),
    [anon_sym___alignof] = ACTIONS(1426),
    [anon_sym__alignof] = ACTIONS(1426),
    [anon_sym_alignof] = ACTIONS(1426),
    [anon_sym__Alignof] = ACTIONS(1426),
    [anon_sym_offsetof] = ACTIONS(1426),
    [anon_sym__Generic] = ACTIONS(1426),
    [anon_sym_asm] = ACTIONS(1426),
    [anon_sym___asm__] = ACTIONS(1426),
    [sym_number_literal] = ACTIONS(1428),
    [anon_sym_L_SQUOTE] = ACTIONS(1428),
    [anon_sym_u_SQUOTE] = ACTIONS(1428),
    [anon_sym_U_SQUOTE] = ACTIONS(1428),
    [anon_sym_u8_SQUOTE] = ACTIONS(1428),
    [anon_sym_SQUOTE] = ACTIONS(1428),
    [anon_sym_L_DQUOTE] = ACTIONS(1428),
    [anon_sym_u_DQUOTE] = ACTIONS(1428),
    [anon_sym_U_DQUOTE] = ACTIONS(1428),
    [anon_sym_u8_DQUOTE] = ACTIONS(1428),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [sym_true] = ACTIONS(1426),
    [sym_false] = ACTIONS(1426),
    [anon_sym_NULL] = ACTIONS(1426),
    [anon_sym_nullptr] = ACTIONS(1426),
    [sym_comment] = ACTIONS(3),
  },
  [469] = {
    [sym_identifier] = ACTIONS(1430),
    [aux_sym_preproc_include_token1] = ACTIONS(1430),
    [aux_sym_preproc_def_token1] = ACTIONS(1430),
    [aux_sym_preproc_if_token1] = ACTIONS(1430),
    [aux_sym_preproc_if_token2] = ACTIONS(1430),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1430),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1430),
    [sym_preproc_directive] = ACTIONS(1430),
    [anon_sym_LPAREN2] = ACTIONS(1432),
    [anon_sym_BANG] = ACTIONS(1432),
    [anon_sym_TILDE] = ACTIONS(1432),
    [anon_sym_DASH] = ACTIONS(1430),
    [anon_sym_PLUS] = ACTIONS(1430),
    [anon_sym_STAR] = ACTIONS(1432),
    [anon_sym_AMP] = ACTIONS(1432),
    [anon_sym_SEMI] = ACTIONS(1432),
    [anon_sym___extension__] = ACTIONS(1430),
    [anon_sym_typedef] = ACTIONS(1430),
    [anon_sym_extern] = ACTIONS(1430),
    [anon_sym___attribute__] = ACTIONS(1430),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(1430),
    [anon_sym___cdecl] = ACTIONS(1430),
    [anon_sym___clrcall] = ACTIONS(1430),
    [anon_sym___stdcall] = ACTIONS(1430),
    [anon_sym___fastcall] = ACTIONS(1430),
    [anon_sym___thiscall] = ACTIONS(1430),
    [anon_sym___vectorcall] = ACTIONS(1430),
    [anon_sym_LBRACE] = ACTIONS(1432),
    [anon_sym_signed] = ACTIONS(1430),
    [anon_sym_unsigned] = ACTIONS(1430),
    [anon_sym_long] = ACTIONS(1430),
    [anon_sym_short] = ACTIONS(1430),
    [anon_sym_static] = ACTIONS(1430),
    [anon_sym_auto] = ACTIONS(1430),
    [anon_sym_register] = ACTIONS(1430),
    [anon_sym_inline] = ACTIONS(1430),
    [anon_sym___inline] = ACTIONS(1430),
    [anon_sym___inline__] = ACTIONS(1430),
    [anon_sym___forceinline] = ACTIONS(1430),
    [anon_sym_thread_local] = ACTIONS(1430),
    [anon_sym___thread] = ACTIONS(1430),
    [anon_sym_const] = ACTIONS(1430),
    [anon_sym_constexpr] = ACTIONS(1430),
    [anon_sym_volatile] = ACTIONS(1430),
    [anon_sym_restrict] = ACTIONS(1430),
    [anon_sym___restrict__] = ACTIONS(1430),
    [anon_sym__Atomic] = ACTIONS(1430),
    [anon_sym__Noreturn] = ACTIONS(1430),
    [anon_sym_noreturn] = ACTIONS(1430),
    [sym_primitive_type] = ACTIONS(1430),
    [anon_sym_enum] = ACTIONS(1430),
    [anon_sym_struct] = ACTIONS(1430),
    [anon_sym_union] = ACTIONS(1430),
    [anon_sym_if] = ACTIONS(1430),
    [anon_sym_switch] = ACTIONS(1430),
    [anon_sym_case] = ACTIONS(1430),
    [anon_sym_default] = ACTIONS(1430),
    [anon_sym_while] = ACTIONS(1430),
    [anon_sym_do] = ACTIONS(1430),
    [anon_sym_for] = ACTIONS(1430),
    [anon_sym_return] = ACTIONS(1430),
    [anon_sym_break] = ACTIONS(1430),
    [anon_sym_continue] = ACTIONS(1430),
    [anon_sym_goto] = ACTIONS(1430),
    [anon_sym___try] = ACTIONS(1430),
    [anon_sym___leave] = ACTIONS(1430),
    [anon_sym_DASH_DASH] = ACTIONS(1432),
    [anon_sym_PLUS_PLUS] = ACTIONS(1432),
    [anon_sym_sizeof] = ACTIONS(1430),
    [anon_sym___alignof__] = ACTIONS(1430),
    [anon_sym___alignof] = ACTIONS(1430),
    [anon_sym__alignof] = ACTIONS(1430),
    [anon_sym_alignof] = ACTIONS(1430),
    [anon_sym__Alignof] = ACTIONS(1430),
    [anon_sym_offsetof] = ACTIONS(1430),
    [anon_sym__Generic] = ACTIONS(1430),
    [anon_sym_asm] = ACTIONS(1430),
    [anon_sym___asm__] = ACTIONS(1430),
    [sym_number_literal] = ACTIONS(1432),
    [anon_sym_L_SQUOTE] = ACTIONS(1432),
    [anon_sym_u_SQUOTE] = ACTIONS(1432),
    [anon_sym_U_SQUOTE] = ACTIONS(1432),
    [anon_sym_u8_SQUOTE] = ACTIONS(1432),
    [anon_sym_SQUOTE] = ACTIONS(1432),
    [anon_sym_L_DQUOTE] = ACTIONS(1432),
    [anon_sym_u_DQUOTE] = ACTIONS(1432),
    [anon_sym_U_DQUOTE] = ACTIONS(1432),
    [anon_sym_u8_DQUOTE] = ACTIONS(1432),
    [anon_sym_DQUOTE] = ACTIONS(1432),
    [sym_true] = ACTIONS(1430),
    [sym_false] = ACTIONS(1430),
    [anon_sym_NULL] = ACTIONS(1430),
    [anon_sym_nullptr] = ACTIONS(1430),
    [sym_comment] = ACTIONS(3),
  },
  [470] = {
    [sym_attribute_declaration] = STATE(488),
    [sym_compound_statement] = STATE(301),
    [sym_attributed_statement] = STATE(301),
    [sym_labeled_statement] = STATE(301),
    [sym_expression_statement] = STATE(301),
    [sym_if_statement] = STATE(301),
    [sym_switch_statement] = STATE(301),
    [sym_case_statement] = STATE(301),
    [sym_while_statement] = STATE(301),
    [sym_do_statement] = STATE(301),
    [sym_for_statement] = STATE(301),
    [sym_return_statement] = STATE(301),
    [sym_break_statement] = STATE(301),
    [sym_continue_statement] = STATE(301),
    [sym_goto_statement] = STATE(301),
    [sym_seh_try_statement] = STATE(301),
    [sym_seh_leave_statement] = STATE(301),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(488),
    [sym_identifier] = ACTIONS(1566),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1278),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1568),
    [anon_sym_default] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1280),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1282),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1284),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [471] = {
    [sym_identifier] = ACTIONS(1438),
    [aux_sym_preproc_include_token1] = ACTIONS(1438),
    [aux_sym_preproc_def_token1] = ACTIONS(1438),
    [aux_sym_preproc_if_token1] = ACTIONS(1438),
    [aux_sym_preproc_if_token2] = ACTIONS(1438),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1438),
    [sym_preproc_directive] = ACTIONS(1438),
    [anon_sym_LPAREN2] = ACTIONS(1440),
    [anon_sym_BANG] = ACTIONS(1440),
    [anon_sym_TILDE] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1438),
    [anon_sym_PLUS] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_SEMI] = ACTIONS(1440),
    [anon_sym___extension__] = ACTIONS(1438),
    [anon_sym_typedef] = ACTIONS(1438),
    [anon_sym_extern] = ACTIONS(1438),
    [anon_sym___attribute__] = ACTIONS(1438),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1440),
    [anon_sym___declspec] = ACTIONS(1438),
    [anon_sym___cdecl] = ACTIONS(1438),
    [anon_sym___clrcall] = ACTIONS(1438),
    [anon_sym___stdcall] = ACTIONS(1438),
    [anon_sym___fastcall] = ACTIONS(1438),
    [anon_sym___thiscall] = ACTIONS(1438),
    [anon_sym___vectorcall] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(1440),
    [anon_sym_signed] = ACTIONS(1438),
    [anon_sym_unsigned] = ACTIONS(1438),
    [anon_sym_long] = ACTIONS(1438),
    [anon_sym_short] = ACTIONS(1438),
    [anon_sym_static] = ACTIONS(1438),
    [anon_sym_auto] = ACTIONS(1438),
    [anon_sym_register] = ACTIONS(1438),
    [anon_sym_inline] = ACTIONS(1438),
    [anon_sym___inline] = ACTIONS(1438),
    [anon_sym___inline__] = ACTIONS(1438),
    [anon_sym___forceinline] = ACTIONS(1438),
    [anon_sym_thread_local] = ACTIONS(1438),
    [anon_sym___thread] = ACTIONS(1438),
    [anon_sym_const] = ACTIONS(1438),
    [anon_sym_constexpr] = ACTIONS(1438),
    [anon_sym_volatile] = ACTIONS(1438),
    [anon_sym_restrict] = ACTIONS(1438),
    [anon_sym___restrict__] = ACTIONS(1438),
    [anon_sym__Atomic] = ACTIONS(1438),
    [anon_sym__Noreturn] = ACTIONS(1438),
    [anon_sym_noreturn] = ACTIONS(1438),
    [sym_primitive_type] = ACTIONS(1438),
    [anon_sym_enum] = ACTIONS(1438),
    [anon_sym_struct] = ACTIONS(1438),
    [anon_sym_union] = ACTIONS(1438),
    [anon_sym_if] = ACTIONS(1438),
    [anon_sym_switch] = ACTIONS(1438),
    [anon_sym_case] = ACTIONS(1438),
    [anon_sym_default] = ACTIONS(1438),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_do] = ACTIONS(1438),
    [anon_sym_for] = ACTIONS(1438),
    [anon_sym_return] = ACTIONS(1438),
    [anon_sym_break] = ACTIONS(1438),
    [anon_sym_continue] = ACTIONS(1438),
    [anon_sym_goto] = ACTIONS(1438),
    [anon_sym___try] = ACTIONS(1438),
    [anon_sym___leave] = ACTIONS(1438),
    [anon_sym_DASH_DASH] = ACTIONS(1440),
    [anon_sym_PLUS_PLUS] = ACTIONS(1440),
    [anon_sym_sizeof] = ACTIONS(1438),
    [anon_sym___alignof__] = ACTIONS(1438),
    [anon_sym___alignof] = ACTIONS(1438),
    [anon_sym__alignof] = ACTIONS(1438),
    [anon_sym_alignof] = ACTIONS(1438),
    [anon_sym__Alignof] = ACTIONS(1438),
    [anon_sym_offsetof] = ACTIONS(1438),
    [anon_sym__Generic] = ACTIONS(1438),
    [anon_sym_asm] = ACTIONS(1438),
    [anon_sym___asm__] = ACTIONS(1438),
    [sym_number_literal] = ACTIONS(1440),
    [anon_sym_L_SQUOTE] = ACTIONS(1440),
    [anon_sym_u_SQUOTE] = ACTIONS(1440),
    [anon_sym_U_SQUOTE] = ACTIONS(1440),
    [anon_sym_u8_SQUOTE] = ACTIONS(1440),
    [anon_sym_SQUOTE] = ACTIONS(1440),
    [anon_sym_L_DQUOTE] = ACTIONS(1440),
    [anon_sym_u_DQUOTE] = ACTIONS(1440),
    [anon_sym_U_DQUOTE] = ACTIONS(1440),
    [anon_sym_u8_DQUOTE] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [sym_true] = ACTIONS(1438),
    [sym_false] = ACTIONS(1438),
    [anon_sym_NULL] = ACTIONS(1438),
    [anon_sym_nullptr] = ACTIONS(1438),
    [sym_comment] = ACTIONS(3),
  },
  [472] = {
    [sym_attribute_declaration] = STATE(432),
    [sym_compound_statement] = STATE(113),
    [sym_attributed_statement] = STATE(113),
    [sym_labeled_statement] = STATE(113),
    [sym_expression_statement] = STATE(113),
    [sym_if_statement] = STATE(113),
    [sym_switch_statement] = STATE(113),
    [sym_case_statement] = STATE(113),
    [sym_while_statement] = STATE(113),
    [sym_do_statement] = STATE(113),
    [sym_for_statement] = STATE(113),
    [sym_return_statement] = STATE(113),
    [sym_break_statement] = STATE(113),
    [sym_continue_statement] = STATE(113),
    [sym_goto_statement] = STATE(113),
    [sym_seh_try_statement] = STATE(113),
    [sym_seh_leave_statement] = STATE(113),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(432),
    [sym_identifier] = ACTIONS(1720),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_do] = ACTIONS(141),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_continue] = ACTIONS(149),
    [anon_sym_goto] = ACTIONS(151),
    [anon_sym___try] = ACTIONS(153),
    [anon_sym___leave] = ACTIONS(155),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [473] = {
    [sym_attribute_declaration] = STATE(473),
    [sym_compound_statement] = STATE(350),
    [sym_attributed_statement] = STATE(350),
    [sym_labeled_statement] = STATE(350),
    [sym_expression_statement] = STATE(350),
    [sym_if_statement] = STATE(350),
    [sym_switch_statement] = STATE(350),
    [sym_case_statement] = STATE(350),
    [sym_while_statement] = STATE(350),
    [sym_do_statement] = STATE(350),
    [sym_for_statement] = STATE(350),
    [sym_return_statement] = STATE(350),
    [sym_break_statement] = STATE(350),
    [sym_continue_statement] = STATE(350),
    [sym_goto_statement] = STATE(350),
    [sym_seh_try_statement] = STATE(350),
    [sym_seh_leave_statement] = STATE(350),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(473),
    [sym_identifier] = ACTIONS(1772),
    [anon_sym_LPAREN2] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1582),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1588),
    [anon_sym_SEMI] = ACTIONS(1775),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1594),
    [anon_sym_LBRACE] = ACTIONS(1778),
    [anon_sym_if] = ACTIONS(1781),
    [anon_sym_switch] = ACTIONS(1784),
    [anon_sym_case] = ACTIONS(1787),
    [anon_sym_default] = ACTIONS(1790),
    [anon_sym_while] = ACTIONS(1793),
    [anon_sym_do] = ACTIONS(1796),
    [anon_sym_for] = ACTIONS(1799),
    [anon_sym_return] = ACTIONS(1802),
    [anon_sym_break] = ACTIONS(1805),
    [anon_sym_continue] = ACTIONS(1808),
    [anon_sym_goto] = ACTIONS(1811),
    [anon_sym___try] = ACTIONS(1814),
    [anon_sym___leave] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1639),
    [anon_sym_PLUS_PLUS] = ACTIONS(1639),
    [anon_sym_sizeof] = ACTIONS(1642),
    [anon_sym___alignof__] = ACTIONS(1645),
    [anon_sym___alignof] = ACTIONS(1645),
    [anon_sym__alignof] = ACTIONS(1645),
    [anon_sym_alignof] = ACTIONS(1645),
    [anon_sym__Alignof] = ACTIONS(1645),
    [anon_sym_offsetof] = ACTIONS(1648),
    [anon_sym__Generic] = ACTIONS(1651),
    [anon_sym_asm] = ACTIONS(1654),
    [anon_sym___asm__] = ACTIONS(1654),
    [sym_number_literal] = ACTIONS(1657),
    [anon_sym_L_SQUOTE] = ACTIONS(1660),
    [anon_sym_u_SQUOTE] = ACTIONS(1660),
    [anon_sym_U_SQUOTE] = ACTIONS(1660),
    [anon_sym_u8_SQUOTE] = ACTIONS(1660),
    [anon_sym_SQUOTE] = ACTIONS(1660),
    [anon_sym_L_DQUOTE] = ACTIONS(1663),
    [anon_sym_u_DQUOTE] = ACTIONS(1663),
    [anon_sym_U_DQUOTE] = ACTIONS(1663),
    [anon_sym_u8_DQUOTE] = ACTIONS(1663),
    [anon_sym_DQUOTE] = ACTIONS(1663),
    [sym_true] = ACTIONS(1666),
    [sym_false] = ACTIONS(1666),
    [anon_sym_NULL] = ACTIONS(1669),
    [anon_sym_nullptr] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
  },
  [474] = {
    [sym_attribute_declaration] = STATE(463),
    [sym_compound_statement] = STATE(304),
    [sym_attributed_statement] = STATE(304),
    [sym_labeled_statement] = STATE(304),
    [sym_expression_statement] = STATE(304),
    [sym_if_statement] = STATE(304),
    [sym_switch_statement] = STATE(304),
    [sym_case_statement] = STATE(304),
    [sym_while_statement] = STATE(304),
    [sym_do_statement] = STATE(304),
    [sym_for_statement] = STATE(304),
    [sym_return_statement] = STATE(304),
    [sym_break_statement] = STATE(304),
    [sym_continue_statement] = STATE(304),
    [sym_goto_statement] = STATE(304),
    [sym_seh_try_statement] = STATE(304),
    [sym_seh_leave_statement] = STATE(304),
    [sym__expression] = STATE(1348),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2343),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(463),
    [sym_identifier] = ACTIONS(1574),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1101),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_default] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1103),
    [anon_sym___leave] = ACTIONS(1105),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [475] = {
    [sym_identifier] = ACTIONS(1526),
    [aux_sym_preproc_include_token1] = ACTIONS(1526),
    [aux_sym_preproc_def_token1] = ACTIONS(1526),
    [aux_sym_preproc_if_token1] = ACTIONS(1526),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1526),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1526),
    [sym_preproc_directive] = ACTIONS(1526),
    [anon_sym_LPAREN2] = ACTIONS(1528),
    [anon_sym_BANG] = ACTIONS(1528),
    [anon_sym_TILDE] = ACTIONS(1528),
    [anon_sym_DASH] = ACTIONS(1526),
    [anon_sym_PLUS] = ACTIONS(1526),
    [anon_sym_STAR] = ACTIONS(1528),
    [anon_sym_AMP] = ACTIONS(1528),
    [anon_sym_SEMI] = ACTIONS(1528),
    [anon_sym___extension__] = ACTIONS(1526),
    [anon_sym_typedef] = ACTIONS(1526),
    [anon_sym_extern] = ACTIONS(1526),
    [anon_sym___attribute__] = ACTIONS(1526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1528),
    [anon_sym___declspec] = ACTIONS(1526),
    [anon_sym___cdecl] = ACTIONS(1526),
    [anon_sym___clrcall] = ACTIONS(1526),
    [anon_sym___stdcall] = ACTIONS(1526),
    [anon_sym___fastcall] = ACTIONS(1526),
    [anon_sym___thiscall] = ACTIONS(1526),
    [anon_sym___vectorcall] = ACTIONS(1526),
    [anon_sym_LBRACE] = ACTIONS(1528),
    [anon_sym_RBRACE] = ACTIONS(1528),
    [anon_sym_signed] = ACTIONS(1526),
    [anon_sym_unsigned] = ACTIONS(1526),
    [anon_sym_long] = ACTIONS(1526),
    [anon_sym_short] = ACTIONS(1526),
    [anon_sym_static] = ACTIONS(1526),
    [anon_sym_auto] = ACTIONS(1526),
    [anon_sym_register] = ACTIONS(1526),
    [anon_sym_inline] = ACTIONS(1526),
    [anon_sym___inline] = ACTIONS(1526),
    [anon_sym___inline__] = ACTIONS(1526),
    [anon_sym___forceinline] = ACTIONS(1526),
    [anon_sym_thread_local] = ACTIONS(1526),
    [anon_sym___thread] = ACTIONS(1526),
    [anon_sym_const] = ACTIONS(1526),
    [anon_sym_constexpr] = ACTIONS(1526),
    [anon_sym_volatile] = ACTIONS(1526),
    [anon_sym_restrict] = ACTIONS(1526),
    [anon_sym___restrict__] = ACTIONS(1526),
    [anon_sym__Atomic] = ACTIONS(1526),
    [anon_sym__Noreturn] = ACTIONS(1526),
    [anon_sym_noreturn] = ACTIONS(1526),
    [sym_primitive_type] = ACTIONS(1526),
    [anon_sym_enum] = ACTIONS(1526),
    [anon_sym_struct] = ACTIONS(1526),
    [anon_sym_union] = ACTIONS(1526),
    [anon_sym_if] = ACTIONS(1526),
    [anon_sym_switch] = ACTIONS(1526),
    [anon_sym_case] = ACTIONS(1526),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1526),
    [anon_sym_do] = ACTIONS(1526),
    [anon_sym_for] = ACTIONS(1526),
    [anon_sym_return] = ACTIONS(1526),
    [anon_sym_break] = ACTIONS(1526),
    [anon_sym_continue] = ACTIONS(1526),
    [anon_sym_goto] = ACTIONS(1526),
    [anon_sym___try] = ACTIONS(1526),
    [anon_sym___leave] = ACTIONS(1526),
    [anon_sym_DASH_DASH] = ACTIONS(1528),
    [anon_sym_PLUS_PLUS] = ACTIONS(1528),
    [anon_sym_sizeof] = ACTIONS(1526),
    [anon_sym___alignof__] = ACTIONS(1526),
    [anon_sym___alignof] = ACTIONS(1526),
    [anon_sym__alignof] = ACTIONS(1526),
    [anon_sym_alignof] = ACTIONS(1526),
    [anon_sym__Alignof] = ACTIONS(1526),
    [anon_sym_offsetof] = ACTIONS(1526),
    [anon_sym__Generic] = ACTIONS(1526),
    [anon_sym_asm] = ACTIONS(1526),
    [anon_sym___asm__] = ACTIONS(1526),
    [sym_number_literal] = ACTIONS(1528),
    [anon_sym_L_SQUOTE] = ACTIONS(1528),
    [anon_sym_u_SQUOTE] = ACTIONS(1528),
    [anon_sym_U_SQUOTE] = ACTIONS(1528),
    [anon_sym_u8_SQUOTE] = ACTIONS(1528),
    [anon_sym_SQUOTE] = ACTIONS(1528),
    [anon_sym_L_DQUOTE] = ACTIONS(1528),
    [anon_sym_u_DQUOTE] = ACTIONS(1528),
    [anon_sym_U_DQUOTE] = ACTIONS(1528),
    [anon_sym_u8_DQUOTE] = ACTIONS(1528),
    [anon_sym_DQUOTE] = ACTIONS(1528),
    [sym_true] = ACTIONS(1526),
    [sym_false] = ACTIONS(1526),
    [anon_sym_NULL] = ACTIONS(1526),
    [anon_sym_nullptr] = ACTIONS(1526),
    [sym_comment] = ACTIONS(3),
  },
  [476] = {
    [sym_identifier] = ACTIONS(1430),
    [aux_sym_preproc_include_token1] = ACTIONS(1430),
    [aux_sym_preproc_def_token1] = ACTIONS(1430),
    [aux_sym_preproc_if_token1] = ACTIONS(1430),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1430),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1430),
    [sym_preproc_directive] = ACTIONS(1430),
    [anon_sym_LPAREN2] = ACTIONS(1432),
    [anon_sym_BANG] = ACTIONS(1432),
    [anon_sym_TILDE] = ACTIONS(1432),
    [anon_sym_DASH] = ACTIONS(1430),
    [anon_sym_PLUS] = ACTIONS(1430),
    [anon_sym_STAR] = ACTIONS(1432),
    [anon_sym_AMP] = ACTIONS(1432),
    [anon_sym_SEMI] = ACTIONS(1432),
    [anon_sym___extension__] = ACTIONS(1430),
    [anon_sym_typedef] = ACTIONS(1430),
    [anon_sym_extern] = ACTIONS(1430),
    [anon_sym___attribute__] = ACTIONS(1430),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(1430),
    [anon_sym___cdecl] = ACTIONS(1430),
    [anon_sym___clrcall] = ACTIONS(1430),
    [anon_sym___stdcall] = ACTIONS(1430),
    [anon_sym___fastcall] = ACTIONS(1430),
    [anon_sym___thiscall] = ACTIONS(1430),
    [anon_sym___vectorcall] = ACTIONS(1430),
    [anon_sym_LBRACE] = ACTIONS(1432),
    [anon_sym_RBRACE] = ACTIONS(1432),
    [anon_sym_signed] = ACTIONS(1430),
    [anon_sym_unsigned] = ACTIONS(1430),
    [anon_sym_long] = ACTIONS(1430),
    [anon_sym_short] = ACTIONS(1430),
    [anon_sym_static] = ACTIONS(1430),
    [anon_sym_auto] = ACTIONS(1430),
    [anon_sym_register] = ACTIONS(1430),
    [anon_sym_inline] = ACTIONS(1430),
    [anon_sym___inline] = ACTIONS(1430),
    [anon_sym___inline__] = ACTIONS(1430),
    [anon_sym___forceinline] = ACTIONS(1430),
    [anon_sym_thread_local] = ACTIONS(1430),
    [anon_sym___thread] = ACTIONS(1430),
    [anon_sym_const] = ACTIONS(1430),
    [anon_sym_constexpr] = ACTIONS(1430),
    [anon_sym_volatile] = ACTIONS(1430),
    [anon_sym_restrict] = ACTIONS(1430),
    [anon_sym___restrict__] = ACTIONS(1430),
    [anon_sym__Atomic] = ACTIONS(1430),
    [anon_sym__Noreturn] = ACTIONS(1430),
    [anon_sym_noreturn] = ACTIONS(1430),
    [sym_primitive_type] = ACTIONS(1430),
    [anon_sym_enum] = ACTIONS(1430),
    [anon_sym_struct] = ACTIONS(1430),
    [anon_sym_union] = ACTIONS(1430),
    [anon_sym_if] = ACTIONS(1430),
    [anon_sym_switch] = ACTIONS(1430),
    [anon_sym_case] = ACTIONS(1430),
    [anon_sym_default] = ACTIONS(1430),
    [anon_sym_while] = ACTIONS(1430),
    [anon_sym_do] = ACTIONS(1430),
    [anon_sym_for] = ACTIONS(1430),
    [anon_sym_return] = ACTIONS(1430),
    [anon_sym_break] = ACTIONS(1430),
    [anon_sym_continue] = ACTIONS(1430),
    [anon_sym_goto] = ACTIONS(1430),
    [anon_sym___try] = ACTIONS(1430),
    [anon_sym___leave] = ACTIONS(1430),
    [anon_sym_DASH_DASH] = ACTIONS(1432),
    [anon_sym_PLUS_PLUS] = ACTIONS(1432),
    [anon_sym_sizeof] = ACTIONS(1430),
    [anon_sym___alignof__] = ACTIONS(1430),
    [anon_sym___alignof] = ACTIONS(1430),
    [anon_sym__alignof] = ACTIONS(1430),
    [anon_sym_alignof] = ACTIONS(1430),
    [anon_sym__Alignof] = ACTIONS(1430),
    [anon_sym_offsetof] = ACTIONS(1430),
    [anon_sym__Generic] = ACTIONS(1430),
    [anon_sym_asm] = ACTIONS(1430),
    [anon_sym___asm__] = ACTIONS(1430),
    [sym_number_literal] = ACTIONS(1432),
    [anon_sym_L_SQUOTE] = ACTIONS(1432),
    [anon_sym_u_SQUOTE] = ACTIONS(1432),
    [anon_sym_U_SQUOTE] = ACTIONS(1432),
    [anon_sym_u8_SQUOTE] = ACTIONS(1432),
    [anon_sym_SQUOTE] = ACTIONS(1432),
    [anon_sym_L_DQUOTE] = ACTIONS(1432),
    [anon_sym_u_DQUOTE] = ACTIONS(1432),
    [anon_sym_U_DQUOTE] = ACTIONS(1432),
    [anon_sym_u8_DQUOTE] = ACTIONS(1432),
    [anon_sym_DQUOTE] = ACTIONS(1432),
    [sym_true] = ACTIONS(1430),
    [sym_false] = ACTIONS(1430),
    [anon_sym_NULL] = ACTIONS(1430),
    [anon_sym_nullptr] = ACTIONS(1430),
    [sym_comment] = ACTIONS(3),
  },
  [477] = {
    [sym_identifier] = ACTIONS(1522),
    [aux_sym_preproc_include_token1] = ACTIONS(1522),
    [aux_sym_preproc_def_token1] = ACTIONS(1522),
    [aux_sym_preproc_if_token1] = ACTIONS(1522),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1522),
    [sym_preproc_directive] = ACTIONS(1522),
    [anon_sym_LPAREN2] = ACTIONS(1524),
    [anon_sym_BANG] = ACTIONS(1524),
    [anon_sym_TILDE] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1522),
    [anon_sym_PLUS] = ACTIONS(1522),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym___extension__] = ACTIONS(1522),
    [anon_sym_typedef] = ACTIONS(1522),
    [anon_sym_extern] = ACTIONS(1522),
    [anon_sym___attribute__] = ACTIONS(1522),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1524),
    [anon_sym___declspec] = ACTIONS(1522),
    [anon_sym___cdecl] = ACTIONS(1522),
    [anon_sym___clrcall] = ACTIONS(1522),
    [anon_sym___stdcall] = ACTIONS(1522),
    [anon_sym___fastcall] = ACTIONS(1522),
    [anon_sym___thiscall] = ACTIONS(1522),
    [anon_sym___vectorcall] = ACTIONS(1522),
    [anon_sym_LBRACE] = ACTIONS(1524),
    [anon_sym_RBRACE] = ACTIONS(1524),
    [anon_sym_signed] = ACTIONS(1522),
    [anon_sym_unsigned] = ACTIONS(1522),
    [anon_sym_long] = ACTIONS(1522),
    [anon_sym_short] = ACTIONS(1522),
    [anon_sym_static] = ACTIONS(1522),
    [anon_sym_auto] = ACTIONS(1522),
    [anon_sym_register] = ACTIONS(1522),
    [anon_sym_inline] = ACTIONS(1522),
    [anon_sym___inline] = ACTIONS(1522),
    [anon_sym___inline__] = ACTIONS(1522),
    [anon_sym___forceinline] = ACTIONS(1522),
    [anon_sym_thread_local] = ACTIONS(1522),
    [anon_sym___thread] = ACTIONS(1522),
    [anon_sym_const] = ACTIONS(1522),
    [anon_sym_constexpr] = ACTIONS(1522),
    [anon_sym_volatile] = ACTIONS(1522),
    [anon_sym_restrict] = ACTIONS(1522),
    [anon_sym___restrict__] = ACTIONS(1522),
    [anon_sym__Atomic] = ACTIONS(1522),
    [anon_sym__Noreturn] = ACTIONS(1522),
    [anon_sym_noreturn] = ACTIONS(1522),
    [sym_primitive_type] = ACTIONS(1522),
    [anon_sym_enum] = ACTIONS(1522),
    [anon_sym_struct] = ACTIONS(1522),
    [anon_sym_union] = ACTIONS(1522),
    [anon_sym_if] = ACTIONS(1522),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1522),
    [anon_sym_default] = ACTIONS(1522),
    [anon_sym_while] = ACTIONS(1522),
    [anon_sym_do] = ACTIONS(1522),
    [anon_sym_for] = ACTIONS(1522),
    [anon_sym_return] = ACTIONS(1522),
    [anon_sym_break] = ACTIONS(1522),
    [anon_sym_continue] = ACTIONS(1522),
    [anon_sym_goto] = ACTIONS(1522),
    [anon_sym___try] = ACTIONS(1522),
    [anon_sym___leave] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1524),
    [anon_sym_PLUS_PLUS] = ACTIONS(1524),
    [anon_sym_sizeof] = ACTIONS(1522),
    [anon_sym___alignof__] = ACTIONS(1522),
    [anon_sym___alignof] = ACTIONS(1522),
    [anon_sym__alignof] = ACTIONS(1522),
    [anon_sym_alignof] = ACTIONS(1522),
    [anon_sym__Alignof] = ACTIONS(1522),
    [anon_sym_offsetof] = ACTIONS(1522),
    [anon_sym__Generic] = ACTIONS(1522),
    [anon_sym_asm] = ACTIONS(1522),
    [anon_sym___asm__] = ACTIONS(1522),
    [sym_number_literal] = ACTIONS(1524),
    [anon_sym_L_SQUOTE] = ACTIONS(1524),
    [anon_sym_u_SQUOTE] = ACTIONS(1524),
    [anon_sym_U_SQUOTE] = ACTIONS(1524),
    [anon_sym_u8_SQUOTE] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(1524),
    [anon_sym_L_DQUOTE] = ACTIONS(1524),
    [anon_sym_u_DQUOTE] = ACTIONS(1524),
    [anon_sym_U_DQUOTE] = ACTIONS(1524),
    [anon_sym_u8_DQUOTE] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1524),
    [sym_true] = ACTIONS(1522),
    [sym_false] = ACTIONS(1522),
    [anon_sym_NULL] = ACTIONS(1522),
    [anon_sym_nullptr] = ACTIONS(1522),
    [sym_comment] = ACTIONS(3),
  },
  [478] = {
    [sym_identifier] = ACTIONS(1518),
    [aux_sym_preproc_include_token1] = ACTIONS(1518),
    [aux_sym_preproc_def_token1] = ACTIONS(1518),
    [aux_sym_preproc_if_token1] = ACTIONS(1518),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1518),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1518),
    [sym_preproc_directive] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(1520),
    [anon_sym_BANG] = ACTIONS(1520),
    [anon_sym_TILDE] = ACTIONS(1520),
    [anon_sym_DASH] = ACTIONS(1518),
    [anon_sym_PLUS] = ACTIONS(1518),
    [anon_sym_STAR] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1520),
    [anon_sym_SEMI] = ACTIONS(1520),
    [anon_sym___extension__] = ACTIONS(1518),
    [anon_sym_typedef] = ACTIONS(1518),
    [anon_sym_extern] = ACTIONS(1518),
    [anon_sym___attribute__] = ACTIONS(1518),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1520),
    [anon_sym___declspec] = ACTIONS(1518),
    [anon_sym___cdecl] = ACTIONS(1518),
    [anon_sym___clrcall] = ACTIONS(1518),
    [anon_sym___stdcall] = ACTIONS(1518),
    [anon_sym___fastcall] = ACTIONS(1518),
    [anon_sym___thiscall] = ACTIONS(1518),
    [anon_sym___vectorcall] = ACTIONS(1518),
    [anon_sym_LBRACE] = ACTIONS(1520),
    [anon_sym_RBRACE] = ACTIONS(1520),
    [anon_sym_signed] = ACTIONS(1518),
    [anon_sym_unsigned] = ACTIONS(1518),
    [anon_sym_long] = ACTIONS(1518),
    [anon_sym_short] = ACTIONS(1518),
    [anon_sym_static] = ACTIONS(1518),
    [anon_sym_auto] = ACTIONS(1518),
    [anon_sym_register] = ACTIONS(1518),
    [anon_sym_inline] = ACTIONS(1518),
    [anon_sym___inline] = ACTIONS(1518),
    [anon_sym___inline__] = ACTIONS(1518),
    [anon_sym___forceinline] = ACTIONS(1518),
    [anon_sym_thread_local] = ACTIONS(1518),
    [anon_sym___thread] = ACTIONS(1518),
    [anon_sym_const] = ACTIONS(1518),
    [anon_sym_constexpr] = ACTIONS(1518),
    [anon_sym_volatile] = ACTIONS(1518),
    [anon_sym_restrict] = ACTIONS(1518),
    [anon_sym___restrict__] = ACTIONS(1518),
    [anon_sym__Atomic] = ACTIONS(1518),
    [anon_sym__Noreturn] = ACTIONS(1518),
    [anon_sym_noreturn] = ACTIONS(1518),
    [sym_primitive_type] = ACTIONS(1518),
    [anon_sym_enum] = ACTIONS(1518),
    [anon_sym_struct] = ACTIONS(1518),
    [anon_sym_union] = ACTIONS(1518),
    [anon_sym_if] = ACTIONS(1518),
    [anon_sym_switch] = ACTIONS(1518),
    [anon_sym_case] = ACTIONS(1518),
    [anon_sym_default] = ACTIONS(1518),
    [anon_sym_while] = ACTIONS(1518),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_for] = ACTIONS(1518),
    [anon_sym_return] = ACTIONS(1518),
    [anon_sym_break] = ACTIONS(1518),
    [anon_sym_continue] = ACTIONS(1518),
    [anon_sym_goto] = ACTIONS(1518),
    [anon_sym___try] = ACTIONS(1518),
    [anon_sym___leave] = ACTIONS(1518),
    [anon_sym_DASH_DASH] = ACTIONS(1520),
    [anon_sym_PLUS_PLUS] = ACTIONS(1520),
    [anon_sym_sizeof] = ACTIONS(1518),
    [anon_sym___alignof__] = ACTIONS(1518),
    [anon_sym___alignof] = ACTIONS(1518),
    [anon_sym__alignof] = ACTIONS(1518),
    [anon_sym_alignof] = ACTIONS(1518),
    [anon_sym__Alignof] = ACTIONS(1518),
    [anon_sym_offsetof] = ACTIONS(1518),
    [anon_sym__Generic] = ACTIONS(1518),
    [anon_sym_asm] = ACTIONS(1518),
    [anon_sym___asm__] = ACTIONS(1518),
    [sym_number_literal] = ACTIONS(1520),
    [anon_sym_L_SQUOTE] = ACTIONS(1520),
    [anon_sym_u_SQUOTE] = ACTIONS(1520),
    [anon_sym_U_SQUOTE] = ACTIONS(1520),
    [anon_sym_u8_SQUOTE] = ACTIONS(1520),
    [anon_sym_SQUOTE] = ACTIONS(1520),
    [anon_sym_L_DQUOTE] = ACTIONS(1520),
    [anon_sym_u_DQUOTE] = ACTIONS(1520),
    [anon_sym_U_DQUOTE] = ACTIONS(1520),
    [anon_sym_u8_DQUOTE] = ACTIONS(1520),
    [anon_sym_DQUOTE] = ACTIONS(1520),
    [sym_true] = ACTIONS(1518),
    [sym_false] = ACTIONS(1518),
    [anon_sym_NULL] = ACTIONS(1518),
    [anon_sym_nullptr] = ACTIONS(1518),
    [sym_comment] = ACTIONS(3),
  },
  [479] = {
    [sym__expression] = STATE(996),
    [sym__expression_not_binary] = STATE(1073),
    [sym__string] = STATE(1073),
    [sym_conditional_expression] = STATE(1073),
    [sym_assignment_expression] = STATE(1073),
    [sym_pointer_expression] = STATE(1073),
    [sym_unary_expression] = STATE(1073),
    [sym_binary_expression] = STATE(1073),
    [sym_update_expression] = STATE(1073),
    [sym_cast_expression] = STATE(1073),
    [sym_sizeof_expression] = STATE(1073),
    [sym_alignof_expression] = STATE(1073),
    [sym_offsetof_expression] = STATE(1073),
    [sym_generic_expression] = STATE(1073),
    [sym_subscript_expression] = STATE(1073),
    [sym_call_expression] = STATE(1073),
    [sym_gnu_asm_expression] = STATE(1073),
    [sym_field_expression] = STATE(1073),
    [sym_compound_literal_expression] = STATE(1073),
    [sym_parenthesized_expression] = STATE(1073),
    [sym_initializer_list] = STATE(1053),
    [sym_char_literal] = STATE(1073),
    [sym_concatenated_string] = STATE(1073),
    [sym_string_literal] = STATE(910),
    [sym_null] = STATE(1073),
    [sym_identifier] = ACTIONS(1546),
    [anon_sym_COMMA] = ACTIONS(1540),
    [aux_sym_preproc_if_token2] = ACTIONS(1540),
    [aux_sym_preproc_else_token1] = ACTIONS(1540),
    [aux_sym_preproc_elif_token1] = ACTIONS(1540),
    [anon_sym_LPAREN2] = ACTIONS(1540),
    [anon_sym_BANG] = ACTIONS(1820),
    [anon_sym_TILDE] = ACTIONS(1822),
    [anon_sym_DASH] = ACTIONS(1546),
    [anon_sym_PLUS] = ACTIONS(1546),
    [anon_sym_STAR] = ACTIONS(1546),
    [anon_sym_SLASH] = ACTIONS(1546),
    [anon_sym_PERCENT] = ACTIONS(1546),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE] = ACTIONS(1546),
    [anon_sym_CARET] = ACTIONS(1546),
    [anon_sym_AMP] = ACTIONS(1546),
    [anon_sym_EQ_EQ] = ACTIONS(1540),
    [anon_sym_BANG_EQ] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1540),
    [anon_sym_LT_EQ] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1546),
    [anon_sym_GT_GT] = ACTIONS(1546),
    [anon_sym_LBRACE] = ACTIONS(1824),
    [anon_sym_LBRACK] = ACTIONS(1540),
    [anon_sym_EQ] = ACTIONS(1546),
    [anon_sym_QMARK] = ACTIONS(1540),
    [anon_sym_STAR_EQ] = ACTIONS(1540),
    [anon_sym_SLASH_EQ] = ACTIONS(1540),
    [anon_sym_PERCENT_EQ] = ACTIONS(1540),
    [anon_sym_PLUS_EQ] = ACTIONS(1540),
    [anon_sym_DASH_EQ] = ACTIONS(1540),
    [anon_sym_LT_LT_EQ] = ACTIONS(1540),
    [anon_sym_GT_GT_EQ] = ACTIONS(1540),
    [anon_sym_AMP_EQ] = ACTIONS(1540),
    [anon_sym_CARET_EQ] = ACTIONS(1540),
    [anon_sym_PIPE_EQ] = ACTIONS(1540),
    [anon_sym_DASH_DASH] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1540),
    [anon_sym_sizeof] = ACTIONS(1826),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym_DOT] = ACTIONS(1546),
    [anon_sym_DASH_GT] = ACTIONS(1540),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
  },
  [480] = {
    [sym_identifier] = ACTIONS(1486),
    [aux_sym_preproc_include_token1] = ACTIONS(1486),
    [aux_sym_preproc_def_token1] = ACTIONS(1486),
    [aux_sym_preproc_if_token1] = ACTIONS(1486),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1486),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1486),
    [sym_preproc_directive] = ACTIONS(1486),
    [anon_sym_LPAREN2] = ACTIONS(1488),
    [anon_sym_BANG] = ACTIONS(1488),
    [anon_sym_TILDE] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_STAR] = ACTIONS(1488),
    [anon_sym_AMP] = ACTIONS(1488),
    [anon_sym_SEMI] = ACTIONS(1488),
    [anon_sym___extension__] = ACTIONS(1486),
    [anon_sym_typedef] = ACTIONS(1486),
    [anon_sym_extern] = ACTIONS(1486),
    [anon_sym___attribute__] = ACTIONS(1486),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1488),
    [anon_sym___declspec] = ACTIONS(1486),
    [anon_sym___cdecl] = ACTIONS(1486),
    [anon_sym___clrcall] = ACTIONS(1486),
    [anon_sym___stdcall] = ACTIONS(1486),
    [anon_sym___fastcall] = ACTIONS(1486),
    [anon_sym___thiscall] = ACTIONS(1486),
    [anon_sym___vectorcall] = ACTIONS(1486),
    [anon_sym_LBRACE] = ACTIONS(1488),
    [anon_sym_RBRACE] = ACTIONS(1488),
    [anon_sym_signed] = ACTIONS(1486),
    [anon_sym_unsigned] = ACTIONS(1486),
    [anon_sym_long] = ACTIONS(1486),
    [anon_sym_short] = ACTIONS(1486),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_auto] = ACTIONS(1486),
    [anon_sym_register] = ACTIONS(1486),
    [anon_sym_inline] = ACTIONS(1486),
    [anon_sym___inline] = ACTIONS(1486),
    [anon_sym___inline__] = ACTIONS(1486),
    [anon_sym___forceinline] = ACTIONS(1486),
    [anon_sym_thread_local] = ACTIONS(1486),
    [anon_sym___thread] = ACTIONS(1486),
    [anon_sym_const] = ACTIONS(1486),
    [anon_sym_constexpr] = ACTIONS(1486),
    [anon_sym_volatile] = ACTIONS(1486),
    [anon_sym_restrict] = ACTIONS(1486),
    [anon_sym___restrict__] = ACTIONS(1486),
    [anon_sym__Atomic] = ACTIONS(1486),
    [anon_sym__Noreturn] = ACTIONS(1486),
    [anon_sym_noreturn] = ACTIONS(1486),
    [sym_primitive_type] = ACTIONS(1486),
    [anon_sym_enum] = ACTIONS(1486),
    [anon_sym_struct] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(1486),
    [anon_sym_if] = ACTIONS(1486),
    [anon_sym_switch] = ACTIONS(1486),
    [anon_sym_case] = ACTIONS(1486),
    [anon_sym_default] = ACTIONS(1486),
    [anon_sym_while] = ACTIONS(1486),
    [anon_sym_do] = ACTIONS(1486),
    [anon_sym_for] = ACTIONS(1486),
    [anon_sym_return] = ACTIONS(1486),
    [anon_sym_break] = ACTIONS(1486),
    [anon_sym_continue] = ACTIONS(1486),
    [anon_sym_goto] = ACTIONS(1486),
    [anon_sym___try] = ACTIONS(1486),
    [anon_sym___leave] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1488),
    [anon_sym_PLUS_PLUS] = ACTIONS(1488),
    [anon_sym_sizeof] = ACTIONS(1486),
    [anon_sym___alignof__] = ACTIONS(1486),
    [anon_sym___alignof] = ACTIONS(1486),
    [anon_sym__alignof] = ACTIONS(1486),
    [anon_sym_alignof] = ACTIONS(1486),
    [anon_sym__Alignof] = ACTIONS(1486),
    [anon_sym_offsetof] = ACTIONS(1486),
    [anon_sym__Generic] = ACTIONS(1486),
    [anon_sym_asm] = ACTIONS(1486),
    [anon_sym___asm__] = ACTIONS(1486),
    [sym_number_literal] = ACTIONS(1488),
    [anon_sym_L_SQUOTE] = ACTIONS(1488),
    [anon_sym_u_SQUOTE] = ACTIONS(1488),
    [anon_sym_U_SQUOTE] = ACTIONS(1488),
    [anon_sym_u8_SQUOTE] = ACTIONS(1488),
    [anon_sym_SQUOTE] = ACTIONS(1488),
    [anon_sym_L_DQUOTE] = ACTIONS(1488),
    [anon_sym_u_DQUOTE] = ACTIONS(1488),
    [anon_sym_U_DQUOTE] = ACTIONS(1488),
    [anon_sym_u8_DQUOTE] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(1488),
    [sym_true] = ACTIONS(1486),
    [sym_false] = ACTIONS(1486),
    [anon_sym_NULL] = ACTIONS(1486),
    [anon_sym_nullptr] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
  },
  [481] = {
    [sym_identifier] = ACTIONS(1482),
    [aux_sym_preproc_include_token1] = ACTIONS(1482),
    [aux_sym_preproc_def_token1] = ACTIONS(1482),
    [aux_sym_preproc_if_token1] = ACTIONS(1482),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1482),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1482),
    [sym_preproc_directive] = ACTIONS(1482),
    [anon_sym_LPAREN2] = ACTIONS(1484),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_TILDE] = ACTIONS(1484),
    [anon_sym_DASH] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_STAR] = ACTIONS(1484),
    [anon_sym_AMP] = ACTIONS(1484),
    [anon_sym_SEMI] = ACTIONS(1484),
    [anon_sym___extension__] = ACTIONS(1482),
    [anon_sym_typedef] = ACTIONS(1482),
    [anon_sym_extern] = ACTIONS(1482),
    [anon_sym___attribute__] = ACTIONS(1482),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1484),
    [anon_sym___declspec] = ACTIONS(1482),
    [anon_sym___cdecl] = ACTIONS(1482),
    [anon_sym___clrcall] = ACTIONS(1482),
    [anon_sym___stdcall] = ACTIONS(1482),
    [anon_sym___fastcall] = ACTIONS(1482),
    [anon_sym___thiscall] = ACTIONS(1482),
    [anon_sym___vectorcall] = ACTIONS(1482),
    [anon_sym_LBRACE] = ACTIONS(1484),
    [anon_sym_RBRACE] = ACTIONS(1484),
    [anon_sym_signed] = ACTIONS(1482),
    [anon_sym_unsigned] = ACTIONS(1482),
    [anon_sym_long] = ACTIONS(1482),
    [anon_sym_short] = ACTIONS(1482),
    [anon_sym_static] = ACTIONS(1482),
    [anon_sym_auto] = ACTIONS(1482),
    [anon_sym_register] = ACTIONS(1482),
    [anon_sym_inline] = ACTIONS(1482),
    [anon_sym___inline] = ACTIONS(1482),
    [anon_sym___inline__] = ACTIONS(1482),
    [anon_sym___forceinline] = ACTIONS(1482),
    [anon_sym_thread_local] = ACTIONS(1482),
    [anon_sym___thread] = ACTIONS(1482),
    [anon_sym_const] = ACTIONS(1482),
    [anon_sym_constexpr] = ACTIONS(1482),
    [anon_sym_volatile] = ACTIONS(1482),
    [anon_sym_restrict] = ACTIONS(1482),
    [anon_sym___restrict__] = ACTIONS(1482),
    [anon_sym__Atomic] = ACTIONS(1482),
    [anon_sym__Noreturn] = ACTIONS(1482),
    [anon_sym_noreturn] = ACTIONS(1482),
    [sym_primitive_type] = ACTIONS(1482),
    [anon_sym_enum] = ACTIONS(1482),
    [anon_sym_struct] = ACTIONS(1482),
    [anon_sym_union] = ACTIONS(1482),
    [anon_sym_if] = ACTIONS(1482),
    [anon_sym_switch] = ACTIONS(1482),
    [anon_sym_case] = ACTIONS(1482),
    [anon_sym_default] = ACTIONS(1482),
    [anon_sym_while] = ACTIONS(1482),
    [anon_sym_do] = ACTIONS(1482),
    [anon_sym_for] = ACTIONS(1482),
    [anon_sym_return] = ACTIONS(1482),
    [anon_sym_break] = ACTIONS(1482),
    [anon_sym_continue] = ACTIONS(1482),
    [anon_sym_goto] = ACTIONS(1482),
    [anon_sym___try] = ACTIONS(1482),
    [anon_sym___leave] = ACTIONS(1482),
    [anon_sym_DASH_DASH] = ACTIONS(1484),
    [anon_sym_PLUS_PLUS] = ACTIONS(1484),
    [anon_sym_sizeof] = ACTIONS(1482),
    [anon_sym___alignof__] = ACTIONS(1482),
    [anon_sym___alignof] = ACTIONS(1482),
    [anon_sym__alignof] = ACTIONS(1482),
    [anon_sym_alignof] = ACTIONS(1482),
    [anon_sym__Alignof] = ACTIONS(1482),
    [anon_sym_offsetof] = ACTIONS(1482),
    [anon_sym__Generic] = ACTIONS(1482),
    [anon_sym_asm] = ACTIONS(1482),
    [anon_sym___asm__] = ACTIONS(1482),
    [sym_number_literal] = ACTIONS(1484),
    [anon_sym_L_SQUOTE] = ACTIONS(1484),
    [anon_sym_u_SQUOTE] = ACTIONS(1484),
    [anon_sym_U_SQUOTE] = ACTIONS(1484),
    [anon_sym_u8_SQUOTE] = ACTIONS(1484),
    [anon_sym_SQUOTE] = ACTIONS(1484),
    [anon_sym_L_DQUOTE] = ACTIONS(1484),
    [anon_sym_u_DQUOTE] = ACTIONS(1484),
    [anon_sym_U_DQUOTE] = ACTIONS(1484),
    [anon_sym_u8_DQUOTE] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(1484),
    [sym_true] = ACTIONS(1482),
    [sym_false] = ACTIONS(1482),
    [anon_sym_NULL] = ACTIONS(1482),
    [anon_sym_nullptr] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
  },
  [482] = {
    [sym_identifier] = ACTIONS(1434),
    [aux_sym_preproc_include_token1] = ACTIONS(1434),
    [aux_sym_preproc_def_token1] = ACTIONS(1434),
    [aux_sym_preproc_if_token1] = ACTIONS(1434),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1434),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1434),
    [sym_preproc_directive] = ACTIONS(1434),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(1436),
    [anon_sym_TILDE] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_STAR] = ACTIONS(1436),
    [anon_sym_AMP] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1436),
    [anon_sym___extension__] = ACTIONS(1434),
    [anon_sym_typedef] = ACTIONS(1434),
    [anon_sym_extern] = ACTIONS(1434),
    [anon_sym___attribute__] = ACTIONS(1434),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1436),
    [anon_sym___declspec] = ACTIONS(1434),
    [anon_sym___cdecl] = ACTIONS(1434),
    [anon_sym___clrcall] = ACTIONS(1434),
    [anon_sym___stdcall] = ACTIONS(1434),
    [anon_sym___fastcall] = ACTIONS(1434),
    [anon_sym___thiscall] = ACTIONS(1434),
    [anon_sym___vectorcall] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1436),
    [anon_sym_RBRACE] = ACTIONS(1436),
    [anon_sym_signed] = ACTIONS(1434),
    [anon_sym_unsigned] = ACTIONS(1434),
    [anon_sym_long] = ACTIONS(1434),
    [anon_sym_short] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(1434),
    [anon_sym_auto] = ACTIONS(1434),
    [anon_sym_register] = ACTIONS(1434),
    [anon_sym_inline] = ACTIONS(1434),
    [anon_sym___inline] = ACTIONS(1434),
    [anon_sym___inline__] = ACTIONS(1434),
    [anon_sym___forceinline] = ACTIONS(1434),
    [anon_sym_thread_local] = ACTIONS(1434),
    [anon_sym___thread] = ACTIONS(1434),
    [anon_sym_const] = ACTIONS(1434),
    [anon_sym_constexpr] = ACTIONS(1434),
    [anon_sym_volatile] = ACTIONS(1434),
    [anon_sym_restrict] = ACTIONS(1434),
    [anon_sym___restrict__] = ACTIONS(1434),
    [anon_sym__Atomic] = ACTIONS(1434),
    [anon_sym__Noreturn] = ACTIONS(1434),
    [anon_sym_noreturn] = ACTIONS(1434),
    [sym_primitive_type] = ACTIONS(1434),
    [anon_sym_enum] = ACTIONS(1434),
    [anon_sym_struct] = ACTIONS(1434),
    [anon_sym_union] = ACTIONS(1434),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_switch] = ACTIONS(1434),
    [anon_sym_case] = ACTIONS(1434),
    [anon_sym_default] = ACTIONS(1434),
    [anon_sym_while] = ACTIONS(1434),
    [anon_sym_do] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1434),
    [anon_sym_return] = ACTIONS(1434),
    [anon_sym_break] = ACTIONS(1434),
    [anon_sym_continue] = ACTIONS(1434),
    [anon_sym_goto] = ACTIONS(1434),
    [anon_sym___try] = ACTIONS(1434),
    [anon_sym___leave] = ACTIONS(1434),
    [anon_sym_DASH_DASH] = ACTIONS(1436),
    [anon_sym_PLUS_PLUS] = ACTIONS(1436),
    [anon_sym_sizeof] = ACTIONS(1434),
    [anon_sym___alignof__] = ACTIONS(1434),
    [anon_sym___alignof] = ACTIONS(1434),
    [anon_sym__alignof] = ACTIONS(1434),
    [anon_sym_alignof] = ACTIONS(1434),
    [anon_sym__Alignof] = ACTIONS(1434),
    [anon_sym_offsetof] = ACTIONS(1434),
    [anon_sym__Generic] = ACTIONS(1434),
    [anon_sym_asm] = ACTIONS(1434),
    [anon_sym___asm__] = ACTIONS(1434),
    [sym_number_literal] = ACTIONS(1436),
    [anon_sym_L_SQUOTE] = ACTIONS(1436),
    [anon_sym_u_SQUOTE] = ACTIONS(1436),
    [anon_sym_U_SQUOTE] = ACTIONS(1436),
    [anon_sym_u8_SQUOTE] = ACTIONS(1436),
    [anon_sym_SQUOTE] = ACTIONS(1436),
    [anon_sym_L_DQUOTE] = ACTIONS(1436),
    [anon_sym_u_DQUOTE] = ACTIONS(1436),
    [anon_sym_U_DQUOTE] = ACTIONS(1436),
    [anon_sym_u8_DQUOTE] = ACTIONS(1436),
    [anon_sym_DQUOTE] = ACTIONS(1436),
    [sym_true] = ACTIONS(1434),
    [sym_false] = ACTIONS(1434),
    [anon_sym_NULL] = ACTIONS(1434),
    [anon_sym_nullptr] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
  },
  [483] = {
    [sym_identifier] = ACTIONS(1454),
    [aux_sym_preproc_include_token1] = ACTIONS(1454),
    [aux_sym_preproc_def_token1] = ACTIONS(1454),
    [aux_sym_preproc_if_token1] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1454),
    [sym_preproc_directive] = ACTIONS(1454),
    [anon_sym_LPAREN2] = ACTIONS(1456),
    [anon_sym_BANG] = ACTIONS(1456),
    [anon_sym_TILDE] = ACTIONS(1456),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_STAR] = ACTIONS(1456),
    [anon_sym_AMP] = ACTIONS(1456),
    [anon_sym_SEMI] = ACTIONS(1456),
    [anon_sym___extension__] = ACTIONS(1454),
    [anon_sym_typedef] = ACTIONS(1454),
    [anon_sym_extern] = ACTIONS(1454),
    [anon_sym___attribute__] = ACTIONS(1454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1456),
    [anon_sym___declspec] = ACTIONS(1454),
    [anon_sym___cdecl] = ACTIONS(1454),
    [anon_sym___clrcall] = ACTIONS(1454),
    [anon_sym___stdcall] = ACTIONS(1454),
    [anon_sym___fastcall] = ACTIONS(1454),
    [anon_sym___thiscall] = ACTIONS(1454),
    [anon_sym___vectorcall] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [anon_sym_RBRACE] = ACTIONS(1456),
    [anon_sym_signed] = ACTIONS(1454),
    [anon_sym_unsigned] = ACTIONS(1454),
    [anon_sym_long] = ACTIONS(1454),
    [anon_sym_short] = ACTIONS(1454),
    [anon_sym_static] = ACTIONS(1454),
    [anon_sym_auto] = ACTIONS(1454),
    [anon_sym_register] = ACTIONS(1454),
    [anon_sym_inline] = ACTIONS(1454),
    [anon_sym___inline] = ACTIONS(1454),
    [anon_sym___inline__] = ACTIONS(1454),
    [anon_sym___forceinline] = ACTIONS(1454),
    [anon_sym_thread_local] = ACTIONS(1454),
    [anon_sym___thread] = ACTIONS(1454),
    [anon_sym_const] = ACTIONS(1454),
    [anon_sym_constexpr] = ACTIONS(1454),
    [anon_sym_volatile] = ACTIONS(1454),
    [anon_sym_restrict] = ACTIONS(1454),
    [anon_sym___restrict__] = ACTIONS(1454),
    [anon_sym__Atomic] = ACTIONS(1454),
    [anon_sym__Noreturn] = ACTIONS(1454),
    [anon_sym_noreturn] = ACTIONS(1454),
    [sym_primitive_type] = ACTIONS(1454),
    [anon_sym_enum] = ACTIONS(1454),
    [anon_sym_struct] = ACTIONS(1454),
    [anon_sym_union] = ACTIONS(1454),
    [anon_sym_if] = ACTIONS(1454),
    [anon_sym_switch] = ACTIONS(1454),
    [anon_sym_case] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(1454),
    [anon_sym_do] = ACTIONS(1454),
    [anon_sym_for] = ACTIONS(1454),
    [anon_sym_return] = ACTIONS(1454),
    [anon_sym_break] = ACTIONS(1454),
    [anon_sym_continue] = ACTIONS(1454),
    [anon_sym_goto] = ACTIONS(1454),
    [anon_sym___try] = ACTIONS(1454),
    [anon_sym___leave] = ACTIONS(1454),
    [anon_sym_DASH_DASH] = ACTIONS(1456),
    [anon_sym_PLUS_PLUS] = ACTIONS(1456),
    [anon_sym_sizeof] = ACTIONS(1454),
    [anon_sym___alignof__] = ACTIONS(1454),
    [anon_sym___alignof] = ACTIONS(1454),
    [anon_sym__alignof] = ACTIONS(1454),
    [anon_sym_alignof] = ACTIONS(1454),
    [anon_sym__Alignof] = ACTIONS(1454),
    [anon_sym_offsetof] = ACTIONS(1454),
    [anon_sym__Generic] = ACTIONS(1454),
    [anon_sym_asm] = ACTIONS(1454),
    [anon_sym___asm__] = ACTIONS(1454),
    [sym_number_literal] = ACTIONS(1456),
    [anon_sym_L_SQUOTE] = ACTIONS(1456),
    [anon_sym_u_SQUOTE] = ACTIONS(1456),
    [anon_sym_U_SQUOTE] = ACTIONS(1456),
    [anon_sym_u8_SQUOTE] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(1456),
    [anon_sym_L_DQUOTE] = ACTIONS(1456),
    [anon_sym_u_DQUOTE] = ACTIONS(1456),
    [anon_sym_U_DQUOTE] = ACTIONS(1456),
    [anon_sym_u8_DQUOTE] = ACTIONS(1456),
    [anon_sym_DQUOTE] = ACTIONS(1456),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [anon_sym_NULL] = ACTIONS(1454),
    [anon_sym_nullptr] = ACTIONS(1454),
    [sym_comment] = ACTIONS(3),
  },
  [484] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(311),
    [sym_attributed_statement] = STATE(313),
    [sym_labeled_statement] = STATE(314),
    [sym_expression_statement] = STATE(316),
    [sym_if_statement] = STATE(317),
    [sym_switch_statement] = STATE(318),
    [sym_case_statement] = STATE(330),
    [sym_while_statement] = STATE(331),
    [sym_do_statement] = STATE(336),
    [sym_for_statement] = STATE(338),
    [sym_return_statement] = STATE(346),
    [sym_break_statement] = STATE(347),
    [sym_continue_statement] = STATE(365),
    [sym_goto_statement] = STATE(367),
    [sym_seh_try_statement] = STATE(368),
    [sym_seh_leave_statement] = STATE(369),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1566),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1278),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1568),
    [anon_sym_default] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1280),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1282),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1284),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [485] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(304),
    [sym_attributed_statement] = STATE(304),
    [sym_labeled_statement] = STATE(304),
    [sym_expression_statement] = STATE(304),
    [sym_if_statement] = STATE(304),
    [sym_switch_statement] = STATE(304),
    [sym_case_statement] = STATE(304),
    [sym_while_statement] = STATE(304),
    [sym_do_statement] = STATE(304),
    [sym_for_statement] = STATE(304),
    [sym_return_statement] = STATE(304),
    [sym_break_statement] = STATE(304),
    [sym_continue_statement] = STATE(304),
    [sym_goto_statement] = STATE(304),
    [sym_seh_try_statement] = STATE(304),
    [sym_seh_leave_statement] = STATE(304),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1566),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1278),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1568),
    [anon_sym_default] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1280),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1282),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1284),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [486] = {
    [sym_identifier] = ACTIONS(1514),
    [aux_sym_preproc_include_token1] = ACTIONS(1514),
    [aux_sym_preproc_def_token1] = ACTIONS(1514),
    [aux_sym_preproc_if_token1] = ACTIONS(1514),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1514),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1514),
    [sym_preproc_directive] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(1516),
    [anon_sym_BANG] = ACTIONS(1516),
    [anon_sym_TILDE] = ACTIONS(1516),
    [anon_sym_DASH] = ACTIONS(1514),
    [anon_sym_PLUS] = ACTIONS(1514),
    [anon_sym_STAR] = ACTIONS(1516),
    [anon_sym_AMP] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(1516),
    [anon_sym___extension__] = ACTIONS(1514),
    [anon_sym_typedef] = ACTIONS(1514),
    [anon_sym_extern] = ACTIONS(1514),
    [anon_sym___attribute__] = ACTIONS(1514),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym___declspec] = ACTIONS(1514),
    [anon_sym___cdecl] = ACTIONS(1514),
    [anon_sym___clrcall] = ACTIONS(1514),
    [anon_sym___stdcall] = ACTIONS(1514),
    [anon_sym___fastcall] = ACTIONS(1514),
    [anon_sym___thiscall] = ACTIONS(1514),
    [anon_sym___vectorcall] = ACTIONS(1514),
    [anon_sym_LBRACE] = ACTIONS(1516),
    [anon_sym_RBRACE] = ACTIONS(1516),
    [anon_sym_signed] = ACTIONS(1514),
    [anon_sym_unsigned] = ACTIONS(1514),
    [anon_sym_long] = ACTIONS(1514),
    [anon_sym_short] = ACTIONS(1514),
    [anon_sym_static] = ACTIONS(1514),
    [anon_sym_auto] = ACTIONS(1514),
    [anon_sym_register] = ACTIONS(1514),
    [anon_sym_inline] = ACTIONS(1514),
    [anon_sym___inline] = ACTIONS(1514),
    [anon_sym___inline__] = ACTIONS(1514),
    [anon_sym___forceinline] = ACTIONS(1514),
    [anon_sym_thread_local] = ACTIONS(1514),
    [anon_sym___thread] = ACTIONS(1514),
    [anon_sym_const] = ACTIONS(1514),
    [anon_sym_constexpr] = ACTIONS(1514),
    [anon_sym_volatile] = ACTIONS(1514),
    [anon_sym_restrict] = ACTIONS(1514),
    [anon_sym___restrict__] = ACTIONS(1514),
    [anon_sym__Atomic] = ACTIONS(1514),
    [anon_sym__Noreturn] = ACTIONS(1514),
    [anon_sym_noreturn] = ACTIONS(1514),
    [sym_primitive_type] = ACTIONS(1514),
    [anon_sym_enum] = ACTIONS(1514),
    [anon_sym_struct] = ACTIONS(1514),
    [anon_sym_union] = ACTIONS(1514),
    [anon_sym_if] = ACTIONS(1514),
    [anon_sym_switch] = ACTIONS(1514),
    [anon_sym_case] = ACTIONS(1514),
    [anon_sym_default] = ACTIONS(1514),
    [anon_sym_while] = ACTIONS(1514),
    [anon_sym_do] = ACTIONS(1514),
    [anon_sym_for] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1514),
    [anon_sym_break] = ACTIONS(1514),
    [anon_sym_continue] = ACTIONS(1514),
    [anon_sym_goto] = ACTIONS(1514),
    [anon_sym___try] = ACTIONS(1514),
    [anon_sym___leave] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1516),
    [anon_sym_PLUS_PLUS] = ACTIONS(1516),
    [anon_sym_sizeof] = ACTIONS(1514),
    [anon_sym___alignof__] = ACTIONS(1514),
    [anon_sym___alignof] = ACTIONS(1514),
    [anon_sym__alignof] = ACTIONS(1514),
    [anon_sym_alignof] = ACTIONS(1514),
    [anon_sym__Alignof] = ACTIONS(1514),
    [anon_sym_offsetof] = ACTIONS(1514),
    [anon_sym__Generic] = ACTIONS(1514),
    [anon_sym_asm] = ACTIONS(1514),
    [anon_sym___asm__] = ACTIONS(1514),
    [sym_number_literal] = ACTIONS(1516),
    [anon_sym_L_SQUOTE] = ACTIONS(1516),
    [anon_sym_u_SQUOTE] = ACTIONS(1516),
    [anon_sym_U_SQUOTE] = ACTIONS(1516),
    [anon_sym_u8_SQUOTE] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1516),
    [anon_sym_L_DQUOTE] = ACTIONS(1516),
    [anon_sym_u_DQUOTE] = ACTIONS(1516),
    [anon_sym_U_DQUOTE] = ACTIONS(1516),
    [anon_sym_u8_DQUOTE] = ACTIONS(1516),
    [anon_sym_DQUOTE] = ACTIONS(1516),
    [sym_true] = ACTIONS(1514),
    [sym_false] = ACTIONS(1514),
    [anon_sym_NULL] = ACTIONS(1514),
    [anon_sym_nullptr] = ACTIONS(1514),
    [sym_comment] = ACTIONS(3),
  },
  [487] = {
    [sym_attribute_declaration] = STATE(463),
    [sym_compound_statement] = STATE(311),
    [sym_attributed_statement] = STATE(313),
    [sym_labeled_statement] = STATE(314),
    [sym_expression_statement] = STATE(316),
    [sym_if_statement] = STATE(317),
    [sym_switch_statement] = STATE(318),
    [sym_case_statement] = STATE(330),
    [sym_while_statement] = STATE(331),
    [sym_do_statement] = STATE(336),
    [sym_for_statement] = STATE(338),
    [sym_return_statement] = STATE(346),
    [sym_break_statement] = STATE(347),
    [sym_continue_statement] = STATE(365),
    [sym_goto_statement] = STATE(367),
    [sym_seh_try_statement] = STATE(368),
    [sym_seh_leave_statement] = STATE(369),
    [sym__expression] = STATE(1348),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2343),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(463),
    [sym_identifier] = ACTIONS(1574),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1101),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_default] = ACTIONS(63),
    [anon_sym_while] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(69),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1103),
    [anon_sym___leave] = ACTIONS(1105),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [488] = {
    [sym_attribute_declaration] = STATE(488),
    [sym_compound_statement] = STATE(301),
    [sym_attributed_statement] = STATE(301),
    [sym_labeled_statement] = STATE(301),
    [sym_expression_statement] = STATE(301),
    [sym_if_statement] = STATE(301),
    [sym_switch_statement] = STATE(301),
    [sym_case_statement] = STATE(301),
    [sym_while_statement] = STATE(301),
    [sym_do_statement] = STATE(301),
    [sym_for_statement] = STATE(301),
    [sym_return_statement] = STATE(301),
    [sym_break_statement] = STATE(301),
    [sym_continue_statement] = STATE(301),
    [sym_goto_statement] = STATE(301),
    [sym_seh_try_statement] = STATE(301),
    [sym_seh_leave_statement] = STATE(301),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(488),
    [sym_identifier] = ACTIONS(1846),
    [anon_sym_LPAREN2] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1582),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1588),
    [anon_sym_SEMI] = ACTIONS(1775),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1594),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_if] = ACTIONS(1849),
    [anon_sym_switch] = ACTIONS(1684),
    [anon_sym_case] = ACTIONS(1852),
    [anon_sym_default] = ACTIONS(1855),
    [anon_sym_while] = ACTIONS(1858),
    [anon_sym_do] = ACTIONS(1696),
    [anon_sym_for] = ACTIONS(1861),
    [anon_sym_return] = ACTIONS(1702),
    [anon_sym_break] = ACTIONS(1705),
    [anon_sym_continue] = ACTIONS(1708),
    [anon_sym_goto] = ACTIONS(1711),
    [anon_sym___try] = ACTIONS(1864),
    [anon_sym___leave] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1639),
    [anon_sym_PLUS_PLUS] = ACTIONS(1639),
    [anon_sym_sizeof] = ACTIONS(1642),
    [anon_sym___alignof__] = ACTIONS(1645),
    [anon_sym___alignof] = ACTIONS(1645),
    [anon_sym__alignof] = ACTIONS(1645),
    [anon_sym_alignof] = ACTIONS(1645),
    [anon_sym__Alignof] = ACTIONS(1645),
    [anon_sym_offsetof] = ACTIONS(1648),
    [anon_sym__Generic] = ACTIONS(1651),
    [anon_sym_asm] = ACTIONS(1654),
    [anon_sym___asm__] = ACTIONS(1654),
    [sym_number_literal] = ACTIONS(1657),
    [anon_sym_L_SQUOTE] = ACTIONS(1660),
    [anon_sym_u_SQUOTE] = ACTIONS(1660),
    [anon_sym_U_SQUOTE] = ACTIONS(1660),
    [anon_sym_u8_SQUOTE] = ACTIONS(1660),
    [anon_sym_SQUOTE] = ACTIONS(1660),
    [anon_sym_L_DQUOTE] = ACTIONS(1663),
    [anon_sym_u_DQUOTE] = ACTIONS(1663),
    [anon_sym_U_DQUOTE] = ACTIONS(1663),
    [anon_sym_u8_DQUOTE] = ACTIONS(1663),
    [anon_sym_DQUOTE] = ACTIONS(1663),
    [sym_true] = ACTIONS(1666),
    [sym_false] = ACTIONS(1666),
    [anon_sym_NULL] = ACTIONS(1669),
    [anon_sym_nullptr] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
  },
  [489] = {
    [sym_identifier] = ACTIONS(1510),
    [aux_sym_preproc_include_token1] = ACTIONS(1510),
    [aux_sym_preproc_def_token1] = ACTIONS(1510),
    [aux_sym_preproc_if_token1] = ACTIONS(1510),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1510),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1510),
    [sym_preproc_directive] = ACTIONS(1510),
    [anon_sym_LPAREN2] = ACTIONS(1512),
    [anon_sym_BANG] = ACTIONS(1512),
    [anon_sym_TILDE] = ACTIONS(1512),
    [anon_sym_DASH] = ACTIONS(1510),
    [anon_sym_PLUS] = ACTIONS(1510),
    [anon_sym_STAR] = ACTIONS(1512),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym_SEMI] = ACTIONS(1512),
    [anon_sym___extension__] = ACTIONS(1510),
    [anon_sym_typedef] = ACTIONS(1510),
    [anon_sym_extern] = ACTIONS(1510),
    [anon_sym___attribute__] = ACTIONS(1510),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1512),
    [anon_sym___declspec] = ACTIONS(1510),
    [anon_sym___cdecl] = ACTIONS(1510),
    [anon_sym___clrcall] = ACTIONS(1510),
    [anon_sym___stdcall] = ACTIONS(1510),
    [anon_sym___fastcall] = ACTIONS(1510),
    [anon_sym___thiscall] = ACTIONS(1510),
    [anon_sym___vectorcall] = ACTIONS(1510),
    [anon_sym_LBRACE] = ACTIONS(1512),
    [anon_sym_RBRACE] = ACTIONS(1512),
    [anon_sym_signed] = ACTIONS(1510),
    [anon_sym_unsigned] = ACTIONS(1510),
    [anon_sym_long] = ACTIONS(1510),
    [anon_sym_short] = ACTIONS(1510),
    [anon_sym_static] = ACTIONS(1510),
    [anon_sym_auto] = ACTIONS(1510),
    [anon_sym_register] = ACTIONS(1510),
    [anon_sym_inline] = ACTIONS(1510),
    [anon_sym___inline] = ACTIONS(1510),
    [anon_sym___inline__] = ACTIONS(1510),
    [anon_sym___forceinline] = ACTIONS(1510),
    [anon_sym_thread_local] = ACTIONS(1510),
    [anon_sym___thread] = ACTIONS(1510),
    [anon_sym_const] = ACTIONS(1510),
    [anon_sym_constexpr] = ACTIONS(1510),
    [anon_sym_volatile] = ACTIONS(1510),
    [anon_sym_restrict] = ACTIONS(1510),
    [anon_sym___restrict__] = ACTIONS(1510),
    [anon_sym__Atomic] = ACTIONS(1510),
    [anon_sym__Noreturn] = ACTIONS(1510),
    [anon_sym_noreturn] = ACTIONS(1510),
    [sym_primitive_type] = ACTIONS(1510),
    [anon_sym_enum] = ACTIONS(1510),
    [anon_sym_struct] = ACTIONS(1510),
    [anon_sym_union] = ACTIONS(1510),
    [anon_sym_if] = ACTIONS(1510),
    [anon_sym_switch] = ACTIONS(1510),
    [anon_sym_case] = ACTIONS(1510),
    [anon_sym_default] = ACTIONS(1510),
    [anon_sym_while] = ACTIONS(1510),
    [anon_sym_do] = ACTIONS(1510),
    [anon_sym_for] = ACTIONS(1510),
    [anon_sym_return] = ACTIONS(1510),
    [anon_sym_break] = ACTIONS(1510),
    [anon_sym_continue] = ACTIONS(1510),
    [anon_sym_goto] = ACTIONS(1510),
    [anon_sym___try] = ACTIONS(1510),
    [anon_sym___leave] = ACTIONS(1510),
    [anon_sym_DASH_DASH] = ACTIONS(1512),
    [anon_sym_PLUS_PLUS] = ACTIONS(1512),
    [anon_sym_sizeof] = ACTIONS(1510),
    [anon_sym___alignof__] = ACTIONS(1510),
    [anon_sym___alignof] = ACTIONS(1510),
    [anon_sym__alignof] = ACTIONS(1510),
    [anon_sym_alignof] = ACTIONS(1510),
    [anon_sym__Alignof] = ACTIONS(1510),
    [anon_sym_offsetof] = ACTIONS(1510),
    [anon_sym__Generic] = ACTIONS(1510),
    [anon_sym_asm] = ACTIONS(1510),
    [anon_sym___asm__] = ACTIONS(1510),
    [sym_number_literal] = ACTIONS(1512),
    [anon_sym_L_SQUOTE] = ACTIONS(1512),
    [anon_sym_u_SQUOTE] = ACTIONS(1512),
    [anon_sym_U_SQUOTE] = ACTIONS(1512),
    [anon_sym_u8_SQUOTE] = ACTIONS(1512),
    [anon_sym_SQUOTE] = ACTIONS(1512),
    [anon_sym_L_DQUOTE] = ACTIONS(1512),
    [anon_sym_u_DQUOTE] = ACTIONS(1512),
    [anon_sym_U_DQUOTE] = ACTIONS(1512),
    [anon_sym_u8_DQUOTE] = ACTIONS(1512),
    [anon_sym_DQUOTE] = ACTIONS(1512),
    [sym_true] = ACTIONS(1510),
    [sym_false] = ACTIONS(1510),
    [anon_sym_NULL] = ACTIONS(1510),
    [anon_sym_nullptr] = ACTIONS(1510),
    [sym_comment] = ACTIONS(3),
  },
  [490] = {
    [sym_identifier] = ACTIONS(1458),
    [aux_sym_preproc_include_token1] = ACTIONS(1458),
    [aux_sym_preproc_def_token1] = ACTIONS(1458),
    [aux_sym_preproc_if_token1] = ACTIONS(1458),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1458),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1458),
    [sym_preproc_directive] = ACTIONS(1458),
    [anon_sym_LPAREN2] = ACTIONS(1460),
    [anon_sym_BANG] = ACTIONS(1460),
    [anon_sym_TILDE] = ACTIONS(1460),
    [anon_sym_DASH] = ACTIONS(1458),
    [anon_sym_PLUS] = ACTIONS(1458),
    [anon_sym_STAR] = ACTIONS(1460),
    [anon_sym_AMP] = ACTIONS(1460),
    [anon_sym_SEMI] = ACTIONS(1460),
    [anon_sym___extension__] = ACTIONS(1458),
    [anon_sym_typedef] = ACTIONS(1458),
    [anon_sym_extern] = ACTIONS(1458),
    [anon_sym___attribute__] = ACTIONS(1458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1460),
    [anon_sym___declspec] = ACTIONS(1458),
    [anon_sym___cdecl] = ACTIONS(1458),
    [anon_sym___clrcall] = ACTIONS(1458),
    [anon_sym___stdcall] = ACTIONS(1458),
    [anon_sym___fastcall] = ACTIONS(1458),
    [anon_sym___thiscall] = ACTIONS(1458),
    [anon_sym___vectorcall] = ACTIONS(1458),
    [anon_sym_LBRACE] = ACTIONS(1460),
    [anon_sym_RBRACE] = ACTIONS(1460),
    [anon_sym_signed] = ACTIONS(1458),
    [anon_sym_unsigned] = ACTIONS(1458),
    [anon_sym_long] = ACTIONS(1458),
    [anon_sym_short] = ACTIONS(1458),
    [anon_sym_static] = ACTIONS(1458),
    [anon_sym_auto] = ACTIONS(1458),
    [anon_sym_register] = ACTIONS(1458),
    [anon_sym_inline] = ACTIONS(1458),
    [anon_sym___inline] = ACTIONS(1458),
    [anon_sym___inline__] = ACTIONS(1458),
    [anon_sym___forceinline] = ACTIONS(1458),
    [anon_sym_thread_local] = ACTIONS(1458),
    [anon_sym___thread] = ACTIONS(1458),
    [anon_sym_const] = ACTIONS(1458),
    [anon_sym_constexpr] = ACTIONS(1458),
    [anon_sym_volatile] = ACTIONS(1458),
    [anon_sym_restrict] = ACTIONS(1458),
    [anon_sym___restrict__] = ACTIONS(1458),
    [anon_sym__Atomic] = ACTIONS(1458),
    [anon_sym__Noreturn] = ACTIONS(1458),
    [anon_sym_noreturn] = ACTIONS(1458),
    [sym_primitive_type] = ACTIONS(1458),
    [anon_sym_enum] = ACTIONS(1458),
    [anon_sym_struct] = ACTIONS(1458),
    [anon_sym_union] = ACTIONS(1458),
    [anon_sym_if] = ACTIONS(1458),
    [anon_sym_switch] = ACTIONS(1458),
    [anon_sym_case] = ACTIONS(1458),
    [anon_sym_default] = ACTIONS(1458),
    [anon_sym_while] = ACTIONS(1458),
    [anon_sym_do] = ACTIONS(1458),
    [anon_sym_for] = ACTIONS(1458),
    [anon_sym_return] = ACTIONS(1458),
    [anon_sym_break] = ACTIONS(1458),
    [anon_sym_continue] = ACTIONS(1458),
    [anon_sym_goto] = ACTIONS(1458),
    [anon_sym___try] = ACTIONS(1458),
    [anon_sym___leave] = ACTIONS(1458),
    [anon_sym_DASH_DASH] = ACTIONS(1460),
    [anon_sym_PLUS_PLUS] = ACTIONS(1460),
    [anon_sym_sizeof] = ACTIONS(1458),
    [anon_sym___alignof__] = ACTIONS(1458),
    [anon_sym___alignof] = ACTIONS(1458),
    [anon_sym__alignof] = ACTIONS(1458),
    [anon_sym_alignof] = ACTIONS(1458),
    [anon_sym__Alignof] = ACTIONS(1458),
    [anon_sym_offsetof] = ACTIONS(1458),
    [anon_sym__Generic] = ACTIONS(1458),
    [anon_sym_asm] = ACTIONS(1458),
    [anon_sym___asm__] = ACTIONS(1458),
    [sym_number_literal] = ACTIONS(1460),
    [anon_sym_L_SQUOTE] = ACTIONS(1460),
    [anon_sym_u_SQUOTE] = ACTIONS(1460),
    [anon_sym_U_SQUOTE] = ACTIONS(1460),
    [anon_sym_u8_SQUOTE] = ACTIONS(1460),
    [anon_sym_SQUOTE] = ACTIONS(1460),
    [anon_sym_L_DQUOTE] = ACTIONS(1460),
    [anon_sym_u_DQUOTE] = ACTIONS(1460),
    [anon_sym_U_DQUOTE] = ACTIONS(1460),
    [anon_sym_u8_DQUOTE] = ACTIONS(1460),
    [anon_sym_DQUOTE] = ACTIONS(1460),
    [sym_true] = ACTIONS(1458),
    [sym_false] = ACTIONS(1458),
    [anon_sym_NULL] = ACTIONS(1458),
    [anon_sym_nullptr] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
  },
  [491] = {
    [sym_identifier] = ACTIONS(1506),
    [aux_sym_preproc_include_token1] = ACTIONS(1506),
    [aux_sym_preproc_def_token1] = ACTIONS(1506),
    [aux_sym_preproc_if_token1] = ACTIONS(1506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1506),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1506),
    [sym_preproc_directive] = ACTIONS(1506),
    [anon_sym_LPAREN2] = ACTIONS(1508),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_TILDE] = ACTIONS(1508),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_typedef] = ACTIONS(1506),
    [anon_sym_extern] = ACTIONS(1506),
    [anon_sym___attribute__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym___declspec] = ACTIONS(1506),
    [anon_sym___cdecl] = ACTIONS(1506),
    [anon_sym___clrcall] = ACTIONS(1506),
    [anon_sym___stdcall] = ACTIONS(1506),
    [anon_sym___fastcall] = ACTIONS(1506),
    [anon_sym___thiscall] = ACTIONS(1506),
    [anon_sym___vectorcall] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1508),
    [anon_sym_RBRACE] = ACTIONS(1508),
    [anon_sym_signed] = ACTIONS(1506),
    [anon_sym_unsigned] = ACTIONS(1506),
    [anon_sym_long] = ACTIONS(1506),
    [anon_sym_short] = ACTIONS(1506),
    [anon_sym_static] = ACTIONS(1506),
    [anon_sym_auto] = ACTIONS(1506),
    [anon_sym_register] = ACTIONS(1506),
    [anon_sym_inline] = ACTIONS(1506),
    [anon_sym___inline] = ACTIONS(1506),
    [anon_sym___inline__] = ACTIONS(1506),
    [anon_sym___forceinline] = ACTIONS(1506),
    [anon_sym_thread_local] = ACTIONS(1506),
    [anon_sym___thread] = ACTIONS(1506),
    [anon_sym_const] = ACTIONS(1506),
    [anon_sym_constexpr] = ACTIONS(1506),
    [anon_sym_volatile] = ACTIONS(1506),
    [anon_sym_restrict] = ACTIONS(1506),
    [anon_sym___restrict__] = ACTIONS(1506),
    [anon_sym__Atomic] = ACTIONS(1506),
    [anon_sym__Noreturn] = ACTIONS(1506),
    [anon_sym_noreturn] = ACTIONS(1506),
    [sym_primitive_type] = ACTIONS(1506),
    [anon_sym_enum] = ACTIONS(1506),
    [anon_sym_struct] = ACTIONS(1506),
    [anon_sym_union] = ACTIONS(1506),
    [anon_sym_if] = ACTIONS(1506),
    [anon_sym_switch] = ACTIONS(1506),
    [anon_sym_case] = ACTIONS(1506),
    [anon_sym_default] = ACTIONS(1506),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_do] = ACTIONS(1506),
    [anon_sym_for] = ACTIONS(1506),
    [anon_sym_return] = ACTIONS(1506),
    [anon_sym_break] = ACTIONS(1506),
    [anon_sym_continue] = ACTIONS(1506),
    [anon_sym_goto] = ACTIONS(1506),
    [anon_sym___try] = ACTIONS(1506),
    [anon_sym___leave] = ACTIONS(1506),
    [anon_sym_DASH_DASH] = ACTIONS(1508),
    [anon_sym_PLUS_PLUS] = ACTIONS(1508),
    [anon_sym_sizeof] = ACTIONS(1506),
    [anon_sym___alignof__] = ACTIONS(1506),
    [anon_sym___alignof] = ACTIONS(1506),
    [anon_sym__alignof] = ACTIONS(1506),
    [anon_sym_alignof] = ACTIONS(1506),
    [anon_sym__Alignof] = ACTIONS(1506),
    [anon_sym_offsetof] = ACTIONS(1506),
    [anon_sym__Generic] = ACTIONS(1506),
    [anon_sym_asm] = ACTIONS(1506),
    [anon_sym___asm__] = ACTIONS(1506),
    [sym_number_literal] = ACTIONS(1508),
    [anon_sym_L_SQUOTE] = ACTIONS(1508),
    [anon_sym_u_SQUOTE] = ACTIONS(1508),
    [anon_sym_U_SQUOTE] = ACTIONS(1508),
    [anon_sym_u8_SQUOTE] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1508),
    [anon_sym_L_DQUOTE] = ACTIONS(1508),
    [anon_sym_u_DQUOTE] = ACTIONS(1508),
    [anon_sym_U_DQUOTE] = ACTIONS(1508),
    [anon_sym_u8_DQUOTE] = ACTIONS(1508),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_true] = ACTIONS(1506),
    [sym_false] = ACTIONS(1506),
    [anon_sym_NULL] = ACTIONS(1506),
    [anon_sym_nullptr] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
  },
  [492] = {
    [sym_identifier] = ACTIONS(1494),
    [aux_sym_preproc_include_token1] = ACTIONS(1494),
    [aux_sym_preproc_def_token1] = ACTIONS(1494),
    [aux_sym_preproc_if_token1] = ACTIONS(1494),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1494),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1494),
    [sym_preproc_directive] = ACTIONS(1494),
    [anon_sym_LPAREN2] = ACTIONS(1496),
    [anon_sym_BANG] = ACTIONS(1496),
    [anon_sym_TILDE] = ACTIONS(1496),
    [anon_sym_DASH] = ACTIONS(1494),
    [anon_sym_PLUS] = ACTIONS(1494),
    [anon_sym_STAR] = ACTIONS(1496),
    [anon_sym_AMP] = ACTIONS(1496),
    [anon_sym_SEMI] = ACTIONS(1496),
    [anon_sym___extension__] = ACTIONS(1494),
    [anon_sym_typedef] = ACTIONS(1494),
    [anon_sym_extern] = ACTIONS(1494),
    [anon_sym___attribute__] = ACTIONS(1494),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1496),
    [anon_sym___declspec] = ACTIONS(1494),
    [anon_sym___cdecl] = ACTIONS(1494),
    [anon_sym___clrcall] = ACTIONS(1494),
    [anon_sym___stdcall] = ACTIONS(1494),
    [anon_sym___fastcall] = ACTIONS(1494),
    [anon_sym___thiscall] = ACTIONS(1494),
    [anon_sym___vectorcall] = ACTIONS(1494),
    [anon_sym_LBRACE] = ACTIONS(1496),
    [anon_sym_RBRACE] = ACTIONS(1496),
    [anon_sym_signed] = ACTIONS(1494),
    [anon_sym_unsigned] = ACTIONS(1494),
    [anon_sym_long] = ACTIONS(1494),
    [anon_sym_short] = ACTIONS(1494),
    [anon_sym_static] = ACTIONS(1494),
    [anon_sym_auto] = ACTIONS(1494),
    [anon_sym_register] = ACTIONS(1494),
    [anon_sym_inline] = ACTIONS(1494),
    [anon_sym___inline] = ACTIONS(1494),
    [anon_sym___inline__] = ACTIONS(1494),
    [anon_sym___forceinline] = ACTIONS(1494),
    [anon_sym_thread_local] = ACTIONS(1494),
    [anon_sym___thread] = ACTIONS(1494),
    [anon_sym_const] = ACTIONS(1494),
    [anon_sym_constexpr] = ACTIONS(1494),
    [anon_sym_volatile] = ACTIONS(1494),
    [anon_sym_restrict] = ACTIONS(1494),
    [anon_sym___restrict__] = ACTIONS(1494),
    [anon_sym__Atomic] = ACTIONS(1494),
    [anon_sym__Noreturn] = ACTIONS(1494),
    [anon_sym_noreturn] = ACTIONS(1494),
    [sym_primitive_type] = ACTIONS(1494),
    [anon_sym_enum] = ACTIONS(1494),
    [anon_sym_struct] = ACTIONS(1494),
    [anon_sym_union] = ACTIONS(1494),
    [anon_sym_if] = ACTIONS(1494),
    [anon_sym_switch] = ACTIONS(1494),
    [anon_sym_case] = ACTIONS(1494),
    [anon_sym_default] = ACTIONS(1494),
    [anon_sym_while] = ACTIONS(1494),
    [anon_sym_do] = ACTIONS(1494),
    [anon_sym_for] = ACTIONS(1494),
    [anon_sym_return] = ACTIONS(1494),
    [anon_sym_break] = ACTIONS(1494),
    [anon_sym_continue] = ACTIONS(1494),
    [anon_sym_goto] = ACTIONS(1494),
    [anon_sym___try] = ACTIONS(1494),
    [anon_sym___leave] = ACTIONS(1494),
    [anon_sym_DASH_DASH] = ACTIONS(1496),
    [anon_sym_PLUS_PLUS] = ACTIONS(1496),
    [anon_sym_sizeof] = ACTIONS(1494),
    [anon_sym___alignof__] = ACTIONS(1494),
    [anon_sym___alignof] = ACTIONS(1494),
    [anon_sym__alignof] = ACTIONS(1494),
    [anon_sym_alignof] = ACTIONS(1494),
    [anon_sym__Alignof] = ACTIONS(1494),
    [anon_sym_offsetof] = ACTIONS(1494),
    [anon_sym__Generic] = ACTIONS(1494),
    [anon_sym_asm] = ACTIONS(1494),
    [anon_sym___asm__] = ACTIONS(1494),
    [sym_number_literal] = ACTIONS(1496),
    [anon_sym_L_SQUOTE] = ACTIONS(1496),
    [anon_sym_u_SQUOTE] = ACTIONS(1496),
    [anon_sym_U_SQUOTE] = ACTIONS(1496),
    [anon_sym_u8_SQUOTE] = ACTIONS(1496),
    [anon_sym_SQUOTE] = ACTIONS(1496),
    [anon_sym_L_DQUOTE] = ACTIONS(1496),
    [anon_sym_u_DQUOTE] = ACTIONS(1496),
    [anon_sym_U_DQUOTE] = ACTIONS(1496),
    [anon_sym_u8_DQUOTE] = ACTIONS(1496),
    [anon_sym_DQUOTE] = ACTIONS(1496),
    [sym_true] = ACTIONS(1494),
    [sym_false] = ACTIONS(1494),
    [anon_sym_NULL] = ACTIONS(1494),
    [anon_sym_nullptr] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
  },
  [493] = {
    [sym_identifier] = ACTIONS(1474),
    [aux_sym_preproc_include_token1] = ACTIONS(1474),
    [aux_sym_preproc_def_token1] = ACTIONS(1474),
    [aux_sym_preproc_if_token1] = ACTIONS(1474),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1474),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1474),
    [sym_preproc_directive] = ACTIONS(1474),
    [anon_sym_LPAREN2] = ACTIONS(1476),
    [anon_sym_BANG] = ACTIONS(1476),
    [anon_sym_TILDE] = ACTIONS(1476),
    [anon_sym_DASH] = ACTIONS(1474),
    [anon_sym_PLUS] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_SEMI] = ACTIONS(1476),
    [anon_sym___extension__] = ACTIONS(1474),
    [anon_sym_typedef] = ACTIONS(1474),
    [anon_sym_extern] = ACTIONS(1474),
    [anon_sym___attribute__] = ACTIONS(1474),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1476),
    [anon_sym___declspec] = ACTIONS(1474),
    [anon_sym___cdecl] = ACTIONS(1474),
    [anon_sym___clrcall] = ACTIONS(1474),
    [anon_sym___stdcall] = ACTIONS(1474),
    [anon_sym___fastcall] = ACTIONS(1474),
    [anon_sym___thiscall] = ACTIONS(1474),
    [anon_sym___vectorcall] = ACTIONS(1474),
    [anon_sym_LBRACE] = ACTIONS(1476),
    [anon_sym_RBRACE] = ACTIONS(1476),
    [anon_sym_signed] = ACTIONS(1474),
    [anon_sym_unsigned] = ACTIONS(1474),
    [anon_sym_long] = ACTIONS(1474),
    [anon_sym_short] = ACTIONS(1474),
    [anon_sym_static] = ACTIONS(1474),
    [anon_sym_auto] = ACTIONS(1474),
    [anon_sym_register] = ACTIONS(1474),
    [anon_sym_inline] = ACTIONS(1474),
    [anon_sym___inline] = ACTIONS(1474),
    [anon_sym___inline__] = ACTIONS(1474),
    [anon_sym___forceinline] = ACTIONS(1474),
    [anon_sym_thread_local] = ACTIONS(1474),
    [anon_sym___thread] = ACTIONS(1474),
    [anon_sym_const] = ACTIONS(1474),
    [anon_sym_constexpr] = ACTIONS(1474),
    [anon_sym_volatile] = ACTIONS(1474),
    [anon_sym_restrict] = ACTIONS(1474),
    [anon_sym___restrict__] = ACTIONS(1474),
    [anon_sym__Atomic] = ACTIONS(1474),
    [anon_sym__Noreturn] = ACTIONS(1474),
    [anon_sym_noreturn] = ACTIONS(1474),
    [sym_primitive_type] = ACTIONS(1474),
    [anon_sym_enum] = ACTIONS(1474),
    [anon_sym_struct] = ACTIONS(1474),
    [anon_sym_union] = ACTIONS(1474),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_switch] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1474),
    [anon_sym_default] = ACTIONS(1474),
    [anon_sym_while] = ACTIONS(1474),
    [anon_sym_do] = ACTIONS(1474),
    [anon_sym_for] = ACTIONS(1474),
    [anon_sym_return] = ACTIONS(1474),
    [anon_sym_break] = ACTIONS(1474),
    [anon_sym_continue] = ACTIONS(1474),
    [anon_sym_goto] = ACTIONS(1474),
    [anon_sym___try] = ACTIONS(1474),
    [anon_sym___leave] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1476),
    [anon_sym_PLUS_PLUS] = ACTIONS(1476),
    [anon_sym_sizeof] = ACTIONS(1474),
    [anon_sym___alignof__] = ACTIONS(1474),
    [anon_sym___alignof] = ACTIONS(1474),
    [anon_sym__alignof] = ACTIONS(1474),
    [anon_sym_alignof] = ACTIONS(1474),
    [anon_sym__Alignof] = ACTIONS(1474),
    [anon_sym_offsetof] = ACTIONS(1474),
    [anon_sym__Generic] = ACTIONS(1474),
    [anon_sym_asm] = ACTIONS(1474),
    [anon_sym___asm__] = ACTIONS(1474),
    [sym_number_literal] = ACTIONS(1476),
    [anon_sym_L_SQUOTE] = ACTIONS(1476),
    [anon_sym_u_SQUOTE] = ACTIONS(1476),
    [anon_sym_U_SQUOTE] = ACTIONS(1476),
    [anon_sym_u8_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1476),
    [anon_sym_L_DQUOTE] = ACTIONS(1476),
    [anon_sym_u_DQUOTE] = ACTIONS(1476),
    [anon_sym_U_DQUOTE] = ACTIONS(1476),
    [anon_sym_u8_DQUOTE] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [sym_true] = ACTIONS(1474),
    [sym_false] = ACTIONS(1474),
    [anon_sym_NULL] = ACTIONS(1474),
    [anon_sym_nullptr] = ACTIONS(1474),
    [sym_comment] = ACTIONS(3),
  },
  [494] = {
    [sym_attribute_declaration] = STATE(454),
    [sym_compound_statement] = STATE(267),
    [sym_attributed_statement] = STATE(269),
    [sym_labeled_statement] = STATE(259),
    [sym_expression_statement] = STATE(273),
    [sym_if_statement] = STATE(274),
    [sym_switch_statement] = STATE(275),
    [sym_case_statement] = STATE(278),
    [sym_while_statement] = STATE(279),
    [sym_do_statement] = STATE(280),
    [sym_for_statement] = STATE(283),
    [sym_return_statement] = STATE(287),
    [sym_break_statement] = STATE(288),
    [sym_continue_statement] = STATE(289),
    [sym_goto_statement] = STATE(290),
    [sym_seh_try_statement] = STATE(291),
    [sym_seh_leave_statement] = STATE(294),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [sym_identifier] = ACTIONS(1770),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [495] = {
    [sym_attribute_declaration] = STATE(454),
    [sym_compound_statement] = STATE(255),
    [sym_attributed_statement] = STATE(255),
    [sym_labeled_statement] = STATE(255),
    [sym_expression_statement] = STATE(255),
    [sym_if_statement] = STATE(255),
    [sym_switch_statement] = STATE(255),
    [sym_case_statement] = STATE(255),
    [sym_while_statement] = STATE(255),
    [sym_do_statement] = STATE(255),
    [sym_for_statement] = STATE(255),
    [sym_return_statement] = STATE(255),
    [sym_break_statement] = STATE(255),
    [sym_continue_statement] = STATE(255),
    [sym_goto_statement] = STATE(255),
    [sym_seh_try_statement] = STATE(255),
    [sym_seh_leave_statement] = STATE(255),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(454),
    [sym_identifier] = ACTIONS(1770),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(511),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(515),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_goto] = ACTIONS(523),
    [anon_sym___try] = ACTIONS(525),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [496] = {
    [sym_identifier] = ACTIONS(1502),
    [aux_sym_preproc_include_token1] = ACTIONS(1502),
    [aux_sym_preproc_def_token1] = ACTIONS(1502),
    [aux_sym_preproc_if_token1] = ACTIONS(1502),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1502),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1502),
    [sym_preproc_directive] = ACTIONS(1502),
    [anon_sym_LPAREN2] = ACTIONS(1504),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_TILDE] = ACTIONS(1504),
    [anon_sym_DASH] = ACTIONS(1502),
    [anon_sym_PLUS] = ACTIONS(1502),
    [anon_sym_STAR] = ACTIONS(1504),
    [anon_sym_AMP] = ACTIONS(1504),
    [anon_sym_SEMI] = ACTIONS(1504),
    [anon_sym___extension__] = ACTIONS(1502),
    [anon_sym_typedef] = ACTIONS(1502),
    [anon_sym_extern] = ACTIONS(1502),
    [anon_sym___attribute__] = ACTIONS(1502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1504),
    [anon_sym___declspec] = ACTIONS(1502),
    [anon_sym___cdecl] = ACTIONS(1502),
    [anon_sym___clrcall] = ACTIONS(1502),
    [anon_sym___stdcall] = ACTIONS(1502),
    [anon_sym___fastcall] = ACTIONS(1502),
    [anon_sym___thiscall] = ACTIONS(1502),
    [anon_sym___vectorcall] = ACTIONS(1502),
    [anon_sym_LBRACE] = ACTIONS(1504),
    [anon_sym_RBRACE] = ACTIONS(1504),
    [anon_sym_signed] = ACTIONS(1502),
    [anon_sym_unsigned] = ACTIONS(1502),
    [anon_sym_long] = ACTIONS(1502),
    [anon_sym_short] = ACTIONS(1502),
    [anon_sym_static] = ACTIONS(1502),
    [anon_sym_auto] = ACTIONS(1502),
    [anon_sym_register] = ACTIONS(1502),
    [anon_sym_inline] = ACTIONS(1502),
    [anon_sym___inline] = ACTIONS(1502),
    [anon_sym___inline__] = ACTIONS(1502),
    [anon_sym___forceinline] = ACTIONS(1502),
    [anon_sym_thread_local] = ACTIONS(1502),
    [anon_sym___thread] = ACTIONS(1502),
    [anon_sym_const] = ACTIONS(1502),
    [anon_sym_constexpr] = ACTIONS(1502),
    [anon_sym_volatile] = ACTIONS(1502),
    [anon_sym_restrict] = ACTIONS(1502),
    [anon_sym___restrict__] = ACTIONS(1502),
    [anon_sym__Atomic] = ACTIONS(1502),
    [anon_sym__Noreturn] = ACTIONS(1502),
    [anon_sym_noreturn] = ACTIONS(1502),
    [sym_primitive_type] = ACTIONS(1502),
    [anon_sym_enum] = ACTIONS(1502),
    [anon_sym_struct] = ACTIONS(1502),
    [anon_sym_union] = ACTIONS(1502),
    [anon_sym_if] = ACTIONS(1502),
    [anon_sym_switch] = ACTIONS(1502),
    [anon_sym_case] = ACTIONS(1502),
    [anon_sym_default] = ACTIONS(1502),
    [anon_sym_while] = ACTIONS(1502),
    [anon_sym_do] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1502),
    [anon_sym_return] = ACTIONS(1502),
    [anon_sym_break] = ACTIONS(1502),
    [anon_sym_continue] = ACTIONS(1502),
    [anon_sym_goto] = ACTIONS(1502),
    [anon_sym___try] = ACTIONS(1502),
    [anon_sym___leave] = ACTIONS(1502),
    [anon_sym_DASH_DASH] = ACTIONS(1504),
    [anon_sym_PLUS_PLUS] = ACTIONS(1504),
    [anon_sym_sizeof] = ACTIONS(1502),
    [anon_sym___alignof__] = ACTIONS(1502),
    [anon_sym___alignof] = ACTIONS(1502),
    [anon_sym__alignof] = ACTIONS(1502),
    [anon_sym_alignof] = ACTIONS(1502),
    [anon_sym__Alignof] = ACTIONS(1502),
    [anon_sym_offsetof] = ACTIONS(1502),
    [anon_sym__Generic] = ACTIONS(1502),
    [anon_sym_asm] = ACTIONS(1502),
    [anon_sym___asm__] = ACTIONS(1502),
    [sym_number_literal] = ACTIONS(1504),
    [anon_sym_L_SQUOTE] = ACTIONS(1504),
    [anon_sym_u_SQUOTE] = ACTIONS(1504),
    [anon_sym_U_SQUOTE] = ACTIONS(1504),
    [anon_sym_u8_SQUOTE] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(1504),
    [anon_sym_L_DQUOTE] = ACTIONS(1504),
    [anon_sym_u_DQUOTE] = ACTIONS(1504),
    [anon_sym_U_DQUOTE] = ACTIONS(1504),
    [anon_sym_u8_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE] = ACTIONS(1504),
    [sym_true] = ACTIONS(1502),
    [sym_false] = ACTIONS(1502),
    [anon_sym_NULL] = ACTIONS(1502),
    [anon_sym_nullptr] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [497] = {
    [sym_attribute_declaration] = STATE(432),
    [sym_compound_statement] = STATE(136),
    [sym_attributed_statement] = STATE(136),
    [sym_labeled_statement] = STATE(136),
    [sym_expression_statement] = STATE(136),
    [sym_if_statement] = STATE(136),
    [sym_switch_statement] = STATE(136),
    [sym_case_statement] = STATE(136),
    [sym_while_statement] = STATE(136),
    [sym_do_statement] = STATE(136),
    [sym_for_statement] = STATE(136),
    [sym_return_statement] = STATE(136),
    [sym_break_statement] = STATE(136),
    [sym_continue_statement] = STATE(136),
    [sym_goto_statement] = STATE(136),
    [sym_seh_try_statement] = STATE(136),
    [sym_seh_leave_statement] = STATE(136),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(432),
    [sym_identifier] = ACTIONS(1720),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_do] = ACTIONS(141),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_continue] = ACTIONS(149),
    [anon_sym_goto] = ACTIONS(151),
    [anon_sym___try] = ACTIONS(153),
    [anon_sym___leave] = ACTIONS(155),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [498] = {
    [sym_identifier] = ACTIONS(1462),
    [aux_sym_preproc_include_token1] = ACTIONS(1462),
    [aux_sym_preproc_def_token1] = ACTIONS(1462),
    [aux_sym_preproc_if_token1] = ACTIONS(1462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1462),
    [sym_preproc_directive] = ACTIONS(1462),
    [anon_sym_LPAREN2] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1464),
    [anon_sym_TILDE] = ACTIONS(1464),
    [anon_sym_DASH] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1462),
    [anon_sym_STAR] = ACTIONS(1464),
    [anon_sym_AMP] = ACTIONS(1464),
    [anon_sym_SEMI] = ACTIONS(1464),
    [anon_sym___extension__] = ACTIONS(1462),
    [anon_sym_typedef] = ACTIONS(1462),
    [anon_sym_extern] = ACTIONS(1462),
    [anon_sym___attribute__] = ACTIONS(1462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1464),
    [anon_sym___declspec] = ACTIONS(1462),
    [anon_sym___cdecl] = ACTIONS(1462),
    [anon_sym___clrcall] = ACTIONS(1462),
    [anon_sym___stdcall] = ACTIONS(1462),
    [anon_sym___fastcall] = ACTIONS(1462),
    [anon_sym___thiscall] = ACTIONS(1462),
    [anon_sym___vectorcall] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_RBRACE] = ACTIONS(1464),
    [anon_sym_signed] = ACTIONS(1462),
    [anon_sym_unsigned] = ACTIONS(1462),
    [anon_sym_long] = ACTIONS(1462),
    [anon_sym_short] = ACTIONS(1462),
    [anon_sym_static] = ACTIONS(1462),
    [anon_sym_auto] = ACTIONS(1462),
    [anon_sym_register] = ACTIONS(1462),
    [anon_sym_inline] = ACTIONS(1462),
    [anon_sym___inline] = ACTIONS(1462),
    [anon_sym___inline__] = ACTIONS(1462),
    [anon_sym___forceinline] = ACTIONS(1462),
    [anon_sym_thread_local] = ACTIONS(1462),
    [anon_sym___thread] = ACTIONS(1462),
    [anon_sym_const] = ACTIONS(1462),
    [anon_sym_constexpr] = ACTIONS(1462),
    [anon_sym_volatile] = ACTIONS(1462),
    [anon_sym_restrict] = ACTIONS(1462),
    [anon_sym___restrict__] = ACTIONS(1462),
    [anon_sym__Atomic] = ACTIONS(1462),
    [anon_sym__Noreturn] = ACTIONS(1462),
    [anon_sym_noreturn] = ACTIONS(1462),
    [sym_primitive_type] = ACTIONS(1462),
    [anon_sym_enum] = ACTIONS(1462),
    [anon_sym_struct] = ACTIONS(1462),
    [anon_sym_union] = ACTIONS(1462),
    [anon_sym_if] = ACTIONS(1462),
    [anon_sym_switch] = ACTIONS(1462),
    [anon_sym_case] = ACTIONS(1462),
    [anon_sym_default] = ACTIONS(1462),
    [anon_sym_while] = ACTIONS(1462),
    [anon_sym_do] = ACTIONS(1462),
    [anon_sym_for] = ACTIONS(1462),
    [anon_sym_return] = ACTIONS(1462),
    [anon_sym_break] = ACTIONS(1462),
    [anon_sym_continue] = ACTIONS(1462),
    [anon_sym_goto] = ACTIONS(1462),
    [anon_sym___try] = ACTIONS(1462),
    [anon_sym___leave] = ACTIONS(1462),
    [anon_sym_DASH_DASH] = ACTIONS(1464),
    [anon_sym_PLUS_PLUS] = ACTIONS(1464),
    [anon_sym_sizeof] = ACTIONS(1462),
    [anon_sym___alignof__] = ACTIONS(1462),
    [anon_sym___alignof] = ACTIONS(1462),
    [anon_sym__alignof] = ACTIONS(1462),
    [anon_sym_alignof] = ACTIONS(1462),
    [anon_sym__Alignof] = ACTIONS(1462),
    [anon_sym_offsetof] = ACTIONS(1462),
    [anon_sym__Generic] = ACTIONS(1462),
    [anon_sym_asm] = ACTIONS(1462),
    [anon_sym___asm__] = ACTIONS(1462),
    [sym_number_literal] = ACTIONS(1464),
    [anon_sym_L_SQUOTE] = ACTIONS(1464),
    [anon_sym_u_SQUOTE] = ACTIONS(1464),
    [anon_sym_U_SQUOTE] = ACTIONS(1464),
    [anon_sym_u8_SQUOTE] = ACTIONS(1464),
    [anon_sym_SQUOTE] = ACTIONS(1464),
    [anon_sym_L_DQUOTE] = ACTIONS(1464),
    [anon_sym_u_DQUOTE] = ACTIONS(1464),
    [anon_sym_U_DQUOTE] = ACTIONS(1464),
    [anon_sym_u8_DQUOTE] = ACTIONS(1464),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_true] = ACTIONS(1462),
    [sym_false] = ACTIONS(1462),
    [anon_sym_NULL] = ACTIONS(1462),
    [anon_sym_nullptr] = ACTIONS(1462),
    [sym_comment] = ACTIONS(3),
  },
  [499] = {
    [sym_attribute_declaration] = STATE(499),
    [sym_compound_statement] = STATE(97),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_case_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym_seh_try_statement] = STATE(97),
    [sym_seh_leave_statement] = STATE(97),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(499),
    [sym_identifier] = ACTIONS(1867),
    [anon_sym_LPAREN2] = ACTIONS(1579),
    [anon_sym_BANG] = ACTIONS(1582),
    [anon_sym_TILDE] = ACTIONS(1582),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1588),
    [anon_sym_SEMI] = ACTIONS(1870),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1594),
    [anon_sym_LBRACE] = ACTIONS(1873),
    [anon_sym_if] = ACTIONS(1876),
    [anon_sym_switch] = ACTIONS(1879),
    [anon_sym_case] = ACTIONS(1882),
    [anon_sym_default] = ACTIONS(1885),
    [anon_sym_while] = ACTIONS(1888),
    [anon_sym_do] = ACTIONS(1891),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_break] = ACTIONS(1900),
    [anon_sym_continue] = ACTIONS(1903),
    [anon_sym_goto] = ACTIONS(1906),
    [anon_sym___try] = ACTIONS(1909),
    [anon_sym___leave] = ACTIONS(1912),
    [anon_sym_DASH_DASH] = ACTIONS(1639),
    [anon_sym_PLUS_PLUS] = ACTIONS(1639),
    [anon_sym_sizeof] = ACTIONS(1642),
    [anon_sym___alignof__] = ACTIONS(1645),
    [anon_sym___alignof] = ACTIONS(1645),
    [anon_sym__alignof] = ACTIONS(1645),
    [anon_sym_alignof] = ACTIONS(1645),
    [anon_sym__Alignof] = ACTIONS(1645),
    [anon_sym_offsetof] = ACTIONS(1648),
    [anon_sym__Generic] = ACTIONS(1651),
    [anon_sym_asm] = ACTIONS(1654),
    [anon_sym___asm__] = ACTIONS(1654),
    [sym_number_literal] = ACTIONS(1657),
    [anon_sym_L_SQUOTE] = ACTIONS(1660),
    [anon_sym_u_SQUOTE] = ACTIONS(1660),
    [anon_sym_U_SQUOTE] = ACTIONS(1660),
    [anon_sym_u8_SQUOTE] = ACTIONS(1660),
    [anon_sym_SQUOTE] = ACTIONS(1660),
    [anon_sym_L_DQUOTE] = ACTIONS(1663),
    [anon_sym_u_DQUOTE] = ACTIONS(1663),
    [anon_sym_U_DQUOTE] = ACTIONS(1663),
    [anon_sym_u8_DQUOTE] = ACTIONS(1663),
    [anon_sym_DQUOTE] = ACTIONS(1663),
    [sym_true] = ACTIONS(1666),
    [sym_false] = ACTIONS(1666),
    [anon_sym_NULL] = ACTIONS(1669),
    [anon_sym_nullptr] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
  },
  [500] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(285),
    [sym_attributed_statement] = STATE(285),
    [sym_labeled_statement] = STATE(285),
    [sym_expression_statement] = STATE(285),
    [sym_if_statement] = STATE(285),
    [sym_switch_statement] = STATE(285),
    [sym_case_statement] = STATE(285),
    [sym_while_statement] = STATE(285),
    [sym_do_statement] = STATE(285),
    [sym_for_statement] = STATE(285),
    [sym_return_statement] = STATE(285),
    [sym_break_statement] = STATE(285),
    [sym_continue_statement] = STATE(285),
    [sym_goto_statement] = STATE(285),
    [sym_seh_try_statement] = STATE(285),
    [sym_seh_leave_statement] = STATE(285),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1566),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1278),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1568),
    [anon_sym_default] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1280),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1282),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1284),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [501] = {
    [sym_attribute_declaration] = STATE(432),
    [sym_compound_statement] = STATE(132),
    [sym_attributed_statement] = STATE(129),
    [sym_labeled_statement] = STATE(127),
    [sym_expression_statement] = STATE(126),
    [sym_if_statement] = STATE(125),
    [sym_switch_statement] = STATE(124),
    [sym_case_statement] = STATE(123),
    [sym_while_statement] = STATE(122),
    [sym_do_statement] = STATE(121),
    [sym_for_statement] = STATE(120),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(117),
    [sym_continue_statement] = STATE(116),
    [sym_goto_statement] = STATE(114),
    [sym_seh_try_statement] = STATE(108),
    [sym_seh_leave_statement] = STATE(106),
    [sym__expression] = STATE(1286),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2150),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(432),
    [sym_identifier] = ACTIONS(1720),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(137),
    [anon_sym_while] = ACTIONS(139),
    [anon_sym_do] = ACTIONS(141),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(147),
    [anon_sym_continue] = ACTIONS(149),
    [anon_sym_goto] = ACTIONS(151),
    [anon_sym___try] = ACTIONS(153),
    [anon_sym___leave] = ACTIONS(155),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [502] = {
    [sym_identifier] = ACTIONS(1466),
    [aux_sym_preproc_include_token1] = ACTIONS(1466),
    [aux_sym_preproc_def_token1] = ACTIONS(1466),
    [aux_sym_preproc_if_token1] = ACTIONS(1466),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1466),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1466),
    [sym_preproc_directive] = ACTIONS(1466),
    [anon_sym_LPAREN2] = ACTIONS(1468),
    [anon_sym_BANG] = ACTIONS(1468),
    [anon_sym_TILDE] = ACTIONS(1468),
    [anon_sym_DASH] = ACTIONS(1466),
    [anon_sym_PLUS] = ACTIONS(1466),
    [anon_sym_STAR] = ACTIONS(1468),
    [anon_sym_AMP] = ACTIONS(1468),
    [anon_sym_SEMI] = ACTIONS(1468),
    [anon_sym___extension__] = ACTIONS(1466),
    [anon_sym_typedef] = ACTIONS(1466),
    [anon_sym_extern] = ACTIONS(1466),
    [anon_sym___attribute__] = ACTIONS(1466),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1468),
    [anon_sym___declspec] = ACTIONS(1466),
    [anon_sym___cdecl] = ACTIONS(1466),
    [anon_sym___clrcall] = ACTIONS(1466),
    [anon_sym___stdcall] = ACTIONS(1466),
    [anon_sym___fastcall] = ACTIONS(1466),
    [anon_sym___thiscall] = ACTIONS(1466),
    [anon_sym___vectorcall] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(1468),
    [anon_sym_RBRACE] = ACTIONS(1468),
    [anon_sym_signed] = ACTIONS(1466),
    [anon_sym_unsigned] = ACTIONS(1466),
    [anon_sym_long] = ACTIONS(1466),
    [anon_sym_short] = ACTIONS(1466),
    [anon_sym_static] = ACTIONS(1466),
    [anon_sym_auto] = ACTIONS(1466),
    [anon_sym_register] = ACTIONS(1466),
    [anon_sym_inline] = ACTIONS(1466),
    [anon_sym___inline] = ACTIONS(1466),
    [anon_sym___inline__] = ACTIONS(1466),
    [anon_sym___forceinline] = ACTIONS(1466),
    [anon_sym_thread_local] = ACTIONS(1466),
    [anon_sym___thread] = ACTIONS(1466),
    [anon_sym_const] = ACTIONS(1466),
    [anon_sym_constexpr] = ACTIONS(1466),
    [anon_sym_volatile] = ACTIONS(1466),
    [anon_sym_restrict] = ACTIONS(1466),
    [anon_sym___restrict__] = ACTIONS(1466),
    [anon_sym__Atomic] = ACTIONS(1466),
    [anon_sym__Noreturn] = ACTIONS(1466),
    [anon_sym_noreturn] = ACTIONS(1466),
    [sym_primitive_type] = ACTIONS(1466),
    [anon_sym_enum] = ACTIONS(1466),
    [anon_sym_struct] = ACTIONS(1466),
    [anon_sym_union] = ACTIONS(1466),
    [anon_sym_if] = ACTIONS(1466),
    [anon_sym_switch] = ACTIONS(1466),
    [anon_sym_case] = ACTIONS(1466),
    [anon_sym_default] = ACTIONS(1466),
    [anon_sym_while] = ACTIONS(1466),
    [anon_sym_do] = ACTIONS(1466),
    [anon_sym_for] = ACTIONS(1466),
    [anon_sym_return] = ACTIONS(1466),
    [anon_sym_break] = ACTIONS(1466),
    [anon_sym_continue] = ACTIONS(1466),
    [anon_sym_goto] = ACTIONS(1466),
    [anon_sym___try] = ACTIONS(1466),
    [anon_sym___leave] = ACTIONS(1466),
    [anon_sym_DASH_DASH] = ACTIONS(1468),
    [anon_sym_PLUS_PLUS] = ACTIONS(1468),
    [anon_sym_sizeof] = ACTIONS(1466),
    [anon_sym___alignof__] = ACTIONS(1466),
    [anon_sym___alignof] = ACTIONS(1466),
    [anon_sym__alignof] = ACTIONS(1466),
    [anon_sym_alignof] = ACTIONS(1466),
    [anon_sym__Alignof] = ACTIONS(1466),
    [anon_sym_offsetof] = ACTIONS(1466),
    [anon_sym__Generic] = ACTIONS(1466),
    [anon_sym_asm] = ACTIONS(1466),
    [anon_sym___asm__] = ACTIONS(1466),
    [sym_number_literal] = ACTIONS(1468),
    [anon_sym_L_SQUOTE] = ACTIONS(1468),
    [anon_sym_u_SQUOTE] = ACTIONS(1468),
    [anon_sym_U_SQUOTE] = ACTIONS(1468),
    [anon_sym_u8_SQUOTE] = ACTIONS(1468),
    [anon_sym_SQUOTE] = ACTIONS(1468),
    [anon_sym_L_DQUOTE] = ACTIONS(1468),
    [anon_sym_u_DQUOTE] = ACTIONS(1468),
    [anon_sym_U_DQUOTE] = ACTIONS(1468),
    [anon_sym_u8_DQUOTE] = ACTIONS(1468),
    [anon_sym_DQUOTE] = ACTIONS(1468),
    [sym_true] = ACTIONS(1466),
    [sym_false] = ACTIONS(1466),
    [anon_sym_NULL] = ACTIONS(1466),
    [anon_sym_nullptr] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
  },
  [503] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(2217),
    [sym_attributed_statement] = STATE(2217),
    [sym_labeled_statement] = STATE(2217),
    [sym_expression_statement] = STATE(2217),
    [sym_if_statement] = STATE(2217),
    [sym_switch_statement] = STATE(2217),
    [sym_case_statement] = STATE(2217),
    [sym_while_statement] = STATE(2217),
    [sym_do_statement] = STATE(2217),
    [sym_for_statement] = STATE(2217),
    [sym_return_statement] = STATE(2217),
    [sym_break_statement] = STATE(2217),
    [sym_continue_statement] = STATE(2217),
    [sym_goto_statement] = STATE(2217),
    [sym_seh_try_statement] = STATE(2217),
    [sym_seh_leave_statement] = STATE(2217),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1566),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1278),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1568),
    [anon_sym_default] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1280),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1282),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1284),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [504] = {
    [sym_identifier] = ACTIONS(1470),
    [aux_sym_preproc_include_token1] = ACTIONS(1470),
    [aux_sym_preproc_def_token1] = ACTIONS(1470),
    [aux_sym_preproc_if_token1] = ACTIONS(1470),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1470),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1470),
    [sym_preproc_directive] = ACTIONS(1470),
    [anon_sym_LPAREN2] = ACTIONS(1472),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_TILDE] = ACTIONS(1472),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_STAR] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1472),
    [anon_sym_SEMI] = ACTIONS(1472),
    [anon_sym___extension__] = ACTIONS(1470),
    [anon_sym_typedef] = ACTIONS(1470),
    [anon_sym_extern] = ACTIONS(1470),
    [anon_sym___attribute__] = ACTIONS(1470),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1472),
    [anon_sym___declspec] = ACTIONS(1470),
    [anon_sym___cdecl] = ACTIONS(1470),
    [anon_sym___clrcall] = ACTIONS(1470),
    [anon_sym___stdcall] = ACTIONS(1470),
    [anon_sym___fastcall] = ACTIONS(1470),
    [anon_sym___thiscall] = ACTIONS(1470),
    [anon_sym___vectorcall] = ACTIONS(1470),
    [anon_sym_LBRACE] = ACTIONS(1472),
    [anon_sym_RBRACE] = ACTIONS(1472),
    [anon_sym_signed] = ACTIONS(1470),
    [anon_sym_unsigned] = ACTIONS(1470),
    [anon_sym_long] = ACTIONS(1470),
    [anon_sym_short] = ACTIONS(1470),
    [anon_sym_static] = ACTIONS(1470),
    [anon_sym_auto] = ACTIONS(1470),
    [anon_sym_register] = ACTIONS(1470),
    [anon_sym_inline] = ACTIONS(1470),
    [anon_sym___inline] = ACTIONS(1470),
    [anon_sym___inline__] = ACTIONS(1470),
    [anon_sym___forceinline] = ACTIONS(1470),
    [anon_sym_thread_local] = ACTIONS(1470),
    [anon_sym___thread] = ACTIONS(1470),
    [anon_sym_const] = ACTIONS(1470),
    [anon_sym_constexpr] = ACTIONS(1470),
    [anon_sym_volatile] = ACTIONS(1470),
    [anon_sym_restrict] = ACTIONS(1470),
    [anon_sym___restrict__] = ACTIONS(1470),
    [anon_sym__Atomic] = ACTIONS(1470),
    [anon_sym__Noreturn] = ACTIONS(1470),
    [anon_sym_noreturn] = ACTIONS(1470),
    [sym_primitive_type] = ACTIONS(1470),
    [anon_sym_enum] = ACTIONS(1470),
    [anon_sym_struct] = ACTIONS(1470),
    [anon_sym_union] = ACTIONS(1470),
    [anon_sym_if] = ACTIONS(1470),
    [anon_sym_switch] = ACTIONS(1470),
    [anon_sym_case] = ACTIONS(1470),
    [anon_sym_default] = ACTIONS(1470),
    [anon_sym_while] = ACTIONS(1470),
    [anon_sym_do] = ACTIONS(1470),
    [anon_sym_for] = ACTIONS(1470),
    [anon_sym_return] = ACTIONS(1470),
    [anon_sym_break] = ACTIONS(1470),
    [anon_sym_continue] = ACTIONS(1470),
    [anon_sym_goto] = ACTIONS(1470),
    [anon_sym___try] = ACTIONS(1470),
    [anon_sym___leave] = ACTIONS(1470),
    [anon_sym_DASH_DASH] = ACTIONS(1472),
    [anon_sym_PLUS_PLUS] = ACTIONS(1472),
    [anon_sym_sizeof] = ACTIONS(1470),
    [anon_sym___alignof__] = ACTIONS(1470),
    [anon_sym___alignof] = ACTIONS(1470),
    [anon_sym__alignof] = ACTIONS(1470),
    [anon_sym_alignof] = ACTIONS(1470),
    [anon_sym__Alignof] = ACTIONS(1470),
    [anon_sym_offsetof] = ACTIONS(1470),
    [anon_sym__Generic] = ACTIONS(1470),
    [anon_sym_asm] = ACTIONS(1470),
    [anon_sym___asm__] = ACTIONS(1470),
    [sym_number_literal] = ACTIONS(1472),
    [anon_sym_L_SQUOTE] = ACTIONS(1472),
    [anon_sym_u_SQUOTE] = ACTIONS(1472),
    [anon_sym_U_SQUOTE] = ACTIONS(1472),
    [anon_sym_u8_SQUOTE] = ACTIONS(1472),
    [anon_sym_SQUOTE] = ACTIONS(1472),
    [anon_sym_L_DQUOTE] = ACTIONS(1472),
    [anon_sym_u_DQUOTE] = ACTIONS(1472),
    [anon_sym_U_DQUOTE] = ACTIONS(1472),
    [anon_sym_u8_DQUOTE] = ACTIONS(1472),
    [anon_sym_DQUOTE] = ACTIONS(1472),
    [sym_true] = ACTIONS(1470),
    [sym_false] = ACTIONS(1470),
    [anon_sym_NULL] = ACTIONS(1470),
    [anon_sym_nullptr] = ACTIONS(1470),
    [sym_comment] = ACTIONS(3),
  },
  [505] = {
    [sym_identifier] = ACTIONS(1478),
    [aux_sym_preproc_include_token1] = ACTIONS(1478),
    [aux_sym_preproc_def_token1] = ACTIONS(1478),
    [aux_sym_preproc_if_token1] = ACTIONS(1478),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1478),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1478),
    [sym_preproc_directive] = ACTIONS(1478),
    [anon_sym_LPAREN2] = ACTIONS(1480),
    [anon_sym_BANG] = ACTIONS(1480),
    [anon_sym_TILDE] = ACTIONS(1480),
    [anon_sym_DASH] = ACTIONS(1478),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_STAR] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1480),
    [anon_sym_SEMI] = ACTIONS(1480),
    [anon_sym___extension__] = ACTIONS(1478),
    [anon_sym_typedef] = ACTIONS(1478),
    [anon_sym_extern] = ACTIONS(1478),
    [anon_sym___attribute__] = ACTIONS(1478),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1480),
    [anon_sym___declspec] = ACTIONS(1478),
    [anon_sym___cdecl] = ACTIONS(1478),
    [anon_sym___clrcall] = ACTIONS(1478),
    [anon_sym___stdcall] = ACTIONS(1478),
    [anon_sym___fastcall] = ACTIONS(1478),
    [anon_sym___thiscall] = ACTIONS(1478),
    [anon_sym___vectorcall] = ACTIONS(1478),
    [anon_sym_LBRACE] = ACTIONS(1480),
    [anon_sym_RBRACE] = ACTIONS(1480),
    [anon_sym_signed] = ACTIONS(1478),
    [anon_sym_unsigned] = ACTIONS(1478),
    [anon_sym_long] = ACTIONS(1478),
    [anon_sym_short] = ACTIONS(1478),
    [anon_sym_static] = ACTIONS(1478),
    [anon_sym_auto] = ACTIONS(1478),
    [anon_sym_register] = ACTIONS(1478),
    [anon_sym_inline] = ACTIONS(1478),
    [anon_sym___inline] = ACTIONS(1478),
    [anon_sym___inline__] = ACTIONS(1478),
    [anon_sym___forceinline] = ACTIONS(1478),
    [anon_sym_thread_local] = ACTIONS(1478),
    [anon_sym___thread] = ACTIONS(1478),
    [anon_sym_const] = ACTIONS(1478),
    [anon_sym_constexpr] = ACTIONS(1478),
    [anon_sym_volatile] = ACTIONS(1478),
    [anon_sym_restrict] = ACTIONS(1478),
    [anon_sym___restrict__] = ACTIONS(1478),
    [anon_sym__Atomic] = ACTIONS(1478),
    [anon_sym__Noreturn] = ACTIONS(1478),
    [anon_sym_noreturn] = ACTIONS(1478),
    [sym_primitive_type] = ACTIONS(1478),
    [anon_sym_enum] = ACTIONS(1478),
    [anon_sym_struct] = ACTIONS(1478),
    [anon_sym_union] = ACTIONS(1478),
    [anon_sym_if] = ACTIONS(1478),
    [anon_sym_switch] = ACTIONS(1478),
    [anon_sym_case] = ACTIONS(1478),
    [anon_sym_default] = ACTIONS(1478),
    [anon_sym_while] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_for] = ACTIONS(1478),
    [anon_sym_return] = ACTIONS(1478),
    [anon_sym_break] = ACTIONS(1478),
    [anon_sym_continue] = ACTIONS(1478),
    [anon_sym_goto] = ACTIONS(1478),
    [anon_sym___try] = ACTIONS(1478),
    [anon_sym___leave] = ACTIONS(1478),
    [anon_sym_DASH_DASH] = ACTIONS(1480),
    [anon_sym_PLUS_PLUS] = ACTIONS(1480),
    [anon_sym_sizeof] = ACTIONS(1478),
    [anon_sym___alignof__] = ACTIONS(1478),
    [anon_sym___alignof] = ACTIONS(1478),
    [anon_sym__alignof] = ACTIONS(1478),
    [anon_sym_alignof] = ACTIONS(1478),
    [anon_sym__Alignof] = ACTIONS(1478),
    [anon_sym_offsetof] = ACTIONS(1478),
    [anon_sym__Generic] = ACTIONS(1478),
    [anon_sym_asm] = ACTIONS(1478),
    [anon_sym___asm__] = ACTIONS(1478),
    [sym_number_literal] = ACTIONS(1480),
    [anon_sym_L_SQUOTE] = ACTIONS(1480),
    [anon_sym_u_SQUOTE] = ACTIONS(1480),
    [anon_sym_U_SQUOTE] = ACTIONS(1480),
    [anon_sym_u8_SQUOTE] = ACTIONS(1480),
    [anon_sym_SQUOTE] = ACTIONS(1480),
    [anon_sym_L_DQUOTE] = ACTIONS(1480),
    [anon_sym_u_DQUOTE] = ACTIONS(1480),
    [anon_sym_U_DQUOTE] = ACTIONS(1480),
    [anon_sym_u8_DQUOTE] = ACTIONS(1480),
    [anon_sym_DQUOTE] = ACTIONS(1480),
    [sym_true] = ACTIONS(1478),
    [sym_false] = ACTIONS(1478),
    [anon_sym_NULL] = ACTIONS(1478),
    [anon_sym_nullptr] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
  },
  [506] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(308),
    [sym_attributed_statement] = STATE(308),
    [sym_labeled_statement] = STATE(308),
    [sym_expression_statement] = STATE(308),
    [sym_if_statement] = STATE(308),
    [sym_switch_statement] = STATE(308),
    [sym_case_statement] = STATE(308),
    [sym_while_statement] = STATE(308),
    [sym_do_statement] = STATE(308),
    [sym_for_statement] = STATE(308),
    [sym_return_statement] = STATE(308),
    [sym_break_statement] = STATE(308),
    [sym_continue_statement] = STATE(308),
    [sym_goto_statement] = STATE(308),
    [sym_seh_try_statement] = STATE(308),
    [sym_seh_leave_statement] = STATE(308),
    [sym__expression] = STATE(1311),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2190),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1566),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1278),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(1568),
    [anon_sym_default] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1280),
    [anon_sym_do] = ACTIONS(67),
    [anon_sym_for] = ACTIONS(1282),
    [anon_sym_return] = ACTIONS(71),
    [anon_sym_break] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_goto] = ACTIONS(77),
    [anon_sym___try] = ACTIONS(1284),
    [anon_sym___leave] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [507] = {
    [ts_builtin_sym_end] = ACTIONS(1448),
    [sym_identifier] = ACTIONS(1446),
    [aux_sym_preproc_include_token1] = ACTIONS(1446),
    [aux_sym_preproc_def_token1] = ACTIONS(1446),
    [anon_sym_COMMA] = ACTIONS(1448),
    [aux_sym_preproc_if_token1] = ACTIONS(1446),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1446),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1446),
    [sym_preproc_directive] = ACTIONS(1446),
    [anon_sym_LPAREN2] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1446),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym___extension__] = ACTIONS(1446),
    [anon_sym_typedef] = ACTIONS(1446),
    [anon_sym_extern] = ACTIONS(1446),
    [anon_sym___attribute__] = ACTIONS(1446),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1448),
    [anon_sym___declspec] = ACTIONS(1446),
    [anon_sym___cdecl] = ACTIONS(1446),
    [anon_sym___clrcall] = ACTIONS(1446),
    [anon_sym___stdcall] = ACTIONS(1446),
    [anon_sym___fastcall] = ACTIONS(1446),
    [anon_sym___thiscall] = ACTIONS(1446),
    [anon_sym___vectorcall] = ACTIONS(1446),
    [anon_sym_LBRACE] = ACTIONS(1448),
    [anon_sym_RBRACE] = ACTIONS(1448),
    [anon_sym_signed] = ACTIONS(1446),
    [anon_sym_unsigned] = ACTIONS(1446),
    [anon_sym_long] = ACTIONS(1446),
    [anon_sym_short] = ACTIONS(1446),
    [anon_sym_static] = ACTIONS(1446),
    [anon_sym_auto] = ACTIONS(1446),
    [anon_sym_register] = ACTIONS(1446),
    [anon_sym_inline] = ACTIONS(1446),
    [anon_sym___inline] = ACTIONS(1446),
    [anon_sym___inline__] = ACTIONS(1446),
    [anon_sym___forceinline] = ACTIONS(1446),
    [anon_sym_thread_local] = ACTIONS(1446),
    [anon_sym___thread] = ACTIONS(1446),
    [anon_sym_const] = ACTIONS(1446),
    [anon_sym_constexpr] = ACTIONS(1446),
    [anon_sym_volatile] = ACTIONS(1446),
    [anon_sym_restrict] = ACTIONS(1446),
    [anon_sym___restrict__] = ACTIONS(1446),
    [anon_sym__Atomic] = ACTIONS(1446),
    [anon_sym__Noreturn] = ACTIONS(1446),
    [anon_sym_noreturn] = ACTIONS(1446),
    [sym_primitive_type] = ACTIONS(1446),
    [anon_sym_enum] = ACTIONS(1446),
    [anon_sym_struct] = ACTIONS(1446),
    [anon_sym_union] = ACTIONS(1446),
    [anon_sym_if] = ACTIONS(1446),
    [anon_sym_switch] = ACTIONS(1446),
    [anon_sym_case] = ACTIONS(1446),
    [anon_sym_default] = ACTIONS(1446),
    [anon_sym_while] = ACTIONS(1446),
    [anon_sym_do] = ACTIONS(1446),
    [anon_sym_for] = ACTIONS(1446),
    [anon_sym_return] = ACTIONS(1446),
    [anon_sym_break] = ACTIONS(1446),
    [anon_sym_continue] = ACTIONS(1446),
    [anon_sym_goto] = ACTIONS(1446),
    [anon_sym_DASH_DASH] = ACTIONS(1448),
    [anon_sym_PLUS_PLUS] = ACTIONS(1448),
    [anon_sym_sizeof] = ACTIONS(1446),
    [anon_sym___alignof__] = ACTIONS(1446),
    [anon_sym___alignof] = ACTIONS(1446),
    [anon_sym__alignof] = ACTIONS(1446),
    [anon_sym_alignof] = ACTIONS(1446),
    [anon_sym__Alignof] = ACTIONS(1446),
    [anon_sym_offsetof] = ACTIONS(1446),
    [anon_sym__Generic] = ACTIONS(1446),
    [anon_sym_asm] = ACTIONS(1446),
    [anon_sym___asm__] = ACTIONS(1446),
    [sym_number_literal] = ACTIONS(1448),
    [anon_sym_L_SQUOTE] = ACTIONS(1448),
    [anon_sym_u_SQUOTE] = ACTIONS(1448),
    [anon_sym_U_SQUOTE] = ACTIONS(1448),
    [anon_sym_u8_SQUOTE] = ACTIONS(1448),
    [anon_sym_SQUOTE] = ACTIONS(1448),
    [anon_sym_L_DQUOTE] = ACTIONS(1448),
    [anon_sym_u_DQUOTE] = ACTIONS(1448),
    [anon_sym_U_DQUOTE] = ACTIONS(1448),
    [anon_sym_u8_DQUOTE] = ACTIONS(1448),
    [anon_sym_DQUOTE] = ACTIONS(1448),
    [sym_true] = ACTIONS(1446),
    [sym_false] = ACTIONS(1446),
    [anon_sym_NULL] = ACTIONS(1446),
    [anon_sym_nullptr] = ACTIONS(1446),
    [sym_comment] = ACTIONS(3),
  },
  [508] = {
    [ts_builtin_sym_end] = ACTIONS(1456),
    [sym_identifier] = ACTIONS(1454),
    [aux_sym_preproc_include_token1] = ACTIONS(1454),
    [aux_sym_preproc_def_token1] = ACTIONS(1454),
    [anon_sym_COMMA] = ACTIONS(1456),
    [aux_sym_preproc_if_token1] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1454),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1454),
    [sym_preproc_directive] = ACTIONS(1454),
    [anon_sym_LPAREN2] = ACTIONS(1456),
    [anon_sym_BANG] = ACTIONS(1456),
    [anon_sym_TILDE] = ACTIONS(1456),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_STAR] = ACTIONS(1456),
    [anon_sym_AMP] = ACTIONS(1456),
    [anon_sym___extension__] = ACTIONS(1454),
    [anon_sym_typedef] = ACTIONS(1454),
    [anon_sym_extern] = ACTIONS(1454),
    [anon_sym___attribute__] = ACTIONS(1454),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1456),
    [anon_sym___declspec] = ACTIONS(1454),
    [anon_sym___cdecl] = ACTIONS(1454),
    [anon_sym___clrcall] = ACTIONS(1454),
    [anon_sym___stdcall] = ACTIONS(1454),
    [anon_sym___fastcall] = ACTIONS(1454),
    [anon_sym___thiscall] = ACTIONS(1454),
    [anon_sym___vectorcall] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [anon_sym_RBRACE] = ACTIONS(1456),
    [anon_sym_signed] = ACTIONS(1454),
    [anon_sym_unsigned] = ACTIONS(1454),
    [anon_sym_long] = ACTIONS(1454),
    [anon_sym_short] = ACTIONS(1454),
    [anon_sym_static] = ACTIONS(1454),
    [anon_sym_auto] = ACTIONS(1454),
    [anon_sym_register] = ACTIONS(1454),
    [anon_sym_inline] = ACTIONS(1454),
    [anon_sym___inline] = ACTIONS(1454),
    [anon_sym___inline__] = ACTIONS(1454),
    [anon_sym___forceinline] = ACTIONS(1454),
    [anon_sym_thread_local] = ACTIONS(1454),
    [anon_sym___thread] = ACTIONS(1454),
    [anon_sym_const] = ACTIONS(1454),
    [anon_sym_constexpr] = ACTIONS(1454),
    [anon_sym_volatile] = ACTIONS(1454),
    [anon_sym_restrict] = ACTIONS(1454),
    [anon_sym___restrict__] = ACTIONS(1454),
    [anon_sym__Atomic] = ACTIONS(1454),
    [anon_sym__Noreturn] = ACTIONS(1454),
    [anon_sym_noreturn] = ACTIONS(1454),
    [sym_primitive_type] = ACTIONS(1454),
    [anon_sym_enum] = ACTIONS(1454),
    [anon_sym_struct] = ACTIONS(1454),
    [anon_sym_union] = ACTIONS(1454),
    [anon_sym_if] = ACTIONS(1454),
    [anon_sym_switch] = ACTIONS(1454),
    [anon_sym_case] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(1454),
    [anon_sym_do] = ACTIONS(1454),
    [anon_sym_for] = ACTIONS(1454),
    [anon_sym_return] = ACTIONS(1454),
    [anon_sym_break] = ACTIONS(1454),
    [anon_sym_continue] = ACTIONS(1454),
    [anon_sym_goto] = ACTIONS(1454),
    [anon_sym_DASH_DASH] = ACTIONS(1456),
    [anon_sym_PLUS_PLUS] = ACTIONS(1456),
    [anon_sym_sizeof] = ACTIONS(1454),
    [anon_sym___alignof__] = ACTIONS(1454),
    [anon_sym___alignof] = ACTIONS(1454),
    [anon_sym__alignof] = ACTIONS(1454),
    [anon_sym_alignof] = ACTIONS(1454),
    [anon_sym__Alignof] = ACTIONS(1454),
    [anon_sym_offsetof] = ACTIONS(1454),
    [anon_sym__Generic] = ACTIONS(1454),
    [anon_sym_asm] = ACTIONS(1454),
    [anon_sym___asm__] = ACTIONS(1454),
    [sym_number_literal] = ACTIONS(1456),
    [anon_sym_L_SQUOTE] = ACTIONS(1456),
    [anon_sym_u_SQUOTE] = ACTIONS(1456),
    [anon_sym_U_SQUOTE] = ACTIONS(1456),
    [anon_sym_u8_SQUOTE] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(1456),
    [anon_sym_L_DQUOTE] = ACTIONS(1456),
    [anon_sym_u_DQUOTE] = ACTIONS(1456),
    [anon_sym_U_DQUOTE] = ACTIONS(1456),
    [anon_sym_u8_DQUOTE] = ACTIONS(1456),
    [anon_sym_DQUOTE] = ACTIONS(1456),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [anon_sym_NULL] = ACTIONS(1454),
    [anon_sym_nullptr] = ACTIONS(1454),
    [sym_comment] = ACTIONS(3),
  },
  [509] = {
    [sym__expression] = STATE(1100),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(884),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(884),
    [sym_call_expression] = STATE(884),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(884),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(884),
    [sym_initializer_list] = STATE(861),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_identifier] = ACTIONS(1538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1540),
    [anon_sym_LPAREN2] = ACTIONS(1540),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_DASH] = ACTIONS(1546),
    [anon_sym_PLUS] = ACTIONS(1546),
    [anon_sym_STAR] = ACTIONS(1546),
    [anon_sym_SLASH] = ACTIONS(1546),
    [anon_sym_PERCENT] = ACTIONS(1546),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE] = ACTIONS(1546),
    [anon_sym_CARET] = ACTIONS(1546),
    [anon_sym_AMP] = ACTIONS(1546),
    [anon_sym_EQ_EQ] = ACTIONS(1540),
    [anon_sym_BANG_EQ] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1540),
    [anon_sym_LT_EQ] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1546),
    [anon_sym_GT_GT] = ACTIONS(1546),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1540),
    [anon_sym_RBRACK] = ACTIONS(1540),
    [anon_sym_EQ] = ACTIONS(1546),
    [anon_sym_QMARK] = ACTIONS(1540),
    [anon_sym_STAR_EQ] = ACTIONS(1540),
    [anon_sym_SLASH_EQ] = ACTIONS(1540),
    [anon_sym_PERCENT_EQ] = ACTIONS(1540),
    [anon_sym_PLUS_EQ] = ACTIONS(1540),
    [anon_sym_DASH_EQ] = ACTIONS(1540),
    [anon_sym_LT_LT_EQ] = ACTIONS(1540),
    [anon_sym_GT_GT_EQ] = ACTIONS(1540),
    [anon_sym_AMP_EQ] = ACTIONS(1540),
    [anon_sym_CARET_EQ] = ACTIONS(1540),
    [anon_sym_PIPE_EQ] = ACTIONS(1540),
    [anon_sym_DASH_DASH] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1540),
    [anon_sym_sizeof] = ACTIONS(1919),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(1546),
    [anon_sym_DASH_GT] = ACTIONS(1540),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [510] = {
    [ts_builtin_sym_end] = ACTIONS(1512),
    [sym_identifier] = ACTIONS(1510),
    [aux_sym_preproc_include_token1] = ACTIONS(1510),
    [aux_sym_preproc_def_token1] = ACTIONS(1510),
    [aux_sym_preproc_if_token1] = ACTIONS(1510),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1510),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1510),
    [sym_preproc_directive] = ACTIONS(1510),
    [anon_sym_LPAREN2] = ACTIONS(1512),
    [anon_sym_BANG] = ACTIONS(1512),
    [anon_sym_TILDE] = ACTIONS(1512),
    [anon_sym_DASH] = ACTIONS(1510),
    [anon_sym_PLUS] = ACTIONS(1510),
    [anon_sym_STAR] = ACTIONS(1512),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym___extension__] = ACTIONS(1510),
    [anon_sym_typedef] = ACTIONS(1510),
    [anon_sym_extern] = ACTIONS(1510),
    [anon_sym___attribute__] = ACTIONS(1510),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1512),
    [anon_sym___declspec] = ACTIONS(1510),
    [anon_sym___cdecl] = ACTIONS(1510),
    [anon_sym___clrcall] = ACTIONS(1510),
    [anon_sym___stdcall] = ACTIONS(1510),
    [anon_sym___fastcall] = ACTIONS(1510),
    [anon_sym___thiscall] = ACTIONS(1510),
    [anon_sym___vectorcall] = ACTIONS(1510),
    [anon_sym_LBRACE] = ACTIONS(1512),
    [anon_sym_signed] = ACTIONS(1510),
    [anon_sym_unsigned] = ACTIONS(1510),
    [anon_sym_long] = ACTIONS(1510),
    [anon_sym_short] = ACTIONS(1510),
    [anon_sym_static] = ACTIONS(1510),
    [anon_sym_auto] = ACTIONS(1510),
    [anon_sym_register] = ACTIONS(1510),
    [anon_sym_inline] = ACTIONS(1510),
    [anon_sym___inline] = ACTIONS(1510),
    [anon_sym___inline__] = ACTIONS(1510),
    [anon_sym___forceinline] = ACTIONS(1510),
    [anon_sym_thread_local] = ACTIONS(1510),
    [anon_sym___thread] = ACTIONS(1510),
    [anon_sym_const] = ACTIONS(1510),
    [anon_sym_constexpr] = ACTIONS(1510),
    [anon_sym_volatile] = ACTIONS(1510),
    [anon_sym_restrict] = ACTIONS(1510),
    [anon_sym___restrict__] = ACTIONS(1510),
    [anon_sym__Atomic] = ACTIONS(1510),
    [anon_sym__Noreturn] = ACTIONS(1510),
    [anon_sym_noreturn] = ACTIONS(1510),
    [sym_primitive_type] = ACTIONS(1510),
    [anon_sym_enum] = ACTIONS(1510),
    [anon_sym_struct] = ACTIONS(1510),
    [anon_sym_union] = ACTIONS(1510),
    [anon_sym_if] = ACTIONS(1510),
    [anon_sym_switch] = ACTIONS(1510),
    [anon_sym_case] = ACTIONS(1510),
    [anon_sym_default] = ACTIONS(1510),
    [anon_sym_while] = ACTIONS(1510),
    [anon_sym_do] = ACTIONS(1510),
    [anon_sym_for] = ACTIONS(1510),
    [anon_sym_return] = ACTIONS(1510),
    [anon_sym_break] = ACTIONS(1510),
    [anon_sym_continue] = ACTIONS(1510),
    [anon_sym_goto] = ACTIONS(1510),
    [anon_sym_DASH_DASH] = ACTIONS(1512),
    [anon_sym_PLUS_PLUS] = ACTIONS(1512),
    [anon_sym_sizeof] = ACTIONS(1510),
    [anon_sym___alignof__] = ACTIONS(1510),
    [anon_sym___alignof] = ACTIONS(1510),
    [anon_sym__alignof] = ACTIONS(1510),
    [anon_sym_alignof] = ACTIONS(1510),
    [anon_sym__Alignof] = ACTIONS(1510),
    [anon_sym_offsetof] = ACTIONS(1510),
    [anon_sym__Generic] = ACTIONS(1510),
    [anon_sym_asm] = ACTIONS(1510),
    [anon_sym___asm__] = ACTIONS(1510),
    [sym_number_literal] = ACTIONS(1512),
    [anon_sym_L_SQUOTE] = ACTIONS(1512),
    [anon_sym_u_SQUOTE] = ACTIONS(1512),
    [anon_sym_U_SQUOTE] = ACTIONS(1512),
    [anon_sym_u8_SQUOTE] = ACTIONS(1512),
    [anon_sym_SQUOTE] = ACTIONS(1512),
    [anon_sym_L_DQUOTE] = ACTIONS(1512),
    [anon_sym_u_DQUOTE] = ACTIONS(1512),
    [anon_sym_U_DQUOTE] = ACTIONS(1512),
    [anon_sym_u8_DQUOTE] = ACTIONS(1512),
    [anon_sym_DQUOTE] = ACTIONS(1512),
    [sym_true] = ACTIONS(1510),
    [sym_false] = ACTIONS(1510),
    [anon_sym_NULL] = ACTIONS(1510),
    [anon_sym_nullptr] = ACTIONS(1510),
    [sym_comment] = ACTIONS(3),
  },
  [511] = {
    [ts_builtin_sym_end] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1923),
    [aux_sym_preproc_include_token1] = ACTIONS(1923),
    [aux_sym_preproc_def_token1] = ACTIONS(1923),
    [aux_sym_preproc_if_token1] = ACTIONS(1923),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1923),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1923),
    [sym_preproc_directive] = ACTIONS(1923),
    [anon_sym_LPAREN2] = ACTIONS(1921),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1923),
    [anon_sym_PLUS] = ACTIONS(1923),
    [anon_sym_STAR] = ACTIONS(1921),
    [anon_sym_AMP] = ACTIONS(1921),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_typedef] = ACTIONS(1923),
    [anon_sym_extern] = ACTIONS(1923),
    [anon_sym___attribute__] = ACTIONS(1923),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1921),
    [anon_sym___declspec] = ACTIONS(1923),
    [anon_sym___cdecl] = ACTIONS(1923),
    [anon_sym___clrcall] = ACTIONS(1923),
    [anon_sym___stdcall] = ACTIONS(1923),
    [anon_sym___fastcall] = ACTIONS(1923),
    [anon_sym___thiscall] = ACTIONS(1923),
    [anon_sym___vectorcall] = ACTIONS(1923),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_signed] = ACTIONS(1923),
    [anon_sym_unsigned] = ACTIONS(1923),
    [anon_sym_long] = ACTIONS(1923),
    [anon_sym_short] = ACTIONS(1923),
    [anon_sym_static] = ACTIONS(1923),
    [anon_sym_auto] = ACTIONS(1923),
    [anon_sym_register] = ACTIONS(1923),
    [anon_sym_inline] = ACTIONS(1923),
    [anon_sym___inline] = ACTIONS(1923),
    [anon_sym___inline__] = ACTIONS(1923),
    [anon_sym___forceinline] = ACTIONS(1923),
    [anon_sym_thread_local] = ACTIONS(1923),
    [anon_sym___thread] = ACTIONS(1923),
    [anon_sym_const] = ACTIONS(1923),
    [anon_sym_constexpr] = ACTIONS(1923),
    [anon_sym_volatile] = ACTIONS(1923),
    [anon_sym_restrict] = ACTIONS(1923),
    [anon_sym___restrict__] = ACTIONS(1923),
    [anon_sym__Atomic] = ACTIONS(1923),
    [anon_sym__Noreturn] = ACTIONS(1923),
    [anon_sym_noreturn] = ACTIONS(1923),
    [sym_primitive_type] = ACTIONS(1923),
    [anon_sym_enum] = ACTIONS(1923),
    [anon_sym_struct] = ACTIONS(1923),
    [anon_sym_union] = ACTIONS(1923),
    [anon_sym_if] = ACTIONS(1923),
    [anon_sym_switch] = ACTIONS(1923),
    [anon_sym_case] = ACTIONS(1923),
    [anon_sym_default] = ACTIONS(1923),
    [anon_sym_while] = ACTIONS(1923),
    [anon_sym_do] = ACTIONS(1923),
    [anon_sym_for] = ACTIONS(1923),
    [anon_sym_return] = ACTIONS(1923),
    [anon_sym_break] = ACTIONS(1923),
    [anon_sym_continue] = ACTIONS(1923),
    [anon_sym_goto] = ACTIONS(1923),
    [anon_sym_DASH_DASH] = ACTIONS(1921),
    [anon_sym_PLUS_PLUS] = ACTIONS(1921),
    [anon_sym_sizeof] = ACTIONS(1923),
    [anon_sym___alignof__] = ACTIONS(1923),
    [anon_sym___alignof] = ACTIONS(1923),
    [anon_sym__alignof] = ACTIONS(1923),
    [anon_sym_alignof] = ACTIONS(1923),
    [anon_sym__Alignof] = ACTIONS(1923),
    [anon_sym_offsetof] = ACTIONS(1923),
    [anon_sym__Generic] = ACTIONS(1923),
    [anon_sym_asm] = ACTIONS(1923),
    [anon_sym___asm__] = ACTIONS(1923),
    [sym_number_literal] = ACTIONS(1921),
    [anon_sym_L_SQUOTE] = ACTIONS(1921),
    [anon_sym_u_SQUOTE] = ACTIONS(1921),
    [anon_sym_U_SQUOTE] = ACTIONS(1921),
    [anon_sym_u8_SQUOTE] = ACTIONS(1921),
    [anon_sym_SQUOTE] = ACTIONS(1921),
    [anon_sym_L_DQUOTE] = ACTIONS(1921),
    [anon_sym_u_DQUOTE] = ACTIONS(1921),
    [anon_sym_U_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8_DQUOTE] = ACTIONS(1921),
    [anon_sym_DQUOTE] = ACTIONS(1921),
    [sym_true] = ACTIONS(1923),
    [sym_false] = ACTIONS(1923),
    [anon_sym_NULL] = ACTIONS(1923),
    [anon_sym_nullptr] = ACTIONS(1923),
    [sym_comment] = ACTIONS(3),
  },
  [512] = {
    [ts_builtin_sym_end] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(1498),
    [aux_sym_preproc_include_token1] = ACTIONS(1498),
    [aux_sym_preproc_def_token1] = ACTIONS(1498),
    [aux_sym_preproc_if_token1] = ACTIONS(1498),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1498),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1498),
    [sym_preproc_directive] = ACTIONS(1498),
    [anon_sym_LPAREN2] = ACTIONS(1500),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_TILDE] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1498),
    [anon_sym_PLUS] = ACTIONS(1498),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym___extension__] = ACTIONS(1498),
    [anon_sym_typedef] = ACTIONS(1498),
    [anon_sym_extern] = ACTIONS(1498),
    [anon_sym___attribute__] = ACTIONS(1498),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1500),
    [anon_sym___declspec] = ACTIONS(1498),
    [anon_sym___cdecl] = ACTIONS(1498),
    [anon_sym___clrcall] = ACTIONS(1498),
    [anon_sym___stdcall] = ACTIONS(1498),
    [anon_sym___fastcall] = ACTIONS(1498),
    [anon_sym___thiscall] = ACTIONS(1498),
    [anon_sym___vectorcall] = ACTIONS(1498),
    [anon_sym_LBRACE] = ACTIONS(1500),
    [anon_sym_signed] = ACTIONS(1498),
    [anon_sym_unsigned] = ACTIONS(1498),
    [anon_sym_long] = ACTIONS(1498),
    [anon_sym_short] = ACTIONS(1498),
    [anon_sym_static] = ACTIONS(1498),
    [anon_sym_auto] = ACTIONS(1498),
    [anon_sym_register] = ACTIONS(1498),
    [anon_sym_inline] = ACTIONS(1498),
    [anon_sym___inline] = ACTIONS(1498),
    [anon_sym___inline__] = ACTIONS(1498),
    [anon_sym___forceinline] = ACTIONS(1498),
    [anon_sym_thread_local] = ACTIONS(1498),
    [anon_sym___thread] = ACTIONS(1498),
    [anon_sym_const] = ACTIONS(1498),
    [anon_sym_constexpr] = ACTIONS(1498),
    [anon_sym_volatile] = ACTIONS(1498),
    [anon_sym_restrict] = ACTIONS(1498),
    [anon_sym___restrict__] = ACTIONS(1498),
    [anon_sym__Atomic] = ACTIONS(1498),
    [anon_sym__Noreturn] = ACTIONS(1498),
    [anon_sym_noreturn] = ACTIONS(1498),
    [sym_primitive_type] = ACTIONS(1498),
    [anon_sym_enum] = ACTIONS(1498),
    [anon_sym_struct] = ACTIONS(1498),
    [anon_sym_union] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1498),
    [anon_sym_switch] = ACTIONS(1498),
    [anon_sym_case] = ACTIONS(1498),
    [anon_sym_default] = ACTIONS(1498),
    [anon_sym_while] = ACTIONS(1498),
    [anon_sym_do] = ACTIONS(1498),
    [anon_sym_for] = ACTIONS(1498),
    [anon_sym_return] = ACTIONS(1498),
    [anon_sym_break] = ACTIONS(1498),
    [anon_sym_continue] = ACTIONS(1498),
    [anon_sym_goto] = ACTIONS(1498),
    [anon_sym_DASH_DASH] = ACTIONS(1500),
    [anon_sym_PLUS_PLUS] = ACTIONS(1500),
    [anon_sym_sizeof] = ACTIONS(1498),
    [anon_sym___alignof__] = ACTIONS(1498),
    [anon_sym___alignof] = ACTIONS(1498),
    [anon_sym__alignof] = ACTIONS(1498),
    [anon_sym_alignof] = ACTIONS(1498),
    [anon_sym__Alignof] = ACTIONS(1498),
    [anon_sym_offsetof] = ACTIONS(1498),
    [anon_sym__Generic] = ACTIONS(1498),
    [anon_sym_asm] = ACTIONS(1498),
    [anon_sym___asm__] = ACTIONS(1498),
    [sym_number_literal] = ACTIONS(1500),
    [anon_sym_L_SQUOTE] = ACTIONS(1500),
    [anon_sym_u_SQUOTE] = ACTIONS(1500),
    [anon_sym_U_SQUOTE] = ACTIONS(1500),
    [anon_sym_u8_SQUOTE] = ACTIONS(1500),
    [anon_sym_SQUOTE] = ACTIONS(1500),
    [anon_sym_L_DQUOTE] = ACTIONS(1500),
    [anon_sym_u_DQUOTE] = ACTIONS(1500),
    [anon_sym_U_DQUOTE] = ACTIONS(1500),
    [anon_sym_u8_DQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE] = ACTIONS(1500),
    [sym_true] = ACTIONS(1498),
    [sym_false] = ACTIONS(1498),
    [anon_sym_NULL] = ACTIONS(1498),
    [anon_sym_nullptr] = ACTIONS(1498),
    [sym_comment] = ACTIONS(3),
  },
  [513] = {
    [ts_builtin_sym_end] = ACTIONS(1516),
    [sym_identifier] = ACTIONS(1514),
    [aux_sym_preproc_include_token1] = ACTIONS(1514),
    [aux_sym_preproc_def_token1] = ACTIONS(1514),
    [aux_sym_preproc_if_token1] = ACTIONS(1514),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1514),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1514),
    [sym_preproc_directive] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(1516),
    [anon_sym_BANG] = ACTIONS(1516),
    [anon_sym_TILDE] = ACTIONS(1516),
    [anon_sym_DASH] = ACTIONS(1514),
    [anon_sym_PLUS] = ACTIONS(1514),
    [anon_sym_STAR] = ACTIONS(1516),
    [anon_sym_AMP] = ACTIONS(1516),
    [anon_sym___extension__] = ACTIONS(1514),
    [anon_sym_typedef] = ACTIONS(1514),
    [anon_sym_extern] = ACTIONS(1514),
    [anon_sym___attribute__] = ACTIONS(1514),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym___declspec] = ACTIONS(1514),
    [anon_sym___cdecl] = ACTIONS(1514),
    [anon_sym___clrcall] = ACTIONS(1514),
    [anon_sym___stdcall] = ACTIONS(1514),
    [anon_sym___fastcall] = ACTIONS(1514),
    [anon_sym___thiscall] = ACTIONS(1514),
    [anon_sym___vectorcall] = ACTIONS(1514),
    [anon_sym_LBRACE] = ACTIONS(1516),
    [anon_sym_signed] = ACTIONS(1514),
    [anon_sym_unsigned] = ACTIONS(1514),
    [anon_sym_long] = ACTIONS(1514),
    [anon_sym_short] = ACTIONS(1514),
    [anon_sym_static] = ACTIONS(1514),
    [anon_sym_auto] = ACTIONS(1514),
    [anon_sym_register] = ACTIONS(1514),
    [anon_sym_inline] = ACTIONS(1514),
    [anon_sym___inline] = ACTIONS(1514),
    [anon_sym___inline__] = ACTIONS(1514),
    [anon_sym___forceinline] = ACTIONS(1514),
    [anon_sym_thread_local] = ACTIONS(1514),
    [anon_sym___thread] = ACTIONS(1514),
    [anon_sym_const] = ACTIONS(1514),
    [anon_sym_constexpr] = ACTIONS(1514),
    [anon_sym_volatile] = ACTIONS(1514),
    [anon_sym_restrict] = ACTIONS(1514),
    [anon_sym___restrict__] = ACTIONS(1514),
    [anon_sym__Atomic] = ACTIONS(1514),
    [anon_sym__Noreturn] = ACTIONS(1514),
    [anon_sym_noreturn] = ACTIONS(1514),
    [sym_primitive_type] = ACTIONS(1514),
    [anon_sym_enum] = ACTIONS(1514),
    [anon_sym_struct] = ACTIONS(1514),
    [anon_sym_union] = ACTIONS(1514),
    [anon_sym_if] = ACTIONS(1514),
    [anon_sym_switch] = ACTIONS(1514),
    [anon_sym_case] = ACTIONS(1514),
    [anon_sym_default] = ACTIONS(1514),
    [anon_sym_while] = ACTIONS(1514),
    [anon_sym_do] = ACTIONS(1514),
    [anon_sym_for] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1514),
    [anon_sym_break] = ACTIONS(1514),
    [anon_sym_continue] = ACTIONS(1514),
    [anon_sym_goto] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1516),
    [anon_sym_PLUS_PLUS] = ACTIONS(1516),
    [anon_sym_sizeof] = ACTIONS(1514),
    [anon_sym___alignof__] = ACTIONS(1514),
    [anon_sym___alignof] = ACTIONS(1514),
    [anon_sym__alignof] = ACTIONS(1514),
    [anon_sym_alignof] = ACTIONS(1514),
    [anon_sym__Alignof] = ACTIONS(1514),
    [anon_sym_offsetof] = ACTIONS(1514),
    [anon_sym__Generic] = ACTIONS(1514),
    [anon_sym_asm] = ACTIONS(1514),
    [anon_sym___asm__] = ACTIONS(1514),
    [sym_number_literal] = ACTIONS(1516),
    [anon_sym_L_SQUOTE] = ACTIONS(1516),
    [anon_sym_u_SQUOTE] = ACTIONS(1516),
    [anon_sym_U_SQUOTE] = ACTIONS(1516),
    [anon_sym_u8_SQUOTE] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1516),
    [anon_sym_L_DQUOTE] = ACTIONS(1516),
    [anon_sym_u_DQUOTE] = ACTIONS(1516),
    [anon_sym_U_DQUOTE] = ACTIONS(1516),
    [anon_sym_u8_DQUOTE] = ACTIONS(1516),
    [anon_sym_DQUOTE] = ACTIONS(1516),
    [sym_true] = ACTIONS(1514),
    [sym_false] = ACTIONS(1514),
    [anon_sym_NULL] = ACTIONS(1514),
    [anon_sym_nullptr] = ACTIONS(1514),
    [sym_comment] = ACTIONS(3),
  },
  [514] = {
    [ts_builtin_sym_end] = ACTIONS(1440),
    [sym_identifier] = ACTIONS(1438),
    [aux_sym_preproc_include_token1] = ACTIONS(1438),
    [aux_sym_preproc_def_token1] = ACTIONS(1438),
    [aux_sym_preproc_if_token1] = ACTIONS(1438),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1438),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1438),
    [sym_preproc_directive] = ACTIONS(1438),
    [anon_sym_LPAREN2] = ACTIONS(1440),
    [anon_sym_BANG] = ACTIONS(1440),
    [anon_sym_TILDE] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1438),
    [anon_sym_PLUS] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym___extension__] = ACTIONS(1438),
    [anon_sym_typedef] = ACTIONS(1438),
    [anon_sym_extern] = ACTIONS(1438),
    [anon_sym___attribute__] = ACTIONS(1438),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1440),
    [anon_sym___declspec] = ACTIONS(1438),
    [anon_sym___cdecl] = ACTIONS(1438),
    [anon_sym___clrcall] = ACTIONS(1438),
    [anon_sym___stdcall] = ACTIONS(1438),
    [anon_sym___fastcall] = ACTIONS(1438),
    [anon_sym___thiscall] = ACTIONS(1438),
    [anon_sym___vectorcall] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(1440),
    [anon_sym_signed] = ACTIONS(1438),
    [anon_sym_unsigned] = ACTIONS(1438),
    [anon_sym_long] = ACTIONS(1438),
    [anon_sym_short] = ACTIONS(1438),
    [anon_sym_static] = ACTIONS(1438),
    [anon_sym_auto] = ACTIONS(1438),
    [anon_sym_register] = ACTIONS(1438),
    [anon_sym_inline] = ACTIONS(1438),
    [anon_sym___inline] = ACTIONS(1438),
    [anon_sym___inline__] = ACTIONS(1438),
    [anon_sym___forceinline] = ACTIONS(1438),
    [anon_sym_thread_local] = ACTIONS(1438),
    [anon_sym___thread] = ACTIONS(1438),
    [anon_sym_const] = ACTIONS(1438),
    [anon_sym_constexpr] = ACTIONS(1438),
    [anon_sym_volatile] = ACTIONS(1438),
    [anon_sym_restrict] = ACTIONS(1438),
    [anon_sym___restrict__] = ACTIONS(1438),
    [anon_sym__Atomic] = ACTIONS(1438),
    [anon_sym__Noreturn] = ACTIONS(1438),
    [anon_sym_noreturn] = ACTIONS(1438),
    [sym_primitive_type] = ACTIONS(1438),
    [anon_sym_enum] = ACTIONS(1438),
    [anon_sym_struct] = ACTIONS(1438),
    [anon_sym_union] = ACTIONS(1438),
    [anon_sym_if] = ACTIONS(1438),
    [anon_sym_switch] = ACTIONS(1438),
    [anon_sym_case] = ACTIONS(1438),
    [anon_sym_default] = ACTIONS(1438),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_do] = ACTIONS(1438),
    [anon_sym_for] = ACTIONS(1438),
    [anon_sym_return] = ACTIONS(1438),
    [anon_sym_break] = ACTIONS(1438),
    [anon_sym_continue] = ACTIONS(1438),
    [anon_sym_goto] = ACTIONS(1438),
    [anon_sym_DASH_DASH] = ACTIONS(1440),
    [anon_sym_PLUS_PLUS] = ACTIONS(1440),
    [anon_sym_sizeof] = ACTIONS(1438),
    [anon_sym___alignof__] = ACTIONS(1438),
    [anon_sym___alignof] = ACTIONS(1438),
    [anon_sym__alignof] = ACTIONS(1438),
    [anon_sym_alignof] = ACTIONS(1438),
    [anon_sym__Alignof] = ACTIONS(1438),
    [anon_sym_offsetof] = ACTIONS(1438),
    [anon_sym__Generic] = ACTIONS(1438),
    [anon_sym_asm] = ACTIONS(1438),
    [anon_sym___asm__] = ACTIONS(1438),
    [sym_number_literal] = ACTIONS(1440),
    [anon_sym_L_SQUOTE] = ACTIONS(1440),
    [anon_sym_u_SQUOTE] = ACTIONS(1440),
    [anon_sym_U_SQUOTE] = ACTIONS(1440),
    [anon_sym_u8_SQUOTE] = ACTIONS(1440),
    [anon_sym_SQUOTE] = ACTIONS(1440),
    [anon_sym_L_DQUOTE] = ACTIONS(1440),
    [anon_sym_u_DQUOTE] = ACTIONS(1440),
    [anon_sym_U_DQUOTE] = ACTIONS(1440),
    [anon_sym_u8_DQUOTE] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [sym_true] = ACTIONS(1438),
    [sym_false] = ACTIONS(1438),
    [anon_sym_NULL] = ACTIONS(1438),
    [anon_sym_nullptr] = ACTIONS(1438),
    [sym_comment] = ACTIONS(3),
  },
  [515] = {
    [ts_builtin_sym_end] = ACTIONS(1476),
    [sym_identifier] = ACTIONS(1474),
    [aux_sym_preproc_include_token1] = ACTIONS(1474),
    [aux_sym_preproc_def_token1] = ACTIONS(1474),
    [aux_sym_preproc_if_token1] = ACTIONS(1474),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1474),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1474),
    [sym_preproc_directive] = ACTIONS(1474),
    [anon_sym_LPAREN2] = ACTIONS(1476),
    [anon_sym_BANG] = ACTIONS(1476),
    [anon_sym_TILDE] = ACTIONS(1476),
    [anon_sym_DASH] = ACTIONS(1474),
    [anon_sym_PLUS] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym___extension__] = ACTIONS(1474),
    [anon_sym_typedef] = ACTIONS(1474),
    [anon_sym_extern] = ACTIONS(1474),
    [anon_sym___attribute__] = ACTIONS(1474),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1476),
    [anon_sym___declspec] = ACTIONS(1474),
    [anon_sym___cdecl] = ACTIONS(1474),
    [anon_sym___clrcall] = ACTIONS(1474),
    [anon_sym___stdcall] = ACTIONS(1474),
    [anon_sym___fastcall] = ACTIONS(1474),
    [anon_sym___thiscall] = ACTIONS(1474),
    [anon_sym___vectorcall] = ACTIONS(1474),
    [anon_sym_LBRACE] = ACTIONS(1476),
    [anon_sym_signed] = ACTIONS(1474),
    [anon_sym_unsigned] = ACTIONS(1474),
    [anon_sym_long] = ACTIONS(1474),
    [anon_sym_short] = ACTIONS(1474),
    [anon_sym_static] = ACTIONS(1474),
    [anon_sym_auto] = ACTIONS(1474),
    [anon_sym_register] = ACTIONS(1474),
    [anon_sym_inline] = ACTIONS(1474),
    [anon_sym___inline] = ACTIONS(1474),
    [anon_sym___inline__] = ACTIONS(1474),
    [anon_sym___forceinline] = ACTIONS(1474),
    [anon_sym_thread_local] = ACTIONS(1474),
    [anon_sym___thread] = ACTIONS(1474),
    [anon_sym_const] = ACTIONS(1474),
    [anon_sym_constexpr] = ACTIONS(1474),
    [anon_sym_volatile] = ACTIONS(1474),
    [anon_sym_restrict] = ACTIONS(1474),
    [anon_sym___restrict__] = ACTIONS(1474),
    [anon_sym__Atomic] = ACTIONS(1474),
    [anon_sym__Noreturn] = ACTIONS(1474),
    [anon_sym_noreturn] = ACTIONS(1474),
    [sym_primitive_type] = ACTIONS(1474),
    [anon_sym_enum] = ACTIONS(1474),
    [anon_sym_struct] = ACTIONS(1474),
    [anon_sym_union] = ACTIONS(1474),
    [anon_sym_if] = ACTIONS(1474),
    [anon_sym_switch] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1474),
    [anon_sym_default] = ACTIONS(1474),
    [anon_sym_while] = ACTIONS(1474),
    [anon_sym_do] = ACTIONS(1474),
    [anon_sym_for] = ACTIONS(1474),
    [anon_sym_return] = ACTIONS(1474),
    [anon_sym_break] = ACTIONS(1474),
    [anon_sym_continue] = ACTIONS(1474),
    [anon_sym_goto] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1476),
    [anon_sym_PLUS_PLUS] = ACTIONS(1476),
    [anon_sym_sizeof] = ACTIONS(1474),
    [anon_sym___alignof__] = ACTIONS(1474),
    [anon_sym___alignof] = ACTIONS(1474),
    [anon_sym__alignof] = ACTIONS(1474),
    [anon_sym_alignof] = ACTIONS(1474),
    [anon_sym__Alignof] = ACTIONS(1474),
    [anon_sym_offsetof] = ACTIONS(1474),
    [anon_sym__Generic] = ACTIONS(1474),
    [anon_sym_asm] = ACTIONS(1474),
    [anon_sym___asm__] = ACTIONS(1474),
    [sym_number_literal] = ACTIONS(1476),
    [anon_sym_L_SQUOTE] = ACTIONS(1476),
    [anon_sym_u_SQUOTE] = ACTIONS(1476),
    [anon_sym_U_SQUOTE] = ACTIONS(1476),
    [anon_sym_u8_SQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1476),
    [anon_sym_L_DQUOTE] = ACTIONS(1476),
    [anon_sym_u_DQUOTE] = ACTIONS(1476),
    [anon_sym_U_DQUOTE] = ACTIONS(1476),
    [anon_sym_u8_DQUOTE] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [sym_true] = ACTIONS(1474),
    [sym_false] = ACTIONS(1474),
    [anon_sym_NULL] = ACTIONS(1474),
    [anon_sym_nullptr] = ACTIONS(1474),
    [sym_comment] = ACTIONS(3),
  },
  [516] = {
    [ts_builtin_sym_end] = ACTIONS(1464),
    [sym_identifier] = ACTIONS(1462),
    [aux_sym_preproc_include_token1] = ACTIONS(1462),
    [aux_sym_preproc_def_token1] = ACTIONS(1462),
    [aux_sym_preproc_if_token1] = ACTIONS(1462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1462),
    [sym_preproc_directive] = ACTIONS(1462),
    [anon_sym_LPAREN2] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1464),
    [anon_sym_TILDE] = ACTIONS(1464),
    [anon_sym_DASH] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1462),
    [anon_sym_STAR] = ACTIONS(1464),
    [anon_sym_AMP] = ACTIONS(1464),
    [anon_sym___extension__] = ACTIONS(1462),
    [anon_sym_typedef] = ACTIONS(1462),
    [anon_sym_extern] = ACTIONS(1462),
    [anon_sym___attribute__] = ACTIONS(1462),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1464),
    [anon_sym___declspec] = ACTIONS(1462),
    [anon_sym___cdecl] = ACTIONS(1462),
    [anon_sym___clrcall] = ACTIONS(1462),
    [anon_sym___stdcall] = ACTIONS(1462),
    [anon_sym___fastcall] = ACTIONS(1462),
    [anon_sym___thiscall] = ACTIONS(1462),
    [anon_sym___vectorcall] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_signed] = ACTIONS(1462),
    [anon_sym_unsigned] = ACTIONS(1462),
    [anon_sym_long] = ACTIONS(1462),
    [anon_sym_short] = ACTIONS(1462),
    [anon_sym_static] = ACTIONS(1462),
    [anon_sym_auto] = ACTIONS(1462),
    [anon_sym_register] = ACTIONS(1462),
    [anon_sym_inline] = ACTIONS(1462),
    [anon_sym___inline] = ACTIONS(1462),
    [anon_sym___inline__] = ACTIONS(1462),
    [anon_sym___forceinline] = ACTIONS(1462),
    [anon_sym_thread_local] = ACTIONS(1462),
    [anon_sym___thread] = ACTIONS(1462),
    [anon_sym_const] = ACTIONS(1462),
    [anon_sym_constexpr] = ACTIONS(1462),
    [anon_sym_volatile] = ACTIONS(1462),
    [anon_sym_restrict] = ACTIONS(1462),
    [anon_sym___restrict__] = ACTIONS(1462),
    [anon_sym__Atomic] = ACTIONS(1462),
    [anon_sym__Noreturn] = ACTIONS(1462),
    [anon_sym_noreturn] = ACTIONS(1462),
    [sym_primitive_type] = ACTIONS(1462),
    [anon_sym_enum] = ACTIONS(1462),
    [anon_sym_struct] = ACTIONS(1462),
    [anon_sym_union] = ACTIONS(1462),
    [anon_sym_if] = ACTIONS(1462),
    [anon_sym_switch] = ACTIONS(1462),
    [anon_sym_case] = ACTIONS(1462),
    [anon_sym_default] = ACTIONS(1462),
    [anon_sym_while] = ACTIONS(1462),
    [anon_sym_do] = ACTIONS(1462),
    [anon_sym_for] = ACTIONS(1462),
    [anon_sym_return] = ACTIONS(1462),
    [anon_sym_break] = ACTIONS(1462),
    [anon_sym_continue] = ACTIONS(1462),
    [anon_sym_goto] = ACTIONS(1462),
    [anon_sym_DASH_DASH] = ACTIONS(1464),
    [anon_sym_PLUS_PLUS] = ACTIONS(1464),
    [anon_sym_sizeof] = ACTIONS(1462),
    [anon_sym___alignof__] = ACTIONS(1462),
    [anon_sym___alignof] = ACTIONS(1462),
    [anon_sym__alignof] = ACTIONS(1462),
    [anon_sym_alignof] = ACTIONS(1462),
    [anon_sym__Alignof] = ACTIONS(1462),
    [anon_sym_offsetof] = ACTIONS(1462),
    [anon_sym__Generic] = ACTIONS(1462),
    [anon_sym_asm] = ACTIONS(1462),
    [anon_sym___asm__] = ACTIONS(1462),
    [sym_number_literal] = ACTIONS(1464),
    [anon_sym_L_SQUOTE] = ACTIONS(1464),
    [anon_sym_u_SQUOTE] = ACTIONS(1464),
    [anon_sym_U_SQUOTE] = ACTIONS(1464),
    [anon_sym_u8_SQUOTE] = ACTIONS(1464),
    [anon_sym_SQUOTE] = ACTIONS(1464),
    [anon_sym_L_DQUOTE] = ACTIONS(1464),
    [anon_sym_u_DQUOTE] = ACTIONS(1464),
    [anon_sym_U_DQUOTE] = ACTIONS(1464),
    [anon_sym_u8_DQUOTE] = ACTIONS(1464),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [sym_true] = ACTIONS(1462),
    [sym_false] = ACTIONS(1462),
    [anon_sym_NULL] = ACTIONS(1462),
    [anon_sym_nullptr] = ACTIONS(1462),
    [sym_comment] = ACTIONS(3),
  },
  [517] = {
    [ts_builtin_sym_end] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1927),
    [aux_sym_preproc_include_token1] = ACTIONS(1927),
    [aux_sym_preproc_def_token1] = ACTIONS(1927),
    [aux_sym_preproc_if_token1] = ACTIONS(1927),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1927),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1927),
    [sym_preproc_directive] = ACTIONS(1927),
    [anon_sym_LPAREN2] = ACTIONS(1925),
    [anon_sym_BANG] = ACTIONS(1925),
    [anon_sym_TILDE] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_PLUS] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1925),
    [anon_sym_AMP] = ACTIONS(1925),
    [anon_sym___extension__] = ACTIONS(1927),
    [anon_sym_typedef] = ACTIONS(1927),
    [anon_sym_extern] = ACTIONS(1927),
    [anon_sym___attribute__] = ACTIONS(1927),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1925),
    [anon_sym___declspec] = ACTIONS(1927),
    [anon_sym___cdecl] = ACTIONS(1927),
    [anon_sym___clrcall] = ACTIONS(1927),
    [anon_sym___stdcall] = ACTIONS(1927),
    [anon_sym___fastcall] = ACTIONS(1927),
    [anon_sym___thiscall] = ACTIONS(1927),
    [anon_sym___vectorcall] = ACTIONS(1927),
    [anon_sym_LBRACE] = ACTIONS(1925),
    [anon_sym_signed] = ACTIONS(1927),
    [anon_sym_unsigned] = ACTIONS(1927),
    [anon_sym_long] = ACTIONS(1927),
    [anon_sym_short] = ACTIONS(1927),
    [anon_sym_static] = ACTIONS(1927),
    [anon_sym_auto] = ACTIONS(1927),
    [anon_sym_register] = ACTIONS(1927),
    [anon_sym_inline] = ACTIONS(1927),
    [anon_sym___inline] = ACTIONS(1927),
    [anon_sym___inline__] = ACTIONS(1927),
    [anon_sym___forceinline] = ACTIONS(1927),
    [anon_sym_thread_local] = ACTIONS(1927),
    [anon_sym___thread] = ACTIONS(1927),
    [anon_sym_const] = ACTIONS(1927),
    [anon_sym_constexpr] = ACTIONS(1927),
    [anon_sym_volatile] = ACTIONS(1927),
    [anon_sym_restrict] = ACTIONS(1927),
    [anon_sym___restrict__] = ACTIONS(1927),
    [anon_sym__Atomic] = ACTIONS(1927),
    [anon_sym__Noreturn] = ACTIONS(1927),
    [anon_sym_noreturn] = ACTIONS(1927),
    [sym_primitive_type] = ACTIONS(1927),
    [anon_sym_enum] = ACTIONS(1927),
    [anon_sym_struct] = ACTIONS(1927),
    [anon_sym_union] = ACTIONS(1927),
    [anon_sym_if] = ACTIONS(1927),
    [anon_sym_switch] = ACTIONS(1927),
    [anon_sym_case] = ACTIONS(1927),
    [anon_sym_default] = ACTIONS(1927),
    [anon_sym_while] = ACTIONS(1927),
    [anon_sym_do] = ACTIONS(1927),
    [anon_sym_for] = ACTIONS(1927),
    [anon_sym_return] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1927),
    [anon_sym_continue] = ACTIONS(1927),
    [anon_sym_goto] = ACTIONS(1927),
    [anon_sym_DASH_DASH] = ACTIONS(1925),
    [anon_sym_PLUS_PLUS] = ACTIONS(1925),
    [anon_sym_sizeof] = ACTIONS(1927),
    [anon_sym___alignof__] = ACTIONS(1927),
    [anon_sym___alignof] = ACTIONS(1927),
    [anon_sym__alignof] = ACTIONS(1927),
    [anon_sym_alignof] = ACTIONS(1927),
    [anon_sym__Alignof] = ACTIONS(1927),
    [anon_sym_offsetof] = ACTIONS(1927),
    [anon_sym__Generic] = ACTIONS(1927),
    [anon_sym_asm] = ACTIONS(1927),
    [anon_sym___asm__] = ACTIONS(1927),
    [sym_number_literal] = ACTIONS(1925),
    [anon_sym_L_SQUOTE] = ACTIONS(1925),
    [anon_sym_u_SQUOTE] = ACTIONS(1925),
    [anon_sym_U_SQUOTE] = ACTIONS(1925),
    [anon_sym_u8_SQUOTE] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1925),
    [anon_sym_L_DQUOTE] = ACTIONS(1925),
    [anon_sym_u_DQUOTE] = ACTIONS(1925),
    [anon_sym_U_DQUOTE] = ACTIONS(1925),
    [anon_sym_u8_DQUOTE] = ACTIONS(1925),
    [anon_sym_DQUOTE] = ACTIONS(1925),
    [sym_true] = ACTIONS(1927),
    [sym_false] = ACTIONS(1927),
    [anon_sym_NULL] = ACTIONS(1927),
    [anon_sym_nullptr] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
  },
  [518] = {
    [ts_builtin_sym_end] = ACTIONS(1528),
    [sym_identifier] = ACTIONS(1526),
    [aux_sym_preproc_include_token1] = ACTIONS(1526),
    [aux_sym_preproc_def_token1] = ACTIONS(1526),
    [aux_sym_preproc_if_token1] = ACTIONS(1526),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1526),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1526),
    [sym_preproc_directive] = ACTIONS(1526),
    [anon_sym_LPAREN2] = ACTIONS(1528),
    [anon_sym_BANG] = ACTIONS(1528),
    [anon_sym_TILDE] = ACTIONS(1528),
    [anon_sym_DASH] = ACTIONS(1526),
    [anon_sym_PLUS] = ACTIONS(1526),
    [anon_sym_STAR] = ACTIONS(1528),
    [anon_sym_AMP] = ACTIONS(1528),
    [anon_sym___extension__] = ACTIONS(1526),
    [anon_sym_typedef] = ACTIONS(1526),
    [anon_sym_extern] = ACTIONS(1526),
    [anon_sym___attribute__] = ACTIONS(1526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1528),
    [anon_sym___declspec] = ACTIONS(1526),
    [anon_sym___cdecl] = ACTIONS(1526),
    [anon_sym___clrcall] = ACTIONS(1526),
    [anon_sym___stdcall] = ACTIONS(1526),
    [anon_sym___fastcall] = ACTIONS(1526),
    [anon_sym___thiscall] = ACTIONS(1526),
    [anon_sym___vectorcall] = ACTIONS(1526),
    [anon_sym_LBRACE] = ACTIONS(1528),
    [anon_sym_signed] = ACTIONS(1526),
    [anon_sym_unsigned] = ACTIONS(1526),
    [anon_sym_long] = ACTIONS(1526),
    [anon_sym_short] = ACTIONS(1526),
    [anon_sym_static] = ACTIONS(1526),
    [anon_sym_auto] = ACTIONS(1526),
    [anon_sym_register] = ACTIONS(1526),
    [anon_sym_inline] = ACTIONS(1526),
    [anon_sym___inline] = ACTIONS(1526),
    [anon_sym___inline__] = ACTIONS(1526),
    [anon_sym___forceinline] = ACTIONS(1526),
    [anon_sym_thread_local] = ACTIONS(1526),
    [anon_sym___thread] = ACTIONS(1526),
    [anon_sym_const] = ACTIONS(1526),
    [anon_sym_constexpr] = ACTIONS(1526),
    [anon_sym_volatile] = ACTIONS(1526),
    [anon_sym_restrict] = ACTIONS(1526),
    [anon_sym___restrict__] = ACTIONS(1526),
    [anon_sym__Atomic] = ACTIONS(1526),
    [anon_sym__Noreturn] = ACTIONS(1526),
    [anon_sym_noreturn] = ACTIONS(1526),
    [sym_primitive_type] = ACTIONS(1526),
    [anon_sym_enum] = ACTIONS(1526),
    [anon_sym_struct] = ACTIONS(1526),
    [anon_sym_union] = ACTIONS(1526),
    [anon_sym_if] = ACTIONS(1526),
    [anon_sym_switch] = ACTIONS(1526),
    [anon_sym_case] = ACTIONS(1526),
    [anon_sym_default] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1526),
    [anon_sym_do] = ACTIONS(1526),
    [anon_sym_for] = ACTIONS(1526),
    [anon_sym_return] = ACTIONS(1526),
    [anon_sym_break] = ACTIONS(1526),
    [anon_sym_continue] = ACTIONS(1526),
    [anon_sym_goto] = ACTIONS(1526),
    [anon_sym_DASH_DASH] = ACTIONS(1528),
    [anon_sym_PLUS_PLUS] = ACTIONS(1528),
    [anon_sym_sizeof] = ACTIONS(1526),
    [anon_sym___alignof__] = ACTIONS(1526),
    [anon_sym___alignof] = ACTIONS(1526),
    [anon_sym__alignof] = ACTIONS(1526),
    [anon_sym_alignof] = ACTIONS(1526),
    [anon_sym__Alignof] = ACTIONS(1526),
    [anon_sym_offsetof] = ACTIONS(1526),
    [anon_sym__Generic] = ACTIONS(1526),
    [anon_sym_asm] = ACTIONS(1526),
    [anon_sym___asm__] = ACTIONS(1526),
    [sym_number_literal] = ACTIONS(1528),
    [anon_sym_L_SQUOTE] = ACTIONS(1528),
    [anon_sym_u_SQUOTE] = ACTIONS(1528),
    [anon_sym_U_SQUOTE] = ACTIONS(1528),
    [anon_sym_u8_SQUOTE] = ACTIONS(1528),
    [anon_sym_SQUOTE] = ACTIONS(1528),
    [anon_sym_L_DQUOTE] = ACTIONS(1528),
    [anon_sym_u_DQUOTE] = ACTIONS(1528),
    [anon_sym_U_DQUOTE] = ACTIONS(1528),
    [anon_sym_u8_DQUOTE] = ACTIONS(1528),
    [anon_sym_DQUOTE] = ACTIONS(1528),
    [sym_true] = ACTIONS(1526),
    [sym_false] = ACTIONS(1526),
    [anon_sym_NULL] = ACTIONS(1526),
    [anon_sym_nullptr] = ACTIONS(1526),
    [sym_comment] = ACTIONS(3),
  },
  [519] = {
    [ts_builtin_sym_end] = ACTIONS(1504),
    [sym_identifier] = ACTIONS(1502),
    [aux_sym_preproc_include_token1] = ACTIONS(1502),
    [aux_sym_preproc_def_token1] = ACTIONS(1502),
    [aux_sym_preproc_if_token1] = ACTIONS(1502),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1502),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1502),
    [sym_preproc_directive] = ACTIONS(1502),
    [anon_sym_LPAREN2] = ACTIONS(1504),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_TILDE] = ACTIONS(1504),
    [anon_sym_DASH] = ACTIONS(1502),
    [anon_sym_PLUS] = ACTIONS(1502),
    [anon_sym_STAR] = ACTIONS(1504),
    [anon_sym_AMP] = ACTIONS(1504),
    [anon_sym___extension__] = ACTIONS(1502),
    [anon_sym_typedef] = ACTIONS(1502),
    [anon_sym_extern] = ACTIONS(1502),
    [anon_sym___attribute__] = ACTIONS(1502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1504),
    [anon_sym___declspec] = ACTIONS(1502),
    [anon_sym___cdecl] = ACTIONS(1502),
    [anon_sym___clrcall] = ACTIONS(1502),
    [anon_sym___stdcall] = ACTIONS(1502),
    [anon_sym___fastcall] = ACTIONS(1502),
    [anon_sym___thiscall] = ACTIONS(1502),
    [anon_sym___vectorcall] = ACTIONS(1502),
    [anon_sym_LBRACE] = ACTIONS(1504),
    [anon_sym_signed] = ACTIONS(1502),
    [anon_sym_unsigned] = ACTIONS(1502),
    [anon_sym_long] = ACTIONS(1502),
    [anon_sym_short] = ACTIONS(1502),
    [anon_sym_static] = ACTIONS(1502),
    [anon_sym_auto] = ACTIONS(1502),
    [anon_sym_register] = ACTIONS(1502),
    [anon_sym_inline] = ACTIONS(1502),
    [anon_sym___inline] = ACTIONS(1502),
    [anon_sym___inline__] = ACTIONS(1502),
    [anon_sym___forceinline] = ACTIONS(1502),
    [anon_sym_thread_local] = ACTIONS(1502),
    [anon_sym___thread] = ACTIONS(1502),
    [anon_sym_const] = ACTIONS(1502),
    [anon_sym_constexpr] = ACTIONS(1502),
    [anon_sym_volatile] = ACTIONS(1502),
    [anon_sym_restrict] = ACTIONS(1502),
    [anon_sym___restrict__] = ACTIONS(1502),
    [anon_sym__Atomic] = ACTIONS(1502),
    [anon_sym__Noreturn] = ACTIONS(1502),
    [anon_sym_noreturn] = ACTIONS(1502),
    [sym_primitive_type] = ACTIONS(1502),
    [anon_sym_enum] = ACTIONS(1502),
    [anon_sym_struct] = ACTIONS(1502),
    [anon_sym_union] = ACTIONS(1502),
    [anon_sym_if] = ACTIONS(1502),
    [anon_sym_switch] = ACTIONS(1502),
    [anon_sym_case] = ACTIONS(1502),
    [anon_sym_default] = ACTIONS(1502),
    [anon_sym_while] = ACTIONS(1502),
    [anon_sym_do] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1502),
    [anon_sym_return] = ACTIONS(1502),
    [anon_sym_break] = ACTIONS(1502),
    [anon_sym_continue] = ACTIONS(1502),
    [anon_sym_goto] = ACTIONS(1502),
    [anon_sym_DASH_DASH] = ACTIONS(1504),
    [anon_sym_PLUS_PLUS] = ACTIONS(1504),
    [anon_sym_sizeof] = ACTIONS(1502),
    [anon_sym___alignof__] = ACTIONS(1502),
    [anon_sym___alignof] = ACTIONS(1502),
    [anon_sym__alignof] = ACTIONS(1502),
    [anon_sym_alignof] = ACTIONS(1502),
    [anon_sym__Alignof] = ACTIONS(1502),
    [anon_sym_offsetof] = ACTIONS(1502),
    [anon_sym__Generic] = ACTIONS(1502),
    [anon_sym_asm] = ACTIONS(1502),
    [anon_sym___asm__] = ACTIONS(1502),
    [sym_number_literal] = ACTIONS(1504),
    [anon_sym_L_SQUOTE] = ACTIONS(1504),
    [anon_sym_u_SQUOTE] = ACTIONS(1504),
    [anon_sym_U_SQUOTE] = ACTIONS(1504),
    [anon_sym_u8_SQUOTE] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(1504),
    [anon_sym_L_DQUOTE] = ACTIONS(1504),
    [anon_sym_u_DQUOTE] = ACTIONS(1504),
    [anon_sym_U_DQUOTE] = ACTIONS(1504),
    [anon_sym_u8_DQUOTE] = ACTIONS(1504),
    [anon_sym_DQUOTE] = ACTIONS(1504),
    [sym_true] = ACTIONS(1502),
    [sym_false] = ACTIONS(1502),
    [anon_sym_NULL] = ACTIONS(1502),
    [anon_sym_nullptr] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
  },
  [520] = {
    [ts_builtin_sym_end] = ACTIONS(1484),
    [sym_identifier] = ACTIONS(1482),
    [aux_sym_preproc_include_token1] = ACTIONS(1482),
    [aux_sym_preproc_def_token1] = ACTIONS(1482),
    [aux_sym_preproc_if_token1] = ACTIONS(1482),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1482),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1482),
    [sym_preproc_directive] = ACTIONS(1482),
    [anon_sym_LPAREN2] = ACTIONS(1484),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_TILDE] = ACTIONS(1484),
    [anon_sym_DASH] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_STAR] = ACTIONS(1484),
    [anon_sym_AMP] = ACTIONS(1484),
    [anon_sym___extension__] = ACTIONS(1482),
    [anon_sym_typedef] = ACTIONS(1482),
    [anon_sym_extern] = ACTIONS(1482),
    [anon_sym___attribute__] = ACTIONS(1482),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1484),
    [anon_sym___declspec] = ACTIONS(1482),
    [anon_sym___cdecl] = ACTIONS(1482),
    [anon_sym___clrcall] = ACTIONS(1482),
    [anon_sym___stdcall] = ACTIONS(1482),
    [anon_sym___fastcall] = ACTIONS(1482),
    [anon_sym___thiscall] = ACTIONS(1482),
    [anon_sym___vectorcall] = ACTIONS(1482),
    [anon_sym_LBRACE] = ACTIONS(1484),
    [anon_sym_signed] = ACTIONS(1482),
    [anon_sym_unsigned] = ACTIONS(1482),
    [anon_sym_long] = ACTIONS(1482),
    [anon_sym_short] = ACTIONS(1482),
    [anon_sym_static] = ACTIONS(1482),
    [anon_sym_auto] = ACTIONS(1482),
    [anon_sym_register] = ACTIONS(1482),
    [anon_sym_inline] = ACTIONS(1482),
    [anon_sym___inline] = ACTIONS(1482),
    [anon_sym___inline__] = ACTIONS(1482),
    [anon_sym___forceinline] = ACTIONS(1482),
    [anon_sym_thread_local] = ACTIONS(1482),
    [anon_sym___thread] = ACTIONS(1482),
    [anon_sym_const] = ACTIONS(1482),
    [anon_sym_constexpr] = ACTIONS(1482),
    [anon_sym_volatile] = ACTIONS(1482),
    [anon_sym_restrict] = ACTIONS(1482),
    [anon_sym___restrict__] = ACTIONS(1482),
    [anon_sym__Atomic] = ACTIONS(1482),
    [anon_sym__Noreturn] = ACTIONS(1482),
    [anon_sym_noreturn] = ACTIONS(1482),
    [sym_primitive_type] = ACTIONS(1482),
    [anon_sym_enum] = ACTIONS(1482),
    [anon_sym_struct] = ACTIONS(1482),
    [anon_sym_union] = ACTIONS(1482),
    [anon_sym_if] = ACTIONS(1482),
    [anon_sym_switch] = ACTIONS(1482),
    [anon_sym_case] = ACTIONS(1482),
    [anon_sym_default] = ACTIONS(1482),
    [anon_sym_while] = ACTIONS(1482),
    [anon_sym_do] = ACTIONS(1482),
    [anon_sym_for] = ACTIONS(1482),
    [anon_sym_return] = ACTIONS(1482),
    [anon_sym_break] = ACTIONS(1482),
    [anon_sym_continue] = ACTIONS(1482),
    [anon_sym_goto] = ACTIONS(1482),
    [anon_sym_DASH_DASH] = ACTIONS(1484),
    [anon_sym_PLUS_PLUS] = ACTIONS(1484),
    [anon_sym_sizeof] = ACTIONS(1482),
    [anon_sym___alignof__] = ACTIONS(1482),
    [anon_sym___alignof] = ACTIONS(1482),
    [anon_sym__alignof] = ACTIONS(1482),
    [anon_sym_alignof] = ACTIONS(1482),
    [anon_sym__Alignof] = ACTIONS(1482),
    [anon_sym_offsetof] = ACTIONS(1482),
    [anon_sym__Generic] = ACTIONS(1482),
    [anon_sym_asm] = ACTIONS(1482),
    [anon_sym___asm__] = ACTIONS(1482),
    [sym_number_literal] = ACTIONS(1484),
    [anon_sym_L_SQUOTE] = ACTIONS(1484),
    [anon_sym_u_SQUOTE] = ACTIONS(1484),
    [anon_sym_U_SQUOTE] = ACTIONS(1484),
    [anon_sym_u8_SQUOTE] = ACTIONS(1484),
    [anon_sym_SQUOTE] = ACTIONS(1484),
    [anon_sym_L_DQUOTE] = ACTIONS(1484),
    [anon_sym_u_DQUOTE] = ACTIONS(1484),
    [anon_sym_U_DQUOTE] = ACTIONS(1484),
    [anon_sym_u8_DQUOTE] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(1484),
    [sym_true] = ACTIONS(1482),
    [sym_false] = ACTIONS(1482),
    [anon_sym_NULL] = ACTIONS(1482),
    [anon_sym_nullptr] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
  },
  [521] = {
    [ts_builtin_sym_end] = ACTIONS(1480),
    [sym_identifier] = ACTIONS(1478),
    [aux_sym_preproc_include_token1] = ACTIONS(1478),
    [aux_sym_preproc_def_token1] = ACTIONS(1478),
    [aux_sym_preproc_if_token1] = ACTIONS(1478),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1478),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1478),
    [sym_preproc_directive] = ACTIONS(1478),
    [anon_sym_LPAREN2] = ACTIONS(1480),
    [anon_sym_BANG] = ACTIONS(1480),
    [anon_sym_TILDE] = ACTIONS(1480),
    [anon_sym_DASH] = ACTIONS(1478),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_STAR] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1480),
    [anon_sym___extension__] = ACTIONS(1478),
    [anon_sym_typedef] = ACTIONS(1478),
    [anon_sym_extern] = ACTIONS(1478),
    [anon_sym___attribute__] = ACTIONS(1478),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1480),
    [anon_sym___declspec] = ACTIONS(1478),
    [anon_sym___cdecl] = ACTIONS(1478),
    [anon_sym___clrcall] = ACTIONS(1478),
    [anon_sym___stdcall] = ACTIONS(1478),
    [anon_sym___fastcall] = ACTIONS(1478),
    [anon_sym___thiscall] = ACTIONS(1478),
    [anon_sym___vectorcall] = ACTIONS(1478),
    [anon_sym_LBRACE] = ACTIONS(1480),
    [anon_sym_signed] = ACTIONS(1478),
    [anon_sym_unsigned] = ACTIONS(1478),
    [anon_sym_long] = ACTIONS(1478),
    [anon_sym_short] = ACTIONS(1478),
    [anon_sym_static] = ACTIONS(1478),
    [anon_sym_auto] = ACTIONS(1478),
    [anon_sym_register] = ACTIONS(1478),
    [anon_sym_inline] = ACTIONS(1478),
    [anon_sym___inline] = ACTIONS(1478),
    [anon_sym___inline__] = ACTIONS(1478),
    [anon_sym___forceinline] = ACTIONS(1478),
    [anon_sym_thread_local] = ACTIONS(1478),
    [anon_sym___thread] = ACTIONS(1478),
    [anon_sym_const] = ACTIONS(1478),
    [anon_sym_constexpr] = ACTIONS(1478),
    [anon_sym_volatile] = ACTIONS(1478),
    [anon_sym_restrict] = ACTIONS(1478),
    [anon_sym___restrict__] = ACTIONS(1478),
    [anon_sym__Atomic] = ACTIONS(1478),
    [anon_sym__Noreturn] = ACTIONS(1478),
    [anon_sym_noreturn] = ACTIONS(1478),
    [sym_primitive_type] = ACTIONS(1478),
    [anon_sym_enum] = ACTIONS(1478),
    [anon_sym_struct] = ACTIONS(1478),
    [anon_sym_union] = ACTIONS(1478),
    [anon_sym_if] = ACTIONS(1478),
    [anon_sym_switch] = ACTIONS(1478),
    [anon_sym_case] = ACTIONS(1478),
    [anon_sym_default] = ACTIONS(1478),
    [anon_sym_while] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_for] = ACTIONS(1478),
    [anon_sym_return] = ACTIONS(1478),
    [anon_sym_break] = ACTIONS(1478),
    [anon_sym_continue] = ACTIONS(1478),
    [anon_sym_goto] = ACTIONS(1478),
    [anon_sym_DASH_DASH] = ACTIONS(1480),
    [anon_sym_PLUS_PLUS] = ACTIONS(1480),
    [anon_sym_sizeof] = ACTIONS(1478),
    [anon_sym___alignof__] = ACTIONS(1478),
    [anon_sym___alignof] = ACTIONS(1478),
    [anon_sym__alignof] = ACTIONS(1478),
    [anon_sym_alignof] = ACTIONS(1478),
    [anon_sym__Alignof] = ACTIONS(1478),
    [anon_sym_offsetof] = ACTIONS(1478),
    [anon_sym__Generic] = ACTIONS(1478),
    [anon_sym_asm] = ACTIONS(1478),
    [anon_sym___asm__] = ACTIONS(1478),
    [sym_number_literal] = ACTIONS(1480),
    [anon_sym_L_SQUOTE] = ACTIONS(1480),
    [anon_sym_u_SQUOTE] = ACTIONS(1480),
    [anon_sym_U_SQUOTE] = ACTIONS(1480),
    [anon_sym_u8_SQUOTE] = ACTIONS(1480),
    [anon_sym_SQUOTE] = ACTIONS(1480),
    [anon_sym_L_DQUOTE] = ACTIONS(1480),
    [anon_sym_u_DQUOTE] = ACTIONS(1480),
    [anon_sym_U_DQUOTE] = ACTIONS(1480),
    [anon_sym_u8_DQUOTE] = ACTIONS(1480),
    [anon_sym_DQUOTE] = ACTIONS(1480),
    [sym_true] = ACTIONS(1478),
    [sym_false] = ACTIONS(1478),
    [anon_sym_NULL] = ACTIONS(1478),
    [anon_sym_nullptr] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
  },
  [522] = {
    [ts_builtin_sym_end] = ACTIONS(1488),
    [sym_identifier] = ACTIONS(1486),
    [aux_sym_preproc_include_token1] = ACTIONS(1486),
    [aux_sym_preproc_def_token1] = ACTIONS(1486),
    [aux_sym_preproc_if_token1] = ACTIONS(1486),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1486),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1486),
    [sym_preproc_directive] = ACTIONS(1486),
    [anon_sym_LPAREN2] = ACTIONS(1488),
    [anon_sym_BANG] = ACTIONS(1488),
    [anon_sym_TILDE] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_STAR] = ACTIONS(1488),
    [anon_sym_AMP] = ACTIONS(1488),
    [anon_sym___extension__] = ACTIONS(1486),
    [anon_sym_typedef] = ACTIONS(1486),
    [anon_sym_extern] = ACTIONS(1486),
    [anon_sym___attribute__] = ACTIONS(1486),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1488),
    [anon_sym___declspec] = ACTIONS(1486),
    [anon_sym___cdecl] = ACTIONS(1486),
    [anon_sym___clrcall] = ACTIONS(1486),
    [anon_sym___stdcall] = ACTIONS(1486),
    [anon_sym___fastcall] = ACTIONS(1486),
    [anon_sym___thiscall] = ACTIONS(1486),
    [anon_sym___vectorcall] = ACTIONS(1486),
    [anon_sym_LBRACE] = ACTIONS(1488),
    [anon_sym_signed] = ACTIONS(1486),
    [anon_sym_unsigned] = ACTIONS(1486),
    [anon_sym_long] = ACTIONS(1486),
    [anon_sym_short] = ACTIONS(1486),
    [anon_sym_static] = ACTIONS(1486),
    [anon_sym_auto] = ACTIONS(1486),
    [anon_sym_register] = ACTIONS(1486),
    [anon_sym_inline] = ACTIONS(1486),
    [anon_sym___inline] = ACTIONS(1486),
    [anon_sym___inline__] = ACTIONS(1486),
    [anon_sym___forceinline] = ACTIONS(1486),
    [anon_sym_thread_local] = ACTIONS(1486),
    [anon_sym___thread] = ACTIONS(1486),
    [anon_sym_const] = ACTIONS(1486),
    [anon_sym_constexpr] = ACTIONS(1486),
    [anon_sym_volatile] = ACTIONS(1486),
    [anon_sym_restrict] = ACTIONS(1486),
    [anon_sym___restrict__] = ACTIONS(1486),
    [anon_sym__Atomic] = ACTIONS(1486),
    [anon_sym__Noreturn] = ACTIONS(1486),
    [anon_sym_noreturn] = ACTIONS(1486),
    [sym_primitive_type] = ACTIONS(1486),
    [anon_sym_enum] = ACTIONS(1486),
    [anon_sym_struct] = ACTIONS(1486),
    [anon_sym_union] = ACTIONS(1486),
    [anon_sym_if] = ACTIONS(1486),
    [anon_sym_switch] = ACTIONS(1486),
    [anon_sym_case] = ACTIONS(1486),
    [anon_sym_default] = ACTIONS(1486),
    [anon_sym_while] = ACTIONS(1486),
    [anon_sym_do] = ACTIONS(1486),
    [anon_sym_for] = ACTIONS(1486),
    [anon_sym_return] = ACTIONS(1486),
    [anon_sym_break] = ACTIONS(1486),
    [anon_sym_continue] = ACTIONS(1486),
    [anon_sym_goto] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1488),
    [anon_sym_PLUS_PLUS] = ACTIONS(1488),
    [anon_sym_sizeof] = ACTIONS(1486),
    [anon_sym___alignof__] = ACTIONS(1486),
    [anon_sym___alignof] = ACTIONS(1486),
    [anon_sym__alignof] = ACTIONS(1486),
    [anon_sym_alignof] = ACTIONS(1486),
    [anon_sym__Alignof] = ACTIONS(1486),
    [anon_sym_offsetof] = ACTIONS(1486),
    [anon_sym__Generic] = ACTIONS(1486),
    [anon_sym_asm] = ACTIONS(1486),
    [anon_sym___asm__] = ACTIONS(1486),
    [sym_number_literal] = ACTIONS(1488),
    [anon_sym_L_SQUOTE] = ACTIONS(1488),
    [anon_sym_u_SQUOTE] = ACTIONS(1488),
    [anon_sym_U_SQUOTE] = ACTIONS(1488),
    [anon_sym_u8_SQUOTE] = ACTIONS(1488),
    [anon_sym_SQUOTE] = ACTIONS(1488),
    [anon_sym_L_DQUOTE] = ACTIONS(1488),
    [anon_sym_u_DQUOTE] = ACTIONS(1488),
    [anon_sym_U_DQUOTE] = ACTIONS(1488),
    [anon_sym_u8_DQUOTE] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(1488),
    [sym_true] = ACTIONS(1486),
    [sym_false] = ACTIONS(1486),
    [anon_sym_NULL] = ACTIONS(1486),
    [anon_sym_nullptr] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
  },
  [523] = {
    [ts_builtin_sym_end] = ACTIONS(1468),
    [sym_identifier] = ACTIONS(1466),
    [aux_sym_preproc_include_token1] = ACTIONS(1466),
    [aux_sym_preproc_def_token1] = ACTIONS(1466),
    [aux_sym_preproc_if_token1] = ACTIONS(1466),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1466),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1466),
    [sym_preproc_directive] = ACTIONS(1466),
    [anon_sym_LPAREN2] = ACTIONS(1468),
    [anon_sym_BANG] = ACTIONS(1468),
    [anon_sym_TILDE] = ACTIONS(1468),
    [anon_sym_DASH] = ACTIONS(1466),
    [anon_sym_PLUS] = ACTIONS(1466),
    [anon_sym_STAR] = ACTIONS(1468),
    [anon_sym_AMP] = ACTIONS(1468),
    [anon_sym___extension__] = ACTIONS(1466),
    [anon_sym_typedef] = ACTIONS(1466),
    [anon_sym_extern] = ACTIONS(1466),
    [anon_sym___attribute__] = ACTIONS(1466),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1468),
    [anon_sym___declspec] = ACTIONS(1466),
    [anon_sym___cdecl] = ACTIONS(1466),
    [anon_sym___clrcall] = ACTIONS(1466),
    [anon_sym___stdcall] = ACTIONS(1466),
    [anon_sym___fastcall] = ACTIONS(1466),
    [anon_sym___thiscall] = ACTIONS(1466),
    [anon_sym___vectorcall] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(1468),
    [anon_sym_signed] = ACTIONS(1466),
    [anon_sym_unsigned] = ACTIONS(1466),
    [anon_sym_long] = ACTIONS(1466),
    [anon_sym_short] = ACTIONS(1466),
    [anon_sym_static] = ACTIONS(1466),
    [anon_sym_auto] = ACTIONS(1466),
    [anon_sym_register] = ACTIONS(1466),
    [anon_sym_inline] = ACTIONS(1466),
    [anon_sym___inline] = ACTIONS(1466),
    [anon_sym___inline__] = ACTIONS(1466),
    [anon_sym___forceinline] = ACTIONS(1466),
    [anon_sym_thread_local] = ACTIONS(1466),
    [anon_sym___thread] = ACTIONS(1466),
    [anon_sym_const] = ACTIONS(1466),
    [anon_sym_constexpr] = ACTIONS(1466),
    [anon_sym_volatile] = ACTIONS(1466),
    [anon_sym_restrict] = ACTIONS(1466),
    [anon_sym___restrict__] = ACTIONS(1466),
    [anon_sym__Atomic] = ACTIONS(1466),
    [anon_sym__Noreturn] = ACTIONS(1466),
    [anon_sym_noreturn] = ACTIONS(1466),
    [sym_primitive_type] = ACTIONS(1466),
    [anon_sym_enum] = ACTIONS(1466),
    [anon_sym_struct] = ACTIONS(1466),
    [anon_sym_union] = ACTIONS(1466),
    [anon_sym_if] = ACTIONS(1466),
    [anon_sym_switch] = ACTIONS(1466),
    [anon_sym_case] = ACTIONS(1466),
    [anon_sym_default] = ACTIONS(1466),
    [anon_sym_while] = ACTIONS(1466),
    [anon_sym_do] = ACTIONS(1466),
    [anon_sym_for] = ACTIONS(1466),
    [anon_sym_return] = ACTIONS(1466),
    [anon_sym_break] = ACTIONS(1466),
    [anon_sym_continue] = ACTIONS(1466),
    [anon_sym_goto] = ACTIONS(1466),
    [anon_sym_DASH_DASH] = ACTIONS(1468),
    [anon_sym_PLUS_PLUS] = ACTIONS(1468),
    [anon_sym_sizeof] = ACTIONS(1466),
    [anon_sym___alignof__] = ACTIONS(1466),
    [anon_sym___alignof] = ACTIONS(1466),
    [anon_sym__alignof] = ACTIONS(1466),
    [anon_sym_alignof] = ACTIONS(1466),
    [anon_sym__Alignof] = ACTIONS(1466),
    [anon_sym_offsetof] = ACTIONS(1466),
    [anon_sym__Generic] = ACTIONS(1466),
    [anon_sym_asm] = ACTIONS(1466),
    [anon_sym___asm__] = ACTIONS(1466),
    [sym_number_literal] = ACTIONS(1468),
    [anon_sym_L_SQUOTE] = ACTIONS(1468),
    [anon_sym_u_SQUOTE] = ACTIONS(1468),
    [anon_sym_U_SQUOTE] = ACTIONS(1468),
    [anon_sym_u8_SQUOTE] = ACTIONS(1468),
    [anon_sym_SQUOTE] = ACTIONS(1468),
    [anon_sym_L_DQUOTE] = ACTIONS(1468),
    [anon_sym_u_DQUOTE] = ACTIONS(1468),
    [anon_sym_U_DQUOTE] = ACTIONS(1468),
    [anon_sym_u8_DQUOTE] = ACTIONS(1468),
    [anon_sym_DQUOTE] = ACTIONS(1468),
    [sym_true] = ACTIONS(1466),
    [sym_false] = ACTIONS(1466),
    [anon_sym_NULL] = ACTIONS(1466),
    [anon_sym_nullptr] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
  },
  [524] = {
    [ts_builtin_sym_end] = ACTIONS(1424),
    [sym_identifier] = ACTIONS(1422),
    [aux_sym_preproc_include_token1] = ACTIONS(1422),
    [aux_sym_preproc_def_token1] = ACTIONS(1422),
    [aux_sym_preproc_if_token1] = ACTIONS(1422),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1422),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1422),
    [sym_preproc_directive] = ACTIONS(1422),
    [anon_sym_LPAREN2] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(1424),
    [anon_sym_TILDE] = ACTIONS(1424),
    [anon_sym_DASH] = ACTIONS(1422),
    [anon_sym_PLUS] = ACTIONS(1422),
    [anon_sym_STAR] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1424),
    [anon_sym___extension__] = ACTIONS(1422),
    [anon_sym_typedef] = ACTIONS(1422),
    [anon_sym_extern] = ACTIONS(1422),
    [anon_sym___attribute__] = ACTIONS(1422),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1424),
    [anon_sym___declspec] = ACTIONS(1422),
    [anon_sym___cdecl] = ACTIONS(1422),
    [anon_sym___clrcall] = ACTIONS(1422),
    [anon_sym___stdcall] = ACTIONS(1422),
    [anon_sym___fastcall] = ACTIONS(1422),
    [anon_sym___thiscall] = ACTIONS(1422),
    [anon_sym___vectorcall] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(1424),
    [anon_sym_signed] = ACTIONS(1422),
    [anon_sym_unsigned] = ACTIONS(1422),
    [anon_sym_long] = ACTIONS(1422),
    [anon_sym_short] = ACTIONS(1422),
    [anon_sym_static] = ACTIONS(1422),
    [anon_sym_auto] = ACTIONS(1422),
    [anon_sym_register] = ACTIONS(1422),
    [anon_sym_inline] = ACTIONS(1422),
    [anon_sym___inline] = ACTIONS(1422),
    [anon_sym___inline__] = ACTIONS(1422),
    [anon_sym___forceinline] = ACTIONS(1422),
    [anon_sym_thread_local] = ACTIONS(1422),
    [anon_sym___thread] = ACTIONS(1422),
    [anon_sym_const] = ACTIONS(1422),
    [anon_sym_constexpr] = ACTIONS(1422),
    [anon_sym_volatile] = ACTIONS(1422),
    [anon_sym_restrict] = ACTIONS(1422),
    [anon_sym___restrict__] = ACTIONS(1422),
    [anon_sym__Atomic] = ACTIONS(1422),
    [anon_sym__Noreturn] = ACTIONS(1422),
    [anon_sym_noreturn] = ACTIONS(1422),
    [sym_primitive_type] = ACTIONS(1422),
    [anon_sym_enum] = ACTIONS(1422),
    [anon_sym_struct] = ACTIONS(1422),
    [anon_sym_union] = ACTIONS(1422),
    [anon_sym_if] = ACTIONS(1422),
    [anon_sym_switch] = ACTIONS(1422),
    [anon_sym_case] = ACTIONS(1422),
    [anon_sym_default] = ACTIONS(1422),
    [anon_sym_while] = ACTIONS(1422),
    [anon_sym_do] = ACTIONS(1422),
    [anon_sym_for] = ACTIONS(1422),
    [anon_sym_return] = ACTIONS(1422),
    [anon_sym_break] = ACTIONS(1422),
    [anon_sym_continue] = ACTIONS(1422),
    [anon_sym_goto] = ACTIONS(1422),
    [anon_sym_DASH_DASH] = ACTIONS(1424),
    [anon_sym_PLUS_PLUS] = ACTIONS(1424),
    [anon_sym_sizeof] = ACTIONS(1422),
    [anon_sym___alignof__] = ACTIONS(1422),
    [anon_sym___alignof] = ACTIONS(1422),
    [anon_sym__alignof] = ACTIONS(1422),
    [anon_sym_alignof] = ACTIONS(1422),
    [anon_sym__Alignof] = ACTIONS(1422),
    [anon_sym_offsetof] = ACTIONS(1422),
    [anon_sym__Generic] = ACTIONS(1422),
    [anon_sym_asm] = ACTIONS(1422),
    [anon_sym___asm__] = ACTIONS(1422),
    [sym_number_literal] = ACTIONS(1424),
    [anon_sym_L_SQUOTE] = ACTIONS(1424),
    [anon_sym_u_SQUOTE] = ACTIONS(1424),
    [anon_sym_U_SQUOTE] = ACTIONS(1424),
    [anon_sym_u8_SQUOTE] = ACTIONS(1424),
    [anon_sym_SQUOTE] = ACTIONS(1424),
    [anon_sym_L_DQUOTE] = ACTIONS(1424),
    [anon_sym_u_DQUOTE] = ACTIONS(1424),
    [anon_sym_U_DQUOTE] = ACTIONS(1424),
    [anon_sym_u8_DQUOTE] = ACTIONS(1424),
    [anon_sym_DQUOTE] = ACTIONS(1424),
    [sym_true] = ACTIONS(1422),
    [sym_false] = ACTIONS(1422),
    [anon_sym_NULL] = ACTIONS(1422),
    [anon_sym_nullptr] = ACTIONS(1422),
    [sym_comment] = ACTIONS(3),
  },
  [525] = {
    [ts_builtin_sym_end] = ACTIONS(1452),
    [sym_identifier] = ACTIONS(1450),
    [aux_sym_preproc_include_token1] = ACTIONS(1450),
    [aux_sym_preproc_def_token1] = ACTIONS(1450),
    [aux_sym_preproc_if_token1] = ACTIONS(1450),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1450),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1450),
    [sym_preproc_directive] = ACTIONS(1450),
    [anon_sym_LPAREN2] = ACTIONS(1452),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_TILDE] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1450),
    [anon_sym_PLUS] = ACTIONS(1450),
    [anon_sym_STAR] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1452),
    [anon_sym___extension__] = ACTIONS(1450),
    [anon_sym_typedef] = ACTIONS(1450),
    [anon_sym_extern] = ACTIONS(1450),
    [anon_sym___attribute__] = ACTIONS(1450),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1452),
    [anon_sym___declspec] = ACTIONS(1450),
    [anon_sym___cdecl] = ACTIONS(1450),
    [anon_sym___clrcall] = ACTIONS(1450),
    [anon_sym___stdcall] = ACTIONS(1450),
    [anon_sym___fastcall] = ACTIONS(1450),
    [anon_sym___thiscall] = ACTIONS(1450),
    [anon_sym___vectorcall] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(1452),
    [anon_sym_signed] = ACTIONS(1450),
    [anon_sym_unsigned] = ACTIONS(1450),
    [anon_sym_long] = ACTIONS(1450),
    [anon_sym_short] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(1450),
    [anon_sym_auto] = ACTIONS(1450),
    [anon_sym_register] = ACTIONS(1450),
    [anon_sym_inline] = ACTIONS(1450),
    [anon_sym___inline] = ACTIONS(1450),
    [anon_sym___inline__] = ACTIONS(1450),
    [anon_sym___forceinline] = ACTIONS(1450),
    [anon_sym_thread_local] = ACTIONS(1450),
    [anon_sym___thread] = ACTIONS(1450),
    [anon_sym_const] = ACTIONS(1450),
    [anon_sym_constexpr] = ACTIONS(1450),
    [anon_sym_volatile] = ACTIONS(1450),
    [anon_sym_restrict] = ACTIONS(1450),
    [anon_sym___restrict__] = ACTIONS(1450),
    [anon_sym__Atomic] = ACTIONS(1450),
    [anon_sym__Noreturn] = ACTIONS(1450),
    [anon_sym_noreturn] = ACTIONS(1450),
    [sym_primitive_type] = ACTIONS(1450),
    [anon_sym_enum] = ACTIONS(1450),
    [anon_sym_struct] = ACTIONS(1450),
    [anon_sym_union] = ACTIONS(1450),
    [anon_sym_if] = ACTIONS(1450),
    [anon_sym_switch] = ACTIONS(1450),
    [anon_sym_case] = ACTIONS(1450),
    [anon_sym_default] = ACTIONS(1450),
    [anon_sym_while] = ACTIONS(1450),
    [anon_sym_do] = ACTIONS(1450),
    [anon_sym_for] = ACTIONS(1450),
    [anon_sym_return] = ACTIONS(1450),
    [anon_sym_break] = ACTIONS(1450),
    [anon_sym_continue] = ACTIONS(1450),
    [anon_sym_goto] = ACTIONS(1450),
    [anon_sym_DASH_DASH] = ACTIONS(1452),
    [anon_sym_PLUS_PLUS] = ACTIONS(1452),
    [anon_sym_sizeof] = ACTIONS(1450),
    [anon_sym___alignof__] = ACTIONS(1450),
    [anon_sym___alignof] = ACTIONS(1450),
    [anon_sym__alignof] = ACTIONS(1450),
    [anon_sym_alignof] = ACTIONS(1450),
    [anon_sym__Alignof] = ACTIONS(1450),
    [anon_sym_offsetof] = ACTIONS(1450),
    [anon_sym__Generic] = ACTIONS(1450),
    [anon_sym_asm] = ACTIONS(1450),
    [anon_sym___asm__] = ACTIONS(1450),
    [sym_number_literal] = ACTIONS(1452),
    [anon_sym_L_SQUOTE] = ACTIONS(1452),
    [anon_sym_u_SQUOTE] = ACTIONS(1452),
    [anon_sym_U_SQUOTE] = ACTIONS(1452),
    [anon_sym_u8_SQUOTE] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [anon_sym_L_DQUOTE] = ACTIONS(1452),
    [anon_sym_u_DQUOTE] = ACTIONS(1452),
    [anon_sym_U_DQUOTE] = ACTIONS(1452),
    [anon_sym_u8_DQUOTE] = ACTIONS(1452),
    [anon_sym_DQUOTE] = ACTIONS(1452),
    [sym_true] = ACTIONS(1450),
    [sym_false] = ACTIONS(1450),
    [anon_sym_NULL] = ACTIONS(1450),
    [anon_sym_nullptr] = ACTIONS(1450),
    [sym_comment] = ACTIONS(3),
  },
  [526] = {
    [ts_builtin_sym_end] = ACTIONS(1492),
    [sym_identifier] = ACTIONS(1490),
    [aux_sym_preproc_include_token1] = ACTIONS(1490),
    [aux_sym_preproc_def_token1] = ACTIONS(1490),
    [aux_sym_preproc_if_token1] = ACTIONS(1490),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1490),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1490),
    [sym_preproc_directive] = ACTIONS(1490),
    [anon_sym_LPAREN2] = ACTIONS(1492),
    [anon_sym_BANG] = ACTIONS(1492),
    [anon_sym_TILDE] = ACTIONS(1492),
    [anon_sym_DASH] = ACTIONS(1490),
    [anon_sym_PLUS] = ACTIONS(1490),
    [anon_sym_STAR] = ACTIONS(1492),
    [anon_sym_AMP] = ACTIONS(1492),
    [anon_sym___extension__] = ACTIONS(1490),
    [anon_sym_typedef] = ACTIONS(1490),
    [anon_sym_extern] = ACTIONS(1490),
    [anon_sym___attribute__] = ACTIONS(1490),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1492),
    [anon_sym___declspec] = ACTIONS(1490),
    [anon_sym___cdecl] = ACTIONS(1490),
    [anon_sym___clrcall] = ACTIONS(1490),
    [anon_sym___stdcall] = ACTIONS(1490),
    [anon_sym___fastcall] = ACTIONS(1490),
    [anon_sym___thiscall] = ACTIONS(1490),
    [anon_sym___vectorcall] = ACTIONS(1490),
    [anon_sym_LBRACE] = ACTIONS(1492),
    [anon_sym_signed] = ACTIONS(1490),
    [anon_sym_unsigned] = ACTIONS(1490),
    [anon_sym_long] = ACTIONS(1490),
    [anon_sym_short] = ACTIONS(1490),
    [anon_sym_static] = ACTIONS(1490),
    [anon_sym_auto] = ACTIONS(1490),
    [anon_sym_register] = ACTIONS(1490),
    [anon_sym_inline] = ACTIONS(1490),
    [anon_sym___inline] = ACTIONS(1490),
    [anon_sym___inline__] = ACTIONS(1490),
    [anon_sym___forceinline] = ACTIONS(1490),
    [anon_sym_thread_local] = ACTIONS(1490),
    [anon_sym___thread] = ACTIONS(1490),
    [anon_sym_const] = ACTIONS(1490),
    [anon_sym_constexpr] = ACTIONS(1490),
    [anon_sym_volatile] = ACTIONS(1490),
    [anon_sym_restrict] = ACTIONS(1490),
    [anon_sym___restrict__] = ACTIONS(1490),
    [anon_sym__Atomic] = ACTIONS(1490),
    [anon_sym__Noreturn] = ACTIONS(1490),
    [anon_sym_noreturn] = ACTIONS(1490),
    [sym_primitive_type] = ACTIONS(1490),
    [anon_sym_enum] = ACTIONS(1490),
    [anon_sym_struct] = ACTIONS(1490),
    [anon_sym_union] = ACTIONS(1490),
    [anon_sym_if] = ACTIONS(1490),
    [anon_sym_switch] = ACTIONS(1490),
    [anon_sym_case] = ACTIONS(1490),
    [anon_sym_default] = ACTIONS(1490),
    [anon_sym_while] = ACTIONS(1490),
    [anon_sym_do] = ACTIONS(1490),
    [anon_sym_for] = ACTIONS(1490),
    [anon_sym_return] = ACTIONS(1490),
    [anon_sym_break] = ACTIONS(1490),
    [anon_sym_continue] = ACTIONS(1490),
    [anon_sym_goto] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1492),
    [anon_sym_PLUS_PLUS] = ACTIONS(1492),
    [anon_sym_sizeof] = ACTIONS(1490),
    [anon_sym___alignof__] = ACTIONS(1490),
    [anon_sym___alignof] = ACTIONS(1490),
    [anon_sym__alignof] = ACTIONS(1490),
    [anon_sym_alignof] = ACTIONS(1490),
    [anon_sym__Alignof] = ACTIONS(1490),
    [anon_sym_offsetof] = ACTIONS(1490),
    [anon_sym__Generic] = ACTIONS(1490),
    [anon_sym_asm] = ACTIONS(1490),
    [anon_sym___asm__] = ACTIONS(1490),
    [sym_number_literal] = ACTIONS(1492),
    [anon_sym_L_SQUOTE] = ACTIONS(1492),
    [anon_sym_u_SQUOTE] = ACTIONS(1492),
    [anon_sym_U_SQUOTE] = ACTIONS(1492),
    [anon_sym_u8_SQUOTE] = ACTIONS(1492),
    [anon_sym_SQUOTE] = ACTIONS(1492),
    [anon_sym_L_DQUOTE] = ACTIONS(1492),
    [anon_sym_u_DQUOTE] = ACTIONS(1492),
    [anon_sym_U_DQUOTE] = ACTIONS(1492),
    [anon_sym_u8_DQUOTE] = ACTIONS(1492),
    [anon_sym_DQUOTE] = ACTIONS(1492),
    [sym_true] = ACTIONS(1490),
    [sym_false] = ACTIONS(1490),
    [anon_sym_NULL] = ACTIONS(1490),
    [anon_sym_nullptr] = ACTIONS(1490),
    [sym_comment] = ACTIONS(3),
  },
  [527] = {
    [ts_builtin_sym_end] = ACTIONS(1444),
    [sym_identifier] = ACTIONS(1442),
    [aux_sym_preproc_include_token1] = ACTIONS(1442),
    [aux_sym_preproc_def_token1] = ACTIONS(1442),
    [aux_sym_preproc_if_token1] = ACTIONS(1442),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1442),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1442),
    [sym_preproc_directive] = ACTIONS(1442),
    [anon_sym_LPAREN2] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1444),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym___extension__] = ACTIONS(1442),
    [anon_sym_typedef] = ACTIONS(1442),
    [anon_sym_extern] = ACTIONS(1442),
    [anon_sym___attribute__] = ACTIONS(1442),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1444),
    [anon_sym___declspec] = ACTIONS(1442),
    [anon_sym___cdecl] = ACTIONS(1442),
    [anon_sym___clrcall] = ACTIONS(1442),
    [anon_sym___stdcall] = ACTIONS(1442),
    [anon_sym___fastcall] = ACTIONS(1442),
    [anon_sym___thiscall] = ACTIONS(1442),
    [anon_sym___vectorcall] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1444),
    [anon_sym_signed] = ACTIONS(1442),
    [anon_sym_unsigned] = ACTIONS(1442),
    [anon_sym_long] = ACTIONS(1442),
    [anon_sym_short] = ACTIONS(1442),
    [anon_sym_static] = ACTIONS(1442),
    [anon_sym_auto] = ACTIONS(1442),
    [anon_sym_register] = ACTIONS(1442),
    [anon_sym_inline] = ACTIONS(1442),
    [anon_sym___inline] = ACTIONS(1442),
    [anon_sym___inline__] = ACTIONS(1442),
    [anon_sym___forceinline] = ACTIONS(1442),
    [anon_sym_thread_local] = ACTIONS(1442),
    [anon_sym___thread] = ACTIONS(1442),
    [anon_sym_const] = ACTIONS(1442),
    [anon_sym_constexpr] = ACTIONS(1442),
    [anon_sym_volatile] = ACTIONS(1442),
    [anon_sym_restrict] = ACTIONS(1442),
    [anon_sym___restrict__] = ACTIONS(1442),
    [anon_sym__Atomic] = ACTIONS(1442),
    [anon_sym__Noreturn] = ACTIONS(1442),
    [anon_sym_noreturn] = ACTIONS(1442),
    [sym_primitive_type] = ACTIONS(1442),
    [anon_sym_enum] = ACTIONS(1442),
    [anon_sym_struct] = ACTIONS(1442),
    [anon_sym_union] = ACTIONS(1442),
    [anon_sym_if] = ACTIONS(1442),
    [anon_sym_switch] = ACTIONS(1442),
    [anon_sym_case] = ACTIONS(1442),
    [anon_sym_default] = ACTIONS(1442),
    [anon_sym_while] = ACTIONS(1442),
    [anon_sym_do] = ACTIONS(1442),
    [anon_sym_for] = ACTIONS(1442),
    [anon_sym_return] = ACTIONS(1442),
    [anon_sym_break] = ACTIONS(1442),
    [anon_sym_continue] = ACTIONS(1442),
    [anon_sym_goto] = ACTIONS(1442),
    [anon_sym_DASH_DASH] = ACTIONS(1444),
    [anon_sym_PLUS_PLUS] = ACTIONS(1444),
    [anon_sym_sizeof] = ACTIONS(1442),
    [anon_sym___alignof__] = ACTIONS(1442),
    [anon_sym___alignof] = ACTIONS(1442),
    [anon_sym__alignof] = ACTIONS(1442),
    [anon_sym_alignof] = ACTIONS(1442),
    [anon_sym__Alignof] = ACTIONS(1442),
    [anon_sym_offsetof] = ACTIONS(1442),
    [anon_sym__Generic] = ACTIONS(1442),
    [anon_sym_asm] = ACTIONS(1442),
    [anon_sym___asm__] = ACTIONS(1442),
    [sym_number_literal] = ACTIONS(1444),
    [anon_sym_L_SQUOTE] = ACTIONS(1444),
    [anon_sym_u_SQUOTE] = ACTIONS(1444),
    [anon_sym_U_SQUOTE] = ACTIONS(1444),
    [anon_sym_u8_SQUOTE] = ACTIONS(1444),
    [anon_sym_SQUOTE] = ACTIONS(1444),
    [anon_sym_L_DQUOTE] = ACTIONS(1444),
    [anon_sym_u_DQUOTE] = ACTIONS(1444),
    [anon_sym_U_DQUOTE] = ACTIONS(1444),
    [anon_sym_u8_DQUOTE] = ACTIONS(1444),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [sym_true] = ACTIONS(1442),
    [sym_false] = ACTIONS(1442),
    [anon_sym_NULL] = ACTIONS(1442),
    [anon_sym_nullptr] = ACTIONS(1442),
    [sym_comment] = ACTIONS(3),
  },
  [528] = {
    [ts_builtin_sym_end] = ACTIONS(1472),
    [sym_identifier] = ACTIONS(1470),
    [aux_sym_preproc_include_token1] = ACTIONS(1470),
    [aux_sym_preproc_def_token1] = ACTIONS(1470),
    [aux_sym_preproc_if_token1] = ACTIONS(1470),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1470),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1470),
    [sym_preproc_directive] = ACTIONS(1470),
    [anon_sym_LPAREN2] = ACTIONS(1472),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_TILDE] = ACTIONS(1472),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_STAR] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1472),
    [anon_sym___extension__] = ACTIONS(1470),
    [anon_sym_typedef] = ACTIONS(1470),
    [anon_sym_extern] = ACTIONS(1470),
    [anon_sym___attribute__] = ACTIONS(1470),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1472),
    [anon_sym___declspec] = ACTIONS(1470),
    [anon_sym___cdecl] = ACTIONS(1470),
    [anon_sym___clrcall] = ACTIONS(1470),
    [anon_sym___stdcall] = ACTIONS(1470),
    [anon_sym___fastcall] = ACTIONS(1470),
    [anon_sym___thiscall] = ACTIONS(1470),
    [anon_sym___vectorcall] = ACTIONS(1470),
    [anon_sym_LBRACE] = ACTIONS(1472),
    [anon_sym_signed] = ACTIONS(1470),
    [anon_sym_unsigned] = ACTIONS(1470),
    [anon_sym_long] = ACTIONS(1470),
    [anon_sym_short] = ACTIONS(1470),
    [anon_sym_static] = ACTIONS(1470),
    [anon_sym_auto] = ACTIONS(1470),
    [anon_sym_register] = ACTIONS(1470),
    [anon_sym_inline] = ACTIONS(1470),
    [anon_sym___inline] = ACTIONS(1470),
    [anon_sym___inline__] = ACTIONS(1470),
    [anon_sym___forceinline] = ACTIONS(1470),
    [anon_sym_thread_local] = ACTIONS(1470),
    [anon_sym___thread] = ACTIONS(1470),
    [anon_sym_const] = ACTIONS(1470),
    [anon_sym_constexpr] = ACTIONS(1470),
    [anon_sym_volatile] = ACTIONS(1470),
    [anon_sym_restrict] = ACTIONS(1470),
    [anon_sym___restrict__] = ACTIONS(1470),
    [anon_sym__Atomic] = ACTIONS(1470),
    [anon_sym__Noreturn] = ACTIONS(1470),
    [anon_sym_noreturn] = ACTIONS(1470),
    [sym_primitive_type] = ACTIONS(1470),
    [anon_sym_enum] = ACTIONS(1470),
    [anon_sym_struct] = ACTIONS(1470),
    [anon_sym_union] = ACTIONS(1470),
    [anon_sym_if] = ACTIONS(1470),
    [anon_sym_switch] = ACTIONS(1470),
    [anon_sym_case] = ACTIONS(1470),
    [anon_sym_default] = ACTIONS(1470),
    [anon_sym_while] = ACTIONS(1470),
    [anon_sym_do] = ACTIONS(1470),
    [anon_sym_for] = ACTIONS(1470),
    [anon_sym_return] = ACTIONS(1470),
    [anon_sym_break] = ACTIONS(1470),
    [anon_sym_continue] = ACTIONS(1470),
    [anon_sym_goto] = ACTIONS(1470),
    [anon_sym_DASH_DASH] = ACTIONS(1472),
    [anon_sym_PLUS_PLUS] = ACTIONS(1472),
    [anon_sym_sizeof] = ACTIONS(1470),
    [anon_sym___alignof__] = ACTIONS(1470),
    [anon_sym___alignof] = ACTIONS(1470),
    [anon_sym__alignof] = ACTIONS(1470),
    [anon_sym_alignof] = ACTIONS(1470),
    [anon_sym__Alignof] = ACTIONS(1470),
    [anon_sym_offsetof] = ACTIONS(1470),
    [anon_sym__Generic] = ACTIONS(1470),
    [anon_sym_asm] = ACTIONS(1470),
    [anon_sym___asm__] = ACTIONS(1470),
    [sym_number_literal] = ACTIONS(1472),
    [anon_sym_L_SQUOTE] = ACTIONS(1472),
    [anon_sym_u_SQUOTE] = ACTIONS(1472),
    [anon_sym_U_SQUOTE] = ACTIONS(1472),
    [anon_sym_u8_SQUOTE] = ACTIONS(1472),
    [anon_sym_SQUOTE] = ACTIONS(1472),
    [anon_sym_L_DQUOTE] = ACTIONS(1472),
    [anon_sym_u_DQUOTE] = ACTIONS(1472),
    [anon_sym_U_DQUOTE] = ACTIONS(1472),
    [anon_sym_u8_DQUOTE] = ACTIONS(1472),
    [anon_sym_DQUOTE] = ACTIONS(1472),
    [sym_true] = ACTIONS(1470),
    [sym_false] = ACTIONS(1470),
    [anon_sym_NULL] = ACTIONS(1470),
    [anon_sym_nullptr] = ACTIONS(1470),
    [sym_comment] = ACTIONS(3),
  },
  [529] = {
    [ts_builtin_sym_end] = ACTIONS(1436),
    [sym_identifier] = ACTIONS(1434),
    [aux_sym_preproc_include_token1] = ACTIONS(1434),
    [aux_sym_preproc_def_token1] = ACTIONS(1434),
    [aux_sym_preproc_if_token1] = ACTIONS(1434),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1434),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1434),
    [sym_preproc_directive] = ACTIONS(1434),
    [anon_sym_LPAREN2] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(1436),
    [anon_sym_TILDE] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_STAR] = ACTIONS(1436),
    [anon_sym_AMP] = ACTIONS(1436),
    [anon_sym___extension__] = ACTIONS(1434),
    [anon_sym_typedef] = ACTIONS(1434),
    [anon_sym_extern] = ACTIONS(1434),
    [anon_sym___attribute__] = ACTIONS(1434),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1436),
    [anon_sym___declspec] = ACTIONS(1434),
    [anon_sym___cdecl] = ACTIONS(1434),
    [anon_sym___clrcall] = ACTIONS(1434),
    [anon_sym___stdcall] = ACTIONS(1434),
    [anon_sym___fastcall] = ACTIONS(1434),
    [anon_sym___thiscall] = ACTIONS(1434),
    [anon_sym___vectorcall] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1436),
    [anon_sym_signed] = ACTIONS(1434),
    [anon_sym_unsigned] = ACTIONS(1434),
    [anon_sym_long] = ACTIONS(1434),
    [anon_sym_short] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(1434),
    [anon_sym_auto] = ACTIONS(1434),
    [anon_sym_register] = ACTIONS(1434),
    [anon_sym_inline] = ACTIONS(1434),
    [anon_sym___inline] = ACTIONS(1434),
    [anon_sym___inline__] = ACTIONS(1434),
    [anon_sym___forceinline] = ACTIONS(1434),
    [anon_sym_thread_local] = ACTIONS(1434),
    [anon_sym___thread] = ACTIONS(1434),
    [anon_sym_const] = ACTIONS(1434),
    [anon_sym_constexpr] = ACTIONS(1434),
    [anon_sym_volatile] = ACTIONS(1434),
    [anon_sym_restrict] = ACTIONS(1434),
    [anon_sym___restrict__] = ACTIONS(1434),
    [anon_sym__Atomic] = ACTIONS(1434),
    [anon_sym__Noreturn] = ACTIONS(1434),
    [anon_sym_noreturn] = ACTIONS(1434),
    [sym_primitive_type] = ACTIONS(1434),
    [anon_sym_enum] = ACTIONS(1434),
    [anon_sym_struct] = ACTIONS(1434),
    [anon_sym_union] = ACTIONS(1434),
    [anon_sym_if] = ACTIONS(1434),
    [anon_sym_switch] = ACTIONS(1434),
    [anon_sym_case] = ACTIONS(1434),
    [anon_sym_default] = ACTIONS(1434),
    [anon_sym_while] = ACTIONS(1434),
    [anon_sym_do] = ACTIONS(1434),
    [anon_sym_for] = ACTIONS(1434),
    [anon_sym_return] = ACTIONS(1434),
    [anon_sym_break] = ACTIONS(1434),
    [anon_sym_continue] = ACTIONS(1434),
    [anon_sym_goto] = ACTIONS(1434),
    [anon_sym_DASH_DASH] = ACTIONS(1436),
    [anon_sym_PLUS_PLUS] = ACTIONS(1436),
    [anon_sym_sizeof] = ACTIONS(1434),
    [anon_sym___alignof__] = ACTIONS(1434),
    [anon_sym___alignof] = ACTIONS(1434),
    [anon_sym__alignof] = ACTIONS(1434),
    [anon_sym_alignof] = ACTIONS(1434),
    [anon_sym__Alignof] = ACTIONS(1434),
    [anon_sym_offsetof] = ACTIONS(1434),
    [anon_sym__Generic] = ACTIONS(1434),
    [anon_sym_asm] = ACTIONS(1434),
    [anon_sym___asm__] = ACTIONS(1434),
    [sym_number_literal] = ACTIONS(1436),
    [anon_sym_L_SQUOTE] = ACTIONS(1436),
    [anon_sym_u_SQUOTE] = ACTIONS(1436),
    [anon_sym_U_SQUOTE] = ACTIONS(1436),
    [anon_sym_u8_SQUOTE] = ACTIONS(1436),
    [anon_sym_SQUOTE] = ACTIONS(1436),
    [anon_sym_L_DQUOTE] = ACTIONS(1436),
    [anon_sym_u_DQUOTE] = ACTIONS(1436),
    [anon_sym_U_DQUOTE] = ACTIONS(1436),
    [anon_sym_u8_DQUOTE] = ACTIONS(1436),
    [anon_sym_DQUOTE] = ACTIONS(1436),
    [sym_true] = ACTIONS(1434),
    [sym_false] = ACTIONS(1434),
    [anon_sym_NULL] = ACTIONS(1434),
    [anon_sym_nullptr] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
  },
  [530] = {
    [ts_builtin_sym_end] = ACTIONS(1428),
    [sym_identifier] = ACTIONS(1426),
    [aux_sym_preproc_include_token1] = ACTIONS(1426),
    [aux_sym_preproc_def_token1] = ACTIONS(1426),
    [aux_sym_preproc_if_token1] = ACTIONS(1426),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1426),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1426),
    [sym_preproc_directive] = ACTIONS(1426),
    [anon_sym_LPAREN2] = ACTIONS(1428),
    [anon_sym_BANG] = ACTIONS(1428),
    [anon_sym_TILDE] = ACTIONS(1428),
    [anon_sym_DASH] = ACTIONS(1426),
    [anon_sym_PLUS] = ACTIONS(1426),
    [anon_sym_STAR] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1428),
    [anon_sym___extension__] = ACTIONS(1426),
    [anon_sym_typedef] = ACTIONS(1426),
    [anon_sym_extern] = ACTIONS(1426),
    [anon_sym___attribute__] = ACTIONS(1426),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1428),
    [anon_sym___declspec] = ACTIONS(1426),
    [anon_sym___cdecl] = ACTIONS(1426),
    [anon_sym___clrcall] = ACTIONS(1426),
    [anon_sym___stdcall] = ACTIONS(1426),
    [anon_sym___fastcall] = ACTIONS(1426),
    [anon_sym___thiscall] = ACTIONS(1426),
    [anon_sym___vectorcall] = ACTIONS(1426),
    [anon_sym_LBRACE] = ACTIONS(1428),
    [anon_sym_signed] = ACTIONS(1426),
    [anon_sym_unsigned] = ACTIONS(1426),
    [anon_sym_long] = ACTIONS(1426),
    [anon_sym_short] = ACTIONS(1426),
    [anon_sym_static] = ACTIONS(1426),
    [anon_sym_auto] = ACTIONS(1426),
    [anon_sym_register] = ACTIONS(1426),
    [anon_sym_inline] = ACTIONS(1426),
    [anon_sym___inline] = ACTIONS(1426),
    [anon_sym___inline__] = ACTIONS(1426),
    [anon_sym___forceinline] = ACTIONS(1426),
    [anon_sym_thread_local] = ACTIONS(1426),
    [anon_sym___thread] = ACTIONS(1426),
    [anon_sym_const] = ACTIONS(1426),
    [anon_sym_constexpr] = ACTIONS(1426),
    [anon_sym_volatile] = ACTIONS(1426),
    [anon_sym_restrict] = ACTIONS(1426),
    [anon_sym___restrict__] = ACTIONS(1426),
    [anon_sym__Atomic] = ACTIONS(1426),
    [anon_sym__Noreturn] = ACTIONS(1426),
    [anon_sym_noreturn] = ACTIONS(1426),
    [sym_primitive_type] = ACTIONS(1426),
    [anon_sym_enum] = ACTIONS(1426),
    [anon_sym_struct] = ACTIONS(1426),
    [anon_sym_union] = ACTIONS(1426),
    [anon_sym_if] = ACTIONS(1426),
    [anon_sym_switch] = ACTIONS(1426),
    [anon_sym_case] = ACTIONS(1426),
    [anon_sym_default] = ACTIONS(1426),
    [anon_sym_while] = ACTIONS(1426),
    [anon_sym_do] = ACTIONS(1426),
    [anon_sym_for] = ACTIONS(1426),
    [anon_sym_return] = ACTIONS(1426),
    [anon_sym_break] = ACTIONS(1426),
    [anon_sym_continue] = ACTIONS(1426),
    [anon_sym_goto] = ACTIONS(1426),
    [anon_sym_DASH_DASH] = ACTIONS(1428),
    [anon_sym_PLUS_PLUS] = ACTIONS(1428),
    [anon_sym_sizeof] = ACTIONS(1426),
    [anon_sym___alignof__] = ACTIONS(1426),
    [anon_sym___alignof] = ACTIONS(1426),
    [anon_sym__alignof] = ACTIONS(1426),
    [anon_sym_alignof] = ACTIONS(1426),
    [anon_sym__Alignof] = ACTIONS(1426),
    [anon_sym_offsetof] = ACTIONS(1426),
    [anon_sym__Generic] = ACTIONS(1426),
    [anon_sym_asm] = ACTIONS(1426),
    [anon_sym___asm__] = ACTIONS(1426),
    [sym_number_literal] = ACTIONS(1428),
    [anon_sym_L_SQUOTE] = ACTIONS(1428),
    [anon_sym_u_SQUOTE] = ACTIONS(1428),
    [anon_sym_U_SQUOTE] = ACTIONS(1428),
    [anon_sym_u8_SQUOTE] = ACTIONS(1428),
    [anon_sym_SQUOTE] = ACTIONS(1428),
    [anon_sym_L_DQUOTE] = ACTIONS(1428),
    [anon_sym_u_DQUOTE] = ACTIONS(1428),
    [anon_sym_U_DQUOTE] = ACTIONS(1428),
    [anon_sym_u8_DQUOTE] = ACTIONS(1428),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [sym_true] = ACTIONS(1426),
    [sym_false] = ACTIONS(1426),
    [anon_sym_NULL] = ACTIONS(1426),
    [anon_sym_nullptr] = ACTIONS(1426),
    [sym_comment] = ACTIONS(3),
  },
  [531] = {
    [ts_builtin_sym_end] = ACTIONS(1432),
    [sym_identifier] = ACTIONS(1430),
    [aux_sym_preproc_include_token1] = ACTIONS(1430),
    [aux_sym_preproc_def_token1] = ACTIONS(1430),
    [aux_sym_preproc_if_token1] = ACTIONS(1430),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1430),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1430),
    [sym_preproc_directive] = ACTIONS(1430),
    [anon_sym_LPAREN2] = ACTIONS(1432),
    [anon_sym_BANG] = ACTIONS(1432),
    [anon_sym_TILDE] = ACTIONS(1432),
    [anon_sym_DASH] = ACTIONS(1430),
    [anon_sym_PLUS] = ACTIONS(1430),
    [anon_sym_STAR] = ACTIONS(1432),
    [anon_sym_AMP] = ACTIONS(1432),
    [anon_sym___extension__] = ACTIONS(1430),
    [anon_sym_typedef] = ACTIONS(1430),
    [anon_sym_extern] = ACTIONS(1430),
    [anon_sym___attribute__] = ACTIONS(1430),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1432),
    [anon_sym___declspec] = ACTIONS(1430),
    [anon_sym___cdecl] = ACTIONS(1430),
    [anon_sym___clrcall] = ACTIONS(1430),
    [anon_sym___stdcall] = ACTIONS(1430),
    [anon_sym___fastcall] = ACTIONS(1430),
    [anon_sym___thiscall] = ACTIONS(1430),
    [anon_sym___vectorcall] = ACTIONS(1430),
    [anon_sym_LBRACE] = ACTIONS(1432),
    [anon_sym_signed] = ACTIONS(1430),
    [anon_sym_unsigned] = ACTIONS(1430),
    [anon_sym_long] = ACTIONS(1430),
    [anon_sym_short] = ACTIONS(1430),
    [anon_sym_static] = ACTIONS(1430),
    [anon_sym_auto] = ACTIONS(1430),
    [anon_sym_register] = ACTIONS(1430),
    [anon_sym_inline] = ACTIONS(1430),
    [anon_sym___inline] = ACTIONS(1430),
    [anon_sym___inline__] = ACTIONS(1430),
    [anon_sym___forceinline] = ACTIONS(1430),
    [anon_sym_thread_local] = ACTIONS(1430),
    [anon_sym___thread] = ACTIONS(1430),
    [anon_sym_const] = ACTIONS(1430),
    [anon_sym_constexpr] = ACTIONS(1430),
    [anon_sym_volatile] = ACTIONS(1430),
    [anon_sym_restrict] = ACTIONS(1430),
    [anon_sym___restrict__] = ACTIONS(1430),
    [anon_sym__Atomic] = ACTIONS(1430),
    [anon_sym__Noreturn] = ACTIONS(1430),
    [anon_sym_noreturn] = ACTIONS(1430),
    [sym_primitive_type] = ACTIONS(1430),
    [anon_sym_enum] = ACTIONS(1430),
    [anon_sym_struct] = ACTIONS(1430),
    [anon_sym_union] = ACTIONS(1430),
    [anon_sym_if] = ACTIONS(1430),
    [anon_sym_switch] = ACTIONS(1430),
    [anon_sym_case] = ACTIONS(1430),
    [anon_sym_default] = ACTIONS(1430),
    [anon_sym_while] = ACTIONS(1430),
    [anon_sym_do] = ACTIONS(1430),
    [anon_sym_for] = ACTIONS(1430),
    [anon_sym_return] = ACTIONS(1430),
    [anon_sym_break] = ACTIONS(1430),
    [anon_sym_continue] = ACTIONS(1430),
    [anon_sym_goto] = ACTIONS(1430),
    [anon_sym_DASH_DASH] = ACTIONS(1432),
    [anon_sym_PLUS_PLUS] = ACTIONS(1432),
    [anon_sym_sizeof] = ACTIONS(1430),
    [anon_sym___alignof__] = ACTIONS(1430),
    [anon_sym___alignof] = ACTIONS(1430),
    [anon_sym__alignof] = ACTIONS(1430),
    [anon_sym_alignof] = ACTIONS(1430),
    [anon_sym__Alignof] = ACTIONS(1430),
    [anon_sym_offsetof] = ACTIONS(1430),
    [anon_sym__Generic] = ACTIONS(1430),
    [anon_sym_asm] = ACTIONS(1430),
    [anon_sym___asm__] = ACTIONS(1430),
    [sym_number_literal] = ACTIONS(1432),
    [anon_sym_L_SQUOTE] = ACTIONS(1432),
    [anon_sym_u_SQUOTE] = ACTIONS(1432),
    [anon_sym_U_SQUOTE] = ACTIONS(1432),
    [anon_sym_u8_SQUOTE] = ACTIONS(1432),
    [anon_sym_SQUOTE] = ACTIONS(1432),
    [anon_sym_L_DQUOTE] = ACTIONS(1432),
    [anon_sym_u_DQUOTE] = ACTIONS(1432),
    [anon_sym_U_DQUOTE] = ACTIONS(1432),
    [anon_sym_u8_DQUOTE] = ACTIONS(1432),
    [anon_sym_DQUOTE] = ACTIONS(1432),
    [sym_true] = ACTIONS(1430),
    [sym_false] = ACTIONS(1430),
    [anon_sym_NULL] = ACTIONS(1430),
    [anon_sym_nullptr] = ACTIONS(1430),
    [sym_comment] = ACTIONS(3),
  },
  [532] = {
    [ts_builtin_sym_end] = ACTIONS(1496),
    [sym_identifier] = ACTIONS(1494),
    [aux_sym_preproc_include_token1] = ACTIONS(1494),
    [aux_sym_preproc_def_token1] = ACTIONS(1494),
    [aux_sym_preproc_if_token1] = ACTIONS(1494),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1494),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1494),
    [sym_preproc_directive] = ACTIONS(1494),
    [anon_sym_LPAREN2] = ACTIONS(1496),
    [anon_sym_BANG] = ACTIONS(1496),
    [anon_sym_TILDE] = ACTIONS(1496),
    [anon_sym_DASH] = ACTIONS(1494),
    [anon_sym_PLUS] = ACTIONS(1494),
    [anon_sym_STAR] = ACTIONS(1496),
    [anon_sym_AMP] = ACTIONS(1496),
    [anon_sym___extension__] = ACTIONS(1494),
    [anon_sym_typedef] = ACTIONS(1494),
    [anon_sym_extern] = ACTIONS(1494),
    [anon_sym___attribute__] = ACTIONS(1494),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1496),
    [anon_sym___declspec] = ACTIONS(1494),
    [anon_sym___cdecl] = ACTIONS(1494),
    [anon_sym___clrcall] = ACTIONS(1494),
    [anon_sym___stdcall] = ACTIONS(1494),
    [anon_sym___fastcall] = ACTIONS(1494),
    [anon_sym___thiscall] = ACTIONS(1494),
    [anon_sym___vectorcall] = ACTIONS(1494),
    [anon_sym_LBRACE] = ACTIONS(1496),
    [anon_sym_signed] = ACTIONS(1494),
    [anon_sym_unsigned] = ACTIONS(1494),
    [anon_sym_long] = ACTIONS(1494),
    [anon_sym_short] = ACTIONS(1494),
    [anon_sym_static] = ACTIONS(1494),
    [anon_sym_auto] = ACTIONS(1494),
    [anon_sym_register] = ACTIONS(1494),
    [anon_sym_inline] = ACTIONS(1494),
    [anon_sym___inline] = ACTIONS(1494),
    [anon_sym___inline__] = ACTIONS(1494),
    [anon_sym___forceinline] = ACTIONS(1494),
    [anon_sym_thread_local] = ACTIONS(1494),
    [anon_sym___thread] = ACTIONS(1494),
    [anon_sym_const] = ACTIONS(1494),
    [anon_sym_constexpr] = ACTIONS(1494),
    [anon_sym_volatile] = ACTIONS(1494),
    [anon_sym_restrict] = ACTIONS(1494),
    [anon_sym___restrict__] = ACTIONS(1494),
    [anon_sym__Atomic] = ACTIONS(1494),
    [anon_sym__Noreturn] = ACTIONS(1494),
    [anon_sym_noreturn] = ACTIONS(1494),
    [sym_primitive_type] = ACTIONS(1494),
    [anon_sym_enum] = ACTIONS(1494),
    [anon_sym_struct] = ACTIONS(1494),
    [anon_sym_union] = ACTIONS(1494),
    [anon_sym_if] = ACTIONS(1494),
    [anon_sym_switch] = ACTIONS(1494),
    [anon_sym_case] = ACTIONS(1494),
    [anon_sym_default] = ACTIONS(1494),
    [anon_sym_while] = ACTIONS(1494),
    [anon_sym_do] = ACTIONS(1494),
    [anon_sym_for] = ACTIONS(1494),
    [anon_sym_return] = ACTIONS(1494),
    [anon_sym_break] = ACTIONS(1494),
    [anon_sym_continue] = ACTIONS(1494),
    [anon_sym_goto] = ACTIONS(1494),
    [anon_sym_DASH_DASH] = ACTIONS(1496),
    [anon_sym_PLUS_PLUS] = ACTIONS(1496),
    [anon_sym_sizeof] = ACTIONS(1494),
    [anon_sym___alignof__] = ACTIONS(1494),
    [anon_sym___alignof] = ACTIONS(1494),
    [anon_sym__alignof] = ACTIONS(1494),
    [anon_sym_alignof] = ACTIONS(1494),
    [anon_sym__Alignof] = ACTIONS(1494),
    [anon_sym_offsetof] = ACTIONS(1494),
    [anon_sym__Generic] = ACTIONS(1494),
    [anon_sym_asm] = ACTIONS(1494),
    [anon_sym___asm__] = ACTIONS(1494),
    [sym_number_literal] = ACTIONS(1496),
    [anon_sym_L_SQUOTE] = ACTIONS(1496),
    [anon_sym_u_SQUOTE] = ACTIONS(1496),
    [anon_sym_U_SQUOTE] = ACTIONS(1496),
    [anon_sym_u8_SQUOTE] = ACTIONS(1496),
    [anon_sym_SQUOTE] = ACTIONS(1496),
    [anon_sym_L_DQUOTE] = ACTIONS(1496),
    [anon_sym_u_DQUOTE] = ACTIONS(1496),
    [anon_sym_U_DQUOTE] = ACTIONS(1496),
    [anon_sym_u8_DQUOTE] = ACTIONS(1496),
    [anon_sym_DQUOTE] = ACTIONS(1496),
    [sym_true] = ACTIONS(1494),
    [sym_false] = ACTIONS(1494),
    [anon_sym_NULL] = ACTIONS(1494),
    [anon_sym_nullptr] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
  },
  [533] = {
    [ts_builtin_sym_end] = ACTIONS(1520),
    [sym_identifier] = ACTIONS(1518),
    [aux_sym_preproc_include_token1] = ACTIONS(1518),
    [aux_sym_preproc_def_token1] = ACTIONS(1518),
    [aux_sym_preproc_if_token1] = ACTIONS(1518),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1518),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1518),
    [sym_preproc_directive] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(1520),
    [anon_sym_BANG] = ACTIONS(1520),
    [anon_sym_TILDE] = ACTIONS(1520),
    [anon_sym_DASH] = ACTIONS(1518),
    [anon_sym_PLUS] = ACTIONS(1518),
    [anon_sym_STAR] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1520),
    [anon_sym___extension__] = ACTIONS(1518),
    [anon_sym_typedef] = ACTIONS(1518),
    [anon_sym_extern] = ACTIONS(1518),
    [anon_sym___attribute__] = ACTIONS(1518),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1520),
    [anon_sym___declspec] = ACTIONS(1518),
    [anon_sym___cdecl] = ACTIONS(1518),
    [anon_sym___clrcall] = ACTIONS(1518),
    [anon_sym___stdcall] = ACTIONS(1518),
    [anon_sym___fastcall] = ACTIONS(1518),
    [anon_sym___thiscall] = ACTIONS(1518),
    [anon_sym___vectorcall] = ACTIONS(1518),
    [anon_sym_LBRACE] = ACTIONS(1520),
    [anon_sym_signed] = ACTIONS(1518),
    [anon_sym_unsigned] = ACTIONS(1518),
    [anon_sym_long] = ACTIONS(1518),
    [anon_sym_short] = ACTIONS(1518),
    [anon_sym_static] = ACTIONS(1518),
    [anon_sym_auto] = ACTIONS(1518),
    [anon_sym_register] = ACTIONS(1518),
    [anon_sym_inline] = ACTIONS(1518),
    [anon_sym___inline] = ACTIONS(1518),
    [anon_sym___inline__] = ACTIONS(1518),
    [anon_sym___forceinline] = ACTIONS(1518),
    [anon_sym_thread_local] = ACTIONS(1518),
    [anon_sym___thread] = ACTIONS(1518),
    [anon_sym_const] = ACTIONS(1518),
    [anon_sym_constexpr] = ACTIONS(1518),
    [anon_sym_volatile] = ACTIONS(1518),
    [anon_sym_restrict] = ACTIONS(1518),
    [anon_sym___restrict__] = ACTIONS(1518),
    [anon_sym__Atomic] = ACTIONS(1518),
    [anon_sym__Noreturn] = ACTIONS(1518),
    [anon_sym_noreturn] = ACTIONS(1518),
    [sym_primitive_type] = ACTIONS(1518),
    [anon_sym_enum] = ACTIONS(1518),
    [anon_sym_struct] = ACTIONS(1518),
    [anon_sym_union] = ACTIONS(1518),
    [anon_sym_if] = ACTIONS(1518),
    [anon_sym_switch] = ACTIONS(1518),
    [anon_sym_case] = ACTIONS(1518),
    [anon_sym_default] = ACTIONS(1518),
    [anon_sym_while] = ACTIONS(1518),
    [anon_sym_do] = ACTIONS(1518),
    [anon_sym_for] = ACTIONS(1518),
    [anon_sym_return] = ACTIONS(1518),
    [anon_sym_break] = ACTIONS(1518),
    [anon_sym_continue] = ACTIONS(1518),
    [anon_sym_goto] = ACTIONS(1518),
    [anon_sym_DASH_DASH] = ACTIONS(1520),
    [anon_sym_PLUS_PLUS] = ACTIONS(1520),
    [anon_sym_sizeof] = ACTIONS(1518),
    [anon_sym___alignof__] = ACTIONS(1518),
    [anon_sym___alignof] = ACTIONS(1518),
    [anon_sym__alignof] = ACTIONS(1518),
    [anon_sym_alignof] = ACTIONS(1518),
    [anon_sym__Alignof] = ACTIONS(1518),
    [anon_sym_offsetof] = ACTIONS(1518),
    [anon_sym__Generic] = ACTIONS(1518),
    [anon_sym_asm] = ACTIONS(1518),
    [anon_sym___asm__] = ACTIONS(1518),
    [sym_number_literal] = ACTIONS(1520),
    [anon_sym_L_SQUOTE] = ACTIONS(1520),
    [anon_sym_u_SQUOTE] = ACTIONS(1520),
    [anon_sym_U_SQUOTE] = ACTIONS(1520),
    [anon_sym_u8_SQUOTE] = ACTIONS(1520),
    [anon_sym_SQUOTE] = ACTIONS(1520),
    [anon_sym_L_DQUOTE] = ACTIONS(1520),
    [anon_sym_u_DQUOTE] = ACTIONS(1520),
    [anon_sym_U_DQUOTE] = ACTIONS(1520),
    [anon_sym_u8_DQUOTE] = ACTIONS(1520),
    [anon_sym_DQUOTE] = ACTIONS(1520),
    [sym_true] = ACTIONS(1518),
    [sym_false] = ACTIONS(1518),
    [anon_sym_NULL] = ACTIONS(1518),
    [anon_sym_nullptr] = ACTIONS(1518),
    [sym_comment] = ACTIONS(3),
  },
  [534] = {
    [ts_builtin_sym_end] = ACTIONS(1524),
    [sym_identifier] = ACTIONS(1522),
    [aux_sym_preproc_include_token1] = ACTIONS(1522),
    [aux_sym_preproc_def_token1] = ACTIONS(1522),
    [aux_sym_preproc_if_token1] = ACTIONS(1522),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1522),
    [sym_preproc_directive] = ACTIONS(1522),
    [anon_sym_LPAREN2] = ACTIONS(1524),
    [anon_sym_BANG] = ACTIONS(1524),
    [anon_sym_TILDE] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1522),
    [anon_sym_PLUS] = ACTIONS(1522),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym___extension__] = ACTIONS(1522),
    [anon_sym_typedef] = ACTIONS(1522),
    [anon_sym_extern] = ACTIONS(1522),
    [anon_sym___attribute__] = ACTIONS(1522),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1524),
    [anon_sym___declspec] = ACTIONS(1522),
    [anon_sym___cdecl] = ACTIONS(1522),
    [anon_sym___clrcall] = ACTIONS(1522),
    [anon_sym___stdcall] = ACTIONS(1522),
    [anon_sym___fastcall] = ACTIONS(1522),
    [anon_sym___thiscall] = ACTIONS(1522),
    [anon_sym___vectorcall] = ACTIONS(1522),
    [anon_sym_LBRACE] = ACTIONS(1524),
    [anon_sym_signed] = ACTIONS(1522),
    [anon_sym_unsigned] = ACTIONS(1522),
    [anon_sym_long] = ACTIONS(1522),
    [anon_sym_short] = ACTIONS(1522),
    [anon_sym_static] = ACTIONS(1522),
    [anon_sym_auto] = ACTIONS(1522),
    [anon_sym_register] = ACTIONS(1522),
    [anon_sym_inline] = ACTIONS(1522),
    [anon_sym___inline] = ACTIONS(1522),
    [anon_sym___inline__] = ACTIONS(1522),
    [anon_sym___forceinline] = ACTIONS(1522),
    [anon_sym_thread_local] = ACTIONS(1522),
    [anon_sym___thread] = ACTIONS(1522),
    [anon_sym_const] = ACTIONS(1522),
    [anon_sym_constexpr] = ACTIONS(1522),
    [anon_sym_volatile] = ACTIONS(1522),
    [anon_sym_restrict] = ACTIONS(1522),
    [anon_sym___restrict__] = ACTIONS(1522),
    [anon_sym__Atomic] = ACTIONS(1522),
    [anon_sym__Noreturn] = ACTIONS(1522),
    [anon_sym_noreturn] = ACTIONS(1522),
    [sym_primitive_type] = ACTIONS(1522),
    [anon_sym_enum] = ACTIONS(1522),
    [anon_sym_struct] = ACTIONS(1522),
    [anon_sym_union] = ACTIONS(1522),
    [anon_sym_if] = ACTIONS(1522),
    [anon_sym_switch] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1522),
    [anon_sym_default] = ACTIONS(1522),
    [anon_sym_while] = ACTIONS(1522),
    [anon_sym_do] = ACTIONS(1522),
    [anon_sym_for] = ACTIONS(1522),
    [anon_sym_return] = ACTIONS(1522),
    [anon_sym_break] = ACTIONS(1522),
    [anon_sym_continue] = ACTIONS(1522),
    [anon_sym_goto] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1524),
    [anon_sym_PLUS_PLUS] = ACTIONS(1524),
    [anon_sym_sizeof] = ACTIONS(1522),
    [anon_sym___alignof__] = ACTIONS(1522),
    [anon_sym___alignof] = ACTIONS(1522),
    [anon_sym__alignof] = ACTIONS(1522),
    [anon_sym_alignof] = ACTIONS(1522),
    [anon_sym__Alignof] = ACTIONS(1522),
    [anon_sym_offsetof] = ACTIONS(1522),
    [anon_sym__Generic] = ACTIONS(1522),
    [anon_sym_asm] = ACTIONS(1522),
    [anon_sym___asm__] = ACTIONS(1522),
    [sym_number_literal] = ACTIONS(1524),
    [anon_sym_L_SQUOTE] = ACTIONS(1524),
    [anon_sym_u_SQUOTE] = ACTIONS(1524),
    [anon_sym_U_SQUOTE] = ACTIONS(1524),
    [anon_sym_u8_SQUOTE] = ACTIONS(1524),
    [anon_sym_SQUOTE] = ACTIONS(1524),
    [anon_sym_L_DQUOTE] = ACTIONS(1524),
    [anon_sym_u_DQUOTE] = ACTIONS(1524),
    [anon_sym_U_DQUOTE] = ACTIONS(1524),
    [anon_sym_u8_DQUOTE] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(1524),
    [sym_true] = ACTIONS(1522),
    [sym_false] = ACTIONS(1522),
    [anon_sym_NULL] = ACTIONS(1522),
    [anon_sym_nullptr] = ACTIONS(1522),
    [sym_comment] = ACTIONS(3),
  },
  [535] = {
    [ts_builtin_sym_end] = ACTIONS(1460),
    [sym_identifier] = ACTIONS(1458),
    [aux_sym_preproc_include_token1] = ACTIONS(1458),
    [aux_sym_preproc_def_token1] = ACTIONS(1458),
    [aux_sym_preproc_if_token1] = ACTIONS(1458),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1458),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1458),
    [sym_preproc_directive] = ACTIONS(1458),
    [anon_sym_LPAREN2] = ACTIONS(1460),
    [anon_sym_BANG] = ACTIONS(1460),
    [anon_sym_TILDE] = ACTIONS(1460),
    [anon_sym_DASH] = ACTIONS(1458),
    [anon_sym_PLUS] = ACTIONS(1458),
    [anon_sym_STAR] = ACTIONS(1460),
    [anon_sym_AMP] = ACTIONS(1460),
    [anon_sym___extension__] = ACTIONS(1458),
    [anon_sym_typedef] = ACTIONS(1458),
    [anon_sym_extern] = ACTIONS(1458),
    [anon_sym___attribute__] = ACTIONS(1458),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1460),
    [anon_sym___declspec] = ACTIONS(1458),
    [anon_sym___cdecl] = ACTIONS(1458),
    [anon_sym___clrcall] = ACTIONS(1458),
    [anon_sym___stdcall] = ACTIONS(1458),
    [anon_sym___fastcall] = ACTIONS(1458),
    [anon_sym___thiscall] = ACTIONS(1458),
    [anon_sym___vectorcall] = ACTIONS(1458),
    [anon_sym_LBRACE] = ACTIONS(1460),
    [anon_sym_signed] = ACTIONS(1458),
    [anon_sym_unsigned] = ACTIONS(1458),
    [anon_sym_long] = ACTIONS(1458),
    [anon_sym_short] = ACTIONS(1458),
    [anon_sym_static] = ACTIONS(1458),
    [anon_sym_auto] = ACTIONS(1458),
    [anon_sym_register] = ACTIONS(1458),
    [anon_sym_inline] = ACTIONS(1458),
    [anon_sym___inline] = ACTIONS(1458),
    [anon_sym___inline__] = ACTIONS(1458),
    [anon_sym___forceinline] = ACTIONS(1458),
    [anon_sym_thread_local] = ACTIONS(1458),
    [anon_sym___thread] = ACTIONS(1458),
    [anon_sym_const] = ACTIONS(1458),
    [anon_sym_constexpr] = ACTIONS(1458),
    [anon_sym_volatile] = ACTIONS(1458),
    [anon_sym_restrict] = ACTIONS(1458),
    [anon_sym___restrict__] = ACTIONS(1458),
    [anon_sym__Atomic] = ACTIONS(1458),
    [anon_sym__Noreturn] = ACTIONS(1458),
    [anon_sym_noreturn] = ACTIONS(1458),
    [sym_primitive_type] = ACTIONS(1458),
    [anon_sym_enum] = ACTIONS(1458),
    [anon_sym_struct] = ACTIONS(1458),
    [anon_sym_union] = ACTIONS(1458),
    [anon_sym_if] = ACTIONS(1458),
    [anon_sym_switch] = ACTIONS(1458),
    [anon_sym_case] = ACTIONS(1458),
    [anon_sym_default] = ACTIONS(1458),
    [anon_sym_while] = ACTIONS(1458),
    [anon_sym_do] = ACTIONS(1458),
    [anon_sym_for] = ACTIONS(1458),
    [anon_sym_return] = ACTIONS(1458),
    [anon_sym_break] = ACTIONS(1458),
    [anon_sym_continue] = ACTIONS(1458),
    [anon_sym_goto] = ACTIONS(1458),
    [anon_sym_DASH_DASH] = ACTIONS(1460),
    [anon_sym_PLUS_PLUS] = ACTIONS(1460),
    [anon_sym_sizeof] = ACTIONS(1458),
    [anon_sym___alignof__] = ACTIONS(1458),
    [anon_sym___alignof] = ACTIONS(1458),
    [anon_sym__alignof] = ACTIONS(1458),
    [anon_sym_alignof] = ACTIONS(1458),
    [anon_sym__Alignof] = ACTIONS(1458),
    [anon_sym_offsetof] = ACTIONS(1458),
    [anon_sym__Generic] = ACTIONS(1458),
    [anon_sym_asm] = ACTIONS(1458),
    [anon_sym___asm__] = ACTIONS(1458),
    [sym_number_literal] = ACTIONS(1460),
    [anon_sym_L_SQUOTE] = ACTIONS(1460),
    [anon_sym_u_SQUOTE] = ACTIONS(1460),
    [anon_sym_U_SQUOTE] = ACTIONS(1460),
    [anon_sym_u8_SQUOTE] = ACTIONS(1460),
    [anon_sym_SQUOTE] = ACTIONS(1460),
    [anon_sym_L_DQUOTE] = ACTIONS(1460),
    [anon_sym_u_DQUOTE] = ACTIONS(1460),
    [anon_sym_U_DQUOTE] = ACTIONS(1460),
    [anon_sym_u8_DQUOTE] = ACTIONS(1460),
    [anon_sym_DQUOTE] = ACTIONS(1460),
    [sym_true] = ACTIONS(1458),
    [sym_false] = ACTIONS(1458),
    [anon_sym_NULL] = ACTIONS(1458),
    [anon_sym_nullptr] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
  },
  [536] = {
    [ts_builtin_sym_end] = ACTIONS(1508),
    [sym_identifier] = ACTIONS(1506),
    [aux_sym_preproc_include_token1] = ACTIONS(1506),
    [aux_sym_preproc_def_token1] = ACTIONS(1506),
    [aux_sym_preproc_if_token1] = ACTIONS(1506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1506),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1506),
    [sym_preproc_directive] = ACTIONS(1506),
    [anon_sym_LPAREN2] = ACTIONS(1508),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_TILDE] = ACTIONS(1508),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym___extension__] = ACTIONS(1506),
    [anon_sym_typedef] = ACTIONS(1506),
    [anon_sym_extern] = ACTIONS(1506),
    [anon_sym___attribute__] = ACTIONS(1506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1508),
    [anon_sym___declspec] = ACTIONS(1506),
    [anon_sym___cdecl] = ACTIONS(1506),
    [anon_sym___clrcall] = ACTIONS(1506),
    [anon_sym___stdcall] = ACTIONS(1506),
    [anon_sym___fastcall] = ACTIONS(1506),
    [anon_sym___thiscall] = ACTIONS(1506),
    [anon_sym___vectorcall] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1508),
    [anon_sym_signed] = ACTIONS(1506),
    [anon_sym_unsigned] = ACTIONS(1506),
    [anon_sym_long] = ACTIONS(1506),
    [anon_sym_short] = ACTIONS(1506),
    [anon_sym_static] = ACTIONS(1506),
    [anon_sym_auto] = ACTIONS(1506),
    [anon_sym_register] = ACTIONS(1506),
    [anon_sym_inline] = ACTIONS(1506),
    [anon_sym___inline] = ACTIONS(1506),
    [anon_sym___inline__] = ACTIONS(1506),
    [anon_sym___forceinline] = ACTIONS(1506),
    [anon_sym_thread_local] = ACTIONS(1506),
    [anon_sym___thread] = ACTIONS(1506),
    [anon_sym_const] = ACTIONS(1506),
    [anon_sym_constexpr] = ACTIONS(1506),
    [anon_sym_volatile] = ACTIONS(1506),
    [anon_sym_restrict] = ACTIONS(1506),
    [anon_sym___restrict__] = ACTIONS(1506),
    [anon_sym__Atomic] = ACTIONS(1506),
    [anon_sym__Noreturn] = ACTIONS(1506),
    [anon_sym_noreturn] = ACTIONS(1506),
    [sym_primitive_type] = ACTIONS(1506),
    [anon_sym_enum] = ACTIONS(1506),
    [anon_sym_struct] = ACTIONS(1506),
    [anon_sym_union] = ACTIONS(1506),
    [anon_sym_if] = ACTIONS(1506),
    [anon_sym_switch] = ACTIONS(1506),
    [anon_sym_case] = ACTIONS(1506),
    [anon_sym_default] = ACTIONS(1506),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_do] = ACTIONS(1506),
    [anon_sym_for] = ACTIONS(1506),
    [anon_sym_return] = ACTIONS(1506),
    [anon_sym_break] = ACTIONS(1506),
    [anon_sym_continue] = ACTIONS(1506),
    [anon_sym_goto] = ACTIONS(1506),
    [anon_sym_DASH_DASH] = ACTIONS(1508),
    [anon_sym_PLUS_PLUS] = ACTIONS(1508),
    [anon_sym_sizeof] = ACTIONS(1506),
    [anon_sym___alignof__] = ACTIONS(1506),
    [anon_sym___alignof] = ACTIONS(1506),
    [anon_sym__alignof] = ACTIONS(1506),
    [anon_sym_alignof] = ACTIONS(1506),
    [anon_sym__Alignof] = ACTIONS(1506),
    [anon_sym_offsetof] = ACTIONS(1506),
    [anon_sym__Generic] = ACTIONS(1506),
    [anon_sym_asm] = ACTIONS(1506),
    [anon_sym___asm__] = ACTIONS(1506),
    [sym_number_literal] = ACTIONS(1508),
    [anon_sym_L_SQUOTE] = ACTIONS(1508),
    [anon_sym_u_SQUOTE] = ACTIONS(1508),
    [anon_sym_U_SQUOTE] = ACTIONS(1508),
    [anon_sym_u8_SQUOTE] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1508),
    [anon_sym_L_DQUOTE] = ACTIONS(1508),
    [anon_sym_u_DQUOTE] = ACTIONS(1508),
    [anon_sym_U_DQUOTE] = ACTIONS(1508),
    [anon_sym_u8_DQUOTE] = ACTIONS(1508),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_true] = ACTIONS(1506),
    [sym_false] = ACTIONS(1506),
    [anon_sym_NULL] = ACTIONS(1506),
    [anon_sym_nullptr] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
  },
  [537] = {
    [sym_type_qualifier] = STATE(1373),
    [sym__type_specifier] = STATE(1398),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__expression] = STATE(1327),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2222),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_type_descriptor] = STATE(2221),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__type_definition_type_repeat1] = STATE(1373),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1403),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1931),
    [anon_sym_unsigned] = ACTIONS(1931),
    [anon_sym_long] = ACTIONS(1931),
    [anon_sym_short] = ACTIONS(1931),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(1933),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [538] = {
    [sym_type_qualifier] = STATE(1373),
    [sym__type_specifier] = STATE(1398),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__expression] = STATE(1327),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2222),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_type_descriptor] = STATE(2142),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__type_definition_type_repeat1] = STATE(1373),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1403),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1931),
    [anon_sym_unsigned] = ACTIONS(1931),
    [anon_sym_long] = ACTIONS(1931),
    [anon_sym_short] = ACTIONS(1931),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(1933),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [539] = {
    [sym_type_qualifier] = STATE(1373),
    [sym__type_specifier] = STATE(1398),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__expression] = STATE(1288),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2157),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_type_descriptor] = STATE(2303),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__type_definition_type_repeat1] = STATE(1373),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1403),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1931),
    [anon_sym_unsigned] = ACTIONS(1931),
    [anon_sym_long] = ACTIONS(1931),
    [anon_sym_short] = ACTIONS(1931),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(1933),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [540] = {
    [sym_type_qualifier] = STATE(1373),
    [sym__type_specifier] = STATE(1398),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__expression] = STATE(1288),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2157),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_type_descriptor] = STATE(2200),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__type_definition_type_repeat1] = STATE(1373),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1403),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1931),
    [anon_sym_unsigned] = ACTIONS(1931),
    [anon_sym_long] = ACTIONS(1931),
    [anon_sym_short] = ACTIONS(1931),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(1933),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [541] = {
    [sym_type_qualifier] = STATE(1373),
    [sym__type_specifier] = STATE(1398),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__expression] = STATE(1327),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2222),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_type_descriptor] = STATE(2143),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__type_definition_type_repeat1] = STATE(1373),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1403),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1931),
    [anon_sym_unsigned] = ACTIONS(1931),
    [anon_sym_long] = ACTIONS(1931),
    [anon_sym_short] = ACTIONS(1931),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(1933),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [542] = {
    [sym_type_qualifier] = STATE(1373),
    [sym__type_specifier] = STATE(1398),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__expression] = STATE(1327),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2222),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_type_descriptor] = STATE(2394),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__type_definition_type_repeat1] = STATE(1373),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1403),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1931),
    [anon_sym_unsigned] = ACTIONS(1931),
    [anon_sym_long] = ACTIONS(1931),
    [anon_sym_short] = ACTIONS(1931),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(1933),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [543] = {
    [sym_type_qualifier] = STATE(1373),
    [sym__type_specifier] = STATE(1398),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__expression] = STATE(1327),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2222),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_type_descriptor] = STATE(2300),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__type_definition_type_repeat1] = STATE(1373),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1403),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1931),
    [anon_sym_unsigned] = ACTIONS(1931),
    [anon_sym_long] = ACTIONS(1931),
    [anon_sym_short] = ACTIONS(1931),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(1933),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [544] = {
    [sym_type_qualifier] = STATE(1373),
    [sym__type_specifier] = STATE(1398),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__expression] = STATE(1327),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2222),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_type_descriptor] = STATE(2164),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__type_definition_type_repeat1] = STATE(1373),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1403),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1931),
    [anon_sym_unsigned] = ACTIONS(1931),
    [anon_sym_long] = ACTIONS(1931),
    [anon_sym_short] = ACTIONS(1931),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(1933),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [545] = {
    [sym_type_qualifier] = STATE(1373),
    [sym__type_specifier] = STATE(1398),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__expression] = STATE(1288),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2157),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_type_descriptor] = STATE(2139),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__type_definition_type_repeat1] = STATE(1373),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1403),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1931),
    [anon_sym_unsigned] = ACTIONS(1931),
    [anon_sym_long] = ACTIONS(1931),
    [anon_sym_short] = ACTIONS(1931),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(1933),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [546] = {
    [sym_type_qualifier] = STATE(1373),
    [sym__type_specifier] = STATE(1398),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__expression] = STATE(1327),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2222),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_type_descriptor] = STATE(2346),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__type_definition_type_repeat1] = STATE(1373),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1403),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1931),
    [anon_sym_unsigned] = ACTIONS(1931),
    [anon_sym_long] = ACTIONS(1931),
    [anon_sym_short] = ACTIONS(1931),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(1933),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [547] = {
    [sym_type_qualifier] = STATE(1373),
    [sym__type_specifier] = STATE(1398),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__expression] = STATE(1288),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2157),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_type_descriptor] = STATE(2156),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__type_definition_type_repeat1] = STATE(1373),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1403),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1931),
    [anon_sym_unsigned] = ACTIONS(1931),
    [anon_sym_long] = ACTIONS(1931),
    [anon_sym_short] = ACTIONS(1931),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(1933),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [548] = {
    [sym_type_qualifier] = STATE(1373),
    [sym__type_specifier] = STATE(1398),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__expression] = STATE(1327),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2222),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_type_descriptor] = STATE(2195),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__type_definition_type_repeat1] = STATE(1373),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1403),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1931),
    [anon_sym_unsigned] = ACTIONS(1931),
    [anon_sym_long] = ACTIONS(1931),
    [anon_sym_short] = ACTIONS(1931),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(1933),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [549] = {
    [sym_type_qualifier] = STATE(1373),
    [sym__type_specifier] = STATE(1398),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__expression] = STATE(1327),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2222),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_type_descriptor] = STATE(2153),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__type_definition_type_repeat1] = STATE(1373),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1403),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1931),
    [anon_sym_unsigned] = ACTIONS(1931),
    [anon_sym_long] = ACTIONS(1931),
    [anon_sym_short] = ACTIONS(1931),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(1933),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [550] = {
    [sym_type_qualifier] = STATE(1373),
    [sym__type_specifier] = STATE(1398),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__expression] = STATE(1327),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2222),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_type_descriptor] = STATE(2232),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__type_definition_type_repeat1] = STATE(1373),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1403),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1931),
    [anon_sym_unsigned] = ACTIONS(1931),
    [anon_sym_long] = ACTIONS(1931),
    [anon_sym_short] = ACTIONS(1931),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(1933),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [551] = {
    [sym_type_qualifier] = STATE(1373),
    [sym__type_specifier] = STATE(1398),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__expression] = STATE(1327),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2222),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_type_descriptor] = STATE(2367),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__type_definition_type_repeat1] = STATE(1373),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1403),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1931),
    [anon_sym_unsigned] = ACTIONS(1931),
    [anon_sym_long] = ACTIONS(1931),
    [anon_sym_short] = ACTIONS(1931),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(1933),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [552] = {
    [sym_type_qualifier] = STATE(1373),
    [sym__type_specifier] = STATE(1398),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__expression] = STATE(1327),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_comma_expression] = STATE(2222),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_type_descriptor] = STATE(2274),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__type_definition_type_repeat1] = STATE(1373),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1403),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(1931),
    [anon_sym_unsigned] = ACTIONS(1931),
    [anon_sym_long] = ACTIONS(1931),
    [anon_sym_short] = ACTIONS(1931),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(1933),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [553] = {
    [sym_identifier] = ACTIONS(1935),
    [anon_sym_COMMA] = ACTIONS(1937),
    [anon_sym_RPAREN] = ACTIONS(1937),
    [anon_sym_LPAREN2] = ACTIONS(1937),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_TILDE] = ACTIONS(1937),
    [anon_sym_DASH] = ACTIONS(1935),
    [anon_sym_PLUS] = ACTIONS(1935),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_AMP] = ACTIONS(1937),
    [anon_sym_SEMI] = ACTIONS(1937),
    [anon_sym___extension__] = ACTIONS(1935),
    [anon_sym_extern] = ACTIONS(1935),
    [anon_sym___attribute__] = ACTIONS(1935),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1937),
    [anon_sym___declspec] = ACTIONS(1935),
    [anon_sym_LBRACE] = ACTIONS(1937),
    [anon_sym_signed] = ACTIONS(1935),
    [anon_sym_unsigned] = ACTIONS(1935),
    [anon_sym_long] = ACTIONS(1935),
    [anon_sym_short] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(1935),
    [anon_sym_EQ] = ACTIONS(1937),
    [anon_sym_static] = ACTIONS(1935),
    [anon_sym_auto] = ACTIONS(1935),
    [anon_sym_register] = ACTIONS(1935),
    [anon_sym_inline] = ACTIONS(1935),
    [anon_sym___inline] = ACTIONS(1935),
    [anon_sym___inline__] = ACTIONS(1935),
    [anon_sym___forceinline] = ACTIONS(1935),
    [anon_sym_thread_local] = ACTIONS(1935),
    [anon_sym___thread] = ACTIONS(1935),
    [anon_sym_const] = ACTIONS(1935),
    [anon_sym_constexpr] = ACTIONS(1935),
    [anon_sym_volatile] = ACTIONS(1935),
    [anon_sym_restrict] = ACTIONS(1935),
    [anon_sym___restrict__] = ACTIONS(1935),
    [anon_sym__Atomic] = ACTIONS(1935),
    [anon_sym__Noreturn] = ACTIONS(1935),
    [anon_sym_noreturn] = ACTIONS(1935),
    [sym_primitive_type] = ACTIONS(1935),
    [anon_sym_enum] = ACTIONS(1935),
    [anon_sym_COLON] = ACTIONS(1937),
    [anon_sym_struct] = ACTIONS(1935),
    [anon_sym_union] = ACTIONS(1935),
    [anon_sym_if] = ACTIONS(1935),
    [anon_sym_switch] = ACTIONS(1935),
    [anon_sym_case] = ACTIONS(1935),
    [anon_sym_default] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1935),
    [anon_sym_do] = ACTIONS(1935),
    [anon_sym_for] = ACTIONS(1935),
    [anon_sym_return] = ACTIONS(1935),
    [anon_sym_break] = ACTIONS(1935),
    [anon_sym_continue] = ACTIONS(1935),
    [anon_sym_goto] = ACTIONS(1935),
    [anon_sym___try] = ACTIONS(1935),
    [anon_sym___leave] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1937),
    [anon_sym_PLUS_PLUS] = ACTIONS(1937),
    [anon_sym_sizeof] = ACTIONS(1935),
    [anon_sym___alignof__] = ACTIONS(1935),
    [anon_sym___alignof] = ACTIONS(1935),
    [anon_sym__alignof] = ACTIONS(1935),
    [anon_sym_alignof] = ACTIONS(1935),
    [anon_sym__Alignof] = ACTIONS(1935),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1935),
    [anon_sym_asm] = ACTIONS(1935),
    [anon_sym___asm__] = ACTIONS(1935),
    [sym_number_literal] = ACTIONS(1937),
    [anon_sym_L_SQUOTE] = ACTIONS(1937),
    [anon_sym_u_SQUOTE] = ACTIONS(1937),
    [anon_sym_U_SQUOTE] = ACTIONS(1937),
    [anon_sym_u8_SQUOTE] = ACTIONS(1937),
    [anon_sym_SQUOTE] = ACTIONS(1937),
    [anon_sym_L_DQUOTE] = ACTIONS(1937),
    [anon_sym_u_DQUOTE] = ACTIONS(1937),
    [anon_sym_U_DQUOTE] = ACTIONS(1937),
    [anon_sym_u8_DQUOTE] = ACTIONS(1937),
    [anon_sym_DQUOTE] = ACTIONS(1937),
    [sym_true] = ACTIONS(1935),
    [sym_false] = ACTIONS(1935),
    [anon_sym_NULL] = ACTIONS(1935),
    [anon_sym_nullptr] = ACTIONS(1935),
    [sym_comment] = ACTIONS(3),
  },
  [554] = {
    [sym__expression] = STATE(902),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(983),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(983),
    [sym_call_expression] = STATE(983),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(983),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(983),
    [sym_initializer_list] = STATE(861),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(890),
    [sym_null] = STATE(884),
    [sym_identifier] = ACTIONS(1546),
    [anon_sym_COMMA] = ACTIONS(1540),
    [aux_sym_preproc_if_token2] = ACTIONS(1540),
    [aux_sym_preproc_else_token1] = ACTIONS(1540),
    [aux_sym_preproc_elif_token1] = ACTIONS(1546),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1540),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1540),
    [anon_sym_LPAREN2] = ACTIONS(1540),
    [anon_sym_BANG] = ACTIONS(1939),
    [anon_sym_TILDE] = ACTIONS(1941),
    [anon_sym_DASH] = ACTIONS(1546),
    [anon_sym_PLUS] = ACTIONS(1546),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1546),
    [anon_sym_PERCENT] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE] = ACTIONS(1546),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1546),
    [anon_sym_EQ_EQ] = ACTIONS(1540),
    [anon_sym_BANG_EQ] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1540),
    [anon_sym_LT_EQ] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1540),
    [anon_sym_GT_GT] = ACTIONS(1540),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1540),
    [anon_sym_QMARK] = ACTIONS(1540),
    [anon_sym_DASH_DASH] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1540),
    [anon_sym_sizeof] = ACTIONS(1943),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(1546),
    [anon_sym_DASH_GT] = ACTIONS(1540),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [555] = {
    [sym__expression] = STATE(902),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_initializer_list] = STATE(861),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_identifier] = ACTIONS(1945),
    [anon_sym_COMMA] = ACTIONS(1540),
    [anon_sym_RPAREN] = ACTIONS(1540),
    [anon_sym_LPAREN2] = ACTIONS(1540),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(1546),
    [anon_sym_PLUS] = ACTIONS(1546),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1546),
    [anon_sym_PERCENT] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE] = ACTIONS(1546),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1546),
    [anon_sym_EQ_EQ] = ACTIONS(1540),
    [anon_sym_BANG_EQ] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1540),
    [anon_sym_LT_EQ] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1540),
    [anon_sym_GT_GT] = ACTIONS(1540),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym___attribute__] = ACTIONS(1546),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1540),
    [anon_sym_COLON] = ACTIONS(1540),
    [anon_sym_QMARK] = ACTIONS(1540),
    [anon_sym_DASH_DASH] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1540),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(1546),
    [anon_sym_DASH_GT] = ACTIONS(1540),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [556] = {
    [sym_identifier] = ACTIONS(1947),
    [anon_sym_COMMA] = ACTIONS(1949),
    [anon_sym_RPAREN] = ACTIONS(1949),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_BANG] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1947),
    [anon_sym_PLUS] = ACTIONS(1947),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1949),
    [anon_sym_SEMI] = ACTIONS(1949),
    [anon_sym___extension__] = ACTIONS(1947),
    [anon_sym_extern] = ACTIONS(1947),
    [anon_sym___attribute__] = ACTIONS(1947),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1949),
    [anon_sym___declspec] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1949),
    [anon_sym_signed] = ACTIONS(1947),
    [anon_sym_unsigned] = ACTIONS(1947),
    [anon_sym_long] = ACTIONS(1947),
    [anon_sym_short] = ACTIONS(1947),
    [anon_sym_LBRACK] = ACTIONS(1947),
    [anon_sym_EQ] = ACTIONS(1949),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_auto] = ACTIONS(1947),
    [anon_sym_register] = ACTIONS(1947),
    [anon_sym_inline] = ACTIONS(1947),
    [anon_sym___inline] = ACTIONS(1947),
    [anon_sym___inline__] = ACTIONS(1947),
    [anon_sym___forceinline] = ACTIONS(1947),
    [anon_sym_thread_local] = ACTIONS(1947),
    [anon_sym___thread] = ACTIONS(1947),
    [anon_sym_const] = ACTIONS(1947),
    [anon_sym_constexpr] = ACTIONS(1947),
    [anon_sym_volatile] = ACTIONS(1947),
    [anon_sym_restrict] = ACTIONS(1947),
    [anon_sym___restrict__] = ACTIONS(1947),
    [anon_sym__Atomic] = ACTIONS(1947),
    [anon_sym__Noreturn] = ACTIONS(1947),
    [anon_sym_noreturn] = ACTIONS(1947),
    [sym_primitive_type] = ACTIONS(1947),
    [anon_sym_enum] = ACTIONS(1947),
    [anon_sym_COLON] = ACTIONS(1949),
    [anon_sym_struct] = ACTIONS(1947),
    [anon_sym_union] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(1947),
    [anon_sym_switch] = ACTIONS(1947),
    [anon_sym_case] = ACTIONS(1947),
    [anon_sym_default] = ACTIONS(1947),
    [anon_sym_while] = ACTIONS(1947),
    [anon_sym_do] = ACTIONS(1947),
    [anon_sym_for] = ACTIONS(1947),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_continue] = ACTIONS(1947),
    [anon_sym_goto] = ACTIONS(1947),
    [anon_sym___try] = ACTIONS(1947),
    [anon_sym___leave] = ACTIONS(1947),
    [anon_sym_DASH_DASH] = ACTIONS(1949),
    [anon_sym_PLUS_PLUS] = ACTIONS(1949),
    [anon_sym_sizeof] = ACTIONS(1947),
    [anon_sym___alignof__] = ACTIONS(1947),
    [anon_sym___alignof] = ACTIONS(1947),
    [anon_sym__alignof] = ACTIONS(1947),
    [anon_sym_alignof] = ACTIONS(1947),
    [anon_sym__Alignof] = ACTIONS(1947),
    [anon_sym_offsetof] = ACTIONS(1947),
    [anon_sym__Generic] = ACTIONS(1947),
    [anon_sym_asm] = ACTIONS(1947),
    [anon_sym___asm__] = ACTIONS(1947),
    [sym_number_literal] = ACTIONS(1949),
    [anon_sym_L_SQUOTE] = ACTIONS(1949),
    [anon_sym_u_SQUOTE] = ACTIONS(1949),
    [anon_sym_U_SQUOTE] = ACTIONS(1949),
    [anon_sym_u8_SQUOTE] = ACTIONS(1949),
    [anon_sym_SQUOTE] = ACTIONS(1949),
    [anon_sym_L_DQUOTE] = ACTIONS(1949),
    [anon_sym_u_DQUOTE] = ACTIONS(1949),
    [anon_sym_U_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8_DQUOTE] = ACTIONS(1949),
    [anon_sym_DQUOTE] = ACTIONS(1949),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1947),
    [anon_sym_nullptr] = ACTIONS(1947),
    [sym_comment] = ACTIONS(3),
  },
  [557] = {
    [sym__expression] = STATE(996),
    [sym__expression_not_binary] = STATE(1073),
    [sym__string] = STATE(1073),
    [sym_conditional_expression] = STATE(1073),
    [sym_assignment_expression] = STATE(1073),
    [sym_pointer_expression] = STATE(1088),
    [sym_unary_expression] = STATE(1073),
    [sym_binary_expression] = STATE(1073),
    [sym_update_expression] = STATE(1073),
    [sym_cast_expression] = STATE(1073),
    [sym_sizeof_expression] = STATE(1073),
    [sym_alignof_expression] = STATE(1073),
    [sym_offsetof_expression] = STATE(1073),
    [sym_generic_expression] = STATE(1073),
    [sym_subscript_expression] = STATE(1088),
    [sym_call_expression] = STATE(1088),
    [sym_gnu_asm_expression] = STATE(1073),
    [sym_field_expression] = STATE(1088),
    [sym_compound_literal_expression] = STATE(1073),
    [sym_parenthesized_expression] = STATE(1088),
    [sym_initializer_list] = STATE(1053),
    [sym_char_literal] = STATE(1073),
    [sym_concatenated_string] = STATE(1073),
    [sym_string_literal] = STATE(910),
    [sym_null] = STATE(1073),
    [sym_identifier] = ACTIONS(1546),
    [anon_sym_COMMA] = ACTIONS(1540),
    [aux_sym_preproc_if_token2] = ACTIONS(1540),
    [aux_sym_preproc_else_token1] = ACTIONS(1540),
    [aux_sym_preproc_elif_token1] = ACTIONS(1540),
    [anon_sym_LPAREN2] = ACTIONS(1540),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1953),
    [anon_sym_DASH] = ACTIONS(1546),
    [anon_sym_PLUS] = ACTIONS(1546),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1546),
    [anon_sym_PERCENT] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE] = ACTIONS(1546),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1546),
    [anon_sym_EQ_EQ] = ACTIONS(1540),
    [anon_sym_BANG_EQ] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1540),
    [anon_sym_LT_EQ] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1540),
    [anon_sym_GT_GT] = ACTIONS(1540),
    [anon_sym_LBRACE] = ACTIONS(1824),
    [anon_sym_LBRACK] = ACTIONS(1540),
    [anon_sym_QMARK] = ACTIONS(1540),
    [anon_sym_DASH_DASH] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1540),
    [anon_sym_sizeof] = ACTIONS(1955),
    [anon_sym___alignof__] = ACTIONS(1828),
    [anon_sym___alignof] = ACTIONS(1828),
    [anon_sym__alignof] = ACTIONS(1828),
    [anon_sym_alignof] = ACTIONS(1828),
    [anon_sym__Alignof] = ACTIONS(1828),
    [anon_sym_offsetof] = ACTIONS(1830),
    [anon_sym__Generic] = ACTIONS(1832),
    [anon_sym_asm] = ACTIONS(1834),
    [anon_sym___asm__] = ACTIONS(1834),
    [anon_sym_DOT] = ACTIONS(1546),
    [anon_sym_DASH_GT] = ACTIONS(1540),
    [sym_number_literal] = ACTIONS(1836),
    [anon_sym_L_SQUOTE] = ACTIONS(1838),
    [anon_sym_u_SQUOTE] = ACTIONS(1838),
    [anon_sym_U_SQUOTE] = ACTIONS(1838),
    [anon_sym_u8_SQUOTE] = ACTIONS(1838),
    [anon_sym_SQUOTE] = ACTIONS(1838),
    [anon_sym_L_DQUOTE] = ACTIONS(1840),
    [anon_sym_u_DQUOTE] = ACTIONS(1840),
    [anon_sym_U_DQUOTE] = ACTIONS(1840),
    [anon_sym_u8_DQUOTE] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [anon_sym_NULL] = ACTIONS(1844),
    [anon_sym_nullptr] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
  },
  [558] = {
    [sym__expression] = STATE(1100),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1138),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1138),
    [sym_call_expression] = STATE(1138),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1138),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1138),
    [sym_initializer_list] = STATE(861),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1540),
    [anon_sym_LPAREN2] = ACTIONS(1540),
    [anon_sym_BANG] = ACTIONS(1959),
    [anon_sym_TILDE] = ACTIONS(1961),
    [anon_sym_DASH] = ACTIONS(1546),
    [anon_sym_PLUS] = ACTIONS(1546),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1546),
    [anon_sym_PERCENT] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE] = ACTIONS(1546),
    [anon_sym_CARET] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1546),
    [anon_sym_EQ_EQ] = ACTIONS(1540),
    [anon_sym_BANG_EQ] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1540),
    [anon_sym_LT_EQ] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1540),
    [anon_sym_GT_GT] = ACTIONS(1540),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1540),
    [anon_sym_RBRACK] = ACTIONS(1540),
    [anon_sym_QMARK] = ACTIONS(1540),
    [anon_sym_DASH_DASH] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1540),
    [anon_sym_sizeof] = ACTIONS(1963),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(1546),
    [anon_sym_DASH_GT] = ACTIONS(1540),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [559] = {
    [sym_else_clause] = STATE(325),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1294),
    [anon_sym_TILDE] = ACTIONS(1294),
    [anon_sym_DASH] = ACTIONS(1292),
    [anon_sym_PLUS] = ACTIONS(1292),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_AMP] = ACTIONS(1294),
    [anon_sym_SEMI] = ACTIONS(1294),
    [anon_sym___extension__] = ACTIONS(1292),
    [anon_sym_typedef] = ACTIONS(1292),
    [anon_sym_extern] = ACTIONS(1292),
    [anon_sym___attribute__] = ACTIONS(1292),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1294),
    [anon_sym___declspec] = ACTIONS(1292),
    [anon_sym_LBRACE] = ACTIONS(1294),
    [anon_sym_signed] = ACTIONS(1292),
    [anon_sym_unsigned] = ACTIONS(1292),
    [anon_sym_long] = ACTIONS(1292),
    [anon_sym_short] = ACTIONS(1292),
    [anon_sym_static] = ACTIONS(1292),
    [anon_sym_auto] = ACTIONS(1292),
    [anon_sym_register] = ACTIONS(1292),
    [anon_sym_inline] = ACTIONS(1292),
    [anon_sym___inline] = ACTIONS(1292),
    [anon_sym___inline__] = ACTIONS(1292),
    [anon_sym___forceinline] = ACTIONS(1292),
    [anon_sym_thread_local] = ACTIONS(1292),
    [anon_sym___thread] = ACTIONS(1292),
    [anon_sym_const] = ACTIONS(1292),
    [anon_sym_constexpr] = ACTIONS(1292),
    [anon_sym_volatile] = ACTIONS(1292),
    [anon_sym_restrict] = ACTIONS(1292),
    [anon_sym___restrict__] = ACTIONS(1292),
    [anon_sym__Atomic] = ACTIONS(1292),
    [anon_sym__Noreturn] = ACTIONS(1292),
    [anon_sym_noreturn] = ACTIONS(1292),
    [sym_primitive_type] = ACTIONS(1292),
    [anon_sym_enum] = ACTIONS(1292),
    [anon_sym_struct] = ACTIONS(1292),
    [anon_sym_union] = ACTIONS(1292),
    [anon_sym_if] = ACTIONS(1292),
    [anon_sym_else] = ACTIONS(1965),
    [anon_sym_switch] = ACTIONS(1292),
    [anon_sym_while] = ACTIONS(1292),
    [anon_sym_do] = ACTIONS(1292),
    [anon_sym_for] = ACTIONS(1292),
    [anon_sym_return] = ACTIONS(1292),
    [anon_sym_break] = ACTIONS(1292),
    [anon_sym_continue] = ACTIONS(1292),
    [anon_sym_goto] = ACTIONS(1292),
    [anon_sym___try] = ACTIONS(1292),
    [anon_sym___leave] = ACTIONS(1292),
    [anon_sym_DASH_DASH] = ACTIONS(1294),
    [anon_sym_PLUS_PLUS] = ACTIONS(1294),
    [anon_sym_sizeof] = ACTIONS(1292),
    [anon_sym___alignof__] = ACTIONS(1292),
    [anon_sym___alignof] = ACTIONS(1292),
    [anon_sym__alignof] = ACTIONS(1292),
    [anon_sym_alignof] = ACTIONS(1292),
    [anon_sym__Alignof] = ACTIONS(1292),
    [anon_sym_offsetof] = ACTIONS(1292),
    [anon_sym__Generic] = ACTIONS(1292),
    [anon_sym_asm] = ACTIONS(1292),
    [anon_sym___asm__] = ACTIONS(1292),
    [sym_number_literal] = ACTIONS(1294),
    [anon_sym_L_SQUOTE] = ACTIONS(1294),
    [anon_sym_u_SQUOTE] = ACTIONS(1294),
    [anon_sym_U_SQUOTE] = ACTIONS(1294),
    [anon_sym_u8_SQUOTE] = ACTIONS(1294),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_L_DQUOTE] = ACTIONS(1294),
    [anon_sym_u_DQUOTE] = ACTIONS(1294),
    [anon_sym_U_DQUOTE] = ACTIONS(1294),
    [anon_sym_u8_DQUOTE] = ACTIONS(1294),
    [anon_sym_DQUOTE] = ACTIONS(1294),
    [sym_true] = ACTIONS(1292),
    [sym_false] = ACTIONS(1292),
    [anon_sym_NULL] = ACTIONS(1292),
    [anon_sym_nullptr] = ACTIONS(1292),
    [sym_comment] = ACTIONS(3),
  },
  [560] = {
    [sym_string_literal] = STATE(824),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1017),
    [sym_identifier] = ACTIONS(1967),
    [anon_sym_COMMA] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_PERCENT] = ACTIONS(1975),
    [anon_sym_PIPE_PIPE] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1969),
    [anon_sym_PIPE] = ACTIONS(1975),
    [anon_sym_CARET] = ACTIONS(1975),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_EQ_EQ] = ACTIONS(1969),
    [anon_sym_BANG_EQ] = ACTIONS(1969),
    [anon_sym_GT] = ACTIONS(1975),
    [anon_sym_GT_EQ] = ACTIONS(1969),
    [anon_sym_LT_EQ] = ACTIONS(1969),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_LT_LT] = ACTIONS(1975),
    [anon_sym_GT_GT] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1969),
    [anon_sym___extension__] = ACTIONS(1967),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym___attribute__] = ACTIONS(1967),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1980),
    [anon_sym___declspec] = ACTIONS(1967),
    [anon_sym___based] = ACTIONS(1967),
    [anon_sym___cdecl] = ACTIONS(1967),
    [anon_sym___clrcall] = ACTIONS(1967),
    [anon_sym___stdcall] = ACTIONS(1967),
    [anon_sym___fastcall] = ACTIONS(1967),
    [anon_sym___thiscall] = ACTIONS(1967),
    [anon_sym___vectorcall] = ACTIONS(1967),
    [anon_sym_signed] = ACTIONS(1982),
    [anon_sym_unsigned] = ACTIONS(1982),
    [anon_sym_long] = ACTIONS(1982),
    [anon_sym_short] = ACTIONS(1982),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_EQ] = ACTIONS(1984),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_auto] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym___inline] = ACTIONS(1967),
    [anon_sym___inline__] = ACTIONS(1967),
    [anon_sym___forceinline] = ACTIONS(1967),
    [anon_sym_thread_local] = ACTIONS(1967),
    [anon_sym___thread] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_constexpr] = ACTIONS(1967),
    [anon_sym_volatile] = ACTIONS(1967),
    [anon_sym_restrict] = ACTIONS(1967),
    [anon_sym___restrict__] = ACTIONS(1967),
    [anon_sym__Atomic] = ACTIONS(1967),
    [anon_sym__Noreturn] = ACTIONS(1967),
    [anon_sym_noreturn] = ACTIONS(1967),
    [anon_sym_COLON] = ACTIONS(1986),
    [anon_sym_QMARK] = ACTIONS(1969),
    [anon_sym_STAR_EQ] = ACTIONS(1988),
    [anon_sym_SLASH_EQ] = ACTIONS(1988),
    [anon_sym_PERCENT_EQ] = ACTIONS(1988),
    [anon_sym_PLUS_EQ] = ACTIONS(1988),
    [anon_sym_DASH_EQ] = ACTIONS(1988),
    [anon_sym_LT_LT_EQ] = ACTIONS(1988),
    [anon_sym_GT_GT_EQ] = ACTIONS(1988),
    [anon_sym_AMP_EQ] = ACTIONS(1988),
    [anon_sym_CARET_EQ] = ACTIONS(1988),
    [anon_sym_PIPE_EQ] = ACTIONS(1988),
    [anon_sym_DASH_DASH] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1969),
    [anon_sym_DOT] = ACTIONS(1969),
    [anon_sym_DASH_GT] = ACTIONS(1969),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [561] = {
    [sym_string_literal] = STATE(824),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1017),
    [sym_identifier] = ACTIONS(1967),
    [anon_sym_COMMA] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_PERCENT] = ACTIONS(1975),
    [anon_sym_PIPE_PIPE] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1969),
    [anon_sym_PIPE] = ACTIONS(1975),
    [anon_sym_CARET] = ACTIONS(1975),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_EQ_EQ] = ACTIONS(1969),
    [anon_sym_BANG_EQ] = ACTIONS(1969),
    [anon_sym_GT] = ACTIONS(1975),
    [anon_sym_GT_EQ] = ACTIONS(1969),
    [anon_sym_LT_EQ] = ACTIONS(1969),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_LT_LT] = ACTIONS(1975),
    [anon_sym_GT_GT] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1969),
    [anon_sym___extension__] = ACTIONS(1967),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym___attribute__] = ACTIONS(1967),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1980),
    [anon_sym___declspec] = ACTIONS(1967),
    [anon_sym___based] = ACTIONS(1967),
    [anon_sym___cdecl] = ACTIONS(1967),
    [anon_sym___clrcall] = ACTIONS(1967),
    [anon_sym___stdcall] = ACTIONS(1967),
    [anon_sym___fastcall] = ACTIONS(1967),
    [anon_sym___thiscall] = ACTIONS(1967),
    [anon_sym___vectorcall] = ACTIONS(1967),
    [anon_sym_signed] = ACTIONS(1982),
    [anon_sym_unsigned] = ACTIONS(1982),
    [anon_sym_long] = ACTIONS(1982),
    [anon_sym_short] = ACTIONS(1982),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_EQ] = ACTIONS(1984),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_auto] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym___inline] = ACTIONS(1967),
    [anon_sym___inline__] = ACTIONS(1967),
    [anon_sym___forceinline] = ACTIONS(1967),
    [anon_sym_thread_local] = ACTIONS(1967),
    [anon_sym___thread] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_constexpr] = ACTIONS(1967),
    [anon_sym_volatile] = ACTIONS(1967),
    [anon_sym_restrict] = ACTIONS(1967),
    [anon_sym___restrict__] = ACTIONS(1967),
    [anon_sym__Atomic] = ACTIONS(1967),
    [anon_sym__Noreturn] = ACTIONS(1967),
    [anon_sym_noreturn] = ACTIONS(1967),
    [anon_sym_COLON] = ACTIONS(1990),
    [anon_sym_QMARK] = ACTIONS(1969),
    [anon_sym_STAR_EQ] = ACTIONS(1988),
    [anon_sym_SLASH_EQ] = ACTIONS(1988),
    [anon_sym_PERCENT_EQ] = ACTIONS(1988),
    [anon_sym_PLUS_EQ] = ACTIONS(1988),
    [anon_sym_DASH_EQ] = ACTIONS(1988),
    [anon_sym_LT_LT_EQ] = ACTIONS(1988),
    [anon_sym_GT_GT_EQ] = ACTIONS(1988),
    [anon_sym_AMP_EQ] = ACTIONS(1988),
    [anon_sym_CARET_EQ] = ACTIONS(1988),
    [anon_sym_PIPE_EQ] = ACTIONS(1988),
    [anon_sym_DASH_DASH] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1969),
    [anon_sym_DOT] = ACTIONS(1969),
    [anon_sym_DASH_GT] = ACTIONS(1969),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [562] = {
    [sym_identifier] = ACTIONS(1992),
    [anon_sym_LPAREN2] = ACTIONS(1995),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1995),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym___extension__] = ACTIONS(1999),
    [anon_sym_extern] = ACTIONS(1999),
    [anon_sym___attribute__] = ACTIONS(1999),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2001),
    [anon_sym___declspec] = ACTIONS(1999),
    [anon_sym_LBRACE] = ACTIONS(1995),
    [anon_sym_signed] = ACTIONS(1999),
    [anon_sym_unsigned] = ACTIONS(1999),
    [anon_sym_long] = ACTIONS(1999),
    [anon_sym_short] = ACTIONS(1999),
    [anon_sym_static] = ACTIONS(1999),
    [anon_sym_auto] = ACTIONS(1999),
    [anon_sym_register] = ACTIONS(1999),
    [anon_sym_inline] = ACTIONS(1999),
    [anon_sym___inline] = ACTIONS(1999),
    [anon_sym___inline__] = ACTIONS(1999),
    [anon_sym___forceinline] = ACTIONS(1999),
    [anon_sym_thread_local] = ACTIONS(1999),
    [anon_sym___thread] = ACTIONS(1999),
    [anon_sym_const] = ACTIONS(1999),
    [anon_sym_constexpr] = ACTIONS(1999),
    [anon_sym_volatile] = ACTIONS(1999),
    [anon_sym_restrict] = ACTIONS(1999),
    [anon_sym___restrict__] = ACTIONS(1999),
    [anon_sym__Atomic] = ACTIONS(1999),
    [anon_sym__Noreturn] = ACTIONS(1999),
    [anon_sym_noreturn] = ACTIONS(1999),
    [sym_primitive_type] = ACTIONS(1999),
    [anon_sym_enum] = ACTIONS(1999),
    [anon_sym_struct] = ACTIONS(1999),
    [anon_sym_union] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1997),
    [anon_sym_switch] = ACTIONS(1997),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1997),
    [anon_sym_while] = ACTIONS(1997),
    [anon_sym_do] = ACTIONS(1997),
    [anon_sym_for] = ACTIONS(1997),
    [anon_sym_return] = ACTIONS(1997),
    [anon_sym_break] = ACTIONS(1997),
    [anon_sym_continue] = ACTIONS(1997),
    [anon_sym_goto] = ACTIONS(1997),
    [anon_sym___try] = ACTIONS(1997),
    [anon_sym___leave] = ACTIONS(1997),
    [anon_sym_DASH_DASH] = ACTIONS(1995),
    [anon_sym_PLUS_PLUS] = ACTIONS(1995),
    [anon_sym_sizeof] = ACTIONS(1997),
    [anon_sym___alignof__] = ACTIONS(1997),
    [anon_sym___alignof] = ACTIONS(1997),
    [anon_sym__alignof] = ACTIONS(1997),
    [anon_sym_alignof] = ACTIONS(1997),
    [anon_sym__Alignof] = ACTIONS(1997),
    [anon_sym_offsetof] = ACTIONS(1997),
    [anon_sym__Generic] = ACTIONS(1997),
    [anon_sym_asm] = ACTIONS(1997),
    [anon_sym___asm__] = ACTIONS(1997),
    [sym_number_literal] = ACTIONS(1995),
    [anon_sym_L_SQUOTE] = ACTIONS(1995),
    [anon_sym_u_SQUOTE] = ACTIONS(1995),
    [anon_sym_U_SQUOTE] = ACTIONS(1995),
    [anon_sym_u8_SQUOTE] = ACTIONS(1995),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_L_DQUOTE] = ACTIONS(1995),
    [anon_sym_u_DQUOTE] = ACTIONS(1995),
    [anon_sym_U_DQUOTE] = ACTIONS(1995),
    [anon_sym_u8_DQUOTE] = ACTIONS(1995),
    [anon_sym_DQUOTE] = ACTIONS(1995),
    [sym_true] = ACTIONS(1997),
    [sym_false] = ACTIONS(1997),
    [anon_sym_NULL] = ACTIONS(1997),
    [anon_sym_nullptr] = ACTIONS(1997),
    [sym_comment] = ACTIONS(3),
  },
  [563] = {
    [sym_string_literal] = STATE(824),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1017),
    [sym_identifier] = ACTIONS(1967),
    [anon_sym_COMMA] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_PERCENT] = ACTIONS(1975),
    [anon_sym_PIPE_PIPE] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1969),
    [anon_sym_PIPE] = ACTIONS(1975),
    [anon_sym_CARET] = ACTIONS(1975),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_EQ_EQ] = ACTIONS(1969),
    [anon_sym_BANG_EQ] = ACTIONS(1969),
    [anon_sym_GT] = ACTIONS(1975),
    [anon_sym_GT_EQ] = ACTIONS(1969),
    [anon_sym_LT_EQ] = ACTIONS(1969),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_LT_LT] = ACTIONS(1975),
    [anon_sym_GT_GT] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1969),
    [anon_sym___extension__] = ACTIONS(1967),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym___attribute__] = ACTIONS(1967),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1980),
    [anon_sym___declspec] = ACTIONS(1967),
    [anon_sym___based] = ACTIONS(1967),
    [anon_sym___cdecl] = ACTIONS(1967),
    [anon_sym___clrcall] = ACTIONS(1967),
    [anon_sym___stdcall] = ACTIONS(1967),
    [anon_sym___fastcall] = ACTIONS(1967),
    [anon_sym___thiscall] = ACTIONS(1967),
    [anon_sym___vectorcall] = ACTIONS(1967),
    [anon_sym_signed] = ACTIONS(1982),
    [anon_sym_unsigned] = ACTIONS(1982),
    [anon_sym_long] = ACTIONS(1982),
    [anon_sym_short] = ACTIONS(1982),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_EQ] = ACTIONS(1984),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_auto] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym___inline] = ACTIONS(1967),
    [anon_sym___inline__] = ACTIONS(1967),
    [anon_sym___forceinline] = ACTIONS(1967),
    [anon_sym_thread_local] = ACTIONS(1967),
    [anon_sym___thread] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_constexpr] = ACTIONS(1967),
    [anon_sym_volatile] = ACTIONS(1967),
    [anon_sym_restrict] = ACTIONS(1967),
    [anon_sym___restrict__] = ACTIONS(1967),
    [anon_sym__Atomic] = ACTIONS(1967),
    [anon_sym__Noreturn] = ACTIONS(1967),
    [anon_sym_noreturn] = ACTIONS(1967),
    [anon_sym_COLON] = ACTIONS(2004),
    [anon_sym_QMARK] = ACTIONS(1969),
    [anon_sym_STAR_EQ] = ACTIONS(1988),
    [anon_sym_SLASH_EQ] = ACTIONS(1988),
    [anon_sym_PERCENT_EQ] = ACTIONS(1988),
    [anon_sym_PLUS_EQ] = ACTIONS(1988),
    [anon_sym_DASH_EQ] = ACTIONS(1988),
    [anon_sym_LT_LT_EQ] = ACTIONS(1988),
    [anon_sym_GT_GT_EQ] = ACTIONS(1988),
    [anon_sym_AMP_EQ] = ACTIONS(1988),
    [anon_sym_CARET_EQ] = ACTIONS(1988),
    [anon_sym_PIPE_EQ] = ACTIONS(1988),
    [anon_sym_DASH_DASH] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1969),
    [anon_sym_DOT] = ACTIONS(1969),
    [anon_sym_DASH_GT] = ACTIONS(1969),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [564] = {
    [sym_string_literal] = STATE(824),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1017),
    [sym_identifier] = ACTIONS(1967),
    [anon_sym_COMMA] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_PERCENT] = ACTIONS(1975),
    [anon_sym_PIPE_PIPE] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1969),
    [anon_sym_PIPE] = ACTIONS(1975),
    [anon_sym_CARET] = ACTIONS(1975),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_EQ_EQ] = ACTIONS(1969),
    [anon_sym_BANG_EQ] = ACTIONS(1969),
    [anon_sym_GT] = ACTIONS(1975),
    [anon_sym_GT_EQ] = ACTIONS(1969),
    [anon_sym_LT_EQ] = ACTIONS(1969),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_LT_LT] = ACTIONS(1975),
    [anon_sym_GT_GT] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(2006),
    [anon_sym___extension__] = ACTIONS(1967),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym___attribute__] = ACTIONS(1967),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1980),
    [anon_sym___declspec] = ACTIONS(1967),
    [anon_sym___based] = ACTIONS(1967),
    [anon_sym___cdecl] = ACTIONS(1967),
    [anon_sym___clrcall] = ACTIONS(1967),
    [anon_sym___stdcall] = ACTIONS(1967),
    [anon_sym___fastcall] = ACTIONS(1967),
    [anon_sym___thiscall] = ACTIONS(1967),
    [anon_sym___vectorcall] = ACTIONS(1967),
    [anon_sym_signed] = ACTIONS(1982),
    [anon_sym_unsigned] = ACTIONS(1982),
    [anon_sym_long] = ACTIONS(1982),
    [anon_sym_short] = ACTIONS(1982),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_EQ] = ACTIONS(1984),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_auto] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym___inline] = ACTIONS(1967),
    [anon_sym___inline__] = ACTIONS(1967),
    [anon_sym___forceinline] = ACTIONS(1967),
    [anon_sym_thread_local] = ACTIONS(1967),
    [anon_sym___thread] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_constexpr] = ACTIONS(1967),
    [anon_sym_volatile] = ACTIONS(1967),
    [anon_sym_restrict] = ACTIONS(1967),
    [anon_sym___restrict__] = ACTIONS(1967),
    [anon_sym__Atomic] = ACTIONS(1967),
    [anon_sym__Noreturn] = ACTIONS(1967),
    [anon_sym_noreturn] = ACTIONS(1967),
    [anon_sym_COLON] = ACTIONS(2004),
    [anon_sym_QMARK] = ACTIONS(1969),
    [anon_sym_STAR_EQ] = ACTIONS(1988),
    [anon_sym_SLASH_EQ] = ACTIONS(1988),
    [anon_sym_PERCENT_EQ] = ACTIONS(1988),
    [anon_sym_PLUS_EQ] = ACTIONS(1988),
    [anon_sym_DASH_EQ] = ACTIONS(1988),
    [anon_sym_LT_LT_EQ] = ACTIONS(1988),
    [anon_sym_GT_GT_EQ] = ACTIONS(1988),
    [anon_sym_AMP_EQ] = ACTIONS(1988),
    [anon_sym_CARET_EQ] = ACTIONS(1988),
    [anon_sym_PIPE_EQ] = ACTIONS(1988),
    [anon_sym_DASH_DASH] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1969),
    [anon_sym_DOT] = ACTIONS(1969),
    [anon_sym_DASH_GT] = ACTIONS(1969),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [565] = {
    [sym_string_literal] = STATE(824),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1017),
    [sym_identifier] = ACTIONS(1967),
    [anon_sym_COMMA] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_PERCENT] = ACTIONS(1975),
    [anon_sym_PIPE_PIPE] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1969),
    [anon_sym_PIPE] = ACTIONS(1975),
    [anon_sym_CARET] = ACTIONS(1975),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_EQ_EQ] = ACTIONS(1969),
    [anon_sym_BANG_EQ] = ACTIONS(1969),
    [anon_sym_GT] = ACTIONS(1975),
    [anon_sym_GT_EQ] = ACTIONS(1969),
    [anon_sym_LT_EQ] = ACTIONS(1969),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_LT_LT] = ACTIONS(1975),
    [anon_sym_GT_GT] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(2006),
    [anon_sym___extension__] = ACTIONS(1967),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym___attribute__] = ACTIONS(1967),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1980),
    [anon_sym___declspec] = ACTIONS(1967),
    [anon_sym___based] = ACTIONS(1967),
    [anon_sym___cdecl] = ACTIONS(1967),
    [anon_sym___clrcall] = ACTIONS(1967),
    [anon_sym___stdcall] = ACTIONS(1967),
    [anon_sym___fastcall] = ACTIONS(1967),
    [anon_sym___thiscall] = ACTIONS(1967),
    [anon_sym___vectorcall] = ACTIONS(1967),
    [anon_sym_signed] = ACTIONS(1982),
    [anon_sym_unsigned] = ACTIONS(1982),
    [anon_sym_long] = ACTIONS(1982),
    [anon_sym_short] = ACTIONS(1982),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_EQ] = ACTIONS(1984),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_auto] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym___inline] = ACTIONS(1967),
    [anon_sym___inline__] = ACTIONS(1967),
    [anon_sym___forceinline] = ACTIONS(1967),
    [anon_sym_thread_local] = ACTIONS(1967),
    [anon_sym___thread] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_constexpr] = ACTIONS(1967),
    [anon_sym_volatile] = ACTIONS(1967),
    [anon_sym_restrict] = ACTIONS(1967),
    [anon_sym___restrict__] = ACTIONS(1967),
    [anon_sym__Atomic] = ACTIONS(1967),
    [anon_sym__Noreturn] = ACTIONS(1967),
    [anon_sym_noreturn] = ACTIONS(1967),
    [anon_sym_COLON] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(1969),
    [anon_sym_STAR_EQ] = ACTIONS(1988),
    [anon_sym_SLASH_EQ] = ACTIONS(1988),
    [anon_sym_PERCENT_EQ] = ACTIONS(1988),
    [anon_sym_PLUS_EQ] = ACTIONS(1988),
    [anon_sym_DASH_EQ] = ACTIONS(1988),
    [anon_sym_LT_LT_EQ] = ACTIONS(1988),
    [anon_sym_GT_GT_EQ] = ACTIONS(1988),
    [anon_sym_AMP_EQ] = ACTIONS(1988),
    [anon_sym_CARET_EQ] = ACTIONS(1988),
    [anon_sym_PIPE_EQ] = ACTIONS(1988),
    [anon_sym_DASH_DASH] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1969),
    [anon_sym_DOT] = ACTIONS(1969),
    [anon_sym_DASH_GT] = ACTIONS(1969),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [566] = {
    [sym_string_literal] = STATE(824),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1017),
    [sym_identifier] = ACTIONS(1967),
    [anon_sym_COMMA] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_PERCENT] = ACTIONS(1975),
    [anon_sym_PIPE_PIPE] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1969),
    [anon_sym_PIPE] = ACTIONS(1975),
    [anon_sym_CARET] = ACTIONS(1975),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_EQ_EQ] = ACTIONS(1969),
    [anon_sym_BANG_EQ] = ACTIONS(1969),
    [anon_sym_GT] = ACTIONS(1975),
    [anon_sym_GT_EQ] = ACTIONS(1969),
    [anon_sym_LT_EQ] = ACTIONS(1969),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_LT_LT] = ACTIONS(1975),
    [anon_sym_GT_GT] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1969),
    [anon_sym___extension__] = ACTIONS(1967),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym___attribute__] = ACTIONS(1967),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1980),
    [anon_sym___declspec] = ACTIONS(1967),
    [anon_sym___based] = ACTIONS(1967),
    [anon_sym___cdecl] = ACTIONS(1967),
    [anon_sym___clrcall] = ACTIONS(1967),
    [anon_sym___stdcall] = ACTIONS(1967),
    [anon_sym___fastcall] = ACTIONS(1967),
    [anon_sym___thiscall] = ACTIONS(1967),
    [anon_sym___vectorcall] = ACTIONS(1967),
    [anon_sym_signed] = ACTIONS(1982),
    [anon_sym_unsigned] = ACTIONS(1982),
    [anon_sym_long] = ACTIONS(1982),
    [anon_sym_short] = ACTIONS(1982),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_EQ] = ACTIONS(1984),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_auto] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym___inline] = ACTIONS(1967),
    [anon_sym___inline__] = ACTIONS(1967),
    [anon_sym___forceinline] = ACTIONS(1967),
    [anon_sym_thread_local] = ACTIONS(1967),
    [anon_sym___thread] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_constexpr] = ACTIONS(1967),
    [anon_sym_volatile] = ACTIONS(1967),
    [anon_sym_restrict] = ACTIONS(1967),
    [anon_sym___restrict__] = ACTIONS(1967),
    [anon_sym__Atomic] = ACTIONS(1967),
    [anon_sym__Noreturn] = ACTIONS(1967),
    [anon_sym_noreturn] = ACTIONS(1967),
    [anon_sym_COLON] = ACTIONS(2011),
    [anon_sym_QMARK] = ACTIONS(1969),
    [anon_sym_STAR_EQ] = ACTIONS(1988),
    [anon_sym_SLASH_EQ] = ACTIONS(1988),
    [anon_sym_PERCENT_EQ] = ACTIONS(1988),
    [anon_sym_PLUS_EQ] = ACTIONS(1988),
    [anon_sym_DASH_EQ] = ACTIONS(1988),
    [anon_sym_LT_LT_EQ] = ACTIONS(1988),
    [anon_sym_GT_GT_EQ] = ACTIONS(1988),
    [anon_sym_AMP_EQ] = ACTIONS(1988),
    [anon_sym_CARET_EQ] = ACTIONS(1988),
    [anon_sym_PIPE_EQ] = ACTIONS(1988),
    [anon_sym_DASH_DASH] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1969),
    [anon_sym_DOT] = ACTIONS(1969),
    [anon_sym_DASH_GT] = ACTIONS(1969),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [567] = {
    [sym_string_literal] = STATE(824),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1017),
    [sym_identifier] = ACTIONS(1967),
    [anon_sym_COMMA] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_PERCENT] = ACTIONS(1975),
    [anon_sym_PIPE_PIPE] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1969),
    [anon_sym_PIPE] = ACTIONS(1975),
    [anon_sym_CARET] = ACTIONS(1975),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_EQ_EQ] = ACTIONS(1969),
    [anon_sym_BANG_EQ] = ACTIONS(1969),
    [anon_sym_GT] = ACTIONS(1975),
    [anon_sym_GT_EQ] = ACTIONS(1969),
    [anon_sym_LT_EQ] = ACTIONS(1969),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_LT_LT] = ACTIONS(1975),
    [anon_sym_GT_GT] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(2006),
    [anon_sym___extension__] = ACTIONS(1967),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym___attribute__] = ACTIONS(1967),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1980),
    [anon_sym___declspec] = ACTIONS(1967),
    [anon_sym___based] = ACTIONS(1967),
    [anon_sym___cdecl] = ACTIONS(1967),
    [anon_sym___clrcall] = ACTIONS(1967),
    [anon_sym___stdcall] = ACTIONS(1967),
    [anon_sym___fastcall] = ACTIONS(1967),
    [anon_sym___thiscall] = ACTIONS(1967),
    [anon_sym___vectorcall] = ACTIONS(1967),
    [anon_sym_signed] = ACTIONS(1982),
    [anon_sym_unsigned] = ACTIONS(1982),
    [anon_sym_long] = ACTIONS(1982),
    [anon_sym_short] = ACTIONS(1982),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_EQ] = ACTIONS(1984),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_auto] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym___inline] = ACTIONS(1967),
    [anon_sym___inline__] = ACTIONS(1967),
    [anon_sym___forceinline] = ACTIONS(1967),
    [anon_sym_thread_local] = ACTIONS(1967),
    [anon_sym___thread] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_constexpr] = ACTIONS(1967),
    [anon_sym_volatile] = ACTIONS(1967),
    [anon_sym_restrict] = ACTIONS(1967),
    [anon_sym___restrict__] = ACTIONS(1967),
    [anon_sym__Atomic] = ACTIONS(1967),
    [anon_sym__Noreturn] = ACTIONS(1967),
    [anon_sym_noreturn] = ACTIONS(1967),
    [anon_sym_COLON] = ACTIONS(1990),
    [anon_sym_QMARK] = ACTIONS(1969),
    [anon_sym_STAR_EQ] = ACTIONS(1988),
    [anon_sym_SLASH_EQ] = ACTIONS(1988),
    [anon_sym_PERCENT_EQ] = ACTIONS(1988),
    [anon_sym_PLUS_EQ] = ACTIONS(1988),
    [anon_sym_DASH_EQ] = ACTIONS(1988),
    [anon_sym_LT_LT_EQ] = ACTIONS(1988),
    [anon_sym_GT_GT_EQ] = ACTIONS(1988),
    [anon_sym_AMP_EQ] = ACTIONS(1988),
    [anon_sym_CARET_EQ] = ACTIONS(1988),
    [anon_sym_PIPE_EQ] = ACTIONS(1988),
    [anon_sym_DASH_DASH] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1969),
    [anon_sym_DOT] = ACTIONS(1969),
    [anon_sym_DASH_GT] = ACTIONS(1969),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [568] = {
    [sym_string_literal] = STATE(824),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1017),
    [sym_identifier] = ACTIONS(1967),
    [anon_sym_COMMA] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_PERCENT] = ACTIONS(1975),
    [anon_sym_PIPE_PIPE] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1969),
    [anon_sym_PIPE] = ACTIONS(1975),
    [anon_sym_CARET] = ACTIONS(1975),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_EQ_EQ] = ACTIONS(1969),
    [anon_sym_BANG_EQ] = ACTIONS(1969),
    [anon_sym_GT] = ACTIONS(1975),
    [anon_sym_GT_EQ] = ACTIONS(1969),
    [anon_sym_LT_EQ] = ACTIONS(1969),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_LT_LT] = ACTIONS(1975),
    [anon_sym_GT_GT] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1969),
    [anon_sym___extension__] = ACTIONS(1967),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym___attribute__] = ACTIONS(1967),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1980),
    [anon_sym___declspec] = ACTIONS(1967),
    [anon_sym___based] = ACTIONS(1967),
    [anon_sym___cdecl] = ACTIONS(1967),
    [anon_sym___clrcall] = ACTIONS(1967),
    [anon_sym___stdcall] = ACTIONS(1967),
    [anon_sym___fastcall] = ACTIONS(1967),
    [anon_sym___thiscall] = ACTIONS(1967),
    [anon_sym___vectorcall] = ACTIONS(1967),
    [anon_sym_signed] = ACTIONS(1982),
    [anon_sym_unsigned] = ACTIONS(1982),
    [anon_sym_long] = ACTIONS(1982),
    [anon_sym_short] = ACTIONS(1982),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_EQ] = ACTIONS(1984),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_auto] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym___inline] = ACTIONS(1967),
    [anon_sym___inline__] = ACTIONS(1967),
    [anon_sym___forceinline] = ACTIONS(1967),
    [anon_sym_thread_local] = ACTIONS(1967),
    [anon_sym___thread] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_constexpr] = ACTIONS(1967),
    [anon_sym_volatile] = ACTIONS(1967),
    [anon_sym_restrict] = ACTIONS(1967),
    [anon_sym___restrict__] = ACTIONS(1967),
    [anon_sym__Atomic] = ACTIONS(1967),
    [anon_sym__Noreturn] = ACTIONS(1967),
    [anon_sym_noreturn] = ACTIONS(1967),
    [anon_sym_COLON] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(1969),
    [anon_sym_STAR_EQ] = ACTIONS(1988),
    [anon_sym_SLASH_EQ] = ACTIONS(1988),
    [anon_sym_PERCENT_EQ] = ACTIONS(1988),
    [anon_sym_PLUS_EQ] = ACTIONS(1988),
    [anon_sym_DASH_EQ] = ACTIONS(1988),
    [anon_sym_LT_LT_EQ] = ACTIONS(1988),
    [anon_sym_GT_GT_EQ] = ACTIONS(1988),
    [anon_sym_AMP_EQ] = ACTIONS(1988),
    [anon_sym_CARET_EQ] = ACTIONS(1988),
    [anon_sym_PIPE_EQ] = ACTIONS(1988),
    [anon_sym_DASH_DASH] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1969),
    [anon_sym_DOT] = ACTIONS(1969),
    [anon_sym_DASH_GT] = ACTIONS(1969),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [569] = {
    [sym_string_literal] = STATE(824),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1017),
    [sym_identifier] = ACTIONS(1967),
    [anon_sym_COMMA] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_PERCENT] = ACTIONS(1975),
    [anon_sym_PIPE_PIPE] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1969),
    [anon_sym_PIPE] = ACTIONS(1975),
    [anon_sym_CARET] = ACTIONS(1975),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_EQ_EQ] = ACTIONS(1969),
    [anon_sym_BANG_EQ] = ACTIONS(1969),
    [anon_sym_GT] = ACTIONS(1975),
    [anon_sym_GT_EQ] = ACTIONS(1969),
    [anon_sym_LT_EQ] = ACTIONS(1969),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_LT_LT] = ACTIONS(1975),
    [anon_sym_GT_GT] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1969),
    [anon_sym___extension__] = ACTIONS(1967),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym___attribute__] = ACTIONS(1967),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1980),
    [anon_sym___declspec] = ACTIONS(1967),
    [anon_sym___based] = ACTIONS(1967),
    [anon_sym___cdecl] = ACTIONS(1967),
    [anon_sym___clrcall] = ACTIONS(1967),
    [anon_sym___stdcall] = ACTIONS(1967),
    [anon_sym___fastcall] = ACTIONS(1967),
    [anon_sym___thiscall] = ACTIONS(1967),
    [anon_sym___vectorcall] = ACTIONS(1967),
    [anon_sym_signed] = ACTIONS(1982),
    [anon_sym_unsigned] = ACTIONS(1982),
    [anon_sym_long] = ACTIONS(1982),
    [anon_sym_short] = ACTIONS(1982),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_EQ] = ACTIONS(1984),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_auto] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym___inline] = ACTIONS(1967),
    [anon_sym___inline__] = ACTIONS(1967),
    [anon_sym___forceinline] = ACTIONS(1967),
    [anon_sym_thread_local] = ACTIONS(1967),
    [anon_sym___thread] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_constexpr] = ACTIONS(1967),
    [anon_sym_volatile] = ACTIONS(1967),
    [anon_sym_restrict] = ACTIONS(1967),
    [anon_sym___restrict__] = ACTIONS(1967),
    [anon_sym__Atomic] = ACTIONS(1967),
    [anon_sym__Noreturn] = ACTIONS(1967),
    [anon_sym_noreturn] = ACTIONS(1967),
    [anon_sym_COLON] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(1969),
    [anon_sym_STAR_EQ] = ACTIONS(1988),
    [anon_sym_SLASH_EQ] = ACTIONS(1988),
    [anon_sym_PERCENT_EQ] = ACTIONS(1988),
    [anon_sym_PLUS_EQ] = ACTIONS(1988),
    [anon_sym_DASH_EQ] = ACTIONS(1988),
    [anon_sym_LT_LT_EQ] = ACTIONS(1988),
    [anon_sym_GT_GT_EQ] = ACTIONS(1988),
    [anon_sym_AMP_EQ] = ACTIONS(1988),
    [anon_sym_CARET_EQ] = ACTIONS(1988),
    [anon_sym_PIPE_EQ] = ACTIONS(1988),
    [anon_sym_DASH_DASH] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1969),
    [anon_sym_DOT] = ACTIONS(1969),
    [anon_sym_DASH_GT] = ACTIONS(1969),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [570] = {
    [sym_string_literal] = STATE(824),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1017),
    [sym_identifier] = ACTIONS(1967),
    [anon_sym_COMMA] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_PERCENT] = ACTIONS(1975),
    [anon_sym_PIPE_PIPE] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1969),
    [anon_sym_PIPE] = ACTIONS(1975),
    [anon_sym_CARET] = ACTIONS(1975),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_EQ_EQ] = ACTIONS(1969),
    [anon_sym_BANG_EQ] = ACTIONS(1969),
    [anon_sym_GT] = ACTIONS(1975),
    [anon_sym_GT_EQ] = ACTIONS(1969),
    [anon_sym_LT_EQ] = ACTIONS(1969),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_LT_LT] = ACTIONS(1975),
    [anon_sym_GT_GT] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(2006),
    [anon_sym___extension__] = ACTIONS(1967),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym___attribute__] = ACTIONS(1967),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1980),
    [anon_sym___declspec] = ACTIONS(1967),
    [anon_sym___based] = ACTIONS(1967),
    [anon_sym___cdecl] = ACTIONS(1967),
    [anon_sym___clrcall] = ACTIONS(1967),
    [anon_sym___stdcall] = ACTIONS(1967),
    [anon_sym___fastcall] = ACTIONS(1967),
    [anon_sym___thiscall] = ACTIONS(1967),
    [anon_sym___vectorcall] = ACTIONS(1967),
    [anon_sym_signed] = ACTIONS(1982),
    [anon_sym_unsigned] = ACTIONS(1982),
    [anon_sym_long] = ACTIONS(1982),
    [anon_sym_short] = ACTIONS(1982),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_EQ] = ACTIONS(1984),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_auto] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym___inline] = ACTIONS(1967),
    [anon_sym___inline__] = ACTIONS(1967),
    [anon_sym___forceinline] = ACTIONS(1967),
    [anon_sym_thread_local] = ACTIONS(1967),
    [anon_sym___thread] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_constexpr] = ACTIONS(1967),
    [anon_sym_volatile] = ACTIONS(1967),
    [anon_sym_restrict] = ACTIONS(1967),
    [anon_sym___restrict__] = ACTIONS(1967),
    [anon_sym__Atomic] = ACTIONS(1967),
    [anon_sym__Noreturn] = ACTIONS(1967),
    [anon_sym_noreturn] = ACTIONS(1967),
    [anon_sym_COLON] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(1969),
    [anon_sym_STAR_EQ] = ACTIONS(1988),
    [anon_sym_SLASH_EQ] = ACTIONS(1988),
    [anon_sym_PERCENT_EQ] = ACTIONS(1988),
    [anon_sym_PLUS_EQ] = ACTIONS(1988),
    [anon_sym_DASH_EQ] = ACTIONS(1988),
    [anon_sym_LT_LT_EQ] = ACTIONS(1988),
    [anon_sym_GT_GT_EQ] = ACTIONS(1988),
    [anon_sym_AMP_EQ] = ACTIONS(1988),
    [anon_sym_CARET_EQ] = ACTIONS(1988),
    [anon_sym_PIPE_EQ] = ACTIONS(1988),
    [anon_sym_DASH_DASH] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1969),
    [anon_sym_DOT] = ACTIONS(1969),
    [anon_sym_DASH_GT] = ACTIONS(1969),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [571] = {
    [sym_string_literal] = STATE(824),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1017),
    [sym_identifier] = ACTIONS(1967),
    [anon_sym_COMMA] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_PERCENT] = ACTIONS(1975),
    [anon_sym_PIPE_PIPE] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1969),
    [anon_sym_PIPE] = ACTIONS(1975),
    [anon_sym_CARET] = ACTIONS(1975),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_EQ_EQ] = ACTIONS(1969),
    [anon_sym_BANG_EQ] = ACTIONS(1969),
    [anon_sym_GT] = ACTIONS(1975),
    [anon_sym_GT_EQ] = ACTIONS(1969),
    [anon_sym_LT_EQ] = ACTIONS(1969),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_LT_LT] = ACTIONS(1975),
    [anon_sym_GT_GT] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1969),
    [anon_sym___extension__] = ACTIONS(1967),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym___attribute__] = ACTIONS(1967),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1980),
    [anon_sym___declspec] = ACTIONS(1967),
    [anon_sym___based] = ACTIONS(1967),
    [anon_sym___cdecl] = ACTIONS(1967),
    [anon_sym___clrcall] = ACTIONS(1967),
    [anon_sym___stdcall] = ACTIONS(1967),
    [anon_sym___fastcall] = ACTIONS(1967),
    [anon_sym___thiscall] = ACTIONS(1967),
    [anon_sym___vectorcall] = ACTIONS(1967),
    [anon_sym_signed] = ACTIONS(1982),
    [anon_sym_unsigned] = ACTIONS(1982),
    [anon_sym_long] = ACTIONS(1982),
    [anon_sym_short] = ACTIONS(1982),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_EQ] = ACTIONS(1984),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_auto] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym___inline] = ACTIONS(1967),
    [anon_sym___inline__] = ACTIONS(1967),
    [anon_sym___forceinline] = ACTIONS(1967),
    [anon_sym_thread_local] = ACTIONS(1967),
    [anon_sym___thread] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_constexpr] = ACTIONS(1967),
    [anon_sym_volatile] = ACTIONS(1967),
    [anon_sym_restrict] = ACTIONS(1967),
    [anon_sym___restrict__] = ACTIONS(1967),
    [anon_sym__Atomic] = ACTIONS(1967),
    [anon_sym__Noreturn] = ACTIONS(1967),
    [anon_sym_noreturn] = ACTIONS(1967),
    [anon_sym_QMARK] = ACTIONS(1969),
    [anon_sym_STAR_EQ] = ACTIONS(1988),
    [anon_sym_SLASH_EQ] = ACTIONS(1988),
    [anon_sym_PERCENT_EQ] = ACTIONS(1988),
    [anon_sym_PLUS_EQ] = ACTIONS(1988),
    [anon_sym_DASH_EQ] = ACTIONS(1988),
    [anon_sym_LT_LT_EQ] = ACTIONS(1988),
    [anon_sym_GT_GT_EQ] = ACTIONS(1988),
    [anon_sym_AMP_EQ] = ACTIONS(1988),
    [anon_sym_CARET_EQ] = ACTIONS(1988),
    [anon_sym_PIPE_EQ] = ACTIONS(1988),
    [anon_sym_DASH_DASH] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1969),
    [anon_sym_DOT] = ACTIONS(1969),
    [anon_sym_DASH_GT] = ACTIONS(1969),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [572] = {
    [sym_string_literal] = STATE(824),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1017),
    [sym_identifier] = ACTIONS(1967),
    [anon_sym_LPAREN2] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_PERCENT] = ACTIONS(1975),
    [anon_sym_PIPE_PIPE] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1969),
    [anon_sym_PIPE] = ACTIONS(1975),
    [anon_sym_CARET] = ACTIONS(1975),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_EQ_EQ] = ACTIONS(1969),
    [anon_sym_BANG_EQ] = ACTIONS(1969),
    [anon_sym_GT] = ACTIONS(1975),
    [anon_sym_GT_EQ] = ACTIONS(1969),
    [anon_sym_LT_EQ] = ACTIONS(1969),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_LT_LT] = ACTIONS(1975),
    [anon_sym_GT_GT] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(2006),
    [anon_sym___extension__] = ACTIONS(1967),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym___attribute__] = ACTIONS(1967),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1980),
    [anon_sym___declspec] = ACTIONS(1967),
    [anon_sym___based] = ACTIONS(1967),
    [anon_sym___cdecl] = ACTIONS(1967),
    [anon_sym___clrcall] = ACTIONS(1967),
    [anon_sym___stdcall] = ACTIONS(1967),
    [anon_sym___fastcall] = ACTIONS(1967),
    [anon_sym___thiscall] = ACTIONS(1967),
    [anon_sym___vectorcall] = ACTIONS(1967),
    [anon_sym_signed] = ACTIONS(1982),
    [anon_sym_unsigned] = ACTIONS(1982),
    [anon_sym_long] = ACTIONS(1982),
    [anon_sym_short] = ACTIONS(1982),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_EQ] = ACTIONS(1984),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_auto] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym___inline] = ACTIONS(1967),
    [anon_sym___inline__] = ACTIONS(1967),
    [anon_sym___forceinline] = ACTIONS(1967),
    [anon_sym_thread_local] = ACTIONS(1967),
    [anon_sym___thread] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_constexpr] = ACTIONS(1967),
    [anon_sym_volatile] = ACTIONS(1967),
    [anon_sym_restrict] = ACTIONS(1967),
    [anon_sym___restrict__] = ACTIONS(1967),
    [anon_sym__Atomic] = ACTIONS(1967),
    [anon_sym__Noreturn] = ACTIONS(1967),
    [anon_sym_noreturn] = ACTIONS(1967),
    [anon_sym_COLON] = ACTIONS(2011),
    [anon_sym_QMARK] = ACTIONS(1969),
    [anon_sym_STAR_EQ] = ACTIONS(1988),
    [anon_sym_SLASH_EQ] = ACTIONS(1988),
    [anon_sym_PERCENT_EQ] = ACTIONS(1988),
    [anon_sym_PLUS_EQ] = ACTIONS(1988),
    [anon_sym_DASH_EQ] = ACTIONS(1988),
    [anon_sym_LT_LT_EQ] = ACTIONS(1988),
    [anon_sym_GT_GT_EQ] = ACTIONS(1988),
    [anon_sym_AMP_EQ] = ACTIONS(1988),
    [anon_sym_CARET_EQ] = ACTIONS(1988),
    [anon_sym_PIPE_EQ] = ACTIONS(1988),
    [anon_sym_DASH_DASH] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1969),
    [anon_sym_DOT] = ACTIONS(1969),
    [anon_sym_DASH_GT] = ACTIONS(1969),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
  },
  [573] = {
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1443),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_based_modifier] = STATE(2409),
    [sym_ms_call_modifier] = STATE(1552),
    [sym__declarator] = STATE(1714),
    [sym__abstract_declarator] = STATE(1852),
    [sym_parenthesized_declarator] = STATE(1647),
    [sym_abstract_parenthesized_declarator] = STATE(1786),
    [sym_attributed_declarator] = STATE(1647),
    [sym_pointer_declarator] = STATE(1647),
    [sym_abstract_pointer_declarator] = STATE(1786),
    [sym_function_declarator] = STATE(1647),
    [sym_abstract_function_declarator] = STATE(1786),
    [sym_array_declarator] = STATE(1647),
    [sym_abstract_array_declarator] = STATE(1786),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_variadic_parameter] = STATE(2016),
    [sym_parameter_list] = STATE(1788),
    [sym_parameter_declaration] = STATE(2016),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2017),
    [anon_sym_RPAREN] = ACTIONS(2019),
    [anon_sym_LPAREN2] = ACTIONS(2021),
    [anon_sym_STAR] = ACTIONS(2023),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___based] = ACTIONS(2025),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2027),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [574] = {
    [sym_type_qualifier] = STATE(908),
    [sym__expression] = STATE(1384),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1138),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1138),
    [sym_call_expression] = STATE(1138),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1138),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1138),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym__type_definition_type_repeat1] = STATE(908),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(2029),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [anon_sym_DASH] = ACTIONS(1959),
    [anon_sym_PLUS] = ACTIONS(1959),
    [anon_sym_STAR] = ACTIONS(2031),
    [anon_sym_AMP] = ACTIONS(2033),
    [anon_sym___extension__] = ACTIONS(2035),
    [anon_sym_RBRACK] = ACTIONS(2037),
    [anon_sym_const] = ACTIONS(2035),
    [anon_sym_constexpr] = ACTIONS(2035),
    [anon_sym_volatile] = ACTIONS(2035),
    [anon_sym_restrict] = ACTIONS(2035),
    [anon_sym___restrict__] = ACTIONS(2035),
    [anon_sym__Atomic] = ACTIONS(2035),
    [anon_sym__Noreturn] = ACTIONS(2035),
    [anon_sym_noreturn] = ACTIONS(2035),
    [anon_sym_DASH_DASH] = ACTIONS(2039),
    [anon_sym_PLUS_PLUS] = ACTIONS(2039),
    [anon_sym_sizeof] = ACTIONS(1963),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [575] = {
    [sym_type_qualifier] = STATE(579),
    [sym__expression] = STATE(1356),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1138),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1138),
    [sym_call_expression] = STATE(1138),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1138),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1138),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym__type_definition_type_repeat1] = STATE(579),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(2029),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [anon_sym_DASH] = ACTIONS(1959),
    [anon_sym_PLUS] = ACTIONS(1959),
    [anon_sym_STAR] = ACTIONS(2041),
    [anon_sym_AMP] = ACTIONS(2033),
    [anon_sym___extension__] = ACTIONS(2035),
    [anon_sym_RBRACK] = ACTIONS(2043),
    [anon_sym_const] = ACTIONS(2035),
    [anon_sym_constexpr] = ACTIONS(2035),
    [anon_sym_volatile] = ACTIONS(2035),
    [anon_sym_restrict] = ACTIONS(2035),
    [anon_sym___restrict__] = ACTIONS(2035),
    [anon_sym__Atomic] = ACTIONS(2035),
    [anon_sym__Noreturn] = ACTIONS(2035),
    [anon_sym_noreturn] = ACTIONS(2035),
    [anon_sym_DASH_DASH] = ACTIONS(2039),
    [anon_sym_PLUS_PLUS] = ACTIONS(2039),
    [anon_sym_sizeof] = ACTIONS(1963),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [576] = {
    [sym_type_qualifier] = STATE(580),
    [sym__expression] = STATE(1360),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1138),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1138),
    [sym_call_expression] = STATE(1138),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1138),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1138),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym__type_definition_type_repeat1] = STATE(580),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(2029),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [anon_sym_DASH] = ACTIONS(1959),
    [anon_sym_PLUS] = ACTIONS(1959),
    [anon_sym_STAR] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2033),
    [anon_sym___extension__] = ACTIONS(2035),
    [anon_sym_RBRACK] = ACTIONS(2047),
    [anon_sym_const] = ACTIONS(2035),
    [anon_sym_constexpr] = ACTIONS(2035),
    [anon_sym_volatile] = ACTIONS(2035),
    [anon_sym_restrict] = ACTIONS(2035),
    [anon_sym___restrict__] = ACTIONS(2035),
    [anon_sym__Atomic] = ACTIONS(2035),
    [anon_sym__Noreturn] = ACTIONS(2035),
    [anon_sym_noreturn] = ACTIONS(2035),
    [anon_sym_DASH_DASH] = ACTIONS(2039),
    [anon_sym_PLUS_PLUS] = ACTIONS(2039),
    [anon_sym_sizeof] = ACTIONS(1963),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [577] = {
    [sym_type_qualifier] = STATE(574),
    [sym__expression] = STATE(1359),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1138),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1138),
    [sym_call_expression] = STATE(1138),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1138),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1138),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym__type_definition_type_repeat1] = STATE(574),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(2029),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [anon_sym_DASH] = ACTIONS(1959),
    [anon_sym_PLUS] = ACTIONS(1959),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2033),
    [anon_sym___extension__] = ACTIONS(2035),
    [anon_sym_RBRACK] = ACTIONS(2051),
    [anon_sym_const] = ACTIONS(2035),
    [anon_sym_constexpr] = ACTIONS(2035),
    [anon_sym_volatile] = ACTIONS(2035),
    [anon_sym_restrict] = ACTIONS(2035),
    [anon_sym___restrict__] = ACTIONS(2035),
    [anon_sym__Atomic] = ACTIONS(2035),
    [anon_sym__Noreturn] = ACTIONS(2035),
    [anon_sym_noreturn] = ACTIONS(2035),
    [anon_sym_DASH_DASH] = ACTIONS(2039),
    [anon_sym_PLUS_PLUS] = ACTIONS(2039),
    [anon_sym_sizeof] = ACTIONS(1963),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [578] = {
    [sym_type_qualifier] = STATE(908),
    [sym__expression] = STATE(1381),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1138),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1138),
    [sym_call_expression] = STATE(1138),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1138),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1138),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym__type_definition_type_repeat1] = STATE(908),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(2029),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [anon_sym_DASH] = ACTIONS(1959),
    [anon_sym_PLUS] = ACTIONS(1959),
    [anon_sym_STAR] = ACTIONS(2053),
    [anon_sym_AMP] = ACTIONS(2033),
    [anon_sym___extension__] = ACTIONS(2035),
    [anon_sym_RBRACK] = ACTIONS(2055),
    [anon_sym_const] = ACTIONS(2035),
    [anon_sym_constexpr] = ACTIONS(2035),
    [anon_sym_volatile] = ACTIONS(2035),
    [anon_sym_restrict] = ACTIONS(2035),
    [anon_sym___restrict__] = ACTIONS(2035),
    [anon_sym__Atomic] = ACTIONS(2035),
    [anon_sym__Noreturn] = ACTIONS(2035),
    [anon_sym_noreturn] = ACTIONS(2035),
    [anon_sym_DASH_DASH] = ACTIONS(2039),
    [anon_sym_PLUS_PLUS] = ACTIONS(2039),
    [anon_sym_sizeof] = ACTIONS(1963),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [579] = {
    [sym_type_qualifier] = STATE(908),
    [sym__expression] = STATE(1363),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1138),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1138),
    [sym_call_expression] = STATE(1138),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1138),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1138),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym__type_definition_type_repeat1] = STATE(908),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(2029),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [anon_sym_DASH] = ACTIONS(1959),
    [anon_sym_PLUS] = ACTIONS(1959),
    [anon_sym_STAR] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2033),
    [anon_sym___extension__] = ACTIONS(2035),
    [anon_sym_RBRACK] = ACTIONS(2059),
    [anon_sym_const] = ACTIONS(2035),
    [anon_sym_constexpr] = ACTIONS(2035),
    [anon_sym_volatile] = ACTIONS(2035),
    [anon_sym_restrict] = ACTIONS(2035),
    [anon_sym___restrict__] = ACTIONS(2035),
    [anon_sym__Atomic] = ACTIONS(2035),
    [anon_sym__Noreturn] = ACTIONS(2035),
    [anon_sym_noreturn] = ACTIONS(2035),
    [anon_sym_DASH_DASH] = ACTIONS(2039),
    [anon_sym_PLUS_PLUS] = ACTIONS(2039),
    [anon_sym_sizeof] = ACTIONS(1963),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [580] = {
    [sym_type_qualifier] = STATE(908),
    [sym__expression] = STATE(1378),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1138),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1138),
    [sym_call_expression] = STATE(1138),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1138),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1138),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym__type_definition_type_repeat1] = STATE(908),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(2029),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [anon_sym_DASH] = ACTIONS(1959),
    [anon_sym_PLUS] = ACTIONS(1959),
    [anon_sym_STAR] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2033),
    [anon_sym___extension__] = ACTIONS(2035),
    [anon_sym_RBRACK] = ACTIONS(2063),
    [anon_sym_const] = ACTIONS(2035),
    [anon_sym_constexpr] = ACTIONS(2035),
    [anon_sym_volatile] = ACTIONS(2035),
    [anon_sym_restrict] = ACTIONS(2035),
    [anon_sym___restrict__] = ACTIONS(2035),
    [anon_sym__Atomic] = ACTIONS(2035),
    [anon_sym__Noreturn] = ACTIONS(2035),
    [anon_sym_noreturn] = ACTIONS(2035),
    [anon_sym_DASH_DASH] = ACTIONS(2039),
    [anon_sym_PLUS_PLUS] = ACTIONS(2039),
    [anon_sym_sizeof] = ACTIONS(1963),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [581] = {
    [sym_type_qualifier] = STATE(908),
    [sym__expression] = STATE(1354),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1138),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1138),
    [sym_call_expression] = STATE(1138),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1138),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1138),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym__type_definition_type_repeat1] = STATE(908),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(2029),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [anon_sym_DASH] = ACTIONS(1959),
    [anon_sym_PLUS] = ACTIONS(1959),
    [anon_sym_STAR] = ACTIONS(2065),
    [anon_sym_AMP] = ACTIONS(2033),
    [anon_sym___extension__] = ACTIONS(2035),
    [anon_sym_RBRACK] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2035),
    [anon_sym_constexpr] = ACTIONS(2035),
    [anon_sym_volatile] = ACTIONS(2035),
    [anon_sym_restrict] = ACTIONS(2035),
    [anon_sym___restrict__] = ACTIONS(2035),
    [anon_sym__Atomic] = ACTIONS(2035),
    [anon_sym__Noreturn] = ACTIONS(2035),
    [anon_sym_noreturn] = ACTIONS(2035),
    [anon_sym_DASH_DASH] = ACTIONS(2039),
    [anon_sym_PLUS_PLUS] = ACTIONS(2039),
    [anon_sym_sizeof] = ACTIONS(1963),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [582] = {
    [sym_type_qualifier] = STATE(578),
    [sym__expression] = STATE(1376),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1138),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1138),
    [sym_call_expression] = STATE(1138),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1138),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1138),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym__type_definition_type_repeat1] = STATE(578),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(2029),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [anon_sym_DASH] = ACTIONS(1959),
    [anon_sym_PLUS] = ACTIONS(1959),
    [anon_sym_STAR] = ACTIONS(2069),
    [anon_sym_AMP] = ACTIONS(2033),
    [anon_sym___extension__] = ACTIONS(2035),
    [anon_sym_RBRACK] = ACTIONS(2071),
    [anon_sym_const] = ACTIONS(2035),
    [anon_sym_constexpr] = ACTIONS(2035),
    [anon_sym_volatile] = ACTIONS(2035),
    [anon_sym_restrict] = ACTIONS(2035),
    [anon_sym___restrict__] = ACTIONS(2035),
    [anon_sym__Atomic] = ACTIONS(2035),
    [anon_sym__Noreturn] = ACTIONS(2035),
    [anon_sym_noreturn] = ACTIONS(2035),
    [anon_sym_DASH_DASH] = ACTIONS(2039),
    [anon_sym_PLUS_PLUS] = ACTIONS(2039),
    [anon_sym_sizeof] = ACTIONS(1963),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [583] = {
    [sym_type_qualifier] = STATE(581),
    [sym__expression] = STATE(1366),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1138),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1138),
    [sym_call_expression] = STATE(1138),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1138),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1138),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym__type_definition_type_repeat1] = STATE(581),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(2029),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [anon_sym_DASH] = ACTIONS(1959),
    [anon_sym_PLUS] = ACTIONS(1959),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2033),
    [anon_sym___extension__] = ACTIONS(2035),
    [anon_sym_RBRACK] = ACTIONS(2075),
    [anon_sym_const] = ACTIONS(2035),
    [anon_sym_constexpr] = ACTIONS(2035),
    [anon_sym_volatile] = ACTIONS(2035),
    [anon_sym_restrict] = ACTIONS(2035),
    [anon_sym___restrict__] = ACTIONS(2035),
    [anon_sym__Atomic] = ACTIONS(2035),
    [anon_sym__Noreturn] = ACTIONS(2035),
    [anon_sym_noreturn] = ACTIONS(2035),
    [anon_sym_DASH_DASH] = ACTIONS(2039),
    [anon_sym_PLUS_PLUS] = ACTIONS(2039),
    [anon_sym_sizeof] = ACTIONS(1963),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [584] = {
    [sym__expression] = STATE(1277),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_initializer_list] = STATE(2001),
    [sym_initializer_pair] = STATE(2001),
    [sym_subscript_designator] = STATE(1734),
    [sym_subscript_range_designator] = STATE(1734),
    [sym_field_designator] = STATE(1734),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_initializer_pair_repeat1] = STATE(1734),
    [sym_identifier] = ACTIONS(2077),
    [anon_sym_COMMA] = ACTIONS(2079),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(2085),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [585] = {
    [sym__expression] = STATE(1279),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_initializer_list] = STATE(1897),
    [sym_initializer_pair] = STATE(1897),
    [sym_subscript_designator] = STATE(1734),
    [sym_subscript_range_designator] = STATE(1734),
    [sym_field_designator] = STATE(1734),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_initializer_pair_repeat1] = STATE(1734),
    [sym_identifier] = ACTIONS(2077),
    [anon_sym_COMMA] = ACTIONS(2087),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(2085),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [586] = {
    [sym__expression] = STATE(1316),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_initializer_list] = STATE(2086),
    [sym_initializer_pair] = STATE(2086),
    [sym_subscript_designator] = STATE(1734),
    [sym_subscript_range_designator] = STATE(1734),
    [sym_field_designator] = STATE(1734),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_initializer_pair_repeat1] = STATE(1734),
    [sym_identifier] = ACTIONS(2077),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(2091),
    [anon_sym_LBRACK] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(2085),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [587] = {
    [sym__expression] = STATE(1316),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_initializer_list] = STATE(2086),
    [sym_initializer_pair] = STATE(2086),
    [sym_subscript_designator] = STATE(1734),
    [sym_subscript_range_designator] = STATE(1734),
    [sym_field_designator] = STATE(1734),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_initializer_pair_repeat1] = STATE(1734),
    [sym_identifier] = ACTIONS(2077),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(2093),
    [anon_sym_LBRACK] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(2085),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [588] = {
    [sym__expression] = STATE(1316),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_initializer_list] = STATE(2086),
    [sym_initializer_pair] = STATE(2086),
    [sym_subscript_designator] = STATE(1734),
    [sym_subscript_range_designator] = STATE(1734),
    [sym_field_designator] = STATE(1734),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_initializer_pair_repeat1] = STATE(1734),
    [sym_identifier] = ACTIONS(2077),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(2095),
    [anon_sym_LBRACK] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(2085),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [589] = {
    [sym__expression] = STATE(1316),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_initializer_list] = STATE(2086),
    [sym_initializer_pair] = STATE(2086),
    [sym_subscript_designator] = STATE(1734),
    [sym_subscript_range_designator] = STATE(1734),
    [sym_field_designator] = STATE(1734),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_initializer_pair_repeat1] = STATE(1734),
    [sym_identifier] = ACTIONS(2077),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(2097),
    [anon_sym_LBRACK] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(2085),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [590] = {
    [sym__expression] = STATE(1316),
    [sym__expression_not_binary] = STATE(884),
    [sym__string] = STATE(884),
    [sym_conditional_expression] = STATE(884),
    [sym_assignment_expression] = STATE(884),
    [sym_pointer_expression] = STATE(1003),
    [sym_unary_expression] = STATE(884),
    [sym_binary_expression] = STATE(884),
    [sym_update_expression] = STATE(884),
    [sym_cast_expression] = STATE(884),
    [sym_sizeof_expression] = STATE(884),
    [sym_alignof_expression] = STATE(884),
    [sym_offsetof_expression] = STATE(884),
    [sym_generic_expression] = STATE(884),
    [sym_subscript_expression] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_gnu_asm_expression] = STATE(884),
    [sym_field_expression] = STATE(1003),
    [sym_compound_literal_expression] = STATE(884),
    [sym_parenthesized_expression] = STATE(1003),
    [sym_initializer_list] = STATE(2086),
    [sym_initializer_pair] = STATE(2086),
    [sym_subscript_designator] = STATE(1734),
    [sym_subscript_range_designator] = STATE(1734),
    [sym_field_designator] = STATE(1734),
    [sym_char_literal] = STATE(884),
    [sym_concatenated_string] = STATE(884),
    [sym_string_literal] = STATE(845),
    [sym_null] = STATE(884),
    [aux_sym_initializer_pair_repeat1] = STATE(1734),
    [sym_identifier] = ACTIONS(2077),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(79),
    [anon_sym_PLUS_PLUS] = ACTIONS(79),
    [anon_sym_sizeof] = ACTIONS(81),
    [anon_sym___alignof__] = ACTIONS(83),
    [anon_sym___alignof] = ACTIONS(83),
    [anon_sym__alignof] = ACTIONS(83),
    [anon_sym_alignof] = ACTIONS(83),
    [anon_sym__Alignof] = ACTIONS(83),
    [anon_sym_offsetof] = ACTIONS(85),
    [anon_sym__Generic] = ACTIONS(87),
    [anon_sym_asm] = ACTIONS(89),
    [anon_sym___asm__] = ACTIONS(89),
    [anon_sym_DOT] = ACTIONS(2085),
    [sym_number_literal] = ACTIONS(157),
    [anon_sym_L_SQUOTE] = ACTIONS(93),
    [anon_sym_u_SQUOTE] = ACTIONS(93),
    [anon_sym_U_SQUOTE] = ACTIONS(93),
    [anon_sym_u8_SQUOTE] = ACTIONS(93),
    [anon_sym_SQUOTE] = ACTIONS(93),
    [anon_sym_L_DQUOTE] = ACTIONS(95),
    [anon_sym_u_DQUOTE] = ACTIONS(95),
    [anon_sym_U_DQUOTE] = ACTIONS(95),
    [anon_sym_u8_DQUOTE] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(95),
    [sym_true] = ACTIONS(159),
    [sym_false] = ACTIONS(159),
    [anon_sym_NULL] = ACTIONS(99),
    [anon_sym_nullptr] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [591] = {
    [sym_preproc_def] = STATE(597),
    [sym_preproc_function_def] = STATE(597),
    [sym_preproc_call] = STATE(597),
    [sym_preproc_if_in_field_declaration_list] = STATE(597),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(597),
    [sym_preproc_else_in_field_declaration_list] = STATE(2256),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2256),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2256),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1577),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__field_declaration_list_item] = STATE(597),
    [sym_field_declaration] = STATE(597),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(597),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2099),
    [aux_sym_preproc_def_token1] = ACTIONS(2101),
    [aux_sym_preproc_if_token1] = ACTIONS(2103),
    [aux_sym_preproc_if_token2] = ACTIONS(2105),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2107),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2107),
    [aux_sym_preproc_else_token1] = ACTIONS(2109),
    [aux_sym_preproc_elif_token1] = ACTIONS(2111),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2113),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2113),
    [sym_preproc_directive] = ACTIONS(2115),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [592] = {
    [sym_preproc_def] = STATE(601),
    [sym_preproc_function_def] = STATE(601),
    [sym_preproc_call] = STATE(601),
    [sym_preproc_if_in_field_declaration_list] = STATE(601),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(601),
    [sym_preproc_else_in_field_declaration_list] = STATE(2341),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2341),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2341),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1577),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__field_declaration_list_item] = STATE(601),
    [sym_field_declaration] = STATE(601),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(601),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2099),
    [aux_sym_preproc_def_token1] = ACTIONS(2101),
    [aux_sym_preproc_if_token1] = ACTIONS(2103),
    [aux_sym_preproc_if_token2] = ACTIONS(2117),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2107),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2107),
    [aux_sym_preproc_else_token1] = ACTIONS(2109),
    [aux_sym_preproc_elif_token1] = ACTIONS(2111),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2113),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2113),
    [sym_preproc_directive] = ACTIONS(2115),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [593] = {
    [sym_preproc_def] = STATE(594),
    [sym_preproc_function_def] = STATE(594),
    [sym_preproc_call] = STATE(594),
    [sym_preproc_if_in_field_declaration_list] = STATE(594),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(594),
    [sym_preproc_else_in_field_declaration_list] = STATE(2184),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2184),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2184),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1577),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__field_declaration_list_item] = STATE(594),
    [sym_field_declaration] = STATE(594),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(594),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2099),
    [aux_sym_preproc_def_token1] = ACTIONS(2101),
    [aux_sym_preproc_if_token1] = ACTIONS(2103),
    [aux_sym_preproc_if_token2] = ACTIONS(2119),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2107),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2107),
    [aux_sym_preproc_else_token1] = ACTIONS(2109),
    [aux_sym_preproc_elif_token1] = ACTIONS(2111),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2113),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2113),
    [sym_preproc_directive] = ACTIONS(2115),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [594] = {
    [sym_preproc_def] = STATE(601),
    [sym_preproc_function_def] = STATE(601),
    [sym_preproc_call] = STATE(601),
    [sym_preproc_if_in_field_declaration_list] = STATE(601),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(601),
    [sym_preproc_else_in_field_declaration_list] = STATE(2187),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2187),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2187),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1577),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__field_declaration_list_item] = STATE(601),
    [sym_field_declaration] = STATE(601),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(601),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2099),
    [aux_sym_preproc_def_token1] = ACTIONS(2101),
    [aux_sym_preproc_if_token1] = ACTIONS(2103),
    [aux_sym_preproc_if_token2] = ACTIONS(2121),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2107),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2107),
    [aux_sym_preproc_else_token1] = ACTIONS(2109),
    [aux_sym_preproc_elif_token1] = ACTIONS(2111),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2113),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2113),
    [sym_preproc_directive] = ACTIONS(2115),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [595] = {
    [sym_preproc_def] = STATE(596),
    [sym_preproc_function_def] = STATE(596),
    [sym_preproc_call] = STATE(596),
    [sym_preproc_if_in_field_declaration_list] = STATE(596),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(596),
    [sym_preproc_else_in_field_declaration_list] = STATE(2218),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2218),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2218),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1577),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__field_declaration_list_item] = STATE(596),
    [sym_field_declaration] = STATE(596),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(596),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2099),
    [aux_sym_preproc_def_token1] = ACTIONS(2101),
    [aux_sym_preproc_if_token1] = ACTIONS(2103),
    [aux_sym_preproc_if_token2] = ACTIONS(2123),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2107),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2107),
    [aux_sym_preproc_else_token1] = ACTIONS(2109),
    [aux_sym_preproc_elif_token1] = ACTIONS(2111),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2113),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2113),
    [sym_preproc_directive] = ACTIONS(2115),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [596] = {
    [sym_preproc_def] = STATE(601),
    [sym_preproc_function_def] = STATE(601),
    [sym_preproc_call] = STATE(601),
    [sym_preproc_if_in_field_declaration_list] = STATE(601),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(601),
    [sym_preproc_else_in_field_declaration_list] = STATE(2351),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2351),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2351),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1577),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__field_declaration_list_item] = STATE(601),
    [sym_field_declaration] = STATE(601),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(601),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2099),
    [aux_sym_preproc_def_token1] = ACTIONS(2101),
    [aux_sym_preproc_if_token1] = ACTIONS(2103),
    [aux_sym_preproc_if_token2] = ACTIONS(2125),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2107),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2107),
    [aux_sym_preproc_else_token1] = ACTIONS(2109),
    [aux_sym_preproc_elif_token1] = ACTIONS(2111),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2113),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2113),
    [sym_preproc_directive] = ACTIONS(2115),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [597] = {
    [sym_preproc_def] = STATE(601),
    [sym_preproc_function_def] = STATE(601),
    [sym_preproc_call] = STATE(601),
    [sym_preproc_if_in_field_declaration_list] = STATE(601),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(601),
    [sym_preproc_else_in_field_declaration_list] = STATE(2248),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2248),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2248),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1577),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__field_declaration_list_item] = STATE(601),
    [sym_field_declaration] = STATE(601),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(601),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2099),
    [aux_sym_preproc_def_token1] = ACTIONS(2101),
    [aux_sym_preproc_if_token1] = ACTIONS(2103),
    [aux_sym_preproc_if_token2] = ACTIONS(2127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2107),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2107),
    [aux_sym_preproc_else_token1] = ACTIONS(2109),
    [aux_sym_preproc_elif_token1] = ACTIONS(2111),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2113),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2113),
    [sym_preproc_directive] = ACTIONS(2115),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [598] = {
    [sym_preproc_def] = STATE(592),
    [sym_preproc_function_def] = STATE(592),
    [sym_preproc_call] = STATE(592),
    [sym_preproc_if_in_field_declaration_list] = STATE(592),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(592),
    [sym_preproc_else_in_field_declaration_list] = STATE(2356),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2356),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2356),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1577),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__field_declaration_list_item] = STATE(592),
    [sym_field_declaration] = STATE(592),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(592),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2099),
    [aux_sym_preproc_def_token1] = ACTIONS(2101),
    [aux_sym_preproc_if_token1] = ACTIONS(2103),
    [aux_sym_preproc_if_token2] = ACTIONS(2129),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2107),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2107),
    [aux_sym_preproc_else_token1] = ACTIONS(2109),
    [aux_sym_preproc_elif_token1] = ACTIONS(2111),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2113),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2113),
    [sym_preproc_directive] = ACTIONS(2115),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [599] = {
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1443),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_ms_call_modifier] = STATE(1656),
    [sym__abstract_declarator] = STATE(1852),
    [sym_abstract_parenthesized_declarator] = STATE(1786),
    [sym_abstract_pointer_declarator] = STATE(1786),
    [sym_abstract_function_declarator] = STATE(1786),
    [sym_abstract_array_declarator] = STATE(1786),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym_variadic_parameter] = STATE(2016),
    [sym_parameter_list] = STATE(1788),
    [sym_parameter_declaration] = STATE(2016),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2017),
    [anon_sym_RPAREN] = ACTIONS(2019),
    [anon_sym_LPAREN2] = ACTIONS(2131),
    [anon_sym_STAR] = ACTIONS(2133),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym___cdecl] = ACTIONS(39),
    [anon_sym___clrcall] = ACTIONS(39),
    [anon_sym___stdcall] = ACTIONS(39),
    [anon_sym___fastcall] = ACTIONS(39),
    [anon_sym___thiscall] = ACTIONS(39),
    [anon_sym___vectorcall] = ACTIONS(39),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2027),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [600] = {
    [sym_preproc_def] = STATE(611),
    [sym_preproc_function_def] = STATE(611),
    [sym_preproc_call] = STATE(611),
    [sym_preproc_if_in_field_declaration_list] = STATE(611),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(611),
    [sym_preproc_else_in_field_declaration_list] = STATE(2201),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2201),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1572),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__field_declaration_list_item] = STATE(611),
    [sym_field_declaration] = STATE(611),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(611),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2099),
    [aux_sym_preproc_def_token1] = ACTIONS(2135),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_if_token2] = ACTIONS(2139),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2141),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2141),
    [aux_sym_preproc_else_token1] = ACTIONS(2109),
    [aux_sym_preproc_elif_token1] = ACTIONS(2111),
    [sym_preproc_directive] = ACTIONS(2143),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [601] = {
    [sym_preproc_def] = STATE(601),
    [sym_preproc_function_def] = STATE(601),
    [sym_preproc_call] = STATE(601),
    [sym_preproc_if_in_field_declaration_list] = STATE(601),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(601),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1577),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__field_declaration_list_item] = STATE(601),
    [sym_field_declaration] = STATE(601),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(601),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2145),
    [aux_sym_preproc_def_token1] = ACTIONS(2148),
    [aux_sym_preproc_if_token1] = ACTIONS(2151),
    [aux_sym_preproc_if_token2] = ACTIONS(2154),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2156),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2156),
    [aux_sym_preproc_else_token1] = ACTIONS(2154),
    [aux_sym_preproc_elif_token1] = ACTIONS(2154),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2154),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2154),
    [sym_preproc_directive] = ACTIONS(2159),
    [anon_sym___extension__] = ACTIONS(2162),
    [anon_sym_extern] = ACTIONS(2165),
    [anon_sym___attribute__] = ACTIONS(2168),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2171),
    [anon_sym___declspec] = ACTIONS(2174),
    [anon_sym_signed] = ACTIONS(2177),
    [anon_sym_unsigned] = ACTIONS(2177),
    [anon_sym_long] = ACTIONS(2177),
    [anon_sym_short] = ACTIONS(2177),
    [anon_sym_static] = ACTIONS(2165),
    [anon_sym_auto] = ACTIONS(2165),
    [anon_sym_register] = ACTIONS(2165),
    [anon_sym_inline] = ACTIONS(2165),
    [anon_sym___inline] = ACTIONS(2165),
    [anon_sym___inline__] = ACTIONS(2165),
    [anon_sym___forceinline] = ACTIONS(2165),
    [anon_sym_thread_local] = ACTIONS(2165),
    [anon_sym___thread] = ACTIONS(2165),
    [anon_sym_const] = ACTIONS(2162),
    [anon_sym_constexpr] = ACTIONS(2162),
    [anon_sym_volatile] = ACTIONS(2162),
    [anon_sym_restrict] = ACTIONS(2162),
    [anon_sym___restrict__] = ACTIONS(2162),
    [anon_sym__Atomic] = ACTIONS(2162),
    [anon_sym__Noreturn] = ACTIONS(2162),
    [anon_sym_noreturn] = ACTIONS(2162),
    [sym_primitive_type] = ACTIONS(2180),
    [anon_sym_enum] = ACTIONS(2183),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_union] = ACTIONS(2189),
    [sym_comment] = ACTIONS(3),
  },
  [602] = {
    [sym_preproc_def] = STATE(612),
    [sym_preproc_function_def] = STATE(612),
    [sym_preproc_call] = STATE(612),
    [sym_preproc_if_in_field_declaration_list] = STATE(612),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(612),
    [sym_preproc_else_in_field_declaration_list] = STATE(2251),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2251),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1572),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__field_declaration_list_item] = STATE(612),
    [sym_field_declaration] = STATE(612),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(612),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2099),
    [aux_sym_preproc_def_token1] = ACTIONS(2135),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_if_token2] = ACTIONS(2192),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2141),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2141),
    [aux_sym_preproc_else_token1] = ACTIONS(2109),
    [aux_sym_preproc_elif_token1] = ACTIONS(2111),
    [sym_preproc_directive] = ACTIONS(2143),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [603] = {
    [sym_preproc_def] = STATE(608),
    [sym_preproc_function_def] = STATE(608),
    [sym_preproc_call] = STATE(608),
    [sym_preproc_if_in_field_declaration_list] = STATE(608),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(608),
    [sym_preproc_else_in_field_declaration_list] = STATE(2261),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2261),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1572),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__field_declaration_list_item] = STATE(608),
    [sym_field_declaration] = STATE(608),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(608),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2099),
    [aux_sym_preproc_def_token1] = ACTIONS(2135),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_if_token2] = ACTIONS(2194),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2141),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2141),
    [aux_sym_preproc_else_token1] = ACTIONS(2109),
    [aux_sym_preproc_elif_token1] = ACTIONS(2111),
    [sym_preproc_directive] = ACTIONS(2143),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [604] = {
    [sym_preproc_def] = STATE(616),
    [sym_preproc_function_def] = STATE(616),
    [sym_preproc_call] = STATE(616),
    [sym_preproc_if_in_field_declaration_list] = STATE(616),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(616),
    [sym_preproc_else_in_field_declaration_list] = STATE(2359),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2359),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1572),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__field_declaration_list_item] = STATE(616),
    [sym_field_declaration] = STATE(616),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(616),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2099),
    [aux_sym_preproc_def_token1] = ACTIONS(2135),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_if_token2] = ACTIONS(2196),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2141),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2141),
    [aux_sym_preproc_else_token1] = ACTIONS(2109),
    [aux_sym_preproc_elif_token1] = ACTIONS(2111),
    [sym_preproc_directive] = ACTIONS(2143),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [605] = {
    [sym_preproc_def] = STATE(604),
    [sym_preproc_function_def] = STATE(604),
    [sym_preproc_call] = STATE(604),
    [sym_preproc_if_in_field_declaration_list] = STATE(604),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(604),
    [sym_preproc_else_in_field_declaration_list] = STATE(2396),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2396),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1572),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__field_declaration_list_item] = STATE(604),
    [sym_field_declaration] = STATE(604),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(604),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2099),
    [aux_sym_preproc_def_token1] = ACTIONS(2135),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_if_token2] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2141),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2141),
    [aux_sym_preproc_else_token1] = ACTIONS(2109),
    [aux_sym_preproc_elif_token1] = ACTIONS(2111),
    [sym_preproc_directive] = ACTIONS(2143),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [606] = {
    [sym_preproc_def] = STATE(610),
    [sym_preproc_function_def] = STATE(610),
    [sym_preproc_call] = STATE(610),
    [sym_preproc_if_in_field_declaration_list] = STATE(610),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(610),
    [sym_preproc_else_in_field_declaration_list] = STATE(2345),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2345),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1572),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__field_declaration_list_item] = STATE(610),
    [sym_field_declaration] = STATE(610),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(610),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2099),
    [aux_sym_preproc_def_token1] = ACTIONS(2135),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_if_token2] = ACTIONS(2200),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2141),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2141),
    [aux_sym_preproc_else_token1] = ACTIONS(2109),
    [aux_sym_preproc_elif_token1] = ACTIONS(2111),
    [sym_preproc_directive] = ACTIONS(2143),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [607] = {
    [sym_preproc_def] = STATE(609),
    [sym_preproc_function_def] = STATE(609),
    [sym_preproc_call] = STATE(609),
    [sym_preproc_if_in_field_declaration_list] = STATE(609),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(609),
    [sym_preproc_else_in_field_declaration_list] = STATE(2186),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2186),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1572),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__field_declaration_list_item] = STATE(609),
    [sym_field_declaration] = STATE(609),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(609),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2099),
    [aux_sym_preproc_def_token1] = ACTIONS(2135),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_if_token2] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2141),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2141),
    [aux_sym_preproc_else_token1] = ACTIONS(2109),
    [aux_sym_preproc_elif_token1] = ACTIONS(2111),
    [sym_preproc_directive] = ACTIONS(2143),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [608] = {
    [sym_preproc_def] = STATE(616),
    [sym_preproc_function_def] = STATE(616),
    [sym_preproc_call] = STATE(616),
    [sym_preproc_if_in_field_declaration_list] = STATE(616),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(616),
    [sym_preproc_else_in_field_declaration_list] = STATE(2393),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2393),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1572),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__field_declaration_list_item] = STATE(616),
    [sym_field_declaration] = STATE(616),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(616),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2099),
    [aux_sym_preproc_def_token1] = ACTIONS(2135),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_if_token2] = ACTIONS(2204),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2141),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2141),
    [aux_sym_preproc_else_token1] = ACTIONS(2109),
    [aux_sym_preproc_elif_token1] = ACTIONS(2111),
    [sym_preproc_directive] = ACTIONS(2143),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [609] = {
    [sym_preproc_def] = STATE(616),
    [sym_preproc_function_def] = STATE(616),
    [sym_preproc_call] = STATE(616),
    [sym_preproc_if_in_field_declaration_list] = STATE(616),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(616),
    [sym_preproc_else_in_field_declaration_list] = STATE(2191),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2191),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1572),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__field_declaration_list_item] = STATE(616),
    [sym_field_declaration] = STATE(616),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(616),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2099),
    [aux_sym_preproc_def_token1] = ACTIONS(2135),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_if_token2] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2141),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2141),
    [aux_sym_preproc_else_token1] = ACTIONS(2109),
    [aux_sym_preproc_elif_token1] = ACTIONS(2111),
    [sym_preproc_directive] = ACTIONS(2143),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [610] = {
    [sym_preproc_def] = STATE(616),
    [sym_preproc_function_def] = STATE(616),
    [sym_preproc_call] = STATE(616),
    [sym_preproc_if_in_field_declaration_list] = STATE(616),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(616),
    [sym_preproc_else_in_field_declaration_list] = STATE(2338),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2338),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1572),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__field_declaration_list_item] = STATE(616),
    [sym_field_declaration] = STATE(616),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(616),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2099),
    [aux_sym_preproc_def_token1] = ACTIONS(2135),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_if_token2] = ACTIONS(2208),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2141),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2141),
    [aux_sym_preproc_else_token1] = ACTIONS(2109),
    [aux_sym_preproc_elif_token1] = ACTIONS(2111),
    [sym_preproc_directive] = ACTIONS(2143),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [611] = {
    [sym_preproc_def] = STATE(616),
    [sym_preproc_function_def] = STATE(616),
    [sym_preproc_call] = STATE(616),
    [sym_preproc_if_in_field_declaration_list] = STATE(616),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(616),
    [sym_preproc_else_in_field_declaration_list] = STATE(2258),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2258),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1572),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__field_declaration_list_item] = STATE(616),
    [sym_field_declaration] = STATE(616),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(616),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2099),
    [aux_sym_preproc_def_token1] = ACTIONS(2135),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_if_token2] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2141),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2141),
    [aux_sym_preproc_else_token1] = ACTIONS(2109),
    [aux_sym_preproc_elif_token1] = ACTIONS(2111),
    [sym_preproc_directive] = ACTIONS(2143),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
  [612] = {
    [sym_preproc_def] = STATE(616),
    [sym_preproc_function_def] = STATE(616),
    [sym_preproc_call] = STATE(616),
    [sym_preproc_if_in_field_declaration_list] = STATE(616),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(616),
    [sym_preproc_else_in_field_declaration_list] = STATE(2247),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2247),
    [sym__declaration_modifiers] = STATE(932),
    [sym__declaration_specifiers] = STATE(1572),
    [sym_attribute_specifier] = STATE(932),
    [sym_attribute_declaration] = STATE(932),
    [sym_ms_declspec_modifier] = STATE(932),
    [sym_storage_class_specifier] = STATE(932),
    [sym_type_qualifier] = STATE(932),
    [sym__type_specifier] = STATE(955),
    [sym_sized_type_specifier] = STATE(998),
    [sym_enum_specifier] = STATE(998),
    [sym_struct_specifier] = STATE(998),
    [sym_union_specifier] = STATE(998),
    [sym__field_declaration_list_item] = STATE(616),
    [sym_field_declaration] = STATE(616),
    [sym_macro_type_specifier] = STATE(998),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(616),
    [aux_sym__declaration_specifiers_repeat1] = STATE(932),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1006),
    [sym_identifier] = ACTIONS(2099),
    [aux_sym_preproc_def_token1] = ACTIONS(2135),
    [aux_sym_preproc_if_token1] = ACTIONS(2137),
    [aux_sym_preproc_if_token2] = ACTIONS(2212),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2141),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2141),
    [aux_sym_preproc_else_token1] = ACTIONS(2109),
    [aux_sym_preproc_elif_token1] = ACTIONS(2111),
    [sym_preproc_directive] = ACTIONS(2143),
    [anon_sym___extension__] = ACTIONS(47),
    [anon_sym_extern] = ACTIONS(45),
    [anon_sym___attribute__] = ACTIONS(33),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1290),
    [anon_sym___declspec] = ACTIONS(37),
    [anon_sym_signed] = ACTIONS(43),
    [anon_sym_unsigned] = ACTIONS(43),
    [anon_sym_long] = ACTIONS(43),
    [anon_sym_short] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(45),
    [anon_sym_auto] = ACTIONS(45),
    [anon_sym_register] = ACTIONS(45),
    [anon_sym_inline] = ACTIONS(45),
    [anon_sym___inline] = ACTIONS(45),
    [anon_sym___inline__] = ACTIONS(45),
    [anon_sym___forceinline] = ACTIONS(45),
    [anon_sym_thread_local] = ACTIONS(45),
    [anon_sym___thread] = ACTIONS(45),
    [anon_sym_const] = ACTIONS(47),
    [anon_sym_constexpr] = ACTIONS(47),
    [anon_sym_volatile] = ACTIONS(47),
    [anon_sym_restrict] = ACTIONS(47),
    [anon_sym___restrict__] = ACTIONS(47),
    [anon_sym__Atomic] = ACTIONS(47),
    [anon_sym__Noreturn] = ACTIONS(47),
    [anon_sym_noreturn] = ACTIONS(47),
    [sym_primitive_type] = ACTIONS(49),
    [anon_sym_enum] = ACTIONS(51),
    [anon_sym_struct] = ACTIONS(53),
    [anon_sym_union] = ACTIONS(55),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2214), 1,
      anon_sym_RPAREN,
    ACTIONS(2216), 1,
      anon_sym___extension__,
    STATE(845), 1,
      sym_string_literal,
    STATE(1280), 1,
      sym__expression,
    STATE(1888), 1,
      sym_compound_statement,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [115] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_RPAREN,
    ACTIONS(2220), 1,
      anon_sym___extension__,
    STATE(845), 1,
      sym_string_literal,
    STATE(1278), 1,
      sym__expression,
    STATE(1942), 1,
      sym_compound_statement,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [230] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2222), 1,
      anon_sym___extension__,
    STATE(845), 1,
      sym_string_literal,
    STATE(1328), 1,
      sym__expression,
    STATE(2120), 1,
      sym_compound_statement,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [342] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2145), 1,
      sym_identifier,
    ACTIONS(2168), 1,
      anon_sym___attribute__,
    ACTIONS(2171), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2174), 1,
      anon_sym___declspec,
    ACTIONS(2180), 1,
      sym_primitive_type,
    ACTIONS(2183), 1,
      anon_sym_enum,
    ACTIONS(2186), 1,
      anon_sym_struct,
    ACTIONS(2189), 1,
      anon_sym_union,
    ACTIONS(2224), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(2227), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(2233), 1,
      sym_preproc_directive,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1572), 1,
      sym__declaration_specifiers,
    ACTIONS(2230), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(2154), 3,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    ACTIONS(2177), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(616), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
    ACTIONS(2162), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2165), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [452] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1548), 1,
      anon_sym_LBRACE,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1315), 1,
      sym__expression,
    STATE(2087), 1,
      sym_initializer_list,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [561] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1548), 1,
      anon_sym_LBRACE,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_sizeof,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(861), 1,
      sym_initializer_list,
    STATE(1100), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1959), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1961), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2039), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1138), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [670] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1548), 1,
      anon_sym_LBRACE,
    ACTIONS(1943), 1,
      anon_sym_sizeof,
    ACTIONS(2236), 1,
      sym_identifier,
    ACTIONS(2238), 1,
      anon_sym_LPAREN2,
    STATE(861), 1,
      sym_initializer_list,
    STATE(890), 1,
      sym_string_literal,
    STATE(902), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1939), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1941), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2242), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(983), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [779] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2244), 1,
      anon_sym_SEMI,
    STATE(845), 1,
      sym_string_literal,
    STATE(1285), 1,
      sym__expression,
    STATE(2125), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [888] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1824), 1,
      anon_sym_LBRACE,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(1955), 1,
      anon_sym_sizeof,
    ACTIONS(2246), 1,
      sym_identifier,
    ACTIONS(2248), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(996), 1,
      sym__expression,
    STATE(1053), 1,
      sym_initializer_list,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(1951), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1953), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2252), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1088), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(1073), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [997] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1548), 1,
      anon_sym_LBRACE,
    ACTIONS(1556), 1,
      anon_sym_sizeof,
    ACTIONS(2254), 1,
      anon_sym_LPAREN2,
    STATE(861), 1,
      sym_initializer_list,
    STATE(890), 1,
      sym_string_literal,
    STATE(902), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1552), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1554), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2256), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1104] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_SEMI,
    STATE(845), 1,
      sym_string_literal,
    STATE(1347), 1,
      sym__expression,
    STATE(2339), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1213] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2260), 1,
      anon_sym_SEMI,
    STATE(845), 1,
      sym_string_literal,
    STATE(1349), 1,
      sym__expression,
    STATE(2337), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1322] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2262), 1,
      anon_sym_COLON,
    STATE(845), 1,
      sym_string_literal,
    STATE(1338), 1,
      sym__expression,
    STATE(2380), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1431] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_COLON,
    STATE(845), 1,
      sym_string_literal,
    STATE(1331), 1,
      sym__expression,
    STATE(2132), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1540] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1548), 1,
      anon_sym_LBRACE,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(861), 1,
      sym_initializer_list,
    STATE(1100), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1647] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2270), 1,
      anon_sym_SEMI,
    STATE(845), 1,
      sym_string_literal,
    STATE(1289), 1,
      sym__expression,
    STATE(2208), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1756] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1548), 1,
      anon_sym_LBRACE,
    ACTIONS(1550), 1,
      anon_sym_sizeof,
    ACTIONS(2272), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(861), 1,
      sym_initializer_list,
    STATE(902), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1544), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2274), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1863] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2276), 1,
      anon_sym_RPAREN,
    STATE(845), 1,
      sym_string_literal,
    STATE(1307), 1,
      sym__expression,
    STATE(2420), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1972] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1548), 1,
      anon_sym_LBRACE,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(861), 1,
      sym_initializer_list,
    STATE(902), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2081] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1548), 1,
      anon_sym_LBRACE,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1318), 1,
      sym__expression,
    STATE(2102), 1,
      sym_initializer_list,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2190] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_COLON,
    STATE(845), 1,
      sym_string_literal,
    STATE(1332), 1,
      sym__expression,
    STATE(2238), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2299] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1548), 1,
      anon_sym_LBRACE,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1351), 1,
      sym__expression,
    STATE(2043), 1,
      sym_initializer_list,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2408] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2280), 1,
      anon_sym_SEMI,
    STATE(845), 1,
      sym_string_literal,
    STATE(1303), 1,
      sym__expression,
    STATE(2382), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2517] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2282), 1,
      anon_sym_RPAREN,
    STATE(845), 1,
      sym_string_literal,
    STATE(1290), 1,
      sym__expression,
    STATE(2240), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2626] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2284), 1,
      anon_sym_SEMI,
    STATE(845), 1,
      sym_string_literal,
    STATE(1302), 1,
      sym__expression,
    STATE(2379), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2735] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2286), 1,
      anon_sym_COLON,
    STATE(845), 1,
      sym_string_literal,
    STATE(1304), 1,
      sym__expression,
    STATE(2291), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2844] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2288), 1,
      anon_sym_RPAREN,
    STATE(845), 1,
      sym_string_literal,
    STATE(1291), 1,
      sym__expression,
    STATE(2210), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2953] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2290), 1,
      anon_sym_COLON,
    STATE(845), 1,
      sym_string_literal,
    STATE(1353), 1,
      sym__expression,
    STATE(2398), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3062] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2292), 1,
      anon_sym_RPAREN,
    STATE(845), 1,
      sym_string_literal,
    STATE(1299), 1,
      sym__expression,
    STATE(2271), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3171] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2294), 1,
      anon_sym_RPAREN,
    STATE(845), 1,
      sym_string_literal,
    STATE(1293), 1,
      sym__expression,
    STATE(2212), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3280] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_COLON,
    STATE(845), 1,
      sym_string_literal,
    STATE(1320), 1,
      sym__expression,
    STATE(2391), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3389] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1824), 1,
      anon_sym_LBRACE,
    ACTIONS(1826), 1,
      anon_sym_sizeof,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(2298), 1,
      sym_identifier,
    ACTIONS(2300), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(996), 1,
      sym__expression,
    STATE(1053), 1,
      sym_initializer_list,
    ACTIONS(1820), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1822), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2302), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1073), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3496] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2304), 1,
      anon_sym_COLON,
    STATE(845), 1,
      sym_string_literal,
    STATE(1296), 1,
      sym__expression,
    STATE(2183), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3605] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2306), 1,
      anon_sym_COLON,
    STATE(845), 1,
      sym_string_literal,
    STATE(1305), 1,
      sym__expression,
    STATE(2263), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3714] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2308), 1,
      anon_sym_SEMI,
    STATE(845), 1,
      sym_string_literal,
    STATE(1312), 1,
      sym__expression,
    STATE(2149), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3823] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2310), 1,
      anon_sym_SEMI,
    STATE(845), 1,
      sym_string_literal,
    STATE(1294), 1,
      sym__expression,
    STATE(2264), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3932] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2312), 1,
      anon_sym_RPAREN,
    STATE(845), 1,
      sym_string_literal,
    STATE(1300), 1,
      sym__expression,
    STATE(2213), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4041] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    ACTIONS(2314), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(2316), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(2320), 1,
      sym_preproc_directive,
    ACTIONS(2322), 1,
      anon_sym_RBRACE,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1576), 1,
      sym__declaration_specifiers,
    ACTIONS(2318), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(667), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [4149] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    ACTIONS(2324), 1,
      anon_sym_RBRACK,
    STATE(845), 1,
      sym_string_literal,
    STATE(1130), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4253] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    ACTIONS(2326), 1,
      anon_sym_RBRACK,
    STATE(845), 1,
      sym_string_literal,
    STATE(1130), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4357] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    ACTIONS(2328), 1,
      anon_sym_RBRACK,
    STATE(845), 1,
      sym_string_literal,
    STATE(1130), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4461] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    ACTIONS(2330), 1,
      anon_sym_RBRACK,
    STATE(845), 1,
      sym_string_literal,
    STATE(1130), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4565] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1350), 1,
      sym__expression,
    STATE(2347), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4671] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    ACTIONS(2332), 1,
      anon_sym_RBRACK,
    STATE(845), 1,
      sym_string_literal,
    STATE(1130), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4775] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    ACTIONS(2334), 1,
      anon_sym_RBRACK,
    STATE(845), 1,
      sym_string_literal,
    STATE(1130), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4879] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    ACTIONS(2336), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(2338), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(2340), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(2344), 1,
      sym_preproc_directive,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1574), 1,
      sym__declaration_specifiers,
    ACTIONS(2342), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(668), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [4987] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    ACTIONS(2346), 1,
      anon_sym_RBRACK,
    STATE(845), 1,
      sym_string_literal,
    STATE(1130), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5091] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2145), 1,
      sym_identifier,
    ACTIONS(2168), 1,
      anon_sym___attribute__,
    ACTIONS(2171), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2174), 1,
      anon_sym___declspec,
    ACTIONS(2180), 1,
      sym_primitive_type,
    ACTIONS(2183), 1,
      anon_sym_enum,
    ACTIONS(2186), 1,
      anon_sym_struct,
    ACTIONS(2189), 1,
      anon_sym_union,
    ACTIONS(2348), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(2351), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(2357), 1,
      sym_preproc_directive,
    ACTIONS(2360), 1,
      anon_sym_RBRACE,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1576), 1,
      sym__declaration_specifiers,
    ACTIONS(2354), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(2177), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(660), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
    ACTIONS(2162), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2165), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [5199] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1327), 1,
      sym__expression,
    STATE(2222), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5305] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    ACTIONS(2362), 1,
      anon_sym_RBRACK,
    STATE(845), 1,
      sym_string_literal,
    STATE(1130), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5409] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    ACTIONS(2364), 1,
      anon_sym_RBRACK,
    STATE(845), 1,
      sym_string_literal,
    STATE(1130), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5513] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    ACTIONS(2366), 1,
      anon_sym_RBRACK,
    STATE(845), 1,
      sym_string_literal,
    STATE(1130), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5617] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    ACTIONS(2336), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(2338), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(2344), 1,
      sym_preproc_directive,
    ACTIONS(2368), 1,
      aux_sym_preproc_if_token2,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1574), 1,
      sym__declaration_specifiers,
    ACTIONS(2342), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(658), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [5725] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1274), 1,
      sym__expression,
    STATE(2013), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5831] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    ACTIONS(2314), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(2316), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(2320), 1,
      sym_preproc_directive,
    ACTIONS(2370), 1,
      anon_sym_RBRACE,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1576), 1,
      sym__declaration_specifiers,
    ACTIONS(2318), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(660), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [5939] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2145), 1,
      sym_identifier,
    ACTIONS(2154), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(2168), 1,
      anon_sym___attribute__,
    ACTIONS(2171), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2174), 1,
      anon_sym___declspec,
    ACTIONS(2180), 1,
      sym_primitive_type,
    ACTIONS(2183), 1,
      anon_sym_enum,
    ACTIONS(2186), 1,
      anon_sym_struct,
    ACTIONS(2189), 1,
      anon_sym_union,
    ACTIONS(2372), 1,
      aux_sym_preproc_def_token1,
    ACTIONS(2375), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(2381), 1,
      sym_preproc_directive,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1574), 1,
      sym__declaration_specifiers,
    ACTIONS(2378), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    ACTIONS(2177), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    STATE(668), 8,
      sym_preproc_def,
      sym_preproc_function_def,
      sym_preproc_call,
      sym_preproc_if_in_field_declaration_list,
      sym_preproc_ifdef_in_field_declaration_list,
      sym__field_declaration_list_item,
      sym_field_declaration,
      aux_sym_preproc_if_in_field_declaration_list_repeat1,
    ACTIONS(2162), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2165), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [6047] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1218), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6150] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_sizeof,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1129), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1959), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1961), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2039), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1138), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6253] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1365), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6356] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1301), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6459] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1379), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6562] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_sizeof,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(2298), 1,
      sym_identifier,
    ACTIONS(2300), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(995), 1,
      sym__expression,
    ACTIONS(1820), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1822), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2302), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1073), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6663] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1224), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6766] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1222), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6869] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1215), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6972] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1550), 1,
      anon_sym_sizeof,
    ACTIONS(2272), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(900), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1544), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2274), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7073] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(891), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7176] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1223), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7279] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1556), 1,
      anon_sym_sizeof,
    ACTIONS(2254), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(900), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1552), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1554), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2256), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7380] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1229), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7483] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1556), 1,
      anon_sym_sizeof,
    ACTIONS(2254), 1,
      anon_sym_LPAREN2,
    STATE(889), 1,
      sym__expression,
    STATE(890), 1,
      sym_string_literal,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1552), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1554), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2256), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7584] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1238), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7687] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1367), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7790] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_sizeof,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1352), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1959), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1961), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2039), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1138), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7893] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1556), 1,
      anon_sym_sizeof,
    ACTIONS(2254), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(899), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1552), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1554), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2256), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7994] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1214), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8097] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1324), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8200] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1550), 1,
      anon_sym_sizeof,
    ACTIONS(2272), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(889), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1544), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2274), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8301] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(1955), 1,
      anon_sym_sizeof,
    ACTIONS(2246), 1,
      sym_identifier,
    ACTIONS(2248), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1247), 1,
      sym__expression,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(1951), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1953), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2252), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1088), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(1073), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8404] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1550), 1,
      anon_sym_sizeof,
    ACTIONS(2384), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(887), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1544), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2274), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8505] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1276), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8608] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(900), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8711] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(1955), 1,
      anon_sym_sizeof,
    ACTIONS(2246), 1,
      sym_identifier,
    ACTIONS(2248), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1249), 1,
      sym__expression,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(1951), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1953), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2252), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1088), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(1073), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8814] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1225), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8917] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1220), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9020] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1217), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9123] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_sizeof,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1372), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1959), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1961), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2039), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1138), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9226] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1550), 1,
      anon_sym_sizeof,
    ACTIONS(2272), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(899), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1544), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2274), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9327] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1943), 1,
      anon_sym_sizeof,
    ACTIONS(2236), 1,
      sym_identifier,
    ACTIONS(2238), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(1209), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1939), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1941), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2242), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(983), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9430] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1550), 1,
      anon_sym_sizeof,
    ACTIONS(2272), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(980), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1544), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2274), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9531] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1550), 1,
      anon_sym_sizeof,
    ACTIONS(2272), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(891), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1544), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2274), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9632] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_sizeof,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(2298), 1,
      sym_identifier,
    ACTIONS(2300), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1039), 1,
      sym__expression,
    ACTIONS(1820), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1822), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2302), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1073), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9733] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1550), 1,
      anon_sym_sizeof,
    ACTIONS(2272), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(979), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1544), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2274), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9834] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1550), 1,
      anon_sym_sizeof,
    ACTIONS(2272), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(978), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1544), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2274), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9935] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_sizeof,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(2298), 1,
      sym_identifier,
    ACTIONS(2300), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1001), 1,
      sym__expression,
    ACTIONS(1820), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1822), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2302), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1073), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10036] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_sizeof,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(2298), 1,
      sym_identifier,
    ACTIONS(2386), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1002), 1,
      sym__expression,
    ACTIONS(1820), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1822), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2302), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1073), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10137] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1281), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10240] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1550), 1,
      anon_sym_sizeof,
    ACTIONS(2272), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(977), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1544), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2274), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10341] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1357), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10444] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1550), 1,
      anon_sym_sizeof,
    ACTIONS(2272), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(976), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1544), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2274), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10545] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1556), 1,
      anon_sym_sizeof,
    ACTIONS(2388), 1,
      anon_sym_LPAREN2,
    STATE(887), 1,
      sym__expression,
    STATE(890), 1,
      sym_string_literal,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1552), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1554), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2256), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10646] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1550), 1,
      anon_sym_sizeof,
    ACTIONS(2272), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(975), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1544), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2274), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10747] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(1955), 1,
      anon_sym_sizeof,
    ACTIONS(2246), 1,
      sym_identifier,
    ACTIONS(2390), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1002), 1,
      sym__expression,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(1951), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1953), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2252), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1088), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(1073), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10850] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1550), 1,
      anon_sym_sizeof,
    ACTIONS(2272), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(973), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1544), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2274), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10951] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1550), 1,
      anon_sym_sizeof,
    ACTIONS(2272), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(972), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1544), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2274), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11052] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1310), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11155] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(1955), 1,
      anon_sym_sizeof,
    ACTIONS(2246), 1,
      sym_identifier,
    ACTIONS(2248), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1001), 1,
      sym__expression,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(1951), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1953), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2252), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1088), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(1073), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11258] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_sizeof,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1337), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1959), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1961), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2039), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1138), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11361] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_sizeof,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1330), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1959), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1961), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2039), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1138), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11464] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(1955), 1,
      anon_sym_sizeof,
    ACTIONS(2246), 1,
      sym_identifier,
    ACTIONS(2248), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1039), 1,
      sym__expression,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(1951), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1953), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2252), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1088), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(1073), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11567] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_sizeof,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1096), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1959), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1961), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2039), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1138), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11670] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1550), 1,
      anon_sym_sizeof,
    ACTIONS(2272), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(971), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1544), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2274), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11771] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_sizeof,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1323), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1959), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1961), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2039), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1138), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11874] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_sizeof,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1322), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1959), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1961), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2039), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1138), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11977] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_sizeof,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1321), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1959), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1961), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2039), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1138), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12080] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(1955), 1,
      anon_sym_sizeof,
    ACTIONS(2246), 1,
      sym_identifier,
    ACTIONS(2248), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1252), 1,
      sym__expression,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(1951), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1953), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2252), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1088), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(1073), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12183] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1556), 1,
      anon_sym_sizeof,
    ACTIONS(2254), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(891), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1552), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1554), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2256), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12284] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(1955), 1,
      anon_sym_sizeof,
    ACTIONS(2246), 1,
      sym_identifier,
    ACTIONS(2248), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1253), 1,
      sym__expression,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(1951), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1953), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2252), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1088), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(1073), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12387] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_sizeof,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1319), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1959), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1961), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2039), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1138), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12490] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(1955), 1,
      anon_sym_sizeof,
    ACTIONS(2246), 1,
      sym_identifier,
    ACTIONS(2248), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1251), 1,
      sym__expression,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(1951), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1953), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2252), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1088), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(1073), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12593] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(1955), 1,
      anon_sym_sizeof,
    ACTIONS(2246), 1,
      sym_identifier,
    ACTIONS(2248), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1250), 1,
      sym__expression,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(1951), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1953), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2252), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1088), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(1073), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12696] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(1955), 1,
      anon_sym_sizeof,
    ACTIONS(2246), 1,
      sym_identifier,
    ACTIONS(2248), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1254), 1,
      sym__expression,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(1951), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1953), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2252), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1088), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(1073), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12799] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(1955), 1,
      anon_sym_sizeof,
    ACTIONS(2246), 1,
      sym_identifier,
    ACTIONS(2248), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1256), 1,
      sym__expression,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(1951), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1953), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2252), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1088), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(1073), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12902] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(1955), 1,
      anon_sym_sizeof,
    ACTIONS(2246), 1,
      sym_identifier,
    ACTIONS(2248), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1244), 1,
      sym__expression,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(1951), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1953), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2252), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1088), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(1073), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13005] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(1955), 1,
      anon_sym_sizeof,
    ACTIONS(2246), 1,
      sym_identifier,
    ACTIONS(2248), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1260), 1,
      sym__expression,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(1951), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1953), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2252), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1088), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(1073), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13108] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(1955), 1,
      anon_sym_sizeof,
    ACTIONS(2246), 1,
      sym_identifier,
    ACTIONS(2248), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1018), 1,
      sym__expression,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(1951), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1953), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2252), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1088), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(1073), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13211] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(1955), 1,
      anon_sym_sizeof,
    ACTIONS(2246), 1,
      sym_identifier,
    ACTIONS(2248), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1259), 1,
      sym__expression,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(1951), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1953), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2252), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1088), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(1073), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13314] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_sizeof,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1314), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1959), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1961), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2039), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1138), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13417] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(1955), 1,
      anon_sym_sizeof,
    ACTIONS(2246), 1,
      sym_identifier,
    ACTIONS(2248), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1257), 1,
      sym__expression,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(1951), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1953), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2252), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1088), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(1073), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13520] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1943), 1,
      anon_sym_sizeof,
    ACTIONS(2236), 1,
      sym_identifier,
    ACTIONS(2238), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(1202), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1939), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1941), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2242), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(983), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13623] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1943), 1,
      anon_sym_sizeof,
    ACTIONS(2236), 1,
      sym_identifier,
    ACTIONS(2238), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(891), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1939), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1941), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2242), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(983), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13726] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1943), 1,
      anon_sym_sizeof,
    ACTIONS(2236), 1,
      sym_identifier,
    ACTIONS(2238), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(1203), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1939), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1941), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2242), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(983), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13829] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1943), 1,
      anon_sym_sizeof,
    ACTIONS(2236), 1,
      sym_identifier,
    ACTIONS(2238), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(1204), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1939), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1941), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2242), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(983), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13932] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_sizeof,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1308), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1959), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1961), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2039), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1138), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14035] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1943), 1,
      anon_sym_sizeof,
    ACTIONS(2236), 1,
      sym_identifier,
    ACTIONS(2238), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(1205), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1939), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1941), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2242), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(983), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14138] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_sizeof,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1284), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1959), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1961), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2039), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1138), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14241] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_sizeof,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1292), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1959), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1961), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2039), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1138), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14344] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1943), 1,
      anon_sym_sizeof,
    ACTIONS(2236), 1,
      sym_identifier,
    ACTIONS(2238), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(1206), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1939), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1941), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2242), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(983), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14447] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1943), 1,
      anon_sym_sizeof,
    ACTIONS(2236), 1,
      sym_identifier,
    ACTIONS(2238), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(1212), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1939), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1941), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2242), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(983), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14550] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_sizeof,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1374), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1959), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1961), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2039), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1138), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14653] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_sizeof,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1380), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1959), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1961), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2039), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1138), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14756] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_sizeof,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(2298), 1,
      sym_identifier,
    ACTIONS(2300), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(988), 1,
      sym__expression,
    ACTIONS(1820), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1822), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2302), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1073), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14857] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_sizeof,
    ACTIONS(2392), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1127), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1959), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1961), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2039), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1138), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14960] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_sizeof,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(2298), 1,
      sym_identifier,
    ACTIONS(2300), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1018), 1,
      sym__expression,
    ACTIONS(1820), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1822), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2302), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1073), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15061] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1130), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15162] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_sizeof,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(2298), 1,
      sym_identifier,
    ACTIONS(2300), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(999), 1,
      sym__expression,
    ACTIONS(1820), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1822), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2302), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1073), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15263] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1282), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15366] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_sizeof,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(2298), 1,
      sym_identifier,
    ACTIONS(2300), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(990), 1,
      sym__expression,
    ACTIONS(1820), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1822), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2302), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1073), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15467] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1358), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15570] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_sizeof,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(2298), 1,
      sym_identifier,
    ACTIONS(2300), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1005), 1,
      sym__expression,
    ACTIONS(1820), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1822), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2302), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1073), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15671] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_sizeof,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1345), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1959), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1961), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2039), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1138), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15774] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_sizeof,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(2298), 1,
      sym_identifier,
    ACTIONS(2300), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1033), 1,
      sym__expression,
    ACTIONS(1820), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1822), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2302), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1073), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15875] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_sizeof,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(2298), 1,
      sym_identifier,
    ACTIONS(2300), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(993), 1,
      sym__expression,
    ACTIONS(1820), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1822), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2302), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1073), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15976] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1275), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16079] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1131), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16180] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1119), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16281] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1135), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16382] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1134), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16483] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1133), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16584] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_sizeof,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(2298), 1,
      sym_identifier,
    ACTIONS(2300), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(994), 1,
      sym__expression,
    ACTIONS(1820), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1822), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2302), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1073), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16685] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1120), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16786] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_sizeof,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1132), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1959), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1961), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2039), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1138), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16889] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1943), 1,
      anon_sym_sizeof,
    ACTIONS(2236), 1,
      sym_identifier,
    ACTIONS(2238), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(1211), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1939), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1941), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2242), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(983), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16992] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1117), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [17093] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1098), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [17194] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1099), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [17295] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1101), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [17396] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1102), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [17497] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1132), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [17598] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1382), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [17701] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1129), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [17802] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_sizeof,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(2298), 1,
      sym_identifier,
    ACTIONS(2300), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(997), 1,
      sym__expression,
    ACTIONS(1820), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1822), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2302), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1073), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [17903] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2394), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1127), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [18004] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1943), 1,
      anon_sym_sizeof,
    ACTIONS(2236), 1,
      sym_identifier,
    ACTIONS(2238), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(1207), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1939), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1941), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2242), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(983), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [18107] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1943), 1,
      anon_sym_sizeof,
    ACTIONS(2236), 1,
      sym_identifier,
    ACTIONS(2238), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(1213), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1939), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1941), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2242), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(983), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [18210] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1370), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [18313] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_sizeof,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1335), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1959), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1961), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2039), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1138), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [18416] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1371), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [18519] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1943), 1,
      anon_sym_sizeof,
    ACTIONS(2236), 1,
      sym_identifier,
    ACTIONS(2396), 1,
      anon_sym_LPAREN2,
    STATE(887), 1,
      sym__expression,
    STATE(890), 1,
      sym_string_literal,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1939), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1941), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2242), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(983), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [18622] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1943), 1,
      anon_sym_sizeof,
    ACTIONS(2236), 1,
      sym_identifier,
    ACTIONS(2238), 1,
      anon_sym_LPAREN2,
    STATE(889), 1,
      sym__expression,
    STATE(890), 1,
      sym_string_literal,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1939), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1941), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2242), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(983), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [18725] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_sizeof,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(2298), 1,
      sym_identifier,
    ACTIONS(2300), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1021), 1,
      sym__expression,
    ACTIONS(1820), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1822), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2302), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1073), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [18826] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1943), 1,
      anon_sym_sizeof,
    ACTIONS(2236), 1,
      sym_identifier,
    ACTIONS(2238), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(900), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1939), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1941), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2242), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(983), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [18929] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1556), 1,
      anon_sym_sizeof,
    ACTIONS(2254), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(954), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1552), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1554), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2256), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [19030] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1556), 1,
      anon_sym_sizeof,
    ACTIONS(2254), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(942), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1552), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1554), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2256), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [19131] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1556), 1,
      anon_sym_sizeof,
    ACTIONS(2254), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(940), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1552), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1554), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2256), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [19232] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1550), 1,
      anon_sym_sizeof,
    ACTIONS(2272), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(957), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1544), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2274), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [19333] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_sizeof,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(2298), 1,
      sym_identifier,
    ACTIONS(2300), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1032), 1,
      sym__expression,
    ACTIONS(1820), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1822), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2302), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1073), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [19434] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1556), 1,
      anon_sym_sizeof,
    ACTIONS(2254), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(953), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1552), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1554), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2256), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [19535] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1556), 1,
      anon_sym_sizeof,
    ACTIONS(2254), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(952), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1552), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1554), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2256), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [19636] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1556), 1,
      anon_sym_sizeof,
    ACTIONS(2254), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(951), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1552), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1554), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2256), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [19737] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1377), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [19840] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1556), 1,
      anon_sym_sizeof,
    ACTIONS(2254), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(948), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1552), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1554), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2256), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [19941] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    ACTIONS(2398), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(887), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [20044] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1556), 1,
      anon_sym_sizeof,
    ACTIONS(2254), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(947), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1552), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1554), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2256), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [20145] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1242), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [20248] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1550), 1,
      anon_sym_sizeof,
    ACTIONS(2272), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(963), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1542), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1544), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2274), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [20349] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(889), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [20452] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1556), 1,
      anon_sym_sizeof,
    ACTIONS(2254), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(946), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1552), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1554), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2256), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [20553] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1943), 1,
      anon_sym_sizeof,
    ACTIONS(2236), 1,
      sym_identifier,
    ACTIONS(2238), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(1210), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1939), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1941), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2242), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(983), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [20656] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1556), 1,
      anon_sym_sizeof,
    ACTIONS(2254), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(945), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1552), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1554), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2256), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [20757] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1943), 1,
      anon_sym_sizeof,
    ACTIONS(2236), 1,
      sym_identifier,
    ACTIONS(2238), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(1201), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1939), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1941), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2242), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(983), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [20860] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1361), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [20963] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_sizeof,
    ACTIONS(2266), 1,
      anon_sym_LPAREN2,
    STATE(845), 1,
      sym_string_literal,
    STATE(1096), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1915), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1917), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2033), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [21064] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(81), 1,
      anon_sym_sizeof,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1945), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1283), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(79), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1003), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [21167] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(1955), 1,
      anon_sym_sizeof,
    ACTIONS(2246), 1,
      sym_identifier,
    ACTIONS(2248), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1258), 1,
      sym__expression,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(1951), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1953), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2252), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1088), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(1073), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [21270] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1538), 1,
      sym_identifier,
    ACTIONS(1556), 1,
      anon_sym_sizeof,
    ACTIONS(2254), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(944), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1552), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1554), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2256), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(884), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [21371] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 1,
      anon_sym_offsetof,
    ACTIONS(87), 1,
      anon_sym__Generic,
    ACTIONS(157), 1,
      sym_number_literal,
    ACTIONS(1943), 1,
      anon_sym_sizeof,
    ACTIONS(2236), 1,
      sym_identifier,
    ACTIONS(2238), 1,
      anon_sym_LPAREN2,
    STATE(890), 1,
      sym_string_literal,
    STATE(1208), 1,
      sym__expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(99), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(159), 2,
      sym_true,
      sym_false,
    ACTIONS(1939), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1941), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2240), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2242), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(83), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(93), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(983), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(884), 17,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [21474] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_sizeof,
    ACTIONS(1830), 1,
      anon_sym_offsetof,
    ACTIONS(1832), 1,
      anon_sym__Generic,
    ACTIONS(1836), 1,
      sym_number_literal,
    ACTIONS(2298), 1,
      sym_identifier,
    ACTIONS(2300), 1,
      anon_sym_LPAREN2,
    STATE(910), 1,
      sym_string_literal,
    STATE(1004), 1,
      sym__expression,
    ACTIONS(1820), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1822), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1834), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(1842), 2,
      sym_true,
      sym_false,
    ACTIONS(1844), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2302), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1828), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(1838), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1073), 22,
      sym__expression_not_binary,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_pointer_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_gnu_asm_expression,
      sym_field_expression,
      sym_compound_literal_expression,
      sym_parenthesized_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [21575] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_const,
    ACTIONS(1971), 1,
      anon_sym_LPAREN2,
    ACTIONS(1977), 1,
      anon_sym_STAR,
    ACTIONS(1984), 1,
      anon_sym_EQ,
    STATE(824), 1,
      sym_string_literal,
    STATE(1017), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2006), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2400), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1980), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(1988), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1975), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1969), 12,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [21663] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    ACTIONS(2402), 1,
      anon_sym_LBRACE,
    STATE(915), 1,
      sym_ms_call_modifier,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1430), 1,
      sym__declaration_specifiers,
    STATE(228), 3,
      sym_function_definition,
      sym_declaration,
      sym_declaration_list,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [21764] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    ACTIONS(2404), 1,
      anon_sym_LBRACE,
    STATE(914), 1,
      sym_ms_call_modifier,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1417), 1,
      sym__declaration_specifiers,
    STATE(535), 3,
      sym_function_definition,
      sym_declaration,
      sym_declaration_list,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [21865] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2406), 1,
      sym_identifier,
    STATE(825), 2,
      sym_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2410), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2408), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [21936] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2412), 1,
      sym_identifier,
    STATE(827), 2,
      sym_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2416), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2414), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [22007] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    ACTIONS(2418), 1,
      anon_sym_LBRACE,
    STATE(919), 1,
      sym_ms_call_modifier,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1423), 1,
      sym__declaration_specifiers,
    STATE(490), 3,
      sym_function_definition,
      sym_declaration,
      sym_declaration_list,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [22108] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2420), 1,
      sym_identifier,
    STATE(827), 2,
      sym_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2427), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2425), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2423), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [22179] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    ACTIONS(2430), 1,
      anon_sym_LBRACE,
    STATE(921), 1,
      sym_ms_call_modifier,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1431), 1,
      sym__declaration_specifiers,
    STATE(465), 3,
      sym_function_definition,
      sym_declaration,
      sym_declaration_list,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [22280] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    ACTIONS(2432), 1,
      anon_sym_LBRACE,
    STATE(920), 1,
      sym_ms_call_modifier,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1432), 1,
      sym__declaration_specifiers,
    STATE(152), 3,
      sym_function_definition,
      sym_declaration,
      sym_declaration_list,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [22381] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(824), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1975), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(1969), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [22449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2436), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [22512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2438), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2440), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [22575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2442), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2444), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [22637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2448), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [22699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2452), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [22761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2454), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2456), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [22823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2458), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2460), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [22885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2462), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2464), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [22947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2466), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2468), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [23009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2470), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2472), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [23071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2474), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2476), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [23133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2478), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2480), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [23195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2484), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [23254] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2496), 1,
      anon_sym___attribute__,
    ACTIONS(2499), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2502), 1,
      anon_sym___declspec,
    ACTIONS(2488), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
    STATE(844), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2490), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2493), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(2486), 17,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23325] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2505), 1,
      sym_identifier,
    STATE(824), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2509), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2507), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [23390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1937), 21,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1935), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_return,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym___try,
      anon_sym___leave,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
  [23449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2484), 21,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2482), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_return,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym___try,
      anon_sym___leave,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
  [23508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1949), 21,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1947), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_return,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym___try,
      anon_sym___leave,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
  [23567] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(499), 1,
      anon_sym_LBRACE,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(502), 1,
      sym_compound_statement,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__declaration_specifiers,
    STATE(881), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [23659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2511), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2513), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [23717] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(499), 1,
      anon_sym_LBRACE,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(453), 1,
      sym_compound_statement,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__declaration_specifiers,
    STATE(898), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [23809] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(129), 1,
      anon_sym_LBRACE,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(154), 1,
      sym_compound_statement,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__declaration_specifiers,
    STATE(854), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [23901] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(201), 1,
      anon_sym_LBRACE,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(250), 1,
      sym_compound_statement,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__declaration_specifiers,
    STATE(898), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [23993] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(129), 1,
      anon_sym_LBRACE,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(161), 1,
      sym_compound_statement,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__declaration_specifiers,
    STATE(898), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [24085] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(129), 1,
      anon_sym_LBRACE,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(165), 1,
      sym_compound_statement,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__declaration_specifiers,
    STATE(860), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [24177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2515), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2517), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [24235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2519), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2521), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [24293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2523), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2525), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [24351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2527), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2529), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [24409] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(129), 1,
      anon_sym_LBRACE,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(150), 1,
      sym_compound_statement,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__declaration_specifiers,
    STATE(898), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [24501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2533), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [24559] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2017), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2535), 1,
      sym_identifier,
    ACTIONS(2537), 1,
      anon_sym_RPAREN,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1443), 1,
      sym__declaration_specifiers,
    STATE(1861), 1,
      sym_variadic_parameter,
    STATE(2016), 1,
      sym_parameter_declaration,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [24653] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2017), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2019), 1,
      anon_sym_RPAREN,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1443), 1,
      sym__declaration_specifiers,
    STATE(2016), 2,
      sym_variadic_parameter,
      sym_parameter_declaration,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [24745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2539), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2541), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [24803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2545), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [24861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2549), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [24919] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(201), 1,
      anon_sym_LBRACE,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(229), 1,
      sym_compound_statement,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__declaration_specifiers,
    STATE(853), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [25011] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(525), 1,
      sym_compound_statement,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__declaration_specifiers,
    STATE(898), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [25103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2551), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2553), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [25161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2555), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2557), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [25219] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(201), 1,
      anon_sym_LBRACE,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(253), 1,
      sym_compound_statement,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__declaration_specifiers,
    STATE(876), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [25311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2559), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2561), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [25369] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(565), 1,
      anon_sym_LBRACE,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(412), 1,
      sym_compound_statement,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__declaration_specifiers,
    STATE(898), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [25461] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(499), 1,
      anon_sym_LBRACE,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(489), 1,
      sym_compound_statement,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__declaration_specifiers,
    STATE(851), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [25553] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(565), 1,
      anon_sym_LBRACE,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(431), 1,
      sym_compound_statement,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__declaration_specifiers,
    STATE(873), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [25645] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(201), 1,
      anon_sym_LBRACE,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(234), 1,
      sym_compound_statement,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__declaration_specifiers,
    STATE(898), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [25737] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(532), 1,
      sym_compound_statement,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__declaration_specifiers,
    STATE(898), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [25829] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(565), 1,
      anon_sym_LBRACE,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(434), 1,
      sym_compound_statement,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__declaration_specifiers,
    STATE(898), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [25921] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(565), 1,
      anon_sym_LBRACE,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(450), 1,
      sym_compound_statement,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__declaration_specifiers,
    STATE(878), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [26013] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(510), 1,
      sym_compound_statement,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__declaration_specifiers,
    STATE(868), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [26105] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(499), 1,
      anon_sym_LBRACE,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(492), 1,
      sym_compound_statement,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__declaration_specifiers,
    STATE(898), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [26197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2563), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2565), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [26255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2567), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2569), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [26313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2571), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2573), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [26371] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(523), 1,
      sym_compound_statement,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__declaration_specifiers,
    STATE(877), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [26463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2575), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2577), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [26521] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2579), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2581), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [26588] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2017), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1443), 1,
      sym__declaration_specifiers,
    STATE(2084), 2,
      sym_variadic_parameter,
      sym_parameter_declaration,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [26677] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2591), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2593), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [26744] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(824), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2509), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2507), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [26805] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2595), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2597), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [26872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2599), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2601), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [26929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2605), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2603), 40,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
  [26986] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2017), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2607), 1,
      sym_identifier,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1443), 1,
      sym__declaration_specifiers,
    STATE(2084), 1,
      sym_parameter_declaration,
    STATE(2095), 1,
      sym_variadic_parameter,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [27077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2609), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2611), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [27134] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2613), 1,
      anon_sym_EQ,
    STATE(824), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2615), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1975), 14,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      sym_identifier,
    ACTIONS(1969), 18,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [27199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2617), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2619), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [27256] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2621), 1,
      sym_identifier,
    ACTIONS(2630), 1,
      anon_sym___attribute__,
    ACTIONS(2633), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2636), 1,
      anon_sym___declspec,
    ACTIONS(2639), 1,
      anon_sym_LBRACE,
    ACTIONS(2644), 1,
      sym_primitive_type,
    ACTIONS(2647), 1,
      anon_sym_enum,
    ACTIONS(2650), 1,
      anon_sym_struct,
    ACTIONS(2653), 1,
      anon_sym_union,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__declaration_specifiers,
    STATE(898), 2,
      sym_declaration,
      aux_sym__old_style_function_definition_repeat1,
    ACTIONS(2641), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2624), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2627), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [27345] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2656), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2658), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [27412] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2660), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2662), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [27477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2664), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2666), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [27534] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2668), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2670), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [27601] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2672), 1,
      sym_identifier,
    STATE(904), 2,
      sym_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2416), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2414), 27,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [27663] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      sym_identifier,
    STATE(904), 2,
      sym_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2677), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2425), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2423), 27,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [27725] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 1,
      sym_identifier,
    STATE(903), 2,
      sym_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2410), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2408), 27,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [27787] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1984), 1,
      anon_sym_EQ,
    STATE(824), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1988), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1975), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1969), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [27851] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2682), 1,
      anon_sym_EQ,
    STATE(905), 1,
      sym_string_literal,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2684), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1975), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      sym_identifier,
    ACTIONS(1969), 17,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [27914] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(908), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2690), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2686), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(2688), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_RBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [27973] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(905), 1,
      sym_string_literal,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1975), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(1969), 27,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [28032] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(905), 1,
      sym_string_literal,
    ACTIONS(1840), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2509), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2507), 27,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [28091] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1523), 1,
      sym__declaration_specifiers,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [28173] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1541), 1,
      sym__declaration_specifiers,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [28255] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1497), 1,
      sym__declaration_specifiers,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [28337] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1554), 1,
      sym__declaration_specifiers,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [28419] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1549), 1,
      sym__declaration_specifiers,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [28501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2438), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2440), 32,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [28555] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1512), 1,
      sym__declaration_specifiers,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [28637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2436), 32,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [28691] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1555), 1,
      sym__declaration_specifiers,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [28773] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1550), 1,
      sym__declaration_specifiers,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [28855] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1551), 1,
      sym__declaration_specifiers,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [28937] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(955), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1543), 1,
      sym__declaration_specifiers,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(932), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [29019] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1984), 1,
      anon_sym_EQ,
    ACTIONS(1986), 1,
      anon_sym_COLON,
    STATE(824), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1988), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1975), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1969), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [29082] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2697), 1,
      anon_sym_LBRACE,
    STATE(965), 1,
      sym_field_declaration_list,
    STATE(1009), 1,
      sym_attribute_specifier,
    ACTIONS(2695), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2693), 34,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29143] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1984), 1,
      anon_sym_EQ,
    ACTIONS(2013), 1,
      anon_sym_COLON,
    STATE(824), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1988), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1975), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1969), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [29206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2701), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_RBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2699), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
  [29259] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1984), 1,
      anon_sym_EQ,
    ACTIONS(2011), 1,
      anon_sym_COLON,
    STATE(824), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1988), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1975), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1969), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [29322] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1984), 1,
      anon_sym_EQ,
    ACTIONS(2703), 1,
      anon_sym_COLON,
    STATE(824), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1988), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1975), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1969), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [29385] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2697), 1,
      anon_sym_LBRACE,
    STATE(966), 1,
      sym_field_declaration_list,
    STATE(1015), 1,
      sym_attribute_specifier,
    ACTIONS(2707), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2705), 34,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29446] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2697), 1,
      anon_sym_LBRACE,
    STATE(984), 1,
      sym_field_declaration_list,
    STATE(1024), 1,
      sym_attribute_specifier,
    ACTIONS(2711), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2709), 34,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29507] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2697), 1,
      anon_sym_LBRACE,
    STATE(956), 1,
      sym_field_declaration_list,
    STATE(992), 1,
      sym_attribute_specifier,
    ACTIONS(2715), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2713), 34,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29568] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(51), 1,
      anon_sym_enum,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(960), 1,
      sym__type_specifier,
    STATE(1006), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(43), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(844), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [29647] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2697), 1,
      anon_sym_LBRACE,
    STATE(985), 1,
      sym_field_declaration_list,
    STATE(1034), 1,
      sym_attribute_specifier,
    ACTIONS(2719), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2717), 34,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [29708] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1984), 1,
      anon_sym_EQ,
    ACTIONS(2009), 1,
      anon_sym_COLON,
    STATE(824), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1988), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1975), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1969), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [29771] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1984), 1,
      anon_sym_EQ,
    ACTIONS(2004), 1,
      anon_sym_COLON,
    STATE(824), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1988), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1975), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1969), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [29834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2701), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2699), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [29887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2723), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(2721), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [29940] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1984), 1,
      anon_sym_EQ,
    ACTIONS(1990), 1,
      anon_sym_COLON,
    STATE(824), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1988), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1975), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1969), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [30003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1949), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1947), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [30055] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2733), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2737), 1,
      anon_sym_PIPE,
    ACTIONS(2739), 1,
      anon_sym_CARET,
    ACTIONS(2741), 1,
      anon_sym_AMP,
    ACTIONS(2751), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2727), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
    ACTIONS(2729), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2743), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2745), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2747), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2731), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2725), 16,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [30141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1937), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1935), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [30193] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2733), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2737), 1,
      anon_sym_PIPE,
    ACTIONS(2739), 1,
      anon_sym_CARET,
    ACTIONS(2741), 1,
      anon_sym_AMP,
    ACTIONS(2751), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2729), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2743), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2745), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2747), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2755), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
    ACTIONS(2731), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2753), 16,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [30279] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2733), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2737), 1,
      anon_sym_PIPE,
    ACTIONS(2739), 1,
      anon_sym_CARET,
    ACTIONS(2741), 1,
      anon_sym_AMP,
    ACTIONS(2751), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2729), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2743), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2745), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2747), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2759), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
    ACTIONS(2731), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2757), 16,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [30365] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2731), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 11,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2597), 23,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [30429] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2737), 1,
      anon_sym_PIPE,
    ACTIONS(2739), 1,
      anon_sym_CARET,
    ACTIONS(2741), 1,
      anon_sym_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2595), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
    ACTIONS(2729), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2743), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2745), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2747), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2731), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2597), 18,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [30511] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2737), 1,
      anon_sym_PIPE,
    ACTIONS(2739), 1,
      anon_sym_CARET,
    ACTIONS(2741), 1,
      anon_sym_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2595), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
    ACTIONS(2729), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2743), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2745), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2747), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2731), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2597), 19,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [30591] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2739), 1,
      anon_sym_CARET,
    ACTIONS(2741), 1,
      anon_sym_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2729), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2743), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2745), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2747), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2595), 3,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(2731), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2597), 19,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [30669] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2741), 1,
      anon_sym_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2729), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2743), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2745), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2747), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2731), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 4,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(2597), 19,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [30745] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2761), 1,
      anon_sym_EQ,
    STATE(824), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2763), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1975), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(1969), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [30805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2767), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2765), 38,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [30857] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2729), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2743), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2745), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2747), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2731), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 5,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2597), 19,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [30931] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2729), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2745), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2747), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2731), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 5,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2597), 21,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [31003] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2729), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2731), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(2597), 23,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [31071] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2729), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2731), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 9,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2597), 23,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [31137] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2771), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
    STATE(961), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2769), 9,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [31200] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(1030), 1,
      sym_attribute_specifier,
    ACTIONS(2775), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2773), 34,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [31255] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2755), 1,
      anon_sym_EQ,
    ACTIONS(2781), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2783), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2785), 1,
      anon_sym_PIPE,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2789), 1,
      anon_sym_AMP,
    ACTIONS(2799), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2777), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2791), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2793), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2795), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2797), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2779), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2753), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2664), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2666), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      sym_identifier,
  [31391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(1008), 1,
      sym_attribute_specifier,
    ACTIONS(2803), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2801), 34,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [31446] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2807), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
    STATE(986), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2805), 9,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [31509] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2811), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
    STATE(844), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2809), 9,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [31572] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(962), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2817), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2815), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2813), 31,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [31627] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2727), 1,
      anon_sym_EQ,
    ACTIONS(2781), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2783), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2785), 1,
      anon_sym_PIPE,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2789), 1,
      anon_sym_AMP,
    ACTIONS(2799), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2777), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2791), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2793), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2795), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2797), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2779), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2725), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2617), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2619), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      sym_identifier,
  [31763] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(1011), 1,
      sym_attribute_specifier,
    ACTIONS(2822), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2820), 34,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [31818] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(1037), 1,
      sym_attribute_specifier,
    ACTIONS(2826), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2824), 34,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [31873] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(991), 1,
      sym_attribute_specifier,
    ACTIONS(2830), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2828), 34,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [31928] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(1031), 1,
      sym_attribute_specifier,
    ACTIONS(2834), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2832), 34,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [31983] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(1012), 1,
      sym_attribute_specifier,
    ACTIONS(2838), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2836), 34,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [32038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2609), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2611), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      sym_identifier,
  [32089] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2777), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2779), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2597), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32154] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2777), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2797), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2779), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(2597), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32221] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2777), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2793), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2795), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2797), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2779), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2597), 21,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32292] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(1020), 1,
      sym_attribute_specifier,
    ACTIONS(2842), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2840), 34,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [32347] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2777), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2791), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2793), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2795), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2797), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2779), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2597), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32420] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2789), 1,
      anon_sym_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2777), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2791), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2793), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2795), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2797), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2595), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(2779), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2597), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32495] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2789), 1,
      anon_sym_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2595), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(2777), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2791), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2793), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2795), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2797), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2779), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2597), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32572] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2595), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      anon_sym_PIPE,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2789), 1,
      anon_sym_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2777), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2791), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2793), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2795), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2797), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2779), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2597), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32651] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2595), 1,
      anon_sym_EQ,
    ACTIONS(2783), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2785), 1,
      anon_sym_PIPE,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2789), 1,
      anon_sym_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2777), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2791), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2793), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2795), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2797), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2779), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2597), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32732] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2779), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2597), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2599), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2601), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      sym_identifier,
  [32846] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2759), 1,
      anon_sym_EQ,
    ACTIONS(2781), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2783), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2785), 1,
      anon_sym_PIPE,
    ACTIONS(2787), 1,
      anon_sym_CARET,
    ACTIONS(2789), 1,
      anon_sym_AMP,
    ACTIONS(2799), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2777), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2791), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2793), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2795), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2797), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2779), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2757), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32931] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2613), 1,
      anon_sym_EQ,
    ACTIONS(2615), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1975), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1969), 19,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [32986] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(1007), 1,
      sym_attribute_specifier,
    ACTIONS(2846), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2844), 34,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [33041] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(1013), 1,
      sym_attribute_specifier,
    ACTIONS(2850), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2848), 34,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [33096] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2854), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
    STATE(844), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2852), 9,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [33159] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 1,
      anon_sym_EQ,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2862), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2864), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2866), 1,
      anon_sym_PIPE,
    ACTIONS(2868), 1,
      anon_sym_CARET,
    ACTIONS(2870), 1,
      anon_sym_AMP,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    ACTIONS(2882), 1,
      anon_sym_QMARK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2858), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2872), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2874), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2876), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2878), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2757), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [33243] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2597), 22,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [33305] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2888), 1,
      anon_sym_LPAREN2,
    STATE(1017), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(1982), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1980), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(1967), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [33361] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2595), 1,
      anon_sym_EQ,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2866), 1,
      anon_sym_PIPE,
    ACTIONS(2868), 1,
      anon_sym_CARET,
    ACTIONS(2870), 1,
      anon_sym_AMP,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2858), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2872), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2874), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2876), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2878), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2597), 18,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [33439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2893), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2891), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [33489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2895), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [33539] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2858), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2872), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2874), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2876), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2878), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2597), 18,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [33611] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2858), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2874), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2876), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2878), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2597), 20,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [33681] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2858), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2878), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(2597), 22,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [33747] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2668), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2670), 22,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [33807] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2858), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2597), 22,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [33871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2899), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [33921] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2595), 1,
      anon_sym_EQ,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2864), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2866), 1,
      anon_sym_PIPE,
    ACTIONS(2868), 1,
      anon_sym_CARET,
    ACTIONS(2870), 1,
      anon_sym_AMP,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2858), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2872), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2874), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2876), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2878), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2597), 17,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [34001] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1027), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2903), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2901), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2899), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [34055] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2591), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2593), 22,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [34115] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2579), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2581), 22,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [34175] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1984), 1,
      anon_sym_EQ,
    ACTIONS(1988), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1975), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1969), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [34229] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2755), 1,
      anon_sym_EQ,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2862), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2864), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2866), 1,
      anon_sym_PIPE,
    ACTIONS(2868), 1,
      anon_sym_CARET,
    ACTIONS(2870), 1,
      anon_sym_AMP,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    ACTIONS(2882), 1,
      anon_sym_QMARK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2858), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2872), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2874), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2876), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2878), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2753), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [34313] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2868), 1,
      anon_sym_CARET,
    ACTIONS(2870), 1,
      anon_sym_AMP,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2595), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(2858), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2872), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2874), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2876), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2878), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2597), 18,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [34389] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2905), 1,
      sym_identifier,
    ACTIONS(2914), 1,
      sym_primitive_type,
    STATE(1036), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2912), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2908), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2910), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [34447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2918), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2916), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [34497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2922), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2920), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [34547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2926), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2924), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [34597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2930), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2928), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [34647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2932), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [34697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2938), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2936), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [34747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2940), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [34797] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1025), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2948), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2946), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2944), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [34851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2952), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2950), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [34901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2956), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2954), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [34951] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(962), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2962), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2960), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2958), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [35005] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2595), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2597), 22,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [35065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2966), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2964), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [35115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2970), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2968), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [35165] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2656), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2658), 22,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [35225] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(962), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2962), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2974), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2972), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [35279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2978), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2976), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [35329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2982), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2980), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [35379] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(962), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2962), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2986), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2984), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [35433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2990), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2988), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [35483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(962), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2962), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2994), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2992), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [35537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2998), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2996), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [35587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3002), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3000), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [35637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3006), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3004), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [35687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3010), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3008), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [35737] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_EQ,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2862), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2864), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2866), 1,
      anon_sym_PIPE,
    ACTIONS(2868), 1,
      anon_sym_CARET,
    ACTIONS(2870), 1,
      anon_sym_AMP,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    ACTIONS(2882), 1,
      anon_sym_QMARK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2858), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2872), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2874), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2876), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2878), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2725), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [35821] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2870), 1,
      anon_sym_AMP,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2858), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2872), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2874), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2876), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2878), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2595), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(2860), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2597), 18,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [35895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3012), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [35945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3018), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3016), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [35995] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      sym_primitive_type,
    STATE(962), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2817), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3023), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3020), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [36051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3028), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3026), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [36101] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1022), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3034), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3032), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3030), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [36155] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2660), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2662), 24,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_identifier,
  [36213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3038), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3036), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [36263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3042), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3040), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [36313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3046), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3044), 35,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [36363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2452), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [36412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3050), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3048), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [36461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3052), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [36510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3056), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [36559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2523), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2525), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [36608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3060), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [36657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3066), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3064), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [36706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2515), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2517), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [36755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3068), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [36804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2474), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2476), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [36853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2533), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [36902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2448), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [36951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2567), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2569), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [37000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2462), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2464), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [37049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2545), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [37098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2539), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2541), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [37147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3074), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3072), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [37196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2527), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2529), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [37245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3078), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3076), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [37294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3080), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [37343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2442), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2444), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [37392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2549), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [37441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2458), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2460), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [37490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1516), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1514), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [37539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3086), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3084), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [37588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1480), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1478), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [37637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3090), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3088), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [37686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1470), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [37735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2555), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2557), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [37784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2559), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2561), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [37833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2571), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2573), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [37882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2484), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [37931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2563), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2565), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [37980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2478), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2480), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [38029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2519), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2521), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [38078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2470), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2472), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [38127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2575), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2577), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [38176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2511), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2513), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [38225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2466), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2468), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [38274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3094), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3092), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [38323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1456), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1454), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [38372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2551), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2553), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [38421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1488), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1486), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [38470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1448), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1446), 40,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [38519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2454), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2456), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [38568] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2682), 1,
      anon_sym_EQ,
    ACTIONS(2684), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1975), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1969), 18,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [38621] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3096), 1,
      anon_sym_SEMI,
    ACTIONS(2771), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(961), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2769), 8,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      sym_identifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [38683] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3102), 1,
      anon_sym___attribute__,
    ACTIONS(3105), 1,
      anon_sym_LBRACE,
    ACTIONS(3107), 1,
      anon_sym_COLON,
    STATE(1040), 1,
      sym_attribute_specifier,
    STATE(1163), 1,
      sym_enumerator_list,
    ACTIONS(3100), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3098), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [38741] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3109), 1,
      anon_sym_SEMI,
    ACTIONS(2771), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(961), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2769), 8,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      sym_identifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [38803] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3111), 1,
      anon_sym_SEMI,
    ACTIONS(2771), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(961), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2769), 8,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      sym_identifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [38865] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3113), 1,
      anon_sym_SEMI,
    ACTIONS(2771), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(961), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2769), 8,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      sym_identifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [38927] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(1290), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3115), 1,
      anon_sym_SEMI,
    ACTIONS(2771), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(961), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2769), 8,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      sym_identifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(45), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [38989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1488), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1486), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [39036] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2595), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2597), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [39095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3074), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3072), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [39142] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3119), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3123), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3121), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(2597), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [39207] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3119), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3121), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2597), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [39270] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2668), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2670), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [39329] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2727), 1,
      anon_sym_EQ,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    ACTIONS(3125), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3129), 1,
      anon_sym_PIPE,
    ACTIONS(3131), 1,
      anon_sym_CARET,
    ACTIONS(3133), 1,
      anon_sym_AMP,
    ACTIONS(3141), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3119), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3123), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3135), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3137), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3139), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3121), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2725), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [39412] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2755), 1,
      anon_sym_EQ,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    ACTIONS(3125), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3129), 1,
      anon_sym_PIPE,
    ACTIONS(3131), 1,
      anon_sym_CARET,
    ACTIONS(3133), 1,
      anon_sym_AMP,
    ACTIONS(3141), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3119), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3123), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3135), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3137), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3139), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3121), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2753), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [39495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1470), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [39542] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3143), 2,
      anon_sym___attribute__,
      sym_identifier,
    ACTIONS(3150), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(3153), 3,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(3146), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_EQ,
    ACTIONS(3148), 28,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
  [39595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3050), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3048), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [39642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3094), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3092), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [39689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3078), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3076), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [39736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3080), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [39783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3052), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [39830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3086), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3084), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [39877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3090), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3088), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [39924] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3155), 2,
      anon_sym___attribute__,
      sym_identifier,
    ACTIONS(3162), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(3165), 3,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(3158), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_EQ,
    ACTIONS(3160), 28,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
  [39977] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3105), 1,
      anon_sym_LBRACE,
    ACTIONS(3171), 1,
      anon_sym___attribute__,
    STATE(1029), 1,
      sym_attribute_specifier,
    STATE(1166), 1,
      sym_enumerator_list,
    ACTIONS(3169), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3167), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [40032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1448), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1446), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [40079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3060), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [40126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3068), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [40173] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3119), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3123), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3137), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3139), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3121), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2597), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [40242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1456), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1454), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [40289] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2595), 1,
      anon_sym_EQ,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    ACTIONS(3127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3129), 1,
      anon_sym_PIPE,
    ACTIONS(3131), 1,
      anon_sym_CARET,
    ACTIONS(3133), 1,
      anon_sym_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3119), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3123), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3135), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3137), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3139), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3121), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2597), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [40368] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3119), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3123), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3135), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3137), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3139), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3121), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2597), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [40439] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2021), 1,
      anon_sym_LPAREN2,
    ACTIONS(2023), 1,
      anon_sym_STAR,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3182), 1,
      anon_sym_LBRACK,
    STATE(1368), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1595), 1,
      sym__declarator,
    STATE(1743), 1,
      sym__abstract_declarator,
    STATE(1788), 1,
      sym_parameter_list,
    STATE(2409), 1,
      sym_ms_based_modifier,
    ACTIONS(3176), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3180), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1255), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1263), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3178), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1786), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [40518] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2021), 1,
      anon_sym_LPAREN2,
    ACTIONS(2023), 1,
      anon_sym_STAR,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3182), 1,
      anon_sym_LBRACK,
    STATE(1368), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1588), 1,
      sym__declarator,
    STATE(1771), 1,
      sym__abstract_declarator,
    STATE(1788), 1,
      sym_parameter_list,
    STATE(2409), 1,
      sym_ms_based_modifier,
    ACTIONS(3180), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3184), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1121), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1245), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3178), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1786), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [40597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3066), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3064), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [40644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3056), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [40691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1480), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1478), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [40738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1516), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1514), 38,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [40785] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2579), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2581), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [40844] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2759), 1,
      anon_sym_EQ,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    ACTIONS(3125), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3129), 1,
      anon_sym_PIPE,
    ACTIONS(3131), 1,
      anon_sym_CARET,
    ACTIONS(3133), 1,
      anon_sym_AMP,
    ACTIONS(3141), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3119), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3123), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3135), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3137), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3139), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3121), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2757), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [40927] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2591), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2593), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [40986] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2656), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2658), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [41045] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3121), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2597), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [41106] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2660), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2662), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [41163] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    ACTIONS(3133), 1,
      anon_sym_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3119), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3123), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3135), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3137), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3139), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2595), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(3121), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2597), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [41236] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    ACTIONS(3131), 1,
      anon_sym_CARET,
    ACTIONS(3133), 1,
      anon_sym_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2595), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3119), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3123), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3135), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3137), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3139), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3121), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2597), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [41311] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2595), 1,
      anon_sym_EQ,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    ACTIONS(3129), 1,
      anon_sym_PIPE,
    ACTIONS(3131), 1,
      anon_sym_CARET,
    ACTIONS(3133), 1,
      anon_sym_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3119), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3123), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3135), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3137), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3139), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3121), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2597), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [41388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(2434), 36,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [41434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(2438), 36,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [41480] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2761), 1,
      anon_sym_EQ,
    ACTIONS(2763), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1975), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(1969), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [41530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3068), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [41575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3078), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3076), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [41620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1480), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(1478), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [41665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1472), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(1470), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [41710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1472), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1470), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [41755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3056), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [41800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3090), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(3088), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [41845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3086), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(3084), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [41890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3058), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(3056), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [41935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3060), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [41980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3066), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3064), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [42025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(3060), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [42070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(3080), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [42115] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(826), 1,
      sym_string_literal,
    ACTIONS(3186), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2765), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [42164] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 1,
      anon_sym___attribute__,
    STATE(1026), 1,
      sym_attribute_specifier,
    ACTIONS(3190), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3188), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [42213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1448), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1446), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [42258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1488), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1486), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [42303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1456), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1454), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [42348] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(829), 1,
      sym_string_literal,
    ACTIONS(3186), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2765), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [42397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3090), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3088), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [42442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3074), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3072), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [42487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1480), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1478), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [42532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1516), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(1514), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [42577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3094), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(3092), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [42622] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3199), 1,
      anon_sym___attribute__,
    STATE(1028), 1,
      sym_attribute_specifier,
    ACTIONS(3197), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3195), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [42671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3066), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(3064), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [42716] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(828), 1,
      sym_string_literal,
    ACTIONS(3186), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2765), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [42765] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym___attribute__,
    STATE(1035), 1,
      sym_attribute_specifier,
    ACTIONS(3204), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3202), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [42814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3078), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(3076), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [42859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3074), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(3072), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [42904] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(823), 1,
      sym_string_literal,
    ACTIONS(3186), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2765), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [42953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3050), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3048), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [42998] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(822), 1,
      sym_string_literal,
    ACTIONS(3186), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2765), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [43047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3052), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [43092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1456), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(1454), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [43137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1488), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(1486), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [43182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(3068), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [43227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3086), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3084), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [43272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1516), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1514), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [43317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(3052), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [43362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3050), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(3048), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [43407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3080), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [43452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3094), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3092), 36,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [43497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1448), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(1446), 35,
      aux_sym_preproc_def_token1,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [43542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1420), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [43586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1414), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1416), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [43630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1326), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1328), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [43674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1300), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [43718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1300), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [43762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1338), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1340), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [43806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1378), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1380), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [43850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1420), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [43894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1378), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1380), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [43938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1414), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1416), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [43982] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3209), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      anon_sym_LPAREN2,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3217), 1,
      sym_primitive_type,
    STATE(1368), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1641), 1,
      sym__type_declarator,
    STATE(2160), 1,
      sym_ms_based_modifier,
    ACTIONS(3180), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1194), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1369), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3178), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3215), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1728), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [44051] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3209), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      anon_sym_LPAREN2,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3217), 1,
      sym_primitive_type,
    STATE(1368), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1648), 1,
      sym__type_declarator,
    STATE(2160), 1,
      sym_ms_based_modifier,
    ACTIONS(3180), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1263), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1362), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3178), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3215), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1728), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [44120] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3209), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      anon_sym_LPAREN2,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3217), 1,
      sym_primitive_type,
    STATE(1368), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1633), 1,
      sym__type_declarator,
    STATE(2160), 1,
      sym_ms_based_modifier,
    ACTIONS(3180), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1263), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1375), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3178), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3215), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1728), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [44189] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3209), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      anon_sym_LPAREN2,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3217), 1,
      sym_primitive_type,
    STATE(1368), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1648), 1,
      sym__type_declarator,
    STATE(2160), 1,
      sym_ms_based_modifier,
    ACTIONS(3180), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1195), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1362), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3178), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3215), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1728), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [44258] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2888), 1,
      anon_sym_LPAREN2,
    ACTIONS(3219), 1,
      anon_sym_COMMA,
    ACTIONS(3222), 1,
      anon_sym_RPAREN,
    STATE(1017), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1909), 1,
      aux_sym__old_style_parameter_list_repeat1,
    ACTIONS(1980), 2,
      anon_sym_STAR,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1982), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1967), 24,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [44313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3227), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3225), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [44356] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2888), 1,
      anon_sym_LPAREN2,
    STATE(1017), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(1980), 2,
      anon_sym_STAR,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3229), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1982), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1967), 24,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [44406] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3235), 1,
      anon_sym_LPAREN2,
    ACTIONS(3239), 1,
      anon_sym_LBRACK,
    STATE(1017), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(1980), 2,
      anon_sym_COMMA,
      anon_sym_STAR,
    ACTIONS(3232), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1982), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1967), 23,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_identifier,
  [44458] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3244), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3250), 1,
      anon_sym_SLASH,
    ACTIONS(3252), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3254), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3256), 1,
      anon_sym_PIPE,
    ACTIONS(3258), 1,
      anon_sym_CARET,
    ACTIONS(3260), 1,
      anon_sym_AMP,
    ACTIONS(3270), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3248), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3262), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3264), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3266), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3242), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [44535] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3250), 1,
      anon_sym_SLASH,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3248), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2595), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2597), 16,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      sym_identifier,
  [44590] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2595), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3250), 1,
      anon_sym_SLASH,
    ACTIONS(3254), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3256), 1,
      anon_sym_PIPE,
    ACTIONS(3258), 1,
      anon_sym_CARET,
    ACTIONS(3260), 1,
      anon_sym_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3248), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3262), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3264), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3266), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2597), 8,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      sym_identifier,
  [44663] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2595), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3250), 1,
      anon_sym_SLASH,
    ACTIONS(3256), 1,
      anon_sym_PIPE,
    ACTIONS(3258), 1,
      anon_sym_CARET,
    ACTIONS(3260), 1,
      anon_sym_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3248), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3262), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3264), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3266), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2597), 9,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      sym_identifier,
  [44734] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3250), 1,
      anon_sym_SLASH,
    ACTIONS(3258), 1,
      anon_sym_CARET,
    ACTIONS(3260), 1,
      anon_sym_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2595), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
    ACTIONS(3246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3248), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3262), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3264), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3266), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2597), 9,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      sym_identifier,
  [44803] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3250), 1,
      anon_sym_SLASH,
    ACTIONS(3260), 1,
      anon_sym_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2595), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
    ACTIONS(3246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3248), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3262), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3264), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3266), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2597), 10,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      sym_identifier,
  [44870] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3250), 1,
      anon_sym_SLASH,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3248), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2595), 5,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2597), 14,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      sym_identifier,
  [44929] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2755), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3250), 1,
      anon_sym_SLASH,
    ACTIONS(3252), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3254), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3256), 1,
      anon_sym_PIPE,
    ACTIONS(3258), 1,
      anon_sym_CARET,
    ACTIONS(3260), 1,
      anon_sym_AMP,
    ACTIONS(3270), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3248), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3262), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3264), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3266), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2753), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [45006] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2759), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3250), 1,
      anon_sym_SLASH,
    ACTIONS(3252), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3254), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3256), 1,
      anon_sym_PIPE,
    ACTIONS(3258), 1,
      anon_sym_CARET,
    ACTIONS(3260), 1,
      anon_sym_AMP,
    ACTIONS(3270), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3248), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3262), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3264), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3266), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2757), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [45083] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2727), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3250), 1,
      anon_sym_SLASH,
    ACTIONS(3252), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3254), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3256), 1,
      anon_sym_PIPE,
    ACTIONS(3258), 1,
      anon_sym_CARET,
    ACTIONS(3260), 1,
      anon_sym_AMP,
    ACTIONS(3270), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3248), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3262), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3264), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3266), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2725), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [45160] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3250), 1,
      anon_sym_SLASH,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3248), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3264), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3266), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2595), 3,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2597), 12,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      sym_identifier,
  [45223] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3250), 1,
      anon_sym_SLASH,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3248), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3262), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3264), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3266), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2595), 3,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2597), 10,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      sym_identifier,
  [45288] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3250), 1,
      anon_sym_SLASH,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3248), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2595), 5,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2597), 16,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      sym_identifier,
  [45345] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2595), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2597), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [45409] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2595), 6,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2597), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [45463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3288), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(3286), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [45503] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2595), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2597), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [45559] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2597), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [45627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1300), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(1298), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [45667] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2595), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2597), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [45725] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2701), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3296), 1,
      anon_sym_typedef,
    ACTIONS(2699), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [45767] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2725), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [45841] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2597), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [45911] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2757), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [45985] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2595), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2597), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [46047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1328), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(1326), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [46087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1416), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(1414), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [46127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1416), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(1414), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [46167] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2595), 1,
      anon_sym_PIPE,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2597), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [46235] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2701), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3304), 1,
      anon_sym_typedef,
    ACTIONS(2699), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [46277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1300), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(1298), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [46317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3306), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(3160), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [46357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3310), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(3308), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [46397] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2701), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3312), 1,
      anon_sym_typedef,
    ACTIONS(2699), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [46439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1380), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(1378), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [46479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1380), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(1378), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [46519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1340), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(1338), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [46559] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2595), 1,
      anon_sym_PIPE,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2597), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [46625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1420), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(1418), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [46665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2701), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3314), 1,
      anon_sym_typedef,
    ACTIONS(2699), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [46707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2701), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3316), 1,
      anon_sym_typedef,
    ACTIONS(2699), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [46749] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2753), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [46823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1420), 2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(1418), 30,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [46863] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    ACTIONS(3322), 1,
      anon_sym_SLASH,
    ACTIONS(3324), 1,
      anon_sym_PIPE,
    ACTIONS(3326), 1,
      anon_sym_CARET,
    ACTIONS(3328), 1,
      anon_sym_AMP,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3318), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3320), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3330), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3332), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3336), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2597), 8,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      sym_identifier,
  [46930] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2021), 1,
      anon_sym_LPAREN2,
    ACTIONS(2023), 1,
      anon_sym_STAR,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3182), 1,
      anon_sym_LBRACK,
    STATE(1595), 1,
      sym__declarator,
    STATE(1743), 1,
      sym__abstract_declarator,
    STATE(1788), 1,
      sym_parameter_list,
    STATE(2409), 1,
      sym_ms_based_modifier,
    ACTIONS(3176), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1786), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [46993] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    ACTIONS(2133), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3182), 1,
      anon_sym_LBRACK,
    STATE(1368), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1743), 1,
      sym__abstract_declarator,
    STATE(1788), 1,
      sym_parameter_list,
    ACTIONS(3340), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3342), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1263), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1399), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3176), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1786), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3338), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [47058] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    ACTIONS(3322), 1,
      anon_sym_SLASH,
    ACTIONS(3324), 1,
      anon_sym_PIPE,
    ACTIONS(3326), 1,
      anon_sym_CARET,
    ACTIONS(3328), 1,
      anon_sym_AMP,
    ACTIONS(3344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3346), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3348), 1,
      anon_sym_QMARK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3318), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3320), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3330), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3332), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3336), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2753), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_identifier,
  [47131] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    ACTIONS(2133), 1,
      anon_sym_STAR,
    ACTIONS(3178), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3182), 1,
      anon_sym_LBRACK,
    STATE(1368), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1771), 1,
      sym__abstract_declarator,
    STATE(1788), 1,
      sym_parameter_list,
    ACTIONS(3340), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3342), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1246), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1395), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3184), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1786), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3338), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [47196] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    ACTIONS(3322), 1,
      anon_sym_SLASH,
    ACTIONS(3324), 1,
      anon_sym_PIPE,
    ACTIONS(3326), 1,
      anon_sym_CARET,
    ACTIONS(3328), 1,
      anon_sym_AMP,
    ACTIONS(3344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3346), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3348), 1,
      anon_sym_QMARK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3318), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3320), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3330), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3332), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3336), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2725), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_identifier,
  [47269] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    ACTIONS(3322), 1,
      anon_sym_SLASH,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2595), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3318), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3320), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3330), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3332), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3336), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2597), 9,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      sym_identifier,
  [47332] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    ACTIONS(3322), 1,
      anon_sym_SLASH,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2595), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3318), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3320), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3332), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3336), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2597), 11,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      sym_identifier,
  [47393] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    ACTIONS(3322), 1,
      anon_sym_SLASH,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3318), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3320), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2595), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2597), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      sym_identifier,
  [47448] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    ACTIONS(3322), 1,
      anon_sym_SLASH,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3318), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3320), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3336), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2595), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2597), 13,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      sym_identifier,
  [47505] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2595), 1,
      anon_sym_PIPE,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    ACTIONS(3322), 1,
      anon_sym_SLASH,
    ACTIONS(3328), 1,
      anon_sym_AMP,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3318), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3320), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3330), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3332), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3336), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2597), 9,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      sym_identifier,
  [47570] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2021), 1,
      anon_sym_LPAREN2,
    ACTIONS(2023), 1,
      anon_sym_STAR,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3182), 1,
      anon_sym_LBRACK,
    STATE(1600), 1,
      sym__declarator,
    STATE(1750), 1,
      sym__abstract_declarator,
    STATE(1788), 1,
      sym_parameter_list,
    STATE(2409), 1,
      sym_ms_based_modifier,
    ACTIONS(3350), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1786), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [47633] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2595), 1,
      anon_sym_PIPE,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    ACTIONS(3322), 1,
      anon_sym_SLASH,
    ACTIONS(3326), 1,
      anon_sym_CARET,
    ACTIONS(3328), 1,
      anon_sym_AMP,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3318), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3320), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3330), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3332), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3336), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2597), 8,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      sym_identifier,
  [47700] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    ACTIONS(3322), 1,
      anon_sym_SLASH,
    ACTIONS(3324), 1,
      anon_sym_PIPE,
    ACTIONS(3326), 1,
      anon_sym_CARET,
    ACTIONS(3328), 1,
      anon_sym_AMP,
    ACTIONS(3344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3346), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3348), 1,
      anon_sym_QMARK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3318), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3320), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3330), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3332), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3336), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2757), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_identifier,
  [47773] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    ACTIONS(3322), 1,
      anon_sym_SLASH,
    ACTIONS(3324), 1,
      anon_sym_PIPE,
    ACTIONS(3326), 1,
      anon_sym_CARET,
    ACTIONS(3328), 1,
      anon_sym_AMP,
    ACTIONS(3344), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3346), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3348), 1,
      anon_sym_QMARK,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3318), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3320), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3330), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3332), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3336), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3242), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_identifier,
  [47846] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    ACTIONS(3322), 1,
      anon_sym_SLASH,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3320), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2595), 6,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2597), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      sym_identifier,
  [47899] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(2880), 1,
      anon_sym_LBRACK,
    ACTIONS(3322), 1,
      anon_sym_SLASH,
    ACTIONS(3324), 1,
      anon_sym_PIPE,
    ACTIONS(3326), 1,
      anon_sym_CARET,
    ACTIONS(3328), 1,
      anon_sym_AMP,
    ACTIONS(3346), 1,
      anon_sym_AMP_AMP,
    STATE(1071), 1,
      sym_argument_list,
    ACTIONS(2884), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2886), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3318), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3320), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3330), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3332), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3334), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3336), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2597), 7,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      sym_identifier,
  [47968] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LPAREN2,
    ACTIONS(3356), 1,
      anon_sym_STAR,
    STATE(1368), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1626), 1,
      sym__field_declarator,
    STATE(2385), 1,
      sym_ms_based_modifier,
    ACTIONS(3180), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1263), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1400), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3178), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1710), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [48028] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(1368), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1600), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    ACTIONS(3180), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1263), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1407), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3178), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [48088] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1368), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(3369), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1263), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3366), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3364), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3362), 16,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [48134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3372), 11,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
    ACTIONS(3374), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
  [48172] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LPAREN2,
    ACTIONS(3356), 1,
      anon_sym_STAR,
    STATE(1368), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1615), 1,
      sym__field_declarator,
    STATE(2385), 1,
      sym_ms_based_modifier,
    ACTIONS(3180), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1263), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1413), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3178), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1710), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [48232] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(1368), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1595), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    ACTIONS(3180), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1262), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1406), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3178), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [48292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3376), 11,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
    ACTIONS(3378), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
  [48330] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(1368), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1588), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    ACTIONS(3180), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1272), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1411), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3178), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [48390] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LPAREN2,
    ACTIONS(3356), 1,
      anon_sym_STAR,
    STATE(1368), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1626), 1,
      sym__field_declarator,
    STATE(2385), 1,
      sym_ms_based_modifier,
    ACTIONS(3180), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1265), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1400), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3178), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1710), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [48450] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LPAREN2,
    ACTIONS(3356), 1,
      anon_sym_STAR,
    STATE(1368), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1610), 1,
      sym__field_declarator,
    STATE(2385), 1,
      sym_ms_based_modifier,
    ACTIONS(3180), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1261), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1404), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3178), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1710), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [48510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3380), 11,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
    ACTIONS(3382), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
  [48548] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(1368), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1595), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    ACTIONS(3180), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1263), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1406), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3178), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [48608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3384), 11,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
    ACTIONS(3386), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
  [48646] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3390), 3,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
  [48720] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3392), 1,
      anon_sym_COMMA,
    ACTIONS(3394), 1,
      anon_sym_RPAREN,
    STATE(870), 1,
      sym_argument_list,
    STATE(1982), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [48795] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3396), 1,
      anon_sym_COMMA,
    ACTIONS(3398), 1,
      anon_sym_RPAREN,
    STATE(870), 1,
      sym_argument_list,
    STATE(1891), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [48870] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3400), 1,
      anon_sym_COMMA,
    ACTIONS(3402), 1,
      anon_sym_RBRACE,
    STATE(870), 1,
      sym_argument_list,
    STATE(1992), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [48945] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3396), 1,
      anon_sym_COMMA,
    ACTIONS(3404), 1,
      anon_sym_RPAREN,
    STATE(870), 1,
      sym_argument_list,
    STATE(1977), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [49020] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3406), 1,
      anon_sym_COMMA,
    ACTIONS(3408), 1,
      anon_sym_RBRACE,
    STATE(870), 1,
      sym_argument_list,
    STATE(1938), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [49095] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3396), 1,
      anon_sym_COMMA,
    ACTIONS(3410), 1,
      anon_sym_RPAREN,
    STATE(870), 1,
      sym_argument_list,
    STATE(2004), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [49170] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3412), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [49241] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3396), 1,
      anon_sym_COMMA,
    ACTIONS(3414), 1,
      anon_sym_RPAREN,
    STATE(870), 1,
      sym_argument_list,
    STATE(1886), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [49316] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3392), 1,
      anon_sym_COMMA,
    ACTIONS(3416), 1,
      anon_sym_RPAREN,
    STATE(870), 1,
      sym_argument_list,
    STATE(1953), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [49391] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2595), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2597), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [49447] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3426), 1,
      anon_sym_SEMI,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [49519] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3428), 1,
      anon_sym_SEMI,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [49591] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1933), 1,
      anon_sym_enum,
    ACTIONS(3430), 1,
      sym_identifier,
    ACTIONS(3434), 1,
      sym_primitive_type,
    STATE(1472), 1,
      sym__type_specifier,
    STATE(1505), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1565), 1,
      sym__type_definition_type,
    STATE(1355), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3432), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [49647] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3436), 1,
      anon_sym_RPAREN,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [49719] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3438), 1,
      anon_sym_SEMI,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [49791] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3440), 1,
      anon_sym_RPAREN,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [49863] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3442), 1,
      anon_sym_RPAREN,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [49935] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2595), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2597), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [49989] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3444), 1,
      anon_sym_RPAREN,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [50061] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3446), 1,
      anon_sym_SEMI,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [50133] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2099), 1,
      sym_identifier,
    ACTIONS(3448), 1,
      anon_sym_enum,
    STATE(1398), 1,
      sym__type_specifier,
    STATE(1403), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2199), 1,
      sym_type_descriptor,
    STATE(1385), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1931), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [50189] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3450), 1,
      anon_sym_COLON,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [50261] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2099), 1,
      sym_identifier,
    ACTIONS(3448), 1,
      anon_sym_enum,
    STATE(1398), 1,
      sym__type_specifier,
    STATE(1403), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2381), 1,
      sym_type_descriptor,
    STATE(1385), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1931), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [50317] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1933), 1,
      anon_sym_enum,
    ACTIONS(3430), 1,
      sym_identifier,
    ACTIONS(3434), 1,
      sym_primitive_type,
    STATE(1472), 1,
      sym__type_specifier,
    STATE(1505), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1566), 1,
      sym__type_definition_type,
    STATE(1355), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3432), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [50373] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3452), 1,
      anon_sym_RPAREN,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [50445] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3454), 1,
      anon_sym_RPAREN,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [50517] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3456), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [50587] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3458), 1,
      anon_sym_SEMI,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [50659] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3460), 1,
      anon_sym_SEMI,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [50731] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3462), 1,
      anon_sym_COLON,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [50803] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3464), 1,
      anon_sym_COLON,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [50875] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1933), 1,
      anon_sym_enum,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(1398), 1,
      sym__type_specifier,
    STATE(1403), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2280), 1,
      sym_type_descriptor,
    STATE(1373), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1931), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [50931] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3466), 1,
      anon_sym_RPAREN,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [51003] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2595), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2597), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [51063] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2099), 1,
      sym_identifier,
    ACTIONS(3448), 1,
      anon_sym_enum,
    STATE(1398), 1,
      sym__type_specifier,
    STATE(1403), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2358), 1,
      sym_type_descriptor,
    STATE(1385), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1931), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [51119] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3472), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [51189] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3474), 1,
      anon_sym_SEMI,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [51261] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3476), 1,
      anon_sym_SEMI,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [51333] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3478), 1,
      anon_sym_SEMI,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [51405] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2595), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2597), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [51467] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3482), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [51537] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3484), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [51607] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1933), 1,
      anon_sym_enum,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(1398), 1,
      sym__type_specifier,
    STATE(1403), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2287), 1,
      sym_type_descriptor,
    STATE(1373), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1931), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [51663] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3486), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [51733] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2595), 1,
      anon_sym_PIPE,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    ACTIONS(3488), 1,
      anon_sym_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2597), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [51797] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3490), 1,
      anon_sym_COLON,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [51869] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2595), 1,
      anon_sym_PIPE,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    ACTIONS(3488), 1,
      anon_sym_AMP,
    ACTIONS(3492), 1,
      anon_sym_CARET,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2597), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [51935] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    ACTIONS(3488), 1,
      anon_sym_AMP,
    ACTIONS(3492), 1,
      anon_sym_CARET,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2597), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [52001] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    ACTIONS(3488), 1,
      anon_sym_AMP,
    ACTIONS(3492), 1,
      anon_sym_CARET,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3496), 1,
      anon_sym_AMP_AMP,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2597), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [52069] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3242), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [52139] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1933), 1,
      anon_sym_enum,
    ACTIONS(3430), 1,
      sym_identifier,
    ACTIONS(3434), 1,
      sym_primitive_type,
    STATE(1472), 1,
      sym__type_specifier,
    STATE(1505), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1558), 1,
      sym__type_definition_type,
    STATE(1355), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3432), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [52195] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1933), 1,
      anon_sym_enum,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(1398), 1,
      sym__type_specifier,
    STATE(1403), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2378), 1,
      sym_type_descriptor,
    STATE(1373), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1931), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [52251] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3498), 1,
      anon_sym_RPAREN,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [52323] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3500), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [52393] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1933), 1,
      anon_sym_enum,
    ACTIONS(3430), 1,
      sym_identifier,
    ACTIONS(3434), 1,
      sym_primitive_type,
    STATE(1472), 1,
      sym__type_specifier,
    STATE(1505), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1557), 1,
      sym__type_definition_type,
    STATE(1355), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3432), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [52449] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2595), 6,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2597), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [52501] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3502), 1,
      anon_sym_COLON,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [52573] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3504), 1,
      anon_sym_COLON,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [52645] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1933), 1,
      anon_sym_enum,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(1398), 1,
      sym__type_specifier,
    STATE(1403), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2314), 1,
      sym_type_descriptor,
    STATE(1373), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1931), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [52701] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1933), 1,
      anon_sym_enum,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(1398), 1,
      sym__type_specifier,
    STATE(1403), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2277), 1,
      sym_type_descriptor,
    STATE(1373), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1931), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [52757] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    ACTIONS(3488), 1,
      anon_sym_AMP,
    ACTIONS(3492), 1,
      anon_sym_CARET,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3506), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3510), 1,
      anon_sym_RBRACK,
    ACTIONS(3512), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [52831] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1933), 1,
      anon_sym_enum,
    ACTIONS(3430), 1,
      sym_identifier,
    ACTIONS(3434), 1,
      sym_primitive_type,
    STATE(1472), 1,
      sym__type_specifier,
    STATE(1505), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1559), 1,
      sym__type_definition_type,
    STATE(1355), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3432), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [52887] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    ACTIONS(3488), 1,
      anon_sym_AMP,
    ACTIONS(3492), 1,
      anon_sym_CARET,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2757), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [52959] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3514), 1,
      anon_sym_COLON,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [53031] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1933), 1,
      anon_sym_enum,
    ACTIONS(3430), 1,
      sym_identifier,
    ACTIONS(3434), 1,
      sym_primitive_type,
    STATE(1472), 1,
      sym__type_specifier,
    STATE(1505), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1564), 1,
      sym__type_definition_type,
    STATE(1355), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3432), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [53087] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1933), 1,
      anon_sym_enum,
    ACTIONS(3430), 1,
      sym_identifier,
    ACTIONS(3434), 1,
      sym_primitive_type,
    STATE(1472), 1,
      sym__type_specifier,
    STATE(1505), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1562), 1,
      sym__type_definition_type,
    STATE(1355), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3432), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [53143] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3516), 1,
      anon_sym_SEMI,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [53215] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3518), 1,
      anon_sym_SEMI,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [53287] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1933), 1,
      anon_sym_enum,
    ACTIONS(3430), 1,
      sym_identifier,
    ACTIONS(3434), 1,
      sym_primitive_type,
    STATE(1472), 1,
      sym__type_specifier,
    STATE(1505), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1561), 1,
      sym__type_definition_type,
    STATE(1355), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3432), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [53343] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1933), 1,
      anon_sym_enum,
    ACTIONS(3430), 1,
      sym_identifier,
    ACTIONS(3434), 1,
      sym_primitive_type,
    STATE(1472), 1,
      sym__type_specifier,
    STATE(1505), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1560), 1,
      sym__type_definition_type,
    STATE(1355), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3432), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [53399] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    ACTIONS(3488), 1,
      anon_sym_AMP,
    ACTIONS(3492), 1,
      anon_sym_CARET,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2753), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [53471] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1933), 1,
      anon_sym_enum,
    ACTIONS(3430), 1,
      sym_identifier,
    ACTIONS(3434), 1,
      sym_primitive_type,
    STATE(1472), 1,
      sym__type_specifier,
    STATE(1505), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1563), 1,
      sym__type_definition_type,
    STATE(1355), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3432), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [53527] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3520), 1,
      anon_sym_SEMI,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [53599] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3522), 1,
      anon_sym_SEMI,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [53671] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3524), 1,
      anon_sym_SEMI,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [53743] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3526), 1,
      anon_sym_RPAREN,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [53815] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3528), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [53885] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2589), 1,
      anon_sym_DASH_GT,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3117), 1,
      anon_sym_DOT,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    ACTIONS(3488), 1,
      anon_sym_AMP,
    ACTIONS(3492), 1,
      anon_sym_CARET,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2725), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [53957] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_COMMA,
    ACTIONS(3530), 1,
      anon_sym_COLON,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [54029] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2324), 1,
      anon_sym_RBRACK,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    ACTIONS(3488), 1,
      anon_sym_AMP,
    ACTIONS(3492), 1,
      anon_sym_CARET,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [54098] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1933), 1,
      anon_sym_enum,
    ACTIONS(3430), 1,
      sym_identifier,
    ACTIONS(3434), 1,
      sym_primitive_type,
    STATE(1453), 1,
      sym__type_specifier,
    STATE(1505), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3432), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [54151] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2366), 1,
      anon_sym_RBRACK,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    ACTIONS(3488), 1,
      anon_sym_AMP,
    ACTIONS(3492), 1,
      anon_sym_CARET,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [54220] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3532), 1,
      anon_sym_COLON,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [54289] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3534), 1,
      anon_sym_COMMA,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [54358] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2362), 1,
      anon_sym_RBRACK,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    ACTIONS(3488), 1,
      anon_sym_AMP,
    ACTIONS(3492), 1,
      anon_sym_CARET,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [54427] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2330), 1,
      anon_sym_RBRACK,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    ACTIONS(3488), 1,
      anon_sym_AMP,
    ACTIONS(3492), 1,
      anon_sym_CARET,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [54496] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3536), 1,
      anon_sym_COLON,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [54565] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3209), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      anon_sym_LPAREN2,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3217), 1,
      sym_primitive_type,
    STATE(1633), 1,
      sym__type_declarator,
    STATE(2160), 1,
      sym_ms_based_modifier,
    STATE(1383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3215), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1728), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [54618] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2364), 1,
      anon_sym_RBRACK,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    ACTIONS(3488), 1,
      anon_sym_AMP,
    ACTIONS(3492), 1,
      anon_sym_CARET,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [54687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3540), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3538), 21,
      anon_sym___extension__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [54722] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3542), 1,
      anon_sym_RPAREN,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [54791] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2346), 1,
      anon_sym_RBRACK,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    ACTIONS(3488), 1,
      anon_sym_AMP,
    ACTIONS(3492), 1,
      anon_sym_CARET,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [54860] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3544), 1,
      anon_sym_COMMA,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [54929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3548), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3546), 21,
      anon_sym___extension__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [54964] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3209), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      anon_sym_LPAREN2,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3217), 1,
      sym_primitive_type,
    STATE(1648), 1,
      sym__type_declarator,
    STATE(2160), 1,
      sym_ms_based_modifier,
    STATE(1383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3215), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1728), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [55017] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3550), 1,
      anon_sym_COLON,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [55086] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3552), 1,
      anon_sym_COLON,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [55155] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    ACTIONS(3488), 1,
      anon_sym_AMP,
    ACTIONS(3492), 1,
      anon_sym_CARET,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_QMARK,
    ACTIONS(3554), 1,
      anon_sym_RBRACK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [55224] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(1933), 1,
      anon_sym_enum,
    ACTIONS(2099), 1,
      sym_identifier,
    STATE(1396), 1,
      sym__type_specifier,
    STATE(1403), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1931), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [55277] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    ACTIONS(3488), 1,
      anon_sym_AMP,
    ACTIONS(3492), 1,
      anon_sym_CARET,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_QMARK,
    ACTIONS(3556), 1,
      anon_sym_RBRACK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [55346] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3209), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      anon_sym_LPAREN2,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3217), 1,
      sym_primitive_type,
    STATE(1643), 1,
      sym__type_declarator,
    STATE(2160), 1,
      sym_ms_based_modifier,
    STATE(1383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3215), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1728), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [55399] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_RBRACK,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    ACTIONS(3488), 1,
      anon_sym_AMP,
    ACTIONS(3492), 1,
      anon_sym_CARET,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [55468] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3558), 1,
      anon_sym_COLON,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [55537] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2328), 1,
      anon_sym_RBRACK,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    ACTIONS(3488), 1,
      anon_sym_AMP,
    ACTIONS(3492), 1,
      anon_sym_CARET,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [55606] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3560), 1,
      anon_sym_RPAREN,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [55675] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    ACTIONS(3488), 1,
      anon_sym_AMP,
    ACTIONS(3492), 1,
      anon_sym_CARET,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_QMARK,
    ACTIONS(3562), 1,
      anon_sym_RBRACK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [55744] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2334), 1,
      anon_sym_RBRACK,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    ACTIONS(3488), 1,
      anon_sym_AMP,
    ACTIONS(3492), 1,
      anon_sym_CARET,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [55813] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    ACTIONS(3564), 1,
      anon_sym_COLON,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [55882] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2688), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3566), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2686), 10,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [55921] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2326), 1,
      anon_sym_RBRACK,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(2856), 1,
      anon_sym_LPAREN2,
    ACTIONS(3422), 1,
      anon_sym_SLASH,
    ACTIONS(3488), 1,
      anon_sym_AMP,
    ACTIONS(3492), 1,
      anon_sym_CARET,
    ACTIONS(3494), 1,
      anon_sym_PIPE,
    ACTIONS(3496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3508), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3420), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3468), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3480), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [55990] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      sym_primitive_type,
    ACTIONS(53), 1,
      anon_sym_struct,
    ACTIONS(55), 1,
      anon_sym_union,
    ACTIONS(2099), 1,
      sym_identifier,
    ACTIONS(3448), 1,
      anon_sym_enum,
    STATE(1396), 1,
      sym__type_specifier,
    STATE(1403), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1931), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(998), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [56043] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(3105), 1,
      anon_sym_LBRACE,
    STATE(1029), 1,
      sym_attribute_specifier,
    STATE(1392), 1,
      sym_enumerator_list,
    ACTIONS(3169), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3167), 16,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [56085] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    ACTIONS(3276), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 1,
      anon_sym_CARET,
    ACTIONS(3294), 1,
      anon_sym_AMP,
    ACTIONS(3298), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3300), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3302), 1,
      anon_sym_QMARK,
    STATE(870), 1,
      sym_argument_list,
    ACTIONS(2587), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2589), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3272), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3274), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3278), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3280), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3282), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [56151] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_SEMI,
    ACTIONS(2571), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2573), 18,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [56187] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(3105), 1,
      anon_sym_LBRACE,
    ACTIONS(3571), 1,
      anon_sym_COLON,
    STATE(1040), 1,
      sym_attribute_specifier,
    STATE(1391), 1,
      sym_enumerator_list,
    ACTIONS(3100), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
    ACTIONS(3098), 16,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [56231] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(1026), 1,
      sym_attribute_specifier,
    ACTIONS(3190), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3188), 16,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [56267] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(1028), 1,
      sym_attribute_specifier,
    ACTIONS(3197), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3195), 16,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [56303] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    STATE(1035), 1,
      sym_attribute_specifier,
    ACTIONS(3204), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3202), 16,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [56339] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3209), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      anon_sym_LPAREN2,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3217), 1,
      sym_primitive_type,
    STATE(1568), 1,
      sym_ms_call_modifier,
    STATE(1716), 1,
      sym__type_declarator,
    STATE(2160), 1,
      sym_ms_based_modifier,
    ACTIONS(3215), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1728), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [56388] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    ACTIONS(2133), 1,
      anon_sym_STAR,
    ACTIONS(3182), 1,
      anon_sym_LBRACK,
    STATE(1751), 1,
      sym__abstract_declarator,
    STATE(1788), 1,
      sym_parameter_list,
    STATE(1383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3573), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1786), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3338), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [56435] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    ACTIONS(2133), 1,
      anon_sym_STAR,
    ACTIONS(3182), 1,
      anon_sym_LBRACK,
    STATE(1743), 1,
      sym__abstract_declarator,
    STATE(1788), 1,
      sym_parameter_list,
    STATE(1383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3176), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1786), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3338), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [56482] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    ACTIONS(2133), 1,
      anon_sym_STAR,
    ACTIONS(3182), 1,
      anon_sym_LBRACK,
    STATE(1755), 1,
      sym__abstract_declarator,
    STATE(1788), 1,
      sym_parameter_list,
    STATE(1397), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3575), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1786), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3338), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [56529] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    ACTIONS(2133), 1,
      anon_sym_STAR,
    ACTIONS(3182), 1,
      anon_sym_LBRACK,
    STATE(1744), 1,
      sym__abstract_declarator,
    STATE(1788), 1,
      sym_parameter_list,
    STATE(1383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3577), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1786), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3338), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [56576] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    ACTIONS(2133), 1,
      anon_sym_STAR,
    ACTIONS(3182), 1,
      anon_sym_LBRACK,
    STATE(1741), 1,
      sym__abstract_declarator,
    STATE(1788), 1,
      sym_parameter_list,
    STATE(1394), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3579), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1786), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3338), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [56623] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_const,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    ACTIONS(2133), 1,
      anon_sym_STAR,
    ACTIONS(3182), 1,
      anon_sym_LBRACK,
    STATE(1750), 1,
      sym__abstract_declarator,
    STATE(1788), 1,
      sym_parameter_list,
    STATE(1383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3350), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1786), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3338), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [56670] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LPAREN2,
    ACTIONS(3356), 1,
      anon_sym_STAR,
    STATE(1615), 1,
      sym__field_declarator,
    STATE(2385), 1,
      sym_ms_based_modifier,
    STATE(1383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1710), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [56714] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(879), 1,
      sym__old_style_function_declarator,
    STATE(1601), 1,
      sym_ms_call_modifier,
    STATE(1646), 1,
      sym__declarator,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1752), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(1927), 1,
      sym_init_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [56768] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 1,
      anon_sym_LPAREN2,
    STATE(1273), 1,
      sym_preproc_argument_list,
    ACTIONS(3587), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3583), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [56802] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2914), 1,
      sym_primitive_type,
    ACTIONS(3589), 1,
      sym_identifier,
    STATE(1408), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3591), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2908), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2910), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [56840] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LPAREN2,
    ACTIONS(3356), 1,
      anon_sym_STAR,
    STATE(1626), 1,
      sym__field_declarator,
    STATE(2385), 1,
      sym_ms_based_modifier,
    STATE(1383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1710), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [56884] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(852), 1,
      sym__old_style_function_declarator,
    STATE(1591), 1,
      sym_ms_call_modifier,
    STATE(1632), 1,
      sym__declarator,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1745), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(1900), 1,
      sym_init_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [56938] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(1600), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [56982] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(1586), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [57026] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(962), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2813), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(2817), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3023), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3020), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [57062] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(871), 1,
      sym__old_style_function_declarator,
    STATE(1604), 1,
      sym_ms_call_modifier,
    STATE(1640), 1,
      sym__declarator,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1740), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(1949), 1,
      sym_init_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [57116] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(885), 1,
      sym__old_style_function_declarator,
    STATE(1599), 1,
      sym_ms_call_modifier,
    STATE(1634), 1,
      sym__declarator,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1747), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(2002), 1,
      sym_init_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [57170] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(1595), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [57214] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(849), 1,
      sym__old_style_function_declarator,
    STATE(1584), 1,
      sym_ms_call_modifier,
    STATE(1639), 1,
      sym__declarator,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1782), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(1964), 1,
      sym_init_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [57268] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LPAREN2,
    ACTIONS(3356), 1,
      anon_sym_STAR,
    STATE(1608), 1,
      sym__field_declarator,
    STATE(2385), 1,
      sym_ms_based_modifier,
    STATE(1383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1710), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [57312] = 5,
    ACTIONS(3583), 1,
      anon_sym_LF,
    ACTIONS(3593), 1,
      anon_sym_LPAREN2,
    ACTIONS(3595), 1,
      sym_comment,
    STATE(1509), 1,
      sym_preproc_argument_list,
    ACTIONS(3587), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [57345] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3597), 1,
      anon_sym_COMMA,
    ACTIONS(3599), 1,
      anon_sym_RPAREN,
    ACTIONS(3605), 1,
      anon_sym_SLASH,
    ACTIONS(3607), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3611), 1,
      anon_sym_PIPE,
    ACTIONS(3613), 1,
      anon_sym_CARET,
    ACTIONS(3615), 1,
      anon_sym_AMP,
    STATE(2003), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(3601), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3603), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3617), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3619), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3621), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3623), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [57400] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1603), 1,
      sym_ms_call_modifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1723), 1,
      sym__declarator,
    STATE(1782), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(1964), 1,
      sym_init_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [57451] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1599), 1,
      sym_ms_call_modifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1663), 1,
      sym__declarator,
    STATE(1747), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(2002), 1,
      sym_init_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [57502] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      sym_identifier,
    ACTIONS(3627), 1,
      anon_sym_RPAREN,
    ACTIONS(3629), 1,
      anon_sym_LPAREN2,
    ACTIONS(3631), 1,
      anon_sym_defined,
    ACTIONS(3637), 1,
      sym_number_literal,
    ACTIONS(3633), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3635), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3639), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1415), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [57545] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      sym_identifier,
    ACTIONS(3629), 1,
      anon_sym_LPAREN2,
    ACTIONS(3631), 1,
      anon_sym_defined,
    ACTIONS(3641), 1,
      anon_sym_RPAREN,
    ACTIONS(3643), 1,
      sym_number_literal,
    ACTIONS(3633), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3635), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3639), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1424), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [57588] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1597), 1,
      sym_ms_call_modifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1723), 1,
      sym__declarator,
    STATE(1767), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(1959), 1,
      sym_init_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [57639] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1585), 1,
      sym_ms_call_modifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1723), 1,
      sym__declarator,
    STATE(1745), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(1900), 1,
      sym_init_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [57690] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1592), 1,
      sym_ms_call_modifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1723), 1,
      sym__declarator,
    STATE(1752), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(1927), 1,
      sym_init_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [57741] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1584), 1,
      sym_ms_call_modifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1654), 1,
      sym__declarator,
    STATE(1782), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(1964), 1,
      sym_init_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [57792] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3597), 1,
      anon_sym_COMMA,
    ACTIONS(3605), 1,
      anon_sym_SLASH,
    ACTIONS(3607), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3611), 1,
      anon_sym_PIPE,
    ACTIONS(3613), 1,
      anon_sym_CARET,
    ACTIONS(3615), 1,
      anon_sym_AMP,
    ACTIONS(3645), 1,
      anon_sym_RPAREN,
    STATE(1926), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(3601), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3603), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3617), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3619), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3621), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3623), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [57847] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1596), 1,
      sym_ms_call_modifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1723), 1,
      sym__declarator,
    STATE(1772), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(1993), 1,
      sym_init_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [57898] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1583), 1,
      sym_ms_call_modifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1723), 1,
      sym__declarator,
    STATE(1740), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(1949), 1,
      sym_init_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [57949] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3597), 1,
      anon_sym_COMMA,
    ACTIONS(3605), 1,
      anon_sym_SLASH,
    ACTIONS(3607), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3611), 1,
      anon_sym_PIPE,
    ACTIONS(3613), 1,
      anon_sym_CARET,
    ACTIONS(3615), 1,
      anon_sym_AMP,
    ACTIONS(3647), 1,
      anon_sym_RPAREN,
    STATE(1978), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(3601), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3603), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3617), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3619), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3621), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3623), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [58004] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1582), 1,
      sym_ms_call_modifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1723), 1,
      sym__declarator,
    STATE(1787), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(2050), 1,
      sym_init_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [58055] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1598), 1,
      sym_ms_call_modifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1723), 1,
      sym__declarator,
    STATE(1747), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(2002), 1,
      sym_init_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [58106] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1604), 1,
      sym_ms_call_modifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1669), 1,
      sym__declarator,
    STATE(1740), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(1949), 1,
      sym_init_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [58157] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1601), 1,
      sym_ms_call_modifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1664), 1,
      sym__declarator,
    STATE(1752), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(1927), 1,
      sym_init_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [58208] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1591), 1,
      sym_ms_call_modifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1667), 1,
      sym__declarator,
    STATE(1745), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(1900), 1,
      sym_init_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [58259] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      sym_identifier,
    ACTIONS(3629), 1,
      anon_sym_LPAREN2,
    ACTIONS(3631), 1,
      anon_sym_defined,
    ACTIONS(3649), 1,
      anon_sym_RPAREN,
    ACTIONS(3651), 1,
      sym_number_literal,
    ACTIONS(3633), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3635), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3639), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1427), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [58302] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3663), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1526), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [58342] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 1,
      anon_sym_SLASH,
    ACTIONS(3615), 1,
      anon_sym_AMP,
    ACTIONS(3669), 1,
      anon_sym_PIPE,
    ACTIONS(3601), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3603), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3617), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3619), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3621), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3623), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3667), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [58386] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3671), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1501), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [58426] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3673), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1544), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [58466] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3675), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1503), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [58506] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3677), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1500), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [58546] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3679), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1533), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [58586] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3681), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1542), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [58626] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3683), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1539), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [58666] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2021), 1,
      anon_sym_LPAREN2,
    ACTIONS(2023), 1,
      anon_sym_STAR,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3182), 1,
      anon_sym_LBRACK,
    STATE(1700), 1,
      sym__declarator,
    STATE(1788), 1,
      sym_parameter_list,
    STATE(1800), 1,
      sym__abstract_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    ACTIONS(3685), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1786), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [58714] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3687), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1519), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [58754] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3691), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(1383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3689), 7,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [58786] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      sym_identifier,
    ACTIONS(3629), 1,
      anon_sym_LPAREN2,
    ACTIONS(3631), 1,
      anon_sym_defined,
    ACTIONS(3693), 1,
      sym_number_literal,
    ACTIONS(3633), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3635), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3639), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1475), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [58826] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3695), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1513), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [58866] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3697), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1499), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [58906] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      sym_identifier,
    ACTIONS(3629), 1,
      anon_sym_LPAREN2,
    ACTIONS(3631), 1,
      anon_sym_defined,
    ACTIONS(3699), 1,
      sym_number_literal,
    ACTIONS(3633), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3635), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3639), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1545), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [58946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3703), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3701), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [58974] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3705), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1547), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [59014] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3707), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1534), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [59054] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3711), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(1445), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3709), 7,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [59086] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3713), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1496), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [59126] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      sym_identifier,
    ACTIONS(3629), 1,
      anon_sym_LPAREN2,
    ACTIONS(3631), 1,
      anon_sym_defined,
    ACTIONS(3715), 1,
      sym_number_literal,
    ACTIONS(3633), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3635), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3639), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1473), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [59166] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3717), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1521), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [59206] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3721), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(1383), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3719), 7,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [59238] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3723), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1525), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [59278] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3725), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1520), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [59318] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 1,
      anon_sym_SLASH,
    ACTIONS(3601), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3603), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3669), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3667), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [59352] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 1,
      anon_sym_SLASH,
    ACTIONS(3601), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3603), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3623), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3669), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3667), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [59388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2575), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2577), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [59416] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 1,
      anon_sym_SLASH,
    ACTIONS(3601), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3603), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3619), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3621), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3623), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3669), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3667), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [59456] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 1,
      anon_sym_SLASH,
    ACTIONS(3601), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3603), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3617), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3619), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3621), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3623), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3669), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3667), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [59498] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      sym_identifier,
    ACTIONS(3629), 1,
      anon_sym_LPAREN2,
    ACTIONS(3631), 1,
      anon_sym_defined,
    ACTIONS(3727), 1,
      sym_number_literal,
    ACTIONS(3633), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3635), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3639), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1435), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [59538] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 1,
      anon_sym_SLASH,
    ACTIONS(3613), 1,
      anon_sym_CARET,
    ACTIONS(3615), 1,
      anon_sym_AMP,
    ACTIONS(3669), 1,
      anon_sym_PIPE,
    ACTIONS(3601), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3603), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3617), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3619), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3621), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3623), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3667), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [59584] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 1,
      anon_sym_SLASH,
    ACTIONS(3611), 1,
      anon_sym_PIPE,
    ACTIONS(3613), 1,
      anon_sym_CARET,
    ACTIONS(3615), 1,
      anon_sym_AMP,
    ACTIONS(3601), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3603), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3617), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3619), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3621), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3623), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3667), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [59630] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 1,
      anon_sym_SLASH,
    ACTIONS(3609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3611), 1,
      anon_sym_PIPE,
    ACTIONS(3613), 1,
      anon_sym_CARET,
    ACTIONS(3615), 1,
      anon_sym_AMP,
    ACTIONS(3601), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3603), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3617), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3619), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3621), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3623), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3667), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
  [59678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3669), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3667), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [59706] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 1,
      anon_sym_SLASH,
    ACTIONS(3603), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3669), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3667), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [59738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3731), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3729), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [59766] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3735), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(1457), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3733), 7,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(47), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [59798] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 1,
      anon_sym_SLASH,
    ACTIONS(3607), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3611), 1,
      anon_sym_PIPE,
    ACTIONS(3613), 1,
      anon_sym_CARET,
    ACTIONS(3615), 1,
      anon_sym_AMP,
    ACTIONS(3601), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3603), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3617), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3619), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3621), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3623), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3737), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [59848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3741), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3739), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [59876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3745), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3743), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [59904] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      sym_identifier,
    ACTIONS(3629), 1,
      anon_sym_LPAREN2,
    ACTIONS(3631), 1,
      anon_sym_defined,
    ACTIONS(3747), 1,
      sym_number_literal,
    ACTIONS(3633), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3635), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3639), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1470), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [59944] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3749), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1506), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [59984] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      sym_identifier,
    ACTIONS(3629), 1,
      anon_sym_LPAREN2,
    ACTIONS(3631), 1,
      anon_sym_defined,
    ACTIONS(3751), 1,
      sym_number_literal,
    ACTIONS(3633), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3635), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3639), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1469), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [60024] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      sym_identifier,
    ACTIONS(3629), 1,
      anon_sym_LPAREN2,
    ACTIONS(3631), 1,
      anon_sym_defined,
    ACTIONS(3753), 1,
      sym_number_literal,
    ACTIONS(3633), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3635), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3639), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1468), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [60064] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3755), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1538), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [60104] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3757), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1527), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [60144] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3759), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1528), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [60184] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3761), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1529), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [60224] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3763), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1530), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [60264] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3765), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1532), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [60304] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3767), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1535), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [60344] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      sym_identifier,
    ACTIONS(3629), 1,
      anon_sym_LPAREN2,
    ACTIONS(3631), 1,
      anon_sym_defined,
    ACTIONS(3769), 1,
      sym_number_literal,
    ACTIONS(3633), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3635), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3639), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1467), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [60384] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3771), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1536), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [60424] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      sym_identifier,
    ACTIONS(3629), 1,
      anon_sym_LPAREN2,
    ACTIONS(3631), 1,
      anon_sym_defined,
    ACTIONS(3773), 1,
      sym_number_literal,
    ACTIONS(3633), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3635), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3639), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1522), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [60464] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      sym_identifier,
    ACTIONS(3629), 1,
      anon_sym_LPAREN2,
    ACTIONS(3631), 1,
      anon_sym_defined,
    ACTIONS(3775), 1,
      sym_number_literal,
    ACTIONS(3633), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3635), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3639), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1466), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [60504] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      sym_identifier,
    ACTIONS(3655), 1,
      anon_sym_LPAREN2,
    ACTIONS(3657), 1,
      anon_sym_defined,
    ACTIONS(3777), 1,
      sym_number_literal,
    ACTIONS(3659), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3661), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3665), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1537), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [60544] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      sym_identifier,
    ACTIONS(3629), 1,
      anon_sym_LPAREN2,
    ACTIONS(3631), 1,
      anon_sym_defined,
    ACTIONS(3779), 1,
      sym_number_literal,
    ACTIONS(3633), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3635), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3639), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1460), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [60584] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      sym_identifier,
    ACTIONS(3629), 1,
      anon_sym_LPAREN2,
    ACTIONS(3631), 1,
      anon_sym_defined,
    ACTIONS(3781), 1,
      sym_number_literal,
    ACTIONS(3633), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3635), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3639), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1461), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [60624] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      sym_identifier,
    ACTIONS(3629), 1,
      anon_sym_LPAREN2,
    ACTIONS(3631), 1,
      anon_sym_defined,
    ACTIONS(3783), 1,
      sym_number_literal,
    ACTIONS(3633), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3635), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3639), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1463), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [60664] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      sym_identifier,
    ACTIONS(3629), 1,
      anon_sym_LPAREN2,
    ACTIONS(3631), 1,
      anon_sym_defined,
    ACTIONS(3785), 1,
      sym_number_literal,
    ACTIONS(3633), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3635), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3639), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1464), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [60704] = 12,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3787), 1,
      anon_sym_LF,
    ACTIONS(3793), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3797), 1,
      anon_sym_PIPE,
    ACTIONS(3799), 1,
      anon_sym_CARET,
    ACTIONS(3801), 1,
      anon_sym_AMP,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [60749] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(874), 1,
      sym__old_style_function_declarator,
    STATE(1621), 1,
      sym_ms_call_modifier,
    STATE(1658), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [60792] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(962), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3023), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3809), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3020), 12,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [60823] = 12,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3797), 1,
      anon_sym_PIPE,
    ACTIONS(3799), 1,
      anon_sym_CARET,
    ACTIONS(3801), 1,
      anon_sym_AMP,
    ACTIONS(3813), 1,
      anon_sym_LF,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [60868] = 12,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3797), 1,
      anon_sym_PIPE,
    ACTIONS(3799), 1,
      anon_sym_CARET,
    ACTIONS(3801), 1,
      anon_sym_AMP,
    ACTIONS(3815), 1,
      anon_sym_LF,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [60913] = 12,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3797), 1,
      anon_sym_PIPE,
    ACTIONS(3799), 1,
      anon_sym_CARET,
    ACTIONS(3801), 1,
      anon_sym_AMP,
    ACTIONS(3817), 1,
      anon_sym_LF,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [60958] = 3,
    ACTIONS(2577), 1,
      anon_sym_LF,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(2575), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [60985] = 12,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3797), 1,
      anon_sym_PIPE,
    ACTIONS(3799), 1,
      anon_sym_CARET,
    ACTIONS(3801), 1,
      anon_sym_AMP,
    ACTIONS(3819), 1,
      anon_sym_LF,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [61030] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1518), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2901), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3821), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2899), 12,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [61061] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3824), 1,
      sym_identifier,
    ACTIONS(3830), 1,
      sym_primitive_type,
    STATE(1498), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2908), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2910), 10,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [61096] = 12,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3797), 1,
      anon_sym_PIPE,
    ACTIONS(3799), 1,
      anon_sym_CARET,
    ACTIONS(3801), 1,
      anon_sym_AMP,
    ACTIONS(3833), 1,
      anon_sym_LF,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [61141] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(962), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2986), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2984), 12,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [61172] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(962), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2974), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3838), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2972), 12,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [61203] = 3,
    ACTIONS(3386), 1,
      anon_sym_LF,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3384), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [61230] = 3,
    ACTIONS(3382), 1,
      anon_sym_LF,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3380), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [61257] = 3,
    ACTIONS(3378), 1,
      anon_sym_LF,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3376), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [61284] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(855), 1,
      sym__old_style_function_declarator,
    STATE(1609), 1,
      sym_ms_call_modifier,
    STATE(1650), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [61327] = 12,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3797), 1,
      anon_sym_PIPE,
    ACTIONS(3799), 1,
      anon_sym_CARET,
    ACTIONS(3801), 1,
      anon_sym_AMP,
    ACTIONS(3841), 1,
      anon_sym_LF,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [61372] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1508), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3032), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3843), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3030), 12,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [61403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1507), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2946), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3846), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2944), 12,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [61434] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3701), 1,
      anon_sym_LF,
    ACTIONS(3703), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [61461] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1980), 1,
      anon_sym_STAR,
    ACTIONS(2888), 1,
      anon_sym_LPAREN2,
    STATE(1540), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3849), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1967), 12,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [61494] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(962), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2994), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3852), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2992), 12,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [61525] = 12,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3797), 1,
      anon_sym_PIPE,
    ACTIONS(3799), 1,
      anon_sym_CARET,
    ACTIONS(3801), 1,
      anon_sym_AMP,
    ACTIONS(3855), 1,
      anon_sym_LF,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [61570] = 12,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3797), 1,
      anon_sym_PIPE,
    ACTIONS(3799), 1,
      anon_sym_CARET,
    ACTIONS(3801), 1,
      anon_sym_AMP,
    ACTIONS(3857), 1,
      anon_sym_LF,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [61615] = 12,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3797), 1,
      anon_sym_PIPE,
    ACTIONS(3799), 1,
      anon_sym_CARET,
    ACTIONS(3801), 1,
      anon_sym_AMP,
    ACTIONS(3859), 1,
      anon_sym_LF,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [61660] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 1,
      anon_sym_SLASH,
    ACTIONS(3607), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3611), 1,
      anon_sym_PIPE,
    ACTIONS(3613), 1,
      anon_sym_CARET,
    ACTIONS(3615), 1,
      anon_sym_AMP,
    ACTIONS(3861), 1,
      anon_sym_RPAREN,
    ACTIONS(3601), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3603), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3617), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3619), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3621), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3623), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [61709] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(875), 1,
      sym__old_style_function_declarator,
    STATE(1607), 1,
      sym_ms_call_modifier,
    STATE(1652), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [61752] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3729), 1,
      anon_sym_LF,
    ACTIONS(3731), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [61779] = 4,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3667), 1,
      anon_sym_LF,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3669), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [61808] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3667), 1,
      anon_sym_LF,
    ACTIONS(3669), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [61835] = 12,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3667), 1,
      anon_sym_LF,
    ACTIONS(3669), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3797), 1,
      anon_sym_PIPE,
    ACTIONS(3799), 1,
      anon_sym_CARET,
    ACTIONS(3801), 1,
      anon_sym_AMP,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [61880] = 11,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3667), 1,
      anon_sym_LF,
    ACTIONS(3797), 1,
      anon_sym_PIPE,
    ACTIONS(3799), 1,
      anon_sym_CARET,
    ACTIONS(3801), 1,
      anon_sym_AMP,
    ACTIONS(3669), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [61923] = 10,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3667), 1,
      anon_sym_LF,
    ACTIONS(3799), 1,
      anon_sym_CARET,
    ACTIONS(3801), 1,
      anon_sym_AMP,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3669), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [61964] = 9,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3667), 1,
      anon_sym_LF,
    ACTIONS(3801), 1,
      anon_sym_AMP,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3669), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [62003] = 3,
    ACTIONS(3374), 1,
      anon_sym_LF,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3372), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [62030] = 8,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3667), 1,
      anon_sym_LF,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(3669), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
  [62067] = 12,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3797), 1,
      anon_sym_PIPE,
    ACTIONS(3799), 1,
      anon_sym_CARET,
    ACTIONS(3801), 1,
      anon_sym_AMP,
    ACTIONS(3863), 1,
      anon_sym_LF,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [62112] = 12,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3797), 1,
      anon_sym_PIPE,
    ACTIONS(3799), 1,
      anon_sym_CARET,
    ACTIONS(3801), 1,
      anon_sym_AMP,
    ACTIONS(3865), 1,
      anon_sym_LF,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [62157] = 7,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3667), 1,
      anon_sym_LF,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(3669), 7,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [62192] = 6,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3667), 1,
      anon_sym_LF,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3669), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [62225] = 5,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3667), 1,
      anon_sym_LF,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3669), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [62256] = 12,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3797), 1,
      anon_sym_PIPE,
    ACTIONS(3799), 1,
      anon_sym_CARET,
    ACTIONS(3801), 1,
      anon_sym_AMP,
    ACTIONS(3867), 1,
      anon_sym_LF,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [62301] = 12,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3797), 1,
      anon_sym_PIPE,
    ACTIONS(3799), 1,
      anon_sym_CARET,
    ACTIONS(3801), 1,
      anon_sym_AMP,
    ACTIONS(3869), 1,
      anon_sym_LF,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [62346] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(962), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2960), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3871), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2958), 12,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      sym_primitive_type,
      sym_identifier,
  [62377] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(880), 1,
      sym__old_style_function_declarator,
    STATE(1620), 1,
      sym_ms_call_modifier,
    STATE(1666), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [62420] = 12,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3797), 1,
      anon_sym_PIPE,
    ACTIONS(3799), 1,
      anon_sym_CARET,
    ACTIONS(3801), 1,
      anon_sym_AMP,
    ACTIONS(3874), 1,
      anon_sym_LF,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [62465] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(867), 1,
      sym__old_style_function_declarator,
    STATE(1618), 1,
      sym_ms_call_modifier,
    STATE(1661), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [62508] = 12,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3797), 1,
      anon_sym_PIPE,
    ACTIONS(3799), 1,
      anon_sym_CARET,
    ACTIONS(3801), 1,
      anon_sym_AMP,
    ACTIONS(3876), 1,
      anon_sym_LF,
    ACTIONS(3789), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3803), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3807), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3791), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3805), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [62553] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 1,
      anon_sym_SLASH,
    ACTIONS(3607), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3611), 1,
      anon_sym_PIPE,
    ACTIONS(3613), 1,
      anon_sym_CARET,
    ACTIONS(3615), 1,
      anon_sym_AMP,
    ACTIONS(3878), 1,
      anon_sym_RPAREN,
    ACTIONS(3601), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3603), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3617), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3619), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3621), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3623), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [62602] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3739), 1,
      anon_sym_LF,
    ACTIONS(3741), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [62629] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(3743), 1,
      anon_sym_LF,
    ACTIONS(3745), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [62656] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(1624), 1,
      sym_ms_call_modifier,
    STATE(1714), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [62696] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(1618), 1,
      sym_ms_call_modifier,
    STATE(1673), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [62736] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(1609), 1,
      sym_ms_call_modifier,
    STATE(1704), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [62776] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(1607), 1,
      sym_ms_call_modifier,
    STATE(1678), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [62816] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2021), 1,
      anon_sym_LPAREN2,
    ACTIONS(2023), 1,
      anon_sym_STAR,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3182), 1,
      anon_sym_LBRACK,
    STATE(1724), 1,
      sym__declarator,
    STATE(1788), 1,
      sym_parameter_list,
    STATE(1832), 1,
      sym__abstract_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1786), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [62860] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LPAREN2,
    ACTIONS(3356), 1,
      anon_sym_STAR,
    STATE(1614), 1,
      sym_ms_call_modifier,
    STATE(1729), 1,
      sym__field_declarator,
    STATE(2385), 1,
      sym_ms_based_modifier,
    STATE(1710), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [62900] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(1620), 1,
      sym_ms_call_modifier,
    STATE(1689), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [62940] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(1621), 1,
      sym_ms_call_modifier,
    STATE(1709), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(39), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [62980] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3098), 1,
      anon_sym_const,
    ACTIONS(3105), 1,
      anon_sym_LBRACE,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(3882), 1,
      anon_sym_COLON,
    STATE(1040), 1,
      sym_attribute_specifier,
    STATE(1391), 1,
      sym_enumerator_list,
    ACTIONS(3100), 11,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [63015] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3209), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      anon_sym_LPAREN2,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3217), 1,
      sym_primitive_type,
    STATE(1631), 1,
      sym__type_declarator,
    STATE(1856), 1,
      sym__type_definition_declarators,
    STATE(2160), 1,
      sym_ms_based_modifier,
    ACTIONS(3215), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1728), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [63056] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3209), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      anon_sym_LPAREN2,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3217), 1,
      sym_primitive_type,
    STATE(1631), 1,
      sym__type_declarator,
    STATE(1805), 1,
      sym__type_definition_declarators,
    STATE(2160), 1,
      sym_ms_based_modifier,
    ACTIONS(3215), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1728), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [63097] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3209), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      anon_sym_LPAREN2,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3217), 1,
      sym_primitive_type,
    STATE(1631), 1,
      sym__type_declarator,
    STATE(1874), 1,
      sym__type_definition_declarators,
    STATE(2160), 1,
      sym_ms_based_modifier,
    ACTIONS(3215), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1728), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [63138] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3209), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      anon_sym_LPAREN2,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3217), 1,
      sym_primitive_type,
    STATE(1631), 1,
      sym__type_declarator,
    STATE(1842), 1,
      sym__type_definition_declarators,
    STATE(2160), 1,
      sym_ms_based_modifier,
    ACTIONS(3215), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1728), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [63179] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3209), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      anon_sym_LPAREN2,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3217), 1,
      sym_primitive_type,
    STATE(1631), 1,
      sym__type_declarator,
    STATE(1816), 1,
      sym__type_definition_declarators,
    STATE(2160), 1,
      sym_ms_based_modifier,
    ACTIONS(3215), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1728), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [63220] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3209), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      anon_sym_LPAREN2,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3217), 1,
      sym_primitive_type,
    STATE(1631), 1,
      sym__type_declarator,
    STATE(1845), 1,
      sym__type_definition_declarators,
    STATE(2160), 1,
      sym_ms_based_modifier,
    ACTIONS(3215), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1728), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [63261] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3209), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      anon_sym_LPAREN2,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3217), 1,
      sym_primitive_type,
    STATE(1631), 1,
      sym__type_declarator,
    STATE(1837), 1,
      sym__type_definition_declarators,
    STATE(2160), 1,
      sym_ms_based_modifier,
    ACTIONS(3215), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1728), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [63302] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3209), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      anon_sym_LPAREN2,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3217), 1,
      sym_primitive_type,
    STATE(1631), 1,
      sym__type_declarator,
    STATE(1870), 1,
      sym__type_definition_declarators,
    STATE(2160), 1,
      sym_ms_based_modifier,
    ACTIONS(3215), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1728), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [63343] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3209), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      anon_sym_LPAREN2,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3217), 1,
      sym_primitive_type,
    STATE(1631), 1,
      sym__type_declarator,
    STATE(1831), 1,
      sym__type_definition_declarators,
    STATE(2160), 1,
      sym_ms_based_modifier,
    ACTIONS(3215), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1728), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [63384] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3209), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      anon_sym_LPAREN2,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3217), 1,
      sym_primitive_type,
    STATE(1631), 1,
      sym__type_declarator,
    STATE(1876), 1,
      sym__type_definition_declarators,
    STATE(2160), 1,
      sym_ms_based_modifier,
    ACTIONS(3215), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1728), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [63425] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(3885), 1,
      sym_identifier,
    ACTIONS(3891), 1,
      anon_sym_LBRACK,
    STATE(1580), 1,
      sym_gnu_asm_expression,
    STATE(1628), 1,
      sym_attribute_specifier,
    STATE(1715), 1,
      aux_sym_type_definition_repeat1,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(3887), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(1571), 2,
      sym_preproc_call_expression,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3889), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [63465] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3209), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      anon_sym_LPAREN2,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3217), 1,
      sym_primitive_type,
    STATE(1730), 1,
      sym__type_declarator,
    STATE(2160), 1,
      sym_ms_based_modifier,
    ACTIONS(3215), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1728), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [63503] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(3885), 1,
      sym_identifier,
    ACTIONS(3891), 1,
      anon_sym_LBRACK,
    STATE(1573), 1,
      sym_gnu_asm_expression,
    ACTIONS(89), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1571), 3,
      sym_preproc_call_expression,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3889), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [63537] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3209), 1,
      sym_identifier,
    ACTIONS(3211), 1,
      anon_sym_LPAREN2,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3217), 1,
      sym_primitive_type,
    STATE(1655), 1,
      sym__type_declarator,
    STATE(2160), 1,
      sym_ms_based_modifier,
    ACTIONS(3215), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1728), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [63575] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(3885), 1,
      sym_identifier,
    ACTIONS(3895), 3,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1578), 3,
      sym_preproc_call_expression,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3893), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [63604] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LPAREN2,
    ACTIONS(3356), 1,
      anon_sym_STAR,
    ACTIONS(3897), 1,
      anon_sym_SEMI,
    STATE(1605), 1,
      sym__field_declarator,
    STATE(1915), 1,
      sym__field_declaration_declarator,
    STATE(2126), 1,
      sym_attribute_specifier,
    STATE(2385), 1,
      sym_ms_based_modifier,
    STATE(1710), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [63645] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(3885), 1,
      sym_identifier,
    ACTIONS(3895), 3,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1575), 3,
      sym_preproc_call_expression,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3893), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [63674] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LPAREN2,
    ACTIONS(3356), 1,
      anon_sym_STAR,
    ACTIONS(3899), 1,
      anon_sym_SEMI,
    STATE(1605), 1,
      sym__field_declarator,
    STATE(2018), 1,
      sym__field_declaration_declarator,
    STATE(2385), 1,
      sym_ms_based_modifier,
    STATE(2412), 1,
      sym_attribute_specifier,
    STATE(1710), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [63715] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(3885), 1,
      sym_identifier,
    ACTIONS(3903), 3,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1578), 3,
      sym_preproc_call_expression,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3901), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [63744] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LPAREN2,
    ACTIONS(3356), 1,
      anon_sym_STAR,
    ACTIONS(3905), 1,
      anon_sym_SEMI,
    STATE(1605), 1,
      sym__field_declarator,
    STATE(1939), 1,
      sym__field_declaration_declarator,
    STATE(2385), 1,
      sym_ms_based_modifier,
    STATE(2389), 1,
      sym_attribute_specifier,
    STATE(1710), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [63785] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LPAREN2,
    ACTIONS(3356), 1,
      anon_sym_STAR,
    ACTIONS(3907), 1,
      anon_sym_SEMI,
    STATE(1605), 1,
      sym__field_declarator,
    STATE(2015), 1,
      sym__field_declaration_declarator,
    STATE(2270), 1,
      sym_attribute_specifier,
    STATE(2385), 1,
      sym_ms_based_modifier,
    STATE(1710), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [63826] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3909), 1,
      sym_identifier,
    ACTIONS(3914), 1,
      anon_sym___attribute__,
    ACTIONS(3917), 3,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1578), 3,
      sym_preproc_call_expression,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3912), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [63855] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3919), 1,
      sym_identifier,
    ACTIONS(3921), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3923), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3925), 1,
      aux_sym_preproc_elif_token1,
    STATE(1625), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1627), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(1735), 1,
      sym_enumerator,
    ACTIONS(3927), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(2233), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
    STATE(2234), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [63894] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(3885), 1,
      sym_identifier,
    ACTIONS(3895), 1,
      anon_sym_LBRACK,
    STATE(1628), 1,
      sym_attribute_specifier,
    STATE(1726), 1,
      aux_sym_type_definition_repeat1,
    ACTIONS(3929), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3931), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1575), 2,
      sym_preproc_call_expression,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3893), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [63931] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3935), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3938), 1,
      anon_sym_LBRACK,
    STATE(1581), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3933), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [63957] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1773), 1,
      sym__declarator,
    STATE(1803), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [63994] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1757), 1,
      sym__declaration_declarator,
    STATE(1773), 1,
      sym__declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [64031] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1690), 1,
      sym__declarator,
    STATE(1760), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [64068] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1753), 1,
      sym__declaration_declarator,
    STATE(1773), 1,
      sym__declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [64105] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    STATE(1569), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3940), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [64134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3946), 5,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
    ACTIONS(3948), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [64155] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    STATE(1569), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3950), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [64184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3165), 5,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
    ACTIONS(3158), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [64205] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(3952), 1,
      sym_identifier,
    ACTIONS(3954), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(3958), 1,
      anon_sym_RBRACE,
    ACTIONS(3956), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(2032), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(2392), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(1616), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [64238] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1694), 1,
      sym__declarator,
    STATE(1753), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [64275] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1756), 1,
      sym__declaration_declarator,
    STATE(1773), 1,
      sym__declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [64312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3153), 5,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
    ACTIONS(3146), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [64333] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 1,
      anon_sym_LPAREN2,
    STATE(1273), 1,
      sym_preproc_argument_list,
    ACTIONS(3960), 5,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
    ACTIONS(3962), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [64358] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    STATE(1569), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3964), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [64387] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1754), 1,
      sym__declaration_declarator,
    STATE(1773), 1,
      sym__declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [64424] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1763), 1,
      sym__declaration_declarator,
    STATE(1773), 1,
      sym__declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [64461] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1769), 1,
      sym__declaration_declarator,
    STATE(1773), 1,
      sym__declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [64498] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1697), 1,
      sym__declarator,
    STATE(1769), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [64535] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    STATE(1569), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3966), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [64564] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1685), 1,
      sym__declarator,
    STATE(1756), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [64601] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(3952), 1,
      sym_identifier,
    ACTIONS(3954), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(3968), 1,
      anon_sym_RBRACE,
    ACTIONS(3956), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(2082), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(2239), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(1590), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [64634] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1760), 1,
      sym__declaration_declarator,
    STATE(1773), 1,
      sym__declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [64671] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    ACTIONS(3581), 1,
      sym_identifier,
    STATE(1647), 1,
      sym_function_declarator,
    STATE(1693), 1,
      sym__declarator,
    STATE(1757), 1,
      sym__declaration_declarator,
    STATE(1844), 1,
      sym__function_declaration_declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1651), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [64708] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3970), 1,
      anon_sym_COMMA,
    ACTIONS(3974), 1,
      anon_sym_LBRACK,
    ACTIONS(3976), 1,
      anon_sym_COLON,
    STATE(1706), 1,
      sym_parameter_list,
    STATE(1811), 1,
      aux_sym__field_declaration_declarator_repeat1,
    STATE(1854), 1,
      sym_bitfield_clause,
    ACTIONS(3972), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
    STATE(1642), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [64744] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3980), 1,
      anon_sym_LBRACK,
    STATE(1581), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3978), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [64768] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(1680), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [64797] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3974), 1,
      anon_sym_LBRACK,
    STATE(1706), 1,
      sym_parameter_list,
    STATE(1642), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3982), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
  [64824] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(1699), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [64853] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3974), 1,
      anon_sym_LBRACK,
    STATE(1706), 1,
      sym_parameter_list,
    STATE(1642), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3984), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
  [64880] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3952), 1,
      sym_identifier,
    ACTIONS(3986), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3988), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3990), 1,
      aux_sym_preproc_elif_token1,
    STATE(1625), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2334), 1,
      sym_enumerator,
    ACTIONS(3992), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(2234), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [64911] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LPAREN2,
    ACTIONS(3356), 1,
      anon_sym_STAR,
    STATE(1622), 1,
      sym__field_declarator,
    STATE(2385), 1,
      sym_ms_based_modifier,
    STATE(1710), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [64940] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3923), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3994), 1,
      sym_identifier,
    ACTIONS(3996), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3998), 1,
      aux_sym_preproc_elif_token1,
    STATE(1683), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1688), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(1802), 1,
      sym_enumerator,
    STATE(2243), 2,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
    STATE(2244), 2,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
  [64973] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LPAREN2,
    ACTIONS(3356), 1,
      anon_sym_STAR,
    STATE(1718), 1,
      sym__field_declarator,
    STATE(2385), 1,
      sym_ms_based_modifier,
    STATE(1710), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [65002] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3974), 1,
      anon_sym_LBRACK,
    STATE(1706), 1,
      sym_parameter_list,
    STATE(1642), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(4000), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
  [65029] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4002), 1,
      sym_identifier,
    ACTIONS(4005), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(4011), 1,
      sym_preproc_directive,
    ACTIONS(4014), 1,
      anon_sym_RBRACE,
    ACTIONS(4008), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(2226), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(1616), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [65058] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3923), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3994), 1,
      sym_identifier,
    ACTIONS(3998), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4016), 1,
      aux_sym_preproc_if_token2,
    STATE(1682), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1713), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(1802), 1,
      sym_enumerator,
    STATE(2196), 2,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
    STATE(2197), 2,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
  [65091] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(1687), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [65120] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3923), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3994), 1,
      sym_identifier,
    ACTIONS(3998), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4018), 1,
      aux_sym_preproc_if_token2,
    STATE(1695), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1696), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(1802), 1,
      sym_enumerator,
    STATE(2405), 2,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
    STATE(2406), 2,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
  [65153] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(1691), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [65182] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(1711), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [65211] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3974), 1,
      anon_sym_LBRACK,
    ACTIONS(3976), 1,
      anon_sym_COLON,
    STATE(1706), 1,
      sym_parameter_list,
    STATE(2019), 1,
      sym_bitfield_clause,
    STATE(1642), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(4020), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [65242] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4022), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    ACTIONS(4024), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1875), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [65267] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym___based,
    ACTIONS(3174), 1,
      sym_identifier,
    ACTIONS(3358), 1,
      anon_sym_LPAREN2,
    ACTIONS(3360), 1,
      anon_sym_STAR,
    STATE(1724), 1,
      sym__declarator,
    STATE(2409), 1,
      sym_ms_based_modifier,
    STATE(1647), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [65296] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3952), 1,
      sym_identifier,
    ACTIONS(3988), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3990), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4026), 1,
      aux_sym_preproc_if_token2,
    STATE(1676), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2334), 1,
      sym_enumerator,
    ACTIONS(3992), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(2331), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [65327] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3974), 1,
      anon_sym_LBRACK,
    STATE(1706), 1,
      sym_parameter_list,
    STATE(1642), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(4028), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
  [65354] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3919), 1,
      sym_identifier,
    ACTIONS(4030), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(4032), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4034), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4036), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1692), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(2236), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [65383] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4040), 1,
      anon_sym___attribute__,
    ACTIONS(3960), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(4038), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4043), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(3962), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [65408] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    STATE(1827), 1,
      sym_gnu_asm_output_operand,
    STATE(2173), 1,
      sym_string_literal,
    ACTIONS(4045), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [65432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4051), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [65450] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(4053), 1,
      anon_sym_COMMA,
    ACTIONS(4057), 1,
      anon_sym_LBRACK,
    STATE(1717), 1,
      sym_parameter_list,
    STATE(1867), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(4055), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
    STATE(1670), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [65480] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(129), 1,
      anon_sym_LBRACE,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_LPAREN2,
    ACTIONS(4061), 1,
      anon_sym_EQ,
    STATE(153), 1,
      sym_compound_statement,
    STATE(1216), 1,
      sym__old_style_parameter_list,
    STATE(1567), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [65512] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(4057), 1,
      anon_sym_LBRACK,
    STATE(1717), 1,
      sym_parameter_list,
    STATE(1670), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(4063), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [65538] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_LPAREN2,
    ACTIONS(4061), 1,
      anon_sym_EQ,
    STATE(516), 1,
      sym_compound_statement,
    STATE(1216), 1,
      sym__old_style_parameter_list,
    STATE(1567), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [65570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4067), 1,
      anon_sym_LBRACK,
    ACTIONS(4065), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [65588] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4071), 1,
      anon_sym_LBRACK,
    STATE(1868), 1,
      sym_gnu_asm_input_operand,
    STATE(2136), 1,
      sym_string_literal,
    ACTIONS(4069), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [65612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4075), 1,
      anon_sym_LBRACK,
    ACTIONS(4073), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [65630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4079), 1,
      anon_sym_LBRACK,
    ACTIONS(4077), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [65648] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(499), 1,
      anon_sym_LBRACE,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_LPAREN2,
    ACTIONS(4061), 1,
      anon_sym_EQ,
    STATE(498), 1,
      sym_compound_statement,
    STATE(1216), 1,
      sym__old_style_parameter_list,
    STATE(1567), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [65680] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(201), 1,
      anon_sym_LBRACE,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_LPAREN2,
    ACTIONS(4061), 1,
      anon_sym_EQ,
    STATE(245), 1,
      sym_compound_statement,
    STATE(1216), 1,
      sym__old_style_parameter_list,
    STATE(1567), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [65712] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(4057), 1,
      anon_sym_LBRACK,
    STATE(1717), 1,
      sym_parameter_list,
    STATE(1670), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(4081), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [65738] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4085), 1,
      anon_sym_LBRACK,
    STATE(1581), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(4083), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
  [65760] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(4057), 1,
      anon_sym_LBRACK,
    STATE(1717), 1,
      sym_parameter_list,
    STATE(1670), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(4087), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [65786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4091), 1,
      anon_sym_LBRACK,
    ACTIONS(4089), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [65804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4095), 1,
      anon_sym_LBRACK,
    ACTIONS(4093), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [65822] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(565), 1,
      anon_sym_LBRACE,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_LPAREN2,
    ACTIONS(4061), 1,
      anon_sym_EQ,
    STATE(451), 1,
      sym_compound_statement,
    STATE(1216), 1,
      sym__old_style_parameter_list,
    STATE(1567), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [65854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4099), 1,
      anon_sym_LBRACK,
    ACTIONS(4097), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [65872] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(4057), 1,
      anon_sym_LBRACK,
    STATE(1717), 1,
      sym_parameter_list,
    STATE(1670), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(4101), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [65898] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4103), 1,
      sym_identifier,
    ACTIONS(4107), 1,
      sym_system_lib_string,
    STATE(2297), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(4105), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [65919] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(129), 1,
      anon_sym_LBRACE,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_LPAREN2,
    STATE(164), 1,
      sym_compound_statement,
    STATE(1216), 1,
      sym__old_style_parameter_list,
    STATE(1569), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [65948] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4099), 1,
      anon_sym_LBRACK,
    ACTIONS(4097), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
    ACTIONS(4109), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_asm,
      anon_sym___asm__,
  [65967] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(565), 1,
      anon_sym_LBRACE,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_LPAREN2,
    STATE(433), 1,
      sym_compound_statement,
    STATE(1216), 1,
      sym__old_style_parameter_list,
    STATE(1569), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [65996] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4022), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1987), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [66017] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(499), 1,
      anon_sym_LBRACE,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    ACTIONS(4061), 1,
      anon_sym_EQ,
    STATE(498), 1,
      sym_compound_statement,
    STATE(1567), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [66046] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(4057), 1,
      anon_sym_LBRACK,
    STATE(1717), 1,
      sym_parameter_list,
    STATE(1670), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(4111), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [66071] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    ACTIONS(2133), 1,
      anon_sym_STAR,
    ACTIONS(3182), 1,
      anon_sym_LBRACK,
    STATE(1788), 1,
      sym_parameter_list,
    STATE(1832), 1,
      sym__abstract_declarator,
    STATE(1786), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
  [66096] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4022), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1901), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [66117] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(499), 1,
      anon_sym_LBRACE,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_LPAREN2,
    STATE(491), 1,
      sym_compound_statement,
    STATE(1216), 1,
      sym__old_style_parameter_list,
    STATE(1569), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [66146] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4022), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1974), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [66167] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4113), 1,
      sym_identifier,
    ACTIONS(4115), 1,
      sym_system_lib_string,
    STATE(2305), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(4105), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [66188] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(201), 1,
      anon_sym_LBRACE,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_LPAREN2,
    STATE(233), 1,
      sym_compound_statement,
    STATE(1216), 1,
      sym__old_style_parameter_list,
    STATE(1569), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [66217] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4117), 1,
      sym_identifier,
    ACTIONS(4119), 1,
      sym_system_lib_string,
    STATE(2194), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(4105), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [66238] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    ACTIONS(4061), 1,
      anon_sym_EQ,
    STATE(516), 1,
      sym_compound_statement,
    STATE(1567), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [66267] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(565), 1,
      anon_sym_LBRACE,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    ACTIONS(4061), 1,
      anon_sym_EQ,
    STATE(451), 1,
      sym_compound_statement,
    STATE(1567), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [66296] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4121), 1,
      sym_identifier,
    ACTIONS(4123), 1,
      sym_system_lib_string,
    STATE(2249), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(4105), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [66317] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_LPAREN2,
    STATE(536), 1,
      sym_compound_statement,
    STATE(1216), 1,
      sym__old_style_parameter_list,
    STATE(1569), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [66346] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(129), 1,
      anon_sym_LBRACE,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    ACTIONS(4061), 1,
      anon_sym_EQ,
    STATE(153), 1,
      sym_compound_statement,
    STATE(1567), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [66375] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4022), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(1887), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [66396] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(201), 1,
      anon_sym_LBRACE,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    ACTIONS(4061), 1,
      anon_sym_EQ,
    STATE(245), 1,
      sym_compound_statement,
    STATE(1567), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [66425] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4127), 1,
      anon_sym_LBRACK,
    STATE(1581), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(4125), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [66446] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4129), 1,
      sym_identifier,
    ACTIONS(4131), 1,
      sym_system_lib_string,
    STATE(2357), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(4105), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [66467] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4022), 1,
      sym_identifier,
    STATE(845), 1,
      sym_string_literal,
    STATE(2011), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [66488] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(201), 1,
      anon_sym_LBRACE,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    STATE(233), 1,
      sym_compound_statement,
    STATE(1569), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [66514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4135), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [66530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4139), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [66546] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4146), 1,
      aux_sym_preproc_elif_token1,
    STATE(1676), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2334), 1,
      sym_enumerator,
    ACTIONS(4144), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [66568] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4150), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4152), 1,
      anon_sym_EQ,
    ACTIONS(4148), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [66586] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(565), 1,
      anon_sym_LBRACE,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    STATE(433), 1,
      sym_compound_statement,
    STATE(1569), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [66612] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4071), 1,
      anon_sym_LBRACK,
    STATE(1933), 1,
      sym_gnu_asm_input_operand,
    STATE(2136), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [66632] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(565), 1,
      anon_sym_LBRACE,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    STATE(413), 1,
      sym_compound_statement,
    STATE(1569), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [66658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4156), 1,
      anon_sym_LBRACK,
    ACTIONS(4154), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [66674] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3952), 1,
      sym_identifier,
    ACTIONS(3988), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4158), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(4160), 1,
      aux_sym_preproc_elif_token1,
    STATE(1738), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2399), 1,
      sym_enumerator,
    STATE(2225), 2,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
  [66700] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3952), 1,
      sym_identifier,
    ACTIONS(3988), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4160), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4162), 1,
      aux_sym_preproc_if_token2,
    STATE(1738), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2399), 1,
      sym_enumerator,
    STATE(2401), 2,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
  [66726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4166), 1,
      anon_sym_LBRACK,
    ACTIONS(4164), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [66742] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(565), 1,
      anon_sym_LBRACE,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    STATE(436), 1,
      sym_compound_statement,
    STATE(1567), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [66768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4170), 1,
      anon_sym_LBRACK,
    ACTIONS(4168), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [66784] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(201), 1,
      anon_sym_LBRACE,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    STATE(248), 1,
      sym_compound_statement,
    STATE(1569), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [66810] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3994), 1,
      sym_identifier,
    ACTIONS(4032), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4172), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(4174), 1,
      aux_sym_preproc_elif_token1,
    STATE(1759), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(2400), 2,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
  [66834] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    STATE(536), 1,
      sym_compound_statement,
    STATE(1569), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [66860] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(499), 1,
      anon_sym_LBRACE,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    STATE(493), 1,
      sym_compound_statement,
    STATE(1567), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [66886] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    STATE(524), 1,
      sym_compound_statement,
    STATE(1569), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [66912] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4176), 1,
      sym_identifier,
    ACTIONS(4181), 1,
      aux_sym_preproc_elif_token1,
    STATE(1692), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    ACTIONS(4179), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [66932] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(201), 1,
      anon_sym_LBRACE,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    STATE(236), 1,
      sym_compound_statement,
    STATE(1567), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [66958] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(129), 1,
      anon_sym_LBRACE,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    STATE(156), 1,
      sym_compound_statement,
    STATE(1567), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [66984] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3952), 1,
      sym_identifier,
    ACTIONS(3988), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4160), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4183), 1,
      aux_sym_preproc_if_token2,
    STATE(1738), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2399), 1,
      sym_enumerator,
    STATE(2362), 2,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
  [67010] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3994), 1,
      sym_identifier,
    ACTIONS(4032), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4174), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4185), 1,
      aux_sym_preproc_if_token2,
    STATE(1759), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(2361), 2,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
  [67034] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    STATE(515), 1,
      sym_compound_statement,
    STATE(1567), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [67060] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3952), 1,
      sym_identifier,
    ACTIONS(3988), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4160), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4187), 1,
      aux_sym_preproc_if_token2,
    STATE(1682), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2399), 1,
      sym_enumerator,
    STATE(2196), 2,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
  [67086] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(129), 1,
      anon_sym_LBRACE,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    STATE(143), 1,
      sym_compound_statement,
    STATE(1569), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [67112] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    STATE(1569), 1,
      sym_parameter_list,
    ACTIONS(4189), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [67136] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3952), 1,
      sym_identifier,
    ACTIONS(3988), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4018), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(4160), 1,
      aux_sym_preproc_elif_token1,
    STATE(1695), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2399), 1,
      sym_enumerator,
    STATE(2406), 2,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
  [67162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_LBRACK,
    ACTIONS(4191), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [67178] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3952), 1,
      sym_identifier,
    ACTIONS(3988), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3996), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(4160), 1,
      aux_sym_preproc_elif_token1,
    STATE(1683), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2399), 1,
      sym_enumerator,
    STATE(2243), 2,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
  [67204] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(129), 1,
      anon_sym_LBRACE,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    STATE(164), 1,
      sym_compound_statement,
    STATE(1569), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [67230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4197), 1,
      anon_sym_LBRACK,
    ACTIONS(4195), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [67246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4201), 1,
      anon_sym_LBRACK,
    ACTIONS(4199), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [67262] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3994), 1,
      sym_identifier,
    ACTIONS(4032), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4174), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4203), 1,
      aux_sym_preproc_if_token2,
    STATE(1696), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(2405), 2,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
  [67286] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3994), 1,
      sym_identifier,
    ACTIONS(4032), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4174), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4205), 1,
      aux_sym_preproc_if_token2,
    STATE(1688), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(2244), 2,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
  [67310] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(499), 1,
      anon_sym_LBRACE,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    STATE(491), 1,
      sym_compound_statement,
    STATE(1569), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [67336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_LBRACK,
    ACTIONS(4207), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [67352] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(499), 1,
      anon_sym_LBRACE,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    STATE(460), 1,
      sym_compound_statement,
    STATE(1569), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [67378] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    STATE(1975), 1,
      sym_gnu_asm_output_operand,
    STATE(2173), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [67398] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3994), 1,
      sym_identifier,
    ACTIONS(4032), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(4174), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4211), 1,
      aux_sym_preproc_if_token2,
    STATE(1759), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(2237), 2,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
  [67422] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    ACTIONS(4213), 1,
      anon_sym_RPAREN,
    STATE(1569), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [67445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    STATE(1737), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(3929), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_asm,
      anon_sym___asm__,
  [67462] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(4057), 1,
      anon_sym_LBRACK,
    ACTIONS(4215), 1,
      anon_sym_RPAREN,
    STATE(1717), 1,
      sym_parameter_list,
    STATE(1670), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [67485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4219), 1,
      anon_sym_LBRACK,
    ACTIONS(4217), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [67500] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3974), 1,
      anon_sym_LBRACK,
    ACTIONS(4221), 1,
      anon_sym_RPAREN,
    STATE(1706), 1,
      sym_parameter_list,
    STATE(1642), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [67523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4225), 1,
      anon_sym_LBRACK,
    ACTIONS(4223), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [67538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4229), 1,
      anon_sym_LBRACK,
    ACTIONS(4227), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [67553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4233), 1,
      anon_sym_LBRACK,
    ACTIONS(4231), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [67568] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4235), 1,
      anon_sym_LBRACK,
    ACTIONS(4238), 1,
      anon_sym_EQ,
    ACTIONS(4240), 1,
      anon_sym_DOT,
    STATE(1722), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [67587] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    ACTIONS(4061), 1,
      anon_sym_EQ,
    STATE(1567), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [67610] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    ACTIONS(4243), 1,
      anon_sym_RPAREN,
    STATE(1569), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [67633] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym___attribute__,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(2697), 1,
      anon_sym_LBRACE,
    ACTIONS(4245), 1,
      sym_identifier,
    STATE(969), 1,
      sym_field_declaration_list,
    STATE(1790), 1,
      sym_attribute_specifier,
    STATE(1904), 1,
      sym_ms_declspec_modifier,
  [67658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    STATE(1737), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(4247), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_asm,
      anon_sym___asm__,
  [67675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4251), 1,
      anon_sym_LBRACK,
    ACTIONS(4249), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [67690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4255), 1,
      anon_sym_LBRACK,
    ACTIONS(4253), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [67705] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3974), 1,
      anon_sym_LBRACK,
    ACTIONS(4257), 1,
      anon_sym_RPAREN,
    STATE(1706), 1,
      sym_parameter_list,
    STATE(1642), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [67728] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(4057), 1,
      anon_sym_LBRACK,
    ACTIONS(4259), 1,
      anon_sym_RPAREN,
    STATE(1717), 1,
      sym_parameter_list,
    STATE(1670), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [67751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4263), 1,
      anon_sym_LBRACK,
    ACTIONS(4261), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [67766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_LBRACK,
    ACTIONS(4265), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [67781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4271), 1,
      anon_sym_LBRACK,
    ACTIONS(4269), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [67796] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2083), 1,
      anon_sym_LBRACK,
    ACTIONS(4273), 1,
      anon_sym_EQ,
    ACTIONS(4275), 1,
      anon_sym_DOT,
    STATE(1722), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [67815] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4279), 1,
      anon_sym_COMMA,
    ACTIONS(4281), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4277), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [67832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4285), 1,
      anon_sym_LBRACK,
    ACTIONS(4283), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [67847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4289), 1,
      anon_sym___attribute__,
    STATE(1737), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(4287), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_asm,
      anon_sym___asm__,
  [67864] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4141), 1,
      sym_identifier,
    STATE(1738), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2399), 1,
      sym_enumerator,
    ACTIONS(4144), 3,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [67882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4292), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4294), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [67896] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4298), 1,
      anon_sym_SEMI,
    STATE(1881), 1,
      aux_sym_declaration_repeat1,
    STATE(1882), 1,
      sym_gnu_asm_expression,
    ACTIONS(4300), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [67916] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(4304), 1,
      anon_sym_LBRACK,
    STATE(1791), 1,
      sym_parameter_list,
    ACTIONS(4302), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [67934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(824), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [67948] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(4304), 1,
      anon_sym_LBRACK,
    STATE(1791), 1,
      sym_parameter_list,
    ACTIONS(4306), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [67966] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(4304), 1,
      anon_sym_LBRACK,
    STATE(1791), 1,
      sym_parameter_list,
    ACTIONS(4308), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [67984] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4310), 1,
      anon_sym_SEMI,
    STATE(1889), 1,
      sym_gnu_asm_expression,
    STATE(1890), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(4300), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [68004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4312), 1,
      anon_sym_LPAREN2,
    STATE(1749), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(4314), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [68020] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4316), 1,
      anon_sym_SEMI,
    STATE(1960), 1,
      aux_sym_declaration_repeat1,
    STATE(1961), 1,
      sym_gnu_asm_expression,
    ACTIONS(4300), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [68040] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4318), 1,
      anon_sym_LPAREN2,
    STATE(1775), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(4314), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [68056] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4320), 1,
      anon_sym_LPAREN2,
    STATE(1774), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(4314), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [68072] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(4304), 1,
      anon_sym_LBRACK,
    STATE(1791), 1,
      sym_parameter_list,
    ACTIONS(4322), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [68090] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(4304), 1,
      anon_sym_LBRACK,
    STATE(1791), 1,
      sym_parameter_list,
    ACTIONS(4324), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [68108] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4326), 1,
      anon_sym_SEMI,
    STATE(1930), 1,
      sym_gnu_asm_expression,
    STATE(1941), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(4300), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [68128] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4328), 1,
      anon_sym_SEMI,
    STATE(1920), 1,
      sym_gnu_asm_expression,
    STATE(1921), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(4300), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [68148] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4330), 1,
      anon_sym_SEMI,
    STATE(1999), 1,
      aux_sym_declaration_repeat1,
    STATE(2006), 1,
      sym_gnu_asm_expression,
    ACTIONS(4300), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [68168] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(4304), 1,
      anon_sym_LBRACK,
    STATE(1791), 1,
      sym_parameter_list,
    ACTIONS(4332), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [68186] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4334), 1,
      anon_sym_SEMI,
    STATE(1944), 1,
      sym_gnu_asm_expression,
    STATE(1945), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(4300), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [68206] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4336), 1,
      anon_sym_SEMI,
    STATE(1903), 1,
      sym_gnu_asm_expression,
    STATE(1908), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(4300), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [68226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2335), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [68240] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4338), 1,
      sym_identifier,
    STATE(1759), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    ACTIONS(4179), 3,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [68256] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4341), 1,
      anon_sym_SEMI,
    STATE(2005), 1,
      aux_sym_declaration_repeat1,
    STATE(2008), 1,
      sym_gnu_asm_expression,
    ACTIONS(4300), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [68276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4343), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4345), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [68290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4347), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4349), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [68304] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4351), 1,
      anon_sym_SEMI,
    STATE(1907), 1,
      aux_sym_declaration_repeat1,
    STATE(1912), 1,
      sym_gnu_asm_expression,
    ACTIONS(4300), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [68324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4014), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4353), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [68338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4357), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [68352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4359), 1,
      anon_sym_EQ,
    ACTIONS(4148), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_identifier,
  [68366] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4361), 1,
      anon_sym_SEMI,
    STATE(1940), 1,
      aux_sym_declaration_repeat1,
    STATE(1947), 1,
      sym_gnu_asm_expression,
    ACTIONS(4300), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [68386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4347), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4349), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [68400] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4363), 1,
      anon_sym_SEMI,
    STATE(1885), 1,
      sym_gnu_asm_expression,
    STATE(1902), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(4300), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [68420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4365), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4367), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [68434] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(4304), 1,
      anon_sym_LBRACK,
    STATE(1791), 1,
      sym_parameter_list,
    ACTIONS(4369), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [68452] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4371), 1,
      anon_sym_SEMI,
    STATE(2009), 1,
      sym_gnu_asm_expression,
    STATE(2010), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(4300), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [68472] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(3944), 1,
      anon_sym_LBRACK,
    STATE(1567), 1,
      sym_parameter_list,
    STATE(1606), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [68492] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_LPAREN2,
    STATE(1774), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(4375), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [68508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4378), 1,
      anon_sym_LPAREN2,
    STATE(1774), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(4314), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [68524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4380), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4382), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [68538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4146), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4144), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [68552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4384), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4386), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [68566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2386), 1,
      sym_string_literal,
    ACTIONS(95), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [68580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4343), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4345), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [68594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4388), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4390), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [68608] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4392), 1,
      anon_sym_SEMI,
    STATE(1883), 1,
      sym_gnu_asm_expression,
    STATE(1996), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(4300), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [68628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4394), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [68639] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    ACTIONS(4398), 1,
      anon_sym_COLON_COLON,
    STATE(2094), 1,
      sym_argument_list,
    ACTIONS(4396), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [68656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4400), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [68667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4402), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [68678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2024), 1,
      sym_gnu_asm_expression,
    ACTIONS(4300), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(4404), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [68693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4406), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [68704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4408), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [68715] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(2697), 1,
      anon_sym_LBRACE,
    ACTIONS(4410), 1,
      sym_identifier,
    STATE(968), 1,
      sym_field_declaration_list,
    STATE(1968), 1,
      sym_ms_declspec_modifier,
  [68734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4412), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [68745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4414), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [68756] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym___declspec,
    ACTIONS(2697), 1,
      anon_sym_LBRACE,
    ACTIONS(4416), 1,
      sym_identifier,
    STATE(967), 1,
      sym_field_declaration_list,
    STATE(1932), 1,
      sym_ms_declspec_modifier,
  [68775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4418), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [68786] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3919), 1,
      sym_identifier,
    ACTIONS(4420), 1,
      aux_sym_preproc_if_token2,
    STATE(1735), 1,
      sym_enumerator,
    STATE(1822), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1823), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [68805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4422), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [68816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4424), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [68827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4426), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [68838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4428), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [68849] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(4304), 1,
      anon_sym_LBRACK,
    STATE(1791), 1,
      sym_parameter_list,
    ACTIONS(4189), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4430), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [68877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4432), 1,
      anon_sym_COMMA,
    ACTIONS(4277), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_identifier,
  [68890] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2092), 1,
      sym_gnu_asm_expression,
    ACTIONS(4300), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(4434), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [68905] = 5,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4436), 1,
      anon_sym_DQUOTE,
    ACTIONS(4438), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4440), 1,
      sym_escape_sequence,
    STATE(1862), 1,
      aux_sym_string_literal_repeat1,
  [68921] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4442), 1,
      anon_sym_SEMI,
    STATE(1849), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [68935] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    STATE(2023), 1,
      sym_argument_list,
    ACTIONS(4444), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [68949] = 5,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4446), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4448), 1,
      anon_sym_LPAREN,
    ACTIONS(4450), 1,
      sym_preproc_arg,
    STATE(2035), 1,
      sym_preproc_params,
  [68965] = 5,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4448), 1,
      anon_sym_LPAREN,
    ACTIONS(4452), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4454), 1,
      sym_preproc_arg,
    STATE(2085), 1,
      sym_preproc_params,
  [68981] = 5,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4456), 1,
      anon_sym_DQUOTE,
    ACTIONS(4458), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4460), 1,
      sym_escape_sequence,
    STATE(1872), 1,
      aux_sym_string_literal_repeat1,
  [68997] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3970), 1,
      anon_sym_COMMA,
    STATE(1812), 1,
      aux_sym__field_declaration_declarator_repeat1,
    ACTIONS(4462), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [69011] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3970), 1,
      anon_sym_COMMA,
    STATE(1812), 1,
      aux_sym__field_declaration_declarator_repeat1,
    ACTIONS(4464), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [69025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_COMMA,
    STATE(1812), 1,
      aux_sym__field_declaration_declarator_repeat1,
    ACTIONS(4469), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [69039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4471), 1,
      anon_sym_SEMI,
    STATE(1737), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [69053] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4473), 1,
      anon_sym_SEMI,
    STATE(1737), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [69067] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4475), 1,
      anon_sym_COMMA,
    STATE(1815), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(4478), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [69081] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4480), 1,
      anon_sym_SEMI,
    STATE(1851), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [69095] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym___except,
    ACTIONS(4484), 1,
      anon_sym___finally,
    STATE(351), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [69109] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4486), 1,
      anon_sym___except,
    ACTIONS(4488), 1,
      anon_sym___finally,
    STATE(349), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [69123] = 5,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4490), 1,
      anon_sym_DQUOTE,
    ACTIONS(4492), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4494), 1,
      sym_escape_sequence,
    STATE(1846), 1,
      aux_sym_string_literal_repeat1,
  [69139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4496), 1,
      anon_sym_SEMI,
    STATE(1737), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [69153] = 4,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4498), 1,
      anon_sym_SQUOTE,
    STATE(1865), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4500), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [69167] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3952), 1,
      sym_identifier,
    ACTIONS(4502), 1,
      aux_sym_preproc_if_token2,
    STATE(1676), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2334), 1,
      sym_enumerator,
  [69183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3919), 1,
      sym_identifier,
    ACTIONS(4504), 1,
      aux_sym_preproc_if_token2,
    STATE(1692), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [69197] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4506), 1,
      anon_sym_COMMA,
    STATE(1824), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(4509), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [69211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4511), 1,
      anon_sym_SEMI,
    STATE(1737), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [69225] = 5,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4448), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4515), 1,
      sym_preproc_arg,
    STATE(2103), 1,
      sym_preproc_params,
  [69241] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4517), 1,
      anon_sym_COMMA,
    STATE(1836), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(4519), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [69255] = 5,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4448), 1,
      anon_sym_LPAREN,
    ACTIONS(4521), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4523), 1,
      sym_preproc_arg,
    STATE(2105), 1,
      sym_preproc_params,
  [69271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4144), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
      sym_identifier,
  [69281] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3919), 1,
      sym_identifier,
    ACTIONS(4525), 1,
      aux_sym_preproc_if_token2,
    STATE(1823), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [69295] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4527), 1,
      anon_sym_SEMI,
    STATE(1813), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [69309] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(4304), 1,
      anon_sym_LBRACK,
    ACTIONS(4529), 1,
      anon_sym_RPAREN,
    STATE(1791), 1,
      sym_parameter_list,
  [69325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4531), 4,
      anon_sym_LPAREN2,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [69335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4533), 1,
      anon_sym___except,
    ACTIONS(4535), 1,
      anon_sym___finally,
    STATE(351), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [69349] = 5,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4537), 1,
      anon_sym_DQUOTE,
    ACTIONS(4539), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4541), 1,
      sym_escape_sequence,
    STATE(1860), 1,
      aux_sym_string_literal_repeat1,
  [69365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4517), 1,
      anon_sym_COMMA,
    STATE(1815), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(4543), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [69379] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4545), 1,
      anon_sym_SEMI,
    STATE(1814), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [69393] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4547), 1,
      anon_sym_COMMA,
    STATE(1838), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(4550), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [69407] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4552), 1,
      anon_sym_SEMI,
    STATE(1737), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [69421] = 5,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4448), 1,
      anon_sym_LPAREN,
    ACTIONS(4554), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4556), 1,
      sym_preproc_arg,
    STATE(2112), 1,
      sym_preproc_params,
  [69437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4558), 1,
      anon_sym_COMMA,
    STATE(1841), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(4561), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [69451] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4563), 1,
      anon_sym_SEMI,
    STATE(1858), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [69465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4565), 1,
      anon_sym___except,
    ACTIONS(4567), 1,
      anon_sym___finally,
    STATE(204), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [69479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4569), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_asm,
      anon_sym___asm__,
  [69489] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4571), 1,
      anon_sym_SEMI,
    STATE(1863), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [69503] = 5,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4573), 1,
      anon_sym_DQUOTE,
    ACTIONS(4575), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4578), 1,
      sym_escape_sequence,
    STATE(1846), 1,
      aux_sym_string_literal_repeat1,
  [69519] = 5,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4448), 1,
      anon_sym_LPAREN,
    ACTIONS(4581), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4583), 1,
      sym_preproc_arg,
    STATE(2110), 1,
      sym_preproc_params,
  [69535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4585), 1,
      anon_sym_COMMA,
    STATE(1841), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(4587), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [69549] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4589), 1,
      anon_sym_SEMI,
    STATE(1737), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [69563] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3952), 1,
      sym_identifier,
    ACTIONS(4420), 1,
      aux_sym_preproc_if_token2,
    STATE(1822), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2334), 1,
      sym_enumerator,
  [69579] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4591), 1,
      anon_sym_SEMI,
    STATE(1737), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [69593] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3942), 1,
      anon_sym_LPAREN2,
    ACTIONS(4304), 1,
      anon_sym_LBRACK,
    ACTIONS(4593), 1,
      anon_sym_RPAREN,
    STATE(1791), 1,
      sym_parameter_list,
  [69609] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4595), 1,
      anon_sym___except,
    ACTIONS(4597), 1,
      anon_sym___finally,
    STATE(282), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [69623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3970), 1,
      anon_sym_COMMA,
    STATE(1810), 1,
      aux_sym__field_declaration_declarator_repeat1,
    ACTIONS(4599), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [69637] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4601), 1,
      anon_sym_SEMI,
    STATE(1737), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [69651] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4603), 1,
      anon_sym_SEMI,
    STATE(1839), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [69665] = 4,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4605), 1,
      anon_sym_SQUOTE,
    STATE(1865), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4500), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [69679] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4607), 1,
      anon_sym_SEMI,
    STATE(1737), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [69693] = 4,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4609), 1,
      anon_sym_SQUOTE,
    STATE(1865), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4500), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [69707] = 5,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4492), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4494), 1,
      sym_escape_sequence,
    ACTIONS(4611), 1,
      anon_sym_DQUOTE,
    STATE(1846), 1,
      aux_sym_string_literal_repeat1,
  [69723] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4613), 1,
      anon_sym_COMMA,
    ACTIONS(4615), 1,
      anon_sym_RPAREN,
    STATE(1909), 1,
      aux_sym__old_style_parameter_list_repeat1,
    STATE(1934), 1,
      aux_sym_parameter_list_repeat1,
  [69739] = 5,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4492), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4494), 1,
      sym_escape_sequence,
    ACTIONS(4617), 1,
      anon_sym_DQUOTE,
    STATE(1846), 1,
      aux_sym_string_literal_repeat1,
  [69755] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4619), 1,
      anon_sym_SEMI,
    STATE(1737), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [69769] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4621), 1,
      anon_sym_COMMA,
    STATE(1838), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(4623), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [69783] = 4,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4625), 1,
      anon_sym_SQUOTE,
    STATE(1865), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4627), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [69797] = 5,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4448), 1,
      anon_sym_LPAREN,
    ACTIONS(4630), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4632), 1,
      sym_preproc_arg,
    STATE(2055), 1,
      sym_preproc_params,
  [69813] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4053), 1,
      anon_sym_COMMA,
    STATE(1824), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(4634), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [69827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4621), 1,
      anon_sym_COMMA,
    STATE(1864), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(4636), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [69841] = 5,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4448), 1,
      anon_sym_LPAREN,
    ACTIONS(4638), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4640), 1,
      sym_preproc_arg,
    STATE(2115), 1,
      sym_preproc_params,
  [69857] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4642), 1,
      anon_sym_SEMI,
    STATE(1825), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [69871] = 4,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4644), 1,
      anon_sym_SQUOTE,
    STATE(1865), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4500), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [69885] = 5,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4492), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4494), 1,
      sym_escape_sequence,
    ACTIONS(4646), 1,
      anon_sym_DQUOTE,
    STATE(1846), 1,
      aux_sym_string_literal_repeat1,
  [69901] = 5,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4448), 1,
      anon_sym_LPAREN,
    ACTIONS(4648), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4650), 1,
      sym_preproc_arg,
    STATE(2075), 1,
      sym_preproc_params,
  [69917] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4652), 1,
      anon_sym_SEMI,
    STATE(1855), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [69931] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4585), 1,
      anon_sym_COMMA,
    STATE(1848), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(4654), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [69945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4656), 1,
      anon_sym_SEMI,
    STATE(1820), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [69959] = 5,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4658), 1,
      anon_sym_DQUOTE,
    ACTIONS(4660), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4662), 1,
      sym_escape_sequence,
    STATE(1819), 1,
      aux_sym_string_literal_repeat1,
  [69975] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4664), 1,
      anon_sym___except,
    ACTIONS(4666), 1,
      anon_sym___finally,
    STATE(130), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [69989] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4668), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3105), 1,
      anon_sym_LBRACE,
    ACTIONS(4670), 1,
      sym_identifier,
    STATE(1390), 1,
      sym_enumerator_list,
  [70015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4672), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70028] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4674), 1,
      anon_sym_SEMI,
    STATE(1918), 1,
      aux_sym_declaration_repeat1,
  [70041] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4676), 1,
      anon_sym_SEMI,
    STATE(1879), 1,
      aux_sym_declaration_repeat1,
  [70054] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4678), 1,
      anon_sym_COMMA,
    ACTIONS(4680), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1967), 1,
      aux_sym_attribute_declaration_repeat1,
  [70067] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4682), 1,
      anon_sym_SEMI,
    STATE(1910), 1,
      aux_sym_declaration_repeat1,
  [70080] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3396), 1,
      anon_sym_COMMA,
    ACTIONS(4684), 1,
      anon_sym_RPAREN,
    STATE(1894), 1,
      aux_sym_argument_list_repeat1,
  [70093] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4686), 1,
      anon_sym_RPAREN,
    ACTIONS(4688), 1,
      anon_sym_COLON,
    STATE(1914), 1,
      sym_gnu_asm_output_operand_list,
  [70106] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3396), 1,
      anon_sym_COMMA,
    ACTIONS(3410), 1,
      anon_sym_RPAREN,
    STATE(2004), 1,
      aux_sym_argument_list_repeat1,
  [70119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4690), 1,
      anon_sym_SEMI,
    STATE(1922), 1,
      aux_sym_declaration_repeat1,
  [70132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4692), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70145] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3396), 1,
      anon_sym_COMMA,
    ACTIONS(4694), 1,
      anon_sym_RPAREN,
    STATE(1894), 1,
      aux_sym_argument_list_repeat1,
  [70158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4696), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70171] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4698), 1,
      anon_sym_RPAREN,
    ACTIONS(4700), 1,
      anon_sym_COLON,
    STATE(2417), 1,
      sym_gnu_asm_goto_list,
  [70184] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3500), 1,
      anon_sym_RPAREN,
    ACTIONS(4702), 1,
      anon_sym_COMMA,
    STATE(1894), 1,
      aux_sym_argument_list_repeat1,
  [70197] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3737), 1,
      anon_sym_RPAREN,
    ACTIONS(4705), 1,
      anon_sym_COMMA,
    STATE(1895), 1,
      aux_sym_preproc_argument_list_repeat1,
  [70210] = 4,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4708), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4710), 1,
      anon_sym_LPAREN2,
    STATE(2311), 1,
      sym_preproc_argument_list,
  [70223] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3406), 1,
      anon_sym_COMMA,
    ACTIONS(3408), 1,
      anon_sym_RBRACE,
    STATE(1938), 1,
      aux_sym_initializer_list_repeat1,
  [70236] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4712), 1,
      anon_sym_COMMA,
    ACTIONS(4715), 1,
      anon_sym_RPAREN,
    STATE(1898), 1,
      aux_sym_preproc_params_repeat1,
  [70249] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4717), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70262] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4719), 1,
      anon_sym_SEMI,
    STATE(1892), 1,
      aux_sym_declaration_repeat1,
  [70275] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4688), 1,
      anon_sym_COLON,
    ACTIONS(4721), 1,
      anon_sym_RPAREN,
    STATE(1928), 1,
      sym_gnu_asm_output_operand_list,
  [70288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4723), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70301] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4725), 1,
      anon_sym_SEMI,
    STATE(1923), 1,
      aux_sym_declaration_repeat1,
  [70314] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2697), 1,
      anon_sym_LBRACE,
    ACTIONS(4727), 1,
      sym_identifier,
    STATE(968), 1,
      sym_field_declaration_list,
  [70327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4729), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [70336] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4731), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70349] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4733), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70362] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4735), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70375] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_COMMA,
    ACTIONS(4739), 1,
      anon_sym_RPAREN,
    STATE(1956), 1,
      aux_sym__old_style_parameter_list_repeat1,
  [70388] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4741), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70401] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4743), 1,
      anon_sym_COMMA,
    ACTIONS(4745), 1,
      anon_sym_RPAREN,
    STATE(1979), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [70414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4747), 1,
      anon_sym_SEMI,
    STATE(1899), 1,
      aux_sym_declaration_repeat1,
  [70427] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3105), 1,
      anon_sym_LBRACE,
    ACTIONS(4749), 1,
      sym_identifier,
    STATE(1390), 1,
      sym_enumerator_list,
  [70440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4751), 1,
      anon_sym_RPAREN,
    ACTIONS(4753), 1,
      anon_sym_COLON,
    STATE(1931), 1,
      sym_gnu_asm_input_operand_list,
  [70453] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4755), 1,
      anon_sym_SEMI,
    STATE(2185), 1,
      sym_attribute_specifier,
  [70466] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4757), 1,
      anon_sym_COMMA,
    ACTIONS(4760), 1,
      anon_sym_RPAREN,
    STATE(1916), 1,
      aux_sym_parameter_list_repeat1,
  [70479] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4762), 1,
      sym_identifier,
    STATE(2096), 1,
      sym_variadic_parameter,
  [70492] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4764), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70505] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4766), 1,
      anon_sym_COMMA,
    ACTIONS(4769), 1,
      anon_sym_RPAREN,
    STATE(1919), 1,
      aux_sym_generic_expression_repeat1,
  [70518] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4771), 1,
      anon_sym_SEMI,
    STATE(1935), 1,
      aux_sym_declaration_repeat1,
  [70531] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4773), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70544] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4775), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70557] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4777), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4678), 1,
      anon_sym_COMMA,
    ACTIONS(4779), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1981), 1,
      aux_sym_attribute_declaration_repeat1,
  [70583] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4678), 1,
      anon_sym_COMMA,
    ACTIONS(4781), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1884), 1,
      aux_sym_attribute_declaration_repeat1,
  [70596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3597), 1,
      anon_sym_COMMA,
    ACTIONS(4783), 1,
      anon_sym_RPAREN,
    STATE(1895), 1,
      aux_sym_preproc_argument_list_repeat1,
  [70609] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4785), 1,
      anon_sym_SEMI,
    STATE(1943), 1,
      aux_sym_declaration_repeat1,
  [70622] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4753), 1,
      anon_sym_COLON,
    ACTIONS(4787), 1,
      anon_sym_RPAREN,
    STATE(1989), 1,
      sym_gnu_asm_input_operand_list,
  [70635] = 4,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4710), 1,
      anon_sym_LPAREN2,
    ACTIONS(4789), 1,
      aux_sym_preproc_include_token2,
    STATE(2311), 1,
      sym_preproc_argument_list,
  [70648] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_SEMI,
    STATE(1946), 1,
      aux_sym_declaration_repeat1,
  [70661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4793), 1,
      anon_sym_RPAREN,
    ACTIONS(4795), 1,
      anon_sym_COLON,
    STATE(1893), 1,
      sym_gnu_asm_clobber_list,
  [70674] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2697), 1,
      anon_sym_LBRACE,
    ACTIONS(4797), 1,
      sym_identifier,
    STATE(974), 1,
      sym_field_declaration_list,
  [70687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4799), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [70696] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_COMMA,
    ACTIONS(4803), 1,
      anon_sym_RPAREN,
    STATE(1916), 1,
      aux_sym_parameter_list_repeat1,
  [70709] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4805), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4807), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [70731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4809), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70744] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2091), 1,
      anon_sym_RBRACE,
    ACTIONS(4811), 1,
      anon_sym_COMMA,
    STATE(1962), 1,
      aux_sym_initializer_list_repeat1,
  [70757] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4813), 1,
      anon_sym_SEMI,
    STATE(2215), 1,
      sym_attribute_specifier,
  [70770] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4815), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70783] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4817), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70796] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3396), 1,
      anon_sym_COMMA,
    ACTIONS(3404), 1,
      anon_sym_RPAREN,
    STATE(1977), 1,
      aux_sym_argument_list_repeat1,
  [70809] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4819), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4821), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat1,
  [70835] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4823), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70848] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4825), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70861] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4827), 1,
      anon_sym_SEMI,
    STATE(1906), 1,
      aux_sym_declaration_repeat1,
  [70874] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4829), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70887] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4831), 1,
      anon_sym_SEMI,
    STATE(1950), 1,
      aux_sym_declaration_repeat1,
  [70900] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4833), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4835), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [70922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4837), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [70931] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3392), 1,
      anon_sym_COMMA,
    ACTIONS(4839), 1,
      anon_sym_RPAREN,
    STATE(1919), 1,
      aux_sym_generic_expression_repeat1,
  [70944] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4841), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [70957] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    STATE(1821), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4843), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [70968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4845), 1,
      anon_sym_COMMA,
    ACTIONS(4848), 1,
      anon_sym_RPAREN,
    STATE(1956), 1,
      aux_sym__old_style_parameter_list_repeat1,
  [70981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4678), 1,
      anon_sym_COMMA,
    ACTIONS(4850), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1967), 1,
      aux_sym_attribute_declaration_repeat1,
  [70994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4852), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [71003] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4854), 1,
      anon_sym_SEMI,
    STATE(1937), 1,
      aux_sym_declaration_repeat1,
  [71016] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4856), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [71029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4858), 1,
      anon_sym_SEMI,
    STATE(1976), 1,
      aux_sym_declaration_repeat1,
  [71042] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3484), 1,
      anon_sym_RBRACE,
    ACTIONS(4860), 1,
      anon_sym_COMMA,
    STATE(1962), 1,
      aux_sym_initializer_list_repeat1,
  [71055] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4678), 1,
      anon_sym_COMMA,
    ACTIONS(4863), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1957), 1,
      aux_sym_attribute_declaration_repeat1,
  [71068] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4865), 1,
      anon_sym_SEMI,
    STATE(1985), 1,
      aux_sym_declaration_repeat1,
  [71081] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 1,
      anon_sym_COMMA,
    ACTIONS(4870), 1,
      anon_sym_RPAREN,
    STATE(1965), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [71094] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4872), 1,
      anon_sym_COMMA,
    ACTIONS(4874), 1,
      anon_sym_RPAREN,
    STATE(1984), 1,
      aux_sym_preproc_params_repeat1,
  [71107] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4876), 1,
      anon_sym_COMMA,
    ACTIONS(4879), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1967), 1,
      aux_sym_attribute_declaration_repeat1,
  [71120] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2697), 1,
      anon_sym_LBRACE,
    ACTIONS(4881), 1,
      sym_identifier,
    STATE(959), 1,
      sym_field_declaration_list,
  [71133] = 4,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4710), 1,
      anon_sym_LPAREN2,
    ACTIONS(4883), 1,
      aux_sym_preproc_include_token2,
    STATE(2311), 1,
      sym_preproc_argument_list,
  [71146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4885), 1,
      anon_sym_COMMA,
    ACTIONS(4888), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [71159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4892), 1,
      anon_sym_RPAREN,
    ACTIONS(4890), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [71170] = 4,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4710), 1,
      anon_sym_LPAREN2,
    ACTIONS(4894), 1,
      aux_sym_preproc_include_token2,
    STATE(2311), 1,
      sym_preproc_argument_list,
  [71183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4896), 1,
      anon_sym_EQ,
    ACTIONS(4148), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [71194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4898), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [71203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4900), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [71212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4902), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [71225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3396), 1,
      anon_sym_COMMA,
    ACTIONS(3398), 1,
      anon_sym_RPAREN,
    STATE(1894), 1,
      aux_sym_argument_list_repeat1,
  [71238] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3597), 1,
      anon_sym_COMMA,
    ACTIONS(4904), 1,
      anon_sym_RPAREN,
    STATE(1895), 1,
      aux_sym_preproc_argument_list_repeat1,
  [71251] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4743), 1,
      anon_sym_COMMA,
    ACTIONS(4906), 1,
      anon_sym_RPAREN,
    STATE(1965), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [71264] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3105), 1,
      anon_sym_LBRACE,
    ACTIONS(4908), 1,
      sym_identifier,
    STATE(1153), 1,
      sym_enumerator_list,
  [71277] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4678), 1,
      anon_sym_COMMA,
    ACTIONS(4910), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1967), 1,
      aux_sym_attribute_declaration_repeat1,
  [71290] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3392), 1,
      anon_sym_COMMA,
    ACTIONS(4912), 1,
      anon_sym_RPAREN,
    STATE(1919), 1,
      aux_sym_generic_expression_repeat1,
  [71303] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_COLON,
    ACTIONS(4914), 1,
      anon_sym_RPAREN,
    STATE(2241), 1,
      sym_gnu_asm_goto_list,
  [71316] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4872), 1,
      anon_sym_COMMA,
    ACTIONS(4916), 1,
      anon_sym_RPAREN,
    STATE(1898), 1,
      aux_sym_preproc_params_repeat1,
  [71329] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4918), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [71342] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4920), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [71355] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4688), 1,
      anon_sym_COLON,
    ACTIONS(4922), 1,
      anon_sym_RPAREN,
    STATE(2014), 1,
      sym_gnu_asm_output_operand_list,
  [71368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4795), 1,
      anon_sym_COLON,
    ACTIONS(4924), 1,
      anon_sym_RPAREN,
    STATE(1983), 1,
      sym_gnu_asm_clobber_list,
  [71381] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4795), 1,
      anon_sym_COLON,
    ACTIONS(4926), 1,
      anon_sym_RPAREN,
    STATE(2007), 1,
      sym_gnu_asm_clobber_list,
  [71394] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_COLON,
    ACTIONS(4928), 1,
      anon_sym_RPAREN,
    STATE(2246), 1,
      sym_gnu_asm_goto_list,
  [71407] = 4,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4710), 1,
      anon_sym_LPAREN2,
    ACTIONS(4930), 1,
      aux_sym_preproc_include_token2,
    STATE(2311), 1,
      sym_preproc_argument_list,
  [71420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2097), 1,
      anon_sym_RBRACE,
    ACTIONS(4932), 1,
      anon_sym_COMMA,
    STATE(1962), 1,
      aux_sym_initializer_list_repeat1,
  [71433] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4934), 1,
      anon_sym_SEMI,
    STATE(2012), 1,
      aux_sym_declaration_repeat1,
  [71446] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    STATE(1871), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4936), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [71457] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4938), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [71470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4940), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [71483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4942), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [71496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4753), 1,
      anon_sym_COLON,
    ACTIONS(4944), 1,
      anon_sym_RPAREN,
    STATE(1988), 1,
      sym_gnu_asm_input_operand_list,
  [71509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4946), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [71522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4795), 1,
      anon_sym_COLON,
    ACTIONS(4948), 1,
      anon_sym_RPAREN,
    STATE(1990), 1,
      sym_gnu_asm_clobber_list,
  [71535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3400), 1,
      anon_sym_COMMA,
    ACTIONS(3402), 1,
      anon_sym_RBRACE,
    STATE(1992), 1,
      aux_sym_initializer_list_repeat1,
  [71548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4950), 1,
      anon_sym_SEMI,
    STATE(1954), 1,
      aux_sym_declaration_repeat1,
  [71561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3597), 1,
      anon_sym_COMMA,
    ACTIONS(4952), 1,
      anon_sym_RPAREN,
    STATE(1895), 1,
      aux_sym_preproc_argument_list_repeat1,
  [71574] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3396), 1,
      anon_sym_COMMA,
    ACTIONS(3414), 1,
      anon_sym_RPAREN,
    STATE(1894), 1,
      aux_sym_argument_list_repeat1,
  [71587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4954), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [71600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4956), 1,
      anon_sym_SEMI,
    STATE(1986), 1,
      aux_sym_declaration_repeat1,
  [71613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_COLON,
    ACTIONS(4958), 1,
      anon_sym_RPAREN,
    STATE(2366), 1,
      sym_gnu_asm_goto_list,
  [71626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4960), 1,
      anon_sym_SEMI,
    STATE(1995), 1,
      aux_sym_declaration_repeat1,
  [71639] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4962), 1,
      anon_sym_SEMI,
    STATE(1997), 1,
      aux_sym_declaration_repeat1,
  [71652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4964), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [71665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4688), 1,
      anon_sym_COLON,
    ACTIONS(4966), 1,
      anon_sym_RPAREN,
    STATE(1998), 1,
      sym_gnu_asm_output_operand_list,
  [71678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    ACTIONS(4968), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      aux_sym_declaration_repeat1,
  [71691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3390), 3,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
  [71700] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4753), 1,
      anon_sym_COLON,
    ACTIONS(4970), 1,
      anon_sym_RPAREN,
    STATE(2000), 1,
      sym_gnu_asm_input_operand_list,
  [71713] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4972), 1,
      anon_sym_SEMI,
    STATE(2254), 1,
      sym_attribute_specifier,
  [71726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_COMMA,
    ACTIONS(4974), 1,
      anon_sym_RPAREN,
    STATE(1934), 1,
      aux_sym_parameter_list_repeat1,
  [71739] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    STATE(1857), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4976), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [71750] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym___attribute__,
    ACTIONS(4978), 1,
      anon_sym_SEMI,
    STATE(2350), 1,
      sym_attribute_specifier,
  [71763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4980), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [71772] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    STATE(1859), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4982), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [71783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4984), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [71792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4986), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [71801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4988), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [71809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4434), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [71817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4990), 1,
      sym_identifier,
    ACTIONS(4992), 1,
      anon_sym_RPAREN,
  [71827] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4994), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4996), 1,
      sym_preproc_arg,
  [71837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LBRACE,
    STATE(92), 1,
      sym_compound_statement,
  [71847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4879), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [71855] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4998), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5000), 1,
      sym_preproc_arg,
  [71865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LPAREN2,
    STATE(2078), 1,
      sym_parenthesized_expression,
  [71875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(499), 1,
      anon_sym_LBRACE,
    STATE(286), 1,
      sym_compound_statement,
  [71885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5004), 1,
      anon_sym_COMMA,
    ACTIONS(5006), 1,
      anon_sym_RBRACE,
  [71895] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5008), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5010), 1,
      sym_preproc_arg,
  [71905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      sym_identifier,
    STATE(1963), 1,
      sym_attribute,
  [71915] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5014), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5016), 1,
      sym_preproc_arg,
  [71925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    STATE(2330), 1,
      sym_argument_list,
  [71935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5018), 1,
      anon_sym_LPAREN2,
    STATE(455), 1,
      sym_parenthesized_expression,
  [71945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(1834), 1,
      sym_compound_statement,
  [71955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5018), 1,
      anon_sym_LPAREN2,
    STATE(457), 1,
      sym_parenthesized_expression,
  [71965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LBRACE,
    STATE(99), 1,
      sym_compound_statement,
  [71975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5020), 1,
      sym_identifier,
    ACTIONS(5022), 1,
      anon_sym_LPAREN2,
  [71985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LPAREN2,
    STATE(2119), 1,
      sym_parenthesized_expression,
  [71995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3528), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [72003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5018), 1,
      anon_sym_LPAREN2,
    STATE(415), 1,
      sym_parenthesized_expression,
  [72013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LPAREN2,
    STATE(2121), 1,
      sym_parenthesized_expression,
  [72023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LPAREN2,
    STATE(2273), 1,
      sym_parenthesized_expression,
  [72033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(499), 1,
      anon_sym_LBRACE,
    STATE(324), 1,
      sym_compound_statement,
  [72043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LPAREN2,
    STATE(2090), 1,
      sym_parenthesized_expression,
  [72053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(1818), 1,
      sym_compound_statement,
  [72063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4404), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [72071] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5024), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5026), 1,
      sym_preproc_arg,
  [72081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LPAREN2,
    STATE(2073), 1,
      sym_parenthesized_expression,
  [72091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5018), 1,
      anon_sym_LPAREN2,
    STATE(414), 1,
      sym_parenthesized_expression,
  [72101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LPAREN2,
    STATE(2040), 1,
      sym_parenthesized_expression,
  [72111] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5028), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5030), 1,
      sym_preproc_arg,
  [72121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LPAREN2,
    STATE(2402), 1,
      sym_parenthesized_expression,
  [72131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5032), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [72139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(201), 1,
      anon_sym_LBRACE,
    STATE(182), 1,
      sym_compound_statement,
  [72149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(1843), 1,
      sym_compound_statement,
  [72159] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5034), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5036), 1,
      sym_preproc_arg,
  [72169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5018), 1,
      anon_sym_LPAREN2,
    STATE(428), 1,
      sym_parenthesized_expression,
  [72179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LPAREN2,
    STATE(2058), 1,
      sym_parenthesized_expression,
  [72189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5018), 1,
      anon_sym_LPAREN2,
    STATE(429), 1,
      sym_parenthesized_expression,
  [72199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5038), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [72207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5040), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [72215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LPAREN2,
    STATE(2107), 1,
      sym_parenthesized_expression,
  [72225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LPAREN2,
    STATE(2155), 1,
      sym_parenthesized_expression,
  [72235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(1878), 1,
      sym_compound_statement,
  [72245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(286), 1,
      sym_compound_statement,
  [72255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5018), 1,
      anon_sym_LPAREN2,
    STATE(403), 1,
      sym_parenthesized_expression,
  [72265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LPAREN2,
    STATE(2122), 1,
      sym_parenthesized_expression,
  [72275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5018), 1,
      anon_sym_LPAREN2,
    STATE(466), 1,
      sym_parenthesized_expression,
  [72285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(565), 1,
      anon_sym_LBRACE,
    STATE(337), 1,
      sym_compound_statement,
  [72295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      sym_identifier,
    STATE(1925), 1,
      sym_attribute,
  [72305] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5042), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5044), 1,
      sym_preproc_arg,
  [72315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LPAREN2,
    STATE(2383), 1,
      sym_parenthesized_expression,
  [72325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(302), 1,
      sym_compound_statement,
  [72335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(499), 1,
      anon_sym_LBRACE,
    STATE(302), 1,
      sym_compound_statement,
  [72345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5048), 1,
      anon_sym_LPAREN2,
  [72355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LPAREN2,
    STATE(2077), 1,
      sym_parenthesized_expression,
  [72365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LPAREN2,
    STATE(2266), 1,
      sym_parenthesized_expression,
  [72375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3958), 1,
      anon_sym_RBRACE,
    ACTIONS(5004), 1,
      anon_sym_COMMA,
  [72385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LPAREN2,
    STATE(2189), 1,
      sym_argument_list,
  [72395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4760), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [72403] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5050), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5052), 1,
      sym_preproc_arg,
  [72413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3484), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [72421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3482), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [72429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(1817), 1,
      sym_compound_statement,
  [72439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(1853), 1,
      sym_compound_statement,
  [72449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(281), 1,
      sym_compound_statement,
  [72459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      sym_identifier,
    STATE(2028), 1,
      sym_attribute,
  [72469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5054), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [72477] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5056), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5058), 1,
      sym_preproc_arg,
  [72487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5060), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [72495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5062), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [72503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4848), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [72511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5018), 1,
      anon_sym_LPAREN2,
    STATE(462), 1,
      sym_parenthesized_expression,
  [72521] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5065), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5067), 1,
      sym_preproc_arg,
  [72531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym_LPAREN2,
    STATE(2047), 1,
      sym_parenthesized_expression,
  [72541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5018), 1,
      anon_sym_LPAREN2,
    STATE(461), 1,
      sym_parenthesized_expression,
  [72551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 1,
      sym_identifier,
    STATE(1924), 1,
      sym_attribute,
  [72561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3486), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [72569] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5069), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5071), 1,
      sym_preproc_arg,
  [72579] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5073), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5075), 1,
      sym_preproc_arg,
  [72589] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5077), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5079), 1,
      sym_preproc_arg,
  [72599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5018), 1,
      anon_sym_LPAREN2,
    STATE(439), 1,
      sym_parenthesized_expression,
  [72609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(310), 1,
      sym_compound_statement,
  [72619] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5081), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5083), 1,
      sym_preproc_arg,
  [72629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5018), 1,
      anon_sym_LPAREN2,
    STATE(500), 1,
      sym_parenthesized_expression,
  [72639] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5085), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5087), 1,
      sym_preproc_arg,
  [72649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(201), 1,
      anon_sym_LBRACE,
    STATE(212), 1,
      sym_compound_statement,
  [72659] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5089), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5091), 1,
      sym_preproc_arg,
  [72669] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5093), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5095), 1,
      sym_preproc_arg,
  [72679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACE,
    STATE(264), 1,
      sym_compound_statement,
  [72689] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5097), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5099), 1,
      sym_preproc_arg,
  [72699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4715), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [72707] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5101), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5103), 1,
      sym_preproc_arg,
  [72717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(565), 1,
      anon_sym_LBRACE,
    STATE(378), 1,
      sym_compound_statement,
  [72727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(565), 1,
      anon_sym_LBRACE,
    STATE(386), 1,
      sym_compound_statement,
  [72737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3500), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [72745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(201), 1,
      anon_sym_LBRACE,
    STATE(178), 1,
      sym_compound_statement,
  [72755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LBRACE,
    STATE(109), 1,
      sym_compound_statement,
  [72765] = 3,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5105), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5107), 1,
      sym_preproc_arg,
  [72775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 1,
      aux_sym_preproc_if_token2,
  [72782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3426), 1,
      anon_sym_SEMI,
  [72789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5111), 1,
      anon_sym_SEMI,
  [72796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 1,
      aux_sym_preproc_if_token2,
  [72803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5115), 1,
      sym_identifier,
  [72810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 1,
      aux_sym_preproc_if_token2,
  [72817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5119), 1,
      aux_sym_preproc_if_token2,
  [72824] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5121), 1,
      aux_sym_preproc_include_token2,
  [72831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3502), 1,
      anon_sym_COLON,
  [72838] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5123), 1,
      aux_sym_preproc_include_token2,
  [72845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5125), 1,
      aux_sym_preproc_if_token2,
  [72852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5127), 1,
      anon_sym_COLON,
  [72859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 1,
      anon_sym_LPAREN2,
  [72866] = 2,
    ACTIONS(3378), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(3595), 1,
      sym_comment,
  [72873] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5131), 1,
      aux_sym_preproc_include_token2,
  [72880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5133), 1,
      anon_sym_RPAREN,
  [72887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5135), 1,
      aux_sym_preproc_if_token2,
  [72894] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5137), 1,
      aux_sym_preproc_include_token2,
  [72901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5139), 1,
      anon_sym_RPAREN,
  [72908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5141), 1,
      anon_sym_RPAREN,
  [72915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5143), 1,
      anon_sym_RPAREN,
  [72922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5145), 1,
      aux_sym_preproc_if_token2,
  [72929] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5147), 1,
      aux_sym_preproc_include_token2,
  [72936] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5149), 1,
      aux_sym_preproc_include_token2,
  [72943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5151), 1,
      anon_sym_SEMI,
  [72950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3476), 1,
      anon_sym_SEMI,
  [72957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3428), 1,
      anon_sym_SEMI,
  [72964] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5153), 1,
      aux_sym_preproc_include_token2,
  [72971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5155), 1,
      anon_sym_SEMI,
  [72978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5157), 1,
      anon_sym_RPAREN,
  [72985] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5159), 1,
      aux_sym_preproc_include_token2,
  [72992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5161), 1,
      anon_sym_SEMI,
  [72999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5163), 1,
      anon_sym_RPAREN,
  [73006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3436), 1,
      anon_sym_RPAREN,
  [73013] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5165), 1,
      aux_sym_preproc_include_token2,
  [73020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5167), 1,
      anon_sym_RPAREN,
  [73027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5169), 1,
      anon_sym_STAR,
  [73034] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5171), 1,
      aux_sym_preproc_include_token2,
  [73041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5173), 1,
      anon_sym_SEMI,
  [73048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5175), 1,
      anon_sym_SEMI,
  [73055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_RPAREN,
  [73062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5179), 1,
      anon_sym_COLON,
  [73069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5181), 1,
      sym_identifier,
  [73076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      aux_sym_preproc_if_token2,
  [73083] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5185), 1,
      aux_sym_preproc_include_token2,
  [73090] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5187), 1,
      aux_sym_preproc_include_token2,
  [73097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5189), 1,
      aux_sym_preproc_if_token2,
  [73104] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5191), 1,
      aux_sym_preproc_include_token2,
  [73111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5193), 1,
      sym_identifier,
  [73118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5195), 1,
      anon_sym_LPAREN2,
  [73125] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5197), 1,
      aux_sym_preproc_include_token2,
  [73132] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5199), 1,
      aux_sym_preproc_include_token2,
  [73139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5201), 1,
      aux_sym_preproc_if_token2,
  [73146] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5203), 1,
      aux_sym_preproc_include_token2,
  [73153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5205), 1,
      sym_identifier,
  [73160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5207), 1,
      sym_identifier,
  [73167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5209), 1,
      sym_identifier,
  [73174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5211), 1,
      sym_identifier,
  [73181] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5213), 1,
      aux_sym_preproc_include_token2,
  [73188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3450), 1,
      anon_sym_COLON,
  [73195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5215), 1,
      aux_sym_preproc_if_token2,
  [73202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5217), 1,
      anon_sym_SEMI,
  [73209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5219), 1,
      aux_sym_preproc_if_token2,
  [73216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5221), 1,
      aux_sym_preproc_if_token2,
  [73223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5223), 1,
      sym_identifier,
  [73230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5225), 1,
      anon_sym_RPAREN,
  [73237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3474), 1,
      anon_sym_SEMI,
  [73244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5227), 1,
      aux_sym_preproc_if_token2,
  [73251] = 2,
    ACTIONS(2440), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(3595), 1,
      sym_comment,
  [73258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5229), 1,
      sym_identifier,
  [73265] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4789), 1,
      aux_sym_preproc_include_token2,
  [73272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5231), 1,
      anon_sym_RPAREN,
  [73279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5233), 1,
      aux_sym_preproc_if_token2,
  [73286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5235), 1,
      aux_sym_preproc_if_token2,
  [73293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5237), 1,
      aux_sym_preproc_if_token2,
  [73300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5239), 1,
      anon_sym_COLON,
  [73307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_RPAREN,
  [73314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5243), 1,
      aux_sym_preproc_if_token2,
  [73321] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5245), 1,
      aux_sym_preproc_include_token2,
  [73328] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5247), 1,
      anon_sym_SEMI,
  [73335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      anon_sym_RPAREN,
  [73342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5251), 1,
      anon_sym_COLON,
  [73349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5253), 1,
      anon_sym_RBRACK,
  [73356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5255), 1,
      aux_sym_preproc_if_token2,
  [73363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3438), 1,
      anon_sym_SEMI,
  [73370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5257), 1,
      sym_identifier,
  [73377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3442), 1,
      anon_sym_RPAREN,
  [73384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5259), 1,
      sym_identifier,
  [73391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3444), 1,
      anon_sym_RPAREN,
  [73398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3454), 1,
      anon_sym_RPAREN,
  [73405] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5261), 1,
      aux_sym_preproc_include_token2,
  [73412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5263), 1,
      anon_sym_SEMI,
  [73419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5265), 1,
      aux_sym_preproc_if_token2,
  [73426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5267), 1,
      anon_sym_while,
  [73433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5269), 1,
      aux_sym_preproc_if_token2,
  [73440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      sym_primitive_type,
  [73447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5273), 1,
      anon_sym_RBRACE,
  [73454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5275), 1,
      anon_sym_RPAREN,
  [73461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 1,
      anon_sym_RPAREN,
  [73468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5277), 1,
      sym_identifier,
  [73475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5279), 1,
      sym_identifier,
  [73482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5281), 1,
      aux_sym_preproc_if_token2,
  [73489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5004), 1,
      anon_sym_COMMA,
  [73496] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5283), 1,
      sym_identifier,
  [73503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5285), 1,
      sym_identifier,
  [73510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5287), 1,
      sym_identifier,
  [73517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5289), 1,
      sym_identifier,
  [73524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5291), 1,
      anon_sym_RPAREN,
  [73531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5293), 1,
      anon_sym_RPAREN,
  [73538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5295), 1,
      aux_sym_preproc_if_token2,
  [73545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5297), 1,
      aux_sym_preproc_if_token2,
  [73552] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5299), 1,
      aux_sym_preproc_include_token2,
  [73559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 1,
      aux_sym_preproc_if_token2,
  [73566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5303), 1,
      aux_sym_preproc_if_token2,
  [73573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3504), 1,
      anon_sym_COLON,
  [73580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3958), 1,
      anon_sym_RBRACE,
  [73587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3440), 1,
      anon_sym_RPAREN,
  [73594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 1,
      anon_sym_RPAREN,
  [73601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5307), 1,
      sym_identifier,
  [73608] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5309), 1,
      aux_sym_preproc_if_token2,
  [73615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5311), 1,
      aux_sym_preproc_if_token2,
  [73622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5313), 1,
      anon_sym_SEMI,
  [73629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_RPAREN,
  [73636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5317), 1,
      aux_sym_preproc_if_token2,
  [73643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5319), 1,
      aux_sym_preproc_if_token2,
  [73650] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4930), 1,
      aux_sym_preproc_include_token2,
  [73657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5321), 1,
      anon_sym_SEMI,
  [73664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5323), 1,
      aux_sym_preproc_if_token2,
  [73671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5325), 1,
      anon_sym_RPAREN,
  [73678] = 2,
    ACTIONS(2436), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(3595), 1,
      sym_comment,
  [73685] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5327), 1,
      anon_sym_SEMI,
  [73692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5329), 1,
      anon_sym_RBRACE,
  [73699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5331), 1,
      aux_sym_preproc_if_token2,
  [73706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5333), 1,
      anon_sym_SEMI,
  [73713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5335), 1,
      aux_sym_preproc_if_token2,
  [73720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5337), 1,
      ts_builtin_sym_end,
  [73727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3402), 1,
      anon_sym_RBRACE,
  [73734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      aux_sym_preproc_if_token2,
  [73741] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5341), 1,
      aux_sym_preproc_if_token2,
  [73748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3464), 1,
      anon_sym_COLON,
  [73755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3446), 1,
      anon_sym_SEMI,
  [73762] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5343), 1,
      anon_sym_RPAREN,
  [73769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5345), 1,
      anon_sym_SEMI,
  [73776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5347), 1,
      sym_identifier,
  [73783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 1,
      sym_identifier,
  [73790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3516), 1,
      anon_sym_SEMI,
  [73797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5351), 1,
      anon_sym_SEMI,
  [73804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3452), 1,
      anon_sym_RPAREN,
  [73811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5353), 1,
      anon_sym_RBRACE,
  [73818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_SEMI,
  [73825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5357), 1,
      anon_sym_RPAREN,
  [73832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_SEMI,
  [73839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5359), 1,
      sym_identifier,
  [73846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5361), 1,
      anon_sym_RPAREN,
  [73853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5363), 1,
      anon_sym_LPAREN2,
  [73860] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5365), 1,
      aux_sym_preproc_include_token2,
  [73867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5367), 1,
      anon_sym_COMMA,
  [73874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5369), 1,
      aux_sym_preproc_if_token2,
  [73881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5371), 1,
      anon_sym_SEMI,
  [73888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_LPAREN2,
  [73895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5375), 1,
      anon_sym_LPAREN2,
  [73902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5377), 1,
      aux_sym_preproc_if_token2,
  [73909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5379), 1,
      anon_sym_RPAREN,
  [73916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_RPAREN,
  [73923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      sym_identifier,
  [73930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5385), 1,
      anon_sym_SEMI,
  [73937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5387), 1,
      anon_sym_RPAREN,
  [73944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_COLON,
  [73951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5389), 1,
      sym_identifier,
  [73958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5391), 1,
      aux_sym_preproc_if_token2,
  [73965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3408), 1,
      anon_sym_RBRACE,
  [73972] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5393), 1,
      aux_sym_preproc_include_token2,
  [73979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      aux_sym_preproc_if_token2,
  [73986] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4883), 1,
      aux_sym_preproc_include_token2,
  [73993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5397), 1,
      sym_identifier,
  [74000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      sym_identifier,
  [74007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5401), 1,
      anon_sym_RPAREN,
  [74014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5403), 1,
      anon_sym_RPAREN,
  [74021] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5405), 1,
      aux_sym_preproc_include_token2,
  [74028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5407), 1,
      anon_sym_RPAREN,
  [74035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5409), 1,
      anon_sym_SEMI,
  [74042] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4894), 1,
      aux_sym_preproc_include_token2,
  [74049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5411), 1,
      sym_identifier,
  [74056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5413), 1,
      sym_primitive_type,
  [74063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5415), 1,
      anon_sym_SEMI,
  [74070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 1,
      anon_sym_RPAREN,
  [74077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5419), 1,
      anon_sym_RBRACE,
  [74084] = 2,
    ACTIONS(3386), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(3595), 1,
      sym_comment,
  [74091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5421), 1,
      anon_sym_SEMI,
  [74098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5423), 1,
      anon_sym_LPAREN2,
  [74105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5425), 1,
      anon_sym_RPAREN,
  [74112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3518), 1,
      anon_sym_SEMI,
  [74119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5427), 1,
      aux_sym_preproc_if_token2,
  [74126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5429), 1,
      sym_identifier,
  [74133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5431), 1,
      anon_sym_SEMI,
  [74140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5433), 1,
      anon_sym_RPAREN,
  [74147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5435), 1,
      anon_sym_SEMI,
  [74154] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5437), 1,
      aux_sym_preproc_include_token2,
  [74161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5439), 1,
      sym_identifier,
  [74168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5441), 1,
      sym_identifier,
  [74175] = 2,
    ACTIONS(3374), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(3595), 1,
      sym_comment,
  [74182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5443), 1,
      sym_identifier,
  [74189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5445), 1,
      sym_identifier,
  [74196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5447), 1,
      sym_identifier,
  [74203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5449), 1,
      sym_identifier,
  [74210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5451), 1,
      anon_sym_COLON,
  [74217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym_STAR,
  [74224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5455), 1,
      aux_sym_preproc_if_token2,
  [74231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 1,
      anon_sym_COLON,
  [74238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5459), 1,
      sym_identifier,
  [74245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4279), 1,
      anon_sym_COMMA,
  [74252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5461), 1,
      anon_sym_LPAREN2,
  [74259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5463), 1,
      anon_sym_SEMI,
  [74266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3524), 1,
      anon_sym_SEMI,
  [74273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5465), 1,
      aux_sym_preproc_if_token2,
  [74280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3520), 1,
      anon_sym_SEMI,
  [74287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5467), 1,
      sym_identifier,
  [74294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5469), 1,
      aux_sym_preproc_if_token2,
  [74301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 1,
      anon_sym_SEMI,
  [74308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3522), 1,
      anon_sym_SEMI,
  [74315] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5473), 1,
      anon_sym_SEMI,
  [74322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5475), 1,
      aux_sym_preproc_if_token2,
  [74329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_RPAREN,
  [74336] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3526), 1,
      anon_sym_RPAREN,
  [74343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5479), 1,
      sym_identifier,
  [74350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5481), 1,
      anon_sym_RBRACE,
  [74357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5483), 1,
      anon_sym_SEMI,
  [74364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      aux_sym_preproc_if_token2,
  [74371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5487), 1,
      sym_identifier,
  [74378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5489), 1,
      sym_identifier,
  [74385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5491), 1,
      sym_identifier,
  [74392] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5493), 1,
      aux_sym_preproc_include_token2,
  [74399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5495), 1,
      aux_sym_preproc_if_token2,
  [74406] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(4708), 1,
      aux_sym_preproc_include_token2,
  [74413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5497), 1,
      anon_sym_COLON,
  [74420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      aux_sym_preproc_if_token2,
  [74427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5501), 1,
      anon_sym_LPAREN2,
  [74434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 1,
      aux_sym_preproc_if_token2,
  [74441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5505), 1,
      aux_sym_preproc_if_token2,
  [74448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5507), 1,
      anon_sym_LPAREN2,
  [74455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5509), 1,
      anon_sym_SEMI,
  [74462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5511), 1,
      anon_sym_SEMI,
  [74469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5513), 1,
      anon_sym_RPAREN,
  [74476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5515), 1,
      anon_sym_RPAREN,
  [74483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5517), 1,
      sym_identifier,
  [74490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5519), 1,
      anon_sym_RBRACK,
  [74497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5521), 1,
      sym_identifier,
  [74504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5523), 1,
      anon_sym_while,
  [74511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_COLON,
  [74518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5527), 1,
      anon_sym_LPAREN2,
  [74525] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5529), 1,
      aux_sym_preproc_include_token2,
  [74532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5531), 1,
      aux_sym_preproc_if_token2,
  [74539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5533), 1,
      sym_identifier,
  [74546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5535), 1,
      aux_sym_preproc_if_token2,
  [74553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5537), 1,
      anon_sym_COMMA,
  [74560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_SEMI,
  [74567] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3514), 1,
      anon_sym_COLON,
  [74574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5539), 1,
      anon_sym_COLON,
  [74581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_SEMI,
  [74588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5541), 1,
      anon_sym_SEMI,
  [74595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5543), 1,
      anon_sym_LPAREN2,
  [74602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5545), 1,
      anon_sym_STAR,
  [74609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5547), 1,
      anon_sym_LPAREN2,
  [74616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5549), 1,
      anon_sym_while,
  [74623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5551), 1,
      anon_sym_LPAREN2,
  [74630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5553), 1,
      anon_sym_SEMI,
  [74637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5555), 1,
      anon_sym_RPAREN,
  [74644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3490), 1,
      anon_sym_COLON,
  [74651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_RBRACE,
  [74658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5557), 1,
      aux_sym_preproc_if_token2,
  [74665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5559), 1,
      anon_sym_RPAREN,
  [74672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5561), 1,
      anon_sym_while,
  [74679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5563), 1,
      aux_sym_preproc_if_token2,
  [74686] = 2,
    ACTIONS(3382), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(3595), 1,
      sym_comment,
  [74693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3530), 1,
      anon_sym_COLON,
  [74700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4432), 1,
      anon_sym_COMMA,
  [74707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5565), 1,
      aux_sym_preproc_if_token2,
  [74714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5567), 1,
      aux_sym_preproc_if_token2,
  [74721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5569), 1,
      anon_sym_SEMI,
  [74728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5571), 1,
      anon_sym_while,
  [74735] = 2,
    ACTIONS(3595), 1,
      sym_comment,
    ACTIONS(5573), 1,
      aux_sym_preproc_include_token2,
  [74742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5575), 1,
      aux_sym_preproc_if_token2,
  [74749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5577), 1,
      aux_sym_preproc_if_token2,
  [74756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5579), 1,
      anon_sym_RBRACE,
  [74763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5581), 1,
      anon_sym_LPAREN2,
  [74770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5583), 1,
      anon_sym_STAR,
  [74777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5585), 1,
      anon_sym_RPAREN,
  [74784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5587), 1,
      aux_sym_preproc_if_token2,
  [74791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5589), 1,
      anon_sym_SEMI,
  [74798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5591), 1,
      anon_sym_LPAREN2,
  [74805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5593), 1,
      aux_sym_preproc_if_token2,
  [74812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5595), 1,
      sym_identifier,
  [74819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5597), 1,
      anon_sym_LPAREN2,
  [74826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5599), 1,
      anon_sym_RPAREN,
  [74833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      aux_sym_preproc_if_token2,
  [74840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5603), 1,
      anon_sym_LPAREN2,
  [74847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_RPAREN,
  [74854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5605), 1,
      sym_identifier,
  [74861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5607), 1,
      anon_sym_LPAREN2,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(613)] = 0,
  [SMALL_STATE(614)] = 115,
  [SMALL_STATE(615)] = 230,
  [SMALL_STATE(616)] = 342,
  [SMALL_STATE(617)] = 452,
  [SMALL_STATE(618)] = 561,
  [SMALL_STATE(619)] = 670,
  [SMALL_STATE(620)] = 779,
  [SMALL_STATE(621)] = 888,
  [SMALL_STATE(622)] = 997,
  [SMALL_STATE(623)] = 1104,
  [SMALL_STATE(624)] = 1213,
  [SMALL_STATE(625)] = 1322,
  [SMALL_STATE(626)] = 1431,
  [SMALL_STATE(627)] = 1540,
  [SMALL_STATE(628)] = 1647,
  [SMALL_STATE(629)] = 1756,
  [SMALL_STATE(630)] = 1863,
  [SMALL_STATE(631)] = 1972,
  [SMALL_STATE(632)] = 2081,
  [SMALL_STATE(633)] = 2190,
  [SMALL_STATE(634)] = 2299,
  [SMALL_STATE(635)] = 2408,
  [SMALL_STATE(636)] = 2517,
  [SMALL_STATE(637)] = 2626,
  [SMALL_STATE(638)] = 2735,
  [SMALL_STATE(639)] = 2844,
  [SMALL_STATE(640)] = 2953,
  [SMALL_STATE(641)] = 3062,
  [SMALL_STATE(642)] = 3171,
  [SMALL_STATE(643)] = 3280,
  [SMALL_STATE(644)] = 3389,
  [SMALL_STATE(645)] = 3496,
  [SMALL_STATE(646)] = 3605,
  [SMALL_STATE(647)] = 3714,
  [SMALL_STATE(648)] = 3823,
  [SMALL_STATE(649)] = 3932,
  [SMALL_STATE(650)] = 4041,
  [SMALL_STATE(651)] = 4149,
  [SMALL_STATE(652)] = 4253,
  [SMALL_STATE(653)] = 4357,
  [SMALL_STATE(654)] = 4461,
  [SMALL_STATE(655)] = 4565,
  [SMALL_STATE(656)] = 4671,
  [SMALL_STATE(657)] = 4775,
  [SMALL_STATE(658)] = 4879,
  [SMALL_STATE(659)] = 4987,
  [SMALL_STATE(660)] = 5091,
  [SMALL_STATE(661)] = 5199,
  [SMALL_STATE(662)] = 5305,
  [SMALL_STATE(663)] = 5409,
  [SMALL_STATE(664)] = 5513,
  [SMALL_STATE(665)] = 5617,
  [SMALL_STATE(666)] = 5725,
  [SMALL_STATE(667)] = 5831,
  [SMALL_STATE(668)] = 5939,
  [SMALL_STATE(669)] = 6047,
  [SMALL_STATE(670)] = 6150,
  [SMALL_STATE(671)] = 6253,
  [SMALL_STATE(672)] = 6356,
  [SMALL_STATE(673)] = 6459,
  [SMALL_STATE(674)] = 6562,
  [SMALL_STATE(675)] = 6663,
  [SMALL_STATE(676)] = 6766,
  [SMALL_STATE(677)] = 6869,
  [SMALL_STATE(678)] = 6972,
  [SMALL_STATE(679)] = 7073,
  [SMALL_STATE(680)] = 7176,
  [SMALL_STATE(681)] = 7279,
  [SMALL_STATE(682)] = 7380,
  [SMALL_STATE(683)] = 7483,
  [SMALL_STATE(684)] = 7584,
  [SMALL_STATE(685)] = 7687,
  [SMALL_STATE(686)] = 7790,
  [SMALL_STATE(687)] = 7893,
  [SMALL_STATE(688)] = 7994,
  [SMALL_STATE(689)] = 8097,
  [SMALL_STATE(690)] = 8200,
  [SMALL_STATE(691)] = 8301,
  [SMALL_STATE(692)] = 8404,
  [SMALL_STATE(693)] = 8505,
  [SMALL_STATE(694)] = 8608,
  [SMALL_STATE(695)] = 8711,
  [SMALL_STATE(696)] = 8814,
  [SMALL_STATE(697)] = 8917,
  [SMALL_STATE(698)] = 9020,
  [SMALL_STATE(699)] = 9123,
  [SMALL_STATE(700)] = 9226,
  [SMALL_STATE(701)] = 9327,
  [SMALL_STATE(702)] = 9430,
  [SMALL_STATE(703)] = 9531,
  [SMALL_STATE(704)] = 9632,
  [SMALL_STATE(705)] = 9733,
  [SMALL_STATE(706)] = 9834,
  [SMALL_STATE(707)] = 9935,
  [SMALL_STATE(708)] = 10036,
  [SMALL_STATE(709)] = 10137,
  [SMALL_STATE(710)] = 10240,
  [SMALL_STATE(711)] = 10341,
  [SMALL_STATE(712)] = 10444,
  [SMALL_STATE(713)] = 10545,
  [SMALL_STATE(714)] = 10646,
  [SMALL_STATE(715)] = 10747,
  [SMALL_STATE(716)] = 10850,
  [SMALL_STATE(717)] = 10951,
  [SMALL_STATE(718)] = 11052,
  [SMALL_STATE(719)] = 11155,
  [SMALL_STATE(720)] = 11258,
  [SMALL_STATE(721)] = 11361,
  [SMALL_STATE(722)] = 11464,
  [SMALL_STATE(723)] = 11567,
  [SMALL_STATE(724)] = 11670,
  [SMALL_STATE(725)] = 11771,
  [SMALL_STATE(726)] = 11874,
  [SMALL_STATE(727)] = 11977,
  [SMALL_STATE(728)] = 12080,
  [SMALL_STATE(729)] = 12183,
  [SMALL_STATE(730)] = 12284,
  [SMALL_STATE(731)] = 12387,
  [SMALL_STATE(732)] = 12490,
  [SMALL_STATE(733)] = 12593,
  [SMALL_STATE(734)] = 12696,
  [SMALL_STATE(735)] = 12799,
  [SMALL_STATE(736)] = 12902,
  [SMALL_STATE(737)] = 13005,
  [SMALL_STATE(738)] = 13108,
  [SMALL_STATE(739)] = 13211,
  [SMALL_STATE(740)] = 13314,
  [SMALL_STATE(741)] = 13417,
  [SMALL_STATE(742)] = 13520,
  [SMALL_STATE(743)] = 13623,
  [SMALL_STATE(744)] = 13726,
  [SMALL_STATE(745)] = 13829,
  [SMALL_STATE(746)] = 13932,
  [SMALL_STATE(747)] = 14035,
  [SMALL_STATE(748)] = 14138,
  [SMALL_STATE(749)] = 14241,
  [SMALL_STATE(750)] = 14344,
  [SMALL_STATE(751)] = 14447,
  [SMALL_STATE(752)] = 14550,
  [SMALL_STATE(753)] = 14653,
  [SMALL_STATE(754)] = 14756,
  [SMALL_STATE(755)] = 14857,
  [SMALL_STATE(756)] = 14960,
  [SMALL_STATE(757)] = 15061,
  [SMALL_STATE(758)] = 15162,
  [SMALL_STATE(759)] = 15263,
  [SMALL_STATE(760)] = 15366,
  [SMALL_STATE(761)] = 15467,
  [SMALL_STATE(762)] = 15570,
  [SMALL_STATE(763)] = 15671,
  [SMALL_STATE(764)] = 15774,
  [SMALL_STATE(765)] = 15875,
  [SMALL_STATE(766)] = 15976,
  [SMALL_STATE(767)] = 16079,
  [SMALL_STATE(768)] = 16180,
  [SMALL_STATE(769)] = 16281,
  [SMALL_STATE(770)] = 16382,
  [SMALL_STATE(771)] = 16483,
  [SMALL_STATE(772)] = 16584,
  [SMALL_STATE(773)] = 16685,
  [SMALL_STATE(774)] = 16786,
  [SMALL_STATE(775)] = 16889,
  [SMALL_STATE(776)] = 16992,
  [SMALL_STATE(777)] = 17093,
  [SMALL_STATE(778)] = 17194,
  [SMALL_STATE(779)] = 17295,
  [SMALL_STATE(780)] = 17396,
  [SMALL_STATE(781)] = 17497,
  [SMALL_STATE(782)] = 17598,
  [SMALL_STATE(783)] = 17701,
  [SMALL_STATE(784)] = 17802,
  [SMALL_STATE(785)] = 17903,
  [SMALL_STATE(786)] = 18004,
  [SMALL_STATE(787)] = 18107,
  [SMALL_STATE(788)] = 18210,
  [SMALL_STATE(789)] = 18313,
  [SMALL_STATE(790)] = 18416,
  [SMALL_STATE(791)] = 18519,
  [SMALL_STATE(792)] = 18622,
  [SMALL_STATE(793)] = 18725,
  [SMALL_STATE(794)] = 18826,
  [SMALL_STATE(795)] = 18929,
  [SMALL_STATE(796)] = 19030,
  [SMALL_STATE(797)] = 19131,
  [SMALL_STATE(798)] = 19232,
  [SMALL_STATE(799)] = 19333,
  [SMALL_STATE(800)] = 19434,
  [SMALL_STATE(801)] = 19535,
  [SMALL_STATE(802)] = 19636,
  [SMALL_STATE(803)] = 19737,
  [SMALL_STATE(804)] = 19840,
  [SMALL_STATE(805)] = 19941,
  [SMALL_STATE(806)] = 20044,
  [SMALL_STATE(807)] = 20145,
  [SMALL_STATE(808)] = 20248,
  [SMALL_STATE(809)] = 20349,
  [SMALL_STATE(810)] = 20452,
  [SMALL_STATE(811)] = 20553,
  [SMALL_STATE(812)] = 20656,
  [SMALL_STATE(813)] = 20757,
  [SMALL_STATE(814)] = 20860,
  [SMALL_STATE(815)] = 20963,
  [SMALL_STATE(816)] = 21064,
  [SMALL_STATE(817)] = 21167,
  [SMALL_STATE(818)] = 21270,
  [SMALL_STATE(819)] = 21371,
  [SMALL_STATE(820)] = 21474,
  [SMALL_STATE(821)] = 21575,
  [SMALL_STATE(822)] = 21663,
  [SMALL_STATE(823)] = 21764,
  [SMALL_STATE(824)] = 21865,
  [SMALL_STATE(825)] = 21936,
  [SMALL_STATE(826)] = 22007,
  [SMALL_STATE(827)] = 22108,
  [SMALL_STATE(828)] = 22179,
  [SMALL_STATE(829)] = 22280,
  [SMALL_STATE(830)] = 22381,
  [SMALL_STATE(831)] = 22449,
  [SMALL_STATE(832)] = 22512,
  [SMALL_STATE(833)] = 22575,
  [SMALL_STATE(834)] = 22637,
  [SMALL_STATE(835)] = 22699,
  [SMALL_STATE(836)] = 22761,
  [SMALL_STATE(837)] = 22823,
  [SMALL_STATE(838)] = 22885,
  [SMALL_STATE(839)] = 22947,
  [SMALL_STATE(840)] = 23009,
  [SMALL_STATE(841)] = 23071,
  [SMALL_STATE(842)] = 23133,
  [SMALL_STATE(843)] = 23195,
  [SMALL_STATE(844)] = 23254,
  [SMALL_STATE(845)] = 23325,
  [SMALL_STATE(846)] = 23390,
  [SMALL_STATE(847)] = 23449,
  [SMALL_STATE(848)] = 23508,
  [SMALL_STATE(849)] = 23567,
  [SMALL_STATE(850)] = 23659,
  [SMALL_STATE(851)] = 23717,
  [SMALL_STATE(852)] = 23809,
  [SMALL_STATE(853)] = 23901,
  [SMALL_STATE(854)] = 23993,
  [SMALL_STATE(855)] = 24085,
  [SMALL_STATE(856)] = 24177,
  [SMALL_STATE(857)] = 24235,
  [SMALL_STATE(858)] = 24293,
  [SMALL_STATE(859)] = 24351,
  [SMALL_STATE(860)] = 24409,
  [SMALL_STATE(861)] = 24501,
  [SMALL_STATE(862)] = 24559,
  [SMALL_STATE(863)] = 24653,
  [SMALL_STATE(864)] = 24745,
  [SMALL_STATE(865)] = 24803,
  [SMALL_STATE(866)] = 24861,
  [SMALL_STATE(867)] = 24919,
  [SMALL_STATE(868)] = 25011,
  [SMALL_STATE(869)] = 25103,
  [SMALL_STATE(870)] = 25161,
  [SMALL_STATE(871)] = 25219,
  [SMALL_STATE(872)] = 25311,
  [SMALL_STATE(873)] = 25369,
  [SMALL_STATE(874)] = 25461,
  [SMALL_STATE(875)] = 25553,
  [SMALL_STATE(876)] = 25645,
  [SMALL_STATE(877)] = 25737,
  [SMALL_STATE(878)] = 25829,
  [SMALL_STATE(879)] = 25921,
  [SMALL_STATE(880)] = 26013,
  [SMALL_STATE(881)] = 26105,
  [SMALL_STATE(882)] = 26197,
  [SMALL_STATE(883)] = 26255,
  [SMALL_STATE(884)] = 26313,
  [SMALL_STATE(885)] = 26371,
  [SMALL_STATE(886)] = 26463,
  [SMALL_STATE(887)] = 26521,
  [SMALL_STATE(888)] = 26588,
  [SMALL_STATE(889)] = 26677,
  [SMALL_STATE(890)] = 26744,
  [SMALL_STATE(891)] = 26805,
  [SMALL_STATE(892)] = 26872,
  [SMALL_STATE(893)] = 26929,
  [SMALL_STATE(894)] = 26986,
  [SMALL_STATE(895)] = 27077,
  [SMALL_STATE(896)] = 27134,
  [SMALL_STATE(897)] = 27199,
  [SMALL_STATE(898)] = 27256,
  [SMALL_STATE(899)] = 27345,
  [SMALL_STATE(900)] = 27412,
  [SMALL_STATE(901)] = 27477,
  [SMALL_STATE(902)] = 27534,
  [SMALL_STATE(903)] = 27601,
  [SMALL_STATE(904)] = 27663,
  [SMALL_STATE(905)] = 27725,
  [SMALL_STATE(906)] = 27787,
  [SMALL_STATE(907)] = 27851,
  [SMALL_STATE(908)] = 27914,
  [SMALL_STATE(909)] = 27973,
  [SMALL_STATE(910)] = 28032,
  [SMALL_STATE(911)] = 28091,
  [SMALL_STATE(912)] = 28173,
  [SMALL_STATE(913)] = 28255,
  [SMALL_STATE(914)] = 28337,
  [SMALL_STATE(915)] = 28419,
  [SMALL_STATE(916)] = 28501,
  [SMALL_STATE(917)] = 28555,
  [SMALL_STATE(918)] = 28637,
  [SMALL_STATE(919)] = 28691,
  [SMALL_STATE(920)] = 28773,
  [SMALL_STATE(921)] = 28855,
  [SMALL_STATE(922)] = 28937,
  [SMALL_STATE(923)] = 29019,
  [SMALL_STATE(924)] = 29082,
  [SMALL_STATE(925)] = 29143,
  [SMALL_STATE(926)] = 29206,
  [SMALL_STATE(927)] = 29259,
  [SMALL_STATE(928)] = 29322,
  [SMALL_STATE(929)] = 29385,
  [SMALL_STATE(930)] = 29446,
  [SMALL_STATE(931)] = 29507,
  [SMALL_STATE(932)] = 29568,
  [SMALL_STATE(933)] = 29647,
  [SMALL_STATE(934)] = 29708,
  [SMALL_STATE(935)] = 29771,
  [SMALL_STATE(936)] = 29834,
  [SMALL_STATE(937)] = 29887,
  [SMALL_STATE(938)] = 29940,
  [SMALL_STATE(939)] = 30003,
  [SMALL_STATE(940)] = 30055,
  [SMALL_STATE(941)] = 30141,
  [SMALL_STATE(942)] = 30193,
  [SMALL_STATE(943)] = 30279,
  [SMALL_STATE(944)] = 30365,
  [SMALL_STATE(945)] = 30429,
  [SMALL_STATE(946)] = 30511,
  [SMALL_STATE(947)] = 30591,
  [SMALL_STATE(948)] = 30669,
  [SMALL_STATE(949)] = 30745,
  [SMALL_STATE(950)] = 30805,
  [SMALL_STATE(951)] = 30857,
  [SMALL_STATE(952)] = 30931,
  [SMALL_STATE(953)] = 31003,
  [SMALL_STATE(954)] = 31071,
  [SMALL_STATE(955)] = 31137,
  [SMALL_STATE(956)] = 31200,
  [SMALL_STATE(957)] = 31255,
  [SMALL_STATE(958)] = 31340,
  [SMALL_STATE(959)] = 31391,
  [SMALL_STATE(960)] = 31446,
  [SMALL_STATE(961)] = 31509,
  [SMALL_STATE(962)] = 31572,
  [SMALL_STATE(963)] = 31627,
  [SMALL_STATE(964)] = 31712,
  [SMALL_STATE(965)] = 31763,
  [SMALL_STATE(966)] = 31818,
  [SMALL_STATE(967)] = 31873,
  [SMALL_STATE(968)] = 31928,
  [SMALL_STATE(969)] = 31983,
  [SMALL_STATE(970)] = 32038,
  [SMALL_STATE(971)] = 32089,
  [SMALL_STATE(972)] = 32154,
  [SMALL_STATE(973)] = 32221,
  [SMALL_STATE(974)] = 32292,
  [SMALL_STATE(975)] = 32347,
  [SMALL_STATE(976)] = 32420,
  [SMALL_STATE(977)] = 32495,
  [SMALL_STATE(978)] = 32572,
  [SMALL_STATE(979)] = 32651,
  [SMALL_STATE(980)] = 32732,
  [SMALL_STATE(981)] = 32795,
  [SMALL_STATE(982)] = 32846,
  [SMALL_STATE(983)] = 32931,
  [SMALL_STATE(984)] = 32986,
  [SMALL_STATE(985)] = 33041,
  [SMALL_STATE(986)] = 33096,
  [SMALL_STATE(987)] = 33159,
  [SMALL_STATE(988)] = 33243,
  [SMALL_STATE(989)] = 33305,
  [SMALL_STATE(990)] = 33361,
  [SMALL_STATE(991)] = 33439,
  [SMALL_STATE(992)] = 33489,
  [SMALL_STATE(993)] = 33539,
  [SMALL_STATE(994)] = 33611,
  [SMALL_STATE(995)] = 33681,
  [SMALL_STATE(996)] = 33747,
  [SMALL_STATE(997)] = 33807,
  [SMALL_STATE(998)] = 33871,
  [SMALL_STATE(999)] = 33921,
  [SMALL_STATE(1000)] = 34001,
  [SMALL_STATE(1001)] = 34055,
  [SMALL_STATE(1002)] = 34115,
  [SMALL_STATE(1003)] = 34175,
  [SMALL_STATE(1004)] = 34229,
  [SMALL_STATE(1005)] = 34313,
  [SMALL_STATE(1006)] = 34389,
  [SMALL_STATE(1007)] = 34447,
  [SMALL_STATE(1008)] = 34497,
  [SMALL_STATE(1009)] = 34547,
  [SMALL_STATE(1010)] = 34597,
  [SMALL_STATE(1011)] = 34647,
  [SMALL_STATE(1012)] = 34697,
  [SMALL_STATE(1013)] = 34747,
  [SMALL_STATE(1014)] = 34797,
  [SMALL_STATE(1015)] = 34851,
  [SMALL_STATE(1016)] = 34901,
  [SMALL_STATE(1017)] = 34951,
  [SMALL_STATE(1018)] = 35005,
  [SMALL_STATE(1019)] = 35065,
  [SMALL_STATE(1020)] = 35115,
  [SMALL_STATE(1021)] = 35165,
  [SMALL_STATE(1022)] = 35225,
  [SMALL_STATE(1023)] = 35279,
  [SMALL_STATE(1024)] = 35329,
  [SMALL_STATE(1025)] = 35379,
  [SMALL_STATE(1026)] = 35433,
  [SMALL_STATE(1027)] = 35483,
  [SMALL_STATE(1028)] = 35537,
  [SMALL_STATE(1029)] = 35587,
  [SMALL_STATE(1030)] = 35637,
  [SMALL_STATE(1031)] = 35687,
  [SMALL_STATE(1032)] = 35737,
  [SMALL_STATE(1033)] = 35821,
  [SMALL_STATE(1034)] = 35895,
  [SMALL_STATE(1035)] = 35945,
  [SMALL_STATE(1036)] = 35995,
  [SMALL_STATE(1037)] = 36051,
  [SMALL_STATE(1038)] = 36101,
  [SMALL_STATE(1039)] = 36155,
  [SMALL_STATE(1040)] = 36213,
  [SMALL_STATE(1041)] = 36263,
  [SMALL_STATE(1042)] = 36313,
  [SMALL_STATE(1043)] = 36363,
  [SMALL_STATE(1044)] = 36412,
  [SMALL_STATE(1045)] = 36461,
  [SMALL_STATE(1046)] = 36510,
  [SMALL_STATE(1047)] = 36559,
  [SMALL_STATE(1048)] = 36608,
  [SMALL_STATE(1049)] = 36657,
  [SMALL_STATE(1050)] = 36706,
  [SMALL_STATE(1051)] = 36755,
  [SMALL_STATE(1052)] = 36804,
  [SMALL_STATE(1053)] = 36853,
  [SMALL_STATE(1054)] = 36902,
  [SMALL_STATE(1055)] = 36951,
  [SMALL_STATE(1056)] = 37000,
  [SMALL_STATE(1057)] = 37049,
  [SMALL_STATE(1058)] = 37098,
  [SMALL_STATE(1059)] = 37147,
  [SMALL_STATE(1060)] = 37196,
  [SMALL_STATE(1061)] = 37245,
  [SMALL_STATE(1062)] = 37294,
  [SMALL_STATE(1063)] = 37343,
  [SMALL_STATE(1064)] = 37392,
  [SMALL_STATE(1065)] = 37441,
  [SMALL_STATE(1066)] = 37490,
  [SMALL_STATE(1067)] = 37539,
  [SMALL_STATE(1068)] = 37588,
  [SMALL_STATE(1069)] = 37637,
  [SMALL_STATE(1070)] = 37686,
  [SMALL_STATE(1071)] = 37735,
  [SMALL_STATE(1072)] = 37784,
  [SMALL_STATE(1073)] = 37833,
  [SMALL_STATE(1074)] = 37882,
  [SMALL_STATE(1075)] = 37931,
  [SMALL_STATE(1076)] = 37980,
  [SMALL_STATE(1077)] = 38029,
  [SMALL_STATE(1078)] = 38078,
  [SMALL_STATE(1079)] = 38127,
  [SMALL_STATE(1080)] = 38176,
  [SMALL_STATE(1081)] = 38225,
  [SMALL_STATE(1082)] = 38274,
  [SMALL_STATE(1083)] = 38323,
  [SMALL_STATE(1084)] = 38372,
  [SMALL_STATE(1085)] = 38421,
  [SMALL_STATE(1086)] = 38470,
  [SMALL_STATE(1087)] = 38519,
  [SMALL_STATE(1088)] = 38568,
  [SMALL_STATE(1089)] = 38621,
  [SMALL_STATE(1090)] = 38683,
  [SMALL_STATE(1091)] = 38741,
  [SMALL_STATE(1092)] = 38803,
  [SMALL_STATE(1093)] = 38865,
  [SMALL_STATE(1094)] = 38927,
  [SMALL_STATE(1095)] = 38989,
  [SMALL_STATE(1096)] = 39036,
  [SMALL_STATE(1097)] = 39095,
  [SMALL_STATE(1098)] = 39142,
  [SMALL_STATE(1099)] = 39207,
  [SMALL_STATE(1100)] = 39270,
  [SMALL_STATE(1101)] = 39329,
  [SMALL_STATE(1102)] = 39412,
  [SMALL_STATE(1103)] = 39495,
  [SMALL_STATE(1104)] = 39542,
  [SMALL_STATE(1105)] = 39595,
  [SMALL_STATE(1106)] = 39642,
  [SMALL_STATE(1107)] = 39689,
  [SMALL_STATE(1108)] = 39736,
  [SMALL_STATE(1109)] = 39783,
  [SMALL_STATE(1110)] = 39830,
  [SMALL_STATE(1111)] = 39877,
  [SMALL_STATE(1112)] = 39924,
  [SMALL_STATE(1113)] = 39977,
  [SMALL_STATE(1114)] = 40032,
  [SMALL_STATE(1115)] = 40079,
  [SMALL_STATE(1116)] = 40126,
  [SMALL_STATE(1117)] = 40173,
  [SMALL_STATE(1118)] = 40242,
  [SMALL_STATE(1119)] = 40289,
  [SMALL_STATE(1120)] = 40368,
  [SMALL_STATE(1121)] = 40439,
  [SMALL_STATE(1122)] = 40518,
  [SMALL_STATE(1123)] = 40597,
  [SMALL_STATE(1124)] = 40644,
  [SMALL_STATE(1125)] = 40691,
  [SMALL_STATE(1126)] = 40738,
  [SMALL_STATE(1127)] = 40785,
  [SMALL_STATE(1128)] = 40844,
  [SMALL_STATE(1129)] = 40927,
  [SMALL_STATE(1130)] = 40986,
  [SMALL_STATE(1131)] = 41045,
  [SMALL_STATE(1132)] = 41106,
  [SMALL_STATE(1133)] = 41163,
  [SMALL_STATE(1134)] = 41236,
  [SMALL_STATE(1135)] = 41311,
  [SMALL_STATE(1136)] = 41388,
  [SMALL_STATE(1137)] = 41434,
  [SMALL_STATE(1138)] = 41480,
  [SMALL_STATE(1139)] = 41530,
  [SMALL_STATE(1140)] = 41575,
  [SMALL_STATE(1141)] = 41620,
  [SMALL_STATE(1142)] = 41665,
  [SMALL_STATE(1143)] = 41710,
  [SMALL_STATE(1144)] = 41755,
  [SMALL_STATE(1145)] = 41800,
  [SMALL_STATE(1146)] = 41845,
  [SMALL_STATE(1147)] = 41890,
  [SMALL_STATE(1148)] = 41935,
  [SMALL_STATE(1149)] = 41980,
  [SMALL_STATE(1150)] = 42025,
  [SMALL_STATE(1151)] = 42070,
  [SMALL_STATE(1152)] = 42115,
  [SMALL_STATE(1153)] = 42164,
  [SMALL_STATE(1154)] = 42213,
  [SMALL_STATE(1155)] = 42258,
  [SMALL_STATE(1156)] = 42303,
  [SMALL_STATE(1157)] = 42348,
  [SMALL_STATE(1158)] = 42397,
  [SMALL_STATE(1159)] = 42442,
  [SMALL_STATE(1160)] = 42487,
  [SMALL_STATE(1161)] = 42532,
  [SMALL_STATE(1162)] = 42577,
  [SMALL_STATE(1163)] = 42622,
  [SMALL_STATE(1164)] = 42671,
  [SMALL_STATE(1165)] = 42716,
  [SMALL_STATE(1166)] = 42765,
  [SMALL_STATE(1167)] = 42814,
  [SMALL_STATE(1168)] = 42859,
  [SMALL_STATE(1169)] = 42904,
  [SMALL_STATE(1170)] = 42953,
  [SMALL_STATE(1171)] = 42998,
  [SMALL_STATE(1172)] = 43047,
  [SMALL_STATE(1173)] = 43092,
  [SMALL_STATE(1174)] = 43137,
  [SMALL_STATE(1175)] = 43182,
  [SMALL_STATE(1176)] = 43227,
  [SMALL_STATE(1177)] = 43272,
  [SMALL_STATE(1178)] = 43317,
  [SMALL_STATE(1179)] = 43362,
  [SMALL_STATE(1180)] = 43407,
  [SMALL_STATE(1181)] = 43452,
  [SMALL_STATE(1182)] = 43497,
  [SMALL_STATE(1183)] = 43542,
  [SMALL_STATE(1184)] = 43586,
  [SMALL_STATE(1185)] = 43630,
  [SMALL_STATE(1186)] = 43674,
  [SMALL_STATE(1187)] = 43718,
  [SMALL_STATE(1188)] = 43762,
  [SMALL_STATE(1189)] = 43806,
  [SMALL_STATE(1190)] = 43850,
  [SMALL_STATE(1191)] = 43894,
  [SMALL_STATE(1192)] = 43938,
  [SMALL_STATE(1193)] = 43982,
  [SMALL_STATE(1194)] = 44051,
  [SMALL_STATE(1195)] = 44120,
  [SMALL_STATE(1196)] = 44189,
  [SMALL_STATE(1197)] = 44258,
  [SMALL_STATE(1198)] = 44313,
  [SMALL_STATE(1199)] = 44356,
  [SMALL_STATE(1200)] = 44406,
  [SMALL_STATE(1201)] = 44458,
  [SMALL_STATE(1202)] = 44535,
  [SMALL_STATE(1203)] = 44590,
  [SMALL_STATE(1204)] = 44663,
  [SMALL_STATE(1205)] = 44734,
  [SMALL_STATE(1206)] = 44803,
  [SMALL_STATE(1207)] = 44870,
  [SMALL_STATE(1208)] = 44929,
  [SMALL_STATE(1209)] = 45006,
  [SMALL_STATE(1210)] = 45083,
  [SMALL_STATE(1211)] = 45160,
  [SMALL_STATE(1212)] = 45223,
  [SMALL_STATE(1213)] = 45288,
  [SMALL_STATE(1214)] = 45345,
  [SMALL_STATE(1215)] = 45409,
  [SMALL_STATE(1216)] = 45463,
  [SMALL_STATE(1217)] = 45503,
  [SMALL_STATE(1218)] = 45559,
  [SMALL_STATE(1219)] = 45627,
  [SMALL_STATE(1220)] = 45667,
  [SMALL_STATE(1221)] = 45725,
  [SMALL_STATE(1222)] = 45767,
  [SMALL_STATE(1223)] = 45841,
  [SMALL_STATE(1224)] = 45911,
  [SMALL_STATE(1225)] = 45985,
  [SMALL_STATE(1226)] = 46047,
  [SMALL_STATE(1227)] = 46087,
  [SMALL_STATE(1228)] = 46127,
  [SMALL_STATE(1229)] = 46167,
  [SMALL_STATE(1230)] = 46235,
  [SMALL_STATE(1231)] = 46277,
  [SMALL_STATE(1232)] = 46317,
  [SMALL_STATE(1233)] = 46357,
  [SMALL_STATE(1234)] = 46397,
  [SMALL_STATE(1235)] = 46439,
  [SMALL_STATE(1236)] = 46479,
  [SMALL_STATE(1237)] = 46519,
  [SMALL_STATE(1238)] = 46559,
  [SMALL_STATE(1239)] = 46625,
  [SMALL_STATE(1240)] = 46665,
  [SMALL_STATE(1241)] = 46707,
  [SMALL_STATE(1242)] = 46749,
  [SMALL_STATE(1243)] = 46823,
  [SMALL_STATE(1244)] = 46863,
  [SMALL_STATE(1245)] = 46930,
  [SMALL_STATE(1246)] = 46993,
  [SMALL_STATE(1247)] = 47058,
  [SMALL_STATE(1248)] = 47131,
  [SMALL_STATE(1249)] = 47196,
  [SMALL_STATE(1250)] = 47269,
  [SMALL_STATE(1251)] = 47332,
  [SMALL_STATE(1252)] = 47393,
  [SMALL_STATE(1253)] = 47448,
  [SMALL_STATE(1254)] = 47505,
  [SMALL_STATE(1255)] = 47570,
  [SMALL_STATE(1256)] = 47633,
  [SMALL_STATE(1257)] = 47700,
  [SMALL_STATE(1258)] = 47773,
  [SMALL_STATE(1259)] = 47846,
  [SMALL_STATE(1260)] = 47899,
  [SMALL_STATE(1261)] = 47968,
  [SMALL_STATE(1262)] = 48028,
  [SMALL_STATE(1263)] = 48088,
  [SMALL_STATE(1264)] = 48134,
  [SMALL_STATE(1265)] = 48172,
  [SMALL_STATE(1266)] = 48232,
  [SMALL_STATE(1267)] = 48292,
  [SMALL_STATE(1268)] = 48330,
  [SMALL_STATE(1269)] = 48390,
  [SMALL_STATE(1270)] = 48450,
  [SMALL_STATE(1271)] = 48510,
  [SMALL_STATE(1272)] = 48548,
  [SMALL_STATE(1273)] = 48608,
  [SMALL_STATE(1274)] = 48646,
  [SMALL_STATE(1275)] = 48720,
  [SMALL_STATE(1276)] = 48795,
  [SMALL_STATE(1277)] = 48870,
  [SMALL_STATE(1278)] = 48945,
  [SMALL_STATE(1279)] = 49020,
  [SMALL_STATE(1280)] = 49095,
  [SMALL_STATE(1281)] = 49170,
  [SMALL_STATE(1282)] = 49241,
  [SMALL_STATE(1283)] = 49316,
  [SMALL_STATE(1284)] = 49391,
  [SMALL_STATE(1285)] = 49447,
  [SMALL_STATE(1286)] = 49519,
  [SMALL_STATE(1287)] = 49591,
  [SMALL_STATE(1288)] = 49647,
  [SMALL_STATE(1289)] = 49719,
  [SMALL_STATE(1290)] = 49791,
  [SMALL_STATE(1291)] = 49863,
  [SMALL_STATE(1292)] = 49935,
  [SMALL_STATE(1293)] = 49989,
  [SMALL_STATE(1294)] = 50061,
  [SMALL_STATE(1295)] = 50133,
  [SMALL_STATE(1296)] = 50189,
  [SMALL_STATE(1297)] = 50261,
  [SMALL_STATE(1298)] = 50317,
  [SMALL_STATE(1299)] = 50373,
  [SMALL_STATE(1300)] = 50445,
  [SMALL_STATE(1301)] = 50517,
  [SMALL_STATE(1302)] = 50587,
  [SMALL_STATE(1303)] = 50659,
  [SMALL_STATE(1304)] = 50731,
  [SMALL_STATE(1305)] = 50803,
  [SMALL_STATE(1306)] = 50875,
  [SMALL_STATE(1307)] = 50931,
  [SMALL_STATE(1308)] = 51003,
  [SMALL_STATE(1309)] = 51063,
  [SMALL_STATE(1310)] = 51119,
  [SMALL_STATE(1311)] = 51189,
  [SMALL_STATE(1312)] = 51261,
  [SMALL_STATE(1313)] = 51333,
  [SMALL_STATE(1314)] = 51405,
  [SMALL_STATE(1315)] = 51467,
  [SMALL_STATE(1316)] = 51537,
  [SMALL_STATE(1317)] = 51607,
  [SMALL_STATE(1318)] = 51663,
  [SMALL_STATE(1319)] = 51733,
  [SMALL_STATE(1320)] = 51797,
  [SMALL_STATE(1321)] = 51869,
  [SMALL_STATE(1322)] = 51935,
  [SMALL_STATE(1323)] = 52001,
  [SMALL_STATE(1324)] = 52069,
  [SMALL_STATE(1325)] = 52139,
  [SMALL_STATE(1326)] = 52195,
  [SMALL_STATE(1327)] = 52251,
  [SMALL_STATE(1328)] = 52323,
  [SMALL_STATE(1329)] = 52393,
  [SMALL_STATE(1330)] = 52449,
  [SMALL_STATE(1331)] = 52501,
  [SMALL_STATE(1332)] = 52573,
  [SMALL_STATE(1333)] = 52645,
  [SMALL_STATE(1334)] = 52701,
  [SMALL_STATE(1335)] = 52757,
  [SMALL_STATE(1336)] = 52831,
  [SMALL_STATE(1337)] = 52887,
  [SMALL_STATE(1338)] = 52959,
  [SMALL_STATE(1339)] = 53031,
  [SMALL_STATE(1340)] = 53087,
  [SMALL_STATE(1341)] = 53143,
  [SMALL_STATE(1342)] = 53215,
  [SMALL_STATE(1343)] = 53287,
  [SMALL_STATE(1344)] = 53343,
  [SMALL_STATE(1345)] = 53399,
  [SMALL_STATE(1346)] = 53471,
  [SMALL_STATE(1347)] = 53527,
  [SMALL_STATE(1348)] = 53599,
  [SMALL_STATE(1349)] = 53671,
  [SMALL_STATE(1350)] = 53743,
  [SMALL_STATE(1351)] = 53815,
  [SMALL_STATE(1352)] = 53885,
  [SMALL_STATE(1353)] = 53957,
  [SMALL_STATE(1354)] = 54029,
  [SMALL_STATE(1355)] = 54098,
  [SMALL_STATE(1356)] = 54151,
  [SMALL_STATE(1357)] = 54220,
  [SMALL_STATE(1358)] = 54289,
  [SMALL_STATE(1359)] = 54358,
  [SMALL_STATE(1360)] = 54427,
  [SMALL_STATE(1361)] = 54496,
  [SMALL_STATE(1362)] = 54565,
  [SMALL_STATE(1363)] = 54618,
  [SMALL_STATE(1364)] = 54687,
  [SMALL_STATE(1365)] = 54722,
  [SMALL_STATE(1366)] = 54791,
  [SMALL_STATE(1367)] = 54860,
  [SMALL_STATE(1368)] = 54929,
  [SMALL_STATE(1369)] = 54964,
  [SMALL_STATE(1370)] = 55017,
  [SMALL_STATE(1371)] = 55086,
  [SMALL_STATE(1372)] = 55155,
  [SMALL_STATE(1373)] = 55224,
  [SMALL_STATE(1374)] = 55277,
  [SMALL_STATE(1375)] = 55346,
  [SMALL_STATE(1376)] = 55399,
  [SMALL_STATE(1377)] = 55468,
  [SMALL_STATE(1378)] = 55537,
  [SMALL_STATE(1379)] = 55606,
  [SMALL_STATE(1380)] = 55675,
  [SMALL_STATE(1381)] = 55744,
  [SMALL_STATE(1382)] = 55813,
  [SMALL_STATE(1383)] = 55882,
  [SMALL_STATE(1384)] = 55921,
  [SMALL_STATE(1385)] = 55990,
  [SMALL_STATE(1386)] = 56043,
  [SMALL_STATE(1387)] = 56085,
  [SMALL_STATE(1388)] = 56151,
  [SMALL_STATE(1389)] = 56187,
  [SMALL_STATE(1390)] = 56231,
  [SMALL_STATE(1391)] = 56267,
  [SMALL_STATE(1392)] = 56303,
  [SMALL_STATE(1393)] = 56339,
  [SMALL_STATE(1394)] = 56388,
  [SMALL_STATE(1395)] = 56435,
  [SMALL_STATE(1396)] = 56482,
  [SMALL_STATE(1397)] = 56529,
  [SMALL_STATE(1398)] = 56576,
  [SMALL_STATE(1399)] = 56623,
  [SMALL_STATE(1400)] = 56670,
  [SMALL_STATE(1401)] = 56714,
  [SMALL_STATE(1402)] = 56768,
  [SMALL_STATE(1403)] = 56802,
  [SMALL_STATE(1404)] = 56840,
  [SMALL_STATE(1405)] = 56884,
  [SMALL_STATE(1406)] = 56938,
  [SMALL_STATE(1407)] = 56982,
  [SMALL_STATE(1408)] = 57026,
  [SMALL_STATE(1409)] = 57062,
  [SMALL_STATE(1410)] = 57116,
  [SMALL_STATE(1411)] = 57170,
  [SMALL_STATE(1412)] = 57214,
  [SMALL_STATE(1413)] = 57268,
  [SMALL_STATE(1414)] = 57312,
  [SMALL_STATE(1415)] = 57345,
  [SMALL_STATE(1416)] = 57400,
  [SMALL_STATE(1417)] = 57451,
  [SMALL_STATE(1418)] = 57502,
  [SMALL_STATE(1419)] = 57545,
  [SMALL_STATE(1420)] = 57588,
  [SMALL_STATE(1421)] = 57639,
  [SMALL_STATE(1422)] = 57690,
  [SMALL_STATE(1423)] = 57741,
  [SMALL_STATE(1424)] = 57792,
  [SMALL_STATE(1425)] = 57847,
  [SMALL_STATE(1426)] = 57898,
  [SMALL_STATE(1427)] = 57949,
  [SMALL_STATE(1428)] = 58004,
  [SMALL_STATE(1429)] = 58055,
  [SMALL_STATE(1430)] = 58106,
  [SMALL_STATE(1431)] = 58157,
  [SMALL_STATE(1432)] = 58208,
  [SMALL_STATE(1433)] = 58259,
  [SMALL_STATE(1434)] = 58302,
  [SMALL_STATE(1435)] = 58342,
  [SMALL_STATE(1436)] = 58386,
  [SMALL_STATE(1437)] = 58426,
  [SMALL_STATE(1438)] = 58466,
  [SMALL_STATE(1439)] = 58506,
  [SMALL_STATE(1440)] = 58546,
  [SMALL_STATE(1441)] = 58586,
  [SMALL_STATE(1442)] = 58626,
  [SMALL_STATE(1443)] = 58666,
  [SMALL_STATE(1444)] = 58714,
  [SMALL_STATE(1445)] = 58754,
  [SMALL_STATE(1446)] = 58786,
  [SMALL_STATE(1447)] = 58826,
  [SMALL_STATE(1448)] = 58866,
  [SMALL_STATE(1449)] = 58906,
  [SMALL_STATE(1450)] = 58946,
  [SMALL_STATE(1451)] = 58974,
  [SMALL_STATE(1452)] = 59014,
  [SMALL_STATE(1453)] = 59054,
  [SMALL_STATE(1454)] = 59086,
  [SMALL_STATE(1455)] = 59126,
  [SMALL_STATE(1456)] = 59166,
  [SMALL_STATE(1457)] = 59206,
  [SMALL_STATE(1458)] = 59238,
  [SMALL_STATE(1459)] = 59278,
  [SMALL_STATE(1460)] = 59318,
  [SMALL_STATE(1461)] = 59352,
  [SMALL_STATE(1462)] = 59388,
  [SMALL_STATE(1463)] = 59416,
  [SMALL_STATE(1464)] = 59456,
  [SMALL_STATE(1465)] = 59498,
  [SMALL_STATE(1466)] = 59538,
  [SMALL_STATE(1467)] = 59584,
  [SMALL_STATE(1468)] = 59630,
  [SMALL_STATE(1469)] = 59678,
  [SMALL_STATE(1470)] = 59706,
  [SMALL_STATE(1471)] = 59738,
  [SMALL_STATE(1472)] = 59766,
  [SMALL_STATE(1473)] = 59798,
  [SMALL_STATE(1474)] = 59848,
  [SMALL_STATE(1475)] = 59876,
  [SMALL_STATE(1476)] = 59904,
  [SMALL_STATE(1477)] = 59944,
  [SMALL_STATE(1478)] = 59984,
  [SMALL_STATE(1479)] = 60024,
  [SMALL_STATE(1480)] = 60064,
  [SMALL_STATE(1481)] = 60104,
  [SMALL_STATE(1482)] = 60144,
  [SMALL_STATE(1483)] = 60184,
  [SMALL_STATE(1484)] = 60224,
  [SMALL_STATE(1485)] = 60264,
  [SMALL_STATE(1486)] = 60304,
  [SMALL_STATE(1487)] = 60344,
  [SMALL_STATE(1488)] = 60384,
  [SMALL_STATE(1489)] = 60424,
  [SMALL_STATE(1490)] = 60464,
  [SMALL_STATE(1491)] = 60504,
  [SMALL_STATE(1492)] = 60544,
  [SMALL_STATE(1493)] = 60584,
  [SMALL_STATE(1494)] = 60624,
  [SMALL_STATE(1495)] = 60664,
  [SMALL_STATE(1496)] = 60704,
  [SMALL_STATE(1497)] = 60749,
  [SMALL_STATE(1498)] = 60792,
  [SMALL_STATE(1499)] = 60823,
  [SMALL_STATE(1500)] = 60868,
  [SMALL_STATE(1501)] = 60913,
  [SMALL_STATE(1502)] = 60958,
  [SMALL_STATE(1503)] = 60985,
  [SMALL_STATE(1504)] = 61030,
  [SMALL_STATE(1505)] = 61061,
  [SMALL_STATE(1506)] = 61096,
  [SMALL_STATE(1507)] = 61141,
  [SMALL_STATE(1508)] = 61172,
  [SMALL_STATE(1509)] = 61203,
  [SMALL_STATE(1510)] = 61230,
  [SMALL_STATE(1511)] = 61257,
  [SMALL_STATE(1512)] = 61284,
  [SMALL_STATE(1513)] = 61327,
  [SMALL_STATE(1514)] = 61372,
  [SMALL_STATE(1515)] = 61403,
  [SMALL_STATE(1516)] = 61434,
  [SMALL_STATE(1517)] = 61461,
  [SMALL_STATE(1518)] = 61494,
  [SMALL_STATE(1519)] = 61525,
  [SMALL_STATE(1520)] = 61570,
  [SMALL_STATE(1521)] = 61615,
  [SMALL_STATE(1522)] = 61660,
  [SMALL_STATE(1523)] = 61709,
  [SMALL_STATE(1524)] = 61752,
  [SMALL_STATE(1525)] = 61779,
  [SMALL_STATE(1526)] = 61808,
  [SMALL_STATE(1527)] = 61835,
  [SMALL_STATE(1528)] = 61880,
  [SMALL_STATE(1529)] = 61923,
  [SMALL_STATE(1530)] = 61964,
  [SMALL_STATE(1531)] = 62003,
  [SMALL_STATE(1532)] = 62030,
  [SMALL_STATE(1533)] = 62067,
  [SMALL_STATE(1534)] = 62112,
  [SMALL_STATE(1535)] = 62157,
  [SMALL_STATE(1536)] = 62192,
  [SMALL_STATE(1537)] = 62225,
  [SMALL_STATE(1538)] = 62256,
  [SMALL_STATE(1539)] = 62301,
  [SMALL_STATE(1540)] = 62346,
  [SMALL_STATE(1541)] = 62377,
  [SMALL_STATE(1542)] = 62420,
  [SMALL_STATE(1543)] = 62465,
  [SMALL_STATE(1544)] = 62508,
  [SMALL_STATE(1545)] = 62553,
  [SMALL_STATE(1546)] = 62602,
  [SMALL_STATE(1547)] = 62629,
  [SMALL_STATE(1548)] = 62656,
  [SMALL_STATE(1549)] = 62696,
  [SMALL_STATE(1550)] = 62736,
  [SMALL_STATE(1551)] = 62776,
  [SMALL_STATE(1552)] = 62816,
  [SMALL_STATE(1553)] = 62860,
  [SMALL_STATE(1554)] = 62900,
  [SMALL_STATE(1555)] = 62940,
  [SMALL_STATE(1556)] = 62980,
  [SMALL_STATE(1557)] = 63015,
  [SMALL_STATE(1558)] = 63056,
  [SMALL_STATE(1559)] = 63097,
  [SMALL_STATE(1560)] = 63138,
  [SMALL_STATE(1561)] = 63179,
  [SMALL_STATE(1562)] = 63220,
  [SMALL_STATE(1563)] = 63261,
  [SMALL_STATE(1564)] = 63302,
  [SMALL_STATE(1565)] = 63343,
  [SMALL_STATE(1566)] = 63384,
  [SMALL_STATE(1567)] = 63425,
  [SMALL_STATE(1568)] = 63465,
  [SMALL_STATE(1569)] = 63503,
  [SMALL_STATE(1570)] = 63537,
  [SMALL_STATE(1571)] = 63575,
  [SMALL_STATE(1572)] = 63604,
  [SMALL_STATE(1573)] = 63645,
  [SMALL_STATE(1574)] = 63674,
  [SMALL_STATE(1575)] = 63715,
  [SMALL_STATE(1576)] = 63744,
  [SMALL_STATE(1577)] = 63785,
  [SMALL_STATE(1578)] = 63826,
  [SMALL_STATE(1579)] = 63855,
  [SMALL_STATE(1580)] = 63894,
  [SMALL_STATE(1581)] = 63931,
  [SMALL_STATE(1582)] = 63957,
  [SMALL_STATE(1583)] = 63994,
  [SMALL_STATE(1584)] = 64031,
  [SMALL_STATE(1585)] = 64068,
  [SMALL_STATE(1586)] = 64105,
  [SMALL_STATE(1587)] = 64134,
  [SMALL_STATE(1588)] = 64155,
  [SMALL_STATE(1589)] = 64184,
  [SMALL_STATE(1590)] = 64205,
  [SMALL_STATE(1591)] = 64238,
  [SMALL_STATE(1592)] = 64275,
  [SMALL_STATE(1593)] = 64312,
  [SMALL_STATE(1594)] = 64333,
  [SMALL_STATE(1595)] = 64358,
  [SMALL_STATE(1596)] = 64387,
  [SMALL_STATE(1597)] = 64424,
  [SMALL_STATE(1598)] = 64461,
  [SMALL_STATE(1599)] = 64498,
  [SMALL_STATE(1600)] = 64535,
  [SMALL_STATE(1601)] = 64564,
  [SMALL_STATE(1602)] = 64601,
  [SMALL_STATE(1603)] = 64634,
  [SMALL_STATE(1604)] = 64671,
  [SMALL_STATE(1605)] = 64708,
  [SMALL_STATE(1606)] = 64744,
  [SMALL_STATE(1607)] = 64768,
  [SMALL_STATE(1608)] = 64797,
  [SMALL_STATE(1609)] = 64824,
  [SMALL_STATE(1610)] = 64853,
  [SMALL_STATE(1611)] = 64880,
  [SMALL_STATE(1612)] = 64911,
  [SMALL_STATE(1613)] = 64940,
  [SMALL_STATE(1614)] = 64973,
  [SMALL_STATE(1615)] = 65002,
  [SMALL_STATE(1616)] = 65029,
  [SMALL_STATE(1617)] = 65058,
  [SMALL_STATE(1618)] = 65091,
  [SMALL_STATE(1619)] = 65120,
  [SMALL_STATE(1620)] = 65153,
  [SMALL_STATE(1621)] = 65182,
  [SMALL_STATE(1622)] = 65211,
  [SMALL_STATE(1623)] = 65242,
  [SMALL_STATE(1624)] = 65267,
  [SMALL_STATE(1625)] = 65296,
  [SMALL_STATE(1626)] = 65327,
  [SMALL_STATE(1627)] = 65354,
  [SMALL_STATE(1628)] = 65383,
  [SMALL_STATE(1629)] = 65408,
  [SMALL_STATE(1630)] = 65432,
  [SMALL_STATE(1631)] = 65450,
  [SMALL_STATE(1632)] = 65480,
  [SMALL_STATE(1633)] = 65512,
  [SMALL_STATE(1634)] = 65538,
  [SMALL_STATE(1635)] = 65570,
  [SMALL_STATE(1636)] = 65588,
  [SMALL_STATE(1637)] = 65612,
  [SMALL_STATE(1638)] = 65630,
  [SMALL_STATE(1639)] = 65648,
  [SMALL_STATE(1640)] = 65680,
  [SMALL_STATE(1641)] = 65712,
  [SMALL_STATE(1642)] = 65738,
  [SMALL_STATE(1643)] = 65760,
  [SMALL_STATE(1644)] = 65786,
  [SMALL_STATE(1645)] = 65804,
  [SMALL_STATE(1646)] = 65822,
  [SMALL_STATE(1647)] = 65854,
  [SMALL_STATE(1648)] = 65872,
  [SMALL_STATE(1649)] = 65898,
  [SMALL_STATE(1650)] = 65919,
  [SMALL_STATE(1651)] = 65948,
  [SMALL_STATE(1652)] = 65967,
  [SMALL_STATE(1653)] = 65996,
  [SMALL_STATE(1654)] = 66017,
  [SMALL_STATE(1655)] = 66046,
  [SMALL_STATE(1656)] = 66071,
  [SMALL_STATE(1657)] = 66096,
  [SMALL_STATE(1658)] = 66117,
  [SMALL_STATE(1659)] = 66146,
  [SMALL_STATE(1660)] = 66167,
  [SMALL_STATE(1661)] = 66188,
  [SMALL_STATE(1662)] = 66217,
  [SMALL_STATE(1663)] = 66238,
  [SMALL_STATE(1664)] = 66267,
  [SMALL_STATE(1665)] = 66296,
  [SMALL_STATE(1666)] = 66317,
  [SMALL_STATE(1667)] = 66346,
  [SMALL_STATE(1668)] = 66375,
  [SMALL_STATE(1669)] = 66396,
  [SMALL_STATE(1670)] = 66425,
  [SMALL_STATE(1671)] = 66446,
  [SMALL_STATE(1672)] = 66467,
  [SMALL_STATE(1673)] = 66488,
  [SMALL_STATE(1674)] = 66514,
  [SMALL_STATE(1675)] = 66530,
  [SMALL_STATE(1676)] = 66546,
  [SMALL_STATE(1677)] = 66568,
  [SMALL_STATE(1678)] = 66586,
  [SMALL_STATE(1679)] = 66612,
  [SMALL_STATE(1680)] = 66632,
  [SMALL_STATE(1681)] = 66658,
  [SMALL_STATE(1682)] = 66674,
  [SMALL_STATE(1683)] = 66700,
  [SMALL_STATE(1684)] = 66726,
  [SMALL_STATE(1685)] = 66742,
  [SMALL_STATE(1686)] = 66768,
  [SMALL_STATE(1687)] = 66784,
  [SMALL_STATE(1688)] = 66810,
  [SMALL_STATE(1689)] = 66834,
  [SMALL_STATE(1690)] = 66860,
  [SMALL_STATE(1691)] = 66886,
  [SMALL_STATE(1692)] = 66912,
  [SMALL_STATE(1693)] = 66932,
  [SMALL_STATE(1694)] = 66958,
  [SMALL_STATE(1695)] = 66984,
  [SMALL_STATE(1696)] = 67010,
  [SMALL_STATE(1697)] = 67034,
  [SMALL_STATE(1698)] = 67060,
  [SMALL_STATE(1699)] = 67086,
  [SMALL_STATE(1700)] = 67112,
  [SMALL_STATE(1701)] = 67136,
  [SMALL_STATE(1702)] = 67162,
  [SMALL_STATE(1703)] = 67178,
  [SMALL_STATE(1704)] = 67204,
  [SMALL_STATE(1705)] = 67230,
  [SMALL_STATE(1706)] = 67246,
  [SMALL_STATE(1707)] = 67262,
  [SMALL_STATE(1708)] = 67286,
  [SMALL_STATE(1709)] = 67310,
  [SMALL_STATE(1710)] = 67336,
  [SMALL_STATE(1711)] = 67352,
  [SMALL_STATE(1712)] = 67378,
  [SMALL_STATE(1713)] = 67398,
  [SMALL_STATE(1714)] = 67422,
  [SMALL_STATE(1715)] = 67445,
  [SMALL_STATE(1716)] = 67462,
  [SMALL_STATE(1717)] = 67485,
  [SMALL_STATE(1718)] = 67500,
  [SMALL_STATE(1719)] = 67523,
  [SMALL_STATE(1720)] = 67538,
  [SMALL_STATE(1721)] = 67553,
  [SMALL_STATE(1722)] = 67568,
  [SMALL_STATE(1723)] = 67587,
  [SMALL_STATE(1724)] = 67610,
  [SMALL_STATE(1725)] = 67633,
  [SMALL_STATE(1726)] = 67658,
  [SMALL_STATE(1727)] = 67675,
  [SMALL_STATE(1728)] = 67690,
  [SMALL_STATE(1729)] = 67705,
  [SMALL_STATE(1730)] = 67728,
  [SMALL_STATE(1731)] = 67751,
  [SMALL_STATE(1732)] = 67766,
  [SMALL_STATE(1733)] = 67781,
  [SMALL_STATE(1734)] = 67796,
  [SMALL_STATE(1735)] = 67815,
  [SMALL_STATE(1736)] = 67832,
  [SMALL_STATE(1737)] = 67847,
  [SMALL_STATE(1738)] = 67864,
  [SMALL_STATE(1739)] = 67882,
  [SMALL_STATE(1740)] = 67896,
  [SMALL_STATE(1741)] = 67916,
  [SMALL_STATE(1742)] = 67934,
  [SMALL_STATE(1743)] = 67948,
  [SMALL_STATE(1744)] = 67966,
  [SMALL_STATE(1745)] = 67984,
  [SMALL_STATE(1746)] = 68004,
  [SMALL_STATE(1747)] = 68020,
  [SMALL_STATE(1748)] = 68040,
  [SMALL_STATE(1749)] = 68056,
  [SMALL_STATE(1750)] = 68072,
  [SMALL_STATE(1751)] = 68090,
  [SMALL_STATE(1752)] = 68108,
  [SMALL_STATE(1753)] = 68128,
  [SMALL_STATE(1754)] = 68148,
  [SMALL_STATE(1755)] = 68168,
  [SMALL_STATE(1756)] = 68186,
  [SMALL_STATE(1757)] = 68206,
  [SMALL_STATE(1758)] = 68226,
  [SMALL_STATE(1759)] = 68240,
  [SMALL_STATE(1760)] = 68256,
  [SMALL_STATE(1761)] = 68276,
  [SMALL_STATE(1762)] = 68290,
  [SMALL_STATE(1763)] = 68304,
  [SMALL_STATE(1764)] = 68324,
  [SMALL_STATE(1765)] = 68338,
  [SMALL_STATE(1766)] = 68352,
  [SMALL_STATE(1767)] = 68366,
  [SMALL_STATE(1768)] = 68386,
  [SMALL_STATE(1769)] = 68400,
  [SMALL_STATE(1770)] = 68420,
  [SMALL_STATE(1771)] = 68434,
  [SMALL_STATE(1772)] = 68452,
  [SMALL_STATE(1773)] = 68472,
  [SMALL_STATE(1774)] = 68492,
  [SMALL_STATE(1775)] = 68508,
  [SMALL_STATE(1776)] = 68524,
  [SMALL_STATE(1777)] = 68538,
  [SMALL_STATE(1778)] = 68552,
  [SMALL_STATE(1779)] = 68566,
  [SMALL_STATE(1780)] = 68580,
  [SMALL_STATE(1781)] = 68594,
  [SMALL_STATE(1782)] = 68608,
  [SMALL_STATE(1783)] = 68628,
  [SMALL_STATE(1784)] = 68639,
  [SMALL_STATE(1785)] = 68656,
  [SMALL_STATE(1786)] = 68667,
  [SMALL_STATE(1787)] = 68678,
  [SMALL_STATE(1788)] = 68693,
  [SMALL_STATE(1789)] = 68704,
  [SMALL_STATE(1790)] = 68715,
  [SMALL_STATE(1791)] = 68734,
  [SMALL_STATE(1792)] = 68745,
  [SMALL_STATE(1793)] = 68756,
  [SMALL_STATE(1794)] = 68775,
  [SMALL_STATE(1795)] = 68786,
  [SMALL_STATE(1796)] = 68805,
  [SMALL_STATE(1797)] = 68816,
  [SMALL_STATE(1798)] = 68827,
  [SMALL_STATE(1799)] = 68838,
  [SMALL_STATE(1800)] = 68849,
  [SMALL_STATE(1801)] = 68866,
  [SMALL_STATE(1802)] = 68877,
  [SMALL_STATE(1803)] = 68890,
  [SMALL_STATE(1804)] = 68905,
  [SMALL_STATE(1805)] = 68921,
  [SMALL_STATE(1806)] = 68935,
  [SMALL_STATE(1807)] = 68949,
  [SMALL_STATE(1808)] = 68965,
  [SMALL_STATE(1809)] = 68981,
  [SMALL_STATE(1810)] = 68997,
  [SMALL_STATE(1811)] = 69011,
  [SMALL_STATE(1812)] = 69025,
  [SMALL_STATE(1813)] = 69039,
  [SMALL_STATE(1814)] = 69053,
  [SMALL_STATE(1815)] = 69067,
  [SMALL_STATE(1816)] = 69081,
  [SMALL_STATE(1817)] = 69095,
  [SMALL_STATE(1818)] = 69109,
  [SMALL_STATE(1819)] = 69123,
  [SMALL_STATE(1820)] = 69139,
  [SMALL_STATE(1821)] = 69153,
  [SMALL_STATE(1822)] = 69167,
  [SMALL_STATE(1823)] = 69183,
  [SMALL_STATE(1824)] = 69197,
  [SMALL_STATE(1825)] = 69211,
  [SMALL_STATE(1826)] = 69225,
  [SMALL_STATE(1827)] = 69241,
  [SMALL_STATE(1828)] = 69255,
  [SMALL_STATE(1829)] = 69271,
  [SMALL_STATE(1830)] = 69281,
  [SMALL_STATE(1831)] = 69295,
  [SMALL_STATE(1832)] = 69309,
  [SMALL_STATE(1833)] = 69325,
  [SMALL_STATE(1834)] = 69335,
  [SMALL_STATE(1835)] = 69349,
  [SMALL_STATE(1836)] = 69365,
  [SMALL_STATE(1837)] = 69379,
  [SMALL_STATE(1838)] = 69393,
  [SMALL_STATE(1839)] = 69407,
  [SMALL_STATE(1840)] = 69421,
  [SMALL_STATE(1841)] = 69437,
  [SMALL_STATE(1842)] = 69451,
  [SMALL_STATE(1843)] = 69465,
  [SMALL_STATE(1844)] = 69479,
  [SMALL_STATE(1845)] = 69489,
  [SMALL_STATE(1846)] = 69503,
  [SMALL_STATE(1847)] = 69519,
  [SMALL_STATE(1848)] = 69535,
  [SMALL_STATE(1849)] = 69549,
  [SMALL_STATE(1850)] = 69563,
  [SMALL_STATE(1851)] = 69579,
  [SMALL_STATE(1852)] = 69593,
  [SMALL_STATE(1853)] = 69609,
  [SMALL_STATE(1854)] = 69623,
  [SMALL_STATE(1855)] = 69637,
  [SMALL_STATE(1856)] = 69651,
  [SMALL_STATE(1857)] = 69665,
  [SMALL_STATE(1858)] = 69679,
  [SMALL_STATE(1859)] = 69693,
  [SMALL_STATE(1860)] = 69707,
  [SMALL_STATE(1861)] = 69723,
  [SMALL_STATE(1862)] = 69739,
  [SMALL_STATE(1863)] = 69755,
  [SMALL_STATE(1864)] = 69769,
  [SMALL_STATE(1865)] = 69783,
  [SMALL_STATE(1866)] = 69797,
  [SMALL_STATE(1867)] = 69813,
  [SMALL_STATE(1868)] = 69827,
  [SMALL_STATE(1869)] = 69841,
  [SMALL_STATE(1870)] = 69857,
  [SMALL_STATE(1871)] = 69871,
  [SMALL_STATE(1872)] = 69885,
  [SMALL_STATE(1873)] = 69901,
  [SMALL_STATE(1874)] = 69917,
  [SMALL_STATE(1875)] = 69931,
  [SMALL_STATE(1876)] = 69945,
  [SMALL_STATE(1877)] = 69959,
  [SMALL_STATE(1878)] = 69975,
  [SMALL_STATE(1879)] = 69989,
  [SMALL_STATE(1880)] = 70002,
  [SMALL_STATE(1881)] = 70015,
  [SMALL_STATE(1882)] = 70028,
  [SMALL_STATE(1883)] = 70041,
  [SMALL_STATE(1884)] = 70054,
  [SMALL_STATE(1885)] = 70067,
  [SMALL_STATE(1886)] = 70080,
  [SMALL_STATE(1887)] = 70093,
  [SMALL_STATE(1888)] = 70106,
  [SMALL_STATE(1889)] = 70119,
  [SMALL_STATE(1890)] = 70132,
  [SMALL_STATE(1891)] = 70145,
  [SMALL_STATE(1892)] = 70158,
  [SMALL_STATE(1893)] = 70171,
  [SMALL_STATE(1894)] = 70184,
  [SMALL_STATE(1895)] = 70197,
  [SMALL_STATE(1896)] = 70210,
  [SMALL_STATE(1897)] = 70223,
  [SMALL_STATE(1898)] = 70236,
  [SMALL_STATE(1899)] = 70249,
  [SMALL_STATE(1900)] = 70262,
  [SMALL_STATE(1901)] = 70275,
  [SMALL_STATE(1902)] = 70288,
  [SMALL_STATE(1903)] = 70301,
  [SMALL_STATE(1904)] = 70314,
  [SMALL_STATE(1905)] = 70327,
  [SMALL_STATE(1906)] = 70336,
  [SMALL_STATE(1907)] = 70349,
  [SMALL_STATE(1908)] = 70362,
  [SMALL_STATE(1909)] = 70375,
  [SMALL_STATE(1910)] = 70388,
  [SMALL_STATE(1911)] = 70401,
  [SMALL_STATE(1912)] = 70414,
  [SMALL_STATE(1913)] = 70427,
  [SMALL_STATE(1914)] = 70440,
  [SMALL_STATE(1915)] = 70453,
  [SMALL_STATE(1916)] = 70466,
  [SMALL_STATE(1917)] = 70479,
  [SMALL_STATE(1918)] = 70492,
  [SMALL_STATE(1919)] = 70505,
  [SMALL_STATE(1920)] = 70518,
  [SMALL_STATE(1921)] = 70531,
  [SMALL_STATE(1922)] = 70544,
  [SMALL_STATE(1923)] = 70557,
  [SMALL_STATE(1924)] = 70570,
  [SMALL_STATE(1925)] = 70583,
  [SMALL_STATE(1926)] = 70596,
  [SMALL_STATE(1927)] = 70609,
  [SMALL_STATE(1928)] = 70622,
  [SMALL_STATE(1929)] = 70635,
  [SMALL_STATE(1930)] = 70648,
  [SMALL_STATE(1931)] = 70661,
  [SMALL_STATE(1932)] = 70674,
  [SMALL_STATE(1933)] = 70687,
  [SMALL_STATE(1934)] = 70696,
  [SMALL_STATE(1935)] = 70709,
  [SMALL_STATE(1936)] = 70722,
  [SMALL_STATE(1937)] = 70731,
  [SMALL_STATE(1938)] = 70744,
  [SMALL_STATE(1939)] = 70757,
  [SMALL_STATE(1940)] = 70770,
  [SMALL_STATE(1941)] = 70783,
  [SMALL_STATE(1942)] = 70796,
  [SMALL_STATE(1943)] = 70809,
  [SMALL_STATE(1944)] = 70822,
  [SMALL_STATE(1945)] = 70835,
  [SMALL_STATE(1946)] = 70848,
  [SMALL_STATE(1947)] = 70861,
  [SMALL_STATE(1948)] = 70874,
  [SMALL_STATE(1949)] = 70887,
  [SMALL_STATE(1950)] = 70900,
  [SMALL_STATE(1951)] = 70913,
  [SMALL_STATE(1952)] = 70922,
  [SMALL_STATE(1953)] = 70931,
  [SMALL_STATE(1954)] = 70944,
  [SMALL_STATE(1955)] = 70957,
  [SMALL_STATE(1956)] = 70968,
  [SMALL_STATE(1957)] = 70981,
  [SMALL_STATE(1958)] = 70994,
  [SMALL_STATE(1959)] = 71003,
  [SMALL_STATE(1960)] = 71016,
  [SMALL_STATE(1961)] = 71029,
  [SMALL_STATE(1962)] = 71042,
  [SMALL_STATE(1963)] = 71055,
  [SMALL_STATE(1964)] = 71068,
  [SMALL_STATE(1965)] = 71081,
  [SMALL_STATE(1966)] = 71094,
  [SMALL_STATE(1967)] = 71107,
  [SMALL_STATE(1968)] = 71120,
  [SMALL_STATE(1969)] = 71133,
  [SMALL_STATE(1970)] = 71146,
  [SMALL_STATE(1971)] = 71159,
  [SMALL_STATE(1972)] = 71170,
  [SMALL_STATE(1973)] = 71183,
  [SMALL_STATE(1974)] = 71194,
  [SMALL_STATE(1975)] = 71203,
  [SMALL_STATE(1976)] = 71212,
  [SMALL_STATE(1977)] = 71225,
  [SMALL_STATE(1978)] = 71238,
  [SMALL_STATE(1979)] = 71251,
  [SMALL_STATE(1980)] = 71264,
  [SMALL_STATE(1981)] = 71277,
  [SMALL_STATE(1982)] = 71290,
  [SMALL_STATE(1983)] = 71303,
  [SMALL_STATE(1984)] = 71316,
  [SMALL_STATE(1985)] = 71329,
  [SMALL_STATE(1986)] = 71342,
  [SMALL_STATE(1987)] = 71355,
  [SMALL_STATE(1988)] = 71368,
  [SMALL_STATE(1989)] = 71381,
  [SMALL_STATE(1990)] = 71394,
  [SMALL_STATE(1991)] = 71407,
  [SMALL_STATE(1992)] = 71420,
  [SMALL_STATE(1993)] = 71433,
  [SMALL_STATE(1994)] = 71446,
  [SMALL_STATE(1995)] = 71457,
  [SMALL_STATE(1996)] = 71470,
  [SMALL_STATE(1997)] = 71483,
  [SMALL_STATE(1998)] = 71496,
  [SMALL_STATE(1999)] = 71509,
  [SMALL_STATE(2000)] = 71522,
  [SMALL_STATE(2001)] = 71535,
  [SMALL_STATE(2002)] = 71548,
  [SMALL_STATE(2003)] = 71561,
  [SMALL_STATE(2004)] = 71574,
  [SMALL_STATE(2005)] = 71587,
  [SMALL_STATE(2006)] = 71600,
  [SMALL_STATE(2007)] = 71613,
  [SMALL_STATE(2008)] = 71626,
  [SMALL_STATE(2009)] = 71639,
  [SMALL_STATE(2010)] = 71652,
  [SMALL_STATE(2011)] = 71665,
  [SMALL_STATE(2012)] = 71678,
  [SMALL_STATE(2013)] = 71691,
  [SMALL_STATE(2014)] = 71700,
  [SMALL_STATE(2015)] = 71713,
  [SMALL_STATE(2016)] = 71726,
  [SMALL_STATE(2017)] = 71739,
  [SMALL_STATE(2018)] = 71750,
  [SMALL_STATE(2019)] = 71763,
  [SMALL_STATE(2020)] = 71772,
  [SMALL_STATE(2021)] = 71783,
  [SMALL_STATE(2022)] = 71792,
  [SMALL_STATE(2023)] = 71801,
  [SMALL_STATE(2024)] = 71809,
  [SMALL_STATE(2025)] = 71817,
  [SMALL_STATE(2026)] = 71827,
  [SMALL_STATE(2027)] = 71837,
  [SMALL_STATE(2028)] = 71847,
  [SMALL_STATE(2029)] = 71855,
  [SMALL_STATE(2030)] = 71865,
  [SMALL_STATE(2031)] = 71875,
  [SMALL_STATE(2032)] = 71885,
  [SMALL_STATE(2033)] = 71895,
  [SMALL_STATE(2034)] = 71905,
  [SMALL_STATE(2035)] = 71915,
  [SMALL_STATE(2036)] = 71925,
  [SMALL_STATE(2037)] = 71935,
  [SMALL_STATE(2038)] = 71945,
  [SMALL_STATE(2039)] = 71955,
  [SMALL_STATE(2040)] = 71965,
  [SMALL_STATE(2041)] = 71975,
  [SMALL_STATE(2042)] = 71985,
  [SMALL_STATE(2043)] = 71995,
  [SMALL_STATE(2044)] = 72003,
  [SMALL_STATE(2045)] = 72013,
  [SMALL_STATE(2046)] = 72023,
  [SMALL_STATE(2047)] = 72033,
  [SMALL_STATE(2048)] = 72043,
  [SMALL_STATE(2049)] = 72053,
  [SMALL_STATE(2050)] = 72063,
  [SMALL_STATE(2051)] = 72071,
  [SMALL_STATE(2052)] = 72081,
  [SMALL_STATE(2053)] = 72091,
  [SMALL_STATE(2054)] = 72101,
  [SMALL_STATE(2055)] = 72111,
  [SMALL_STATE(2056)] = 72121,
  [SMALL_STATE(2057)] = 72131,
  [SMALL_STATE(2058)] = 72139,
  [SMALL_STATE(2059)] = 72149,
  [SMALL_STATE(2060)] = 72159,
  [SMALL_STATE(2061)] = 72169,
  [SMALL_STATE(2062)] = 72179,
  [SMALL_STATE(2063)] = 72189,
  [SMALL_STATE(2064)] = 72199,
  [SMALL_STATE(2065)] = 72207,
  [SMALL_STATE(2066)] = 72215,
  [SMALL_STATE(2067)] = 72225,
  [SMALL_STATE(2068)] = 72235,
  [SMALL_STATE(2069)] = 72245,
  [SMALL_STATE(2070)] = 72255,
  [SMALL_STATE(2071)] = 72265,
  [SMALL_STATE(2072)] = 72275,
  [SMALL_STATE(2073)] = 72285,
  [SMALL_STATE(2074)] = 72295,
  [SMALL_STATE(2075)] = 72305,
  [SMALL_STATE(2076)] = 72315,
  [SMALL_STATE(2077)] = 72325,
  [SMALL_STATE(2078)] = 72335,
  [SMALL_STATE(2079)] = 72345,
  [SMALL_STATE(2080)] = 72355,
  [SMALL_STATE(2081)] = 72365,
  [SMALL_STATE(2082)] = 72375,
  [SMALL_STATE(2083)] = 72385,
  [SMALL_STATE(2084)] = 72395,
  [SMALL_STATE(2085)] = 72403,
  [SMALL_STATE(2086)] = 72413,
  [SMALL_STATE(2087)] = 72421,
  [SMALL_STATE(2088)] = 72429,
  [SMALL_STATE(2089)] = 72439,
  [SMALL_STATE(2090)] = 72449,
  [SMALL_STATE(2091)] = 72459,
  [SMALL_STATE(2092)] = 72469,
  [SMALL_STATE(2093)] = 72477,
  [SMALL_STATE(2094)] = 72487,
  [SMALL_STATE(2095)] = 72495,
  [SMALL_STATE(2096)] = 72503,
  [SMALL_STATE(2097)] = 72511,
  [SMALL_STATE(2098)] = 72521,
  [SMALL_STATE(2099)] = 72531,
  [SMALL_STATE(2100)] = 72541,
  [SMALL_STATE(2101)] = 72551,
  [SMALL_STATE(2102)] = 72561,
  [SMALL_STATE(2103)] = 72569,
  [SMALL_STATE(2104)] = 72579,
  [SMALL_STATE(2105)] = 72589,
  [SMALL_STATE(2106)] = 72599,
  [SMALL_STATE(2107)] = 72609,
  [SMALL_STATE(2108)] = 72619,
  [SMALL_STATE(2109)] = 72629,
  [SMALL_STATE(2110)] = 72639,
  [SMALL_STATE(2111)] = 72649,
  [SMALL_STATE(2112)] = 72659,
  [SMALL_STATE(2113)] = 72669,
  [SMALL_STATE(2114)] = 72679,
  [SMALL_STATE(2115)] = 72689,
  [SMALL_STATE(2116)] = 72699,
  [SMALL_STATE(2117)] = 72707,
  [SMALL_STATE(2118)] = 72717,
  [SMALL_STATE(2119)] = 72727,
  [SMALL_STATE(2120)] = 72737,
  [SMALL_STATE(2121)] = 72745,
  [SMALL_STATE(2122)] = 72755,
  [SMALL_STATE(2123)] = 72765,
  [SMALL_STATE(2124)] = 72775,
  [SMALL_STATE(2125)] = 72782,
  [SMALL_STATE(2126)] = 72789,
  [SMALL_STATE(2127)] = 72796,
  [SMALL_STATE(2128)] = 72803,
  [SMALL_STATE(2129)] = 72810,
  [SMALL_STATE(2130)] = 72817,
  [SMALL_STATE(2131)] = 72824,
  [SMALL_STATE(2132)] = 72831,
  [SMALL_STATE(2133)] = 72838,
  [SMALL_STATE(2134)] = 72845,
  [SMALL_STATE(2135)] = 72852,
  [SMALL_STATE(2136)] = 72859,
  [SMALL_STATE(2137)] = 72866,
  [SMALL_STATE(2138)] = 72873,
  [SMALL_STATE(2139)] = 72880,
  [SMALL_STATE(2140)] = 72887,
  [SMALL_STATE(2141)] = 72894,
  [SMALL_STATE(2142)] = 72901,
  [SMALL_STATE(2143)] = 72908,
  [SMALL_STATE(2144)] = 72915,
  [SMALL_STATE(2145)] = 72922,
  [SMALL_STATE(2146)] = 72929,
  [SMALL_STATE(2147)] = 72936,
  [SMALL_STATE(2148)] = 72943,
  [SMALL_STATE(2149)] = 72950,
  [SMALL_STATE(2150)] = 72957,
  [SMALL_STATE(2151)] = 72964,
  [SMALL_STATE(2152)] = 72971,
  [SMALL_STATE(2153)] = 72978,
  [SMALL_STATE(2154)] = 72985,
  [SMALL_STATE(2155)] = 72992,
  [SMALL_STATE(2156)] = 72999,
  [SMALL_STATE(2157)] = 73006,
  [SMALL_STATE(2158)] = 73013,
  [SMALL_STATE(2159)] = 73020,
  [SMALL_STATE(2160)] = 73027,
  [SMALL_STATE(2161)] = 73034,
  [SMALL_STATE(2162)] = 73041,
  [SMALL_STATE(2163)] = 73048,
  [SMALL_STATE(2164)] = 73055,
  [SMALL_STATE(2165)] = 73062,
  [SMALL_STATE(2166)] = 73069,
  [SMALL_STATE(2167)] = 73076,
  [SMALL_STATE(2168)] = 73083,
  [SMALL_STATE(2169)] = 73090,
  [SMALL_STATE(2170)] = 73097,
  [SMALL_STATE(2171)] = 73104,
  [SMALL_STATE(2172)] = 73111,
  [SMALL_STATE(2173)] = 73118,
  [SMALL_STATE(2174)] = 73125,
  [SMALL_STATE(2175)] = 73132,
  [SMALL_STATE(2176)] = 73139,
  [SMALL_STATE(2177)] = 73146,
  [SMALL_STATE(2178)] = 73153,
  [SMALL_STATE(2179)] = 73160,
  [SMALL_STATE(2180)] = 73167,
  [SMALL_STATE(2181)] = 73174,
  [SMALL_STATE(2182)] = 73181,
  [SMALL_STATE(2183)] = 73188,
  [SMALL_STATE(2184)] = 73195,
  [SMALL_STATE(2185)] = 73202,
  [SMALL_STATE(2186)] = 73209,
  [SMALL_STATE(2187)] = 73216,
  [SMALL_STATE(2188)] = 73223,
  [SMALL_STATE(2189)] = 73230,
  [SMALL_STATE(2190)] = 73237,
  [SMALL_STATE(2191)] = 73244,
  [SMALL_STATE(2192)] = 73251,
  [SMALL_STATE(2193)] = 73258,
  [SMALL_STATE(2194)] = 73265,
  [SMALL_STATE(2195)] = 73272,
  [SMALL_STATE(2196)] = 73279,
  [SMALL_STATE(2197)] = 73286,
  [SMALL_STATE(2198)] = 73293,
  [SMALL_STATE(2199)] = 73300,
  [SMALL_STATE(2200)] = 73307,
  [SMALL_STATE(2201)] = 73314,
  [SMALL_STATE(2202)] = 73321,
  [SMALL_STATE(2203)] = 73328,
  [SMALL_STATE(2204)] = 73335,
  [SMALL_STATE(2205)] = 73342,
  [SMALL_STATE(2206)] = 73349,
  [SMALL_STATE(2207)] = 73356,
  [SMALL_STATE(2208)] = 73363,
  [SMALL_STATE(2209)] = 73370,
  [SMALL_STATE(2210)] = 73377,
  [SMALL_STATE(2211)] = 73384,
  [SMALL_STATE(2212)] = 73391,
  [SMALL_STATE(2213)] = 73398,
  [SMALL_STATE(2214)] = 73405,
  [SMALL_STATE(2215)] = 73412,
  [SMALL_STATE(2216)] = 73419,
  [SMALL_STATE(2217)] = 73426,
  [SMALL_STATE(2218)] = 73433,
  [SMALL_STATE(2219)] = 73440,
  [SMALL_STATE(2220)] = 73447,
  [SMALL_STATE(2221)] = 73454,
  [SMALL_STATE(2222)] = 73461,
  [SMALL_STATE(2223)] = 73468,
  [SMALL_STATE(2224)] = 73475,
  [SMALL_STATE(2225)] = 73482,
  [SMALL_STATE(2226)] = 73489,
  [SMALL_STATE(2227)] = 73496,
  [SMALL_STATE(2228)] = 73503,
  [SMALL_STATE(2229)] = 73510,
  [SMALL_STATE(2230)] = 73517,
  [SMALL_STATE(2231)] = 73524,
  [SMALL_STATE(2232)] = 73531,
  [SMALL_STATE(2233)] = 73538,
  [SMALL_STATE(2234)] = 73545,
  [SMALL_STATE(2235)] = 73552,
  [SMALL_STATE(2236)] = 73559,
  [SMALL_STATE(2237)] = 73566,
  [SMALL_STATE(2238)] = 73573,
  [SMALL_STATE(2239)] = 73580,
  [SMALL_STATE(2240)] = 73587,
  [SMALL_STATE(2241)] = 73594,
  [SMALL_STATE(2242)] = 73601,
  [SMALL_STATE(2243)] = 73608,
  [SMALL_STATE(2244)] = 73615,
  [SMALL_STATE(2245)] = 73622,
  [SMALL_STATE(2246)] = 73629,
  [SMALL_STATE(2247)] = 73636,
  [SMALL_STATE(2248)] = 73643,
  [SMALL_STATE(2249)] = 73650,
  [SMALL_STATE(2250)] = 73657,
  [SMALL_STATE(2251)] = 73664,
  [SMALL_STATE(2252)] = 73671,
  [SMALL_STATE(2253)] = 73678,
  [SMALL_STATE(2254)] = 73685,
  [SMALL_STATE(2255)] = 73692,
  [SMALL_STATE(2256)] = 73699,
  [SMALL_STATE(2257)] = 73706,
  [SMALL_STATE(2258)] = 73713,
  [SMALL_STATE(2259)] = 73720,
  [SMALL_STATE(2260)] = 73727,
  [SMALL_STATE(2261)] = 73734,
  [SMALL_STATE(2262)] = 73741,
  [SMALL_STATE(2263)] = 73748,
  [SMALL_STATE(2264)] = 73755,
  [SMALL_STATE(2265)] = 73762,
  [SMALL_STATE(2266)] = 73769,
  [SMALL_STATE(2267)] = 73776,
  [SMALL_STATE(2268)] = 73783,
  [SMALL_STATE(2269)] = 73790,
  [SMALL_STATE(2270)] = 73797,
  [SMALL_STATE(2271)] = 73804,
  [SMALL_STATE(2272)] = 73811,
  [SMALL_STATE(2273)] = 73818,
  [SMALL_STATE(2274)] = 73825,
  [SMALL_STATE(2275)] = 73832,
  [SMALL_STATE(2276)] = 73839,
  [SMALL_STATE(2277)] = 73846,
  [SMALL_STATE(2278)] = 73853,
  [SMALL_STATE(2279)] = 73860,
  [SMALL_STATE(2280)] = 73867,
  [SMALL_STATE(2281)] = 73874,
  [SMALL_STATE(2282)] = 73881,
  [SMALL_STATE(2283)] = 73888,
  [SMALL_STATE(2284)] = 73895,
  [SMALL_STATE(2285)] = 73902,
  [SMALL_STATE(2286)] = 73909,
  [SMALL_STATE(2287)] = 73916,
  [SMALL_STATE(2288)] = 73923,
  [SMALL_STATE(2289)] = 73930,
  [SMALL_STATE(2290)] = 73937,
  [SMALL_STATE(2291)] = 73944,
  [SMALL_STATE(2292)] = 73951,
  [SMALL_STATE(2293)] = 73958,
  [SMALL_STATE(2294)] = 73965,
  [SMALL_STATE(2295)] = 73972,
  [SMALL_STATE(2296)] = 73979,
  [SMALL_STATE(2297)] = 73986,
  [SMALL_STATE(2298)] = 73993,
  [SMALL_STATE(2299)] = 74000,
  [SMALL_STATE(2300)] = 74007,
  [SMALL_STATE(2301)] = 74014,
  [SMALL_STATE(2302)] = 74021,
  [SMALL_STATE(2303)] = 74028,
  [SMALL_STATE(2304)] = 74035,
  [SMALL_STATE(2305)] = 74042,
  [SMALL_STATE(2306)] = 74049,
  [SMALL_STATE(2307)] = 74056,
  [SMALL_STATE(2308)] = 74063,
  [SMALL_STATE(2309)] = 74070,
  [SMALL_STATE(2310)] = 74077,
  [SMALL_STATE(2311)] = 74084,
  [SMALL_STATE(2312)] = 74091,
  [SMALL_STATE(2313)] = 74098,
  [SMALL_STATE(2314)] = 74105,
  [SMALL_STATE(2315)] = 74112,
  [SMALL_STATE(2316)] = 74119,
  [SMALL_STATE(2317)] = 74126,
  [SMALL_STATE(2318)] = 74133,
  [SMALL_STATE(2319)] = 74140,
  [SMALL_STATE(2320)] = 74147,
  [SMALL_STATE(2321)] = 74154,
  [SMALL_STATE(2322)] = 74161,
  [SMALL_STATE(2323)] = 74168,
  [SMALL_STATE(2324)] = 74175,
  [SMALL_STATE(2325)] = 74182,
  [SMALL_STATE(2326)] = 74189,
  [SMALL_STATE(2327)] = 74196,
  [SMALL_STATE(2328)] = 74203,
  [SMALL_STATE(2329)] = 74210,
  [SMALL_STATE(2330)] = 74217,
  [SMALL_STATE(2331)] = 74224,
  [SMALL_STATE(2332)] = 74231,
  [SMALL_STATE(2333)] = 74238,
  [SMALL_STATE(2334)] = 74245,
  [SMALL_STATE(2335)] = 74252,
  [SMALL_STATE(2336)] = 74259,
  [SMALL_STATE(2337)] = 74266,
  [SMALL_STATE(2338)] = 74273,
  [SMALL_STATE(2339)] = 74280,
  [SMALL_STATE(2340)] = 74287,
  [SMALL_STATE(2341)] = 74294,
  [SMALL_STATE(2342)] = 74301,
  [SMALL_STATE(2343)] = 74308,
  [SMALL_STATE(2344)] = 74315,
  [SMALL_STATE(2345)] = 74322,
  [SMALL_STATE(2346)] = 74329,
  [SMALL_STATE(2347)] = 74336,
  [SMALL_STATE(2348)] = 74343,
  [SMALL_STATE(2349)] = 74350,
  [SMALL_STATE(2350)] = 74357,
  [SMALL_STATE(2351)] = 74364,
  [SMALL_STATE(2352)] = 74371,
  [SMALL_STATE(2353)] = 74378,
  [SMALL_STATE(2354)] = 74385,
  [SMALL_STATE(2355)] = 74392,
  [SMALL_STATE(2356)] = 74399,
  [SMALL_STATE(2357)] = 74406,
  [SMALL_STATE(2358)] = 74413,
  [SMALL_STATE(2359)] = 74420,
  [SMALL_STATE(2360)] = 74427,
  [SMALL_STATE(2361)] = 74434,
  [SMALL_STATE(2362)] = 74441,
  [SMALL_STATE(2363)] = 74448,
  [SMALL_STATE(2364)] = 74455,
  [SMALL_STATE(2365)] = 74462,
  [SMALL_STATE(2366)] = 74469,
  [SMALL_STATE(2367)] = 74476,
  [SMALL_STATE(2368)] = 74483,
  [SMALL_STATE(2369)] = 74490,
  [SMALL_STATE(2370)] = 74497,
  [SMALL_STATE(2371)] = 74504,
  [SMALL_STATE(2372)] = 74511,
  [SMALL_STATE(2373)] = 74518,
  [SMALL_STATE(2374)] = 74525,
  [SMALL_STATE(2375)] = 74532,
  [SMALL_STATE(2376)] = 74539,
  [SMALL_STATE(2377)] = 74546,
  [SMALL_STATE(2378)] = 74553,
  [SMALL_STATE(2379)] = 74560,
  [SMALL_STATE(2380)] = 74567,
  [SMALL_STATE(2381)] = 74574,
  [SMALL_STATE(2382)] = 74581,
  [SMALL_STATE(2383)] = 74588,
  [SMALL_STATE(2384)] = 74595,
  [SMALL_STATE(2385)] = 74602,
  [SMALL_STATE(2386)] = 74609,
  [SMALL_STATE(2387)] = 74616,
  [SMALL_STATE(2388)] = 74623,
  [SMALL_STATE(2389)] = 74630,
  [SMALL_STATE(2390)] = 74637,
  [SMALL_STATE(2391)] = 74644,
  [SMALL_STATE(2392)] = 74651,
  [SMALL_STATE(2393)] = 74658,
  [SMALL_STATE(2394)] = 74665,
  [SMALL_STATE(2395)] = 74672,
  [SMALL_STATE(2396)] = 74679,
  [SMALL_STATE(2397)] = 74686,
  [SMALL_STATE(2398)] = 74693,
  [SMALL_STATE(2399)] = 74700,
  [SMALL_STATE(2400)] = 74707,
  [SMALL_STATE(2401)] = 74714,
  [SMALL_STATE(2402)] = 74721,
  [SMALL_STATE(2403)] = 74728,
  [SMALL_STATE(2404)] = 74735,
  [SMALL_STATE(2405)] = 74742,
  [SMALL_STATE(2406)] = 74749,
  [SMALL_STATE(2407)] = 74756,
  [SMALL_STATE(2408)] = 74763,
  [SMALL_STATE(2409)] = 74770,
  [SMALL_STATE(2410)] = 74777,
  [SMALL_STATE(2411)] = 74784,
  [SMALL_STATE(2412)] = 74791,
  [SMALL_STATE(2413)] = 74798,
  [SMALL_STATE(2414)] = 74805,
  [SMALL_STATE(2415)] = 74812,
  [SMALL_STATE(2416)] = 74819,
  [SMALL_STATE(2417)] = 74826,
  [SMALL_STATE(2418)] = 74833,
  [SMALL_STATE(2419)] = 74840,
  [SMALL_STATE(2420)] = 74847,
  [SMALL_STATE(2421)] = 74854,
  [SMALL_STATE(2422)] = 74861,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1665),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2421),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2415),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2026),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1221),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2388),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2373),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1198),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1980),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1793),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2044),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2053),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2313),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2308),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2304),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2284),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2283),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2278),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1748),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1662),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2267),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2268),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1480),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2098),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2205),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2097),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2408),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2163),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2162),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2276),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1649),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2327),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2299),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2051),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2072),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2062),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2329),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2070),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2413),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2245),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2250),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2306),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 3, .production_id = 17),
  [235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(567),
  [238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1662),
  [241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2267),
  [244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1477),
  [247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2),
  [249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2268),
  [252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2098),
  [255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(537),
  [258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(694),
  [261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(694),
  [264] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(700),
  [267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(134),
  [270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1230),
  [273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1336),
  [276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1157),
  [279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2388),
  [282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2034),
  [285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2373),
  [288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1198),
  [291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(46),
  [294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1006),
  [297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(950),
  [300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(936),
  [303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1000),
  [306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1980),
  [309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1725),
  [312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1793),
  [315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2100),
  [318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2071),
  [321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(814),
  [324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2205),
  [327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2097),
  [330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(449),
  [333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2408),
  [336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(647),
  [339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2163),
  [342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2162),
  [345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2276),
  [348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2068),
  [351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2152),
  [354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(809),
  [357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(805),
  [360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2284),
  [363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2283),
  [366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2278),
  [369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1748),
  [372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(884),
  [375] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2017),
  [378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1804),
  [381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(884),
  [384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(882),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 4, .production_id = 40),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 3, .production_id = 40),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 2, .production_id = 17),
  [407] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(564),
  [410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1649),
  [413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2327),
  [416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1448),
  [419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2299),
  [422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2051),
  [425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(210),
  [428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1234),
  [431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1287),
  [434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1171),
  [437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(44),
  [440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2072),
  [443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2062),
  [446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(788),
  [449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2329),
  [452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2070),
  [455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(448),
  [458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2413),
  [461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(624),
  [464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2245),
  [467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2250),
  [470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2306),
  [473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2059),
  [476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2312),
  [479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1671),
  [483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2179),
  [485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1454),
  [487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2180),
  [489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2033),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2037),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2372),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2039),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2360),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2365),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2364),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2188),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2203),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2348),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 2),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2328),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2063),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2052),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2416),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2320),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2318),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2333),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2049),
  [591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2282),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 1),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(570),
  [602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1671),
  [605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2179),
  [608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1454),
  [611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2180),
  [614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2033),
  [617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(272),
  [620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1241),
  [623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1340),
  [626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1152),
  [629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(51),
  [632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2),
  [634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2037),
  [637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2099),
  [640] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(711),
  [643] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2372),
  [646] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2039),
  [649] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(404),
  [652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2360),
  [655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(623),
  [658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2365),
  [661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2364),
  [664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2188),
  [667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2088),
  [670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2203),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(565),
  [688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1660),
  [691] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2348),
  [694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1436),
  [697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2328),
  [700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2123),
  [703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(319),
  [706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1240),
  [709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1343),
  [712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(1165),
  [715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(30),
  [718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2063),
  [721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2052),
  [724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(782),
  [727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2135),
  [730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2061),
  [733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(441),
  [736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2416),
  [739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(648),
  [742] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2320),
  [745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2318),
  [748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2333),
  [751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2049),
  [754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2), SHIFT_REPEAT(2282),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2),
  [767] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(572),
  [770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1665),
  [773] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2421),
  [776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1459),
  [779] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2415),
  [782] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2026),
  [785] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(537),
  [788] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(694),
  [791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(694),
  [794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(700),
  [797] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1221),
  [800] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1346),
  [803] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1169),
  [806] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2388),
  [809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2034),
  [812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2373),
  [815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1198),
  [818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(39),
  [821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1006),
  [824] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(950),
  [827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(936),
  [830] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1000),
  [833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1980),
  [836] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1725),
  [839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1793),
  [842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2044),
  [845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2048),
  [848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(790),
  [851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2332),
  [854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2053),
  [857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(503),
  [860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2313),
  [863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(620),
  [866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2308),
  [869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2304),
  [872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2181),
  [875] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(809),
  [878] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(805),
  [881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2284),
  [884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2283),
  [887] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2278),
  [890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1748),
  [893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1388),
  [896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(2017),
  [899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1804),
  [902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1388),
  [905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(882),
  [908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 1),
  [910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(561),
  [913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2),
  [915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(537),
  [918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(694),
  [921] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(694),
  [924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(700),
  [927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(134),
  [930] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1230),
  [933] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1336),
  [936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(950),
  [939] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2388),
  [942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2034),
  [945] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2373),
  [948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(46),
  [951] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1006),
  [954] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(936),
  [957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1000),
  [960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1980),
  [963] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1725),
  [966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1793),
  [969] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2100),
  [972] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2071),
  [975] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2097),
  [978] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(449),
  [981] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2408),
  [984] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(647),
  [987] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2163),
  [990] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2162),
  [993] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2276),
  [996] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2068),
  [999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2152),
  [1002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(809),
  [1005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(805),
  [1008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2284),
  [1011] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2283),
  [1014] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2278),
  [1017] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1748),
  [1020] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(884),
  [1023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2017),
  [1026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1804),
  [1029] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(884),
  [1032] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(882),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [1037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3),
  [1039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, .production_id = 9),
  [1041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 2),
  [1043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4, .production_id = 9),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [1047] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(563),
  [1050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(210),
  [1053] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1234),
  [1056] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1287),
  [1059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(44),
  [1062] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2072),
  [1065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2062),
  [1068] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2070),
  [1071] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(448),
  [1074] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2413),
  [1077] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(624),
  [1080] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2245),
  [1083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2250),
  [1086] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2306),
  [1089] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2059),
  [1092] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2312),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [1097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4, .production_id = 9),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2344),
  [1107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(569),
  [1110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(319),
  [1113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1240),
  [1116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1343),
  [1119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(30),
  [1122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2063),
  [1125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2052),
  [1128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2061),
  [1131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(441),
  [1134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2416),
  [1137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(648),
  [1140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2320),
  [1143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2318),
  [1146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2333),
  [1149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2049),
  [1152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2282),
  [1155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(568),
  [1158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(272),
  [1161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1241),
  [1164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1340),
  [1167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(51),
  [1170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2),
  [1172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2037),
  [1175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2099),
  [1178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2039),
  [1181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(404),
  [1184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2360),
  [1187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(623),
  [1190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2365),
  [1193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2364),
  [1196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2188),
  [1199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2088),
  [1202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2203),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [1207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 2),
  [1209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, .production_id = 9),
  [1211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3),
  [1213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(566),
  [1216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(383),
  [1219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1221),
  [1222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1346),
  [1225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(39),
  [1228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2044),
  [1231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2048),
  [1234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2053),
  [1237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(503),
  [1240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2313),
  [1243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(620),
  [1246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2308),
  [1249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2304),
  [1252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2181),
  [1255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2089),
  [1258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2344),
  [1261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(560),
  [1264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2106),
  [1267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2109),
  [1270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2384),
  [1273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2038),
  [1276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [1278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [1280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2109),
  [1282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2384),
  [1284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2038),
  [1286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [1290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [1292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 27),
  [1294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 27),
  [1296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [1298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 5, .production_id = 91),
  [1300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 5, .production_id = 91),
  [1302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_finally_clause, 2, .production_id = 8),
  [1304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_finally_clause, 2, .production_id = 8),
  [1306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [1308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [1310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [1312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [1314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [1316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [1318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3),
  [1320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3),
  [1322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_statement, 2),
  [1324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_statement, 2),
  [1326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 6, .production_id = 111),
  [1328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 6, .production_id = 111),
  [1330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_except_clause, 3, .production_id = 100),
  [1332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_except_clause, 3, .production_id = 100),
  [1334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 6, .production_id = 76),
  [1336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 6, .production_id = 76),
  [1338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 5, .production_id = 90),
  [1340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 5, .production_id = 90),
  [1342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_leave_statement, 2),
  [1344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_leave_statement, 2),
  [1346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [1348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [1350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, .production_id = 85),
  [1352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, .production_id = 85),
  [1354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2),
  [1356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2),
  [1358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 28),
  [1360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 28),
  [1362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 28),
  [1364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 28),
  [1366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [1368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [1370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3, .production_id = 29),
  [1372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3, .production_id = 29),
  [1374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .production_id = 31),
  [1376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .production_id = 31),
  [1378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 3, .production_id = 35),
  [1380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 3, .production_id = 35),
  [1382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 4, .production_id = 47),
  [1384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 4, .production_id = 47),
  [1386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_try_statement, 3, .production_id = 8),
  [1388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_try_statement, 3, .production_id = 8),
  [1390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 55),
  [1392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 55),
  [1394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 1),
  [1396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1),
  [1398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 81),
  [1400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 81),
  [1402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2),
  [1404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2),
  [1406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, .production_id = 47),
  [1408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, .production_id = 47),
  [1410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, .production_id = 76),
  [1412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, .production_id = 76),
  [1414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, .production_id = 64),
  [1416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, .production_id = 64),
  [1418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, .production_id = 62),
  [1420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, .production_id = 62),
  [1422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, .production_id = 94),
  [1424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, .production_id = 94),
  [1426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3),
  [1428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3),
  [1430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_include, 3, .production_id = 16),
  [1432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_include, 3, .production_id = 16),
  [1434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 3, .production_id = 17),
  [1436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 3, .production_id = 17),
  [1438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__empty_declaration, 2),
  [1440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__empty_declaration, 2),
  [1442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 6, .production_id = 97),
  [1444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 6, .production_id = 97),
  [1446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 2, .production_id = 4),
  [1448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 2, .production_id = 4),
  [1450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_function_definition, 5, .production_id = 95),
  [1452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__old_style_function_definition, 5, .production_id = 95),
  [1454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 3, .production_id = 18),
  [1456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 3, .production_id = 18),
  [1458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage_specification, 3, .production_id = 23),
  [1460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage_specification, 3, .production_id = 23),
  [1462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, .production_id = 33),
  [1464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, .production_id = 33),
  [1466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_function_definition, 3, .production_id = 36),
  [1468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__old_style_function_definition, 3, .production_id = 36),
  [1470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 4, .production_id = 38),
  [1472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 4, .production_id = 38),
  [1474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, .production_id = 61),
  [1476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, .production_id = 61),
  [1478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 4, .production_id = 39),
  [1480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 4, .production_id = 39),
  [1482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 4, .production_id = 40),
  [1484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 4, .production_id = 40),
  [1486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 3, .production_id = 17),
  [1488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 3, .production_id = 17),
  [1490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, .production_id = 41),
  [1492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, .production_id = 41),
  [1494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_function_definition, 4, .production_id = 66),
  [1496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__old_style_function_definition, 4, .production_id = 66),
  [1498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, .production_id = 17),
  [1500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, .production_id = 17),
  [1502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2),
  [1504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2),
  [1506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, .production_id = 67),
  [1508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, .production_id = 67),
  [1510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_function_definition, 4, .production_id = 68),
  [1512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__old_style_function_definition, 4, .production_id = 68),
  [1514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 5, .production_id = 71),
  [1516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 5, .production_id = 71),
  [1518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, .production_id = 72),
  [1520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, .production_id = 72),
  [1522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, .production_id = 40),
  [1524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, .production_id = 40),
  [1526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 5, .production_id = 73),
  [1528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 5, .production_id = 73),
  [1530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 1, .production_id = 2),
  [1532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 1, .production_id = 2),
  [1534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [1536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [1538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [1540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 4, .production_id = 57),
  [1542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [1544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [1546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 4, .production_id = 57),
  [1548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [1550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [1552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [1554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [1556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [1558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [1560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [1562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [1564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [1566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [1568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [1570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [1572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [1574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [1576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(934),
  [1579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(537),
  [1582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(694),
  [1585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(694),
  [1588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(700),
  [1591] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(319),
  [1594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2101),
  [1597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(30),
  [1600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2063),
  [1603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2052),
  [1606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(782),
  [1609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2135),
  [1612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2061),
  [1615] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(441),
  [1618] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2416),
  [1621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(648),
  [1624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2320),
  [1627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2318),
  [1630] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2333),
  [1633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2049),
  [1636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2282),
  [1639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(809),
  [1642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(805),
  [1645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2284),
  [1648] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2283),
  [1651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2278),
  [1654] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1748),
  [1657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(884),
  [1660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2017),
  [1663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1804),
  [1666] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(884),
  [1669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(882),
  [1672] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(927),
  [1675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(383),
  [1678] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(39),
  [1681] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2044),
  [1684] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2048),
  [1687] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(790),
  [1690] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2332),
  [1693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2053),
  [1696] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(503),
  [1699] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2313),
  [1702] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(620),
  [1705] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2308),
  [1708] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2304),
  [1711] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2181),
  [1714] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2089),
  [1717] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2344),
  [1720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [1722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(935),
  [1725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(210),
  [1728] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(44),
  [1731] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2072),
  [1734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2062),
  [1737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(788),
  [1740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2329),
  [1743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2070),
  [1746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(448),
  [1749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2413),
  [1752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(624),
  [1755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2245),
  [1758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2250),
  [1761] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2306),
  [1764] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2059),
  [1767] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2312),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [1772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(925),
  [1775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(272),
  [1778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(51),
  [1781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2037),
  [1784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2099),
  [1787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(711),
  [1790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2372),
  [1793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2039),
  [1796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(404),
  [1799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2360),
  [1802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(623),
  [1805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2365),
  [1808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2364),
  [1811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2188),
  [1814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2088),
  [1817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2203),
  [1820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [1822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [1826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [1828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2363),
  [1830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2419),
  [1832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2422),
  [1834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [1842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1073),
  [1844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [1846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(923),
  [1849] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2106),
  [1852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(803),
  [1855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2165),
  [1858] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2109),
  [1861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2384),
  [1864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2038),
  [1867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(938),
  [1870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(134),
  [1873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(46),
  [1876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2100),
  [1879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2071),
  [1882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(814),
  [1885] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2205),
  [1888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2097),
  [1891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(449),
  [1894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2408),
  [1897] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(647),
  [1900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2163),
  [1903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2162),
  [1906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2276),
  [1909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2068),
  [1912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(2152),
  [1915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [1917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [1919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [1921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 1, .production_id = 2),
  [1923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 1, .production_id = 2),
  [1925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_expression_statement, 2),
  [1927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_expression_statement, 2),
  [1929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [1931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1403),
  [1933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [1935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 4),
  [1937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 4),
  [1939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [1943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [1945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(906),
  [1947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 3),
  [1949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 3),
  [1951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [1955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [1957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [1959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [1963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [1965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [1967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_specifier, 1, .production_id = 1),
  [1969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_not_binary, 1),
  [1971] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), REDUCE(sym__expression_not_binary, 1), SHIFT(1333),
  [1975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_not_binary, 1),
  [1977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_specifier, 1, .production_id = 1), REDUCE(sym__expression_not_binary, 1),
  [1980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1),
  [1982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [1984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [1986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [1988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [1990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [1992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1), REDUCE(aux_sym_attributed_declarator_repeat1, 1),
  [1995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1),
  [1997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1),
  [1999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1),
  [2001] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_modifiers, 1), REDUCE(aux_sym_attributed_declarator_repeat1, 1),
  [2004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [2006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), REDUCE(sym__expression_not_binary, 1),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [2015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [2025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [2027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [2035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [2037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [2039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [2041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [2043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [2045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [2047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [2049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [2053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [2055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [2057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [2059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [2061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [2063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [2065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [2067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [2071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [2077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [2079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [2085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2292),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [2091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [2093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [2099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [2101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2352),
  [2103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [2105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [2107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2229),
  [2109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [2111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1452),
  [2113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2223),
  [2115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2117),
  [2117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [2119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [2121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1108),
  [2123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [2125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [2127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [2129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [2131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [2133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [2135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2353),
  [2137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1444),
  [2139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [2141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2288),
  [2143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [2145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(989),
  [2148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2352),
  [2151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1456),
  [2154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2),
  [2156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2229),
  [2159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2117),
  [2162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(936),
  [2165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(950),
  [2168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2388),
  [2171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2074),
  [2174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2373),
  [2177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1006),
  [2180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1000),
  [2183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1980),
  [2186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1725),
  [2189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1793),
  [2192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [2194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 2, .production_id = 17),
  [2196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, .production_id = 40),
  [2198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, .production_id = 40),
  [2200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [2202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [2204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, .production_id = 17),
  [2206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1105),
  [2208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [2210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [2212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [2214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [2216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [2218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [2220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [2222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [2224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2353),
  [2227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1444),
  [2230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2288),
  [2233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2108),
  [2236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [2246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [2266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [2272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [2276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, .production_id = 105),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [2282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, .production_id = 84),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [2288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, .production_id = 56),
  [2290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [2292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, .production_id = 40),
  [2294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2),
  [2296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [2298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [2312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, .production_id = 56),
  [2314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2298),
  [2316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1438),
  [2318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2228),
  [2320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2093),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [2330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [2334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [2336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2354),
  [2338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [2340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 2),
  [2342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2317),
  [2344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [2348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2298),
  [2351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1438),
  [2354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2228),
  [2357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2093),
  [2360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [2368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 1),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [2372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2354),
  [2375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1437),
  [2378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2317),
  [2381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(2104),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [2406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [2408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2),
  [2410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2),
  [2412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [2414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 3),
  [2416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 3),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [2420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(827),
  [2423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [2425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [2427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1804),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [2434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2),
  [2436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2),
  [2438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3),
  [2440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3),
  [2442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, .production_id = 124),
  [2444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, .production_id = 124),
  [2446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, .production_id = 120),
  [2448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, .production_id = 120),
  [2450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, .production_id = 119),
  [2452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, .production_id = 119),
  [2454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 9, .production_id = 129),
  [2456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 9, .production_id = 129),
  [2458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, .production_id = 87),
  [2460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, .production_id = 87),
  [2462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, .production_id = 108),
  [2464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, .production_id = 108),
  [2466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, .production_id = 125),
  [2468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, .production_id = 125),
  [2470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, .production_id = 88),
  [2472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, .production_id = 88),
  [2474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, .production_id = 109),
  [2476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, .production_id = 109),
  [2478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 4, .production_id = 58),
  [2480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 4, .production_id = 58),
  [2482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [2484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [2486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2),
  [2488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2),
  [2490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(936),
  [2493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(950),
  [2496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(2388),
  [2499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(2074),
  [2502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(2373),
  [2505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [2507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string, 1),
  [2509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string, 1),
  [2511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, .production_id = 37),
  [2513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, .production_id = 37),
  [2515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 4),
  [2517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 4),
  [2519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignof_expression, 4, .production_id = 57),
  [2521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignof_expression, 4, .production_id = 57),
  [2523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 3),
  [2525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 3),
  [2527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 8),
  [2529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 8),
  [2531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 4, .production_id = 45),
  [2533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 4, .production_id = 45),
  [2535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [2537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [2539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 5),
  [2541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 5),
  [2543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_offsetof_expression, 6, .production_id = 106),
  [2545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_offsetof_expression, 6, .production_id = 106),
  [2547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 69),
  [2549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 69),
  [2551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 9),
  [2553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 9),
  [2555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 13),
  [2557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 13),
  [2559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 12),
  [2561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 12),
  [2563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_null, 1),
  [2565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null, 1),
  [2567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 2),
  [2569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 2),
  [2571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [2573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [2575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char_literal, 3),
  [2577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char_literal, 3),
  [2579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 2, .production_id = 9),
  [2581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 2, .production_id = 9),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [2591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 5),
  [2593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 5),
  [2595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 30),
  [2597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 30),
  [2599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2),
  [2601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [2603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_specifier, 4),
  [2605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_specifier, 4),
  [2607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1199),
  [2609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4),
  [2611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4),
  [2613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [2617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3),
  [2619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [2621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(989),
  [2624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(936),
  [2627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(950),
  [2630] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(2388),
  [2633] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(2074),
  [2636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(2373),
  [2639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2),
  [2641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(1006),
  [2644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(1000),
  [2647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(1980),
  [2650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(1725),
  [2653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__old_style_function_definition_repeat1, 2), SHIFT_REPEAT(1793),
  [2656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_expression, 2, .production_id = 5),
  [2658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_expression, 2, .production_id = 5),
  [2660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 5),
  [2662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 5),
  [2664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5),
  [2666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5),
  [2668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, .production_id = 45),
  [2670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, .production_id = 45),
  [2672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [2674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(904),
  [2677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1809),
  [2680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [2682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [2684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [2686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2),
  [2688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2),
  [2690] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2), SHIFT_REPEAT(926),
  [2693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, .production_id = 53),
  [2695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, .production_id = 53),
  [2697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [2699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier, 1),
  [2701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier, 1),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [2705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 2, .production_id = 7),
  [2707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 2, .production_id = 7),
  [2709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, .production_id = 25),
  [2711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, .production_id = 25),
  [2713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 2, .production_id = 7),
  [2715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 2, .production_id = 7),
  [2717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, .production_id = 25),
  [2719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, .production_id = 25),
  [2721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_declspec_modifier, 4),
  [2723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_declspec_modifier, 4),
  [2725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 4, .production_id = 70),
  [2727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 4, .production_id = 70),
  [2729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [2731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [2737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [2739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [2741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [2743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [2745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [2749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [2751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [2753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, .production_id = 96),
  [2755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, .production_id = 96),
  [2757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 30),
  [2759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 30),
  [2761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [2763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [2765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_class_specifier, 1),
  [2767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_class_specifier, 1),
  [2769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 1, .production_id = 3),
  [2771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 1, .production_id = 3),
  [2773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, .production_id = 24),
  [2775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, .production_id = 24),
  [2777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [2779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [2781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [2783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [2785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [2787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [2789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [2791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [2793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [2797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [2799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [2801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, .production_id = 54),
  [2803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, .production_id = 54),
  [2805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, .production_id = 14),
  [2807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, .production_id = 14),
  [2809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, .production_id = 3),
  [2811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, .production_id = 3),
  [2813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [2815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [2817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(962),
  [2820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 5, .production_id = 80),
  [2822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 5, .production_id = 80),
  [2824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, .production_id = 24),
  [2826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, .production_id = 24),
  [2828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 2, .production_id = 8),
  [2830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 2, .production_id = 8),
  [2832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, .production_id = 26),
  [2834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, .production_id = 26),
  [2836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 2, .production_id = 8),
  [2838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 2, .production_id = 8),
  [2840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, .production_id = 26),
  [2842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, .production_id = 26),
  [2844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 4, .production_id = 52),
  [2846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 4, .production_id = 52),
  [2848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, .production_id = 52),
  [2850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, .production_id = 52),
  [2852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 3, .production_id = 14),
  [2854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 3, .production_id = 14),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [2858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [2860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [2862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [2864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [2866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [2868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [2870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [2872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [2874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [2876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [2878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [2880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [2882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [2886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [2888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), SHIFT(1333),
  [2891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, .production_id = 8),
  [2893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, .production_id = 8),
  [2895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, .production_id = 7),
  [2897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, .production_id = 7),
  [2899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_specifier, 1),
  [2901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_specifier, 1),
  [2903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [2905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1), SHIFT(1038),
  [2908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 1),
  [2910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1),
  [2912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [2914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [2916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 5, .production_id = 52),
  [2918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 5, .production_id = 52),
  [2920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 5, .production_id = 54),
  [2922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 5, .production_id = 54),
  [2924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 5, .production_id = 53),
  [2926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 5, .production_id = 53),
  [2928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_type_specifier, 4, .dynamic_precedence = -1, .production_id = 59),
  [2930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_type_specifier, 4, .dynamic_precedence = -1, .production_id = 59),
  [2932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 6, .production_id = 80),
  [2934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 6, .production_id = 80),
  [2936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, .production_id = 8),
  [2938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, .production_id = 8),
  [2940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 5, .production_id = 52),
  [2942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 5, .production_id = 52),
  [2944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .production_id = 14),
  [2946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, .production_id = 14),
  [2948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [2950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, .production_id = 7),
  [2952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, .production_id = 7),
  [2954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2),
  [2956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2),
  [2958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .production_id = 10),
  [2960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .production_id = 10),
  [2962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [2964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 4),
  [2966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 4),
  [2968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 4, .production_id = 26),
  [2970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 4, .production_id = 26),
  [2972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, .dynamic_precedence = -1, .production_id = 15),
  [2974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, .dynamic_precedence = -1, .production_id = 15),
  [2976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 3),
  [2978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 3),
  [2980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 4, .production_id = 25),
  [2982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 4, .production_id = 25),
  [2984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, .production_id = 14),
  [2986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, .production_id = 14),
  [2988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, .production_id = 8),
  [2990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, .production_id = 8),
  [2992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .production_id = 3),
  [2994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, .production_id = 3),
  [2996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, .production_id = 24),
  [2998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, .production_id = 24),
  [3000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, .production_id = 50),
  [3002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, .production_id = 50),
  [3004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 4, .production_id = 24),
  [3006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 4, .production_id = 24),
  [3008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, .production_id = 26),
  [3010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, .production_id = 26),
  [3012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, .production_id = 25),
  [3014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, .production_id = 25),
  [3016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 6, .production_id = 78),
  [3018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 6, .production_id = 78),
  [3020] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2), REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [3023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2), REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [3026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, .production_id = 24),
  [3028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, .production_id = 24),
  [3030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .production_id = 15),
  [3032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .production_id = 15),
  [3034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [3036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, .production_id = 7),
  [3038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, .production_id = 7),
  [3040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 2),
  [3042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 2),
  [3044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3),
  [3046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3),
  [3048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .production_id = 40),
  [3050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .production_id = 40),
  [3052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .production_id = 72),
  [3054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .production_id = 72),
  [3056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 79),
  [3058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 79),
  [3060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 42),
  [3062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 42),
  [3064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .production_id = 17),
  [3066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .production_id = 17),
  [3068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .production_id = 73),
  [3070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .production_id = 73),
  [3072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, .production_id = 97),
  [3074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, .production_id = 97),
  [3076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, .production_id = 79),
  [3078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, .production_id = 79),
  [3080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .production_id = 17),
  [3082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .production_id = 17),
  [3084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .production_id = 41),
  [3086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .production_id = 41),
  [3088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .production_id = 40),
  [3090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .production_id = 40),
  [3092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 42),
  [3094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 42),
  [3096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [3098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, .production_id = 7),
  [3100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, .production_id = 7),
  [3102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_enum_specifier, 2, .production_id = 7), SHIFT(2388),
  [3105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [3107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [3111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [3113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [3115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [3117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2368),
  [3119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [3121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [3123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [3129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [3131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [3133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [3137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [3143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_parameter_list, 2), REDUCE(sym__old_style_parameter_list, 2),
  [3146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2),
  [3148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_parameter_list, 2),
  [3150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter_list, 2), REDUCE(sym__old_style_parameter_list, 2),
  [3153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 2),
  [3155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_parameter_list, 3), REDUCE(sym__old_style_parameter_list, 3),
  [3158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3),
  [3160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_parameter_list, 3),
  [3162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter_list, 3), REDUCE(sym__old_style_parameter_list, 3),
  [3165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 3),
  [3167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, .production_id = 50),
  [3169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, .production_id = 50),
  [3171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_enum_specifier, 4, .production_id = 50), SHIFT(2388),
  [3174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1647),
  [3176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, .dynamic_precedence = 1),
  [3178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [3180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [3182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [3184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 1, .dynamic_precedence = 1),
  [3186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [3188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, .production_id = 8),
  [3190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, .production_id = 8),
  [3192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_enum_specifier, 2, .production_id = 8), SHIFT(2388),
  [3195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, .production_id = 24),
  [3197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, .production_id = 24),
  [3199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_enum_specifier, 3, .production_id = 24), SHIFT(2388),
  [3202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, .production_id = 78),
  [3204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, .production_id = 78),
  [3206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_enum_specifier, 5, .production_id = 78), SHIFT(2388),
  [3209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1736),
  [3211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [3213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [3215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1727),
  [3217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1728),
  [3219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), SHIFT(1917),
  [3222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), SHIFT(1232),
  [3225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_call_modifier, 1),
  [3227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_call_modifier, 1),
  [3229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), REDUCE(aux_sym__old_style_parameter_list_repeat1, 2),
  [3232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .production_id = 1),
  [3235] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .production_id = 1), SHIFT(1333),
  [3239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .production_id = 1),
  [3242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 3, .production_id = 77),
  [3244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 3, .production_id = 77),
  [3246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [3248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [3250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [3254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [3256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [3258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [3260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [3264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [3268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [3272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [3274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [3276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [3278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [3280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [3286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_function_declarator, 2, .production_id = 34),
  [3288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__old_style_function_declarator, 2, .production_id = 34),
  [3290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [3292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [3294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [3296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [3300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [3302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [3304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1329),
  [3306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__old_style_parameter_list, 3),
  [3308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__old_style_parameter_list, 4),
  [3310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__old_style_parameter_list, 4),
  [3312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [3314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [3316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [3318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [3320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [3322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [3324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [3326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [3328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [3330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [3332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [3334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [3350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, .dynamic_precedence = 1),
  [3352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1674),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [3362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2),
  [3364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2),
  [3366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2), SHIFT_REPEAT(1368),
  [3369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2), SHIFT_REPEAT(1364),
  [3372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 3),
  [3374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 3),
  [3376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 4),
  [3378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 4),
  [3380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 2),
  [3382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 2),
  [3384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call_expression, 2, .production_id = 13),
  [3386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call_expression, 2, .production_id = 13),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [3390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comma_expression, 3, .production_id = 44),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [3398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [3404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [3406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [3412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitfield_clause, 2),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [3418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [3422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [3424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [3426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [3428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [3430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1517),
  [3432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [3434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1504),
  [3436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [3440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, .production_id = 103),
  [3442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, .production_id = 83),
  [3444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, .production_id = 82),
  [3446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [3448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1880),
  [3450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [3452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, .production_id = 102),
  [3454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, .production_id = 104),
  [3456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 4),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [3460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [3464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [3466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 5, .production_id = 116),
  [3468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [3472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 3),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [3476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [3480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [3482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, .production_id = 114),
  [3484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2),
  [3486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, .production_id = 115),
  [3488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [3492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [3494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [3498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [3500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [3512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [3524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [3528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declarator, 3, .production_id = 63),
  [3530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [3532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [3534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [3538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1),
  [3540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1),
  [3542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [3544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [3546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_pointer_modifier, 1),
  [3548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_pointer_modifier, 1),
  [3550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [3552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [3554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [3556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [3558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [3560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [3562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [3564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [3566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2), SHIFT_REPEAT(936),
  [3569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [3571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [3573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, .production_id = 3),
  [3575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, .production_id = 14),
  [3577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, .production_id = 14),
  [3579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 1, .production_id = 3),
  [3581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1651),
  [3583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preproc_expression, 1),
  [3585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [3587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__preproc_expression, 1),
  [3589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [3591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [3593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1418),
  [3595] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [3597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [3599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [3601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [3603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [3605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [3607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [3609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [3611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [3613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [3615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [3617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [3619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1493),
  [3621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [3623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [3625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [3627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [3629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [3631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2041),
  [3633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [3635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [3637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [3639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [3641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [3643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [3645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [3647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [3649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [3651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [3653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1414),
  [3655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [3657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2079),
  [3659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [3661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1451),
  [3663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [3665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [3667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_binary_expression, 3, .production_id = 30),
  [3669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_binary_expression, 3, .production_id = 30),
  [3671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [3673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [3675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [3677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [3679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [3681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [3683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [3685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 1, .production_id = 42),
  [3687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [3689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 3, .production_id = 14),
  [3691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 3, .production_id = 14),
  [3693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [3695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [3697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [3699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [3701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 4),
  [3703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 4),
  [3705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [3707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [3709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, .production_id = 14),
  [3711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, .production_id = 14),
  [3713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [3715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [3717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [3719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, .production_id = 3),
  [3721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, .production_id = 3),
  [3723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [3725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [3727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [3729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_parenthesized_expression, 3),
  [3731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_parenthesized_expression, 3),
  [3733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 1, .production_id = 3),
  [3735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 1, .production_id = 3),
  [3737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2),
  [3739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 2),
  [3741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 2),
  [3743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_unary_expression, 2, .production_id = 5),
  [3745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_unary_expression, 2, .production_id = 5),
  [3747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [3749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [3751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [3753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [3755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [3757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [3759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [3761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [3763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [3765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [3767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [3769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [3771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [3773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [3775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [3777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [3779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [3781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [3783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [3785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [3787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [3789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1458),
  [3791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [3793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1481),
  [3795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [3797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [3799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [3801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [3803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [3805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [3807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [3809] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2), REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT(962),
  [3813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [3815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [3817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [3819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [3821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_specifier, 1), SHIFT(1518),
  [3824] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1), SHIFT(1514),
  [3827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1), SHIFT(1498),
  [3830] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1), SHIFT(1515),
  [3833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [3835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, .production_id = 14), SHIFT(962),
  [3838] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, .dynamic_precedence = -1, .production_id = 15), SHIFT(962),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [3843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .production_id = 15), SHIFT(1508),
  [3846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .production_id = 14), SHIFT(1507),
  [3849] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_specifier, 1, .production_id = 1), SHIFT(1540),
  [3852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .production_id = 3), SHIFT(962),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [3857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [3859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [3861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [3863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [3865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [3867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [3871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .production_id = 10), SHIFT(962),
  [3874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [3878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [3880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [3882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_enum_specifier, 2, .production_id = 7), SHIFT(2307),
  [3885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1594),
  [3887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declaration_declarator, 2, .production_id = 34),
  [3889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 2, .production_id = 34),
  [3891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 2, .production_id = 34),
  [3893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 3, .production_id = 34),
  [3895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 3, .production_id = 34),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [3901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 4, .production_id = 34),
  [3903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 4, .production_id = 34),
  [3905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [3909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1594),
  [3912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_declarator_repeat1, 2),
  [3914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(2388),
  [3917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_declarator_repeat1, 2),
  [3919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [3921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [3923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [3925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1439),
  [3927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [3929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declaration_declarator, 3, .production_id = 34),
  [3931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declaration_declarator, 3, .production_id = 34),
  [3933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2),
  [3935] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT_REPEAT(2034),
  [3938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2),
  [3940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 5, .dynamic_precedence = 1, .production_id = 110),
  [3942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [3944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [3946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 4),
  [3948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4),
  [3950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 2, .dynamic_precedence = 1, .production_id = 32),
  [3952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [3954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [3956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2211),
  [3958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [3960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_declarator_repeat1, 1),
  [3962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_declarator_repeat1, 1),
  [3964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 3, .dynamic_precedence = 1, .production_id = 60),
  [3966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 4, .dynamic_precedence = 1, .production_id = 89),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [3972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_declarator, 1, .production_id = 22),
  [3974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [3976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [3978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_declarator, 2),
  [3980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_declarator, 2),
  [3982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 5, .dynamic_precedence = 1, .production_id = 110),
  [3984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 2, .dynamic_precedence = 1, .production_id = 32),
  [3986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [3988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [3990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [3992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [3994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [3996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 2, .production_id = 17),
  [3998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [4000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 4, .dynamic_precedence = 1, .production_id = 89),
  [4002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2), SHIFT_REPEAT(1973),
  [4005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2), SHIFT_REPEAT(1442),
  [4008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2), SHIFT_REPEAT(2227),
  [4011] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2), SHIFT_REPEAT(2026),
  [4014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2),
  [4016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [4018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 3, .production_id = 40),
  [4020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__field_declaration_declarator_repeat1, 2, .production_id = 32),
  [4022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [4024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 1),
  [4026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [4028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 3, .dynamic_precedence = 1, .production_id = 60),
  [4030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [4032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [4034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1441),
  [4036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [4038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 1),
  [4040] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 1), REDUCE(aux_sym_function_declarator_repeat1, 1),
  [4043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 1),
  [4045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 1),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [4049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 4, .dynamic_precedence = -10),
  [4051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 4, .dynamic_precedence = -10),
  [4053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [4055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 1, .production_id = 22),
  [4057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [4059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [4061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [4063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 4, .dynamic_precedence = 1, .production_id = 89),
  [4065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, .production_id = 92),
  [4067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, .production_id = 92),
  [4069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 1),
  [4071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [4073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, .production_id = 22),
  [4075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, .production_id = 22),
  [4077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 3, .dynamic_precedence = -10),
  [4079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 3, .dynamic_precedence = -10),
  [4081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 2, .dynamic_precedence = 1, .production_id = 32),
  [4083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_field_declarator, 2),
  [4085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_field_declarator, 2),
  [4087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 5, .dynamic_precedence = 1, .production_id = 110),
  [4089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 3, .production_id = 22),
  [4091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 3, .production_id = 22),
  [4093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 5, .production_id = 112),
  [4095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 5, .production_id = 112),
  [4097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declarator, 1),
  [4099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declarator, 1),
  [4101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 3, .dynamic_precedence = 1, .production_id = 60),
  [4103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1969),
  [4105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [4109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_declarator, 1),
  [4111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, .production_id = 32),
  [4113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1972),
  [4115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [4117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [4119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [4121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1991),
  [4123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [4125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_type_declarator, 2),
  [4127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_type_declarator, 2),
  [4129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [4131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [4133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, .production_id = 51),
  [4135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, .production_id = 51),
  [4137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 3, .dynamic_precedence = -10),
  [4139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 3, .dynamic_precedence = -10),
  [4141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2), SHIFT_REPEAT(1973),
  [4144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2),
  [4146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2),
  [4148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 1, .production_id = 6),
  [4150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 1, .production_id = 6),
  [4152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [4154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, .production_id = 22),
  [4156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, .production_id = 22),
  [4158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [4162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, .production_id = 17),
  [4164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 4, .dynamic_precedence = -10),
  [4166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 4, .dynamic_precedence = -10),
  [4168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 5, .production_id = 112),
  [4170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 5, .production_id = 112),
  [4172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, .production_id = 17),
  [4174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [4176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2), SHIFT_REPEAT(1677),
  [4179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2),
  [4181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2),
  [4183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, .production_id = 40),
  [4185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, .production_id = 40),
  [4187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [4189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, .production_id = 35),
  [4191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 3, .production_id = 22),
  [4193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 3, .production_id = 22),
  [4195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, .production_id = 92),
  [4197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, .production_id = 92),
  [4199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_field_declarator, 2, .production_id = 34),
  [4201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_field_declarator, 2, .production_id = 34),
  [4203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 3, .production_id = 40),
  [4205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 2, .production_id = 17),
  [4207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1),
  [4209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [4213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [4215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [4217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type_declarator, 2, .production_id = 34),
  [4219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type_declarator, 2, .production_id = 34),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [4223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, .production_id = 22),
  [4225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, .production_id = 22),
  [4227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, .production_id = 92),
  [4229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, .production_id = 92),
  [4231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 4, .dynamic_precedence = -10),
  [4233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 4, .dynamic_precedence = -10),
  [4235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2), SHIFT_REPEAT(789),
  [4238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2),
  [4240] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2), SHIFT_REPEAT(2292),
  [4243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [4245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [4247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declaration_declarator, 4, .production_id = 34),
  [4249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, .production_id = 21),
  [4251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, .production_id = 21),
  [4253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1),
  [4255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1),
  [4257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [4259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [4261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 3, .production_id = 22),
  [4263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 3, .production_id = 22),
  [4265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 3, .dynamic_precedence = -10),
  [4267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 3, .dynamic_precedence = -10),
  [4269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 5, .production_id = 112),
  [4271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 5, .production_id = 112),
  [4273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [4277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [4281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1),
  [4283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, .production_id = 1),
  [4285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, .production_id = 1),
  [4287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2),
  [4289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(2388),
  [4292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, .production_id = 41),
  [4294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, .production_id = 41),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [4298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [4302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, .production_id = 19),
  [4304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [4306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, .dynamic_precedence = 1, .production_id = 60),
  [4308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 4, .production_id = 75),
  [4310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [4314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [4316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [4318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [4320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [4322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 4, .dynamic_precedence = 1, .production_id = 89),
  [4324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, .production_id = 43),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [4330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [4332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, .production_id = 46),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [4336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [4338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2), SHIFT_REPEAT(1766),
  [4341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [4343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, .production_id = 17),
  [4345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, .production_id = 17),
  [4347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, .production_id = 40),
  [4349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, .production_id = 40),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [4353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2),
  [4355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, .production_id = 73),
  [4357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, .production_id = 73),
  [4359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [4361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [4363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [4365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, .production_id = 40),
  [4367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, .production_id = 40),
  [4369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, .dynamic_precedence = 1, .production_id = 32),
  [4371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [4373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2),
  [4375] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2), SHIFT_REPEAT(1833),
  [4378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [4380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, .production_id = 72),
  [4382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, .production_id = 72),
  [4384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, .production_id = 97),
  [4386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, .production_id = 97),
  [4388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, .production_id = 17),
  [4390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, .production_id = 17),
  [4392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [4394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, .production_id = 92),
  [4396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, .production_id = 6),
  [4398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [4400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 2),
  [4402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__abstract_declarator, 1),
  [4404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, .production_id = 32),
  [4406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 1, .production_id = 20),
  [4408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3),
  [4410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [4412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 2, .production_id = 34),
  [4414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 4),
  [4416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [4418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, .production_id = 22),
  [4420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 1),
  [4422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, .production_id = 98),
  [4424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, .production_id = 74),
  [4426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, .production_id = 22),
  [4428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 3),
  [4430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 5, .production_id = 112),
  [4432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [4434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 3, .production_id = 93),
  [4436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [4438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [4440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [4442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [4444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, .production_id = 49),
  [4446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [4448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [4450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2374),
  [4452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [4454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2214),
  [4456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [4458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [4460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1872),
  [4462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_declarator, 3, .production_id = 101),
  [4464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_declarator, 2, .production_id = 48),
  [4466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__field_declaration_declarator_repeat1, 2, .production_id = 65), SHIFT_REPEAT(1612),
  [4469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__field_declaration_declarator_repeat1, 2, .production_id = 65),
  [4471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [4473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [4475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, .production_id = 117), SHIFT_REPEAT(1712),
  [4478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, .production_id = 117),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [4490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2192),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [4494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [4496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [4498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1502),
  [4500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [4502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 2),
  [4504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 2),
  [4506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, .production_id = 65), SHIFT_REPEAT(1570),
  [4509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, .production_id = 65),
  [4511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [4513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [4515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2175),
  [4517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [4519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 2, .production_id = 86),
  [4521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [4523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2169),
  [4525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 1),
  [4527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [4529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [4531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_qualifier, 1),
  [4533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [4537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [4539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [4541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [4543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 3, .production_id = 107),
  [4545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [4547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, .production_id = 117), SHIFT_REPEAT(1679),
  [4550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, .production_id = 117),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [4556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2147),
  [4558] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, .production_id = 127), SHIFT_REPEAT(1659),
  [4561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, .production_id = 127),
  [4563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [4565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [4567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [4569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_declarator, 1, .production_id = 11),
  [4571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [4573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2),
  [4575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1846),
  [4578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1846),
  [4581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [4583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2154),
  [4585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [4587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 3, .production_id = 122),
  [4589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [4599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_declarator, 2, .production_id = 22),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [4603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [4605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [4607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [4609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [4611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [4615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [4617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [4619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [4621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [4623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 3, .production_id = 107),
  [4625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2),
  [4627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2), SHIFT_REPEAT(1865),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [4632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2321),
  [4634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 2, .production_id = 48),
  [4636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 2, .production_id = 86),
  [4638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [4640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2141),
  [4642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [4644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [4646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [4648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [4650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2279),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [4654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 2, .production_id = 118),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [4658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2253),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [4662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1819),
  [4664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [4668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [4674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [4686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [4688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [4694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [4700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [4702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(615),
  [4705] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2), SHIFT_REPEAT(1455),
  [4708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [4710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [4712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2), SHIFT_REPEAT(2057),
  [4715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2),
  [4717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [4723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [4725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [4727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [4729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_range_designator, 5, .production_id = 126),
  [4731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [4733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [4735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [4737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [4739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [4743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [4745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 2, .production_id = 123),
  [4747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [4749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [4751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [4753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [4755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [4757] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2), SHIFT_REPEAT(888),
  [4760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2),
  [4762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [4764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [4766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2), SHIFT_REPEAT(1309),
  [4769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2),
  [4771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [4775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [4779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [4783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [4787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [4789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [4791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [4793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [4795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [4799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, .production_id = 86),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [4807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_designator, 2, .production_id = 99),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [4811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [4813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [4821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [4823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [4825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [4827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [4829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [4831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [4835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 4, .production_id = 121),
  [4837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 4, .production_id = 121),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [4843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [4845] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__old_style_parameter_list_repeat1, 2), SHIFT_REPEAT(1917),
  [4848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__old_style_parameter_list_repeat1, 2),
  [4850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [4852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_designator, 3),
  [4854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [4856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [4858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [4860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2), SHIFT_REPEAT(590),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [4867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, .production_id = 130), SHIFT_REPEAT(2323),
  [4870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, .production_id = 130),
  [4872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [4874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [4876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2), SHIFT_REPEAT(2091),
  [4879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2),
  [4881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [4885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, .production_id = 65), SHIFT_REPEAT(1428),
  [4888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, .production_id = 65),
  [4890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [4892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [4894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [4896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [4898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, .production_id = 118),
  [4900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, .production_id = 86),
  [4902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [4904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [4906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 3, .production_id = 128),
  [4908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [4910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [4912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [4914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [4916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [4918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [4920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [4922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [4924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [4926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [4928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [4930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [4932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [4934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [4936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1871),
  [4938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [4940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [4942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [4944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [4946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [4948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [4950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [4952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [4954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [4956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [4958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [4960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [4962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [4964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [4966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [4968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [4970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [4972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [4974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [4976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [4978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [4980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__field_declaration_declarator_repeat1, 3, .production_id = 32),
  [4982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [4984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 7, .production_id = 131),
  [4986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 7, .production_id = 131),
  [4988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4, .production_id = 49),
  [4990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [4992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 1),
  [4994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [4996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2235),
  [4998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 2),
  [5000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 2),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [5004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [5006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [5008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [5010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2355),
  [5012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [5014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [5016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2133),
  [5018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [5020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [5022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [5024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [5026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2295),
  [5028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [5030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2202),
  [5032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [5034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 3),
  [5036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 3),
  [5038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 1),
  [5040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, .production_id = 123),
  [5042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [5044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2404),
  [5046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [5048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [5050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [5052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [5054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 4, .production_id = 113),
  [5056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [5058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2302),
  [5060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, .production_id = 6),
  [5062] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2), REDUCE(aux_sym__old_style_parameter_list_repeat1, 2),
  [5065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [5067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2158),
  [5069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [5071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [5073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [5075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [5077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [5079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [5081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [5083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2168),
  [5085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [5087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2161),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [5091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2131),
  [5093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 4),
  [5095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 4),
  [5097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [5099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [5103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [5105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [5107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2138),
  [5109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 4, .production_id = 73),
  [5111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [5115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [5117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [5119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [5121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [5123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [5125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 4, .production_id = 72),
  [5127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [5129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [5131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [5133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [5135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [5137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [5139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [5141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [5143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [5145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [5147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [5149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [5151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [5153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [5155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [5157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [5159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [5161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [5163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [5165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [5167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [5169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [5171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [5173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [5175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [5177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [5179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [5183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [5185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [5187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [5189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [5191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [5193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [5195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [5197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [5199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [5201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [5203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [5205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [5207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [5209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [5211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [5213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [5215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [5217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [5219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [5221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [5223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [5225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [5227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [5231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [5233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [5235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [5237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 5, .production_id = 97),
  [5239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [5241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [5243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [5245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [5247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [5249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [5251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [5253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [5255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [5257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [5259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [5261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [5263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [5265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 3, .production_id = 41),
  [5267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [5269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [5271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [5273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, .production_id = 72),
  [5275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [5277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [5279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [5281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [5283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [5285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [5287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [5289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [5291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [5293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [5295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [5297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [5299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [5301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [5303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [5305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [5307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [5309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, .production_id = 41),
  [5311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, .production_id = 41),
  [5313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [5315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [5317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [5319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [5321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [5325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [5329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 5, .production_id = 73),
  [5331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [5333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [5337] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [5339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, .production_id = 41),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [5343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [5345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [5347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [5349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [5351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [5353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, .production_id = 41),
  [5355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [5359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [5361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [5363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [5367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [5373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [5375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [5389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [5391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [5393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [5395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [5397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [5399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [5401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [5403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [5405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [5407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [5409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [5411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [5413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [5415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [5417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [5419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, .production_id = 40),
  [5421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [5423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [5425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [5427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [5429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [5431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [5433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [5435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [5437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [5439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [5441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [5443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [5445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [5447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [5449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [5451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [5453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_based_modifier, 2),
  [5455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [5457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [5459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [5461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [5463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [5467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [5469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [5473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [5475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [5477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [5479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [5481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, .production_id = 17),
  [5483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [5485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [5487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [5489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [5491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [5493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [5495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [5497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [5499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 5, .production_id = 97),
  [5501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [5503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 5, .production_id = 97),
  [5505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 5, .production_id = 97),
  [5507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [5509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [5511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [5513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [5515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [5517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [5519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [5521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [5523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [5525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [5527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [5529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [5531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [5533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [5535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [5537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [5539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [5541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [5543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [5545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [5547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [5549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [5551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [5553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [5555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [5557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 4, .production_id = 73),
  [5559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [5561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [5563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, .production_id = 72),
  [5565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 4, .production_id = 73),
  [5567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 4, .production_id = 73),
  [5569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [5571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [5573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [5575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, .production_id = 72),
  [5577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, .production_id = 72),
  [5579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 6, .production_id = 97),
  [5581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [5583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [5585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [5587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [5589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [5591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [5593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [5595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [5597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [5599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [5601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [5603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [5605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [5607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_c() {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
