#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 338
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 47
#define ALIAS_COUNT 0
#define TOKEN_COUNT 22
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 5
#define MAX_ALIAS_SEQUENCE_LENGTH 11
#define PRODUCTION_ID_COUNT 20

enum ts_symbol_identifiers {
  anon_sym_DOT = 1,
  anon_sym_DQUOTE = 2,
  aux_sym__string_token1 = 3,
  sym_escape_sequence = 4,
  anon_sym_STAR = 5,
  anon_sym_PLUS = 6,
  anon_sym_QMARK = 7,
  sym_identifier = 8,
  aux_sym__immediate_identifier_token1 = 9,
  anon_sym__ = 10,
  anon_sym_AT = 11,
  sym_comment = 12,
  anon_sym_LBRACK = 13,
  anon_sym_RBRACK = 14,
  anon_sym_LPAREN = 15,
  anon_sym_RPAREN = 16,
  anon_sym_SLASH = 17,
  anon_sym_COLON = 18,
  anon_sym_BANG = 19,
  anon_sym_POUND = 20,
  sym_predicate_type = 21,
  sym_program = 22,
  sym__definition = 23,
  sym__group_expression = 24,
  sym__named_node_expression = 25,
  sym__string = 26,
  sym_quantifier = 27,
  sym__immediate_identifier = 28,
  sym__node_identifier = 29,
  sym_capture = 30,
  sym_string = 31,
  sym_parameters = 32,
  sym_list = 33,
  sym_grouping = 34,
  sym_anonymous_node = 35,
  sym_named_node = 36,
  sym__field_name = 37,
  sym_field_definition = 38,
  sym_negated_field = 39,
  sym_predicate = 40,
  aux_sym_program_repeat1 = 41,
  aux_sym__string_repeat1 = 42,
  aux_sym_parameters_repeat1 = 43,
  aux_sym_list_repeat1 = 44,
  aux_sym_grouping_repeat1 = 45,
  aux_sym_named_node_repeat1 = 46,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_DOT] = ".",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym__string_token1] = "_string_token1",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_STAR] = "*",
  [anon_sym_PLUS] = "+",
  [anon_sym_QMARK] = "\?",
  [sym_identifier] = "identifier",
  [aux_sym__immediate_identifier_token1] = "identifier",
  [anon_sym__] = "_",
  [anon_sym_AT] = "@",
  [sym_comment] = "comment",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SLASH] = "/",
  [anon_sym_COLON] = ":",
  [anon_sym_BANG] = "!",
  [anon_sym_POUND] = "#",
  [sym_predicate_type] = "predicate_type",
  [sym_program] = "program",
  [sym__definition] = "_definition",
  [sym__group_expression] = "_group_expression",
  [sym__named_node_expression] = "_named_node_expression",
  [sym__string] = "_string",
  [sym_quantifier] = "quantifier",
  [sym__immediate_identifier] = "_immediate_identifier",
  [sym__node_identifier] = "_node_identifier",
  [sym_capture] = "capture",
  [sym_string] = "string",
  [sym_parameters] = "parameters",
  [sym_list] = "list",
  [sym_grouping] = "grouping",
  [sym_anonymous_node] = "anonymous_node",
  [sym_named_node] = "named_node",
  [sym__field_name] = "_field_name",
  [sym_field_definition] = "field_definition",
  [sym_negated_field] = "negated_field",
  [sym_predicate] = "predicate",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym__string_repeat1] = "_string_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_list_repeat1] = "list_repeat1",
  [aux_sym_grouping_repeat1] = "grouping_repeat1",
  [aux_sym_named_node_repeat1] = "named_node_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym__string_token1] = aux_sym__string_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [sym_identifier] = sym_identifier,
  [aux_sym__immediate_identifier_token1] = sym_identifier,
  [anon_sym__] = anon_sym__,
  [anon_sym_AT] = anon_sym_AT,
  [sym_comment] = sym_comment,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_POUND] = anon_sym_POUND,
  [sym_predicate_type] = sym_predicate_type,
  [sym_program] = sym_program,
  [sym__definition] = sym__definition,
  [sym__group_expression] = sym__group_expression,
  [sym__named_node_expression] = sym__named_node_expression,
  [sym__string] = sym__string,
  [sym_quantifier] = sym_quantifier,
  [sym__immediate_identifier] = sym__immediate_identifier,
  [sym__node_identifier] = sym__node_identifier,
  [sym_capture] = sym_capture,
  [sym_string] = sym_string,
  [sym_parameters] = sym_parameters,
  [sym_list] = sym_list,
  [sym_grouping] = sym_grouping,
  [sym_anonymous_node] = sym_anonymous_node,
  [sym_named_node] = sym_named_node,
  [sym__field_name] = sym__field_name,
  [sym_field_definition] = sym_field_definition,
  [sym_negated_field] = sym_negated_field,
  [sym_predicate] = sym_predicate,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym__string_repeat1] = aux_sym__string_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_list_repeat1] = aux_sym_list_repeat1,
  [aux_sym_grouping_repeat1] = aux_sym_grouping_repeat1,
  [aux_sym_named_node_repeat1] = aux_sym_named_node_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__string_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__immediate_identifier_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [sym_predicate_type] = {
    .visible = true,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__definition] = {
    .visible = false,
    .named = true,
  },
  [sym__group_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__named_node_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__string] = {
    .visible = false,
    .named = true,
  },
  [sym_quantifier] = {
    .visible = true,
    .named = true,
  },
  [sym__immediate_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym__node_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_capture] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_grouping] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_node] = {
    .visible = true,
    .named = true,
  },
  [sym_named_node] = {
    .visible = true,
    .named = true,
  },
  [sym__field_name] = {
    .visible = false,
    .named = true,
  },
  [sym_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_negated_field] = {
    .visible = true,
    .named = true,
  },
  [sym_predicate] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_grouping_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_node_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_name = 1,
  field_parameters = 2,
  field_quantifier = 3,
  field_supertype = 4,
  field_type = 5,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_name] = "name",
  [field_parameters] = "parameters",
  [field_quantifier] = "quantifier",
  [field_supertype] = "supertype",
  [field_type] = "type",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 2},
  [4] = {.index = 1, .length = 2},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 1},
  [7] = {.index = 5, .length = 1},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 8, .length = 2},
  [10] = {.index = 10, .length = 2},
  [11] = {.index = 12, .length = 3},
  [12] = {.index = 15, .length = 4},
  [13] = {.index = 19, .length = 2},
  [14] = {.index = 21, .length = 3},
  [15] = {.index = 24, .length = 2},
  [16] = {.index = 26, .length = 3},
  [17] = {.index = 29, .length = 2},
  [18] = {.index = 31, .length = 3},
  [19] = {.index = 34, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0},
  [1] =
    {field_name, 0},
    {field_quantifier, 1},
  [3] =
    {field_name, 1},
  [4] =
    {field_quantifier, 2},
  [5] =
    {field_quantifier, 3},
  [6] =
    {field_name, 1},
    {field_quantifier, 3},
  [8] =
    {field_name, 3},
    {field_supertype, 1},
  [10] =
    {field_name, 1},
    {field_quantifier, 4},
  [12] =
    {field_name, 3},
    {field_quantifier, 5},
    {field_supertype, 1},
  [15] =
    {field_name, 1},
    {field_name, 2},
    {field_parameters, 4},
    {field_type, 3},
  [19] =
    {field_name, 1},
    {field_quantifier, 5},
  [21] =
    {field_name, 3},
    {field_quantifier, 6},
    {field_supertype, 1},
  [24] =
    {field_name, 1},
    {field_quantifier, 6},
  [26] =
    {field_name, 3},
    {field_quantifier, 7},
    {field_supertype, 1},
  [29] =
    {field_name, 1},
    {field_quantifier, 7},
  [31] =
    {field_name, 3},
    {field_quantifier, 8},
    {field_supertype, 1},
  [34] =
    {field_name, 3},
    {field_quantifier, 9},
    {field_supertype, 1},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [2] = {
    [0] = sym_identifier,
  },
  [4] = {
    [0] = sym_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__string, 2,
    sym__string,
    sym_identifier,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 2,
  [5] = 3,
  [6] = 2,
  [7] = 3,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 8,
  [12] = 12,
  [13] = 12,
  [14] = 14,
  [15] = 14,
  [16] = 10,
  [17] = 17,
  [18] = 17,
  [19] = 8,
  [20] = 14,
  [21] = 17,
  [22] = 10,
  [23] = 12,
  [24] = 24,
  [25] = 25,
  [26] = 25,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 28,
  [31] = 27,
  [32] = 29,
  [33] = 29,
  [34] = 28,
  [35] = 35,
  [36] = 35,
  [37] = 25,
  [38] = 24,
  [39] = 39,
  [40] = 40,
  [41] = 40,
  [42] = 24,
  [43] = 35,
  [44] = 39,
  [45] = 40,
  [46] = 39,
  [47] = 27,
  [48] = 48,
  [49] = 48,
  [50] = 50,
  [51] = 48,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 55,
  [58] = 53,
  [59] = 59,
  [60] = 53,
  [61] = 59,
  [62] = 59,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 80,
  [82] = 80,
  [83] = 72,
  [84] = 74,
  [85] = 76,
  [86] = 77,
  [87] = 69,
  [88] = 79,
  [89] = 66,
  [90] = 68,
  [91] = 64,
  [92] = 65,
  [93] = 73,
  [94] = 67,
  [95] = 64,
  [96] = 69,
  [97] = 67,
  [98] = 66,
  [99] = 70,
  [100] = 78,
  [101] = 78,
  [102] = 68,
  [103] = 71,
  [104] = 72,
  [105] = 79,
  [106] = 63,
  [107] = 76,
  [108] = 71,
  [109] = 74,
  [110] = 70,
  [111] = 63,
  [112] = 73,
  [113] = 77,
  [114] = 65,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 116,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 115,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 115,
  [171] = 171,
  [172] = 171,
  [173] = 169,
  [174] = 169,
  [175] = 175,
  [176] = 116,
  [177] = 171,
  [178] = 122,
  [179] = 138,
  [180] = 120,
  [181] = 119,
  [182] = 142,
  [183] = 118,
  [184] = 146,
  [185] = 138,
  [186] = 134,
  [187] = 128,
  [188] = 127,
  [189] = 126,
  [190] = 121,
  [191] = 148,
  [192] = 129,
  [193] = 135,
  [194] = 131,
  [195] = 149,
  [196] = 151,
  [197] = 117,
  [198] = 154,
  [199] = 158,
  [200] = 160,
  [201] = 162,
  [202] = 163,
  [203] = 165,
  [204] = 167,
  [205] = 166,
  [206] = 206,
  [207] = 150,
  [208] = 123,
  [209] = 124,
  [210] = 125,
  [211] = 164,
  [212] = 132,
  [213] = 213,
  [214] = 133,
  [215] = 136,
  [216] = 137,
  [217] = 140,
  [218] = 141,
  [219] = 143,
  [220] = 144,
  [221] = 145,
  [222] = 147,
  [223] = 152,
  [224] = 153,
  [225] = 155,
  [226] = 156,
  [227] = 157,
  [228] = 159,
  [229] = 161,
  [230] = 159,
  [231] = 161,
  [232] = 164,
  [233] = 150,
  [234] = 142,
  [235] = 157,
  [236] = 166,
  [237] = 167,
  [238] = 165,
  [239] = 163,
  [240] = 162,
  [241] = 160,
  [242] = 158,
  [243] = 156,
  [244] = 154,
  [245] = 117,
  [246] = 151,
  [247] = 149,
  [248] = 131,
  [249] = 135,
  [250] = 129,
  [251] = 148,
  [252] = 121,
  [253] = 126,
  [254] = 127,
  [255] = 128,
  [256] = 134,
  [257] = 155,
  [258] = 122,
  [259] = 146,
  [260] = 118,
  [261] = 153,
  [262] = 119,
  [263] = 120,
  [264] = 152,
  [265] = 147,
  [266] = 123,
  [267] = 124,
  [268] = 145,
  [269] = 125,
  [270] = 144,
  [271] = 143,
  [272] = 141,
  [273] = 140,
  [274] = 137,
  [275] = 136,
  [276] = 133,
  [277] = 132,
  [278] = 213,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 281,
  [286] = 283,
  [287] = 287,
  [288] = 284,
  [289] = 289,
  [290] = 290,
  [291] = 287,
  [292] = 279,
  [293] = 282,
  [294] = 284,
  [295] = 281,
  [296] = 283,
  [297] = 282,
  [298] = 287,
  [299] = 299,
  [300] = 279,
  [301] = 301,
  [302] = 206,
  [303] = 206,
  [304] = 213,
  [305] = 305,
  [306] = 306,
  [307] = 299,
  [308] = 299,
  [309] = 301,
  [310] = 301,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 313,
  [315] = 313,
  [316] = 316,
  [317] = 317,
  [318] = 316,
  [319] = 316,
  [320] = 320,
  [321] = 320,
  [322] = 322,
  [323] = 322,
  [324] = 324,
  [325] = 324,
  [326] = 320,
  [327] = 322,
  [328] = 324,
  [329] = 329,
  [330] = 329,
  [331] = 331,
  [332] = 332,
  [333] = 331,
  [334] = 334,
  [335] = 331,
  [336] = 329,
  [337] = 337,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(16);
      ADVANCE_MAP(
        '!', 39,
        '"', 18,
        '#', 40,
        '(', 35,
        ')', 36,
        '*', 25,
        '+', 26,
        '.', 17,
        '/', 37,
        ':', 38,
        ';', 32,
        '?', 27,
        '@', 31,
        '[', 33,
        '\\', 7,
        ']', 34,
        '_', 30,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(14);
      if (lookahead == '$' ||
          ('-' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '!', 39,
        '"', 18,
        '(', 35,
        ')', 36,
        '*', 25,
        '+', 26,
        '.', 17,
        '/', 37,
        ':', 38,
        ';', 32,
        '?', 27,
        '@', 31,
        '[', 33,
        '_', 30,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(2);
      if (lookahead == '$' ||
          ('-' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '!', 39,
        '"', 18,
        '(', 35,
        ')', 36,
        '*', 25,
        '+', 26,
        '.', 17,
        ':', 38,
        ';', 32,
        '?', 27,
        '@', 31,
        '[', 33,
        '_', 30,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(2);
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(18);
      if (lookahead == ';') ADVANCE(19);
      if (lookahead == '\\') ADVANCE(7);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(20);
      if (lookahead != 0) ADVANCE(21);
      END_STATE();
    case 4:
      if (lookahead == ';') ADVANCE(32);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(41);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(29);
      END_STATE();
    case 5:
      if (lookahead == ';') ADVANCE(32);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5);
      END_STATE();
    case 6:
      if (lookahead == ';') ADVANCE(32);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(6);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      END_STATE();
    case 7:
      if (lookahead == 'u') ADVANCE(8);
      if (lookahead == 'x') ADVANCE(13);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(24);
      if (lookahead != 0) ADVANCE(22);
      END_STATE();
    case 8:
      if (lookahead == '{') ADVANCE(12);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(10);
      END_STATE();
    case 9:
      if (lookahead == '}') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(9);
      END_STATE();
    case 10:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(13);
      END_STATE();
    case 11:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(22);
      END_STATE();
    case 12:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(9);
      END_STATE();
    case 13:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(11);
      END_STATE();
    case 14:
      if (eof) ADVANCE(16);
      ADVANCE_MAP(
        '!', 39,
        '"', 18,
        '#', 40,
        '(', 35,
        ')', 36,
        '*', 25,
        '+', 26,
        '.', 17,
        ':', 38,
        ';', 32,
        '?', 27,
        '@', 31,
        '[', 33,
        ']', 34,
        '_', 30,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(14);
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      END_STATE();
    case 15:
      if (eof) ADVANCE(16);
      ADVANCE_MAP(
        '!', 39,
        '"', 18,
        '#', 40,
        '(', 35,
        ')', 36,
        '*', 25,
        '+', 26,
        ';', 32,
        '?', 27,
        '@', 31,
        '[', 33,
        ']', 34,
        '_', 30,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(15);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(aux_sym__string_token1);
      if (lookahead == '\n') ADVANCE(21);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(19);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(aux_sym__string_token1);
      if (lookahead == ';') ADVANCE(19);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(20);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(21);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(aux_sym__string_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(21);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(22);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(23);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(aux_sym__immediate_identifier_token1);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(29);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '$' ||
          lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(32);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(sym_predicate_type);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 15},
  [2] = {.lex_state = 1},
  [3] = {.lex_state = 1},
  [4] = {.lex_state = 1},
  [5] = {.lex_state = 1},
  [6] = {.lex_state = 1},
  [7] = {.lex_state = 1},
  [8] = {.lex_state = 15},
  [9] = {.lex_state = 15},
  [10] = {.lex_state = 15},
  [11] = {.lex_state = 15},
  [12] = {.lex_state = 15},
  [13] = {.lex_state = 15},
  [14] = {.lex_state = 15},
  [15] = {.lex_state = 15},
  [16] = {.lex_state = 15},
  [17] = {.lex_state = 15},
  [18] = {.lex_state = 15},
  [19] = {.lex_state = 15},
  [20] = {.lex_state = 15},
  [21] = {.lex_state = 15},
  [22] = {.lex_state = 15},
  [23] = {.lex_state = 15},
  [24] = {.lex_state = 15},
  [25] = {.lex_state = 15},
  [26] = {.lex_state = 15},
  [27] = {.lex_state = 15},
  [28] = {.lex_state = 15},
  [29] = {.lex_state = 15},
  [30] = {.lex_state = 15},
  [31] = {.lex_state = 15},
  [32] = {.lex_state = 15},
  [33] = {.lex_state = 15},
  [34] = {.lex_state = 15},
  [35] = {.lex_state = 15},
  [36] = {.lex_state = 15},
  [37] = {.lex_state = 15},
  [38] = {.lex_state = 15},
  [39] = {.lex_state = 15},
  [40] = {.lex_state = 15},
  [41] = {.lex_state = 15},
  [42] = {.lex_state = 15},
  [43] = {.lex_state = 15},
  [44] = {.lex_state = 15},
  [45] = {.lex_state = 15},
  [46] = {.lex_state = 15},
  [47] = {.lex_state = 15},
  [48] = {.lex_state = 15},
  [49] = {.lex_state = 15},
  [50] = {.lex_state = 15},
  [51] = {.lex_state = 15},
  [52] = {.lex_state = 15},
  [53] = {.lex_state = 15},
  [54] = {.lex_state = 15},
  [55] = {.lex_state = 15},
  [56] = {.lex_state = 15},
  [57] = {.lex_state = 15},
  [58] = {.lex_state = 15},
  [59] = {.lex_state = 15},
  [60] = {.lex_state = 15},
  [61] = {.lex_state = 15},
  [62] = {.lex_state = 15},
  [63] = {.lex_state = 1},
  [64] = {.lex_state = 1},
  [65] = {.lex_state = 1},
  [66] = {.lex_state = 1},
  [67] = {.lex_state = 1},
  [68] = {.lex_state = 1},
  [69] = {.lex_state = 1},
  [70] = {.lex_state = 1},
  [71] = {.lex_state = 1},
  [72] = {.lex_state = 1},
  [73] = {.lex_state = 1},
  [74] = {.lex_state = 1},
  [75] = {.lex_state = 1},
  [76] = {.lex_state = 1},
  [77] = {.lex_state = 1},
  [78] = {.lex_state = 1},
  [79] = {.lex_state = 1},
  [80] = {.lex_state = 15},
  [81] = {.lex_state = 15},
  [82] = {.lex_state = 15},
  [83] = {.lex_state = 15},
  [84] = {.lex_state = 15},
  [85] = {.lex_state = 15},
  [86] = {.lex_state = 15},
  [87] = {.lex_state = 15},
  [88] = {.lex_state = 15},
  [89] = {.lex_state = 15},
  [90] = {.lex_state = 15},
  [91] = {.lex_state = 15},
  [92] = {.lex_state = 15},
  [93] = {.lex_state = 15},
  [94] = {.lex_state = 15},
  [95] = {.lex_state = 15},
  [96] = {.lex_state = 15},
  [97] = {.lex_state = 15},
  [98] = {.lex_state = 15},
  [99] = {.lex_state = 15},
  [100] = {.lex_state = 15},
  [101] = {.lex_state = 15},
  [102] = {.lex_state = 15},
  [103] = {.lex_state = 15},
  [104] = {.lex_state = 15},
  [105] = {.lex_state = 15},
  [106] = {.lex_state = 15},
  [107] = {.lex_state = 15},
  [108] = {.lex_state = 15},
  [109] = {.lex_state = 15},
  [110] = {.lex_state = 15},
  [111] = {.lex_state = 15},
  [112] = {.lex_state = 15},
  [113] = {.lex_state = 15},
  [114] = {.lex_state = 15},
  [115] = {.lex_state = 1},
  [116] = {.lex_state = 1},
  [117] = {.lex_state = 1},
  [118] = {.lex_state = 1},
  [119] = {.lex_state = 1},
  [120] = {.lex_state = 1},
  [121] = {.lex_state = 1},
  [122] = {.lex_state = 1},
  [123] = {.lex_state = 1},
  [124] = {.lex_state = 1},
  [125] = {.lex_state = 1},
  [126] = {.lex_state = 1},
  [127] = {.lex_state = 1},
  [128] = {.lex_state = 1},
  [129] = {.lex_state = 1},
  [130] = {.lex_state = 15},
  [131] = {.lex_state = 1},
  [132] = {.lex_state = 1},
  [133] = {.lex_state = 1},
  [134] = {.lex_state = 1},
  [135] = {.lex_state = 1},
  [136] = {.lex_state = 1},
  [137] = {.lex_state = 1},
  [138] = {.lex_state = 1},
  [139] = {.lex_state = 15},
  [140] = {.lex_state = 1},
  [141] = {.lex_state = 1},
  [142] = {.lex_state = 1},
  [143] = {.lex_state = 1},
  [144] = {.lex_state = 1},
  [145] = {.lex_state = 1},
  [146] = {.lex_state = 1},
  [147] = {.lex_state = 1},
  [148] = {.lex_state = 1},
  [149] = {.lex_state = 1},
  [150] = {.lex_state = 1},
  [151] = {.lex_state = 1},
  [152] = {.lex_state = 1},
  [153] = {.lex_state = 1},
  [154] = {.lex_state = 1},
  [155] = {.lex_state = 1},
  [156] = {.lex_state = 1},
  [157] = {.lex_state = 1},
  [158] = {.lex_state = 1},
  [159] = {.lex_state = 1},
  [160] = {.lex_state = 1},
  [161] = {.lex_state = 1},
  [162] = {.lex_state = 1},
  [163] = {.lex_state = 1},
  [164] = {.lex_state = 1},
  [165] = {.lex_state = 1},
  [166] = {.lex_state = 1},
  [167] = {.lex_state = 1},
  [168] = {.lex_state = 15},
  [169] = {.lex_state = 15},
  [170] = {.lex_state = 15},
  [171] = {.lex_state = 1},
  [172] = {.lex_state = 1},
  [173] = {.lex_state = 15},
  [174] = {.lex_state = 15},
  [175] = {.lex_state = 15},
  [176] = {.lex_state = 15},
  [177] = {.lex_state = 1},
  [178] = {.lex_state = 15},
  [179] = {.lex_state = 15},
  [180] = {.lex_state = 15},
  [181] = {.lex_state = 15},
  [182] = {.lex_state = 15},
  [183] = {.lex_state = 15},
  [184] = {.lex_state = 15},
  [185] = {.lex_state = 15},
  [186] = {.lex_state = 15},
  [187] = {.lex_state = 15},
  [188] = {.lex_state = 15},
  [189] = {.lex_state = 15},
  [190] = {.lex_state = 15},
  [191] = {.lex_state = 15},
  [192] = {.lex_state = 15},
  [193] = {.lex_state = 15},
  [194] = {.lex_state = 15},
  [195] = {.lex_state = 15},
  [196] = {.lex_state = 15},
  [197] = {.lex_state = 15},
  [198] = {.lex_state = 15},
  [199] = {.lex_state = 15},
  [200] = {.lex_state = 15},
  [201] = {.lex_state = 15},
  [202] = {.lex_state = 15},
  [203] = {.lex_state = 15},
  [204] = {.lex_state = 15},
  [205] = {.lex_state = 15},
  [206] = {.lex_state = 1},
  [207] = {.lex_state = 15},
  [208] = {.lex_state = 15},
  [209] = {.lex_state = 15},
  [210] = {.lex_state = 15},
  [211] = {.lex_state = 15},
  [212] = {.lex_state = 15},
  [213] = {.lex_state = 1},
  [214] = {.lex_state = 15},
  [215] = {.lex_state = 15},
  [216] = {.lex_state = 15},
  [217] = {.lex_state = 15},
  [218] = {.lex_state = 15},
  [219] = {.lex_state = 15},
  [220] = {.lex_state = 15},
  [221] = {.lex_state = 15},
  [222] = {.lex_state = 15},
  [223] = {.lex_state = 15},
  [224] = {.lex_state = 15},
  [225] = {.lex_state = 15},
  [226] = {.lex_state = 15},
  [227] = {.lex_state = 15},
  [228] = {.lex_state = 15},
  [229] = {.lex_state = 15},
  [230] = {.lex_state = 15},
  [231] = {.lex_state = 15},
  [232] = {.lex_state = 15},
  [233] = {.lex_state = 15},
  [234] = {.lex_state = 15},
  [235] = {.lex_state = 15},
  [236] = {.lex_state = 15},
  [237] = {.lex_state = 15},
  [238] = {.lex_state = 15},
  [239] = {.lex_state = 15},
  [240] = {.lex_state = 15},
  [241] = {.lex_state = 15},
  [242] = {.lex_state = 15},
  [243] = {.lex_state = 15},
  [244] = {.lex_state = 15},
  [245] = {.lex_state = 15},
  [246] = {.lex_state = 15},
  [247] = {.lex_state = 15},
  [248] = {.lex_state = 15},
  [249] = {.lex_state = 15},
  [250] = {.lex_state = 15},
  [251] = {.lex_state = 15},
  [252] = {.lex_state = 15},
  [253] = {.lex_state = 15},
  [254] = {.lex_state = 15},
  [255] = {.lex_state = 15},
  [256] = {.lex_state = 15},
  [257] = {.lex_state = 15},
  [258] = {.lex_state = 15},
  [259] = {.lex_state = 15},
  [260] = {.lex_state = 15},
  [261] = {.lex_state = 15},
  [262] = {.lex_state = 15},
  [263] = {.lex_state = 15},
  [264] = {.lex_state = 15},
  [265] = {.lex_state = 15},
  [266] = {.lex_state = 15},
  [267] = {.lex_state = 15},
  [268] = {.lex_state = 15},
  [269] = {.lex_state = 15},
  [270] = {.lex_state = 15},
  [271] = {.lex_state = 15},
  [272] = {.lex_state = 15},
  [273] = {.lex_state = 15},
  [274] = {.lex_state = 15},
  [275] = {.lex_state = 15},
  [276] = {.lex_state = 15},
  [277] = {.lex_state = 15},
  [278] = {.lex_state = 15},
  [279] = {.lex_state = 1},
  [280] = {.lex_state = 1},
  [281] = {.lex_state = 1},
  [282] = {.lex_state = 1},
  [283] = {.lex_state = 1},
  [284] = {.lex_state = 1},
  [285] = {.lex_state = 1},
  [286] = {.lex_state = 1},
  [287] = {.lex_state = 1},
  [288] = {.lex_state = 1},
  [289] = {.lex_state = 1},
  [290] = {.lex_state = 1},
  [291] = {.lex_state = 1},
  [292] = {.lex_state = 1},
  [293] = {.lex_state = 1},
  [294] = {.lex_state = 1},
  [295] = {.lex_state = 1},
  [296] = {.lex_state = 1},
  [297] = {.lex_state = 1},
  [298] = {.lex_state = 1},
  [299] = {.lex_state = 1},
  [300] = {.lex_state = 1},
  [301] = {.lex_state = 1},
  [302] = {.lex_state = 15},
  [303] = {.lex_state = 15},
  [304] = {.lex_state = 15},
  [305] = {.lex_state = 0},
  [306] = {.lex_state = 0},
  [307] = {.lex_state = 15},
  [308] = {.lex_state = 15},
  [309] = {.lex_state = 15},
  [310] = {.lex_state = 15},
  [311] = {.lex_state = 15},
  [312] = {.lex_state = 15},
  [313] = {.lex_state = 3},
  [314] = {.lex_state = 3},
  [315] = {.lex_state = 3},
  [316] = {.lex_state = 3},
  [317] = {.lex_state = 3},
  [318] = {.lex_state = 3},
  [319] = {.lex_state = 3},
  [320] = {.lex_state = 4},
  [321] = {.lex_state = 4},
  [322] = {.lex_state = 4},
  [323] = {.lex_state = 4},
  [324] = {.lex_state = 4},
  [325] = {.lex_state = 4},
  [326] = {.lex_state = 4},
  [327] = {.lex_state = 4},
  [328] = {.lex_state = 4},
  [329] = {.lex_state = 0},
  [330] = {.lex_state = 0},
  [331] = {.lex_state = 4},
  [332] = {.lex_state = 0},
  [333] = {.lex_state = 4},
  [334] = {.lex_state = 0},
  [335] = {.lex_state = 4},
  [336] = {.lex_state = 0},
  [337] = {.lex_state = 6},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [sym_predicate_type] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(332),
    [sym__definition] = STATE(54),
    [sym__string] = STATE(103),
    [sym_list] = STATE(54),
    [sym_grouping] = STATE(54),
    [sym_anonymous_node] = STATE(54),
    [sym_named_node] = STATE(54),
    [sym__field_name] = STATE(80),
    [sym_field_definition] = STATE(54),
    [sym_predicate] = STATE(54),
    [aux_sym_program_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [anon_sym__] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_DOT,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(27), 1,
      anon_sym_RPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    STATE(13), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(295), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [48] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(31), 1,
      anon_sym_DOT,
    ACTIONS(33), 1,
      anon_sym_RPAREN,
    STATE(22), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(287), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [96] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(35), 1,
      anon_sym_DOT,
    ACTIONS(37), 1,
      anon_sym_RPAREN,
    STATE(12), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(285), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [144] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(39), 1,
      anon_sym_DOT,
    ACTIONS(41), 1,
      anon_sym_RPAREN,
    STATE(16), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(291), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [192] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(43), 1,
      anon_sym_DOT,
    ACTIONS(45), 1,
      anon_sym_RPAREN,
    STATE(23), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(281), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [240] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(47), 1,
      anon_sym_DOT,
    ACTIONS(49), 1,
      anon_sym_RPAREN,
    STATE(10), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(298), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [288] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_RPAREN,
    STATE(9), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(294), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [333] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_DQUOTE,
    ACTIONS(56), 1,
      sym_identifier,
    ACTIONS(59), 1,
      anon_sym__,
    ACTIONS(62), 1,
      anon_sym_LBRACK,
    ACTIONS(65), 1,
      anon_sym_LPAREN,
    ACTIONS(68), 1,
      anon_sym_RPAREN,
    ACTIONS(70), 1,
      anon_sym_BANG,
    STATE(9), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(290), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [378] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(73), 1,
      anon_sym_RPAREN,
    STATE(9), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(296), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [423] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(75), 1,
      anon_sym_RPAREN,
    STATE(9), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(288), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [468] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(77), 1,
      anon_sym_RPAREN,
    STATE(9), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(282), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [513] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(79), 1,
      anon_sym_RPAREN,
    STATE(9), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(293), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [558] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(81), 1,
      anon_sym_RPAREN,
    STATE(9), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(300), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [603] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(83), 1,
      anon_sym_RPAREN,
    STATE(9), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(292), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [648] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(85), 1,
      anon_sym_RPAREN,
    STATE(9), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(283), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [693] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(87), 1,
      sym_identifier,
    ACTIONS(89), 1,
      anon_sym__,
    ACTIONS(91), 1,
      anon_sym_RPAREN,
    ACTIONS(93), 1,
      anon_sym_POUND,
    STATE(5), 1,
      sym__node_identifier,
    STATE(51), 1,
      aux_sym_grouping_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(306), 8,
      sym__definition,
      sym__group_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [740] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(89), 1,
      anon_sym__,
    ACTIONS(95), 1,
      sym_identifier,
    ACTIONS(97), 1,
      anon_sym_RPAREN,
    ACTIONS(99), 1,
      anon_sym_POUND,
    STATE(3), 1,
      sym__node_identifier,
    STATE(49), 1,
      aux_sym_grouping_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(306), 8,
      sym__definition,
      sym__group_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [787] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(101), 1,
      anon_sym_RPAREN,
    STATE(9), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(284), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [832] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(103), 1,
      anon_sym_RPAREN,
    STATE(9), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(279), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [877] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(89), 1,
      anon_sym__,
    ACTIONS(105), 1,
      sym_identifier,
    ACTIONS(107), 1,
      anon_sym_RPAREN,
    ACTIONS(109), 1,
      anon_sym_POUND,
    STATE(7), 1,
      sym__node_identifier,
    STATE(48), 1,
      aux_sym_grouping_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(306), 8,
      sym__definition,
      sym__group_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [924] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(111), 1,
      anon_sym_RPAREN,
    STATE(9), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(286), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [969] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(113), 1,
      anon_sym_RPAREN,
    STATE(9), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(297), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1014] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(289), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1056] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(115), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(289), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1098] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(117), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(289), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1140] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(119), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(289), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1182] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(83), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(289), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1224] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(121), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(289), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1266] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(81), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(289), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1308] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(123), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(289), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1350] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(125), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(289), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1392] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(127), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(289), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1434] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(103), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(289), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1476] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(129), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(289), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1518] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(131), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(289), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1560] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(133), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(289), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1602] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(101), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(289), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1644] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    STATE(19), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(286), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1686] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    STATE(14), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(297), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1728] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    STATE(20), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(282), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1770] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(75), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(289), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1812] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(135), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(289), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1854] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    STATE(11), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(283), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1896] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    STATE(15), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(293), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1938] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    STATE(8), 1,
      aux_sym_named_node_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(296), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [1980] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    ACTIONS(137), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(289), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [2022] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(139), 1,
      anon_sym_RPAREN,
    STATE(50), 1,
      aux_sym_grouping_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(306), 8,
      sym__definition,
      sym__group_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [2063] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_RPAREN,
    STATE(50), 1,
      aux_sym_grouping_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(306), 8,
      sym__definition,
      sym__group_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [2104] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      sym_identifier,
    ACTIONS(149), 1,
      anon_sym__,
    ACTIONS(152), 1,
      anon_sym_LBRACK,
    ACTIONS(155), 1,
      anon_sym_LPAREN,
    ACTIONS(158), 1,
      anon_sym_RPAREN,
    STATE(50), 1,
      aux_sym_grouping_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(306), 8,
      sym__definition,
      sym__group_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [2145] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(160), 1,
      anon_sym_RPAREN,
    STATE(50), 1,
      aux_sym_grouping_repeat1,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(306), 8,
      sym__definition,
      sym__group_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [2186] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      anon_sym_BANG,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(289), 9,
      sym__definition,
      sym__named_node_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_negated_field,
      sym_predicate,
  [2225] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(162), 1,
      anon_sym_DQUOTE,
    ACTIONS(164), 1,
      anon_sym__,
    ACTIONS(166), 1,
      anon_sym_LBRACK,
    ACTIONS(168), 1,
      anon_sym_RBRACK,
    ACTIONS(170), 1,
      anon_sym_LPAREN,
    STATE(81), 1,
      sym__field_name,
    STATE(108), 1,
      sym__string,
    STATE(61), 8,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
      aux_sym_program_repeat1,
  [2263] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_DQUOTE,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(11), 1,
      anon_sym__,
    ACTIONS(13), 1,
      anon_sym_LBRACK,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(172), 1,
      ts_builtin_sym_end,
    STATE(80), 1,
      sym__field_name,
    STATE(103), 1,
      sym__string,
    STATE(55), 8,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
      aux_sym_program_repeat1,
  [2301] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      ts_builtin_sym_end,
    ACTIONS(176), 1,
      anon_sym_DQUOTE,
    ACTIONS(179), 1,
      sym_identifier,
    ACTIONS(182), 1,
      anon_sym__,
    ACTIONS(185), 1,
      anon_sym_LBRACK,
    ACTIONS(188), 1,
      anon_sym_LPAREN,
    STATE(80), 1,
      sym__field_name,
    STATE(103), 1,
      sym__string,
    STATE(55), 8,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
      aux_sym_program_repeat1,
  [2339] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    ACTIONS(158), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(305), 8,
      sym__definition,
      sym__group_expression,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [2377] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(174), 1,
      anon_sym_RBRACK,
    ACTIONS(179), 1,
      sym_identifier,
    ACTIONS(191), 1,
      anon_sym_DQUOTE,
    ACTIONS(194), 1,
      anon_sym__,
    ACTIONS(197), 1,
      anon_sym_LBRACK,
    ACTIONS(200), 1,
      anon_sym_LPAREN,
    STATE(81), 1,
      sym__field_name,
    STATE(108), 1,
      sym__string,
    STATE(57), 8,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
      aux_sym_program_repeat1,
  [2415] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(162), 1,
      anon_sym_DQUOTE,
    ACTIONS(164), 1,
      anon_sym__,
    ACTIONS(166), 1,
      anon_sym_LBRACK,
    ACTIONS(170), 1,
      anon_sym_LPAREN,
    ACTIONS(203), 1,
      anon_sym_RBRACK,
    STATE(81), 1,
      sym__field_name,
    STATE(108), 1,
      sym__string,
    STATE(62), 8,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
      aux_sym_program_repeat1,
  [2453] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(162), 1,
      anon_sym_DQUOTE,
    ACTIONS(164), 1,
      anon_sym__,
    ACTIONS(166), 1,
      anon_sym_LBRACK,
    ACTIONS(170), 1,
      anon_sym_LPAREN,
    ACTIONS(205), 1,
      anon_sym_RBRACK,
    STATE(81), 1,
      sym__field_name,
    STATE(108), 1,
      sym__string,
    STATE(57), 8,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
      aux_sym_program_repeat1,
  [2491] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(162), 1,
      anon_sym_DQUOTE,
    ACTIONS(164), 1,
      anon_sym__,
    ACTIONS(166), 1,
      anon_sym_LBRACK,
    ACTIONS(170), 1,
      anon_sym_LPAREN,
    ACTIONS(207), 1,
      anon_sym_RBRACK,
    STATE(81), 1,
      sym__field_name,
    STATE(108), 1,
      sym__string,
    STATE(59), 8,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
      aux_sym_program_repeat1,
  [2529] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(162), 1,
      anon_sym_DQUOTE,
    ACTIONS(164), 1,
      anon_sym__,
    ACTIONS(166), 1,
      anon_sym_LBRACK,
    ACTIONS(170), 1,
      anon_sym_LPAREN,
    ACTIONS(209), 1,
      anon_sym_RBRACK,
    STATE(81), 1,
      sym__field_name,
    STATE(108), 1,
      sym__string,
    STATE(57), 8,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
      aux_sym_program_repeat1,
  [2567] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(162), 1,
      anon_sym_DQUOTE,
    ACTIONS(164), 1,
      anon_sym__,
    ACTIONS(166), 1,
      anon_sym_LBRACK,
    ACTIONS(170), 1,
      anon_sym_LPAREN,
    ACTIONS(211), 1,
      anon_sym_RBRACK,
    STATE(81), 1,
      sym__field_name,
    STATE(108), 1,
      sym__string,
    STATE(57), 8,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
      aux_sym_program_repeat1,
  [2605] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(156), 1,
      sym_quantifier,
    STATE(155), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(213), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(217), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(215), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2636] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(128), 1,
      sym_quantifier,
    STATE(127), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(217), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(221), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(223), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2667] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(126), 1,
      sym_quantifier,
    STATE(121), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(217), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(225), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(227), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2698] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(136), 1,
      sym_quantifier,
    STATE(133), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(217), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(229), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(231), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2729] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(118), 1,
      sym_quantifier,
    STATE(146), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(217), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(233), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(235), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2760] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(120), 1,
      sym_quantifier,
    STATE(119), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(217), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(237), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(239), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2791] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(129), 1,
      sym_quantifier,
    STATE(135), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(217), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(241), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(243), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2822] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(151), 1,
      sym_quantifier,
    STATE(117), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(217), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(245), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(247), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2853] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(164), 1,
      sym_quantifier,
    STATE(161), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(217), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(249), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(251), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2884] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(124), 1,
      sym_quantifier,
    STATE(123), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(217), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(253), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(255), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2915] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(153), 1,
      sym_quantifier,
    STATE(152), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(217), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(257), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(259), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2946] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(154), 1,
      sym_quantifier,
    STATE(158), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(217), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(261), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(263), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [2977] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(142), 1,
      sym_quantifier,
    STATE(150), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(217), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(265), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(267), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3008] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(142), 1,
      sym_quantifier,
    STATE(150), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(217), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(269), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(271), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3039] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(140), 1,
      sym_quantifier,
    STATE(137), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(217), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(273), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(275), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3070] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(144), 1,
      sym_quantifier,
    STATE(143), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(217), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(277), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(279), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3101] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(165), 1,
      sym_quantifier,
    STATE(167), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(217), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(281), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(283), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [3132] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_DQUOTE,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(11), 1,
      anon_sym__,
    ACTIONS(13), 1,
      anon_sym_LBRACK,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    STATE(80), 1,
      sym__field_name,
    STATE(103), 1,
      sym__string,
    STATE(307), 7,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [3166] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(162), 1,
      anon_sym_DQUOTE,
    ACTIONS(164), 1,
      anon_sym__,
    ACTIONS(166), 1,
      anon_sym_LBRACK,
    ACTIONS(170), 1,
      anon_sym_LPAREN,
    STATE(81), 1,
      sym__field_name,
    STATE(108), 1,
      sym__string,
    STATE(308), 7,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [3200] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(19), 1,
      anon_sym_DQUOTE,
    ACTIONS(21), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LPAREN,
    STATE(71), 1,
      sym__string,
    STATE(82), 1,
      sym__field_name,
    STATE(299), 7,
      sym__definition,
      sym_list,
      sym_grouping,
      sym_anonymous_node,
      sym_named_node,
      sym_field_definition,
      sym_predicate,
  [3234] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    STATE(209), 1,
      sym_quantifier,
    ACTIONS(253), 2,
      sym_identifier,
      anon_sym__,
    STATE(208), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(285), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(255), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [3263] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    STATE(244), 1,
      sym_quantifier,
    ACTIONS(261), 2,
      sym_identifier,
      anon_sym__,
    STATE(242), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(289), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(263), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [3292] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    STATE(182), 1,
      sym_quantifier,
    ACTIONS(269), 2,
      sym_identifier,
      anon_sym__,
    STATE(207), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(289), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(271), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [3321] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    STATE(273), 1,
      sym_quantifier,
    ACTIONS(273), 2,
      sym_identifier,
      anon_sym__,
    STATE(274), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(289), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(275), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [3350] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    STATE(192), 1,
      sym_quantifier,
    ACTIONS(241), 2,
      sym_identifier,
      anon_sym__,
    STATE(193), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(285), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(243), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [3379] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    STATE(203), 1,
      sym_quantifier,
    ACTIONS(281), 2,
      sym_identifier,
      anon_sym__,
    STATE(204), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(285), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(283), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [3408] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    STATE(215), 1,
      sym_quantifier,
    ACTIONS(229), 2,
      sym_identifier,
      anon_sym__,
    STATE(214), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(285), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(231), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [3437] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    STATE(180), 1,
      sym_quantifier,
    ACTIONS(237), 2,
      sym_identifier,
      anon_sym__,
    STATE(181), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(285), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(239), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [3466] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    STATE(255), 1,
      sym_quantifier,
    ACTIONS(221), 2,
      sym_identifier,
      anon_sym__,
    STATE(254), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(289), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(223), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [3495] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    STATE(253), 1,
      sym_quantifier,
    ACTIONS(225), 2,
      sym_identifier,
      anon_sym__,
    STATE(252), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(289), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(227), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [3524] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    STATE(261), 1,
      sym_quantifier,
    ACTIONS(257), 2,
      sym_identifier,
      anon_sym__,
    STATE(264), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(289), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(259), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [3553] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    STATE(183), 1,
      sym_quantifier,
    ACTIONS(233), 2,
      sym_identifier,
      anon_sym__,
    STATE(184), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(285), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(235), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [3582] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    STATE(187), 1,
      sym_quantifier,
    ACTIONS(221), 2,
      sym_identifier,
      anon_sym__,
    STATE(188), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(285), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(223), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [3611] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    STATE(250), 1,
      sym_quantifier,
    ACTIONS(241), 2,
      sym_identifier,
      anon_sym__,
    STATE(249), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(289), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(243), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [3640] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    STATE(260), 1,
      sym_quantifier,
    ACTIONS(233), 2,
      sym_identifier,
      anon_sym__,
    STATE(259), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(289), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(235), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [3669] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    STATE(275), 1,
      sym_quantifier,
    ACTIONS(229), 2,
      sym_identifier,
      anon_sym__,
    STATE(276), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(289), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(231), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [3698] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    STATE(246), 1,
      sym_quantifier,
    ACTIONS(245), 2,
      sym_identifier,
      anon_sym__,
    STATE(245), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(289), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(247), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [3727] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    STATE(220), 1,
      sym_quantifier,
    ACTIONS(277), 2,
      sym_identifier,
      anon_sym__,
    STATE(219), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(285), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(279), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [3756] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    STATE(270), 1,
      sym_quantifier,
    ACTIONS(277), 2,
      sym_identifier,
      anon_sym__,
    STATE(271), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(289), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(279), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [3785] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    STATE(263), 1,
      sym_quantifier,
    ACTIONS(237), 2,
      sym_identifier,
      anon_sym__,
    STATE(262), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(289), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(239), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [3814] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    STATE(211), 1,
      sym_quantifier,
    ACTIONS(249), 2,
      sym_identifier,
      anon_sym__,
    STATE(229), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(289), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(251), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [3843] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    STATE(267), 1,
      sym_quantifier,
    ACTIONS(253), 2,
      sym_identifier,
      anon_sym__,
    STATE(266), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(289), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(255), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [3872] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    STATE(238), 1,
      sym_quantifier,
    ACTIONS(281), 2,
      sym_identifier,
      anon_sym__,
    STATE(237), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(289), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(283), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [3901] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    STATE(243), 1,
      sym_quantifier,
    ACTIONS(213), 2,
      sym_identifier,
      anon_sym__,
    STATE(257), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(289), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(215), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [3930] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    STATE(234), 1,
      sym_quantifier,
    ACTIONS(269), 2,
      sym_identifier,
      anon_sym__,
    STATE(233), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(285), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(271), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [3959] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    STATE(232), 1,
      sym_quantifier,
    ACTIONS(249), 2,
      sym_identifier,
      anon_sym__,
    STATE(231), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(285), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(251), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [3988] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    STATE(198), 1,
      sym_quantifier,
    ACTIONS(261), 2,
      sym_identifier,
      anon_sym__,
    STATE(199), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(285), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(263), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4017] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    STATE(196), 1,
      sym_quantifier,
    ACTIONS(245), 2,
      sym_identifier,
      anon_sym__,
    STATE(197), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(285), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(247), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4046] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    STATE(226), 1,
      sym_quantifier,
    ACTIONS(213), 2,
      sym_identifier,
      anon_sym__,
    STATE(225), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(285), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(215), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4075] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    STATE(224), 1,
      sym_quantifier,
    ACTIONS(257), 2,
      sym_identifier,
      anon_sym__,
    STATE(223), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(285), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(259), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4104] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    STATE(217), 1,
      sym_quantifier,
    ACTIONS(273), 2,
      sym_identifier,
      anon_sym__,
    STATE(216), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(285), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(275), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4133] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    STATE(189), 1,
      sym_quantifier,
    ACTIONS(225), 2,
      sym_identifier,
      anon_sym__,
    STATE(190), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(285), 3,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
    ACTIONS(227), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [4162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(293), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(295), 9,
      anon_sym_DQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(297), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(299), 9,
      anon_sym_DQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4202] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(301), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(303), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4225] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(148), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(305), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(307), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4248] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(221), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(223), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4271] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(134), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(309), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(311), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4294] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(245), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(247), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4317] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(313), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(315), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4340] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(233), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(235), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4363] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(138), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(317), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(319), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4386] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(321), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(323), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4409] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(149), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(325), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(327), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4432] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(241), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(243), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4455] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(131), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(329), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(331), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4478] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(160), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(333), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(335), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(297), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(299), 9,
      anon_sym_DQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [4520] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(337), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(339), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4543] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(341), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(343), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4566] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(345), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(347), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4589] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(349), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(351), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4612] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(261), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(263), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4635] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(122), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(353), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(355), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4658] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(253), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(255), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4681] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(357), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(359), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(293), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(295), 9,
      anon_sym_DQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [4723] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(125), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(361), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(363), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4746] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(365), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(367), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4769] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(159), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(369), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(371), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4792] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(373), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(375), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4815] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(132), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(377), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(379), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4838] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(381), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(383), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4861] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(225), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(227), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4884] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(385), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(387), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4907] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(389), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(391), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4930] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(393), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(395), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4953] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(397), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(399), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4976] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(162), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(401), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(403), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [4999] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(229), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(231), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5022] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(141), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(405), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(407), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5045] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(163), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(409), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(411), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5068] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(277), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(279), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5091] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(145), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(413), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(415), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5114] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(421), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(417), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(419), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5137] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(281), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(283), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5160] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(424), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(426), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5183] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(428), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(430), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5206] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(432), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(434), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5229] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(436), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(438), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5252] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(440), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(442), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5275] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(147), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(444), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(446), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5298] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(166), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(448), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(450), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5321] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(452), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(454), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5344] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 1,
      anon_sym_AT,
    STATE(157), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(456), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(458), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5367] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(162), 1,
      anon_sym_DQUOTE,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(462), 1,
      anon_sym_RPAREN,
    STATE(311), 1,
      sym__string,
    ACTIONS(460), 2,
      sym_identifier,
      anon_sym__,
    STATE(175), 4,
      sym__node_identifier,
      sym_capture,
      sym_string,
      aux_sym_parameters_repeat1,
  [5393] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(162), 1,
      anon_sym_DQUOTE,
    ACTIONS(287), 1,
      anon_sym_AT,
    STATE(311), 1,
      sym__string,
    STATE(329), 1,
      sym_parameters,
    ACTIONS(464), 2,
      sym_identifier,
      anon_sym__,
    STATE(168), 4,
      sym__node_identifier,
      sym_capture,
      sym_string,
      aux_sym_parameters_repeat1,
  [5419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(293), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(295), 8,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5437] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(466), 1,
      anon_sym_SLASH,
    ACTIONS(468), 1,
      anon_sym_COLON,
    ACTIONS(265), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(267), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5459] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(468), 1,
      anon_sym_COLON,
    ACTIONS(470), 1,
      anon_sym_SLASH,
    ACTIONS(265), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(267), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5481] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(162), 1,
      anon_sym_DQUOTE,
    ACTIONS(287), 1,
      anon_sym_AT,
    STATE(311), 1,
      sym__string,
    STATE(330), 1,
      sym_parameters,
    ACTIONS(464), 2,
      sym_identifier,
      anon_sym__,
    STATE(168), 4,
      sym__node_identifier,
      sym_capture,
      sym_string,
      aux_sym_parameters_repeat1,
  [5507] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(162), 1,
      anon_sym_DQUOTE,
    ACTIONS(287), 1,
      anon_sym_AT,
    STATE(311), 1,
      sym__string,
    STATE(336), 1,
      sym_parameters,
    ACTIONS(464), 2,
      sym_identifier,
      anon_sym__,
    STATE(168), 4,
      sym__node_identifier,
      sym_capture,
      sym_string,
      aux_sym_parameters_repeat1,
  [5533] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_DQUOTE,
    ACTIONS(478), 1,
      anon_sym_AT,
    ACTIONS(481), 1,
      anon_sym_RPAREN,
    STATE(311), 1,
      sym__string,
    ACTIONS(475), 2,
      sym_identifier,
      anon_sym__,
    STATE(175), 4,
      sym__node_identifier,
      sym_capture,
      sym_string,
      aux_sym_parameters_repeat1,
  [5559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(297), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(299), 8,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5577] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(468), 1,
      anon_sym_COLON,
    ACTIONS(483), 1,
      anon_sym_SLASH,
    ACTIONS(265), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(267), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [5599] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(313), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(315), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5620] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(357), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(359), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5641] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(309), 2,
      sym_identifier,
      anon_sym__,
    STATE(186), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(311), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [5662] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(221), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(223), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [5683] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(369), 2,
      sym_identifier,
      anon_sym__,
    STATE(230), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(371), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [5704] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(305), 2,
      sym_identifier,
      anon_sym__,
    STATE(191), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(307), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [5725] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(225), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(227), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [5746] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(357), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(359), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [5767] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(349), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(351), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [5788] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(329), 2,
      sym_identifier,
      anon_sym__,
    STATE(194), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(331), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [5809] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(241), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(243), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [5830] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(325), 2,
      sym_identifier,
      anon_sym__,
    STATE(195), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(327), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [5851] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(245), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(247), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [5872] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(389), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(391), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [5893] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(333), 2,
      sym_identifier,
      anon_sym__,
    STATE(200), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(335), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [5914] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(261), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(263), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [5935] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(337), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(339), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [5956] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(393), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(395), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [5977] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(401), 2,
      sym_identifier,
      anon_sym__,
    STATE(201), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(403), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [5998] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(301), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(303), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6019] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(409), 2,
      sym_identifier,
      anon_sym__,
    STATE(202), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(411), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6040] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(281), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(283), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6061] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(428), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(430), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6082] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(436), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(438), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6103] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(440), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(442), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6124] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(448), 2,
      sym_identifier,
      anon_sym__,
    STATE(205), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(450), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6145] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(456), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(458), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6166] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(452), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(454), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(485), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(487), 6,
      anon_sym_DQUOTE,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [6204] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(397), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(399), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [6225] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(233), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(235), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6246] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(317), 2,
      sym_identifier,
      anon_sym__,
    STATE(185), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(319), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6267] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(321), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(323), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6288] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(444), 2,
      sym_identifier,
      anon_sym__,
    STATE(265), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(446), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [6309] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(341), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(343), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(489), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(491), 6,
      anon_sym_DQUOTE,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [6347] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(345), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(347), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6368] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(353), 2,
      sym_identifier,
      anon_sym__,
    STATE(258), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(355), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6389] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(253), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(255), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6410] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(361), 2,
      sym_identifier,
      anon_sym__,
    STATE(210), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(363), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6431] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(365), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(367), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6452] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(373), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(375), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6473] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(377), 2,
      sym_identifier,
      anon_sym__,
    STATE(212), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(379), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6494] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(381), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(383), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6515] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(385), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(387), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6536] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(229), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(231), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6557] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(405), 2,
      sym_identifier,
      anon_sym__,
    STATE(218), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(407), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6578] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(277), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(279), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6599] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(413), 2,
      sym_identifier,
      anon_sym__,
    STATE(221), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(415), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6620] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(493), 1,
      anon_sym_AT,
    ACTIONS(417), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(419), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6641] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(424), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(426), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6662] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(432), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(434), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [6683] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(424), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(426), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [6704] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(432), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(434), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6725] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(444), 2,
      sym_identifier,
      anon_sym__,
    STATE(222), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(446), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6746] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(397), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(399), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6767] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(369), 2,
      sym_identifier,
      anon_sym__,
    STATE(228), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(371), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [6788] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(496), 1,
      anon_sym_AT,
    ACTIONS(417), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(419), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [6809] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(452), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(454), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [6830] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(456), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(458), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [6851] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(448), 2,
      sym_identifier,
      anon_sym__,
    STATE(236), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(450), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [6872] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(440), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(442), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [6893] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(436), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(438), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [6914] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(428), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(430), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [6935] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(281), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(283), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [6956] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(413), 2,
      sym_identifier,
      anon_sym__,
    STATE(268), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(415), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [6977] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(409), 2,
      sym_identifier,
      anon_sym__,
    STATE(239), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(411), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [6998] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(301), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(303), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7019] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(401), 2,
      sym_identifier,
      anon_sym__,
    STATE(240), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(403), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7040] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(393), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(395), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7061] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(337), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(339), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7082] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(261), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(263), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7103] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(333), 2,
      sym_identifier,
      anon_sym__,
    STATE(241), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(335), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7124] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(389), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(391), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7145] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(245), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(247), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7166] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(325), 2,
      sym_identifier,
      anon_sym__,
    STATE(247), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(327), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7187] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(241), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(243), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7208] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(329), 2,
      sym_identifier,
      anon_sym__,
    STATE(248), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(331), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7229] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(349), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(351), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7250] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(277), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(279), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7271] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_AT,
    ACTIONS(313), 2,
      sym_identifier,
      anon_sym__,
    STATE(227), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(315), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [7292] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(225), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(227), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7313] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(305), 2,
      sym_identifier,
      anon_sym__,
    STATE(251), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(307), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7334] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(405), 2,
      sym_identifier,
      anon_sym__,
    STATE(272), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(407), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7355] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(221), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(223), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7376] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(309), 2,
      sym_identifier,
      anon_sym__,
    STATE(256), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(311), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7397] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(229), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(231), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7418] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(385), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(387), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7439] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(233), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(235), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7460] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(317), 2,
      sym_identifier,
      anon_sym__,
    STATE(179), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(319), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7481] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(381), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(383), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7502] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(321), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(323), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7523] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(377), 2,
      sym_identifier,
      anon_sym__,
    STATE(277), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(379), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7544] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(373), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(375), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7565] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(365), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(367), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7586] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(361), 2,
      sym_identifier,
      anon_sym__,
    STATE(269), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(363), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7607] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(253), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(255), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7628] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(353), 2,
      sym_identifier,
      anon_sym__,
    STATE(178), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(355), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7649] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(345), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(347), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7670] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_AT,
    ACTIONS(341), 2,
      sym_identifier,
      anon_sym__,
    STATE(235), 2,
      sym_capture,
      aux_sym_list_repeat1,
    ACTIONS(343), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [7691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(489), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(491), 6,
      anon_sym_DQUOTE,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [7707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(499), 1,
      anon_sym_DOT,
    ACTIONS(503), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(501), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [7725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(507), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [7741] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 1,
      anon_sym_DOT,
    ACTIONS(503), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(501), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [7759] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(511), 1,
      anon_sym_DOT,
    ACTIONS(503), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(501), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [7777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(513), 1,
      anon_sym_DOT,
    ACTIONS(503), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(501), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [7795] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(515), 1,
      anon_sym_DOT,
    ACTIONS(503), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(501), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [7813] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(517), 1,
      anon_sym_DOT,
    ACTIONS(503), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(501), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [7831] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_DOT,
    ACTIONS(503), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(501), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [7849] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_DOT,
    ACTIONS(503), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(501), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [7867] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      anon_sym_DOT,
    ACTIONS(503), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(501), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [7885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(527), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [7901] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(529), 1,
      anon_sym_DOT,
    ACTIONS(503), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(501), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [7919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(531), 1,
      anon_sym_DOT,
    ACTIONS(503), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(501), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [7937] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 1,
      anon_sym_DOT,
    ACTIONS(503), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(501), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [7955] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(535), 1,
      anon_sym_DOT,
    ACTIONS(503), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(501), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [7973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(537), 1,
      anon_sym_DOT,
    ACTIONS(503), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(501), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [7991] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(539), 1,
      anon_sym_DOT,
    ACTIONS(503), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(501), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [8009] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(541), 1,
      anon_sym_DOT,
    ACTIONS(503), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(501), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [8027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      anon_sym_DOT,
    ACTIONS(503), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(501), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [8045] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(545), 1,
      anon_sym_DOT,
    ACTIONS(503), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(501), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [8063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(547), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(549), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [8079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(551), 1,
      anon_sym_DOT,
    ACTIONS(503), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(501), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [8097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(555), 5,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BANG,
  [8113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(485), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(487), 5,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [8128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(485), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(487), 5,
      anon_sym_DQUOTE,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [8143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(489), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(491), 5,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [8158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 3,
      anon_sym_DOT,
      sym_identifier,
      anon_sym__,
    ACTIONS(559), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [8173] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(561), 1,
      anon_sym_DOT,
    ACTIONS(565), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(563), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [8190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(547), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(549), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [8204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(547), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(549), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [8218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(555), 4,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [8232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(553), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(555), 4,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
  [8246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(569), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(567), 3,
      anon_sym_DQUOTE,
      anon_sym_AT,
      anon_sym_RPAREN,
  [8259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(573), 2,
      sym_identifier,
      anon_sym__,
    ACTIONS(571), 3,
      anon_sym_DQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [8272] = 4,
    ACTIONS(575), 1,
      anon_sym_DQUOTE,
    ACTIONS(579), 1,
      sym_comment,
    STATE(317), 1,
      aux_sym__string_repeat1,
    ACTIONS(577), 2,
      aux_sym__string_token1,
      sym_escape_sequence,
  [8286] = 4,
    ACTIONS(579), 1,
      sym_comment,
    ACTIONS(581), 1,
      anon_sym_DQUOTE,
    STATE(317), 1,
      aux_sym__string_repeat1,
    ACTIONS(577), 2,
      aux_sym__string_token1,
      sym_escape_sequence,
  [8300] = 4,
    ACTIONS(579), 1,
      sym_comment,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    STATE(317), 1,
      aux_sym__string_repeat1,
    ACTIONS(577), 2,
      aux_sym__string_token1,
      sym_escape_sequence,
  [8314] = 4,
    ACTIONS(579), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_DQUOTE,
    STATE(315), 1,
      aux_sym__string_repeat1,
    ACTIONS(587), 2,
      aux_sym__string_token1,
      sym_escape_sequence,
  [8328] = 4,
    ACTIONS(579), 1,
      sym_comment,
    ACTIONS(589), 1,
      anon_sym_DQUOTE,
    STATE(317), 1,
      aux_sym__string_repeat1,
    ACTIONS(591), 2,
      aux_sym__string_token1,
      sym_escape_sequence,
  [8342] = 4,
    ACTIONS(579), 1,
      sym_comment,
    ACTIONS(594), 1,
      anon_sym_DQUOTE,
    STATE(313), 1,
      aux_sym__string_repeat1,
    ACTIONS(596), 2,
      aux_sym__string_token1,
      sym_escape_sequence,
  [8356] = 4,
    ACTIONS(579), 1,
      sym_comment,
    ACTIONS(598), 1,
      anon_sym_DQUOTE,
    STATE(314), 1,
      aux_sym__string_repeat1,
    ACTIONS(600), 2,
      aux_sym__string_token1,
      sym_escape_sequence,
  [8370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(602), 1,
      aux_sym__immediate_identifier_token1,
    STATE(2), 1,
      sym__immediate_identifier,
  [8380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(604), 1,
      aux_sym__immediate_identifier_token1,
    STATE(6), 1,
      sym__immediate_identifier,
  [8390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(606), 1,
      aux_sym__immediate_identifier_token1,
    STATE(304), 1,
      sym__immediate_identifier,
  [8400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(608), 1,
      aux_sym__immediate_identifier_token1,
    STATE(213), 1,
      sym__immediate_identifier,
  [8410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(610), 1,
      aux_sym__immediate_identifier_token1,
    STATE(335), 1,
      sym__immediate_identifier,
  [8420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(612), 1,
      aux_sym__immediate_identifier_token1,
    STATE(333), 1,
      sym__immediate_identifier,
  [8430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(614), 1,
      aux_sym__immediate_identifier_token1,
    STATE(4), 1,
      sym__immediate_identifier,
  [8440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(616), 1,
      aux_sym__immediate_identifier_token1,
    STATE(278), 1,
      sym__immediate_identifier,
  [8450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(618), 1,
      aux_sym__immediate_identifier_token1,
    STATE(331), 1,
      sym__immediate_identifier,
  [8460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(620), 1,
      anon_sym_RPAREN,
  [8467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      anon_sym_RPAREN,
  [8474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(624), 1,
      sym_predicate_type,
  [8481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 1,
      ts_builtin_sym_end,
  [8488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      sym_predicate_type,
  [8495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(468), 1,
      anon_sym_COLON,
  [8502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(630), 1,
      sym_predicate_type,
  [8509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(632), 1,
      anon_sym_RPAREN,
  [8516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(634), 1,
      sym_identifier,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 48,
  [SMALL_STATE(4)] = 96,
  [SMALL_STATE(5)] = 144,
  [SMALL_STATE(6)] = 192,
  [SMALL_STATE(7)] = 240,
  [SMALL_STATE(8)] = 288,
  [SMALL_STATE(9)] = 333,
  [SMALL_STATE(10)] = 378,
  [SMALL_STATE(11)] = 423,
  [SMALL_STATE(12)] = 468,
  [SMALL_STATE(13)] = 513,
  [SMALL_STATE(14)] = 558,
  [SMALL_STATE(15)] = 603,
  [SMALL_STATE(16)] = 648,
  [SMALL_STATE(17)] = 693,
  [SMALL_STATE(18)] = 740,
  [SMALL_STATE(19)] = 787,
  [SMALL_STATE(20)] = 832,
  [SMALL_STATE(21)] = 877,
  [SMALL_STATE(22)] = 924,
  [SMALL_STATE(23)] = 969,
  [SMALL_STATE(24)] = 1014,
  [SMALL_STATE(25)] = 1056,
  [SMALL_STATE(26)] = 1098,
  [SMALL_STATE(27)] = 1140,
  [SMALL_STATE(28)] = 1182,
  [SMALL_STATE(29)] = 1224,
  [SMALL_STATE(30)] = 1266,
  [SMALL_STATE(31)] = 1308,
  [SMALL_STATE(32)] = 1350,
  [SMALL_STATE(33)] = 1392,
  [SMALL_STATE(34)] = 1434,
  [SMALL_STATE(35)] = 1476,
  [SMALL_STATE(36)] = 1518,
  [SMALL_STATE(37)] = 1560,
  [SMALL_STATE(38)] = 1602,
  [SMALL_STATE(39)] = 1644,
  [SMALL_STATE(40)] = 1686,
  [SMALL_STATE(41)] = 1728,
  [SMALL_STATE(42)] = 1770,
  [SMALL_STATE(43)] = 1812,
  [SMALL_STATE(44)] = 1854,
  [SMALL_STATE(45)] = 1896,
  [SMALL_STATE(46)] = 1938,
  [SMALL_STATE(47)] = 1980,
  [SMALL_STATE(48)] = 2022,
  [SMALL_STATE(49)] = 2063,
  [SMALL_STATE(50)] = 2104,
  [SMALL_STATE(51)] = 2145,
  [SMALL_STATE(52)] = 2186,
  [SMALL_STATE(53)] = 2225,
  [SMALL_STATE(54)] = 2263,
  [SMALL_STATE(55)] = 2301,
  [SMALL_STATE(56)] = 2339,
  [SMALL_STATE(57)] = 2377,
  [SMALL_STATE(58)] = 2415,
  [SMALL_STATE(59)] = 2453,
  [SMALL_STATE(60)] = 2491,
  [SMALL_STATE(61)] = 2529,
  [SMALL_STATE(62)] = 2567,
  [SMALL_STATE(63)] = 2605,
  [SMALL_STATE(64)] = 2636,
  [SMALL_STATE(65)] = 2667,
  [SMALL_STATE(66)] = 2698,
  [SMALL_STATE(67)] = 2729,
  [SMALL_STATE(68)] = 2760,
  [SMALL_STATE(69)] = 2791,
  [SMALL_STATE(70)] = 2822,
  [SMALL_STATE(71)] = 2853,
  [SMALL_STATE(72)] = 2884,
  [SMALL_STATE(73)] = 2915,
  [SMALL_STATE(74)] = 2946,
  [SMALL_STATE(75)] = 2977,
  [SMALL_STATE(76)] = 3008,
  [SMALL_STATE(77)] = 3039,
  [SMALL_STATE(78)] = 3070,
  [SMALL_STATE(79)] = 3101,
  [SMALL_STATE(80)] = 3132,
  [SMALL_STATE(81)] = 3166,
  [SMALL_STATE(82)] = 3200,
  [SMALL_STATE(83)] = 3234,
  [SMALL_STATE(84)] = 3263,
  [SMALL_STATE(85)] = 3292,
  [SMALL_STATE(86)] = 3321,
  [SMALL_STATE(87)] = 3350,
  [SMALL_STATE(88)] = 3379,
  [SMALL_STATE(89)] = 3408,
  [SMALL_STATE(90)] = 3437,
  [SMALL_STATE(91)] = 3466,
  [SMALL_STATE(92)] = 3495,
  [SMALL_STATE(93)] = 3524,
  [SMALL_STATE(94)] = 3553,
  [SMALL_STATE(95)] = 3582,
  [SMALL_STATE(96)] = 3611,
  [SMALL_STATE(97)] = 3640,
  [SMALL_STATE(98)] = 3669,
  [SMALL_STATE(99)] = 3698,
  [SMALL_STATE(100)] = 3727,
  [SMALL_STATE(101)] = 3756,
  [SMALL_STATE(102)] = 3785,
  [SMALL_STATE(103)] = 3814,
  [SMALL_STATE(104)] = 3843,
  [SMALL_STATE(105)] = 3872,
  [SMALL_STATE(106)] = 3901,
  [SMALL_STATE(107)] = 3930,
  [SMALL_STATE(108)] = 3959,
  [SMALL_STATE(109)] = 3988,
  [SMALL_STATE(110)] = 4017,
  [SMALL_STATE(111)] = 4046,
  [SMALL_STATE(112)] = 4075,
  [SMALL_STATE(113)] = 4104,
  [SMALL_STATE(114)] = 4133,
  [SMALL_STATE(115)] = 4162,
  [SMALL_STATE(116)] = 4182,
  [SMALL_STATE(117)] = 4202,
  [SMALL_STATE(118)] = 4225,
  [SMALL_STATE(119)] = 4248,
  [SMALL_STATE(120)] = 4271,
  [SMALL_STATE(121)] = 4294,
  [SMALL_STATE(122)] = 4317,
  [SMALL_STATE(123)] = 4340,
  [SMALL_STATE(124)] = 4363,
  [SMALL_STATE(125)] = 4386,
  [SMALL_STATE(126)] = 4409,
  [SMALL_STATE(127)] = 4432,
  [SMALL_STATE(128)] = 4455,
  [SMALL_STATE(129)] = 4478,
  [SMALL_STATE(130)] = 4501,
  [SMALL_STATE(131)] = 4520,
  [SMALL_STATE(132)] = 4543,
  [SMALL_STATE(133)] = 4566,
  [SMALL_STATE(134)] = 4589,
  [SMALL_STATE(135)] = 4612,
  [SMALL_STATE(136)] = 4635,
  [SMALL_STATE(137)] = 4658,
  [SMALL_STATE(138)] = 4681,
  [SMALL_STATE(139)] = 4704,
  [SMALL_STATE(140)] = 4723,
  [SMALL_STATE(141)] = 4746,
  [SMALL_STATE(142)] = 4769,
  [SMALL_STATE(143)] = 4792,
  [SMALL_STATE(144)] = 4815,
  [SMALL_STATE(145)] = 4838,
  [SMALL_STATE(146)] = 4861,
  [SMALL_STATE(147)] = 4884,
  [SMALL_STATE(148)] = 4907,
  [SMALL_STATE(149)] = 4930,
  [SMALL_STATE(150)] = 4953,
  [SMALL_STATE(151)] = 4976,
  [SMALL_STATE(152)] = 4999,
  [SMALL_STATE(153)] = 5022,
  [SMALL_STATE(154)] = 5045,
  [SMALL_STATE(155)] = 5068,
  [SMALL_STATE(156)] = 5091,
  [SMALL_STATE(157)] = 5114,
  [SMALL_STATE(158)] = 5137,
  [SMALL_STATE(159)] = 5160,
  [SMALL_STATE(160)] = 5183,
  [SMALL_STATE(161)] = 5206,
  [SMALL_STATE(162)] = 5229,
  [SMALL_STATE(163)] = 5252,
  [SMALL_STATE(164)] = 5275,
  [SMALL_STATE(165)] = 5298,
  [SMALL_STATE(166)] = 5321,
  [SMALL_STATE(167)] = 5344,
  [SMALL_STATE(168)] = 5367,
  [SMALL_STATE(169)] = 5393,
  [SMALL_STATE(170)] = 5419,
  [SMALL_STATE(171)] = 5437,
  [SMALL_STATE(172)] = 5459,
  [SMALL_STATE(173)] = 5481,
  [SMALL_STATE(174)] = 5507,
  [SMALL_STATE(175)] = 5533,
  [SMALL_STATE(176)] = 5559,
  [SMALL_STATE(177)] = 5577,
  [SMALL_STATE(178)] = 5599,
  [SMALL_STATE(179)] = 5620,
  [SMALL_STATE(180)] = 5641,
  [SMALL_STATE(181)] = 5662,
  [SMALL_STATE(182)] = 5683,
  [SMALL_STATE(183)] = 5704,
  [SMALL_STATE(184)] = 5725,
  [SMALL_STATE(185)] = 5746,
  [SMALL_STATE(186)] = 5767,
  [SMALL_STATE(187)] = 5788,
  [SMALL_STATE(188)] = 5809,
  [SMALL_STATE(189)] = 5830,
  [SMALL_STATE(190)] = 5851,
  [SMALL_STATE(191)] = 5872,
  [SMALL_STATE(192)] = 5893,
  [SMALL_STATE(193)] = 5914,
  [SMALL_STATE(194)] = 5935,
  [SMALL_STATE(195)] = 5956,
  [SMALL_STATE(196)] = 5977,
  [SMALL_STATE(197)] = 5998,
  [SMALL_STATE(198)] = 6019,
  [SMALL_STATE(199)] = 6040,
  [SMALL_STATE(200)] = 6061,
  [SMALL_STATE(201)] = 6082,
  [SMALL_STATE(202)] = 6103,
  [SMALL_STATE(203)] = 6124,
  [SMALL_STATE(204)] = 6145,
  [SMALL_STATE(205)] = 6166,
  [SMALL_STATE(206)] = 6187,
  [SMALL_STATE(207)] = 6204,
  [SMALL_STATE(208)] = 6225,
  [SMALL_STATE(209)] = 6246,
  [SMALL_STATE(210)] = 6267,
  [SMALL_STATE(211)] = 6288,
  [SMALL_STATE(212)] = 6309,
  [SMALL_STATE(213)] = 6330,
  [SMALL_STATE(214)] = 6347,
  [SMALL_STATE(215)] = 6368,
  [SMALL_STATE(216)] = 6389,
  [SMALL_STATE(217)] = 6410,
  [SMALL_STATE(218)] = 6431,
  [SMALL_STATE(219)] = 6452,
  [SMALL_STATE(220)] = 6473,
  [SMALL_STATE(221)] = 6494,
  [SMALL_STATE(222)] = 6515,
  [SMALL_STATE(223)] = 6536,
  [SMALL_STATE(224)] = 6557,
  [SMALL_STATE(225)] = 6578,
  [SMALL_STATE(226)] = 6599,
  [SMALL_STATE(227)] = 6620,
  [SMALL_STATE(228)] = 6641,
  [SMALL_STATE(229)] = 6662,
  [SMALL_STATE(230)] = 6683,
  [SMALL_STATE(231)] = 6704,
  [SMALL_STATE(232)] = 6725,
  [SMALL_STATE(233)] = 6746,
  [SMALL_STATE(234)] = 6767,
  [SMALL_STATE(235)] = 6788,
  [SMALL_STATE(236)] = 6809,
  [SMALL_STATE(237)] = 6830,
  [SMALL_STATE(238)] = 6851,
  [SMALL_STATE(239)] = 6872,
  [SMALL_STATE(240)] = 6893,
  [SMALL_STATE(241)] = 6914,
  [SMALL_STATE(242)] = 6935,
  [SMALL_STATE(243)] = 6956,
  [SMALL_STATE(244)] = 6977,
  [SMALL_STATE(245)] = 6998,
  [SMALL_STATE(246)] = 7019,
  [SMALL_STATE(247)] = 7040,
  [SMALL_STATE(248)] = 7061,
  [SMALL_STATE(249)] = 7082,
  [SMALL_STATE(250)] = 7103,
  [SMALL_STATE(251)] = 7124,
  [SMALL_STATE(252)] = 7145,
  [SMALL_STATE(253)] = 7166,
  [SMALL_STATE(254)] = 7187,
  [SMALL_STATE(255)] = 7208,
  [SMALL_STATE(256)] = 7229,
  [SMALL_STATE(257)] = 7250,
  [SMALL_STATE(258)] = 7271,
  [SMALL_STATE(259)] = 7292,
  [SMALL_STATE(260)] = 7313,
  [SMALL_STATE(261)] = 7334,
  [SMALL_STATE(262)] = 7355,
  [SMALL_STATE(263)] = 7376,
  [SMALL_STATE(264)] = 7397,
  [SMALL_STATE(265)] = 7418,
  [SMALL_STATE(266)] = 7439,
  [SMALL_STATE(267)] = 7460,
  [SMALL_STATE(268)] = 7481,
  [SMALL_STATE(269)] = 7502,
  [SMALL_STATE(270)] = 7523,
  [SMALL_STATE(271)] = 7544,
  [SMALL_STATE(272)] = 7565,
  [SMALL_STATE(273)] = 7586,
  [SMALL_STATE(274)] = 7607,
  [SMALL_STATE(275)] = 7628,
  [SMALL_STATE(276)] = 7649,
  [SMALL_STATE(277)] = 7670,
  [SMALL_STATE(278)] = 7691,
  [SMALL_STATE(279)] = 7707,
  [SMALL_STATE(280)] = 7725,
  [SMALL_STATE(281)] = 7741,
  [SMALL_STATE(282)] = 7759,
  [SMALL_STATE(283)] = 7777,
  [SMALL_STATE(284)] = 7795,
  [SMALL_STATE(285)] = 7813,
  [SMALL_STATE(286)] = 7831,
  [SMALL_STATE(287)] = 7849,
  [SMALL_STATE(288)] = 7867,
  [SMALL_STATE(289)] = 7885,
  [SMALL_STATE(290)] = 7901,
  [SMALL_STATE(291)] = 7919,
  [SMALL_STATE(292)] = 7937,
  [SMALL_STATE(293)] = 7955,
  [SMALL_STATE(294)] = 7973,
  [SMALL_STATE(295)] = 7991,
  [SMALL_STATE(296)] = 8009,
  [SMALL_STATE(297)] = 8027,
  [SMALL_STATE(298)] = 8045,
  [SMALL_STATE(299)] = 8063,
  [SMALL_STATE(300)] = 8079,
  [SMALL_STATE(301)] = 8097,
  [SMALL_STATE(302)] = 8113,
  [SMALL_STATE(303)] = 8128,
  [SMALL_STATE(304)] = 8143,
  [SMALL_STATE(305)] = 8158,
  [SMALL_STATE(306)] = 8173,
  [SMALL_STATE(307)] = 8190,
  [SMALL_STATE(308)] = 8204,
  [SMALL_STATE(309)] = 8218,
  [SMALL_STATE(310)] = 8232,
  [SMALL_STATE(311)] = 8246,
  [SMALL_STATE(312)] = 8259,
  [SMALL_STATE(313)] = 8272,
  [SMALL_STATE(314)] = 8286,
  [SMALL_STATE(315)] = 8300,
  [SMALL_STATE(316)] = 8314,
  [SMALL_STATE(317)] = 8328,
  [SMALL_STATE(318)] = 8342,
  [SMALL_STATE(319)] = 8356,
  [SMALL_STATE(320)] = 8370,
  [SMALL_STATE(321)] = 8380,
  [SMALL_STATE(322)] = 8390,
  [SMALL_STATE(323)] = 8400,
  [SMALL_STATE(324)] = 8410,
  [SMALL_STATE(325)] = 8420,
  [SMALL_STATE(326)] = 8430,
  [SMALL_STATE(327)] = 8440,
  [SMALL_STATE(328)] = 8450,
  [SMALL_STATE(329)] = 8460,
  [SMALL_STATE(330)] = 8467,
  [SMALL_STATE(331)] = 8474,
  [SMALL_STATE(332)] = 8481,
  [SMALL_STATE(333)] = 8488,
  [SMALL_STATE(334)] = 8495,
  [SMALL_STATE(335)] = 8502,
  [SMALL_STATE(336)] = 8509,
  [SMALL_STATE(337)] = 8516,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [53] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_node_repeat1, 2, 0, 0), SHIFT_REPEAT(316),
  [56] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_named_node_repeat1, 2, 0, 0), SHIFT_REPEAT(334),
  [59] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_named_node_repeat1, 2, 0, 0), SHIFT_REPEAT(76),
  [62] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_node_repeat1, 2, 0, 0), SHIFT_REPEAT(60),
  [65] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_node_repeat1, 2, 0, 0), SHIFT_REPEAT(18),
  [68] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_node_repeat1, 2, 0, 0),
  [70] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_node_repeat1, 2, 0, 0), SHIFT_REPEAT(337),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_grouping_repeat1, 2, 0, 0), SHIFT_REPEAT(316),
  [146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grouping_repeat1, 2, 0, 0), SHIFT_REPEAT(334),
  [149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grouping_repeat1, 2, 0, 0), SHIFT_REPEAT(76),
  [152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_grouping_repeat1, 2, 0, 0), SHIFT_REPEAT(60),
  [155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_grouping_repeat1, 2, 0, 0), SHIFT_REPEAT(18),
  [158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_grouping_repeat1, 2, 0, 0),
  [160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1, 0, 0),
  [174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0),
  [176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(318),
  [179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(334),
  [182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(85),
  [185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(58),
  [188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(17),
  [191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(319),
  [194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(107),
  [197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(53),
  [200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(21),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 2, 0, 0),
  [215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 2, 0, 0),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 6, 0, 9),
  [223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 6, 0, 9),
  [225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 6, 0, 5),
  [227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 6, 0, 5),
  [229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grouping, 3, 0, 0),
  [231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grouping, 3, 0, 0),
  [233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 5, 0, 5),
  [235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 5, 0, 5),
  [237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 5, 0, 9),
  [239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 5, 0, 9),
  [241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 7, 0, 9),
  [243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 7, 0, 9),
  [245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 7, 0, 5),
  [247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 7, 0, 5),
  [249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_node, 1, 0, 2),
  [251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_node, 1, 0, 2),
  [253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 4, 0, 5),
  [255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 4, 0, 5),
  [257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grouping, 2, 0, 0),
  [259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grouping, 2, 0, 0),
  [261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 8, 0, 9),
  [263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 8, 0, 9),
  [265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__node_identifier, 1, 0, 0),
  [267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__node_identifier, 1, 0, 0),
  [269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_node, 1, 0, 1),
  [271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_node, 1, 0, 1),
  [273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 3, 0, 5),
  [275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 3, 0, 5),
  [277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3, 0, 0),
  [279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3, 0, 0),
  [281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 9, 0, 9),
  [283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 9, 0, 9),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string, 3, 0, 0),
  [295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string, 3, 0, 0),
  [297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string, 2, 0, 0),
  [299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string, 2, 0, 0),
  [301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 8, 0, 5),
  [303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 8, 0, 5),
  [305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 6, 0, 13),
  [307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 6, 0, 13),
  [309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 6, 0, 11),
  [311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 6, 0, 11),
  [313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grouping, 5, 0, 7),
  [315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grouping, 5, 0, 7),
  [317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 5, 0, 10),
  [319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 5, 0, 10),
  [321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 5, 0, 8),
  [323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 5, 0, 8),
  [325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 7, 0, 15),
  [327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 7, 0, 15),
  [329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 7, 0, 14),
  [331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 7, 0, 14),
  [333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 8, 0, 16),
  [335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 8, 0, 16),
  [337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 8, 0, 14),
  [339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 8, 0, 14),
  [341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 5, 0, 7),
  [343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 5, 0, 7),
  [345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grouping, 4, 0, 0),
  [347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grouping, 4, 0, 0),
  [349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 7, 0, 11),
  [351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 7, 0, 11),
  [353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grouping, 4, 0, 7),
  [355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grouping, 4, 0, 7),
  [357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 6, 0, 10),
  [359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 6, 0, 10),
  [361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 4, 0, 8),
  [363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 4, 0, 8),
  [365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grouping, 4, 0, 6),
  [367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grouping, 4, 0, 6),
  [369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_node, 2, 0, 3),
  [371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_node, 2, 0, 3),
  [373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 4, 0, 0),
  [375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 4, 0, 0),
  [377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 4, 0, 7),
  [379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 4, 0, 7),
  [381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 4, 0, 6),
  [383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 4, 0, 6),
  [385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_node, 3, 0, 4),
  [387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_node, 3, 0, 4),
  [389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 7, 0, 13),
  [391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 7, 0, 13),
  [393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 8, 0, 15),
  [395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 8, 0, 15),
  [397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_node, 2, 0, 1),
  [399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_node, 2, 0, 1),
  [401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 8, 0, 17),
  [403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 8, 0, 17),
  [405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grouping, 3, 0, 6),
  [407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grouping, 3, 0, 6),
  [409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 9, 0, 18),
  [411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 9, 0, 18),
  [413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3, 0, 6),
  [415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3, 0, 6),
  [417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_list_repeat1, 2, 0, 0),
  [419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2, 0, 0),
  [421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2, 0, 0), SHIFT_REPEAT(323),
  [424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_node, 3, 0, 3),
  [426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_node, 3, 0, 3),
  [428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 9, 0, 16),
  [430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 9, 0, 16),
  [432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_node, 2, 0, 2),
  [434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_node, 2, 0, 2),
  [436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 9, 0, 17),
  [438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 9, 0, 17),
  [440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 10, 0, 18),
  [442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 10, 0, 18),
  [444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_node, 2, 0, 4),
  [446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_node, 2, 0, 4),
  [448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 10, 0, 19),
  [450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 10, 0, 19),
  [452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 11, 0, 19),
  [454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 11, 0, 19),
  [456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_node, 10, 0, 9),
  [458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_node, 10, 0, 9),
  [460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 1, 0, 0),
  [464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(319),
  [475] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(175),
  [478] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(327),
  [481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quantifier, 1, 0, 0),
  [487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantifier, 1, 0, 0),
  [489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_capture, 2, 0, 5),
  [491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_capture, 2, 0, 5),
  [493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2, 0, 0), SHIFT_REPEAT(327),
  [496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2, 0, 0), SHIFT_REPEAT(322),
  [499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_node_repeat1, 1, 0, 0),
  [503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_named_node_repeat1, 1, 0, 0),
  [505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_negated_field, 2, 0, 0),
  [507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_negated_field, 2, 0, 0),
  [509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__named_node_expression, 3, 0, 0),
  [527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_node_expression, 3, 0, 0),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(33),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_definition, 2, 0, 1),
  [549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_definition, 2, 0, 1),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predicate, 6, 0, 12),
  [555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predicate, 6, 0, 12),
  [557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__group_expression, 3, 0, 0),
  [559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__group_expression, 3, 0, 0),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_grouping_repeat1, 1, 0, 0),
  [565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_grouping_repeat1, 1, 0, 0),
  [567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1, 0, 0),
  [569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1, 0, 0),
  [571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_name, 2, 0, 0),
  [573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_name, 2, 0, 0),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__string_repeat1, 2, 0, 0),
  [591] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_repeat1, 2, 0, 0), SHIFT_REPEAT(317),
  [594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [626] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_query(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
